/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/base/common/path","vs/platform/log/common/log","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/network","vs/base/common/arrays","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/instantiation/common/extensions","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(X){for(var e=[],k=0,T=X.length;k<T;k++)e[k]=te[X[k]];return e};define(te[101],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(T,P){if(!T)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=k}),define(te[67],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function T(i){const E=[];for(let f in i)k.call(i,f)&&E.push(i[f]);return E}e.values=T;function P(i,E){for(let f in i)if(k.call(i,f)&&E({key:f,value:i[f]},function(){delete i[f]})===!1)return}e.forEach=P;function R(i,E){const f=Object.create(null);for(const p of i){const h=E(p);let w=f[h];w||(w=f[h]=[]),w.push(p)}return f}e.groupBy=R;function D(i){const E=Object.create(null);return i&&i.forEach((f,p)=>{E[p]=f}),E}e.fromMap=D;function C(i,E){const f=[],p=[];for(let h of i)E.has(h)||f.push(h);for(let h of E)i.has(h)||p.push(h);return{removed:f,added:p}}e.diffSets=C;function S(i,E){const f=[],p=[];for(let[h,w]of i)E.has(h)||f.push(w);for(let[h,w]of E)i.has(h)||p.push(w);return{removed:f,added:p}}e.diffMaps=S;class I{constructor(){this.map=new Map}add(E,f){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(f)}delete(E,f){const p=this.map.get(E);!p||(p.delete(f),p.size===0&&this.map.delete(E))}forEach(E,f){const p=this.map.get(E);!p||p.forEach(f)}}e.SetMap=I}),define(te[68],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(D){return(C,S,I)=>{let i=null,E=null;if(typeof I.value=="function"?(i="value",E=I.value):typeof I.get=="function"&&(i="get",E=I.get),!E)throw new Error("not supported");I[i]=D(E,S)}}e.createDecorator=k;function T(D,C,S){let I=null,i=null;if(typeof S.value=="function"?(I="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",i=S.get),!i)throw new Error("not supported");const E=`$memoize$${C}`;S[I]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,f)}),this[E]}}e.memoize=T;function P(D,C,S){return k((I,i)=>{const E=`$debounce$${i}`,f=`$debounce$result$${i}`;return function(...p){this[f]||(this[f]=S?S():void 0),clearTimeout(this[E]),C&&(this[f]=C(this[f],...p),p=[this[f]]),this[E]=setTimeout(()=>{I.apply(this,p),this[f]=S?S():void 0},D)}})}e.debounce=P;function R(D,C,S){return k((I,i)=>{const E=`$throttle$timer$${i}`,f=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...w){if(this[f]||(this[f]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),C&&(this[f]=C(this[f],...w)),this[h])return;const y=this[p]+D;y<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[f]]),this[f]=S?S():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),I.apply(this,[this[f]]),this[f]=S?S():void 0},y-Date.now()))}})}e.throttle=R}),define(te[7],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=k,e.errorHandler=new k;function T(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=T;function P(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=P;function R(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){let{name:t,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:s,stack:r}}return c}e.transformErrorForSerialization=D;const C="Canceled";function S(c){return c instanceof Error&&c.name===C&&c.message===C}e.isPromiseCanceledError=S;class I extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=I;function i(){const c=new Error(C);return c.name=c.message,c}e.canceled=i;function E(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=E;function f(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=f;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=w;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function d(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(c,t=Object.create(null)){const s=new Error(c);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=l}),define(te[16],ne([0,1,7]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(F,B=0){return F[F.length-(1+B)]}e.tail=T;function P(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=P;function R(F,B,V=(Q,Z)=>Q===Z){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let Q=0,Z=F.length;Q<Z;Q++)if(!V(F[Q],B[Q]))return!1;return!0}e.equals=R;function D(F,B,V){let Q=0,Z=F.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=V(F[G],B);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=D;function C(F,B){let V=0,Q=F.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(F[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=C;function S(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return F<Z.length?S(F,Z,V):F<Z.length+H.length?H[0]:S(F-(Z.length+H.length),G,V)}e.quickSelect=S;function I(F,B){const V=[];let Q;for(const Z of F.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=I;function i(F,B,V){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===F.length){Z(G,0,B.slice(H));break}if(H===B.length){Z(G,F.length-G,[]);break}const re=F[G],ie=B[H],ce=V(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=i;function E(F,B,V){const Q=i(F,B,V),Z=[],G=[];for(const H of Q)Z.push(...F.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=E;function f(F,B,V){if(V===0)return[];const Q=F.slice(0,V).sort(B);return h(F,B,Q,V,F.length),Q}e.top=f;function p(F,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=F.length,ie=F.slice(0,V).sort(B);for(let ce=V,le=Math.min(V+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>V&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,k.canceled)();h(F,B,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=p;function h(F,B,V,Q,Z){for(const G=V.length;Q<Z;Q++){const H=F[Q];if(B(H,V[G-1])<0){V.pop();const re=C(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function w(F){return F.filter(B=>!!B)}e.coalesce=w;function y(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.coalesceInPlace=y;function m(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.move=m;function v(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=v;function d(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=d;function l(F,B=V=>V){const V=new Set;return F.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=l;function c(F){const B=Object.create(null);return V=>{const Q=F(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=c;function t(F,B){const V=s(F,B);if(V!==-1)return F[V]}e.findLast=t;function s(F,B){for(let V=F.length-1;V>=0;V--){const Q=F[V];if(B(Q))return V}return-1}e.lastIndex=s;function r(F,B){return F.length>0?F[0]:B}e.firstOrDefault=r;function n(F,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(F.length,B.length);Z<G&&V(F[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=n;function a(F){return[].concat(...F)}e.flatten=a;function o(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=o;function u(F,B,V){return F.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function g(F,B){return F.push(B),()=>b(F,B)}e.insert=g;function b(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.remove=b;function A(F,B,V){const Q=F.slice(0,B),Z=F.slice(B);return Q.concat(V,Z)}e.arrayInsert=A;function U(F,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=F.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),G=F[Q];F[Q]=F[Z],F[Z]=G}}e.shuffle=U;function O(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.pushToStart=O;function q(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.pushToEnd=q;function N(F,B){return Array.isArray(F)?F.map(B):B(F)}e.mapArrayOrNot=N;function L(F){return Array.isArray(F)?F:[F]}e.asArray=L;function $(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=$;function _(F,B){for(const V of F){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=_;function M(F,B,V){const Q=W(F,B),Z=F.length,G=V.length;F.length=Z+G;for(let H=Z-1;H>=Q;H--)F[H+G]=F[H];for(let H=0;H<G;H++)F[H+Q]=V[H]}e.insertInto=M;function j(F,B,V,Q){const Z=W(F,B),G=F.splice(Z,V);return M(F,Z,Q),G}e.splice=j;function W(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}function x(F,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H<V&&(V=H,Q=G)}),Q}e.minIndex=x;function z(F,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H>V&&(V=H,Q=G)}),Q}e.maxIndex=z;class K{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const V=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,V}}e.ArrayQueue=K}),define(te[69],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(T){const P=this;let R=!1,D;return function(){return R||(R=!0,D=T.apply(P,arguments)),D}}e.once=k}),define(te[56],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(T){function P(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}T.is=P;const R=Object.freeze([]);function D(){return R}T.empty=D;function*C(c){yield c}T.single=C;function S(c){return c||R}T.from=S;function I(c){return!c||c[Symbol.iterator]().next().done===!0}T.isEmpty=I;function i(c){return c[Symbol.iterator]().next().value}T.first=i;function E(c,t){for(const s of c)if(t(s))return!0;return!1}T.some=E;function f(c,t){for(const s of c)if(t(s))return s}T.find=f;function*p(c,t){for(const s of c)t(s)&&(yield s)}T.filter=p;function*h(c,t){let s=0;for(const r of c)yield t(r,s++)}T.map=h;function*w(...c){for(const t of c)for(const s of t)yield s}T.concat=w;function*y(c){for(const t of c)for(const s of t)yield s}T.concatNested=y;function m(c,t,s){let r=s;for(const n of c)r=t(r,n);return r}T.reduce=m;function*v(c,t,s=c.length){for(t<0&&(t+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);t<s;t++)yield c[t]}T.slice=v;function d(c,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,c];const r=c[Symbol.iterator]();for(let n=0;n<t;n++){const a=r.next();if(a.done)return[s,T.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}T.consume=d;function l(c,t,s=(r,n)=>r===n){const r=c[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=r.next(),o=n.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}T.equals=l})(k=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(t,s=!1){let r=0,n=t.length,a="",o=0,u=16,g=0;function b($){let _=0,M=0;for(;_<$;){const j=t.charCodeAt(r);if(j>=48&&j<=57)M=M*16+j-48;else if(j>=65&&j<=70)M=M*16+j-65+10;else if(j>=97&&j<=102)M=M*16+j-97+10;else break;r++,_++}return _<$&&(M=-1),M}function A($){r=$,a="",o=0,u=16,g=0}function U(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return g=3,t.substring($,r);let _=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;_=r}else g=3;return t.substring($,_)}function O(){let $="",_=r;for(;;){if(r>=n){$+=t.substring(_,r),g=2;break}const M=t.charCodeAt(r);if(M===34){$+=t.substring(_,r),r++;break}if(M===92){if($+=t.substring(_,r),r++,r>=n){g=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=b(4);W>=0?$+=String.fromCharCode(W):g=4;break;default:g=5}_=r;continue}if(M>=0&&M<=31)if(S(M)){$+=t.substring(_,r),g=2;break}else g=6;r++}return $}function q(){if(a="",g=0,o=r,r>=n)return o=n,u=17;let $=t.charCodeAt(r);if(C($)){do r++,a+=String.fromCharCode($),$=t.charCodeAt(r);while(C($));return u=15}if(S($))return r++,a+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch($){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=O(),u=10;case 47:const _=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!S(t.charCodeAt(r));)r++;return a=t.substring(_,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const M=n-1;let j=!1;for(;r<M;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,j=!0;break}r++}return j||(r++,g=1),a=t.substring(_,r),u=13}return a+=String.fromCharCode($),r++,u=16;case 45:if(a+=String.fromCharCode($),r++,r===n||!I(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),u=11;default:for(;r<n&&N($);)r++,$=t.charCodeAt(r);if(o!==r){switch(a=t.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),r++,u=16}}function N($){if(C($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=q();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>r,scan:s?L:q,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>g}}e.createScanner=D;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function E(t,s){const r=[],n=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(b,A,U,O){o.value=b,o.offset=A,o.length=U,o.type=O,o.colonOffset=void 0,a=o}try{d(t,{onObjectBegin:(b,A)=>{if(s<=b)throw n;a=void 0,u=s>b,r.push("")},onObjectProperty:(b,A,U)=>{if(s<A||(g(b,A,U,"property"),r[r.length-1]=b,s<=A+U))throw n},onObjectEnd:(b,A)=>{if(s<=b)throw n;a=void 0,r.pop()},onArrayBegin:(b,A)=>{if(s<=b)throw n;a=void 0,r.push(0)},onArrayEnd:(b,A)=>{if(s<=b)throw n;a=void 0,r.pop()},onLiteralValue:(b,A,U)=>{if(s<A||(g(b,A,U,c(b)),s<=A+U))throw n},onSeparator:(b,A,U)=>{if(s<=A)throw n;if(b===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(b===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(b){if(b!==n)throw b}return{path:r,previousNode:a,isAtPropertyKey:u,matches:b=>{let A=0;for(let U=0;A<b.length&&U<r.length;U++)if(b[A]===r[U]||b[A]==="*")A++;else if(b[A]!=="**")return!1;return A===b.length}}}e.getLocation=E;function f(t,s=[],r=R.DEFAULT){let n=null,a=[];const o=[];function u(b){Array.isArray(a)?a.push(b):n!==null&&(a[n]=b)}return d(t,{onObjectBegin:()=>{const b={};u(b),o.push(a),a=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const b=[];u(b),o.push(a),a=b,n=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(b,A,U)=>{s.push({error:b,offset:A,length:U})}},r),a[0]}e.parse=f;function p(t,s=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function o(b){return n.children.push(b),b}d(t,{onObjectBegin:b=>{n=o({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,A,U)=>{n=o({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:A,length:U,parent:n})},onObjectEnd:(b,A)=>{n.length=b+A-n.offset,n=n.parent,a(b+A)},onArrayBegin:(b,A)=>{n=o({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,A)=>{n.length=b+A-n.offset,n=n.parent,a(b+A)},onLiteralValue:(b,A,U)=>{o({type:c(b),offset:A,length:U,parent:n,value:b}),a(A+U)},onSeparator:(b,A,U)=>{n.type==="property"&&(b===":"?n.colonOffset=A:b===","&&a(A))},onError:(b,A,U)=>{s.push({error:b,offset:A,length:U})}},r);const g=n.children[0];return g&&delete g.parent,g}e.parseTree=p;function h(t,s){if(!t)return;let r=t;for(let n of s)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===n){r=o.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=h;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=w;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const s=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(s[r.children[0].value]=y(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function m(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=m;function v(t,s,r=!1){if(m(t,s,r)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=s;a++){const o=v(n[a],s,r);if(o)return o}return t}}e.findNodeAtOffset=v;function d(t,s,r=R.DEFAULT){const n=D(t,!1);function a(V){return V?()=>V(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(V){return V?Q=>V(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),g=o(s.onObjectProperty),b=a(s.onObjectEnd),A=a(s.onArrayBegin),U=a(s.onArrayEnd),O=o(s.onLiteralValue),q=o(s.onSeparator),N=a(s.onComment),L=o(s.onError),$=r&&r.disallowComments,_=r&&r.allowTrailingComma;function M(){for(;;){const V=n.scan();switch(n.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:$||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(V){case 12:case 13:$?j(10):N();break;case 16:j(1);break;case 15:case 14:break;default:return V}}}function j(V,Q=[],Z=[]){if(L(V),Q.length+Z.length>0){let G=n.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){M();break}else if(Z.indexOf(G)!==-1)break;G=M()}}}function W(V){const Q=n.getTokenValue();return V?O(Q):g(Q),M(),!0}function x(){switch(n.getToken()){case 11:let V=0;try{V=JSON.parse(n.getTokenValue()),typeof V!="number"&&(j(2),V=0)}catch(Q){j(2)}O(V);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function z(){return n.getToken()!==10?(j(3,[],[2,5]),!1):(W(!1),n.getToken()===6?(q(":"),M(),B()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){u(),M();let V=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(V||j(4,[],[]),q(","),M(),n.getToken()===2&&_)break}else V&&j(6,[],[]);z()||j(4,[],[2,5]),V=!0}return b(),n.getToken()!==2?j(7,[2],[]):M(),!0}function F(){A(),M();let V=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(V||j(4,[],[]),q(","),M(),n.getToken()===4&&_)break}else V&&j(6,[],[]);B()||j(4,[],[4,5]),V=!0}return U(),n.getToken()!==4?j(8,[4],[]):M(),!0}function B(){switch(n.getToken()){case 3:return F();case 1:return K();case 10:return W(!0);default:return x()}}return M(),n.getToken()===17?r.allowEmptyContent?!0:(j(4,[],[]),!1):B()?(n.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=d;function l(t,s){let r=D(t),n=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&n.push(t.substring(o,u)),s!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return n.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[48],ne([0,1,32]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(S,I,i){let E,f,p,h,w;if(I){for(h=I.offset,w=h+I.length,p=h;p>0&&!C(S,p-1);)p--;let o=w;for(;o<S.length&&!C(S,o);)o++;f=S.substring(p,o),E=R(f,i)}else f=S,E=0,p=0,h=0,w=S.length;const y=D(i,S);let m=!1,v=0,d;i.insertSpaces?d=P(" ",i.tabSize||4):d="	";const l=(0,k.createScanner)(f,!1);let c=!1;function t(){return y+P(d,E+v)}function s(){let o=l.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=l.scan();return c=o===16||l.getTokenError()!==0,o}const r=[];function n(o,u,g){!c&&u<w&&g>h&&S.substring(u,g)!==o&&r.push({offset:u,length:g-u,content:o})}let a=s();if(a!==17){const o=l.getTokenOffset()+p,u=P(d,E);n(u,p,o)}for(;a!==17;){let o=l.getTokenOffset()+l.getTokenLength()+p,u=s(),g="";for(;!m&&(u===12||u===13);){const A=l.getTokenOffset()+p;n(" ",o,A),o=l.getTokenOffset()+l.getTokenLength()+p,g=u===12?t():"",u=s()}if(u===2)a!==1&&(v--,g=t());else if(u===4)a!==3&&(v--,g=t());else{switch(a){case 3:case 1:v++,g=t();break;case 5:case 12:g=t();break;case 13:m?g=t():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}m&&(u===12||u===13)&&(g=t())}const b=l.getTokenOffset()+p;n(g,o,b),a=u}return r}e.format=T;function P(S,I){let i="";for(let E=0;E<I;E++)i+=S;return i}function R(S,I){let i=0,E=0;const f=I.tabSize||4;for(;i<S.length;){const p=S.charAt(i);if(p===" ")E++;else if(p==="	")E+=f;else break;i++}return Math.floor(E/f)}function D(S,I){for(let i=0;i<I.length;i++){const E=I.charAt(i);if(E==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=D;function C(S,I){return`\r
`.indexOf(S.charAt(I))!==-1}e.isEOL=C}),define(te[40],ne([0,1,32,48]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(I,i,E){return R(I,i,void 0,E)}e.removeProperty=P;function R(I,i,E,f,p){const h=i.slice(),w=[],y=(0,k.parseTree)(I,w);let m,v;for(;h.length>0&&(v=h.pop(),m=(0,k.findNodeAtLocation)(y,h),m===void 0&&E!==void 0);)typeof v=="string"?E={[v]:E}:E=[E];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,k.findNodeAtLocation)(m,[v]);if(d!==void 0)if(E===void 0){if(!d.parent)throw new Error("Malformed AST");const l=m.children.indexOf(d.parent);let c,t=d.parent.offset+d.parent.length;if(l>0){const s=m.children[l-1];c=s.offset+s.length}else c=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return D(I,{offset:c,length:t-c,content:""},f)}else return D(I,{offset:d.offset,length:d.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const l=`${JSON.stringify(v)}: ${JSON.stringify(E)}`,c=p?p(m.children.map(s=>s.children[0].value)):m.children.length;let t;if(c>0){const s=m.children[c-1];t={offset:s.offset+s.length,length:0,content:","+l}}else m.children.length===0?t={offset:m.offset+1,length:0,content:l}:t={offset:m.offset+1,length:0,content:l+","};return D(I,t,f)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(E!==void 0){const d=`${JSON.stringify(E)}`;let l;if(m.children.length===0||v===0)l={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const c=v===-1||v>m.children.length?m.children.length:v,t=m.children[c-1];l={offset:t.offset+t.length,length:0,content:","+d}}return D(I,l,f)}else{const d=v,l=m.children[d];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const t=m.children[d-1],s=t.offset+t.length,r=m.offset+m.length;c={offset:s,length:r-2-s,content:""}}else c={offset:l.offset,length:m.children[d+1].offset-l.offset,content:""};return D(I,c,f)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(I,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},f)}}e.setProperty=R;function D(I,i,E){let f=C(I,i),p=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,T.isEOL)(f,p-1);)p--;for(;h<f.length&&!(0,T.isEOL)(f,h);)h++}const w=(0,T.format)(f,{offset:p,length:h-p},E);for(let m=w.length-1;m>=0;m--){const v=w[m];f=C(f,v),p=Math.min(p,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const y=I.length-(f.length-h)-p;return[{offset:p,length:y,content:f.substring(p,h)}]}e.withFormatting=D;function C(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=C;function S(I,i){let E=i.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),f=I.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=f)I=C(I,h);else throw new Error("Overlapping edit");f=h.offset}return I}e.applyEdits=S}),define(te[2],ne([0,1,69,56]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function D(n){R=n}if(e.setDisposableTracker=D,P){const n="__is_disposable_tracked__";D(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[n]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==v.None)try{a[n]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[n]=!0}catch{}}markAsSingleton(a){}})}function C(n){return R?.trackDisposable(n),n}function S(n){R?.markAsDisposed(n)}function I(n,a){R?.setParent(n,a)}function i(n,a){if(!!R)for(const o of n)R.setParent(o,a)}function E(n){return R?.markAsSingleton(n),n}e.markAsSingleton=E;class f extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=f;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function h(n){if(T.Iterable.is(n)){let a=[];for(const o of n)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new f(a);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=h;function w(...n){const a=y(()=>h(n));return i(n,a),a}e.combinedDisposable=w;function y(n){const a=C({dispose:(0,k.once)(()=>{S(a),n()})});return a}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,C(this),I(this._store,this)}dispose(){S(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&I(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&I(a,null),a}}e.MutableDisposable=d;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:g}=u,b=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:g,dispose:b}}}e.ReferenceCollection=c;class t{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=t;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(n){const a=new m;try{n(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[102],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(R){this.element=R,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class T{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let R=this._first;for(;R!==k.Undefined;){const D=R.next;R.prev=k.Undefined,R.next=k.Undefined,R=D}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const C=new k(R);if(this._first===k.Undefined)this._first=C,this._last=C;else if(D){const I=this._last;this._last=C,C.prev=I,I.next=C}else{const I=this._first;this._first=C,C.next=I,I.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==k.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==k.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==k.Undefined&&R.next!==k.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===k.Undefined&&R.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):R.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):R.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==k.Undefined;)yield R.element,R=R.next}}e.LinkedList=T}),function(){function X(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function D(S){R.push(S,Date.now())}function C(){const S=[];for(let I=0;I<R.length;I+=2)S.push({name:R[I],startTime:R[I+1]});return S}return{mark:D,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(P+D.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function k(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=k(T))}(),define(te[4],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let T=!1,P=!1,R=!1,D=!1,C=!1,S=!1,I=!1,i,E=k,f,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,T=p.indexOf("Windows")>=0,P=p.indexOf("Macintosh")>=0,I=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=p.indexOf("Linux")>=0,S=!0,i=navigator.language,E=i;else if(typeof h=="object"){T=h.platform==="win32",P=h.platform==="darwin",R=h.platform==="linux",D=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=k,E=k;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),a=n.availableLanguages["*"];i=n.locale,E=a||k,f=n._translationsConfigFile}catch(n){}C=!0}else console.error("Unable to resolve platform.");var y;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let v=0;P?v=1:T?v=3:R&&(v=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=D,e.isNative=C,e.isWeb=S,e.isIOS=I,e.platform=v,e.userAgent=p,e.language=E;var d;(function(r){function n(){return e.language}r.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(d=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let g=0,b=a.length;g<b;g++){const A=a[g];if(A.id===u.data.vscodeSetImmediateId){a.splice(g,1),A.callback();return}}});let o=0;return u=>{const g=++o;a.push({id:g,callback:u}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const n=Promise.resolve();return a=>n.then(a)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||I?2:T?1:3;let c=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const P=k.globals.vscode.process;T={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()},nextTick(R){return(0,k.setImmediate)(R)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:T={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},nextTick(P){return(0,k.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(te[9],ne([0,1,31]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,P=97,R=90,D=122,C=46,S=47,I=92,i=58,E=63;class f extends Error{constructor(l,c,t){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=l.indexOf(".")!==-1?"property":"argument";let n=`The "${l}" ${r} ${s} of type ${c}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function p(d,l){if(typeof d!="string")throw new f(l,"string",d)}function h(d){return d===S||d===I}function w(d){return d===S}function y(d){return d>=T&&d<=R||d>=P&&d<=D}function m(d,l,c,t){let s="",r=0,n=-1,a=0,o=0;for(let u=0;u<=d.length;++u){if(u<d.length)o=d.charCodeAt(u);else{if(t(o))break;o=S}if(t(o)){if(!(n===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const g=s.lastIndexOf(c);g===-1?(s="",r=0):(s=s.slice(0,g),r=s.length-1-s.lastIndexOf(c)),n=u,a=0;continue}else if(s.length!==0){s="",r=0,n=u,a=0;continue}}l&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${d.slice(n+1,u)}`:s=d.slice(n+1,u),r=u-n-1;n=u,a=0}else o===C&&a!==-1?++a:a=-1}return s}function v(d,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${d}${t}`:t}e.win32={resolve(...d){let l="",c="",t=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],p(r,"path"),r.length===0)continue}else l.length===0?r=k.cwd():(r=k.env[`=${l}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${l}\\`));const n=r.length;let a=0,o="",u=!1;const g=r.charCodeAt(0);if(n===1)h(g)&&(a=1,u=!0);else if(h(g))if(u=!0,h(r.charCodeAt(1))){let b=2,A=b;for(;b<n&&!h(r.charCodeAt(b));)b++;if(b<n&&b!==A){const U=r.slice(A,b);for(A=b;b<n&&h(r.charCodeAt(b));)b++;if(b<n&&b!==A){for(A=b;b<n&&!h(r.charCodeAt(b));)b++;(b===n||b!==A)&&(o=`\\\\${U}\\${r.slice(A,b)}`,a=b)}}}else a=1;else y(g)&&r.charCodeAt(1)===i&&(o=r.slice(0,2),a=2,n>2&&h(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(t){if(l.length>0)break}else if(c=`${r.slice(a)}\\${c}`,t=u,u&&l.length>0)break}return c=m(c,!t,"\\",h),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(d){p(d,"path");const l=d.length;if(l===0)return".";let c=0,t,s=!1;const r=d.charCodeAt(0);if(l===1)return w(r)?"\\":d;if(h(r))if(s=!0,h(d.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(d.charCodeAt(a));)a++;if(a<l&&a!==o){const u=d.slice(o,a);for(o=a;a<l&&h(d.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(d.charCodeAt(a));)a++;if(a===l)return`\\\\${u}\\${d.slice(o)}\\`;a!==o&&(t=`\\\\${u}\\${d.slice(o,a)}`,c=a)}}}else c=1;else y(r)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),c=2,l>2&&h(d.charCodeAt(2))&&(s=!0,c=3));let n=c<l?m(d.slice(c),!s,"\\",h):"";return n.length===0&&!s&&(n="."),n.length>0&&h(d.charCodeAt(l-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){p(d,"path");const l=d.length;if(l===0)return!1;const c=d.charCodeAt(0);return h(c)||l>2&&y(c)&&d.charCodeAt(1)===i&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,c;for(let r=0;r<d.length;++r){const n=d[r];p(n,"path"),n.length>0&&(l===void 0?l=c=n:l+=`\\${n}`)}if(l===void 0)return".";let t=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const r=c.length;r>1&&h(c.charCodeAt(1))&&(++s,r>2&&(h(c.charCodeAt(2))?++s:t=!1))}if(t){for(;s<l.length&&h(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(d,l){if(p(d,"from"),p(l,"to"),d===l)return"";const c=e.win32.resolve(d),t=e.win32.resolve(l);if(c===t||(d=c.toLowerCase(),l=t.toLowerCase(),d===l))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===I;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===I;)r--;const n=r-s;let a=0;for(;a<l.length&&l.charCodeAt(a)===I;)a++;let o=l.length;for(;o-1>a&&l.charCodeAt(o-1)===I;)o--;const u=o-a,g=n<u?n:u;let b=-1,A=0;for(;A<g;A++){const O=d.charCodeAt(s+A);if(O!==l.charCodeAt(a+A))break;O===I&&(b=A)}if(A!==g){if(b===-1)return t}else{if(u>g){if(l.charCodeAt(a+A)===I)return t.slice(a+A+1);if(A===2)return t.slice(a+A)}n>g&&(d.charCodeAt(s+A)===I?b=A:A===2&&(b=3)),b===-1&&(b=0)}let U="";for(A=s+b+1;A<=r;++A)(A===r||d.charCodeAt(A)===I)&&(U+=U.length===0?"..":"\\..");return a+=b,U.length>0?`${U}${t.slice(a,o)}`:(t.charCodeAt(a)===I&&++a,t.slice(a,o))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===I){if(l.charCodeAt(1)===I){const c=l.charCodeAt(2);if(c!==E&&c!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(y(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===I)return`\\\\?\\${l}`;return d},dirname(d){p(d,"path");const l=d.length;if(l===0)return".";let c=-1,t=0;const s=d.charCodeAt(0);if(l===1)return h(s)?d:".";if(h(s)){if(c=t=1,h(d.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(d.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&h(d.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(d.charCodeAt(a));)a++;if(a===l)return d;a!==o&&(c=t=a+1)}}}}else y(s)&&d.charCodeAt(1)===i&&(c=l>2&&h(d.charCodeAt(2))?3:2,t=c);let r=-1,n=!0;for(let a=l-1;a>=t;--a)if(h(d.charCodeAt(a))){if(!n){r=a;break}}else n=!1;if(r===-1){if(c===-1)return".";r=c}return d.slice(0,r)},basename(d,l){l!==void 0&&p(l,"ext"),p(d,"path");let c=0,t=-1,s=!0,r;if(d.length>=2&&y(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(c=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let n=l.length-1,a=-1;for(r=d.length-1;r>=c;--r){const o=d.charCodeAt(r);if(h(o)){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),n>=0&&(o===l.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=a))}return c===t?t=a:t===-1&&(t=d.length),d.slice(c,t)}for(r=d.length-1;r>=c;--r)if(h(d.charCodeAt(r))){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(c,t)},extname(d){p(d,"path");let l=0,c=-1,t=0,s=-1,r=!0,n=0;d.length>=2&&d.charCodeAt(1)===i&&y(d.charCodeAt(0))&&(l=t=2);for(let a=d.length-1;a>=l;--a){const o=d.charCodeAt(a);if(h(o)){if(!r){t=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===C?c===-1?c=a:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||s===-1||n===0||n===1&&c===s-1&&c===t+1?"":d.slice(c,s)},format:v.bind(null,"\\"),parse(d){p(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.length;let t=0,s=d.charCodeAt(0);if(c===1)return h(s)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(h(s)){if(t=1,h(d.charCodeAt(1))){let b=2,A=b;for(;b<c&&!h(d.charCodeAt(b));)b++;if(b<c&&b!==A){for(A=b;b<c&&h(d.charCodeAt(b));)b++;if(b<c&&b!==A){for(A=b;b<c&&!h(d.charCodeAt(b));)b++;b===c?t=b:b!==A&&(t=b+1)}}}}else if(y(s)&&d.charCodeAt(1)===i){if(c<=2)return l.root=l.dir=d,l;if(t=2,h(d.charCodeAt(2))){if(c===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let r=-1,n=t,a=-1,o=!0,u=d.length-1,g=0;for(;u>=t;--u){if(s=d.charCodeAt(u),h(s)){if(!o){n=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===C?r===-1?r=u:g!==1&&(g=1):r!==-1&&(g=-1)}return a!==-1&&(r===-1||g===0||g===1&&r===a-1&&r===n+1?l.base=l.name=d.slice(n,a):(l.name=d.slice(n,r),l.base=d.slice(n,a),l.ext=d.slice(r,a))),n>0&&n!==t?l.dir=d.slice(0,n-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",c=!1;for(let t=d.length-1;t>=-1&&!c;t--){const s=t>=0?d[t]:k.cwd();p(s,"path"),s.length!==0&&(l=`${s}/${l}`,c=s.charCodeAt(0)===S)}return l=m(l,!c,"/",w),c?`/${l}`:l.length>0?l:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===S,c=d.charCodeAt(d.length-1)===S;return d=m(d,!l,"/",w),d.length===0?l?"/":c?"./":".":(c&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===S},join(...d){if(d.length===0)return".";let l;for(let c=0;c<d.length;++c){const t=d[c];p(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(p(d,"from"),p(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const c=1,t=d.length,s=t-c,r=1,n=l.length-r,a=s<n?s:n;let o=-1,u=0;for(;u<a;u++){const b=d.charCodeAt(c+u);if(b!==l.charCodeAt(r+u))break;b===S&&(o=u)}if(u===a)if(n>a){if(l.charCodeAt(r+u)===S)return l.slice(r+u+1);if(u===0)return l.slice(r+u)}else s>a&&(d.charCodeAt(c+u)===S?o=u:u===0&&(o=0));let g="";for(u=c+o+1;u<=t;++u)(u===t||d.charCodeAt(u)===S)&&(g+=g.length===0?"..":"/..");return`${g}${l.slice(r+o)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===S;let c=-1,t=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===S){if(!t){c=s;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":d.slice(0,c)},basename(d,l){l!==void 0&&p(l,"ext"),p(d,"path");let c=0,t=-1,s=!0,r;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let n=l.length-1,a=-1;for(r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===S){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),n>=0&&(o===l.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=a))}return c===t?t=a:t===-1&&(t=d.length),d.slice(c,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===S){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(c,t)},extname(d){p(d,"path");let l=-1,c=0,t=-1,s=!0,r=0;for(let n=d.length-1;n>=0;--n){const a=d.charCodeAt(n);if(a===S){if(!s){c=n+1;break}continue}t===-1&&(s=!1,t=n+1),a===C?l===-1?l=n:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===c+1?"":d.slice(l,t)},format:v.bind(null,"/"),parse(d){p(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.charCodeAt(0)===S;let t;c?(l.root="/",t=1):t=0;let s=-1,r=0,n=-1,a=!0,o=d.length-1,u=0;for(;o>=t;--o){const g=d.charCodeAt(o);if(g===S){if(!a){r=o+1;break}continue}n===-1&&(a=!1,n=o+1),g===C?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(n!==-1){const g=r===0&&c?1:r;s===-1||u===0||u===1&&s===n-1&&s===r+1?l.base=l.name=d.slice(g,n):(l.name=d.slice(g,s),l.base=d.slice(g,n),l.ext=d.slice(s,n))}return r>0?l.dir=d.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[103],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var T;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(R,...D){const C=D.reduce((i,E)=>(i[E]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(i=>!C[i]).forEach(i=>{for(let E=0;E<S.length;E++)if(i.search(S[E])!==-1){delete R[i];break}})}e.sanitizeProcessEnvironment=P}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var T in k)(typeof exports=="object"?exports:X)[T]=k[T]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function k(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return X[T].call(P.exports,P,P.exports,k),P.l=!0,P.exports}return k.m=X,k.c=e,k.d=function(T,P,R){k.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:R})},k.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},k.t=function(T,P){if(1&P&&(T=k(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(k.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var D in T)k.d(R,D,function(C){return T[C]}.bind(null,D));return R},k.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return k.d(P,"a",P),P},k.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},k.p="",k(k.s=0)}([function(X,e,k){(function(T){var P;e=X.exports=Z,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],I=0,i=I++;S[i]="0|[1-9]\\d*";var E=I++;S[E]="[0-9]+";var f=I++;S[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=I++;S[p]="("+S[i]+")\\.("+S[i]+")\\.("+S[i]+")";var h=I++;S[h]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var w=I++;S[w]="(?:"+S[i]+"|"+S[f]+")";var y=I++;S[y]="(?:"+S[E]+"|"+S[f]+")";var m=I++;S[m]="(?:-("+S[w]+"(?:\\."+S[w]+")*))";var v=I++;S[v]="(?:-?("+S[y]+"(?:\\."+S[y]+")*))";var d=I++;S[d]="[0-9A-Za-z-]+";var l=I++;S[l]="(?:\\+("+S[d]+"(?:\\."+S[d]+")*))";var c=I++,t="v?"+S[p]+S[m]+"?"+S[l]+"?";S[c]="^"+t+"$";var s="[v=\\s]*"+S[h]+S[v]+"?"+S[l]+"?",r=I++;S[r]="^"+s+"$";var n=I++;S[n]="((?:<|>)?=?)";var a=I++;S[a]=S[E]+"|x|X|\\*";var o=I++;S[o]=S[i]+"|x|X|\\*";var u=I++;S[u]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[m]+")?"+S[l]+"?)?)?";var g=I++;S[g]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[l]+"?)?)?";var b=I++;S[b]="^"+S[n]+"\\s*"+S[u]+"$";var A=I++;S[A]="^"+S[n]+"\\s*"+S[g]+"$";var U=I++;S[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;S[O]="(?:~>?)";var q=I++;S[q]="(\\s*)"+S[O]+"\\s+",C[q]=new RegExp(S[q],"g");var N=I++;S[N]="^"+S[O]+S[u]+"$";var L=I++;S[L]="^"+S[O]+S[g]+"$";var $=I++;S[$]="(?:\\^)";var _=I++;S[_]="(\\s*)"+S[$]+"\\s+",C[_]=new RegExp(S[_],"g");var M=I++;S[M]="^"+S[$]+S[u]+"$";var j=I++;S[j]="^"+S[$]+S[g]+"$";var W=I++;S[W]="^"+S[n]+"\\s*("+s+")$|^$";var x=I++;S[x]="^"+S[n]+"\\s*("+t+")$|^$";var z=I++;S[z]="(\\s*)"+S[n]+"\\s*("+s+"|"+S[u]+")",C[z]=new RegExp(S[z],"g");var K=I++;S[K]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var F=I++;S[F]="^\\s*("+S[g]+")\\s+-\\s+("+S[g]+")\\s*$";var B=I++;S[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)P(V,S[V]),C[V]||(C[V]=new RegExp(S[V]));function Q(ee,ae){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>R||!(ae?C[r]:C[c]).test(ee))return null;try{return new Z(ee,ae)}catch(oe){return null}}function Z(ee,ae){if(ee instanceof Z){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Z))return new Z(ee,ae);P("SemVer",ee,ae),this.loose=ae;var oe=ee.trim().match(ae?C[r]:C[c]);if(!oe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var Se=+pe;if(Se>=0&&Se<D)return Se}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,ae){var oe=Q(ee,ae);return oe?oe.version:null},e.clean=function(ee,ae){var oe=Q(ee.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=ee.prerelease[ae];if(P("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return H(oe,pe)}while(++ae)},Z.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new Z(ee,oe).inc(ae,pe).version}catch(Se){return null}},e.diff=function(ee,ae){if(le(ee,ae))return null;var oe=Q(ee),pe=Q(ae);if(oe.prerelease.length||pe.prerelease.length){for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return"pre"+Se;return"prerelease"}for(var Se in oe)if((Se==="major"||Se==="minor"||Se==="patch")&&oe[Se]!==pe[Se])return Se},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,ae){var oe=G.test(ee),pe=G.test(ae);return oe&&pe&&(ee=+ee,ae=+ae),oe&&!pe?-1:pe&&!oe?1:ee<ae?-1:ee>ae?1:0}function re(ee,ae,oe){return new Z(ee,oe).compare(new Z(ae,oe))}function ie(ee,ae,oe){return re(ee,ae,oe)>0}function ce(ee,ae,oe){return re(ee,ae,oe)<0}function le(ee,ae,oe){return re(ee,ae,oe)===0}function de(ee,ae,oe){return re(ee,ae,oe)!==0}function fe(ee,ae,oe){return re(ee,ae,oe)>=0}function be(ee,ae,oe){return re(ee,ae,oe)<=0}function Ce(ee,ae,oe,pe){var Se;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee===oe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),Se=ee!==oe;break;case"":case"=":case"==":Se=le(ee,oe,pe);break;case"!=":Se=de(ee,oe,pe);break;case">":Se=ie(ee,oe,pe);break;case">=":Se=fe(ee,oe,pe);break;case"<":Se=ce(ee,oe,pe);break;case"<=":Se=be(ee,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return Se}function Ee(ee,ae){if(ee instanceof Ee){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,ae);P("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,ae){return H(ae,ee)},e.major=function(ee,ae){return new Z(ee,ae).major},e.minor=function(ee,ae){return new Z(ee,ae).minor},e.patch=function(ee,ae){return new Z(ee,ae).patch},e.compare=re,e.compareLoose=function(ee,ae){return re(ee,ae,!0)},e.rcompare=function(ee,ae,oe){return re(ae,ee,oe)},e.sort=function(ee,ae){return ee.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(ee,ae){return ee.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=fe,e.lte=be,e.cmp=Ce,e.Comparator=Ee;var Ae={};function Pe(ee,ae){if(ee instanceof Pe)return ee.loose===ae?ee:new Pe(ee.raw,ae);if(ee instanceof Ee)return new Pe(ee.value,ae);if(!(this instanceof Pe))return new Pe(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie){return((ae=Le(oe)?"":Le(pe)?">="+oe+".0.0":Le(Se)?">="+oe+"."+pe+".0":">="+ae)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Ne(ee,ae){for(var oe=0;oe<ee.length;oe++)if(!ee[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<ee.length;oe++)if(P(ee[oe].semver),ee[oe].semver!==Ae&&ee[oe].semver.prerelease.length>0){var pe=ee[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(ee,ae,oe){try{ae=new Pe(ae,oe)}catch(pe){return!1}return ae.test(ee)}function xe(ee,ae,oe,pe){var Se,_e,Re,Y,se;switch(ee=new Z(ee,pe),ae=new Pe(ae,pe),oe){case">":Se=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":Se=ce,_e=fe,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,ae,pe))return!1;for(var ue=0;ue<ae.set.length;++ue){var ge=ae.set[ue],me=null,Ie=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ie=Ie||ke,Se(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ie.semver,pe)&&(Ie=ke)}),me.operator===Y||me.operator===se||(!Ie.operator||Ie.operator===Y)&&_e(ee,Ie.semver)||Ie.operator===se&&Re(ee,Ie.semver))return!1}return!0}Ee.prototype.parse=function(ee){var ae=this.loose?C[W]:C[x],oe=ee.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+ee);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Z(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,ae){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(ee.value,ae),$e(this.value,oe,ae);if(ee.operator==="")return oe=new Pe(this.value,ae),$e(ee.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||Se||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),P("range",ee,ae);var oe=ae?C[F]:C[K];ee=ee.replace(oe,Fe),P("hyphen replace",ee),ee=ee.replace(C[z],"$1$2$3"),P("comparator trim",ee,C[z]),ee=(ee=(ee=ee.replace(C[q],"$1~")).replace(C[_],"$1^")).split(/\s+/).join(" ");var pe=ae?C[W]:C[x],Se=ee.split(" ").map(function(_e){return function(Re,Y){return P("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){P("caret",me,Ie);var ke=Ie?C[j]:C[M];return me.replace(ke,function(Te,ye,we,De,Oe){var Me;return P("caret",me,Te,ye,we,De,Oe),Le(ye)?Me="":Le(we)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Me=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+Oe+" <"+(+ye+1)+".0.0"):(P("no pr"),Me=ye==="0"?we==="0"?">="+ye+"."+we+"."+De+" <"+ye+"."+we+"."+(+De+1):">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+De+" <"+(+ye+1)+".0.0"),P("caret return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),P("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){var ke=Ie?C[L]:C[N];return me.replace(ke,function(Te,ye,we,De,Oe){var Me;return P("tilde",me,Te,ye,we,De,Oe),Le(ye)?Me="":Le(we)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Le(De)?Me=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+ye+"."+we+"."+De+Oe+" <"+ye+"."+(+we+1)+".0"):Me=">="+ye+"."+we+"."+De+" <"+ye+"."+(+we+1)+".0",P("tilde return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),P("tildes",Re),Re=function(se,ue){return P("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ie){me=me.trim();var ke=Ie?C[A]:C[b];return me.replace(ke,function(Te,ye,we,De,Oe,Me){P("xRange",me,Te,ye,we,De,Oe,Me);var Qe=Le(we),Ye=Qe||Le(De),je=Ye||Le(Oe);return ye==="="&&je&&(ye=""),Qe?Te=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(Ye&&(De=0),je&&(Oe=0),ye===">"?(ye=">=",Ye?(we=+we+1,De=0,Oe=0):je&&(De=+De+1,Oe=0)):ye==="<="&&(ye="<",Ye?we=+we+1:De=+De+1),Te=ye+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),P("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),P("xrange",Re),Re=function(se,ue){return P("replaceStars",se,ue),se.trim().replace(C[B],"")}(Re,Y),P("stars",Re),Re}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(_e){return!!_e.match(pe)})),Se=Se.map(function(_e){return new Ee(_e,ae)})},Pe.prototype.intersects=function(ee,ae){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return ee.set.some(function(Se){return Se.every(function(_e){return pe.intersects(_e,ae)})})})})},e.toComparators=function(ee,ae){return new Pe(ee,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==-1||(Se=new Z(pe=Re,oe)))}),pe},e.minSatisfying=function(ee,ae,oe){var pe=null,Se=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&Se.compare(Re)!==1||(Se=new Z(pe=Re,oe)))}),pe},e.validRange=function(ee,ae){try{return new Pe(ee,ae).range||"*"}catch(oe){return null}},e.ltr=function(ee,ae,oe){return xe(ee,ae,"<",oe)},e.gtr=function(ee,ae,oe){return xe(ee,ae,">",oe)},e.outside=xe,e.prerelease=function(ee,ae){var oe=Q(ee,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(ee,ae,oe){return ee=new Pe(ee,oe),ae=new Pe(ae,oe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var ae=ee.match(C[U]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,k(1))},function(X,e){var k,T,P=X.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function C(y){if(k===setTimeout)return setTimeout(y,0);if((k===R||!k)&&setTimeout)return k=setTimeout,setTimeout(y,0);try{return k(y,0)}catch(m){try{return k.call(null,y,0)}catch(v){return k.call(this,y,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:R}catch(y){k=R}try{T=typeof clearTimeout=="function"?clearTimeout:D}catch(y){T=D}})();var S,I=[],i=!1,E=-1;function f(){i&&S&&(i=!1,S.length?I=S.concat(I):E=-1,I.length&&p())}function p(){if(!i){var y=C(f);i=!0;for(var m=I.length;m;){for(S=I,I=[];++E<m;)S&&S[E].run();E=-1,m=I.length}S=null,i=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===D||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch(d){try{return T.call(null,v)}catch(l){return T.call(this,v)}}}(y)}}function h(y,m){this.fun=y,this.array=m}function w(){}P.nextTick=function(y){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];I.push(new h(y,m)),I.length!==1||i||C(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=w,P.addListener=w,P.once=w,P.off=w,P.removeListener=w,P.removeAllListeners=w,P.emit=w,P.prependListener=w,P.prependOnceListener=w,P.listeners=function(y){return[]},P.binding=function(y){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(y){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(X,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(C,S,I){this.level=C,this.key=S,this.value=I,this.forward=[]}}const P=void 0;class R{constructor(C,S=2**16){this.comparator=C,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new T(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new T(this._maxLevel,P,P)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,S){return R._insert(this,C,S,this.comparator)&&(this._size+=1),this}delete(C){const S=R._delete(this,C,this.comparator);return S&&(this._size-=1),S}forEach(C,S){let I=this._header.forward[0];for(;I;)C.call(S,I.value,I.key,this),I=I.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",S=this._header.forward[0];for(;S;)C+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return C}static _search(C,S,I){let i=C._header;for(let E=C._level-1;E>=0;E--)for(;i.forward[E]&&I(i.forward[E].key,S)<0;)i=i.forward[E];if(i=i.forward[0],i&&I(i.key,S)===0)return i}static _insert(C,S,I,i){let E=[],f=C._header;for(let p=C._level-1;p>=0;p--){for(;f.forward[p]&&i(f.forward[p].key,S)<0;)f=f.forward[p];E[p]=f}if(f=f.forward[0],f&&i(f.key,S)===0)return f.value=I,!1;{let p=R._randomLevel(C);if(p>C._level){for(let h=C._level;h<p;h++)E[h]=C._header;C._level=p}f=new T(p,S,I);for(let h=0;h<p;h++)f.forward[h]=E[h].forward[h],E[h].forward[h]=f;return!0}}static _randomLevel(C,S=.5){let I=1;for(;Math.random()<S&&I<C._maxLevel;)I+=1;return I}static _delete(C,S,I){let i=[],E=C._header;for(let f=C._level-1;f>=0;f--){for(;E.forward[f]&&I(E.forward[f].key,S)<0;)E=E.forward[f];i[f]=E}if(E=E.forward[0],!E||I(E.key,S)!==0)return!1;for(let f=0;f<C._level&&i[f].forward[f]===E;f++)i[f].forward[f]=E.forward[f];for(;C._level>0&&C._header.forward[C._level-1]===P;)C._level-=1;return!0}}e.SkipList=R}),define(te[105],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=k.globals.performance&&typeof k.globals.performance.now=="function";class P{constructor(D){this._highResolution=T&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new P(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=P}),define(te[3],ne([0,1,7,69,2,102,105]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(l){l.None=()=>P.Disposable.None;function c(_){return(M,j=null,W)=>{let x=!1,z;return z=_(K=>{if(!x)return z?z.dispose():x=!0,M.call(j,K)},null,W),x&&z.dispose(),z}}l.once=c;function t(_,M){return u((j,W=null,x)=>_(z=>j.call(W,M(z)),null,x))}l.map=t;function s(_,M){return u((j,W=null,x)=>_(z=>{M(z),j.call(W,z)},null,x))}l.forEach=s;function r(_,M){return u((j,W=null,x)=>_(z=>M(z)&&j.call(W,z),null,x))}l.filter=r;function n(_){return _}l.signal=n;function a(..._){return(M,j=null,W)=>(0,P.combinedDisposable)(..._.map(x=>x(z=>M.call(j,z),null,W)))}l.any=a;function o(_,M,j){let W=j;return t(_,x=>(W=M(W,x),W))}l.reduce=o;function u(_){let M;const j=new f({onFirstListenerAdd(){M=_(j.fire,j)},onLastListenerRemove(){M.dispose()}});return j.event}function g(_,M,j=100,W=!1,x){let z,K,F,B=0;const V=new f({leakWarningThreshold:x,onFirstListenerAdd(){z=_(Q=>{B++,K=M(K,Q),W&&!F&&(V.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const Z=K;K=void 0,F=void 0,(!W||B>1)&&V.fire(Z),B=0},j)})},onLastListenerRemove(){z.dispose()}});return V.event}l.debounce=g;function b(_,M=(j,W)=>j===W){let j=!0,W;return r(_,x=>{const z=j||!M(x,W);return j=!1,W=x,z})}l.latch=b;function A(_,M){return[l.filter(_,M),l.filter(_,j=>!M(j))]}l.split=A;function U(_,M=!1,j=[]){let W=j.slice(),x=_(F=>{W?W.push(F):K.fire(F)});const z=()=>{W&&W.forEach(F=>K.fire(F)),W=null},K=new f({onFirstListenerAdd(){x||(x=_(F=>K.fire(F)))},onFirstListenerDidAdd(){W&&(M?setTimeout(z):z())},onLastListenerRemove(){x&&x.dispose(),x=null}});return K.event}l.buffer=U;class O{constructor(M){this.event=M}map(M){return new O(t(this.event,M))}forEach(M){return new O(s(this.event,M))}filter(M){return new O(r(this.event,M))}reduce(M,j){return new O(o(this.event,M,j))}latch(){return new O(b(this.event))}debounce(M,j=100,W=!1,x){return new O(g(this.event,M,j,W,x))}on(M,j,W){return this.event(M,j,W)}once(M,j,W){return c(this.event)(M,j,W)}}function q(_){return new O(_)}l.chain=q;function N(_,M,j=W=>W){const W=(...F)=>K.fire(j(...F)),x=()=>_.on(M,W),z=()=>_.removeListener(M,W),K=new f({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}l.fromNodeEventEmitter=N;function L(_,M,j=W=>W){const W=(...F)=>K.fire(j(...F)),x=()=>_.addEventListener(M,W),z=()=>_.removeEventListener(M,W),K=new f({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}l.fromDOMEventEmitter=L;function $(_){return new Promise(M=>c(_)(M))}l.toPromise=$})(C=e.Event||(e.Event={}));class S{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${S._idPool++}`}start(c){this._stopWatch=new D.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let I=-1;function i(l){const c=I;return I=l,{dispose(){I=c}}}e.setGlobalLeakWarningThreshold=i;class E{constructor(c,t=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let t=I;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||c<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let n,a=0;for(const[o,u]of this._stacks)(!n||a<u)&&(n=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${a}):`),console.warn(n)}return()=>{const n=this._stacks.get(s)||0;this._stacks.set(s,n-1)}}}class f{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=I>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(c,t,s)=>{this._listeners||(this._listeners=new R.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(t?[c,t]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,t);const a=this._leakageMon?.check(this._listeners.size),o=(0,P.toDisposable)(()=>{a&&a(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof P.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(r){(0,k.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class p extends f{async fireAsync(c,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),a=[],o={...n,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,k.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const g of u)g.status==="rejected"&&(0,k.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=p;class h extends f{constructor(c){super(c);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=h;class w extends h{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=w;class y extends f{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const t={event:c,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,P.toDisposable)((0,T.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(t=>this.emitter.fire(t))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class v{constructor(){this.buffers=[]}wrapEvent(c){return(t,s,r)=>c(n=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(s,n)):t.call(s,n)},void 0,r)}bufferEvents(c){const t=[];this.buffers.push(t);const s=c();return this.buffers.pop(),t.forEach(r=>r()),s}}e.EventBufferer=v;class d{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=P.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=d}),define(te[28],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,S){const I=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(I)}}});var P;(function(C){function S(I){return I===C.None||I===C.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=P.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=D}),define(te[49],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new k.Emitter}add(E){const f=this._icons.get(E.id);f?E.description?f.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new T;e.iconRegistry=P;function R(i,E){return new C(i,E)}e.registerCodicon=R;function D(i){return i?i.replace(/\$\((.*?)\)/g,(E,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=D;class C{constructor(E,f,p){this.id=E,this.definition=f,this.description=p,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(i,E){const f=["codicon","codicon-"+i];return E&&f.push("codicon-modifier-"+E),f}e.getClassNamesArray=S;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function f(w){if(w instanceof C)return["codicon","codicon-"+w.id];const y=E.exec(w.id);if(!y)return f(C.error);let[,m,v]=y;const d=["codicon","codicon-"+m];return v&&d.push("codicon-modifier-"+v.substr(1)),d}i.asClassNameArray=f;function p(w){return f(w).join(" ")}i.asClassName=p;function h(w){return"."+f(w).join(".")}i.asCSSSelector=h})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(C=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,7,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=P;function R(d){const l=d;return l?P(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=R;function D(d,l){return new C(d,l)}e.newWriteableStream=D;class C{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,k.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(c);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(d,l){const c=[];let t;for(;(t=d.read())!==null;)c.push(t);return l(c)}e.consumeReadable=S;function I(d,l,c){const t=[];let s;for(;(s=d.read())!==null&&t.length<c;)t.push(s);return s===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=I;function i(d,l){return new Promise((c,t)=>{const s=[];E(d,{onData:r=>{l&&s.push(r)},onError:r=>{l?t(r):c(void 0)},onEnd:()=>{c(l?l(s):void 0)}})})}e.consumeStream=i;function E(d,l){d.on("error",c=>l.onError(c)),d.on("end",()=>l.onEnd()),d.on("data",c=>l.onData(c))}e.listenStream=E;function f(d,l){return new Promise((c,t)=>{const s=new T.DisposableStore,r=[],n=u=>{if(r.push(u),r.length>l)return s.dispose(),d.pause(),c({stream:d,buffer:r,ended:!1})},a=u=>t(u),o=()=>c({stream:d,buffer:r,ended:!0});s.add((0,T.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),s.add((0,T.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),s.add((0,T.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=f;function p(d,l){const c=D(l);return c.end(d),c}e.toStream=p;function h(){const d=D(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function w(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=w;function y(d,l,c){const t=D(c);return E(d,{onData:s=>t.write(l.data(s)),onError:s=>t.error(l.error?l.error(s):s),onEnd:()=>t.end()}),t}e.transform=y;function m(d,l,c){let t=!1;return{read:()=>{const s=l.read();return t?s:(t=!0,s!==null?c([d,s]):d)}}}e.prefixedReadable=m;function v(d,l,c){let t=!1;const s=D(c);return E(l,{onData:r=>t?s.write(r):(t=!0,s.write(c([d,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(d)),s.end()}}),s}e.prefixedStream=v}),define(te[19],ne([0,1,50]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let P,R;class D{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return T?new D(Buffer.allocUnsafe(n)):new D(new Uint8Array(n))}static wrap(n){return T&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new D(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&T?new D(Buffer.from(n)):(P||(P=new TextEncoder),new D(P.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let g=0,b=n.length;g<b;g++)a+=n[g].byteLength}const o=D.alloc(a);let u=0;for(let g=0,b=n.length;g<b;g++){const A=n[g];o.set(A,u),u+=A.byteLength}return o}toString(){return T?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,a){return new D(this.buffer.subarray(n,a))}set(n,a){n instanceof D?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return I(this.buffer,n)}writeUInt32BE(n,a){i(this.buffer,n,a)}readUInt32LE(n){return E(this.buffer,n)}writeUInt32LE(n,a){f(this.buffer,n,a)}readUInt8(n){return p(this.buffer,n)}writeUInt8(n,a){h(this.buffer,n,a)}}e.VSBuffer=D;function C(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}e.readUInt16LE=C;function S(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255}e.writeUInt16LE=S;function I(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}e.readUInt32BE=I;function i(r,n,a){r[a+3]=n,n=n>>>8,r[a+2]=n,n=n>>>8,r[a+1]=n,n=n>>>8,r[a]=n}e.writeUInt32BE=i;function E(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}e.readUInt32LE=E;function f(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255,n=n>>>8,r[a+2]=n&255,n=n>>>8,r[a+3]=n&255}e.writeUInt32LE=f;function p(r,n){return r[n]}e.readUInt8=p;function h(r,n,a){r[a]=n}e.writeUInt8=h;function w(r){return k.consumeReadable(r,n=>D.concat(n))}e.readableToBuffer=w;function y(r){return k.toReadable(r)}e.bufferToReadable=y;function m(r){return k.consumeStream(r,n=>D.concat(n))}e.streamToBuffer=m;async function v(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await m(r.stream)])}e.bufferedStreamToBuffer=v;function d(r){return k.toStream(r,n=>D.concat(n))}e.bufferToStream=d;function l(r){return k.transform(r,{data:n=>typeof n=="string"?D.fromString(n):D.wrap(n)},n=>D.concat(n))}e.streamToBufferReadableStream=l;function c(r){return k.newWriteableStream(n=>D.concat(n),r)}e.newWriteableBufferStream=c;function t(r,n){return k.prefixedReadable(r,n,a=>D.concat(a))}e.prefixedBufferReadable=t;function s(r,n){return k.prefixedStream(r,n,a=>D.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function P(Y,...se){return se.length===0?Y:Y.replace(T,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=P;const R=/{([^}]+)}/g;function D(Y,se){return Y.replace(R,(ue,ge)=>se[ge]??ue)}e.format2=D;function C(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=I;function i(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=i;function E(Y,se=" "){const ue=f(Y,se);return p(ue,se)}e.trim=E;function f(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=f;function p(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ie=-1;for(;Ie=Y.lastIndexOf(se,me-1),!(Ie===-1||Ie+ue!==me);){if(Ie===0)return"";me=Ie}return Y.substring(0,me)}e.rtrim=p;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(Y){return Y.replace(/\*/g,"")}e.stripWildcards=w;function y(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=y;function m(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function d(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=d;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function c(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function t(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function n(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye<we)return-1;if(ye>we)return 1}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=n;function a(Y,se){return o(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function o(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let ye=Y.charCodeAt(ue),we=se.charCodeAt(me);if(ye===we)continue;if(ye>=128||we>=128)return n(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ie);u(ye)&&(ye-=32),u(we)&&(we-=32);const De=ye-we;if(De!==0)return De}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=o;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function g(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=g;function b(Y,se){return Y.length===se.length&&o(Y,se)===0}e.equalsIgnoreCase=b;function A(Y,se){const ue=se.length;return se.length>Y.length?!1:o(Y,se,0,ue)===0}e.startsWithIgnoreCase=A;function U(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=U;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ie=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ie-ue))return ue;return ge}e.commonSuffixLength=O;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function L(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=L;function $(Y,se,ue){const ge=Y.charCodeAt(ue);if(q(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(N(me))return L(ge,me)}return ge}e.getNextCodePoint=$;function _(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(q(ge))return L(ge,ue)}return ue}function M(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ie=$(Y,me,se);se+=Ie>=65536?2:1;let ke=ue.getGraphemeBreakType(Ie);for(;se<me;){const Te=$(Y,me,se),ye=ue.getGraphemeBreakType(Te);if($e(ke,ye))break;se+=Te>=65536?2:1,ke=ye}return se-ge}e.nextCharLength=M;function j(Y,se){const ue=ee.getInstance(),ge=se,me=_(Y,se);se-=me>=65536?2:1;let Ie=ue.getGraphemeBreakType(me);for(;se>0;){const ke=_(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ie))break;se-=ke>=65536?2:1,Ie=Te}return ge-se}e.prevCharLength=j;function W(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ie=$(Y,ge,se),ke=ue.getGraphemeBreakType(Ie);se+=Ie>=65536?2:1;let Te=ke;for(;se<ge;){const we=$(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const ye=se;for(se=me,Te=ke;se>0;){const we=_(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,ye]}function x(Y,se){return se>0&&N(Y.charCodeAt(se))?W(Y,se-1):W(Y,se)}e.getCharContainingOffset=x;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return z.test(Y)}e.containsRTL=K;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return F.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(de,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ce(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ie=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ie+1);if(ke<0)return!1;Ie=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ae;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function Ne(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=ae()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function oe(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=_(se,Y);return Y-=Se(ge),Y}e.getLeftDeleteOffset=oe;function pe(Y,se){let ue=_(se,Y);for(Y-=Se(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=_(se,Y),Y-=Se(ue)}if(!!re(ue)){if(Y>=0){const ge=_(se,Y);ge===8205&&(Y-=Se(ge))}return Y}}function Se(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={}))}),define(te[106],ne([0,1,25]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(m){return P(m,0)}e.hash=T;function P(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?S(m,v):I(m,v);case"string":return C(m,v);case"boolean":return D(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=P;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function D(m,v){return R(m?433:863,v)}function C(m,v){v=R(149417,v);for(let d=0,l=m.length;d<l;d++)v=R(m.charCodeAt(d),v);return v}e.stringHash=C;function S(m,v){return v=R(104579,v),m.reduce((d,l)=>P(l,d),v)}function I(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((d,l)=>(d=C(l,d),P(m[l],d)),v)}class i{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=P(v,this._value),this._value}}e.Hasher=i;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(m,v,d=32){const l=d-v,c=~((1<<l)-1);return(m<<v|(c&m)>>>l)>>>0}function p(m,v=0,d=m.byteLength,l=0){for(let c=0;c<d;c++)m[v+c]=l}function h(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function w(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),v/4)}e.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d===0)return;const l=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=v.charCodeAt(0),r=0);;){let n=s;if(k.isHighSurrogate(s))if(r+1<d){const a=v.charCodeAt(r+1);k.isLowSurrogate(a)?(r++,n=k.computeCodePoint(s,a)):n=65533}else{t=s;break}else k.isLowSurrogate(s)&&(n=65533);if(c=this._push(l,c,n),r++,r<d)s=v.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=t}_push(v,d,l){return l<128?v[d++]=l:l<2048?(v[d++]=192|(l&1984)>>>6,v[d++]=128|(l&63)>>>0):l<65536?(v[d++]=224|(l&61440)>>>12,v[d++]=128|(l&4032)>>>6,v[d++]=128|(l&63)>>>0):(v[d++]=240|(l&1835008)>>>18,v[d++]=128|(l&258048)>>>12,v[d++]=128|(l&4032)>>>6,v[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=y._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,f(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let l=this._h0,c=this._h1,t=this._h2,s=this._h3,r=this._h4,n,a,o;for(let u=0;u<80;u++)u<20?(n=c&t|~c&s,a=1518500249):u<40?(n=c^t^s,a=1859775393):u<60?(n=c&t|c&s|t&s,a=2400959708):(n=c^t^s,a=3395469782),o=f(l,5)+n+r+a+v.getUint32(u*4,!1)&4294967295,r=s,s=t,t=f(c,30),c=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(X,e,k,T,P){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!P:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?P.call(X,k):P?P.value=k:e.set(X,k),k},Ve=this&&this.__classPrivateFieldGet||function(X,e,k,T){if(k==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!T:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?T:k==="a"?T.call(X):T?T.value:e.get(X)};define(te[41],ne([0,1,16,25]),function(X,e,k,T){"use strict";var P,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(r,n,a){let o=r.get(n);return o===void 0&&(o=a,r.set(n,o)),o}e.getOrSet=C;function S(r){const n=[];return r.forEach((a,o)=>{n.push(`${o} => ${a}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=S;function I(r){const n=[];return r.forEach(a=>{n.push(a)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=I;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const a=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=i;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(n=!0,a=!0){this._splitOnBackslash=n,this._caseSensitive=a}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class m{constructor(n){this._iter=n}static forUris(n=()=>!1){return new m(new h(n))}static forPaths(){return new m(new f)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(n,a){if(a){const o=a.slice(0);(0,k.shuffle)(o);for(let u of o)this.set(u,n)}else{const o=n.slice(0);(0,k.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(n,a){const o=this._iter.reset(n);let u;this._root||(this._root=new w,this._root.segment=o.value());const g=[];for(u=this._root;;){const A=o.cmp(u.segment);if(A>0)u.left||(u.left=new w,u.left.segment=o.value()),g.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new w,u.right.segment=o.value()),g.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new w,u.mid.segment=o.value()),g.push([0,u]),u=u.mid;else break}const b=u.value;u.value=a,u.key=n;for(let A=g.length-1;A>=0;A--){const U=g[A][1];U.updateHeight();const O=U.balanceFactor();if(O<-1||O>1){const q=g[A][0],N=g[A+1][0];if(q===1&&N===1)g[A][1]=U.rotateLeft();else if(q===-1&&N===-1)g[A][1]=U.rotateRight();else if(q===1&&N===-1)U.right=g[A+1][1]=g[A+1][1].rotateRight(),g[A][1]=U.rotateLeft();else if(q===-1&&N===1)U.left=g[A+1][1]=g[A+1][1].rotateLeft(),g[A][1]=U.rotateRight();else throw new Error;if(A>0)switch(g[A-1][0]){case-1:g[A-1][1].left=g[A][1];break;case 1:g[A-1][1].right=g[A][1];break;case 0:g[A-1][1].mid=g[A][1];break}else this._root=g[0][1]}}return b}get(n){return this._getNode(n)?.value}_getNode(n){const a=this._iter.reset(n);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(n){const a=this._getNode(n);return!(a?.value===void 0&&a?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,a){const o=this._iter.reset(n),u=[];let g=this._root;for(;g;){const b=o.cmp(g.segment);if(b>0)u.push([-1,g]),g=g.left;else if(b<0)u.push([1,g]),g=g.right;else if(o.hasNext())o.next(),u.push([0,g]),g=g.mid;else break}if(!!g){if(a?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const b=this._min(g.right),{key:A,value:U,segment:O}=b;this._delete(b.key,!1),g.key=A,g.value=U,g.segment=O}else{const b=g.left??g.right;if(u.length>0){const[A,U]=u[u.length-1];switch(A){case-1:U.left=b;break;case 0:U.mid=b;break;case 1:U.right=b;break}}else this._root=b}for(let b=u.length-1;b>=0;b--){const A=u[b][1];A.updateHeight();const U=A.balanceFactor();if(U>1?(A.right.balanceFactor()>=0||(A.right=u[b+1][1]=u[b+1][1].rotateRight()),u[b][1]=A.rotateLeft()):U<-1&&(A.left.balanceFactor()<=0||(A.left=u[b+1][1]=u[b+1][1].rotateLeft()),u[b][1]=A.rotateRight()),b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const a=this._iter.reset(n);let o=this._root,u;for(;o;){const g=a.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(n){const a=this._iter.reset(n);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[a,o]of this)n(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:n(a.left)&&n(a.right)};return n(this._root)}}e.TernarySearchTree=m;class v{constructor(n,a){this.uri=n,this.value=a}}class d{constructor(n,a){this[P]="ResourceMap",n instanceof d?(this.map=new Map(n.map),this.toKey=a??d.defaultToKey):(this.map=new Map,this.toKey=n??d.defaultToKey)}set(n,a){return this.map.set(this.toKey(n),new v(n,a)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,a){typeof a!="undefined"&&(n=n.bind(a));for(let[o,u]of this.map)n(u.value,u.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,a=0){const o=this._map.get(n);if(!!o)return a!==0&&this.touch(o,a),o.value}set(n,a,o=0){let u=this._map.get(n);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:n,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this._map.get(n);if(!!a)return this._map.delete(n),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,a){const o=this._state;let u=this._head;for(;u;){if(a?n.bind(a)(u.value,u.key,this):n(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.key,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}values(){const n=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.value,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}entries(){const n=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:[o.key,o.value],done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>n;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const a=n.next,o=n.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}n.next=void 0,n.previous=void 0,this._state++}touch(n,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this._head)return;const o=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(a===2){if(n===this._tail)return;const o=n.next,u=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((a,o)=>{n.push([o,a])}),n}fromJSON(n){this.clear();for(const[a,o]of n)this.set(a,o)}}e.LinkedMap=c;class t extends c{constructor(n,a=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(n){D.set(this,void 0),Ct(this,D,n,"f")}get size(){return Ve(this,D,"f").size}forEach(n,a){Ve(this,D,"f").forEach(n,a)}get(n){return Ve(this,D,"f").get(n)}has(n){return Ve(this,D,"f").has(n)}entries(){return Ve(this,D,"f").entries()}keys(){return Ve(this,D,"f").keys()}values(){return Ve(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ve(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(te[70],ne([0,1,41]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new k.LRUCache(1e4);function P(I){return S(I,"NFC",T)}e.normalizeNFC=P;const R=new k.LRUCache(1e4);function D(I){return S(I,"NFD",R)}e.normalizeNFD=D;const C=/[^\u0000-\u0080]/;function S(I,i,E){if(!I)return I;const f=E.get(I);if(f)return f;let p;return C.test(I)?p=I.normalize(i):p=I,E.set(I,p),p}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(i){return D(i).replace(I,"")}}()}),define(te[17],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(g){return Array.isArray(g)}e.isArray=k;function T(g){return typeof g=="string"}e.isString=T;function P(g){return Array.isArray(g)&&g.every(b=>T(b))}e.isStringArray=P;function R(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=R;function D(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=D;function C(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=C;function S(g){return g===!0||g===!1}e.isBoolean=S;function I(g){return typeof g=="undefined"}e.isUndefined=I;function i(g){return!E(g)}e.isDefined=i;function E(g){return I(g)||g===null}e.isUndefinedOrNull=E;function f(g,b){if(!g)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=f;function p(g){if(E(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function h(...g){const b=[];for(let A=0;A<g.length;A++){const U=g[A];if(E(U))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);b.push(U)}return b}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function y(g){if(!R(g))return!1;for(let b in g)if(w.call(g,b))return!1;return!0}e.isEmptyObject=y;function m(g){return typeof g=="function"}e.isFunction=m;function v(...g){return g.length>0&&g.every(m)}e.areFunctions=v;function d(g,b){const A=Math.min(g.length,b.length);for(let U=0;U<A;U++)l(g[U],b[U])}e.validateConstraints=d;function l(g,b){if(T(b)){if(typeof g!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(m(b)){try{if(g instanceof b)return}catch{}if(!E(g)&&g.constructor===b||b.length===1&&b.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(g){let b=[],A=Object.getPrototypeOf(g);for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}e.getAllPropertyNames=c;function t(g){const b=[];for(const A of c(g))typeof g[A]=="function"&&b.push(A);return b}e.getAllMethodNames=t;function s(g,b){const A=O=>function(){const q=Array.prototype.slice.call(arguments,0);return b(O,q)};let U={};for(const O of g)U[O]=A(O);return U}e.createProxyObject=s;function r(g){return g===null?void 0:g}e.withNullAsUndefined=r;function n(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=n;function a(g){return class{constructor(){return new Proxy({},{get(b,A){if(b[A])return b[A];throw new Error(`Not Implemented: ${g}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function o(g,b="Unreachable"){throw new Error(b)}e.assertNever=o;function u(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=u}),define(te[42],ne([0,1,9,4,25,17]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function C(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=C;function S(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function I(r,n=k.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(D(o)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let g=3;const b=g;for(;g<a&&!D(r.charCodeAt(g));g++);if(b!==g&&!D(r.charCodeAt(g+1))){for(g+=1;g<a;g++)if(D(r.charCodeAt(g)))return r.slice(0,g+1).replace(/[\\/]/g,n)}}return n}else if(m(o)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=I;function i(r){if(!T.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let a=2;const o=a;for(;a<r.length&&(n=r.charCodeAt(a),n!==92);a++);return!(o===a||(n=r.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,n=T.isWindows){const a=n?E:f;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||n&&p.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,n,a){const o=r===n;return!a||o?o:!r||!n?!1:(0,P.equalsIgnoreCase)(r,n)}e.isEqual=w;function y(r,n,a,o=k.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(a){if(!(0,P.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let g=n.length;return n.charAt(n.length-1)===o&&g--,r.charAt(g)===o}return n.charAt(n.length-1)!==o&&(n+=o),r.indexOf(n)===0}e.isEqualOrParent=y;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=m;function v(r,n){return T.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(n,r)),r=(0,k.normalize)(r),T.isWindows?(r=(0,P.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,P.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=v;function d(r){const n=(0,k.normalize)(r);return T.isWindows?r.length>3?!1:l(n)&&(r.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=d;function l(r){return T.isWindows?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function t(r,n,a){return n.length>r.length?-1:r===n?0:(a&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function s(r){const n=r.split(":");let a,o,u;if(n.forEach(g=>{const b=Number(g);(0,R.isNumber)(b)?o===void 0?o=b:u===void 0&&(u=b):a=a?[a,g].join(":"):g}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,17]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const y=Array.isArray(w)?[]:{};return Object.keys(w).forEach(m=>{w[m]&&typeof w[m]=="object"?y[m]=T(w[m]):y[m]=w[m]}),y}e.deepClone=T;function P(w){if(!w||typeof w!="object")return w;const y=[w];for(;y.length>0;){const m=y.shift();Object.freeze(m);for(const v in m)if(R.call(m,v)){const d=m[v];typeof d=="object"&&!Object.isFrozen(d)&&y.push(d)}}return w}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function D(w,y){return C(w,y,new Set)}e.cloneAndChange=D;function C(w,y,m){if((0,k.isUndefinedOrNull)(w))return w;const v=y(w);if(typeof v!="undefined")return v;if((0,k.isArray)(w)){const d=[];for(const l of w)d.push(C(l,y,m));return d}if((0,k.isObject)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const d={};for(let l in w)R.call(w,l)&&(d[l]=C(w[l],y,m));return m.delete(w),d}return w}function S(w,y,m=!0){return(0,k.isObject)(w)?((0,k.isObject)(y)&&Object.keys(y).forEach(v=>{v in w?m&&((0,k.isObject)(w[v])&&(0,k.isObject)(y[v])?S(w[v],y[v],m):w[v]=y[v]):w[v]=y[v]}),w):y}e.mixin=S;function I(w,y){if(w===y)return!0;if(w==null||y===null||y===void 0||typeof w!=typeof y||typeof w!="object"||Array.isArray(w)!==Array.isArray(y))return!1;let m,v;if(Array.isArray(w)){if(w.length!==y.length)return!1;for(m=0;m<w.length;m++)if(!I(w[m],y[m]))return!1}else{const d=[];for(v in w)d.push(v);d.sort();const l=[];for(v in y)l.push(v);if(l.sort(),!I(d,l))return!1;for(m=0;m<d.length;m++)if(!I(w[d[m]],y[d[m]]))return!1}return!0}e.equals=I;function i(w){const y=new Set;return JSON.stringify(w,(m,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(y.has(v))return"[Circular]";y.add(v)}return v})}e.safeStringify=i;function E(w,y,m){const v=y(w);return typeof v=="undefined"?m:v}e.getOrDefault=E;function f(w,y){const m=Object.create(null);return!w||!y||Object.keys(y).forEach(d=>{const l=w[d],c=y[d];I(l,c)||(m[d]=c)}),m}e.distinct=f;function p(w,y){const m=y.toLowerCase(),v=Object.keys(w).find(d=>d.toLowerCase()===m);return v?w[v]:w[y]}e.getCaseInsensitive=p;function h(w,y){const m=Object.create(null);for(const v of Object.keys(w))y(v,w[v])&&(m[v]=w[v]);return m}e.filter=h}),define(te[8],ne([0,1,9,4]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function C(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,n){return!r&&!n?"file":r}function I(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==E&&(n=E+n):n=E;break}return n}const i="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,a,o,u,g,b=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,b),this.authority=a||i,this.path=I(this.scheme,o||i),this.query=u||i,this.fragment=g||i,C(this,b))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:o,path:u,query:g,fragment:b}=n;return a===void 0?a=this.scheme:a===null&&(a=i),o===void 0?o=this.authority:o===null&&(o=i),u===void 0?u=this.path:u===null&&(u=i),g===void 0?g=this.query:g===null&&(g=i),b===void 0?b=this.fragment:b===null&&(b=i),a===this.scheme&&o===this.authority&&u===this.path&&g===this.query&&b===this.fragment?this:new w(a,o,u,g,b)}static parse(n,a=!1){const o=f.exec(n);return o?new w(o[2]||i,s(o[4]||i),s(o[5]||i),s(o[7]||i),s(o[9]||i),a):new w(i,i,i,i,i)}static file(n){let a=i;if(T.isWindows&&(n=n.replace(/\\/g,E)),n[0]===E&&n[1]===E){const o=n.indexOf(E,2);o===-1?(a=n.substring(2),n=E):(a=n.substring(2,o),n=n.substring(o)||E)}return new w("file",a,n,i,i)}static from(n){const a=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return C(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return T.isWindows&&n.scheme==="file"?o=p.file(k.win32.join(d(n,!0),...a)).path:o=k.posix.join(n.path,...a),n.with({path:o})}toString(n=!1){return l(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const a=new w(n);return a._formatted=n.external,a._fsPath=n._sep===h?n.fsPath:null,a}}else return n}}e.URI=p;const h=T.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(r,n){let a,o=-1;for(let u=0;u<r.length;u++){const g=r.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||n&&g===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const b=y[g];b!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=b):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function v(r){let n;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(n===void 0&&(n=r.substr(0,a)),n+=y[o]):n!==void 0&&(n+=r[a])}return n!==void 0?n:r}function d(r,n){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,T.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=d;function l(r,n){const a=n?v:m;let o="",{scheme:u,authority:g,path:b,query:A,fragment:U}=r;if(u&&(o+=u,o+=":"),(g||u==="file")&&(o+=E,o+=E),g){let O=g.indexOf("@");if(O!==-1){const q=g.substr(0,O);g=g.substr(O+1),O=q.indexOf(":"),O===-1?o+=a(q,!1):(o+=a(q.substr(0,O),!1),o+=":",o+=a(q.substr(O+1),!1)),o+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?o+=a(g,!1):(o+=a(g.substr(0,O),!1),o+=g.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}o+=a(b,!0)}return A&&(o+="?",o+=a(A,!1)),U&&(o+="#",o+=n?U:m(U,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,n=>c(n)):r}}),define(te[107],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(I){const i=I;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=T;function P(I){const i=[];let E;try{const f=JSON.parse(I.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),E=p.__$stack),i.push(...f)}catch(f){i.push("Unable to log remote console arguments",I.arguments)}return{args:i,stack:E}}e.parse=P;function R(I){if(typeof I!="string")return R(P(I).stack);const i=I;if(i){const E=D(i),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=R;function D(I){if(!I)return I;const i=I.indexOf(`
`);return i===-1?I:I.substring(0,i)}function C(I,i){const{args:E,stack:f}=P(I),p=typeof E[0]=="string"&&E.length===1;let h=D(f);h&&(h=`(${h.trim()})`);let w=[];if(typeof E[0]=="string"?h&&p?w=[`%c[${i}] %c${E[0]} %c${h}`,S("blue"),S(""),S("grey")]:w=[`%c[${i}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:w=[`%c[${i}]%`,S("blue"),...E],h&&!p&&w.push(h),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,w)}e.log=C;function S(I){return`color: ${I}`}}),define(te[108],ne([0,1,19,25,8]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(i){return JSON.stringify(i,S)}e.stringify=R;function D(i){let E=JSON.parse(i);return E=I(E),E}e.parse=D;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function S(i,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,T.regExpFlags)(E)}:E}function I(i,E=0){if(!i||E>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return P.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof k.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let f=0;f<i.length;++f)i[f]=I(i[f],E+1);else for(const f in i)Object.hasOwnProperty.call(i,f)&&(i[f]=I(i[f],E+1))}return i}e.revive=I}),define(te[15],ne([0,1,4,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,I,i){this._hosts[S]=I,this._ports[S]=i}setConnectionToken(S,I){this._connectionTokens[S]=I}rewrite(S){if(this._delegate)return this._delegate(S);const I=S.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const E=this._ports[I],f=this._connectionTokens[I];let p=`path=${encodeURIComponent(S.path)}`;return typeof f=="string"&&(p+=`&tkn=${encodeURIComponent(f)}`),T.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${i}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new R;class D{asBrowserUri(S,I){const i=this.toUri(S,I);return i.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===P.file&&(k.isNative||typeof k.globals.importScripts=="function"&&k.globals.origin===`${P.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?i.with({scheme:P.vscodeFileResource,authority:i.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,I){const i=this.toUri(S,I);return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==D.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,I){return T.URI.isUri(S)?S:T.URI.parse(I.toUrl(S))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(te[18],ne([0,1,42,15,9,4,25,8]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=S;class I{constructor(h){this._ignorePathCasing=h}compare(h,w,y=!1){return h===w?0:(0,D.compare)(this.getComparisonKey(h,y),this.getComparisonKey(w,y))}isEqual(h,w,y=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,y)===this.getComparisonKey(w,y)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,y=!1){if(h.scheme===w.scheme){if(h.scheme===T.Schemas.file)return k.isEqualOrParent(S(h),S(w),this._ignorePathCasing(h))&&h.query===w.query&&(y||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return k.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(y||h.fragment===w.fragment)}return!1}joinPath(h,...w){return C.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return P.posix.basename(h.path)}extname(h){return P.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===T.Schemas.file?w=C.URI.file(P.dirname(S(h))).path:(w=P.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===T.Schemas.file?w=C.URI.file(P.normalize(S(h))).path:w=P.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===T.Schemas.file){const v=P.relative(S(h),S(w));return R.isWindows?k.toSlashes(v):v}let y=h.path||"/",m=w.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const d=Math.min(y.length,m.length);v<d&&!(y.charCodeAt(v)!==m.charCodeAt(v)&&y.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);y=m.substr(0,v)+y.substr(v)}return P.posix.relative(y,m)}resolvePath(h,w){if(h.scheme===T.Schemas.file){const y=C.URI.file(P.resolve(S(h),w));return h.with({authority:y.authority,path:y.path})}return w=k.toPosixPath(w),h.with({path:P.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,D.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=P.sep){if(h.scheme===T.Schemas.file){const y=S(h);return y.length>k.getRoot(y).length&&y[y.length-1]===w}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=P.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=P.sep){let y=!1;if(h.scheme===T.Schemas.file){const m=S(h);y=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===w}else{w="/";const m=h.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===T.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,h){const w=[];for(let y=0;y<p.length;y++){const m=h(p[y]);p.some((v,d)=>d===y?!1:(0,e.isEqualOrParent)(m,h(v)))||w.push(p[y])}return w}e.distinctParents=i;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,c]=d.split(":");l&&c&&y.set(l,c)});const v=w.path.substring(0,w.path.indexOf(";"));return v&&y.set(p.META_DATA_MIME,v),y}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function f(p,h,w){if(h){let y=p.path;return y&&y[0]!==P.posix.sep&&(y=P.posix.sep+y),p.with({scheme:w,authority:h,path:y})}return p.with({scheme:w})}e.toLocalResource=f}),define(te[5],ne([0,1,28,7,3,2,18]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(j){return!!j&&typeof j.then=="function"}e.isThenable=C;function S(j){const W=new k.CancellationTokenSource,x=j(W.token),z=new Promise((K,F)=>{const B=W.token.onCancellationRequested(()=>{B.dispose(),W.dispose(),F((0,T.canceled)())});Promise.resolve(x).then(V=>{B.dispose(),W.dispose(),K(V)},V=>{B.dispose(),W.dispose(),F(V)})});return new class{cancel(){W.cancel()}then(K,F){return z.then(K,F)}catch(K){return this.then(void 0,K)}finally(K){return z.finally(K)}}}e.createCancelablePromise=S;function I(j,W,x){return Promise.race([j,new Promise(z=>W.onCancellationRequested(()=>z(x)))])}e.raceCancellation=I;async function i(j){let W=-1;const x=j.map((K,F)=>K.then(B=>(W=F,B))),z=await Promise.race(x);return j.forEach((K,F)=>{F!==W&&K.cancel()}),z}e.raceCancellablePromises=i;function E(j,W,x){let z;const K=setTimeout(()=>{z?.(void 0),x?.()},W);return Promise.race([j.finally(()=>clearTimeout(K)),new Promise(F=>z=F)])}e.raceTimeout=E;function f(j){return new Promise((W,x)=>{const z=j();C(z)?z.then(W,x):W(z)})}e.asPromise=f;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=W(),new Promise((x,z)=>{this.activePromise.then(K=>{this.activePromise=null,x(K)},K=>{this.activePromise=null,z(K)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(W,x){const K=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(W)===K&&this.promiseMap.delete(W)});return this.promiseMap.set(W,K),K}}e.SequencerByKey=w;class y{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,x=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,K)=>{this.doResolve=z,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class m{constructor(W){this.delayer=new y(W),this.throttler=new p}trigger(W,x){return this.delayer.trigger(()=>this.throttler.queue(W),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class v{constructor(){this._isOpen=!1,this._promise=new Promise((W,x)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class d extends v{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function l(j,W){return W?new Promise((x,z)=>{const K=setTimeout(()=>{F.dispose(),x()},j),F=W.onCancellationRequested(()=>{clearTimeout(K),F.dispose(),z((0,T.canceled)())})}):S(x=>l(j,x))}e.timeout=l;function c(j,W=0){const x=setTimeout(j,W);return(0,R.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=c;function t(j){const W=[];let x=0;const z=j.length;function K(){return x<z?j[x++]():null}function F(B){B!=null&&W.push(B);const V=K();return V?V.then(F):Promise.resolve(W)}return Promise.resolve(null).then(F)}e.sequence=t;function s(j,W=z=>!!z,x=null){let z=0;const K=j.length,F=()=>{if(z>=K)return Promise.resolve(x);const B=j[z++];return Promise.resolve(B()).then(Q=>W(Q)?Promise.resolve(Q):F())};return F()}e.first=s;function r(j,W=z=>!!z,x=null){if(j.length===0)return Promise.resolve(x);let z=j.length;const K=()=>{z=-1;for(const F of j)F.cancel?.()};return new Promise((F,B)=>{for(const V of j)V.then(Q=>{--z>=0&&W(Q)?(K(),F(Q)):z===0&&F(x)}).catch(Q=>{--z>=0&&(K(),B(Q))})})}e.firstParallel=r;class n{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:W,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const x=W.factory();x.then(W.c,W.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(W,x=D.extUri){const z=x.getComparisonKey(W);let K=this.queues.get(z);return K||(K=new a,P.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(z)}),this.queues.set(z,K)),K}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(W,x){this._token=-1,typeof W=="function"&&typeof x=="number"&&this.setIfNotSet(W,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},x)}setIfNotSet(W,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},x))}}e.TimeoutTimer=u;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setInterval(()=>{W()},x)}}e.IntervalTimer=g;class b{constructor(W,x){this.timeoutToken=-1,this.runner=W,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class A{constructor(W,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class U extends b{constructor(W,x){super(W,x);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class O extends R.Disposable{constructor(W,x,z,K){super();this.maxWorkChunkSize=W,this.maxPendingWork=x,this.throttleDelay=z,this.handler=K,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{const W=setTimeout(()=>{const z=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(W))}}}:e.runWhenIdle=(j,W)=>{const x=requestIdleCallback(j,typeof W=="number"?{timeout:W}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class q{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function N(j,W,x){let z;for(let K=0;K<x;K++)try{return await j()}catch(F){z=F,await l(W)}throw z}e.retry=N;class L{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,x,z){return this._pending={taskId:W,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending(W),()=>this.donePending(W)),x}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let x,z;const K=new Promise((F,B)=>{x=F,z=B});this._next={run:W,promise:K,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=L;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,x)=>{this.completeCallback=W,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(x=>{this.completeCallback(W),this.resolved=!0,x()})}error(W){return new Promise(x=>{this.errorCallback(W),this.rejected=!0,x()})}cancel(){new Promise(W=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=_;var M;(function(j){async function W(z){let K;const F=await Promise.all(z.map(B=>B.then(V=>V,V=>{K||(K=V)})));if(typeof K!="undefined")throw K;return F}j.settled=W;function x(z){return new Promise(async(K,F)=>{try{await z(K,F)}catch(B){F(B)}})}j.withAsyncBody=x})(M=e.Promises||(e.Promises={}))}),define(te[109],ne([0,1,5,42,41,9,25]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",I="/",i="[/\\\\]",E="[^/\\\\]",f=/\//g;function p(z){switch(z){case 0:return"";case 1:return`${E}*?`;default:return`(?:${i}|${E}+${i}|${i}${E}+)*?`}}function h(z,K){if(!z)return[];const F=[];let B=!1,V=!1,Q="";for(const Z of z){switch(Z){case K:if(!B&&!V){F.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&F.push(Q),F}e.splitGlobAware=h;function w(z){if(!z)return"";let K="";const F=h(z,I);if(F.every(B=>B===S))K=".*";else{let B=!1;F.forEach((V,Q)=>{if(V===S){B||(K+=p(2),B=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===I?ce="":ce=D.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(de=>w(de)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=E;continue;case"*":K+=p(1);continue;default:K+=D.escapeRegExpCharacters(ie)}}Q<F.length-1&&(F[Q+1]!==S||Q+2<F.length)&&(K+=i),B=!1})}return K}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),s=function(){return!1},r=function(){return null};function n(z,K){if(!z)return r;let F;typeof z!="string"?F=z.pattern:F=z,F=F.trim();const B=`${F}_${!!K.trimForExclusions}`;let V=t.get(B);if(V)return a(V,z);let Q;if(y.test(F)){const Z=F.substr(4);V=function(G,H){return typeof G=="string"&&G.endsWith(Z)?F:null}}else(Q=m.exec(o(F,K)))?V=u(Q[1],F):(K.trimForExclusions?d:v).test(F)?V=g(F,K):(Q=l.exec(o(F,K)))?V=b(Q[1].substr(1),F,!0):(Q=c.exec(o(F,K)))?V=b(Q[1],F,!1):V=A(F);return t.set(B,V),a(V,z)}function a(z,K){return typeof K=="string"?z:function(F,B){return T.isEqualOrParent(F,K.base)?z(R.relative(K.base,F),B):null}}function o(z,K){return K.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,K){const F=`/${z}`,B=`\\${z}`,V=function(Z,G){return typeof Z!="string"?null:G?G===z?K:null:Z===z||Z.endsWith(F)||Z.endsWith(B)?K:null},Q=[z];return V.basenames=Q,V.patterns=[K],V.allBasenames=Q,V}function g(z,K){const F=x(z.slice(1,-1).split(",").map(G=>n(G,K)).filter(G=>G!==r),z),B=F.length;if(!B)return r;if(B===1)return F[0];const V=function(G,H){for(let re=0,ie=F.length;re<ie;re++)if(F[re](G,H))return z;return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function b(z,K,F){const B=R.sep===R.posix.sep,V=B?z:z.replace(f,R.sep),Q=R.sep+V,Z=R.posix.sep+z,G=F?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===z||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===z)?K:null};return G.allPaths=[(F?"*/":"./")+z],G}function A(z){try{const K=new RegExp(`^${w(z)}$`);return function(F){return K.lastIndex=0,typeof F=="string"&&K.test(F)?z:null}}catch(K){return r}}function U(z,K,F){return!z||typeof K!="string"?!1:O(z)(K,void 0,F)}e.match=U;function O(z,K={}){if(!z)return s;if(typeof z=="string"||$(z)){const F=n(z,K);if(F===r)return s;const B=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(B.allBasenames=F.allBasenames),F.allPaths&&(B.allPaths=F.allPaths),B}return j(z,K)}e.parse=O;function q(z){if(!z)return;let K;return F=>(K||(K=(z()||Promise.resolve([])).then(B=>B?L(B):{})),K.then(B=>!!B[F]))}e.hasSiblingPromiseFn=q;function N(z){if(!z)return;let K;return F=>{if(!K){const B=z();K=B?L(B):{}}return!!K[F]}}e.hasSiblingFn=N;function L(z){const K={};for(const F of z)K[F]=!0;return K}function $(z){const K=z;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function _(z){return z.allBasenames||[]}e.getBasenameTerms=_;function M(z){return z.allPaths||[]}e.getPathTerms=M;function j(z,K){const F=x(Object.getOwnPropertyNames(z).map(G=>W(G,z[G],K)).filter(G=>G!==r)),B=F.length;if(!B)return r;if(!F.some(G=>!!G.requiresSiblings)){if(B===1)return F[0];const G=function(ie,ce){for(let le=0,de=F.length;le<de;le++){const fe=F[le](ie,ce);if(fe)return fe}return null},H=F.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=F.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const V=function(G,H,re){let ie;for(let ce=0,le=F.length;ce<le;ce++){const de=F[ce];de.requiresSiblings&&re&&(H||(H=R.basename(G)),ie||(ie=H.substr(0,H.length-R.extname(G).length)));const fe=de(G,H,ie,re);if(fe)return fe}return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function W(z,K,F){if(K===!1)return r;const B=n(z,F);if(B===r)return r;if(typeof K=="boolean")return B;if(K){const V=K.when;if(typeof V=="string"){const Q=(Z,G,H,re)=>{if(!re||!B(Z,G))return null;const ie=V.replace("$(basename)",H),ce=re(ie);return(0,k.isThenable)(ce)?ce.then(le=>le?z:null):ce?z:null};return Q.requiresSiblings=!0,Q}}return B}function x(z,K){const F=z.filter(G=>!!G.basenames);if(F.length<2)return z;const B=F.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let V;if(K){V=[];for(let G=0,H=B.length;G<H;G++)V.push(K)}else V=F.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=z.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[110],ne([0,1,109,15,9,18,25]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let S=[],I=[],i=[];function E(n,a=!1){const o=f(n);S.push(o),o.userConfigured?i.push(o):I.push(o),a&&!o.userConfigured&&S.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=E;function f(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,k.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(P.posix.sep)>=0:!1}}function p(n){n?(S=S.filter(a=>!a.userConfigured),i=[]):(S=[],I=[],i=[])}e.clearTextMimes=p;function h(n,a){let o;if(n)switch(n.scheme){case T.Schemas.file:o=n.fsPath;break;case T.Schemas.data:o=R.DataUri.parseMetaData(n).get(R.DataUri.META_DATA_LABEL);break;default:o=n.path}if(!o)return[C.unknown];o=o.toLowerCase();const u=(0,P.basename)(o),g=w(o,u,i);if(g)return[g,C.text];const b=w(o,u,I);if(b)return[b,C.text];if(a){const A=y(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=h;function w(n,a,o){let u=null,g=null,b=null;for(let A=o.length-1;A>=0;A--){const U=o[A];if(a===U.filenameLowercase){u=U;break}if(U.filepattern&&(!g||U.filepattern.length>g.filepattern.length)){const O=U.filepatternOnPath?n:a;U.filepatternLowercase?.(O)&&(g=U)}U.extension&&(!b||U.extension.length>b.extension.length)&&a.endsWith(U.extensionLowercase)&&(b=U)}return u?u.mime:g?g.mime:b?b.mime:null}function y(n){if((0,D.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let a=S.length-1;a>=0;a--){const o=S[a];if(!o.firstline)continue;const u=n.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function m(n){return n?typeof n=="string"?n===C.binary||n===C.text||n===C.unknown:n.length===1&&m(n[0]):!0}e.isUnspecific=m;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(n){const a=(0,P.extname)(n),o=v[a.toLowerCase()];return o!==void 0?o:c(n)}e.getMediaOrTextMime=l;function c(n){const a=(0,P.extname)(n);return d[a.toLowerCase()]}e.getMediaMime=c;function t(n){for(const a in d)if(d[a]===n)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(n,a){const o=s.exec(n);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:n}e.normalizeMimeType=r}),define(te[111],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class P{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:T(k.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:T(k.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:k.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function R(i,E,f){if(!i||f>200)return null;if(typeof i=="object"){if(i instanceof k.URI)return E.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const h=R(i[p],E,f+1);h!==null&&(i[p]=h)}}return null}function D(i,E){const f=R(i,E,0);return f===null?i:f}e.transformOutgoingURIs=D;function C(i,E,f,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return f?k.URI.revive(E.transformIncoming(i)):E.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const w=C(i[h],E,f,p+1);w!==null&&(i[h]=w)}}return null}function S(i,E){const f=C(i,E,!1,0);return f===null?i:f}e.transformIncomingURIs=S;function I(i,E){const f=C(i,E,!0,0);return f===null?i:f}e.transformAndReviveIncomingURIs=I}),define(te[29],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(S){return k.test(S)}e.isUUID=T;const P=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(S){for(let I=0;I<S.length;I++)S[I]=Math.floor(Math.random()*256);return S};function C(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,I="";return I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I+="-",I+=R[P[S++]],I+=R[P[S++]],I+="-",I+=R[P[S++]],I+=R[P[S++]],I+="-",I+=R[P[S++]],I+=R[P[S++]],I+="-",I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I+=R[P[S++]],I}e.generateUuid=C}),define(te[112],ne([0,1,113]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(R="utf8"){this.stringDecoder=new k.StringDecoder(R),this.remaining=null}write(R){const D=[],C=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(C.length<1)return D;let S=0,I,i=S;for(;i<C.length;)if(I=C.charCodeAt(i),I===13||I===10){if(D.push(C.substring(S,i)),i++,i<C.length){const E=I;I=C.charCodeAt(i),(E===13&&I===10||E===10&&I===13)&&i++}S=i}else i++;return this.remaining=S<C.length?C.substr(S):null,D}end(){return this.remaining}}e.LineDecoder=T}),define(te[114],ne([0,1,33]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const C=D.replace(/\-/g,":").toLowerCase();return!T.has(C)}function R(){const D=(0,k.networkInterfaces)();for(let C in D){const S=D[C];if(S){for(const{mac:I}of S)if(P(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[115],ne([0,1,33,7,41,29,114]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,E=0;const f=(0,k.networkInterfaces)();for(let p in f){const h=f[p];if(h)for(const{mac:w,internal:y}of h)y||(E+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(i+=1))}this._value=E>0?i/E:0}return this._value}};let C;async function S(){return C||(C=(async()=>await I()||R.generateUuid())()),C}e.getMachineId=S;async function I(){try{const i=await new Promise((f,p)=>{X(["crypto"],f,p)}),E=(0,D.getMac)();return i.createHash("sha256").update(E,"utf8").digest("hex")}catch(i){T.onUnexpectedError(i);return}}}),define(te[20],ne([0,1,51,33,246,5,42,70,9,4,18,8,29]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(_,M=p.UNLINK){if((0,D.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return M===p.UNLINK?y(_):w(_)}async function w(_){try{const M=(0,S.join)((0,T.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(_,M)}catch(j){return y(_)}y(M).catch(j=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function y(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,D.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");k.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function v(_,M){return c(await(M?d(_):(0,P.promisify)(k.readdir)(_)))}async function d(_){try{return await(0,P.promisify)(k.readdir)(_,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const M=[],j=await v(_);for(const W of j){let x=!1,z=!1,K=!1;try{const F=await e.Promises.lstat((0,S.join)(_,W));x=F.isFile(),z=F.isDirectory(),K=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}M.push({name:W,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>K})}return M}function l(_){return c(k.readdirSync(_))}e.readdirSync=l;function c(_){return _.map(M=>typeof M=="string"?I.isMacintosh?(0,C.normalizeNFC)(M):M:(M.name=I.isMacintosh?(0,C.normalizeNFC)(M.name):M.name,M))}async function t(_){const M=await v(_),j=[];for(const W of M)await r.existsDirectory((0,S.join)(_,W))&&j.push(W);return j}function s(_,M=1e3){return new Promise(j=>{let W=!1;const x=setInterval(()=>{W||(W=!0,k.access(_,z=>{W=!1,z&&(clearInterval(x),j(void 0))}))},M)})}e.whenDeleted=s;var r;(function(_){async function M(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch(K){}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(I.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw F}throw K}}_.stat=M;async function j(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isFile()&&K?.dangling!==!0}catch(z){}return!1}_.existsFile=j;async function W(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isDirectory()&&K?.dangling!==!0}catch(z){}return!1}_.existsDirectory=W})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function a(_,M,j){return n.queueFor(E.URI.file(_),i.extUriBiasedIgnorePathCase).queue(()=>{const W=b(j);return new Promise((x,z)=>u(_,M,W,K=>K?z(K):x()))})}let o=!0;function u(_,M,j,W){if(!o)return k.writeFile(_,M,{mode:j.mode,flag:j.flag},W);k.open(_,j.flag,j.mode,(x,z)=>{if(x)return W(x);k.writeFile(z,M,K=>{if(K)return k.close(z,()=>W(K));k.fdatasync(z,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),o=!1),k.close(z,B=>W(B))))})})}function g(_,M,j){const W=b(j);if(!o)return k.writeFileSync(_,M,{mode:W.mode,flag:W.flag});const x=k.openSync(_,W.flag,W.mode);try{k.writeFileSync(x,M);try{k.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o=!1}}finally{k.closeSync(x)}}e.writeFileSync=g;function b(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,M){if(_===M)return;async function j(W){try{const x=await e.Promises.lstat(W);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(W,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(_,M),await j(M)}catch(W){if(_.toLowerCase()!==M.toLowerCase()&&W.code==="EXDEV"||_.endsWith("."))await U(_,M,{preserveSymlinks:!1}),await h(_,p.MOVE),await j(M);else throw W}}async function U(_,M,j){return q(_,M,{root:{source:_,target:M},options:j,handledSourcePaths:new Set})}const O=511;async function q(_,M,j){if(j.handledSourcePaths.has(_))return;j.handledSourcePaths.add(_);const{stat:W,symbolicLink:x}=await r.stat(_);if(x){if(j.options.preserveSymlinks)try{return await $(_,M,j)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return W.isDirectory()?N(_,M,W.mode&O,j):L(_,M,W.mode&O)}async function N(_,M,j,W){await e.Promises.mkdir(M,{recursive:!0,mode:j});const x=await v(_);for(const z of x)await q((0,S.join)(_,z),(0,S.join)(M,z),W)}async function L(_,M,j){await e.Promises.copyFile(_,M),await e.Promises.chmod(M,j)}async function $(_,M,j){let W=await e.Promises.readlink(_);(0,D.isEqualOrParent)(W,j.root.source,!I.isLinux)&&(W=(0,S.join)(j.root.target,W.substr(j.root.source.length+1))),await e.Promises.symlink(W,M)}e.Promises=new class{get access(){return(0,P.promisify)(k.access)}get stat(){return(0,P.promisify)(k.stat)}get lstat(){return(0,P.promisify)(k.lstat)}get utimes(){return(0,P.promisify)(k.utimes)}get read(){return(0,P.promisify)(k.read)}get readFile(){return(0,P.promisify)(k.readFile)}get write(){return(0,P.promisify)(k.write)}get appendFile(){return(0,P.promisify)(k.appendFile)}get fdatasync(){return(0,P.promisify)(k.fdatasync)}get truncate(){return(0,P.promisify)(k.truncate)}get rename(){return(0,P.promisify)(k.rename)}get copyFile(){return(0,P.promisify)(k.copyFile)}get open(){return(0,P.promisify)(k.open)}get close(){return(0,P.promisify)(k.close)}get symlink(){return(0,P.promisify)(k.symlink)}get readlink(){return(0,P.promisify)(k.readlink)}get chmod(){return(0,P.promisify)(k.chmod)}get mkdir(){return(0,P.promisify)(k.mkdir)}get unlink(){return(0,P.promisify)(k.unlink)}get rmdir(){return(0,P.promisify)(k.rmdir)}get realpath(){return(0,P.promisify)(k.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return U}}}),define(te[116],ne([0,1,51,9,25,20]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function D(i){const E=(0,T.dirname)(i);if(i===E)return i;const f=((0,T.basename)(i)||i).toLowerCase();try{const h=(0,R.readdirSync)(E).filter(w=>w.toLowerCase()===f);if(h.length===1){const w=D(E);if(w)return(0,T.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(f);if(w>=0){const y=D(E);if(y)return(0,T.join)(y,h[w])}}}catch(p){}return null}e.realcaseSync=D;async function C(i){try{return await R.Promises.realpath(i)}catch(E){const f=I(i);return await R.Promises.access(f,k.constants.R_OK),f}}e.realpath=C;function S(i){try{return k.realpathSync(i)}catch(E){const f=I(i);return k.accessSync(f,k.constants.R_OK),f}}e.realpathSync=S;function I(i){return(0,P.rtrim)((0,T.normalize)(i),T.sep)}}),define(te[117],ne([0,1,57]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function T(C,S,I,i=1){let E=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!E)return E=!0,f(0)},I);P(C,S,i,h=>{if(!E)return E=!0,clearTimeout(p),f(h)})})}e.findFreePort=T;function P(C,S,I,i){if(S===0)return i(0);const E=new k.Socket;E.once("connect",()=>(D(E),P(C+I,S-1,I,i))),E.once("data",()=>{}),E.once("error",f=>(D(E),f.code!=="ECONNREFUSED"?P(C+I,S-1,I,i):i(C))),E.connect(C,"127.0.0.1")}function R(C,S,I){let i=!1,E,f=1;const p=k.createServer({pauseOnConnect:!0});function h(w,y){i||(i=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),y(w))}return new Promise(w=>{E=setTimeout(()=>{h(0,w)},I),p.on("listening",()=>{h(C,w)}),p.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&f<S?(C++,f++,p.listen(C,"127.0.0.1")):h(0,w)}),p.on("close",()=>{h(0,w)}),p.listen(C,"127.0.0.1")})}e.findFreePortFaster=R;function D(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(S){console.error(S)}}}),define(te[71],ne([0,1,33,9,20]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var S;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(S||(S={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class E{constructor(c,t,s){this.exePath=c,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?I===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=f({useAlternateBitness:l});if(!t)return null;const s=T.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let r=-1,n=null;for(const u of await P.Promises.readdir(s)){let g=-1;if(c){const A=u.indexOf("-");if(A<0)continue;const U=u.substring(0,A);if(!R.test(U)||u.substring(A+1)!=="preview")continue;g=parseInt(U,10)}else{if(!R.test(u))continue;g=parseInt(u,10)}if(g<=r)continue;const b=T.join(s,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(b)||(n=b,r=g)}if(!n)return null;const a=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new E(n,`PowerShell${o}${a}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(c))if(t.test(r)){const n=T.join(c,r,"pwsh.exe");return new E(n,s)}return null}function w(){const l=T.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(l,".NET Core PowerShell Global Tool")}function y(){const l=T.join(process.env.windir,I===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(l,"Windows PowerShell",!0)}async function*m(){let l=await p();l&&(yield l),l=await p({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=w(),l&&(yield l),l=await p({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await p({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=y(),l&&(yield l)}async function*v(){for await(const l of m())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=v;async function d(){for await(const l of v())return l;return null}e.getFirstAvailablePowerShellInstallation=d}),define(te[118],ne([0,1,43,15]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(D){return new Promise((C,S)=>{let I;const i=new Map;function E(p,h,w,y,m){const v=i.get(h);if(p===D||v){const d={name:f(w),cmd:w,pid:p,ppid:h,load:y,mem:m};i.set(p,d),p===D&&(I=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((l,c)=>l.pid-c.pid)))}}function f(p){const h=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,y=/--crashes-directory/,m=/\\pipe\\winpty-control/,v=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"watcherService ";if(y.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(v.exec(p))return"console-window-host (Windows internal process)";let l=d.exec(p);if(l&&l.length===2)return l[1]==="renderer"?h.exec(p)?"shared-process":"window":l[1];const c=/[a-zA-Z-]+\.js/g;let t="";do l=c.exec(p),l&&(t+=l+" ");while(l);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,w)=>{X(["windows-process-tree"],h,w)}).then(h=>{h.getProcessList(D,w=>{h.getProcessCpuUsage(w,y=>{const m=new Map;y.forEach(v=>{const d=p(v.commandLine||"");m.set(v.pid,{name:f(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),I=m.get(D),I?(m.forEach(v=>{const d=m.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((d,l)=>d.pid-l.pid))}),C(I)):S(new Error(`Root process ${D} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[I];const w=[];for(;h.length;){const m=h.shift();m&&(w.push(m.pid),m.children&&(h=h.concat(m.children)))}let y=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);y+=" "+w.join(" "),(0,k.exec)(y,{},(m,v,d)=>{if(m||d)S(m||new Error(d.toString()));else{const l=v.toString().split(`
`);for(let c=0;c<w.length;c++){const t=i.get(w[c]);t.load=parseFloat(l[c])}if(!I){S(new Error(`Root process ${D} not found`));return}C(I)}})};(0,k.exec)("which ps",{},(h,w,y)=>{if(h||y)if(process.platform!=="linux")S(h||new Error(y.toString()));else{const m=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,k.exec)(m,{},(v,d,l)=>{v||l?S(v||new Error(l.toString())):(R(d,E),p())})}else{const m=w.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,l,c)=>{d||c&&!c.includes("screen size is bogus")?S(d||new Error(c.toString())):(R(l,E),process.platform==="linux"?p():I?C(I):S(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=P;function R(D,C){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=D.toString().split(`
`);for(const i of I){const E=S.exec(i.trim());E&&E.length===6&&C(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[119],ne([0,1,51,28,42,2,70,9,4,20]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(h,w,y){return f({path:h,isDirectory:!1},w,y)}e.watchFile=i;function E(h,w,y){return f({path:h,isDirectory:!0},w,y)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function f(h,w,y){if(S.isMacintosh&&(0,P.isEqualOrParent)(h.path,"/Volumes/"))return y(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=(0,C.basename)(h.path),v=new Map;let d=!1,l=[(0,R.toDisposable)(()=>{v.forEach(c=>(0,R.dispose)(c)),v.clear()})];try{const c=(0,k.watch)(h.path);l.push((0,R.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const t=new Set;h.isDirectory&&I.Promises.readdir(h.path).then(s=>s.forEach(r=>t.add(r))),c.on("error",(s,r)=>{d||y(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),c.on("change",(s,r)=>{if(d)return;let n="";if(r&&(n=r.toString(),S.isMacintosh&&(n=(0,D.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,C.join)(h.path,n):h.path;if(h.isDirectory)if(s==="rename"){const o=v.get(a);o&&(0,R.dispose)(o);const u=setTimeout(async()=>{v.delete(a);const g=await I.Promises.exists(a);if(d)return;let b;g?t.has(n)?b="changed":(b="added",t.add(n)):(t.delete(n),b="deleted"),w(b,a)},e.CHANGE_BUFFER_DELAY);v.set(a,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let o;t.has(n)?o="changed":(o="added",t.add(n)),w(o,a)}else if(s==="rename"||n!==m){const o=setTimeout(async()=>{const u=await I.Promises.exists(a);d||(u?(w("changed",a),l=[f(h,w,y)]):w("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(l),l=[(0,R.toDisposable)(()=>clearTimeout(o))]}else w("changed",a)})}catch(c){I.Promises.exists(h.path).then(t=>{t&&!d&&y(`Failed to watch ${h.path} for changes using fs.watch() (${c.toString()})`)})}return(0,R.toDisposable)(()=>{d=!0,l=(0,R.dispose)(l)})}async function p(h,w,y,m=512){const v=await I.Promises.open(h,"r"),d=Buffer.allocUnsafe(m),l=new T.CancellationTokenSource(y);let c,t=!1;const s=i(h,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:n}=await I.Promises.read(v,d,0,m,null);if(!n||l.token.isCancellationRequested)break;w(d.slice(0,n))}}catch(n){c=new Error(n),l.dispose(!0)}finally{t=!1}}},r=>{c=new Error(r),l.dispose(!0)});return new Promise((r,n)=>{l.token.onCancellationRequested(async()=>{s.dispose(),await I.Promises.close(v),c?n(c):r()})})}e.watchFileContents=p});var he=this&&this.__decorate||function(X,e,k,T){var P=arguments.length,R=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,k):T,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(X,e,k,T);else for(var C=X.length-1;C>=0;C--)(D=X[C])&&(R=(P<3?D(R):P>3?D(e,k,R):D(e,k))||R);return P>3&&R&&Object.defineProperty(e,k,R),R};define(te[34],ne([0,1,16,5,19,28,68,7,3,2,108,25,17]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function y(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class v{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class d{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(l||(l={}));function c(x){const z=P.VSBuffer.alloc(4);return z.writeUInt32BE(x,0),z}function t(x){return x.read(4).readUInt32BE(0)}function s(x){const z=P.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const r={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},n=typeof Buffer!="undefined";function a(x,z){if(typeof z=="undefined")x.write(r.Undefined);else if(typeof z=="string"){const K=P.VSBuffer.fromString(z);x.write(r.String),x.write(c(K.byteLength)),x.write(K)}else if(n&&Buffer.isBuffer(z)){const K=P.VSBuffer.wrap(z);x.write(r.Buffer),x.write(c(K.byteLength)),x.write(K)}else if(z instanceof P.VSBuffer)x.write(r.VSBuffer),x.write(c(z.byteLength)),x.write(z);else if(Array.isArray(z)){x.write(r.Array),x.write(c(z.length));for(const K of z)a(x,K)}else{const K=P.VSBuffer.fromString(JSON.stringify(z));x.write(r.Object),x.write(c(K.byteLength)),x.write(K)}}function o(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(t(x)).toString();case l.Buffer:return x.read(t(x)).buffer;case l.VSBuffer:return x.read(t(x));case l.Array:{const K=t(x),F=[];for(let B=0;B<K;B++)F.push(o(x));return F}case l.Object:return JSON.parse(x.read(t(x)).toString())}}class u{constructor(z,K,F=null,B=1e3){this.protocol=z,this.ctx=K,this.logger=F,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger&&this.logger.logOutgoing(K,0,1,y(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(K,z.id,1,y(z.type),z.data);return}}}send(z,K=void 0){const F=new d;return a(F,z),a(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onRawMessage(z){const K=new v(z),F=o(K),B=o(K),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=new R.CancellationTokenSource;let B;try{B=K.call(this.ctx,z.name,z.arg,F.token)}catch(Z){B=Promise.reject(Z)}const V=z.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete(z.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete(z.id)});const Q=(0,I.toDisposable)(()=>F.cancel());this.activeRequests.set(z.id,Q)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=z.id,V=K.listen(this.ctx,z.name,z.arg)(Q=>this.sendResponse({id:F,data:Q,type:204}));this.activeRequests.set(z.id,V)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const F=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:F})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const F of K)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=K}getChannel(z){const K=this;return{call(F,B,V){return K.isDisposed?Promise.reject(C.canceled()):K.requestPromise(z,F,B,V)},listen(F,B){return K.isDisposed?Promise.reject(C.canceled()):K.requestEvent(z,F,B)}}}requestPromise(z,K,F,B=R.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:z,name:K,arg:F};if(B.isCancellationRequested)return Promise.reject(C.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(C.canceled());const ce=()=>{const be=Ce=>{switch(Ce.type){case 201:this.handlers.delete(V),re(Ce.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ce.data);break}};this.handlers.set(V,be),this.sendRequest(Z)};let le=null;this.state===m.Idle?ce():(le=(0,T.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:V,type:101}),ie(C.canceled())},fe=B.onCancellationRequested(de);G=(0,I.combinedDisposable)((0,I.toDisposable)(de),fe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(z,K,F){const B=this.lastRequestId++,Q={id:B,type:102,channelName:z,name:K,arg:F};let Z=null;const G=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,T.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(B,H),G.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const F=new d;return a(F,z),a(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onBuffer(z){const K=new v(z),F=o(K),B=o(K),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,y(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],0,y(V),B),this.onResponse({type:F[0],id:F[1],data:B})}}onResponse(z){if(z.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}he([D.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:F})=>{S.Event.once(K.onMessage)(V=>{const Q=new v(V),Z=o(Q),G=new u(K,Z),H=new b(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),F(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const F=this;return{call(B,V,Q){let Z;if((0,f.isFunction)(K)){let H=(0,k.getRandomElement)(F.connections.filter(K));Z=H?Promise.resolve(H):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,K))}else Z=K.routeCall(F,B,V);const G=Z.then(H=>H.channelClient.getChannel(z));return O(G).call(B,V,Q)},listen(B,V){if((0,f.isFunction)(K))return F.getMulticastEvent(z,K,B,V);const Q=K.routeEvent(F,B,V).then(Z=>Z.channelClient.getChannel(z));return O(Q).listen(B,V)}}}getMulticastEvent(z,K,F,B){const V=this;let Q=new I.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{Q=new I.DisposableStore;const G=new S.EventMultiplexer,H=new Map,re=ce=>{const de=ce.channelClient.getChannel(z).listen(F,B),fe=G.add(de);H.set(ce,fe)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};V.connections.filter(K).forEach(re),S.Event.filter(V.onDidAddConnection,K)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(F=>{F.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class U{constructor(z,K,F=null){const B=new d;a(B,K),z.send(B.buffer),this.channelClient=new b(z,F),this.channelServer=new u(z,K,F)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function O(x){return{call(z,K,F){return x.then(B=>B.call(z,K,F))},listen(z,K){const F=new S.Relay;return x.then(B=>F.input=B.listen(z,K)),F.event}}}e.getDelayedChannel=O;function q(x){let z=!1;return{call(K,F,B){return z?x.call(K,F,B):(0,T.timeout)(0).then(()=>z=!0).then(()=>x.call(K,F,B))},listen(K,F){if(z)return x.listen(K,F);const B=new S.Relay;return(0,T.timeout)(0).then(()=>z=!0).then(()=>B.input=x.listen(K,F)),B.event}}}e.getNextTickChannel=q;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await S.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;var L;(function(x){function z(V,Q){const Z=V,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)F(re)&&H.set(re,S.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(B(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,i.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=z;function K(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:F(H)?V.listen(H):async function(...re){let ie;Q&&!(0,f.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await V.call(H,ie);return Z?ce:(0,i.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}x.toService=K;function F(V){return V[0]==="o"&&V[1]==="n"&&E.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&E.isUpperAsciiLetter(V.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let z=x.toString();if(z!=="[object Object]")return z}return x}function M(x){return Array.isArray(x)?x.map(_):_(x)}function j(x,z,K,F,B,V,Q){Q=M(Q);const Z=$[B],G=Z[F%Z.length];let H=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=j;class W{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,F,B,V){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,F,B,V)}logIncoming(z,K,F,B,V){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,F,B,V)}}e.IPCLogger=W}),define(te[120],ne([0,1,19,3,34]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(S){this.port=S,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",I=>k.VSBuffer.wrap(I.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends P.IPCClient{constructor(S,I){const i=new R(S);super(i,I);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[72],ne([0,1,19,3,2,4,31,34]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function i(){return I||(I=k.VSBuffer.alloc(0)),I}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const b=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),b}if(this._chunks[0].byteLength>n){const b=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),b}let o=k.VSBuffer.alloc(n),u=0,g=0;for(;n>0;){const b=this._chunks[g];if(b.byteLength>n){const A=b.slice(0,n);o.set(A,u),u+=n,a&&(this._chunks[g]=b.slice(n),this._totalLength-=n),n-=n}else o.set(b,u),u+=b.byteLength,a?(this._chunks.shift(),this._totalLength-=b.byteLength):g++,n-=b.byteLength}return o}}e.ChunkStream=E;var f;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(f||(f={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(n,a,o,u){this.type=n,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.Disposable{constructor(n){super();this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,u,g,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=k.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const o=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,o}_bufferTake(){const n=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&R.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends P.Disposable{constructor(n){super();this._onMessage=new T.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new h(1,0,0,n))}}e.Protocol=m;class v extends C.IPCClient{constructor(n,a,o=null){super(n,a,o);this.protocol=n}static fromSocket(n,a){return new v(new m(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=v;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new T.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,D.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class l{constructor(n){this.data=n,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,o=this._first;for(;o;)n[a++]=o.data,o=o.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new l(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<t._HISTORY_LENGTH;u++)n-this.lastRuns[u]<=a&&o++;return 1-o/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,a=null,o=t.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,P.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new h(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new h(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,P.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,o=n.length;a<o;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(n){const a=new h(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new h(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(te[121],ne([0,1,73,3,34,120]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class D extends P.IPCServer{static getOnDidClientConnect(){const S=T.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(I,i)=>i);return T.Event.map(S,I=>{const{port1:i,port2:E}=new MessageChannel,p={protocol:new R.Protocol(i),onDidClientDisconnect:T.Event.fromDOMEventEmitter(i,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[E]),p})}constructor(){super(D.getOnDidClientConnect())}}e.Server=D}),define(te[122],ne([0,1,19,7]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(C,S){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((i,E)=>{I.open(C.type||"GET",C.url||"",!0,C.user,C.password),R(I,C),I.responseType="arraybuffer",I.onerror=f=>E(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=f=>{i({res:{statusCode:I.status,headers:D(I)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=f=>E(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(I.timeout=C.timeout),I.send(C.data),S.onCancellationRequested(()=>{I.abort(),E((0,T.canceled)())})})}e.request=P;function R(C,S){if(S.headers){e:for(let I in S.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(I,S.headers[I])}}}function D(C){const S=Object.create(null);for(const I of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const i=I.indexOf(":");S[I.substr(0,i).trim().toLowerCase()]=I.substr(i+1).trim()}return S}}),define(te[74],ne([0,1,5,3,2,17]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function C(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var S;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(S||(S={}));class I extends P.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,h)=>this.accept(h,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===S.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(p)?h=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const h=this.cache.get(f);return(0,R.isUndefinedOrNull)(h)?p:h}getBoolean(f,p){const h=this.get(f);return(0,R.isUndefinedOrNull)(h)?p:h==="true"}getNumber(f,p){const h=this.get(f);return(0,R.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(f,p){if(this.state===S.Closed)return;if((0,R.isUndefinedOrNull)(p))return this.delete(f);const h=String(p);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===S.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,h)=>this.items.set(h,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[123],ne([12,13]),function(X,e){return X.create("vs/base/common/date",e)}),define(te[58],ne([0,1,123]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,P=T*60,R=P*24,D=R*7,C=R*30,S=R*365;function I(E,f){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,k.localize)(0,null,I(new Date().getTime()+p*1e3,!1));if(p<30)return(0,k.localize)(1,null);let h;return p<T?(h=p,f?h===1?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):h===1?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h)):p<P?(h=Math.floor(p/T),f?h===1?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):h===1?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):p<R?(h=Math.floor(p/P),f?h===1?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):h===1?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h)):p<D?(h=Math.floor(p/R),f?h===1?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):h===1?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):p<C?(h=Math.floor(p/D),f?h===1?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):h===1?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h)):p<S?(h=Math.floor(p/C),f?h===1?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):h===1?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):(h=Math.floor(p/S),f?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h))}e.fromNow=I;function i(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[124],ne([12,13]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,17,124]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(I,i){return i&&(I.stack||I.stacktrace)?P.localize(0,null,C(I),D(I.stack)||D(I.stacktrace)):C(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function C(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?P.localize(1,null,I.message):I.message||P.localize(2,null)}function S(I=null,i=!1){if(!I)return P.localize(3,null);if(Array.isArray(I)){const E=k.coalesce(I),f=S(E[0],i);return E.length>1?P.localize(4,null,f,E.length):f}if(T.isString(I))return I;if(I.detail){const E=I.detail;if(E.error)return R(E.error,i);if(E.exception)return R(E.exception,i)}return I.stack?R(I,i):I.message?I.message:P.localize(5,null)}e.toErrorMessage=S}),define(te[125],ne([12,13]),function(X,e){return X.create("vs/base/node/processes",e)}),define(te[75],ne([0,1,43,42,15,26,9,4,31,103,17,112,20,125]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(t,s){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const n=k.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],r);return new Promise(a=>{n.once("error",o=>{a({success:!1,error:o})}),n.once("exit",(o,u)=>{a(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(n=>{k.execFile(r,[t.pid.toString()],{encoding:"utf8",shell:!0},(a,o,u)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function y(t){!t||(delete t.DEBUG,C.isMacintosh&&delete t.DYLD_LIBRARY_PATH,C.isLinux&&delete t.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function m(t=S.env){return t.comspec||"cmd.exe"}e.getWindowsShell=m;class v{constructor(s,r,n,a){if(r!==void 0&&n!==void 0&&a!==void 0)this.cmd=s,this.args=r,this.shell=n,this.options=a;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(S.env).forEach(u=>{o[u]=S.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(D.sep);return r!==-1&&(s=s.substring(r+1)),v.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(S.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let n,a;const o=new Promise((u,g)=>{n=u,a=g});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=k.exec(u,this.options,(g,b,A)=>{this.childProcess=null;const U=g;U&&U.killed?a({killed:this.terminateRequested,stdout:b.toString(),stderr:A.toString()}):this.handleExec(n,s,g,b,A)})}else{let u=null;const g=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,n,s,a);const A={terminated:this.terminateRequested};i.isNumber(b)&&(A.cmdCode=b),n(A)};if(this.shell&&C.isWindows){const b=R.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let A=!1,U=!1;const O=[];let q=this.ensureQuotes(this.cmd);O.push(q.value),A=q.quoted,this.args&&this.args.forEach(L=>{q=this.ensureQuotes(L),O.push(q.value),U=U&&q.quoted});const N=["/s","/c"];A?U?N.push('"'+O.join(" ")+'"'):O.length>1?N.push('"'+O[0]+'" '+O.slice(1).join(" ")):N.push('"'+O[0]+'"'):N.push(O.join(" ")),u=k.spawn(m(),N,b)}else this.cmd&&(u=k.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(i.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",b=>{this.childProcess=null,a({terminated:this.terminateRequested,error:b})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,n,s,a,!0)))}return o})}handleClose(s,r,n,a){}ensureQuotes(s){return v.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,w(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const r=k.spawn(m(),["/s","/c"]);r.on("error",n=>s(!0)),r.on("exit",n=>s(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class d extends v{constructor(s,r,n,a){super(s,r,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,n,a,o){[a,o].forEach((u,g)=>{const b=new E.LineDecoder;b.write(u).forEach(O=>{r({line:O,source:g===0?0:1})});const U=b.end();U&&r({line:U,source:g===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,r,n,a,o){const u=new E.LineDecoder,g=new E.LineDecoder;s.stdout.on("data",b=>{u.write(b).forEach(U=>n({line:U,source:0}))}),s.stderr.on("data",b=>{g.write(b).forEach(U=>n({line:U,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(s,r,n,a){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}e.LineProcess=d;function l(t){let s=[],r=!1;const n=function(a){if(r){s.push(a);return}(!t.send(a,u=>{if(u&&console.error(u),r=!1,s.length>0){const g=s.slice(0);s=[],g.forEach(b=>n(b))}})||C.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=l;var c;(function(t){async function s(r,n,a){if(D.isAbsolute(r))return r;if(n===void 0&&(n=S.cwd()),D.dirname(r)!=="."||(a===void 0&&i.isString(S.env.PATH)&&(a=S.env.PATH.split(D.delimiter)),a===void 0||a.length===0))return D.join(n,r);async function u(g){if(await f.Promises.exists(g)){let b;try{b=await f.Promises.stat(g)}catch(A){A.message.startsWith("EACCES")&&(b=await f.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(let g of a){let b;if(D.isAbsolute(g)?b=D.join(g,r):b=D.join(n,g,r),await u(b))return b;let A=b+".com";if(await u(A)||(A=b+".exe",await u(A)))return A}return D.join(n,r)}t.findExecutable=s})(c=e.win32||(e.win32={}))}),define(te[126],ne([0,1,33,4,71,75]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(p,h){return p===1?T.isWindows?E():R.getWindowsShell(h):I(p,h)}e.getSystemShell=D;function C(p,h){return p===1?T.isWindows?f(h):R.getWindowsShell(h):I(p,h)}e.getSystemShellSync=C;let S=null;function I(p,h){if(T.isLinux&&p===2||T.isMacintosh&&p===3)return"/bin/bash";if(!S){let w;if(T.isWindows)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,k.userInfo)().shell}catch(y){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let i=null;async function E(){return i||(i=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),i}function f(p){if(i)return i;const h=T.isWindows&&parseFloat((0,k.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:R.getWindowsShell(p)}}),define(te[52],ne([0,1,43,5,19,28,107,7,3,2,26,75,34]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(y){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(v){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",m=>P.VSBuffer.wrap(Buffer.from(m,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(y,m){this.modulePath=y,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new T.Delayer(v),this.child=null,this._client=null}getChannel(y){const m=this;return{call(v,d,l){return m.requestPromise(y,v,d,l)},listen(v,d){return m.requestEvent(y,v,d)}}}requestPromise(y,m,v,d=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(y),c=(0,T.createCancelablePromise)(r=>l.call(m,v,r)),t=d.onCancellationRequested(()=>c.cancel()),s=(0,I.toDisposable)(()=>c.cancel());return this.activeRequests.add(s),c.finally(()=>{t.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(y,m,v){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let d;const l=new S.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(y).listen(m,v)(l.fire,l),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,y,m);const v=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,D.isRemoteConsoleLog)(n)){(0,D.log)(n,`IPC Library: ${this.options.serverName}`);return}v.fire(P.VSBuffer.wrap(Buffer.from(n,"base64")))});const l=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,c=n=>this.child&&this.child.connected&&l.send(n.buffer.toString("base64")),t=v.event,s={send:c,onMessage:t};this._client=new f.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,I.dispose)(o)),this.activeRequests.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:a})})}return this._client}getCachedChannel(y){let m=this.channels.get(y);return m||(m=this.client.getChannel(y),this.channels.set(y,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[127],ne([12,13]),function(X,e){return X.create("vs/base/node/zip",e)}),define(te[128],ne([12,13]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[129],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(te[130],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(te[131],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/shellEnv",e)}),define(te[132],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[133],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[134],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[135],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[136],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[137],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[138],ne([12,13]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[139],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(te[140],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(te[141],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(te[142],ne([12,13]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[143],ne([12,13]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(te[144],ne([12,13]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[145],ne([12,13]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[146],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[147],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[148],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[149],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[150],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[151],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[152],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var T;(function(D){D.Team="team",D.Internal="internal",D.Insiders="insider",D.Public="public"})(T=e.TargetPopulation||(e.TargetPopulation={}));var P;(function(D){D.Market="X-MSEdge-Market",D.CorpNet="X-FD-Corpnet",D.ApplicationVersion="X-VSCode-AppVersion",D.Build="X-VSCode-Build",D.ClientId="X-MSEdge-ClientId",D.ExtensionName="X-VSCode-ExtensionName",D.Language="X-VSCode-Language",D.TargetPopulation="X-VSCode-TargetPopulation"})(P=e.Filters||(e.Filters={}));class R{constructor(C,S,I,i){this.version=C,this.appName=S,this.machineId=I,this.targetPopulation=i}getFilterValue(C){switch(C){case P.ApplicationVersion:return this.version;case P.Build:return this.appName;case P.ClientId:return this.machineId;case P.Language:return k.language;case P.ExtensionName:return"vscode-core";case P.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let C=new Map,S=Object.values(P);for(let I of S)C.set(I,this.getFilterValue(I));return C}}e.AssignmentFilterProvider=R}),define(te[76],ne([0,1,58,68,15,9,31,18,8]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(w,y,m){this._args=w,this.paths=y,this.productService=m}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",X).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(S.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=D.env.VSCODE_PORTABLE;return w?S.URI.file((0,R.join)(w,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,R.resolve)(w):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,R.resolve)(w):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,R.resolve)(w);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(y=>/^[^:/?#]+?:\/\//.test(y)?S.URI.parse(y):S.URI.file((0,R.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?S.URI.parse(w):S.URI.file((0,R.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([T.memoize],I.prototype,"appRoot",null),he([T.memoize],I.prototype,"userHome",null),he([T.memoize],I.prototype,"userDataPath",null),he([T.memoize],I.prototype,"appSettingsHome",null),he([T.memoize],I.prototype,"tmpDir",null),he([T.memoize],I.prototype,"userRoamingDataHome",null),he([T.memoize],I.prototype,"settingsResource",null),he([T.memoize],I.prototype,"userDataSyncHome",null),he([T.memoize],I.prototype,"userDataSyncLogResource",null),he([T.memoize],I.prototype,"sync",null),he([T.memoize],I.prototype,"machineSettingsResource",null),he([T.memoize],I.prototype,"globalStorageHome",null),he([T.memoize],I.prototype,"workspaceStorageHome",null),he([T.memoize],I.prototype,"keybindingsResource",null),he([T.memoize],I.prototype,"keyboardLayoutResource",null),he([T.memoize],I.prototype,"argvResource",null),he([T.memoize],I.prototype,"snippetsHome",null),he([T.memoize],I.prototype,"isExtensionDevelopment",null),he([T.memoize],I.prototype,"untitledWorkspacesHome",null),he([T.memoize],I.prototype,"installSourcePath",null),he([T.memoize],I.prototype,"builtinExtensionsPath",null),he([T.memoize],I.prototype,"extensionsPath",null),he([T.memoize],I.prototype,"extensionDevelopmentLocationURI",null),he([T.memoize],I.prototype,"extensionDevelopmentKind",null),he([T.memoize],I.prototype,"extensionTestsLocationURI",null),he([T.memoize],I.prototype,"debugExtensionHost",null),he([T.memoize],I.prototype,"serviceMachineIdResource",null),he([T.memoize],I.prototype,"telemetryLogResource",null),he([T.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function i(h,w){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=i;function E(h,w){return p(h["inspect-search"],h["inspect-brk-search"],5876,w,h.extensionEnvironment)}e.parseSearchPort=E;function f(h,w){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,w,h.extensionEnvironment)}e.parsePtyHostPort=f;function p(h,w,y,m,v,d){const c=Number(w||h)||(m?null:y),t=c?Boolean(!!w):!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:c,break:t,debugId:v,env:s}}}),define(te[153],ne([0,1,247,4,129]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,P.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(14,null)},category:{type:"string",cat:"e",description:(0,P.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,P.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,P.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,P.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,P.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,P.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,P.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,P.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(h,w,y=D){const m={},v=[],d=[];for(let s in w){const r=w[s];r.alias&&(m[s]=r.alias),r.type==="string"||r.type==="string[]"?(v.push(s),r.deprecates&&v.push(r.deprecates)):r.type==="boolean"&&(d.push(s),r.deprecates&&d.push(r.deprecates))}const l=k(h,{string:v,boolean:d,alias:m}),c={},t=l;c._=l._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in w){const r=w[s];r.alias&&delete t[r.alias];let n=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(n||(n=t[r.deprecates]),delete t[r.deprecates]),typeof n!="undefined"&&(r.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):r.type==="string"&&Array.isArray(n)&&(n=n.pop(),y.onMultipleValues(s,n)),c[s]=n),delete t[s]}for(let s in t)y.onUnknownOption(s);return c}e.parseArgs=C;function S(h,w){let y="";return w.args&&(Array.isArray(w.args)?y=` <${w.args.join("> <")}>`:y=` <${w.args}>`),w.alias?`-${w.alias} --${h}${y}`:`--${h}${y}`}function I(h,w){let y=0,m=[];for(const c in h){const t=h[c],s=S(c,t);y=Math.max(y,s.length),m.push([s,t.description])}let v=y+2+1;if(w-v<25)return m.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let d=w-v-1,l=[];for(const c of m){let t=c[0],s=E(c[1],d),r=i(v-t.length-2);l.push("  "+t+r+s[0]);for(let n=1;n<s.length;n++)l.push(i(v)+s[n])}return l}e.formatOptions=I;function i(h){return" ".repeat(h)}function E(h,w){let y=[];for(;h.length;){let m=h.length<w?h.length:h.lastIndexOf(" ",w),v=h.slice(0,m).trim();h=h.slice(m),y.push(v)}return y}function f(h,w,y,m,v=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${h} ${y}`];l.push(""),l.push(`${(0,P.localize)(32,null)}: ${w} [${(0,P.localize)(33,null)}][${(0,P.localize)(34,null)}...]`),l.push(""),v&&(T.isWindows?l.push((0,P.localize)(35,null,w)):l.push((0,P.localize)(36,null,w)),l.push(""));const c={};for(const t in m){const s=m[t];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[t]=s}}for(let t in c){const s=t;let r=c[s];r&&(l.push(R[s]),l.push(...I(r,d)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function p(h,w){return`${h||(0,P.localize)(37,null)}
${w||(0,P.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function X(e,k,T,P){function R(C){const S=D(C),I=[S];return e.isAbsolute(S)||I.unshift(P),e.resolve(...I)}function D(C){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,T);const i=C["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(E,"AppData","Roaming")}break;case"darwin":I=e.join(k.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,T)}return{getUserDataPath:R}}if(typeof define=="function")define(te[154],ne([0,155,33,15,18,31]),function(e,k,T,P,R,D){const C=R.dirname(P.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return X(k,T,S.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),T=require("os");module.exports=X(k,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[156],ne([0,1,33,76,154]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends T.AbstractNativeEnvironmentService{constructor(C,S){super(C,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,P.getUserDataPath)(C)},S)}}e.NativeEnvironmentService=R}),define(te[157],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,D=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(y){const m=y.match(D);return m?m[1]:null}function i(y){if(y.indexOf("://")===-1){const m=y.match(T);return m?I(m[2]):null}try{const m=k.URI.parse(y);if(m.authority)return I(m.authority)}catch(m){}return null}function E(y,m){const v=new Set;let d;for(;d=C.exec(y);){const c=i(d[1]);c&&v.add(c)}const l=new Set(m);return Array.from(v).map(c=>l.has(c)?c:c.replace(S,"a"))}e.getDomainsOfRemotes=E;function f(y){const m=y.match(R);return m?m[2]:null}function p(y,m,v){return y&&m?(v&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${y}${m}`:`${y}/${m}`):null}function h(y,m){if(y.indexOf("://")===-1){const v=y.match(P);if(v)return p(v[2],v[3],m)}try{const v=k.URI.parse(y);if(v.authority)return p(f(v.authority),v.path,m)}catch(v){}return null}function w(y,m=!1){const v=[];let d;for(;d=C.exec(y);){const l=h(d[1],m);l&&v.push(l)}return v}e.getRemotes=w}),define(te[158],ne([0,1,26]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function P(R,D){const C=S=>{if(typeof S!="string")return;const I=T.exec(S);if(!I)return;const i=D[I[1]]??S;return typeof i=="string"?i:typeof i.message=="string"?i.message:S};return(0,k.cloneAndChange)(R,C)}e.localizeManifest=P}),define(te[159],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,D,C,S){return this.channel.call("promptImportantExtensionsInstallNotification",[R,D,C,S])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class T{constructor(R){this.service=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,C){switch(D){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${D}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(te[77],ne([0,1,138]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=R;function D(f){if(!R(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=D;function C(f){if(!f)return null;let p=f.majorBase,h=f.majorMustEqual,w=f.minorBase,y=f.minorMustEqual,m=f.patchBase,v=f.patchMustEqual;f.hasCaret&&(p===0||(y=!1),v=!1);let d=0;if(f.preRelease){const l=P.exec(f.preRelease);if(l){const[,c,t,s]=l;d=Date.UTC(Number(c),Number(t)-1,Number(s))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:y,patchBase:m,patchMustEqual:v,isMinimum:f.hasGreaterEquals,notBefore:d}}e.normalizeVersion=C;function S(f,p,h){let w;typeof f=="string"?w=C(D(f)):w=f;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let m;if(typeof h=="string"?m=C(D(h)):m=h,!w||!m)return!1;let v=w.majorBase,d=w.minorBase,l=w.patchBase,c=m.majorBase,t=m.minorBase,s=m.patchBase,r=m.notBefore,n=m.majorMustEqual,a=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?v>c?!0:v<c?!1:d>t?!0:d<t||y&&y<r?!1:l>=s:(v===1&&c===0&&(!n||!a||!o)&&(c=1,t=0,s=0,n=!0,a=!1,o=!1),v<c?!1:v>c?!n:d<t?!1:d>t?!a:l<s?!1:l>s?!o:!(y&&y<r))}e.isValidVersion=S;function I(f,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:E(f,p,h.engines.vscode,w)}e.isValidExtensionVersion=I;function i(f,p,h){return f==="*"||E(p,h,f)}e.isEngineValid=i;function E(f,p,h,w=[]){let y=C(D(h));if(!y)return w.push(k.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return w.push(k.localize(1,null,h)),!1}else if(!y.majorMustEqual)return w.push(k.localize(2,null,h)),!1;return S(f,p,y)?!0:(w.push(k.localize(3,null,f,h)),!1)}}),define(te[53],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(P,R=[],D=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=k}),define(te[59],ne([0,1,53]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function P(D,C,S){C instanceof k.SyncDescriptor||(C=new k.SyncDescriptor(C,[],S)),T.push([D,C])}e.registerSingleton=P;function R(){return T}e.getSingletonServiceDescriptors=R}),define(te[160],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=k;class T{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const C=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(D);C.outgoing.set(this._hashFn(D),S),S.incoming.set(this._hashFn(R),C)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(let C of this._nodes.values())C.outgoing.delete(D),C.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let C=this._nodes.get(D);return C||(C=new k(R),this._nodes.set(D,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[D,C]of this._nodes)R.push(`${D}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,D]of this._nodes){const C=new Set([R]),S=this._findCycle(D,C);if(S)return S}}_findCycle(R,D){for(let[C,S]of R.outgoing){if(D.has(C))return[...D,C].join(" -> ");D.add(C);const I=this._findCycle(S,D);if(I)return I;D.delete(C)}}}e.Graph=T}),define(te[6],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function C(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=C})(k=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function T(D,C,S,I){C[k.DI_TARGET]===C?C[k.DI_DEPENDENCIES].push({id:D,index:S,optional:I}):(C[k.DI_DEPENDENCIES]=[{id:D,index:S,optional:I}],C[k.DI_TARGET]=C)}function P(D){if(k.serviceIds.has(D))return k.serviceIds.get(D);const C=function(S,I,i){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(C,S,i,!1)};return C.toString=()=>D,k.serviceIds.set(D,C),C}e.createDecorator=P;function R(D){return D}e.refineServiceDecorator=R}),define(te[161],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[162],ne([0,1,4,25,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=k.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",k.isMacintosh),D.set("isLinux",k.isLinux),D.set("isWindows",k.isWindows),D.set("isWeb",k.isWeb),D.set("isMacNative",k.isMacintosh&&!k.isWeb),D.set("isEdge",R.indexOf("Edg/")>=0),D.set("isFirefox",R.indexOf("Firefox")>=0),D.set("isChrome",R.indexOf("Chrome")>=0),D.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return f.INSTANCE}static true(){return p.INSTANCE}static has(L){return h.create(L)}static equals(L,$){return w.create(L,$)}static notEquals(L,$){return v.create(L,$)}static regex(L,$){return n.create(L,$)}static in(L,$){return y.create(L,$)}static not(L){return d.create(L)}static and(...L){return u.create(L,null)}static or(...L){return g.create(L,null,!0)}static greater(L,$){return c.create(L,$)}static greaterEquals(L,$){return t.create(L,$)}static smaller(L,$){return s.create(L,$)}static smallerEquals(L,$){return r.create(L,$)}static deserialize(L,$=!1){if(!!L)return this._deserializeOrExpression(L,$)}static _deserializeOrExpression(L,$){let _=L.split("||");return g.create(_.map(M=>this._deserializeAndExpression(M,$)),null,!0)}static _deserializeAndExpression(L,$){let _=L.split("&&");return u.create(_.map(M=>this._deserializeOne(M,$)),null)}static _deserializeOne(L,$){if(L=L.trim(),L.indexOf("!=")>=0){let _=L.split("!=");return v.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("==")>=0){let _=L.split("==");return w.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("=~")>=0){let _=L.split("=~");return n.create(_[0].trim(),this._deserializeRegexValue(_[1],$))}if(L.indexOf(" in ")>=0){let _=L.split(" in ");return y.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const _=L.split(">=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const _=L.split(">");return c.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const _=L.split("<=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const _=L.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let _=/^'([^']*)'$/.exec(L);return _?_[1].trim():L}static _deserializeRegexValue(L,$){if((0,T.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=L.indexOf("/"),M=L.lastIndexOf("/");if(_===M||_<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let j=L.slice(_+1,M),W=L[M+1]==="i"?"i":"";try{return new RegExp(j,W)}catch(x){if($)throw new Error(`bad regexp-value '${L}', parse error: ${x}`);return console.warn(`bad regexp-value '${L}', parse error: ${x}`),null}}}e.ContextKeyExpr=I;function i(N,L){const $=N?N.substituteConstants():void 0,_=L?L.substituteConstants():void 0;return!$&&!_?!0:!$||!_?!1:$.equals(_)}e.expressionsAreEqualWithConstantSubstitution=i;function E(N,L){return N.cmp(L)}class f{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(L,$){this.key=L,this.negated=$,this.type=2}static create(L,$=null){const _=D.get(L);return typeof _=="boolean"?_?p.INSTANCE:f.INSTANCE:new h(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=D.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:f.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=4}static create(L,$,_=null){if(typeof $=="boolean")return $?h.create(L,_):d.create(L,_);const M=D.get(L);return typeof M=="boolean"?$===(M?"true":"false")?p.INSTANCE:f.INSTANCE:new w(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=D.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?p.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class y{constructor(L,$){this.key=L,this.valueKey=$,this.type=10,this.negated=null}static create(L,$){return new y(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.valueKey),_=L.getValue(this.key);return Array.isArray($)?$.indexOf(_)>=0:typeof _=="string"&&typeof $=="object"&&$!==null?C.call($,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=y;class m{constructor(L){this._actual=L,this.type=11}static create(L){return new m(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new m(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class v{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=5}static create(L,$,_=null){if(typeof $=="boolean")return $?d.create(L,_):h.create(L,_);const M=D.get(L);return typeof M=="boolean"?$===(M?"true":"false")?f.INSTANCE:p.INSTANCE:new v(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=D.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?f.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class d{constructor(L,$){this.key=L,this.negated=$,this.type=3}static create(L,$=null){const _=D.get(L);return typeof _=="boolean"?_?f.INSTANCE:p.INSTANCE:new d(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=D.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=d;function l(N,L){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?L(N):f.INSTANCE}class c{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=12}static create(L,$,_=null){return l($,M=>new c(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class t{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=13}static create(L,$,_=null){return l($,M=>new t(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=t;class s{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=14}static create(L,$,_=null){return l($,M=>new s(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=15}static create(L,$,_=null){return l($,M=>new r(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{constructor(L,$){this.key=L,this.regexp=$,this.type=7,this.negated=null}static create(L,$){return new n(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return $<_?-1:$>_?1:0}equals(L){if(L.type===this.type){const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return this.key===L.key&&$===_}return!1}substituteConstants(){return this}evaluate(L){let $=L.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class a{constructor(L){this._actual=L,this.type=8}static create(L){return new a(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new a(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function o(N){let L=null;for(let $=0,_=N.length;$<_;$++){const M=N[$].substituteConstants();if(N[$]!==M&&L===null){L=[];for(let j=0;j<$;j++)L[j]=N[j]}L!==null&&(L[$]=M)}return L===null?N:L}class u{constructor(L,$){this.expr=L,this.negated=$,this.type=6}static create(L,$){return u._normalizeArr(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=E(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static _normalizeArr(L,$){const _=[];let M=!1;for(const j of L)if(!!j){if(j.type===1){M=!0;continue}if(j.type===0)return f.INSTANCE;if(j.type===6){_.push(...j.expr);continue}_.push(j)}if(_.length===0&&M)return p.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(E);for(let j=1;j<_.length;j++)_[j-1].equals(_[j])&&(_.splice(j,1),j--);if(_.length===1)return _[0];for(;_.length>1;){const j=_[_.length-1];if(j.type!==9)break;_.pop();const W=_.pop(),x=_.length===0,z=g.create(j.expr.map(K=>u.create([K,W],null)),null,x);z&&(_.push(z),_.sort(E))}return _.length===1?_[0]:new u(_,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new u(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){const L=[];for(let $ of this.expr)L.push($.negate());this.negated=g.create(L,this,!0)}return this.negated}}class g{constructor(L,$){this.expr=L,this.negated=$,this.type=9}static create(L,$,_){return g._normalizeArr(L,$,_)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=E(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:g.create(L,this.negated,!1)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(this.expr[$].evaluate(L))return!0;return!1}static _normalizeArr(L,$,_){let M=[],j=!1;if(L){for(let W=0,x=L.length;W<x;W++){const z=L[W];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){M=M.concat(z.expr);continue}M.push(z)}}if(M.length===0&&j)return f.INSTANCE;M.sort(E)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(_){for(let W=0;W<M.length;W++)for(let x=W+1;x<M.length;x++)O(M[W],M[x])&&(M.splice(x,1),x--);if(M.length===1)return M[0]}return new g(M,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new g(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){let L=[];for(let $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),_=L.shift(),M=[];for(const W of q($))for(const x of q(_))M.push(u.create([W,x],null));const j=L.length===0;L.unshift(g.create(M,null,j))}this.negated=L[0]}return this.negated}}class b extends h{constructor(L,$,_){super(L,null);this._defaultValue=$,typeof _=="object"?b._info.push({..._,key:L}):_!==!0&&b._info.push({key:L,description:_,type:$!=null?typeof $:void 0})}static all(){return b._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return w.create(this.key,L)}notEqualsTo(L){return v.create(this.key,L)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function A(N,L){return N<L?-1:N>L?1:0}function U(N,L,$,_){return N<$?-1:N>$?1:L<_?-1:L>_?1:0}function O(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const M of L.expr)if(N.equals(M))return!0}const $=N.negate(),_=q($).concat(q(L));_.sort(E);for(let M=0;M<_.length;M++){const W=_[M].negate();for(let x=M+1;x<_.length;x++){const z=_[x];if(W.equals(z))return!0}}return!1}e.implies=O;function q(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function T(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=T}),define(te[79],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,133,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function S(d,l){switch(d){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function I(d,l){return l==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function i(d,l,c){return I(l,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c?!0:E(c).includes(d)}e.isTargetPlatformCompatible=i;function E(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function f(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=f;var p;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(d){d.Install="install",d.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var m;(function(d){d.Unsupported="Unsupported",d.Malicious="Malicious",d.Incompatible="Incompatible",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(l,c){super(l);this.code=c,this.name=c}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(X,e){return function(k,T){e(k,T,X)}};define(te[163],ne([0,1,2,30]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends k.Disposable{constructor(D){super();this.extensionManagementService=D,this._register(D),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=he([J(0,T.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(te[164],ne([0,1,3,2,26,8,111,30]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(w,y){return R.URI.revive(y?y.transformIncoming(w):w)}function I(w,y){return y?y.transformOutgoingURI(w):w}function i(w,y){y=y||D.DefaultURITransformer;const m=w.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...w,manifest:void 0},y),manifest:m}}function E(w,y){return y?(0,P.cloneAndChange)(w,m=>m instanceof R.URI?y.transformOutgoingURI(m):void 0):w}class f{constructor(y,m){this.service=y,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,m){const v=this.getUriTransformer(y);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,d=>d.map(l=>({...l,local:l.local?E(l.local,v):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,m,v){const d=this.getUriTransformer(y);switch(m){case"zip":return this.service.zip(i(v[0],d)).then(l=>I(l,d));case"unzip":return this.service.unzip(S(v[0],d));case"install":return this.service.install(S(v[0],d),v[1]);case"getManifest":return this.service.getManifest(S(v[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(i(v[0],d),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(v[0],d));case"getInstalled":return this.service.getInstalled(v[0]).then(l=>l.map(c=>E(c,d)));case"updateMetadata":return this.service.updateMetadata(i(v[0],d),v[1]).then(l=>E(l,d));case"updateExtensionScope":return this.service.updateExtensionScope(i(v[0],d),v[1]).then(l=>E(l,d));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends T.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?R.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(v=>({...v,local:v.local?i(v.local,null):v.local,source:this.isUriComponents(v.source)?R.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(y){const m=await this.getTargetPlatform();return y.allTargetPlatforms.some(v=>(0,C.isTargetPlatformCompatible)(v,y.allTargetPlatforms,m))}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(m=>R.URI.revive(m)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,m){return Promise.resolve(this.channel.call("install",[y,m])).then(v=>i(v,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}installFromGallery(y,m){return Promise.resolve(this.channel.call("installFromGallery",[y,m])).then(v=>i(v,null))}uninstall(y,m){return Promise.resolve(this.channel.call("uninstall",[y,m]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(m=>m.map(v=>i(v,null)))}updateMetadata(y,m){return Promise.resolve(this.channel.call("updateMetadata",[y,m])).then(v=>i(v,null))}updateExtensionScope(y,m){return Promise.resolve(this.channel.call("updateExtensionScope",[y,m])).then(v=>i(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(y){this.service=y}listen(y,m){throw new Error("Invalid listen")}call(y,m,v){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function P(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var R;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,k.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,41,9,25,17,8,140,6]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function I(_){return _.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var E;(function(_){_[_.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var f;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function y(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=y;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(M,j){super(M);this.code=j}}e.FileSystemProviderError=v;function d(_,M){const j=new v(_.toString(),M);return c(j,M),j}e.createFileSystemProviderError=d;function l(_){return _||d((0,C.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=l;function c(_,M){return _.name=M?`${M} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=c;function t(_){if(!_)return m.Unknown;if(_ instanceof v)return _.code;const M=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function s(_){if(_ instanceof g)return _.fileOperationResult;switch(t(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(M,j,W){this.resource=M,this.operation=j,this.target=W}isOperation(M){return this.operation===M}}e.FileOperationEvent=n;var a;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor(M,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const x of M){const z=W.get(x.type);z?z.push([x.resource,x]):W.set(x.type,[[x.resource,x]])}for(const[x,z]of W)switch(x){case 1:this.added=k.TernarySearchTree.forUris(()=>j),this.added.fill(z);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>j),this.updated.fill(z);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>j),this.deleted.fill(z);break}}contains(M,...j){return this.doContains(M,{includeChildren:!1},...j)}affects(M,...j){return this.doContains(M,{includeChildren:!0},...j)}doContains(M,j,...W){if(!M)return!1;const x=W.length>0;return!!((!x||W.includes(1))&&(this.added?.get(M)||j.includeChildren&&this.added?.findSuperstr(M))||(!x||W.includes(0))&&(this.updated?.get(M)||j.includeChildren&&this.updated?.findSuperstr(M))||(!x||W.includes(2))&&(this.deleted?.findSubstr(M)||j.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(_,M,j){return!_||!M||_===M||M.length>_.length?!1:(M.charAt(M.length-1)!==T.sep&&(M+=T.sep),j?(0,P.startsWithIgnoreCase)(_,M):_.indexOf(M)===0)}e.isParent=u;class g extends Error{constructor(M,j,W){super(M);this.fileOperationResult=j,this.options=W}}e.FileOperationError=g;class b extends g{constructor(M,j,W){super(M,2,W);this.stat=j}}e.NotModifiedSinceFileOperationError=b;var A;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=O;async function q(_,M){if(!M.hasProvider(D.URI.from({scheme:_.scheme})))return new Promise(j=>{const W=M.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===_.scheme&&x.added&&(W.dispose(),j())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(M){return(0,R.isNumber)(M)||(M=0),M<N.KB?(0,C.localize)(1,null,M.toFixed(0)):M<N.MB?(0,C.localize)(2,null,(M/N.KB).toFixed(2)):M<N.GB?(0,C.localize)(3,null,(M/N.MB).toFixed(2)):M<N.TB?(0,C.localize)(4,null,(M/N.GB).toFixed(2)):(0,C.localize)(5,null,(M/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var L;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function $(_){return{maxFileSize:_===0?300*N.MB:16*N.GB,maxHeapSize:_===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(te[165],ne([0,1,82,50,14]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(C){this.fileService=C}async checksum(C){const S=(await this.fileService.readFileStream(C)).value;return new Promise((I,i)=>{const E=(0,k.createHash)("md5");(0,T.listenStream)(S,{onData:f=>E.update(f.buffer),onError:f=>i(f),onEnd:()=>I(E.digest("base64").replace(/=+$/,""))})})}};R=he([J(0,P.IFileService)],R),e.ChecksumService=R}),define(te[166],ne([0,1,248,130,153,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function D(f,p){const h={onUnknownOption:y=>{console.warn((0,T.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,T.localize)(1,null,y,m))}},w=(0,P.parseArgs)(f,P.OPTIONS,p?h:void 0);return w.goto&&w._.forEach(y=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,T.localize)(2,null))),w["max-memory"]&&k(parseInt(w["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function C(f){const p=f.findIndex(h=>!/^-/.test(h));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function S(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=C(p)||[]);const h=!E(process.env);return D(p,h)}e.parseMainProcessArgv=S;function I(f){const[,,...p]=f;return D(p,!0)}e.parseCLIProcessArgv=I;function i(f,...p){const h=f.indexOf("--");return h===-1?f.push(...p):f.splice(h,0,...p),f}e.addArg=i;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[167],ne([0,1,43,9,131,28,38,7,4,29,126,166,5]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function w(m,v,d){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(d)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(l,c)=>{const t=new R.CancellationTokenSource,s=setTimeout(()=>{t.dispose(!0),c(new Error((0,P.localize)(0,null)))},p);try{l(await y(m,t.token))}catch(r){!(0,C.isPromiseCanceledError)(r)&&!t.token.isCancellationRequested?c(new Error((0,P.localize)(1,null,(0,D.toErrorMessage)(r)))):l({})}finally{clearTimeout(s),t.dispose()}})),h)}e.resolveShellEnv=w;async function y(m,v){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",l);const c=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const r=await(0,i.getSystemShell)(S.OS,s);return m.trace("getUnixShellEnvironment#shell",r),new Promise((n,a)=>{if(v.isCancellationRequested)return a((0,C.canceled)());const o=(0,T.basename)(r);let u,g;/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,g=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,o==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),u);const b=(0,k.spawn)(r,[...g,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(b.kill(),a((0,C.canceled)()))),b.on("error",O=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(O)),a(O)});const A=[];b.stdout.on("data",O=>A.push(O));const U=[];b.stderr.on("data",O=>U.push(O)),b.on("close",(O,q)=>{const N=Buffer.concat(A).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const L=Buffer.concat(U).toString("utf8");if(L.trim()&&m.trace("getUnixShellEnvironment#stderr",L),O||q)return a(new Error((0,P.localize)(2,null,O,q)));const $=t.exec(N),_=$?$[1]:"{}";try{const M=JSON.parse(_);d?M.ELECTRON_RUN_AS_NODE=d:delete M.ELECTRON_RUN_AS_NODE,l?M.ELECTRON_NO_ATTACH_CONSOLE=l:delete M.ELECTRON_NO_ATTACH_CONSOLE,delete M.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",M),n(M)}catch(M){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(M)),a(M)}})})}}),define(te[83],ne([0,1,19,7,141,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(i,E,f,p,h,w){let y;try{await C(i,E,f,p,h,w)}catch(m){y=m}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&f.error(y),f.end()}}e.readFileIntoStream=D;async function C(i,E,f,p,h,w){S(w);const y=await i.open(E,{create:!1});try{S(w);let m=0,v=0,d=h&&typeof h.length=="number"?h.length:void 0,l=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,t=0;do v=await i.read(y,c,l.buffer,t,l.byteLength-t),c+=v,t+=v,m+=v,typeof d=="number"&&(d-=v),t===l.byteLength&&(await f.write(p(l)),l=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),t=0);while(v>0&&(typeof d!="number"||d>0)&&S(w)&&I(m,h));if(t>0){let s=t;typeof d=="number"&&(s=Math.min(t,d)),f.write(p(l.slice(0,s)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await i.close(y)}}function S(i){if(i.isCancellationRequested)throw(0,T.canceled)();return!0}function I(i,E){if(E?.limits){if(typeof E.limits.memory=="number"&&i>E.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&i>E.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,8,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class D extends k.Disposable{constructor(f,p,h){super();this.onFileChanges=f,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new k.DisposableStore;this.serviceDisposables.value=f,this.service=this.createService(f),this.service.setVerboseLogging(this.verboseLogging),f.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),f.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),f.add(this.service.onDidError(p=>this.onError(p)))}onError(f){this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.service?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${f}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=D,D.MAX_RESTARTS=5;class C extends k.Disposable{}e.WatcherService=C;function S(E){return E.map(f=>({type:f.type,resource:P.URI.file(f.path)}))}e.toFileChanges=S;function I(E){const f=new i;for(const p of E)f.processEvent(p);return f.normalize()}e.normalizeFileChanges=I;class i{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(f){return T.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const p=this.mapPathToChange.get(this.toKey(f));let h=!1;if(p){const w=p.type,y=f.type;p.path!==f.path&&f.type===2?h=!0:w===1&&y===2?(this.mapPathToChange.delete(this.toKey(f)),this.normalized.delete(p)):w===2&&y===1?p.type=0:w===1&&y===0||(p.type=y)}else h=!0;h&&(this.normalized.add(f),this.mapPathToChange.set(this.toKey(f),f))}normalize(){const f=[],p=[];return Array.from(this.normalized).filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,w)=>h.path.length-w.path.length).filter(h=>p.some(w=>(0,R.isParent)(h.path,w,!T.isLinux))?!1:(p.push(h.path),!0)).concat(f)}}}),define(te[168],ne([0,1,5,2,9,116,20,119,54]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends T.Disposable{constructor(E,f,p,h){super();this.path=E,this.onDidFilesChange=f,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new k.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:f}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(f)try{p=await(0,R.realpath)(p)}catch(h){if(this.onError(h),f.dangling)return}E.isDirectory()?this._register((0,C.watchFolder)(p,(h,w)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,P.join)(this.path,(0,P.basename)(w))})},h=>this.onError(h))):this._register((0,C.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.normalizeFileChanges)(f);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(te[169],ne([0,1,15,34,52,54]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D extends R.WatcherService{constructor(S,I,i){super();this.onDidFilesChange=S,this.onLogMessage=I,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const S=this._register(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=T.ProxyChannel.toService((0,T.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}async setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||await this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}async watch(S){this.isDisposed||await this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=D}),define(te[170],ne([0,1,15,34,52,54]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D extends R.AbstractWatcherService{constructor(S,I,i){super(S,I,i);this.init()}createService(S){const I=S.add(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(I.onDidProcessExit(({code:i,signal:E})=>this.onError(`terminated by itself with code ${i}, signal: ${E}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(I.getChannel("watcher")))}}e.FileWatcher=D}),define(te[84],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...P){this._entries=new Map;for(let[R,D]of P)this.set(R,D)}set(P,R){const D=this._entries.get(P);return this._entries.set(P,R),D}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=k}),define(te[171],ne([0,1,5,7,53,160,6,84]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new C.ServiceCollection,w=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=y,this._services.set(D.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...w){let y=f.traceInvocation(h),m=!1;try{return h({get:d=>{if(m)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(d,y);if(!l)throw new Error(`[invokeFunction] unknown service '${d}'`);return l}},...w)}finally{m=!0,y.stop()}}createInstance(h,...w){let y,m;return h instanceof P.SyncDescriptor?(y=f.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(w),y)):(y=f.traceCreation(h),m=this._createInstance(h,w,y)),y.stop(),m}_createInstance(h,w=[],y){let m=D._util.getServiceDependencies(h).sort((l,c)=>l.index-c.index),v=[];for(const l of m){let c=this._getOrCreateServiceInstance(l.id,y);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`);v.push(c)}let d=m.length>0?m[0].index:w.length;if(w.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${w.length} static arguments`);let l=d-w.length;l>0?w=w.concat(new Array(l)):w=w.slice(0,d)}return new h(...[...w,...v])}_setServiceInstance(h,w){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,w.branch(h,!0)):(w.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,w,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,y){const m=new R.Graph(l=>l.id.toString());let v=0;const d=[{id:h,desc:w,_trace:y}];for(;d.length;){const l=d.pop();if(m.lookupOrInsertNode(l),v++>1e3)throw new I(m);for(let c of D._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const s={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};m.insertEdge(l,s),d.push(s)}}}for(;;){const l=m.roots();if(l.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof P.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,y=[],m,v){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(w,y,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,y,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],y,m){if(y){const v=new k.IdleValue(()=>this._createInstance(h,w,m));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let c=v.value,t=c[l];return typeof t!="function"||(t=t.bind(c),d[l]=t),t},set(d,l,c){return v.value[l]=c,!0}})}else return this._createInstance(h,w,m)}}e.InstantiationService=i;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class f{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return S?new f(0,h.name):f._None}branch(h,w){let y=new f(2,h.toString());return this._dep.push([h,w,y]),y}stop(){let h=Date.now()-this._start;f._totals+=h;let w=!1;function y(v,d){let l=[],c=new Array(v+1).join("	");for(const[t,s,r]of d._dep)if(s&&r){w=!0,l.push(`${c}CREATES -> ${t}`);let n=y(v+1,r);n&&l.push(n)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[172],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(P,R){this.server=P,this.router=R}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,R){this.server.registerChannel(P,R)}}e.MessagePortMainProcessService=k}),define(te[173],ne([0,1,34,53,59,6]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class D{constructor(p,h,w){const y=w.getChannel(p);return C(h)?new h.channelClientCtor(y):k.ProxyChannel.toService(y,h?.proxyOptions)}}function C(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let S=class extends D{constructor(p,h,w){super(p,h,w)}};S=he([J(2,e.IMainProcessService)],S);function I(f,p,h){(0,P.registerSingleton)(f,new T.SyncDescriptor(S,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let i=class extends D{constructor(p,h,w){super(p,h,w)}};i=he([J(2,e.ISharedProcessService)],i);function E(f,p,h){(0,P.registerSingleton)(f,new T.SyncDescriptor(i,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[60],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function T(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=T}),define(te[174],ne([0,1,2,60]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends k.Disposable{constructor(D){super();this.localizationsService=D,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=he([J(0,T.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(te[10],ne([0,1,38,3,2,4,6]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class I extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}s+=(r>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class E extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...s):console.warn(`[main ${C()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class f extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=f;class p extends I{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,k.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class w extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=w;class y extends P.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=m;function v(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=d(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function d(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=d;function l(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(te[175],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends P.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,R.basename)(this.environmentService.logsPath),f=(0,R.dirname)(this.environmentService.logsPath),w=(await D.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),y=w.slice(0,Math.max(0,w.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(m=>D.Promises.rm((0,R.join)(f,m)))))}catch(E){(0,T.onUnexpectedError)(E)}}};I=he([J(0,C.IEnvironmentService),J(1,S.ILogService)],I),e.LogsDataCleaner=I}),define(te[176],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class Et extends P.Disposable{constructor(E,f,p){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await D.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(w=>w.backupFolder),h=await D.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async w=>{w.length!==Et.NON_EMPTY_WORKSPACE_ID_LENGTH&&p.indexOf(w)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${w}.`),await D.Promises.rm((0,R.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}))}catch(E){(0,T.onUnexpectedError)(E)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I=he([J(1,C.INativeEnvironmentService),J(2,S.ILogService)],I),e.StorageDataCleaner=I}),define(te[85],ne([0,1,5,19,32,40,11,14,6,10]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(f){f.ERROR_INVALID_FILE="ERROR_INVALID_FILE",f.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,S.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,h,w){this.environmentService=p,this.fileService=h,this.logService=w,this.queue=new k.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:w,mtime:y,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let v=w.toString();const d=[];if((0,P.parse)(v,d,{allowTrailingComma:!0,allowEmptyContent:!0}),d.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(p,v,h)[0];if(l){v=v.substring(0,l.offset)+l.content+v.substring(l.offset+l.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(v),{etag:m,mtime:y})}catch(c){if(c.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},w,y){return h.length?(0,R.setProperty)(w,h,p,y):[{content:JSON.stringify(p,null,y.insertSpaces&&y.tabSize?" ".repeat(y.tabSize):"	"),length:w.length,offset:0}]}};E=he([J(0,D.IEnvironmentService),J(1,C.IFileService),J(2,I.ILogService)],E),e.UserConfigurationFileService=E}),define(te[177],ne([0,1,43,5,38,3,2,15,9,20,11,10]),function(X,e,k,T,P,R,D,C,S,I,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends D.Disposable{constructor(h,w){super();this.environmentService=h,this.logService=w,this.processesLimiter=new T.Limiter(5)}async postUninstall(h){const w=this.parseScript(h,"uninstall");return w&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),I.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,w){const y=`vscode:${w}`;if(h.location.scheme===C.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const m=h.manifest.scripts[y].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,w,y,m,v){return new Promise((d,l)=>{const c=this.start(h,w,y,v);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?l(r):d(void 0)};c.on("error",r=>{s((0,P.toErrorMessage)(r)||"Unknown")}),c.on("exit",(r,n)=>{s(r?`post-${w} process exited with code ${r}`:void 0)}),m&&(t=setTimeout(()=>{t=null,c.kill(),l("timed out")},5e3))})}start(h,w,y,m){const v={silent:!0,execArgv:void 0},d=(0,k.fork)(h,[`--type=extension-post-${w}`,...y],v);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const l=R.Event.fromNodeEventEmitter(d.stdout,"data"),c=R.Event.fromNodeEventEmitter(d.stderr,"data");l(r=>this.logService.info(m.identifier.id,m.manifest.version,`post-${w}`,r)),c(r=>this.logService.error(m.identifier.id,m.manifest.version,`post-${w}`,r));const t=R.Event.any(R.Event.map(l,r=>({data:`%c${r}`,format:[""]})),R.Event.map(c,r=>({data:`%c${r}`,format:["color: red"]})));return R.Event.debounce(t,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(m.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),d}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=he([J(0,i.IEnvironmentService),J(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[178],ne([0,1,7,2,81,3,43,15,113,4,10,59,26,31]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends T.Disposable{constructor(m,v){super();this.id=m,this._logService=v,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null}register(m){this._register(m)}start(m){this._process=(0,D.fork)(C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,f.mixin)({cwd:(0,p.cwd)()},m));const v=this._process.pid;this._logService.info(`Starting extension host with pid ${v}.`);const d=new S.StringDecoder("utf-8");this._process.stdout?.on("data",c=>{const t=typeof c=="string"?c:d.write(c);this._onStdout.fire(t)});const l=new S.StringDecoder("utf-8");return this._process.stderr?.on("data",c=>{const t=typeof c=="string"?c:l.write(c);this._onStderr.fire(t)}),this._process.on("message",c=>{this._onMessage.fire(c)}),this._process.on("error",c=>{this._onError.fire({error:(0,k.transformErrorForSerialization)(c)})}),this._process.on("exit",(c,t)=>{this._onExit.fire({pid:v,code:c,signal:t})}),{pid:v}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):I.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([J(1,i.ILogService)],h);let w=class bt{constructor(m){this._logService=m,this._extHosts=new Map}dispose(){}_getExtHost(m){const v=this._extHosts.get(m);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(m){return this._getExtHost(m).onStdout}onDynamicStderr(m){return this._getExtHost(m).onStderr}onDynamicMessage(m){return this._getExtHost(m).onMessage}onDynamicError(m){return this._getExtHost(m).onError}onDynamicExit(m){return this._getExtHost(m).onExit}async createExtensionHost(){const m=String(++bt._lastId),v=new h(m,this._logService);return this._extHosts.set(m,v),v.onExit(({pid:d,code:l,signal:c})=>{this._logService.info(`Extension host with pid ${d} exited with code: ${l}, signal: ${c}.`),setTimeout(()=>{v.dispose(),this._extHosts.delete(m)})}),{id:m}}async start(m,v){return this._getExtHost(m).start(v)}async enableInspectPort(m){const v=this._extHosts.get(m);return v?v.enableInspectPort():!1}async kill(m){const v=this._extHosts.get(m);!v||v.kill()}};w._lastId=0,w=he([J(0,i.ILogService)],w),e.ExtensionHostStarter=w,(0,E.registerSingleton)(P.IExtensionHostStarter,w,!0)}),define(te[179],ne([0,1,16,5,7,3,2,9,54,10]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends D.Disposable{constructor(f){super();this.logService=f,this._onDidErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(f,p){return p.recursive?this.watchRecursive(f,p):this.watchNonRecursive(f)}watchRecursive(f,p){const h={path:this.toFilePath(f),excludes:p.excludes},w=(0,k.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,P.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,f=>this._onDidChangeFile.fire((0,S.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,p){return f.watch(p)}watchNonRecursive(f){const p=this.createNonRecursiveWatcher(this.toFilePath(f),w=>this._onDidChangeFile.fire((0,S.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,D.combinedDisposable)(p,h)}onWatcherLogMessage(f){f.type==="error"&&this._onDidErrorOccur.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,C.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(te[180],ne([0,1,16,5,19,28,3,56,2,41,15,181,18,50,139,14,83,10]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class Ke extends S.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new w.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new w.FileChangesEvent(c,!0)))),this.watchedResources=I.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new S.DisposableStore;return t.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,S.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await T.Promises.settled(c)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return C.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,f.isAbsolutePath)(l))throw new w.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasReadWriteCapability)(c)||(0,w.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,w.toFileSystemProviderErrorCode)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),s=this.isPathCaseSensitive(t),r=c?.resolveTo,n=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,o=await t.stat(l);let u;return this.toFileStat(t,l,o,void 0,!!a,(g,b)=>(u||(u=I.TernarySearchTree.forUris(()=>!s),u.set(l,!0),r&&u.fill(!0,r)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&n?b===1:!1))}async toFileStat(l,c,t,s,r,n){const{providerExtUri:a}=this.getExtUri(l),o={resource:c,name:a.basename(c),isFile:(t.type&w.FileType.File)!=0,isDirectory:(t.type&w.FileType.Directory)!=0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&w.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,w.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&n(o,s)){try{const u=await l.readdir(c),g=await T.Promises.settled(u.map(async([b,A])=>{try{const U=a.joinPath(c,b),O=r?await l.stat(U):{type:A};return await this.toFileStat(l,U,O,u.length,r,n)}catch(U){return this.logService.trace(U),null}}));o.children=(0,k.coalesce)(g)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(l){return T.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!c?.overwrite&&await this.exists(l))throw new w.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=P.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const s=await this.writeFile(l,c);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,s)),s}async writeFile(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,l,t)||await this.mkdirp(s,r.dirname(l));let a;if((0,w.hasReadWriteCapability)(s)&&!(c instanceof P.VSBuffer))if((0,p.isReadableStream)(c)){const o=await(0,p.peekStream)(c,3);o.ended?a=P.VSBuffer.concat(o.buffer):a=o}else a=(0,p.peekReadable)(c,o=>P.VSBuffer.concat(o),3);else a=c;!(0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)&&a instanceof P.VSBuffer?await this.doWriteUnbuffered(s,l,t,a):await this.doWriteBuffered(s,l,t,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a)}catch(n){throw new w.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!t?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(c)));let r;try{r=await l.stat(c)}catch(n){return}if((r.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,h.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,w.etag)({mtime:t.mtime,size:r.size}))throw new w.FileOperationError((0,h.localize)(7,null),3,t);return r}async readFile(l,c){const t=await this.withReadProvider(l);return c?.atomic?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(l,c,t);s(n)}catch(n){r(n)}})})}async doReadFile(l,c,t){const s=await this.doReadFileStream(l,c,{...t,preferUnbuffered:!0});return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const s=new R.CancellationTokenSource,r=this.validateReadFile(c,t).then(a=>a,a=>{throw s.cancel(),a});let n;try{return typeof t?.etag=="string"&&t.etag!==w.ETAG_DISABLED&&await r,!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&t?.preferUnbuffered?n=this.readFileUnbuffered(l,c,t):(0,w.hasFileReadStreamCapability)(l)?n=this.readFileStreamed(l,c,s.token,t):n=this.readFileBuffered(l,c,s.token,t),{...await r,value:n}}catch(a){n&&await(0,p.consumeStream)(n);const o=(0,h.localize)(8,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(o,a.stat,t):new w.FileOperationError(o,(0,w.toFileOperationResult)(a),t)}}readFileStreamed(l,c,t,s=Object.create(null)){const r=l.readFileStream(c,s,t);return(0,p.transform)(r,{data:n=>n instanceof P.VSBuffer?n:P.VSBuffer.wrap(n),error:n=>new w.FileOperationError((0,h.localize)(9,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),s)},n=>P.VSBuffer.concat(n))}readFileBuffered(l,c,t,s=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,y.readFileIntoStream)(l,c,r,n=>n,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new w.FileOperationError((0,h.localize)(10,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(n).toString()),(0,w.toFileOperationResult)(n),s)},t),r}readFileUnbuffered(l,c,t){const s=(0,p.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r=await l.readFile(c);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(c,r.byteLength,t),s.end(P.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new w.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,c);if(typeof c?.etag=="string"&&c.etag!==w.ETAG_DISABLED&&c.etag===t.etag)throw new w.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&c>t.limits.size&&(s=7),typeof s=="number")throw new w.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),s)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,s){if(l.toString()!==c.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,l,n,c,t,s)}catch(r){return r}return!0}async move(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=await this.doMoveCopy(s,l,r,c,"move",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,n==="move"?2:3,a)),a}async copy(l,c,t){const s=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=await this.doMoveCopy(s,l,r,c,"copy",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,n==="copy"?3:2,a)),a}async doMoveCopy(l,c,t,s,r,n){if(c.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,c,t,s,r,n);if(a&&!o&&n&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(l===t&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(c,s,{overwrite:n});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(l,u,t,s):await this.doCopyFile(l,c,t,s)}return r}else return l===t?(await l.rename(c,s,{overwrite:n}),r):(await this.doMoveCopy(l,c,t,s,"copy",n),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,s){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,s);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,s);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,s);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,s)}async doCopyFolder(l,c,t,s){await t.mkdir(s),Array.isArray(c.children)&&await T.Promises.settled(c.children.map(async r=>{const n=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),t,n):this.doCopyFile(l,r.resource,t,n)}))}async doValidateMoveCopy(l,c,t,s,r,n){let a=!1;if(l===t){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(l);if(g||(a=u.isEqual(c,s)),a&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,c))throw new Error((0,h.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!n)throw new w.FileOperationError((0,h.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(l===t){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(c,s))throw new Error((0,h.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:s}=this.getExtUri(l);for(;!s.isEqual(c,s.dirname(c));)try{if(((await l.stat(c)).type&w.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(c)),c=s.dirname(c)}for(let r=t.length-1;r>=0;r--){c=s.joinPath(c,t[r]);try{await l.mkdir(c)}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let r;try{r=await t.stat(l)}catch(a){}if(r)this.throwIfFileIsReadonly(l,r);else throw new w.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!c?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),s=!!c?.useTrash,r=!!c?.recursive;await t.delete(l,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}onDidChangeFile(l,c){this._onDidChangeFilesRaw.fire({changes:l});let t,s;{for(const r of l)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new w.FileChangesEvent(t,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,c={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let s=!1,r=()=>{s=!0};return t.add((0,S.toDisposable)(()=>r())),this.doWatch(l,c).then(n=>{s?(0,S.dispose)(n):r=()=>(0,S.dispose)(n)},n=>this.logService.error(n)),c.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),t.add((0,S.toDisposable)(()=>{const n=this.watchedResources.get(l);typeof n=="number"&&(n<=1?this.watchedResources.delete(l):this.watchedResources.set(l,n-1))}))),t}async doWatch(l,c){const t=await this.withProvider(l),s=this.toWatchKey(t,l,c);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:t.watch(l,c)},this.activeWatchers.set(s,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(s)))})}toWatchKey(l,c,t){const{providerExtUri:s}=this.getExtUri(l);return[s.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,S.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,p.isReadableStream)(s)||(0,p.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(l,r,s):await this.doWriteReadableBufferedQueued(l,r,s)}catch(n){throw(0,w.ensureFileSystemProviderError)(n)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,c,t){let s=0,r;if((0,p.isReadableBufferedStream)(t)){if(t.buffer.length>0){const n=P.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,n,n.byteLength,s,0),s+=n.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((n,a)=>{(0,p.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(l,c,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(l,c,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(l,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(l,c,t,s,r,n){let a=0;for(;a<s;)a+=await l.write(c,r+a,t.buffer,n+a,s-a)}async doWriteUnbuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,s))}async doWriteUnbufferedQueued(l,c,t,s){let r;s instanceof P.VSBuffer?r=s:(0,p.isReadableStream)(s)?r=await(0,P.streamToBuffer)(s):(0,p.isReadableBufferedStream)(s)?r=await(0,P.bufferedStreamToBuffer)(s):r=(0,P.readableToBuffer)(s),await l.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,s))}async doPipeBufferedQueued(l,c,t,s){let r,n;try{r=await l.open(c,{create:!1}),n=await t.open(s,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,g=0;do g=await l.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,n,a,g,o,u),o+=g,u+=g,u===a.byteLength&&(u=0);while(g>0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await T.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof n=="number"?t.close(n):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,s))}async doPipeUnbufferedQueued(l,c,t,s){return t.writeFile(s,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,s))}async doPipeUnbufferedToBufferedQueued(l,c,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const n=await l.readFile(c);await this.doWriteBuffer(t,r,P.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,w.ensureFileSystemProviderError)(n)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(l,c,t,s){const r=await(0,P.streamToBuffer)(this.readFileBuffered(l,c,R.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new w.FileOperationError((0,h.localize)(22,null,this.resourceForError(c)),6);return l}throwIfFileIsReadonly(l,c){if((c.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===i.Schemas.file?l.fsPath:l.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([J(0,m.ILogService)],v),e.FileService=v}),define(te[182],ne([0,1,51,249,5,19,3,42,9,4,18,50,20,142,14,83,168,169,170,179,38]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(k)}catch(t){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(t)}`)}})();class c extends d.AbstractDiskFileSystemProvider{constructor(s,r){super(s);this.options=r,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:r,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(r,n),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(s){try{const r=await f.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(r.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,i.joinPath)(s,a.name))).type:o=this.toType(a),n.push([a.name,o])}catch(o){this.logService.trace(o)}})),n}catch(r){throw this.toFileSystemProviderError(r)}}toType(s,r){let n;return r?.dangling?n=h.FileType.Unknown:s.isFile()?n=h.FileType.File:s.isDirectory()?n=h.FileType.Directory:n=h.FileType.Unknown,r&&(n|=h.FileType.SymbolicLink),n}async readFile(s){try{const r=this.toFilePath(s);return await f.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(s,r,n){const a=(0,E.newWriteableStream)(o=>R.VSBuffer.concat(o.map(u=>R.VSBuffer.wrap(u))).buffer);return(0,w.readFileIntoStream)(this,s,a,o=>o.buffer,{...r,bufferSize:256*1024},n),a}async writeFile(s,r,n){let a;try{const o=this.toFilePath(s);if(!n.create||!n.overwrite){if(await f.Promises.exists(o)){if(!n.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:n.unlock}),await this.write(a,0,r,0,r.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(s,o)}finally{typeof a=="number"&&await this.close(a)}}async open(s,r){try{const n=this.toFilePath(s);if((0,h.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(n);u.mode&128||await f.Promises.chmod(n,u.mode|128)}catch(u){this.logService.trace(u)}let a;if((0,h.isFileOpenForWriteOptions)(r)){if(I.isWindows)try{await f.Promises.truncate(n,0),a="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}a||(a="w")}else a="r";const o=await f.Promises.open(n,a);return this.mapHandleToPos.set(o,0),(0,h.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(o,s),o}catch(n){throw(0,h.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(s,n):this.toFileSystemProviderError(n)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await f.Promises.fdatasync(s)}catch(r){this.canFlush=!1,this.logService.error(r)}return await f.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}}async read(s,r,n,a,o){const u=this.normalizePos(s,r);let g=null;try{const b=await f.Promises.read(s,n,a,o,u);return typeof b=="number"?g=b:g=b.bytesRead,g}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(s,u,g)}}normalizePos(s,r){return r===this.mapHandleToPos.get(s)?null:r}updatePos(s,r,n){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof r=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,a+n):this.mapHandleToPos.delete(s)))}async write(s,r,n,a,o){return(0,P.retry)(()=>this.doWrite(s,r,n,a,o),100,3)}async doWrite(s,r,n,a,o){const u=this.normalizePos(s,r);let g=null;try{const b=await f.Promises.write(s,n,a,o,u);return typeof b=="number"?g=b:g=b.bytesWritten,g}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),b)}finally{this.updatePos(s,u,g)}}async mkdir(s){try{await f.Promises.mkdir(this.toFilePath(s))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(s,r){try{const n=this.toFilePath(s);await this.doDelete(n,r)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(s,r){r.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}async rename(s,r,n){const a=this.toFilePath(s),o=this.toFilePath(r);if(a!==o)try{await this.validateTargetDeleted(s,r,"move",n.overwrite),await f.Promises.move(a,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,S.basename)(a),(0,S.basename)((0,S.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,r,n){const a=this.toFilePath(s),o=this.toFilePath(r);if(a!==o)try{await this.validateTargetDeleted(s,r,"copy",n.overwrite),await f.Promises.copy(a,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,S.basename)(a),(0,S.basename)((0,S.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,r,n,a){const o=this.toFilePath(s),u=this.toFilePath(r);let g=!1;if(!!(this.capabilities&1024)||(g=(0,C.isEqual)(o,u,!0)),g&&n==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await f.Promises.exists(u)){if(!a)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,r,n,a){let o,u=!1;return this.options?.watcher?.usePolling?u=!1:u=this.options?.legacyWatcher==="on",u?o=m.FileWatcher:o=v.FileWatcher,new o(g=>r(g),g=>n(g),a,this.options?.watcher)}doWatch(s,r){const n=this.options?.watcher?.usePolling;if(n===!0)for(const a of r)a.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const a of r)n.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,r)}createNonRecursiveWatcher(s,r,n,a){return new y.FileWatcher(s,o=>r(o),o=>n(o),a)}toFileSystemProviderError(s){if(s instanceof h.FileSystemProviderError)return s;let r;switch(s.code){case"ENOENT":r=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=h.FileSystemProviderErrorCode.NoPermissions;break;default:r=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(s,r)}async toFileSystemProviderWriteError(s,r){let n=this.toFileSystemProviderError(r);if(s&&n.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await f.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(n=(0,h.createFileSystemProviderError)(r,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return n}}e.DiskFileSystemProvider=c}),define(te[86],ne([0,1,3,8,10]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=R;class D{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){D.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=D;class C{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"createLogger":this.createLogger(T.URI.revive(h[0]),h[1]);return;case"log":return this.log(T.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let h=console.log;switch(f){case P.LogLevel.Error:h=console.error;break;case P.LogLevel.Warning:h=console.warn;break;case P.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(f,p){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[w,y]of p)switch(w){case P.LogLevel.Trace:h.trace(y);break;case P.LogLevel.Debug:h.debug(y);break;case P.LogLevel.Info:h.info(y);break;case P.LogLevel.Warning:h.warn(y);break;case P.LogLevel.Error:h.error(y);break;case P.LogLevel.Critical:h.critical(y);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class S extends P.AbstractLoggerService{constructor(f,p,h){super(f,p);this.channel=h}createConsoleMainLogger(){return new P.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,h){return new I(this.channel,f,p,h)}}e.LoggerChannelClient=S;class I extends P.AbstractMessageLogger{constructor(f,p,h,w){super(w?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const h=[[f,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class i extends P.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=i}),define(te[61],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[87],ne([0,1,15,4,31,18]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const C=T.globals.vscode.context.configuration();if(C)D=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const C=(0,R.dirname)(k.FileAccess.asFileUri("",X));D=X.__$__nodeRequire((0,R.joinPath)(C,"product.json").fsPath);const S=X.__$__nodeRequire((0,R.joinPath)(C,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:S.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=D}),define(te[27],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService")}),define(te[183],ne([0,1,5,7,2,9,20,10,27]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends P.Disposable{constructor(E,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,R.dirname)(E),h=(0,R.basename)(E),w=await D.Promises.readdir(p);await Promise.all(w.map(async y=>{if(y===h)return;const m=(0,R.join)(p,y),v=await D.Promises.stat(m);if(v.isDirectory()&&f-v.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),D.Promises.rm(m)}))}catch(f){(0,T.onUnexpectedError)(f)}}};I=he([J(1,S.IProductService),J(2,C.ILogService)],I),e.CodeCacheCleaner=I}),define(te[184],ne([0,1,5,7,2,9,20,11,10,27]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends P.Disposable{constructor(f,p,h){super();this.environmentService=f,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await D.Promises.readFile((0,R.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(p)){const d=p[v];f[`${d.hash}.${v}`]=!0}const h=(0,R.join)(this.environmentService.userDataPath,"clp");if(!await D.Promises.exists(h))return;const y=await D.Promises.readdir(h);for(const v of y){if(f[v]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await D.Promises.rm((0,R.join)(h,v))}const m=Date.now();for(const v of Object.keys(f)){const d=(0,R.join)(h,v),l=await D.Promises.readdir(d);for(const c of l){if(c==="tcf.json")continue;const t=(0,R.join)(d,c),s=await D.Promises.stat(t);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,R.join)(v,c)}`),await D.Promises.rm(t))}}}catch(f){(0,T.onUnexpectedError)(f)}}};i=he([J(0,C.INativeEnvironmentService),J(1,S.ILogService),J(2,I.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[35],ne([0,1,101,17]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(D,C){k.ok(T.isString(D)),k.ok(T.isObject(C)),k.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,C)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new P}),define(te[88],ne([0,1,3,35]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,I){this.schemasById[P(S)]=I,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;T.Registry.add(e.Extensions.JSONContribution,D)}),define(te[39],ne([0,1,16,3,17,128,88,35]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=C.Registry.as(D.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(d,l=!0){this.registerConfigurations([d],l)}registerConfigurations(d,l=!0){const c=this.doRegisterConfigurations(d,l);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(d){const l=this.doDeregisterConfigurations(d);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:d,remove:l}){const c=[];c.push(...this.doDeregisterConfigurations(l)),c.push(...this.doRegisterConfigurations(d,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,k.distinct)(c))}registerDefaultConfigurations(d){const l=[],c=[];for(const t of d)for(const s in t)if(l.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const r={type:"object",default:this.defaultValues[s],description:R.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(p(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=t[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(d){const l=[];for(const c of d)for(const t in c)if(l.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const l of d)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,l){const c=[];return d.forEach(t=>{c.push(...this.validateAndRegisterProperties(t,l,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),c}doDeregisterConfigurations(d){const l=[],c=t=>{if(t.properties)for(const s in t.properties)l.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>c(s))};for(const t of d){c(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return l}validateAndRegisterProperties(d,l=!0,c,t=3){t=P.isUndefinedOrNull(d.scope)?t:d.scope;let s=[],r=d.properties;if(r)for(let a in r){if(l&&y(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=P.isUndefinedOrNull(o.scope)?t:o.scope,o.restricted=P.isUndefinedOrNull(o.restricted)?!!c?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let n=d.allOf;if(n)for(let a of n)s.push(...this.validateAndRegisterProperties(a,l,c,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(d){const l=c=>{let t=c.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let s=c.allOf;s&&s.forEach(l)};l(d)}updateSchema(d,l){switch(e.allSettings.properties[d]=l,l.scope){case 1:e.applicationSettings.properties[d]=l;break;case 2:e.machineSettings.properties[d]=l;break;case 6:e.machineOverridableSettings.properties[d]=l;break;case 3:e.windowSettings.properties[d]=l;break;case 4:e.resourceSettings.properties[d]=l;break;case 5:e.resourceSettings.properties[d]=l,this.resourceLanguageSettingsSchema.properties[d]=l;break}}removeFromSchema(d,l){switch(delete e.allSettings.properties[d],l.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const l=`[${d}]`,c={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,l){let c=this.defaultValues[d];P.isUndefined(c)&&(c=l.default),P.isUndefined(c)&&(c=h(l.type)),l.default=c}}const f="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function p(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=p;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new E;C.Registry.add(e.Extensions.Configuration,w);function y(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?R.localize(5,null,v):w.getConfigurationProperties()[v]!==void 0?R.localize(6,null,v):null:R.localize(4,null)}e.validateProperty=y;function m(){const v=[],d=w.getConfigurationProperties();for(const l of Object.keys(d))v.push([l,d[l].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=m}),define(te[21],ne([0,1,26,17,8,39,6,35]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationOverrides=S;var I;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function E(s,r){const n=r?s?r.keys.filter(U=>s.keys.indexOf(U)===-1):[...r.keys]:[],a=s?r?s.keys.filter(U=>r.keys.indexOf(U)===-1):[...s.keys]:[],o=[];if(r&&s){for(const U of s.keys)if(r.keys.indexOf(U)!==-1){const O=m(s.contents,U),q=m(r.contents,U);k.equals(O,q)||o.push(U)}}const u=[],g=U=>{const O={};for(const q of U)for(const N of q.identifiers)O[c(N)]=q;return O},b=r?g(r.overrides):{},A=s?g(s.overrides):{};if(Object.keys(b).length)for(const U of n){const O=b[U];O&&u.push([(0,R.overrideIdentifierFromKey)(U),O.keys])}if(Object.keys(A).length)for(const U of a){const O=A[U];O&&u.push([(0,R.overrideIdentifierFromKey)(U),O.keys])}if(Object.keys(b).length&&Object.keys(A).length)for(const U of o){const O=A[U],q=b[U];if(O&&q){const N=E({contents:O.contents,keys:O.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(U),[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:a,updated:o,overrides:u}}e.compare=E;function f(s,r){const n=[];for(const a of Object.keys(s))if(R.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];n.push({identifiers:[(0,R.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:p(o,r)})}return n}e.toOverrides=f;function p(s,r){const n=Object.create(null);for(let a in s)h(n,a,s[a],r);return n}e.toValuesTree=p;function h(s,r,n,a){const o=r.split("."),u=o.pop();let g=s;for(let b=0;b<o.length;b++){let A=o[b],U=g[A];switch(typeof U){case"undefined":U=g[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,b+1).join(".")} is ${JSON.stringify(U)}`);return}g=U}if(typeof g=="object"&&g!==null)try{g[u]=n}catch(b){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(g)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function w(s,r){const n=r.split(".");y(s,n)}e.removeFromValueTree=w;function y(s,r){const n=r.shift();if(r.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const a=s[n];typeof a=="object"&&!Array.isArray(a)&&(y(a,r),Object.keys(a).length===0&&delete s[n])}}function m(s,r,n){function a(g,b){let A=g;for(const U of b){if(typeof A!="object"||A===null)return;A=A[U]}return A}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?n:u}e.getConfigurationValue=m;function v(s,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?T.isObject(s[a])&&T.isObject(r[a])?v(s[a],r[a],n):n&&(s[a]=r[a]):s[a]=r[a])})}e.merge=v;function d(){const s=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function l(){const s=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let n in r){let a=r[n].default;h(s,n,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=l;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function t(s,r,n){const a=s.inspect(r),o=s.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=t}),define(te[89],ne([0,1,16,3,32,2,41,26,17,8,21,39,35]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,i.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(g=>k.equals(g.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(C.deepClone(o))}for(const o of a.keys)n.indexOf(o)===-1&&n.push(o)}return new p(s,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[n],o=s[n];o&&(typeof a=="object"&&typeof o=="object"?(a=C.deepClone(a),this.mergeContents(a,o)):a=o),r[n]=a}return new p(r,this.keys,this.overrides)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=C.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,r)}}e.DefaultConfigurationModel=h;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:n,overrides:a,restricted:o}=this.doParseRaw(t,s);this._configurationModel=new p(r,n,a),this._restrictedConfigurations=o||[]}doParseContent(t){let s={},r=null,n=[],a=[],o=[];function u(b){Array.isArray(n)?n.push(b):r!==null&&(n[r]=b)}let g={onObjectBegin:()=>{let b={};u(b),a.push(n),n=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let b=[];u(b),a.push(n),n=b,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:u,onError:(b,A,U)=>{o.push({error:b,offset:A,length:U})}};if(t)try{P.visit(t,g),s=n[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return s}doParseRaw(t,s){const r=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,s);t=n.raw;const a=(0,i.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),o=Object.keys(t),u=(0,i.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:a,keys:o,overrides:u,restricted:n.restricted}}filter(t,s,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},o=[];for(let u in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const g=this.filter(t[u],s,!1,n);a[u]=g.raw,o.push(...g.restricted)}else{const g=s[u],b=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&o.push(u),(b===void 0||n.scopes===void 0||n.scopes.includes(b))&&(n.skipRestricted&&g?.restricted||(a[u]=t[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=w;class y extends R.Disposable{constructor(t,s,r,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class m{constructor(t,s,r=new p,n=new p,a=new D.ResourceMap,o=new p,u=new D.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new p,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const n=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,q=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(t):o.getValue(t),N=n.getValue(t),L=k.distinct(k.flatten(n.overrides.map($=>$.identifiers))).filter($=>n.getOverrideValue(t,$)!==void 0);return{defaultValue:u,userValue:g,userLocalValue:b,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:O,memoryValue:q,value:N,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:o.getValue(t),override:s.overrideIdentifier?o.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(n=>E.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,E.overrideIdentifierFromKey)(n),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),g=[...u.filter(b=>o.indexOf(b)===-1),...o.filter(b=>u.indexOf(b)===-1),...o.filter(b=>!C.equals(this._defaultConfiguration.override(a).getValue(b),t.override(a).getValue(b)))];return[a,g]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,i.compare)(this.localUserConfiguration,t),o=[...s,...r,...n];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,t);let o=[...s,...r,...n];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,i.compare)(this.workspaceConfiguration,t);let o=[...s,...r,...n];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:n,updated:a,removed:o,overrides:u}=(0,i.compare)(r,s);let g=[...n,...a,...o];return(g.length||!r)&&this.updateFolderConfiguration(t,s),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:a,overrides:o}=(0,i.compare)(s,void 0);return{keys:[...r,...n,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=r.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((o,u)=>(o.set(I.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new D.ResourceMap);return new m(s,r,new p,n,a,new p,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function v(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,s=new Map;for(const n of c)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,o])=>{const u=(0,D.getOrSet)(s,a,new Set);o.forEach(g=>u.add(g))});const r=[];return s.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=v;class d{constructor(t,s,r,n){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(g=>a.add(g))),this.affectedKeys=[...a.values()];const o=new p;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!C.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,i.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,s,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=l}),define(te[185],ne([0,1,5,3,2,18,21,89,39,35]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends P.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,p)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const h=typeof f=="string"?f:void 0,w=(0,D.isConfigurationOverrides)(f)?f:(0,D.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,w,void 0)}updateValue(f,p,h,w){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,f);this.trigger(h,p,6)}trigger(f,p,h){const w=new C.ConfigurationChangeEvent(f,{data:p},this.configuration);w.source=h,w.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[186],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(D,C=T.Unknown,S){super(D);this._message=D,this._code=C,this._detail=S,this.isHandled=C===T.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===T.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===T.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}}e.RemoteAuthorityResolverError=P}),define(te[187],ne([0,1,5,19,28,7,3,2,29,72,186]),function(X,e,k,T,P,R,D,C,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const B=new P.CancellationTokenSource;return setTimeout(()=>B.cancel(),F),B.token}function w(F,B){if(F.isCancellationRequested||B.isCancellationRequested)return P.CancellationToken.Cancelled;const V=new P.CancellationTokenSource;return F.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class y{constructor(B){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function m(F,B){const V=new y(B);return V.registerDisposable(F.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=j(Z);G?V.reject(G):V.resolve(Z)})),V.promise}function v(F,B,V,Q,Z,G){const H=new y(G);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&F.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function d(F,B){const V=new y(B);return F.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function l(F,B,V,Q){const Z=z(F,B);F.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await v(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw F.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),F.logService.error(le),le}F.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(G,null),H=F.reconnectionProtocol,re=!1):(H=new I.PersistentProtocol(G,null),re=!0),F.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await d(F.signService.createNewMessage((0,S.generateUuid)()),Q),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(T.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await m(H,w(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(F.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await d(F.signService.validate(ie,le.signedData),Q)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await d(F.signService.sign(le.data),Q),be={type:"connectionType",commit:F.commit,signedData:fe,desiredConnectionType:B};return V&&(be.args=V),F.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(T.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(F.logService.error(`${Z} the handshake timed out. Error:`),F.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Z} received error control message when negotiating connection. Error:`),F.logService.error(le)),re&&M(H),le}}async function c(F,B,V,Q){const Z=Date.now(),G=z(F,B),{protocol:H,ownsProtocol:re}=await l(F,B,V,Q),ie=new y(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=j(le);de?(F.logService.error(`${G} received error control message when negotiating connection. Error:`),F.logService.error(de),re&&M(H),ie.reject(de)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function t(F,B){const{protocol:V}=await c(F,1,void 0,B);return{protocol:V}}async function s(F,B,V){const{protocol:Q,firstMessage:Z}=await c(F,2,B,V),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function r(F,B,V){const Q=Date.now(),Z=z(F,3),{protocol:G}=await l(F,3,B,V);return F.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function n(F,B,V){const{host:Q,port:Z,connectionToken:G}=await F.addressProvider.getAddress();return{commit:F.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:V,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function a(F,B,V){try{const Q=(0,S.generateUuid)(),Z=await n(F,Q,null),{protocol:G}=await t(Z,P.CancellationToken.None);return new $(F,B,V,Q,G)}catch(Q){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(Q),L.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=a;async function o(F,B){try{const V=(0,S.generateUuid)(),Q=await n(F,V,null),{protocol:Z,debugPort:G}=await s(Q,B,P.CancellationToken.None);return new _(F,B,V,Z,G)}catch(V){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(V),L.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=o;async function u(F,B,V){const Q=await n(F,(0,S.generateUuid)(),null);return await r(Q,{host:B,port:V},P.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function g(F){return(0,k.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,F*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var b;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(b=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=A;class U{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class O{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class q{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=q;class N{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class L extends C.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new q(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=x(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const B=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=g(Z);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(L._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(E)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,R.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,i.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,B,V,Q)),M(this.protocol)}}L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class $ extends L{constructor(B,V,Q,Z,G){super(1,B,Z,G);this.client=this._register(new I.Client(G,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await t(B,V)}}e.ManagementPersistentConnection=$;class _ extends L{constructor(B,V,Q,Z,G){super(2,B,Q,Z);this._startArguments=V,this.debugPort=G}async _reconnect(B,V){await s(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=_;function M(F){try{F.acceptDisconnect();const B=F.getSocket();F.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function j(F){if(F&&F.type==="error"){const B=new Error(`Connection error: ${F.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function W(F,B){for(;F.length<B;)F+=" ";return F}function x(F,B,V){return`[remote-connection][${W(p(F),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function z(F,B){return`${x(B,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function K(F){return`${Date.now()-F} ms`}}),define(te[188],ne([0,1,15]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(I){return I.scheme===k.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=T;function P(I){if(!I)return;const i=I.indexOf("+");return i<0?I:I.substr(0,i)}e.getRemoteName=P;function R(I){return I.scheme!==k.Schemas.file&&I.scheme!==k.Schemas.vscodeRemote}e.isVirtualResource=R;function D(I){if(I.folders.length)return I.folders.every(i=>R(i.uri))?I.folders[0].uri:void 0;if(I.configuration&&R(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=D;function C(I){return D(I)?.scheme}e.getVirtualWorkspaceScheme=C;function S(I){return D(I)!==void 0}e.isVirtualWorkspace=S}),define(te[90],ne([0,1,25,6,188]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class S{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,y=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(w,y)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=S;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function i(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function E(f,p){if(p&&f.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,P.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,90]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,k.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=P;class R{constructor(w,y){this.version=y,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof R?P(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=R;function D(h,w){return`${h}.${w}`}e.getExtensionId=D;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(h,w){return C(D(h,w))}e.getGalleryExtensionId=S;function I(h,w){const y=[],m=v=>{for(const d of y)if(d.some(l=>P(w(l),w(v))))return d;return null};for(const v of h){const d=m(v);d?d.push(v):y.push([v])}return y}e.groupByExtension=I;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(h){const w=new Set;for(const y of h)y.malicious&&w.add(y.id.id);return w}e.getMaliciousExtensionsSet=f;function p(h,w){const y=[],m=w.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const v=m.shift();if(v&&y.every(d=>!P(d.identifier,{id:v}))){const d=h.filter(l=>P(l.identifier,{id:v}));d.length===1&&(y.push(d[0]),m.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(te[189],ne([0,1,5,7,2,4,18,62,8,29,20,11,30,36,14,10]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends P.Disposable{constructor(d,l,c,t){super();this.fileService=l,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=S.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,l){await this.cleanUpPromise;const c=this.getName(d),t=(0,D.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const s=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(d,s,l);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(n){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return t}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,l,c){try{await i.Promises.rename(d.fsPath,l.fsPath)}catch(t){if(R.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${d} to ${l} with 'EPERM' error. Trying again...`),this.rename(d,l,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const l=[],c=[];for(const r of d.children){const n=this.parse(r.name);n&&c.push([n,r])}const t=(0,p.groupByExtension)(c,([r])=>r),s=[];for(const r of t)r.sort((n,a)=>C.rcompare(n[0].version,a[0].version)),l.push(...r.slice(1).map(n=>n[1].resource)),s.push(r[0][1]);s.sort((r,n)=>r.mtime-n.mtime),l.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?`${new p.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase()}${d.properties.targetPlatform!=="undefined"?`-${d.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(d){const l=y.exec(d);return l&&l[1]&&l[2]?new p.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};m=he([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,w.ILogService)],m),e.ExtensionsDownloader=m}),define(te[190],ne([0,1,2,9,20,90]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends k.Disposable{constructor(S,I){super();this.environmentService=S,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(I.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(S){S.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(te[191],ne([0,1,82,16,5,2,15,9,20,11,30,36,60,10]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(m,v,d){super();this.extensionManagementService=m,this.logService=d,this.cache=this._register(new w(v,d)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),v=["en",...Object.keys(m)];return(0,T.distinct)(v)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const v=await this.cache.getLanguagePacks();Object.keys(v).some(d=>v[d]&&v[d].extensions.some(l=>(0,E.areSameExtensions)(l.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(v);return!(0,T.equals)(Object.keys(m),Object.keys(d))}};h=he([J(0,i.IExtensionManagementService),J(1,I.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let w=class extends R.Disposable{constructor(m,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(v=>{Object.keys(v).forEach(d=>delete v[d]),this.createLanguagePacksFromExtensions(v,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...v){for(const d of v)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,d);Object.keys(m).forEach(d=>this.updateHash(m[d]))}createLanguagePacksFromExtension(m,v){const d=v.identifier,l=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const c of l)if(v.location.scheme===D.Schemas.file&&(0,f.isValidLocalization)(c)){let t=m[c.languageId];t||(t={hash:"",extensions:[],translations:{}},m[c.languageId]=t);let s=t.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,d))[0];s?s.version=v.manifest.version:t.extensions.push({extensionIdentifier:d,version:v.manifest.version});for(const r of c.translations)t.translations[r.id]=(0,C.join)(v.location.fsPath,r.path)}}updateHash(m){if(m){const v=(0,k.createHash)("md5");for(const d of m.extensions)v.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);m.hash=v.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch(l){return{}}}).then(d=>(v=m(d),d)).then(d=>{for(const c of Object.keys(d))d[c]||delete d[c];this.languagePacks=d,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),S.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>v,d=>this.logService.error(d))})}};w=he([J(0,I.INativeEnvironmentService),J(1,p.ILogService)],w)}),define(te[192],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[63],ne([0,1,3,4,6,10]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function f(h,w){return w?w!==1&&h<1024:!T.isWindows&&h<1024}e.isPortPrivileged=f;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,y){return this._tunnelProvider=w,w?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],y=Array.from(this._tunnels.values());for(let m of y){const v=Array.from(m.values());for(let d of v){const l=await d.value;l&&w.push(l)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:y}of w.values())await y.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,y,m,v,d=!1,l=C.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${m} on local port ${v}.`),!w)return;y||(y="localhost");const t=this.retainOrCreateTunnel(w,y,m,v,d,l,c);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==y||s.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const y=this._tunnels.get(w.tunnelRemoteHost);if(y){const m=y.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,y,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${y}.`);const v=m.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(y),v}}async closeTunnel(w,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${y} `);const m=this._tunnels.get(w);if(m&&m.has(y)){const v=m.get(y);v.refcount=0,await this.tryDisposeTunnel(w,y,v)}}addTunnelToMap(w,y,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(y,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,y){const m=this._tunnels.get(w);m&&(await m.get(y)||m.delete(y),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,y){let m=[w];i(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const v=m.map(d=>this._tunnels.get(d));for(const d of v){const l=d?.get(y);if(l)return l}}canTunnel(w){return!!I(w)}createWithProvider(w,y,m,v,d,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${m} on local port ${v}.`);const s={elevationRequired:d?f(v===void 0?m:v):!1},r={remoteAddress:{host:y,port:m},localAddressPort:v,privacy:l,public:l!==C.Private,protocol:c},n=w.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(y,m,n),n}};p=he([J(0,R.ILogService)],p),e.AbstractTunnelService=p}),define(te[193],ne([0,1,10,63,2,7,5]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends P.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new D.DeferredPromise),this._addressPromise.p)}setAddress(i){this._address=i,this._addressPromise&&(this._addressPromise.complete(i),this._addressPromise=null)}setTunnel(i){this._register(i)}}let S=class It extends P.Disposable{constructor(i,E){super();this._tunnelService=i,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(i=>i.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(i,E,f,p,h,w){const y=new C,m=await Promise.resolve(this._tunnelService.openTunnel(i,y,f,p,h,w));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),y.dispose(),await m.dispose(),(0,R.canceled)();return y.setTunnel(m),this._tunnels.set(E,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(i,E){const f=this._tunnels.get(i);!f||f.setAddress(E)}async destroyTunnel(i){const E=this._tunnels.get(i);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${i}.`),this._tunnels.delete(i),await E.dispose();return}this._disposedTunnels.add(i)}};S._lastId=0,S=he([J(0,T.ISharedTunnelsService),J(1,k.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[194],ne([0,1,122,21,10]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(C,S){this.configurationService=C,this.logService=S}request(C,S){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(C,S)}async resolveProxy(C){}};R=he([J(0,T.IConfigurationService),J(1,P.ILogService)],R),e.RequestService=R}),define(te[44],ne([0,1,19,143,39,6,35]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=C;function S(h){return h.res.statusCode===204}async function I(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,k.streamToBuffer)(h.stream)).toString()}e.asText=I;async function i(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const y=(await(0,k.streamToBuffer)(h.stream)).toString();try{return JSON.parse(y)}catch(m){throw m.message+=`:
`+y,m}}e.asJson=i;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let f;function p(h){const w=D.Registry.as(P.Extensions.Configuration),y=f;f={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[f],remove:y?[y]:[]})}p(2)}),define(te[195],ne([0,1,28,15,14,44]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(S,I){this.requestService=S,this.fileService=I}async download(S,I,i=k.CancellationToken.None){if(S.scheme===T.Schemas.file||S.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(S,I);return}const E={type:"GET",url:S.toString()},f=await this.requestService.request(E,i);if(f.res.statusCode===200)await this.fileService.writeFile(I,f.stream);else{const p=await(0,R.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};D=he([J(0,R.IRequestService),J(1,P.IFileService)],D),e.DownloadService=D}),define(te[196],ne([0,1,16,28,67,2,18,157,14,10,27,44]),function(X,e,k,T,P,R,D,C,S,I,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends R.Disposable{constructor(h,w,y,m){super();this.fileService=h,this.productService=w,this.requestService=y,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const w=[];for(const[y,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,D.joinPath)(h,y)),d=new Map;(0,P.forEach)(m.recommendations,({key:c,value:t})=>{if((0,k.isNonEmptyArray)(t.remotes))for(const s of t.remotes)d.set(s,{extensionId:c,extensionName:t.name,configName:m.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else w.push({extensionId:c,extensionName:t.name,configName:m.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const l=(0,C.getDomainsOfRemotes)(v.value.toString(),[...d.keys()]);for(const c of l){const t=d.get(c);t&&w.push(t)}}catch(v){}return w}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(h.res.statusCode!==200)return[];const w=await(0,E.asJson)(h);return w?w.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=he([J(0,S.IFileService),J(1,i.IProductService),J(2,E.IRequestService),J(3,I.ILogService)],f),e.ExtensionTipsService=f}),define(te[46],ne([0,1,19,29]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(R,D,C){let S=C&&C.get("storage.serviceMachineId",0)||null;if(S)return S;try{const i=(await D.readFile(R.serviceMachineIdResource)).value.toString();S=(0,T.isUUID)(i)?i:null}catch(I){S=null}if(!S){S=(0,T.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,k.VSBuffer.fromString(S))}catch(I){}}return C&&C.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=P}),define(te[91],ne([0,1,106,6]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function P(R){return(0,k.hash)({moduleId:R.process.moduleId,windowId:R.reply.windowId})}e.hash=P,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[197],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[198],ne([0,1,73,155,28,3,2,15,4,29,11,10,27,91,197]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(v,d,l){this.logService=v,this.productService=d,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const d=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const l=(0,p.hash)(v);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(v));const c=new P.CancellationTokenSource;let t,s,r;this.processeDisposables.set(l,u=>{c.dispose(!0),t?.terminate(v,P.CancellationToken.None),s?.close(),r?.close(),this.processeDisposables.delete(l);const g=this.processResolvers.get(l);g&&(this.processResolvers.delete(l),g({reason:u}))}),t=await this.getOrCreateWebWorker(v);const n=new Promise(u=>{this.processResolvers.set(l,u)});if(c.token.isCancellationRequested)return n;const{port1:a,port2:o}=new MessageChannel;return s=a,r=o,await t.spawn(v,r,c.token),c.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[s])),n}getOrCreateWebWorker(v){let d=this.workers.get(v.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const l=new y(v.process.type,this.logService,this.productService,this.environmentService);d=l.init(),l.onDidProcessSelfTerminate(({configuration:c,reason:t})=>{this.doDisposeWorker(c,t)}),this.workers.set(v.process.moduleId,d)}return d}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,d){const l=this.processeDisposables.get((0,p.hash)(v));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),l(d))}};w=he([J(0,E.ILogService),J(1,f.IProductService),J(2,i.INativeEnvironmentService)],w),e.SharedProcessWorkerService=w;class y extends D.Disposable{constructor(v,d,l,c){super();this.type=v,this.logService=d,this.productService=l,this.environmentService=c,this._onDidProcessSelfTerminate=this._register(new R.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let v;const d=new Promise(c=>v=c),l=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return l.onerror=c=>{this.logService.error(`SharedProcess: worker error (${this.type})`,c.message)},l.onmessageerror=c=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,c)},l.onmessage=c=>{const{id:t,message:s,configuration:r,nonce:n}=c.data;switch(t){case h.SharedProcessWorkerMessages.Ready:v(l);break;case h.SharedProcessWorkerMessages.Ack:if(n){const a=this.mapMessageNonceToPendingMessageResolve.get(n);a&&(this.mapMessageNonceToPendingMessageResolve.delete(n),a())}break;case h.SharedProcessWorkerMessages.SelfTerminated:r&&s&&this._onDidProcessSelfTerminate.fire({configuration:r,reason:JSON.parse(s)});break;case h.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Info:s&&this.logService.info(s);break;case h.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,s);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,c)}},l.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),d}async send(v,d,l){const c=await this.workerReady;if(!d.isCancellationRequested)return new Promise(t=>{const s=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(s,t);const r={...v,nonce:s};l?c.postMessage(r,[l]):c.postMessage(r),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(s)&&t()})})}spawn(v,d,l){const c={id:h.SharedProcessWorkerMessages.Spawn,configuration:v,environment:this.getSharedProcessWorkerEnvironment()};return this.send(c,l,d)}getSharedProcessWorkerEnvironment(){const v={bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,env:Object.create(null)};if(S.isLinux){const d={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],c=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&c&&l&&(0,I.isUUID)(l)){const r=c["linux-x64"];d.submitURL=r.concat("&uid=",l,"&iid=",l,"&sid=",l),d.uploadToServer=!0}const s=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;v.env.BREAKPAD_DUMP_LOCATION=(0,T.join)(s,this.type),v.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(d)}return v}terminate(v,d){const l={id:h.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(l,d)}}}),define(te[92],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[199],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((P,R)=>X(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.vsda(),D=new R.validator;if(D){const C=String(k._nextId++);return this.validators.set(C,D),{id:C,data:D.createNewMessage(P)}}}catch(R){}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const D=this.validators.get(P.id);if(!D)return!1;this.validators.delete(P.id);try{return D.validate(R)==="ok"}catch(C){return!1}}async sign(P){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(P)}catch(R){}return P}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,181,17,74,6]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var i;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends P.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,v){v===I?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:v,target:this.getKeyTargets(m)[v]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,v,d){return this.getStorage(v)?.get(m,d)}getBoolean(m,v,d){return this.getStorage(v)?.getBoolean(m,d)}getNumber(m,v,d){return this.getStorage(v)?.getNumber(m,d)}store(m,v,d,l){if((0,D.isUndefinedOrNull)(v)){this.remove(m,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,d,l),this.getStorage(d)?.set(m,v)})}remove(m,v){this.withPausedEmitters(()=>{this.updateKeyTarget(m,v,void 0),this.getStorage(v)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,v){const d=[],l=this.getKeyTargets(m);for(const c of Object.keys(l))l[c]===v&&d.push(c);return d}updateKeyTarget(m,v,d){const l=this.getKeyTargets(v);typeof d=="number"?l[m]!==d&&(l[m]=d,this.getStorage(v)?.set(I,JSON.stringify(l))):typeof l[m]=="number"&&(delete l[m],this.getStorage(v)?.set(I,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const v=this.get(I,m);if(v)try{return JSON.parse(v)}catch(d){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=i.NONE){this._onWillSaveState.fire({reason:m}),await k.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const m=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return w(m,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function w(y,m,v,d){const l=o=>{try{return JSON.parse(o)}catch(u){return o}},c=new Map,t=new Map;y.forEach((o,u)=>{c.set(u,o),t.set(u,l(o))});const s=new Map,r=new Map;m.forEach((o,u)=>{s.set(u,o),r.set(u,l(o))}),console.group(`Storage: Global (path: ${v})`);let n=[];c.forEach((o,u)=>{n.push({key:u,value:o})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${d})`);let a=[];s.forEach((o,u)=>{a.push({key:u,value:o})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=w}),define(te[200],ne([0,1,3,2,17,30,36,23]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends T.Disposable{constructor(E){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(E)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(p=>!(0,D.areSameExtensions)(p,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const h=f[p];if((0,D.areSameExtensions)(h,E))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};S=he([J(0,C.IStorageService)],S),e.GlobalExtensionEnablementService=S;class I extends T.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let p;return f===0?((0,P.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),p=this.storage[E]):p=this._get(E,f),JSON.parse(p)}set(E,f,p){let h=JSON.stringify(f.map(({id:y,uuid:m})=>({id:y,uuid:m})));this._get(E,p)!==h&&(p===0&&(f.length?this.storage[E]=h:delete this.storage[E]),this._set(E,f.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),w=p.filter(m=>!h.some(v=>(0,D.areSameExtensions)(m,v))),y=h.filter(m=>!p.some(v=>(0,D.areSameExtensions)(v,m)));(w.length||y.length)&&this._onDidChange.fire([...w,...y])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,p){f?this.storageService.store(E,f,p,1):this.storageService.remove(E,p)}}e.StorageManager=I}),define(te[201],ne([0,1,3,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends T.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i}async getItems(){const I={workspace:this.workspace},i=await this.channel.call("getItems",I);return new Map(i)}updateItems(I){const i={workspace:this.workspace};return I.insert&&(i.insert=Array.from(I.insert.entries())),I.delete&&(i.delete=Array.from(I.delete.values())),this.channel.call("updateItems",i)}}class R extends P{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class D extends P{constructor(I,i){super(I,i);this.onDidChangeItemsExternal=k.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class C extends T.Disposable{constructor(I,i){super();this.channel=I,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new D(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[202],ne([0,1,5,2,18,74,23,201]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends D.AbstractStorageService{constructor(i,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(i)}createGlobalStorage(){const i=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new R.Storage(i.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(i){const E=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),i);if(E.workspaceStorage){const f=new R.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=i?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(i){return i===0?this.globalStorage:this.workspaceStorage}getLogDetails(i){return i===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,P.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(D.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(i){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(i),await this.workspaceStorage.init();for(const[p,h]of f)this.workspaceStorage.set(p,h)}}e.NativeStorageService=S}),define(te[203],ne([0,1,4,31,8,29]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function C(I,i,E,f,p,h,w,y,m,v){const d=Object.create(null);d["common.machineId"]=w,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=p,d.version=h,d["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,k.PlatformToString)(k.platform),d["common.nodePlatform"]=T.platform,d["common.nodeArch"]=f,d["common.product"]=v||"desktop";const l=S(y||[]);l&&(d["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),k.isLinuxSnap&&(d["common.snap"]="true");const s=D(E);s&&(d["common.platformDetail"]=s);try{const r=await I.readFile(P.URI.file(m));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=C;function S(I){const i=T.env.USERDNSDOMAIN;if(!i)return!1;const E=i.toLowerCase();return I.some(f=>E===f)}e.verifyMicrosoftInternalDomain=S}),define(te[22],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,33,56,5,32,15,9,4,8,115,20,118,78,14,27,22]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(t,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,a=new Map,o=2e4;function u(A,U,O,q){const N=U.substring(A.length+1);return P.Promises.withAsyncBody(async L=>{let $;try{$=await E.Promises.readdir(U,{withFileTypes:!0})}catch(j){L();return}if(q.count>=o){q.count+=$.length,q.maxReached=!0,L();return}let _=$.length;if(_===0){L();return}let M=$;q.count+$.length>o&&(q.maxReached=!0,_=o-q.count,M=$.slice(0,_)),q.count+=$.length;for(const j of M)if(j.isDirectory()){if(O.includes(j.name)||await u(A,(0,C.join)(U,j.name),O,q),--_==0){L();return}}else{const W=j.name.lastIndexOf(".");if(W>=0){const x=j.name.substring(W+1);x&&n.set(x,(n.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(N)!==!1&&x.filePattern.test(j.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--_==0){L();return}}})}const g={count:0,maxReached:!1};await u(t,t,s,g);const b=await l(t);return{configFiles:v(a),fileTypes:v(n),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:b}}e.collectWorkspaceStats=m;function v(t){return[...T.Iterable.map(t.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function d(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},s=k.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.getMachineInfo=d;async function l(t){try{const s=new Map,r=(0,C.join)(t,".vscode","launch.json"),n=await E.Promises.readFile(r),a=[],o=(0,R.parse)(n.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const g=u.type;g&&(s.has(g)?s.set(g,s.get(g)+1):s.set(g,1))}return v(s)}catch(s){return[]}}e.collectLaunchConfigs=l;let c=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const n=k.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||r.push(`Load (avg):       ${k.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,f.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async n=>{let[a,o]=n,u=this.formatProcessList(s,a);return r.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,o+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(s,g.processes)}`),g.workspaceMetadata){o+=`
|  Remote: ${g.hostName}`;for(const b of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[b];let U=`${A.fileCount} files`;A.maxFilesReached&&(U=`more than ${U}`),o+=`|    Folder (${b}): ${U}`,o+=this.formatWorkspaceStats(A)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(s,r){const{memory:n,vmHint:a,os:o,cpus:u}=d(),g={os:o,memory:n,cpus:u,vmHint:a,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return S.isWindows||(g.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),S.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(s,r){const n=[];return(0,f.listProcesses)(s.mainPID).then(async a=>(n.push(""),n.push(this.formatEnvironment(s)),n.push(""),n.push(this.formatProcessList(s,a)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(s))),r.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.formatMachineInfo(o.machineInfo)),o.processes&&n.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const g=o.workspaceMetadata[u];let b=`${g.fileCount} files`;g.maxFilesReached&&(b=`more than ${b}`),n.push(`Folder (${u}): ${b}`),n.push(this.formatWorkspaceStats(g))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(s){const r=[],n=60;let a=0;const o=(A,U)=>{const O=` ${A}(${U})`;a+O.length>n?(r.push(u),u="|                 ",a=u.length):a+=O.length,u+=O};let u="|      File types:";const g=10;let b=s.fileTypes.length>g?g:s.fileTypes.length;for(let A=0;A<b;A++){const U=s.fileTypes[A];o(U.name,U.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",a=0,s.configFiles.forEach(A=>{o(A.name,A.count)}),r.push(u)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(U=>{A+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(A)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(n=>n.length));return Object.keys(s).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${s[n]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],n=[];return s.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(o=>{const u=I.URI.revive(o);if(u.scheme===D.Schemas.file){const g=u.fsPath;n.push(m(g,["node_modules",".git"]).then(b=>{let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,C.basename)(g)}): ${A}`),r.push(this.formatWorkspaceStats(b))}).catch(b=>{r.push(`|      Error: Unable to collect workspace stats for folder ${g} (${b.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(s,r){const n=new Map;s.windows.forEach(o=>n.set(o.pid,o.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,n,a,r,0),a.join(`
`)}formatProcessItem(s,r,n,a,o){const u=o===0;let g;u?g=a.pid===s?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(o)} ${a.name}`,a.name==="window"&&(g=`${g} (${r.get(a.pid)})`));const b=process.platform==="win32"?a.mem:k.totalmem()*(a.mem/100);n.push(`${a.load.toFixed(0).padStart(5," ")}	${(b/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(s,r,n,A,o+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const n=I.URI.revive(r);if(n.scheme!==D.Schemas.file)continue;const a=n.fsPath;try{const o=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};c=he([J(0,y.ITelemetryService),J(1,w.IProductService)],c),e.DiagnosticsService=c}),define(te[205],ne([0,1,16,5,28,7,3,2,4,8,132,30,36,10,27,22]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends C.Disposable{constructor(c,t,s,r){super();this.galleryService=c,this.telemetryService=t,this.logService=s,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const t=await this.getTargetPlatform();return c.allTargetPlatforms.some(s=>(0,E.isTargetPlatformCompatible)(s,c.allTargetPlatforms,t))}async installFromGallery(c,t={}){if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(i.localize(0,null),E.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(c)){const r=await this.getTargetPlatform(),n=new E.ExtensionManagementError(i.localize(1,null,c.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(r)),E.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",c.identifier.id,n.message),v(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(c),void 0,n),n}try{c=await this.checkAndGetCompatibleVersion(c,!t.installGivenVersion)}catch(r){throw this.logService.error((0,R.getErrorMessage)(r)),v(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(c),void 0,r),r}const s=await this.galleryService.getManifest(c,P.CancellationToken.None);if(s===null){const r=new E.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",c.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(c),void 0,r),r}if(s.version!==c.version){const r=new E.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);throw this.logService.error(r.message),v(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(c),void 0,r),r}return this.installExtension(s,c,t)}async uninstall(c,t={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,t)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(c);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}registerParticipant(c){this.participants.push(c)}async installExtension(c,t,s){if(!I.URI.isUri(t)){let u=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],n=[],a=this.createInstallExtensionTask(c,t,s);I.URI.isUri(t)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:t}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:c});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:b,manifest:A}of g)if(o=o||!!A.extensionDependencies?.some(U=>(0,f.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(b.identifier,b.version).key()))this.logService.info("Extension is already requested to install",b.identifier.id);else{const U=this.createInstallExtensionTask(A,b,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(U.identifier,A.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:b}),this.logService.info("Installing extension:",U.identifier.id),r.push({task:U,manifest:A})}}catch(g){if(I.URI.isUri(a.source))(0,k.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,g.message),(0,k.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,g.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(g),g}const u=r.reduce((g,{task:b,manifest:A})=>(g.set(b.identifier.id.toLowerCase(),{task:b,manifest:A}),g),new Map);for(;u.size;){let g;const b=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(U=>u.has(U.toLowerCase())));b.length?g=u.size===1?b:b.filter(({task:A})=>!(A===a&&!o)):(this.logService.info("Found extensions with circular dependencies",b.map(({task:A})=>A.identifier.id)),g=[...u.values()]),await this.joinAllSettled(g.map(async({task:A})=>{const U=new Date().getTime();try{const O=await A.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(O,A.source,s,P.CancellationToken.None))),!I.URI.isUri(A.source)&&(v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-U,void 0),S.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(q){}n.push({local:O,identifier:A.identifier,operation:A.operation,source:A.source})}catch(O){throw I.URI.isUri(A.source)||v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-U,O),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(O),O}finally{u.delete(A.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:g})=>(0,f.areSameExtensions)(g,a.identifier))[0].local}catch(u){if(r.forEach(({task:g})=>g.cancel()),n.length)try{const g=await Promise.allSettled(n.map(({local:b})=>this.createUninstallExtensionTask(b,{versionOnly:!0}).run()));for(let b=0;b<g.length;b++){const A=g[b],{identifier:U}=n[b];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,R.getErrorMessage)(A.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(g),n.map(({identifier:b})=>b.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,R.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:E.ExtensionManagementErrorCode.Internal),u}finally{for(const{task:u,manifest:g}of r)if(!I.URI.isUri(u.source)){const b=new f.ExtensionIdentifierWithVersion(u.identifier,g.version).key();this.installingExtensions.delete(b)||this.logService.warn("Installation task is not found in the cache",b)}}}async joinAllSettled(c){const t=[],s=[],r=await Promise.allSettled(c);for(const n of r)n.status==="fulfilled"?t.push(n.value):s.push(n.reason);if(s.length)throw m(s);return t}async getAllDepsAndPackExtensionsToInstall(c,t,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const n=[c,...r.map(u=>u.identifier)],a=[],o=async(u,g)=>{const b=g.extensionDependencies||[],A=[...b];if(g.extensionPack){const U=s?r.find(O=>(0,f.areSameExtensions)(O.identifier,u)):void 0;for(const O of g.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(q=>(0,f.areSameExtensions)({id:q},{id:O}))||A.every(q=>!(0,f.areSameExtensions)({id:q},{id:O}))&&A.push(O)}if(A.length){const U=[...n,...a.map(q=>q.gallery.identifier)],O=A.filter(q=>U.every(N=>!(0,f.areSameExtensions)(N,{id:q})));if(O.length){const q=await this.galleryService.query({names:O,pageSize:A.length},P.CancellationToken.None);for(const N of q.firstPage){if(U.find(M=>(0,f.areSameExtensions)(M,N.identifier)))continue;if(!b.some(M=>(0,f.areSameExtensions)({id:M},N.identifier))&&!await this.canInstall(N)){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}const $=await this.checkAndGetCompatibleVersion(N,!0),_=await this.galleryService.getManifest($,P.CancellationToken.None);if(_===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);a.push({gallery:$,manifest:_}),await o($.identifier,_)}}}};return await o(c,t),r=await this.getInstalled(),a.filter(u=>!r.some(g=>(0,f.areSameExtensions)(g.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(c,t){if(await this.isMalicious(c))throw new E.ExtensionManagementError(i.localize(4,null,c.identifier.id),E.ExtensionManagementErrorCode.Malicious);const s=await this.getCompatibleVersion(c,t);if(!s)throw new E.ExtensionManagementError(i.localize(5,null,c.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);return s}async getCompatibleVersion(c,t){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(c,s)&&(r=c),!r&&t&&(r=await this.galleryService.getCompatibleExtension(c,s)),r}async isMalicious(c){const t=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(t).has(c.identifier.id)}async unininstallExtension(c,t){const s=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),s.waitUntilTaskIsFinished();const r=(u,g)=>{const b=this.createUninstallExtensionTask(u,g);return this.uninstallingExtensions.set(b.extension.identifier.id.toLowerCase(),b),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),b},n=(u,g)=>{g?this.logService.error("Failed to uninstall extension:",u.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(u),void 0,g),this._onDidUninstallExtension.fire({identifier:u.identifier,error:g?.code})},a=[],o=[];try{a.push(r(c,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(c,u);for(const b of g)this.uninstallingExtensions.has(b.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",b.identifier.id):a.push(r(b,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(g=>g.extension),u,c),await this.joinAllSettled(a.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(b=>b.postUninstall(g.extension,t,P.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(b){}n(g.extension)}catch(b){const A=b instanceof E.ExtensionManagementError?b:new E.ExtensionManagementError((0,R.getErrorMessage)(b),E.ExtensionManagementErrorCode.Internal);throw n(g.extension,A),A}finally{o.push(g)}}))}catch(u){const g=u instanceof E.ExtensionManagementError?u:new E.ExtensionManagementError((0,R.getErrorMessage)(u),E.ExtensionManagementErrorCode.Internal);for(const b of a){try{b.cancel()}catch(A){}o.includes(b)||n(b.extension,g)}throw g}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(c,t,s){for(const r of c){const n=this.getDependents(r,t);if(n.length){const a=n.filter(o=>!c.some(u=>(0,f.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(c,t,s){return s===c?t.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(c,t,s=[]){if(s.indexOf(c)!==-1)return[];s.push(c);const r=c.manifest.extensionPack?c.manifest.extensionPack:[];if(r.length){const n=t.filter(o=>!o.isBuiltin&&r.some(u=>(0,f.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of n)a.push(...this.getAllPackExtensionsToUninstall(o,t,s));return[...n,...a]}return[]}getDependents(c,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,f.areSameExtensions)({id:r},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const t=await this.findGalleryExtensionById(c.identifier.uuid);return t||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=he([J(0,E.IExtensionGalleryService),J(1,w.ITelemetryService),J(2,p.ILogService),J(3,h.IProductService)],y),e.AbstractExtensionManagementService=y;function m(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=m;function v(l,c,t,s,r){const n=r?r instanceof E.ExtensionManagementError?r.code:E.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(c,{...t,success:!r,duration:s,errorcode:n})}e.reportTelemetry=v;class d{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(c=>new Promise((t,s)=>{const r=c.onCancellationRequested(()=>{r.dispose(),s((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=d}),define(te[206],ne([0,1,16,5,67,3,9,4,31,8,134,11,30,196,80,14,10,61,27,44,23,22]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends p.ExtensionTipsService{constructor(a,o,u,g,b,A,U,O,q,N){super(U,O,q,N);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=b,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,P.forEach)(O.exeBasedExtensionTips,({key:L,value:$})=>{const _=[],M=[],j=[];(0,P.forEach)($.recommendations,({key:W,value:x})=>{x.important?$.important?_.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):M.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):j.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:_}),M.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:M}),j.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:j})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:b}=this.groupByInstalled([...u.keys()],o);for(const O of g){const q=u.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:q.exeName})}for(const O of b){const q=u.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:q.exeName})}const A=this.getPromptedExecutableTips(),U=new Map;for(const O of b){const q=u.get(O);if(q&&(!A[q.exeName]||!A[q.exeName].includes(q.extensionId))){let N=U.get(q.exeName);N||(N=[],U.set(q.exeName,N)),N.push(q)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const b=this._register((0,T.disposableTimeout)(()=>{b.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[g,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(b[0].exeName,b);const U=this._register((0,T.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,T.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:g})=>g.toLowerCase()),u=(0,i.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],g=[],b=o.reduce((A,U)=>(A.add(U.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{b.has(A.toLowerCase())?u.push(A):g.push(A)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const g of a.keys()){const b=a.get(g);if(!b||!(0,k.isNonEmptyArray)(b.recommendations))continue;const A=[];C.isWindows?b.windowsPath&&A.push(b.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(A.push((0,D.join)("/usr/local/bin",g)),A.push((0,D.join)("/usr/bin",g)),A.push((0,D.join)(this.environmentService.userHome.fsPath,g)));for(const U of A){let O=u.get(U);if(O===void 0&&(O=await this.fileService.exists(I.URI.file(U)),u.set(U,O)),O)for(const{extensionId:q,extensionName:N,isExtensionPack:L}of b.recommendations)o.push({extensionId:q,extensionName:N,isExtensionPack:L,exeName:g,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath})}}return o}};r=he([J(0,E.INativeEnvironmentService),J(1,c.ITelemetryService),J(2,f.IExtensionManagementService),J(3,l.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,w.IFileService),J(7,v.IProductService),J(8,d.IRequestService),J(9,y.ILogService)],r),e.ExtensionTipsService=r}),define(te[93],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:C,data:S}){return this.appenders.forEach(I=>I.log(C,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class T{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(te[45],ne([0,1,26,17,21,22]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,v){return Promise.resolve(void 0)}publicLog2(m,v){return this.publicLog(m,v)}publicLogError(m,v){return Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class C{async publicLog(m,v,d){}async publicLogError(m,v,d){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(y,m){return m.onDidChangeConfiguration(v=>{v.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=S;function I(y,m){return!(m.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=I;function i(y){const m=y.getValue(R.TELEMETRY_SETTING_ID),v=y.getValue("telemetry.enableCrashReporter");if(y.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function E(y){const m=Object.create(null),v=Object.create(null),d=Object.create(null);p(y,d);for(let l in d){l=l.length>150?l.substr(l.length-149):l;const c=d[l];typeof c=="number"?v[l]=c:typeof c=="boolean"?v[l]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${c.length}`),m[l]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(m[l]=c)}return{properties:m,measurements:v}}e.validateTelemetryData=E;function f(y){if(!y)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{y.indexOf(`${d}+`)===0&&(m=d)}),m}e.cleanRemoteAuthority=f;function p(y,m,v=0,d){if(!!y)for(let l of Object.getOwnPropertyNames(y)){const c=y[l],t=d?d+l:l;Array.isArray(c)?m[t]=(0,k.safeStringify)(c):c instanceof Date?m[t]=c.toISOString():(0,T.isObject)(c)?v<2?p(c,m,v+1,t+"."):m[t]=(0,k.safeStringify)(c):m[t]=c}}function h(y){if(!y)return[];const m=[];return w(m,"",y),m}function w(y,m,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(d=>w(y,m?`${m}.${d}`:d,v[d])):y.push(m)}}),define(te[207],ne([0,1,45,152]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class P{constructor(){}setSharedProperty(S,I){}postEvent(S,I){}}class R{constructor(S,I,i,E,f){this.getMachineId=S,this.configurationService=I,this.productService=i,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,i.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(w=>setTimeout(w,h))}get experimentsEnabled(){return this.configurationService.getValue("workbench.enableExperiments")===!0}async getTreatment(S){await this.overrideInitDelay;const I=this.configurationService.getValue("experiments.override."+S);if(I!==void 0)return I;if(!this.tasClient||!this.experimentsEnabled)return;let i;const E=await this.tasClient;return this.networkInitialized?i=E.getTreatmentVariable("vscode",S):i=await E.getTreatmentVariableAsync("vscode",S,!0),i=E.getTreatmentVariable("vscode",S),i}async setupTASClient(){const S=this.productService.quality==="stable"?T.TargetPopulation.Public:T.TargetPopulation.Insiders,I=await this.getMachineId(),i=new T.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,I,S),E=this.productService.tasConfig,f=new(await new Promise((p,h)=>{X(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[i],telemetry:this.telemetry,storageKey:T.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:T.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=R;class D extends R{constructor(S,I,i){super(()=>Promise.resolve(S),I,i,new P)}}e.AssignmentService=D}),define(te[208],ne([0,1,16,28,7,26,4,31,8,21,11,30,36,77,14,10,27,44,46,23,22,45]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=D.isWeb?"web":(0,E.getTargetPlatform)(D.platform,C.arch);var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...G){return String(G.reduce((H,re)=>H|re,0))}var n;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class b{constructor(H=g){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new b({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new b({...this.state,criteria:ie})}withSortBy(H){return new b({...this.state,sortBy:H})}withSortOrder(H){return new b({...this.state,sortOrder:H})}withFlags(...H){return new b({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new b({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:fe,flags:de}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===n.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function U(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=L(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function O(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return L(G,a.Repository)}function q(G){return{uri:`${G.fallbackAssetUri}/${a.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${a.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=L(G,a.Icon);if(H)return H;const re=E.DefaultIconPath;return{uri:re,fallbackUri:re}}function L(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function $(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,f.adoptToGalleryExtensionId)(ce)):[]}function _(G){const H=G.properties?G.properties.filter(re=>re.key===o.Engine):[];return H.length>0&&H[0].value||""}function M(G){const H=G.properties?G.properties.filter(ie=>ie.key===o.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function j(G){return G.indexOf("preview")!==-1}function W(G){return G.targetPlatform?(0,E.toTargetPlatform)(G.targetPlatform):"undefined"}function x(G){const H=(0,k.distinct)(G.versions.map(W)),re=!!G.tags?.includes(E.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function z(G,H){const re=(0,E.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const de=W(ce);if(de===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&G[le-1].version===ce.version&&W(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=z;function K(G,H,re,ie,ce){const le=x(G);let de=G.versions[0];return de=G.versions.find(fe=>fe.version===de.version&&(0,E.isTargetPlatformCompatible)(W(fe),le,ce))||de,F(G,de,le,H,re,ie)}function F(G,H,re,ie,ce,le){const de={manifest:L(H,a.Manifest),readme:L(H,a.Details),changelog:L(H,a.Changelog),license:L(H,a.License),repository:O(H),download:q(H),icon:N(H),coreTranslations:U(H)};return{identifier:{id:(0,f.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:A(G.statistics,"install"),rating:A(G.statistics,"averagerating"),ratingCount:A(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:$(H,o.Dependency),extensionPack:$(H,o.ExtensionPack),engine:_(H),localizedLanguages:M(H),targetPlatform:W(H)},preview:j(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(H,re,ie,ce,le,de,fe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=fe,this.configurationService=be;const Ce=fe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(fe.version,fe,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...H.map(({id:de})=>de.toLowerCase()));H.every(de=>!de.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,t,T.CancellationToken.None);for(let de=0;de<le.length;de++){const fe=le[de];if(!fe.versions.length)continue;const be=(0,f.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),Ce=H.find(Ee=>(0,f.areSameExtensions)(Ee,{id:be}))?.version;if(Ce){const Ee=fe.versions.find(Ae=>Ae.version===Ce);Ee&&ie.push(F(fe,Ee,x(fe),de,ce))}else ie.push(K(fe,de,ce,void 0,t))}return ie}async getCompatibleExtension(H,re){const ie=(0,E.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,E.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let de=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(n.ExtensionId,le):de=de.withFilter(n.ExtensionName,ce);const{galleryExtensions:fe}=await this.queryGallery(de,re,T.CancellationToken.None),[be]=fe;if(!be||!be.versions.length)return null;const Ce=x(be);if((0,E.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of be.versions){if(!_(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return F(be,Ee,Ce,0,de)}return null}async isExtensionCompatible(H,re){if(!(0,E.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,p.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,E.isTargetPlatformCompatible)(W(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=T.CancellationToken.isCancellationToken(H)?{}:H,ce=T.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const de=(0,R.getOrDefault)(ie,Pe=>Pe.pageSize,50);let fe=new b().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,de).withFilter(n.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(n.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(n.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(n.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),fe=fe.withFilter(n.SearchText,le)),fe=fe.withSortBy(0)):ie.ids?fe=fe.withFilter(n.ExtensionId,...ie.ids):ie.names?fe=fe.withFilter(n.ExtensionName,...ie.names):fe=fe.withSortBy(4),typeof ie.sortBy=="number"&&(fe=fe.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(fe=fe.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(fe,t,ce),Ee=be.map((Pe,Le)=>K(Pe,Le,fe,ie.source,t)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,P.canceled)();const Fe=fe.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,t,Le);return Ne.map(($e,xe)=>K($e,xe,Fe,ie.source,t))};return{firstPage:Ee,total:Ce,pageSize:fe.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},fe=new Date().getTime();let be,Ce,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,m.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Ne=>z(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ce=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-fe,success:!!be&&(0,m.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ce?(0,P.isPromiseCanceledError)(Ce)?"canceled":(0,P.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=D.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),de=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},T.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,f.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),de=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),fe=ie===1?"install":ie===2?"update":"",be=fe?{uri:`${H.assets.download.uri}${S.URI.parse(H.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${H.assets.download.fallbackUri}${S.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:H.assets.download,Ce=await this.getAsset(be);await this.fileService.writeFile(re,Ce.stream),de(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,m.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,m.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=L(H,a.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,m.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,m.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,m.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new b().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(n.ExtensionId,H.identifier.uuid):ie=ie.withFilter(n.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const le=x(ce[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const fe of ce[0].versions)try{de[de.length-1]?.version!==fe.version&&await this.isRawExtensionVersionCompatible(fe,le,re)&&de.push({version:fe.version,date:fe.lastUpdated})}catch(be){}return de}async getAsset(H,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const fe=H.uri,be=H.fallbackUri,Ce={...re,url:fe};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,m.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,P.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,P.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=_(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,m.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([J(1,m.IRequestService),J(2,w.ILogService),J(3,i.IEnvironmentService),J(4,l.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,I.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ce,le,de,fe,be){super(H,re,ie,ce,le,de,fe,be)}};V=he([J(0,d.IStorageService),J(1,m.IRequestService),J(2,w.ILogService),J(3,i.IEnvironmentService),J(4,l.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,I.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ce,le,de,fe){super(void 0,H,re,ie,ce,le,de,fe)}};Q=he([J(0,m.IRequestService),J(1,w.ILogService),J(2,i.IEnvironmentService),J(3,l.ITelemetryService),J(4,h.IFileService),J(5,y.IProductService),J(6,I.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},fe=await(0,v.getServiceMachineId)(re,ce,le);return(0,c.supportsTelemetry)(H,re)&&(0,c.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=fe),de}e.resolveMarketplaceHeaders=Z}),define(te[94],ne([0,1,2,11,10,45]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let D=class extends k.Disposable{constructor(S,I,i=""){super();this.prefix=i;const E=S.getLogger(I.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(S.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,I){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,R.validateTelemetryData)(I))}};D=he([J(0,P.ILoggerService),J(1,T.IEnvironmentService)],D),e.TelemetryLogAppender=D}),define(te[95],ne([0,1,2,26,4,25,144,21,39,87,35,22,45]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(y,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const d=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!d})})}setExperimentProperty(y,m){this._experimentProperties[y]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let m=y.sessionID,v=y["common.instanceId"],d=y["common.machineId"],l=y["common.firstSessionDate"],c=y["common.msftInternal"];return{sessionId:m,instanceId:v,machineId:d,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}_log(y,m,v,d){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(l=>{v=(0,T.mixin)(v,l),v=(0,T.mixin)(v,this._experimentProperties),v=(0,T.cloneAndChange)(v,c=>{if(typeof c=="string")return this._cleanupInfo(c,d)}),this._appenders.forEach(c=>c.log(y,v))},l=>{console.error(l)})}publicLog(y,m,v){return this._log(y,3,m,v)}publicLog2(y,m,v){return this.publicLog(y,m,v)}publicLogError(y,m){return this.sendErrorTelemetry?this._log(y,2,m,!0):Promise.resolve(void 0)}publicLogError2(y,m){return this.publicLogError(y,m)}_anonymizeFilePaths(y){let m=y;const v=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(y);if(!s)break;v.push([s.index,t.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(m="";;){const t=l.exec(y);if(!t)break;!d.test(t[0])&&v.every(([s,r])=>t.index<s||t.index>=r)&&(m+=y.substring(c,t.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<y.length&&(m+=y.substr(c)),m}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const m=y.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":v.test(m)?"<REDACTED: email>":y}_cleanupInfo(y,m){let v=y;m&&(v=this._anonymizeFilePaths(v));for(let d of this._cleanupPatterns)v=v.replace(d,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([J(1,C.IConfigurationService)],p),e.TelemetryService=p;function h(){const w=(0,D.localize)(0,null,I.default.nameLong),y=I.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=P.isWeb?"":(0,D.localize)(3,null),v=(0,D.localize)(4,null),d=(0,D.localize)(5,null),l=(0,D.localize)(6,null),c=(0,D.localize)(7,null),t=`
|       | ${v} | ${d} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${w} ${y} ${m}

&nbsp;

${c}
${t}

&nbsp;

${s}
`}i.Registry.as(S.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(S.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,D.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,D.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[209],ne([0,1,7,26,45]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(C,S){const I=await new Promise((E,f)=>{X(["applicationinsights"],E,f)});let i;return I.defaultClient?(i=new I.TelemetryClient(C),i.channel.setUseDiskRetryCaching(!0)):(I.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),i=I.defaultClient),C.indexOf("AIF-")===0&&(i.config.endpointUrl=S?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),i}class D{constructor(S,I,i,E,f){this._eventPrefix=S,this._defaultData=I,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(I=>{S(I)},I=>{(0,k.onUnexpectedError)(I),console.error(I)})}}log(S,I){!this._aiClient||(I=(0,T.mixin)(I,this._defaultData),I=(0,P.validateTelemetryData)(I),this.testCollector&&(I.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+S,properties:I.properties,measurements:I.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(I=>{I.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=D}),define(te[210],ne([0,1,15,52,21,11,10,22,93,94,95]),function(X,e,k,T,P,R,D,C,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,w,y){this.configurationService=p,this.telemetryService=h,this.loggerService=w,this.environmentService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:w}=await this.telemetryService.getTelemetryInfo(),y=Object.create(null);y["common.vscodemachineid"]=h,y["common.vscodesessionid"]=w;const m=[p.id,JSON.stringify(y),p.aiKey],d=new T.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new S.TelemetryAppenderClient(d),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new i.TelemetryService({appenders:l,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,w){await(await this.getCustomTelemetryService(p)).publicLog(h,w)}async publicLogError(p,h,w){await(await this.getCustomTelemetryService(p)).publicLogError(h,w)}};E=he([J(0,P.IConfigurationService),J(1,C.ITelemetryService),J(2,D.ILoggerService),J(3,R.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[211],ne([0,1,5,28,3,2,10]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends R.Disposable{constructor(I,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((i,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,i),this._onCreateRequest.fire({requestId:f,...I});const p=new T.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,R.toDisposable)(()=>p.cancel())])})}acceptReply(I,i){const E=this._pendingRequests.get(I);E?(this._pendingRequests.delete(I),(0,R.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),E(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};C=he([J(1,D.ILogService)],C),e.RequestStore=C}),define(te[96],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var R;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Log="log",y.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var S;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(y){y.TerminalView="view",y.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(y){y.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(te[212],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[213],ne([0,1,33,26,9,4,31,17,20]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=I;async function i(E,f,p,h=D.env,w=S.Promises.exists){if(P.isAbsolute(E))return await w(E)?E:void 0;if(f===void 0&&(f=D.cwd()),P.dirname(E)!=="."){const d=P.join(f,E);return await w(d)?d:void 0}const m=(0,T.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,C.isString)(m)&&(p=m.split(P.delimiter)),p===void 0||p.length===0){const d=P.join(f,E);return await w(d)?d:void 0}for(let d of p){let l;if(P.isAbsolute(d)?l=P.join(d,E):l=P.join(f,d,E),await w(l))return l;if(R.isWindows){let c=l+".com";if(await w(c)||(c=l+".exe",await w(c)))return c}}const v=P.join(f,E);return await w(v)?v:void 0}e.findExecutable=i}),define(te[214],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,49,3,2,6,35,214]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var S;(function(y){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}y.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function I(y){return{id:y}}e.themeColorFromId=I;var i;(function(y){function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}y.isThemeIcon=m;const v=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=v.exec(s);if(!r)return;let[,n]=r;return{id:n}}y.fromString=d;function l(s,r){let n=s.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}y.modify=l;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}y.isEqual=c;function t(s,r){return{id:s.id,color:r?I(r):void 0}}y.asThemeIcon=t,y.asClassNameArray=k.CSSIcon.asClassNameArray,y.asClassName=k.CSSIcon.asClassName,y.asCSSSelector=k.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(y){switch(y){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,P.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;D.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class w extends P.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=w}),define(te[215],ne([0,1,49,8,97]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(E,f){const p=E.map(h=>({name:h.profileName,description:D(h)}));return f&&p.push(...f.map(h=>({name:h.title,description:C(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=R;function D(E){let f=`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function C(E){return`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function S(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function I(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(P.ThemeIcon.isThemeIcon(E)&&P.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=E,h=f;if((T.URI.isUri(p.light)||i(p.light))&&(T.URI.isUri(p.dark)||i(p.dark))&&(T.URI.isUri(h.light)||i(h.light))&&(T.URI.isUri(h.dark)||i(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(T.URI.isUri(E)&&T.URI.isUri(f)||i(E)||i(f)){const p=E,h=f;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=I;function i(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=i}),define(te[216],ne([0,1,49,145,39,35,215]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,d=>d.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,d=>`$(${d.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},I=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,T.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,T.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,T.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,T.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,T.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,T.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(25,null)}},{type:"string",markdownDescription:(0,T.localize)(26,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(28,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(29,null),type:"string"},id:{description:(0,T.localize)(30,null),type:"string"},title:{description:(0,T.localize)(31,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(33,null),type:"string"},id:{description:(0,T.localize)(34,null),type:"string"},title:{description:(0,T.localize)(35,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(37,null),type:"string"},id:{description:(0,T.localize)(38,null),type:"string"},title:{description:(0,T.localize)(39,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){R.Registry.as(P.Extensions.Configuration).registerConfiguration(w),v()}e.registerTerminalPlatformConfiguration=y;let m;function v(d,l){const c=R.Registry.as(P.Extensions.Configuration);let t;d&&(t=(0,D.createProfileSchemaEnums)(d?.profiles,l));const s=m;m={id:"terminal",order:100,title:(0,T.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?t?.values:void 0,markdownEnumDescriptions:d?.os===3?t?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?t?.values:void 0,markdownEnumDescriptions:d?.os===2?t?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?t?.values:void 0,markdownEnumDescriptions:d?.os===1?t?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[m],remove:s?[s]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(te[217],ne([0,1,43,49,9,4,20,71,213,97]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i,E=!0;function f(s,r,n,a,o=process.env,u,g,b,A){return u=u||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},R.isWindows?p(n,u,o,g,a.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),A,b):l(u,g,n,s&&typeof s=="object"?{...s}:a.getValue(R.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(R.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,b,o)}e.detectAvailableProfiles=f;async function p(s,r,n,a,o,u,g,b,A){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let q=!1;(0,S.getWindowsBuildNumber)()>=16299&&(q=!0),await y(b);const N=new Map;s&&(N.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),c(u,N);const L=await h(N.entries(),g,r,n,a,A);if(s||!s&&o)try{const $=await v(`${O}\\${q?"wsl":"bash"}.exe`,g);for(const _ of $)(!u||!(_.profileName in u))&&L.push(_)}catch($){E&&(a?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function h(s,r,n,a=process.env,o,u){const g=[];for(const[b,A]of s){if(A===null)continue;let U,O,q;if("source"in A){const $=i?.get(A.source);if(!$)continue;U=$.paths,O=A.args||$.args,A.icon?q=w(A.icon):$.icon&&(q=$.icon)}else U=Array.isArray(A.path)?A.path:[A.path],O=R.isWindows||Array.isArray(A.args)?A.args:void 0,q=w(A.icon)||void 0;const N=await u?.(U)||U.slice(),L=await t(b,r,N,n,a,O,A.env,A.overrideName,A.isAutoDetected,o);L?(L.isAutoDetected=A.isAutoDetected,L.icon=q,L.color=A.color,g.push(L)):o?.trace("profile not validated",b,U)}return g}function w(s){return typeof s=="string"?{id:s}:s}async function y(s){i&&!s||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:I.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const r of(0,C.enumeratePowerShellInstallations)())s.push(r.exePath);return s}async function v(s,r){const n=[],a=await new Promise((g,b)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(A,U)=>{if(A)return b("Problem occurred when getting wsl distros");g(U)})});if(!a)return[];const o=new RegExp(/[\r?\n]/),u=a.split(o).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const b=`${g} (WSL)`,A={profileName:b,path:s,args:["-d",`${g}`],isDefault:b===r,icon:d(g)};n.push(A)}return n}function d(s){return s.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):s.includes("Debian")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function l(s,r,n,a,o,u,g,b){const A=new Map;if(n){const U=(await s.readFile("/etc/shells")).toString(),O=u||U.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),q=new Map;for(const N of O){let L=(0,P.basename)(N),$=q.get(L)||0;$++,$>1&&(L=`${L} (${$})`),q.set(L,$),A.set(L,{path:N,isAutoDetected:!0})}}return c(a,A),await h(A.entries(),o,s,b,r,g)}function c(s,r){if(!!s)for(const[n,a]of Object.entries(s))a===null||!("path"in a)&&!("source"in a)?r.delete(n):r.set(n,a)}async function t(s,r,n,a,o,u,g,b,A,U){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return t(s,r,n,a,o,u,g,b,A);const q={profileName:s,path:O,args:u,env:g,overrideName:b,isAutoDetected:A,isDefault:s===r};if((0,P.basename)(O)===O){const L=o.PATH?o.PATH.split(P.delimiter):void 0;return await(0,S.findExecutable)(O,void 0,L,void 0,a.existsFile)?q:t(s,r,n,a,o,u)}return await a.existsFile((0,P.normalize)(O))?q:t(s,r,n,a,o,u,g,b,A)}}),define(te[218],ne([0,1,3,2,15,4,34,52,21,11,76,167,10,86,22,211,96,216,217]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let l=0,c=class extends T.Disposable{constructor(s,r,n,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=n,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new w.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(R.isWindows)return process.env;try{return await(0,E.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const n=new C.Client(P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,s);this._onPtyHostStart.fire(),D.ProxyChannel.toService(n.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=d.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const o=n.getChannel(y.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=D.ProxyChannel.toService(n.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(g=>this._onProcessData.fire(g))),this._register(u.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(u.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(u.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(u.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(u.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(u.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[n,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,n,a,o,u,g,b,A,U,O){const q=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(s,r,n,a,o,u,g,b,A,U,O);return clearTimeout(q),l=Math.max(l,N),N}updateTitle(s,r,n){return this._proxy.updateTitle(s,r,n)}updateIcon(s,r,n){return this._proxy.updateIcon(s,r,n)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,n){return this._proxy.resize(s,r,n)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,n,a=!1){const o=await this._shellEnv;return(0,v.detectAvailableProfiles)(r,n,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,n){return this._proxy.updateProperty(s,r,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};c=he([J(1,S.IConfigurationService),J(2,I.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],c),e.PtyHostService=c}),define(te[37],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[219],ne([0,1,3,2,8,11,36,14,10,37]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends T.Disposable{constructor(f,p,h,w,y){super();this.extensionsManagementService=f,this.logService=w,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(v=>this.onInstallExtension(v))),this._register(f.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(f.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const m=P.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(k.Event.filter(p.onDidChangeFilesRaw,v=>v.changes.some(d=>this.doesChangeAffects(d,m)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,D.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,D.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,D.areSameExtensions)(y,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),h=this.installedExtensions.filter(w=>this.installingExtensions.some(y=>(0,D.areSameExtensions)(y,w))?!1:f.every(y=>!(0,D.areSameExtensions)(y.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=f.map(w=>w.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};i=he([J(1,C.IFileService),J(2,R.INativeEnvironmentService),J(3,S.ILogService),J(4,I.IUriIdentityService)],i),e.ExtensionsWatcher=i}),define(te[220],ne([0,1,37,59,14,18,104,3,2]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(f){this.uri=f,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let i=class{constructor(f){this._fileService=f,this._dispooables=new S.DisposableStore,this._limit=2**16;const p=new Map,h=w=>{let y=p.get(w.scheme);return y===void 0&&(y=f.hasProvider(w)&&!this._fileService.hasCapability(w,1024),p.set(w.scheme,y)),y};this._dispooables.add(C.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(w=>{p.delete(w.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new D.SkipList((w,y)=>this.extUri.compare(w,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,R.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new I(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,w)=>h[1].touch<w[1].touch?1:h[1].touch>w[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};i=he([J(0,P.IFileService)],i),e.UriIdentityService=i,(0,T.registerSingleton)(k.IUriIdentityService,i,!0)}),define(te[55],ne([0,1,40]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(D,C,S,I){const i=(0,k.setProperty)(D,C,S,I)[0];return i&&(D=D.substring(0,i.offset)+i.content+D.substring(i.offset+i.length)),D}e.edit=T;function P(D,C,S){let I=S;for(;I>=0;){if(D.charAt(I)===C.charAt(C.length-1)&&C.length===1)return I+1;if(I--,C.length===2&&I>=0&&D.charAt(I)===C.charAt(0))return I+2}return 0}e.getLineStartOffset=P;function R(D,C,S){let I=S;for(;I>=0;)if(D.charAt(I)===C.charAt(C.length-1)&&C.length===1||(I++,C.length===2&&I>=0&&D.charAt(I)===C.charAt(1)))return I;return D.length-1}e.getLineEndOffset=R}),define(te[221],ne([0,1,26,62]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(E,f,p,h,w){const y=[],m=[],v=[];if(!f){const U=E.filter(({identifier:O})=>w.every(q=>q.toLowerCase()!==O.id.toLowerCase()));return{local:{added:y,removed:m,updated:v},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}E=E.map(I),f=f.map(I),p=p?p.map(I):null;const d=new Map,l=U=>{U.uuid&&d.set(U.id.toLowerCase(),U.uuid)};E.forEach(({identifier:U})=>l(U)),f.forEach(({identifier:U})=>l(U)),p&&p.forEach(({identifier:U})=>l(U));const c=U=>{const O=U.identifier.uuid||d.get(U.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${U.identifier.id.toLowerCase()}`},t=(U,O)=>(U.set(c(O),O),U),s=E.reduce(t,new Map),r=f.reduce(t,new Map),n=f.reduce((U,O)=>{const q=c(O);O=(0,k.deepClone)(O);const N=s.get(q);return N&&(N.installed&&(O.installed=!0),O.version||(O.version=N.version)),t(U,O)},new Map),a=p?p.reduce(t,new Map):null,o=h.reduce(t,new Map),u=w.reduce((U,O)=>{const q=d.get(O.toLowerCase());return U.add(q?`uuid:${q}`:`id:${O.toLowerCase()}`)},new Set),g=R(s,r,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const U=R(a,s,u),O=R(a,r,u),q=(N,L)=>{const $=s.get(N);if($){const _=r.get(N);return{...L?_:$,version:(_.version&&T.gt(_.version,$.version),$.version),state:D($,_,a?.get(N))}}};for(const N of O.removed.values()){const L=s.get(N);L&&m.push(L.identifier)}for(const N of O.added.values())if(U.added.has(N)){if(g.updated.has(N)){const L=q(N,!0);L&&(v.push(i(L,N)),n.set(N,L))}}else{const L=r.get(N);L.installed&&y.push(i(L,N))}for(const N of O.updated.values()){const L=q(N,!0);L&&(v.push(i(L,N)),n.set(N,L))}for(const N of U.added.values())O.added.has(N)||n.set(N,s.get(N));for(const N of U.updated.values())if(!O.removed.has(N)&&!O.updated.has(N)){const L=q(N,!1);L&&(n.get(N)?.installed&&(L.installed=!0),n.set(N,L))}for(const N of U.removed.values())!o.has(N)&&!O.updated.has(N)&&a?.get(N)?.installed&&n.delete(N)}const b=[],A=R(r,n,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&n.forEach((U,O)=>b.push(i(U,O))),{local:{added:y,removed:m,updated:v},remote:b.length?{added:[...A.added].map(U=>n.get(U)),updated:[...A.updated].map(U=>n.get(U)),removed:[...A.removed].map(U=>r.get(U)),all:b}:null}}e.merge=P;function R(E,f,p,{checkInstalledProperty:h,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const y=E?[...E.keys()].filter(c=>!p.has(c)):[],m=[...f.keys()].filter(c=>!p.has(c)),v=m.filter(c=>y.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),d=y.filter(c=>m.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),l=new Set;for(const c of y){if(d.has(c))continue;const t=E.get(c),s=f.get(c);(!s||t.disabled!==s.disabled||!S(t.state,s.state)||w&&t.version!==s.version||h&&t.installed!==s.installed)&&l.add(c)}return{added:v,removed:d,updated:l}}function D(E,f,p){const h=E.state,w=f.state,y=p?.state;if(!f.version||h&&T.gt(E.version,f.version))return h;if(w&&T.gt(f.version,E.version)||!h)return w;if(!w)return h;const m=(0,k.deepClone)(h),v=y?C(y,w):{added:Object.keys(w).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set},d=y?C(y,h):{added:Object.keys(h).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set};for(const l of[...v.added.values(),...v.updated.values()])m[l]=w[l];for(const l of v.removed.values())d.updated.has(l)||delete m[l];return m}function C(E,f){const p=Object.keys(E),h=Object.keys(f),w=h.filter(v=>p.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),y=p.filter(v=>h.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),m=new Set;for(const v of p){if(y.has(v))continue;const d=E[v],l=f[v];(0,k.equals)(d,l)||m.add(v)}return{added:w,removed:y,updated:m}}function S(E={},f={}){const{added:p,removed:h,updated:w}=C(E,f);return p.size===0&&h.size===0&&w.size===0}function I(E){return{...E,disabled:!!E.disabled,installed:!!E.installed}}function i(E,f){const p={identifier:{id:E.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return E.version&&(p.version=E.version),E.disabled&&(p.disabled=!0),E.installed&&(p.installed=!0),E.state&&(p.state=E.state),p}}),define(te[98],ne([0,1,16,3,2,36,6,27,23]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,D.createDecorator)("IExtensionsStorageSyncService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class it extends P.Disposable{constructor(f,p){super();this.storageService=f,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(f){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const p=I.exec(f);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const f=this.storageService.keys(0,1);for(const p of f){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(f.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,p){this.storageService.store(it.toKey(f),JSON.stringify(p),0,1)}getKeysForSync(f){const p=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.storageService.get(it.toKey(f),0),w=h?JSON.parse(h):void 0;return w&&p?(0,k.distinct)([...w,...p]):w||p}};i=he([J(0,S.IStorageService),J(1,C.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[99],ne([0,1,16,21,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,S){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==C&&i!==`-${C}`),S&&I.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(C,S){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return I=I.filter(i=>i!==C&&i!==`-${C}`),S&&I.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(C){const S=C.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),i=[],E=[];if(Array.isArray(I))for(const f of I)f.startsWith("-")?E.push(f.substring(1)):i.push(f);return(0,k.distinct)([...S,...i].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};R=he([J(0,T.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(te[222],ne([0,1,16,32,26,162,55]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(l){return(0,T.parse)(l)||[]}e.parseKeybindings=C;async function S(l,c,t,s,r){const n=C(l),a=C(c),o=t?C(t):null,u=[...n,...a,...o||[]].map(M=>M.key),g=await r.resolveUserBindings(u);let b=i(n,a,o,g);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const A=f(n),U=f(a),O=o?f(o):null,q=h(A,U,g),N=O?h(O,A,g):{added:[...A.keys()].reduce((M,j)=>(M.add(j),M),new Set),removed:new Set,updated:new Set},L=O?h(O,U,g):{added:[...U.keys()].reduce((M,j)=>(M.add(j),M),new Set),removed:new Set,updated:new Set},$=I(q,N,L);let _=l;for(const M of $.removed.values())$.conflicts.has(M)||(_=v(_,M,s));for(const M of $.added.values()){if($.conflicts.has(M))continue;const j=U.get(M);if(j.some(W=>W.command!==`-${M}`&&b.conflicts.has(g[W.key]))){$.conflicts.add(M);continue}_=m(_,j,s)}for(const M of $.updated.values()){if($.conflicts.has(M))continue;const j=U.get(M);if(j.some(W=>W.command!==`-${M}`&&b.conflicts.has(g[W.key]))){$.conflicts.add(M);continue}_=d(_,M,j,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=S;function I(l,c,t){const s=new Set,r=new Set,n=new Set,a=new Set;for(const o of c.removed.values())t.updated.has(o)&&a.add(o);for(const o of t.removed.values())a.has(o)||(c.updated.has(o)?a.add(o):r.add(o));for(const o of c.added.values())a.has(o)||t.added.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.added.values())a.has(o)||(c.added.has(o)?l.updated.has(o)&&a.add(o):s.add(o));for(const o of c.updated.values())a.has(o)||t.updated.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.updated.values())a.has(o)||(c.updated.has(o)?l.updated.has(o)&&a.add(o):n.add(o));return{added:s,removed:r,updated:n,conflicts:a}}function i(l,c,t,s){const r=new Set,n=E(l,s),a=E(c,s),o=t?E(t,s):null,u=p(n,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const g=o?p(o,n):{added:[...n.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const b=o?p(o,a):{added:[...a.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:A,removed:U,updated:O,conflicts:q}=I(u,g,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:U,updated:O,conflicts:q}}function E(l,c){const t=new Map;for(const s of l){const r=c[s.key];let n=t.get(r);n||(n=[],t.set(r,n)),n.push(s)}return t}function f(l){const c=new Map;for(const t of l){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=c.get(s);r||(r=[],c.set(s,r)),r.push(t)}return c}function p(l,c){const t=[...l.keys()],s=[...c.keys()],r=s.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),n=t.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of t){if(n.has(o))continue;const u=l.get(o).map(b=>({...b,key:o})),g=c.get(o).map(b=>({...b,key:o}));(0,k.equals)(u,g,(b,A)=>y(b,A))||a.add(o)}return{added:r,removed:n,updated:a}}function h(l,c,t){const s=[...l.keys()],r=[...c.keys()],n=r.filter(u=>s.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const g=l.get(u).map(A=>({...A,key:t[A.key]})),b=c.get(u).map(A=>({...A,key:t[A.key]}));w(g,b)||o.add(u)}return{added:n,removed:a,updated:o}}function w(l,c){return!(!(0,k.equals)(l.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,s)=>y(t,s))||!(0,k.equals)(l.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,s)=>y(t,s)))}function y(l,c){if(l.command!==c.command||l.key!==c.key)return!1;const t=R.ContextKeyExpr.deserialize(l.when),s=R.ContextKeyExpr.deserialize(c.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!P.equals(l.args,c.args))}function m(l,c,t){for(const s of c)l=D.edit(l,[-1],s,t);return l}function v(l,c,t){const s=C(l);for(let r=s.length-1;r>=0;r--)(s[r].command===c||s[r].command===`-${c}`)&&(l=D.edit(l,[r],void 0,t));return l}function d(l,c,t,s){const r=C(l),n=r.findIndex(a=>a.command===c||a.command===`-${c}`);for(let a=r.length-1;a>=0;a--)(r[a].command===c||r[a].command===`-${c}`)&&(l=D.edit(l,[a],void 0,s));for(let a=t.length-1;a>=0;a--)l=D.edit(l,[n],t[a],s);return l}}),define(te[223],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(R,D,C){const S={},I={},i=new Set;if(!D)return{local:{added:S,updated:I,removed:[...i.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const E=T(R,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:I,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=T(C,R),p=T(C,D),h={},w={},y=new Set,m=new Set;for(const v of f.removed.values())p.updated.has(v)?S[v]=D[v]:y.add(v);for(const v of p.removed.values())m.has(v)||(f.updated.has(v)?m.add(v):i.add(v));for(const v of f.updated.values())m.has(v)||(p.updated.has(v)?E.updated.has(v)&&m.add(v):w[v]=R[v]);for(const v of p.updated.values())m.has(v)||(f.updated.has(v)?E.updated.has(v)&&m.add(v):R[v]!==void 0&&(I[v]=D[v]));for(const v of f.added.values())m.has(v)||(p.added.has(v)?E.updated.has(v)&&m.add(v):h[v]=R[v]);for(const v of p.added.values())m.has(v)||(f.added.has(v)?E.updated.has(v)&&m.add(v):S[v]=D[v]);return{local:{added:S,removed:[...i.values()],updated:I},remote:{added:h,removed:[...y.values()],updated:w},conflicts:[...m.values()]}}e.merge=k;function T(R,D){const C=R?Object.keys(R):[],S=D?Object.keys(D):[],I=S.filter(f=>C.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),i=C.filter(f=>S.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),E=new Set;for(const f of C){if(i.has(f))continue;const p=R[f],h=D[f];p!==h&&E.add(f)}return{added:I,removed:i,updated:E}}function P(R,D){const{added:C,removed:S,updated:I}=T(R,D);return C.size===0&&S.size===0&&I.size===0}e.areSame=P}),define(te[24],ne([0,1,16,18,17,150,39,30,6,88,35]),function(X,e,k,T,P,R,D,C,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const o=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(A=>!!o[A].ignoreSync),g=Object.keys(o).filter(A=>o[A].scope===2||o[A].scope===6),b=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...b])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",u=i.Registry.as(D.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=i.Registry.as(I.Extensions.JSONContribution),b=()=>{const A=E(),U=f().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(D.allSettings.properties).filter(L=>U.indexOf(L)===-1),q=U.filter(L=>A.indexOf(L)===-1),N={items:{type:"string",enum:[...O,...q.map(L=>`-${L}`)]}};g.registerSchema(o,N)};return u.onDidUpdateConfiguration(()=>b())}e.registerConfiguration=p;function h(o){return o&&(0,P.isObject)(o)&&(0,P.isString)(o.id)&&(0,P.isArray)(o.scopes)}e.isAuthenticationProvider=h;var w;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(w=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function y(o,u,g){return g.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=m;var v;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(u,g,b,A){super(u);this.code=g,this.resource=b,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class l extends d{constructor(u,g,b,A,U){super(u,b,void 0,U);this.url=g,this.serverCode=A}}e.UserDataSyncStoreError=l;class c extends d{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=c,function(o){function u(g){if(g instanceof o)return g;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(b&&b[1]){const A=b[2]==="unknown"?void 0:b[2],U=b[3]==="unknown"?void 0:b[3];return new o(g.message,b[1],A,U)}return new o(g.message,"Unknown")}o.toUserDataSyncError=u}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(o){return`sync.enable.${o}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,T.isEqualOrParent)(o,(0,T.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[47],ne([0,1,16,5,19,28,3,32,2,25,17,8,146,21,11,14,46,23,22,37,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=c;let t=class extends S.Disposable{constructor(o,u,g,b,A,U,O,q,N,L,$){super();this.resource=o,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=O,this.telemetryService=q,this.logService=N,this.configurationService=L,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=$.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(o,g,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(g,u,b)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),R.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,g={}){return this._sync(o,!1,u,g)}async apply(o,u={}){try{this.syncHeaders={...u};const g=await this.doApply(o);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,g,b){try{if(this.syncHeaders={...b},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const U=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(o,U);return A=await this.performSync(O,U,u,g),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,b),U=await this.isRemoteDataFromCurrentMachine(A),O=await this.generateSyncPreview({ref:A.ref,syncData:g},b,U,this.getUserDataSyncConfiguration(),R.CancellationToken.None),q=[];for(const N of O){const L=await this.getAcceptResult(N,N.remoteResource,void 0,R.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,R.CancellationToken.None);q.push([N,{...L,remoteChange:$!==0?$:2}])}await this.applyResult(A,b,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const g=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,g,b){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,g,b)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,g,b);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,g,b)}throw A}}async doSync(o,u,g,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(o,u,g,b,U)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g?.content||""));const b=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,R.CancellationToken.None):void 0;return u.acceptResult=b,u.mergeState=g.hasConflicts?"conflict":b?"accepted":"preview",u.localChange=b?b.localChange:g.localChange,u.remoteChange=b?b.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async g=>{const b=await this.getAcceptResult(g,o,u,R.CancellationToken.None);return g.acceptResult=b,g.mergeState="accepted",g.localChange=b.localChange,g.remoteChange=b.remoteChange,g}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const b=g.resourcePreviews.findIndex(({localResource:A,remoteResource:U,previewResource:O})=>this.extUri.isEqual(A,o)||this.extUri.isEqual(U,o)||this.extUri.isEqual(O,o));b!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const U=[...g.resourcePreviews];return U[b]=await u(U[b]),{...g,resourcePreviews:U}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,u,(g,b)=>this.extUri.isEqual(g.previewResource,b.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(o){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,o))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,o))return g.remoteContent;if(this.extUri.isEqual(g.localResource,o))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,g,b,A){const U=await this.isRemoteDataFromCurrentMachine(o),O=await this.generateSyncPreview(o,u,U,b,A),q=[];for(const N of O){const L=N.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)q.push({...N,acceptedResource:L,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=g?await this.getMergeResult(N,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,P.VSBuffer.fromString($?.content||""));const _=$&&!$.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,A):void 0;q.push({...N,acceptResult:_,mergeState:$?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:$?$.localChange:N.localChange,remoteChange:_?_.remoteChange:$?$.remoteChange:N.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const b=u;if(b.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(b.content);if(c(A))return{...u,syncData:A,content:void 0}}catch(o){o instanceof w.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),b={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(b)))}async getRemoteUserData(o){const{ref:u,content:g}=await this.getUserData(o);let b=null;return g!==null&&(b=this.parseSyncData(g)),{ref:u,syncData:b}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,i.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const g=await this.currentMachineIdPromise,b={version:this.version,machineId:g,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(b),u,this.syncHeaders),{ref:u,syncData:b}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([J(1,w.IFileService),J(2,h.IEnvironmentService),J(3,m.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncResourceEnablementService),J(7,v.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,d.IUriIdentityService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(o,u,g,b,A,U,O,q,N,L,$,_){super(u,g,b,A,U,O,q,N,L,$,_);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,g){try{u?await this.writeFileContent(o,u,g):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:g})}catch(b){throw b instanceof w.FileOperationError&&b.fileOperationResult===1||b instanceof w.FileOperationError&&b.fileOperationResult===3?new l.UserDataSyncError(b.message,"LocalPreconditionFailed"):b}}async writeFileContent(o,u,g){await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),g?void 0:u)}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([J(2,w.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,d.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,g,b,A,U,O,q,N,L,$,_,M){super(o,u,g,b,A,U,O,q,N,L,_,M);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,C.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([J(2,w.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,d.IUriIdentityService)],r),e.AbstractJsonFileSynchroniser=r;let n=class{constructor(o,u,g,b,A){this.resource=o,this.environmentService=u,this.logService=g,this.fileService=b,this.extUri=A.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:g})}catch(A){this.logService.error(A)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const g={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(g)))}};n=he([J(1,h.IEnvironmentService),J(2,l.IUserDataSyncLogService),J(3,w.IFileService),J(4,d.IUriIdentityService)],n),e.AbstractInitializer=n}),define(te[224],ne([0,1,5,28,7,3,40,48,25,8,21,11,30,36,14,23,22,37,47,221,98,99,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(u,g){const b=JSON.parse(u.content);if(u.version===1||u.version===2){const A=(await g.getInstalled(0)).filter(U=>U.isBuiltin);for(const U of b)u.version===1&&(U.enabled===!1&&(U.disabled=!0),delete U.enabled),u.version===2&&A.every(O=>!(0,p.areSameExtensions)(O.identifier,U.identifier))&&(U.installed=!0)}return b}function r(u,g,b){const A=b.get((0,p.getExtensionId)(u,g),0)||"{}";return JSON.parse(A)}e.getExtensionStorageState=r;function n(u,g,b,A){A.store((0,p.getExtensionId)(u,g),JSON.stringify(b),0,1)}e.storeExtensionStorageState=n;let a=class gt extends v.AbstractSynchroniser{constructor(g,b,A,U,O,q,N,L,$,_,M,j,W,x,z){super("extensions",b,g,A,U,O,j,W,$,M,z);this.storageService=A,this.extensionManagementService=q,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=_,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,K=>K.some(({local:F})=>!!F)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(g,b){const A=g.syncData?await s(g.syncData,this.extensionManagementService):null,U=b?.skippedExtensions||[],O=b?.syncData?await s(b.syncData,this.extensionManagementService):null,q=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(q),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(q);A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:_}=(0,d.merge)(N,A,O,U,L),M={local:$,remote:_,content:this.getPreviewContent(N,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:_!==null?2:0};return[{skippedExtensions:U,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:A?this.format(A):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(g,b,A,U){const O=[...b,...A],q=new Set,N=L=>{q.add(L.id.toLowerCase()),L.uuid&&q.add(L.uuid)};O.forEach(({identifier:L})=>N(L)),U.forEach(N);for(const L of g)q.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&q.has(L.identifier.uuid)||O.push(L);return this.format(O)}async getMergeResult(g,b){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,b,A,U){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(b,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),U=(0,d.merge)(g.localExtensions,null,null,g.skippedExtensions,A),{local:O,remote:q}=U;return{content:g.localContent,local:O,remote:q,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),U=g.remoteContent?JSON.parse(g.remoteContent):null;if(U!==null){const O=(0,d.merge)(g.localExtensions,U,g.localExtensions,[],A),{local:q,remote:N}=O;return{content:g.remoteContent,local:q,remote:N,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(g,b,A,U){let{skippedExtensions:O,localExtensions:q}=A[0][0],{local:N,remote:L,localChange:$,remoteChange:_}=A[0][1];if($===0&&_===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(q)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(L.all);g=await this.updateRemoteUserData(M,U?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(j=>j.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(j=>j.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(j=>j.identifier.id))}.`:""}`)}b?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(g,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,gt.EXTENSIONS_DATA_URI)){const A=await this.extensionManagementService.getInstalled(),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(A),O=this.getLocalExtensions(A).filter(q=>!U.some(N=>(0,p.areSameExtensions)({id:N},q.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let b=await super.resolveContent(g);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(g)),b){const A=this.parseSyncData(b);if(A)switch(this.extUri.basename(g)){case"extensions.json":return this.format(this.parseExtensions(A))}}return null}format(g){g.sort((U,O)=>!U.identifier.uuid&&O.identifier.uuid?-1:U.identifier.uuid&&!O.identifier.uuid?1:(0,S.compare)(U.identifier.id,O.identifier.id));const b=JSON.stringify(g),A=(0,C.format)(b,void 0,{});return(0,D.applyEdits)(b,A)}async hasLocalData(){try{const g=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(g).some(A=>A.installed||A.disabled))return!0}catch(g){}return!1}async updateLocalExtensions(g,b,A,U){const O=[],q=[],N=await this.extensionManagementService.getInstalled();if(b.length){const $=N.filter(({identifier:_,isBuiltin:M})=>!M&&b.some(j=>(0,p.areSameExtensions)(_,j)));await k.Promises.settled($.map(async _=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,_.identifier.id),await this.extensionManagementService.uninstall(_,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,_.identifier.id),O.push(_.identifier)}))}(g.length||A.length)&&await k.Promises.settled([...g,...A].map(async $=>{const _=N.find(j=>(0,p.areSameExtensions)(j.identifier,$.identifier));if(_&&_.isBuiltin){$.state&&_.manifest.version===$.version&&this.updateExtensionState($.state,_.manifest.publisher,_.manifest.name,_.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),O.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],T.CancellationToken.None))[0];if($.state&&(_?_.manifest.version===$.version:!!M)){const j=_?_.manifest.publisher:M.publisher,W=_?_.manifest.name:M.name;this.updateExtensionState($.state,j,W,_?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),_||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),q.push($)))}catch(j){q.push($),j instanceof f.ExtensionManagementError&&j.code===f.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else q.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const L=[];for(const $ of U)O.some(_=>(0,p.areSameExtensions)(_,$.identifier))||L.push($);for(const $ of q)L.some(_=>(0,p.areSameExtensions)(_.identifier,$.identifier))||L.push($);return L}updateExtensionState(g,b,A,U){const O=r(b,A,this.storageService),q=U?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(b,A),version:U}):void 0;q?q.forEach(N=>{O[N]=g[N]}):Object.keys(g).forEach(N=>O[N]=g[N]),n(b,A,O,this.storageService)}parseExtensions(g){return JSON.parse(g.content)}getLocalExtensions(g){const b=this.extensionEnablementService.getDisabledExtensions();return g.map(({identifier:A,isBuiltin:U,manifest:O})=>{const q={identifier:A,version:O.version};b.some(N=>(0,p.areSameExtensions)(N,A))&&(q.disabled=!0),U||(q.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:A.id,version:O.version});if(N){const L=r(O.publisher,O.name,this.storageService);q.state=Object.keys(L).reduce(($,_)=>(N.includes(_)&&($[_]=L[_]),$),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,P.getErrorMessage)(N))}return q})}};a.EXTENSIONS_DATA_URI=I.URI.from({scheme:t.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=he([J(0,E.IEnvironmentService),J(1,h.IFileService),J(2,w.IStorageService),J(3,t.IUserDataSyncStoreService),J(4,t.IUserDataSyncBackupStoreService),J(5,f.IExtensionManagementService),J(6,f.IGlobalExtensionEnablementService),J(7,c.IIgnoredExtensionsManagementService),J(8,t.IUserDataSyncLogService),J(9,f.IExtensionGalleryService),J(10,i.IConfigurationService),J(11,t.IUserDataSyncResourceEnablementService),J(12,y.ITelemetryService),J(13,l.IExtensionsStorageSyncService),J(14,m.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let o=class extends v.AbstractInitializer{constructor(g,b,A,U,O,q){super("extensions",U,O,A,q);this.extensionManagementService=g,this.ignoredExtensionsManagementService=b}async parseExtensions(g){return g.syncData?await s(g.syncData,this.extensionManagementService):null}generatePreview(g,b){const A=[],U=[],O=[];for(const q of g){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const N=b.find(L=>(0,p.areSameExtensions)(L.identifier,q.identifier));N?(A.push(N),q.disabled&&O.push(q.identifier)):q.installed&&(U.push(q.identifier),q.disabled&&O.push(q.identifier))}return{installedExtensions:A,newExtensions:U,disabledExtensions:O,remoteExtensions:g}}};o=he([J(0,f.IExtensionManagementService),J(1,c.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,E.IEnvironmentService),J(4,t.IUserDataSyncLogService),J(5,m.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(te[225],ne([0,1,26,24]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(C,S,I,i,E){if(!S)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const f=R(C,S);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=I?R(I,S):{added:Object.keys(S).reduce((v,d)=>(v.add(d),v),new Set),removed:new Set,updated:new Set},h=I?R(I,C):{added:Object.keys(C).reduce((v,d)=>(v.add(d),v),new Set),removed:new Set,updated:new Set},w={added:{},removed:[],updated:{}},y=k.deepClone(S),m=!I;for(const v of h.added.values())v!==T.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(v)||(y[v]=C[v]);for(const v of h.updated.values())y[v]=C[v];for(const v of h.removed.values())i.unregistered.includes(v)||delete y[v];for(const v of p.added.values()){const d=S[v];if(i.machine.includes(v)){E.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(I&&h.added.has(v))continue;const l=C[v];l&&l.value===d.value||v===T.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(v)||(l?w.updated[v]=d:w.added[v]=d)}for(const v of p.updated.values()){const d=S[v];if(i.machine.includes(v)){E.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const l=C[v];l&&l.value===d.value||(w.updated[v]=d)}for(const v of p.removed.values()){if(i.machine.includes(v)){E.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||w.removed.push(v)}return{local:w,remote:D(y,S)?null:y}}e.merge=P;function R(C,S){const I=Object.keys(C),i=Object.keys(S),E=i.filter(h=>I.indexOf(h)===-1).reduce((h,w)=>(h.add(w),h),new Set),f=I.filter(h=>i.indexOf(h)===-1).reduce((h,w)=>(h.add(w),h),new Set),p=new Set;for(const h of I){if(f.has(h))continue;const w=C[h],y=S[h];k.equals(w,y)||p.add(h)}return{added:E,removed:f,updated:p}}function D(C,S){const{added:I,removed:i,updated:E}=R(C,S);return I.size===0&&i.size===0&&E.size===0}}),define(te[226],ne([0,1,19,7,3,32,40,48,4,8,29,21,11,14,10,46,23,22,37,47,55,225,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",r=["locale"];function n(b){const A=b.storage?Object.keys(b.storage).sort():[],U={};A.forEach(N=>U[N]=b.storage[N]),b.storage=U;const O=JSON.stringify(b),q=(0,C.format)(O,void 0,{});return(0,D.applyEdits)(O,q)}const a=1;let o=class mt extends d.AbstractSynchroniser{constructor(A,U,O,q,N,L,$,_,M,j){super("globalState",A,N,M,U,O,L,$,q,_,j);this.storageService=M,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(A.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),P.Event.filter(M.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:M.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(A,U,O){const q=A.syncData?JSON.parse(A.syncData.content):null;U=U===null&&O?A:U;const N=U&&U.syncData?JSON.parse(U.syncData.content):null,L=await this.getLocalGlobalState();q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(N),{local:_,remote:M}=(0,c.merge)(L.storage,q?q.storage:null,N?N.storage:null,$,this.logService),j={content:null,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:n(L),localUserData:L,remoteResource:this.remoteResource,remoteContent:q?n(q):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(A,U){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,U,O,q){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(U,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:A.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(A){if(A.remoteContent!==null){const U=JSON.parse(A.remoteContent),{local:O,remote:q}=(0,c.merge)(A.localUserData.storage,U.storage,null,A.storageKeys,this.logService);return{content:A.remoteContent,local:O,remote:q,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(A,U,O,q){let{localUserData:N}=O[0][0],{local:L,remote:$,localChange:_,remoteChange:M}=O[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(L),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const j=JSON.stringify({storage:$});A=await this.updateRemoteUserData(j,q?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}U?.ref!==A.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(A),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:A}){return[{resource:this.extUri.joinPath(A,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(A){if(this.extUri.isEqual(A,mt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return n(O)}if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A))return this.resolvePreviewContent(A);let U=await super.resolveContent(A);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(A)),U){const O=this.parseSyncData(U);if(O)switch(this.extUri.basename(A)){case"globalState.json":return n(JSON.parse(O.content))}}return null}async hasLocalData(){try{const{storage:A}=await this.getLocalGlobalState();if(Object.keys(A).length>1||A[`${s}.locale`]?.value!=="en")return!0}catch(A){}return!1}async getLocalGlobalState(){const A={},U=await this.getLocalArgvContent(),O=(0,R.parse)(U);for(const q of r)O[q]!==void 0&&(A[`${s}${q}`]={version:1,value:O[q]});for(const q of this.storageService.keys(0,0)){const N=this.storageService.get(q,0);N&&(A[q]={version:1,value:N})}return{storage:A}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const A=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),A.value.toString()}catch(A){this.logService.debug((0,T.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:U,updated:O}){const q={},N={},L=(_,M)=>{for(const j of _){if(j.startsWith(s)){q[j.substring(s.length)]=M?M[j].value:void 0;continue}if(M){const W=M[j];W.value!==String(this.storageService.get(j,0))&&(N[j]=W.value)}else this.storageService.get(j,0)!==void 0&&(N[j]=void 0)}};if(L(Object.keys(A),A),L(Object.keys(O),O),L(U),Object.keys(q).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(q),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(N))this.storageService.store(_,N[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(A){const U=await this.getLocalArgvContent();let O=U;for(const q of Object.keys(A))O=(0,l.edit)(O,[q],A[q],{});U!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(A){const U=this.storageService.keys(0,0),O=this.storageService.keys(0,1),q=[...U,...O],N=A?.storage?Object.keys(A.storage).filter(L=>!L.startsWith(s)&&!q.includes(L)&&this.storageService.get(L,0)!==void 0):[];if(!S.isWeb){const L=[...t.ALL_SYNC_RESOURCES.map($=>(0,t.getEnablementKey)($)),t.SYNC_SERVICE_URL_TYPE];N.push(...L),O.push(...L)}return{user:U,machine:O,unregistered:N}}};o.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:t.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([J(0,p.IFileService),J(1,t.IUserDataSyncStoreService),J(2,t.IUserDataSyncBackupStoreService),J(3,t.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,t.IUserDataSyncResourceEnablementService),J(6,m.ITelemetryService),J(7,E.IConfigurationService),J(8,y.IStorageService),J(9,v.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let u=class extends d.AbstractInitializer{constructor(A,U,O,q,N){super("globalState",O,q,U,N);this.storageService=A}async doInitialize(A){const U=A.syncData?JSON.parse(A.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},q={};for(const N of Object.keys(U.storage))N.startsWith(s)?O[N.substring(s.length)]=U.storage[N].value:this.storageService.get(N,0)===void 0&&(q[N]=U.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(L){}for(const L of Object.keys(O))N=(0,l.edit)(N,[L],O[L],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(N))}if(Object.keys(q).length)for(const N of Object.keys(q))this.storageService.store(N,q[N],0,0)}};u=he([J(0,y.IStorageService),J(1,p.IFileService),J(2,f.IEnvironmentService),J(3,t.IUserDataSyncLogService),J(4,v.IUriIdentityService)],u),e.GlobalStateInitializer=u;let g=class{constructor(A,U,O,q,N){this.userDataSyncStoreClient=A,this.storageService=U,this.environmentService=O,this.fileService=q,this.logService=N}getSyncStoreType(A){return this.parseGlobalState(A)?.storage[t.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const U=(0,t.createSyncHeaders)((0,i.generateUuid)());try{return await this.doSync(A,U)}catch(O){if(O instanceof t.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(A,U)}throw O}}async doSync(A,U){const O=await this.userDataSyncStoreClient.read("globalState",null,U),q=this.parseGlobalState(O)||{storage:{}};q.storage[t.SYNC_SERVICE_URL_TYPE]={value:A,version:a};const N=await(0,w.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),L={version:a,machineId:N,content:n(q)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(L),O.ref,U)}parseGlobalState({content:A}){if(!A)return null;const U=JSON.parse(A);if((0,d.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};g=he([J(1,y.IStorageService),J(2,f.IEnvironmentService),J(3,p.IFileService),J(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[227],ne([0,1,16,19,3,32,4,17,147,21,11,14,23,22,37,47,222,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(c,t,s){try{const r=JSON.parse(c);if(!t)return(0,C.isUndefined)(r.all)?null:r.all;switch(D.OS){case 2:return(0,C.isUndefined)(r.mac)?null:r.mac;case 3:return(0,C.isUndefined)(r.linux)?null:r.linux;case 1:return(0,C.isUndefined)(r.windows)?null:r.windows}}catch(r){return s.error(r),null}}e.getKeybindingsContentFromSyncContent=v;let d=class extends w.AbstractJsonFileSynchroniser{constructor(t,s,r,n,a,o,u,g,b,A,U){super(u.keybindingsResource,"keybindings",o,u,g,t,s,a,A,r,b,n,U);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(n.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(t,s,r,n){const a=t.syncData?v(t.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&r?t:s;const o=s?this.getKeybindingsContentFromLastSyncUserData(s):null,u=await this.getLocalFileContent(),g=await this.getFormattingOptions();let b=null,A=!1,U=!1,O=!1;if(a){let N=u?u.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new m.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==N||o!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const L=await(0,y.merge)(N,a,o,g,this.userDataSyncUtilService);L.hasChanges&&(b=L.mergeContent,O=L.hasConflicts,A=O||L.mergeContent!==N,U=O||L.mergeContent!==a)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=u.value.toString(),U=!0);const q={content:b,localChange:A?u?2:1:0,remoteChange:U?2:0,hasConflicts:O};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){return t.previewResult}async getAcceptResult(t,s,r,n){if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,r,n){const{fileContent:a}=r[0][0];let{content:o,localChange:u,remoteChange:g}=r[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(o||"[]",a,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const b=this.toSyncContent(o||"[]",t.syncData?.content);t=await this.updateRemoteUserData(b,n?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(b){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(t,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=(0,R.parse)(t.value.toString());if((0,k.isNonEmptyArray)(s))return!0}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"keybindings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const r=this.parseSyncData(s);if(r)switch(this.extUri.basename(t)){case"keybindings.json":return v(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(t.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(t,s){let r={};try{r=JSON.parse(s||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=t,D.OS){case 2:r.mac=t;break;case 3:r.linux=t;break;case 1:r.windows=t;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,I.IConfigurationService),J(4,m.IUserDataSyncResourceEnablementService),J(5,E.IFileService),J(6,i.IEnvironmentService),J(7,f.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let l=class extends w.AbstractInitializer{constructor(t,s,r,n){super("keybindings",s,r,t,n)}async doInitialize(t){const s=t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(s)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource),s=(0,R.parse)(t.value.toString());return!(0,k.isNonEmptyArray)(s)}catch(t){return t.fileOperationResult===1}}getKeybindingsContentFromSyncContent(t){try{return v(t,!0,this.logService)}catch(s){return this.logService.error(s),null}}};l=he([J(0,E.IFileService),J(1,i.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(te[228],ne([0,1,16,32,40,48,26,55,24]),function(X,e,k,T,P,R,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(o,u,g){let b=[];g?b=E(g):b=i(u);const A=[],U=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const O of b)O.startsWith("-")?U.push(O.substring(1)):A.push(O);return(0,k.distinct)([...o,...A].filter(O=>U.indexOf(O)===-1))}e.getIgnoredSettings=I;function i(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const u=(0,T.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(o,u,g,b){if(g.length){const A=a(u),U=(0,T.parse)(u),O=(0,T.parse)(o),q=[];for(const N of g){const L=U[N],$=O[N];L===void 0?o=C.edit(o,[N],void 0,b):$!==void 0?o=C.edit(o,[N],L,b):q.push(c(N,A))}q.sort((N,L)=>N.startOffset-L.startOffset),q.forEach(N=>o=m(N.setting.key,u,o,b))}return o}e.updateIgnoredSettings=f;function p(o,u,g,b,A,U){const O=f(o,u,b,U),q=g!==O,N=g!==u;if(!q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(N&&!q)return{conflictsSettings:[],localContent:f(u,o,b,U),remoteContent:null,hasConflicts:!1};if(g===null&&w(o)){const H=h(o,u,b)?null:f(u,o,b,U);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let L=o,$=u;const _=(0,T.parse)(o),M=(0,T.parse)(u),j=g?(0,T.parse)(g):null,W=b.reduce((H,re)=>(H.add(re),H),new Set),x=y(_,M,W),z=y(j,_,W),K=y(j,M,W),F=new Map,B=new Set,V=H=>{B.add(H);const re=A.filter(({key:ie})=>ie===H)[0];re?(L=C.edit(L,[H],re.value,U),$=C.edit($,[H],re.value,U)):F.set(H,{key:H,localValue:_[H],remoteValue:M[H]})};for(const H of z.removed.values())K.updated.has(H)?V(H):$=C.edit($,[H],void 0,U);for(const H of K.removed.values())B.has(H)||(z.updated.has(H)?V(H):L=C.edit(L,[H],void 0,U));for(const H of z.updated.values())B.has(H)||(K.updated.has(H)?x.updated.has(H)&&V(H):$=C.edit($,[H],_[H],U));for(const H of K.updated.values())B.has(H)||(z.updated.has(H)?x.updated.has(H)&&V(H):L=C.edit(L,[H],M[H],U));for(const H of z.added.values())B.has(H)||(K.added.has(H)?x.updated.has(H)&&V(H):$=m(H,L,$,U));for(const H of K.added.values())B.has(H)||(z.added.has(H)?x.updated.has(H)&&V(H):L=m(H,$,L,U));const Q=F.size>0||!h(L,$,b),Z=Q||!h(L,o,[]),G=Q||!h($,u,[]);return{localContent:Z?L:null,remoteContent:G?$:null,conflictsSettings:[...F.values()],hasConflicts:Q}}e.merge=p;function h(o,u,g){if(o===u)return!0;const b=(0,T.parse)(o),A=(0,T.parse)(u),U=g.reduce((N,L)=>(N.add(L),N),new Set),O=a(o).filter(N=>!(N.setting&&U.has(N.setting.key))),q=a(u).filter(N=>!(N.setting&&U.has(N.setting.key)));if(O.length!==q.length)return!1;for(let N=0;N<O.length;N++){const L=O[N],$=q[N];if(L.setting&&$.setting){if(L.setting.key!==$.setting.key||!D.equals(b[L.setting.key],A[L.setting.key]))return!1}else if(!L.setting&&!$.setting){if(L.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function w(o){return o?a(o).length===0:!0}e.isEmpty=w;function y(o,u,g){const b=o?Object.keys(o).filter(N=>!g.has(N)):[],A=Object.keys(u).filter(N=>!g.has(N)),U=A.filter(N=>b.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),O=b.filter(N=>A.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),q=new Set;if(o)for(const N of b){if(O.has(N))continue;const L=o[N],$=u[N];D.equals(L,$)||q.add(N)}return{added:U,removed:O,updated:q}}function m(o,u,g,b){const A=(0,T.parse)(u),U=a(u),O=a(g),q=v(o,U,O);return d(g,o,A[o],q,O,b)}e.addSetting=m;function v(o,u,g){const b=u.findIndex(U=>U.setting?.key===o),A=u[b-1];if(A){if(A.setting){const O=c(A.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(b,u);if(O){const q=c(O.setting.key,g);if(q){const N=s(g.indexOf(q),g),L=r(u,O,u[b]);if(N){const $=r(g,q,N),_=n(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.indexOf(N),insertAfter:!1}}else{const $=r(g,q,g[g.length-1]),_=n(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const U=u[b+1];if(U)if(U.setting){const O=c(U.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=s(b,u);if(O){const q=c(O.setting.key,g);if(q){const N=t(g.indexOf(q),g),L=r(u,u[b],O);if(N){const $=r(g,N,q),_=n(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:g.indexOf(N),insertAfter:!0}}else{const $=r(g,g[0],q),_=n(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function d(o,u,g,b,A,U){let O;return b.index===-1?O=(0,P.setProperty)(o,[u],g,U):O=l(o,u,g,b,A,U).map(q=>(0,P.withFormatting)(o,q,U)[0]),(0,P.applyEdits)(o,O)}function l(o,u,g,b,A,U){const O=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,q=(0,R.getEOL)(U,o),N=A[b.index];if(b.insertAfter){const L=[];if(N.setting)L.push({offset:N.endOffset,length:0,content:","+O});else{const $=s(b.index,A),_=t(b.index,A),M=_?.setting?.commaOffset;_&&M===void 0&&L.push({offset:_.endOffset,length:0,content:","});const j=M!==void 0&&M>N.endOffset;L.push({offset:j?M+1:N.endOffset,length:0,content:$?q+O+",":q+O})}return L}else{if(N.setting)return[{offset:N.startOffset,length:0,content:O+","}];const L=(A[b.index-1]&&!A[b.index-1].setting?q:"")+O+(s(b.index,A)?",":"")+q;return[{offset:N.startOffset,length:0,content:L}]}}function c(o,u){return u.filter(g=>g.setting?.key===o)[0]}function t(o,u){for(let g=o-1;g>=0;g--)if(u[g].setting)return u[g]}function s(o,u){for(let g=o+1;g<u.length;g++)if(u[g].setting)return u[g]}function r(o,u,g){const b=o.indexOf(u),A=o.indexOf(g);return o.filter((U,O)=>b<O&&O<A)}function n(o,u){if(o.length&&u.length){let g=0;for(;g<u.length&&g<o.length;g++)if(o[g].value!==u[g].value)return u[g-1];return u[g-1]}}function a(o){const u=[];let g=-1,b,A;const U={onObjectBegin:O=>{g++},onObjectProperty:(O,q,N)=>{g===0&&(b=q,A=O)},onObjectEnd:(O,q)=>{g--,g===0&&u.push({startOffset:b,endOffset:O+q,value:o.substring(b,O+q),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(O,q)=>{g++},onArrayEnd:(O,q)=>{g--,g===0&&u.push({startOffset:b,endOffset:O+q,value:o.substring(b,O+q),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(O,q,N)=>{g===0&&u.push({startOffset:b,endOffset:q+N,value:o.substring(b,q+N),setting:{key:A,commaOffset:void 0}})},onSeparator:(O,q,N)=>{if(g===0&&O===","){let L=u.length-1;for(;L>=0&&!u[L].setting;L--);const $=u[L];$&&u.splice(L,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:q}})}},onComment:(O,q)=>{g===0&&u.push({startOffset:O,endOffset:O+q,value:o.substring(O,O+q)})}};return(0,T.visit)(o,U),u}}),define(te[229],ne([0,1,19,3,40,148,21,89,85,11,30,14,23,22,37,47,55,228,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function l(r){const n=JSON.parse(r);return d(n)?n:{settings:r}}e.parseSettingsSyncContent=l;let c=class extends w.AbstractJsonFileSynchroniser{constructor(n,a,o,u,g,b,A,U,O,q,N,L,$){super(a.settingsResource,"settings",n,a,o,u,g,O,q,b,A,U,$);this.extensionManagementService=N,this.userConfigurationFileService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(n){const a=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(n,a),u=this.getSettingsSyncContent(o),g=new C.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&g.parse(u.settings),g.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(n,a,o){const u=await this.getLocalFileContent(),g=await this.getFormattingOptions(),b=this.getSettingsSyncContent(n);a=a===null&&o?n:a;const A=a?this.getSettingsSyncContent(a):null,U=await this.getIgnoredSettings();let O=null,q=!1,N=!1,L=!1;if(b){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(_,b.settings,A?A.settings:null,U,[],g);O=M.localContent||M.remoteContent,q=M.localContent!==null,N=M.remoteContent!==null,L=M.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),O=u.value.toString(),N=!0);const $={content:O,localChange:q?2:0,remoteChange:N?2:0,hasConflicts:L};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:b?b.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(n,a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...n.previewResult,content:n.previewResult.content?(0,m.updateIgnoredSettings)(n.previewResult.content,"{}",u,o):null}}async getAcceptResult(n,a,o,u){const g=await this.getFormattingOptions(),b=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:n.fileContent?(0,m.updateIgnoredSettings)(n.fileContent.value.toString(),"{}",b,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:n.remoteContent!==null?(0,m.updateIgnoredSettings)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return o===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:o!==null?(0,m.updateIgnoredSettings)(o,n.fileContent?n.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(n,a,o,u){const{fileContent:g}=o[0][0];let{content:b,localChange:A,remoteChange:U}=o[0][1];if(A===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),b=b?b.trim():"{}",b=b||"{}",this.validateContent(b),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(b,g,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),U!==0){const O=await this.getFormattingOptions(),q=this.getSettingsSyncContent(n),N=await this.getIgnoredSettings(b);b=(0,m.updateIgnoredSettings)(b,q?q.settings:"{}",N,O),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),n=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(b)),u?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(O){}a?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(n),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const a=await this.getFormattingOptions(),o=(0,y.edit)(n.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,m.isEmpty)(o)}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"settings.json"),comparableResource:a}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let a=await super.resolveContent(n);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(n)),a){const o=this.parseSyncData(a);if(o){const u=this.parseSettingsSyncContent(o.content);if(u)switch(this.extUri.basename(n)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(n){let a=await super.resolvePreviewContent(n);if(a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();a=(0,m.updateIgnoredSettings)(a,"{}",u,o)}return a}getSettingsSyncContent(n){return n.syncData?this.parseSettingsSyncContent(n.syncData.content):null}parseSettingsSyncContent(n){try{return l(n)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(n){return{settings:n}}async getIgnoredSettings(n){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:g})=>!!g)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(a,this.configurationService,n)}async writeFileContent(n,a,o){await this.userConfigurationFileService.write(k.VSBuffer.fromString(n),o?void 0:{etag:a.etag,mtime:a.mtime})}validateContent(n){if(this.hasErrors(n))throw new v.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const n=await this.getLocalFileContent();if(!n)return;const a=JSON.parse(n.value.toString());if(!s(a))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const o=this.parseSettingsSyncContent(a.content);if(!o||!o.settings)return;let u=o.settings;const g=await this.getFormattingOptions();for(const b in a)if(["version","content","machineId"].indexOf(b)===-1&&a[b]!==void 0){const A=(0,P.setProperty)(u,[b],a[b],g);A.length&&(u=(0,P.applyEdits)(u,A))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(u))}catch(n){}}};c=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,f.IStorageService),J(3,v.IUserDataSyncStoreService),J(4,v.IUserDataSyncBackupStoreService),J(5,v.IUserDataSyncLogService),J(6,v.IUserDataSyncUtilService),J(7,D.IConfigurationService),J(8,v.IUserDataSyncResourceEnablementService),J(9,p.ITelemetryService),J(10,i.IExtensionManagementService),J(11,S.IUserConfigurationFileService),J(12,h.IUriIdentityService)],c),e.SettingsSynchroniser=c;let t=class extends w.AbstractInitializer{constructor(n,a,o,u){super("settings",a,o,n,u)}async doInitialize(n){const a=n.syncData?this.parseSettingsSyncContent(n.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(n.value.toString().trim())}catch(n){return n.fileOperationResult===1}}parseSettingsSyncContent(n){try{return l(n)}catch(a){this.logService.error(a)}return null}};t=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,v.IUserDataSyncLogService),J(3,h.IUriIdentityService)],t),e.SettingsInitializer=t;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(te[230],ne([0,1,19,3,26,21,11,14,23,22,37,47,223,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,v,d,l,c,t,s,r,n,a){super("snippets",v,m,d,l,c,r,n,t,s,a);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,v,d){const l=await this.getSnippetsFileContents(),c=this.toSnippetsContents(l),t=m.syncData?this.parseSnippets(m.syncData):null;v=v===null&&d?m:v;const s=v&&v.syncData?this.parseSnippets(v.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(c,t,s);return this.getResourcePreviews(r,l,t||{})}async getMergeResult(m,v){return m.previewResult}async getAcceptResult(m,v,d,l){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return d===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:d,localChange:d===null?m.fileContent!==null?3:0:2,remoteChange:d===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(m,v,d,l){const c=d.map(([t,s])=>({...t,acceptResult:s}));c.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,l)),c.some(({remoteChange:t})=>t!==0)&&(m=await this.updateRemoteSnippets(c,m,l)),v?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of c)try{await this.fileService.del(t)}catch(s){}}getResourcePreviews(m,v,d){const l=new Map;for(const c of Object.keys(m.local.added)){const t={content:m.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};l.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.local.updated)){const t={content:m.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.remote.added)){const t={content:m.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(m.remote.updated)){const t={content:m.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c],localContent:v[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of m.conflicts){const t={content:v[c]?v[c].value.toString():null,hasConflicts:!0,localChange:v[c]?2:1,remoteChange:d[c]?2:1};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c]||null,localContent:v[c]?v[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(v))if(!l.has(c)){const t={content:v[c]?v[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};l.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[c]||null,localContent:v[c]?v[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...l.values()]}async getAssociatedResources({uri:m}){let v=await super.resolveContent(m);if(v){const d=this.parseSyncData(v);if(d){const l=this.parseSnippets(d),c=[];for(const t of Object.keys(l)){const s=this.extUri.joinPath(m,t),r=this.extUri.joinPath(this.snippetsFolder,t),n=await this.fileService.exists(r);c.push({resource:s,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let v=await super.resolveContent(m);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(m)),v){const d=this.parseSyncData(v);if(d)return this.parseSnippets(d)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const v={};for(const d of m)d.fileContent&&(v[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(m,v){for(const{fileContent:d,acceptResult:l,localResource:c,remoteResource:t,localChange:s}of m)if(s!==0){const r=t?this.extUri.basename(t):this.extUri.basename(c),n=this.extUri.joinPath(this.snippetsFolder,r);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,k.VSBuffer.fromString(l.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,k.VSBuffer.fromString(l.content),v?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(m,v,d){const l=v.syncData?this.parseSnippets(v.syncData):{},c=(0,P.deepClone)(l);for(const{acceptResult:t,localResource:s,remoteResource:r,remoteChange:n}of m)if(n!==0){const a=s?this.extUri.basename(s):this.extUri.basename(r);n===3?delete c[a]:c[a]=t.content}return(0,f.areSame)(l,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(c),d?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const v={};for(const d of Object.keys(m))v[d]=m[d].value.toString();return v}async getSnippetsFileContents(){const m={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof C.FileOperationError&&d.fileOperationResult===1)return m;throw d}for(const d of v.children||[]){const l=d.resource,c=this.extUri.extname(l);if(c===".json"||c===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,l),s=await this.fileService.readFile(l);m[t]=s}}return m}};h=he([J(0,D.IEnvironmentService),J(1,C.IFileService),J(2,S.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,R.IConfigurationService),J(7,p.IUserDataSyncResourceEnablementService),J(8,I.ITelemetryService),J(9,i.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let w=class extends E.AbstractInitializer{constructor(m,v,d,l){super("snippets",v,d,m,l)}async doInitialize(m){const v=m.syncData?JSON.parse(m.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(v)){const c=v[l];if(c){const t=this.extUri.joinPath(this.environmentService.snippetsHome,l);await this.fileService.createFile(t,k.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=he([J(0,C.IFileService),J(1,D.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,i.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(te[64],ne([0,1,3,2,6,24]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,P.createDecorator)("IUserDataSyncAccountService");let D=class extends T.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};D=he([J(0,R.IUserDataSyncStoreService)],D),e.UserDataSyncAccountService=D}),define(te[231],ne([0,1,5,19,58,2,18,21,11,14,24]),function(X,e,k,T,P,R,D,C,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends R.Disposable{constructor(p,h,w,y){super();this.environmentService=p,this.fileService=h,this.configurationService=w,this.logService=y,i.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,p),w=await this.fileService.resolve(h);return w.children?w.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const w=await this.getAllRefs(p);w.length&&(h=w[w.length-1].ref)}if(h){const w=(0,D.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(w)).value.toString()}return null}async backup(p,h){const w=(0,D.joinPath)(this.environmentService.userDataSyncHome,p),y=(0,D.joinPath)(w,`${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(y,T.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(y){return}const w=await this.fileService.resolve(h);if(w.children){const y=w.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=y.filter(l=>Date.now()-this.getCreationTime(l)>m);const d=y.length-v.length;d<10&&(v=v.slice(10-d)),await k.Promises.settled(v.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([J(0,S.IEnvironmentService),J(1,I.IFileService),J(2,C.IConfigurationService),J(3,i.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[232],ne([0,1,2,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class R{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class D{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=D;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class S{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class I{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class i extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:T.URI.revive(f.url),type:f.type,defaultUrl:T.URI.revive(f.defaultUrl),insidersUrl:T.URI.revive(f.insidersUrl),stableUrl:T.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[233],ne([0,1,11,10]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends T.AbstractLogger{constructor(D,C){super();this.logger=this._register(D.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(D,...C){this.logger.trace(D,...C)}debug(D,...C){this.logger.debug(D,...C)}info(D,...C){this.logger.info(D,...C)}warn(D,...C){this.logger.warn(D,...C)}error(D,...C){this.logger.error(D,...C)}critical(D,...C){this.logger.critical(D,...C)}flush(){this.logger.flush()}};P=he([J(0,T.ILoggerService),J(1,k.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(te[65],ne([0,1,3,2,4,25,151,11,14,6,27,46,23,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let w=class tt extends T.Disposable{constructor(m,v,d,l,c,t){super();this.storageService=d,this.userDataSyncStoreService=l,this.logService=c,this.productService=t,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,v,d)}async getMachines(m){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(l=>({...l,isCurrent:l.id===v}))}async addCurrentMachine(m){const v=await this.currentMachineIdPromise,d=await this.readMachinesData(m);d.machines.some(({id:l})=>l===v)||(d.machines.push({id:v,name:this.computeCurrentMachineName(d.machines)}),await this.writeMachinesData(d))}async removeCurrentMachine(m){const v=await this.currentMachineIdPromise,d=await this.readMachinesData(m),l=d.machines.filter(({id:c})=>c!==v);l.length!==d.machines.length&&(d.machines=l,await this.writeMachinesData(d))}async renameMachine(m,v,d){const l=await this.currentMachineIdPromise,c=await this.readMachinesData(d),t=c.machines.find(({id:s})=>s===m);t&&(t.name=v,await this.writeMachinesData(c),c.machines.some(({id:s})=>s===l)&&this.storageService.store(h,v,0,1))}async setEnablement(m,v){const d=await this.readMachinesData(),l=d.machines.find(({id:c})=>c===m);l&&(l.disabled=v?void 0:!0,await this.writeMachinesData(d))}computeCurrentMachineName(m){const v=this.storageService.get(h,0);if(v)return v;const d=`${this.productService.nameLong} (${(0,P.PlatformToString)(P.isWeb?0:P.platform)})`,l=new RegExp(`${(0,R.escapeRegExpCharacters)(d)}\\s#(\\d+)`);let c=0;for(const t of m){const s=l.exec(t.name),r=s?parseInt(s[1]):0;c=r>c?r:c}return`${d} #${c+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const v=this.parse(this.userData);if(v.version!==tt.VERSION)throw new Error((0,D.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(m){const v=JSON.stringify(m),d=await this.userDataSyncStoreService.write(tt.RESOURCE,v,this.userData?.ref||null);this.userData={ref:d,content:v},this._onDidChange.fire()}async readUserData(m){if(this.userData){const v=m&&m.latest?m.latest[tt.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(v){this.logService.error(v)}return{version:tt.VERSION,machines:[]}}};w.VERSION=1,w.RESOURCE="machines",w=he([J(0,C.IEnvironmentService),J(1,S.IFileService),J(2,f.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,i.IProductService)],w),e.UserDataSyncMachinesService=w}),define(te[100],ne([0,1,5,58,38,7,3,2,4,18,8,149,11,27,23,22,24,64,65]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const d="sync.enable",l="sync.disableMachineEventually",c="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let r=class extends C.Disposable{constructor(u,g,b){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=b,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(d,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(d,u,0,1)}onDidStorageChange(u){if(u.scope===0&&d===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([J(0,h.IStorageService),J(1,f.IEnvironmentService),J(2,y.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let n=class extends C.Disposable{constructor(u,g,b,A,U,O,q,N,L,$,_){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=b,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=U,this.logService=O,this.userDataSyncAccountService=q,this.telemetryService=N,this.userDataSyncMachinesService=L,this.storageService=$,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new k.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(q.onDidChangeAccount(()=>this.updateAutoSync())),this._register(b.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(D.Event.debounce(U.onDidChangeLocal,(M,j)=>M?[...M,j]:[j],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(D.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?i.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(b=>this.onDidFinishSync(b))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,b){try{this.userDataSyncAccountService.account&&!b&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(g)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(d,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=y.UserDataSyncError.toUserDataSyncError(u);g instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?S.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(l,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(l,0,!1)}stopDisableMachineEventually(){this.storageService.remove(l,0)}async triggerSync(u,g,b){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",b)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([J(0,p.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncResourceEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,m.IUserDataSyncAccountService),J(7,w.ITelemetryService),J(8,v.IUserDataSyncMachinesService),J(9,h.IStorageService),J(10,y.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class a extends C.Disposable{constructor(u,g,b,A,U,O,q,N){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=b,this.userDataSyncStoreService=A,this.userDataSyncService=U,this.userDataSyncMachinesService=O,this.logService=q,this.storageService=N,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new D.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new D.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const b=(0,k.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(U){if((0,R.isPromiseCanceledError)(U))return}return this.doSync(u,g,A)});return this.syncPromise=b,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,I.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,I.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,I.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,b){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),b.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const U=this.storageService.get(c,0);if(U&&this.manifest&&U!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(b.isCancellationRequested)return;const q=O.find(N=>N.isCurrent);if(q?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new y.UserDataAutoSyncError((0,P.toErrorMessage)(N),N instanceof y.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==U&&this.storageService.store(c,this.manifest.session,0,1),b.isCancellationRequested)return;q||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(U){this.logService.error(U),A=U}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[234],ne([0,1,3,2,4,23,22,24]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends T.Disposable{constructor(i,E){super();this.storageService=i,this.telemetryService=E,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(i){return this.storageService.getBoolean((0,C.getEnablementKey)(i),0,!0)}setResourceEnablement(i,E){if(this.isResourceEnabled(i)!==E){const f=(0,C.getEnablementKey)(i);this.telemetryService.publicLog2(f,{enabled:E}),this.storeResourceEnablement(f,E)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,E){this.storageService.store(i,E,0,P.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const E=C.ALL_SYNC_RESOURCES.filter(f=>(0,C.getEnablementKey)(f)===i.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}}};S=he([J(0,R.IStorageService),J(1,D.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[235],ne([0,1,16,5,38,7,3,2,18,29,21,6,23,22,224,226,227,229,230,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let c=class extends C.Disposable{constructor(n,a,o,u,g,b,A){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=g,this.telemetryService=b,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new D.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new D.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(w.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(l,0,void 0),this.onDidChangeLocal=D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeLocal,()=>U.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,a){await this.checkEnablement();const o=(0,I.generateUuid)();try{const A=(0,d.createSyncHeaders)(o);a&&(A["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,A)}catch(A){const U=d.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(U,o),U}let u=!1;const g=this;let b;return{manifest:n,run(){if(u)throw new Error("Can run a task only once");return b=(0,T.createCancelablePromise)(A=>g.sync(n,o,A)),b.finally(()=>b=void 0)},async stop(){if(b&&b.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,I.generateUuid)(),a=(0,d.createSyncHeaders)(n);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const g=d.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,n),g}return new t(n,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(n,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,d.createSyncHeaders)(a);for(const b of this.synchronisers){if(o.isCancellationRequested)return;try{await b.sync(n,g)}catch(A){let U=!1;if(A instanceof d.UserDataSyncError)switch(A.code){case"TooLarge":A=new d.UserDataSyncError(A.message,A.code,b.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const O=d.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(O,a),U)throw O;this.logService.error(A),this.logService.error(`${b.resource}: ${(0,P.toErrorMessage)(A)}`),this._syncErrors.push([b.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(g){const b=d.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(b,a),b}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(a){this.logService.error(a)}}async replace(n){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(n))return}async accept(n,a,o,u){await this.checkEnablement();const g=this.getSynchroniser(n);await g.accept(a,o),u&&await g.apply(!1,(0,d.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(n){for(const a of this.synchronisers){const o=await a.resolveContent(n);if(o)return o}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,a){return this.getSynchroniser(n).getAssociatedResources(a)}getMachineId(n,a){return this.getSynchroniser(n).getMachineId(a)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of n)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(l,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(a){this.logService.error(`${n.resource}: ${(0,P.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const a=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,k.equals)(this._conflicts,n,([a,o],[u,g])=>a===a&&(0,k.equals)(o,g,(b,A)=>(0,S.isEqual)(b.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,a){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof d.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof d.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(s)])}getSynchroniser(n){return this.synchronisers.find(a=>a.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([J(0,d.IUserDataSyncStoreService),J(1,d.IUserDataSyncStoreManagementService),J(2,E.IInstantiationService),J(3,i.IConfigurationService),J(4,d.IUserDataSyncLogService),J(5,p.ITelemetryService),J(6,f.IStorageService)],c),e.UserDataSyncService=c;class t extends C.Disposable{constructor(n,a,o,u,g,b){super();this.id=n,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=g,this.logService=b,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new D.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,a){try{return await this.performAction(n,o=>o.accept(n,a))}catch(o){throw this.logService.error(o),o}}async merge(n){try{return n?await this.performAction(n,a=>a.merge(n)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(n){try{return await this.performAction(n,a=>a.discard(n))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&n.push(o.previewResource);for(const a of n)await this.discard(a);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===a);for(const b of o.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&await u.merge(b.previewResource);const g=await u.apply(!1,this.syncHeaders);g&&n.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,a]of this.previews){this.synchronizingResources.push([n,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===n);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,a]of this.previews){this.synchronizingResources.push([n,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===n);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(a){(0,R.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(n,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:L,previewResource:$,remoteResource:_})=>(0,S.isEqual)(n,L)||(0,S.isEqual)(n,$)||(0,S.isEqual)(n,_)));if(o===-1)return this.previews;const[u,g]=this.previews[o],b=g.resourcePreviews.find(({localResource:N,remoteResource:L,previewResource:$})=>(0,S.isEqual)(N,n)||(0,S.isEqual)(L,n)||(0,S.isEqual)($,n));if(!b)return this.previews;let A=this.synchronizingResources.find(N=>N[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(N=>(0,S.isEqual)(N,b.localResource))||(A[1].push(b.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const U=this.synchronisers.find(N=>N.resource===this.previews[o][0]),O=await a(U);O?this.previews.splice(o,1,this.toSyncResourcePreview(U.resource,O)):this.previews.splice(o,1);const q=this.synchronizingResources.findIndex(N=>N[0]===u);return this.synchronizingResources[q][1].splice(A[1].findIndex(N=>(0,S.isEqual)(N,b.localResource)),1),A[1].length||(this.synchronizingResources.splice(q,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===a);let g=o;for(const b of o.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&(g=await u.merge(b.previewResource));g&&n.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(n.isCancellationRequested)return[];const g=await u.preview(this.manifest,o,this.syncHeaders);g&&a.push(this.toSyncResourcePreview(u.resource,g))}return a}async getUserDataSyncConfiguration(){const n=this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...n,...a}}toSyncResourcePreview(n,a){return[n,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[236],ne([0,1,3,2,17,8,24]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,p){try{return await this._call(E,f,p)}catch(h){throw this.logService.error(h),h}}async _call(E,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],R.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),w=p[0],y=this.getManualSyncTask(w);switch(p=p.slice(1),h){case"preview":return y.preview();case"accept":return y.accept(R.URI.revive(p[0]),p[1]);case"merge":return y.merge(R.URI.revive(p[0]));case"discard":return y.discard(R.URI.revive(p[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new T.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=C;class S extends T.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,h){return E.call(f,p,h).then(null,w=>{throw D.UserDataSyncError.toUserDataSyncError(w)})},listen(f,p){return E.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,h])=>{this.updateStatus(f),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(w=>this.updateStatus(w))),this._register(this.channel.listen("onDidChangeLastSyncTime")(w=>this.updateLastSyncTime(w)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,h])=>[p,D.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),h=this,w=new I(E,f,p,{async call(y,m,v){return h.channel.call(`manualSync/${y}`,[E,...(0,P.isArray)(m)?m:[m]],v)},listen(y,m){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${y}`,m),v=>!w.isDiposed()&&v.manualSyncTaskId===E),v=>v.data)}});return w}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,p,h){return this.channel.call("accept",[E,f,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:h,comparableResource:w})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(w)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,p])=>[f,p.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=S;class I extends T.Disposable{constructor(E,f,p,h){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=p;const w=this;this.channel={async call(y,m,v){try{const d=await h.call(y,m,v);return w.isDiposed()||(w._status=await h.call("_getStatus")),d}catch(d){throw D.UserDataSyncError.toUserDataSyncError(d)}},listen(y,m){return h.listen(y,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const p=await this.channel.call("accept",[E,f]);return this.deserializePreviews(p)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(te[237],ne([0,1,5,28,7,3,2,110,4,18,17,8,29,21,11,14,27,44,46,23,24]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",n=100,a=1e3*60*5;let o=class extends D.Disposable{constructor(O,q,N){super();this.productService=O,this.configurationService=q,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new R.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(R.Event.filter(N.onDidChangeValue,L=>L.key===l.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,O,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,q){O=S.isWeb&&O?.web?{...O,...O.web}:O;const N={...O||{},...q||{}};if(N&&(0,i.isString)(N.url)&&(0,i.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>(0,i.isArray)(N.authenticationProviders[L].scopes))){const L=N,$=!!L.canSwitch&&!q?.url,_=L.url===L.insidersUrl?"insiders":"stable",M=($?this.userDataSyncStoreType:void 0)||_,j=q?.url||(M==="insiders"?L.insidersUrl:M==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(j),type:M,defaultType:_,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((W,x)=>(W.push({id:x,scopes:L.authenticationProviders[x].scopes}),W),[])}}}};o=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,d.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,q,N){super(O,q,N);const L=this.storageService.get(c,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const $=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(c,JSON.stringify($),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,d.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends D.Disposable{constructor(O,q,N,L,$,_,M){super();this.requestService=N,this.logService=L,this.storageService=M,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new R.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new R.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)($,_,M).then(j=>{const W={"X-Client-Name":`${q.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":q.version};return q.commit&&(W["X-Client-Commit"]=q.commit),W}),this.session=new A(n,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,D.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,q){this.authToken={token:O,type:q}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(q=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),N={},L=await this.request(q.toString(),{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,m.asJson)(L)||[]).map(({url:_,created:M})=>({ref:(0,I.relativePath)(q,q.with({path:_})),created:M*1e3}))}async resolveContent(O,q){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,q).toString(),L={};L["Cache-Control"]="no-cache";const $=await this.request(N,{type:"GET",headers:L},[],T.CancellationToken.None);return await(0,m.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),N={};await this.request(q,{type:"DELETE",headers:N},[],T.CancellationToken.None)}async read(O,q,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();N={...N},N["Cache-Control"]="no-cache",q&&(N["If-None-Match"]=q.ref);const $=await this.request(L,{type:"GET",headers:N},[304],T.CancellationToken.None);let _=null;if($.res.statusCode===304&&(_=q),_===null){const M=$.res.headers.etag;if(!M)throw new l.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",$.res.statusCode,$.res.headers[l.HEADER_OPERATION_ID]);const j=await(0,m.asText)($);if(!j&&$.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",L,"EmptyResponse",$.res.statusCode,$.res.headers[l.HEADER_OPERATION_ID]);_={ref:M,content:j}}return _}async write(O,q,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();L={...L},L["Content-Type"]=C.Mimes.text,N&&(L["If-Match"]=N);const _=await this.request($,{type:"POST",data:q,headers:L},[],T.CancellationToken.None),M=_.res.headers.etag;if(!M)throw new l.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",_.res.statusCode,_.res.headers[l.HEADER_OPERATION_ID]);return M}async manifest(O,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();q={...q},q["Content-Type"]="application/json",O&&(q["If-None-Match"]=O.ref);const L=await this.request(N,{type:"GET",headers:q},[304],T.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=O),!$){const M=L.res.headers.etag;if(!M)throw new l.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[l.HEADER_OPERATION_ID]);const j=await(0,m.asText)(L);if(!j&&L.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[l.HEADER_OPERATION_ID]);j&&($={...JSON.parse(j),ref:M})}const _=this.storageService.get(s,0);return _&&$&&_!==$.session&&this.clearSession(),$===null&&_&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),q={"Content-Type":C.Mimes.text};await this.request(O,{type:"DELETE",headers:q},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,q,N,L){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;q.headers={...q.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(q.headers),this.logService.trace("Sending request to server",{url:O,type:q.type,headers:{...q.headers,authorization:void 0}});let _;try{_=await this.session.request(O,q,L)}catch(x){if(!(x instanceof l.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,P.getErrorMessage)(x).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,P.isPromiseCanceledError)(x)&&(z="RequestCanceled"),x=new l.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,z,void 0,void 0)}throw this.logService.info("Request failed",O),x}const M=_.res.headers[l.HEADER_OPERATION_ID],j={url:O,status:_.res.statusCode,"execution-id":q.headers[l.HEADER_EXECUTION_ID],"operation-id":M},W=(0,m.isSuccess)(_)||_.res.statusCode&&N.indexOf(_.res.statusCode)!==-1;if(W?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",_.res.statusCode,M);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",_.res.statusCode,M);if(_.res.statusCode===410)throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",_.res.statusCode,M);if(_.res.statusCode===412)throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",_.res.statusCode,M);if(_.res.statusCode===413)throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",_.res.statusCode,M);if(_.res.statusCode===426)throw new l.UserDataSyncStoreError(`${q.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",_.res.statusCode,M);if(_.res.statusCode===429){const x=_.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",_.res.statusCode,M)):new l.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",_.res.statusCode,M)}if(!W)throw new l.UserDataSyncStoreError("Server returned "+_.res.statusCode,O,"Unknown",_.res.statusCode,M);return _}addSessionHeaders(O){let q=this.storageService.get(r,0);q===void 0&&(q=(0,f.generateUuid)(),this.storageService.store(r,q,0,1)),O["X-Machine-Session-Id"]=q;const N=this.storageService.get(s,0);N!==void 0&&(O["X-User-Session-Id"]=N)}};g=he([J(1,y.IProductService),J(2,m.IRequestService),J(3,l.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,w.IFileService),J(6,d.IStorageService)],g),e.UserDataSyncStoreClient=g;let b=class extends g{constructor(O,q,N,L,$,_,M){super(O.userDataSyncStore?.url,q,N,L,$,_,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};b=he([J(0,l.IUserDataSyncStoreManagementService),J(1,y.IProductService),J(2,m.IRequestService),J(3,l.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,w.IFileService),J(6,d.IStorageService)],b),e.UserDataSyncStoreService=b;class A{constructor(O,q,N,L){this.limit=O,this.interval=q,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(O,q,N){if(this.isExpired()&&this.reset(),q.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(q,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[238],ne([0,1,3,61,27,23,22,100,24,64,65]),function(X,e,k,T,P,R,D,C,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends C.UserDataAutoSyncService{constructor(p,h,w,y,m,v,d,l,c,t,s,r){super(p,h,w,y,m,d,l,c,t,s,r);this._register(k.Event.debounce(k.Event.any(k.Event.map(v.onDidFocusWindow,()=>"windowFocus"),k.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(n,a)=>n?[...n,a]:[a],1e3)(n=>this.triggerSync(n,!0,!1)))}};E=he([J(0,P.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncResourceEnablementService),J(4,S.IUserDataSyncService),J(5,T.INativeHostService),J(6,S.IUserDataSyncLogService),J(7,I.IUserDataSyncAccountService),J(8,D.ITelemetryService),J(9,i.IUserDataSyncMachinesService),J(10,R.IStorageService),J(11,S.IUserDataAutoSyncEnablementService)],E),e.UserDataAutoSyncService=E}),define(te[239],ne([0,1,5,3,2]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends P.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:S,getActiveWindowId:I}){super();this.disposables=this._register(new P.DisposableStore),T.Event.latch(T.Event.any(C,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>I()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[66],ne([0,1,51,5,9,17,20,127,250,251]),function(X,e,k,T,P,R,D,C,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let r=s.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=s}}e.ExtractError=i;function E(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,r)=>s+r,t&61440)}function f(c){if(c instanceof i)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new i(t,c)}function p(c,t,s,r,n,a){const o=P.dirname(t),u=P.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(C.localize(0,null,t)));const g=P.join(r,t);let b;return a.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(D.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!a.isCancellationRequested)try{b=(0,k.createWriteStream)(g,{mode:s}),b.once("close",()=>A()),b.once("error",U),c.once("error",U),c.pipe(b)}catch(O){U(O)}}))}function h(c,t,s,r){let n=(0,T.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{n.cancel(),c.close()}),new Promise((o,u)=>{const g=new T.Sequencer,b=A=>{A.isCancellationRequested||(a++,c.readEntry())};c.once("error",u),c.once("close",()=>n.then(()=>{r.isCancellationRequested||c.entryCount===a?o():u(new i("Incomplete",new Error(C.localize(1,null,a,c.entryCount))))},u)),c.readEntry(),c.on("entry",A=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){b(r);return}const U=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(U)){const N=P.join(t,U);n=(0,T.createCancelablePromise)(L=>D.Promises.mkdir(N,{recursive:!0}).then(()=>b(L)).then(void 0,u));return}const O=y(c,A),q=E(A);n=(0,T.createCancelablePromise)(N=>g.queue(()=>O.then(L=>p(L,U,q,t,s,N).then(()=>b(N)))).then(null,u))})})}function w(c,t=!1){return new Promise((s,r)=>{(0,S.open)(c,t?{lazyEntries:!0}:void 0,(n,a)=>{n?r(f(n)):s((0,R.assertIsDefined)(a))})})}function y(c,t){return new Promise((s,r)=>{c.openReadStream(t,(n,a)=>{n?r(f(n)):s((0,R.assertIsDefined)(a))})})}function m(c,t){return new Promise((s,r)=>{const n=new I.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const a=(0,k.createWriteStream)(c);n.outputStream.pipe(a),n.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(c))})}e.zip=m;function v(c,t,s={},r){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=w(c,!0);return s.overwrite&&(a=a.then(o=>D.Promises.rm(t).then(()=>o))),a.then(o=>h(o,t,{sourcePathRegex:n},r))}e.extract=v;function d(c,t){return w(c).then(s=>new Promise((r,n)=>{s.on("entry",a=>{a.fileName===t&&y(s,a).then(o=>r(o),o=>n(o))}),s.once("close",()=>n(new Error(C.localize(2,null,t))))}))}function l(c,t){return d(c,t).then(s=>new Promise((r,n)=>{const a=[];s.once("error",n),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=l}),define(te[240],ne([0,1,66,136]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(R){return(0,k.buffer)(R,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(C){throw new Error((0,T.localize)(0,null))}})}e.getManifest=P}),define(te[241],ne([0,1,16,5,7,2,15,9,4,18,62,8,29,20,66,137,11,30,36,158,14,10,27]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends R.Disposable{constructor(n,a,o,u,g){super();this.beforeRemovingExtension=n,this.fileService=a,this.logService=o,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const a=[];(n===null||n===0)&&a.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&a.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(a);return(0,k.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[a,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!a[new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),n&&(o=(0,v.groupByExtension)(o,g=>g.identifier).map(g=>g.sort((b,A)=>i.rcompare(b.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,a,o,u){const g=n.key(),b=C.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),A=C.join(this.extensionsPath,g);try{await p.Promises.rm(A)}catch(O){try{await p.Promises.rm(A)}catch(q){}throw new m.ExtensionManagementError((0,w.localize)(0,null,A,n.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,a,b,u);let U=await this.scanExtension(E.URI.file(b),1);if(!U)throw new Error((0,w.localize)(1,null,b));await this.storeMetadata(U,{...o,installedTimestamp:Date.now()});try{await this.rename(n,b,A,Date.now()+2*60*1e3),this.logService.info("Renamed to",A)}catch(O){try{await p.Promises.rm(b)}catch(q){}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(O)}. Deleted from extracted location`,b),O}try{U=await this.scanExtension(E.URI.file(A),1)}catch(O){}if(U)return U;throw new Error((0,w.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,a){return this.setMetadata(n,a),await this.storeMetadata(n,{...a,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const o=C.join(n.location.fsPath,"package.json"),u=await p.Promises.readFile(o,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=a,await p.Promises.writeFile(o,JSON.stringify(g,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const a=n.map(o=>new v.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{a.forEach(u=>o[u.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(u=>delete u[n.key()]);const o=(await this.scanExtensions(1)).find(u=>new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(n))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(a)try{o=JSON.parse(a)}catch(u){}return n&&(n(o),Object.keys(o).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await p.Promises.rm(this.uninstalledPath)),o})}async removeExtension(n,a){this.logService.trace(`Deleting ${a} extension from disk`,n.identifier.id,n.location.fsPath),await p.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new v.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,a,o,u){this.logService.trace(`Started extracting the extension from ${a} to ${o}`);try{await p.Promises.rm(o)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(a,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,n.id)}catch(g){try{await p.Promises.rm(o)}catch(A){}let b=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?b=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(b=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,b)}}async rename(n,a,o,u){try{await p.Promises.rename(a,o)}catch(g){if(S.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${a} to ${o} with 'EPERM' error. Trying again...`,n.id),this.rename(n,a,o,u);throw new m.ExtensionManagementError(g.message||(0,w.localize)(3,null,a,o),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const a=this.scanDevSystemExtensions(),[o,u]=await Promise.all([n,a]);return[...o,...u]}async scanExtensionsInDir(n,a){const o=new T.Limiter(10),u=await this.fileService.resolve(E.URI.file(n));return u.children?(await Promise.all(u.children.filter(b=>b.isDirectory).map(b=>o.queue(async()=>a===1&&(0,I.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,a))))).filter(b=>b&&b.identifier):[]}async scanExtension(n,a){try{const o=await this.fileService.resolve(n);if(o.children){const{manifest:u,metadata:g}=await this.readManifest(n.fsPath),b=o.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,A=o.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,U={id:(0,v.getGalleryExtensionId)(u.publisher,u.name)},O={type:a,identifier:U,manifest:u,location:n,readmeUrl:b,changelogUrl:A,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return g&&(this.setMetadata(O,g),O.installedTimestamp=g.installedTimestamp),O}}catch(o){a!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(o=>n.some(u=>(0,v.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(n,a){n.publisherDisplayName=a.publisherDisplayName||null,n.publisherId=a.publisherId||null,n.identifier.uuid=a.id,n.isMachineScoped=!!a.isMachineScoped,n.isBuiltin=n.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),o=new Set;for(const b of a)n[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]||o.add(b.identifier.id.toLowerCase());const u=(0,v.groupByExtension)(a,b=>b.identifier);await T.Promises.settled(u.map(async b=>{const A=b.sort((U,O)=>i.rcompare(U.manifest.version,O.manifest.version))[0];o.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const g=a.filter(b=>n[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]);await T.Promises.settled(g.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),a=[],o=(0,v.groupByExtension)(n,u=>u.identifier);a.push(...(0,k.flatten)(o.map(u=>u.sort((g,b)=>i.rcompare(g.manifest.version,b.manifest.version)).slice(1)))),await T.Promises.settled(a.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const a=Array.isArray(n)?n:[n];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(D.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const a=[p.Promises.readFile(C.join(n,"package.json"),"utf8").then(b=>this.parseManifest(b)),p.Promises.readFile(C.join(n,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:o,metadata:u},g]=await Promise.all(a);return{manifest:(0,d.localizeManifest)(o,g),metadata:u}}parseManifest(n){return new Promise((a,o)=>{try{const u=JSON.parse(n),g=u.__metadata||null;a({manifest:u,metadata:g})}catch(u){o(new Error((0,w.localize)(4,null)))}})}};s=he([J(1,l.IFileService),J(2,c.ILogService),J(3,y.INativeEnvironmentService),J(4,t.IProductService)],s),e.ExtensionsScanner=s}),define(te[242],ne([0,1,38,7,15,9,4,31,18,62,8,29,20,66,135,79,11,205,30,36,189,177,240,190,241,219,77,14,6,10,27,22,37]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c,t,s,r,n,a,o,u,g,b,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends m.AbstractExtensionManagementService{constructor(M,j,W,x,z,K,F,B,V){super(M,j,W,B);this.environmentService=x,this.downloadService=z,this.fileService=F;const Q=this._register(K.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(r.ExtensionsScanner,G=>Q.postUninstall(G))),this.manifestCache=this._register(new s.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(K.createInstance(l.ExtensionsDownloader));const Z=this._register(new n.ExtensionsWatcher(this,F,x,W,V));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:G,removed:H})=>{G.length&&this._onDidInstallExtensions.fire(G.map(re=>({identifier:re.identifier,operation:0,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),j=(0,v.getTargetPlatform)(M?"alpine":D.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",j),j})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let M;try{M=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(j){try{M=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(W){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(W))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const j=await this.collectFiles(M),W=await(0,p.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,j);return i.URI.file(W)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const j=await this.downloadVsix(M),W=R.resolve(j.fsPath);return(0,t.getManifest)(W)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,j={}){this.logService.trace("ExtensionManagementService#install",M.toString());const W=await this.downloadVsix(M),x=await(0,t.getManifest)(R.resolve(W.fsPath));if(x.engines&&x.engines.vscode&&!(0,a.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,d.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,W,j)}async updateMetadata(M,j){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...j}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===P.Schemas.file)return M;const j=(0,S.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(M,j),j}createInstallExtensionTask(M,j,W){return i.URI.isUri(j)?new L(M,j,W,this.galleryService,this.extensionsScanner,this.logService):new N(j,W,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,j){return new $(M,j,this.extensionsScanner)}async collectFiles(M){const j=async x=>{let z=await f.Promises.readdir(x);z=z.map(B=>R.join(x,B));const K=await Promise.all(z.map(B=>f.Promises.stat(B)));let F=Promise.resolve([]);return K.forEach((B,V)=>{const Q=z[V];B.isFile()&&(F=F.then(Z=>[...Z,Q])),B.isDirectory()&&(F=F.then(Z=>j(Q).then(G=>[...Z,...G])))}),F};return(await j(M.location.fsPath)).map(x=>({path:`extension/${R.relative(M.location.fsPath,x)}`,localPath:x}))}};O=he([J(0,v.IExtensionGalleryService),J(1,A.ITelemetryService),J(2,g.ILogService),J(3,y.INativeEnvironmentService),J(4,w.IDownloadService),J(5,u.IInstantiationService),J(6,o.IFileService),J(7,b.IProductService),J(8,U.IUriIdentityService)],O),e.ExtensionManagementService=O;class q extends m.AbstractExtensionTask{constructor(M,j,W,x){super();this.identifier=M,this.source=j,this.extensionsScanner=W,this.logService=x,this._operation=1}get operation(){return this._operation}async installExtension(M,j){try{const W=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(W)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(W,M.metadata):W}catch(W){throw D.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(h.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(M,j)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const W=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),W}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:j,metadata:W},x){let z=await this.extensionsScanner.extractUserExtension(j,M,W,x);return this.logService.info("Extracting completed.",j.id),z}}class N extends q{constructor(M,j,W,x,z){super(M.identifier,M,x,z);this.gallery=M,this.options=j,this.extensionsDownloader=W}async doRun(M){const W=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,d.areSameExtensions)(z.identifier,this.gallery.identifier));W&&(this._operation=2);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||W?.isBuiltin;try{const z=await this.installExtension(x,M);return W&&I.neq(W.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(W),z}catch(z){throw await this.deleteDownloadedVSIX(x.zipPath),z}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(i.URI.file(M))}catch(j){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,T.getErrorMessage)(j))}}async downloadInstallableExtension(M,j){const W={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",M.identifier.id),x=(await this.extensionsDownloader.downloadExtension(M,j)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,x)}catch(z){throw new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Download)}try{const z=await(0,t.getManifest)(x);return{zipPath:x,identifierWithVersion:new d.ExtensionIdentifierWithVersion(M.identifier,z.version),metadata:W}}catch(z){throw await this.deleteDownloadedVSIX(x),new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Invalid)}}}class L extends q{constructor(M,j,W,x,z,K){super({id:(0,d.getGalleryExtensionId)(M.publisher,M.name)},j,z,K);this.manifest=M,this.location=j,this.options=W,this.galleryService=x}async doRun(M){const j=new d.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,d.areSameExtensions)(this.identifier,K.identifier)),z=await this.getMetadata(this.identifier.id,M);if(z.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=2,j.equals(new d.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch(K){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const K=await this.unsetUninstalledAndGetLocal(j);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(F){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:j,metadata:z},M)}async getMetadata(M,j){try{const W=(await this.galleryService.query({names:[M],pageSize:1},j)).firstPage[0];if(W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId}}catch(W){}return{}}}class $ extends m.AbstractExtensionTask{constructor(M,j,W){super();this.extension=M,this.options=j,this.extensionsScanner=W}async doRun(M){const j=[],W=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new d.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);j.push(...W.filter(z=>x.equals(new d.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else j.push(...W.filter(x=>(0,d.areSameExtensions)(x.identifier,this.extension.identifier)));if(!j.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const x of j)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(z){throw new Error(h.localize(6,null,(0,k.toErrorMessage)(z)))}}}}),define(te[243],ne([0,1,82,57,33,19,7,3,2,9,4,29,34,72,252]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(u){this.socket=u,this._errorListener=g=>{if(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const g=b=>u(R.VSBuffer.wrap(b));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(u){const g=b=>{u({type:0,hadError:b,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}}end(){this.socket.end()}drain(){return new Promise((u,g)=>{if(this.socket.bufferSize===0){u();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),u()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=w;var y;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var m;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(m||(m={}));class v extends S.Disposable{constructor(u,g,b,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=A,g?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",U=>{console.error(U),(0,D.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibInflate.on("data",U=>{this._pendingInflateData.push(U)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{console.error(U),(0,D.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibDeflate.on("data",U=>{this._pendingDeflateData.push(U)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):R.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(R.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,g){let b=2;u.byteLength<126?b+=0:u.byteLength<2**16?b+=2:b+=8;const A=R.VSBuffer.alloc(b);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let U=1;A.writeUInt8(u.byteLength>>>8&255,++U),A.writeUInt8(u.byteLength>>>0&255,++U)}else{A.writeUInt8(127,1);let U=1;A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(u.byteLength>>>24&255,++U),A.writeUInt8(u.byteLength>>>16&255,++U),A.writeUInt8(u.byteLength>>>8&255,++U),A.writeUInt8(u.byteLength>>>0&255,++U)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(R.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),b=g.readUInt8(0),A=(b&128)>>>7,U=(b&64)>>>6,O=g.readUInt8(1),q=(O&128)>>>7,N=O&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),b=g.readUInt8(1),A=(b&128)>>>7;let U=b&127,O=1;U===126?U=g.readUInt8(++O)*2**8+g.readUInt8(++O):U===127&&(U=g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O));let q=0;A&&(q=g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O)),this._state.state=3,this._state.readLen=U,this._state.mask=q}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);d(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(R.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function d(o,u){if(u===0)return;let g=o.byteLength>>>2;for(let N=0;N<g;N++){const L=o.readUInt32BE(N*4);o.writeUInt32BE(L^u,N*4)}let b=g*4,A=o.byteLength-b;const U=u>>>24&255,O=u>>>16&255,q=u>>>8&255;A>=1&&o.writeUInt8(o.readUInt8(b)^U,b),A>=2&&o.writeUInt8(o.readUInt8(b+1)^O,b+1),A>=3&&o.writeUInt8(o.readUInt8(b+2)^q,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const o=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,I.join)((0,P.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=c;function t(o,u,g){const b=(0,k.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${g}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${g}-${u}.sock`):A=(0,I.join)(o,`${g}-${u}.sock`),s(A),A}e.createStaticIPCHandle=t;function s(o){const u=l[i.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends f.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const g=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(g,b=>({protocol:new p.Protocol(new w(b)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(o){return new Promise((u,g)=>{const b=(0,T.createServer)();b.on("error",g),b.listen(o,()=>{b.removeListener("error",g),u(new r(b))})})}e.serve=n;function a(o,u){return new Promise((g,b)=>{const A=(0,T.createConnection)(o,()=>{A.removeListener("error",b),g(p.Client.fromSocket(new w(A),u))});A.once("error",b)})}e.connect=a}),define(te[244],ne([0,1,57,243]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,R,D,C){const S=i=>C(i,void 0),I=k.createConnection({host:P,port:R},()=>{I.removeListener("error",S);const i=Buffer.alloc(16);for(let h=0;h<16;h++)i[h]=Math.round(Math.random()*256);const E=i.toString("base64");let f=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${R}/?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];I.write(f.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",p),C(void 0,new T.NodeSocket(I)))};I.on("data",p)});I.once("error",S)}}}),define(te[245],ne([0,1,57,117,244,5,2,21,10,27,187,63,92]),function(X,e,k,T,P,R,D,C,S,I,i,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(v,d,l,c,t){return new h(v,d,l,c,t).waitForReady()}class h extends D.Disposable{constructor(d,l,c,t,s){super();this.defaultTunnelHost=l,this.suggestedLocalPort=s,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=k.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let d=await(0,T.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(d){d.pause();const l=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,i.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),t=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&d.write(s.buffer),d.on("end",()=>{this._socketsDispose.delete(d.localAddress),t.end()}),d.on("close",()=>t.end()),d.on("error",()=>{this._socketsDispose.delete(d.localAddress),t.destroy()}),t.on("end",()=>d.end()),t.on("close",()=>d.end()),t.on("error",()=>{d.destroy()}),d.pipe(t),t.pipe(d),this._socketsDispose.set(d.localAddress,()=>{d.end(),t.end()})}}let w=class extends E.AbstractTunnelService{constructor(d,l,c,t,s){super(l);this.socketFactory=d,this.signService=c,this.productService=t,this.configurationService=s}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,l,c,t,s,r,n){const a=this.getTunnelFromMap(l,c);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,c,t,s,r,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${c} on local port ${t}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(o,this.defaultTunnelHost,l,c,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,c,u),u}}};w=he([J(1,S.ILogService),J(2,f.ISignService),J(3,I.IProductService),J(4,C.IConfigurationService)],w),e.BaseTunnelService=w;let y=class extends w{constructor(d,l,c,t){super(P.nodeSocketFactory,d,l,c,t)}};y=he([J(0,S.ILogService),J(1,f.ISignService),J(2,I.IProductService),J(3,C.IConfigurationService)],y),e.TunnelService=y;let m=class extends D.Disposable{constructor(d,l,c,t){super();this.logService=d,this.productService=l,this.signService=c,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(d,l,c,t,s,r,n,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${t} on local port ${s}.`),!this._tunnelServices.has(d)){const o=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(d,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(l,c,t,s,r,n,a)}};m=he([J(0,S.ILogService),J(1,I.IProductService),J(2,f.ISignService),J(3,C.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[253],ne([0,1,73,33,38,7,2,15,18,8,34,121,183,163,184,174,175,176,161,165,21,185,78,204,79,195,11,156,200,208,30,164,206,242,80,159,14,180,182,53,6,171,84,172,173,60,191,10,86,61,87,27,194,44,23,202,203,22,93,94,95,45,209,210,96,212,218,98,99,100,24,64,231,232,233,65,234,235,236,237,238,239,81,178,92,199,63,245,192,193,91,198,85,207,37,220]),function(X,e,k,T,P,R,D,C,S,I,i,E,f,p,h,w,y,m,v,d,l,c,t,s,r,n,a,o,u,g,b,A,U,O,q,N,L,$,_,M,j,W,x,z,K,F,B,V,Q,Z,G,H,re,ie,ce,le,de,fe,be,Ce,Ee,Ae,Pe,Le,Fe,Ne,$e,xe,ee,ae,oe,pe,Se,_e,Re,Y,se,ue,ge,me,Ie,ke,Te,ye,we,De,Oe,Me,Qe,Ye,je,Pt,vt,Dt,Rt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends D.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(He,ze)=>this.onDisposeWorker(ze);k.ipcRenderer.on(Ue,qe),this._register((0,D.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,oe.registerConfiguration)(),ve.invokeFunction(Ue=>{const qe=Ue.get(V.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,D.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(y.LogsDataCleaner),ve.createInstance(w.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Ue={_serviceBrand:void 0,...G.default};ve.set(H.IProductService,Ue);const qe=new i.StaticRouter(Be=>Be==="main"),He=new z.MessagePortMainProcessService(this.server,qe);ve.set(K.IMainProcessService,He);const ze=new o.NativeEnvironmentService(this.configuration.args,Ue);ve.set(a.INativeEnvironmentService,ze);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));ve.set(V.ILoggerService,Ze);const ot=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,S.joinPath)(I.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Q.FollowerLogService(rt,ot));ve.set(V.ILogService,Ge),this.sharedProcessWorkerService=new Pt.SharedProcessWorkerService(Ge,Ue,ze),ve.set(je.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ve.set(L.IFileService,Je);const ct=this._register(new _.DiskFileSystemProvider(Ge));Je.registerProvider(C.Schemas.file,ct);const We=this._register(new c.ConfigurationService(ze.settingsResource,Je));ve.set(l.IConfigurationService,We);const nt=new le.NativeStorageService(void 0,He,ze);ve.set(ce.IStorageService,nt),this._register((0,D.toDisposable)(()=>nt.flush())),await Promise.all([We.initialize(),nt.initialize()]),ve.set(vt.IUserConfigurationFileService,i.ProxyChannel.toService(He.getChannel(vt.UserConfigurationFileServiceId))),ve.set(Rt.IUriIdentityService,new kt.UriIdentityService(Je)),ve.set(ie.IRequestService,new M.SyncDescriptor(re.RequestService)),ve.set(v.IChecksumService,new M.SyncDescriptor(d.ChecksumService));const st=i.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(r.IDownloadService,new M.SyncDescriptor(n.DownloadService));const lt=this._register(new ke.ActiveWindowManager(st)),ut=new i.StaticRouter(Be=>lt.getActiveClientId().then(ft=>Be===ft));ve.set(q.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Dt.AssignmentService(this.configuration.machineId,We,Ue);let Xe;const et=[];if((0,Ae.supportsTelemetry)(Ue,ze)){const Be=new Ce.TelemetryLogAppender(Ze,ze);et.push(Be);const{appRoot:ft,extensionsPath:_t,installSourcePath:Ot}=ze;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const at=await ht.getTreatment("telemetryMigration")??!1,dt=Ue.quality!=="stable";if(dt&&at){const wt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,at,!0);this._register((0,D.toDisposable)(()=>wt.flush())),et.push(wt)}const St=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,dt?!1:at,at&&dt);this._register((0,D.toDisposable)(()=>St.flush())),et.push(St)}Xe=new Ee.TelemetryService({appenders:et,commonProperties:(0,de.resolveCommonProperties)(Je,(0,T.release)(),(0,T.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[ft,_t]},We)}else{Xe=Ae.NullTelemetryService;const Be=Ae.NullAppender;et.push(Be)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(et)),ve.set(fe.ITelemetryService,Xe);const At=new Le.CustomEndpointTelemetryService(We,Xe,Ze,ze);ve.set(fe.ICustomEndpointTelemetryService,At),ve.set(b.IExtensionManagementService,new M.SyncDescriptor(O.ExtensionManagementService)),ve.set(b.IExtensionGalleryService,new M.SyncDescriptor(g.ExtensionGalleryService)),ve.set(b.IExtensionTipsService,new M.SyncDescriptor(U.ExtensionTipsService)),ve.set(F.ILocalizationsService,new M.SyncDescriptor(B.LocalizationsService)),ve.set(t.IDiagnosticsService,new M.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new M.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(oe.IUserDataSyncLogService,new M.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(oe.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(b.IGlobalExtensionEnablementService,new M.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new M.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(oe.IUserDataSyncStoreManagementService,new M.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(oe.IUserDataSyncStoreService,new M.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new M.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(oe.IUserDataSyncBackupStoreService,new M.SyncDescriptor(Se.UserDataSyncBackupStoreService)),ve.set(oe.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),ve.set(oe.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(oe.IUserDataSyncService,new M.SyncDescriptor(ue.UserDataSyncService));const yt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,ze,Ge,Xe);return await yt.initialize(),ve.set(Ne.ILocalPtyService,this._register(yt)),ve.set(Te.IExtensionHostStarter,this._register(new ye.ExtensionHostStarter(Ge))),ve.set(we.ISignService,new M.SyncDescriptor(De.SignService)),ve.set(Oe.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),ve.set(Qe.ISharedProcessTunnelService,new M.SyncDescriptor(Ye.SharedProcessTunnelService)),new W.InstantiationService(ve)}initChannels(ve){const Ue=new A.ExtensionManagementChannel(ve.get(b.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=i.ProxyChannel.fromService(ve.get(F.ILocalizationsService));this.server.registerChannel("localizations",qe);const He=i.ProxyChannel.fromService(ve.get(t.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const ze=new A.ExtensionTipsChannel(ve.get(b.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=i.ProxyChannel.fromService(ve.get(v.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const ot=i.ProxyChannel.fromService(ve.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ot);const Ge=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(oe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ct=new ge.UserDataSyncChannel(ve.get(oe.IUserDataSyncService),ve.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const We=this._register(ve.get(j.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),lt=i.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=i.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,ut);const ht=i.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,ht);const Xe=i.ProxyChannel.fromService(ve.get(je.ISharedProcessWorkerService));this.server.registerChannel(je.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,R.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Ue=>{const qe=(0,P.toErrorMessage)(Ue,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Lt(pt){const ve=new Tt(pt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Lt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/552af97a0170b43c9323bec62211feb184da9749/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
