/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/types","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","vs/code/electron-main/main"],J=function(H){for(var e=[],p=0,L=H.length;p<L;p++)e[p]=Q[H[p]];return e};define(Q[104],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,M){if(!L)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=p}),define(Q[47],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(I){return(E,h,d)=>{let i=null,S=null;if(typeof d.value=="function"?(i="value",S=d.value):typeof d.get=="function"&&(i="get",S=d.get),!S)throw new Error("not supported");d[i]=I(S,h)}}e.createDecorator=p;function L(I,E,h){let d=null,i=null;if(typeof h.value=="function"?(d="value",i=h.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(d="get",i=h.get),!i)throw new Error("not supported");const S=`$memoize$${E}`;h[d]=function(...g){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,g)}),this[S]}}e.memoize=L;function M(I,E,h){return p((d,i)=>{const S=`$debounce$${i}`,g=`$debounce$result$${i}`;return function(...w){this[g]||(this[g]=h?h():void 0),clearTimeout(this[S]),E&&(this[g]=E(this[g],...w),w=[this[g]]),this[S]=setTimeout(()=>{d.apply(this,w),this[g]=h?h():void 0},I)}})}e.debounce=M;function k(I,E,h){return p((d,i)=>{const S=`$throttle$timer$${i}`,g=`$throttle$result$${i}`,w=`$throttle$lastRun$${i}`,t=`$throttle$pending$${i}`;return function(...f){if(this[g]||(this[g]=h?h():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[g]=E(this[g],...f)),this[t])return;const b=this[w]+I;b<=Date.now()?(this[w]=Date.now(),d.apply(this,[this[g]]),this[g]=h?h():void 0):(this[t]=!0,this[S]=setTimeout(()=>{this[t]=!1,this[w]=Date.now(),d.apply(this,[this[g]]),this[g]=h?h():void 0},b-Date.now()))}})}e.throttle=k}),define(Q[16],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=p,e.errorHandler=new p;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function M(u){h(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=M;function k(u){h(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=k;function I(u){if(u instanceof Error){let{name:n,message:o}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:n,message:o,stack:s}}return u}e.transformErrorForSerialization=I;const E="Canceled";function h(u){return u instanceof Error&&u.name===E&&u.message===E}e.isPromiseCanceledError=h;class d extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=d;function i(){const u=new Error(E);return u.name=u.message,u}e.canceled=i;function S(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=S;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=g;function w(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function t(u){const n=new Error(`${u} has been disposed`);return n.name="DISPOSED",n}e.disposed=t;function f(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=f;class b extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=b;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(u){const n=u;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=c;function a(u,n=Object.create(null)){const o=new Error(u);return n.actions&&(o.actions=n.actions),o}e.createErrorWithActions=a}),define(Q[31],J([0,1,16]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,A=0){return W[W.length-(1+A)]}e.tail=L;function M(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=M;function k(W,A,O=(q,X)=>q===X){if(W===A)return!0;if(!W||!A||W.length!==A.length)return!1;for(let q=0,X=W.length;q<X;q++)if(!O(W[q],A[q]))return!1;return!0}e.equals=k;function I(W,A,O){let q=0,X=W.length-1;for(;q<=X;){const $=(q+X)/2|0,z=O(W[$],A);if(z<0)q=$+1;else if(z>0)X=$-1;else return $}return-(q+1)}e.binarySearch=I;function E(W,A){let O=0,q=W.length;if(q===0)return 0;for(;O<q;){const X=Math.floor((O+q)/2);A(W[X])?q=X:O=X+1}return O}e.findFirstInSorted=E;function h(W,A,O){if(W=W|0,W>=A.length)throw new TypeError("invalid index");let q=A[Math.floor(A.length*Math.random())],X=[],$=[],z=[];for(let Z of A){const ee=O(Z,q);ee<0?X.push(Z):ee>0?$.push(Z):z.push(Z)}return W<X.length?h(W,X,O):W<X.length+z.length?z[0]:h(W-(X.length+z.length),$,O)}e.quickSelect=h;function d(W,A){const O=[];let q;for(const X of W.slice(0).sort(A))!q||A(q[0],X)!==0?(q=[X],O.push(q)):q.push(X);return O}e.groupBy=d;function i(W,A,O){const q=[];function X(Z,ee,le){if(ee===0&&le.length===0)return;const re=q[q.length-1];re&&re.start+re.deleteCount===Z?(re.deleteCount+=ee,re.toInsert.push(...le)):q.push({start:Z,deleteCount:ee,toInsert:le})}let $=0,z=0;for(;;){if($===W.length){X($,0,A.slice(z));break}if(z===A.length){X($,W.length-$,[]);break}const Z=W[$],ee=A[z],le=O(Z,ee);le===0?($+=1,z+=1):le<0?(X($,1,[]),$+=1):le>0&&(X($,0,[ee]),z+=1)}return q}e.sortedDiff=i;function S(W,A,O){const q=i(W,A,O),X=[],$=[];for(const z of q)X.push(...W.slice(z.start,z.start+z.deleteCount)),$.push(...z.toInsert);return{removed:X,added:$}}e.delta=S;function g(W,A,O){if(O===0)return[];const q=W.slice(0,O).sort(A);return t(W,A,q,O,W.length),q}e.top=g;function w(W,A,O,q,X){return O===0?Promise.resolve([]):new Promise(($,z)=>{(async()=>{const Z=W.length,ee=W.slice(0,O).sort(A);for(let le=O,re=Math.min(O+q,Z);le<Z;le=re,re=Math.min(re+q,Z)){if(le>O&&await new Promise(ie=>setTimeout(ie)),X&&X.isCancellationRequested)throw(0,p.canceled)();t(W,A,ee,le,re)}return ee})().then($,z)})}e.topAsync=w;function t(W,A,O,q,X){for(const $=O.length;q<X;q++){const z=W[q];if(A(z,O[$-1])<0){O.pop();const Z=E(O,ee=>A(z,ee)<0);O.splice(Z,0,z)}}}function f(W){return W.filter(A=>!!A)}e.coalesce=f;function b(W){let A=0;for(let O=0;O<W.length;O++)W[O]&&(W[A]=W[O],A+=1);W.length=A}e.coalesceInPlace=b;function v(W,A,O){W.splice(O,0,W.splice(A,1)[0])}e.move=v;function P(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=P;function c(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=c;function a(W,A=O=>O){const O=new Set;return W.filter(q=>{const X=A(q);return O.has(X)?!1:(O.add(X),!0)})}e.distinct=a;function u(W){const A=Object.create(null);return O=>{const q=W(O);return A[q]?!1:(A[q]=!0,!0)}}e.uniqueFilter=u;function n(W,A){const O=o(W,A);if(O!==-1)return W[O]}e.findLast=n;function o(W,A){for(let O=W.length-1;O>=0;O--){const q=W[O];if(A(q))return O}return-1}e.lastIndex=o;function s(W,A){return W.length>0?W[0]:A}e.firstOrDefault=s;function r(W,A,O=(q,X)=>q===X){let q=0;for(let X=0,$=Math.min(W.length,A.length);X<$&&O(W[X],A[X]);X++)q++;return q}e.commonPrefixLength=r;function l(W){return[].concat(...W)}e.flatten=l;function m(W,A){let O=typeof A=="number"?W:0;typeof A=="number"?O=W:(O=0,A=W);const q=[];if(O<=A)for(let X=O;X<A;X++)q.push(X);else for(let X=O;X>A;X--)q.push(X);return q}e.range=m;function y(W,A,O){return W.reduce((q,X)=>(q[A(X)]=O?O(X):X,q),Object.create(null))}e.index=y;function D(W,A){return W.push(A),()=>R(W,A)}e.insert=D;function R(W,A){const O=W.indexOf(A);if(O>-1)return W.splice(O,1),A}e.remove=R;function T(W,A,O){const q=W.slice(0,A),X=W.slice(A);return q.concat(O,X)}e.arrayInsert=T;function _(W,A){let O;if(typeof A=="number"){let q=A;O=()=>{const X=Math.sin(q++)*179426549;return X-Math.floor(X)}}else O=Math.random;for(let q=W.length-1;q>0;q-=1){const X=Math.floor(O()*(q+1)),$=W[q];W[q]=W[X],W[X]=$}}e.shuffle=_;function j(W,A){const O=W.indexOf(A);O>-1&&(W.splice(O,1),W.unshift(A))}e.pushToStart=j;function te(W,A){const O=W.indexOf(A);O>-1&&(W.splice(O,1),W.push(A))}e.pushToEnd=te;function se(W,A){return Array.isArray(W)?W.map(A):A(W)}e.mapArrayOrNot=se;function oe(W){return Array.isArray(W)?W:[W]}e.asArray=oe;function G(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=G;function F(W,A){for(const O of W){const q=A(O);if(q!==void 0)return q}}e.mapFind=F;function B(W,A,O){const q=C(W,A),X=W.length,$=O.length;W.length=X+$;for(let z=X-1;z>=q;z--)W[z+$]=W[z];for(let z=0;z<$;z++)W[z+q]=O[z]}e.insertInto=B;function V(W,A,O,q){const X=C(W,A),$=W.splice(X,O);return B(W,X,q),$}e.splice=V;function C(W,A){return A<0?Math.max(A+W.length,0):Math.min(A,W.length)}function N(W,A){let O=Number.MAX_SAFE_INTEGER,q=0;return W.forEach((X,$)=>{const z=A(X);z<O&&(O=z,q=$)}),q}e.minIndex=N;function U(W,A){let O=Number.MIN_SAFE_INTEGER,q=0;return W.forEach((X,$)=>{const z=A(X);z>O&&(O=z,q=$)}),q}e.maxIndex=U;class Y{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const q=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,q}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const q=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,q}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=Y}),define(Q[42],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const M=this;let k=!1,I;return function(){return k||(k=!0,I=L.apply(M,arguments)),I}}e.once=p}),define(Q[69],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function M(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=M;const k=Object.freeze([]);function I(){return k}L.empty=I;function*E(u){yield u}L.single=E;function h(u){return u||k}L.from=h;function d(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=d;function i(u){return u[Symbol.iterator]().next().value}L.first=i;function S(u,n){for(const o of u)if(n(o))return!0;return!1}L.some=S;function g(u,n){for(const o of u)if(n(o))return o}L.find=g;function*w(u,n){for(const o of u)n(o)&&(yield o)}L.filter=w;function*t(u,n){let o=0;for(const s of u)yield n(s,o++)}L.map=t;function*f(...u){for(const n of u)for(const o of n)yield o}L.concat=f;function*b(u){for(const n of u)for(const o of n)yield o}L.concatNested=b;function v(u,n,o){let s=o;for(const r of u)s=n(s,r);return s}L.reduce=v;function*P(u,n,o=u.length){for(n<0&&(n+=u.length),o<0?o+=u.length:o>u.length&&(o=u.length);n<o;n++)yield u[n]}L.slice=P;function c(u,n=Number.POSITIVE_INFINITY){const o=[];if(n===0)return[o,u];const s=u[Symbol.iterator]();for(let r=0;r<n;r++){const l=s.next();if(l.done)return[o,L.empty()];o.push(l.value)}return[o,{[Symbol.iterator](){return s}}]}L.consume=c;function a(u,n,o=(s,r)=>s===r){const s=u[Symbol.iterator](),r=n[Symbol.iterator]();for(;;){const l=s.next(),m=r.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!o(l.value,m.value))return!1}}L.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function I(n,o=!1){let s=0,r=n.length,l="",m=0,y=16,D=0;function R(G){let F=0,B=0;for(;F<G;){const V=n.charCodeAt(s);if(V>=48&&V<=57)B=B*16+V-48;else if(V>=65&&V<=70)B=B*16+V-65+10;else if(V>=97&&V<=102)B=B*16+V-97+10;else break;s++,F++}return F<G&&(B=-1),B}function T(G){s=G,l="",m=0,y=16,D=0}function _(){const G=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&d(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&d(n.charCodeAt(s)))for(s++;s<n.length&&d(n.charCodeAt(s));)s++;else return D=3,n.substring(G,s);let F=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&d(n.charCodeAt(s))){for(s++;s<n.length&&d(n.charCodeAt(s));)s++;F=s}else D=3;return n.substring(G,F)}function j(){let G="",F=s;for(;;){if(s>=r){G+=n.substring(F,s),D=2;break}const B=n.charCodeAt(s);if(B===34){G+=n.substring(F,s),s++;break}if(B===92){if(G+=n.substring(F,s),s++,s>=r){D=2;break}switch(n.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const C=R(4);C>=0?G+=String.fromCharCode(C):D=4;break;default:D=5}F=s;continue}if(B>=0&&B<=31)if(h(B)){G+=n.substring(F,s),D=2;break}else D=6;s++}return G}function te(){if(l="",D=0,m=s,s>=r)return m=r,y=17;let G=n.charCodeAt(s);if(E(G)){do s++,l+=String.fromCharCode(G),G=n.charCodeAt(s);while(E(G));return y=15}if(h(G))return s++,l+=String.fromCharCode(G),G===13&&n.charCodeAt(s)===10&&(s++,l+=`
`),y=14;switch(G){case 123:return s++,y=1;case 125:return s++,y=2;case 91:return s++,y=3;case 93:return s++,y=4;case 58:return s++,y=6;case 44:return s++,y=5;case 34:return s++,l=j(),y=10;case 47:const F=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<r&&!h(n.charCodeAt(s));)s++;return l=n.substring(F,s),y=12}if(n.charCodeAt(s+1)===42){s+=2;const B=r-1;let V=!1;for(;s<B;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,V=!0;break}s++}return V||(s++,D=1),l=n.substring(F,s),y=13}return l+=String.fromCharCode(G),s++,y=16;case 45:if(l+=String.fromCharCode(G),s++,s===r||!d(n.charCodeAt(s)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=_(),y=11;default:for(;s<r&&se(G);)s++,G=n.charCodeAt(s);if(m!==s){switch(l=n.substring(m,s),l){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return l+=String.fromCharCode(G),s++,y=16}}function se(G){if(E(G)||h(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let G;do G=te();while(G>=12&&G<=15);return G}return{setPosition:T,getPosition:()=>s,scan:o?oe:te,getToken:()=>y,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>D}}e.createScanner=I;function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function h(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function S(n,o){const s=[],r=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function D(R,T,_,j){m.value=R,m.offset=T,m.length=_,m.type=j,m.colonOffset=void 0,l=m}try{c(n,{onObjectBegin:(R,T)=>{if(o<=R)throw r;l=void 0,y=o>R,s.push("")},onObjectProperty:(R,T,_)=>{if(o<T||(D(R,T,_,"property"),s[s.length-1]=R,o<=T+_))throw r},onObjectEnd:(R,T)=>{if(o<=R)throw r;l=void 0,s.pop()},onArrayBegin:(R,T)=>{if(o<=R)throw r;l=void 0,s.push(0)},onArrayEnd:(R,T)=>{if(o<=R)throw r;l=void 0,s.pop()},onLiteralValue:(R,T,_)=>{if(o<T||(D(R,T,_,u(R)),o<=T+_))throw r},onSeparator:(R,T,_)=>{if(o<=T)throw r;if(R===":"&&l&&l.type==="property")l.colonOffset=T,y=!1,l=void 0;else if(R===","){const j=s[s.length-1];typeof j=="number"?s[s.length-1]=j+1:(y=!0,s[s.length-1]=""),l=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:l,isAtPropertyKey:y,matches:R=>{let T=0;for(let _=0;T<R.length&&_<s.length;_++)if(R[T]===s[_]||R[T]==="*")T++;else if(R[T]!=="**")return!1;return T===R.length}}}e.getLocation=S;function g(n,o=[],s=k.DEFAULT){let r=null,l=[];const m=[];function y(R){Array.isArray(l)?l.push(R):r!==null&&(l[r]=R)}return c(n,{onObjectBegin:()=>{const R={};y(R),m.push(l),l=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const R=[];y(R),m.push(l),l=R,r=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:y,onError:(R,T,_)=>{o.push({error:R,offset:T,length:_})}},s),l[0]}e.parse=g;function w(n,o=[],s=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function m(R){return r.children.push(R),R}c(n,{onObjectBegin:R=>{r=m({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,T,_)=>{r=m({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:T,length:_,parent:r})},onObjectEnd:(R,T)=>{r.length=R+T-r.offset,r=r.parent,l(R+T)},onArrayBegin:(R,T)=>{r=m({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,T)=>{r.length=R+T-r.offset,r=r.parent,l(R+T)},onLiteralValue:(R,T,_)=>{m({type:u(R),offset:T,length:_,parent:r,value:R}),l(T+_)},onSeparator:(R,T,_)=>{r.type==="property"&&(R===":"?r.colonOffset=T:R===","&&l(T))},onError:(R,T,_)=>{o.push({error:R,offset:T,length:_})}},s);const D=r.children[0];return D&&delete D.parent,D}e.parseTree=w;function t(n,o){if(!n)return;let s=n;for(let r of o)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===r){s=m.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.findNodeAtLocation=t;function f(n){if(!n.parent||!n.parent.children)return[];const o=f(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;o.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&o.push(s)}return o}e.getNodePath=f;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":const o=Object.create(null);for(let s of n.children){const r=s.children[1];r&&(o[s.children[0].value]=b(r))}return o;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function v(n,o,s=!1){return o>=n.offset&&o<n.offset+n.length||s&&o===n.offset+n.length}e.contains=v;function P(n,o,s=!1){if(v(n,o,s)){const r=n.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=o;l++){const m=P(r[l],o,s);if(m)return m}return n}}e.findNodeAtOffset=P;function c(n,o,s=k.DEFAULT){const r=I(n,!1);function l(O){return O?()=>O(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(O){return O?q=>O(q,r.getTokenOffset(),r.getTokenLength()):()=>!0}const y=l(o.onObjectBegin),D=m(o.onObjectProperty),R=l(o.onObjectEnd),T=l(o.onArrayBegin),_=l(o.onArrayEnd),j=m(o.onLiteralValue),te=m(o.onSeparator),se=l(o.onComment),oe=m(o.onError),G=s&&s.disallowComments,F=s&&s.allowTrailingComma;function B(){for(;;){const O=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:G||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(O){case 12:case 13:G?V(10):se();break;case 16:V(1);break;case 15:case 14:break;default:return O}}}function V(O,q=[],X=[]){if(oe(O),q.length+X.length>0){let $=r.getToken();for(;$!==17;){if(q.indexOf($)!==-1){B();break}else if(X.indexOf($)!==-1)break;$=B()}}}function C(O){const q=r.getTokenValue();return O?j(q):D(q),B(),!0}function N(){switch(r.getToken()){case 11:let O=0;try{O=JSON.parse(r.getTokenValue()),typeof O!="number"&&(V(2),O=0)}catch(q){V(2)}j(O);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return B(),!0}function U(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(C(!1),r.getToken()===6?(te(":"),B(),A()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){y(),B();let O=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(O||V(4,[],[]),te(","),B(),r.getToken()===2&&F)break}else O&&V(6,[],[]);U()||V(4,[],[2,5]),O=!0}return R(),r.getToken()!==2?V(7,[2],[]):B(),!0}function W(){T(),B();let O=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(O||V(4,[],[]),te(","),B(),r.getToken()===4&&F)break}else O&&V(6,[],[]);A()||V(4,[],[4,5]),O=!0}return _(),r.getToken()!==4?V(8,[4],[]):B(),!0}function A(){switch(r.getToken()){case 3:return W();case 1:return Y();case 10:return C(!0);default:return N()}}return B(),r.getToken()===17?s.allowEmptyContent?!0:(V(4,[],[]),!1):A()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=c;function a(n,o){let s=I(n),r=[],l,m=0,y;do switch(y=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:m!==y&&r.push(n.substring(m,y)),o!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,o)),m=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=a;function u(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[105],J([0,1,39]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(h,d,i){let S,g,w,t,f;if(d){for(t=d.offset,f=t+d.length,w=t;w>0&&!E(h,w-1);)w--;let m=f;for(;m<h.length&&!E(h,m);)m++;g=h.substring(w,m),S=k(g,i)}else g=h,S=0,w=0,t=0,f=h.length;const b=I(i,h);let v=!1,P=0,c;i.insertSpaces?c=M(" ",i.tabSize||4):c="	";const a=(0,p.createScanner)(g,!1);let u=!1;function n(){return b+M(c,S+P)}function o(){let m=a.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=a.scan();return u=m===16||a.getTokenError()!==0,m}const s=[];function r(m,y,D){!u&&y<f&&D>t&&h.substring(y,D)!==m&&s.push({offset:y,length:D-y,content:m})}let l=o();if(l!==17){const m=a.getTokenOffset()+w,y=M(c,S);r(y,w,m)}for(;l!==17;){let m=a.getTokenOffset()+a.getTokenLength()+w,y=o(),D="";for(;!v&&(y===12||y===13);){const T=a.getTokenOffset()+w;r(" ",m,T),m=a.getTokenOffset()+a.getTokenLength()+w,D=y===12?n():"",y=o()}if(y===2)l!==1&&(P--,D=n());else if(y===4)l!==3&&(P--,D=n());else{switch(l){case 3:case 1:P++,D=n();break;case 5:case 12:D=n();break;case 13:v?D=n():D=" ";break;case 6:D=" ";break;case 10:if(y===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?D=" ":y!==5&&y!==17&&(u=!0);break;case 16:u=!0;break}v&&(y===12||y===13)&&(D=n())}const R=a.getTokenOffset()+w;r(D,m,R),l=y}return s}e.format=L;function M(h,d){let i="";for(let S=0;S<d;S++)i+=h;return i}function k(h,d){let i=0,S=0;const g=d.tabSize||4;for(;i<h.length;){const w=h.charAt(i);if(w===" ")S++;else if(w==="	")S+=g;else break;i++}return Math.floor(S/g)}function I(h,d){for(let i=0;i<d.length;i++){const S=d.charAt(i);if(S==="\r")return i+1<d.length&&d.charAt(i+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=I;function E(h,d){return`\r
`.indexOf(h.charAt(d))!==-1}e.isEOL=E}),define(Q[78],J([0,1,39,105]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(d,i,S){return k(d,i,void 0,S)}e.removeProperty=M;function k(d,i,S,g,w){const t=i.slice(),f=[],b=(0,p.parseTree)(d,f);let v,P;for(;t.length>0&&(P=t.pop(),v=(0,p.findNodeAtLocation)(b,t),v===void 0&&S!==void 0);)typeof P=="string"?S={[P]:S}:S=[S];if(v)if(v.type==="object"&&typeof P=="string"&&Array.isArray(v.children)){const c=(0,p.findNodeAtLocation)(v,[P]);if(c!==void 0)if(S===void 0){if(!c.parent)throw new Error("Malformed AST");const a=v.children.indexOf(c.parent);let u,n=c.parent.offset+c.parent.length;if(a>0){const o=v.children[a-1];u=o.offset+o.length}else u=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return I(d,{offset:u,length:n-u,content:""},g)}else return I(d,{offset:c.offset,length:c.length,content:JSON.stringify(S)},g);else{if(S===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(S)}`,u=w?w(v.children.map(o=>o.children[0].value)):v.children.length;let n;if(u>0){const o=v.children[u-1];n={offset:o.offset+o.length,length:0,content:","+a}}else v.children.length===0?n={offset:v.offset+1,length:0,content:a}:n={offset:v.offset+1,length:0,content:a+","};return I(d,n,g)}}else if(v.type==="array"&&typeof P=="number"&&Array.isArray(v.children))if(S!==void 0){const c=`${JSON.stringify(S)}`;let a;if(v.children.length===0||P===0)a={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const u=P===-1||P>v.children.length?v.children.length:P,n=v.children[u-1];a={offset:n.offset+n.length,length:0,content:","+c}}return I(d,a,g)}else{const c=P,a=v.children[c];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const n=v.children[c-1],o=n.offset+n.length,s=v.offset+v.length;u={offset:o,length:s-2-o,content:""}}else u={offset:a.offset,length:v.children[c+1].offset-a.offset,content:""};return I(d,u,g)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${v.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(d,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(S)},g)}}e.setProperty=k;function I(d,i,S){let g=E(d,i),w=i.offset,t=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;w>0&&!(0,L.isEOL)(g,w-1);)w--;for(;t<g.length&&!(0,L.isEOL)(g,t);)t++}const f=(0,L.format)(g,{offset:w,length:t-w},S);for(let v=f.length-1;v>=0;v--){const P=f[v];g=E(g,P),w=Math.min(w,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const b=d.length-(g.length-t)-w;return[{offset:w,length:b,content:g.substring(w,t)}]}e.withFormatting=I;function E(d,i){return d.substring(0,i.offset)+i.content+d.substring(i.offset+i.length)}e.applyEdit=E;function h(d,i){let S=i.slice(0).sort((w,t)=>{const f=w.offset-t.offset;return f===0?w.length-t.length:f}),g=d.length;for(let w=S.length-1;w>=0;w--){let t=S[w];if(t.offset+t.length<=g)d=E(d,t);else throw new Error("Overlapping edit");g=t.offset}return d}e.applyEdits=h}),define(Q[79],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(L=e.ScanCode||(e.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(f,b){this._keyCodeToStr[f]=b,this._strToKeyCode[b.toLowerCase()]=f}keyCodeToStr(f){return this._keyCodeToStr[f]}strToKeyCode(f){return this._strToKeyCode[f.toLowerCase()]||0}}const k=new M,I=new M,E=new M;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],d=Object.create(null),i=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>i[t]||0,toEnum:t=>d[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",f=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let b=[],v=[];for(const P of f){const[c,a,u,n,o,s,r,l,m,y]=P;if(v[u]||(v[u]=!0,h[u]=n,d[n]=u,i[n.toLowerCase()]=u,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[o]=u))),!b[o]){if(b[o]=!0,!s)throw new Error(`String representation missing for key code ${o} around scan code ${n}`);k.define(o,s),I.define(o,m||s),E.define(o,y||m||s)}r&&(e.EVENT_KEY_CODE_MAP[r]=o),l&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=o)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var S;(function(t){function f(u){return k.keyCodeToStr(u)}t.toString=f;function b(u){return k.strToKeyCode(u)}t.fromString=b;function v(u){return I.keyCodeToStr(u)}t.toUserSettingsUS=v;function P(u){return E.keyCodeToStr(u)}t.toUserSettingsGeneral=P;function c(u){return I.strToKeyCode(u)||E.strToKeyCode(u)}t.fromUserSettings=c;function a(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return k.keyCodeToStr(u)}t.toElectronAccelerator=a})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var g;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(g=e.KeyMod||(e.KeyMod={}));function w(t,f){const b=(f&65535)<<16>>>0;return(t|b)>>>0}e.KeyChord=w}),define(Q[59],J([0,1,16]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var L;(function(S){S[S.CtrlCmd=2048]="CtrlCmd",S[S.Shift=1024]="Shift",S[S.Alt=512]="Alt",S[S.WinCtrl=256]="WinCtrl",S[S.KeyCode=255]="KeyCode"})(L||(L={}));function M(S,g){if(S===0)return null;const w=(S&65535)>>>0,t=(S&4294901760)>>>16;return t!==0?new E([k(w,g),k(t,g)]):new E([k(w,g)])}e.createKeybinding=M;function k(S,g){const w=!!(S&2048),t=!!(S&256),f=g===2?t:w,b=!!(S&1024),v=!!(S&512),P=g===2?w:t,c=S&255;return new I(f,b,v,P,c)}e.createSimpleKeybinding=k;class I{constructor(g,w,t,f,b){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=f,this.keyCode=b}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.keyCode===g.keyCode}getHashCode(){const g=this.ctrlKey?"1":"0",w=this.shiftKey?"1":"0",t=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${g}${w}${t}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new E([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=I;class E{constructor(g){if(g.length===0)throw(0,p.illegalArgument)("parts");this.parts=g}getHashCode(){let g="";for(let w=0,t=this.parts.length;w<t;w++)w!==0&&(g+=";"),g+=this.parts[w].getHashCode();return g}equals(g){if(g===null||this.parts.length!==g.parts.length)return!1;for(let w=0;w<this.parts.length;w++)if(!this.parts[w].equals(g.parts[w]))return!1;return!0}}e.ChordKeybinding=E;class h{constructor(g,w,t,f,b){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=f,this.scanCode=b}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.scanCode===g.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class d{constructor(g,w,t,f,b,v){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=f,this.keyLabel=b,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=d;class i{}e.ResolvedKeybinding=i}),define(Q[106],J([0,1,79,59]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(I){I=I.toLowerCase().trim();let E=!1,h=!1,d=!1,i=!1,S;do S=!1,/^ctrl(\+|\-)/.test(I)&&(E=!0,I=I.substr("ctrl-".length),S=!0),/^shift(\+|\-)/.test(I)&&(h=!0,I=I.substr("shift-".length),S=!0),/^alt(\+|\-)/.test(I)&&(d=!0,I=I.substr("alt-".length),S=!0),/^meta(\+|\-)/.test(I)&&(i=!0,I=I.substr("meta-".length),S=!0),/^win(\+|\-)/.test(I)&&(i=!0,I=I.substr("win-".length),S=!0),/^cmd(\+|\-)/.test(I)&&(i=!0,I=I.substr("cmd-".length),S=!0);while(S);let g;const w=I.indexOf(" ");return w>0?(g=I.substring(0,w),I=I.substring(w)):(g=I,I=""),{remains:I,ctrl:E,shift:h,alt:d,meta:i,key:g}}static parseSimpleKeybinding(I){const E=this._readModifiers(I),h=p.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,h),E.remains]}static parseKeybinding(I,E){if(!I)return null;const h=[];let d;do[d,I]=this.parseSimpleKeybinding(I),h.push(d);while(I.length>0);return new L.ChordKeybinding(h)}static parseSimpleUserBinding(I){const E=this._readModifiers(I),h=E.key.match(/^\[([^\]]+)\]$/);if(h){const i=h[1],S=p.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(E.ctrl,E.shift,E.alt,E.meta,S),E.remains]}const d=p.KeyCodeUtils.fromUserSettings(E.key);return[new L.SimpleKeybinding(E.ctrl,E.shift,E.alt,E.meta,d),E.remains]}static parseUserBinding(I){if(!I)return[];const E=[];let h;for(;I.length>0;)[h,I]=this.parseSimpleUserBinding(I),E.push(h);return E}}e.KeybindingParser=M}),define(Q[2],J([0,1,42,69]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let k=null;function I(r){k=r}if(e.setDisposableTracker=I,M){const r="__is_disposable_tracked__";I(new class{trackDisposable(l){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[r]||console.log(m)},3e3)}setParent(l,m){if(l&&l!==P.None)try{l[r]=!0}catch{}}markAsDisposed(l){if(l&&l!==P.None)try{l[r]=!0}catch{}}markAsSingleton(l){}})}function E(r){return k?.trackDisposable(r),r}function h(r){k?.markAsDisposed(r)}function d(r,l){k?.setParent(r,l)}function i(r,l){if(!!k)for(const m of r)k.setParent(m,l)}function S(r){return k?.markAsSingleton(r),r}e.markAsSingleton=S;class g extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=g;function w(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=w;function t(r){if(L.Iterable.is(r)){let l=[];for(const m of r)if(m)try{m.dispose()}catch(y){l.push(y)}if(l.length===1)throw l[0];if(l.length>1)throw new g(l);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function f(...r){const l=b(()=>t(r));return i(r,l),l}e.combinedDisposable=f;function b(r){const l=E({dispose:(0,p.once)(()=>{h(l),r()})});return l}e.toDisposable=b;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return d(l,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new v,E(this),d(this._store,this)}dispose(){h(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&d(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&d(l,null),l}}e.MutableDisposable=c;class a{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(l,...m){let y=this.references.get(l);y||(y={counter:0,object:this.createReferencedObject(l,...m)},this.references.set(l,y));const{object:D}=y,R=(0,p.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(l,y.object),this.references.delete(l))});return y.counter++,{object:D,dispose:R}}}e.ReferenceCollection=u;class n{constructor(l){this.referenceCollection=l}async acquire(l,...m){const y=this.referenceCollection.acquire(l,...m);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(D){throw y.dispose(),D}}}e.AsyncReferenceCollection=n;class o{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=o;function s(r){const l=new v;try{r(l)}finally{l.dispose()}}e.disposeOnReturn=s}),define(Q[107],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const I=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=I}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,I){const E=new p(k);if(this._first===p.Undefined)this._first=E,this._last=E;else if(I){const d=this._last;this._last=E,E.prev=d,d.next=E}else{const d=this._first;this._first=E,E.next=d,d.prev=E}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(E))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const I=k.prev;I.next=k.next,k.next.prev=I}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function H(M){const k=[];typeof M=="number"&&k.push("code/timeOrigin",M);function I(h){k.push(h,Date.now())}function E(){const h=[];for(let d=0;d<k.length;d+=2)h.push({name:k[d],startTime:k[d+1]});return h}return{mark:I,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const I of performance.getEntriesByType("mark"))k.push({name:I.name,startTime:Math.round(M+I.startTime)});return k}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function p(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Q[3],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,M=!1,k=!1,I=!1,E=!1,h=!1,d=!1,i,S=p,g,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const f=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=f&&t?.sandboxed,typeof navigator=="object"&&!f)w=navigator.userAgent,L=w.indexOf("Windows")>=0,M=w.indexOf("Macintosh")>=0,d=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=w.indexOf("Linux")>=0,h=!0,i=navigator.language,S=i;else if(typeof t=="object"){L=t.platform==="win32",M=t.platform==="darwin",k=t.platform==="linux",I=k&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,i=p,S=p;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),l=r.availableLanguages["*"];i=r.locale,S=l||p,g=r._translationsConfigFile}catch(r){}E=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function v(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let P=0;M?P=1:L?P=3:k&&(P=2),e.isWindows=L,e.isMacintosh=M,e.isLinux=k,e.isLinuxSnap=I,e.isNative=E,e.isWeb=h,e.isIOS=d,e.platform=P,e.userAgent=w,e.language=S;var c;(function(s){function r(){return e.language}s.value=r;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function m(){return e.language==="en"}s.isDefault=m})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let D=0,R=l.length;D<R;D++){const T=l[D];if(T.id===y.data.vscodeSetImmediateId){l.splice(D,1),T.callback();return}}});let m=0;return y=>{const D=++m;l.push({id:D,callback:y}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const r=Promise.resolve();return l=>r.then(l)}();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||d?2:L?1:3;let u=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=o}),define(Q[32],J([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const M=p.globals.vscode.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(k){return(0,p.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,p.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Q[8],J([0,1,32]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,M=97,k=90,I=122,E=46,h=47,d=92,i=58,S=63;class g extends Error{constructor(a,u,n){let o;typeof u=="string"&&u.indexOf("not ")===0?(o="must not be",u=u.replace(/^not /,"")):o="must be";const s=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${s} ${o} of type ${u}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function w(c,a){if(typeof c!="string")throw new g(a,"string",c)}function t(c){return c===h||c===d}function f(c){return c===h}function b(c){return c>=L&&c<=k||c>=M&&c<=I}function v(c,a,u,n){let o="",s=0,r=-1,l=0,m=0;for(let y=0;y<=c.length;++y){if(y<c.length)m=c.charCodeAt(y);else{if(n(m))break;m=h}if(n(m)){if(!(r===y-1||l===1))if(l===2){if(o.length<2||s!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const D=o.lastIndexOf(u);D===-1?(o="",s=0):(o=o.slice(0,D),s=o.length-1-o.lastIndexOf(u)),r=y,l=0;continue}else if(o.length!==0){o="",s=0,r=y,l=0;continue}}a&&(o+=o.length>0?`${u}..`:"..",s=2)}else o.length>0?o+=`${u}${c.slice(r+1,y)}`:o=c.slice(r+1,y),s=y-r-1;r=y,l=0}else m===E&&l!==-1?++l:l=-1}return o}function P(c,a){if(a===null||typeof a!="object")throw new g("pathObject","Object",a);const u=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${n}`:`${u}${c}${n}`:n}e.win32={resolve(...c){let a="",u="",n=!1;for(let o=c.length-1;o>=-1;o--){let s;if(o>=0){if(s=c[o],w(s,"path"),s.length===0)continue}else a.length===0?s=p.cwd():(s=p.env[`=${a}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===d)&&(s=`${a}\\`));const r=s.length;let l=0,m="",y=!1;const D=s.charCodeAt(0);if(r===1)t(D)&&(l=1,y=!0);else if(t(D))if(y=!0,t(s.charCodeAt(1))){let R=2,T=R;for(;R<r&&!t(s.charCodeAt(R));)R++;if(R<r&&R!==T){const _=s.slice(T,R);for(T=R;R<r&&t(s.charCodeAt(R));)R++;if(R<r&&R!==T){for(T=R;R<r&&!t(s.charCodeAt(R));)R++;(R===r||R!==T)&&(m=`\\\\${_}\\${s.slice(T,R)}`,l=R)}}}else l=1;else b(D)&&s.charCodeAt(1)===i&&(m=s.slice(0,2),l=2,r>2&&t(s.charCodeAt(2))&&(y=!0,l=3));if(m.length>0)if(a.length>0){if(m.toLowerCase()!==a.toLowerCase())continue}else a=m;if(n){if(a.length>0)break}else if(u=`${s.slice(l)}\\${u}`,n=y,y&&a.length>0)break}return u=v(u,!n,"\\",t),n?`${a}\\${u}`:`${a}${u}`||"."},normalize(c){w(c,"path");const a=c.length;if(a===0)return".";let u=0,n,o=!1;const s=c.charCodeAt(0);if(a===1)return f(s)?"\\":c;if(t(s))if(o=!0,t(c.charCodeAt(1))){let l=2,m=l;for(;l<a&&!t(c.charCodeAt(l));)l++;if(l<a&&l!==m){const y=c.slice(m,l);for(m=l;l<a&&t(c.charCodeAt(l));)l++;if(l<a&&l!==m){for(m=l;l<a&&!t(c.charCodeAt(l));)l++;if(l===a)return`\\\\${y}\\${c.slice(m)}\\`;l!==m&&(n=`\\\\${y}\\${c.slice(m,l)}`,u=l)}}}else u=1;else b(s)&&c.charCodeAt(1)===i&&(n=c.slice(0,2),u=2,a>2&&t(c.charCodeAt(2))&&(o=!0,u=3));let r=u<a?v(c.slice(u),!o,"\\",t):"";return r.length===0&&!o&&(r="."),r.length>0&&t(c.charCodeAt(a-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(c){w(c,"path");const a=c.length;if(a===0)return!1;const u=c.charCodeAt(0);return t(u)||a>2&&b(u)&&c.charCodeAt(1)===i&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,u;for(let s=0;s<c.length;++s){const r=c[s];w(r,"path"),r.length>0&&(a===void 0?a=u=r:a+=`\\${r}`)}if(a===void 0)return".";let n=!0,o=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++o;const s=u.length;s>1&&t(u.charCodeAt(1))&&(++o,s>2&&(t(u.charCodeAt(2))?++o:n=!1))}if(n){for(;o<a.length&&t(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(c,a){if(w(c,"from"),w(a,"to"),c===a)return"";const u=e.win32.resolve(c),n=e.win32.resolve(a);if(u===n||(c=u.toLowerCase(),a=n.toLowerCase(),c===a))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===d;)o++;let s=c.length;for(;s-1>o&&c.charCodeAt(s-1)===d;)s--;const r=s-o;let l=0;for(;l<a.length&&a.charCodeAt(l)===d;)l++;let m=a.length;for(;m-1>l&&a.charCodeAt(m-1)===d;)m--;const y=m-l,D=r<y?r:y;let R=-1,T=0;for(;T<D;T++){const j=c.charCodeAt(o+T);if(j!==a.charCodeAt(l+T))break;j===d&&(R=T)}if(T!==D){if(R===-1)return n}else{if(y>D){if(a.charCodeAt(l+T)===d)return n.slice(l+T+1);if(T===2)return n.slice(l+T)}r>D&&(c.charCodeAt(o+T)===d?R=T:T===2&&(R=3)),R===-1&&(R=0)}let _="";for(T=o+R+1;T<=s;++T)(T===s||c.charCodeAt(T)===d)&&(_+=_.length===0?"..":"\\..");return l+=R,_.length>0?`${_}${n.slice(l,m)}`:(n.charCodeAt(l)===d&&++l,n.slice(l,m))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const u=a.charCodeAt(2);if(u!==S&&u!==E)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return c},dirname(c){w(c,"path");const a=c.length;if(a===0)return".";let u=-1,n=0;const o=c.charCodeAt(0);if(a===1)return t(o)?c:".";if(t(o)){if(u=n=1,t(c.charCodeAt(1))){let l=2,m=l;for(;l<a&&!t(c.charCodeAt(l));)l++;if(l<a&&l!==m){for(m=l;l<a&&t(c.charCodeAt(l));)l++;if(l<a&&l!==m){for(m=l;l<a&&!t(c.charCodeAt(l));)l++;if(l===a)return c;l!==m&&(u=n=l+1)}}}}else b(o)&&c.charCodeAt(1)===i&&(u=a>2&&t(c.charCodeAt(2))?3:2,n=u);let s=-1,r=!0;for(let l=a-1;l>=n;--l)if(t(c.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return c.slice(0,s)},basename(c,a){a!==void 0&&w(a,"ext"),w(c,"path");let u=0,n=-1,o=!0,s;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(u=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let r=a.length-1,l=-1;for(s=c.length-1;s>=u;--s){const m=c.charCodeAt(s);if(t(m)){if(!o){u=s+1;break}}else l===-1&&(o=!1,l=s+1),r>=0&&(m===a.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return u===n?n=l:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=u;--s)if(t(c.charCodeAt(s))){if(!o){u=s+1;break}}else n===-1&&(o=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){w(c,"path");let a=0,u=-1,n=0,o=-1,s=!0,r=0;c.length>=2&&c.charCodeAt(1)===i&&b(c.charCodeAt(0))&&(a=n=2);for(let l=c.length-1;l>=a;--l){const m=c.charCodeAt(l);if(t(m)){if(!s){n=l+1;break}continue}o===-1&&(s=!1,o=l+1),m===E?u===-1?u=l:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||o===-1||r===0||r===1&&u===o-1&&u===n+1?"":c.slice(u,o)},format:P.bind(null,"\\"),parse(c){w(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.length;let n=0,o=c.charCodeAt(0);if(u===1)return t(o)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(o)){if(n=1,t(c.charCodeAt(1))){let R=2,T=R;for(;R<u&&!t(c.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&t(c.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&!t(c.charCodeAt(R));)R++;R===u?n=R:R!==T&&(n=R+1)}}}}else if(b(o)&&c.charCodeAt(1)===i){if(u<=2)return a.root=a.dir=c,a;if(n=2,t(c.charCodeAt(2))){if(u===3)return a.root=a.dir=c,a;n=3}}n>0&&(a.root=c.slice(0,n));let s=-1,r=n,l=-1,m=!0,y=c.length-1,D=0;for(;y>=n;--y){if(o=c.charCodeAt(y),t(o)){if(!m){r=y+1;break}continue}l===-1&&(m=!1,l=y+1),o===E?s===-1?s=y:D!==1&&(D=1):s!==-1&&(D=-1)}return l!==-1&&(s===-1||D===0||D===1&&s===l-1&&s===r+1?a.base=a.name=c.slice(r,l):(a.name=c.slice(r,s),a.base=c.slice(r,l),a.ext=c.slice(s,l))),r>0&&r!==n?a.dir=c.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",u=!1;for(let n=c.length-1;n>=-1&&!u;n--){const o=n>=0?c[n]:p.cwd();w(o,"path"),o.length!==0&&(a=`${o}/${a}`,u=o.charCodeAt(0)===h)}return a=v(a,!u,"/",f),u?`/${a}`:a.length>0?a:"."},normalize(c){if(w(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===h,u=c.charCodeAt(c.length-1)===h;return c=v(c,!a,"/",f),c.length===0?a?"/":u?"./":".":(u&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return w(c,"path"),c.length>0&&c.charCodeAt(0)===h},join(...c){if(c.length===0)return".";let a;for(let u=0;u<c.length;++u){const n=c[u];w(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(w(c,"from"),w(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const u=1,n=c.length,o=n-u,s=1,r=a.length-s,l=o<r?o:r;let m=-1,y=0;for(;y<l;y++){const R=c.charCodeAt(u+y);if(R!==a.charCodeAt(s+y))break;R===h&&(m=y)}if(y===l)if(r>l){if(a.charCodeAt(s+y)===h)return a.slice(s+y+1);if(y===0)return a.slice(s+y)}else o>l&&(c.charCodeAt(u+y)===h?m=y:y===0&&(m=0));let D="";for(y=u+m+1;y<=n;++y)(y===n||c.charCodeAt(y)===h)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(s+m)}`},toNamespacedPath(c){return c},dirname(c){if(w(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===h;let u=-1,n=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===h){if(!n){u=o;break}}else n=!1;return u===-1?a?"/":".":a&&u===1?"//":c.slice(0,u)},basename(c,a){a!==void 0&&w(a,"ext"),w(c,"path");let u=0,n=-1,o=!0,s;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let r=a.length-1,l=-1;for(s=c.length-1;s>=0;--s){const m=c.charCodeAt(s);if(m===h){if(!o){u=s+1;break}}else l===-1&&(o=!1,l=s+1),r>=0&&(m===a.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=l))}return u===n?n=l:n===-1&&(n=c.length),c.slice(u,n)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===h){if(!o){u=s+1;break}}else n===-1&&(o=!1,n=s+1);return n===-1?"":c.slice(u,n)},extname(c){w(c,"path");let a=-1,u=0,n=-1,o=!0,s=0;for(let r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===h){if(!o){u=r+1;break}continue}n===-1&&(o=!1,n=r+1),l===E?a===-1?a=r:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||n===-1||s===0||s===1&&a===n-1&&a===u+1?"":c.slice(a,n)},format:P.bind(null,"/"),parse(c){w(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.charCodeAt(0)===h;let n;u?(a.root="/",n=1):n=0;let o=-1,s=0,r=-1,l=!0,m=c.length-1,y=0;for(;m>=n;--m){const D=c.charCodeAt(m);if(D===h){if(!l){s=m+1;break}continue}r===-1&&(l=!1,r=m+1),D===E?o===-1?o=m:y!==1&&(y=1):o!==-1&&(y=-1)}if(r!==-1){const D=s===0&&u?1:s;o===-1||y===0||y===1&&o===r-1&&o===s+1?a.base=a.name=c.slice(D,r):(a.name=c.slice(D,o),a.base=c.slice(D,r),a.ext=c.slice(o,r))}return s>0?a.dir=c.slice(0,s-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[80],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(k,...I){const E=I.reduce((i,S)=>(i[S]=!0,i),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(i=>!E[i]).forEach(i=>{for(let S=0;S<h.length;S++)if(i.search(h[S])!==-1){delete k[i];break}})}e.sanitizeProcessEnvironment=M}),define(Q[108],J([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class M{constructor(I){this._highResolution=L&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new M(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Q[4],J([0,1,16,42,2,107,108]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(a){a.None=()=>M.Disposable.None;function u(F){return(B,V=null,C)=>{let N=!1,U;return U=F(Y=>{if(!N)return U?U.dispose():N=!0,B.call(V,Y)},null,C),N&&U.dispose(),U}}a.once=u;function n(F,B){return y((V,C=null,N)=>F(U=>V.call(C,B(U)),null,N))}a.map=n;function o(F,B){return y((V,C=null,N)=>F(U=>{B(U),V.call(C,U)},null,N))}a.forEach=o;function s(F,B){return y((V,C=null,N)=>F(U=>B(U)&&V.call(C,U),null,N))}a.filter=s;function r(F){return F}a.signal=r;function l(...F){return(B,V=null,C)=>(0,M.combinedDisposable)(...F.map(N=>N(U=>B.call(V,U),null,C)))}a.any=l;function m(F,B,V){let C=V;return n(F,N=>(C=B(C,N),C))}a.reduce=m;function y(F){let B;const V=new g({onFirstListenerAdd(){B=F(V.fire,V)},onLastListenerRemove(){B.dispose()}});return V.event}function D(F,B,V=100,C=!1,N){let U,Y,W,A=0;const O=new g({leakWarningThreshold:N,onFirstListenerAdd(){U=F(q=>{A++,Y=B(Y,q),C&&!W&&(O.fire(Y),Y=void 0),clearTimeout(W),W=setTimeout(()=>{const X=Y;Y=void 0,W=void 0,(!C||A>1)&&O.fire(X),A=0},V)})},onLastListenerRemove(){U.dispose()}});return O.event}a.debounce=D;function R(F,B=(V,C)=>V===C){let V=!0,C;return s(F,N=>{const U=V||!B(N,C);return V=!1,C=N,U})}a.latch=R;function T(F,B){return[a.filter(F,B),a.filter(F,V=>!B(V))]}a.split=T;function _(F,B=!1,V=[]){let C=V.slice(),N=F(W=>{C?C.push(W):Y.fire(W)});const U=()=>{C&&C.forEach(W=>Y.fire(W)),C=null},Y=new g({onFirstListenerAdd(){N||(N=F(W=>Y.fire(W)))},onFirstListenerDidAdd(){C&&(B?setTimeout(U):U())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Y.event}a.buffer=_;class j{constructor(B){this.event=B}map(B){return new j(n(this.event,B))}forEach(B){return new j(o(this.event,B))}filter(B){return new j(s(this.event,B))}reduce(B,V){return new j(m(this.event,B,V))}latch(){return new j(R(this.event))}debounce(B,V=100,C=!1,N){return new j(D(this.event,B,V,C,N))}on(B,V,C){return this.event(B,V,C)}once(B,V,C){return u(this.event)(B,V,C)}}function te(F){return new j(F)}a.chain=te;function se(F,B,V=C=>C){const C=(...W)=>Y.fire(V(...W)),N=()=>F.on(B,C),U=()=>F.removeListener(B,C),Y=new g({onFirstListenerAdd:N,onLastListenerRemove:U});return Y.event}a.fromNodeEventEmitter=se;function oe(F,B,V=C=>C){const C=(...W)=>Y.fire(V(...W)),N=()=>F.addEventListener(B,C),U=()=>F.removeEventListener(B,C),Y=new g({onFirstListenerAdd:N,onLastListenerRemove:U});return Y.event}a.fromDOMEventEmitter=oe;function G(F){return new Promise(B=>u(F)(B))}a.toPromise=G})(E=e.Event||(e.Event={}));class h{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${h._idPool++}`}start(u){this._stopWatch=new I.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let d=-1;function i(a){const u=d;return d=a,{dispose(){d=u}}}e.setGlobalLeakWarningThreshold=i;class S{constructor(u,n=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let n=d;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||u<n)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(o)||0;if(this._stacks.set(o,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let r,l=0;for(const[m,y]of this._stacks)(!r||l<y)&&(r=m,l=y);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${l}):`),console.warn(r)}return()=>{const r=this._stacks.get(o)||0;this._stacks.set(o,r-1)}}}class g{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=d>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(u,n,o)=>{this._listeners||(this._listeners=new k.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(n?[u,n]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,n);const l=this._leakageMon?.check(this._listeners.size),m=(0,M.toDisposable)(()=>{l&&l(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof M.DisposableStore?o.add(m):Array.isArray(o)&&o.push(m),m}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,o]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class w extends g{async fireAsync(u,n,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),l=[],m={...r,waitUntil:y=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");o&&(y=o(y,typeof s=="function"?s:s[0])),l.push(y)}};try{typeof s=="function"?s.call(void 0,m):s[0].call(s[1],m)}catch(y){(0,p.onUnexpectedError)(y);continue}Object.freeze(l),await Promise.allSettled(l).then(y=>{for(const D of y)D.status==="rejected"&&(0,p.onUnexpectedError)(D.reason)})}}}}e.AsyncEmitter=w;class t extends g{constructor(u){super(u);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class f extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=f;class b extends g{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const n={event:u,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const o=()=>{this.hasListeners&&this.unhook(n);const s=this.events.indexOf(n);this.events.splice(s,1)};return(0,M.toDisposable)((0,L.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(n=>this.emitter.fire(n))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class P{constructor(){this.buffers=[]}wrapEvent(u){return(n,o,s)=>u(r=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>n.call(o,r)):n.call(o,r)},void 0,s)}bufferEvents(u){const n=[];this.buffers.push(n);const o=u();return this.buffers.pop(),n.forEach(s=>s()),o}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=M.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Q[23],J([0,1,4]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,h){const d=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(d)}}});var M;(function(E){function h(d){return d===E.None||d===E.Cancelled||d instanceof k?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=M.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=I}),define(Q[109],J([0,1,4]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(S){const g=this._icons.get(S.id);g?S.description?g.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new L;e.iconRegistry=M;function k(i,S){return new E(i,S)}e.registerCodicon=k;function I(i){return i?i.replace(/\$\((.*?)\)/g,(S,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=I;class E{constructor(S,g,w){this.id=S,this.definition=g,this.description=w,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function h(i,S){const g=["codicon","codicon-"+i];return S&&g.push("codicon-modifier-"+S),g}e.getClassNamesArray=h;var d;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(f){if(f instanceof E)return["codicon","codicon-"+f.id];const b=S.exec(f.id);if(!b)return g(E.error);let[,v,P]=b;const c=["codicon","codicon-"+v];return P&&c.push("codicon-modifier-"+P.substr(1)),c}i.asClassNameArray=g;function w(f){return g(f).join(" ")}i.asClassName=w;function t(f){return"."+g(f).join(".")}i.asCSSSelector=t})(d=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(E=e.Codicon||(e.Codicon={}))}),define(Q[60],J([0,1,16,2]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=M;function k(c){const a=c;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function I(c,a){return new E(c,a)}e.newWriteableStream=I;class E{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let n;switch(a){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(u);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(c,a){const u=[];let n;for(;(n=c.read())!==null;)u.push(n);return a(u)}e.consumeReadable=h;function d(c,a,u){const n=[];let o;for(;(o=c.read())!==null&&n.length<u;)n.push(o);return o===null&&n.length>0?a(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const s=o;return o=void 0,s}return c.read()}}}e.peekReadable=d;function i(c,a){return new Promise((u,n)=>{const o=[];S(c,{onData:s=>{a&&o.push(s)},onError:s=>{a?n(s):u(void 0)},onEnd:()=>{u(a?a(o):void 0)}})})}e.consumeStream=i;function S(c,a){c.on("error",u=>a.onError(u)),c.on("end",()=>a.onEnd()),c.on("data",u=>a.onData(u))}e.listenStream=S;function g(c,a){return new Promise((u,n)=>{const o=new L.DisposableStore,s=[],r=y=>{if(s.push(y),s.length>a)return o.dispose(),c.pause(),u({stream:c,buffer:s,ended:!1})},l=y=>n(y),m=()=>u({stream:c,buffer:s,ended:!0});o.add((0,L.toDisposable)(()=>c.removeListener("error",l))),c.on("error",l),o.add((0,L.toDisposable)(()=>c.removeListener("end",m))),c.on("end",m),o.add((0,L.toDisposable)(()=>c.removeListener("data",r))),c.on("data",r)})}e.peekStream=g;function w(c,a){const u=I(a);return u.end(c),u}e.toStream=w;function t(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function f(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=f;function b(c,a,u){const n=I(u);return S(c,{onData:o=>n.write(a.data(o)),onError:o=>n.error(a.error?a.error(o):o),onEnd:()=>n.end()}),n}e.transform=b;function v(c,a,u){let n=!1;return{read:()=>{const o=a.read();return n?o:(n=!0,o!==null?u([c,o]):c)}}}e.prefixedReadable=v;function P(c,a,u){let n=!1;const o=I(u);return S(a,{onData:s=>n?o.write(s):(n=!0,o.write(u([c,s]))),onError:s=>o.error(s),onEnd:()=>{n||(n=!0,o.write(c)),o.end()}}),o}e.prefixedStream=P}),define(Q[17],J([0,1,60]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let M,k;class I{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&L?new I(Buffer.from(r)):(M||(M=new TextEncoder),new I(M.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let D=0,R=r.length;D<R;D++)l+=r[D].byteLength}const m=I.alloc(l);let y=0;for(let D=0,R=r.length;D<R;D++){const T=r[D];m.set(T,y),y+=T.byteLength}return m}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(r,l){return new I(this.buffer.subarray(r,l))}set(r,l){r instanceof I?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,l){i(this.buffer,r,l)}readUInt32LE(r){return S(this.buffer,r)}writeUInt32LE(r,l){g(this.buffer,r,l)}readUInt8(r){return w(this.buffer,r)}writeUInt8(r,l){t(this.buffer,r,l)}}e.VSBuffer=I;function E(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=E;function h(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255}e.writeUInt16LE=h;function d(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=d;function i(s,r,l){s[l+3]=r,r=r>>>8,s[l+2]=r,r=r>>>8,s[l+1]=r,r=r>>>8,s[l]=r}e.writeUInt32BE=i;function S(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=S;function g(s,r,l){s[l+0]=r&255,r=r>>>8,s[l+1]=r&255,r=r>>>8,s[l+2]=r&255,r=r>>>8,s[l+3]=r&255}e.writeUInt32LE=g;function w(s,r){return s[r]}e.readUInt8=w;function t(s,r,l){s[l]=r}e.writeUInt8=t;function f(s){return p.consumeReadable(s,r=>I.concat(r))}e.readableToBuffer=f;function b(s){return p.toReadable(s)}e.bufferToReadable=b;function v(s){return p.consumeStream(s,r=>I.concat(r))}e.streamToBuffer=v;async function P(s){return s.ended?I.concat(s.buffer):I.concat([...s.buffer,await v(s.stream)])}e.bufferedStreamToBuffer=P;function c(s){return p.toStream(s,r=>I.concat(r))}e.bufferToStream=c;function a(s){return p.transform(s,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=a;function u(s){return p.newWriteableStream(r=>I.concat(r),s)}e.newWriteableBufferStream=u;function n(s,r){return p.prefixedReadable(s,r,l=>I.concat(l))}e.prefixedBufferReadable=n;function o(s,r){return p.prefixedStream(s,r,l=>I.concat(l))}e.prefixedBufferStream=o}),define(Q[27],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function M(K,...ne){return ne.length===0?K:K.replace(L,function(ce,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=ne.length?ce:ne[Ee]})}e.format=M;const k=/{([^}]+)}/g;function I(K,ne){return K.replace(k,(ce,pe)=>ne[pe]??ce)}e.format2=I;function E(K){return K.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=E;function h(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=h;function d(K,ne){let ce=0;const pe=ne.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===pe&&ce++;return ce}e.count=d;function i(K,ne,ce="\u2026"){return K.length<=ne?K:`${K.substr(0,ne)}${ce}`}e.truncate=i;function S(K,ne=" "){const ce=g(K,ne);return w(ce,ne)}e.trim=S;function g(K,ne){if(!K||!ne)return K;const ce=ne.length;if(ce===0||K.length===0)return K;let pe=0;for(;K.indexOf(ne,pe)===pe;)pe=pe+ce;return K.substring(pe)}e.ltrim=g;function w(K,ne){if(!K||!ne)return K;const ce=ne.length,pe=K.length;if(ce===0||pe===0)return K;let Ee=pe,Re=-1;for(;Re=K.lastIndexOf(ne,Ee-1),!(Re===-1||Re+ce!==Ee);){if(Re===0)return"";Ee=Re}return K.substring(0,Ee)}e.rtrim=w;function t(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function f(K){return K.replace(/\*/g,"")}e.stripWildcards=f;function b(K,ne,ce={}){if(!K)throw new Error("Cannot create regex from empty string");ne||(K=h(K)),ce.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let pe="";return ce.global&&(pe+="g"),ce.matchCase||(pe+="i"),ce.multiline&&(pe+="m"),ce.unicode&&(pe+="u"),new RegExp(K,pe)}e.createRegExp=b;function v(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function c(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=c;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function u(K){for(let ne=0,ce=K.length;ne<ce;ne++){const pe=K.charCodeAt(ne);if(pe!==32&&pe!==9)return ne}return-1}e.firstNonWhitespaceIndex=u;function n(K,ne=0,ce=K.length){for(let pe=ne;pe<ce;pe++){const Ee=K.charCodeAt(pe);if(Ee!==32&&Ee!==9)return K.substring(ne,pe)}return K.substring(ne,ce)}e.getLeadingWhitespace=n;function o(K,ne=K.length-1){for(let ce=ne;ce>=0;ce--){const pe=K.charCodeAt(ce);if(pe!==32&&pe!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(K,ne){return K<ne?-1:K>ne?1:0}e.compare=s;function r(K,ne,ce=0,pe=K.length,Ee=0,Re=ne.length){for(;ce<pe&&Ee<Re;ce++,Ee++){let Be=K.charCodeAt(ce),_e=ne.charCodeAt(Ee);if(Be<_e)return-1;if(Be>_e)return 1}const Oe=pe-ce,Ce=Re-Ee;return Oe<Ce?-1:Oe>Ce?1:0}e.compareSubstring=r;function l(K,ne){return m(K,ne,0,K.length,0,ne.length)}e.compareIgnoreCase=l;function m(K,ne,ce=0,pe=K.length,Ee=0,Re=ne.length){for(;ce<pe&&Ee<Re;ce++,Ee++){let Be=K.charCodeAt(ce),_e=ne.charCodeAt(Ee);if(Be===_e)continue;if(Be>=128||_e>=128)return r(K.toLowerCase(),ne.toLowerCase(),ce,pe,Ee,Re);y(Be)&&(Be-=32),y(_e)&&(_e-=32);const $e=Be-_e;if($e!==0)return $e}const Oe=pe-ce,Ce=Re-Ee;return Oe<Ce?-1:Oe>Ce?1:0}e.compareSubstringIgnoreCase=m;function y(K){return K>=97&&K<=122}e.isLowerAsciiLetter=y;function D(K){return K>=65&&K<=90}e.isUpperAsciiLetter=D;function R(K,ne){return K.length===ne.length&&m(K,ne)===0}e.equalsIgnoreCase=R;function T(K,ne){const ce=ne.length;return ne.length>K.length?!1:m(K,ne,0,ce)===0}e.startsWithIgnoreCase=T;function _(K,ne){let ce,pe=Math.min(K.length,ne.length);for(ce=0;ce<pe;ce++)if(K.charCodeAt(ce)!==ne.charCodeAt(ce))return ce;return pe}e.commonPrefixLength=_;function j(K,ne){let ce,pe=Math.min(K.length,ne.length);const Ee=K.length-1,Re=ne.length-1;for(ce=0;ce<pe;ce++)if(K.charCodeAt(Ee-ce)!==ne.charCodeAt(Re-ce))return ce;return pe}e.commonSuffixLength=j;function te(K){return 55296<=K&&K<=56319}e.isHighSurrogate=te;function se(K){return 56320<=K&&K<=57343}e.isLowSurrogate=se;function oe(K,ne){return(K-55296<<10)+(ne-56320)+65536}e.computeCodePoint=oe;function G(K,ne,ce){const pe=K.charCodeAt(ce);if(te(pe)&&ce+1<ne){const Ee=K.charCodeAt(ce+1);if(se(Ee))return oe(pe,Ee)}return pe}e.getNextCodePoint=G;function F(K,ne){const ce=K.charCodeAt(ne-1);if(se(ce)&&ne>1){const pe=K.charCodeAt(ne-2);if(te(pe))return oe(pe,ce)}return ce}function B(K,ne){const ce=We.getInstance(),pe=ne,Ee=K.length,Re=G(K,Ee,ne);ne+=Re>=65536?2:1;let Oe=ce.getGraphemeBreakType(Re);for(;ne<Ee;){const Ce=G(K,Ee,ne),Be=ce.getGraphemeBreakType(Ce);if(Fe(Oe,Be))break;ne+=Ce>=65536?2:1,Oe=Be}return ne-pe}e.nextCharLength=B;function V(K,ne){const ce=We.getInstance(),pe=ne,Ee=F(K,ne);ne-=Ee>=65536?2:1;let Re=ce.getGraphemeBreakType(Ee);for(;ne>0;){const Oe=F(K,ne),Ce=ce.getGraphemeBreakType(Oe);if(Fe(Ce,Re))break;ne-=Oe>=65536?2:1,Re=Ce}return pe-ne}e.prevCharLength=V;function C(K,ne){const ce=We.getInstance(),pe=K.length,Ee=ne,Re=G(K,pe,ne),Oe=ce.getGraphemeBreakType(Re);ne+=Re>=65536?2:1;let Ce=Oe;for(;ne<pe;){const _e=G(K,pe,ne),$e=ce.getGraphemeBreakType(_e);if(Fe(Ce,$e))break;ne+=_e>=65536?2:1,Ce=$e}const Be=ne;for(ne=Ee,Ce=Oe;ne>0;){const _e=F(K,ne),$e=ce.getGraphemeBreakType(_e);if(Fe($e,Ce))break;ne-=_e>=65536?2:1,Ce=$e}return[ne,Be]}function N(K,ne){return ne>0&&se(K.charCodeAt(ne))?C(K,ne-1):C(K,ne)}e.getCharContainingOffset=N;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(K){return U.test(K)}e.containsRTL=Y;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function A(K){return W.test(K)}e.containsEmoji=A;const O=/^[\t\n\r\x20-\x7E]*$/;function q(K){return O.test(K)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=X;function $(K){for(let ne=0,ce=K.length;ne<ce;ne++)if(z(K.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=$;function z(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=z;function Z(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=Z;function ee(K,ne){if(K.length<ne)return K;const ce=/\b/g;let pe=0;for(;ce.test(K)&&!(K.length-ce.lastIndex<ne);)pe=ce.lastIndex,ce.lastIndex+=1;return K.substring(pe).replace(/^\s/,"")}e.lcut=ee;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ae(K){return K&&(K=K.replace(le,""),K=K.replace(re,""),K=K.replace(ie,"")),K}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(K){return ue(K)?K.substr(1):K}e.stripUTF8BOM=de;function ve(K,ne){if(!K||!ne||K.length<ne.length)return!1;const ce=ne.length,pe=K.toLowerCase();let Ee=0,Re=-1;for(;Ee<ce;){const Oe=pe.indexOf(ne[Ee],Re+1);if(Oe<0)return!1;Re=Oe,Ee++}return!0}e.fuzzyContains=ve;function Pe(K,ne=!1){return K?(ne&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Pe;function we(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=we;function ge(K,ne=1){if(ne===0)return"";let ce=-1;do ce=K.indexOf(`
`,ce+1),ne--;while(ne>0&&ce>=0);return ce===-1?K:(K[ce-1]==="\r"&&ce--,K.substr(0,ce))}e.getNLines=ge;function be(K){const ne=90-65+1;return K=K%(2*ne),K<ne?String.fromCharCode(97+K):String.fromCharCode(65+K-ne)}e.singleLetterHash=be;function ke(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=ke;function Fe(K,ne){return K===0?ne!==5&&ne!==7:K===2&&ne===3?!1:K===4||K===2||K===3||ne===4||ne===2||ne===3?!0:!(K===8&&(ne===8||ne===9||ne===11||ne===12)||(K===11||K===9)&&(ne===9||ne===10)||(K===12||K===10)&&ne===10||ne===5||ne===13||ne===7||K===1||K===13&&ne===14||K===6&&ne===6)}e.breakBetweenGraphemeBreakType=Fe;var Ne;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Ve()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ce=this._data,pe=ce.length/3;let Ee=1;for(;Ee<=pe;)if(ne<ce[3*Ee])Ee=2*Ee;else if(ne>ce[3*Ee+1])Ee=2*Ee+1;else return ce[3*Ee+2];return 0}}We._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function xe(K,ne){if(K===0)return 0;const ce=st(K,ne);if(ce!==void 0)return ce;const pe=F(ne,K);return K-=Ke(pe),K}e.getLeftDeleteOffset=xe;function st(K,ne){let ce=F(ne,K);for(K-=Ke(ce);ht(ce)||ce===65039||ce===8419;){if(K===0)return;ce=F(ne,K),K-=Ke(ce)}if(!!Z(ce)){if(K>=0){const pe=F(ne,K);pe===8205&&(K-=Ke(pe))}return K}}function Ke(K){return K>=65536?2:1}function ht(K){return 127995<=K&&K<=127999}var et;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Q[81],J([0,1,27]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(v){return M(v,0)}e.hash=L;function M(v,P){switch(typeof v){case"object":return v===null?k(349,P):Array.isArray(v)?h(v,P):d(v,P);case"string":return E(v,P);case"boolean":return I(v,P);case"number":return k(v,P);case"undefined":return k(937,P);default:return k(617,P)}}e.doHash=M;function k(v,P){return(P<<5)-P+v|0}e.numberHash=k;function I(v,P){return k(v?433:863,P)}function E(v,P){P=k(149417,P);for(let c=0,a=v.length;c<a;c++)P=k(v.charCodeAt(c),P);return P}e.stringHash=E;function h(v,P){return P=k(104579,P),v.reduce((c,a)=>M(a,c),P)}function d(v,P){return P=k(181387,P),Object.keys(v).sort().reduce((c,a)=>(c=E(a,c),M(v[a],c)),P)}class i{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=M(P,this._value),this._value}}e.Hasher=i;var S;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function g(v,P,c=32){const a=c-P,u=~((1<<a)-1);return(v<<P|(u&v)>>>a)>>>0}function w(v,P=0,c=v.byteLength,a=0){for(let u=0;u<c;u++)v[P+u]=a}function t(v,P,c="0"){for(;v.length<P;)v=c+v;return v}function f(v,P=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),P/4)}e.toHexString=f;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let u=this._buffLen,n=this._leftoverHighSurrogate,o,s;for(n!==0?(o=n,s=-1,n=0):(o=P.charCodeAt(0),s=0);;){let r=o;if(p.isHighSurrogate(o))if(s+1<c){const l=P.charCodeAt(s+1);p.isLowSurrogate(l)?(s++,r=p.computeCodePoint(o,l)):r=65533}else{n=o;break}else p.isLowSurrogate(o)&&(r=65533);if(u=this._push(a,u,r),s++,s<c)o=P.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=n}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,c=this._buffDV;for(let y=0;y<64;y+=4)P.setUint32(y,c.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)P.setUint32(y,g(P.getUint32(y-12,!1)^P.getUint32(y-32,!1)^P.getUint32(y-56,!1)^P.getUint32(y-64,!1),1),!1);let a=this._h0,u=this._h1,n=this._h2,o=this._h3,s=this._h4,r,l,m;for(let y=0;y<80;y++)y<20?(r=u&n|~u&o,l=1518500249):y<40?(r=u^n^o,l=1859775393):y<60?(r=u&n|u&o|n&o,l=2400959708):(r=u^n^o,l=3395469782),m=g(a,5)+r+s+l+P.getUint32(y*4,!1)&4294967295,s=o,o=n,n=g(u,30),u=a,a=m;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))});var Et=this&&this.__classPrivateFieldSet||function(H,e,p,L,M){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!M:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?M.call(H,p):M?M.value=p:e.set(H,p),p},qe=this&&this.__classPrivateFieldGet||function(H,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!L:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(H):L?L.value:e.get(H)};define(Q[40],J([0,1,31,27]),function(H,e,p,L){"use strict";var M,k,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(s,r,l){let m=s.get(r);return m===void 0&&(m=l,s.set(r,m)),m}e.getOrSet=E;function h(s){const r=[];return s.forEach((l,m)=>{r.push(`${m} => ${l}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=h;function d(s){const r=[];return s.forEach(l=>{r.push(l)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=d;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),m=this._value.charCodeAt(this._pos);return l-m}value(){return this._value[this._pos]}}e.StringIterator=i;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class g{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var w;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(w||(w={}));class t{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(b||(b={}));class v{constructor(r){this._iter=r}static forUris(r=()=>!1){return new v(new t(r))}static forPaths(){return new v(new g)}static forStrings(){return new v(new i)}static forConfigKeys(){return new v(new S)}clear(){this._root=void 0}fill(r,l){if(l){const m=l.slice(0);(0,p.shuffle)(m);for(let y of m)this.set(y,r)}else{const m=r.slice(0);(0,p.shuffle)(m);for(let y of m)this.set(y[0],y[1])}}set(r,l){const m=this._iter.reset(r);let y;this._root||(this._root=new f,this._root.segment=m.value());const D=[];for(y=this._root;;){const T=m.cmp(y.segment);if(T>0)y.left||(y.left=new f,y.left.segment=m.value()),D.push([-1,y]),y=y.left;else if(T<0)y.right||(y.right=new f,y.right.segment=m.value()),D.push([1,y]),y=y.right;else if(m.hasNext())m.next(),y.mid||(y.mid=new f,y.mid.segment=m.value()),D.push([0,y]),y=y.mid;else break}const R=y.value;y.value=l,y.key=r;for(let T=D.length-1;T>=0;T--){const _=D[T][1];_.updateHeight();const j=_.balanceFactor();if(j<-1||j>1){const te=D[T][0],se=D[T+1][0];if(te===1&&se===1)D[T][1]=_.rotateLeft();else if(te===-1&&se===-1)D[T][1]=_.rotateRight();else if(te===1&&se===-1)_.right=D[T+1][1]=D[T+1][1].rotateRight(),D[T][1]=_.rotateLeft();else if(te===-1&&se===1)_.left=D[T+1][1]=D[T+1][1].rotateLeft(),D[T][1]=_.rotateRight();else throw new Error;if(T>0)switch(D[T-1][0]){case-1:D[T-1][1].left=D[T][1];break;case 1:D[T-1][1].right=D[T][1];break;case 0:D[T-1][1].mid=D[T][1];break}else this._root=D[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let m=this._root;for(;m;){const y=l.cmp(m.segment);if(y>0)m=m.left;else if(y<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else break}return m}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const m=this._iter.reset(r),y=[];let D=this._root;for(;D;){const R=m.cmp(D.segment);if(R>0)y.push([-1,D]),D=D.left;else if(R<0)y.push([1,D]),D=D.right;else if(m.hasNext())m.next(),y.push([0,D]),D=D.mid;else break}if(!!D){if(l?(D.left=void 0,D.mid=void 0,D.right=void 0,D.height=1):(D.key=void 0,D.value=void 0),!D.mid&&!D.value)if(D.left&&D.right){const R=this._min(D.right),{key:T,value:_,segment:j}=R;this._delete(R.key,!1),D.key=T,D.value=_,D.segment=j}else{const R=D.left??D.right;if(y.length>0){const[T,_]=y[y.length-1];switch(T){case-1:_.left=R;break;case 0:_.mid=R;break;case 1:_.right=R;break}}else this._root=R}for(let R=y.length-1;R>=0;R--){const T=y[R][1];T.updateHeight();const _=T.balanceFactor();if(_>1?(T.right.balanceFactor()>=0||(T.right=y[R+1][1]=y[R+1][1].rotateRight()),y[R][1]=T.rotateLeft()):_<-1&&(T.left.balanceFactor()<=0||(T.left=y[R+1][1]=y[R+1][1].rotateLeft()),y[R][1]=T.rotateRight()),R>0)switch(y[R-1][0]){case-1:y[R-1][1].left=y[R][1];break;case 1:y[R-1][1].right=y[R][1];break;case 0:y[R-1][1].mid=y[R][1];break}else this._root=y[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const l=this._iter.reset(r);let m=this._root,y;for(;m;){const D=l.cmp(m.segment);if(D>0)m=m.left;else if(D<0)m=m.right;else if(l.hasNext())l.next(),y=m.value||y,m=m.mid;else break}return m&&m.value||y}findSuperstr(r){const l=this._iter.reset(r);let m=this._root;for(;m;){const y=l.cmp(m.segment);if(y>0)m=m.left;else if(y<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(r){for(const[l,m]of this)r(m,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=l=>{if(!l)return!0;const m=l.balanceFactor();return m<-1||m>1?!1:r(l.left)&&r(l.right)};return r(this._root)}}e.TernarySearchTree=v;class P{constructor(r,l){this.uri=r,this.value=l}}class c{constructor(r,l){this[M]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=l??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),new P(r,l)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[m,y]of this.map)r(y.value,y.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var a;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const m=this._map.get(r);if(!!m)return l!==0&&this.touch(m,l),m.value}set(r,l,m=0){let y=this._map.get(r);if(y)y.value=l,m!==0&&this.touch(y,m);else{switch(y={key:r,value:l,next:void 0,previous:void 0},m){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(r,y),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const m=this._state;let y=this._head;for(;y;){if(l?r.bind(l)(y.value,y.key,this):r(y.value,y.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const r=this,l=this._state;let m=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const D={value:m.key,done:!1};return m=m.next,D}else return{value:void 0,done:!0}}};return y}values(){const r=this,l=this._state;let m=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const D={value:m.value,done:!1};return m=m.next,D}else return{value:void 0,done:!0}}};return y}entries(){const r=this,l=this._state;let m=this._head;const y={[Symbol.iterator](){return y},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(m){const D={value:[m.key,m.value],done:!1};return m=m.next,D}else return{value:void 0,done:!0}}};return y}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,m=this.size;for(;l&&m>r;)this._map.delete(l.key),l=l.next,m--;this._head=l,this._size=m,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,m=r.previous;if(!l||!m)throw new Error("Invalid list");l.previous=m,m.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const m=r.next,y=r.previous;r===this._tail?(y.next=void 0,this._tail=y):(m.previous=y,y.next=m),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const m=r.next,y=r.previous;r===this._head?(m.previous=void 0,this._head=m):(m.previous=y,y.next=m),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,m)=>{r.push([m,l])}),r}fromJSON(r){this.clear();for(const[l,m]of r)this.set(l,m)}}e.LinkedMap=u;class n extends u{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class o{constructor(r){I.set(this,void 0),Et(this,I,r,"f")}get size(){return qe(this,I,"f").size}forEach(r,l){qe(this,I,"f").forEach(r,l)}get(r){return qe(this,I,"f").get(r)}has(r){return qe(this,I,"f").has(r)}entries(){return qe(this,I,"f").entries()}keys(){return qe(this,I,"f").keys()}values(){return qe(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return qe(this,I,"f").entries()}}e.ReadonlyMapView=o}),define(Q[70],J([0,1,40]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function M(d){return h(d,"NFC",L)}e.normalizeNFC=M;const k=new p.LRUCache(1e4);function I(d){return h(d,"NFD",k)}e.normalizeNFD=I;const E=/[^\u0000-\u0080]/;function h(d,i,S){if(!d)return d;const g=S.get(d);if(g)return g;let w;return E.test(d)?w=d.normalize(i):w=d,S.set(d,w),w}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(i){return I(i).replace(d,"")}}()}),define(Q[14],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(D){return Array.isArray(D)}e.isArray=p;function L(D){return typeof D=="string"}e.isString=L;function M(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=M;function k(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=k;function I(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=I;function E(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=E;function h(D){return D===!0||D===!1}e.isBoolean=h;function d(D){return typeof D=="undefined"}e.isUndefined=d;function i(D){return!S(D)}e.isDefined=i;function S(D){return d(D)||D===null}e.isUndefinedOrNull=S;function g(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=g;function w(D){if(S(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=w;function t(...D){const R=[];for(let T=0;T<D.length;T++){const _=D[T];if(S(_))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);R.push(_)}return R}e.assertAllDefined=t;const f=Object.prototype.hasOwnProperty;function b(D){if(!k(D))return!1;for(let R in D)if(f.call(D,R))return!1;return!0}e.isEmptyObject=b;function v(D){return typeof D=="function"}e.isFunction=v;function P(...D){return D.length>0&&D.every(v)}e.areFunctions=P;function c(D,R){const T=Math.min(D.length,R.length);for(let _=0;_<T;_++)a(D[_],R[_])}e.validateConstraints=c;function a(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(v(R)){try{if(D instanceof R)return}catch{}if(!S(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(D){let R=[],T=Object.getPrototypeOf(D);for(;Object.prototype!==T;)R=R.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return R}e.getAllPropertyNames=u;function n(D){const R=[];for(const T of u(D))typeof D[T]=="function"&&R.push(T);return R}e.getAllMethodNames=n;function o(D,R){const T=j=>function(){const te=Array.prototype.slice.call(arguments,0);return R(j,te)};let _={};for(const j of D)_[j]=T(j);return _}e.createProxyObject=o;function s(D){return D===null?void 0:D}e.withNullAsUndefined=s;function r(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=r;function l(D){return class{constructor(){return new Proxy({},{get(R,T){if(R[T])return R[T];throw new Error(`Not Implemented: ${D}->${String(T)}`)}})}}}e.NotImplementedProxy=l;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function y(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=y}),define(Q[33],J([0,1,8,3,27,14]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function E(s){return s.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=E;function h(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function d(s,r=p.posix.sep){if(!s)return"";const l=s.length,m=s.charCodeAt(0);if(I(m)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let D=3;const R=D;for(;D<l&&!I(s.charCodeAt(D));D++);if(R!==D&&!I(s.charCodeAt(D+1))){for(D+=1;D<l;D++)if(I(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,r)}}return r}else if(v(m)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let y=s.indexOf("://");if(y!==-1){for(y+=3;y<l;y++)if(I(s.charCodeAt(y)))return s.slice(0,y+1)}return""}e.getRoot=d;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let l=2;const m=l;for(;l<s.length&&(r=s.charCodeAt(l),r!==92);l++);return!(m===l||(r=s.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=i;const S=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,r=L.isWindows){const l=r?S:g;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||r&&w.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function f(s,r,l){const m=s===r;return!l||m?m:!s||!r?!1:(0,M.equalsIgnoreCase)(s,r)}e.isEqual=f;function b(s,r,l,m=p.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(l){if(!(0,M.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let D=r.length;return r.charAt(r.length-1)===m&&D--,s.charAt(D)===m}return r.charAt(r.length-1)!==m&&(r+=m),s.indexOf(r)===0}e.isEqualOrParent=b;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function P(s,r){return L.isWindows&&s.endsWith(":")&&(s+=p.sep),(0,p.isAbsolute)(s)||(s=(0,p.join)(r,s)),s=(0,p.normalize)(s),L.isWindows?(s=(0,M.rtrim)(s,p.sep),s.endsWith(":")&&(s+=p.sep)):(s=(0,M.rtrim)(s,p.sep),s||(s=p.sep)),s}e.sanitizeFilePath=P;function c(s){const r=(0,p.normalize)(s);return L.isWindows?s.length>3?!1:a(r)&&(s.length===2||r.charCodeAt(2)===92):r===p.posix.sep}e.isRootOrDriveLetter=c;function a(s){return L.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(s){return a(s)?s[0]:void 0}e.getDriveLetter=u;function n(s,r,l){return r.length>s.length?-1:s===r?0:(l&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=n;function o(s){const r=s.split(":");let l,m,y;if(r.forEach(D=>{const R=Number(D);(0,k.isNumber)(R)?m===void 0?m=R:y===void 0&&(y=R):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:y!==void 0?y:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(Q[43],J([0,1,14]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.keys(f).forEach(v=>{f[v]&&typeof f[v]=="object"?b[v]=L(f[v]):b[v]=f[v]}),b}e.deepClone=L;function M(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const v=b.shift();Object.freeze(v);for(const P in v)if(k.call(v,P)){const c=v[P];typeof c=="object"&&!Object.isFrozen(c)&&b.push(c)}}return f}e.deepFreeze=M;const k=Object.prototype.hasOwnProperty;function I(f,b){return E(f,b,new Set)}e.cloneAndChange=I;function E(f,b,v){if((0,p.isUndefinedOrNull)(f))return f;const P=b(f);if(typeof P!="undefined")return P;if((0,p.isArray)(f)){const c=[];for(const a of f)c.push(E(a,b,v));return c}if((0,p.isObject)(f)){if(v.has(f))throw new Error("Cannot clone recursive data-structure");v.add(f);const c={};for(let a in f)k.call(f,a)&&(c[a]=E(f[a],b,v));return v.delete(f),c}return f}function h(f,b,v=!0){return(0,p.isObject)(f)?((0,p.isObject)(b)&&Object.keys(b).forEach(P=>{P in f?v&&((0,p.isObject)(f[P])&&(0,p.isObject)(b[P])?h(f[P],b[P],v):f[P]=b[P]):f[P]=b[P]}),f):b}e.mixin=h;function d(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let v,P;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(v=0;v<f.length;v++)if(!d(f[v],b[v]))return!1}else{const c=[];for(P in f)c.push(P);c.sort();const a=[];for(P in b)a.push(P);if(a.sort(),!d(c,a))return!1;for(v=0;v<c.length;v++)if(!d(f[c[v]],b[c[v]]))return!1}return!0}e.equals=d;function i(f){const b=new Set;return JSON.stringify(f,(v,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=i;function S(f,b,v){const P=b(f);return typeof P=="undefined"?v:P}e.getOrDefault=S;function g(f,b){const v=Object.create(null);return!f||!b||Object.keys(b).forEach(c=>{const a=f[c],u=b[c];d(a,u)||(v[c]=u)}),v}e.distinct=g;function w(f,b){const v=b.toLowerCase(),P=Object.keys(f).find(c=>c.toLowerCase()===v);return P?f[P]:f[b]}e.getCaseInsensitive=w;function t(f,b){const v=Object.create(null);for(const P of Object.keys(f))b(P,f[P])&&(v[P]=f[P]);return v}e.filter=t}),define(Q[7],J([0,1,8,3]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,k=/^\//,I=/^\/\//;function E(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!M.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!k.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(s,r){return!s&&!r?"file":s}function d(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==S&&(r=S+r):r=S;break}return r}const i="",S="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(r,l,m,y,D,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=h(r,R),this.authority=l||i,this.path=d(this.scheme,m||i),this.query=y||i,this.fragment=D||i,E(this,R))}static isUri(r){return r instanceof w?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:m,path:y,query:D,fragment:R}=r;return l===void 0?l=this.scheme:l===null&&(l=i),m===void 0?m=this.authority:m===null&&(m=i),y===void 0?y=this.path:y===null&&(y=i),D===void 0?D=this.query:D===null&&(D=i),R===void 0?R=this.fragment:R===null&&(R=i),l===this.scheme&&m===this.authority&&y===this.path&&D===this.query&&R===this.fragment?this:new f(l,m,y,D,R)}static parse(r,l=!1){const m=g.exec(r);return m?new f(m[2]||i,o(m[4]||i),o(m[5]||i),o(m[7]||i),o(m[9]||i),l):new f(i,i,i,i,i)}static file(r){let l=i;if(L.isWindows&&(r=r.replace(/\\/g,S)),r[0]===S&&r[1]===S){const m=r.indexOf(S,2);m===-1?(l=r.substring(2),r=S):(l=r.substring(2,m),r=r.substring(m)||S)}return new f("file",l,r,i,i)}static from(r){const l=new f(r.scheme,r.authority,r.path,r.query,r.fragment);return E(l,!0),l}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&r.scheme==="file"?m=w.file(p.win32.join(c(r,!0),...l)).path:m=p.posix.join(r.path,...l),r.with({path:m})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof w)return r;{const l=new f(r);return l._formatted=r.external,l._fsPath=r._sep===t?r.fsPath:null,l}}else return r}}e.URI=w;const t=L.isWindows?1:void 0;class f extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,r){let l,m=-1;for(let y=0;y<s.length;y++){const D=s.charCodeAt(y);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||r&&D===47)m!==-1&&(l+=encodeURIComponent(s.substring(m,y)),m=-1),l!==void 0&&(l+=s.charAt(y));else{l===void 0&&(l=s.substr(0,y));const R=b[D];R!==void 0?(m!==-1&&(l+=encodeURIComponent(s.substring(m,y)),m=-1),l+=R):m===-1&&(m=y)}}return m!==-1&&(l+=encodeURIComponent(s.substring(m))),l!==void 0?l:s}function P(s){let r;for(let l=0;l<s.length;l++){const m=s.charCodeAt(l);m===35||m===63?(r===void 0&&(r=s.substr(0,l)),r+=b[m]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function c(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function a(s,r){const l=r?P:v;let m="",{scheme:y,authority:D,path:R,query:T,fragment:_}=s;if(y&&(m+=y,m+=":"),(D||y==="file")&&(m+=S,m+=S),D){let j=D.indexOf("@");if(j!==-1){const te=D.substr(0,j);D=D.substr(j+1),j=te.indexOf(":"),j===-1?m+=l(te,!1):(m+=l(te.substr(0,j),!1),m+=":",m+=l(te.substr(j+1),!1)),m+="@"}D=D.toLowerCase(),j=D.indexOf(":"),j===-1?m+=l(D,!1):(m+=l(D.substr(0,j),!1),m+=D.substr(j))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const j=R.charCodeAt(1);j>=65&&j<=90&&(R=`/${String.fromCharCode(j+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const j=R.charCodeAt(0);j>=65&&j<=90&&(R=`${String.fromCharCode(j+32)}:${R.substr(2)}`)}m+=l(R,!0)}return T&&(m+="?",m+=l(T,!1)),_&&(m+="#",m+=r?_:v(_,!1)),m}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(n)?s.replace(n,r=>u(r)):s}}),define(Q[110],J([0,1,7]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(d){const i=d;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function M(d){const i=[];let S;try{const g=JSON.parse(d.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),S=w.__$stack),i.push(...g)}catch(g){i.push("Unable to log remote console arguments",d.arguments)}return{args:i,stack:S}}e.parse=M;function k(d){if(typeof d!="string")return k(M(d).stack);const i=d;if(i){const S=I(i),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(g&&g.length===4)return{uri:p.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function I(d){if(!d)return d;const i=d.indexOf(`
`);return i===-1?d:d.substring(0,i)}function E(d,i){const{args:S,stack:g}=M(d),w=typeof S[0]=="string"&&S.length===1;let t=I(g);t&&(t=`(${t.trim()})`);let f=[];if(typeof S[0]=="string"?t&&w?f=[`%c[${i}] %c${S[0]} %c${t}`,h("blue"),h(""),h("grey")]:f=[`%c[${i}] %c${S[0]}`,h("blue"),h(""),...S.slice(1)]:f=[`%c[${i}]%`,h("blue"),...S],t&&!w&&f.push(t),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,f)}e.log=E;function h(d){return`color: ${d}`}}),define(Q[111],J([0,1,17,27,7]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,h)}e.stringify=k;function I(i){let S=JSON.parse(i);return S=d(S),S}e.parse=I;var E;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function h(i,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:(0,L.regExpFlags)(S)}:S}function d(i,S=0){if(!i||S>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return M.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=d(i[g],S+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=d(i[g],S+1))}return i}e.revive=d}),define(Q[10],J([0,1,3,7]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(M=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,d,i){this._hosts[h]=d,this._ports[h]=i}setConnectionToken(h,d){this._connectionTokens[h]=d}rewrite(h){if(this._delegate)return this._delegate(h);const d=h.authority;let i=this._hosts[d];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const S=this._ports[d],g=this._connectionTokens[d];let w=`path=${encodeURIComponent(h.path)}`;return typeof g=="string"&&(w+=`&tkn=${encodeURIComponent(g)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${i}:${S}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new k;class I{asBrowserUri(h,d){const i=this.toUri(h,d);return i.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===M.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${M.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?i.with({scheme:M.vscodeFileResource,authority:i.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(h,d){const i=this.toUri(h,d);return i.scheme===M.vscodeFileResource?i.with({scheme:M.file,authority:i.authority!==I.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(h,d){return L.URI.isUri(h)?h:L.URI.parse(d.toUrl(h))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Q[15],J([0,1,33,10,8,3,27,7]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(w){return(0,E.uriToFsPath)(w,!0)}e.originalFSPath=h;class d{constructor(t){this._ignorePathCasing=t}compare(t,f,b=!1){return t===f?0:(0,I.compare)(this.getComparisonKey(t,b),this.getComparisonKey(f,b))}isEqual(t,f,b=!1){return t===f?!0:!t||!f?!1:this.getComparisonKey(t,b)===this.getComparisonKey(f,b)}getComparisonKey(t,f=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,f,b=!1){if(t.scheme===f.scheme){if(t.scheme===L.Schemas.file)return p.isEqualOrParent(h(t),h(f),this._ignorePathCasing(t))&&t.query===f.query&&(b||t.fragment===f.fragment);if((0,e.isEqualAuthority)(t.authority,f.authority))return p.isEqualOrParent(t.path,f.path,this._ignorePathCasing(t),"/")&&t.query===f.query&&(b||t.fragment===f.fragment)}return!1}joinPath(t,...f){return E.URI.joinPath(t,...f)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return M.posix.basename(t.path)}extname(t){return M.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let f;return t.scheme===L.Schemas.file?f=E.URI.file(M.dirname(h(t))).path:(f=M.posix.dirname(t.path),t.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),f="/")),t.with({path:f})}normalizePath(t){if(!t.path.length)return t;let f;return t.scheme===L.Schemas.file?f=E.URI.file(M.normalize(h(t))).path:f=M.posix.normalize(t.path),t.with({path:f})}relativePath(t,f){if(t.scheme!==f.scheme||!(0,e.isEqualAuthority)(t.authority,f.authority))return;if(t.scheme===L.Schemas.file){const P=M.relative(h(t),h(f));return k.isWindows?p.toSlashes(P):P}let b=t.path||"/",v=f.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(b.length,v.length);P<c&&!(b.charCodeAt(P)!==v.charCodeAt(P)&&b.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);b=v.substr(0,P)+b.substr(P)}return M.posix.relative(b,v)}resolvePath(t,f){if(t.scheme===L.Schemas.file){const b=E.URI.file(M.resolve(h(t),f));return t.with({authority:b.authority,path:b.path})}return f=p.toPosixPath(f),t.with({path:M.posix.resolve(t.path,f)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,f){return t===f||t!==void 0&&f!==void 0&&(0,I.equalsIgnoreCase)(t,f)}hasTrailingPathSeparator(t,f=M.sep){if(t.scheme===L.Schemas.file){const b=h(t);return b.length>p.getRoot(b).length&&b[b.length-1]===f}else{const b=t.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,f=M.sep){return(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,f=M.sep){let b=!1;if(t.scheme===L.Schemas.file){const v=h(t);b=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===f}else{f="/";const v=t.path;b=v.length===1&&v.charCodeAt(v.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(t,f)?t.with({path:t.path+"/"}):t}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(w=>w.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new d(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(w,t){const f=[];for(let b=0;b<w.length;b++){const v=t(w[b]);w.some((P,c)=>c===b?!1:(0,e.isEqualOrParent)(v,t(P)))||f.push(w[b])}return f}e.distinctParents=i;var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function t(f){const b=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,u]=c.split(":");a&&u&&b.set(a,u)});const P=f.path.substring(0,f.path.indexOf(";"));return P&&b.set(w.META_DATA_MIME,P),b}w.parseMetaData=t})(S=e.DataUri||(e.DataUri={}));function g(w,t,f){if(t){let b=w.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),w.with({scheme:f,authority:t,path:b})}return w.with({scheme:f})}e.toLocalResource=g}),define(Q[9],J([0,1,23,16,4,2,15]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function h(V){const C=new p.CancellationTokenSource,N=V(C.token),U=new Promise((Y,W)=>{const A=C.token.onCancellationRequested(()=>{A.dispose(),C.dispose(),W((0,L.canceled)())});Promise.resolve(N).then(O=>{A.dispose(),C.dispose(),Y(O)},O=>{A.dispose(),C.dispose(),W(O)})});return new class{cancel(){C.cancel()}then(Y,W){return U.then(Y,W)}catch(Y){return this.then(void 0,Y)}finally(Y){return U.finally(Y)}}}e.createCancelablePromise=h;function d(V,C,N){return Promise.race([V,new Promise(U=>C.onCancellationRequested(()=>U(N)))])}e.raceCancellation=d;async function i(V){let C=-1;const N=V.map((Y,W)=>Y.then(A=>(C=W,A))),U=await Promise.race(N);return V.forEach((Y,W)=>{W!==C&&Y.cancel()}),U}e.raceCancellablePromises=i;function S(V,C,N){let U;const Y=setTimeout(()=>{U?.(void 0),N?.()},C);return Promise.race([V.finally(()=>clearTimeout(Y)),new Promise(W=>U=W)])}e.raceTimeout=S;function g(V){return new Promise((C,N)=>{const U=V();E(U)?U.then(C,N):C(U)})}e.asPromise=g;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(C){if(this.activePromise){if(this.queuedPromiseFactory=C,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(N,N).then(U)})}return new Promise((N,U)=>{this.queuedPromise.then(N,U)})}return this.activePromise=C(),new Promise((N,U)=>{this.activePromise.then(Y=>{this.activePromise=null,N(Y)},Y=>{this.activePromise=null,U(Y)})})}}e.Throttler=w;class t{constructor(){this.current=Promise.resolve(null)}queue(C){return this.current=this.current.then(()=>C(),()=>C())}}e.Sequencer=t;class f{constructor(){this.promiseMap=new Map}queue(C,N){const Y=(this.promiseMap.get(C)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(C)===Y&&this.promiseMap.delete(C)});return this.promiseMap.set(C,Y),Y}}e.SequencerByKey=f;class b{constructor(C){this.defaultDelay=C,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(C,N=this.defaultDelay){return this.task=C,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,Y)=>{this.doResolve=U,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class v{constructor(C){this.delayer=new b(C),this.throttler=new w}trigger(C,N){return this.delayer.trigger(()=>this.throttler.queue(C),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class P{constructor(){this._isOpen=!1,this._promise=new Promise((C,N)=>{this._completePromise=C})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class c extends P{constructor(C){super();this._timeout=setTimeout(()=>this.open(),C)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function a(V,C){return C?new Promise((N,U)=>{const Y=setTimeout(()=>{W.dispose(),N()},V),W=C.onCancellationRequested(()=>{clearTimeout(Y),W.dispose(),U((0,L.canceled)())})}):h(N=>a(V,N))}e.timeout=a;function u(V,C=0){const N=setTimeout(V,C);return(0,k.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=u;function n(V){const C=[];let N=0;const U=V.length;function Y(){return N<U?V[N++]():null}function W(A){A!=null&&C.push(A);const O=Y();return O?O.then(W):Promise.resolve(C)}return Promise.resolve(null).then(W)}e.sequence=n;function o(V,C=U=>!!U,N=null){let U=0;const Y=V.length,W=()=>{if(U>=Y)return Promise.resolve(N);const A=V[U++];return Promise.resolve(A()).then(q=>C(q)?Promise.resolve(q):W())};return W()}e.first=o;function s(V,C=U=>!!U,N=null){if(V.length===0)return Promise.resolve(N);let U=V.length;const Y=()=>{U=-1;for(const W of V)W.cancel?.()};return new Promise((W,A)=>{for(const O of V)O.then(q=>{--U>=0&&C(q)?(Y(),W(q)):U===0&&W(N)}).catch(q=>{--U>=0&&(Y(),A(q))})})}e.firstParallel=s;class r{constructor(C){this._size=0,this.maxDegreeOfParalellism=C,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(C){return this._size++,new Promise((N,U)=>{this.outstandingPromises.push({factory:C,c:N,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const C=this.outstandingPromises.shift();this.runningPromises++;const N=C.factory();N.then(C.c,C.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class l extends r{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor(C,N=I.extUri){const U=N.getComparisonKey(C);let Y=this.queues.get(U);return Y||(Y=new l,M.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(U)}),this.queues.set(U,Y)),Y}dispose(){this.queues.forEach(C=>C.dispose()),this.queues.clear()}}e.ResourceQueue=m;class y{constructor(C,N){this._token=-1,typeof C=="function"&&typeof N=="number"&&this.setIfNotSet(C,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(C,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,C()},N)}setIfNotSet(C,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,C()},N))}}e.TimeoutTimer=y;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(C,N){this.cancel(),this._token=setInterval(()=>{C()},N)}}e.IntervalTimer=D;class R{constructor(C,N){this.timeoutToken=-1,this.runner=C,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(C=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,C)}get delay(){return this.timeout}set delay(C){this.timeout=C}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(C,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=C,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(C=this.timeout){C%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(C/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends R{constructor(C,N){super(C,N);this.units=[]}work(C){this.units.push(C),this.isScheduled()||this.schedule()}doRun(){const C=this.units;this.units=[],this.runner&&this.runner(C)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class j extends k.Disposable{constructor(C,N,U,Y){super();this.maxWorkChunkSize=C,this.maxPendingWork=N,this.throttleDelay=U,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(C){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+C.length>this.maxPendingWork)return!1}else if(this.pending+C.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...C),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{const C=setTimeout(()=>{const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0,clearTimeout(C))}}}:e.runWhenIdle=(V,C)=>{const N=requestIdleCallback(V,typeof C=="number"?{timeout:C}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(N))}}}}();class te{constructor(C){this._didRun=!1,this._executor=()=>{try{this._value=C()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function se(V,C,N){let U;for(let Y=0;Y<N;Y++)try{return await V()}catch(W){U=W,await a(C)}throw U}e.retry=se;class oe{hasPending(C){return this._pending?typeof C=="number"?this._pending.taskId===C:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(C,N,U){return this._pending={taskId:C,cancel:()=>U?.(),promise:N},N.then(()=>this.donePending(C),()=>this.donePending(C)),N}donePending(C){this._pending&&C===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const C=this._next;this._next=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this._next)this._next.run=C;else{let N,U;const Y=new Promise((W,A)=>{N=W,U=A});this._next={run:C,promise:Y,promiseResolve:N,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=oe;class G{constructor(C){this.interval=C,this.lastIncrementTime=0,this.value=0}increment(){const C=Date.now();return C-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=C,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((C,N)=>{this.completeCallback=C,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(C){return new Promise(N=>{this.completeCallback(C),this.resolved=!0,N()})}error(C){return new Promise(N=>{this.errorCallback(C),this.rejected=!0,N()})}cancel(){new Promise(C=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,C()})}}e.DeferredPromise=F;var B;(function(V){async function C(U){let Y;const W=await Promise.all(U.map(A=>A.then(O=>O,O=>{Y||(Y=O)})));if(typeof Y!="undefined")throw Y;return W}V.settled=C;function N(U){return new Promise(async(Y,W)=>{try{await U(Y,W)}catch(A){W(A)}})}V.withAsyncBody=N})(B=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,27,7]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function d(r,l,m){if(typeof r=="string"&&(r=h.URI.file(r)),m){const D=m.getWorkspaceFolder(r);if(D){const R=m.getWorkspace().folders.length>1;let T;if((0,I.isEqual)(D.uri,r)?T="":T=(0,I.relativePath)(D.uri,r),R){const _=D.name?D.name:(0,I.basename)(D.uri);T=T?_+" \u2022 "+T:_}return T}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(r.fsPath))return(0,M.normalize)(S(r.fsPath));let y=(0,M.normalize)(r.fsPath);return!k.isWindows&&l?.userHome&&(y=w(y,l.userHome.fsPath)),y}e.getPathLabel=d;function i(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const l=(0,I.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return k.isWindows&&(0,p.isRootOrDriveLetter)(l)?S(l):l}e.getBaseLabel=i;function S(r){return(0,p.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=S;let g=Object.create(null);function w(r,l){if(k.isWindows||!r||!l)return r;let m=g.original===l?g.normalized:void 0;return m||(m=`${(0,E.rtrim)(l,M.posix.sep)}${M.posix.sep}`,g={original:l,normalized:m}),(k.isLinux?r.startsWith(m):(0,E.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}e.tildify=w;function t(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=t;const f="\u2026",b="\\\\",v="~";function P(r,l=M.sep){const m=new Array(r.length);let y=!1;for(let D=0;D<r.length;D++){let R=r[D];if(R===""){m[D]=`.${l}`;continue}if(!R){m[D]=R;continue}y=!0;let T="";R.indexOf(b)===0?(T=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(l)===0?(T=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(v)===0&&(T=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const _=R.split(l);for(let j=1;y&&j<=_.length;j++)for(let te=_.length-j;y&&te>=0;te--){y=!1;let se=_.slice(te,te+j).join(l);for(let oe=0;!y&&oe<r.length;oe++)if(oe!==D&&r[oe]&&r[oe].indexOf(se)>-1){const G=te+j===_.length,F=te>0&&r[oe].indexOf(l)>-1?l+se:se,B=r[oe].endsWith(F);y=!G||B}if(!y){let oe="";(_[0].endsWith(":")||T!=="")&&(te===1&&(te=0,j++,se=_[0]+l+se),te>0&&(oe=_[0]+l),oe=T+oe),te>0&&(oe=oe+f+l),oe=oe+se,te+j<_.length&&(oe=oe+l+f),m[D]=oe}}y&&(m[D]=R)}return m}e.shorten=P;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(r,l=Object.create(null)){const m=[];let y=!1,D="";for(const R of r)if(R==="$"||y&&R==="{")D&&m.push({value:D,type:c.TEXT}),D="",y=!0;else if(R==="}"&&y){const T=l[D];if(typeof T=="string")T.length&&m.push({value:T,type:c.VARIABLE});else if(T){const _=m[m.length-1];(!_||_.type!==c.SEPARATOR)&&m.push({value:T.label,type:c.SEPARATOR})}D="",y=!1}else D+=R;return D&&!y&&m.push({value:D,type:c.TEXT}),m.filter((R,T)=>{if(R.type===c.SEPARATOR){const _=m[T-1],j=m[T+1];return[_,j].every(te=>te&&(te.type===c.VARIABLE||te.type===c.TEXT)&&te.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=a;function u(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function n(r,l){return k.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function o(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=o;function s(r){const l=r.indexOf("/")!==-1?M.posix:M.win32,m=l.basename(r),y=l.dirname(r);return m.length?{name:m,parentPath:y}:{name:y,parentPath:""}}e.splitName=s}),define(Q[112],J([0,1,7]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class M{constructor(S){this._uriTransformer=S}transformIncoming(S){const g=this._uriTransformer.transformIncoming(S);return g===S?S:L(p.URI.from(g))}transformOutgoing(S){const g=this._uriTransformer.transformOutgoing(S);return g===S?S:L(p.URI.from(g))}transformOutgoingURI(S){const g=this._uriTransformer.transformOutgoing(S);return g===S?S:p.URI.from(g)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,S,g){if(!i||g>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return S.transformOutgoing(i);for(let w in i)if(Object.hasOwnProperty.call(i,w)){const t=k(i[w],S,g+1);t!==null&&(i[w]=t)}}return null}function I(i,S){const g=k(i,S,0);return g===null?i:g}e.transformOutgoingURIs=I;function E(i,S,g,w){if(!i||w>200)return null;if(typeof i=="object"){if(i.$mid===1)return g?p.URI.revive(S.transformIncoming(i)):S.transformIncoming(i);for(let t in i)if(Object.hasOwnProperty.call(i,t)){const f=E(i[t],S,g,w+1);f!==null&&(i[t]=f)}}return null}function h(i,S){const g=E(i,S,!1,0);return g===null?i:g}e.transformIncomingURIs=h;function d(i,S){const g=E(i,S,!0,0);return g===null?i:g}e.transformAndReviveIncomingURIs=d}),define(Q[28],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(h){return p.test(h)}e.isUUID=L;const M=new Uint8Array(16),k=[];for(let h=0;h<256;h++)k.push(h.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(h){for(let d=0;d<h.length;d++)h[d]=Math.floor(Math.random()*256);return h};function E(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,d="";return d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d+="-",d+=k[M[h++]],d+=k[M[h++]],d+="-",d+=k[M[h++]],d+=k[M[h++]],d+="-",d+=k[M[h++]],d+=k[M[h++]],d+="-",d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d+=k[M[h++]],d}e.generateUuid=E}),define(Q[113],J([0,1,61,29,42]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function k(I,E){if(await new Promise((i,S)=>{const g=L.createReadStream(I),w=p.createHash("sha1");g.pipe(w);const t=(0,M.once)((f,b)=>{g.removeAllListeners(),w.removeAllListeners(),f?S(f):i(b)});g.once("error",t),g.once("end",t),w.once("error",t),w.once("data",f=>t(void 0,f.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=k}),define(Q[114],J([0,1,242]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const I=[],E=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(E.length<1)return I;let h=0,d,i=h;for(;i<E.length;)if(d=E.charCodeAt(i),d===13||d===10){if(I.push(E.substring(h,i)),i++,i<E.length){const S=d;d=E.charCodeAt(i),(S===13&&d===10||S===10&&d===13)&&i++}h=i}else i++;return this.remaining=h<E.length?E.substr(h):null,I}end(){return this.remaining}}e.LineDecoder=L}),define(Q[115],J([0,1,25]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(I){const E=I.replace(/\-/g,":").toLowerCase();return!L.has(E)}function k(){const I=(0,p.networkInterfaces)();for(let E in I){const h=I[E];if(h){for(const{mac:d}of h)if(M(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(Q[71],J([0,1,25,16,40,28,115]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,S=0;const g=(0,p.networkInterfaces)();for(let w in g){const t=g[w];if(t)for(const{mac:f,internal:b}of t)b||(S+=1,this._isVirtualMachineMacAddress(f.toUpperCase())&&(i+=1))}this._value=S>0?i/S:0}return this._value}};let E;async function h(){return E||(E=(async()=>await d()||k.generateUuid())()),E}e.getMachineId=h;async function d(){try{const i=await new Promise((g,w)=>{H(["crypto"],g,w)}),S=(0,I.getMac)();return i.createHash("sha256").update(S,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Q[20],J([0,1,29,25,116,9,33,70,8,3,15,7,28]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function t(F,B=w.UNLINK){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===w.UNLINK?b(F):f(F)}async function f(F){try{const B=(0,h.join)((0,L.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(F,B)}catch(V){return b(F)}b(B).catch(V=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function b(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function v(F){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(F,{recursive:!0})}e.rimrafSync=v;async function P(F,B){return u(await(B?c(F):(0,M.promisify)(p.readdir)(F)))}async function c(F){try{return await(0,M.promisify)(p.readdir)(F,{withFileTypes:!0})}catch(C){console.warn("[node.js fs] readdir with filetypes failed with error: ",C)}const B=[],V=await P(F);for(const C of V){let N=!1,U=!1,Y=!1;try{const W=await e.Promises.lstat((0,h.join)(F,C));N=W.isFile(),U=W.isDirectory(),Y=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}B.push({name:C,isFile:()=>N,isDirectory:()=>U,isSymbolicLink:()=>Y})}return B}function a(F){return u(p.readdirSync(F))}e.readdirSync=a;function u(F){return F.map(B=>typeof B=="string"?d.isMacintosh?(0,E.normalizeNFC)(B):B:(B.name=d.isMacintosh?(0,E.normalizeNFC)(B.name):B.name,B))}async function n(F){const B=await P(F),V=[];for(const C of B)await s.existsDirectory((0,h.join)(F,C))&&V.push(C);return V}function o(F,B=1e3){return new Promise(V=>{let C=!1;const N=setInterval(()=>{C||(C=!0,p.access(F,U=>{C=!1,U&&(clearInterval(N),V(void 0))}))},B)})}e.whenDeleted=o;var s;(function(F){async function B(N){let U;try{if(U=await e.Promises.lstat(N),!U.isSymbolicLink())return{stat:U}}catch(Y){}try{return{stat:await e.Promises.stat(N),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(d.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw W}throw Y}}F.stat=B;async function V(N){try{const{stat:U,symbolicLink:Y}=await F.stat(N);return U.isFile()&&Y?.dangling!==!0}catch(U){}return!1}F.existsFile=V;async function C(N){try{const{stat:U,symbolicLink:Y}=await F.stat(N);return U.isDirectory()&&Y?.dangling!==!0}catch(U){}return!1}F.existsDirectory=C})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new k.ResourceQueue;function l(F,B,V){return r.queueFor(S.URI.file(F),i.extUriBiasedIgnorePathCase).queue(()=>{const C=R(V);return new Promise((N,U)=>y(F,B,C,Y=>Y?U(Y):N()))})}let m=!0;function y(F,B,V,C){if(!m)return p.writeFile(F,B,{mode:V.mode,flag:V.flag},C);p.open(F,V.flag,V.mode,(N,U)=>{if(N)return C(N);p.writeFile(U,B,Y=>{if(Y)return p.close(U,()=>C(Y));p.fdatasync(U,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),m=!1),p.close(U,A=>C(A))))})})}function D(F,B,V){const C=R(V);if(!m)return p.writeFileSync(F,B,{mode:C.mode,flag:C.flag});const N=p.openSync(F,C.flag,C.mode);try{p.writeFileSync(N,B);try{p.fdatasyncSync(N)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),m=!1}}finally{p.closeSync(N)}}e.writeFileSync=D;function R(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function T(F,B){if(F===B)return;async function V(C){try{const N=await e.Promises.lstat(C);if(N.isDirectory()||N.isSymbolicLink())return;await e.Promises.utimes(C,N.atime,new Date)}catch(N){}}try{await e.Promises.rename(F,B),await V(B)}catch(C){if(F.toLowerCase()!==B.toLowerCase()&&C.code==="EXDEV"||F.endsWith("."))await _(F,B,{preserveSymlinks:!1}),await t(F,w.MOVE),await V(B);else throw C}}async function _(F,B,V){return te(F,B,{root:{source:F,target:B},options:V,handledSourcePaths:new Set})}const j=511;async function te(F,B,V){if(V.handledSourcePaths.has(F))return;V.handledSourcePaths.add(F);const{stat:C,symbolicLink:N}=await s.stat(F);if(N){if(V.options.preserveSymlinks)try{return await G(F,B,V)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(N.dangling)return}return C.isDirectory()?se(F,B,C.mode&j,V):oe(F,B,C.mode&j)}async function se(F,B,V,C){await e.Promises.mkdir(B,{recursive:!0,mode:V});const N=await P(F);for(const U of N)await te((0,h.join)(F,U),(0,h.join)(B,U),C)}async function oe(F,B,V){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,V)}async function G(F,B,V){let C=await e.Promises.readlink(F);(0,I.isEqualOrParent)(C,V.root.source,!d.isLinux)&&(C=(0,h.join)(V.root.target,C.substr(V.root.source.length+1))),await e.Promises.symlink(C,B)}e.Promises=new class{get access(){return(0,M.promisify)(p.access)}get stat(){return(0,M.promisify)(p.stat)}get lstat(){return(0,M.promisify)(p.lstat)}get utimes(){return(0,M.promisify)(p.utimes)}get read(){return(0,M.promisify)(p.read)}get readFile(){return(0,M.promisify)(p.readFile)}get write(){return(0,M.promisify)(p.write)}get appendFile(){return(0,M.promisify)(p.appendFile)}get fdatasync(){return(0,M.promisify)(p.fdatasync)}get truncate(){return(0,M.promisify)(p.truncate)}get rename(){return(0,M.promisify)(p.rename)}get copyFile(){return(0,M.promisify)(p.copyFile)}get open(){return(0,M.promisify)(p.open)}get close(){return(0,M.promisify)(p.close)}get symlink(){return(0,M.promisify)(p.symlink)}get readlink(){return(0,M.promisify)(p.readlink)}get chmod(){return(0,M.promisify)(p.chmod)}get mkdir(){return(0,M.promisify)(p.mkdir)}get unlink(){return(0,M.promisify)(p.unlink)}get rmdir(){return(0,M.promisify)(p.rmdir)}get realpath(){return(0,M.promisify)(p.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return n}get writeFile(){return l}get rm(){return t}get move(){return T}get copy(){return _}}}),define(Q[82],J([0,1,29,8,27,20]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(i){const S=(0,L.dirname)(i);if(i===S)return i;const g=((0,L.basename)(i)||i).toLowerCase();try{const t=(0,k.readdirSync)(S).filter(f=>f.toLowerCase()===g);if(t.length===1){const f=I(S);if(f)return(0,L.join)(f,t[0])}else if(t.length>1){const f=t.indexOf(g);if(f>=0){const b=I(S);if(b)return(0,L.join)(b,t[f])}}}catch(w){}return null}e.realcaseSync=I;async function E(i){try{return await k.Promises.realpath(i)}catch(S){const g=d(i);return await k.Promises.access(g,p.constants.R_OK),g}}e.realpath=E;function h(i){try{return p.realpathSync(i)}catch(S){const g=d(i);return p.accessSync(g,p.constants.R_OK),g}}e.realpathSync=h;function d(i){return(0,M.rtrim)((0,L.normalize)(i),L.sep)}}),define(Q[117],J([0,1,62]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(E,h,d,i=1){let S=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!S)return S=!0,g(0)},d);M(E,h,i,t=>{if(!S)return S=!0,clearTimeout(w),g(t)})})}e.findFreePort=L;function M(E,h,d,i){if(h===0)return i(0);const S=new p.Socket;S.once("connect",()=>(I(S),M(E+d,h-1,d,i))),S.once("data",()=>{}),S.once("error",g=>(I(S),g.code!=="ECONNREFUSED"?M(E+d,h-1,d,i):i(E))),S.connect(E,"127.0.0.1")}function k(E,h,d){let i=!1,S,g=1;const w=p.createServer({pauseOnConnect:!0});function t(f,b){i||(i=!0,w.removeAllListeners(),w.close(),S&&clearTimeout(S),b(f))}return new Promise(f=>{S=setTimeout(()=>{t(0,f)},d),w.on("listening",()=>{t(E,f)}),w.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&g<h?(E++,g++,w.listen(E,"127.0.0.1")):t(0,f)}),w.on("close",()=>{t(0,f)}),w.listen(E,"127.0.0.1")})}e.findFreePortFaster=k;function I(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),define(Q[118],J([0,1,25,8,20]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,I=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(h||(h={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class S{constructor(u,n,o){this.exePath=u,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:a=!1,findPreview:u=!1}={}){const n=g({useAlternateBitness:a});if(!n)return null;const o=L.join(n,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(o))return null;let s=-1,r=null;for(const y of await M.Promises.readdir(o)){let D=-1;if(u){const T=y.indexOf("-");if(T<0)continue;const _=y.substring(0,T);if(!k.test(_)||y.substring(T+1)!=="preview")continue;D=parseInt(_,10)}else{if(!k.test(y))continue;D=parseInt(y,10)}if(D<=s)continue;const R=L.join(o,y,"pwsh.exe");!await M.SymlinkSupport.existsFile(R)||(r=R,s=D)}if(!r)return null;const l=n.includes("x86")?" (x86)":"",m=u?" Preview":"";return new S(r,`PowerShell${m}${l}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=a?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await M.Promises.readdir(u))if(n.test(s)){const r=L.join(u,s,"pwsh.exe");return new S(r,o)}return null}function f(){const a=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new S(a,".NET Core PowerShell Global Tool")}function b(){const a=L.join(process.env.windir,d===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(a,"Windows PowerShell",!0)}async function*v(){let a=await w();a&&(yield a),a=await w({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=f(),a&&(yield a),a=await w({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await w({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*P(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Q[83],J([0,1,44,10]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(I){return new Promise((E,h)=>{let d;const i=new Map;function S(w,t,f,b,v){const P=i.get(t);if(w===I||P){const c={name:g(f),cmd:f,pid:w,ppid:t,load:b,mem:v};i.set(w,c),w===I&&(d=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,u)=>a.pid-u.pid)))}}function g(w){const t=/--disable-blink-features=Auxclick/,f=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,v=/\\pipe\\winpty-control/,P=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(f.exec(w))return"watcherService ";if(b.exec(w))return"electron-crash-reporter";if(v.exec(w))return"winpty-process";if(P.exec(w))return"console-window-host (Windows internal process)";let a=c.exec(w);if(a&&a.length===2)return a[1]==="renderer"?t.exec(w)?"shared-process":"window":a[1];const u=/[a-zA-Z-]+\.js/g;let n="";do a=u.exec(w),a&&(n+=a+" ");while(a);return n&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${n}`:w}if(process.platform==="win32"){const w=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,f)=>{H(["windows-process-tree"],t,f)}).then(t=>{t.getProcessList(I,f=>{t.getProcessCpuUsage(f,b=>{const v=new Map;b.forEach(P=>{const c=w(P.commandLine||"");v.set(P.pid,{name:g(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),d=v.get(I),d?(v.forEach(P=>{const c=v.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),v.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),E(d)):h(new Error(`Root process ${I} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let w=function(){let t=[d];const f=[];for(;t.length;){const v=t.shift();v&&(f.push(v.pid),v.children&&(t=t.concat(v.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);b+=" "+f.join(" "),(0,p.exec)(b,{},(v,P,c)=>{if(v||c)h(v||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let u=0;u<f.length;u++){const n=i.get(f[u]);n.load=parseFloat(a[u])}if(!d){h(new Error(`Root process ${I} not found`));return}E(d)}})};(0,p.exec)("which ps",{},(t,f,b)=>{if(t||b)if(process.platform!=="linux")h(t||new Error(b.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,p.exec)(v,{},(P,c,a)=>{P||a?h(P||new Error(a.toString())):(k(c,S),w())})}else{const v=f.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,u)=>{c||u&&!u.includes("screen size is bogus")?h(c||new Error(u.toString())):(k(a,S),process.platform==="linux"?w():d?E(d):h(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=M;function k(I,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=I.toString().split(`
`);for(const i of d){const S=h.exec(i.trim());S&&S.length===6&&E(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(Q[119],J([0,1,29,23,33,2,70,8,3,20]),function(H,e,p,L,M,k,I,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(t,f,b){return g({path:t,isDirectory:!1},f,b)}e.watchFile=i;function S(t,f,b){return g({path:t,isDirectory:!0},f,b)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function g(t,f,b){if(h.isMacintosh&&(0,M.isEqualOrParent)(t.path,"/Volumes/"))return b(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const v=(0,E.basename)(t.path),P=new Map;let c=!1,a=[(0,k.toDisposable)(()=>{P.forEach(u=>(0,k.dispose)(u)),P.clear()})];try{const u=(0,p.watch)(t.path);a.push((0,k.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const n=new Set;t.isDirectory&&d.Promises.readdir(t.path).then(o=>o.forEach(s=>n.add(s))),u.on("error",(o,s)=>{c||b(`Failed to watch ${t.path} for changes using fs.watch() (${o}, ${s})`)}),u.on("change",(o,s)=>{if(c)return;let r="";if(s&&(r=s.toString(),h.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!r||o!=="change"&&o!=="rename")return;const l=t.isDirectory?(0,E.join)(t.path,r):t.path;if(t.isDirectory)if(o==="rename"){const m=P.get(l);m&&(0,k.dispose)(m);const y=setTimeout(async()=>{P.delete(l);const D=await d.Promises.exists(l);if(c)return;let R;D?n.has(r)?R="changed":(R="added",n.add(r)):(n.delete(r),R="deleted"),f(R,l)},e.CHANGE_BUFFER_DELAY);P.set(l,(0,k.toDisposable)(()=>clearTimeout(y)))}else{let m;n.has(r)?m="changed":(m="added",n.add(r)),f(m,l)}else if(o==="rename"||r!==v){const m=setTimeout(async()=>{const y=await d.Promises.exists(l);c||(y?(f("changed",l),a=[g(t,f,b)]):f("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(a),a=[(0,k.toDisposable)(()=>clearTimeout(m))]}else f("changed",l)})}catch(u){d.Promises.exists(t.path).then(n=>{n&&!c&&b(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,k.toDisposable)(()=>{c=!0,a=(0,k.dispose)(a)})}async function w(t,f,b,v=512){const P=await d.Promises.open(t,"r"),c=Buffer.allocUnsafe(v),a=new L.CancellationTokenSource(b);let u,n=!1;const o=i(t,async s=>{if(s==="changed"){if(n)return;n=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:r}=await d.Promises.read(P,c,0,v,null);if(!r||a.token.isCancellationRequested)break;f(c.slice(0,r))}}catch(r){u=new Error(r),a.dispose(!0)}finally{n=!1}}},s=>{u=new Error(s),a.dispose(!0)});return new Promise((s,r)=>{a.token.onCancellationRequested(async()=>{o.dispose(),await d.Promises.close(P),u?r(u):s()})})}e.watchFileContents=w}),define(Q[120],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[121],J([0,1,13,14,120]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){p.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(E,h,d,i,S)=>{const g=I(E,i,d);g.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(E.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{g&&E.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=k;function I(E,h,d){const i=new p.Menu;return d.forEach(S=>{let g;S.type==="separator"?g=new p.MenuItem({type:S.type}):Array.isArray(S.submenu)?g=new p.MenuItem({submenu:I(E,h,S.submenu),label:S.label}):g=new p.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(w,t,f)=>E.sender.send(h,S.id,f)}),i.append(g)}),i}});var he=this&&this.__decorate||function(H,e,p,L){var M=arguments.length,k=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(H,e,p,L);else for(var E=H.length-1;E>=0;E--)(I=H[E])&&(k=(M<3?I(k):M>3?I(e,p,k):I(e,p))||k);return M>3&&k&&Object.defineProperty(e,p,k),k};define(Q[35],J([0,1,31,9,17,23,47,16,4,2,111,27,14]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function b(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(v||(v={}));class P{constructor(U){this.buffer=U,this.pos=0}read(U){const Y=this.buffer.slice(this.pos,this.pos+U);return this.pos+=Y.byteLength,Y}}class c{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var a;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(a||(a={}));function u(N){const U=M.VSBuffer.alloc(4);return U.writeUInt32BE(N,0),U}function n(N){return N.read(4).readUInt32BE(0)}function o(N){const U=M.VSBuffer.alloc(1);return U.writeUInt8(N,0),U}const s={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object)},r=typeof Buffer!="undefined";function l(N,U){if(typeof U=="undefined")N.write(s.Undefined);else if(typeof U=="string"){const Y=M.VSBuffer.fromString(U);N.write(s.String),N.write(u(Y.byteLength)),N.write(Y)}else if(r&&Buffer.isBuffer(U)){const Y=M.VSBuffer.wrap(U);N.write(s.Buffer),N.write(u(Y.byteLength)),N.write(Y)}else if(U instanceof M.VSBuffer)N.write(s.VSBuffer),N.write(u(U.byteLength)),N.write(U);else if(Array.isArray(U)){N.write(s.Array),N.write(u(U.length));for(const Y of U)l(N,Y)}else{const Y=M.VSBuffer.fromString(JSON.stringify(U));N.write(s.Object),N.write(u(Y.byteLength)),N.write(Y)}}function m(N){switch(N.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return N.read(n(N)).toString();case a.Buffer:return N.read(n(N)).buffer;case a.VSBuffer:return N.read(n(N));case a.Array:{const Y=n(N),W=[];for(let A=0;A<Y;A++)W.push(m(N));return W}case a.Object:return JSON.parse(N.read(n(N)).toString())}}class y{constructor(U,Y,W=null,A=1e3){this.protocol=U,this.ctx=Y,this.logger=W,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(U,Y){this.channels.set(U,Y),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const Y=this.send([U.type]);this.logger&&this.logger.logOutgoing(Y,0,1,b(U.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(Y,U.id,1,b(U.type),U.data);return}}}send(U,Y=void 0){const W=new c;return l(W,U),l(W,Y),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(Y){return 0}}onRawMessage(U){const Y=new P(U),W=m(Y),A=m(Y),O=W[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${t(O)}: ${W[2]}.${W[3]}`,A),this.onPromise({type:O,id:W[1],channelName:W[2],name:W[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${t(O)}: ${W[2]}.${W[3]}`,A),this.onEventListen({type:O,id:W[1],channelName:W[2],name:W[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:W[1]})}}onPromise(U){const Y=this.channels.get(U.channelName);if(!Y){this.collectPendingRequest(U);return}const W=new k.CancellationTokenSource;let A;try{A=Y.call(this.ctx,U.name,U.arg,W.token)}catch(X){A=Promise.reject(X)}const O=U.id;A.then(X=>{this.sendResponse({id:O,data:X,type:201}),this.activeRequests.delete(U.id)},X=>{X instanceof Error?this.sendResponse({id:O,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:O,data:X,type:203}),this.activeRequests.delete(U.id)});const q=(0,d.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,q)}onEventListen(U){const Y=this.channels.get(U.channelName);if(!Y){this.collectPendingRequest(U);return}const W=U.id,O=Y.listen(this.ctx,U.name,U.arg)(q=>this.sendResponse({id:W,data:q,type:204}));this.activeRequests.set(U.id,O)}disposeActiveRequest(U){const Y=this.activeRequests.get(U.id);Y&&(Y.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let Y=this.pendingRequests.get(U.channelName);Y||(Y=[],this.pendingRequests.set(U.channelName,Y));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const Y=this.pendingRequests.get(U);if(Y){for(const W of Y)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=y;var D;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(U,Y=null){this.protocol=U,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=Y}getChannel(U){const Y=this;return{call(W,A,O){return Y.isDisposed?Promise.reject(E.canceled()):Y.requestPromise(U,W,A,O)},listen(W,A){return Y.isDisposed?Promise.reject(E.canceled()):Y.requestEvent(U,W,A)}}}requestPromise(U,Y,W,A=k.CancellationToken.None){const O=this.lastRequestId++,X={id:O,type:100,channelName:U,name:Y,arg:W};if(A.isCancellationRequested)return Promise.reject(E.canceled());let $;return new Promise((Z,ee)=>{if(A.isCancellationRequested)return ee(E.canceled());const le=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(O),Z(de.data);break;case 202:this.handlers.delete(O);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break;case 203:this.handlers.delete(O),ee(de.data);break}};this.handlers.set(O,ue),this.sendRequest(X)};let re=null;this.state===v.Idle?le():(re=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),re.then(()=>{re=null,le()}));const ie=()=>{re?(re.cancel(),re=null):this.sendRequest({id:O,type:101}),ee(E.canceled())},ae=A.onCancellationRequested(ie);$=(0,d.combinedDisposable)((0,d.toDisposable)(ie),ae),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(U,Y,W){const A=this.lastRequestId++,q={id:A,type:102,channelName:U,name:Y,arg:W};let X=null;const $=new h.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add($),this.sendRequest(q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete($),this.sendRequest({id:A,type:103}))}}),z=Z=>$.fire(Z.data);return this.handlers.set(A,z),$.event}sendRequest(U){switch(U.type){case 100:case 102:{const Y=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(Y,U.id,0,`${t(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const Y=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(Y,U.id,0,t(U.type));return}}}send(U,Y=void 0){const W=new c;return l(W,U),l(W,Y),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(Y){return 0}}onBuffer(U){const Y=new P(U),W=m(Y),A=m(Y),O=W[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,b(O)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,b(O),A),this.onResponse({type:W[0],id:W[1],data:A})}}onResponse(U){if(U.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(U.id);Y&&Y(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}he([I.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class T{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:Y,onDidClientDisconnect:W})=>{h.Event.once(Y.onMessage)(O=>{const q=new P(O),X=m(q),$=new y(Y,X),z=new R(Y);this.channels.forEach((ee,le)=>$.registerChannel(le,ee));const Z={channelServer:$,channelClient:z,ctx:X};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{$.dispose(),z.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const U=[];return this._connections.forEach(Y=>U.push(Y)),U}getChannel(U,Y){const W=this;return{call(A,O,q){let X;if((0,g.isFunction)(Y)){let z=(0,p.getRandomElement)(W.connections.filter(Y));X=z?Promise.resolve(z):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,Y))}else X=Y.routeCall(W,A,O);const $=X.then(z=>z.channelClient.getChannel(U));return j($).call(A,O,q)},listen(A,O){if((0,g.isFunction)(Y))return W.getMulticastEvent(U,Y,A,O);const q=Y.routeEvent(W,A,O).then(X=>X.channelClient.getChannel(U));return j(q).listen(A,O)}}}getMulticastEvent(U,Y,W,A){const O=this;let q=new d.DisposableStore;const X=new h.Emitter({onFirstListenerAdd:()=>{q=new d.DisposableStore;const $=new h.EventMultiplexer,z=new Map,Z=le=>{const ie=le.channelClient.getChannel(U).listen(W,A),ae=$.add(ie);z.set(le,ae)},ee=le=>{const re=z.get(le);!re||(re.dispose(),z.delete(le))};O.connections.filter(Y).forEach(Z),h.Event.filter(O.onDidAddConnection,Y)(Z,void 0,q),O.onDidRemoveConnection(ee,void 0,q),$.event(X.fire,X,q),q.add($)},onLastListenerRemove:()=>{q.dispose()}});return X.event}registerChannel(U,Y){this.channels.set(U,Y),this._connections.forEach(W=>{W.channelServer.registerChannel(U,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor(U,Y,W=null){const A=new c;l(A,Y),U.send(A.buffer),this.channelClient=new R(U,W),this.channelServer=new y(U,Y,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,Y){this.channelServer.registerChannel(U,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function j(N){return{call(U,Y,W){return N.then(A=>A.call(U,Y,W))},listen(U,Y){const W=new h.Relay;return N.then(A=>W.input=A.listen(U,Y)),W.event}}}e.getDelayedChannel=j;function te(N){let U=!1;return{call(Y,W,A){return U?N.call(Y,W,A):(0,L.timeout)(0).then(()=>U=!0).then(()=>N.call(Y,W,A))},listen(Y,W){if(U)return N.listen(Y,W);const A=new h.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>A.input=N.listen(Y,W)),A.event}}}e.getNextTickChannel=te;class se{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const Y of U.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await h.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=se;var oe;(function(N){function U(O,q){const X=O,$=q&&q.disableMarshalling,z=new Map;for(const Z in X)W(Z)&&z.set(Z,h.Event.buffer(X[Z],!0));return new class{listen(Z,ee,le){const re=z.get(ee);if(re)return re;if(A(ee)){const ie=X[ee];if(typeof ie=="function")return ie.call(X,le)}throw new Error(`Event not found: ${ee}`)}call(Z,ee,le){const re=X[ee];if(typeof re=="function"){if(!$&&Array.isArray(le))for(let ie=0;ie<le.length;ie++)le[ie]=(0,i.revive)(le[ie]);return re.apply(X,le)}throw new Error(`Method not found: ${ee}`)}}}N.fromService=U;function Y(O,q){const X=q&&q.disableMarshalling;return new Proxy({},{get($,z){if(typeof z=="string")return q?.properties?.has(z)?q.properties.get(z):A(z)?function(Z){return O.listen(z,Z)}:W(z)?O.listen(z):async function(...Z){let ee;q&&!(0,g.isUndefinedOrNull)(q.context)?ee=[q.context,...Z]:ee=Z;const le=await O.call(z,ee);return X?le:(0,i.revive)(le)};throw new Error(`Property not found: ${String(z)}`)}})}N.toService=Y;function W(O){return O[0]==="o"&&O[1]==="n"&&S.isUpperAsciiLetter(O.charCodeAt(2))}function A(O){return/^onDynamic/.test(O)&&S.isUpperAsciiLetter(O.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let U=N.toString();if(U!=="[object Object]")return U}return N}function B(N){return Array.isArray(N)?N.map(F):F(N)}function V(N,U,Y,W,A,O,q){q=B(q);const X=G[A],$=X[W%X.length];let z=[`%c[${N}]%c[${String(U).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(O)?(z=z.concat(q),z.push(")")):z.push(q),console.log.apply(console,z)}e.logWithColors=V;class C{constructor(U,Y){this._outgoingPrefix=U,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,Y,W,A,O){this._totalOutgoing+=U,V(this._outgoingPrefix,this._totalOutgoing,U,Y,W,A,O)}logIncoming(U,Y,W,A,O){this._totalIncoming+=U,V(this._incomingPrefix,this._totalIncoming,U,Y,W,A,O)}}e.IPCLogger=C}),define(Q[122],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(M,k){this.sender=M,this.onMessage=k}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(k){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Q[123],J([0,1,17,4,35]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(h){this.port=h,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",d=>p.VSBuffer.wrap(d.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class I extends M.IPCClient{constructor(h,d){const i=new k(h);super(i,d);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=I}),define(Q[84],J([0,1,17,4,2,3,32,35]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var h;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let d=null;function i(){return d||(d=p.VSBuffer.alloc(0)),d}class S{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let m=p.VSBuffer.alloc(r),y=0,D=0;for(;r>0;){const R=this._chunks[D];if(R.byteLength>r){const T=R.slice(0,r);m.set(T,y),y+=r,l&&(this._chunks[D]=R.slice(r),this._totalLength-=r),r-=r}else m.set(R,y),y+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,r-=R.byteLength}return m}}e.ChunkStream=S;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(r,l,m,y){this.type=r,this.id=l,this.ack=m,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends M.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new S,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,y=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(m,y,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=p.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._writeSoon(l,r.data)}_bufferAdd(r,l){const m=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,m}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends M.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new t(1,0,0,r))}}e.Protocol=v;class P extends E.IPCClient{constructor(r,l,m=null){super(r,l,m);this.protocol=r}static fromSocket(r,l){return new P(new v(r),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=P;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class a{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],l=0,m=this._first;for(;m;)r[l++]=m.data,m=m.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new a(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class n{constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<n._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=n._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const r=Date.now(),l=(1+n._HISTORY_LENGTH)*1e3;let m=0;for(let y=0;y<n._HISTORY_LENGTH;y++)r-this.lastRuns[y]<=l&&m++;return 1-m/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class o{constructor(r,l=null,m=n.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new t(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const l=new t(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let l=0,m=r.length;l<m;l++)this._socketWriter.write(r[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new t(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,y=l.length;m<y;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new t(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(r){const l=new t(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new t(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=o}),define(Q[124],J([0,1,13,17,4,2,35,122]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(i,S){const g=M.Event.fromNodeEventEmitter(p.ipcMain,S,(t,f)=>({event:t,message:f})),w=M.Event.filter(g,({event:t})=>t.sender.id===i);return M.Event.map(w,({message:t})=>t&&L.VSBuffer.wrap(t))}class d extends I.IPCServer{constructor(){super(d.getOnDidClientConnect())}static getOnDidClientConnect(){const S=M.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:g})=>g);return M.Event.map(S,g=>{const w=g.id,t=d.Clients.get(w);t&&t.dispose();const f=new M.Emitter;d.Clients.set(w,(0,k.toDisposable)(()=>f.fire()));const b=h(w,"vscode:message"),v=M.Event.any(M.Event.signal(h(w,"vscode:disconnect")),f.event);return{protocol:new E.Protocol(g,b),onDidClientDisconnect:v}})}}e.Server=d,d.Clients=new Map}),define(Q[85],J([0,1,13,4,28,123]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends k.Client{constructor(d,i){super({addEventListener:(S,g)=>d.addListener(S,g),removeEventListener:(S,g)=>d.removeListener(S,g),postMessage:S=>d.postMessage(S),start:()=>d.start(),close:()=>d.close()},i)}}e.Client=I;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,M.generateUuid)();h.webContents.send("vscode:createMessageChannel",d);const i=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:S}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,g=>g.nonce===d)));return S}e.connect=E}),define(Q[86],J([0,1,9,4,2,14]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));function E(S){const g=S;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var h;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(h||(h={}));class d extends M.Disposable{constructor(g,w=Object.create(null)){super();this.database=g,this.options=w,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((w,t)=>this.accept(t,w)),g.deleted?.forEach(w=>this.accept(w,void 0))}accept(g,w){if(this.state===h.Closed)return;let t=!1;(0,k.isUndefinedOrNull)(w)?t=this.cache.delete(g):this.cache.get(g)!==w&&(this.cache.set(g,w),t=!0),t&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,w){const t=this.cache.get(g);return(0,k.isUndefinedOrNull)(t)?w:t}getBoolean(g,w){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?w:t==="true"}getNumber(g,w){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?w:parseInt(t,10)}async set(g,w){if(this.state===h.Closed)return;if((0,k.isUndefinedOrNull)(w))return this.delete(g);const t=String(w);if(this.cache.get(g)!==t)return this.cache.set(g,t),this.pendingInserts.set(g,t),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===h.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((w,t)=>this.items.set(t,w)),g.delete&&g.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=i}),define(Q[125],J([0,1,9,4,40,8,20]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{constructor(i,S=Object.create(null)){this.path=i,this.options=S,this.name=(0,k.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,S=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(w=>S.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${S.size} rows`),S}async updateItems(i){const S=await this.whenConnected;return this.doUpdateItems(S,i)}doUpdateItems(i,S){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${S.insert?(0,M.mapToString)(S.insert):"0"}), delete(${S.delete?(0,M.setToString)(S.delete):"0"})`),this.transaction(i,()=>{const g=S.insert,w=S.delete;if(g&&g.size>0){const t=[];t.push([]);let f=0;g.forEach((b,v)=>{let P=t[f];P.length>E.MAX_HOST_PARAMETERS&&(f++,P=[],t.push(P)),P.push(v,b)}),t.forEach(b=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,v=>v.run(b),()=>{const v=[];let P=0;return g.forEach((c,a)=>{v.push(a),P+=c.length}),`Keys: ${v.join(", ")} Length: ${P}`})})}if(w&&w.size){const t=[];t.push([]);let f=0;w.forEach(b=>{let v=t[f];v.length>E.MAX_HOST_PARAMETERS&&(f++,v=[],t.push(v)),v.push(b)}),t.forEach(b=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,v=>v.run(b),()=>{const v=[];return w.forEach(P=>{v.push(P)}),`Keys: ${v.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const S=await this.whenConnected;return this.doClose(S,i)}doClose(i,S){return new Promise((g,w)=>{i.db.close(t=>(t&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${t}`),this.path===E.IN_MEMORY_PATH?g():!i.isErroneous&&!i.isInMemory?this.backup().then(g,f=>(this.logger.error(`[storage ${this.name}] backup(): ${f}`),g())):typeof S=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(f=>{const b=()=>this.doClose(f,void 0);return this.doUpdateItems(f,{insert:S()}).then(()=>b(),v=>(b(),Promise.reject(v)))})).then(g,w):w(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return I.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const S=await this.whenConnected,g=await this.get(S,i?"PRAGMA integrity_check":"PRAGMA quick_check"),w=i?g.integrity_check:g.quick_check;return S.isErroneous?`${w} (last error: ${S.lastError})`:S.isInMemory?`${w} (in-memory!)`:w}async connect(i,S=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${S})`);try{return await this.doConnect(i)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&S)return await(0,p.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await I.Promises.unlink(i);try{await I.Promises.rename(this.toBackupPath(i),i)}catch(w){}return await this.doConnect(i)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(i,S){i.isErroneous=!0,i.lastError=S,this.logger.error(S)}doConnect(i){return new Promise((S,g)=>{new Promise((w,t)=>{H(["@vscode/sqlite3"],w,t)}).then(w=>{const t={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(i,f=>f?t.db?t.db.close(()=>g(f)):g(f):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(t),b=>t.db.close(()=>g(b)))),isInMemory:i===E.IN_MEMORY_PATH};t.db.on("error",f=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${f}`)),this.logger.isTracing&&t.db.on("trace",f=>this.logger.trace(`[storage ${this.name}] Trace (event): ${f}`))},g)})}exec(i,S){return new Promise((g,w)=>{i.db.exec(S,t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${t}`),w(t)):g())})}get(i,S){return new Promise((g,w)=>{i.db.get(S,(t,f)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${t}`),w(t)):g(f))})}all(i,S){return new Promise((g,w)=>{i.db.all(S,(t,f)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${t}`),w(t)):g(f))})}transaction(i,S){return new Promise((g,w)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),S(),i.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${t}`),w(t)):g())})})}prepare(i,S,g,w){const t=i.db.prepare(S),f=b=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${b} (${S}). Details: ${w()}`)};t.on("error",f),g(t),t.finalize(b=>{b&&f(b),t.removeListener("error",f)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class h{constructor(i){i&&typeof i.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[126],J([12,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(Q[127],J([0,1,126]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,M=L*60,k=M*24,I=k*7,E=k*30,h=k*365;function d(S,g){typeof S!="number"&&(S=S.getTime());const w=Math.round((new Date().getTime()-S)/1e3);if(w<-30)return(0,p.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(w<30)return(0,p.localize)(1,null);let t;return w<L?(t=w,g?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):w<M?(t=Math.floor(w/L),g?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):w<k?(t=Math.floor(w/M),g?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):w<I?(t=Math.floor(w/k),g?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):w<E?(t=Math.floor(w/I),g?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):w<h?(t=Math.floor(w/E),g?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(w/h),g?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=d;function i(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Q[128],J([12,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(Q[45],J([0,1,31,14,128]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(d,i){return i&&(d.stack||d.stacktrace)?M.localize(0,null,E(d),I(d.stack)||I(d.stacktrace)):E(d)}function I(d){return Array.isArray(d)?d.join(`
`):d}function E(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?M.localize(1,null,d.message):d.message||M.localize(2,null)}function h(d=null,i=!1){if(!d)return M.localize(3,null);if(Array.isArray(d)){const S=p.coalesce(d),g=h(S[0],i);return S.length>1?M.localize(4,null,g,S.length):g}if(L.isString(d))return d;if(d.detail){const S=d.detail;if(S.error)return k(S.error,i);if(S.exception)return k(S.exception,i)}return d.stack?k(d,i):d.message?d.message:M.localize(5,null)}e.toErrorMessage=h}),define(Q[129],J([12,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(Q[130],J([0,1,129]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(I,E,h=E){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=E,this.modifierLabels[3]=h}toLabel(I,E,h){if(E.length===0)return null;const d=[];for(let i=0,S=E.length;i<S;i++){const g=E[i],w=h(g);if(w===null)return null;d[i]=M(g,w,this.modifierLabels[I])}return d.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(k,I,E){if(I===null)return"";const h=[];return k.ctrlKey&&h.push(E.ctrlKey),k.shiftKey&&h.push(E.shiftKey),k.altKey&&h.push(E.altKey),k.metaKey&&h.push(E.metaKey),I!==""&&h.push(I),h.join(E.separator)}}),define(Q[131],J([12,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(Q[72],J([0,1,44,33,10,43,8,3,32,80,14,114,20,131]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function t(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(n,o){if(E.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};o&&(s.cwd=o);const r=p.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],s);return new Promise(l=>{r.once("error",m=>{l({success:!1,error:m})}),r.once("exit",(m,y)=>{l(m===0?{success:!0}:{success:!1,code:m!==null?m:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(E.isLinux||E.isMacintosh)try{const s=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(r=>{p.execFile(s,[n.pid.toString()],{encoding:"utf8",shell:!0},(l,m,y)=>{r(l?{success:!1,error:l}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function b(n){!n||(delete n.DEBUG,E.isMacintosh&&delete n.DYLD_LIBRARY_PATH,E.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=b;function v(n=h.env){return n.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(o,s,r,l){if(s!==void 0&&r!==void 0&&l!==void 0)this.cmd=o,this.args=s,this.shell=r,this.options=l;else{const m=o;this.cmd=m.command,this.shell=m.isShellCommand,this.args=m.args.slice(0),this.options=m.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const m=Object.create(null);Object.keys(h.env).forEach(y=>{m[y]=h.env[y]}),Object.keys(this.options.env).forEach(y=>{m[y]=this.options.env[y]}),this.options.env=m}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const s=o.lastIndexOf(I.sep);return s!==-1&&(o=o.substring(s+1)),P.WellKnowCommands[o]?o:"other"}start(o){return E.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(h.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(s=>{let r,l;const m=new Promise((y,D)=>{r=y,l=D});if(s){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=p.exec(y,this.options,(D,R,T)=>{this.childProcess=null;const _=D;_&&_.killed?l({killed:this.terminateRequested,stdout:R.toString(),stderr:T.toString()}):this.handleExec(r,o,D,R,T)})}else{let y=null;const D=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,r,o,l);const T={terminated:this.terminateRequested};i.isNumber(R)&&(T.cmdCode=R),r(T)};if(this.shell&&E.isWindows){const R=k.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let T=!1,_=!1;const j=[];let te=this.ensureQuotes(this.cmd);j.push(te.value),T=te.quoted,this.args&&this.args.forEach(oe=>{te=this.ensureQuotes(oe),j.push(te.value),_=_&&te.quoted});const se=["/s","/c"];T?_?se.push('"'+j.join(" ")+'"'):j.length>1?se.push('"'+j[0]+'" '+j.slice(1).join(" ")):se.push('"'+j[0]+'"'):se.push(j.join(" ")),y=p.spawn(v(),se,R)}else this.cmd&&(y=p.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(i.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",R=>{this.childProcess=null,l({terminated:this.terminateRequested,error:R})}),y.pid&&(this.childProcess.on("close",D),this.handleSpawn(y,r,o,l,!0)))}return m})}handleClose(o,s,r,l){}ensureQuotes(o){return P.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,f(o,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!E.isWindows)return o(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",r=>o(!0)),s.on("exit",r=>o(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(o,s,r,l){super(o,s,r,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,s,r,l,m){[l,m].forEach((y,D)=>{const R=new S.LineDecoder;R.write(y).forEach(j=>{s({line:j,source:D===0?0:1})});const _=R.end();_&&s({line:_,source:D===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,s,r,l,m){const y=new S.LineDecoder,D=new S.LineDecoder;o.stdout.on("data",R=>{y.write(R).forEach(_=>r({line:_,source:0}))}),o.stderr.on("data",R=>{D.write(R).forEach(_=>r({line:_,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=D}handleClose(o,s,r,l){const m=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;m&&r({line:m,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&r({line:y,source:1})}}e.LineProcess=c;function a(n){let o=[],s=!1;const r=function(l){if(s){o.push(l);return}(!n.send(l,y=>{if(y&&console.error(y),s=!1,o.length>0){const D=o.slice(0);o=[],D.forEach(R=>r(R))}})||E.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=a;var u;(function(n){async function o(s,r,l){if(I.isAbsolute(s))return s;if(r===void 0&&(r=h.cwd()),I.dirname(s)!=="."||(l===void 0&&i.isString(h.env.PATH)&&(l=h.env.PATH.split(I.delimiter)),l===void 0||l.length===0))return I.join(r,s);async function y(D){if(await g.Promises.exists(D)){let R;try{R=await g.Promises.stat(D)}catch(T){T.message.startsWith("EACCES")&&(R=await g.Promises.lstat(D))}return R?!R.isDirectory():!1}return!1}for(let D of l){let R;if(I.isAbsolute(D)?R=I.join(D,s):R=I.join(r,D,s),await y(R))return R;let T=R+".com";if(await y(T)||(T=R+".exe",await y(T)))return T}return I.join(r,s)}n.findExecutable=o})(u=e.win32||(e.win32={}))}),define(Q[132],J([0,1,25,3,118,72]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(w,t){return w===1?L.isWindows?S():k.getWindowsShell(t):d(w,t)}e.getSystemShell=I;function E(w,t){return w===1?L.isWindows?g(t):k.getWindowsShell(t):d(w,t)}e.getSystemShellSync=E;let h=null;function d(w,t){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!h){let f;if(L.isWindows)f="/bin/bash";else{if(f=t.SHELL,!f)try{f=(0,p.userInfo)().shell}catch(b){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}h=f}return h}let i=null;async function S(){return i||(i=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),i}function g(w){if(i)return i;const t=L.isWindows&&parseFloat((0,p.release)())>=10,f=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${w.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?b:k.getWindowsShell(w)}}),define(Q[87],J([0,1,44,9,17,23,110,16,4,2,43,72,35]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends g.ChannelServer{constructor(b){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(P){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",v=>M.VSBuffer.wrap(Buffer.from(v,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=w;class t{constructor(b,v){this.modulePath=b,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new L.Delayer(P),this.child=null,this._client=null}getChannel(b){const v=this;return{call(P,c,a){return v.requestPromise(b,P,c,a)},listen(P,c){return v.requestEvent(b,P,c)}}}requestPromise(b,v,P,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),u=(0,L.createCancelablePromise)(s=>a.call(v,P,s)),n=c.onCancellationRequested(()=>u.cancel()),o=(0,d.toDisposable)(()=>u.cancel());return this.activeRequests.add(o),u.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(b,v,P){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let c;const a=new h.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(b).listen(v,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,S.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,b,v);const P=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,I.isRemoteConsoleLog)(r)){(0,I.log)(r,`IPC Library: ${this.options.serverName}`);return}P.fire(M.VSBuffer.wrap(Buffer.from(r,"base64")))});const a=this.options.useQueue?(0,S.createQueuedSender)(this.child):this.child,u=r=>this.child&&this.child.connected&&a.send(r.buffer.toString("base64")),n=P.event,o={send:u,onMessage:n};this._client=new g.ChannelClient(o);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(m=>(0,d.dispose)(m)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(b){let v=this.channels.get(b);return v||(v=this.client.getChannel(b),this.channels.set(b,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[133],J([12,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(Q[134],J([12,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[135],J([12,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[136],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(Q[137],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(Q[138],J([12,11]),function(H,e){return H.create("vs/platform/environment/node/shellEnv",e)}),define(Q[139],J([12,11]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[140],J([12,11]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[141],J([12,11]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[142],J([12,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(Q[143],J([12,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(Q[144],J([12,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(Q[145],J([12,11]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Q[146],J([12,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[147],J([12,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[148],J([12,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[149],J([12,11]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[150],J([12,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(Q[151],J([12,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[152],J([12,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[153],J([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(Q[154],J([12,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[155],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[156],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[157],J([12,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[158],J([0,1,4,2]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(E,h,d){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(E,h,d){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class k extends L.Disposable{constructor(E){super();this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,h,d){this.channel.call("attach",[E,h,d])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,h){this.channel.call("terminate",[E,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.channel.call("openExtensionDevelopmentHostWindow",[E,h])}}e.ExtensionHostDebugChannelClient=k}),define(Q[159],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(I){this.driver=I}listen(I,E){throw new Error(`No event found: ${E}`)}call(I,E,h){switch(E){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=p;class L{constructor(I){this.channel=I}click(I,E,h){return this.channel.call("click",[I,E,h])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,E){return this.channel.call("setValue",[I,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,E){return this.channel.call("getElements",[I,E])}getElementXY(I,E,h){return this.channel.call("getElementXY",[I,E,h])}typeInEditor(I,E){return this.channel.call("typeInEditor",[I,E])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,E){return this.channel.call("writeInTerminal",[I,E])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class M{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=M}),define(Q[160],J([0,1,127,47,10,8,32,15,7]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class d{constructor(f,b,v){this._args=f,this.paths=b,this.productService=v}get appRoot(){return(0,k.dirname)(M.FileAccess.asFileUri("",H).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(h.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=I.env.VSCODE_PORTABLE;return f?h.URI.file((0,k.join)(f,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,E.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.resolve)(f):(0,k.normalize)((0,k.join)(M.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,k.resolve)(f):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.resolve)(f);const b=I.env.VSCODE_EXTENSIONS;if(b)return b;const v=I.env.VSCODE_PORTABLE;return v?(0,k.join)(v,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(b=>/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,k.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,k.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],d.prototype,"appRoot",null),he([L.memoize],d.prototype,"userHome",null),he([L.memoize],d.prototype,"userDataPath",null),he([L.memoize],d.prototype,"appSettingsHome",null),he([L.memoize],d.prototype,"tmpDir",null),he([L.memoize],d.prototype,"userRoamingDataHome",null),he([L.memoize],d.prototype,"settingsResource",null),he([L.memoize],d.prototype,"userDataSyncHome",null),he([L.memoize],d.prototype,"userDataSyncLogResource",null),he([L.memoize],d.prototype,"sync",null),he([L.memoize],d.prototype,"machineSettingsResource",null),he([L.memoize],d.prototype,"globalStorageHome",null),he([L.memoize],d.prototype,"workspaceStorageHome",null),he([L.memoize],d.prototype,"keybindingsResource",null),he([L.memoize],d.prototype,"keyboardLayoutResource",null),he([L.memoize],d.prototype,"argvResource",null),he([L.memoize],d.prototype,"snippetsHome",null),he([L.memoize],d.prototype,"isExtensionDevelopment",null),he([L.memoize],d.prototype,"untitledWorkspacesHome",null),he([L.memoize],d.prototype,"installSourcePath",null),he([L.memoize],d.prototype,"builtinExtensionsPath",null),he([L.memoize],d.prototype,"extensionsPath",null),he([L.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],d.prototype,"extensionDevelopmentKind",null),he([L.memoize],d.prototype,"extensionTestsLocationURI",null),he([L.memoize],d.prototype,"debugExtensionHost",null),he([L.memoize],d.prototype,"serviceMachineIdResource",null),he([L.memoize],d.prototype,"telemetryLogResource",null),he([L.memoize],d.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=d;function i(t,f){return w(t["inspect-extensions"],t["inspect-brk-extensions"],5870,f,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=i;function S(t,f){return w(t["inspect-search"],t["inspect-brk-search"],5876,f,t.extensionEnvironment)}e.parseSearchPort=S;function g(t,f){return w(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,f,t.extensionEnvironment)}e.parsePtyHostPort=g;function w(t,f,b,v,P,c){const u=Number(f||t)||(v?null:b),n=u?Boolean(!!f):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:u,break:n,debugId:P,env:o}}}),define(Q[88],J([0,1,243,3,136]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function E(t,f,b=I){const v={},P=[],c=[];for(let o in f){const s=f[o];s.alias&&(v[o]=s.alias),s.type==="string"||s.type==="string[]"?(P.push(o),s.deprecates&&P.push(s.deprecates)):s.type==="boolean"&&(c.push(o),s.deprecates&&c.push(s.deprecates))}const a=p(t,{string:P,boolean:c,alias:v}),u={},n=a;u._=a._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(let o in f){const s=f[o];s.alias&&delete n[s.alias];let r=n[o];s.deprecates&&n.hasOwnProperty(s.deprecates)&&(r||(r=n[s.deprecates]),delete n[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(o,r)),u[o]=r),delete n[o]}for(let o in n)b.onUnknownOption(o);return u}e.parseArgs=E;function h(t,f){let b="";return f.args&&(Array.isArray(f.args)?b=` <${f.args.join("> <")}>`:b=` <${f.args}>`),f.alias?`-${f.alias} --${t}${b}`:`--${t}${b}`}function d(t,f){let b=0,v=[];for(const u in t){const n=t[u],o=h(u,n);b=Math.max(b,o.length),v.push([o,n.description])}let P=b+2+1;if(f-P<25)return v.reduce((u,n)=>u.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let c=f-P-1,a=[];for(const u of v){let n=u[0],o=S(u[1],c),s=i(P-n.length-2);a.push("  "+n+s+o[0]);for(let r=1;r<o.length;r++)a.push(i(P)+o[r])}return a}e.formatOptions=d;function i(t){return" ".repeat(t)}function S(t,f){let b=[];for(;t.length;){let v=t.length<f?t.length:t.lastIndexOf(" ",f),P=t.slice(0,v).trim();t=t.slice(v),b.push(P)}return b}function g(t,f,b,v,P=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${t} ${b}`];a.push(""),a.push(`${(0,M.localize)(32,null)}: ${f} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),a.push(""),P&&(L.isWindows?a.push((0,M.localize)(35,null,f)):a.push((0,M.localize)(36,null,f)),a.push(""));const u={};for(const n in v){const o=v[n];if(o.description&&o.cat){let s=u[o.cat];s||(u[o.cat]=s={}),s[n]=o}}for(let n in u){const o=n;let s=u[o];s&&(a.push(k[o]),a.push(...d(s,c)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=g;function w(t,f){return`${t||(0,M.localize)(37,null)}
${f||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Q[161],J([0,1,62,158,88]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class k extends L.ExtensionHostDebugBroadcastChannel{constructor(E){super();this.windowsMainService=E}call(E,h,d){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(d[0],d[1]):super.call(E,h,d)}async openExtensionDevelopmentHostWindow(E,h){const d=(0,M.parseArgs)(E,M.OPTIONS);d.debugRenderer=h;const i=d.extensionDevelopmentPath;if(!i)return{success:!1};const[S]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:d});if(!h)return{success:!0};const g=S.win;if(!g)return{success:!0};const w=g.webContents.debugger;let t=w.isAttached()?Infinity:0;const f=(0,p.createServer)(b=>{t++==0&&w.attach();let v=!1;const P=u=>{v||b.write(JSON.stringify(u)+"\0")},c=(u,n,o,s)=>P({method:n,params:o,sessionId:s});g.on("close",()=>{w.removeListener("message",c),b.end(),v=!0}),w.addListener("message",c);let a=Buffer.alloc(0);b.on("data",u=>{a=Buffer.concat([a,u]);for(let n=a.indexOf(0);n!==-1;n=a.indexOf(0)){let o;try{const s=a.slice(0,n).toString("utf8");a=a.slice(n+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}w.sendCommand(o.method,o.params,o.sessionId).then(s=>P({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>P({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{v=!0,--t==0&&w.detach()})});return await new Promise(b=>f.listen(0,b)),g.on("close",()=>f.close()),{rendererDebugPort:f.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=k}),function(){"use strict";function H(e,p,L,M){function k(E){const h=I(E),d=[h];return e.isAbsolute(h)||d.unshift(M),e.resolve(...d)}function I(E){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,L);const i=E["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(S,"AppData","Roaming")}break;case"darwin":d=e.join(p.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,L)}return{getUserDataPath:k}}if(typeof define=="function")define(Q[162],J([0,244,25,10,15,32]),function(e,p,L,M,k,I){const E=k.dirname(M.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(k.joinPath(E,"package.json").fsPath);return H(p,L,h.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=H(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[163],J([0,1,25,160,162]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(E,h){super(E,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,M.getUserDataPath)(E)},h)}}e.NativeEnvironmentService=k}),define(Q[164],J([0,1,29,25,8]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function k(I){const E=(0,M.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(E,""),I&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){I&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=k}),define(Q[165],J([0,1,140]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function k(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=k;function I(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=g.match(L);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=I;function E(g){if(!g)return null;let w=g.majorBase,t=g.majorMustEqual,f=g.minorBase,b=g.minorMustEqual,v=g.patchBase,P=g.patchMustEqual;g.hasCaret&&(w===0||(b=!1),P=!1);let c=0;if(g.preRelease){const a=M.exec(g.preRelease);if(a){const[,u,n,o]=a;c=Date.UTC(Number(u),Number(n)-1,Number(o))}}return{majorBase:w,majorMustEqual:t,minorBase:f,minorMustEqual:b,patchBase:v,patchMustEqual:P,isMinimum:g.hasGreaterEquals,notBefore:c}}e.normalizeVersion=E;function h(g,w,t){let f;typeof g=="string"?f=E(I(g)):f=g;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let v;if(typeof t=="string"?v=E(I(t)):v=t,!f||!v)return!1;let P=f.majorBase,c=f.minorBase,a=f.patchBase,u=v.majorBase,n=v.minorBase,o=v.patchBase,s=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?P>u?!0:P<u?!1:c>n?!0:c<n||b&&b<s?!1:a>=o:(P===1&&u===0&&(!r||!l||!m)&&(u=1,n=0,o=0,r=!0,l=!1,m=!1),P<u?!1:P>u?!r:c<n?!1:c>n?!l:a<o?!1:a>o?!m:!(b&&b<s))}e.isValidVersion=h;function d(g,w,t,f){return t.isBuiltin||typeof t.main=="undefined"?!0:S(g,w,t.engines.vscode,f)}e.isValidExtensionVersion=d;function i(g,w,t){return g==="*"||S(w,t,g)}e.isEngineValid=i;function S(g,w,t,f=[]){let b=E(I(t));if(!b)return f.push(p.localize(0,null,t)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(p.localize(1,null,t)),!1}else if(!b.majorMustEqual)return f.push(p.localize(2,null,t)),!1;return h(g,w,b)?!0:(f.push(p.localize(3,null,g,t)),!1)}}),define(Q[166],J([0,1,4,2,17,60,23]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class E extends L.Disposable{constructor(d,i){super();this.provider=d,this.logService=i,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(d,i,S){const g=this.getUriTransformer(d);switch(i){case"stat":return this.stat(g,S[0]);case"readdir":return this.readdir(g,S[0]);case"open":return this.open(g,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(g,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(g,S[0],S[1],S[2]);case"rename":return this.rename(g,S[0],S[1],S[2]);case"copy":return this.copy(g,S[0],S[1],S[2]);case"mkdir":return this.mkdir(g,S[0]);case"delete":return this.delete(g,S[0],S[1]);case"watch":return this.watch(g,S[0],S[1],S[2],S[3]);case"unwatch":return this.unwatch(S[0],S[1])}throw new Error(`IPC Command ${i} not found`)}listen(d,i,S){const g=this.getUriTransformer(d);switch(i){case"fileChange":return this.onFileChange(g,S[0]);case"readFileStream":return this.onReadFileStream(g,S[0],S[1])}throw new Error(`Unknown event ${i}`)}stat(d,i){const S=this.transformIncoming(d,i,!0);return this.provider.stat(S)}readdir(d,i){const S=this.transformIncoming(d,i);return this.provider.readdir(S)}async readFile(d,i){const S=this.transformIncoming(d,i,!0),g=await this.provider.readFile(S);return M.VSBuffer.wrap(g)}onReadFileStream(d,i,S){const g=this.transformIncoming(d,i,!0),w=new I.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{w.cancel()}}),f=this.provider.readFileStream(g,S,w.token);return(0,k.listenStream)(f,{onData:b=>t.fire(M.VSBuffer.wrap(b)),onError:b=>t.fire(b),onEnd:()=>{t.fire("end"),t.dispose(),w.dispose()}}),t.event}writeFile(d,i,S,g){const w=this.transformIncoming(d,i);return this.provider.writeFile(w,S.buffer,g)}open(d,i,S){const g=this.transformIncoming(d,i,!0);return this.provider.open(g,S)}close(d){return this.provider.close(d)}async read(d,i,S){const g=M.VSBuffer.alloc(S),w=0,t=await this.provider.read(d,i,g.buffer,w,S);return[g,t]}write(d,i,S,g,w){return this.provider.write(d,i,S.buffer,g,w)}mkdir(d,i){const S=this.transformIncoming(d,i);return this.provider.mkdir(S)}delete(d,i,S){const g=this.transformIncoming(d,i);return this.provider.delete(g,S)}rename(d,i,S,g){const w=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.rename(w,t,g)}copy(d,i,S,g){const w=this.transformIncoming(d,i),t=this.transformIncoming(d,S);return this.provider.copy(w,t,g)}onFileChange(d,i){const S=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(i,this.createSessionFileWatcher(d,S))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(i)),this.sessionToWatcher.delete(i)}});return S.event}async watch(d,i,S,g,w){const t=this.sessionToWatcher.get(i);if(t){const f=this.transformIncoming(d,g),b=t.watch(S,f,w);this.watchRequests.set(i+S,b)}}async unwatch(d,i){const S=d+i,g=this.watchRequests.get(S);g&&((0,L.dispose)(g),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(d=>(0,L.dispose)(d)),this.watchRequests.clear(),this.sessionToWatcher.forEach(d=>(0,L.dispose)(d)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=E}),define(Q[73],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(M,k=[],I=!1){this.ctor=M,this.staticArguments=k,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=p}),define(Q[167],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let I of this._nodes.values())I.outgoing.size===0&&k.push(I);return k}insertEdge(k,I){const E=this.lookupOrInsertNode(k),h=this.lookupOrInsertNode(I);E.outgoing.set(this._hashFn(I),h),h.incoming.set(this._hashFn(k),E)}removeNode(k){const I=this._hashFn(k);this._nodes.delete(I);for(let E of this._nodes.values())E.outgoing.delete(I),E.incoming.delete(I)}lookupOrInsertNode(k){const I=this._hashFn(k);let E=this._nodes.get(I);return E||(E=new p(k),this._nodes.set(I,E)),E}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[I,E]of this._nodes)k.push(`${I}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,I]of this._nodes){const E=new Set([k]),h=this._findCycle(I,E);if(h)return h}}_findCycle(k,I){for(let[E,h]of k.outgoing){if(I.has(E))return[...I,E].join(" -> ");I.add(E);const d=this._findCycle(h,I);if(d)return d;I.delete(E)}}}e.Graph=L}),define(Q[5],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function L(I,E,h,d){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:I,index:h,optional:d}):(E[p.DI_DEPENDENCIES]=[{id:I,index:h,optional:d}],E[p.DI_TARGET]=E)}function M(I){if(p.serviceIds.has(I))return p.serviceIds.get(I);const E=function(h,d,i){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(E,h,i,!1)};return E.toString=()=>I,p.serviceIds.set(I,E),E}e.createDecorator=M;function k(I){return I}e.refineServiceDecorator=k}),define(Q[74],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=L}),define(Q[89],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(k){this.machineId=k}encryption(){return new Promise((k,I)=>H(["vscode-encrypt"],k,I))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch(I){return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch(I){return k}}}e.EncryptionMainService=L}),define(Q[48],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[168],J([0,1,10,139,5]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function E(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function h(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function d(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=d;function i(c,a,u){return d(a,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u?!0:S(u).includes(c)}e.isTargetPlatformCompatible=i;function S(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function g(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=g;var w;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var v;(function(c){c.Unsupported="Unsupported",c.Malicious="Malicious",c.Incompatible="Incompatible",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,u){super(a);this.code=u,this.name=u}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Q[169],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Q[90],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Q[170],J([0,1,44,10,8,3,80,20,72,141,90]),function(H,e,p,L,M,k,I,E,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=d.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends g{openTerminal(a,u){return this.spawnTerminal(p,a,h.getWindowsShell(),u)}spawnTerminal(a,u,n,o){const s=u.windowsExec||w.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=M.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return a.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(r==="wt"||r==="wt.exe")&&l.push("-d ."),new Promise((m,y)=>{const D=b(process),R=a.spawn(n,l,{cwd:o,env:D});R.on("error",y),R.on("exit",()=>m())})}runInTerminal(a,u,n,o,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows();return new Promise((l,m)=>{const y=`"${u} - ${S}"`,D=`""${n.join('" "')}" & pause"`,R=["/c","start",y,"/wait",r,"/c",D],T=Object.assign({},b(process),o);Object.keys(T).filter(te=>T[te]===null).forEach(te=>delete T[te]);const _={cwd:u,env:T,windowsVerbatimArguments:!0};p.spawn(w.CMD,R,_).on("error",te=>{m(v(te))}),l(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class t extends g{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,n,o,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const y=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`,H).fsPath,"-t",a||S,"-w",u];for(let j of n)R.push("-a"),R.push(j);if(o){const j=Object.assign({},b(process),o);for(let te in j){const se=j[te];se===null?(R.push("-u"),R.push(te)):(R.push("-e"),R.push(`${te}=${se}`))}}let T="";const _=p.spawn(t.OSASCRIPT,R);_.on("error",j=>{m(v(j))}),_.stderr.on("data",j=>{T+=j.toString()}),_.on("exit",j=>{if(j===0)l(void 0);else if(T){const te=T.split(`
`,1);m(new Error(te[0]))}else m(new Error(d.localize(1,null,y,j)))})}else m(new Error(d.localize(2,null,r)))})}spawnTerminal(a,u,n){const o=u.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const l=["-a",o];n&&l.push(n);const m=b(process),y=a.spawn("/usr/bin/open",l,{cwd:n,env:m});y.on("error",r),y.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class f extends g{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,n,o,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let y=[];r.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const R=`${P(n)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;y.push(`''${R}''`);const T=Object.assign({},b(process),o);Object.keys(T).filter(se=>T[se]===null).forEach(se=>delete T[se]);const _={cwd:u,env:T};let j="";const te=p.spawn(D,y,_);te.on("error",se=>{m(v(se))}),te.stderr.on("data",se=>{j+=se.toString()}),te.on("exit",se=>{if(se===0)l(void 0);else if(j){const oe=j.split(`
`,1);m(new Error(oe[0]))}else m(new Error(d.localize(4,null,D,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!f._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)f._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await E.Promises.exists("/etc/debian_version");f._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{a?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,n){const o=u.linuxExec?Promise.resolve(u.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{o.then(l=>{const m=b(process),y=a.spawn(l,[],{cwd:n,env:m});y.on("error",r),y.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=d.localize(3,null);function b(c){const a={...c.env};return(0,I.sanitizeProcessEnvironment)(a),a}function v(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(d.localize(5,null,c.path)):c}function P(c){let a="";for(let u of c)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Q[18],J([0,1,40,8,27,14,7,143,5]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function d(F){return F.create===!0}e.isFileOpenForWriteOptions=d;var i;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var S;(function(F){F[F.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var g;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=w;function t(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=t;function f(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function b(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=b;var v;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(B,V){super(B);this.code=V}}e.FileSystemProviderError=P;function c(F,B){const V=new P(F.toString(),B);return u(V,B),V}e.createFileSystemProviderError=c;function a(F){return F||c((0,E.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function u(F,B){return F.name=B?`${B} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=u;function n(F){if(!F)return v.Unknown;if(F instanceof P)return F.code;const B=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!B)return v.Unknown;switch(B[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function o(F){if(F instanceof D)return F.fileOperationResult;switch(n(F)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(B,V,C){this.resource=B,this.operation=V,this.target=C}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var l;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(B,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const C=new Map;for(const N of B){const U=C.get(N.type);U?U.push([N.resource,N]):C.set(N.type,[[N.resource,N]])}for(const[N,U]of C)switch(N){case 1:this.added=p.TernarySearchTree.forUris(()=>V),this.added.fill(U);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>V),this.updated.fill(U);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>V),this.deleted.fill(U);break}}contains(B,...V){return this.doContains(B,{includeChildren:!1},...V)}affects(B,...V){return this.doContains(B,{includeChildren:!0},...V)}doContains(B,V,...C){if(!B)return!1;const N=C.length>0;return!!((!N||C.includes(1))&&(this.added?.get(B)||V.includeChildren&&this.added?.findSuperstr(B))||(!N||C.includes(0))&&(this.updated?.get(B)||V.includeChildren&&this.updated?.findSuperstr(B))||(!N||C.includes(2))&&(this.deleted?.findSubstr(B)||V.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function y(F,B,V){return!F||!B||F===B||B.length>F.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),V?(0,M.startsWithIgnoreCase)(F,B):F.indexOf(B)===0)}e.isParent=y;class D extends Error{constructor(B,V,C){super(B);this.fileOperationResult=V,this.options=C}}e.FileOperationError=D;class R extends D{constructor(B,V,C){super(B,2,C);this.stat=V}}e.NotModifiedSinceFileOperationError=R;var T;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=j;async function te(F,B){if(!B.hasProvider(I.URI.from({scheme:F.scheme})))return new Promise(V=>{const C=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===F.scheme&&N.added&&(C.dispose(),V())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<se.KB?(0,E.localize)(1,null,B.toFixed(0)):B<se.MB?(0,E.localize)(2,null,(B/se.KB).toFixed(2)):B<se.GB?(0,E.localize)(3,null,(B/se.MB).toFixed(2)):B<se.TB?(0,E.localize)(4,null,(B/se.GB).toFixed(2)):(0,E.localize)(5,null,(B/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var oe;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function G(F){return{maxFileSize:F===0?300*se.MB:16*se.GB,maxHeapSize:F===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=G}),define(Q[54],J([0,1,245,137,88,18]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(g,w){const t={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,v)=>{console.warn((0,L.localize)(1,null,b,v))}},f=(0,M.parseArgs)(g,M.OPTIONS,w?t:void 0);return f.goto&&f._.forEach(b=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),f["max-memory"]&&p(parseInt(f["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),f}function E(g){const w=g.findIndex(t=>!/^-/.test(t));if(w>-1)return[...g.slice(0,w),...g.slice(w+1)]}function h(g){let[,...w]=g;process.env.VSCODE_DEV&&(w=E(w)||[]);const t=!S(process.env);return I(w,t)}e.parseMainProcessArgv=h;function d(g){const[,,...w]=g;return I(w,!0)}e.parseCLIProcessArgv=d;function i(g,...w){const t=g.indexOf("--");return t===-1?g.push(...w):g.splice(t,0,...w),g}e.addArg=i;function S(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),define(Q[91],J([0,1,44,8,138,23,45,16,3,28,132,54,9]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const w=1e4;let t;async function f(v,P,c){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(c)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(c)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=g.Promises.withAsyncBody(async(a,u)=>{const n=new k.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),u(new Error((0,M.localize)(0,null)))},w);try{a(await b(v,n.token))}catch(s){!(0,E.isPromiseCanceledError)(s)&&!n.token.isCancellationRequested?u(new Error((0,M.localize)(1,null,(0,I.toErrorMessage)(s)))):a({})}finally{clearTimeout(o),n.dispose()}})),t)}e.resolveShellEnv=f;async function b(v,P){const c=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",a);const u=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(u+"(.*)"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",o);const s=await(0,i.getSystemShell)(h.OS,o);return v.trace("getUnixShellEnvironment#shell",s),new Promise((r,l)=>{if(P.isCancellationRequested)return l((0,E.canceled)());const m=(0,L.basename)(s);let y,D;/^pwsh(-preview)?$/.test(m)?(y=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,D=["-Login","-Command"]):(y=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,m==="tcsh"?D=["-ic"]:D=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),y);const R=(0,p.spawn)(s,[...D,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});P.onCancellationRequested(()=>(R.kill(),l((0,E.canceled)()))),R.on("error",j=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(j)),l(j)});const T=[];R.stdout.on("data",j=>T.push(j));const _=[];R.stderr.on("data",j=>_.push(j)),R.on("close",(j,te)=>{const se=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",se);const oe=Buffer.concat(_).toString("utf8");if(oe.trim()&&v.trace("getUnixShellEnvironment#stderr",oe),j||te)return l(new Error((0,M.localize)(2,null,j,te)));const G=n.exec(se),F=G?G[1]:"{}";try{const B=JSON.parse(F);c?B.ELECTRON_RUN_AS_NODE=c:delete B.ELECTRON_RUN_AS_NODE,a?B.ELECTRON_NO_ATTACH_CONSOLE=a:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",B),r(B)}catch(B){v.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(B)),l(B)}})})}}),define(Q[92],J([0,1,17,16,144,18]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function I(i,S,g,w,t,f){let b;try{await E(i,S,g,w,t,f)}catch(v){b=v}finally{b&&t.errorTransformer&&(b=t.errorTransformer(b)),typeof b!="undefined"&&g.error(b),g.end()}}e.readFileIntoStream=I;async function E(i,S,g,w,t,f){h(f);const b=await i.open(S,{create:!1});try{h(f);let v=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,n=0;do P=await i.read(b,u,a.buffer,n,a.byteLength-n),u+=P,n+=P,v+=P,typeof c=="number"&&(c-=P),n===a.byteLength&&(await g.write(w(a)),a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),n=0);while(P>0&&(typeof c!="number"||c>0)&&h(f)&&d(v,t));if(n>0){let o=n;typeof c=="number"&&(o=Math.min(n,c)),g.write(w(a.slice(0,o)))}}catch(v){throw(0,k.ensureFileSystemProviderError)(v)}finally{await i.close(b)}}function h(i){if(i.isCancellationRequested)throw(0,L.canceled)();return!0}function d(i,S){if(S?.limits){if(typeof S.limits.memory=="number"&&i>S.limits.memory)throw(0,k.createFileSystemProviderError)((0,M.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&i>S.limits.size)throw(0,k.createFileSystemProviderError)((0,M.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[55],J([0,1,2,3,7,18]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class I extends p.Disposable{constructor(g,w,t){super();this.onFileChanges=g,this.onLogMessage=w,this.verboseLogging=t,this.serviceDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new p.DisposableStore;this.serviceDisposables.value=g,this.service=this.createService(g),this.service.setVerboseLogging(this.verboseLogging),g.add(this.service.onDidChangeFile(w=>this.onFileChanges(w))),g.add(this.service.onDidLogMessage(w=>this.onLogMessage(w))),g.add(this.service.onDidError(w=>this.onError(w)))}onError(g){this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.service?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.service?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${g}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=I,I.MAX_RESTARTS=5;class E extends p.Disposable{}e.WatcherService=E;function h(S){return S.map(g=>({type:g.type,resource:M.URI.file(g.path)}))}e.toFileChanges=h;function d(S){const g=new i;for(const w of S)g.processEvent(w);return g.normalize()}e.normalizeFileChanges=d;class i{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const w=this.mapPathToChange.get(this.toKey(g));let t=!1;if(w){const f=w.type,b=g.type;w.path!==g.path&&g.type===2?t=!0:f===1&&b===2?(this.mapPathToChange.delete(this.toKey(g)),this.normalized.delete(w)):f===2&&b===1?w.type=0:f===1&&b===0||(w.type=b)}else t=!0;t&&(this.normalized.add(g),this.mapPathToChange.set(this.toKey(g),g))}normalize(){const g=[],w=[];return Array.from(this.normalized).filter(t=>t.type!==2?(g.push(t),!1):!0).sort((t,f)=>t.path.length-f.path.length).filter(t=>w.some(f=>(0,k.isParent)(t.path,f,!L.isLinux))?!1:(w.push(t.path),!0)).concat(g)}}}),define(Q[93],J([0,1,9,2,8,82,20,119,55]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class d extends L.Disposable{constructor(S,g,w,t){super();this.path=S,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(S){this.verboseLogging=S}async startWatching(){try{const{stat:S,symbolicLink:g}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(g)try{w=await(0,k.realpath)(w)}catch(t){if(this.onError(t),g.dangling)return}S.isDirectory()?this._register((0,E.watchFolder)(w,(t,f)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(f))})},t=>this.onError(t))):this._register((0,E.watchFile)(w,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(S){S.code!=="ENOENT"&&this.onError(S)}}onFileChange(S){this.fileChangesBuffer.push(S),this.verboseLogging&&this.onVerbose(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,h.normalizeFileChanges)(g);if(this.verboseLogging)for(const t of w)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(S){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${S}`})}onVerbose(S){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=d}),define(Q[171],J([0,1,10,35,87,55]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends k.WatcherService{constructor(h,d,i){super();this.onDidFilesChange=h,this.onLogMessage=d,this.verboseLogging=i,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new M.Client(p.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(Q[172],J([0,1,10,35,87,55]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends k.AbstractWatcherService{constructor(h,d,i){super(h,d,i);this.init()}createService(h){const d=h.add(new M.Client(p.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(d.onDidProcessExit(({code:i,signal:S})=>this.onError(`terminated by itself with code ${i}, signal: ${S}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher")))}}e.FileWatcher=I}),define(Q[75],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...M){this._entries=new Map;for(let[k,I]of M)this.set(k,I)}set(M,k){const I=this._entries.get(M);return this._entries.set(M,k),I}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=p}),define(Q[173],J([0,1,9,16,73,167,5,75]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class d extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class i{constructor(t=new E.ServiceCollection,f=!1,b){this._activeInstantiations=new Set,this._services=t,this._strict=f,this._parent=b,this._services.set(I.IInstantiationService,this)}createChild(t){return new i(t,this._strict,this)}invokeFunction(t,...f){let b=g.traceInvocation(t),v=!1;try{return t({get:c=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,b);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...f)}finally{v=!0,b.stop()}}createInstance(t,...f){let b,v;return t instanceof M.SyncDescriptor?(b=g.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(f),b)):(b=g.traceCreation(t),v=this._createInstance(t,f,b)),b.stop(),v}_createInstance(t,f=[],b){let v=I._util.getServiceDependencies(t).sort((a,u)=>a.index-u.index),P=[];for(const a of v){let u=this._getOrCreateServiceInstance(a.id,b);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(u)}let c=v.length>0?v[0].index:f.length;if(f.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${f.length} static arguments`);let a=c-f.length;a>0?f=f.concat(new Array(a)):f=f.slice(0,c)}return new t(...[...f,...P])}_setServiceInstance(t,f){if(this._services.get(t)instanceof M.SyncDescriptor)this._services.set(t,f);else if(this._parent)this._parent._setServiceInstance(t,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let f=this._services.get(t);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):f}_getOrCreateServiceInstance(t,f){let b=this._getServiceInstanceOrDescriptor(t);return b instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,b,f.branch(t,!0)):(f.branch(t,!1),b)}_safeCreateAndCacheServiceInstance(t,f,b){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,f,b)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,f,b){const v=new k.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:f,_trace:b}];for(;c.length;){const a=c.pop();if(v.lookupOrInsertNode(a),P++>1e3)throw new d(v);for(let u of I._util.getServiceDependencies(a.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(u.id);if(!n&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),n instanceof M.SyncDescriptor){const o={id:u.id,desc:n,_trace:a._trace.branch(u.id,!0)};v.insertEdge(a,o),c.push(o)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new d(v);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const o=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,o)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,f,b=[],v,P){if(this._services.get(t)instanceof M.SyncDescriptor)return this._createServiceInstance(f,b,v,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,f,b,v,P);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(t,f=[],b,v){if(b){const P=new p.IdleValue(()=>this._createInstance(t,f,v));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let u=P.value,n=u[a];return typeof n!="function"||(n=n.bind(u),c[a]=n),n},set(c,a,u){return P.value[a]=u,!0}})}else return this._createInstance(t,f,v)}}e.InstantiationService=i;var S;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(S||(S={}));class g{constructor(t,f){this.type=t,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new g(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(t){return h?new g(0,t.name):g._None}branch(t,f){let b=new g(2,t.toString());return this._dep.push([t,f,b]),b}stop(){let t=Date.now()-this._start;g._totals+=t;let f=!1;function b(P,c){let a=[],u=new Array(P+1).join("	");for(const[n,o,s]of c._dep)if(o&&s){f=!0,a.push(`${u}CREATES -> ${n}`);let r=b(P+1,s);r&&a.push(r)}else a.push(`${u}uses -> ${n}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||f)&&console.log(v.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Q[174],J([0,1,16,130,59]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class k extends M.ResolvedKeybinding{constructor(E,h){super();if(h.length===0)throw(0,p.illegalArgument)("parts");this._os=E,this._parts=h}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,E=>this._getLabel(E))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,E=>this._getAriaLabel(E))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,E=>this._getElectronAccelerator(E))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,E=>this._getUserSettingsLabel(E))}isWYSIWYG(){return this._parts.every(E=>this._isWYSIWYG(E))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(E=>this._getPart(E))}_getPart(E){return new M.ResolvedKeybindingPart(E.ctrlKey,E.shiftKey,E.altKey,E.metaKey,this._getLabel(E),this._getAriaLabel(E))}getDispatchParts(){return this._parts.map(E=>this._getDispatchPart(E))}getSingleModifierDispatchParts(){return this._parts.map(E=>this._getSingleModifierDispatchPart(E))}}e.BaseResolvedKeybinding=k}),define(Q[175],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(k,I,E,h,d,i,S){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=k,this.keypressParts=k?L(k.getDispatchParts()):[],k&&this.keypressParts.length===0&&(this.keypressParts=L(k.getSingleModifierDispatchParts())),this.bubble=I?I.charCodeAt(0)===94:!1,this.command=this.bubble?I.substr(1):I,this.commandArgs=E,this.when=h,this.isDefault=d,this.extensionId=i,this.isBuiltinExtension=S}}e.ResolvedKeybindingItem=p;function L(M){let k=[];for(let I=0,E=M.length;I<E;I++){const h=M[I];if(!h)return k;k.push(h)}return k}e.removeElementsAfterNulls=L}),define(Q[176],J([0,1,79,59,174,175]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class I extends M.BaseResolvedKeybinding{constructor(h,d){super(d,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return p.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const d=p.KeyCodeUtils.toUserSettingsUS(h.keyCode);return d&&d.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return I.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let d="";return h.ctrlKey&&(d+="ctrl+"),h.shiftKey&&(d+="shift+"),h.altKey&&(d+="alt+"),h.metaKey&&(d+="meta+"),d+=p.KeyCodeUtils.toString(h.keyCode),d}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const d=p.IMMUTABLE_CODE_TO_KEY_CODE[h];if(d!==-1)return d;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof L.SimpleKeybinding)return h;const d=this._scanCodeToKeyCode(h.scanCode);return d===0?null:new L.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,d)}static resolveUserBinding(h,d){const i=(0,k.removeElementsAfterNulls)(h.map(S=>this._resolveSimpleUserBinding(S)));return i.length>0?[new I(new L.ChordKeybinding(i),d)]:[]}}e.USLayoutResolvedKeybinding=I}),define(Q[177],J([0,1,9]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(M,k){if(M.length===0)return Promise.resolve(!1);const I=[];let E=!1;for(let h of M){if(h===!0)return Promise.resolve(!0);(0,p.isThenable)(h)&&I.push(h.then(d=>{d&&(E=!0)},d=>{k(d),E=!0}))}return p.Promises.settled(I).then(()=>E)}e.handleVetos=L}),define(Q[6],J([0,1,45,4,2,3,5]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function E(){return new Date().toISOString()}var h;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;class d extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=d;class i extends d{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...o){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([n,...o]))}debug(n,...o){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([n,...o]))}info(n,...o){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([n,...o]))}warn(n,...o){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([n,...o]))}error(n,...o){if(this.checkLogLevel(h.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(h.Error,this.format(s))}else this.log(h.Error,this.format([n,...o]))}critical(n,...o){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([n,...o]))}flush(){}format(n){let o="";for(let s=0;s<n.length;s++){let r=n[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}o+=(s>0?" ":"")+r}return o}}e.AbstractMessageLogger=i;class S extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!k.isWindows}trace(n,...o){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...o):console.log(`[main ${E()}]`,n,...o))}debug(n,...o){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...o):console.log(`[main ${E()}]`,n,...o))}info(n,...o){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,n,...o):console.log(`[main ${E()}]`,n,...o))}warn(n,...o){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,n,...o):console.warn(`[main ${E()}]`,n,...o))}error(n,...o){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,n,...o):console.error(`[main ${E()}]`,n,...o))}critical(n,...o){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,n,...o):console.error(`[main ${E()}]`,n,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class g extends d{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...o){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",n,...o)}debug(n,...o){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...o)}info(n,...o){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",n,...o)}warn(n,...o){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",n,...o)}error(n,...o){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",n,...o)}critical(n,...o){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...o)}dispose(){}flush(){}}e.ConsoleLogger=g;class w extends d{constructor(n,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(o)}trace(n,...o){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(n),...o])}debug(n,...o){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(n),...o])}info(n,...o){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(n),...o])}warn(n,...o){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(n),...o])}error(n,...o){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(n),...o])}critical(n,...o){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(n),...o])}extractMessage(n){return typeof n=="string"?n:(0,p.toErrorMessage)(n,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class t extends d{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const o of this.logServices)o.setLevel(n);super.setLevel(n)}trace(n,...o){for(const s of this.logServices)s.trace(n,...o)}debug(n,...o){for(const s of this.logServices)s.debug(n,...o)}info(n,...o){for(const s of this.logServices)s.info(n,...o)}warn(n,...o){for(const s of this.logServices)s.warn(n,...o)}error(n,...o){for(const s of this.logServices)s.error(n,...o)}critical(n,...o){for(const s of this.logServices)s.critical(n,...o)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=t;class f extends M.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...o){this.logger.trace(n,...o)}debug(n,...o){this.logger.debug(n,...o)}info(n,...o){this.logger.info(n,...o)}warn(n,...o){this.logger.warn(n,...o)}error(n,...o){this.logger.error(n,...o)}critical(n,...o){this.logger.critical(n,...o)}flush(){this.logger.flush()}}e.LogService=f;class b extends M.Disposable{constructor(n,o){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,o){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,o?.always?h.Trace:this.logLevel,o),this.loggers.set(n.toString(),s),o?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return h.Info}trace(n,...o){}debug(n,...o){}info(n,...o){}warn(n,...o){}error(n,...o){}critical(n,...o){}dispose(){}flush(){}}e.NullLogService=v;function P(u){if(u.verbose)return h.Trace;if(typeof u.logLevel=="string"){const n=c(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function c(u){switch(u){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=c;function a(u){switch(u){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=a});var x=this&&this.__param||function(H,e){return function(p,L){e(p,L,H)}};define(Q[178],J([0,1,9,17,39,78,48,18,5,6]),function(H,e,p,L,M,k,I,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(g){g.ERROR_INVALID_FILE="ERROR_INVALID_FILE",g.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let S=class{constructor(w,t,f){this.environmentService=w,this.fileService=t,this.logService=f,this.queue=new p.Queue}async updateSettings(w,t){return this.queue.queue(()=>this.doWrite(w,t))}async doWrite(w,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),w);const{value:f,mtime:b,etag:v}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=f.toString();const c=[];if((0,M.parse)(P,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(w,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(P),{etag:v,mtime:b})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(w,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,w,t)})}getEdits({value:w,path:t},f,b){return t.length?(0,k.setProperty)(f,t,w,b):[{content:JSON.stringify(w,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:f.length,offset:0}]}};S=he([x(0,I.IEnvironmentService),x(1,E.IFileService),x(2,d.ILogService)],S),e.UserConfigurationFileService=S}),define(Q[179],J([0,1,31,9,16,4,2,8,55,6]),function(H,e,p,L,M,k,I,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class i extends I.Disposable{constructor(g){super();this.logService=g,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(g,w){return w.recursive?this.watchRecursive(g,w):this.watchNonRecursive(g)}watchRecursive(g,w){const t={path:this.toFilePath(g),excludes:w.excludes},f=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,I.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,M.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(g,w){return g.watch(w)}watchNonRecursive(g){const w=this.createNonRecursiveWatcher(this.toFilePath(g),f=>this._onDidChangeFile.fire((0,h.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===d.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{w.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,I.combinedDisposable)(w,t)}onWatcherLogMessage(g){g.type==="error"&&this._onDidErrorOccur.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,E.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=i}),define(Q[180],J([0,1,31,9,17,23,4,69,2,40,10,63,15,60,142,18,92,6]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class je extends h.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new f.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new f.FileChangesEvent(u,!0)))),this.watchedResources=d.TernarySearchTree.forUris(u=>{const n=this.getProvider(u.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const n=new h.DisposableStore;return n.add(u.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(u)))),n.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&n.add(u.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,h.dispose)(n)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(n){u.push(n)}}),!this.provider.has(a)&&await L.Promises.settled(u)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,u){const n=this.provider.get(a.scheme);return!!(n&&n.capabilities&u)}listCapabilities(){return E.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,g.isAbsolutePath)(a))throw new f.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const n=new Error;throw n.name="ENOPRO",n.message=(0,t.localize)(1,null,a.toString()),n}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasReadWriteCapability)(u)||(0,f.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(n){throw(0,f.toFileSystemProviderErrorCode)(n)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,f.ensureFileSystemProviderError)(n)}}async doResolveFile(a,u){const n=await this.withProvider(a),o=this.isPathCaseSensitive(n),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,l=u?.resolveMetadata,m=await n.stat(a);let y;return this.toFileStat(n,a,m,void 0,!!l,(D,R)=>(y||(y=d.TernarySearchTree.forUris(()=>!o),y.set(a,!0),s&&y.fill(!0,s)),y.get(D.resource)||y.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&r?R===1:!1))}async toFileStat(a,u,n,o,s,r){const{providerExtUri:l}=this.getExtUri(a),m={resource:u,name:l.basename(u),isFile:(n.type&f.FileType.File)!=0,isDirectory:(n.type&f.FileType.Directory)!=0,isSymbolicLink:(n.type&f.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&f.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,f.etag)({mtime:n.mtime,size:n.size})};if(m.isDirectory&&r(m,o)){try{const y=await a.readdir(u),D=await L.Promises.settled(y.map(async([R,T])=>{try{const _=l.joinPath(u,R),j=s?await a.stat(_):{type:T};return await this.toFileStat(a,_,j,y.length,s,r)}catch(_){return this.logService.trace(_),null}}));m.children=(0,p.coalesce)(D)}catch(y){this.logService.trace(y),m.children=[]}return m}return m}async resolveAll(a){return L.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(n){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(n){return n}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new f.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=M.VSBuffer.fromString(""),n){await this.doValidateCreateFile(a,n);const o=await this.writeFile(a,u);return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,o)),o}async writeFile(a,u,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(o);try{await this.validateWriteFile(o,a,n)||await this.mkdirp(o,s.dirname(a));let l;if((0,f.hasReadWriteCapability)(o)&&!(u instanceof M.VSBuffer))if((0,w.isReadableStream)(u)){const m=await(0,w.peekStream)(u,3);m.ended?l=M.VSBuffer.concat(m.buffer):l=m}else l=(0,w.peekReadable)(u,m=>M.VSBuffer.concat(m),3);else l=u;!(0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o)&&l instanceof M.VSBuffer?await this.doWriteUnbuffered(o,a,n,l):await this.doWriteBuffered(o,a,n,l instanceof M.VSBuffer?(0,M.bufferToReadable)(l):l)}catch(r){throw new f.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),n)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,n){if(!!n?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let s;try{s=await a.stat(u)}catch(r){return}if((s.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,n);if(this.throwIfFileIsReadonly(u,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==f.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,f.etag)({mtime:n.mtime,size:s.size}))throw new f.FileOperationError((0,t.localize)(7,null),3,n);return s}async readFile(a,u){const n=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(n,a,u):this.doReadFile(n,a,u)}async doReadFileAtomic(a,u,n){return new Promise((o,s)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(a,u,n);o(r)}catch(r){s(r)}})})}async doReadFile(a,u,n){const o=await this.doReadFileStream(a,u,{...n,preferUnbuffered:!0});return{...o,value:await(0,M.streamToBuffer)(o.value)}}async readFileStream(a,u){const n=await this.withReadProvider(a);return this.doReadFileStream(n,a,u)}async doReadFileStream(a,u,n){const o=new k.CancellationTokenSource,s=this.validateReadFile(u,n).then(l=>l,l=>{throw o.cancel(),l});let r;try{return typeof n?.etag=="string"&&n.etag!==f.ETAG_DISABLED&&await s,!((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasFileReadStreamCapability)(a))||(0,f.hasReadWriteCapability)(a)&&n?.preferUnbuffered?r=this.readFileUnbuffered(a,u,n):(0,f.hasFileReadStreamCapability)(a)?r=this.readFileStreamed(a,u,o.token,n):r=this.readFileBuffered(a,u,o.token,n),{...await s,value:r}}catch(l){r&&await(0,w.consumeStream)(r);const m=(0,t.localize)(8,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(l).toString());throw l instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(m,l.stat,n):new f.FileOperationError(m,(0,f.toFileOperationResult)(l),n)}}readFileStreamed(a,u,n,o=Object.create(null)){const s=a.readFileStream(u,o,n);return(0,w.transform)(s,{data:r=>r instanceof M.VSBuffer?r:M.VSBuffer.wrap(r),error:r=>new f.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),o)},r=>M.VSBuffer.concat(r))}readFileBuffered(a,u,n,o=Object.create(null)){const s=(0,M.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,u,s,r=>r,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new f.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(r).toString()),(0,f.toFileOperationResult)(r),o)},n),s}readFileUnbuffered(a,u,n){const o=(0,w.newWriteableStream)(s=>M.VSBuffer.concat(s));return(async()=>{try{let s=await a.readFile(u);typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(u,s.byteLength,n),o.end(M.VSBuffer.wrap(s))}catch(s){o.error(s),o.end()}})(),o}async validateReadFile(a,u){const n=await this.resolve(a,{resolveMetadata:!0});if(n.isDirectory)throw new f.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==f.ETAG_DISABLED&&u.etag===n.etag)throw new f.NotModifiedSinceFileOperationError((0,t.localize)(12,null),n,u);return this.validateReadFileLimits(a,n.size,u),n}validateReadFileLimits(a,u,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&u>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&u>n.limits.size&&(o=7),typeof o=="number")throw new f.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),o)}}async canMove(a,u,n){return this.doCanMoveCopy(a,u,"move",n)}async canCopy(a,u,n){return this.doCanMoveCopy(a,u,"copy",n)}async doCanMoveCopy(a,u,n,o){if(a.toString()!==u.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,a,r,u,n,o)}catch(s){return s}return!0}async move(a,u,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(o,a,s,u,"move",!!n),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,r==="move"?2:3,l)),l}async copy(a,u,n){const o=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(o,a,s,u,"copy",!!n),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,r==="copy"?3:2,l)),l}async doMoveCopy(a,u,n,o,s,r){if(u.toString()===o.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(a,u,n,o,s,r);if(l&&!m&&r&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),s==="copy"){if(a===n&&(0,f.hasFileFolderCopyCapability)(a))await a.copy(u,o,{overwrite:r});else{const y=await this.resolve(u);y.isDirectory?await this.doCopyFolder(a,y,n,o):await this.doCopyFile(a,u,n,o)}return s}else return a===n?(await a.rename(u,o,{overwrite:r}),s):(await this.doMoveCopy(a,u,n,o,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,n,o){if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(a,u,n,o);if((0,f.hasOpenReadWriteCloseCapability)(a)&&(0,f.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(a,u,n,o);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(a,u,n,o);if((0,f.hasReadWriteCapability)(a)&&(0,f.hasReadWriteCapability)(n))return this.doPipeUnbuffered(a,u,n,o)}async doCopyFolder(a,u,n,o){await n.mkdir(o),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(n).providerExtUri.joinPath(o,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),n,r):this.doCopyFile(a,s.resource,n,r)}))}async doValidateMoveCopy(a,u,n,o,s,r){let l=!1;if(a===n){const{providerExtUri:y,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(l=y.isEqual(u,o)),l&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(o)));if(!l&&y.isEqualOrParent(o,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(o)))}const m=await this.exists(o);if(m&&!l){if(!r)throw new f.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(o)),4);if(a===n){const{providerExtUri:y}=this.getExtUri(a);if(y.isEqualOrParent(u,o))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(o)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const n=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(a,0,n)),n}async mkdirp(a,u){const n=[],{providerExtUri:o}=this.getExtUri(a);for(;!o.isEqual(u,o.dirname(u));)try{if(((await a.stat(u)).type&f.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(u)),u=o.dirname(u)}for(let s=n.length-1;s>=0;s--){u=o.joinPath(u,n[s]);try{await a.mkdir(u)}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(n){return n}return!0}async doValidateDelete(a,u){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(n.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let s;try{s=await n.stat(a)}catch(l){}if(s)this.throwIfFileIsReadonly(a,s);else throw new f.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const l=await this.resolve(a);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return n}async del(a,u){const n=await this.doValidateDelete(a,u),o=!!u?.useTrash,s=!!u?.recursive;await n.delete(a,{recursive:s,useTrash:o}),this._onDidRunOperation.fire(new f.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let n,o;{for(const s of a)this.watchedResources.has(s.resource)?(n||(n=[]),n.push(s)):(o||(o=[]),o.push(s));n&&this._onDidFilesChange.fire(new f.FileChangesEvent(n,!u))}if(o){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(o)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const n=new h.DisposableStore;let o=!1,s=()=>{o=!0};return n.add((0,h.toDisposable)(()=>s())),this.doWatch(a,u).then(r=>{o?(0,h.dispose)(r):s=()=>(0,h.dispose)(r)},r=>this.logService.error(r)),u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),n.add((0,h.toDisposable)(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),n}async doWatch(a,u){const n=await this.withProvider(a),o=this.toWatchKey(n,a,u);let s=this.activeWatchers.get(o);return s||(s={count:0,disposable:n.watch(a,u)},this.activeWatchers.set(o,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.activeWatchers.delete(o)))})}toWatchKey(a,u,n){const{providerExtUri:o}=this.getExtUri(a);return[o.getComparisonKey(u),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,h.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,n,o){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const s=await a.open(u,{create:!0,unlock:n?.unlock??!1});try{(0,w.isReadableStream)(o)||(0,w.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(a,s,o):await this.doWriteReadableBufferedQueued(a,s,o)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await a.close(s)}})}async doWriteStreamBufferedQueued(a,u,n){let o=0,s;if((0,w.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=M.VSBuffer.concat(n.buffer);await this.doWriteBuffer(a,u,r,r.byteLength,o,0),o+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,l)=>{(0,w.listenStream)(s,{onData:async m=>{s.pause();try{await this.doWriteBuffer(a,u,m,m.byteLength,o,0)}catch(y){return l(y)}o+=m.byteLength,setTimeout(()=>s.resume())},onError:m=>l(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(a,u,n){let o=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(a,u,s,s.byteLength,o,0),o+=s.byteLength}async doWriteBuffer(a,u,n,o,s,r){let l=0;for(;l<o;)l+=await a.write(u,s+l,n.buffer,r+l,o-l)}async doWriteUnbuffered(a,u,n,o){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,n,o))}async doWriteUnbufferedQueued(a,u,n,o){let s;o instanceof M.VSBuffer?s=o:(0,w.isReadableStream)(o)?s=await(0,M.streamToBuffer)(o):(0,w.isReadableBufferedStream)(o)?s=await(0,M.bufferedStreamToBuffer)(o):s=(0,M.readableToBuffer)(o),await a.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(a,u,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,n,o))}async doPipeBufferedQueued(a,u,n,o){let s,r;try{s=await a.open(u,{create:!1}),r=await n.open(o,{create:!0,unlock:!1});const l=M.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,y=0,D=0;do D=await a.read(s,m,l.buffer,y,l.byteLength-y),await this.doWriteBuffer(n,r,l,D,m,y),m+=D,y+=D,y===l.byteLength&&(y=0);while(D>0)}catch(l){throw(0,f.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(a,u,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,n,o))}async doPipeUnbufferedQueued(a,u,n,o){return n.writeFile(o,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,n,o))}async doPipeUnbufferedToBufferedQueued(a,u,n,o){const s=await n.open(o,{create:!0,unlock:!1});try{const r=await a.readFile(u);await this.doWriteBuffer(n,s,M.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(a,u,n,o){const s=await(0,M.streamToBuffer)(this.readFileBuffered(a,u,k.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,s)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new f.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===i.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=he([x(0,v.ILogService)],P),e.FileService=P}),define(Q[181],J([0,1,13,145,3,7,18,93,8,2,55,6,166,112]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends g.AbstractDiskFileSystemProviderChannel{constructor(v,P){super(v,P)}getUriTransformer(v){return w.DefaultURITransformer}transformIncoming(v,P){return k.URI.revive(P)}async delete(v,P,c){if(!c.useTrash)return super.delete(v,P,c);const a=this.transformIncoming(v,P),u=(0,h.normalize)(a.fsPath);try{await p.shell.trashItem(u)}catch(n){throw(0,I.createFileSystemProviderError)(M.isWindows?(0,L.localize)(0,null,(0,h.basename)(u)):(0,L.localize)(1,null,(0,h.basename)(u)),I.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(v,P){return new f(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class f extends d.Disposable{constructor(v,P){super();this.sessionEmitter=v,this.logService=P,this.watcherRequests=new Map}watch(v,P,c){if(c.recursive)throw(0,I.createFileSystemProviderError)("Recursive watcher is not supported from main process",I.FileSystemProviderErrorCode.Unavailable);const a=new d.DisposableStore;this.watcherRequests.set(v,a),a.add((0,d.toDisposable)(()=>this.watcherRequests.delete(v)));const u=a.add(new E.FileWatcher((0,h.normalize)(P.fsPath),n=>this.sessionEmitter.fire((0,i.toFileChanges)(n)),n=>this.onWatcherLogMessage(n),this.logService.getLevel()===S.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})),a}onWatcherLogMessage(v){v.type==="error"&&this.sessionEmitter.fire(v.message),this.logService[v.type](v.message)}dispose(){super.dispose(),this.watcherRequests.forEach(v=>(0,d.dispose)(v)),this.watcherRequests.clear()}}}),define(Q[94],J([0,1,29,246,9,17,4,33,8,3,15,60,20,146,18,92,93,171,172,179,45]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(p)}catch(n){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(n)}`)}})();class u extends c.AbstractDiskFileSystemProvider{constructor(o,s){super(o);this.options=s,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:s,symbolicLink:r}=await g.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(s,r),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(o){try{const s=await g.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),r=[];return await Promise.all(s.map(async l=>{try{let m;l.isSymbolicLink()?m=(await this.stat((0,i.joinPath)(o,l.name))).type:m=this.toType(l),r.push([l.name,m])}catch(m){this.logService.trace(m)}})),r}catch(s){throw this.toFileSystemProviderError(s)}}toType(o,s){let r;return s?.dangling?r=t.FileType.Unknown:o.isFile()?r=t.FileType.File:o.isDirectory()?r=t.FileType.Directory:r=t.FileType.Unknown,s&&(r|=t.FileType.SymbolicLink),r}async readFile(o){try{const s=this.toFilePath(o);return await g.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(o,s,r){const l=(0,S.newWriteableStream)(m=>k.VSBuffer.concat(m.map(y=>k.VSBuffer.wrap(y))).buffer);return(0,f.readFileIntoStream)(this,o,l,m=>m.buffer,{...s,bufferSize:256*1024},r),l}async writeFile(o,s,r){let l;try{const m=this.toFilePath(o);if(!r.create||!r.overwrite){if(await g.Promises.exists(m)){if(!r.overwrite)throw(0,t.createFileSystemProviderError)((0,w.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,t.createFileSystemProviderError)((0,w.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(o,{create:!0,unlock:r.unlock}),await this.write(l,0,s,0,s.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(o,m)}finally{typeof l=="number"&&await this.close(l)}}async open(o,s){try{const r=this.toFilePath(o);if((0,t.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:y}=await g.SymlinkSupport.stat(r);y.mode&128||await g.Promises.chmod(r,y.mode|128)}catch(y){this.logService.trace(y)}let l;if((0,t.isFileOpenForWriteOptions)(s)){if(d.isWindows)try{await g.Promises.truncate(r,0),l="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}l||(l="w")}else l="r";const m=await g.Promises.open(r,l);return this.mapHandleToPos.set(m,0),(0,t.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(m,o),m}catch(r){throw(0,t.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(o,r):this.toFileSystemProviderError(r)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await g.Promises.fdatasync(o)}catch(s){this.canFlush=!1,this.logService.error(s)}return await g.Promises.close(o)}catch(s){throw this.toFileSystemProviderError(s)}}async read(o,s,r,l,m){const y=this.normalizePos(o,s);let D=null;try{const R=await g.Promises.read(o,r,l,m,y);return typeof R=="number"?D=R:D=R.bytesRead,D}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(o,y,D)}}normalizePos(o,s){return s===this.mapHandleToPos.get(o)?null:s}updatePos(o,s,r){const l=this.mapHandleToPos.get(o);typeof l=="number"&&(typeof s=="number"||(typeof r=="number"?this.mapHandleToPos.set(o,l+r):this.mapHandleToPos.delete(o)))}async write(o,s,r,l,m){return(0,M.retry)(()=>this.doWrite(o,s,r,l,m),100,3)}async doWrite(o,s,r,l,m){const y=this.normalizePos(o,s);let D=null;try{const R=await g.Promises.write(o,r,l,m,y);return typeof R=="number"?D=R:D=R.bytesWritten,D}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),R)}finally{this.updatePos(o,y,D)}}async mkdir(o){try{await g.Promises.mkdir(this.toFilePath(o))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(o,s){try{const r=this.toFilePath(o);await this.doDelete(r,s)}catch(r){throw this.toFileSystemProviderError(r)}}async doDelete(o,s){s.recursive?await g.Promises.rm(o,g.RimRafMode.MOVE):await g.Promises.unlink(o)}async rename(o,s,r){const l=this.toFilePath(o),m=this.toFilePath(s);if(l!==m)try{await this.validateTargetDeleted(o,s,"move",r.overwrite),await g.Promises.move(l,m)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(2,null,(0,h.basename)(l),(0,h.basename)((0,h.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(o,s,r){const l=this.toFilePath(o),m=this.toFilePath(s);if(l!==m)try{await this.validateTargetDeleted(o,s,"copy",r.overwrite),await g.Promises.copy(l,m,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(3,null,(0,h.basename)(l),(0,h.basename)((0,h.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(o,s,r,l){const m=this.toFilePath(o),y=this.toFilePath(s);let D=!1;if(!!(this.capabilities&1024)||(D=(0,E.isEqual)(m,y,!0)),D&&r==="copy")throw(0,t.createFileSystemProviderError)((0,w.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!D&&await g.Promises.exists(y)){if(!l)throw(0,t.createFileSystemProviderError)((0,w.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(o,s,r,l){let m,y=!1;return this.options?.watcher?.usePolling?y=!1:y=this.options?.legacyWatcher==="on",y?m=v.FileWatcher:m=P.FileWatcher,new m(D=>s(D),D=>r(D),l,this.options?.watcher)}doWatch(o,s){const r=this.options?.watcher?.usePolling;if(r===!0)for(const l of s)l.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const l of s)r.includes(l.path)&&(l.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(o,s)}createNonRecursiveWatcher(o,s,r,l){return new b.FileWatcher(o,m=>s(m),m=>r(m),l)}toFileSystemProviderError(o){if(o instanceof t.FileSystemProviderError)return o;let s;switch(o.code){case"ENOENT":s=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=t.FileSystemProviderErrorCode.NoPermissions;break;default:s=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(o,s)}async toFileSystemProviderWriteError(o,s){let r=this.toFileSystemProviderError(s);if(o&&r.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await g.SymlinkSupport.stat(this.toFilePath(o));l.mode&128||(r=(0,t.createFileSystemProviderError)(s,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}e.DiskFileSystemProvider=u}),define(Q[95],J([0,1,6]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(k,I){switch(I){case p.LogLevel.Trace:return k.trace;case p.LogLevel.Debug:return k.debug;case p.LogLevel.Info:return k.info;case p.LogLevel.Warning:return k.warn;case p.LogLevel.Error:return k.error;case p.LogLevel.Critical:return k.critical;default:throw new Error("Invalid log level")}}class M extends p.AbstractLogger{constructor(I=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}set logger(I){this._logger=I;for(const{level:E,args:h}of this.buffer)L(I,E).apply(I,h);this.buffer=[]}_log(I,...E){this._logger?L(this._logger,I).apply(this._logger,E):this.getLevel()<=I&&this.buffer.push({level:I,args:E})}trace(I,...E){this._log(p.LogLevel.Trace,I,...E)}debug(I,...E){this._log(p.LogLevel.Debug,I,...E)}info(I,...E){this._log(p.LogLevel.Info,I,...E)}warn(I,...E){this._log(p.LogLevel.Warning,I,...E)}error(I,...E){this._log(p.LogLevel.Error,I,...E)}critical(I,...E){this._log(p.LogLevel.Critical,I,...E)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Q[182],J([0,1,9,17,15,18,5,95,6]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const d=5*k.ByteSize.MB;let i=class extends h.AbstractLogger{constructor(w,t,f,b,v){super();this.name=w,this.resource=t,this.donotUseFormatters=b,this.fileService=v,this.backupIndex=1,this.setLevel(f),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=w.stack,this._log(h.LogLevel.Error,this.format(t))}else this._log(h.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,this.format(arguments))}flush(){}log(w,t){this._log(w,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,t){this.queue.queue(async()=>{await this.initializePromise;let f=await this.loadContent();f.length>d&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(f)),f=""),this.donotUseFormatters?f+=t:f+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${t}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(f))})}getCurrentTimestamp(){const w=b=>b<10?`0${b}`:b,t=b=>b<10?`00${b}`:b<100?`0${b}`:b,f=new Date;return`${f.getFullYear()}-${w(f.getMonth()+1)}-${w(f.getDate())} ${w(f.getHours())}:${w(f.getMinutes())}:${w(f.getSeconds())}.${t(f.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(w){return""}}stringifyLogLevel(w){switch(w){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}format(w){let t="";for(let f=0;f<w.length;f++){let b=w[f];if(typeof b=="object")try{b=JSON.stringify(b)}catch(v){}t+=(f>0?" ":"")+b}return t}};i=he([x(4,k.IFileService)],i),e.FileLogger=i;let S=class extends h.AbstractLoggerService{constructor(w,t,f){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=t,this.fileService=f}doCreateLogger(w,t,f){const b=new E.BufferLogService(t);return(0,k.whenProviderRegistered)(w,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(i,(0,M.basename)(w),w,b.getLevel(),!!f?.donotUseFormatters)),b}};S=he([x(0,h.ILogService),x(1,I.IInstantiationService),x(2,k.IFileService)],S),e.FileLoggerService=S}),define(Q[183],J([0,1,4,7,6]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(g){this.service=g,this.onDidChangeLogLevel=p.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(g,w,t){switch(w){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=k;class I{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){I.setLevel(this.channel,g)}static setLevel(g,w){return g.call("setLevel",w)}}e.LogLevelChannelClient=I;class E{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,w){throw new Error(`Event not found: ${w}`)}async call(g,w,t){switch(w){case"createLogger":this.createLogger(L.URI.revive(t[0]),t[1]);return;case"log":return this.log(L.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${w}`)}createLogger(g,w){this.loggers.set(g.toString(),this.loggerService.createLogger(g,w))}consoleLog(g,w){let t=console.log;switch(g){case M.LogLevel.Error:t=console.error;break;case M.LogLevel.Warning:t=console.warn;break;case M.LogLevel.Info:t=console.info;break}t.call(console,...w)}log(g,w){const t=this.loggers.get(g.toString());if(!t)throw new Error("Create the logger before logging");for(const[f,b]of w)switch(f){case M.LogLevel.Trace:t.trace(b);break;case M.LogLevel.Debug:t.debug(b);break;case M.LogLevel.Info:t.info(b);break;case M.LogLevel.Warning:t.warn(b);break;case M.LogLevel.Error:t.error(b);break;case M.LogLevel.Critical:t.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=E;class h extends M.AbstractLoggerService{constructor(g,w,t){super(g,w);this.channel=t}createConsoleMainLogger(){return new M.AdapterLogger({log:(g,w)=>{this.channel.call("consoleLog",[g,w])}})}doCreateLogger(g,w,t){return new d(this.channel,g,w,t)}}e.LoggerChannelClient=h;class d extends M.AbstractMessageLogger{constructor(g,w,t,f){super(f?.always);this.channel=g,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[w,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,w){const t=[[g,w]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(g){this.channel.call("log",[this.file,g])}}class i extends M.LogService{constructor(g,w){super(w);this.parent=g,this._register(g.onDidChangeLogLevel(t=>w.setLevel(t)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=i}),define(Q[96],J([0,1,18,6]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function M(h,d,i,S){try{const g=await new Promise((w,t)=>{H(["spdlog"],w,t)});return g.setFlushOn(L.LogLevel.Trace),g.createAsyncRotatingLogger(h,d,i,S)}catch(g){console.error(g)}return null}function k(h,d,i,S){const g=H.__$__nodeRequire("spdlog");return g.setFlushOn(L.LogLevel.Trace),g.createRotatingLogger(h,d,i,S)}e.createRotatingLogger=k;function I(h,d,i){switch(d){case L.LogLevel.Trace:h.trace(i);break;case L.LogLevel.Debug:h.debug(i);break;case L.LogLevel.Info:h.info(i);break;case L.LogLevel.Warning:h.warn(i);break;case L.LogLevel.Error:h.error(i);break;case L.LogLevel.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}class E extends L.AbstractMessageLogger{constructor(d,i,S,g){super();this.name=d,this.filepath=i,this.rotating=S,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const d=this.rotating?6:1,i=30/d*p.ByteSize.MB;return M(this.name,this.filepath,i,d).then(S=>{if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:g,message:w}of this.buffer)I(this._logger,g,w);this.buffer=[]}})}log(d,i){this._logger?I(this._logger,d,i):this.getLevel()<=d&&this.buffer.push({level:d,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(Q[184],J([0,1,10,15,28,18,182,6,96]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let d=class extends E.AbstractLoggerService{constructor(S,g){super(S.getLevel(),S.onDidChangeLogLevel);this.fileService=g}doCreateLogger(S,g,w){if(S.scheme===p.Schemas.file){const t=new h.SpdLogLogger(w?.name||(0,M.generateUuid)(),S.fsPath,!w?.donotRotate,g);return w?.donotUseFormatters&&t.clearFormatters(),t}else return new I.FileLogger(w?.name??(0,L.basename)(S),S,g,!!w?.donotUseFormatters,this.fileService)}};d=he([x(0,E.ILogService),x(1,k.IFileService)],d),e.LoggerService=d}),define(Q[185],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function M(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function k(I){return!p(I)&&!L(I)&&!M(I)}e.isMenubarMenuItemAction=k}),define(Q[56],J([0,1,10,3,32,15]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const E=L.globals.vscode.context.configuration();if(E)I=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof H?.__$__nodeRequire=="function"){const E=(0,k.dirname)(p.FileAccess.asFileUri("",H));I=H.__$__nodeRequire((0,k.joinPath)(E,"product.json").fsPath);const h=H.__$__nodeRequire((0,k.joinPath)(E,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:h.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(Q[21],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Q[186],J([0,1,61,6,21]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let k=class{constructor(E,h){this.productService=E,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(h);if(!d)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,i,S]=d;let g=this.trustedExtensionUrlPublicKeys.get(E);if(!g){if(g=this.productService.trustedExtensionUrlPublicKeys[E],!g||g.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...g])}const w=Buffer.from(decodeURIComponent(S),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=w.slice(0,6),f=w.readUIntBE(0,6),b=Date.now()-f;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const v=w.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(i)),P.end();for(let c=0;c<g.length;c++){let a=g[c];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),g[c]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${E}:`,u),g[c]=null;continue}if(P.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};k=he([x(0,M.IProductService),x(1,L.ILogService)],k),e.ExtensionUrlTrustService=k}),define(Q[57],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Q[187],J([0,1,13,2,40,10,3,15,7,28,48,6]),function(H,e,p,L,M,k,I,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let g=class extends L.Disposable{constructor(t,f){super();this.logService=f,this.validRoots=M.TernarySearchTree.forUris(()=>!I.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(f,b)=>this.handleResourceRequest(f,b)),t.protocol.interceptFileProtocol(k.Schemas.file,(f,b)=>this.handleFileRequest(f,b)),this._register((0,L.toDisposable)(()=>{t.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?L.Disposable.None:(this.validRoots.set(t,!0),(0,L.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,f){const b=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${k.Schemas.file}: protocol (original URL: ${t.url})`),f({error:-3})}handleResourceRequest(t,f){const b=h.URI.parse(t.url),v=k.FileAccess.asFileUri(b);return this.validRoots.findSubstr(v)?f({path:v.fsPath}):this.validExtensions.has((0,E.extname)(v))?f({path:v.fsPath}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),f({error:-3}))}createIPCObjectUrl(){let t;const f=h.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),b=f.toString(),v=async()=>t;return p.ipcMain.handle(b,v),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:f,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),p.ipcMain.removeHandler(b)}}}};g=he([x(0,i.INativeEnvironmentService),x(1,S.ILogService)],g),e.ProtocolMainService=g}),define(Q[37],J([0,1,104,14]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(I,E){p.ok(L.isString(I)),p.ok(L.isObject(E)),p.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,E)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new M}),define(Q[188],J([0,1,4,37]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class k{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,d){this.schemasById[M(h)]=d,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new k;L.Registry.add(e.Extensions.JSONContribution,I)}),define(Q[49],J([0,1,31,4,14,134,188,37]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var d;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=E.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const u=this.doRegisterConfigurations(c,a);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:c,remove:a}){const u=[];u.push(...this.doDeregisterConfigurations(a)),u.push(...this.doRegisterConfigurations(c,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(u))}registerDefaultConfigurations(c){const a=[],u=[];for(const n of c)for(const o in n)if(a.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]={...this.defaultValues[o]||{},...n[o]};const s={type:"object",default:this.defaultValues[o],description:k.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};u.push(w(o)),this.configurationProperties[o]=s,this.defaultLanguageConfigurationOverridesNode.properties[o]=s}else{this.defaultValues[o]=n[o];const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(c){const a=[];for(const u of c)for(const n in u)if(a.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const u=[];return c.forEach(n=>{u.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),u}doDeregisterConfigurations(c){const a=[],u=n=>{if(n.properties)for(const o in n.properties)a.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>u(o))};for(const n of c){u(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return a}validateAndRegisterProperties(c,a=!0,u,n=3){n=M.isUndefinedOrNull(c.scope)?n:c.scope;let o=[],s=c.properties;if(s)for(let l in s){if(a&&b(l)){delete s[l];continue}const m=s[l];if(this.updatePropertyDefaultValue(l,m),e.OVERRIDE_PROPERTY_PATTERN.test(l)?m.scope=void 0:(m.scope=M.isUndefinedOrNull(m.scope)?n:m.scope,m.restricted=M.isUndefinedOrNull(m.restricted)?!!u?.restrictedConfigurations?.includes(l):m.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),o.push(l)}let r=c.allOf;if(r)for(let l of r)o.push(...this.validateAndRegisterProperties(l,a,u,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const a=u=>{let n=u.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let o=u.allOf;o&&o.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,u={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,u),e.allSettings.properties[a]=u,e.applicationSettings.properties[a]=u,e.machineSettings.properties[a]=u,e.machineOverridableSettings.properties[a]=u,e.windowSettings.properties[a]=u,e.resourceSettings.properties[a]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){let u=this.defaultValues[c];M.isUndefined(u)&&(u=a.default),M.isUndefined(u)&&(u=t(a.type)),a.default=u}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function w(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=w;function t(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const f=new S;E.Registry.add(e.Extensions.Configuration,f);function b(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?k.localize(5,null,P):f.getConfigurationProperties()[P]!==void 0?k.localize(6,null,P):null:k.localize(4,null)}e.validateProperty=b;function v(){const P=[],c=f.getConfigurationProperties();for(const a of Object.keys(c))P.push([a,c[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=v}),define(Q[19],J([0,1,43,14,7,49,5,37]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function h(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof M.URI)}e.isConfigurationOverrides=h;var d;(function(o){o[o.USER=1]="USER",o[o.USER_LOCAL=2]="USER_LOCAL",o[o.USER_REMOTE=3]="USER_REMOTE",o[o.WORKSPACE=4]="WORKSPACE",o[o.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",o[o.DEFAULT=6]="DEFAULT",o[o.MEMORY=7]="MEMORY"})(d=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(o){switch(o){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function S(o,s){const r=s?o?s.keys.filter(_=>o.keys.indexOf(_)===-1):[...s.keys]:[],l=o?s?o.keys.filter(_=>s.keys.indexOf(_)===-1):[...o.keys]:[],m=[];if(s&&o){for(const _ of o.keys)if(s.keys.indexOf(_)!==-1){const j=v(o.contents,_),te=v(s.contents,_);p.equals(j,te)||m.push(_)}}const y=[],D=_=>{const j={};for(const te of _)for(const se of te.identifiers)j[u(se)]=te;return j},R=s?D(s.overrides):{},T=o?D(o.overrides):{};if(Object.keys(R).length)for(const _ of r){const j=R[_];j&&y.push([(0,k.overrideIdentifierFromKey)(_),j.keys])}if(Object.keys(T).length)for(const _ of l){const j=T[_];j&&y.push([(0,k.overrideIdentifierFromKey)(_),j.keys])}if(Object.keys(R).length&&Object.keys(T).length)for(const _ of m){const j=T[_],te=R[_];if(j&&te){const se=S({contents:j.contents,keys:j.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});y.push([(0,k.overrideIdentifierFromKey)(_),[...se.added,...se.removed,...se.updated]])}}return{added:r,removed:l,updated:m,overrides:y}}e.compare=S;function g(o,s){const r=[];for(const l of Object.keys(o))if(k.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const y in o[l])m[y]=o[l][y];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:w(m,s)})}return r}e.toOverrides=g;function w(o,s){const r=Object.create(null);for(let l in o)t(r,l,o[l],s);return r}e.toValuesTree=w;function t(o,s,r,l){const m=s.split("."),y=m.pop();let D=o;for(let R=0;R<m.length;R++){let T=m[R],_=D[T];switch(typeof _){case"undefined":_=D[T]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(_)}`);return}D=_}if(typeof D=="object"&&D!==null)try{D[y]=r}catch(R){l(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${s} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=t;function f(o,s){const r=s.split(".");b(o,r)}e.removeFromValueTree=f;function b(o,s){const r=s.shift();if(s.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const l=o[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,s),Object.keys(l).length===0&&delete o[r])}}function v(o,s,r){function l(D,R){let T=D;for(const _ of R){if(typeof T!="object"||T===null)return;T=T[_]}return T}const m=s.split("."),y=l(o,m);return typeof y=="undefined"?r:y}e.getConfigurationValue=v;function P(o,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in o?L.isObject(o[l])&&L.isObject(s[l])?P(o[l],s[l],r):r&&(o[l]=s[l]):o[l]=s[l])})}e.merge=P;function c(){const o=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o)}e.getConfigurationKeys=c;function a(){const o=Object.create(null),s=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;t(o,r,l,m=>console.error(`Conflict in default settings: ${m}`))}return o}e.getDefaultValues=a;function u(o){return`[${o}]`}e.keyFromOverrideIdentifier=u;function n(o,s,r){const l=o.inspect(s),m=o.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=n}),define(Q[189],J([0,1,31,4,39,2,40,43,14,7,19,49,37]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(n={},o=[],s=[]){this._contents=n,this._keys=o,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,o){const s=this.getContentsForOverrideIdentifer(o);return s?n?(0,i.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){for(const o of this.overrides)if(o.identifiers.indexOf(n)!==-1)return o.keys;return[]}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=E.deepClone(this.contents),s=E.deepClone(this.overrides),r=[...this.keys];for(const l of n){this.mergeContents(o,l.contents);for(const m of l.overrides){const[y]=s.filter(D=>p.equals(D.identifiers,m.identifiers));y?this.mergeContents(y.contents,m.contents):s.push(E.deepClone(m))}for(const m of l.keys)r.indexOf(m)===-1&&r.push(m)}return new w(o,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let s={};for(const r of p.distinct([...Object.keys(this.contents),...Object.keys(o)])){let l=this.contents[r],m=o[r];m&&(typeof l=="object"&&typeof m=="object"?(l=E.deepClone(l),this.mergeContents(l,m)):l=m),s[r]=l}return new w(s,this.keys,this.overrides)}mergeContents(n,o){for(const s of Object.keys(o)){if(s in n&&h.isObject(n[s])&&h.isObject(o[s])){this.mergeContents(n[s],o[s]);continue}n[s]=E.deepClone(o[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?E.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const o of this.overrides)if(o.identifiers.indexOf(n)!==-1)return o.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,i.addToValueTree)(this.contents,n,o,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let s=0;s<o;s++)n.indexOf(this.keys[s])===0&&(o=s);this.keys.splice(o,1,n)}removeKey(n){let o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=w;class t extends w{constructor(){const n=(0,i.getDefaultValues)(),o=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(n))S.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(n[r]),contents:(0,i.toValuesTree)(n[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(n,o,s)}}e.DefaultConfigurationModel=t;class f{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!h.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:s,keys:r,overrides:l,restricted:m}=this.doParseRaw(n,o);this._configurationModel=new w(s,r,l),this._restrictedConfigurations=m||[]}doParseContent(n){let o={},s=null,r=[],l=[],m=[];function y(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let D={onObjectBegin:()=>{let R={};y(R),l.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let R=[];y(R),l.push(r),r=R,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(R,T,_)=>{m.push({error:R,offset:T,length:_})}};if(n)try{M.visit(n,D),o=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return o}doParseRaw(n,o){const s=g.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,s,!0,o);n=r.raw;const l=(0,i.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(n),y=(0,i.toOverrides)(n,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:m,overrides:y,restricted:r.restricted}}filter(n,o,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const l={},m=[];for(let y in n)if(S.OVERRIDE_PROPERTY_PATTERN.test(y)&&s){const D=this.filter(n[y],o,!1,r);l[y]=D.raw,m.push(...D.restricted)}else{const D=o[y],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(y),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&D?.restricted||(l[y]=n[y]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=f;class b extends k.Disposable{constructor(n,o,s,r){super();this.userSettingsResource=n,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class v{constructor(n,o,s=new w,r=new w,l=new I.ResourceMap,m=new w,y=new I.ResourceMap,D=!0){this._defaultConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=y,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(n,o,s){return this.getConsolidateConfigurationModel(o,s).getValue(n)}updateValue(n,o,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new w,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(n):r.setValue(n,o),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,s){const r=this.getConsolidateConfigurationModel(o,s),l=this.getFolderConfigurationModelForResource(o.resource,s),m=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,y=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),D=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),T=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),_=s?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,j=l?o.overrideIdentifier?l.freeze().override(o.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,te=o.overrideIdentifier?m.override(o.overrideIdentifier).getValue(n):m.getValue(n),se=r.getValue(n),oe=p.distinct(p.flatten(r.overrides.map(G=>G.identifiers))).filter(G=>r.getOverrideValue(n,G)!==void 0);return{defaultValue:y,userValue:D,userLocalValue:R,userRemoteValue:T,workspaceValue:_,workspaceFolderValue:j,memoryValue:te,value:se,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:l?.freeze().getValue(n),override:o.overrideIdentifier?l?.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:m.getValue(n),override:o.overrideIdentifier?m.getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const s=o.filter(r=>S.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,S.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),y=n.getKeysForOverrideIdentifier(l),D=[...y.filter(R=>m.indexOf(R)===-1),...m.filter(R=>y.indexOf(R)===-1),...m.filter(R=>!E.equals(this._defaultConfiguration.override(l).getValue(R),n.override(l).getValue(R)))];return[l,D]});return this.updateDefaultConfiguration(n),{keys:o,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:s,removed:r,overrides:l}=(0,i.compare)(this.localUserConfiguration,n),m=[...o,...s,...r];return m.length&&this.updateLocalUserConfiguration(n),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:s,removed:r,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,n);let m=[...o,...s,...r];return m.length&&this.updateRemoteUserConfiguration(n),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:s,removed:r,overrides:l}=(0,i.compare)(this.workspaceConfiguration,n);let m=[...o,...s,...r];return m.length&&this.updateWorkspaceConfiguration(n),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(n,o){const s=this.folderConfigurations.get(n),{added:r,updated:l,removed:m,overrides:y}=(0,i.compare)(s,o);let D=[...r,...l,...m];return(D.length||!s)&&this.updateFolderConfiguration(n,o),{keys:D,overrides:y}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:l,overrides:m}=(0,i.compare)(o,void 0);return{keys:[...s,...r,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,o){let s=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},o){let s=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const r=o.getFolder(n);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(o=s.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=s}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const s=o.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(o);return n.push([o,{contents:s,overrides:r,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>o.add(r))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),r=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((m,y)=>(m.set(d.URI.revive(y[0]),this.parseConfigurationModel(y[1])),m),new I.ResourceMap);return new v(o,s,new w,r,l,new w,new I.ResourceMap,!1)}static parseConfigurationModel(n){return new w(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const n=new Set,o=new Map;for(const r of u)r.keys.forEach(l=>n.add(l)),r.overrides.forEach(([l,m])=>{const y=(0,I.getOrSet)(o,l,new Set);m.forEach(D=>y.add(D))});const s=[];return o.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=P;class c{constructor(n,o,s,r){this.change=n,this.previous=o,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(y=>l.add(y)),n.overrides.forEach(([,y])=>y.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const m=new w;this.affectedKeys.forEach(y=>m.setValue(y,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!E.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let s=(0,i.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(n=n[r],!n)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(n,o,s,r){super({keys:n.allKeys(),overrides:[]},void 0,n,o);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=a}),define(Q[190],J([0,1,9,4,2,15,19,189,49,37]),function(H,e,p,L,M,k,I,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends M.Disposable{constructor(g,w){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,w)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,w){const t=typeof g=="string"?g:void 0,f=(0,I.isConfigurationOverrides)(g)?g:(0,I.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(t,f,void 0)}updateValue(g,w,t,f){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(t,w,1)}onDidDefaultConfigurationChange(g){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,g);this.trigger(t,w,6)}trigger(g,w,t){const f=new E.ConfigurationChangeEvent(g,{data:w},this.configuration);f.source=t,f.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Q[191],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(I,E=L.Unknown,h){super(I);this._message=I,this._code=E,this._detail=h,this.isHandled=E===L.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(I){return I instanceof M&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof M&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof M&&I.isHandled}}e.RemoteAuthorityResolverError=M}),define(Q[192],J([0,1,9,17,23,16,4,2,28,84,191]),function(H,e,p,L,M,k,I,E,h,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var g;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function w(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const A=new M.CancellationTokenSource;return setTimeout(()=>A.cancel(),W),A.token}function f(W,A){if(W.isCancellationRequested||A.isCancellationRequested)return M.CancellationToken.Cancelled;const O=new M.CancellationTokenSource;return W.onCancellationRequested(()=>O.cancel()),A.onCancellationRequested(()=>O.cancel()),O.token}class b{constructor(A){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((O,q)=>{this._resolvePromise=O,this._rejectPromise=q}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function v(W,A){const O=new b(A);return O.registerDisposable(W.onControlMessage(q=>{const X=JSON.parse(q.toString()),$=V(X);$?O.reject($):O.resolve(X)})),O.promise}function P(W,A,O,q,X,$){const z=new b($);return A.connect(O,q,X,(Z,ee)=>{z.didTimeout?(Z&&W.error(Z),ee?.dispose()):Z||!ee?z.reject(Z):z.resolve(ee)}),z.promise}function c(W,A){const O=new b(A);return W.then(q=>{O.didTimeout||O.resolve(q)},q=>{O.didTimeout||O.reject(q)}),O.promise}async function a(W,A,O,q){const X=U(W,A);W.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let $;try{$=await P(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,q)}catch(re){throw W.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),W.logService.error(re),re}W.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let z,Z;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection($,null),z=W.reconnectionProtocol,Z=!1):(z=new d.PersistentProtocol($,null),Z=!0),W.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const ee=await c(W.signService.createNewMessage((0,h.generateUuid)()),q),le={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(L.VSBuffer.fromString(JSON.stringify(le)));try{const re=await v(z,f(q,t(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(W.logService.trace(`${X} 4/6. received SignRequest control message.`),!await c(W.signService.validate(ee,re.signedData),q)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const ae=await c(W.signService.sign(re.data),q),ue={type:"connectionType",commit:W.commit,signedData:ae,desiredConnectionType:A};return O&&(ue.args=O),W.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(L.VSBuffer.fromString(JSON.stringify(ue))),{protocol:z,ownsProtocol:Z}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(W.logService.error(`${X} the handshake timed out. Error:`),W.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${X} received error control message when negotiating connection. Error:`),W.logService.error(re)),Z&&B(z),re}}async function u(W,A,O,q){const X=Date.now(),$=U(W,A),{protocol:z,ownsProtocol:Z}=await a(W,A,O,q),ee=new b(q);return ee.registerDisposable(z.onControlMessage(le=>{const re=JSON.parse(le.toString()),ie=V(re);ie?(W.logService.error(`${$} received error control message when negotiating connection. Error:`),W.logService.error(ie),Z&&B(z),ee.reject(ie)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${Y(X)}!`),ee.resolve({protocol:z,firstMessage:re}))})),ee.promise}async function n(W,A){const{protocol:O}=await u(W,1,void 0,A);return{protocol:O}}async function o(W,A,O){const{protocol:q,firstMessage:X}=await u(W,2,A,O),$=X&&X.debugPort;return{protocol:q,debugPort:$}}async function s(W,A,O){const q=Date.now(),X=U(W,3),{protocol:$}=await a(W,3,A,O);return W.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),$}async function r(W,A,O){const{host:q,port:X,connectionToken:$}=await W.addressProvider.getAddress();return{commit:W.commit,host:q,port:X,connectionToken:$,reconnectionToken:A,reconnectionProtocol:O,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function l(W,A,O){try{const q=(0,h.generateUuid)(),X=await r(W,q,null),{protocol:$}=await n(X,M.CancellationToken.None);return new G(W,A,O,q,$)}catch(q){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(q),oe.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=l;async function m(W,A){try{const O=(0,h.generateUuid)(),q=await r(W,O,null),{protocol:X,debugPort:$}=await o(q,A,M.CancellationToken.None);return new F(W,A,O,X,$)}catch(O){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(O),oe.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=m;async function y(W,A,O){const q=await r(W,(0,h.generateUuid)(),null);return await s(q,{host:A,port:O},M.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function D(W){return(0,p.createCancelablePromise)(A=>new Promise((O,q)=>{const X=setTimeout(O,W*1e3);A.onCancellationRequested(()=>{clearTimeout(X),O()})}))}var R;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(A,O){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=T;class _{constructor(A,O,q,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.durationSeconds=q,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class j{constructor(A,O,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=j;class te{constructor(A,O,q){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=q,this.type=4}}e.ConnectionGainEvent=te;class se{constructor(A,O,q,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=q,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class oe extends E.Disposable{constructor(A,O,q,X){super();this._connectionType=A,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=q,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(X.onSocketClose($=>{const z=N(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const $=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${$} received socket timeout event.`),this._beginReconnecting()})),oe._instances.push(this),oe._permanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}static triggerPermanentFailure(A,O,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=O,this._permanentFailureHandled=q,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(oe._permanentFailure)return;const A=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const X=q<O.length?O[q]:O[O.length-1];try{if(X>0){const z=D(X);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,z)),this._options.logService.info(`${A} waiting for ${X} seconds before reconnecting...`);try{await z}catch{}}if(oe._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${A} resolving connection...`);const $=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${$.host}:${$.port}...`),await this._reconnect($,t(S)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,k.isPromiseCanceledError)($)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,i.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!oe._permanentFailure)}_gotoPermanentFailure(A,O,q){this._onDidStateChange.fire(new se(this.reconnectionToken,A,O,q)),B(this.protocol)}}oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class G extends oe{constructor(A,O,q,X,$){super(1,A,X,$);this.client=this._register(new d.Client($,{remoteAuthority:O,clientId:q},A.ipcLogger))}async _reconnect(A,O){await n(A,O)}}e.ManagementPersistentConnection=G;class F extends oe{constructor(A,O,q,X,$){super(2,A,q,X);this._startArguments=O,this.debugPort=$}async _reconnect(A,O){await o(A,this._startArguments,O)}}e.ExtensionHostPersistentConnection=F;function B(W){try{W.acceptDisconnect();const A=W.getSocket();W.dispose(),A.dispose()}catch(A){(0,k.onUnexpectedError)(A)}}function V(W){if(W&&W.type==="error"){const A=new Error(`Connection error: ${W.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function C(W,A){for(;W.length<A;)W+=" ";return W}function N(W,A,O){return`[remote-connection][${C(w(W),13)}][${A.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function U(W,A){return`${N(A,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function Y(W){return`${Date.now()-W} ms`}}),define(Q[64],J([0,1,10]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(d){return d.scheme===p.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=L;function M(d){if(!d)return;const i=d.indexOf("+");return i<0?d:d.substr(0,i)}e.getRemoteName=M;function k(d){return d.scheme!==p.Schemas.file&&d.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=k;function I(d){if(d.folders.length)return d.folders.every(i=>k(i.uri))?d.folders[0].uri:void 0;if(d.configuration&&k(d.configuration))return d.configuration}e.getVirtualWorkspaceLocation=I;function E(d){return I(d)?.scheme}e.getVirtualWorkspaceScheme=E;function h(d){return I(d)!==void 0}e.isVirtualWorkspace=h}),define(Q[193],J([0,1,27,5,64]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=k;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,t){if(typeof w=="undefined"||w===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof w=="string"||typeof t=="string"){let f=typeof w=="string"?w:w.value,b=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(f,b)}return w._lower===t._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=h;function d(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=d;function i(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function S(g,w){if(w&&g.enableProposedApi){const t=`onResolveRemoteAuthority:${(0,M.getRemoteName)(w)}`;return g.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[194],J([0,1,27,193]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(t,f){return t.uuid&&f.uuid?t.uuid===f.uuid:t.id===f.id?!0:(0,p.compareIgnoreCase)(t.id,f.id)===0}e.areSameExtensions=M;class k{constructor(f,b){this.version=b,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof k?M(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=k;function I(t,f){return`${t}.${f}`}e.getExtensionId=I;function E(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function h(t,f){return E(I(t,f))}e.getGalleryExtensionId=h;function d(t,f){const b=[],v=P=>{for(const c of b)if(c.some(a=>M(f(a),f(P))))return c;return null};for(const P of t){const c=v(P);c?c.push(P):b.push([P])}return b}e.groupByExtension=d;function i(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function S(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function g(t){const f=new Set;for(const b of t)b.malicious&&f.add(b.id.id);return f}e.getMaliciousExtensionsSet=g;function w(t,f){const b=[],v=f.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const P=v.shift();if(P&&b.every(c=>!M(c.identifier,{id:P}))){const c=t.filter(a=>M(a.identifier,{id:P}));c.length===1&&(b.push(c[0]),v.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=w}),define(Q[97],J([0,1,4,3,5,6]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,M.createDecorator)("sharedTunnelsService");var I;(function(t){t.Http="http",t.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=S;function g(t,f){return f?f!==1&&t<1024:!L.isWindows&&t<1024}e.isPortPrivileged=g;let w=class{constructor(f){this.logService=f,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(f,b){return this._tunnelProvider=f,f?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],b=Array.from(this._tunnels.values());for(let v of b){const P=Array.from(v.values());for(let c of P){const a=await c.value;a&&f.push(a)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:b}of f.values())await b.then(v=>v?.dispose());f.clear()}this._tunnels.clear()}openTunnel(f,b,v,P,c=!1,a=E.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${v} on local port ${P}.`),!f)return;b||(b="localhost");const n=this.retainOrCreateTunnel(f,b,v,P,c,a,u);return n?n.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(o);return(o.tunnelRemoteHost!==b||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const b=this._tunnels.get(f.tunnelRemoteHost);if(b){const v=b.get(f.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,v))}}}}async tryDisposeTunnel(f,b,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${b}.`);const P=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(b),P}}async closeTunnel(f,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${b} `);const v=this._tunnels.get(f);if(v&&v.has(b)){const P=v.get(b);P.refcount=0,await this.tryDisposeTunnel(f,b,P)}}addTunnelToMap(f,b,v){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(b,{refcount:1,value:v})}async removeEmptyTunnelFromMap(f,b){const v=this._tunnels.get(f);v&&(await v.get(b)||v.delete(b),v.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,b){let v=[f];i(f)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):S(f)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const P=v.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(b);if(a)return a}}canTunnel(f){return!!d(f)}createWithProvider(f,b,v,P,c,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${v} on local port ${P}.`);const o={elevationRequired:c?g(P===void 0?v:P):!1},s={remoteAddress:{host:b,port:v},localAddressPort:P,privacy:a,public:a!==E.Private,protocol:u},r=f.forwardPort(s,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(b,v,r),r}};w=he([x(0,k.ILogService)],w),e.AbstractTunnelService=w}),define(Q[50],J([0,1,17,150,49,5,37]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function E(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=E;function h(t){return t.res.statusCode===204}async function d(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=d;async function i(t){if(!E(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const b=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(b)}catch(v){throw v.message+=`:
`+b,v}}e.asJson=i;function S(t){w(t)}e.updateProxyConfigurationsScope=S;let g;function w(t){const f=I.Registry.as(M.Extensions.Configuration),b=g;g={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[g],remove:b?[b]:[]})}w(2)}),define(Q[195],J([0,1,196,14]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(I,E){return I.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:I.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function k(I,E,h={}){const d=(0,p.parse)(I),i=h.proxyUrl||M(d,E);if(!i)return null;const S=(0,p.parse)(i);if(!/^https?:$/.test(S.protocol||""))return null;const g={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,L.isBoolean)(h.strictSSL)?h.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((w,t)=>{H(["http-proxy-agent"],w,t)}))(g):new(await new Promise((w,t)=>{H(["https-proxy-agent"],w,t)}))(g)}e.getProxyAgent=k}),define(Q[197],J([0,1,17,28]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(k,I,E){let h=E&&E.get("storage.serviceMachineId",0)||null;if(h)return h;try{const i=(await I.readFile(k.serviceMachineIdResource)).value.toString();h=(0,L.isUUID)(i)?i:null}catch(d){h=null}if(!h){h=(0,L.generateUuid)();try{await I.writeFile(k.serviceMachineIdResource,p.VSBuffer.fromString(h))}catch(d){}}return E&&E.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=M}),define(Q[76],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[198],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((M,k)=>H(["vsda"],M,k))}async createNewMessage(M){try{const k=await this.vsda(),I=new k.validator;if(I){const E=String(p._nextId++);return this.validators.set(E,I),{id:E,data:I.createNewMessage(M)}}}catch(k){}return{id:"",data:M}}async validate(M,k){if(!M.id)return!0;const I=this.validators.get(M.id);if(!I)return!1;this.validators.delete(M.id);try{return I.validate(k)==="ok"}catch(E){return!1}}async sign(M){try{const k=await this.vsda(),I=new k.signer;if(I)return I.sign(M)}catch(k){}return M}}e.SignService=p,p._nextId=1}),define(Q[38],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Q[22],J([0,1,13,9,4,2,3,32,14,5,177,6,38]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,d.createDecorator)("lifecycleMainService");var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ct extends k.Disposable{constructor(b,v){super();this.logService=b,this.stateMainService=v,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",b);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",b),p.app.removeListener("window-all-closed",v),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(v){b.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(b)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let v=this.phaseWhen.get(b);v||(v=new L.Barrier,this.phaseWhen.set(b,v)),await v.wait()}registerWindow(b){const v=new k.DisposableStore;this.windowCounter++,v.add(b.onWillLoad(c=>this._onWillLoadWindow.fire({window:b,workspace:c.workspace,reason:c.reason})));const P=(0,h.assertIsDefined)(b.win);P.on("close",c=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),c.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,v){await this.unload(b,3)||b.reload(v)}async unload(b,v){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const P=this._quitRequested?2:v;let c=await this.onBeforeUnloadWindowInRenderer(b,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(b,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,P),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,v){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,u=`vscode:cancel${c}`;p.ipcMain.once(a,()=>{P(!1)}),p.ipcMain.once(u,()=>{P(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:v})})}onBeforeUnloadWindowInMain(b,v){const P=[];return this._onBeforeUnloadWindow.fire({reason:v,window:b,veto(c){P.push(c)}}),(0,i.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(b,v){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>P()),b.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(b?.addArgs&&v.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const u=v.indexOf(a);u>=0&&v.splice(u,1)}const P=()=>{try{if(I.isWindows){const a=(0,E.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let P;v.webContents&&!v.webContents.isDestroyed()?P=new Promise(c=>v.once("closed",c)):P=Promise.resolve(),v.destroy(),await P}})()]),p.app.exit(b)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([x(0,S.ILogService),x(1,g.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[199],J([0,1,4,2,5,22]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let I=class extends L.Disposable{constructor(d){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,d.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const d=await new Promise((i,S)=>{H(["native-keymap"],i,S)});this._keyboardLayoutData=E(d),d.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=E(d),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([x(0,k.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function E(h){const d=h.getKeyMap(),i=h.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:i}}}),define(Q[98],J([0,1,9,4,2,63,14,86,5]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var i;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(b){b[b.GLOBAL=0]="GLOBAL",b[b.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var g;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class w extends M.Disposable{constructor(v={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,P){P===d?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:P,target:this.getKeyTargets(v)[P]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,P,c){return this.getStorage(P)?.get(v,c)}getBoolean(v,P,c){return this.getStorage(P)?.getBoolean(v,c)}getNumber(v,P,c){return this.getStorage(P)?.getNumber(v,c)}store(v,P,c,a){if((0,I.isUndefinedOrNull)(P)){this.remove(v,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,c,a),this.getStorage(c)?.set(v,P)})}remove(v,P){this.withPausedEmitters(()=>{this.updateKeyTarget(v,P,void 0),this.getStorage(P)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,P){const c=[],a=this.getKeyTargets(v);for(const u of Object.keys(a))a[u]===P&&c.push(u);return c}updateKeyTarget(v,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[v]!==c&&(a[v]=c,this.getStorage(P)?.set(d,JSON.stringify(a))):typeof a[v]=="number"&&(delete a[v],this.getStorage(P)?.set(d,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const P=this.get(d,v);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=i.NONE){this._onWillSaveState.fire({reason:v}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return f(v,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends w{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function f(b,v,P,c){const a=m=>{try{return JSON.parse(m)}catch(y){return m}},u=new Map,n=new Map;b.forEach((m,y)=>{u.set(y,m),n.set(y,a(m))});const o=new Map,s=new Map;v.forEach((m,y)=>{o.set(y,m),s.set(y,a(m))}),console.group(`Storage: Global (path: ${P})`);let r=[];u.forEach((m,y)=>{r.push({key:y,value:m})}),console.table(r),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${c})`);let l=[];o.forEach((m,y)=>{l.push({key:y,value:m})}),console.table(l),console.groupEnd(),console.log(s)}e.logStorage=f}),define(Q[200],J([0,1,3,32,7,28]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(d){if(p.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function E(d,i,S,g,w,t,f,b,v,P){const c=Object.create(null);c["common.machineId"]=f,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=w,c.version=t,c["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=L.platform,c["common.nodeArch"]=g,c["common.product"]=P||"desktop";const a=h(b||[]);a&&(c["common.msftInternal"]=a);let u=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const o=I(S);o&&(c["common.platformDetail"]=o);try{const s=await d.readFile(M.URI.file(v));c["common.source"]=s.value.toString().slice(0,30)}catch(s){}return c}e.resolveCommonProperties=E;function h(d){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const S=i.toLowerCase();return d.some(g=>S===g)}e.verifyMicrosoftInternalDomain=h}),define(Q[30],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[201],J([0,1,25,69,9,39,10,8,3,7,71,20,83,74,18,21,30]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(n,o){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,l=new Map,m=2e4;function y(T,_,j,te){const se=_.substring(T.length+1);return M.Promises.withAsyncBody(async oe=>{let G;try{G=await S.Promises.readdir(_,{withFileTypes:!0})}catch(V){oe();return}if(te.count>=m){te.count+=G.length,te.maxReached=!0,oe();return}let F=G.length;if(F===0){oe();return}let B=G;te.count+G.length>m&&(te.maxReached=!0,F=m-te.count,B=G.slice(0,F)),te.count+=G.length;for(const V of B)if(V.isDirectory()){if(j.includes(V.name)||await y(T,(0,E.join)(_,V.name),j,te),--F==0){oe();return}}else{const C=V.name.lastIndexOf(".");if(C>=0){const N=V.name.substring(C+1);N&&r.set(N,(r.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(se)!==!1&&N.filePattern.test(V.name)&&l.set(N.tag,(l.get(N.tag)??0)+1);if(--F==0){oe();return}}})}const D={count:0,maxReached:!1};await y(n,n,o,D);const R=await a(n);return{configFiles:P(l),fileTypes:P(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function P(n){return[...L.Iterable.map(n.entries(),([o,s])=>({name:o,count:s}))].sort((o,s)=>s.count-o.count)}function c(){const n={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},o=p.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=c;async function a(n){try{const o=new Map,s=(0,E.join)(n,".vscode","launch.json"),r=await S.Promises.readFile(s),l=[],m=(0,k.parse)(r.toString(),l);if(l.length)return console.log(`Unable to parse ${s}`),[];if((0,k.getNodeType)(m)==="object"&&m.configurations)for(const y of m.configurations){const D=y.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return P(o)}catch(o){return[]}}e.collectLaunchConfigs=a;let u=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||s.push(`Load (avg):       ${p.loadavg().map(l=>Math.round(l)).join(", ")}`),s.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,g.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async r=>{let[l,m]=r,y=this.formatProcessList(o,l);return s.forEach(D=>{if((0,w.isRemoteDiagnosticError)(D))y+=`
${D.errorMessage}`,m+=`
${D.errorMessage}`;else if(y+=`

Remote: ${D.hostName}`,D.processes&&(y+=`
${this.formatProcessList(o,D.processes)}`),D.workspaceMetadata){m+=`
|  Remote: ${D.hostName}`;for(const R of Object.keys(D.workspaceMetadata)){const T=D.workspaceMetadata[R];let _=`${T.fileCount} files`;T.maxFilesReached&&(_=`more than ${_}`),m+=`|    Folder (${R}): ${_}`,m+=this.formatWorkspaceStats(T)}}}),{processInfo:y,workspaceInfo:m}})}async getSystemInfo(o,s){const{memory:r,vmHint:l,os:m,cpus:y}=c(),D={os:m,memory:r,cpus:y,vmHint:l,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return h.isWindows||(D.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),h.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,s){const r=[];return(0,g.listProcesses)(o.mainPID).then(async l=>(r.push(""),r.push(this.formatEnvironment(o)),r.push(""),r.push(this.formatProcessList(o,l)),o.windows.some(m=>m.folderURIs&&m.folderURIs.length>0&&!m.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(o))),s.forEach(m=>{if((0,w.isRemoteDiagnosticError)(m))r.push(`
${m.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${m.hostName}`),r.push(this.formatMachineInfo(m.machineInfo)),m.processes&&r.push(this.formatProcessList(o,m.processes)),m.workspaceMetadata)for(const y of Object.keys(m.workspaceMetadata)){const D=m.workspaceMetadata[y];let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${y}): ${R}`),r.push(this.formatWorkspaceStats(D))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(o){const s=[],r=60;let l=0;const m=(T,_)=>{const j=` ${T}(${_})`;l+j.length>r?(s.push(y),y="|                 ",l=y.length):l+=j.length,y+=j};let y="|      File types:";const D=10;let R=o.fileTypes.length>D?D:o.fileTypes.length;for(let T=0;T<R;T++){const _=o.fileTypes[T];m(_.name,_.count)}if(s.push(y),o.configFiles.length>=0&&(y="|      Conf files:",l=0,o.configFiles.forEach(T=>{m(T.name,T.count)}),s.push(y)),o.launchConfigFiles.length>0){let T="|      Launch Configs:";o.launchConfigFiles.forEach(_=>{T+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(r=>r.length));return Object.keys(o).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${o[r]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],r=[];return o.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(s.push(`|  Window (${l.title})`),l.folderURIs.forEach(m=>{const y=d.URI.revive(m);if(y.scheme===I.Schemas.file){const D=y.fsPath;r.push(v(D,["node_modules",".git"]).then(R=>{let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,E.basename)(D)}): ${T}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${R.toString()})`)}))}else s.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(l=>s.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(o,s){const r=new Map;o.windows.forEach(m=>r.set(m.pid,m.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,r,l,s,0),l.join(`
`)}formatProcessItem(o,s,r,l,m){const y=m===0;let D;y?D=l.pid===o?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(m)} ${l.name}`,l.name==="window"&&(D=`${D} (${s.get(l.pid)})`));const R=process.platform==="win32"?l.mem:p.totalmem()*(l.mem/100);r.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(l.children)&&l.children.forEach(T=>this.formatProcessItem(o,s,r,T,m+1))}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const r=d.URI.revive(s);if(r.scheme!==I.Schemas.file)continue;const l=r.fsPath;try{const m=await v(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),m.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})}),m.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})}),m.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})})}catch{}}}};u=he([x(0,b.ITelemetryService),x(1,f.IProductService)],u),e.DiagnosticsService=u}),define(Q[202],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appenders=k}listen(k,I){throw new Error(`Event not found: ${I}`)}call(k,I,{eventName:E,data:h}){return this.appenders.forEach(d=>d.log(E,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(k){this.channel=k}log(k,I){return this.channel.call("log",{eventName:k,data:I}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Q[65],J([0,1,43,14,19,30]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,P){return Promise.resolve(void 0)}publicLog2(v,P){return this.publicLog(v,P)}publicLogError(v,P){return Promise.resolve(void 0)}publicLogError2(v,P){return this.publicLogError(v,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(v,P,c){}async publicLogError(v,P,c){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(b,v){return v.onDidChangeConfiguration(P=>{P.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=h;function d(b,v){return!(v.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=d;function i(b){const v=b.getValue(k.TELEMETRY_SETTING_ID),P=b.getValue("telemetry.enableCrashReporter");if(b.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function S(b){const v=Object.create(null),P=Object.create(null),c=Object.create(null);w(b,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const u=c[a];typeof u=="number"?P[a]=u:typeof u=="boolean"?P[a]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${u.length}`),v[a]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:P}}e.validateTelemetryData=S;function g(b){if(!b)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{b.indexOf(`${c}+`)===0&&(v=c)}),v}e.cleanRemoteAuthority=g;function w(b,v,P=0,c){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const u=b[a],n=c?c+a:a;Array.isArray(u)?v[n]=(0,p.safeStringify)(u):u instanceof Date?v[n]=u.toISOString():(0,L.isObject)(u)?P<2?w(u,v,P+1,n+"."):v[n]=(0,p.safeStringify)(u):v[n]=u}}function t(b){if(!b)return[];const v=[];return f(v,"",b),v}function f(b,v,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>f(b,v?`${v}.${c}`:c,P[c])):b.push(v)}}),define(Q[203],J([0,1,31,23,16,43,3,32,7,19,48,168,194,165,18,6,21,50,197,98,30,65]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=I.isWeb?"web":(0,S.getTargetPlatform)(I.platform,E.arch);var o;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(o||(o={}));function s(...$){return String($.reduce((z,Z)=>z|Z,0))}var r;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class R{constructor(z=D){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,Z=this.state.pageSize){return new R({...this.state,pageNumber:z,pageSize:Z})}withFilter(z,...Z){const ee=[...this.state.criteria,...Z.length?Z.map(le=>({filterType:z,value:le})):[{filterType:z}]];return new R({...this.state,criteria:ee})}withSortBy(z){return new R({...this.state,sortBy:z})}withSortOrder(z){return new R({...this.state,sortOrder:z})}withFlags(...z){return new R({...this.state,flags:z.reduce((Z,ee)=>Z|ee,0)})}withAssetTypes(...z){return new R({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:Z,pageSize:ee,sortBy:le,sortOrder:re,flags:ie,assetTypes:ae}=this.state;return{filters:[{criteria:z,pageNumber:Z,pageSize:ee,sortBy:le,sortOrder:re}],assetTypes:ae,flags:ie}}get searchText(){const z=this.state.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T($,z){const Z=($||[]).filter(ee=>ee.statisticName===z)[0];return Z?Z.value:0}function _($){const z="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ee=>ee.assetType.indexOf(z)===0).reduce((ee,le)=>{const re=oe($,le.assetType);return re&&ee.push([le.assetType.substring(z.length),re]),ee},[])}function j($){if($.properties){const z=$.properties.filter(le=>le.key===l.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=z.filter(le=>Z.test(le.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return oe($,l.Repository)}function te($){return{uri:`${$.fallbackAssetUri}/${l.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${l.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function se($){const z=oe($,l.Icon);if(z)return z;const Z=S.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function oe($,z){return $.files.filter(ee=>ee.assetType===z)[0]?{uri:`${$.assetUri}/${z}`,fallbackUri:`${$.fallbackAssetUri}/${z}`}:null}function G($,z){const Z=$.properties?$.properties.filter(le=>le.key===z):[],ee=Z.length>0&&Z[0].value;return ee?ee.split(",").map(le=>(0,g.adoptToGalleryExtensionId)(le)):[]}function F($){const z=$.properties?$.properties.filter(Z=>Z.key===m.Engine):[];return z.length>0&&z[0].value||""}function B($){const z=$.properties?$.properties.filter(ee=>ee.key===m.LocalizedLanguages):[],Z=z.length>0&&z[0].value||"";return Z?Z.split(","):[]}function V($){return $.indexOf("preview")!==-1}function C($){return $.targetPlatform?(0,S.toTargetPlatform)($.targetPlatform):"undefined"}function N($){const z=(0,p.distinct)($.versions.map(C)),Z=!!$.tags?.includes(S.WEB_EXTENSION_TAG),ee=z.indexOf("web");return Z?ee===-1&&z.push("web"):ee!==-1&&z.splice(ee,1),z}function U($,z){const Z=(0,S.getFallbackTargetPlarforms)(z);for(let ee=0;ee<$.length;ee++){const le=$[ee];if(le.version===$[ee-1]?.version){let re=ee;const ie=C(le);if(ie===z)for(;re>0&&$[re-1].version===le.version;)re--;else if(Z.includes(ie))for(;re>0&&$[re-1].version===le.version&&C($[re-1])!==z;)re--;re!==ee&&($.splice(ee,1),$.splice(re,0,le))}}return $}e.sortExtensionVersions=U;function Y($,z,Z,ee,le){const re=N($);let ie=$.versions[0];return ie=$.versions.find(ae=>ae.version===ie.version&&(0,S.isTargetPlatformCompatible)(C(ae),re,le))||ie,W($,ie,re,z,Z,ee)}function W($,z,Z,ee,le,re){const ie={manifest:oe(z,l.Manifest),readme:oe(z,l.Details),changelog:oe(z,l.Changelog),license:oe(z,l.License),repository:j(z),download:te(z),icon:se(z),coreTranslations:_(z)};return{identifier:{id:(0,g.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:z.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,description:$.shortDescription||"",installCount:T($.statistics,"install"),rating:T($.statistics,"averagerating"),ratingCount:T($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:Z,assets:ie,properties:{dependencies:G(z,m.Dependency),extensionPack:G(z,m.ExtensionPack),engine:F(z),localizedLanguages:B(z),targetPlatform:C(z)},preview:V($.flags),telemetryData:{index:(le.pageNumber-1)*le.pageSize+ee,querySource:re}}}let A=class{constructor(z,Z,ee,le,re,ie,ae,ue){this.requestService=Z,this.logService=ee,this.environmentService=le,this.telemetryService=re,this.fileService=ie,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=X(ae.version,ae,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,Z){const ee=[];let le=new R().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,z.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...z.map(({id:ie})=>ie.toLowerCase()));z.every(ie=>!ie.version)&&(le=le.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:re}=await this.queryGallery(le,n,L.CancellationToken.None);for(let ie=0;ie<re.length;ie++){const ae=re[ie];if(!ae.versions.length)continue;const ue=(0,g.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=z.find(ve=>(0,g.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Pe=>Pe.version===de);ve&&ee.push(W(ae,ve,N(ae),ie,le))}else ee.push(Y(ae,ie,le,void 0,n))}return ee}async getCompatibleExtension(z,Z){const ee=(0,S.isIExtensionIdentifier)(z)?null:z;if(ee){if((0,S.isNotWebExtensionInWebTargetPlatform)(ee.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(ee,Z))return ee}const{id:le,uuid:re}=ee?ee.identifier:z;let ie=new R().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");re?ie=ie.withFilter(r.ExtensionId,re):ie=ie.withFilter(r.ExtensionName,le);const{galleryExtensions:ae}=await this.queryGallery(ie,Z,L.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=N(ue);if((0,S.isNotWebExtensionInWebTargetPlatform)(de,Z))return null;for(let ve of ue.versions){if(!F(ve)){const Pe=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Z))return W(ue,ve,de,0,ie)}return null}async isExtensionCompatible(z,Z){if(!(0,S.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,Z))return!1;let ee=z.properties.engine;if(!ee){const le=await this.getManifest(z,L.CancellationToken.None);if(!le)throw new Error("Manifest was not found");ee=le.engines.vscode}return(0,w.isEngineValid)(ee,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,Z,ee){if(!(0,S.isTargetPlatformCompatible)(C(z),Z,ee))return!1;const le=await this.getEngine(z);return(0,w.isEngineValid)(le,this.productService.version,this.productService.date)}async query(z,Z){const ee=L.CancellationToken.isCancellationToken(z)?{}:z,le=L.CancellationToken.isCancellationToken(z)?z:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=ee.text||"";const ie=(0,k.getOrDefault)(ee,we=>we.pageSize,50);let ae=new R().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,ie).withFilter(r.Target,"Microsoft.VisualStudio.Code");re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ge,be)=>(ae=ae.withFilter(r.Category,be||ge),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ge,be)=>(ae=ae.withFilter(r.Tag,be||ge),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(r.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),ae=ae.withFilter(r.SearchText,re)),ae=ae.withSortBy(0)):ee.ids?ae=ae.withFilter(r.ExtensionId,...ee.ids):ee.names?ae=ae.withFilter(r.ExtensionName,...ee.names):ae=ae.withSortBy(4),typeof ee.sortBy=="number"&&(ae=ae.withSortBy(ee.sortBy)),typeof ee.sortOrder=="number"&&(ae=ae.withSortOrder(ee.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,n,le),ve=ue.map((we,ge)=>Y(we,ge,ae,ee.source,n)),Pe=async(we,ge)=>{if(ge.isCancellationRequested)throw(0,M.canceled)();const be=ae.withPage(we+1),{galleryExtensions:ke}=await this.queryGallery(be,n,ge);return ke.map((Fe,Ne)=>Y(Fe,Ne,be,ee.source,n))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Pe}}async queryGallery(z,Z,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,o.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(o.Unpublished));const le=await this.commonHeadersPromise,re=JSON.stringify(z.raw),ie={...le,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:re,headers:ie},ee),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Pe=await(0,v.asJson)(ue);if(Pe){const we=Pe.results[0],ge=we.extensions;ge.forEach(ke=>U(ke.versions,Z));const be=we.resultMetadata&&we.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Pe){throw de=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(re.length),duration:new Date().getTime()-ae,success:!!ue&&(0,v.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,M.isPromiseCanceledError)(de)?"canceled":(0,M.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(z,Z,ee,le){if(!this.isEnabled())return;const re=I.isWeb?this.api(`/itemName/${z}.${Z}/version/${ee}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${Z}/${ee}/stats?statType=${le}`),ie=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:re,headers:ue},L.CancellationToken.None)}catch(de){}}async download(z,Z,ee){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const le=(0,g.getGalleryExtensionTelemetryData)(z),re=new Date().getTime(),ie=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:ve}),ae=ee===1?"install":ee===2?"update":"",ue=ae?{uri:`${z.assets.download.uri}${h.URI.parse(z.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${z.assets.download.fallbackUri}${h.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:z.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Z,de.stream),ie(new Date().getTime()-re)}async getReadme(z,Z){if(z.assets.readme){const ee=await this.getAsset(z.assets.readme,{},Z);return await(0,v.asText)(ee)||""}return""}async getManifest(z,Z){if(z.assets.manifest){const ee=await this.getAsset(z.assets.manifest,{},Z),le=await(0,v.asText)(ee);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(z,Z){const ee=oe(z,l.Manifest);if(!ee)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},re=await this.getAsset(ee,{headers:le});return await(0,v.asJson)(re)}async getCoreTranslation(z,Z){const ee=z.assets.coreTranslations.filter(le=>le[0]===Z.toUpperCase())[0];if(ee){const le=await this.getAsset(ee[1]),re=await(0,v.asText)(le);return re?JSON.parse(re):null}return null}async getChangelog(z,Z){if(z.assets.changelog){const ee=await this.getAsset(z.assets.changelog,{},Z);return await(0,v.asText)(ee)||""}return""}async getAllCompatibleVersions(z,Z){let ee=new R().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");z.identifier.uuid?ee=ee.withFilter(r.ExtensionId,z.identifier.uuid):ee=ee.withFilter(r.ExtensionName,z.identifier.id);const{galleryExtensions:le}=await this.queryGallery(ee,Z,L.CancellationToken.None);if(!le.length)return[];const re=N(le[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(re,Z))return[];const ie=[];for(const ae of le[0].versions)try{ie[ie.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,re,Z)&&ie.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ie}async getAsset(z,Z={},ee=L.CancellationToken.None){const le=await this.commonHeadersPromise,re={type:"GET"},ie={...le,...Z.headers||{}};Z={...Z,...re,headers:ie};const ae=z.uri,ue=z.fallbackUri,de={...Z,url:ae};try{const ve=await this.requestService.request(de,ee);if(ve.res.statusCode===200)return ve;const Pe=await(0,v.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Pe}`)}catch(ve){if((0,M.isPromiseCanceledError)(ve))throw ve;const Pe=(0,M.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Pe});const we={...Z,url:ue};return this.requestService.request(we,ee)}}async getEngine(z){let Z=F(z);if(!Z){const ee=await this.getManifestFromRawExtensionVersion(z,L.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");Z=ee.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,v.asJson)(z),ee=new Map;if(Z)for(const le of Z.malicious){const re=ee.get(le)||{id:{id:le},malicious:!0,slow:!1};re.malicious=!0,ee.set(le,re)}return[...ee.values()]}};A=he([x(1,v.IRequestService),x(2,f.ILogService),x(3,i.IEnvironmentService),x(4,a.ITelemetryService),x(5,t.IFileService),x(6,b.IProductService),x(7,d.IConfigurationService)],A);let O=class extends A{constructor(z,Z,ee,le,re,ie,ae,ue){super(z,Z,ee,le,re,ie,ae,ue)}};O=he([x(0,c.IStorageService),x(1,v.IRequestService),x(2,f.ILogService),x(3,i.IEnvironmentService),x(4,a.ITelemetryService),x(5,t.IFileService),x(6,b.IProductService),x(7,d.IConfigurationService)],O),e.ExtensionGalleryService=O;let q=class extends A{constructor(z,Z,ee,le,re,ie,ae){super(void 0,z,Z,ee,le,re,ie,ae)}};q=he([x(0,v.IRequestService),x(1,f.ILogService),x(2,i.IEnvironmentService),x(3,a.ITelemetryService),x(4,t.IFileService),x(5,b.IProductService),x(6,d.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q;async function X($,z,Z,ee,le,re){const ie={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},ae=await(0,P.getServiceMachineId)(Z,le,re);return(0,u.supportsTelemetry)(z,Z)&&(0,u.getTelemetryLevel)(ee)===3&&(ie["X-Market-User-Id"]=ae),ie}e.resolveMarketplaceHeaders=X}),define(Q[204],J([0,1,2,43,3,27,151,19,49,56,37,30,65]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(b,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(b,v){this._experimentProperties[b]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let v=b.sessionID,P=b["common.instanceId"],c=b["common.machineId"],a=b["common.firstSessionDate"],u=b["common.msftInternal"];return{sessionId:v,instanceId:P,machineId:c,firstSessionDate:a,msftInternal:u}}dispose(){this._disposables.dispose()}_log(b,v,P,c){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,L.mixin)(P,a),P=(0,L.mixin)(P,this._experimentProperties),P=(0,L.cloneAndChange)(P,u=>{if(typeof u=="string")return this._cleanupInfo(u,c)}),this._appenders.forEach(u=>u.log(b,P))},a=>{console.error(a)})}publicLog(b,v,P){return this._log(b,3,v,P)}publicLog2(b,v,P){return this.publicLog(b,v,P)}publicLogError(b,v){return this.sendErrorTelemetry?this._log(b,2,v,!0):Promise.resolve(void 0)}publicLogError2(b,v){return this.publicLogError(b,v)}_anonymizeFilePaths(b){let v=b;const P=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(b);if(!o)break;P.push([o.index,n.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const n=a.exec(b);if(!n)break;!c.test(n[0])&&P.every(([o,s])=>n.index<o||n.index>=s)&&(v+=b.substring(u,n.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<b.length&&(v+=b.substr(u)),v}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const v=b.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":P.test(v)?"<REDACTED: email>":b}_cleanupInfo(b,v){let P=b;v&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([x(1,E.IConfigurationService)],w),e.TelemetryService=w;function t(){const f=(0,I.localize)(0,null,d.default.nameLong),b=d.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=M.isWeb?"":(0,I.localize)(3,null),P=(0,I.localize)(4,null),c=(0,I.localize)(5,null),a=(0,I.localize)(6,null),u=(0,I.localize)(7,null),n=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,I.localize)(8,null);return`
${f} ${b} ${v}

&nbsp;

${u}
${n}

&nbsp;

${o}
`}i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(h.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,I.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,I.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[205],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Q[206],J([0,1,109,4,2,5,37,205]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var h;(function(b){function v(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=v})(h=e.ThemeColor||(e.ThemeColor={}));function d(b){return{id:b}}e.themeColorFromId=d;var i;(function(b){function v(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||h.isThemeColor(o.color))}b.isThemeIcon=v;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const s=P.exec(o);if(!s)return;let[,r]=s;return{id:r}}b.fromString=c;function a(o,s){let r=o.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),s&&(r=`${r}~${s}`),{id:r}}b.modify=a;function u(o,s){return o.id===s.id&&o.color?.id===s.color?.id}b.isEqual=u;function n(o,s){return{id:o.id,color:s?d(s):void 0}}b.asThemeIcon=n,b.asClassNameArray=p.CSSIcon.asClassNameArray,b.asClassName=p.CSSIcon.asClassName,b.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function S(b){switch(b){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,M.toDisposable)(()=>{const P=this.themingParticipants.indexOf(v);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new g;I.Registry.add(e.Extensions.ThemingContribution,w);function t(b){return w.onColorThemeChange(b)}e.registerThemingParticipant=t;class f extends M.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,P){let c=this.theme.getColor(v);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=f}),define(Q[66],J([0,1,13,3,5,38]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",E="#1E1E1E",h="#000000",d="theme",i="themeBackground",S="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let g=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(i,null);if(!t){let f;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?f="hc-black":f=this.stateMainService.getItem(d,"vs-dark").split(" ")[0],t=f==="hc-black"?h:f==="vs"?I:E}return L.isMacintosh&&t.toUpperCase()===E&&(t="#171717"),t}saveWindowSplash(t,f){this.stateMainService.setItems([{key:d,data:f.baseTheme},{key:i,data:f.colorInfo.background},{key:S,data:f}]),typeof t=="number"&&this.updateBackgroundColor(t,f)}updateBackgroundColor(t,f){for(const b of p.BrowserWindow.getAllWindows())if(b.id===t){b.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(S)}};g=he([x(0,k.IStateMainService)],g),e.ThemeMainService=g}),define(Q[41],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(L=e.StateType||(e.StateType={}));var M;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(k,I)=>({type:"idle",updateType:k,error:I}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:k=>({type:"downloading",update:k}),Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Q[207],J([0,1,3,152,49,37]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[208],J([0,1,4,41]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(E){this.service=E}listen(E,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,d){switch(h){case"checkForUpdates":return this.service.checkForUpdates(d);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=M;class k{constructor(E){this.channel=E,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=k}),define(Q[99],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Q[209],J([0,1,7]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(E){this.handler=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,d){switch(h){case"handleURL":return this.handler.handleURL(p.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=L;class M{constructor(E){this.channel=E}handleURL(E,h){return this.channel.call("handleURL",[E.toJSON(),h])}}e.URLHandlerChannelClient=M;class k{constructor(E){this.next=E}async routeCall(E,h,d,i){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(d){const S=p.URI.revive(d);if(S&&S.query){const g=/\bwindowId=(\d+)/.exec(S.query);if(g){const w=g[1],t=new RegExp(`window:${w}`),f=E.connections.find(b=>t.test(b.ctx));if(f)return f}}}return this.next.routeCall(E,h,d,i)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=k}),define(Q[210],J([0,1,9,2,7,21]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(d,i){const S=[...this.handlers.values()];return(0,p.first)(S.map(g=>()=>g.handleURL(d,i)),void 0,!1).then(g=>g||!1)}registerHandler(d){return this.handlers.add(d),(0,L.toDisposable)(()=>this.handlers.delete(d))}}e.AbstractURLService=I;let E=class extends I{constructor(d){super();this.productService=d}create(d){let{authority:i,path:S,query:g,fragment:w}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&S&&S.indexOf("/")!==0&&(S=`/${S}`),M.URI.from({scheme:this.productService.urlProtocol,authority:i,path:S,query:g,fragment:w})}};E=he([x(0,k.IProductService)],E),e.NativeURLService=E}),define(Q[211],J([0,1,13,9,4,2,3,7]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(i){try{return E.URI.parse(i)}catch(S){return null}}class d{constructor(S,g,w,t,f){if(this.urlService=g,this.uris=[],this.retryCount=0,this.flushDisposable=k.Disposable.None,this.disposables=new k.DisposableStore,this.uris=S,I.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,P)}const b=M.Event.map(M.Event.fromNodeEventEmitter(p.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(b(P=>{const c=h(P);!c||this.urlService.open(c,{originalUrl:P})})),w.getWindows().filter(P=>P.isReady).length>0?this.flush():M.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const S=[];for(const g of this.uris)await this.urlService.open(g.uri,{originalUrl:g.url})||S.push(g);S.length!==0&&(this.uris=S,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=d}),define(Q[212],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Q[213],J([0,1,13,2,10,7]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class I extends L.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(M.Schemas.vscodeWebview,h)}handleWebviewRequest(h,d){try{const i=k.URI.parse(h.url),S=I.validWebviewFilePaths.get(i.path);if(typeof S=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${S}`,w=M.FileAccess.asFileUri(g,H);return d(decodeURIComponent(w.fsPath))}else return d({error:-10})}catch{}return d({error:-2})}}e.WebviewProtocolProvider=I,I.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[67],J([0,1,3]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(d){return!!d.workspaceUri}e.isWorkspaceToOpen=L;function M(d){return!!d.folderUri}e.isFolderToOpen=M;function k(d){return!!d.fileUri}e.isFileToOpen=k;function I(d){const i=E(d),S=d.getValue("window.menuBarVisibility");return S==="default"||i==="native"&&S==="compact"||p.isMacintosh&&p.isNative?"classic":S}e.getMenuBarVisibility=I;function E(d){if(p.isWeb)return"custom";const i=d.getValue("window");if(i){if(p.isMacintosh&&i.nativeTabs===!0||p.isMacintosh&&i.nativeFullScreen===!1)return"native";const w=d.getValue("workbench.colorCustomizations");if(w?.["window.activeBorder"]||w?.["window.inactiveBorder"])return"custom";const t=i.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=E;function h(d=0){return Math.pow(1.2,d)}e.zoomLevelToZoomFactor=h}),define(Q[36],J([0,1,5]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(d){d[d.INITIAL=1]="INITIAL",d[d.LOAD=2]="LOAD",d[d.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var M;(function(d){d[d.CLOSE=1]="CLOSE",d[d.QUIT=2]="QUIT",d[d.RELOAD=3]="RELOAD",d[d.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var k;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(k=e.OpenContext||(e.OpenContext={}));const I=function(d=1){return{width:1024,height:768,mode:d}};e.defaultWindowState=I;var E;(function(d){d[d.Maximized=0]="Maximized",d[d.Normal=1]="Normal",d[d.Minimized=2]="Minimized",d[d.Fullscreen=3]="Fullscreen"})(E=e.WindowMode||(e.WindowMode={}));var h;(function(d){d[d.UNRESPONSIVE=1]="UNRESPONSIVE",d[d.CRASHED=2]="CRASHED",d[d.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Q[214],J([0,1,13,4,2,213,36]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends M.Disposable{constructor(d){super();this.windowsMainService=d,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,i){let S;if(typeof d.windowId=="number"){const{windowId:g}=d,w=this.windowsMainService.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);S=w.win.webContents}else{const{webContentsId:g}=d;if(S=p.webContents.fromId(g),!S)throw new Error(`Invalid webContentsId: ${g}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(i)}async findInFrame(d,i,S,g){const w=this.getFrameByName(d,i),t=w;if(typeof t.findInFrame=="function"){t.findInFrame(S,{findNext:g.findNext,forward:g.forward});const f=(b,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),w.removeListener("found-in-frame",f))};w.on("found-in-frame",f)}}async stopFindInFrame(d,i,S){const w=this.getFrameByName(d,i);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}getFrameByName(d,i){const S=this.windowsMainService.getWindowById(d.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${d}`);const g=S.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===i);if(!g)throw new Error(`Unknown frame: ${i}`);return g}};E=he([x(0,I.IWindowsMainService)],E),e.WebviewMainService=E}),define(Q[215],J([0,1,9,4,2]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends M.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:h,getActiveWindowId:d}){super();this.disposables=this._register(new M.DisposableStore),L.Event.latch(L.Event.any(E,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>d()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch(S){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Q[216],J([0,1,40,15,7,5]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var I;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function E(g){const w=g;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=E;function h(g){const w=g;return!!(w&&typeof w=="object"&&M.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(w,t,f,b,v){this._id=w,this._transient=f,this._configuration=b,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class i{constructor(w,t){this.raw=t,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function S(g){return new i({uri:g,index:0,name:(0,L.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=S}),define(Q[26],J([0,1,33,39,78,34,10,8,3,15,7,155,5,64,216]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(F){return(typeof F=="string"?(0,E.extname)(F):(0,d.extname)(F))===f}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function v(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function P(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(F){const B=F;return typeof B?.id=="string"&&i.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=u;function n(F){const B=F;return typeof B?.id=="string"&&i.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=n;function o(F){const B=F;if(B?.uri)return{id:B.id,uri:i.URI.revive(B.uri)};const V=F;if(V?.configPath)return{id:V.id,configPath:i.URI.revive(V.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=o;function s(F,B){return d.extUriBiasedIgnorePathCase.isEqualOrParent(F,B.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(F){return l(F)||m(F)}e.isStoredWorkspaceFolder=r;function l(F){const B=F;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=l;function m(F){const B=F;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=m;function y(F,B,V,C,N=!h.isWindows,U){if(F.scheme!==C.scheme)return{name:V,uri:F.toString(!0)};let Y=B?void 0:U.relativePath(C,F);if(Y!==void 0)Y.length===0?Y=".":h.isWindows&&F.scheme===I.Schemas.file&&!N&&(Y=Y.replace(/\//g,"\\"));else if(F.scheme===I.Schemas.file)Y=F.fsPath,h.isWindows&&(Y=(0,k.normalizeDriveLetter)(Y),N&&(Y=(0,p.toSlashes)(Y)));else{if(!U.isEqualAuthority(F.authority,C.authority))return{name:V,uri:F.toString(!0)};Y=F.path}return{name:V,path:Y}}e.getStoredWorkspaceFolder=y;function D(F,B,V){let C=[],N=new Set;const U=V.dirname(B);for(let Y of F){let W;if(l(Y))Y.path&&(W=V.resolvePath(U,Y.path));else if(m(Y))try{W=i.URI.parse(Y.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(A){console.warn(A)}if(W){let A=V.getComparisonKey(W);if(!N.has(A)){N.add(A);const O=Y.name||V.basenameOrAuthority(W);C.push(new t.WorkspaceFolder({uri:W,name:O,index:C.length},Y))}}}return C}e.toWorkspaceFolders=D;function R(F,B,V,C,N){let U=T(B,F);const Y=N.dirname(B),W=N.dirname(C),A=[],O=_(U.folders);for(const z of U.folders){const Z=l(z)?N.resolvePath(Y,z.path):i.URI.parse(z.uri);let ee;V?ee=!1:ee=!l(z)||(0,E.isAbsolute)(z.path),A.push(y(Z,ee,z.name,W,O,N))}const q={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},X=M.setProperty(F,["folders"],A,q);let $=M.applyEdits(F,X);return(0,d.isEqualAuthority)(U.remoteAuthority,(0,w.getRemoteAuthority)(C))&&($=M.applyEdits($,M.removeProperty($,["remoteAuthority"],q))),$}e.rewriteWorkspaceFileForNewLocation=R;function T(F,B){let V=L.parse(B);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(C=>r(C));else throw new Error(`${F} looks like an invalid workspace file.`);return V}function _(F){return h.isWindows?F.some(B=>l(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=_;function j(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function te(F){return typeof F.folderUri=="string"}function se(F){return typeof F.fileUri=="string"}function oe(F,B){const V={workspaces:[],files:[]};if(F){const C=function(U,Y){for(let W=0;W<U.length;W++)try{Y(U[W],W)}catch(A){B.warn(`Error restoring recent entry ${JSON.stringify(U[W])}: ${A.toString()}. Skip entry.`)}},N=F;if(Array.isArray(N.entries))C(N.entries,U=>{const Y=U.label,W=U.remoteAuthority;j(U)?V.workspaces.push({label:Y,remoteAuthority:W,workspace:{id:U.workspace.id,configPath:i.URI.parse(U.workspace.configPath)}}):te(U)?V.workspaces.push({label:Y,remoteAuthority:W,folderUri:i.URI.parse(U.folderUri)}):se(U)&&V.files.push({label:Y,remoteAuthority:W,fileUri:i.URI.parse(U.fileUri)})});else{const U=F;Array.isArray(U.workspaces3)&&C(U.workspaces3,(Y,W)=>{const A=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[W]||void 0;typeof Y=="object"&&typeof Y.id=="string"&&typeof Y.configURIPath=="string"?V.workspaces.push({label:A,workspace:{id:Y.id,configPath:i.URI.parse(Y.configURIPath)}}):typeof Y=="string"&&V.workspaces.push({label:A,folderUri:i.URI.parse(Y)})}),Array.isArray(U.files2)&&C(U.files2,(Y,W)=>{const A=Array.isArray(U.fileLabels)&&U.fileLabels[W]||void 0;typeof Y=="string"&&V.files.push({label:A,fileUri:i.URI.parse(Y)})})}}return V}e.restoreRecentlyOpened=oe;function G(F){const B={entries:[]};for(const V of F.workspaces)P(V)?B.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):B.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of F.files)B.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return B}e.toStoreData=G}),define(Q[51],J([0,1,5,26]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function M(k){const I=k;return I&&(0,L.isWorkspaceIdentifier)(I.workspace)}e.isWorkspaceBackupInfo=M}),define(Q[52],J([0,1,13,9,81,34,2,70,8,3,14,20,135,5,6,38,26]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let v=class mt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,g.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,g.localize)(2,null)},a)}pickWorkspace(c,a){const u=(0,g.localize)(3,null),n=(0,k.mnemonicButtonLabel)((0,g.localize)(4,null)),o=b.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:u,filters:o,buttonLabel:n},a)}async doPick(c,a){const u={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};u.defaultPath=c.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(u.properties=void 0,c.pickFiles&&c.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&u.properties.push("treatPackageAsDirectory");const n=a||p.BrowserWindow.getFocusedWindow(),o=await this.showOpenDialog(u,(0,i.withNullAsUndefined)(n));if(o&&o.filePaths&&o.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,h.dirname)(o.filePaths[0])),o.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new L.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,a){const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let n;return a?n=await p.dialog.showSaveDialog(a,c):n=await p.dialog.showSaveDialog(c),n.filePath=this.normalizePath(n.filePath),n})}finally{(0,I.dispose)(u)}}normalizePath(c){return c&&d.isMacintosh&&(c=(0,E.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await S.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let n;return a?n=await p.dialog.showOpenDialog(a,c):n=await p.dialog.showOpenDialog(c),n.filePaths=this.normalizePaths(n.filePaths),n})}finally{(0,I.dispose)(u)}}acquireFileDialogLock(c,a){if(!a)return I.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const n=(0,M.hash)(c);if(!u.has(n))return u.add(n),(0,I.toDisposable)(()=>{u?.delete(n),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=he([x(0,f.IStateMainService),x(1,t.ILogService)],v),e.DialogMainService=v}),define(Q[217],J([0,1,4,2,26]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends L.Disposable{constructor(E,h){super();this.logService=E,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(E,h)=>(E?E.push(h):E=[h],E),k.STORAGE_CHANGE_DEBOUNCE_TIME)(E=>{E.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(E))}))}serializeGlobalStorageEvents(E){const h=new Map,d=new Set;return E.forEach(i=>{const S=this.storageMainService.globalStorage.get(i.key);typeof S=="string"?h.set(i.key,S):d.add(i.key)}),{changed:Array.from(h.entries()),deleted:Array.from(d.values())}}listen(E,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(E,h,d){const i=(0,M.reviveIdentifier)(d.workspace),S=await this.withStorageInitialized(i);switch(h){case"getItems":return Array.from(S.items.entries());case"updateItems":{const g=d;if(g.insert)for(const[w,t]of g.insert)S.set(w,t);g.delete&&g.delete.forEach(w=>S.delete(w));break}case"close":{if(i)return S.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(E){const h=E?this.storageMainService.workspaceStorage(E):this.storageMainService.globalStorage;try{await h.init()}catch(d){this.logService.error(`StorageIPC#init: Unable to init ${E?"workspace":"global"} storage due to ${d}`)}return h}}e.StorageDatabaseChannel=k,k.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[218],J([0,1,4,2,8,28,20,86,125,6,98,30,26]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new E.Storage(new E.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(v);const P=v.getBoolean(i.IS_NEW_KEY);P===void 0?v.set(i.IS_NEW_KEY,!0):P&&v.set(i.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===d.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,P){return this.storage.get(v,P)}set(v,P){return this.storage.set(v,P)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends w{constructor(v,P,c){super(P);this.options=v,this.environmentService=c}async doCreate(){let v;return this.options.useInMemoryStorage?v=h.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,M.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new E.Storage(new h.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(S.instanceStorageKey,void 0)===void 0&&v.set(S.instanceStorageKey,(0,k.generateUuid)()),v.get(S.firstSessionDateStorageKey,void 0)===void 0&&v.set(S.firstSessionDateStorageKey,new Date().toUTCString());const a=v.get(S.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();v.set(S.lastSessionDateStorageKey,typeof a=="undefined"?null:a),v.set(S.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class f extends w{constructor(v,P,c,a){super(c);this.workspace=v,this.options=P,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new E.Storage(new h.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:P?E.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:h.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,M.join)(v,f.WORKSPACE_STORAGE_NAME);return await I.Promises.exists(v)?{storageFilePath:P,wasCreated:!1}:(await I.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let P;if((0,g.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,g.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const c=(0,M.join)(v,f.WORKSPACE_META_NAME);await I.Promises.exists(c)||await I.Promises.writeFile(c,JSON.stringify(P,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=f,f.WORKSPACE_STORAGE_NAME="state.vscdb",f.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],J([0,1,42,2,48,5,22,6,218]),function(H,e,p,L,M,k,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let d=class extends L.Disposable{constructor(S,g,w){super();this.logService=S,this.environmentService=g,this.lifecycleMainService=w,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async S=>{S.workspace&&this.workspaceStorage(S.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(S=>{S.join(this.globalStorage.close());for(const[,g]of this.mapWorkspaceToStorage)S.join(g.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const S=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(S.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),S}createWorkspaceStorage(S){return new h.WorkspaceStorageMain(S,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(S){let g=this.mapWorkspaceToStorage.get(S.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${S.id})`),g=this.createWorkspaceStorage(S),this.mapWorkspaceToStorage.set(S.id,g),(0,p.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${S.id})`),this.mapWorkspaceToStorage.delete(S.id)})),g}};d=he([x(0,E.ILogService),x(1,M.IEnvironmentService),x(2,I.ILifecycleMainService)],d),e.StorageMainService=d}),define(Q[101],J([0,1,15,7,26]),function(H,e,p,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function k(h,d,i){for(const g of h){const w=g.openedWorkspace;if((0,M.isWorkspaceIdentifier)(w)){const t=i(w);if(t){if(t.folders.some(f=>p.extUriBiasedIgnorePathCase.isEqualOrParent(d,f.uri)))return g}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(d,w.configPath))return g}}const S=h.filter(g=>(0,M.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(d,g.openedWorkspace.uri));if(S.length)return S.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=k;function I(h,d){for(const i of h)if((0,M.isWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,d)||(0,M.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,d))return i}e.findWindowOnWorkspaceOrFolder=I;function E(h,d){const i=S=>d.some(g=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(g),L.URI.file(S)));for(const S of h)if(S.config?.extensionDevelopmentPath?.some(g=>i(g)))return S}e.findWindowOnExtensionDevelopmentPath=E}),define(Q[219],J([0,1,13,2,3,15,7,19,22,6,38,36,26]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class wt extends L.Disposable{constructor(c,a,u,n,o){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=u,this.logService=n,this.configurationService=o,this._state=t(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(c.lastActiveWindow=this.toWindowState(n))}const a=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const u=b(c);this.stateMainService.setItem(wt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(u=>{const n=(0,g.isWorkspaceIdentifier)(c.openedWorkspace)&&u.workspace?.id===c.openedWorkspace.id,o=(0,g.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&u.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(u.folderUri,c.openedWorkspace.uri);(n||o)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,g.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),u=this.configurationService.getValue("window");let n;return a.hasDefaultState?n=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),n&&M.isMacintosh&&this.windowsMainService.getWindows().some(o=>o.isFullScreen)&&(n=!1)),a.mode===3&&!n&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=c.workspace;if((0,g.isWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(y.length)return y[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(l)){const y=this.state.openedWindows.filter(D=>D.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(y.length)return y[0]}else if(c.backupPath){const y=this.state.openedWindows.filter(D=>D.backupPath===c.backupPath).map(D=>D.uiState);if(y.length)return y[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!a&&m)return m.uiState}let u;const n=p.screen.getAllDisplays();if(n.length===1)u=n[0];else{if(M.isMacintosh){const l=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(l)}!u&&a&&(u=p.screen.getDisplayMatching(a.getBounds())),u||(u=p.screen.getPrimaryDisplay()||n[0])}let o=(0,S.defaultWindowState)();o.x=Math.round(u.bounds.x+u.bounds.width/2-o.width/2),o.y=Math.round(u.bounds.y+u.bounds.height/2-o.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")o.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")o.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const l=a.serializeWindowState();l.mode===3?o.mode=3:o=l,r=o.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(o=this.ensureNoOverlap(o)),o.hasDefaultState=!0,o}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===c.x||u.y===c.y);)c.x+=30,c.y+=30;return c}};w.windowsStateStorageKey="windowsState",w=he([x(0,S.IWindowsMainService),x(1,i.IStateMainService),x(2,h.ILifecycleMainService),x(3,d.ILogService),x(4,E.IConfigurationService)],w),e.WindowsStateHandler=w;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=f(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=f(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(u=>f(u))),c}e.restoreWindowsState=t;function f(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=I.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:I.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function b(P){return{lastActiveWindow:P.lastActiveWindow&&v(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&v(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>v(c))}}e.getWindowsStateStoreData=b;function v(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Q[102],J([0,1,61,29,10,3,15]),function(H,e,p,L,M,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function E(d){function i(){let S=d.scheme===M.Schemas.file?(0,I.originalFSPath)(d):d.toString();return k.isLinux||(S=S.toLowerCase()),(0,p.createHash)("md5").update(S).digest("hex")}return{id:i(),configPath:d}}e.getWorkspaceIdentifier=E;function h(d,i){function S(){if(d.scheme!==M.Schemas.file)return(0,p.createHash)("md5").update(d.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(d.fsPath)}catch(t){return}let w;return k.isLinux?w=i.ino:k.isMacintosh?w=i.birthtime.getTime():k.isWindows&&(typeof i.birthtimeMs=="number"?w=Math.floor(i.birthtimeMs):w=i.birthtime.getTime()),(0,p.createHash)("md5").update(d.fsPath).update(w?String(w):"").digest("hex")}const g=S();if(typeof g=="string")return{id:g,uri:d}}e.getSingleFolderWorkspaceIdentifier=h}),define(Q[58],J([0,1,61,62,25,17,16,4,2,8,3,28,35,84,220]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(y){this.socket=y,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const D=R=>y(k.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(y){const D=R=>{y({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,I.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((y,D)=>{if(this.socket.bufferSize===0){y();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),y()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=f;var b;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class P extends h.Disposable{constructor(y,D,R,T){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=T,D?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,I.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,I.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(k.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,D){let R=2;y.byteLength<126?R+=0:y.byteLength<2**16?R+=2:R+=8;const T=k.VSBuffer.alloc(R);if(D?T.writeUInt8(194,0):T.writeUInt8(130,0),y.byteLength<126)T.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(y.byteLength>>>8&255,++_),T.writeUInt8(y.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(y.byteLength>>>24&255,++_),T.writeUInt8(y.byteLength>>>16&255,++_),T.writeUInt8(y.byteLength>>>8&255,++_),T.writeUInt8(y.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=T.byteLength+y.byteLength,this.socket.write(k.VSBuffer.concat([T,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),R=D.readUInt8(0),T=(R&128)>>>7,_=(R&64)>>>6,j=D.readUInt8(1),te=(j&128)>>>7,se=j&127;this._state.state=2,this._state.readLen=2+(te?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),T=(R&128)>>>7;let _=R&127,j=1;_===126?_=D.readUInt8(++j)*2**8+D.readUInt8(++j):_===127&&(_=D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j));let te=0;T&&(te=D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j)),this._state.state=3,this._state.readLen=_,this._state.mask=te}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);c(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(k.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function c(m,y){if(y===0)return;let D=m.byteLength>>>2;for(let se=0;se<D;se++){const oe=m.readUInt32BE(se*4);m.writeUInt32BE(oe^y,se*4)}let R=D*4,T=m.byteLength-R;const _=y>>>24&255,j=y>>>16&255,te=y>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(R)^_,R),T>=2&&m.writeUInt8(m.readUInt8(R+1)^j,R+1),T>=3&&m.writeUInt8(m.readUInt8(R+2)^te,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):y=(0,d.join)((0,M.tmpdir)(),`vscode-ipc-${m}.sock`),o(y),y}e.createRandomIPCHandle=u;function n(m,y,D){const R=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${y}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,d.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${y}.sock`):T=(0,d.join)(m,`${D}-${y}.sock`),o(T),T}e.createStaticIPCHandle=n;function o(m){const y=a[i.platform];typeof y=="number"&&m.length>=y&&console.warn(`WARNING: IPC handle "${m}" is longer than ${y} chars, try a shorter --user-data-dir`)}class s extends g.IPCServer{constructor(y){super(s.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const D=E.Event.fromNodeEventEmitter(y,"connection");return E.Event.map(D,R=>({protocol:new w.Protocol(new f(R)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(m){return new Promise((y,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),y(new s(R))})})}e.serve=r;function l(m,y){return new Promise((D,R)=>{const T=(0,L.createConnection)(m,()=>{T.removeListener("error",R),D(w.Client.fromSocket(new f(T),y))});T.once("error",R)})}e.connect=l}),define(Q[221],J([0,1,58]),function(H,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(h){this.driver=h}listen(h,d){throw new Error("No event found")}call(h,d,i){switch(d){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${d}`)}}e.DriverChannel=L;class M{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,d){return this.channel.call("dispatchKeybinding",[h,d])}click(h,d,i,S){return this.channel.call("click",[h,d,i,S])}doubleClick(h,d){return this.channel.call("doubleClick",[h,d])}setValue(h,d,i){return this.channel.call("setValue",[h,d,i])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,d){return this.channel.call("isActiveElement",[h,d])}getElements(h,d,i){return this.channel.call("getElements",[h,d,i])}getElementXY(h,d,i,S){return this.channel.call("getElementXY",[h,d,i,S])}typeInEditor(h,d,i){return this.channel.call("typeInEditor",[h,d,i])}getTerminalBuffer(h,d){return this.channel.call("getTerminalBuffer",[h,d])}writeInTerminal(h,d,i){return this.channel.call("writeInTerminal",[h,d,i])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=M;class k{constructor(h){this.registry=h}listen(h,d){throw new Error(`Event not found: ${d}`)}call(h,d,i){switch(d){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${d}`)}}e.WindowDriverRegistryChannel=k;async function I(E){const h=await(0,p.connect)(E,"driverClient"),d=h.getChannel("driver"),i=new M(d);return{client:h,driver:i}}e.connect=I}),define(Q[222],J([0,1,9,4,106,59,2,3,35,58,159,221,176,22,36]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function f(P){return P<21}let b=class{constructor(c,a,u,n){this.windowServer=c,this.options=a,this.windowsMainService=u,this.lifecycleMainService=n,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a?.win)throw new Error("Invalid window");return(await a.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const a=this.windowsMainService.getWindowById(c);if(!a)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(a)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(c,a){await this.whenUnfrozen(c);const u=M.KeybindingParser.parseUserBinding(a);for(let n of u)await this._dispatchKeybinding(c,n)}async _dispatchKeybinding(c,a){if(a instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(c);if(!u?.win)throw new Error("Invalid window");const n=u.win.webContents,o=new k.SimpleKeybinding(!1,!1,!1,!1,a.keyCode),r=new g.USLayoutResolvedKeybinding(o.toChord(),E.OS).getElectronAccelerator(),l=[];a.ctrlKey&&l.push("ctrl"),a.metaKey&&l.push("meta"),a.shiftKey&&l.push("shift"),a.altKey&&l.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:r,modifiers:l}),f(a.keyCode)||n.sendInputEvent({type:"char",keyCode:r,modifiers:l}),n.sendInputEvent({type:"keyUp",keyCode:r,modifiers:l}),await(0,p.timeout)(100)}async click(c,a,u,n){await(await this.getWindowDriver(c)).click(a,u,n)}async doubleClick(c,a){await(await this.getWindowDriver(c)).doubleClick(a)}async setValue(c,a,u){await(await this.getWindowDriver(c)).setValue(a,u)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,a){return await(await this.getWindowDriver(c)).isActiveElement(a)}async getElements(c,a,u){return await(await this.getWindowDriver(c)).getElements(a,u)}async getElementXY(c,a,u,n){return await(await this.getWindowDriver(c)).getElementXY(a,u,n)}async typeInEditor(c,a,u){await(await this.getWindowDriver(c)).typeInEditor(a,u)}async getTerminalBuffer(c,a){return await(await this.getWindowDriver(c)).getTerminalBuffer(a)}async writeInTerminal(c,a,u){await(await this.getWindowDriver(c)).writeInTerminal(a,u)}async getLocaleInfo(c){return await(await this.getWindowDriver(c)).getLocaleInfo()}async getLocalizedStrings(c){return await(await this.getWindowDriver(c)).getLocalizedStrings()}async getWindowDriver(c){await this.whenUnfrozen(c);const a=`window:${c}`,u=new h.StaticRouter(o=>o===a),n=this.windowServer.getChannel("windowDriver",u);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await L.Event.toPromise(this.onDidReloadingChange.event)}};b=he([x(2,t.IWindowsMainService),x(3,w.ILifecycleMainService)],b),e.Driver=b;async function v(P,c,a,u){const n=a.driverVerbose,o=u.createInstance(b,P,{verbose:n}),s=new S.WindowDriverRegistryChannel(o);P.registerChannel("windowDriverRegistry",s);const r=await(0,d.serve)(c),l=new S.DriverChannel(o);return r.registerChannel("driver",l),(0,I.combinedDisposable)(r,P)}e.serve=v}),define(Q[24],J([0,1,47,8,58,48,163,5]),function(H,e,p,L,M,k,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(k.IEnvironmentService);class h extends I.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([p.memoize],h.prototype,"cachedLanguagesPath",null),he([p.memoize],h.prototype,"backupHome",null),he([p.memoize],h.prototype,"backupWorkspacesPath",null),he([p.memoize],h.prototype,"mainIPCHandle",null),he([p.memoize],h.prototype,"mainLockfile",null),he([p.memoize],h.prototype,"sandbox",null),he([p.memoize],h.prototype,"driverVerbose",null),he([p.memoize],h.prototype,"disableUpdates",null),he([p.memoize],h.prototype,"disableKeytar",null),he([p.memoize],h.prototype,"codeCachePath",null),he([p.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Q[223],J([0,1,61,29,33,10,8,3,15,7,20,51,19,24,18,6,26]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(c,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,o)=>(0,M.isEqual)(n,o,!E.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(n){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:d.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch(n){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(c.folderURIWorkspaces)&&(u=c.folderURIWorkspaces.map(n=>d.URI.parse(n)))}catch(n){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(n=>c.workspace.id===n.workspace.id)||(this.workspaces.push(c),this.saveSync());const u=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(c,a){if(L.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),L.existsSync(a))try{L.renameSync(a,c)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,u=this.workspaces.findIndex(n=>n.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c,a))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(c,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const u=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,I.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,u=[];for(let n of c){const o=n.workspace;if(!(0,b.isWorkspaceIdentifier)(o))return[];if(!a.has(o.id)){a.add(o.id);const s=this.getBackupPath(o.id);await this.doHasBackups(s)?o.configPath.scheme!==k.Schemas.file||await i.Promises.exists(o.configPath.fsPath)?u.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let n of c){const o=this.backupUriComparer.getComparisonKey(n);if(!u.has(o)){u.add(o);const s=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(s)?n.scheme!==k.Schemas.file||await i.Promises.exists(n.fsPath)?a.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let n of c){const o=n.backupFolder;if(typeof o!="string")return[];if(!u.has(o)){u.add(o);const s=this.getBackupPath(o);await this.doHasBackups(s)?a.push(n):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(c){try{await i.Promises.exists(c)&&await i.Promises.rm(c,i.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await i.Promises.rename(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{L.renameSync(c,u)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return d.URI.isUri(c)?a=this.getBackupPath(this.getFolderHash(c)):(0,S.isWorkspaceBackupInfo)(c)?a=this.getBackupPath(c.workspace.id):a=c.backupFolder,this.doHasBackups(a)}async doHasBackups(c){try{const a=await i.Promises.readdir(c);for(const u of a)try{if((await i.Promises.readdir((0,I.join)(c,u))).length>0)return!0}catch(n){}}catch(a){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let a;return c.scheme===k.Schemas.file?a=E.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,p.createHash)("md5").update(a).digest("hex")}};v=he([x(0,w.IEnvironmentMainService),x(1,g.IConfigurationService),x(2,f.ILogService)],v),e.BackupMainService=v}),define(Q[224],J([0,1,62,58]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,k,I,E){const h=i=>E(i,void 0),d=p.createConnection({host:M,port:k},()=>{d.removeListener("error",h);const i=Buffer.alloc(16);for(let t=0;t<16;t++)i[t]=Math.round(Math.random()*256);const S=i.toString("base64");let g=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${k}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];d.write(g.join(`\r
`)+`\r
\r
`);const w=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",w),E(void 0,new L.NodeSocket(d)))};d.on("data",w)});d.once("error",h)}}}),define(Q[225],J([0,1,62,117,224,9,2,19,6,21,192,97,76]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(P,c,a,u,n){return new t(P,c,a,u,n).waitForReady()}class t extends I.Disposable{constructor(c,a,u,n,o){super();this.defaultTunnelHost=a,this.suggestedLocalPort=o,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,i.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),n=u.getSocket().socket,o=u.readEntireBuffer();u.dispose(),o.byteLength>0&&c.write(o.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),n.destroy()}),n.on("end",()=>c.end()),n.on("close",()=>c.end()),n.on("error",()=>{c.destroy()}),c.pipe(n),n.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),n.end()})}}let f=class extends S.AbstractTunnelService{constructor(c,a,u,n,o){super(a);this.socketFactory=c,this.signService=u,this.productService=n,this.configurationService=o}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,u,n,o,s,r){const l=this.getTunnelFromMap(a,u);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,n,o,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${n}.`);const m={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},y=w(m,this.defaultTunnelHost,a,u,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,y),y}}};f=he([x(1,h.ILogService),x(2,g.ISignService),x(3,d.IProductService),x(4,E.IConfigurationService)],f),e.BaseTunnelService=f;let b=class extends f{constructor(c,a,u,n){super(M.nodeSocketFactory,c,a,u,n)}};b=he([x(0,h.ILogService),x(1,g.ISignService),x(2,d.IProductService),x(3,E.IConfigurationService)],b),e.TunnelService=b;let v=class extends I.Disposable{constructor(c,a,u,n){super();this.logService=c,this.productService=a,this.signService=u,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(c,a,u,n,o,s,r,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${n} on local port ${o}.`),!this._tunnelServices.has(c)){const m=new b(this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(c,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,u,n,o,s,r,l)}};v=he([x(0,h.ILogService),x(1,d.IProductService),x(2,g.ISignService),x(3,E.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Q[226],J([0,1,196,9,17,16,2,14,19,48,91,6,195,220]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends I.Disposable{constructor(b,v,P){super();this.environmentService=v,this.logService=P,this.configure(b.getValue()),this._register(b.onDidChangeConfiguration(()=>this.configure(b.getValue()),this))}configure(b){this.proxyUrl=b.http&&b.http.proxy,this.strictSSL=!!(b.http&&b.http.proxyStrictSSL),this.authorization=b.http&&b.http.proxyAuthorization}async request(b,v){this.logService.trace("RequestService#request",b.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,i.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.logService.error("RequestService#request resolving shell environment failed",o)}const u={...process.env,...a},n=b.agent?b.agent:await(0,g.getProxyAgent)(b.url||"",u,{proxyUrl:P,strictSSL:c});return b.agent=n,b.strictSSL=c,this.authorization&&(b.headers={...b.headers||{},"Proxy-Authorization":this.authorization}),this._request(b,v)}async getNodeRequest(b){return((0,p.parse)(b.url).protocol==="https:"?await new Promise((c,a)=>{H(["https"],c,a)}):await new Promise((c,a)=>{H(["http"],c,a)})).request}_request(b,v){return L.Promises.withAsyncBody(async(P,c)=>{let a;const u=(0,p.parse)(b.url),n=b.getRawRequest?b.getRawRequest(b):await this.getNodeRequest(b),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,E.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(o.auth=b.user+":"+b.password),a=n(o,s=>{const r=(0,E.isNumber)(b.followRedirects)?b.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...b,url:s.headers.location,followRedirects:r-1},v).then(P,c);else{let l=s;s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,w.createGunzip)())),P({res:s,stream:(0,M.streamToBufferReadableStream)(l)})}}),a.on("error",c),b.timeout&&a.setTimeout(b.timeout),b.data&&typeof b.data=="string"&&a.write(b.data),a.end(),v.onCancellationRequested(()=>{a.abort(),c((0,k.canceled)())})})}async resolveProxy(b){}};t=he([x(0,h.IConfigurationService),x(1,d.INativeEnvironmentService),x(2,S.ILogService)],t),e.RequestService=t}),define(Q[227],J([0,1,13,226]),function(H,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(I){return p.net.request}class k extends L.RequestService{request(E,h){return super.request({...E||{},getRawRequest:M},h)}}e.RequestMainService=k}),define(Q[228],J([0,1,13,9,4,2,10,14,85,24,22,6,56,57,66,45]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends k.Disposable{constructor(P,c,a,u,n,o,s){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=n,this.themeMainService=o,this.protocolMainService=s,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new k.DisposableStore,u=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},n=p.BrowserWindow.fromId(c.reply.windowId);if(!n||n.isDestroyed()||n.webContents.isDestroyed()||!c.reply.channel){u("unavailable");return}a.add(M.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===n)(()=>u("load"))),a.add(M.Event.fromNodeEventEmitter(n,"closed")(()=>u("closed"))),n.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(c){}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,f.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default}),this.window.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,E.assertIsDefined)(this.window);return(0,h.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};b=he([x(2,d.IEnvironmentMainService),x(3,i.ILifecycleMainService),x(4,S.ILogService),x(5,t.IThemeMainService),x(6,w.IProtocolMainService)],b),e.SharedProcess=b}),define(Q[229],J([0,1,9,17,8,14,7,24,18,6]),function(H,e,p,L,M,k,I,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(w,t,f){this.storagePath=w,this.logService=t,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,t){const f=this.storage[w];return(0,k.isUndefinedOrNull)(f)?t:f}setItem(w,t){this.setItems([{key:w,data:t}])}setItems(w){let t=!1;for(const{key:f,data:b}of w)this.storage[f]!==b&&((0,k.isUndefinedOrNull)(b)?(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,t=!0):(this.storage[f]=b,t=!0));t&&this.save()}removeItem(w){(0,k.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let S=class St{constructor(w,t,f){this.fileStorage=new i(I.URI.file((0,M.join)(w.userDataPath,St.STATE_FILE)),t,f)}async init(){return this.fileStorage.init()}getItem(w,t){return this.fileStorage.getItem(w,t)}setItem(w,t){this.fileStorage.setItem(w,t)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};S.STATE_FILE="storage.json",S=he([x(0,E.IEnvironmentMainService),x(1,d.ILogService),x(2,h.IFileService)],S),e.StateMainService=S}),define(Q[77],J([0,1,9,23,4,19,24,22,6,21,50,41]),function(H,e,p,L,M,k,I,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function g(t,f,b){return`${b.updateUrl}/api/update/${t}/${f}/${b.commit}`}e.createUpdateURL=g;let w=class{constructor(f,b,v,P,c,a){this.lifecycleMainService=f,this.configurationService=b,this.environmentMainService=v,this.requestService=P,this.logService=c,this.productService=a,this._state=S.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.getUpdateMode(),b=this.getProductQuality(f);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(S.State.Idle(this.getUpdateType())),f==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(f){return f==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(f=60*60*1e3){return(0,p.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(f){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};w=he([x(0,E.ILifecycleMainService),x(1,k.IConfigurationService),x(2,I.IEnvironmentMainService),x(3,i.IRequestService),x(4,h.ILogService),x(5,d.IProductService)],w),e.AbstractUpdateService=w}),define(Q[230],J([0,1,13,47,4,2,19,24,22,6,21,50,30,41,77]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let f=class extends t.AbstractUpdateService{constructor(v,P,c,a,u,n,o){super(v,P,a,u,n,o);this.telemetryService=c,this.disposables=new k.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,P)=>P)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(w.State.Idle(1,c))}buildUpdateFeedUrl(v){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,v,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(v){this.setState(w.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(w.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],f.prototype,"onRawError",null),he([L.memoize],f.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],f.prototype,"onRawUpdateAvailable",null),he([L.memoize],f.prototype,"onRawUpdateDownloaded",null),f=he([x(0,h.ILifecycleMainService),x(1,I.IConfigurationService),x(2,g.ITelemetryService),x(3,E.IEnvironmentMainService),x(4,S.IRequestService),x(5,d.ILogService),x(6,i.IProductService)],f),e.DarwinUpdateService=f}),define(Q[231],J([0,1,44,29,9,4,8,24,22,6,30,41]),function(H,e,p,L,M,k,I,E,h,d,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let g=class{constructor(f,b,v){if(this.lifecycleMainService=f,this.logService=v,this._state=S.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(f){this.logService.info("update#setState",f.type),this._state=f,this._onStateChange.fire(f)}scheduleCheckForUpdates(f=60*60*1e3){return(0,M.timeout)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(f){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(f)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(f){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(f=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};g=he([x(0,h.ILifecycleMainService),x(1,E.IEnvironmentMainService),x(2,d.ILogService)],g);let w=class extends g{constructor(f,b,v,P,c,a){super(v,P,c);this.snap=f,this.snapRevision=b,this.telemetryService=a;const u=(0,L.watch)(I.dirname(this.snap)),n=k.Event.fromNodeEventEmitter(u,"change",(l,m)=>m),o=k.Event.filter(n,l=>l==="current"),r=k.Event.debounce(o,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(f=>{f?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,f.message||f))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+I.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const f=await new Promise((v,P)=>(0,L.realpath)(`${I.dirname(this.snap)}/current`,(c,a)=>c?P(c):v(a))),b=I.basename(f);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,f=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=he([x(2,h.ILifecycleMainService),x(3,E.IEnvironmentMainService),x(4,d.ILogService),x(5,i.ITelemetryService)],w),e.SnapUpdateService=w}),define(Q[46],J([0,1,13,29,4,39,34,2,10,8,3,15,14,20,157,51,52,24,5,6,21,101,26,102]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let s=class extends E.Disposable{constructor(l,m,y,D,R){super();this.environmentMainService=l,this.logService=m,this.backupMainService=y,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>w.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===h.Schemas.file)try{const y=m(l.fsPath);return y instanceof Promise?y.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,y)}catch{return}}isWorkspacePath(l){return(0,n.isUntitledWorkspace)(l,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const y=this.doParseStoredWorkspace(l,m),D=(0,o.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,n.toWorkspaceFolders)(y.folders,D.configPath,S.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority,transient:y.transient}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(l,m){const y=(0,k.parse)(m);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(D=>(0,n.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(l,m){const{workspace:y,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=y.configPath.fsPath;return await w.Promises.mkdir((0,d.dirname)(R),{recursive:!0}),await w.Promises.writeFile(R,JSON.stringify(D,null,"	")),y}createUntitledWorkspaceSync(l,m){const{workspace:y,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=y.configPath.fsPath;return(0,L.mkdirSync)((0,d.dirname)(R),{recursive:!0}),(0,w.writeFileSync)(R,JSON.stringify(D,null,"	")),y}newUntitledWorkspace(l=[],m){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,S.joinPath)(this.untitledWorkspacesHome,y),R=(0,S.joinPath)(D,n.UNTITLED_WORKSPACE_NAME),T=[];for(const _ of l)T.push((0,n.getStoredWorkspaceFolder)(_.uri,!0,_.name,D,!i.isWindows,S.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(R),storedWorkspace:{folders:T,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,o.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,n.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,S.originalFSPath)(l.configPath);try{(0,w.rimrafSync)((0,d.dirname)(m));const y=(0,d.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(y)&&(0,w.writeFileSync)((0,d.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${m} (${y}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,S.joinPath)(this.untitledWorkspacesHome,y,n.UNTITLED_WORKSPACE_NAME));for(const y of m){const D=(0,o.getWorkspaceIdentifier)(y),R=this.resolveLocalWorkspaceSync(y);R?l.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,y){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,y))return;const R=this.doEnterWorkspace(l,(0,o.getWorkspaceIdentifier)(y));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,m,y){if(!y)return!0;if((0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,y))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(m,y)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,S.basename)(y)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,g.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let y;return l.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,n.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=y,{workspace:m,backupPath:y}}};s=he([x(0,v.IEnvironmentMainService),x(1,c.ILogService),x(2,f.IBackupMainService),x(3,b.IDialogMainService),x(4,a.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Q[103],J([0,1,13,31,23,3,14,7,20,19,54,5,6,99,36,26,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let v=class{constructor(c,a,u,n,o){this.logService=c,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=n,this.configurationService=o}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),k.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(c);if(u.length){let n=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(n=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),n.then(()=>{for(const{uri:o,url:s}of u)this.urlService.open(o,{originalUrl:s})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,L.coalesce)(c._urls.map(a=>{try{return{uri:E.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(c,a){const u=(0,i.isLaunchedFromCli)(a)?0:4;let n=[];const o=c.wait&&c.waitMarkerFilePath?E.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0,r={context:u,cli:c,userEnv:a,waitMarkerFileURI:o,remoteAuthority:s};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,r);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let l=!1;if(c["new-window"]||c["unity-launch"])l=!0;else if(c["reuse-window"])l=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":l=!0;break;case"off":l=!1;break;default:l=!k.isMacintosh}if(l)n=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const m=this.windowsMainService.getLastActiveWindow();m?(this.windowsMainService.openExistingWindow(m,r),n=[m]):n=this.windowsMainService.open({...r,forceEmpty:!0})}}else n=this.windowsMainService.open({...r,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(o&&n.length===1&&n[0])return Promise.race([n[0].whenClosedOrLoaded,(0,h.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?c.push(this.codeWindowToInfo(u)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(n=>new Promise(o=>{const s=n.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${n.id}`,l={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(n):void 0};n.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:r,args:l}),p.ipcMain.once(r,(m,y)=>{y||o({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),o(y)}),setTimeout(()=>{o({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else o(void 0)})))).filter(n=>!!n)}getFolderURIs(c){const a=[],u=c.openedWorkspace;if((0,f.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,f.isWorkspaceIdentifier)(u)){const n=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);n&&n.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),u=(0,I.assertIsDefined)(c.win);return this.browserWindowToInfo(u,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],u){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:u}}};v=he([x(0,g.ILogService),x(1,t.IWindowsMainService),x(2,w.IURLService),x(3,b.IWorkspacesManagementMainService),x(4,d.IConfigurationService)],v),e.LaunchMainService=v}),define(Q[53],J([0,1,44,13,25,116,47,4,34,2,10,8,3,7,82,71,20,149,52,24,5,22,6,21,30,66,36,26,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o,s,r,l,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let D=class ut extends d.Disposable{constructor(T,_,j,te,se,oe,G,F,B,V){super();this.sharedProcess=T,this.windowsMainService=_,this.dialogMainService=j,this.lifecycleMainService=te,this.environmentMainService=se,this.telemetryService=oe,this.logService=G,this.productService=F,this.themeMainService=B,this.workspacesManagementMainService=V,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,C=>C.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(C,N)=>N.id),C=>!!this.windowsMainService.getWindowById(C)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(C,N)=>N.id),C=>!!this.windowsMainService.getWindowById(C)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(C,N)=>N.id),C=>!!this.windowsMainService.getWindowById(C)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),C=>!!C),C=>C.id),E.Event.filter(E.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(C,N)=>N.id),C=>!!this.windowsMainService.getWindowById(C))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(C,N,U)=>U),C=>!(Array.isArray(C)&&C.length===1&&C[0]==="workArea")),E.Event.fromNodeEventEmitter(L.screen,"display-added"),E.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(_=>({id:_.id,workspace:_.openedWorkspace,title:_.win?.getTitle()??"",filename:_.getRepresentedFilename(),dirty:_.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const _=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(_)return _.id}openWindow(T,_,j){return Array.isArray(_)?this.doOpenWindow(T,_,j):this.doOpenEmptyWindow(T,_)}async doOpenWindow(T,_,j=Object.create(null)){_.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:_,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0})}async doOpenEmptyWindow(T,_){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},_)}async toggleFullScreen(T){const _=this.windowById(T);_&&_.toggleFullScreen()}async handleTitleDoubleClick(T){const _=this.windowById(T);_&&_.handleTitleDoubleClick()}async isMaximized(T){const _=this.windowById(T);return _?.win?_.win.isMaximized():!1}async maximizeWindow(T){const _=this.windowById(T);_?.win&&_.win.maximize()}async unmaximizeWindow(T){const _=this.windowById(T);_?.win&&_.win.unmaximize()}async minimizeWindow(T){const _=this.windowById(T);_?.win&&_.win.minimize()}async focusWindow(T,_){_&&typeof _.windowId=="number"&&(T=_.windowId);const j=this.windowById(T);j&&j.focus({force:_?.force??!1})}async setMinimumSize(T,_,j){const te=this.windowById(T);if(te?.win){const[se,oe]=te.win.getSize(),[G,F]=te.win.getMinimumSize(),[B,V]=[_??G,j??F],[C,N]=[Math.max(se,B),Math.max(oe,V)];(G!==B||F!==V)&&te.win.setMinimumSize(B,V),(se!==C||oe!==N)&&te.win.setSize(C,N)}}async saveWindowSplash(T,_){this.themeMainService.saveWindowSplash(T,_)}async installShellCommand(T){const{source:_,target:j}=await this.getShellCommandLink();try{const{symbolicLink:te}=await b.SymlinkSupport.stat(_);if(te&&!te.dangling){const se=await(0,t.realpath)(_);if(j===se)return}await b.Promises.unlink(_)}catch(te){if(te.code!=="ENOENT")throw te}try{await b.Promises.symlink(j,_)}catch(te){if(te.code!=="EACCES"&&te.code!=="ENOENT")throw te;const{response:se}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${_}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(oe)}catch(oe){throw new Error((0,v.localize)(3,null,_))}}}async uninstallShellCommand(T){const{source:_}=await this.getShellCommandLink();try{await b.Promises.unlink(_)}catch(j){switch(j.code){case"EACCES":const{response:te}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const se=`osascript -e "do shell script \\"rm '${_}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(se)}catch(se){throw new Error((0,v.localize)(7,null,_))}break;case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const T=(0,S.resolve)(this.environmentMainService.appRoot,"bin","code"),_=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(T))throw new Error((0,v.localize)(8,null,T));return{source:_,target:T}}async showMessageBox(T,_){return this.dialogMainService.showMessageBox(_,this.toBrowserWindow(T))}async showSaveDialog(T,_){return this.dialogMainService.showSaveDialog(_,this.toBrowserWindow(T))}async showOpenDialog(T,_){return this.dialogMainService.showOpenDialog(_,this.toBrowserWindow(T))}toBrowserWindow(T){const _=this.windowById(T);if(_?.win)return _.win}async pickFileFolderAndOpen(T,_){const j=await this.dialogMainService.pickFileFolder(_);j&&(this.sendPickerTelemetry(j,_.telemetryEventName||"openFileFolder",_.telemetryExtraData),this.doOpenPicked(await Promise.all(j.map(async te=>await b.SymlinkSupport.existsDirectory(te)?{folderUri:w.URI.file(te)}:{fileUri:w.URI.file(te)})),_,T))}async pickFolderAndOpen(T,_){const j=await this.dialogMainService.pickFolder(_);j&&(this.sendPickerTelemetry(j,_.telemetryEventName||"openFolder",_.telemetryExtraData),this.doOpenPicked(j.map(te=>({folderUri:w.URI.file(te)})),_,T))}async pickFileAndOpen(T,_){const j=await this.dialogMainService.pickFile(_);j&&(this.sendPickerTelemetry(j,_.telemetryEventName||"openFile",_.telemetryExtraData),this.doOpenPicked(j.map(te=>({fileUri:w.URI.file(te)})),_,T))}async pickWorkspaceAndOpen(T,_){const j=await this.dialogMainService.pickWorkspace(_);j&&(this.sendPickerTelemetry(j,_.telemetryEventName||"openWorkspace",_.telemetryExtraData),this.doOpenPicked(j.map(te=>({workspaceUri:w.URI.file(te)})),_,T))}doOpenPicked(T,_,j){this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:_.forceNewWindow})}sendPickerTelemetry(T,_,j){const te=T?T.length:0;this.telemetryService.publicLog(_,{...j,outcome:te?"success":"canceled",numberOfPaths:te})}async showItemInFolder(T,_){L.shell.showItemInFolder(_)}async setRepresentedFilename(T,_){const j=this.windowById(T);j&&j.setRepresentedFilename(_)}async setDocumentEdited(T,_){const j=this.windowById(T);j&&j.setDocumentEdited(_)}async openExternal(T,_){return g.isLinuxSnap?this.safeSnapOpenExternal(_):L.shell.openExternal(_),!0}safeSnapOpenExternal(T){const _=process.env.GDK_PIXBUF_MODULE_FILE,j=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=_,process.env.GDK_PIXBUF_MODULEDIR=j}moveItemToTrash(T,_){return L.shell.trashItem(_)}async isAdmin(){let T;return g.isWindows?T=(await new Promise((_,j)=>{H(["native-is-elevated"],_,j)}))():T=process.getuid()===0,T}async writeElevated(T,_,j,te){const se=await new Promise((oe,G)=>{H(["sudo-prompt"],oe,G)});return new Promise((oe,G)=>{const F=[`"${this.cliPath}"`];te?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${_.fsPath}"`,`"${j.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:g.isMacintosh&&this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(F.join(" "),B,(V,C,N)=>{C&&this.logService.trace(`[sudo-prompt] received stdout: ${C}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),V?G(V):oe(void 0)})})}get cliPath(){return g.isWindows?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):g.isLinux?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,S.join)(this.environmentMainService.appRoot,"bin","code"):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return f.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(T,_,j){process.kill(_,j)}async readClipboardText(T,_){return L.clipboard.readText(_)}async writeClipboardText(T,_,j){return L.clipboard.writeText(_,j)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,_){return L.clipboard.writeFindText(_)}async writeClipboardBuffer(T,_,j,te){return L.clipboard.writeBuffer(_,Buffer.from(j),te)}async readClipboardBuffer(T,_){return L.clipboard.readBuffer(_)}async hasClipboard(T,_,j){return L.clipboard.has(_,j)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,_){const j=this.windowById(T);j&&j.updateTouchBar(_)}async notifyReady(T){const _=this.windowById(T);_&&_.setReady()}async relaunch(T,_){return this.lifecycleMainService.relaunch(_)}async reload(T,_){const j=this.windowById(T);if(j){if((0,m.isWorkspaceIdentifier)(j.openedWorkspace)){const te=j.openedWorkspace.configPath;if(te.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(te))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,_?.disableExtensions!==void 0?{_:[],"disable-extensions":_.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,_){const j=this.windowById(_);if(j?.win)return j.win.close()}async quit(T){const _=this.windowsMainService.getLastActiveWindow();_?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&_.win?_.win.close():this.lifecycleMainService.quit()}async exit(T,_){await this.lifecycleMainService.kill(_)}async resolveProxy(T,_){const te=this.windowById(T)?.win?.webContents?.session;if(te)return te.resolveProxy(_)}async openDevTools(T,_){const j=this.windowById(T);j?.win&&j.win.webContents.openDevTools(_)}async toggleDevTools(T){const _=this.windowById(T);_?.win&&_.win.webContents.toggleDevTools()}async sendInputEvent(T,_){const j=this.windowById(T);j?.win&&(_.type==="mouseDown"||_.type==="mouseUp")&&j.win.webContents.sendInputEvent(_)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,_,j,te){if(!g.isWindows)return;const se=await new Promise((oe,G)=>{H(["vscode-windows-registry"],oe,G)});try{return se.GetStringRegKey(_,j,te)}catch{return}}async getPassword(T,_,j){const te=await this.withKeytar(),se=await te.getPassword(_,j);if(se)try{let{content:oe,hasNextChunk:G}=JSON.parse(se);if(!oe||!G)return se;let F=1;for(;G;){const B=await te.getPassword(_,`${j}-${F}`),V=JSON.parse(B);oe+=V.content,G=V.hasNextChunk,F++}return oe}catch{return se}return se}async setPassword(T,_,j,te){const se=await this.withKeytar(),oe=3,G=async(F,B,V)=>{let C=0,N;for(;C<oe;)try{await se.setPassword(F,B,V);return}catch(U){N=U,this.logService.warn("Error attempting to set a password: ",U),C++,await new Promise(Y=>setTimeout(Y,200))}throw N};if(g.isWindows&&te.length>ut.MAX_PASSWORD_LENGTH){let F=0,B=0,V=!0;for(;V;){const C=te.substring(F,F+ut.PASSWORD_CHUNK_SIZE);F+=ut.PASSWORD_CHUNK_SIZE,V=te.length-F>0;const N={content:C,hasNextChunk:V};await G(_,B?`${j}-${B}`:j,JSON.stringify(N)),B++}}else await G(_,j,te);this._onDidChangePassword.fire({service:_,account:j})}async deletePassword(T,_,j){const se=await(await this.withKeytar()).deletePassword(_,j);return se&&this._onDidChangePassword.fire({service:_,account:j}),se}async findPassword(T,_){return(await this.withKeytar()).findPassword(_)}async findCredentials(T,_){return(await this.withKeytar()).findCredentials(_)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((T,_)=>{H(["keytar"],T,_)})}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,he([I.memoize],D.prototype,"cliPath",null),D=he([x(1,l.IWindowsMainService),x(2,P.IDialogMainService),x(3,u.ILifecycleMainService),x(4,c.IEnvironmentMainService),x(5,s.ITelemetryService),x(6,n.ILogService),x(7,o.IProductService),x(8,r.IThemeMainService),x(9,y.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Q[232],J([0,1,13,23,4,81,2,28,89,6,53,21,36]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let t=class extends I.Disposable{constructor(b,v,P,c,a){super();this.logService=b,this.windowsMainService=v,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(p.app,"login",(v,P,c,a,u)=>({event:v,webContents:P,req:c,authInfo:a,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:v,req:P,callback:c}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(b);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const v=String((0,k.hash)({scheme:b.scheme,host:b.host,port:b.port}));let P,c;try{const o=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(o){const s=JSON.parse(await this.encryptionMainService.decrypt(o));P=s.username,c=s.password}}catch(o){this.logService.error(o)}if(this.state!==w.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=w.LoginDialogShown;const n=await new Promise(o=>{const s=async(r,l,m)=>{if(l===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",s),m){const y={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(y));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(D){this.logService.error(D)}o({username:y.username,password:y.password})}else o(void 0)};a.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=n,n}};t=he([x(0,d.ILogService),x(1,g.IWindowsMainService),x(2,i.INativeHostMainService),x(3,h.IEncryptionMainService),x(4,S.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[233],J([0,1,13,25,34,2,10,3,83,147,74,52,24,5,103,6,53,56,21,57,67]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");let u=class bt{constructor(o,s,r,l,m,y,D,R,T){this.userEnv=o,this.environmentMainService=s,this.launchMainService=r,this.logService=l,this.diagnosticsService=m,this.dialogMainService=y,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=T,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async o=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(o,"vscode:issueSystemInfoResponse",l)}),p.ipcMain.on("vscode:listProcesses",async o=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,d.localize)(0,null),rootProcess:await(0,h.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,i.isRemoteDiagnosticError)(m)?s.push({name:m.hostName,rootProcess:m}):m.processes&&s.push({name:m.hostName,rootProcess:m.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(o,"vscode:listProcessesResponse",s)}),p.ipcMain.on("vscode:issueReporterClipboard",async o=>{const s={title:this.productService.nameLong,message:(0,d.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,d.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,d.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(o,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async o=>{const s=await this.getPerformanceInfo();this.safeSend(o,"vscode:issuePerformanceInfoResponse",s)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const o={title:this.productService.nameLong,message:(0,d.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,d.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,d.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(o,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(o,s)=>{const{id:r,from:l,args:m}=s;let y;switch(l){case"issueReporter":y=this.issueReporterParentWindow;break;case"processExplorer":y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}y&&y.webContents.send("vscode:runAction",{id:r,from:l,args:m})}),p.ipcMain.on("vscode:openExternal",(o,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),p.ipcMain.on("vscode:closeIssueReporter",o=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",o=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async o=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(o,"vscode:windowsInfoResponse",s.windows)})}safeSend(o,s,...r){o.sender.isDestroyed()||o.sender.send(s,...r)}async openReporter(o){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new k.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,r,{backgroundColor:o.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:o,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(o){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new k.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,r,{backgroundColor:o.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:o.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:o,product:v.default}),this.processExplorerWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(o,s,r){const l=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:r.title,backgroundColor:r.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[o,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(o,s)}getWindowPosition(o,s,r){let l;const m=p.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(E.isMacintosh){const R=p.screen.getCursorScreenPoint();l=p.screen.getDisplayNearestPoint(R)}!l&&o&&(l=p.screen.getDisplayMatching(o.getBounds())),l||(l=p.screen.getPrimaryDisplay()||m[0])}const y={width:s,height:r},D=l.bounds;return y.x=D.x+D.width/2-y.width/2,y.y=D.y+D.height/2-y.height/2,D.width>0&&D.height>0&&(y.x<D.x&&(y.x=D.x),y.y<D.y&&(y.y=D.y),y.x>D.x+D.width&&(y.x=D.x),y.y>D.y+D.height&&(y.y=D.y),y.width>D.width&&(y.width=D.width),y.height>D.height&&(y.height=D.height)),y}async getPerformanceInfo(){try{const[o,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(o,s)}catch(o){throw this.logService.warn("issueService#getPerformanceInfo ",o.message),o}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([x(1,g.IEnvironmentMainService),x(2,t.ILaunchMainService),x(3,f.ILogService),x(4,i.IDiagnosticsService),x(5,S.IDialogMainService),x(6,b.INativeHostMainService),x(7,c.IProtocolMainService),x(8,P.IProductService)],u),e.IssueMainService=u}),define(Q[234],J([0,1,23,19,24,22,6,53,21,50,30,41,77]),function(H,e,p,L,M,k,I,E,h,d,i,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends g.AbstractUpdateService{constructor(f,b,v,P,c,a,u,n){super(f,b,P,c,a,n);this.telemetryService=v,this.nativeHostMainService=u}buildUpdateFeedUrl(f){return(0,g.createUpdateURL)(`linux-${process.arch}`,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(S.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},p.CancellationToken.None).then(d.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const v=f?b.message||b:void 0;this.setState(S.State.Idle(1,v))}))}async doDownloadUpdate(f){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(S.State.Idle(1))}};w=he([x(0,k.ILifecycleMainService),x(1,L.IConfigurationService),x(2,i.ITelemetryService),x(3,M.IEnvironmentMainService),x(4,d.IRequestService),x(5,I.ILogService),x(6,E.INativeHostMainService),x(7,h.IProductService)],w),e.LinuxUpdateService=w}),define(Q[235],J([0,1,44,29,25,9,23,47,8,7,113,20,19,24,18,22,6,53,21,50,30,41,77]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(m,y=1e3){for(;!m();)await(0,k.timeout)(y)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),s}let l=class extends n.AbstractUpdateService{constructor(y,D,R,T,_,j,te,se,oe){super(y,D,T,_,j,oe);this.telemetryService=R,this.fileService=te,this.nativeHostMainService=se}get cachePath(){const y=h.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return S.Promises.mkdir(y,{recursive:!0}).then(()=>y)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(y){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),r()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,n.createUpdateURL)(D,y,this.productService)}doCheckForUpdates(y){!this.url||(this.setState(u.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},I.CancellationToken.None).then(c.asJson).then(D=>{const R=r();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(T=>S.Promises.exists(T).then(_=>{if(_)return Promise.resolve(T);const j=D.url,te=D.hash,se=`${T}.tmp`;return this.requestService.request({url:j},I.CancellationToken.None).then(oe=>this.fileService.writeFile(d.URI.file(se),oe.stream)).then(te?()=>(0,i.checksum)(se,D.hash):()=>{}).then(()=>S.Promises.rename(se,T)).then(()=>T)})).then(T=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},_&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y});const R=y?D.message||D:void 0;this.setState(u.State.Idle(r(),R))}))}async doDownloadUpdate(y){y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(y){const D=await this.cachePath;return h.join(D,`CodeSetup-${this.productService.quality}-${y}.exe`)}async cleanup(y=null){const D=y?j=>!new RegExp(`${this.productService.quality}-${y}\\.exe$`).test(j):()=>!0,R=await this.cachePath,_=(await S.Promises.readdir(R)).filter(D).map(async j=>{try{await S.Promises.unlink(h.join(R,j))}catch(te){}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const y=this.state.update;this.setState(u.State.Updating(y));const D=await this.cachePath;this.availableUpdate.updateFilePath=h.join(D,`CodeSetup-${this.productService.quality}-${y.version}.flag`),await S.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,_=await new Promise((j,te)=>{H(["windows-mutex"],j,te)});o(()=>_.isActive(T)).then(()=>this.setState(u.State.Ready(y)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([E.memoize],l.prototype,"cachePath",null),l=he([x(0,f.ILifecycleMainService),x(1,g.IConfigurationService),x(2,a.ITelemetryService),x(3,w.IEnvironmentMainService),x(4,c.IRequestService),x(5,b.ILogService),x(6,t.IFileService),x(7,v.INativeHostMainService),x(8,P.IProductService)],l),e.Win32UpdateService=l}),define(Q[236],J([0,1,13,9,23,45,4,34,2,10,8,63,3,7,153,51,19,52,24,54,203,18,22,6,21,57,100,30,206,66,67,36,26,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o,s,r,l,m,y,D,R,T,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var te;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(te||(te={}));let se=class extends h.Disposable{constructor(G,F,B,V,C,N,U,Y,W,A,O,q,X,$,z){super();this.logService=F,this.environmentMainService=B,this.fileService=V,this.configurationService=N,this.themeMainService=U,this.workspacesManagementMainService=Y,this.backupMainService=W,this.telemetryService=A,this.dialogMainService=O,this.lifecycleMainService=q,this.productService=X,this.protocolMainService=$,this.windowsMainService=z,this._onWillLoad=this._register(new I.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new I.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new I.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new I.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Z,ee]=this.restoreWindowState(G.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const le=this.windowState.mode===0||this.windowState.mode===3,re=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:R.WindowMinimumSize.WIDTH,minHeight:R.WindowMinimumSize.HEIGHT,show:!le,title:this.productService.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,R.zoomLevelToZoomFactor)(re?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};g.isLinux?ie.icon=(0,i.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,i.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),g.isMacintosh&&(ie.acceptFirstMouse=!0,re?.clickThroughInactive===!1&&(ie.acceptFirstMouse=!1));const ae=g.isMacintosh&&re?.nativeTabs===!0;ae&&(ie.tabbingIdentifier=this.productService.nameShort);const ue=(0,R.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(ie.frame=!1)),(0,S.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(ie),(0,S.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&ue&&this._win.setSheetOffset(22),g.isMacintosh&&ee&&(!ae||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")){const de=this.windowState;this._win.setBounds({width:de.width,height:de.height,x:de.x,y:de.y})}le&&((0,S.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,S.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:Z=>C.globalStorage.get(Z),store:(Z,ee)=>C.globalStorage.set(Z,ee)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){g.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){g.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){g.isMacintosh&&G?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function F(){B.dispose(),V.dispose(),G()}const B=this.onDidClose(()=>F()),V=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(C,N,U)=>this.onWindowError(3,{reason:U,exitCode:N})),this._win.webContents.on("will-prevent-unload",C=>{C.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),F=C=>{for(let N=C;N;N=N.parent)if(N.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},B=C=>C.resourceType==="xhr"||F(C.frame);this._win.webContents.session.webRequest.onBeforeRequest((C,N)=>{const U=w.URI.parse(C.url);return U.path.endsWith(".svg")&&!G.has(U.scheme)?N({cancel:!B(C)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,N)=>{const U=C.responseHeaders,Y=U["content-type"]||U["Content-Type"];if(Y&&Array.isArray(Y)){const W=w.URI.parse(C.url);if(W.path.endsWith(".svg")&&G.has(W.scheme))return U["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:U});if(!W.path.includes(d.Schemas.vscodeRemoteResource)&&Y.some(A=>A.toLowerCase().includes("image/svg")))return N({cancel:!B(C)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(C,N)=>{const U=await this.marketplaceHeadersPromise;N({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,U)})})}async onWindowError(G,F){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:F?.reason,code:F?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(B.response!==1){const V=B.response===0;this.destroyWindow(V)}}else if(G===2){let B;F?B=(0,t.localize)(6,null,F.reason,F.exitCode??"<unknown>"):B=(0,t.localize)(5,null);const C=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,t.localize)(8,null))],message:B,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(C)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let F,B;(0,_.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?F={folderUri:this.openedWorkspace.uri}:(0,_.isWorkspaceIdentifier)(this.openedWorkspace)?F={workspaceUri:this.openedWorkspace.configPath}:B=!0;const[V]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:F?[F]:void 0,forceEmpty:B,forceNewWindow:!0});V.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let F=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=F,this.currentNoProxy=B;const V=F||"",C=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${C}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:C,pacScript:""})}}addTabbedWindow(G){g.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,F=Object.create(null)){this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,F),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:F.isReload?3:B?2:1})}updateConfiguration(G,F){const B=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(B){const V=(0,c.isLaunchedFromCli)(B)&&!(0,c.isLaunchedFromCli)(G.userEnv),C=this.isExtensionDevelopmentHost;(V||C)&&(G.userEnv={...B,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(G["disable-extensions"]=F.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,S.mark)("code/willOpenNewWindow"),G.perfMarks=(0,S.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const F=Object.assign({},this.currentConfig);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToWait,this.isExtensionDevelopmentHost&&G&&(F.verbose=G.verbose,F.debugId=G.debugId,F.extensionEnvironment=G.extensionEnvironment,F["inspect-extensions"]=G["inspect-extensions"],F["inspect-brk-extensions"]=G["inspect-brk-extensions"],F["extensions-dir"]=G["extensions-dir"]),F.isInitialStartup=!1,this.load(F,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,_.isWorkspaceIdentifier)(G.workspace)){const F=G.workspace.configPath;if(F.scheme===d.Schemas.file&&!await this.fileService.exists(F))return}else if((0,_.isSingleFolderWorkspaceIdentifier)(G.workspace)){const F=G.workspace.uri;if(F.scheme===d.Schemas.file&&!await this.fileService.exists(F))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,T.defaultWindowState)();if(this.isFullScreen){let B;try{B=p.screen.getDisplayMatching(this.getBounds())}catch(N){}const V=(0,T.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let F;if(!g.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?G.mode=0:G.mode=1,F===1||F===0){let B;F===1?B=this.getBounds():B=this._win.getNormalBounds(),G.x=B.x,G.y=B.y,G.width=B.width,G.height=B.height}return G}restoreWindowState(G){(0,S.mark)("code/willRestoreCodeWindowState");let F=!1;if(G)try{const B=p.screen.getAllDisplays();F=B.length>1,G=this.validateWindowState(G,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,S.mark)("code/didRestoreCodeWindowState"),[G||(0,T.defaultWindowState)(),F]}validateWindowState(G,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const C=this.getWorkingArea(F[0]);if(C){let N=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!C||(G.x<C.x&&(G.x=C.x),G.y<C.y&&(G.y=C.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",C),N(),G.width>C.width&&(G.width=C.width),G.height>C.height&&(G.height=C.height),G.x>C.x+C.width-128&&(G.x=C.x+C.width-G.width),G.y>C.y+C.height-128&&(G.y=C.y+C.height-G.height),N()}return G}if(G.display&&G.mode===3){const C=F.find(N=>N.id===G.display);if(C&&typeof C.bounds?.x=="number"&&typeof C.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,T.defaultWindowState)(3);return N.x=C.bounds.x,N.y=C.bounds.y,N}}let B,V;try{B=p.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(B)}catch(C){}if(B&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,F]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:G,y:F,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,R.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,F=!0){g.isMacintosh||(G==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const F=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,F,...B){this.isReady?this.send(G,...B):this.ready().then(()=>{F.isCancellationRequested||this.send(G,...B)})}send(G,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}try{this._win.webContents.send(G,...F)}catch(B){this.logService.warn(`Error sending IPC message to channel '${G}' of window ${this._id}: ${(0,k.toErrorMessage)(B)}`)}}}updateTouchBar(G){!g.isMacintosh||this.touchBarGroups.forEach((F,B)=>{const V=G[B];F.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!g.isMacintosh){for(let G=0;G<10;G++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const F=this.createTouchBarGroupSegments(G),B=new p.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(G=[]){return G.map(B=>{let V;B.icon&&!y.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===d.Schemas.file&&(V=p.nativeImage.createFromPath(w.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let C;return typeof B.title=="string"?C=B.title:C=B.title.value,{id:B.id,label:V?void 0:C,icon:V}})}dispose(){super.dispose(),this._win=null}};se=he([x(1,o.ILogService),x(2,P.IEnvironmentMainService),x(3,u.IFileService),x(4,l.IStorageMainService),x(5,b.IConfigurationService),x(6,D.IThemeMainService),x(7,j.IWorkspacesManagementMainService),x(8,f.IBackupMainService),x(9,m.ITelemetryService),x(10,v.IDialogMainService),x(11,n.ILifecycleMainService),x(12,s.IProductService),x(13,r.IProtocolMainService),x(14,T.IWindowsMainService)],se),e.CodeWindow=se}),define(Q[68],J([0,1,13,31,9,4,34,2,10,3,15,7,20,156,5,22,6,38,26,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class ze extends E.Disposable{constructor(n,o,s,r){super();this.stateMainService=n,this.logService=o,this.workspacesManagementMainService=s,this.lifecycleMainService=r,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace}])))}handleWindowsJumpList(){!d.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(n){const o=[],s=[];for(let r of n)if((0,P.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(o,r.workspace)===-1&&o.push(r);else if((0,P.isRecentFolder)(r))this.indexOfFolder(o,r.folderUri)===-1&&o.push(r);else{const l=this.indexOfFile(s,r.fileUri)>=0,m=r.fileUri.scheme===h.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,i.basename)(r.fileUri))>=0;!l&&!m&&(s.push(r),d.isWindows&&r.fileUri.scheme===h.Schemas.file&&p.app.addRecentDocument(r.fileUri.fsPath))}this.addEntriesFromStorage(o,s),o.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(o.length=ze.MAX_TOTAL_RECENT_ENTRIES),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:o,files:s}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(n){const o=m=>{const y=this.location(m);for(const D of n)if(i.extUriBiasedIgnorePathCase.isEqual(D,y))return!1;return!0},s=this.getRecentlyOpened(),r=s.workspaces.filter(o),l=s.files.filter(o);(r.length!==s.workspaces.length||l.length!==s.files.length)&&(this.saveRecentlyOpened({files:l,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),d.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!d.isMacintosh)return;p.app.clearRecentDocuments();const n=this.getRecentlyOpened(),o=[];let s=0;for(let l=0;l<n.workspaces.length&&s<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const m=this.location(n.workspaces[l]);if(m.scheme===h.Schemas.file){const y=(0,i.originalFSPath)(m);await g.Promises.exists(y)&&(o.push(y),s++)}}const r=[];for(let l=0;l<n.files.length&&s<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const m=this.location(n.files[l]);if(m.scheme===h.Schemas.file){const y=(0,i.originalFSPath)(m);if(ze.COMMON_FILES_FILTER.includes((0,i.basename)(m))||o.includes(y))continue;await g.Promises.exists(y)&&(r.push(y),s++)}}r.reverse().forEach(l=>p.app.addRecentDocument(l)),o.reverse().forEach(l=>p.app.addRecentDocument(l))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(n){const o=[],s=[],r=n?.config?.workspace;(0,P.isWorkspaceIdentifier)(r)&&!this.workspacesManagementMainService.isUntitledWorkspace(r)?o.push({workspace:r}):(0,P.isSingleFolderWorkspaceIdentifier)(r)&&o.push({folderUri:r.uri});const l=n?.config?.filesToOpenOrCreate;if(l)for(let m of l){const y=m.fileUri;y&&this.indexOfFile(s,y)===-1&&s.push({fileUri:y})}return this.addEntriesFromStorage(o,s),{workspaces:o,files:s}}addEntriesFromStorage(n,o){let s=this.getRecentlyOpenedFromStorage();for(let r of s.workspaces){let l=(0,P.isRecentFolder)(r)?this.indexOfFolder(n,r.folderUri):this.indexOfWorkspace(n,r.workspace);l>=0?n[l].label=n[l].label||r.label:n.push(r)}for(let r of s.files){let l=this.indexOfFile(o,r.fileUri);l>=0?o[l].label=o[l].label||r.label:o.push(r)}}getRecentlyOpenedFromStorage(){const n=this.stateMainService.getItem(ze.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(n,this.logService)}saveRecentlyOpened(n){const o=(0,P.toStoreData)(n);this.stateMainService.setItem(ze.recentlyOpenedStorageKey,o)}updateWindowsJumpList(){if(!d.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let o=[];for(let l of p.app.getJumpListSettings().removedItems){const m=l.args;if(m){const y=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);y&&o.push(S.URI.parse(y[2]))}}this.removeRecentlyOpened(o);let s=!1;const r=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const m=(0,P.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:y,description:D}=this.getWindowsJumpListLabel(m,l.label);let R;return S.URI.isUri(m)?R=`--folder-uri "${m.toString()}"`:(s=!0,R=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:y.substr(0,255),description:D.substr(0,255),program:process.execPath,args:R,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&n.push({type:"custom",name:s?(0,w.localize)(2,null):(0,w.localize)(3,null),items:r})}n.push({type:"recent"});try{p.app.setJumpList(n)}catch(o){this.logService.warn("updateWindowsJumpList#setJumpList",o)}}getWindowsJumpListLabel(n,o){if(o)return{title:(0,I.splitName)(o).name,description:o};if(S.URI.isUri(n))return{title:(0,i.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,w.localize)(4,null),description:""};let s=(0,i.basename)(n.configPath);return s.endsWith(P.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,s),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,I.normalizeDriveLetter)(n.fsPath):n.toString()}location(n){return(0,P.isRecentFolder)(n)?n.folderUri:(0,P.isRecentFile)(n)?n.fileUri:n.workspace.configPath}indexOfWorkspace(n,o){return n.findIndex(s=>(0,P.isRecentWorkspace)(s)&&s.workspace.id===o.id)}indexOfFolder(n,o){return n.findIndex(s=>(0,P.isRecentFolder)(s)&&i.extUriBiasedIgnorePathCase.isEqual(s.folderUri,o))}indexOfFile(n,o){return n.findIndex(s=>i.extUriBiasedIgnorePathCase.isEqual(s.fileUri,o))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=he([x(0,v.IStateMainService),x(1,b.ILogService),x(2,c.IWorkspacesManagementMainService),x(3,f.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Q[237],J([0,1,13,9,23,34,3,7,148,19,24,22,6,185,53,21,38,30,41,67,36,68]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let o=class pt{constructor(l,m,y,D,R,T,_,j,te,se,oe){this.updateService=l,this.configurationService=m,this.windowsMainService=y,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=T,this.stateMainService=_,this.lifecycleMainService=j,this.logService=te,this.nativeHostMainService=se,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(I.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,_,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,_,j)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,_,j)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,_,j)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(j),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const y=this.productService.reportIssueUrl;y&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(y,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(I.language){const T=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${T}lang=${I.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!I.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!I.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!I.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=p.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(I.isMacintosh?new p.Menu:null);return}const m=new p.Menu;let y;if(I.isMacintosh){const R=new p.Menu;y=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(y)}if(I.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(T)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(T)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(T)}if(this.shouldDrawMenu("View")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(T)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(T)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(T)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(T)}let D;if(this.shouldDrawMenu("Window")){const R=new p.Menu;D=new p.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(T)}m.items&&m.items.length>0?p.Menu.setApplicationMenu(m):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),y=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const G=new p.Menu;this.setMenuById(G,"Preferences"),D=new p.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:G})}const R=new p.Menu,T=new p.MenuItem({label:h.localize(12,null),role:"services",submenu:R}),_=new p.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),j=new p.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new p.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new p.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),oe=[m];oe.push(...y),D&&oe.push(s(),D),oe.push(s(),T,s(),_,j,te,s(),se),oe.forEach(G=>l.append(G))}shouldDrawMenu(l){if(!I.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(y=>{if((0,w.isMenubarMenuItemSeparator)(y))l.append(s());else if((0,w.isMenubarMenuItemSubmenu)(y)){const D=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(y.label),submenu:D});this.setMenu(D,y.submenu.items),l.append(R)}else(0,w.isMenubarMenuItemRecentAction)(y)?l.append(this.createOpenRecentMenuItem(y)):(0,w.isMenubarMenuItemAction)(y)&&(y.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),I.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[y.id]?l.append(new p.MenuItem(this.likeAction(y.id,{label:this.mnemonicLabel(y.label),click:this.fallbackMenuHandlers[y.id]}))):l.append(this.createMenuItem(y.label,y.id,!1,y.checked)):l.append(this.createMenuItem(y.label,y.id,y.enabled!==!1,!!y.checked)):l.append(this.createMenuItem(y.label,y.id,y.enabled!==!1,!!y.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(y=>l.append(y)),l.append(s()))}createOpenRecentMenuItem(l){const m=E.URI.revive(l.uri),y=l.id,D=y==="openRecentFile"?{fileUri:m}:y==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new p.MenuItem(this.likeAction(y,{label:l.label,click:(R,T,_)=>{const j=this.isOptionClick(_);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:j,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!I.isMacintosh&&(l.ctrlKey||l.shiftKey)||I.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,y){const D={label:this.mnemonicLabel(l),role:y,enabled:!0};return new p.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(l){const m=new p.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),y=new p.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new p.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(s()),T.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,y,s(),R,...T,s(),D].forEach(_=>l.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,y,D){const R=this.mnemonicLabel(l),T=typeof m=="function"?m:(oe,G,F)=>{const B=oe?oe.userSettingsLabel:null;let V=m;Array.isArray(m)&&(V=this.isOptionClick(F)?m[1]:m[0]),B&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:V})},_=typeof y=="boolean"?y:this.windowsMainService.getWindowCount()>0,j=typeof D=="boolean"?D:!1,te={label:R,click:T,enabled:_};j&&(te.type="checkbox",te.checked=j);let se;return typeof m=="string"?se=m:Array.isArray(m)&&(se=m[0]),I.isMacintosh&&(se==="editor.action.clipboardCutAction"?te.role="cut":se==="editor.action.clipboardCopyAction"?te.role="copy":se==="editor.action.clipboardPasteAction"&&(te.role="paste"),se==="undo"?te.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?te.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(se,te))}makeContextAwareClickHandler(l,m){return(y,D,R)=>{const T=p.BrowserWindow.getFocusedWindow();if(!T)return m.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return m.inDevTools(T.webContents.devToolsWebContents);l(y,D||T,R)}}runActionInRenderer(l){let m=p.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const y=m?this.windowsMainService.getWindowById(m.id):void 0;if(y){if(this.logService.trace("menubar#runActionInRenderer",l),I.isMacintosh&&!this.environmentMainService.isBuilt&&!y.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};y.sendWhenReady("vscode:runAction",M.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};y.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const y=typeof l=="string"?this.keybindings[l]:void 0;if(y?.label){if(y.isNative!==!1)m.accelerator=y.label,m.userSettingsLabel=y.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${y.label}]`:m.label=`${m.label} [${y.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,y=!m.accelerator){y&&(m=this.withKeybinding(l,m));const D=m.click;return m.click=(R,T,_)=>{this.reportMenuActionTelemetry(l),D&&D(R,T,_)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:n})}mnemonicLabel(l){return(0,k.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=he([x(0,P.IUpdateService),x(1,d.IConfigurationService),x(2,a.IWindowsMainService),x(3,i.IEnvironmentMainService),x(4,v.ITelemetryService),x(5,u.IWorkspacesHistoryMainService),x(6,b.IStateMainService),x(7,S.ILifecycleMainService),x(8,g.ILogService),x(9,t.INativeHostMainService),x(10,f.IProductService)],o),e.Menubar=o;function s(){return new p.MenuItem({type:"separator"})}}),define(Q[238],J([0,1,5,22,6,237]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let I=class{constructor(h,d,i){this.instantiationService=h,this.lifecycleMainService=d,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(h,d){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(d,h)}};I=he([x(0,p.IInstantiationService),x(1,L.ILifecycleMainService),x(2,M.ILogService)],I),e.MenubarMainService=I}),define(Q[239],J([0,1,13,29,25,31,23,4,33,42,34,2,10,8,63,3,32,15,14,7,154,51,19,52,24,18,5,22,6,56,21,57,64,38,67,236,101,219,26,102,68,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o,s,r,l,m,y,D,R,T,_,j,te,se,oe,G,F,B,V,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,F.isWorkspaceIdentifier)(W?.workspace)}function U(W){return(0,F.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let Y=class Ze extends S.Disposable{constructor(A,O,q,X,$,z,Z,ee,le,re,ie,ae,ue,de,ve){super();this.machineId=A,this.initialUserEnv=O,this.logService=q,this.stateMainService=X,this.environmentMainService=$,this.lifecycleMainService=z,this.backupMainService=Z,this.configurationService=ee,this.workspacesHistoryMainService=le,this.workspacesManagementMainService=re,this.instantiationService=ie,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new G.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new S.DisposableStore;if(O.add(E.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const q of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(c.URI.file(q)));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(c.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,O){let q=this.environmentMainService.args;const X=O?.remoteAuthority||void 0,$=!0,z=O?.forceReuseWindow,Z=!z;return this.open({...A,cli:q,forceEmpty:$,forceNewWindow:Z,forceReuseWindow:z,remoteAuthority:X})}openExistingWindow(A,O){A.focus(),this.handleWaitMarkerFile(O,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],q=[],X=[],$=[],z=[];let Z,ee=0;const le=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",le);for(const ue of le)U(ue)?A.addMode?O.push(ue):q.push(ue):N(ue)?X.push(ue):ue.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Z.filesToOpenOrCreate.push(ue)):ue.backupPath?z.push({backupFolder:(0,w.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ee++;A.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),Z&&A.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...$),z.push(...this.backupMainService.getEmptyWindowBackupPaths())):z.length=0;const{windows:re,filesOpenedInWindow:ie}=this.doOpen(A,X,q,z,ee,Z,O);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${q.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ee})`),re.length>1)if(ie)ie.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,ve=!0;if(ue){const Pe=re.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Pe.length&&(Pe[0].focus(),de=!1,ve=!1)}if(de)for(let Pe=re.length-1;Pe>=0;Pe--){const we=re[Pe];if(!(we.openedWorkspace&&$.some(ge=>we.openedWorkspace&&ge.workspace.id===we.openedWorkspace.id)||we.backupPath&&z.some(ge=>we.backupPath&&ge.backupFolder===(0,w.basename)(we.backupPath)))){we.focus(),ve=!1;break}}ve&&re[re.length-1].focus()}const ae=Z&&Z.filesToDiff.length>0;if(!re.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!A.noRecentEntry){const ue=[];for(const de of le)N(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):U(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(A,re),re}handleWaitMarkerFile(A,O){const q=A.waitMarkerFileURI;A.context===0&&q&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(q)}catch(X){}})()}doOpen(A,O,q,X,$,z,Z){const ee=[];let le;function re(we,ge){ee.push(we),ge&&(le=we,z=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Z.length>0){const we=Z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(we);ge&&re(this.doAddFoldersToExistingWindow(ge,Z.map(be=>be.workspace.uri)))}const ue=q.length+O.length+X.length;if(z&&ue===0){const we=z.filesToOpenOrCreate[0]||z.filesToDiff[0],ge=this.getWindows().filter(ke=>z&&(0,v.isEqualAuthority)(ke.remoteAuthority,z.remoteAuthority));let be;we?.fileUri&&!ae&&((A.context===4||A.context===0||A.context===1)&&(be=(0,oe.findWindowOnFile)(ge,we.fileUri,ke=>ke.configPath.scheme===g.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(ge))),be?(0,F.isWorkspaceIdentifier)(be.openedWorkspace)?O.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):re(this.doOpenFilesInExistingWindow(A,be,z),!0):re(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const de=(0,k.distinct)(O,we=>we.workspace.id);if(de.length>0){const we=(0,k.coalesce)(de.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(we.length>0){const ge=we[0],be=(0,v.isEqualAuthority)(z?.remoteAuthority,ge.remoteAuthority)?z:void 0;re(this.doOpenFilesInExistingWindow(A,ge,be),!!be),ie=!0}de.forEach(ge=>{if(we.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===ge.workspace.id))return;const be=ge.remoteAuthority,ke=(0,v.isEqualAuthority)(z?.remoteAuthority,be)?z:void 0;re(this.doOpenFolderOrWorkspace(A,ge,ie,ke),!!ke),ie=!0})}const ve=(0,k.distinct)(q,we=>v.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(ve.length>0){const we=(0,k.coalesce)(ve.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(we.length>0){const ge=we[0],be=(0,v.isEqualAuthority)(z?.remoteAuthority,ge.remoteAuthority)?z:void 0;re(this.doOpenFilesInExistingWindow(A,ge,be),!!be),ie=!0}ve.forEach(ge=>{if(we.some(Fe=>(0,F.isSingleFolderWorkspaceIdentifier)(Fe.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Fe.openedWorkspace.uri,ge.workspace.uri)))return;const be=ge.remoteAuthority,ke=(0,v.isEqualAuthority)(z?.remoteAuthority,be)?z:void 0;re(this.doOpenFolderOrWorkspace(A,ge,ie,ke),!!ke),ie=!0})}const Pe=(0,k.distinct)(X,we=>we.backupFolder);if(Pe.length>0&&Pe.forEach(we=>{const ge=we.remoteAuthority,be=(0,v.isEqualAuthority)(z?.remoteAuthority,ge)?z:void 0;re(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!be),ie=!0}),ee.length===0||z){z&&!$&&$++;const we=z?z.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<$;ge++)re(this.doOpenEmpty(A,ie,we,z),!!z),ie=!0}return{windows:(0,k.distinct)(ee),filesOpenedInWindow:le}}doOpenFilesInExistingWindow(A,O,q){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const X={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToWait:q?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",I.CancellationToken.None,X),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const q={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",I.CancellationToken.None,q),A}doOpenEmpty(A,O,q,X,$){return!O&&!$&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:q,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}doOpenFolderOrWorkspace(A,O,q,X,$){return!q&&!$&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:$})}getPathsToOpen(A){let O,q=!1,X=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),q=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),q=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),X=!0),!A.addMode&&q){const $=O.filter(z=>U(z));if($.length>1){const z=$[0].remoteAuthority;if($.every(Z=>(0,v.isEqualAuthority)(Z.remoteAuthority,z))){const Z=this.workspacesManagementMainService.createUntitledWorkspaceSync($.map(ee=>({uri:ee.workspace.uri})));O.push({workspace:Z,remoteAuthority:z}),O=O.filter(ee=>!U(ee))}}}return A.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter($=>N($)||U($)||$.backupPath)),O}doExtractPathsFromAPI(A){const O=[],q={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const X of(0,k.coalesce)(A.urisToOpen||[])){const $=this.resolveOpenable(X,q);if($)$.label=X.label,O.push($);else{const z=this.resourceFromOpenable(X),Z={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:z.scheme===g.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:z.scheme===g.Schemas.file?(0,a.localize)(3,null,(0,i.getPathLabel)(z.fsPath,this.environmentMainService)):(0,a.localize)(4,null,z.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],q={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},X=A["folder-uri"];if(X)for(const Z of X){const ee=this.cliArgToUri(Z);if(ee){const le=this.resolveOpenable({folderUri:ee},q);le&&O.push(le)}}const $=A["file-uri"];if($)for(const Z of $){const ee=this.cliArgToUri(Z);if(ee){const le=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(Z)?{workspaceUri:ee}:{fileUri:ee},q);le&&O.push(le)}}const z=A._;for(const Z of z){const ee=q.remoteAuthority?this.doResolvePathRemote(Z,q):this.doResolveFilePath(Z,q);ee&&O.push(ee)}return O}cliArgToUri(A){try{const O=c.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const q=[];for(const X of O)if(X.workspace){const $=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});N($)&&q.push($)}else if(X.folderUri){const $=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});U($)&&q.push($)}else A!=="folders"&&X.backupPath&&q.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return q}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){let q=this.resourceFromOpenable(A);return q.scheme===g.Schemas.file?((0,te.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(q.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let q=this.resourceFromOpenable(A);const X=(0,_.getRemoteAuthority)(q)||O.remoteAuthority;if(q=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(q)),(0,te.isFileToOpen)(A)){if(O.gotoLineMode){const{path:$,line:z,column:Z}=(0,h.parseLineAndColumnAware)(q.path);return{fileUri:q.with({path:$}),selection:z?{startLineNumber:z,startColumn:Z||1}:void 0,remoteAuthority:X}}return{fileUri:q,remoteAuthority:X}}else if((0,te.isWorkspaceToOpen)(A))return{workspace:(0,B.getWorkspaceIdentifier)(q),remoteAuthority:X};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:X}}resourceFromOpenable(A){return(0,te.isWorkspaceToOpen)(A)?A.workspaceUri:(0,te.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let q,X;O.gotoLineMode&&({path:A,line:q,column:X}=(0,h.parseLineAndColumnAware)(A)),A=(0,h.sanitizeFilePath)((0,w.normalize)(A),(0,b.cwd)());try{const $=(0,L.statSync)(A);if($.isFile()){if(!O.forceOpenWorkspaceAsFile){const z=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(A));if(z)return z.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:z.id,configPath:z.configPath},type:r.FileType.File,exists:!0,remoteAuthority:z.remoteAuthority,transient:z.transient}}return{fileUri:c.URI.file(A),type:r.FileType.File,exists:!0,selection:q?{startLineNumber:q,startColumn:X||1}:void 0}}else{if($.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(c.URI.file(A),$),type:r.FileType.Directory,exists:!0};if(!f.isWindows&&A==="/dev/null")return{fileUri:c.URI.file(A),type:r.FileType.File,exists:!0}}}catch($){const z=c.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([z]),O.ignoreFileNotFound)return{fileUri:z,type:r.FileType.File,exists:!1}}}doResolvePathRemote(A,O){const q=A.charCodeAt(0),X=O.remoteAuthority;let $,z;O.gotoLineMode&&({path:A,line:$,column:z}=(0,h.parseLineAndColumnAware)(A)),q!==47&&((0,h.isWindowsDriveLetter)(q)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,h.toSlashes)(A)),A=`/${A}`);const Z=c.URI.from({scheme:g.Schemas.vscodeRemote,authority:X,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:Z,selection:$?{startLineNumber:$,startColumn:z||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(Z),remoteAuthority:X};if(O.gotoLineMode||w.posix.basename(A).indexOf(".")!==-1)return{fileUri:Z,selection:$?{startLineNumber:$,startColumn:z||1}:void 0,remoteAuthority:X}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:X}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),q=O?.openFoldersInNewWindow||"default",X=O?.openFilesInNewWindow||"off";let $=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(q==="on"||q==="off")&&($=q==="on");let z=!1;return A.forceNewWindow||A.forceReuseWindow?z=!!A.forceNewWindow&&!A.forceReuseWindow:(f.isMacintosh?A.context===1&&(z=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!A.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(z=X==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:z}}openExtensionDevelopmentHostWindow(A,O){const q=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(q)return this.lifecycleMainService.reload(q,O.cli),q.focus(),[q];let X=O.cli["folder-uri"]||[],$=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!X.length&&!$.length&&!O.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=re&&(re.workspace||re.folderUri);ie&&(c.URI.isUri(ie)?ie.scheme===g.Schemas.file?z=[ie.fsPath]:X=[ie.toString()]:ie.configPath.scheme===g.Schemas.file?z=[(0,v.originalFSPath)(ie.configPath)]:$=[ie.configPath.toString()])}let Z=O.remoteAuthority;for(const re of A)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=c.URI.parse(re),ae=(0,_.getRemoteAuthority)(ie);ae&&(Z?ae!==Z&&this.logService.error("more than one extension development path authority"):Z=ae)}z=z.filter(re=>{const ie=c.URI.file(re);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,v.isEqualAuthority)((0,_.getRemoteAuthority)(ie),Z)}),X=X.filter(re=>{const ie=this.cliArgToUri(re);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,v.isEqualAuthority)((0,_.getRemoteAuthority)(ie),Z):!1}),$=$.filter(re=>{const ie=this.cliArgToUri(re);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,v.isEqualAuthority)((0,_.getRemoteAuthority)(ie),Z):!1}),O.cli._=z,O.cli["folder-uri"]=X,O.cli["file-uri"]=$;const ee=!z.length&&!X.length&&!$.length,le={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ee,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:Z};return this.open(le)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),q={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let X;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const $=X.config;!q.extensionDevelopmentPath&&$&&!!$.extensionDevelopmentPath&&(q.extensionDevelopmentPath=$.extensionDevelopmentPath,q.verbose=$.verbose,q["inspect-brk-extensions"]=$["inspect-brk-extensions"],q.debugId=$.debugId,q.extensionEnvironment=$.extensionEnvironment,q["inspect-extensions"]=$["inspect-extensions"],q["extensions-dir"]=$["extensions-dir"])}else{const $=this.windowsStateHandler.getNewWindowState(q);(0,t.mark)("code/willCreateCodeWindow");const z=X=this.instantiationService.createInstance(se.CodeWindow,{state:$,extensionDevelopmentPath:q.extensionDevelopmentPath,isExtensionTestHost:!!q.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const ee=this.getLastActiveWindow();ee&&ee.addTabbedWindow(z)}Ze.WINDOWS.push(z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(z.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(z)),(0,d.once)(z.onDidClose)(()=>this.onWindowClosed(z)),(0,d.once)(z.onDidDestroy)(()=>this._onDidDestroyWindow.fire(z));const Z=(0,P.assertIsDefined)(z.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return q.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then($=>{$||this.doOpenInBrowserWindow(X,q,A)}):this.doOpenInBrowserWindow(X,q,A),X}doOpenInBrowserWindow(A,O,q){if(!O.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const X=q.emptyWindowBackupInfo&&q.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=Ze.WINDOWS.indexOf(A);Ze.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,v.isEqualAuthority)(O.remoteAuthority,A)))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(q=>q.lastFocusTime));return A.find(q=>q.lastFocusTime===O)}sendToFocused(A,...O){const q=this.getFocusedWindow()||this.getLastActiveWindow();q&&q.sendWhenReady(A,I.CancellationToken.None,...O)}sendToAll(A,O,q){for(const X of this.getWindows())q&&q.indexOf(X.id)>=0||X.sendWhenReady(A,I.CancellationToken.None,O)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(q=>q.id===A);return(0,k.firstOrDefault)(O)}getWindowByWebContents(A){const O=p.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};Y.WINDOWS=[],Y=he([x(2,y.ILogService),x(3,j.IStateMainService),x(4,s.IEnvironmentMainService),x(5,m.ILifecycleMainService),x(6,u.IBackupMainService),x(7,n.IConfigurationService),x(8,V.IWorkspacesHistoryMainService),x(9,C.IWorkspacesManagementMainService),x(10,l.IInstantiationService),x(11,o.IDialogMainService),x(12,r.IFileService),x(13,R.IProductService),x(14,T.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(Q[240],J([0,1,51,36,68,46]),function(H,e,p,L,M,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(h,d,i,S){this.workspacesManagementMainService=h,this.windowsMainService=d,this.workspacesHistoryMainService=i,this.backupMainService=S,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,d){const i=this.windowsMainService.getWindowById(h);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),d)}createUntitledWorkspace(h,d,i){return this.workspacesManagementMainService.createUntitledWorkspace(d,i)}deleteUntitledWorkspace(h,d){return this.workspacesManagementMainService.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(h,d){return this.workspacesManagementMainService.getWorkspaceIdentifier(d)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,d){return this.workspacesHistoryMainService.addRecentlyOpened(d)}async removeRecentlyOpened(h,d){return this.workspacesHistoryMainService.removeRecentlyOpened(d)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([x(0,k.IWorkspacesManagementMainService),x(1,L.IWindowsMainService),x(2,M.IWorkspacesHistoryMainService),x(3,p.IBackupMainService)],I),e.WorkspacesMainService=I}),define(Q[241],J([0,1,13,29,25,17,45,16,33,42,39,34,2,10,8,3,15,14,7,28,71,121,35,124,85,232,133,51,223,19,178,161,74,52,222,89,24,54,91,169,186,90,170,18,181,94,73,5,75,233,199,103,22,6,183,238,53,21,64,228,76,38,217,100,200,30,202,204,65,41,208,230,234,231,235,99,209,210,211,212,214,36,239,215,26,68,240,46]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o,s,r,l,m,y,D,R,T,_,j,te,se,oe,G,F,B,V,C,N,U,Y,W,A,O,q,X,$,z,Z,ee,le,re,ie,ae,ue,de,ve,Pe,we,ge,be,ke,Fe,Ne,We,Ve,xe,st,Ke,ht,et,K,ne,ce,pe,Ee,Re,Oe,Ce,Be,_e,$e,It,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends g.Disposable{constructor(fe,ye,Se,me,Ie,De,Me,Ae,Te,He){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=me,this.environmentMainService=Ie,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ae,this.fileService=Te,this.productService=He,this.configureSession(),this.registerListeners()}configureSession(){const fe=me=>me?.startsWith(`${w.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((me,Ie,De,Me)=>fe(Me.requestingUrl)?De(ye.has(Ie)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((me,Ie,De,Me)=>fe(Me.requestingUrl)?ye.has(Ie):!1);const Se=p.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,E.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,E.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Se,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),p.app.on("activate",(Se,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Se,me)=>{me.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),me.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let fe=[],ye;p.app.on("open-file",(Se,me)=>{this.logService.trace("app#open-file: ",me),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(me)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Se=>{const me=this.windowsMainService?.getWindowByWebContents(Se.sender);let Ie,De;return me?.config?(Ie=me.config,De={...process.env,...me.config.userEnv}):(Ie=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Ie,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(Se,me,Ie)=>{const De=this.validateNlsPath([me]);if(!De||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,k.VSBuffer.fromString(Ie))}),p.ipcMain.handle("vscode:readNlsFile",async(Se,...me)=>{const Ie=this.validateNlsPath(me);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,t.join)(ye,Se));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,h.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!f.isLinux)))return P.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;f.isWindows&&fe&&p.app.setAppUserModelId(fe);try{f.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const ye=new o.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:me,sharedProcessReady:Ie,sharedProcessClient:De}=this.setupSharedProcess(Se),Me=await this.initServices(Se,me,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,te.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,ye,De));const Ae=Me.invokeFunction(Te=>this.openFirstWindow(Te,ye));Me.invokeFunction(Te=>this.afterWindowOpen(Te,me)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Ae))}async resolveMachineId(){let fe=this.stateMainService.getItem(ke.machineIdKey);return(!fe||f.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,a.getMachineId)(),this.stateMainService.setItem(ke.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(de.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Ie,"main")})(),me=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:me,sharedProcessClient:Se}}async initServices(fe,ye,Se){const me=new q.ServiceCollection;switch(process.platform){case"win32":me.set(Ve.IUpdateService,new A.SyncDescriptor(et.Win32UpdateService));break;case"linux":f.isLinuxSnap?me.set(Ve.IUpdateService,new A.SyncDescriptor(ht.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(Ve.IUpdateService,new A.SyncDescriptor(Ke.LinuxUpdateService));break;case"darwin":me.set(Ve.IUpdateService,new A.SyncDescriptor(st.DarwinUpdateService));break}me.set(Oe.IWindowsMainService,new A.SyncDescriptor(Ce.WindowsMainService,[fe,this.userEnv])),me.set(j.IDialogMainService,new A.SyncDescriptor(j.DialogMainService)),me.set(z.ILaunchMainService,new A.SyncDescriptor(z.LaunchMainService)),me.set(_.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Se.then(De=>De.getChannel("diagnostics"))))),me.set(X.IIssueMainService,new A.SyncDescriptor(X.IssueMainService,[this.userEnv])),me.set(se.IEncryptionMainService,new A.SyncDescriptor(se.EncryptionMainService,[fe])),me.set($.IKeyboardLayoutMainService,new A.SyncDescriptor($.KeyboardLayoutMainService)),me.set(ie.INativeHostMainService,new A.SyncDescriptor(ie.NativeHostMainService,[ye])),me.set(Ee.IWebviewManagerService,new A.SyncDescriptor(Re.WebviewMainService)),me.set(_e.IWorkspacesService,new A.SyncDescriptor(It.WorkspacesMainService)),me.set(vt.IWorkspacesManagementMainService,new A.SyncDescriptor(vt.WorkspacesManagementMainService)),me.set($e.IWorkspacesHistoryMainService,new A.SyncDescriptor($e.WorkspacesHistoryMainService)),me.set(re.IMenubarMainService,new A.SyncDescriptor(re.MenubarMainService)),me.set(B.IExtensionUrlTrustService,new A.SyncDescriptor(V.ExtensionUrlTrustService)),me.set(ge.IStorageMainService,new A.SyncDescriptor(ge.StorageMainService)),f.isWindows?me.set(C.IExternalTerminalMainService,new A.SyncDescriptor(N.WindowsExternalTerminalService)):f.isMacintosh?me.set(C.IExternalTerminalMainService,new A.SyncDescriptor(N.MacExternalTerminalService)):f.isLinux&&me.set(C.IExternalTerminalMainService,new A.SyncDescriptor(N.LinuxExternalTerminalService));const Ie=new y.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(m.IBackupMainService,Ie),me.set(K.IURLService,new A.SyncDescriptor(ce.NativeURLService)),(0,We.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,n.getDelayedChannel)(Se.then(Ge=>Ge.getChannel("telemetryAppender"))),Me=new Fe.TelemetryAppenderClient(De),Ae=(0,be.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],He={appenders:[Me],commonProperties:Ae,piiPaths:Te,sendErrorTelemetry:!0};me.set(ke.ITelemetryService,new A.SyncDescriptor(Ne.TelemetryService,[He]))}else me.set(ke.ITelemetryService,We.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(me)}initChannels(fe,ye,Se){const me=n.ProxyChannel.fromService(fe.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me);const Ie=this.fileService.getProvider(w.Schemas.file);(0,v.assertType)(Ie instanceof W.DiskFileSystemProvider);const De=new Y.DiskFileSystemProviderChannel(Ie,this.logService);ye.registerChannel("localFilesystem",De);const Me=new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(Me)),Se.then(Le=>Le.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(Me)));const Ae=new xe.UpdateChannel(fe.get(Ve.IUpdateService));ye.registerChannel("update",Ae);const Te=n.ProxyChannel.fromService(fe.get(X.IIssueMainService));ye.registerChannel("issue",Te);const He=n.ProxyChannel.fromService(fe.get(se.IEncryptionMainService));ye.registerChannel("encryption",He);const Ge=n.ProxyChannel.fromService(fe.get(ve.ISignService));ye.registerChannel("sign",Ge);const tt=n.ProxyChannel.fromService(fe.get($.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",tt),this.nativeHostMainService=fe.get(ie.INativeHostMainService);const Ye=n.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Ye),Se.then(Le=>Le.registerChannel("nativeHost",Ye));const ft=n.ProxyChannel.fromService(fe.get(_e.IWorkspacesService));ye.registerChannel("workspaces",ft);const Ue=n.ProxyChannel.fromService(fe.get(re.IMenubarMainService));ye.registerChannel("menubar",Ue);const ot=n.ProxyChannel.fromService(fe.get(K.IURLService));ye.registerChannel("url",ot);const it=n.ProxyChannel.fromService(fe.get(B.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",it);const nt=n.ProxyChannel.fromService(fe.get(Ee.IWebviewManagerService));ye.registerChannel("webview",nt);const rt=this._register(new we.StorageDatabaseChannel(this.logService,fe.get(ge.IStorageMainService)));ye.registerChannel("storage",rt),Se.then(Le=>Le.registerChannel("storage",rt));const at=n.ProxyChannel.fromService(fe.get(C.IExternalTerminalMainService));ye.registerChannel("externalTerminal",at);const Xe=new le.LogLevelChannel(fe.get(ee.ILogService));ye.registerChannel("logLevel",Xe),Se.then(Le=>Le.registerChannel("logLevel",Xe));const Qe=new le.LoggerChannel(fe.get(ee.ILoggerService));ye.registerChannel("logger",Qe),Se.then(Le=>Le.registerChannel("logger",Qe));const lt=new T.ElectronExtensionHostDebugBroadcastChannel(fe.get(Oe.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(Oe.IWindowsMainService),me=fe.get(K.IURLService),Ie=fe.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Le=>{try{return{uri:P.URI.parse(Le),url:Le}}catch{return}}).filter(Le=>{if(!Le||this.shouldBlockURI(Le.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(Le.uri);return Je?(De.push(Je),!1):!0}),Ae=this,Te=this.environmentMainService,He=this.productService;me.registerHandler({async handleURL(Le,Je){if(Le.scheme===He.urlProtocol&&Le.path==="workspace"&&(Le=Le.with({authority:"file",path:P.URI.parse(Le.query).path,query:""})),Ae.shouldBlockURI(Le))return!0;const yt=Ae.getWindowOpenableFromProtocolLink(Le);if(yt){const[gt]=Se.open({context:5,cli:{...Te.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(f.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(Le)});return await gt.ready(),me.open(Le,Je)}return!1}});const Ge=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),tt=new n.StaticRouter(Le=>Ge.getActiveClientId().then(Je=>Le===Je)),Ye=new ne.URLHandlerRouter(tt),ft=ye.getChannel("urlHandler",Ye);me.registerHandler(new ne.URLHandlerChannelClient(ft)),this._register(new pe.ElectronURLListener(Me,me,Se,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ot=global.macOpenFiles,it=(0,G.isLaunchedFromCli)(process.env)?0:4,nt=Ue._.length,rt=!!Ue["folder-uri"],at=!!Ue["file-uri"],Xe=Ue["skip-add-to-recently-opened"]===!0,Qe=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,lt=Ue.remote||void 0;return De.length>0?Se.open({context:it,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!nt&&!rt&&!at?Se.open({context:it,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:lt}):ot.length&&!nt&&!rt&&!at?Se.open({context:1,cli:Ue,urisToOpen:ot.map(Le=>this.getWindowOpenableFromPathSync(Le)),noRecentEntry:Xe,waitMarkerFileURI:Qe,initialStartup:!0}):Se.open({context:it,cli:Ue,forceNewWindow:Ue["new-window"]||!nt&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:Xe,waitMarkerFileURI:Qe,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:lt})}shouldBlockURI(fe){return!!(fe.authority===w.Schemas.file&&f.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,l.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,l.localize)(1,null))],defaultId:0,cancelId:1,message:(0,l.localize)(2,null,(0,S.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,l.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===w.Schemas.file){const ye=P.URI.file(fe.fsPath);return(0,_e.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===w.Schemas.vscodeRemote){const ye=fe.path.indexOf(t.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),me=fe.path.substring(ye),Ie=P.URI.from({scheme:w.Schemas.vscodeRemote,authority:Se,path:me,query:fe.query,fragment:fe.fragment});return(0,_e.hasWorkspaceFileExtension)(me)?{workspaceUri:Ie}:/:[\d]+$/.test(me)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:P.URI.file(fe)};if((0,_e.hasWorkspaceFileExtension)(fe))return{workspaceUri:P.URI.file(fe)}}catch(ye){}return{fileUri:P.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const me=fe.get(ke.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Ae})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Te)),me.publicLog2("sharedprocesserror",{type:Me,reason:Ae?.reason,code:Ae?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Ie=this.productService.win32MutexName;if(f.isWindows&&Ie)try{const Me=H.__$__nodeRequire("windows-mutex").Mutex,Ae=new Me(Ie);(0,d.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Me,Ae)=>{Ae({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=fe.get(Ve.IUpdateService);(De instanceof et.Win32UpdateService||De instanceof Ke.LinuxUpdateService||De instanceof st.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Ge=(0,We.getTelemetryLevel)(this.configurationService)>=1,tt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ge},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],Ye=Ae.substring(0,Ae.length-2).concat(`,
`,tt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(Ye))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,ye,Se){try{return await(0,F.resolveShellEnv)(this.logService,fe,ye)}catch(me){const Ie=(0,I.toErrorMessage)(me);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.logService.error(Ie)}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(j.IDialogMainService);let me=!1;const Ie=async Me=>{if(me)return;me=!0;const Ae=await p.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,l.localize)(4,null),detail:(0,l.localize)(5,null,Ae),buttons:[(0,S.mnemonicButtonLabel)((0,l.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Ie(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Ie(!1)})}};dt=he([x(2,O.IInstantiationService),x(3,ee.ILogService),x(4,oe.IEnvironmentMainService),x(5,Z.ILifecycleMainService),x(6,D.IConfigurationService),x(7,Pe.IStateMainService),x(8,U.IFileService),x(9,ae.IProductService)],dt),e.CodeApplication=dt}),define(Q[247],J([0,1,13,29,31,9,45,16,33,42,34,10,8,63,3,32,27,20,35,58,241,11,19,190,201,24,54,164,18,180,94,73,173,75,22,95,6,184,96,56,21,57,187,97,225,50,227,76,198,38,229,65,66,207]),function(H,e,p,L,M,k,I,E,h,d,i,S,g,w,t,f,b,v,P,c,a,u,n,o,s,r,l,m,y,D,R,T,_,j,te,se,oe,G,F,B,V,C,N,U,Y,W,A,O,q,X,$,z,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ee{main(){try{this.startup()}catch(ie){console.error(ie.message),p.app.exit(1)}}async startup(){(0,E.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ie,ae,ue,de,ve,Pe,we]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,we.nameLong,ge),ge}await ie.invokeFunction(async ge=>{const be=ge.get(oe.ILogService),ke=ge.get(te.ILifecycleMainService),Fe=ge.get(y.IFileService),Ne=await this.claimInstance(be,ue,ke,ie,we,!0);return v.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(We=>{be.warn(`Error writing main lockfile: ${We.stack}`)}),Pe.logger=new F.SpdLogLogger("main",(0,g.join)(ue.logsPath,"main.log"),!0,Pe.getLevel()),(0,d.once)(ke.onWillShutdown)(We=>{Fe.dispose(),de.dispose(),We.join(v.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ie.createInstance(a.CodeApplication,Ne,ae).startup()})}catch(ge){ie.invokeFunction(this.quit,ge)}}createServices(){const ie=new j.ServiceCollection,ae={_serviceBrand:void 0,...B.default};ie.set(V.IProductService,ae);const ue=new r.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ie.set(r.IEnvironmentMainService,ue);const ve=new se.BufferLogService,Pe=new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(ue)),ve]);process.once("exit",()=>Pe.dispose()),ie.set(oe.ILogService,Pe);const we=new D.FileService(Pe);ie.set(y.IFileService,we);const ge=new R.DiskFileSystemProvider(Pe);we.registerProvider(S.Schemas.file,ge),ie.set(oe.ILoggerService,new G.LoggerService(Pe,we));const be=new o.ConfigurationService(ue.settingsResource,we);ie.set(n.IConfigurationService,be),ie.set(te.ILifecycleMainService,new T.SyncDescriptor(te.LifecycleMainService));const ke=new $.StateMainService(ue,Pe,we);return ie.set(X.IStateMainService,ke),ie.set(W.IRequestService,new T.SyncDescriptor(A.RequestMainService)),ie.set(Z.IThemeMainService,new T.SyncDescriptor(Z.ThemeMainService)),ie.set(O.ISignService,new T.SyncDescriptor(q.SignService)),ie.set(U.ITunnelService,new T.SyncDescriptor(Y.TunnelService)),ie.set(C.IProtocolMainService,new T.SyncDescriptor(N.ProtocolMainService)),[new _.InstantiationService(ie,!0),de,ue,be,ke,ve,ae]}patchEnvironment(ie){const ae={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ie,ae,ue){return k.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(de=>de?v.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ie,ae,ue,de,ve,Pe){let we;try{(0,w.mark)("code/willStartMainServer"),we=await(0,c.serve)(ae.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,d.once)(ue.onWillShutdown)(()=>we.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let be;try{be=await(0,c.connect)(ae.mainIPCHandle,"main")}catch(Ne){if(!Pe||t.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),Ne;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(We){throw ie.warn("Could not delete obsolete instance handle",We),We}return this.claimInstance(ie,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(Ne),be.dispose(),new Error(Ne)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Fe=P.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const Ne=new s.DiagnosticsService(z.NullTelemetryService,ve),We=await Fe.getMainProcessInfo(),Ve=await Fe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),xe=await Ne.getDiagnostics(We,Ve);throw console.log(xe),new E.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Fe,ie),ie.trace("Sending env to running instance..."),await Fe.start(ae.args,process.env),be.dispose(),ke&&clearTimeout(ke),new E.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new E.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(ie,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,M.coalesce)([ie.userDataPath,ie.extensionsPath,c.XDG_RUNTIME_DIR]).map(ve=>(0,i.getPathLabel)(ve,ie));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,I.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ie,ae,ue){p.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ie,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,ae){if(t.isWindows){const ue=await ie.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{H(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ie,ae){const ue=ie.get(oe.ILogService),de=ie.get(te.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ie=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const ae=(0,m.createWaitMarkerFile)(ie.verbose);ae&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ae),ie.waitMarkerFilePath=ae)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const ae=this.doValidatePaths(ie._,ie.goto);ie._=ae}return ie}doValidatePaths(ie,ae){const ue=(0,f.cwd)(),de=ie.map(we=>{let ge=String(we),be;ae&&(be=(0,h.parseLineAndColumnAware)(ge),ge=be.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,h.sanitizeFilePath)(ge,ue),Fe=(0,g.basename)(ke);return Fe&&!(0,h.isValidBasename)(Fe)?null:ae&&be?(be.path=ke,this.toPath(be)):ke}),ve=t.isWindows||t.isMacintosh,Pe=(0,M.distinct)(de,we=>we&&ve?we.toLowerCase():we||"");return(0,M.coalesce)(Pe)}preparePath(ie,ae){return t.isWindows&&(ae=(0,b.rtrim)(ae,'"')),ae=(0,b.trim)((0,b.trim)(ae," "),"	"),t.isWindows&&(ae=(0,g.resolve)(ie,ae),ae=(0,b.rtrim)(ae,".")),ae}toPath(ie){const ae=[ie.path];return typeof ie.line=="number"&&ae.push(String(ie.line)),typeof ie.column=="number"&&ae.push(String(ie.column)),ae.join(":")}}new ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/552af97a0170b43c9323bec62211feb184da9749/core/vs/code/electron-main/main.js.map
