/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Y=function(x){for(var t=[],L=0,I=x.length;L<I;L++)t[L]=J[x[L]];return t};define(J[56],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function L(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=L}),define(J[46],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function L(T){return(S,l,d)=>{let p=null,C=null;if(typeof d.value=="function"?(p="value",C=d.value):typeof d.get=="function"&&(p="get",C=d.get),!C)throw new Error("not supported");d[p]=T(C,l)}}t.createDecorator=L;function I(T,S,l){let d=null,p=null;if(typeof l.value=="function"?(d="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",p=l.get),!p)throw new Error("not supported");const C=`$memoize$${S}`;l[d]=function(...c){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,c)}),this[C]}}t.memoize=I;function b(T,S,l){return L((d,p)=>{const C=`$debounce$${p}`,c=`$debounce$result$${p}`;return function(...w){this[c]||(this[c]=l?l():void 0),clearTimeout(this[C]),S&&(this[c]=S(this[c],...w),w=[this[c]]),this[C]=setTimeout(()=>{d.apply(this,w),this[c]=l?l():void 0},T)}})}t.debounce=b;function D(T,S,l){return L((d,p)=>{const C=`$throttle$timer$${p}`,c=`$throttle$result$${p}`,w=`$throttle$lastRun$${p}`,u=`$throttle$pending$${p}`;return function(...h){if(this[c]||(this[c]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[c]=S(this[c],...h)),this[u])return;const v=this[w]+T;v<=Date.now()?(this[w]=Date.now(),d.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[w]=Date.now(),d.apply(this,[this[c]]),this[c]=l?l():void 0},v-Date.now()))}})}t.throttle=D}),define(J[57],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var L;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(L=t.ScanError||(t.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,r=e.length,a="",m=0,y=16,R=0;function P(ne){let de=0,z=0;for(;de<ne;){const H=e.charCodeAt(n);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;n++,de++}return de<ne&&(z=-1),z}function O(ne){n=ne,a="",m=0,y=16,R=0}function U(){const ne=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return R=3,e.substring(ne,n);let de=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;de=n}else R=3;return e.substring(ne,de)}function q(){let ne="",de=n;for(;;){if(n>=r){ne+=e.substring(de,n),R=2;break}const z=e.charCodeAt(n);if(z===34){ne+=e.substring(de,n),n++;break}if(z===92){if(ne+=e.substring(de,n),n++,n>=r){R=2;break}switch(e.charCodeAt(n++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:const re=P(4);re>=0?ne+=String.fromCharCode(re):R=4;break;default:R=5}de=n;continue}if(z>=0&&z<=31)if(l(z)){ne+=e.substring(de,n),R=2;break}else R=6;n++}return ne}function te(){if(a="",R=0,m=n,n>=r)return m=r,y=17;let ne=e.charCodeAt(n);if(S(ne)){do n++,a+=String.fromCharCode(ne),ne=e.charCodeAt(n);while(S(ne));return y=15}if(l(ne))return n++,a+=String.fromCharCode(ne),ne===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),y=14;switch(ne){case 123:return n++,y=1;case 125:return n++,y=2;case 91:return n++,y=3;case 93:return n++,y=4;case 58:return n++,y=6;case 44:return n++,y=5;case 34:return n++,a=q(),y=10;case 47:const de=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(de,n),y=12}if(e.charCodeAt(n+1)===42){n+=2;const z=r-1;let H=!1;for(;n<z;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,R=1),a=e.substring(de,n),y=13}return a+=String.fromCharCode(ne),n++,y=16;case 45:if(a+=String.fromCharCode(ne),n++,n===r||!d(e.charCodeAt(n)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),y=11;default:for(;n<r&&ce(ne);)n++,ne=e.charCodeAt(n);if(m!==n){switch(a=e.substring(m,n),a){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return a+=String.fromCharCode(ne),n++,y=16}}function ce(ne){if(S(ne)||l(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ne;do ne=te();while(ne>=12&&ne<=15);return ne}return{setPosition:O,getPosition:()=>n,scan:i?le:te,getToken:()=>y,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>R}}t.createScanner=T;function S(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function C(e,i){const n=[],r=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function R(P,O,U,q){m.value=P,m.offset=O,m.length=U,m.type=q,m.colonOffset=void 0,a=m}try{f(e,{onObjectBegin:(P,O)=>{if(i<=P)throw r;a=void 0,y=i>P,n.push("")},onObjectProperty:(P,O,U)=>{if(i<O||(R(P,O,U,"property"),n[n.length-1]=P,i<=O+U))throw r},onObjectEnd:(P,O)=>{if(i<=P)throw r;a=void 0,n.pop()},onArrayBegin:(P,O)=>{if(i<=P)throw r;a=void 0,n.push(0)},onArrayEnd:(P,O)=>{if(i<=P)throw r;a=void 0,n.pop()},onLiteralValue:(P,O,U)=>{if(i<O||(R(P,O,U,s(P)),i<=O+U))throw r},onSeparator:(P,O,U)=>{if(i<=O)throw r;if(P===":"&&a&&a.type==="property")a.colonOffset=O,y=!1,a=void 0;else if(P===","){const q=n[n.length-1];typeof q=="number"?n[n.length-1]=q+1:(y=!0,n[n.length-1]=""),a=void 0}}})}catch(P){if(P!==r)throw P}return{path:n,previousNode:a,isAtPropertyKey:y,matches:P=>{let O=0;for(let U=0;O<P.length&&U<n.length;U++)if(P[O]===n[U]||P[O]==="*")O++;else if(P[O]!=="**")return!1;return O===P.length}}}t.getLocation=C;function c(e,i=[],n=D.DEFAULT){let r=null,a=[];const m=[];function y(P){Array.isArray(a)?a.push(P):r!==null&&(a[r]=P)}return f(e,{onObjectBegin:()=>{const P={};y(P),m.push(a),a=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const P=[];y(P),m.push(a),a=P,r=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:y,onError:(P,O,U)=>{i.push({error:P,offset:O,length:U})}},n),a[0]}t.parse=c;function w(e,i=[],n=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){r.type==="property"&&(r.length=P-r.offset,r=r.parent)}function m(P){return r.children.push(P),P}f(e,{onObjectBegin:P=>{r=m({type:"object",offset:P,length:-1,parent:r,children:[]})},onObjectProperty:(P,O,U)=>{r=m({type:"property",offset:O,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:P,offset:O,length:U,parent:r})},onObjectEnd:(P,O)=>{r.length=P+O-r.offset,r=r.parent,a(P+O)},onArrayBegin:(P,O)=>{r=m({type:"array",offset:P,length:-1,parent:r,children:[]})},onArrayEnd:(P,O)=>{r.length=P+O-r.offset,r=r.parent,a(P+O)},onLiteralValue:(P,O,U)=>{m({type:s(P),offset:O,length:U,parent:r,value:P}),a(O+U)},onSeparator:(P,O,U)=>{r.type==="property"&&(P===":"?r.colonOffset=O:P===","&&a(O))},onError:(P,O,U)=>{i.push({error:P,offset:O,length:U})}},n);const R=r.children[0];return R&&delete R.parent,R}t.parseTree=w;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===r){n=m.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function h(e){if(!e.parent||!e.parent.children)return[];const i=h(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=h;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=v(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function g(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=g;function E(e,i,n=!1){if(g(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const m=E(r[a],i,n);if(m)return m}return e}}t.findNodeAtOffset=E;function f(e,i,n=D.DEFAULT){const r=T(e,!1);function a(X){return X?()=>X(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(X){return X?Z=>X(Z,r.getTokenOffset(),r.getTokenLength()):()=>!0}const y=a(i.onObjectBegin),R=m(i.onObjectProperty),P=a(i.onObjectEnd),O=a(i.onArrayBegin),U=a(i.onArrayEnd),q=m(i.onLiteralValue),te=m(i.onSeparator),ce=a(i.onComment),le=m(i.onError),ne=n&&n.disallowComments,de=n&&n.allowTrailingComma;function z(){for(;;){const X=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:ne||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(X){case 12:case 13:ne?H(10):ce();break;case 16:H(1);break;case 15:case 14:break;default:return X}}}function H(X,Z=[],_=[]){if(le(X),Z.length+_.length>0){let N=r.getToken();for(;N!==17;){if(Z.indexOf(N)!==-1){z();break}else if(_.indexOf(N)!==-1)break;N=z()}}}function re(X){const Z=r.getTokenValue();return X?q(Z):R(Z),z(),!0}function M(){switch(r.getToken()){case 11:let X=0;try{X=JSON.parse(r.getTokenValue()),typeof X!="number"&&(H(2),X=0)}catch(Z){H(2)}q(X);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return z(),!0}function k(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(re(!1),r.getToken()===6?(te(":"),z(),ee()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function W(){y(),z();let X=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(X||H(4,[],[]),te(","),z(),r.getToken()===2&&de)break}else X&&H(6,[],[]);k()||H(4,[],[2,5]),X=!0}return P(),r.getToken()!==2?H(7,[2],[]):z(),!0}function G(){O(),z();let X=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(X||H(4,[],[]),te(","),z(),r.getToken()===4&&de)break}else X&&H(6,[],[]);ee()||H(4,[],[4,5]),X=!0}return U(),r.getToken()!==4?H(8,[4],[]):z(),!0}function ee(){switch(r.getToken()){case 3:return G();case 1:return W();case 10:return re(!0);default:return M()}}return z(),r.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):ee()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}t.visit=f;function o(e,i){let n=T(e),r=[],a,m=0,y;do switch(y=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:m!==y&&r.push(e.substring(m,y)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),m=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function x(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function T(l){D.push(l,Date.now())}function S(){const l=[];for(let d=0;d<D.length;d+=2)l.push({name:D[d],startTime:D[d+1]});return l}return{mark:T,getMarks:S}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(b+T.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function L(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=L(I))}(),define(J[58],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var L;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(L=t.Source||(t.Source={}));var I;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(I=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(D,...T){const S=T.reduce((p,C)=>(p[C]=!0,p),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(p=>!S[p]).forEach(p=>{for(let C=0;C<l.length;C++)if(p.search(l[C])!==-1){delete D[p];break}})}t.sanitizeProcessEnvironment=b}),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var L=t();for(var I in L)(typeof exports=="object"?exports:x)[I]=L[I]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function L(I){if(t[I])return t[I].exports;var b=t[I]={i:I,l:!1,exports:{}};return x[I].call(b.exports,b,b.exports,L),b.l=!0,b.exports}return L.m=x,L.c=t,L.d=function(I,b,D){L.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:D})},L.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},L.t=function(I,b){if(1&b&&(I=L(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var D=Object.create(null);if(L.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var T in I)L.d(D,T,function(S){return I[S]}.bind(null,T));return D},L.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return L.d(b,"a",b),b},L.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},L.p="",L(L.s=0)}([function(x,t,L){(function(I){var b;t=x.exports=_,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,S=t.re=[],l=t.src=[],d=0,p=d++;l[p]="0|[1-9]\\d*";var C=d++;l[C]="[0-9]+";var c=d++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=d++;l[w]="("+l[p]+")\\.("+l[p]+")\\.("+l[p]+")";var u=d++;l[u]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var h=d++;l[h]="(?:"+l[p]+"|"+l[c]+")";var v=d++;l[v]="(?:"+l[C]+"|"+l[c]+")";var g=d++;l[g]="(?:-("+l[h]+"(?:\\."+l[h]+")*))";var E=d++;l[E]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var f=d++;l[f]="[0-9A-Za-z-]+";var o=d++;l[o]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var s=d++,e="v?"+l[w]+l[g]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[E]+"?"+l[o]+"?",n=d++;l[n]="^"+i+"$";var r=d++;l[r]="((?:<|>)?=?)";var a=d++;l[a]=l[C]+"|x|X|\\*";var m=d++;l[m]=l[p]+"|x|X|\\*";var y=d++;l[y]="[v=\\s]*("+l[m]+")(?:\\.("+l[m]+")(?:\\.("+l[m]+")(?:"+l[g]+")?"+l[o]+"?)?)?";var R=d++;l[R]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[E]+")?"+l[o]+"?)?)?";var P=d++;l[P]="^"+l[r]+"\\s*"+l[y]+"$";var O=d++;l[O]="^"+l[r]+"\\s*"+l[R]+"$";var U=d++;l[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=d++;l[q]="(?:~>?)";var te=d++;l[te]="(\\s*)"+l[q]+"\\s+",S[te]=new RegExp(l[te],"g");var ce=d++;l[ce]="^"+l[q]+l[y]+"$";var le=d++;l[le]="^"+l[q]+l[R]+"$";var ne=d++;l[ne]="(?:\\^)";var de=d++;l[de]="(\\s*)"+l[ne]+"\\s+",S[de]=new RegExp(l[de],"g");var z=d++;l[z]="^"+l[ne]+l[y]+"$";var H=d++;l[H]="^"+l[ne]+l[R]+"$";var re=d++;l[re]="^"+l[r]+"\\s*("+i+")$|^$";var M=d++;l[M]="^"+l[r]+"\\s*("+e+")$|^$";var k=d++;l[k]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[y]+")",S[k]=new RegExp(l[k],"g");var W=d++;l[W]="^\\s*("+l[y]+")\\s+-\\s+("+l[y]+")\\s*$";var G=d++;l[G]="^\\s*("+l[R]+")\\s+-\\s+("+l[R]+")\\s*$";var ee=d++;l[ee]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)b(X,l[X]),S[X]||(S[X]=new RegExp(l[X]));function Z(F,j){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(j?S[n]:S[s]).test(F))return null;try{return new _(F,j)}catch($){return null}}function _(F,j){if(F instanceof _){if(F.loose===j)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,j);b("SemVer",F,j),this.loose=j;var $=F.trim().match(j?S[n]:S[s]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var fe=+ae;if(fe>=0&&fe<T)return fe}return ae}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,j){var $=Z(F,j);return $?$.version:null},t.clean=function(F,j){var $=Z(F.trim().replace(/^[=v]+/,""),j);return $?$.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var j=0;do{var $=this.prerelease[j],ae=F.prerelease[j];if(b("prerelease compare",j,$,ae),$===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if($===void 0)return-1;if($!==ae)return A($,ae)}while(++j)},_.prototype.inc=function(F,j){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",j);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",j);break;case"prepatch":this.prerelease.length=0,this.inc("patch",j),this.inc("pre",j);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",j),this.inc("pre",j);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}j&&(this.prerelease[0]===j?isNaN(this.prerelease[1])&&(this.prerelease=[j,0]):this.prerelease=[j,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,j,$,ae){typeof $=="string"&&(ae=$,$=void 0);try{return new _(F,$).inc(j,ae).version}catch(fe){return null}},t.diff=function(F,j){if(Q(F,j))return null;var $=Z(F),ae=Z(j);if($.prerelease.length||ae.prerelease.length){for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return"pre"+fe;return"prerelease"}for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return fe},t.compareIdentifiers=A;var N=/^[0-9]+$/;function A(F,j){var $=N.test(F),ae=N.test(j);return $&&ae&&(F=+F,j=+j),$&&!ae?-1:ae&&!$?1:F<j?-1:F>j?1:0}function B(F,j,$){return new _(F,$).compare(new _(j,$))}function V(F,j,$){return B(F,j,$)>0}function K(F,j,$){return B(F,j,$)<0}function Q(F,j,$){return B(F,j,$)===0}function se(F,j,$){return B(F,j,$)!==0}function ie(F,j,$){return B(F,j,$)>=0}function me(F,j,$){return B(F,j,$)<=0}function ye(F,j,$,ae){var fe;switch(j){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F!==$;break;case"":case"=":case"==":fe=Q(F,$,ae);break;case"!=":fe=se(F,$,ae);break;case">":fe=V(F,$,ae);break;case">=":fe=ie(F,$,ae);break;case"<":fe=K(F,$,ae);break;case"<=":fe=me(F,$,ae);break;default:throw new TypeError("Invalid operator: "+j)}return fe}function ue(F,j){if(F instanceof ue){if(F.loose===j)return F;F=F.value}if(!(this instanceof ue))return new ue(F,j);b("comparator",F,j),this.loose=j,this.parse(F),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(F,j){return A(j,F)},t.major=function(F,j){return new _(F,j).major},t.minor=function(F,j){return new _(F,j).minor},t.patch=function(F,j){return new _(F,j).patch},t.compare=B,t.compareLoose=function(F,j){return B(F,j,!0)},t.rcompare=function(F,j,$){return B(j,F,$)},t.sort=function(F,j){return F.sort(function($,ae){return t.compare($,ae,j)})},t.rsort=function(F,j){return F.sort(function($,ae){return t.rcompare($,ae,j)})},t.gt=V,t.lt=K,t.eq=Q,t.neq=se,t.gte=ie,t.lte=me,t.cmp=ye,t.Comparator=ue;var Ie={};function ve(F,j){if(F instanceof ve)return F.loose===j?F:new ve(F.raw,j);if(F instanceof ue)return new ve(F.value,j);if(!(this instanceof ve))return new ve(F,j);if(this.loose=j,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,j,$,ae,fe,Ce,we,Oe,Pe,Re,Ne,De,Te){return((j=Ee($)?"":Ee(ae)?">="+$+".0.0":Ee(fe)?">="+$+"."+ae+".0":">="+j)+" "+(Oe=Ee(Pe)?"":Ee(Re)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Re+1)+".0":De?"<="+Pe+"."+Re+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(F,j){for(var $=0;$<F.length;$++)if(!F[$].test(j))return!1;if(j.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==Ie&&F[$].semver.prerelease.length>0){var ae=F[$].semver;if(ae.major===j.major&&ae.minor===j.minor&&ae.patch===j.patch)return!0}return!1}return!0}function xe(F,j,$){try{j=new ve(j,$)}catch(ae){return!1}return j.test(F)}function ze(F,j,$,ae){var fe,Ce,we,Oe,Pe;switch(F=new _(F,ae),j=new ve(j,ae),$){case">":fe=V,Ce=me,we=K,Oe=">",Pe=">=";break;case"<":fe=K,Ce=ie,we=V,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,j,ae))return!1;for(var Re=0;Re<j.set.length;++Re){var Ne=j.set[Re],De=null,Te=null;if(Ne.forEach(function(ke){ke.semver===Ie&&(ke=new ue(">=0.0.0")),De=De||ke,Te=Te||ke,fe(ke.semver,De.semver,ae)?De=ke:we(ke.semver,Te.semver,ae)&&(Te=ke)}),De.operator===Oe||De.operator===Pe||(!Te.operator||Te.operator===Oe)&&Ce(F,Te.semver)||Te.operator===Pe&&we(F,Te.semver))return!1}return!0}ue.prototype.parse=function(F){var j=this.loose?S[re]:S[M],$=F.match(j);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===Ie||(typeof F=="string"&&(F=new _(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(F,j){if(!(F instanceof ue))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,j),xe(this.value,$,j);if(F.operator==="")return $=new ve(this.value,j),xe(F.semver,$,j);var ae=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=ye(this.semver,"<",F.semver,j)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ye(this.semver,">",F.semver,j)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ae||fe||Ce&&we||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var j=this.loose;F=F.trim(),b("range",F,j);var $=j?S[G]:S[W];F=F.replace($,Fe),b("hyphen replace",F),F=F.replace(S[k],"$1$2$3"),b("comparator trim",F,S[k]),F=(F=(F=F.replace(S[te],"$1~")).replace(S[de],"$1^")).split(/\s+/).join(" ");var ae=j?S[re]:S[M],fe=F.split(" ").map(function(Ce){return function(we,Oe){return b("comp",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){b("caret",De,Te);var ke=Te?S[H]:S[z];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("caret",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":be?(b("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+be+" <"+(+ge+1)+".0.0"):(b("no pr"),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),b("caret return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("caret",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){var ke=Te?S[le]:S[ce];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("tilde",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":be?(b("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0"):Le=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",b("tilde return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("tildes",we),we=function(Pe,Re){return b("replaceXRanges",Pe,Re),Pe.split(/\s+/).map(function(Ne){return function(De,Te){De=De.trim();var ke=Te?S[O]:S[P];return De.replace(ke,function(Ae,ge,pe,Se,be,Le){b("xRange",De,Ae,ge,pe,Se,be,Le);var We=Ee(pe),Ve=We||Ee(Se),je=Ve||Ee(be);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(be=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,be=0):je&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+be):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),b("xRange return",Ae),Ae})}(Ne,Re)}).join(" ")}(we,Oe),b("xrange",we),we=function(Pe,Re){return b("replaceStars",Pe,Re),Pe.trim().replace(S[ee],"")}(we,Oe),b("stars",we),we}(Ce,j)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ce){return!!Ce.match(ae)})),fe=fe.map(function(Ce){return new ue(Ce,j)})},ve.prototype.intersects=function(F,j){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ae){return F.set.some(function(fe){return fe.every(function(Ce){return ae.intersects(Ce,j)})})})})},t.toComparators=function(F,j){return new ve(F,j).set.map(function($){return $.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var j=0;j<this.set.length;j++)if(Me(this.set[j],F))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(F,j,$){var ae=null,fe=null;try{var Ce=new ve(j,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==-1||(fe=new _(ae=we,$)))}),ae},t.minSatisfying=function(F,j,$){var ae=null,fe=null;try{var Ce=new ve(j,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==1||(fe=new _(ae=we,$)))}),ae},t.validRange=function(F,j){try{return new ve(F,j).range||"*"}catch($){return null}},t.ltr=function(F,j,$){return ze(F,j,"<",$)},t.gtr=function(F,j,$){return ze(F,j,">",$)},t.outside=ze,t.prerelease=function(F,j){var $=Z(F,j);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,j,$){return F=new ve(F,$),j=new ve(j,$),F.intersects(j)},t.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var j=F.match(S[U]);return j==null?null:Z((j[1]||"0")+"."+(j[2]||"0")+"."+(j[3]||"0"))}}).call(this,L(1))},function(x,t){var L,I,b=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function S(v){if(L===setTimeout)return setTimeout(v,0);if((L===D||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch(g){try{return L.call(null,v,0)}catch(E){return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:D}catch(v){L=D}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch(v){I=T}})();var l,d=[],p=!1,C=-1;function c(){p&&l&&(p=!1,l.length?d=l.concat(d):C=-1,d.length&&w())}function w(){if(!p){var v=S(c);p=!0;for(var g=d.length;g;){for(l=d,d=[];++C<g;)l&&l[C].run();C=-1,g=d.length}l=null,p=!1,function(E){if(I===clearTimeout)return clearTimeout(E);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(E);try{I(E)}catch(f){try{return I.call(null,E)}catch(o){return I.call(this,E)}}}(v)}}function u(v,g){this.fun=v,this.array=g}function h(){}b.nextTick=function(v){var g=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)g[E-1]=arguments[E];d.push(new u(v,g)),d.length!==1||p||S(w)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Y([0,1]),function(x,t){"use strict";var L;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class I{constructor(S,l,d){this.level=S,this.key=l,this.value=d,this.forward=[]}}const b=void 0;class D{constructor(S,l=2**16){this.comparator=S,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(S){return Boolean(D._search(this,S,this.comparator))}get(S){return D._search(this,S,this.comparator)?.value}set(S,l){return D._insert(this,S,l,this.comparator)&&(this._size+=1),this}delete(S){const l=D._delete(this,S,this.comparator);return l&&(this._size-=1),l}forEach(S,l){let d=this._header.forward[0];for(;d;)S.call(l,d.value,d.key,this),d=d.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",l=this._header.forward[0];for(;l;)S+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return S}static _search(S,l,d){let p=S._header;for(let C=S._level-1;C>=0;C--)for(;p.forward[C]&&d(p.forward[C].key,l)<0;)p=p.forward[C];if(p=p.forward[0],p&&d(p.key,l)===0)return p}static _insert(S,l,d,p){let C=[],c=S._header;for(let w=S._level-1;w>=0;w--){for(;c.forward[w]&&p(c.forward[w].key,l)<0;)c=c.forward[w];C[w]=c}if(c=c.forward[0],c&&p(c.key,l)===0)return c.value=d,!1;{let w=D._randomLevel(S);if(w>S._level){for(let u=S._level;u<w;u++)C[u]=S._header;S._level=w}c=new I(w,l,d);for(let u=0;u<w;u++)c.forward[u]=C[u].forward[u],C[u].forward[u]=c;return!0}}static _randomLevel(S,l=.5){let d=1;for(;Math.random()<l&&d<S._maxLevel;)d+=1;return d}static _delete(S,l,d){let p=[],C=S._header;for(let c=S._level-1;c>=0;c--){for(;C.forward[c]&&d(C.forward[c].key,l)<0;)C=C.forward[c];p[c]=C}if(C=C.forward[0],!C||d(C.key,l)!==0)return!1;for(let c=0;c<S._level&&p[c].forward[c]===C;c++)p[c].forward[c]=C.forward[c];for(;S._level>0&&S._header.forward[S._level-1]===b;)S._level-=1;return!0}}t.SkipList=D}),define(J[38],Y([0,1,7,2]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=b;function D(f){const o=f;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=D;function T(f,o){return new S(f,o)}t.newWriteableStream=T;class S{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,L.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,o){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function d(f,o,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=d;function p(f,o){return new Promise((s,e)=>{const i=[];C(f,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=p;function C(f,o){f.on("error",s=>o.onError(s)),f.on("end",()=>o.onEnd()),f.on("data",s=>o.onData(s))}t.listenStream=C;function c(f,o){return new Promise((s,e)=>{const i=new I.DisposableStore,n=[],r=y=>{if(n.push(y),n.length>o)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},a=y=>e(y),m=()=>s({stream:f,buffer:n,ended:!0});i.add((0,I.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,I.toDisposable)(()=>f.removeListener("end",m))),f.on("end",m),i.add((0,I.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=c;function w(f,o){const s=T(o);return s.end(f),s}t.toStream=w;function u(){const f=T(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=u;function h(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}t.toReadable=h;function v(f,o,s){const e=T(s);return C(f,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=v;function g(f,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=g;function E(f,o,s){let e=!1;const i=T(s);return C(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=E}),define(J[17],Y([0,1,38]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,D;class T{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return I?new T(Buffer.allocUnsafe(r)):new T(new Uint8Array(r))}static wrap(r){return I&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new T(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(r)):(b||(b=new TextEncoder),new T(b.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let R=0,P=r.length;R<P;R++)a+=r[R].byteLength}const m=T.alloc(a);let y=0;for(let R=0,P=r.length;R<P;R++){const O=r[R];m.set(O,y),y+=O.byteLength}return m}toString(){return I?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(r,a){return new T(this.buffer.subarray(r,a))}set(r,a){r instanceof T?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){p(this.buffer,r,a)}readUInt32LE(r){return C(this.buffer,r)}writeUInt32LE(r,a){c(this.buffer,r,a)}readUInt8(r){return w(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=T;function S(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=S;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function p(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=p;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=C;function c(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=c;function w(n,r){return n[r]}t.readUInt8=w;function u(n,r,a){n[a]=r}t.writeUInt8=u;function h(n){return L.consumeReadable(n,r=>T.concat(r))}t.readableToBuffer=h;function v(n){return L.toReadable(n)}t.bufferToReadable=v;function g(n){return L.consumeStream(n,r=>T.concat(r))}t.streamToBuffer=g;async function E(n){return n.ended?T.concat(n.buffer):T.concat([...n.buffer,await g(n.stream)])}t.bufferedStreamToBuffer=E;function f(n){return L.toStream(n,r=>T.concat(r))}t.bufferToStream=f;function o(n){return L.transform(n,{data:r=>typeof r=="string"?T.fromString(r):T.wrap(r)},r=>T.concat(r))}t.streamToBufferReadableStream=o;function s(n){return L.newWriteableStream(r=>T.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return L.prefixedReadable(n,r,a=>T.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return L.prefixedStream(n,r,a=>T.concat(a))}t.prefixedBufferStream=i}),define(J[18],Y([0,1,11]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(g=>{h[g]&&typeof h[g]=="object"?v[g]=I(h[g]):v[g]=h[g]}),v}t.deepClone=I;function b(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const E in g)if(D.call(g,E)){const f=g[E];typeof f=="object"&&!Object.isFrozen(f)&&v.push(f)}}return h}t.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function T(h,v){return S(h,v,new Set)}t.cloneAndChange=T;function S(h,v,g){if((0,L.isUndefinedOrNull)(h))return h;const E=v(h);if(typeof E!="undefined")return E;if((0,L.isArray)(h)){const f=[];for(const o of h)f.push(S(o,v,g));return f}if((0,L.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const f={};for(let o in h)D.call(h,o)&&(f[o]=S(h[o],v,g));return g.delete(h),f}return h}function l(h,v,g=!0){return(0,L.isObject)(h)?((0,L.isObject)(v)&&Object.keys(v).forEach(E=>{E in h?g&&((0,L.isObject)(h[E])&&(0,L.isObject)(v[E])?l(h[E],v[E],g):h[E]=v[E]):h[E]=v[E]}),h):v}t.mixin=l;function d(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let g,E;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(g=0;g<h.length;g++)if(!d(h[g],v[g]))return!1}else{const f=[];for(E in h)f.push(E);f.sort();const o=[];for(E in v)o.push(E);if(o.sort(),!d(f,o))return!1;for(g=0;g<f.length;g++)if(!d(h[f[g]],v[f[g]]))return!1}return!0}t.equals=d;function p(h){const v=new Set;return JSON.stringify(h,(g,E)=>{if((0,L.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}t.safeStringify=p;function C(h,v,g){const E=v(h);return typeof E=="undefined"?g:E}t.getOrDefault=C;function c(h,v){const g=Object.create(null);return!h||!v||Object.keys(v).forEach(f=>{const o=h[f],s=v[f];d(o,s)||(g[f]=s)}),g}t.distinct=c;function w(h,v){const g=v.toLowerCase(),E=Object.keys(h).find(f=>f.toLowerCase()===g);return E?h[E]:h[v]}t.getCaseInsensitive=w;function u(h,v){const g=Object.create(null);for(const E of Object.keys(h))v(E,h[E])&&(g[E]=h[E]);return g}t.filter=u}),define(J[60],Y([0,1,8]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function I(d){const p=d;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=I;function b(d){const p=[];let C;try{const c=JSON.parse(d.arguments),w=c[c.length-1];w&&w.__$stack&&(c.pop(),C=w.__$stack),p.push(...c)}catch(c){p.push("Unable to log remote console arguments",d.arguments)}return{args:p,stack:C}}t.parse=b;function D(d){if(typeof d!="string")return D(b(d).stack);const p=d;if(p){const C=T(p),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(c&&c.length===4)return{uri:L.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}t.getFirstFrame=D;function T(d){if(!d)return d;const p=d.indexOf(`
`);return p===-1?d:d.substring(0,p)}function S(d,p){const{args:C,stack:c}=b(d),w=typeof C[0]=="string"&&C.length===1;let u=T(c);u&&(u=`(${u.trim()})`);let h=[];if(typeof C[0]=="string"?u&&w?h=[`%c[${p}] %c${C[0]} %c${u}`,l("blue"),l(""),l("grey")]:h=[`%c[${p}] %c${C[0]}`,l("blue"),l(""),...C.slice(1)]:h=[`%c[${p}]%`,l("blue"),...C],u&&!w&&h.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,h)}t.log=S;function l(d){return`color: ${d}`}}),define(J[61],Y([0,1,17,27,8]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function D(p){return JSON.stringify(p,l)}t.stringify=D;function T(p){let C=JSON.parse(p);return C=d(C),C}t.parse=T;var S;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(S=t.MarshalledId||(t.MarshalledId={}));function l(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,I.regExpFlags)(C)}:C}function d(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof L.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let c=0;c<p.length;++c)p[c]=d(p[c],C+1);else for(const c in p)Object.hasOwnProperty.call(p,c)&&(p[c]=d(p[c],C+1))}return p}t.revive=d}),define(J[62],Y([0,1,47,9,6,12,19,27,8]),function(x,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,m){if(typeof r=="string"&&(r=l.URI.file(r)),m){const R=m.getWorkspaceFolder(r);if(R){const P=m.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(R.uri,r)?O="":O=(0,T.relativePath)(R.uri,r),P){const U=R.name?R.name:(0,T.basename)(R.uri);O=O?U+" \u2022 "+O:U}return O}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(r.fsPath))return(0,b.normalize)(C(r.fsPath));let y=(0,b.normalize)(r.fsPath);return!D.isWindows&&a?.userHome&&(y=w(y,a.userHome.fsPath)),y}t.getPathLabel=d;function p(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,T.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,L.isRootOrDriveLetter)(a)?C(a):a}t.getBaseLabel=p;function C(r){return(0,L.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=C;let c=Object.create(null);function w(r,a){if(D.isWindows||!r||!a)return r;let m=c.original===a?c.normalized:void 0;return m||(m=`${(0,S.rtrim)(a,b.posix.sep)}${b.posix.sep}`,c={original:a,normalized:m}),(D.isLinux?r.startsWith(m):(0,S.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}t.tildify=w;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const h="\u2026",v="\\\\",g="~";function E(r,a=b.sep){const m=new Array(r.length);let y=!1;for(let R=0;R<r.length;R++){let P=r[R];if(P===""){m[R]=`.${a}`;continue}if(!P){m[R]=P;continue}y=!0;let O="";P.indexOf(v)===0?(O=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(a)===0?(O=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(g)===0&&(O=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length));const U=P.split(a);for(let q=1;y&&q<=U.length;q++)for(let te=U.length-q;y&&te>=0;te--){y=!1;let ce=U.slice(te,te+q).join(a);for(let le=0;!y&&le<r.length;le++)if(le!==R&&r[le]&&r[le].indexOf(ce)>-1){const ne=te+q===U.length,de=te>0&&r[le].indexOf(a)>-1?a+ce:ce,z=r[le].endsWith(de);y=!ne||z}if(!y){let le="";(U[0].endsWith(":")||O!=="")&&(te===1&&(te=0,q++,ce=U[0]+a+ce),te>0&&(le=U[0]+a),le=O+le),te>0&&(le=le+h+a),le=le+ce,te+q<U.length&&(le=le+a+h),m[R]=le}}y&&(m[R]=P)}return m}t.shorten=E;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(r,a=Object.create(null)){const m=[];let y=!1,R="";for(const P of r)if(P==="$"||y&&P==="{")R&&m.push({value:R,type:f.TEXT}),R="",y=!0;else if(P==="}"&&y){const O=a[R];if(typeof O=="string")O.length&&m.push({value:O,type:f.VARIABLE});else if(O){const U=m[m.length-1];(!U||U.type!==f.SEPARATOR)&&m.push({value:O.label,type:f.SEPARATOR})}R="",y=!1}else R+=P;return R&&!y&&m.push({value:R,type:f.TEXT}),m.filter((P,O)=>{if(P.type===f.SEPARATOR){const U=m[O-1],q=m[O+1];return[U,q].every(te=>te&&(te.type===f.VARIABLE||te.type===f.TEXT)&&te.value.length>0)}return!0}).map(P=>P.value).join("")}t.template=o;function s(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?b.posix:b.win32,m=a.basename(r),y=a.dirname(r);return m.length?{name:m,parentPath:y}:{name:y,parentPath:""}}t.splitName=n}),define(J[63],Y([0,1,131]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class I{constructor(D="utf8"){this.stringDecoder=new L.StringDecoder(D),this.remaining=null}write(D){const T=[],S=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(S.length<1)return T;let l=0,d,p=l;for(;p<S.length;)if(d=S.charCodeAt(p),d===13||d===10){if(T.push(S.substring(l,p)),p++,p<S.length){const C=d;d=S.charCodeAt(p),(C===13&&d===10||C===10&&d===13)&&p++}l=p}else p++;return this.remaining=l<S.length?S.substr(l):null,T}end(){return this.remaining}}t.LineDecoder=I}),define(J[64],Y([0,1,48,6,27,13]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(p){const C=(0,I.dirname)(p);if(p===C)return p;const c=((0,I.basename)(p)||p).toLowerCase();try{const u=(0,D.readdirSync)(C).filter(h=>h.toLowerCase()===c);if(u.length===1){const h=T(C);if(h)return(0,I.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(c);if(h>=0){const v=T(C);if(v)return(0,I.join)(v,u[h])}}}catch(w){}return null}t.realcaseSync=T;async function S(p){try{return await D.Promises.realpath(p)}catch(C){const c=d(p);return await D.Promises.access(c,L.constants.R_OK),c}}t.realpath=S;function l(p){try{return L.realpathSync(p)}catch(C){const c=d(p);return L.accessSync(c,L.constants.R_OK),c}}t.realpathSync=l;function d(p){return(0,b.rtrim)((0,I.normalize)(p),I.sep)}}),define(J[65],Y([0,1,34,6,13]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class C{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=c({useAlternateBitness:o});if(!e)return null;const i=I.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const y of await b.Promises.readdir(i)){let R=-1;if(s){const O=y.indexOf("-");if(O<0)continue;const U=y.substring(0,O);if(!D.test(U)||y.substring(O+1)!=="preview")continue;R=parseInt(U,10)}else{if(!D.test(y))continue;R=parseInt(y,10)}if(R<=n)continue;const P=I.join(i,y,"pwsh.exe");!await b.SymlinkSupport.existsFile(P)||(r=P,n=R)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",m=s?" Preview":"";return new C(r,`PowerShell${m}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await b.Promises.readdir(s))if(e.test(n)){const r=I.join(s,n,"pwsh.exe");return new C(r,i)}return null}function h(){const o=I.join(L.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function v(){const o=I.join(process.env.windir,d===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*g(){let o=await w();o&&(yield o),o=await w({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=h(),o&&(yield o),o=await w({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await w({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=v(),o&&(yield o)}async function*E(){for await(const o of g())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=E;async function f(){for await(const o of E())return o;return null}t.getFirstAvailablePowerShellInstallation=f});var he=this&&this.__decorate||function(x,t,L,I){var b=arguments.length,D=b<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,L):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,t,L,I);else for(var S=x.length-1;S>=0;S--)(T=x[S])&&(D=(b<3?T(D):b>3?T(t,L,D):T(t,L))||D);return b>3&&D&&Object.defineProperty(t,L,D),D};define(J[39],Y([0,1,20,3,17,24,46,7,10,2,61,27,11]),function(x,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w=t.RequestType||(t.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(g||(g={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const W=this.buffer.slice(this.pos,this.pos+k);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function s(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function e(M){return M.read(4).readUInt32BE(0)}function i(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(M,k){if(typeof k=="undefined")M.write(n.Undefined);else if(typeof k=="string"){const W=b.VSBuffer.fromString(k);M.write(n.String),M.write(s(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(k)){const W=b.VSBuffer.wrap(k);M.write(n.Buffer),M.write(s(W.byteLength)),M.write(W)}else if(k instanceof b.VSBuffer)M.write(n.VSBuffer),M.write(s(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(n.Array),M.write(s(k.length));for(const W of k)a(M,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(k));M.write(n.Object),M.write(s(W.byteLength)),M.write(W)}}function m(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(e(M)).toString();case o.Buffer:return M.read(e(M)).buffer;case o.VSBuffer:return M.read(e(M));case o.Array:{const W=e(M),G=[];for(let ee=0;ee<W;ee++)G.push(m(M));return G}case o.Object:return JSON.parse(M.read(e(M)).toString())}}class y{constructor(k,W,G=null,ee=1e3){this.protocol=k,this.ctx=W,this.logger=G,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(k,W){this.channels.set(k,W),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const W=this.send([k.type]);this.logger&&this.logger.logOutgoing(W,0,1,v(k.type));return}case 201:case 202:case 204:case 203:{const W=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(W,k.id,1,v(k.type),k.data);return}}}send(k,W=void 0){const G=new f;return a(G,k),a(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onRawMessage(k){const W=new E(k),G=m(W),ee=m(W),X=G[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}: ${G[2]}.${G[3]}`,ee),this.onPromise({type:X,id:G[1],channelName:G[2],name:G[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}: ${G[2]}.${G[3]}`,ee),this.onEventListen({type:X,id:G[1],channelName:G[2],name:G[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(X)}`),this.disposeActiveRequest({type:X,id:G[1]})}}onPromise(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=new D.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,k.name,k.arg,G.token)}catch(_){ee=Promise.reject(_)}const X=k.id;ee.then(_=>{this.sendResponse({id:X,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:X,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:X,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,d.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const W=this.channels.get(k.channelName);if(!W){this.collectPendingRequest(k);return}const G=k.id,X=W.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,X)}disposeActiveRequest(k){const W=this.activeRequests.get(k.id);W&&(W.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let W=this.pendingRequests.get(k.channelName);W||(W=[],this.pendingRequests.set(k.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const W=this.pendingRequests.get(k);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}t.ChannelServer=y;var R;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(k,W=null){this.protocol=k,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=W}getChannel(k){const W=this;return{call(G,ee,X){return W.isDisposed?Promise.reject(S.canceled()):W.requestPromise(k,G,ee,X)},listen(G,ee){return W.isDisposed?Promise.reject(S.canceled()):W.requestEvent(k,G,ee)}}}requestPromise(k,W,G,ee=D.CancellationToken.None){const X=this.lastRequestId++,_={id:X,type:100,channelName:k,name:W,arg:G};if(ee.isCancellationRequested)return Promise.reject(S.canceled());let N;return new Promise((B,V)=>{if(ee.isCancellationRequested)return V(S.canceled());const K=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(X),B(ye.data);break;case 202:this.handlers.delete(X);const ue=new Error(ye.data.message);ue.stack=ye.data.stack,ue.name=ye.data.name,V(ue);break;case 203:this.handlers.delete(X),V(ye.data);break}};this.handlers.set(X,me),this.sendRequest(_)};let Q=null;this.state===g.Idle?K():(Q=(0,I.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,K()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:X,type:101}),V(S.canceled())},ie=ee.onCancellationRequested(se);N=(0,d.combinedDisposable)((0,d.toDisposable)(se),ie),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(k,W,G){const ee=this.lastRequestId++,Z={id:ee,type:102,channelName:k,name:W,arg:G};let _=null;const N=new l.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(B=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:ee,type:103}))}}),A=B=>N.fire(B.data);return this.handlers.set(ee,A),N.event}sendRequest(k){switch(k.type){case 100:case 102:{const W=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(W,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const W=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(W,k.id,0,u(k.type));return}}}send(k,W=void 0){const G=new f;return a(G,k),a(G,W),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(W){return 0}}onBuffer(k){const W=new E(k),G=m(W),ee=m(W),X=G[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,v(X)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,v(X),ee),this.onResponse({type:G[0],id:G[1],data:ee})}}onResponse(k){if(k.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(k.id);W&&W(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}he([T.memoize],P.prototype,"onDidInitializePromise",null),t.ChannelClient=P;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:W,onDidClientDisconnect:G})=>{l.Event.once(W.onMessage)(X=>{const Z=new E(X),_=m(Z),N=new y(W,_),A=new P(W);this.channels.forEach((V,K)=>N.registerChannel(K,V));const B={channelServer:N,channelClient:A,ctx:_};this._connections.add(B),this._onDidAddConnection.fire(B),G(()=>{N.dispose(),A.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const k=[];return this._connections.forEach(W=>k.push(W)),k}getChannel(k,W){const G=this;return{call(ee,X,Z){let _;if((0,c.isFunction)(W)){let A=(0,L.getRandomElement)(G.connections.filter(W));_=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,W))}else _=W.routeCall(G,ee,X);const N=_.then(A=>A.channelClient.getChannel(k));return q(N).call(ee,X,Z)},listen(ee,X){if((0,c.isFunction)(W))return G.getMulticastEvent(k,W,ee,X);const Z=W.routeEvent(G,ee,X).then(_=>_.channelClient.getChannel(k));return q(Z).listen(ee,X)}}}getMulticastEvent(k,W,G,ee){const X=this;let Z=new d.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new d.DisposableStore;const N=new l.EventMultiplexer,A=new Map,B=K=>{const se=K.channelClient.getChannel(k).listen(G,ee),ie=N.add(se);A.set(K,ie)},V=K=>{const Q=A.get(K);!Q||(Q.dispose(),A.delete(K))};X.connections.filter(W).forEach(B),l.Event.filter(X.onDidAddConnection,W)(B,void 0,Z),X.onDidRemoveConnection(V,void 0,Z),N.event(_.fire,_,Z),Z.add(N)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,W){this.channels.set(k,W),this._connections.forEach(G=>{G.channelServer.registerChannel(k,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class U{constructor(k,W,G=null){const ee=new f;a(ee,W),k.send(ee.buffer),this.channelClient=new P(k,G),this.channelServer=new y(k,W,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,W){this.channelServer.registerChannel(k,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function q(M){return{call(k,W,G){return M.then(ee=>ee.call(k,W,G))},listen(k,W){const G=new l.Relay;return M.then(ee=>G.input=ee.listen(k,W)),G.event}}}t.getDelayedChannel=q;function te(M){let k=!1;return{call(W,G,ee){return k?M.call(W,G,ee):(0,I.timeout)(0).then(()=>k=!0).then(()=>M.call(W,G,ee))},listen(W,G){if(k)return M.listen(W,G);const ee=new l.Relay;return(0,I.timeout)(0).then(()=>k=!0).then(()=>ee.input=M.listen(W,G)),ee.event}}}t.getNextTickChannel=te;class ce{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const W of k.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=ce;var le;(function(M){function k(X,Z){const _=X,N=Z&&Z.disableMarshalling,A=new Map;for(const B in _)G(B)&&A.set(B,l.Event.buffer(_[B],!0));return new class{listen(B,V,K){const Q=A.get(V);if(Q)return Q;if(ee(V)){const se=_[V];if(typeof se=="function")return se.call(_,K)}throw new Error(`Event not found: ${V}`)}call(B,V,K){const Q=_[V];if(typeof Q=="function"){if(!N&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,p.revive)(K[se]);return Q.apply(_,K)}throw new Error(`Method not found: ${V}`)}}}M.fromService=k;function W(X,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(N,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ee(A)?function(B){return X.listen(A,B)}:G(A)?X.listen(A):async function(...B){let V;Z&&!(0,c.isUndefinedOrNull)(Z.context)?V=[Z.context,...B]:V=B;const K=await X.call(A,V);return _?K:(0,p.revive)(K)};throw new Error(`Property not found: ${String(A)}`)}})}M.toService=W;function G(X){return X[0]==="o"&&X[1]==="n"&&C.isUpperAsciiLetter(X.charCodeAt(2))}function ee(X){return/^onDynamic/.test(X)&&C.isUpperAsciiLetter(X.charCodeAt(9))}})(le=t.ProxyChannel||(t.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function z(M){return Array.isArray(M)?M.map(de):de(M)}function H(M,k,W,G,ee,X,Z){Z=z(Z);const _=ne[ee],N=_[G%_.length];let A=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(X)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=H;class re{constructor(k,W){this._outgoingPrefix=k,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,W,G,ee,X){this._totalOutgoing+=k,H(this._outgoingPrefix,this._totalOutgoing,k,W,G,ee,X)}logIncoming(k,W,G,ee,X){this._totalIncoming+=k,H(this._incomingPrefix,this._totalIncoming,k,W,G,ee,X)}}t.IPCLogger=re}),define(J[66],Y([0,1,3,10,2,11]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function S(C){const c=C;return c?.changed instanceof Map||c?.deleted instanceof Set}t.isStorageItemsChangeEvent=S;var l;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(l||(l={}));class d extends b.Disposable{constructor(c,w=Object.create(null)){super();this.database=c,this.options=w,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((w,u)=>this.accept(u,w)),c.deleted?.forEach(w=>this.accept(w,void 0))}accept(c,w){if(this.state===l.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(w)?u=this.cache.delete(c):this.cache.get(c)!==w&&(this.cache.set(c,w),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,w){const u=this.cache.get(c);return(0,D.isUndefinedOrNull)(u)?w:u}getBoolean(c,w){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?w:u==="true"}getNumber(c,w){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?w:parseInt(u,10)}async set(c,w){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(w))return this.delete(c);const u=String(w);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.flushDelayer.trigger(()=>this.flushPending())}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((w,u)=>this.items.set(u,w)),c.delete&&c.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=p}),define(J[67],Y([4,5]),function(x,t){return x.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const I=60,b=I*60,D=b*24,T=D*7,S=D*30,l=D*365;function d(C,c){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,L.localize)(0,null,d(new Date().getTime()+w*1e3,!1));if(w<30)return(0,L.localize)(1,null);let u;return w<I?(u=w,c?u===1?(0,L.localize)(2,null,u):(0,L.localize)(3,null,u):u===1?(0,L.localize)(4,null,u):(0,L.localize)(5,null,u)):w<b?(u=Math.floor(w/I),c?u===1?(0,L.localize)(6,null,u):(0,L.localize)(7,null,u):u===1?(0,L.localize)(8,null,u):(0,L.localize)(9,null,u)):w<D?(u=Math.floor(w/b),c?u===1?(0,L.localize)(10,null,u):(0,L.localize)(11,null,u):u===1?(0,L.localize)(12,null,u):(0,L.localize)(13,null,u)):w<T?(u=Math.floor(w/D),c?u===1?(0,L.localize)(14,null,u):(0,L.localize)(15,null,u):u===1?(0,L.localize)(16,null,u):(0,L.localize)(17,null,u)):w<S?(u=Math.floor(w/T),c?u===1?(0,L.localize)(18,null,u):(0,L.localize)(19,null,u):u===1?(0,L.localize)(20,null,u):(0,L.localize)(21,null,u)):w<l?(u=Math.floor(w/S),c?u===1?(0,L.localize)(22,null,u):(0,L.localize)(23,null,u):u===1?(0,L.localize)(24,null,u):(0,L.localize)(25,null,u)):(u=Math.floor(w/l),c?u===1?(0,L.localize)(26,null,u):(0,L.localize)(27,null,u):u===1?(0,L.localize)(28,null,u):(0,L.localize)(29,null,u))}t.fromNow=d;function p(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(J[69],Y([4,5]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,20,11,69]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function D(d,p){return p&&(d.stack||d.stacktrace)?b.localize(0,null,S(d),T(d.stack)||T(d.stacktrace)):S(d)}function T(d){return Array.isArray(d)?d.join(`
`):d}function S(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?b.localize(1,null,d.message):d.message||b.localize(2,null)}function l(d=null,p=!1){if(!d)return b.localize(3,null);if(Array.isArray(d)){const C=L.coalesce(d),c=l(C[0],p);return C.length>1?b.localize(4,null,c,C.length):c}if(I.isString(d))return d;if(d.detail){const C=d.detail;if(C.error)return D(C.error,p);if(C.exception)return D(C.exception,p)}return d.stack?D(d,p):d.message?d.message:b.localize(5,null)}t.toErrorMessage=l}),define(J[70],Y([4,5]),function(x,t){return x.create("vs/base/node/processes",t)}),define(J[49],Y([0,1,40,47,9,18,6,12,29,58,11,63,13,70]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(e,i){if(S.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};i&&(n.cwd=i);const r=L.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],n);return new Promise(a=>{r.once("error",m=>{a({success:!1,error:m})}),r.once("exit",(m,y)=>{a(m===0?{success:!0}:{success:!1,code:m!==null?m:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(S.isLinux||S.isMacintosh)try{const n=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(r=>{L.execFile(n,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,m,y)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function v(e){!e||(delete e.DEBUG,S.isMacintosh&&delete e.DYLD_LIBRARY_PATH,S.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=v;function g(e=l.env){return e.comspec||"cmd.exe"}t.getWindowsShell=g;class E{constructor(i,n,r,a){if(n!==void 0&&r!==void 0&&a!==void 0)this.cmd=i,this.args=n,this.shell=r,this.options=a;else{const m=i;this.cmd=m.command,this.shell=m.isShellCommand,this.args=m.args.slice(0),this.options=m.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const m=Object.create(null);Object.keys(l.env).forEach(y=>{m[y]=l.env[y]}),Object.keys(this.options.env).forEach(y=>{m[y]=this.options.env[y]}),this.options.env=m}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const n=i.lastIndexOf(T.sep);return n!==-1&&(i=i.substring(n+1)),E.WellKnowCommands[i]?i:"other"}start(i){return S.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(n=>{let r,a;const m=new Promise((y,R)=>{r=y,a=R});if(n){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=L.exec(y,this.options,(R,P,O)=>{this.childProcess=null;const U=R;U&&U.killed?a({killed:this.terminateRequested,stdout:P.toString(),stderr:O.toString()}):this.handleExec(r,i,R,P,O)})}else{let y=null;const R=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,r,i,a);const O={terminated:this.terminateRequested};p.isNumber(P)&&(O.cmdCode=P),r(O)};if(this.shell&&S.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let O=!1,U=!1;const q=[];let te=this.ensureQuotes(this.cmd);q.push(te.value),O=te.quoted,this.args&&this.args.forEach(le=>{te=this.ensureQuotes(le),q.push(te.value),U=U&&te.quoted});const ce=["/s","/c"];O?U?ce.push('"'+q.join(" ")+'"'):q.length>1?ce.push('"'+q[0]+'" '+q.slice(1).join(" ")):ce.push('"'+q[0]+'"'):ce.push(q.join(" ")),y=L.spawn(g(),ce,P)}else this.cmd&&(y=L.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(p.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",P=>{this.childProcess=null,a({terminated:this.terminateRequested,error:P})}),y.pid&&(this.childProcess.on("close",R),this.handleSpawn(y,r,i,a,!0)))}return m})}handleClose(i,n,r,a){}ensureQuotes(i){return E.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,h(i,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!S.isWindows)return i(!1);const n=L.spawn(g(),["/s","/c"]);n.on("error",r=>i(!0)),n.on("exit",r=>i(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class f extends E{constructor(i,n,r,a){super(i,n,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,n,r,a,m){[a,m].forEach((y,R)=>{const P=new C.LineDecoder;P.write(y).forEach(q=>{n({line:q,source:R===0?0:1})});const U=P.end();U&&n({line:U,source:R===0?0:1})}),i({terminated:this.terminateRequested,error:r})}handleSpawn(i,n,r,a,m){const y=new C.LineDecoder,R=new C.LineDecoder;i.stdout.on("data",P=>{y.write(P).forEach(U=>r({line:U,source:0}))}),i.stderr.on("data",P=>{R.write(P).forEach(U=>r({line:U,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=R}handleClose(i,n,r,a){const m=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;m&&r({line:m,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&r({line:y,source:1})}}t.LineProcess=f;function o(e){let i=[],n=!1;const r=function(a){if(n){i.push(a);return}(!e.send(a,y=>{if(y&&console.error(y),n=!1,i.length>0){const R=i.slice(0);i=[],R.forEach(P=>r(P))}})||S.isWindows)&&(n=!0)};return{send:r}}t.createQueuedSender=o;var s;(function(e){async function i(n,r,a){if(T.isAbsolute(n))return n;if(r===void 0&&(r=l.cwd()),T.dirname(n)!=="."||(a===void 0&&p.isString(l.env.PATH)&&(a=l.env.PATH.split(T.delimiter)),a===void 0||a.length===0))return T.join(r,n);async function y(R){if(await c.Promises.exists(R)){let P;try{P=await c.Promises.stat(R)}catch(O){O.message.startsWith("EACCES")&&(P=await c.Promises.lstat(R))}return P?!P.isDirectory():!1}return!1}for(let R of a){let P;if(T.isAbsolute(R)?P=T.join(R,n):P=T.join(r,R,n),await y(P))return P;let O=P+".com";if(await y(O)||(O=P+".exe",await y(O)))return O}return T.join(r,n)}e.findExecutable=i})(s=t.win32||(t.win32={}))}),define(J[71],Y([0,1,34,12,65,49]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(w,u){return w===1?I.isWindows?C():D.getWindowsShell(u):d(w,u)}t.getSystemShell=T;function S(w,u){return w===1?I.isWindows?c(u):D.getWindowsShell(u):d(w,u)}t.getSystemShellSync=S;let l=null;function d(w,u){if(I.isLinux&&w===2||I.isMacintosh&&w===3)return"/bin/bash";if(!l){let h;if(I.isWindows)h="/bin/bash";else{if(h=u.SHELL,!h)try{h=(0,L.userInfo)().shell}catch(v){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}l=h}return l}let p=null;async function C(){return p||(p=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),p}function c(w){if(p)return p;const u=I.isWindows&&parseFloat((0,L.release)())>=10,h=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${w.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?v:D.getWindowsShell(w)}}),define(J[50],Y([0,1,40,3,17,24,60,7,10,2,18,49,39]),function(x,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class w extends c.ChannelServer{constructor(v){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch(E){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",g=>b.VSBuffer.wrap(Buffer.from(g,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=w;class u{constructor(v,g){this.modulePath=v,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new I.Delayer(E),this.child=null,this._client=null}getChannel(v){const g=this;return{call(E,f,o){return g.requestPromise(v,E,f,o)},listen(E,f){return g.requestEvent(v,E,f)}}}requestPromise(v,g,E,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),s=(0,I.createCancelablePromise)(n=>o.call(g,E,n)),e=f.onCancellationRequested(()=>s.cancel()),i=(0,d.toDisposable)(()=>s.cancel());return this.activeRequests.add(i),s.finally(()=>{e.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(v,g,E){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const o=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(v).listen(g,E)(o.fire,o),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,L.fork)(this.modulePath,v,g);const E=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}E.fire(b.VSBuffer.wrap(Buffer.from(r,"base64")))});const o=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,s=r=>this.child&&this.child.connected&&o.send(r.buffer.toString("base64")),e=E.event,i={send:s,onMessage:e};this._client=new c.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",n),this.activeRequests.forEach(m=>(0,d.dispose)(m)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(v){let g=this.channels.get(v);return g||(g=this.client.getChannel(v),this.channels.set(v,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(J[72],Y([4,5]),function(x,t){return x.create("vs/base/node/zip",t)}),define(J[73],Y([4,5]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([4,5]),function(x,t){return x.create("vs/platform/environment/node/shellEnv",t)}),define(J[75],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[76],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[77],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[78],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[79],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[80],Y([4,5]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[81],Y([4,5]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[82],Y([4,5]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(J[83],Y([4,5]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(J[84],Y([4,5]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[85],Y([4,5]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(J[86],Y([4,5]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[87],Y([0,1,68,46,9,6,29,19,8]),function(x,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(h,v,g){this._args=h,this.paths=v,this.productService=g}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?l.URI.file((0,D.join)(h,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const g=T.env.VSCODE_PORTABLE;return g?(0,D.join)(g,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,D.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?l.URI.parse(h):l.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([I.memoize],d.prototype,"appRoot",null),he([I.memoize],d.prototype,"userHome",null),he([I.memoize],d.prototype,"userDataPath",null),he([I.memoize],d.prototype,"appSettingsHome",null),he([I.memoize],d.prototype,"tmpDir",null),he([I.memoize],d.prototype,"userRoamingDataHome",null),he([I.memoize],d.prototype,"settingsResource",null),he([I.memoize],d.prototype,"userDataSyncHome",null),he([I.memoize],d.prototype,"userDataSyncLogResource",null),he([I.memoize],d.prototype,"sync",null),he([I.memoize],d.prototype,"machineSettingsResource",null),he([I.memoize],d.prototype,"globalStorageHome",null),he([I.memoize],d.prototype,"workspaceStorageHome",null),he([I.memoize],d.prototype,"keybindingsResource",null),he([I.memoize],d.prototype,"keyboardLayoutResource",null),he([I.memoize],d.prototype,"argvResource",null),he([I.memoize],d.prototype,"snippetsHome",null),he([I.memoize],d.prototype,"isExtensionDevelopment",null),he([I.memoize],d.prototype,"untitledWorkspacesHome",null),he([I.memoize],d.prototype,"installSourcePath",null),he([I.memoize],d.prototype,"builtinExtensionsPath",null),he([I.memoize],d.prototype,"extensionsPath",null),he([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([I.memoize],d.prototype,"extensionDevelopmentKind",null),he([I.memoize],d.prototype,"extensionTestsLocationURI",null),he([I.memoize],d.prototype,"debugExtensionHost",null),he([I.memoize],d.prototype,"serviceMachineIdResource",null),he([I.memoize],d.prototype,"telemetryLogResource",null),he([I.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function p(u,h){return w(u["inspect-extensions"],u["inspect-brk-extensions"],5870,h,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=p;function C(u,h){return w(u["inspect-search"],u["inspect-brk-search"],5876,h,u.extensionEnvironment)}t.parseSearchPort=C;function c(u,h){return w(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,h,u.extensionEnvironment)}t.parsePtyHostPort=c;function w(u,h,v,g,E,f){const s=Number(h||u)||(g?null:v),e=s?Boolean(!!h):!1;let i;if(f)try{i=JSON.parse(f)}catch{}return{port:s,break:e,debugId:E,env:i}}}),function(){"use strict";function x(t,L,I,b){function D(S){const l=T(S),d=[l];return t.isAbsolute(l)||d.unshift(b),t.resolve(...d)}function T(S){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,I);const p=S["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(C,"AppData","Roaming")}break;case"darwin":d=t.join(L.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,I)}return{getUserDataPath:D}}if(typeof define=="function")define(J[88],Y([0,132,34,9,19,29]),function(t,L,I,b,D,T){const S=D.dirname(b.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(D.joinPath(S,"package.json").fsPath);return x(L,I,l.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),L=require("path"),I=require("os");module.exports=x(L,I,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Y([0,1,34,87,88]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class D extends I.AbstractNativeEnvironmentService{constructor(S,l){super(S,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,b.getUserDataPath)(S)},l)}}t.NativeEnvironmentService=D}),define(J[90],Y([0,1,18]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function b(D,T){const S=l=>{if(typeof l!="string")return;const d=I.exec(l);if(!d)return;const p=T[d[1]]??l;return typeof p=="string"?p:typeof p.message=="string"?p.message:l};return(0,L.cloneAndChange)(D,S)}t.localizeManifest=b}),define(J[51],Y([0,1,81]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(c){return c=c.trim(),c==="*"||I.test(c)}t.isValidVersionStr=D;function T(c){if(!D(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=c.match(I);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}t.parseVersion=T;function S(c){if(!c)return null;let w=c.majorBase,u=c.majorMustEqual,h=c.minorBase,v=c.minorMustEqual,g=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(w===0||(v=!1),E=!1);let f=0;if(c.preRelease){const o=b.exec(c.preRelease);if(o){const[,s,e,i]=o;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:w,majorMustEqual:u,minorBase:h,minorMustEqual:v,patchBase:g,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:f}}t.normalizeVersion=S;function l(c,w,u){let h;typeof c=="string"?h=S(T(c)):h=c;let v;w instanceof Date?v=w.getTime():typeof w=="string"&&(v=new Date(w).getTime());let g;if(typeof u=="string"?g=S(T(u)):g=u,!h||!g)return!1;let E=h.majorBase,f=h.minorBase,o=h.patchBase,s=g.majorBase,e=g.minorBase,i=g.patchBase,n=g.notBefore,r=g.majorMustEqual,a=g.minorMustEqual,m=g.patchMustEqual;return g.isMinimum?E>s?!0:E<s?!1:f>e?!0:f<e||v&&v<n?!1:o>=i:(E===1&&s===0&&(!r||!a||!m)&&(s=1,e=0,i=0,r=!0,a=!1,m=!1),E<s?!1:E>s?!r:f<e?!1:f>e?!a:o<i?!1:o>i?!m:!(v&&v<n))}t.isValidVersion=l;function d(c,w,u,h){return u.isBuiltin||typeof u.main=="undefined"?!0:C(c,w,u.engines.vscode,h)}t.isValidExtensionVersion=d;function p(c,w,u){return c==="*"||C(w,u,c)}t.isEngineValid=p;function C(c,w,u,h=[]){let v=S(T(u));if(!v)return h.push(L.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(L.localize(1,null,u)),!1}else if(!v.majorMustEqual)return h.push(L.localize(2,null,u)),!1;return l(c,w,v)?!0:(h.push(L.localize(3,null,c,u)),!1)}}),define(J[41],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class L{constructor(b,D=[],T=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=L}),define(J[91],Y([0,1,41]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const I=[];function b(T,S,l){S instanceof L.SyncDescriptor||(S=new L.SyncDescriptor(S,[],l)),I.push([T,S])}t.registerSingleton=b;function D(){return I}t.getSingletonServiceDescriptors=D}),define(J[92],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class L{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}t.Node=L;class I{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const S=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(T);S.outgoing.set(this._hashFn(T),l),l.incoming.set(this._hashFn(D),S)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let S of this._nodes.values())S.outgoing.delete(T),S.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let S=this._nodes.get(T);return S||(S=new L(D),this._nodes.set(T,S)),S}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,S]of this._nodes)D.push(`${T}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const S=new Set([D]),l=this._findCycle(T,S);if(l)return l}}_findCycle(D,T){for(let[S,l]of D.outgoing){if(T.has(S))return[...T,S].join(" -> ");T.add(S);const d=this._findCycle(l,T);if(d)return d;T.delete(S)}}}t.Graph=I}),define(J[52],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,L.createDecorator)("downloadService")}),define(J[21],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,L.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,L.refineServiceDecorator)(t.IEnvironmentService)}),define(J[22],Y([0,1,9,76,14]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var D;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(D=t.TargetPlatform||(t.TargetPlatform={}));function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=T;function S(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=S;function l(f,o){switch(f){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(f,o){return o==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function p(f,o,s){return d(o,s)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===s?!0:C(s).includes(f)}t.isTargetPlatformCompatible=p;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=C;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=c;var w;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(w=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var h;(function(f){f.Install="install",f.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var g;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(g=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(o,s){super(o);this.code=s,this.name=s}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,I.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,I.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Y([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(x,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const w=1e4;let u;async function h(g,E,f){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(o,s)=>{const e=new D.CancellationTokenSource,i=setTimeout(()=>{e.dispose(!0),s(new Error((0,b.localize)(0,null)))},w);try{o(await v(g,e.token))}catch(n){!(0,S.isPromiseCanceledError)(n)&&!e.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(n)))):o({})}finally{clearTimeout(i),e.dispose()}})),u)}t.resolveShellEnv=h;async function v(g,E){const f=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",o);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",i);const n=await(0,p.getSystemShell)(l.OS,i);return g.trace("getUnixShellEnvironment#shell",n),new Promise((r,a)=>{if(E.isCancellationRequested)return a((0,S.canceled)());const m=(0,I.basename)(n);let y,R;/^pwsh(-preview)?$/.test(m)?(y=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,R=["-Login","-Command"]):(y=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,m==="tcsh"?R=["-ic"]:R=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),y);const P=(0,L.spawn)(n,[...R,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});E.onCancellationRequested(()=>(P.kill(),a((0,S.canceled)()))),P.on("error",q=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(q)),a(q)});const O=[];P.stdout.on("data",q=>O.push(q));const U=[];P.stderr.on("data",q=>U.push(q)),P.on("close",(q,te)=>{const ce=Buffer.concat(O).toString("utf8");g.trace("getUnixShellEnvironment#raw",ce);const le=Buffer.concat(U).toString("utf8");if(le.trim()&&g.trace("getUnixShellEnvironment#stderr",le),q||te)return a(new Error((0,b.localize)(2,null,q,te)));const ne=e.exec(ce),de=ne?ne[1]:"{}";try{const z=JSON.parse(de);f?z.ELECTRON_RUN_AS_NODE=f:delete z.ELECTRON_RUN_AS_NODE,o?z.ELECTRON_NO_ATTACH_CONSOLE=o:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",z),r(z)}catch(z){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(z)),a(z)}})})}}),define(J[53],Y([0,1,17,7,83,16]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(p,C,c,w,u,h){let v;try{await S(p,C,c,w,u,h)}catch(g){v=g}finally{v&&u.errorTransformer&&(v=u.errorTransformer(v)),typeof v!="undefined"&&c.error(v),c.end()}}t.readFileIntoStream=T;async function S(p,C,c,w,u,h){l(h);const v=await p.open(C,{create:!1});try{l(h);let g=0,E=0,f=u&&typeof u.length=="number"?u.length:void 0,o=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),s=u&&typeof u.position=="number"?u.position:0,e=0;do E=await p.read(v,s,o.buffer,e,o.byteLength-e),s+=E,e+=E,g+=E,typeof f=="number"&&(f-=E),e===o.byteLength&&(await c.write(w(o)),o=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),e=0);while(E>0&&(typeof f!="number"||f>0)&&l(h)&&d(g,u));if(e>0){let i=e;typeof f=="number"&&(i=Math.min(e,f)),c.write(w(o.slice(0,i)))}}catch(g){throw(0,D.ensureFileSystemProviderError)(g)}finally{await p.close(v)}}function l(p){if(p.isCancellationRequested)throw(0,I.canceled)();return!0}function d(p,C){if(C?.limits){if(typeof C.limits.memory=="number"&&p>C.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&p>C.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[35],Y([0,1,2,12,8,16]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=t.AbstractWatcherService=void 0;class T extends L.Disposable{constructor(c,w,u){super();this.onFileChanges=c,this.onLogMessage=w,this.verboseLogging=u,this.serviceDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new L.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(w=>this.onFileChanges(w))),c.add(this.service.onDidLogMessage(w=>this.onLogMessage(w))),c.add(this.service.onDidError(w=>this.onError(w)))}onError(c){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}t.AbstractWatcherService=T,T.MAX_RESTARTS=5;class S extends L.Disposable{}t.WatcherService=S;function l(C){return C.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}t.toFileChanges=l;function d(C){const c=new p;for(const w of C)c.processEvent(w);return c.normalize()}t.normalizeFileChanges=d;class p{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(c){return I.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const w=this.mapPathToChange.get(this.toKey(c));let u=!1;if(w){const h=w.type,v=c.type;w.path!==c.path&&c.type===2?u=!0:h===1&&v===2?(this.mapPathToChange.delete(this.toKey(c)),this.normalized.delete(w)):h===2&&v===1?w.type=0:h===1&&v===0||(w.type=v)}else u=!0;u&&(this.normalized.add(c),this.mapPathToChange.set(this.toKey(c),c))}normalize(){const c=[],w=[];return Array.from(this.normalized).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,h)=>u.path.length-h.path.length).filter(u=>w.some(h=>(0,D.isParent)(u.path,h,!I.isLinux))?!1:(w.push(u.path),!0)).concat(c)}}}),define(J[94],Y([0,1,3,2,6,64,13,134,35]),function(x,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends I.Disposable{constructor(C,c,w,u){super();this.path=C,this.onDidFilesChange=c,this.onLogMessage=w,this.verboseLogging=u,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(S.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:c}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(c)try{w=await(0,D.realpath)(w)}catch(u){if(this.onError(u),c.dangling)return}C.isDirectory()?this._register((0,S.watchFolder)(w,(u,h)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(h))})},u=>this.onError(u))):this._register((0,S.watchFile)(w,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,l.normalizeFileChanges)(c);if(this.verboseLogging)for(const u of w)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(J[95],Y([0,1,9,39,50,35]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.WatcherService{constructor(l,d,p){super();this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=p,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T}),define(J[96],Y([0,1,9,39,50,35]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.AbstractWatcherService{constructor(l,d,p){super(l,d,p);this.init()}createService(l){const d=l.add(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(d.onDidProcessExit(({code:p,signal:C})=>this.onError(`terminated by itself with code ${p}, signal: ${C}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}t.FileWatcher=T}),define(J[54],Y([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class L{constructor(...b){this._entries=new Map;for(let[D,T]of b)this.set(D,T)}set(b,D){const T=this._entries.get(b);return this._entries.set(b,D),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=L}),define(J[97],Y([0,1,3,7,41,92,14,54]),function(x,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class p{constructor(u=new S.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=h,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(u){return new p(u,this._strict,this)}invokeFunction(u,...h){let v=c.traceInvocation(u),g=!1;try{return u({get:f=>{if(g)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(f,v);if(!o)throw new Error(`[invokeFunction] unknown service '${f}'`);return o}},...h)}finally{g=!0,v.stop()}}createInstance(u,...h){let v,g;return u instanceof b.SyncDescriptor?(v=c.traceCreation(u.ctor),g=this._createInstance(u.ctor,u.staticArguments.concat(h),v)):(v=c.traceCreation(u),g=this._createInstance(u,h,v)),v.stop(),g}_createInstance(u,h=[],v){let g=T._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),E=[];for(const o of g){let s=this._getOrCreateServiceInstance(o.id,v);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);E.push(s)}let f=g.length>0?g[0].index:h.length;if(h.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${h.length} static arguments`);let o=f-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,f)}return new u(...[...h,...E])}_setServiceInstance(u,h){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,h);else if(this._parent)this._parent._setServiceInstance(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let h=this._services.get(u);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):h}_getOrCreateServiceInstance(u,h){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,h.branch(u,!0)):(h.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,h,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,h,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,h,v){const g=new D.Graph(o=>o.id.toString());let E=0;const f=[{id:u,desc:h,_trace:v}];for(;f.length;){const o=f.pop();if(g.lookupOrInsertNode(o),E++>1e3)throw new d(g);for(let s of T._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};g.insertEdge(o,i),f.push(i)}}}for(;;){const o=g.roots();if(o.length===0){if(!g.isEmpty())throw new d(g);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}g.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,h,v=[],g,E){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(h,v,g,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,h,v,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(u,h=[],v,g){if(v){const E=new L.IdleValue(()=>this._createInstance(u,h,g));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let s=E.value,e=s[o];return typeof e!="function"||(e=e.bind(s),f[o]=e),e},set(f,o,s){return E.value[o]=s,!0}})}else return this._createInstance(u,h,g)}}t.InstantiationService=p;var C;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(C||(C={}));class c{constructor(u,h){this.type=u,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,h){let v=new c(2,u.toString());return this._dep.push([u,h,v]),v}stop(){let u=Date.now()-this._start;c._totals+=u;let h=!1;function v(E,f){let o=[],s=new Array(E+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){h=!0,o.push(`${s}CREATES -> ${e}`);let r=v(E+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||h)&&console.log(g.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(J[55],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,L.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=I}),define(J[15],Y([0,1,28,10,2,12,14]),function(x,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function S(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class d extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class p extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=p;class C extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...i):console.log(`[main ${S()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...i):console.log(`[main ${S()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,e,...i):console.log(`[main ${S()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,e,...i):console.warn(`[main ${S()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,e,...i):console.error(`[main ${S()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,e,...i):console.error(`[main ${S()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=C;class c extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=c;class w extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,L.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=w;class u extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class h extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class v extends b.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class g{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=g;function E(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=E;function f(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=f;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var oe=this&&this.__param||function(x,t){return function(L,I){t(L,I,x)}};define(J[98],Y([0,1,40,3,28,10,2,9,6,13,21,15]),function(x,t,L,I,b,D,T,S,l,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let c=class extends T.Disposable{constructor(u,h){super();this.environmentService=u,this.logService=h,this.processesLimiter=new I.Limiter(5)}async postUninstall(u){const h=this.parseScript(u,"uninstall");return h&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,h){const v=`vscode:${h}`;if(u.location.scheme===S.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const g=u.manifest.scripts[v].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(u,h,v,g,E){return new Promise((f,o)=>{const s=this.start(u,h,v,E);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):f(void 0)};s.on("error",n=>{i((0,b.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${h} process exited with code ${n}`:void 0)}),g&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,h,v,g){const E={silent:!0,execArgv:void 0},f=(0,L.fork)(u,[`--type=extension-post-${h}`,...v],E);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=D.Event.fromNodeEventEmitter(f.stdout,"data"),s=D.Event.fromNodeEventEmitter(f.stderr,"data");o(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${h}`,n)),s(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${h}`,n));const e=D.Event.any(D.Event.map(o,n=>({data:`%c${n}`,format:[""]})),D.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return D.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=he([oe(0,p.IEnvironmentService),oe(1,C.ILogService)],c),t.ExtensionsLifecycle=c}),define(J[99],Y([0,1,20,3,7,10,2,6,35,15]),function(x,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class p extends T.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(c,w){return w.recursive?this.watchRecursive(c,w):this.watchNonRecursive(c)}watchRecursive(c,w){const u={path:this.toFilePath(c),excludes:w.excludes},h=(0,L.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch.length,c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,w){return c.watch(w)}watchNonRecursive(c){const w=this.createNonRecursiveWatcher(this.toFilePath(c),h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{w.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,T.combinedDisposable)(w,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,S.normalize)(c.fsPath)}}t.AbstractDiskFileSystemProvider=p}),define(J[100],Y([0,1,20,3,17,24,10,135,2,101,9,102,19,38,82,16,53,15]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let E=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new h.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new h.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await I.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return S.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new h.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasReadWriteCapability)(s)||(0,h.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,h.toFileSystemProviderErrorCode)(e)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,h.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,m=await e.stat(o);let y;return this.toFileStat(e,o,m,void 0,!!a,(R,P)=>(y||(y=d.TernarySearchTree.forUris(()=>!i),y.set(o,!0),n&&y.fill(!0,n)),y.get(R.resource)||y.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&r?P===1:!1))}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),m={resource:s,name:a.basename(s),isFile:(e.type&h.FileType.File)!=0,isDirectory:(e.type&h.FileType.Directory)!=0,isSymbolicLink:(e.type&h.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&h.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,h.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&r(m,i)){try{const y=await o.readdir(s),R=await I.Promises.settled(y.map(async([P,O])=>{try{const U=a.joinPath(s,P),q=n?await o.stat(U):{type:O};return await this.toFileStat(o,U,q,y.length,n,r)}catch(U){return this.logService.trace(U),null}}));m.children=(0,L.coalesce)(R)}catch(y){this.logService.trace(y),m.children=[]}return m}return m}async resolveAll(o){return I.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new h.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=b.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new h.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,h.hasReadWriteCapability)(i)&&!(s instanceof b.VSBuffer))if((0,w.isReadableStream)(s)){const m=await(0,w.peekStream)(s,3);m.ended?a=b.VSBuffer.concat(m.buffer):a=m}else a=(0,w.peekReadable)(s,m=>b.VSBuffer.concat(m),3);else a=s;!(0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a)}catch(r){throw new h.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==h.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,h.etag)({mtime:e.mtime,size:n.size}))throw new h.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,b.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new D.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==h.ETAG_DISABLED&&await n,!((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasFileReadStreamCapability)(o))||(0,h.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,h.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,w.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(a).toString());throw a instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(m,a.stat,e):new h.FileOperationError(m,(0,h.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,w.transform)(n,{data:r=>r instanceof b.VSBuffer?r:b.VSBuffer.wrap(r),error:r=>new h.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),i)},r=>b.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new h.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,w.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(b.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new h.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==h.ETAG_DISABLED&&s.etag===e.etag)throw new h.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new h.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!m&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,h.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const y=await this.resolve(s);y.isDirectory?await this.doCopyFolder(o,y,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,h.hasOpenReadWriteCloseCapability)(o)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,h.hasOpenReadWriteCloseCapability)(o)&&(0,h.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,h.hasReadWriteCapability)(o)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,h.hasReadWriteCapability)(o)&&(0,h.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await I.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:y,isPathCaseSensitive:R}=this.getExtUri(o);if(R||(a=y.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&y.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const m=await this.exists(i);if(m&&!a){if(!r)throw new h.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:y}=this.getExtUri(o);if(y.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&h.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,h.toFileSystemProviderErrorCode)(n)!==h.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new h.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new h.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new h.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;let i=!1,n=()=>{i=!0};return e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r)),s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:e.watch(o,s)},this.activeWatchers.set(i,n)),n.count+=1,(0,l.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i)))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=b.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise((r,a)=>{(0,w.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,s,m,m.byteLength,i,0)}catch(y){return a(y)}i+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>a(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof b.VSBuffer?n=i:(0,w.isReadableStream)(i)?n=await(0,b.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?n=await(0,b.bufferedStreamToBuffer)(i):n=(0,b.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,y=0,R=0;do R=await o.read(n,m,a.buffer,y,a.byteLength-y),await this.doWriteBuffer(e,r,a,R,m,y),m+=R,y+=R,y===a.byteLength&&(y=0);while(R>0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await I.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,b.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,s,D.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new h.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};E.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},E=he([oe(0,g.ILogService)],E),t.FileService=E}),define(J[103],Y([0,1,48,136,3,17,10,47,6,12,19,38,13,84,16,53,94,95,96,99,28]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g,E,f,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(L)}catch(e){console.error(`Error enabling graceful-fs: ${(0,o.toErrorMessage)(e)}`)}})();class s extends f.AbstractDiskFileSystemProvider{constructor(i,n){super(i);this.options=n,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await c.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await c.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,p.joinPath)(i,a.name))).type:m=this.toType(a),r.push([a.name,m])}catch(m){this.logService.trace(m)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=u.FileType.Unknown:i.isFile()?r=u.FileType.File:i.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async readFile(i){try{const n=this.toFilePath(i);return await c.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(i,n,r){const a=(0,C.newWriteableStream)(m=>D.VSBuffer.concat(m.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,i,a,m=>m.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const m=this.toFilePath(i);if(!r.create||!r.overwrite){if(await c.Promises.exists(m)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(i,m)}finally{typeof a=="number"&&await this.close(a)}}async open(i,n){try{const r=this.toFilePath(i);if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await c.SymlinkSupport.stat(r);y.mode&128||await c.Promises.chmod(r,y.mode|128)}catch(y){this.logService.trace(y)}let a;if((0,u.isFileOpenForWriteOptions)(n)){if(d.isWindows)try{await c.Promises.truncate(r,0),a="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}a||(a="w")}else a="r";const m=await c.Promises.open(r,a);return this.mapHandleToPos.set(m,0),(0,u.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(m,i),m}catch(r){throw(0,u.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,r):this.toFileSystemProviderError(r)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await c.Promises.fdatasync(i)}catch(n){this.canFlush=!1,this.logService.error(n)}return await c.Promises.close(i)}catch(n){throw this.toFileSystemProviderError(n)}}async read(i,n,r,a,m){const y=this.normalizePos(i,n);let R=null;try{const P=await c.Promises.read(i,r,a,m,y);return typeof P=="number"?R=P:R=P.bytesRead,R}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(i,y,R)}}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,a+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,a,m){return(0,b.retry)(()=>this.doWrite(i,n,r,a,m),100,3)}async doWrite(i,n,r,a,m){const y=this.normalizePos(i,n);let R=null;try{const P=await c.Promises.write(i,r,a,m,y);return typeof P=="number"?R=P:R=P.bytesWritten,R}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),P)}finally{this.updatePos(i,y,R)}}async mkdir(i){try{await c.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);await this.doDelete(r,n)}catch(r){throw this.toFileSystemProviderError(r)}}async doDelete(i,n){n.recursive?await c.Promises.rm(i,c.RimRafMode.MOVE):await c.Promises.unlink(i)}async rename(i,n,r){const a=this.toFilePath(i),m=this.toFilePath(n);if(a!==m)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await c.Promises.move(a,m)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(2,null,(0,l.basename)(a),(0,l.basename)((0,l.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,n,r){const a=this.toFilePath(i),m=this.toFilePath(n);if(a!==m)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await c.Promises.copy(a,m,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,w.localize)(3,null,(0,l.basename)(a),(0,l.basename)((0,l.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,n,r,a){const m=this.toFilePath(i),y=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,S.isEqual)(m,y,!0)),R&&r==="copy")throw(0,u.createFileSystemProviderError)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!R&&await c.Promises.exists(y)){if(!a)throw(0,u.createFileSystemProviderError)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(i,n,r,a){let m,y=!1;return this.options?.watcher?.usePolling?y=!1:y=this.options?.legacyWatcher==="on",y?m=g.FileWatcher:m=E.FileWatcher,new m(R=>n(R),R=>r(R),a,this.options?.watcher)}doWatch(i,n){const r=this.options?.watcher?.usePolling;if(r===!0)for(const a of n)a.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const a of n)r.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(i,n)}createNonRecursiveWatcher(i,n,r,a){return new v.FileWatcher(i,m=>n(m),m=>r(m),a)}toFileSystemProviderError(i){if(i instanceof u.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await c.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}t.DiskFileSystemProvider=s}),define(J[104],Y([0,1,16,15]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(l,d,p,C){try{const c=await new Promise((w,u)=>{x(["spdlog"],w,u)});return c.setFlushOn(I.LogLevel.Trace),c.createAsyncRotatingLogger(l,d,p,C)}catch(c){console.error(c)}return null}function D(l,d,p,C){const c=x.__$__nodeRequire("spdlog");return c.setFlushOn(I.LogLevel.Trace),c.createRotatingLogger(l,d,p,C)}t.createRotatingLogger=D;function T(l,d,p){switch(d){case I.LogLevel.Trace:l.trace(p);break;case I.LogLevel.Debug:l.debug(p);break;case I.LogLevel.Info:l.info(p);break;case I.LogLevel.Warning:l.warn(p);break;case I.LogLevel.Error:l.error(p);break;case I.LogLevel.Critical:l.critical(p);break;default:throw new Error("Invalid log level")}}class S extends I.AbstractMessageLogger{constructor(d,p,C,c){super();this.name=d,this.filepath=p,this.rotating=C,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const d=this.rotating?6:1,p=30/d*L.ByteSize.MB;return b(this.name,this.filepath,p,d).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:c,message:w}of this.buffer)T(this._logger,c,w);this.buffer=[]}})}log(d,p){this._logger?T(this._logger,d,p):this.getLevel()<=d&&this.buffer.push({level:d,message:p})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=S}),define(J[32],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,L.createDecorator)("productService")}),define(J[25],Y([0,1,56,11]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,S){L.ok(I.isString(T)),L.ok(I.isObject(S)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,S)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(J[105],Y([0,1,10,25]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[b(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;I.Registry.add(t.Extensions.JSONContribution,T)}),define(J[33],Y([0,1,20,10,11,73,105,25]),function(x,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=S.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,o=!0){this.registerConfigurations([f],o)}registerConfigurations(f,o=!0){const s=this.doRegisterConfigurations(f,o);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(f){const o=this.doDeregisterConfigurations(f);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:f,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(f,!1)),p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,L.distinct)(s))}registerDefaultConfigurations(f){const o=[],s=[];for(const e of f)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:D.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(w(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(f){const o=[];for(const s of f)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const o of f)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,o){const s=[];return f.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(f){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of f){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(f,o=!0,s,e=3){e=b.isUndefinedOrNull(f.scope)?e:f.scope;let i=[],n=f.properties;if(n)for(let a in n){if(o&&v(a)){delete n[a];continue}const m=n[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=b.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=b.isUndefinedOrNull(m.restricted)?!!s?.restrictedConfigurations?.includes(a):m.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=f.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(f)}updateSchema(f,o){switch(t.allSettings.properties[f]=o,o.scope){case 1:t.applicationSettings.properties[f]=o;break;case 2:t.machineSettings.properties[f]=o;break;case 6:t.machineOverridableSettings.properties[f]=o;break;case 3:t.windowSettings.properties[f]=o;break;case 4:t.resourceSettings.properties[f]=o;break;case 5:t.resourceSettings.properties[f]=o,this.resourceLanguageSettingsSchema.properties[f]=o;break}}removeFromSchema(f,o){switch(delete t.allSettings.properties[f],o.scope){case 1:delete t.applicationSettings.properties[f];break;case 2:delete t.machineSettings.properties[f];break;case 6:delete t.machineOverridableSettings.properties[f];break;case 3:delete t.windowSettings.properties[f];break;case 4:case 5:delete t.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const o=`[${f}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,o){let s=this.defaultValues[f];b.isUndefined(s)&&(s=o.default),b.isUndefined(s)&&(s=u(o.type)),o.default=s}}const c="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function w(E){return E.substring(1,E.length-1)}t.overrideIdentifierFromKey=w;function u(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const h=new C;S.Registry.add(t.Extensions.Configuration,h);function v(E){return E.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(E)?D.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?D.localize(6,null,E):null:D.localize(4,null)}t.validateProperty=v;function g(){const E=[],f=h.getConfigurationProperties();for(const o of Object.keys(f))E.push([o,f[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}t.getScopes=g}),define(J[26],Y([0,1,18,11,8,33,14,25]),function(x,t,L,I,b,D,T,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof b.URI)}t.isConfigurationOverrides=l;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function C(i,n){const r=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],a=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],m=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const q=g(i.contents,U),te=g(n.contents,U);L.equals(q,te)||m.push(U)}}const y=[],R=U=>{const q={};for(const te of U)for(const ce of te.identifiers)q[s(ce)]=te;return q},P=n?R(n.overrides):{},O=i?R(i.overrides):{};if(Object.keys(P).length)for(const U of r){const q=P[U];q&&y.push([(0,D.overrideIdentifierFromKey)(U),q.keys])}if(Object.keys(O).length)for(const U of a){const q=O[U];q&&y.push([(0,D.overrideIdentifierFromKey)(U),q.keys])}if(Object.keys(P).length&&Object.keys(O).length)for(const U of m){const q=O[U],te=P[U];if(q&&te){const ce=C({contents:q.contents,keys:q.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});y.push([(0,D.overrideIdentifierFromKey)(U),[...ce.added,...ce.removed,...ce.updated]])}}return{added:r,removed:a,updated:m,overrides:y}}t.compare=C;function c(i,n){const r=[];for(const a of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const y in i[a])m[y]=i[a][y];r.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:w(m,n)})}return r}t.toOverrides=c;function w(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=w;function u(i,n,r,a){const m=n.split("."),y=m.pop();let R=i;for(let P=0;P<m.length;P++){let O=m[P],U=R[O];switch(typeof U){case"undefined":U=R[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${m.slice(0,P+1).join(".")} is ${JSON.stringify(U)}`);return}R=U}if(typeof R=="object"&&R!==null)try{R[y]=r}catch(P){a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(R)}`)}else a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(R)}`)}t.addToValueTree=u;function h(i,n){const r=n.split(".");v(i,r)}t.removeFromValueTree=h;function v(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[r])}}function g(i,n,r){function a(R,P){let O=R;for(const U of P){if(typeof O!="object"||O===null)return;O=O[U]}return O}const m=n.split("."),y=a(i,m);return typeof y=="undefined"?r:y}t.getConfigurationValue=g;function E(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?I.isObject(i[a])&&I.isObject(n[a])?E(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=E;function f(){const i=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function o(){const i=Object.create(null),n=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,m=>console.error(`Conflict in default settings: ${m}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),m=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(J[106],Y([0,1,20,10,57,2,101,18,11,8,26,33,25]),function(x,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class w{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,p.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=S.deepClone(this.contents),n=S.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const m of a.overrides){const[y]=n.filter(R=>L.equals(R.identifiers,m.identifiers));y?this.mergeContents(y.contents,m.contents):n.push(S.deepClone(m))}for(const m of a.keys)r.indexOf(m)===-1&&r.push(m)}return new w(i,r,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],m=i[r];m&&(typeof a=="object"&&typeof m=="object"?(a=S.deepClone(a),this.mergeContents(a,m)):a=m),n[r]=a}return new w(n,this.keys,this.overrides)}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=S.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?S.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,p.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=w;class u extends w{constructor(){const e=(0,p.getDefaultValues)(),i=(0,p.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))C.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,C.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,p.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:m}=this.doParseRaw(e,i);this._configurationModel=new w(n,r,a),this._restrictedConfigurations=m||[]}doParseContent(e){let i={},n=null,r=[],a=[],m=[];function y(P){Array.isArray(r)?r.push(P):n!==null&&(r[n]=P)}let R={onObjectBegin:()=>{let P={};y(P),a.push(r),r=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let P=[];y(P),a.push(r),r=P,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:y,onError:(P,O,U)=>{m.push({error:P,offset:O,length:U})}};if(e)try{b.visit(e,R),i=r[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(e,i){const n=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,p.toValuesTree)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),m=Object.keys(e),y=(0,p.toOverrides)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:a,keys:m,overrides:y,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let y in e)if(C.OVERRIDE_PROPERTY_PATTERN.test(y)&&n){const R=this.filter(e[y],i,!1,r);a[y]=R.raw,m.push(...R.restricted)}else{const R=i[y],P=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&m.push(y),(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&(r.skipRestricted&&R?.restricted||(a[y]=e[y]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=h;class v extends D.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class g{constructor(e,i,n=new w,r=new w,a=new T.ResourceMap,m=new w,y=new T.ResourceMap,R=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=y,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new w,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,y=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,q=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,te=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(e):m.getValue(e),ce=r.getValue(e),le=L.distinct(L.flatten(r.overrides.map(ne=>ne.identifiers))).filter(ne=>r.getOverrideValue(e,ne)!==void 0);return{defaultValue:y,userValue:R,userLocalValue:P,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:q,memoryValue:te,value:ce,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:m.getValue(e),override:i.overrideIdentifier?m.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>C.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,C.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),y=e.getKeysForOverrideIdentifier(a),R=[...y.filter(P=>m.indexOf(P)===-1),...m.filter(P=>y.indexOf(P)===-1),...m.filter(P=>!S.equals(this._defaultConfiguration.override(a).getValue(P),e.override(a).getValue(P)))];return[a,R]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.localUserConfiguration,e),m=[...i,...n,...r];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.remoteUserConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,p.compare)(this.workspaceConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:m,overrides:y}=(0,p.compare)(n,i);let R=[...r,...a,...m];return(R.length||!n)&&this.updateFolderConfiguration(e,i),{keys:R,overrides:y}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:m}=(0,p.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,y)=>(m.set(d.URI.revive(y[0]),this.parseConfigurationModel(y[1])),m),new T.ResourceMap);return new g(i,n,new w,r,a,new w,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new w(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=g;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,m])=>{const y=(0,T.getOrSet)(i,a,new Set);m.forEach(R=>y.add(R))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=E;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(y=>a.add(y)),e.overrides.forEach(([,y])=>y.forEach(R=>a.add(R))),this.affectedKeys=[...a.values()];const m=new w;this.affectedKeys.forEach(y=>m.setValue(y,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!S.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,p.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class o extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(J[107],Y([0,1,3,10,2,19,26,106,33,25]),function(x,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends b.Disposable{constructor(c,w){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,w)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,w){const u=typeof c=="string"?c:void 0,h=(0,T.isConfigurationOverrides)(c)?c:(0,T.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(u,h,void 0)}updateValue(c,w,u,h){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,w,1)}onDidDefaultConfigurationChange(c){const w=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,c);this.trigger(u,w,6)}trigger(c,w,u){const h=new S.ConfigurationChangeEvent(c,{data:w},this.configuration);h.source=u,h.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(J[108],Y([0,1,9]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function I(d){return d.scheme===L.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=I;function b(d){if(!d)return;const p=d.indexOf("+");return p<0?d:d.substr(0,p)}t.getRemoteName=b;function D(d){return d.scheme!==L.Schemas.file&&d.scheme!==L.Schemas.vscodeRemote}t.isVirtualResource=D;function T(d){if(d.folders.length)return d.folders.every(p=>D(p.uri))?d.folders[0].uri:void 0;if(d.configuration&&D(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=T;function S(d){return T(d)?.scheme}t.getVirtualWorkspaceScheme=S;function l(d){return T(d)!==void 0}t.isVirtualWorkspace=l}),define(J[42],Y([0,1,27,14,108]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}t.getWorkspaceSupportTypeMessage=D;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S=t.ExtensionType||(t.ExtensionType={}));class l{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,u){if(typeof w=="undefined"||w===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof w=="string"||typeof u=="string"){let h=typeof w=="string"?w:w.value,v=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(h,v)}return w._lower===u._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}t.ExtensionIdentifier=l;function d(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}t.isLanguagePackExtension=d;function p(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=p;function C(c,w){if(w&&c.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(w)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=C,t.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Y([0,1,27,42]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(u,h){return u.uuid&&h.uuid?u.uuid===h.uuid:u.id===h.id?!0:(0,L.compareIgnoreCase)(u.id,h.id)===0}t.areSameExtensions=b;class D{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof D?b(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=D;function T(u,h){return`${u}.${h}`}t.getExtensionId=T;function S(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=S;function l(u,h){return S(T(u,h))}t.getGalleryExtensionId=l;function d(u,h){const v=[],g=E=>{for(const f of v)if(f.some(o=>b(h(o),h(E))))return f;return null};for(const E of u){const f=g(E);f?f.push(E):v.push([E])}return v}t.groupByExtension=d;function p(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=C,t.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(u){const h=new Set;for(const v of u)v.malicious&&h.add(v.id.id);return h}t.getMaliciousExtensionsSet=c;function w(u,h){const v=[],g=h.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const E=g.shift();if(E&&v.every(f=>!b(f.identifier,{id:E}))){const f=u.filter(o=>b(o.identifier,{id:E}));f.length===1&&(v.push(f[0]),g.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=w}),define(J[109],Y([0,1,24,7,62,9,43,8,77,22,23,42]),function(x,t,L,I,b,D,T,S,l,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const c=E=>(0,l.localize)(0,null,E),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(E,f){return f?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(E){const f=h.exec(E);return f&&f[1]?[(0,p.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,p.adoptToGalleryExtensionId)(E),void 0]}t.getIdAndVersion=v;let g=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=C.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(m=>m.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,f)))}async installExtensions(f,o,s,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(P,O)=>{const U=a.find(q=>(0,p.areSameExtensions)(q.identifier,{id:P}));if(U){if(!O&&!e)return i.log((0,l.localize)(5,null,P,U.manifest.version,P)),!1;if(O&&U.manifest.version===O)return i.log((0,l.localize)(6,null,`${P}@${O}`)),!1}return!0},y=[],R=[];for(const P of f)if(P instanceof S.URI)y.push(P);else{const[O,U]=v(P);m(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const P of o){const[O,U]=v(P);m(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async P=>{try{const O=await this.installVSIX(P,{isBuiltin:!1,isMachineScoped:s},e,i);O&&r.push(O)}catch(O){i.error(O.message||O.stack||O),n.push(P.toString())}})),R.length){const P=await this.getGalleryExtensions(R);await Promise.all(R.map(async O=>{const U=P.get(O.id.toLowerCase());if(U)try{const q=await this.installFromGallery(O,U,a,e,i);q&&r.push(q)}catch(q){i.error(q.message||q.stack||q),n.push(O.id)}else i.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${w}`),n.push(O.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(f,o,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,o),e.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),i}catch(r){if((0,I.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const o=new Map,s=await this.extensionGalleryService.getExtensions(f,L.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:f,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,L.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const m=i.find(y=>(0,p.areSameExtensions)(y.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return r.log((0,l.localize)(10,null,o?`${f}@${o}`:f)),null;r.log((0,l.localize)(11,null,f,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,f,o):(0,l.localize)(13,null,f)):r.log(o?(0,l.localize)(14,null,f,o):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,f,e.version)),a}catch(y){if((0,I.isPromiseCanceledError)(y))return r.log((0,l.localize)(17,null,f)),null;throw y}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,s){const e={id:(0,p.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,p.areSameExtensions)(e,r.identifier)&&(0,T.gt)(r.manifest.version,f.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,o,s=console){const e=async n=>{if(n instanceof S.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of f){const r=await e(n),m=(await this.extensionManagementService.getInstalled()).filter(y=>(0,p.areSameExtensions)(y.identifier,{id:r}));if(!m.length)throw new Error(`${this.notInstalled(r)}
${w}`);if(m.some(y=>y.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&m.some(y=>y.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const y of m)await this.extensionManagementService.uninstall(y),i.push(y);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(f,o=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===D.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};g=he([oe(0,d.IExtensionManagementService),oe(1,d.IExtensionGalleryService)],g),t.ExtensionManagementCLIService=g}),define(J[110],Y([0,1,3,7,2,12,19,43,8,31,13,21,22,23,16,15]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends b.Disposable{constructor(f,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const s=this.getName(f),e=(0,T.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,o,s){try{await p.Promises.rename(f.fsPath,o.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],s=[];for(const n of f.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,w.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>S.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await L.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(f){const o=v.exec(f);return o&&o[1]&&o[2]?new w.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};g=he([oe(0,C.INativeEnvironmentService),oe(1,u.IFileService),oe(2,c.IExtensionGalleryService),oe(3,h.ILogService)],g),t.ExtensionsDownloader=g}),define(J[111],Y([0,1,2,6,13,42]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[112],Y([0,1,137,20,3,2,9,6,13,21,22,23,55,15]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(g,E,f){super();this.extensionManagementService=g,this.logService=f,this.cache=this._register(new h(E,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),E=["en",...Object.keys(g)];return(0,I.distinct)(E)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const E=await this.cache.getLanguagePacks();Object.keys(E).some(f=>E[f]&&E[f].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(E);return!(0,I.equals)(Object.keys(g),Object.keys(f))}};u=he([oe(0,p.IExtensionManagementService),oe(1,d.INativeEnvironmentService),oe(2,w.ILogService)],u),t.LocalizationsService=u;let h=class extends D.Disposable{constructor(g,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(E=>{Object.keys(E).forEach(f=>delete E[f]),this.createLanguagePacksFromExtensions(E,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...E){for(const f of E)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,E){const f=E.identifier,o=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const s of o)if(E.location.scheme===T.Schemas.file&&(0,c.isValidLocalization)(s)){let e=g[s.languageId];e||(e={hash:"",extensions:[],translations:{}},g[s.languageId]=e);let i=e.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=E.manifest.version:e.extensions.push({extensionIdentifier:f,version:E.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,S.join)(E.location.fsPath,n.path)}}updateHash(g){if(g){const E=(0,L.createHash)("md5");for(const f of g.extensions)E.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=E.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(E=g(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>E,f=>this.logService.error(f))})}};h=he([oe(0,d.INativeEnvironmentService),oe(1,w.ILogService)],h)}),define(J[44],Y([0,1,17,85,33,14,25]),function(x,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,D.createDecorator)("requestService");function S(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=S;function l(u){return u.res.statusCode===204}async function d(u){if(!S(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,L.streamToBuffer)(u.stream)).toString()}t.asText=d;async function p(u){if(!S(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const v=(await(0,L.streamToBuffer)(u.stream)).toString();try{return JSON.parse(v)}catch(g){throw g.message+=`:
`+v,g}}t.asJson=p;function C(u){w(u)}t.updateProxyConfigurationsScope=C;let c;function w(u){const h=T.Registry.as(b.Extensions.Configuration),v=c;c={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[c],remove:v?[v]:[]})}w(2)}),define(J[113],Y([0,1,24,9,16,44]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,p=L.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const C={type:"GET",url:l.toString()},c=await this.requestService.request(C,p);if(c.res.statusCode===200)await this.fileService.writeFile(d,c.stream);else{const w=await(0,D.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${w}`)}}};T=he([oe(0,D.IRequestService),oe(1,b.IFileService)],T),t.DownloadService=T}),define(J[114],Y([0,1,115,11]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,S){return T.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:T.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(T,S,l={}){const d=(0,L.parse)(T),p=l.proxyUrl||b(d,S);if(!p)return null;const C=(0,L.parse)(p);if(!/^https?:$/.test(C.protocol||""))return null;const c={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((w,u)=>{x(["http-proxy-agent"],w,u)}))(c):new(await new Promise((w,u)=>{x(["https-proxy-agent"],w,u)}))(c)}t.getProxyAgent=D}),define(J[116],Y([0,1,17,31]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(D,T,S){let l=S&&S.get("storage.serviceMachineId",0)||null;if(l)return l;try{const p=(await T.readFile(D.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(p)?p:null}catch(d){l=null}if(!l){l=(0,I.generateUuid)();try{await T.writeFile(D.serviceMachineIdResource,L.VSBuffer.fromString(l))}catch(d){}}return S&&S.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=b}),define(J[117],Y([0,1,3,10,2,102,11,66,14]),function(x,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";t.IStorageService=(0,l.createDecorator)("storageService");var p;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(p=t.WillSaveStateReason||(t.WillSaveStateReason={}));var C;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(C=t.StorageScope||(t.StorageScope={}));var c;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(c=t.StorageTarget||(t.StorageTarget={}));class w extends b.Disposable{constructor(g={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,E){E===d?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:E,target:this.getKeyTargets(g)[E]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,E,f){return this.getStorage(E)?.get(g,f)}getBoolean(g,E,f){return this.getStorage(E)?.getBoolean(g,f)}getNumber(g,E,f){return this.getStorage(E)?.getNumber(g,f)}store(g,E,f,o){if((0,T.isUndefinedOrNull)(E)){this.remove(g,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,f,o),this.getStorage(f)?.set(g,E)})}remove(g,E){this.withPausedEmitters(()=>{this.updateKeyTarget(g,E,void 0),this.getStorage(E)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,E){const f=[],o=this.getKeyTargets(g);for(const s of Object.keys(o))o[s]===E&&f.push(s);return f}updateKeyTarget(g,E,f){const o=this.getKeyTargets(E);typeof f=="number"?o[g]!==f&&(o[g]=f,this.getStorage(E)?.set(d,JSON.stringify(o))):typeof o[g]=="number"&&(delete o[g],this.getStorage(E)?.set(d,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const E=this.get(d,g);if(E)try{return JSON.parse(E)}catch(f){}return Object.create(null)}isNew(g){return this.getBoolean(t.IS_NEW_KEY,g)===!0}async flush(g=p.NONE){this._onWillSaveState.fire({reason:g}),await L.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const g=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return h(g,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends w{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}t.InMemoryStorageService=u;async function h(v,g,E,f){const o=m=>{try{return JSON.parse(m)}catch(y){return m}},s=new Map,e=new Map;v.forEach((m,y)=>{s.set(y,m),e.set(y,o(m))});const i=new Map,n=new Map;g.forEach((m,y)=>{i.set(y,m),n.set(y,o(m))}),console.group(`Storage: Global (path: ${E})`);let r=[];s.forEach((m,y)=>{r.push({key:y,value:m})}),console.table(r),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${f})`);let a=[];i.forEach((m,y)=>{a.push({key:y,value:m})}),console.table(a),console.groupEnd(),console.log(n)}t.logStorage=h}),define(J[118],Y([0,1,12,29,8,31]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(d){if(L.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function S(d,p,C,c,w,u,h,v,g,E){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=w,f.version=u,f["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,L.PlatformToString)(L.platform),f["common.nodePlatform"]=I.platform,f["common.nodeArch"]=c,f["common.product"]=E||"desktop";const o=l(v||[]);o&&(f["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),L.isLinuxSnap&&(f["common.snap"]="true");const i=T(C);i&&(f["common.platformDetail"]=i);try{const n=await d.readFile(b.URI.file(g));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=S;function l(d){const p=I.env.USERDNSDOMAIN;if(!p)return!1;const C=p.toLowerCase();return d.some(c=>C===c)}t.verifyMicrosoftInternalDomain=l}),define(J[30],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,L.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(I=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[119],Y([0,1,20,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let v=class extends S.Disposable{constructor(s,e,i,n){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,S.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,C.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(p.localize(0,null),C.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new C.ExtensionManagementError(p.localize(1,null,s.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(n)),C.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,D.getErrorMessage)(n)),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,b.CancellationToken.None);if(i===null){const n=new C.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new C.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error(n.message),E(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(p.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let y=this.installingExtensions.get(new c.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(y)return this.logService.info("Extensions is already requested to install",e.identifier.id),y.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let m=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:P,manifest:O}of R)if(m=m||!!O.extensionDependencies?.some(U=>(0,c.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new c.ExtensionIdentifierWithVersion(P.identifier,P.version).key()))this.logService.info("Extension is already requested to install",P.identifier.id);else{const U=this.createInstallExtensionTask(O,P,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:P}),this.logService.info("Installing extension:",U.identifier.id),n.push({task:U,manifest:O})}}catch(R){if(d.URI.isUri(a.source))(0,L.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,R.message),(0,L.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(R),R}const y=n.reduce((R,{task:P,manifest:O})=>(R.set(P.identifier.id.toLowerCase(),{task:P,manifest:O}),R),new Map);for(;y.size;){let R;const P=[...y.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>y.has(U.toLowerCase())));P.length?R=y.size===1?P:P.filter(({task:O})=>!(O===a&&!m)):(this.logService.info("Found extensions with circular dependencies",P.map(({task:O})=>O.identifier.id)),R=[...y.values()]),await this.joinAllSettled(R.map(async({task:O})=>{const U=new Date().getTime();try{const q=await O.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(q,O.source,i,b.CancellationToken.None))),!d.URI.isUri(O.source)&&(E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),l.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch(te){}r.push({local:q,identifier:O.identifier,operation:O.operation,source:O.source})}catch(q){throw d.URI.isUri(O.source)||E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,q),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(q),q}finally{y.delete(O.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:R})=>(0,c.areSameExtensions)(R,a.identifier))[0].local}catch(y){if(n.forEach(({task:R})=>R.cancel()),r.length)try{const R=await Promise.allSettled(r.map(({local:P})=>this.createUninstallExtensionTask(P,{versionOnly:!0}).run()));for(let P=0;P<R.length;P++){const O=R[P],{identifier:U}=r[P];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,D.getErrorMessage)(O.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(R),r.map(({identifier:P})=>P.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(y)),this._onDidInstallExtensions.fire(n.map(({task:R})=>({identifier:R.identifier,operation:1,source:R.source}))),y instanceof Error&&(y.name=y&&y.code?y.code:C.ExtensionManagementErrorCode.Internal),y}finally{for(const{task:y,manifest:R}of n)if(!d.URI.isUri(y.source)){const P=new c.ExtensionIdentifierWithVersion(y.identifier,R.version).key();this.installingExtensions.delete(P)||this.logService.warn("Installation task is not found in the cache",P)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw g(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(y=>y.identifier)],a=[],m=async(y,R)=>{const P=R.extensionDependencies||[],O=[...P];if(R.extensionPack){const U=i?n.find(q=>(0,c.areSameExtensions)(q.identifier,y)):void 0;for(const q of R.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(te=>(0,c.areSameExtensions)({id:te},{id:q}))||O.every(te=>!(0,c.areSameExtensions)({id:te},{id:q}))&&O.push(q)}if(O.length){const U=[...r,...a.map(te=>te.gallery.identifier)],q=O.filter(te=>U.every(ce=>!(0,c.areSameExtensions)(ce,{id:te})));if(q.length){const te=await this.galleryService.query({names:q,pageSize:O.length},b.CancellationToken.None);for(const ce of te.firstPage){if(U.find(z=>(0,c.areSameExtensions)(z,ce.identifier)))continue;if(!P.some(z=>(0,c.areSameExtensions)({id:z},ce.identifier))&&!await this.canInstall(ce)){this.logService.info("Skipping the packed extension as it cannot be installed",ce.identifier.id);continue}const ne=await this.checkAndGetCompatibleVersion(ce,!0),de=await this.galleryService.getManifest(ne,b.CancellationToken.None);if(de===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${ne.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);a.push({gallery:ne,manifest:de}),await m(ne.identifier,de)}}}};return await m(s,e),n=await this.getInstalled(),a.filter(y=>!n.some(R=>(0,c.areSameExtensions)(R.identifier,y.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new C.ExtensionManagementError(p.localize(4,null,s.identifier.id),C.ExtensionManagementErrorCode.Malicious);const i=await this.getCompatibleVersion(s,e);if(!i)throw new C.ExtensionManagementError(p.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,c.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(y,R)=>{const P=this.createUninstallExtensionTask(y,R);return this.uninstallingExtensions.set(P.extension.identifier.id.toLowerCase(),P),this.logService.info("Uninstalling extension:",y.identifier.id),this._onUninstallExtension.fire(y.identifier),P},r=(y,R)=>{R?this.logService.error("Failed to uninstall extension:",y.identifier.id,R.message):this.logService.info("Successfully uninstalled extension:",y.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",(0,c.getLocalExtensionTelemetryData)(y),void 0,R),this._onDidUninstallExtension.fire({identifier:y.identifier,error:R?.code})},a=[],m=[];try{a.push(n(s,{}));const y=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const R=this.getAllPackExtensionsToUninstall(s,y);for(const P of R)this.uninstallingExtensions.has(P.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",P.identifier.id):a.push(n(P,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(R=>R.extension),y,s),await this.joinAllSettled(a.map(async R=>{try{if(await R.run(),await this.joinAllSettled(this.participants.map(P=>P.postUninstall(R.extension,e,b.CancellationToken.None))),R.extension.identifier.uuid)try{await this.galleryService.reportStatistic(R.extension.manifest.publisher,R.extension.manifest.name,R.extension.manifest.version,"uninstall")}catch(P){}r(R.extension)}catch(P){const O=P instanceof C.ExtensionManagementError?P:new C.ExtensionManagementError((0,D.getErrorMessage)(P),C.ExtensionManagementErrorCode.Internal);throw r(R.extension,O),O}finally{m.push(R)}}))}catch(y){const R=y instanceof C.ExtensionManagementError?y:new C.ExtensionManagementError((0,D.getErrorMessage)(y),C.ExtensionManagementErrorCode.Internal);for(const P of a){try{P.cancel()}catch(O){}m.includes(P)||r(P.extension,R)}throw R}finally{for(const y of a)this.uninstallingExtensions.delete(y.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",y.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(m=>!s.some(y=>(0,c.areSameExtensions)(y.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?p.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?p.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(m=>!m.isBuiltin&&n.some(y=>(0,c.areSameExtensions)({id:y},m.identifier))),a=[];for(const m of r)a.push(...this.getAllPackExtensionsToUninstall(m,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,c.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=he([oe(0,C.IExtensionGalleryService),oe(1,h.ITelemetryService),oe(2,w.ILogService),oe(3,u.IProductService)],v),t.AbstractExtensionManagementService=v;function g(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=g;function E(o,s,e,i,n){const r=n?n instanceof C.ExtensionManagementError?n.code:C.ExtensionManagementErrorCode.Internal:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=E;class f{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=f}),define(J[36],Y([0,1,18,11,26,30]),function(x,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,E){return Promise.resolve(void 0)}publicLog2(g,E){return this.publicLog(g,E)}publicLogError(g,E){return Promise.resolve(void 0)}publicLogError2(g,E){return this.publicLogError(g,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class S{async publicLog(g,E,f){}async publicLogError(g,E,f){}}t.NullEndpointTelemetryService=S,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(v,g){return g.onDidChangeConfiguration(E=>{E.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(E.source),configurationKeys:u(E.sourceConfig)})})}t.configurationTelemetry=l;function d(v,g){return!(g.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=d;function p(v){const g=v.getValue(D.TELEMETRY_SETTING_ID),E=v.getValue("telemetry.enableCrashReporter");if(v.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=p;function C(v){const g=Object.create(null),E=Object.create(null),f=Object.create(null);w(v,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const s=f[o];typeof s=="number"?E[o]=s:typeof s=="boolean"?E[o]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${s.length}`),g[o]=s.substring(0,8191)):typeof s!="undefined"&&s!==null&&(g[o]=s)}return{properties:g,measurements:E}}t.validateTelemetryData=C;function c(v){if(!v)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{v.indexOf(`${f}+`)===0&&(g=f)}),g}t.cleanRemoteAuthority=c;function w(v,g,E=0,f){if(!!v)for(let o of Object.getOwnPropertyNames(v)){const s=v[o],e=f?f+o:o;Array.isArray(s)?g[e]=(0,L.safeStringify)(s):s instanceof Date?g[e]=s.toISOString():(0,I.isObject)(s)?E<2?w(s,g,E+1,e+"."):g[e]=(0,L.safeStringify)(s):g[e]=s}}function u(v){if(!v)return[];const g=[];return h(g,"",v),g}function h(v,g,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(f=>h(v,g?`${g}.${f}`:f,E[f])):v.push(g)}}),define(J[120],Y([0,1,20,24,7,18,12,29,8,26,21,22,23,51,16,15,32,44,116,117,30,36]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g,E,f,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,S.arch);var i;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...N){return String(N.reduce((A,B)=>A|B,0))}var r;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(A=R){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,B=this.state.pageSize){return new P({...this.state,pageNumber:A,pageSize:B})}withFilter(A,...B){const V=[...this.state.criteria,...B.length?B.map(K=>({filterType:A,value:K})):[{filterType:A}]];return new P({...this.state,criteria:V})}withSortBy(A){return new P({...this.state,sortBy:A})}withSortOrder(A){return new P({...this.state,sortOrder:A})}withFlags(...A){return new P({...this.state,flags:A.reduce((B,V)=>B|V,0)})}withAssetTypes(...A){return new P({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:B,pageSize:V,sortBy:K,sortOrder:Q,flags:se,assetTypes:ie}=this.state;return{filters:[{criteria:A,pageNumber:B,pageSize:V,sortBy:K,sortOrder:Q}],assetTypes:ie,flags:se}}get searchText(){const A=this.state.criteria.filter(B=>B.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(N,A){const B=(N||[]).filter(V=>V.statisticName===A)[0];return B?B.value:0}function U(N){const A="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(V=>V.assetType.indexOf(A)===0).reduce((V,K)=>{const Q=le(N,K.assetType);return Q&&V.push([K.assetType.substring(A.length),Q]),V},[])}function q(N){if(N.properties){const A=N.properties.filter(K=>K.key===a.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=A.filter(K=>B.test(K.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return le(N,a.Repository)}function te(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ce(N){const A=le(N,a.Icon);if(A)return A;const B=C.DefaultIconPath;return{uri:B,fallbackUri:B}}function le(N,A){return N.files.filter(V=>V.assetType===A)[0]?{uri:`${N.assetUri}/${A}`,fallbackUri:`${N.fallbackAssetUri}/${A}`}:null}function ne(N,A){const B=N.properties?N.properties.filter(K=>K.key===A):[],V=B.length>0&&B[0].value;return V?V.split(",").map(K=>(0,c.adoptToGalleryExtensionId)(K)):[]}function de(N){const A=N.properties?N.properties.filter(B=>B.key===m.Engine):[];return A.length>0&&A[0].value||""}function z(N){const A=N.properties?N.properties.filter(V=>V.key===m.LocalizedLanguages):[],B=A.length>0&&A[0].value||"";return B?B.split(","):[]}function H(N){return N.indexOf("preview")!==-1}function re(N){return N.targetPlatform?(0,C.toTargetPlatform)(N.targetPlatform):"undefined"}function M(N){const A=(0,L.distinct)(N.versions.map(re)),B=!!N.tags?.includes(C.WEB_EXTENSION_TAG),V=A.indexOf("web");return B?V===-1&&A.push("web"):V!==-1&&A.splice(V,1),A}function k(N,A){const B=(0,C.getFallbackTargetPlarforms)(A);for(let V=0;V<N.length;V++){const K=N[V];if(K.version===N[V-1]?.version){let Q=V;const se=re(K);if(se===A)for(;Q>0&&N[Q-1].version===K.version;)Q--;else if(B.includes(se))for(;Q>0&&N[Q-1].version===K.version&&re(N[Q-1])!==A;)Q--;Q!==V&&(N.splice(V,1),N.splice(Q,0,K))}}return N}t.sortExtensionVersions=k;function W(N,A,B,V,K){const Q=M(N);let se=N.versions[0];return se=N.versions.find(ie=>ie.version===se.version&&(0,C.isTargetPlatformCompatible)(re(ie),Q,K))||se,G(N,se,Q,A,B,V)}function G(N,A,B,V,K,Q){const se={manifest:le(A,a.Manifest),readme:le(A,a.Details),changelog:le(A,a.Changelog),license:le(A,a.License),repository:q(A),download:te(A),icon:ce(A),coreTranslations:U(A)};return{identifier:{id:(0,c.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:A.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:O(N.statistics,"install"),rating:O(N.statistics,"averagerating"),ratingCount:O(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:B,assets:se,properties:{dependencies:ne(A,m.Dependency),extensionPack:ne(A,m.ExtensionPack),engine:de(A),localizedLanguages:z(A),targetPlatform:re(A)},preview:H(N.flags),telemetryData:{index:(K.pageNumber-1)*K.pageSize+V,querySource:Q}}}let ee=class{constructor(A,B,V,K,Q,se,ie,me){this.requestService=B,this.logService=V,this.environmentService=K,this.telemetryService=Q,this.fileService=se,this.productService=ie,this.configurationService=me;const ye=ie.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(ie.version,ie,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,B){const V=[];let K=new P().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(K=K.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(K,e,I.CancellationToken.None);for(let se=0;se<Q.length;se++){const ie=Q[se];if(!ie.versions.length)continue;const me=(0,c.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ye=A.find(ue=>(0,c.areSameExtensions)(ue,{id:me}))?.version;if(ye){const ue=ie.versions.find(Ie=>Ie.version===ye);ue&&V.push(G(ie,ue,M(ie),se,K))}else V.push(W(ie,se,K,void 0,e))}return V}async getCompatibleExtension(A,B){const V=(0,C.isIExtensionIdentifier)(A)?null:A;if(V){if((0,C.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(V,B))return V}const{id:K,uuid:Q}=V?V.identifier:A;let se=new P().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,K);const{galleryExtensions:ie}=await this.queryGallery(se,B,I.CancellationToken.None),[me]=ie;if(!me||!me.versions.length)return null;const ye=M(me);if((0,C.isNotWebExtensionInWebTargetPlatform)(ye,B))return null;for(let ue of me.versions){if(!de(ue)){const Ie=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:m.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ue,ye,B))return G(me,ue,ye,0,se)}return null}async isExtensionCompatible(A,B){if(!(0,C.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B))return!1;let V=A.properties.engine;if(!V){const K=await this.getManifest(A,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");V=K.engines.vscode}return(0,w.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,B,V){if(!(0,C.isTargetPlatformCompatible)(re(A),B,V))return!1;const K=await this.getEngine(A);return(0,w.isEngineValid)(K,this.productService.version,this.productService.date)}async query(A,B){const V=I.CancellationToken.isCancellationToken(A)?{}:A,K=I.CancellationToken.isCancellationToken(A)?A:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=V.text||"";const se=(0,D.getOrDefault)(V,ve=>ve.pageSize,50);let ie=new P().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(r.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(r.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ie=ie.withFilter(r.SearchText,Q)),ie=ie.withSortBy(0)):V.ids?ie=ie.withFilter(r.ExtensionId,...V.ids):V.names?ie=ie.withFilter(r.ExtensionName,...V.names):ie=ie.withSortBy(4),typeof V.sortBy=="number"&&(ie=ie.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ie=ie.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(ie,e,K),ue=me.map((ve,Ee)=>W(ve,Ee,ie,V.source,e)),Ie=async(ve,Ee)=>{if(Ee.isCancellationRequested)throw(0,b.canceled)();const Fe=ie.withPage(ve+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,Ee);return Me.map((xe,ze)=>W(xe,ze,Fe,V.source,e))};return{firstPage:ue,total:ye,pageSize:ie.pageSize,getPage:Ie}}async queryGallery(A,B,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const K=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ie=new Date().getTime();let me,ye,ue=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},V),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:ue};const Ie=await(0,g.asJson)(me);if(Ie){const ve=Ie.results[0],Ee=ve.extensions;Ee.forEach(Me=>k(Me.versions,B));const Fe=ve.resultMetadata&&ve.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return ue=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue}}return{galleryExtensions:[],total:ue}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-ie,success:!!me&&(0,g.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,b.isPromiseCanceledError)(ye)?"canceled":(0,b.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(A,B,V,K){if(!this.isEnabled())return;const Q=T.isWeb?this.api(`/itemName/${A}.${B}/version/${V}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${B}/${V}/stats?statType=${K}`),se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},I.CancellationToken.None)}catch(ye){}}async download(A,B,V){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const K=(0,c.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:ue}),ie=V===1?"install":V===2?"update":"",me=ie?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(B,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,B){if(A.assets.readme){const V=await this.getAsset(A.assets.readme,{},B);return await(0,g.asText)(V)||""}return""}async getManifest(A,B){if(A.assets.manifest){const V=await this.getAsset(A.assets.manifest,{},B),K=await(0,g.asText)(V);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(A,B){const V=le(A,a.Manifest);if(!V)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Q=await this.getAsset(V,{headers:K});return await(0,g.asJson)(Q)}async getCoreTranslation(A,B){const V=A.assets.coreTranslations.filter(K=>K[0]===B.toUpperCase())[0];if(V){const K=await this.getAsset(V[1]),Q=await(0,g.asText)(K);return Q?JSON.parse(Q):null}return null}async getChangelog(A,B){if(A.assets.changelog){const V=await this.getAsset(A.assets.changelog,{},B);return await(0,g.asText)(V)||""}return""}async getAllCompatibleVersions(A,B){let V=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?V=V.withFilter(r.ExtensionId,A.identifier.uuid):V=V.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:K}=await this.queryGallery(V,B,I.CancellationToken.None);if(!K.length)return[];const Q=M(K[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(Q,B))return[];const se=[];for(const ie of K[0].versions)try{se[se.length-1]?.version!==ie.version&&await this.isRawExtensionVersionCompatible(ie,Q,B)&&se.push({version:ie.version,date:ie.lastUpdated})}catch(me){}return se}async getAsset(A,B={},V=I.CancellationToken.None){const K=await this.commonHeadersPromise,Q={type:"GET"},se={...K,...B.headers||{}};B={...B,...Q,headers:se};const ie=A.uri,me=A.fallbackUri,ye={...B,url:ie};try{const ue=await this.requestService.request(ye,V);if(ue.res.statusCode===200)return ue;const Ie=await(0,g.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${Ie}`)}catch(ue){if((0,b.isPromiseCanceledError)(ue))throw ue;const Ie=(0,b.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ie});const ve={...B,url:me};return this.requestService.request(ve,V)}}async getEngine(A){let B=de(A);if(!B){const V=await this.getManifestFromRawExtensionVersion(A,I.CancellationToken.None);if(!V)throw new Error("Manifest was not found");B=V.engines.vscode}return B}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,g.asJson)(A),V=new Map;if(B)for(const K of B.malicious){const Q=V.get(K)||{id:{id:K},malicious:!0,slow:!1};Q.malicious=!0,V.set(K,Q)}return[...V.values()]}};ee=he([oe(1,g.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,u.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],ee);let X=class extends ee{constructor(A,B,V,K,Q,se,ie,me){super(A,B,V,K,Q,se,ie,me)}};X=he([oe(0,f.IStorageService),oe(1,g.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,u.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],X),t.ExtensionGalleryService=X;let Z=class extends ee{constructor(A,B,V,K,Q,se,ie){super(void 0,A,B,V,K,Q,se,ie)}};Z=he([oe(0,g.IRequestService),oe(1,h.ILogService),oe(2,p.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,u.IFileService),oe(5,v.IProductService),oe(6,d.IConfigurationService)],Z),t.ExtensionGalleryServiceWithNoStorageService=Z;async function _(N,A,B,V,K,Q){const se={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ie=await(0,E.getServiceMachineId)(B,K,Q);return(0,s.supportsTelemetry)(A,B)&&(0,s.getTelemetryLevel)(V)===3&&(se["X-Market-User-Id"]=ie),se}t.resolveMarketplaceHeaders=_}),define(J[121],Y([0,1,2,18,12,27,86,26,33,122,25,30,36]),function(x,t,L,I,b,D,T,S,l,d,p,C,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let w=class{constructor(v,g){this._configurationService=g,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const f=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(v,g){this._experimentProperties[v]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let g=v.sessionID,E=v["common.instanceId"],f=v["common.machineId"],o=v["common.firstSessionDate"],s=v["common.msftInternal"];return{sessionId:g,instanceId:E,machineId:f,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(v,g,E,f){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(o=>{E=(0,I.mixin)(E,o),E=(0,I.mixin)(E,this._experimentProperties),E=(0,I.cloneAndChange)(E,s=>{if(typeof s=="string")return this._cleanupInfo(s,f)}),this._appenders.forEach(s=>s.log(v,E))},o=>{console.error(o)})}publicLog(v,g,E){return this._log(v,3,g,E)}publicLog2(v,g,E){return this.publicLog(v,g,E)}publicLogError(v,g){return this.sendErrorTelemetry?this._log(v,2,g,!0):Promise.resolve(void 0)}publicLogError2(v,g){return this.publicLogError(v,g)}_anonymizeFilePaths(v){let g=v;const E=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(v);if(!i)break;E.push([i.index,e.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(g="";;){const e=o.exec(v);if(!e)break;!f.test(e[0])&&E.every(([i,n])=>e.index<i||e.index>=n)&&(g+=v.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<v.length&&(g+=v.substr(s)),g}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const g=v.toLowerCase(),E=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(g)?"<REDACTED: secret>":E.test(g)?"<REDACTED: email>":v}_cleanupInfo(v,g){let E=v;g&&(E=this._anonymizeFilePaths(E));for(let f of this._cleanupPatterns)E=E.replace(f,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([oe(1,S.IConfigurationService)],w),t.TelemetryService=w;function u(){const h=(0,T.localize)(0,null,d.default.nameLong),v=d.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=b.isWeb?"":(0,T.localize)(3,null),E=(0,T.localize)(4,null),f=(0,T.localize)(5,null),o=(0,T.localize)(6,null),s=(0,T.localize)(7,null),e=`
|       | ${E} | ${f} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,T.localize)(8,null);return`
${h} ${v} ${g}

&nbsp;

${s}
${e}

&nbsp;

${i}
`}p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,T.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,T.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Y([0,1,7,18,36]),function(x,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function D(S,l){const d=await new Promise((C,c)=>{x(["applicationinsights"],C,c)});let p;return d.defaultClient?(p=new d.TelemetryClient(S),p.channel.setUseDiskRetryCaching(!0)):(d.setup(S).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=d.defaultClient),S.indexOf("AIF-")===0&&(p.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),p}class T{constructor(l,d,p,C,c){this._eventPrefix=l,this._defaultData=d,this.testCollector=C,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,L.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,I.mixin)(d,this._defaultData),d=(0,b.validateTelemetryData)(d),this.testCollector&&(d.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[124],Y([0,1,6,13]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(D,T){const S=Object.create(null),l=(p,C)=>{const c=JSON.parse(p);S[C]=c};if(T){const p=[],C=await I.Promises.readdir(T);for(const w of C)try{(await I.Promises.stat((0,L.join)(T,w))).isDirectory()&&p.push(w)}catch{}const c=[];for(const w of p)(await I.Promises.readdir((0,L.join)(T,w))).filter(h=>h==="telemetry.json").length===1&&c.push(w);for(const w of c){const u=(await I.Promises.readFile((0,L.join)(T,w,"telemetry.json"))).toString();l(u,w)}}let d=(await I.Promises.readFile((0,L.join)(D,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await I.Promises.readFile((0,L.join)(D,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(S,null,4)}t.buildTelemetryMessage=b}),define(J[37],Y([0,1,14]),function(x,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(J[125],Y([0,1,10,2,8,21,23,16,15,37]),function(x,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends I.Disposable{constructor(c,w,u,h,v){super();this.extensionsManagementService=c,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(E=>this.onInstallExtension(E))),this._register(c.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(c.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const g=b.URI.file(u.extensionsPath);this._register(w.watch(g)),this._register(L.Event.filter(w.onDidChangeFilesRaw,E=>E.changes.some(f=>this.doesChangeAffects(f,g)))(()=>this.onDidChange()))}doesChangeAffects(c,w){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),w)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const w of c)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(w=>!(0,T.areSameExtensions)(w,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,T.areSameExtensions)(w,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),w=c.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),u=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,h))?!1:c.every(v=>!(0,T.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=c.map(h=>h.identifier),(w.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:u})}}};p=he([oe(1,S.IFileService),oe(2,D.INativeEnvironmentService),oe(3,l.ILogService),oe(4,d.IUriIdentityService)],p),t.ExtensionsWatcher=p}),define(J[126],Y([0,1,37,91,16,19,59,10,2]),function(x,t,L,I,b,D,T,S,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(c){this.uri=c,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let p=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const w=new Map,u=h=>{let v=w.get(h.scheme);return v===void 0&&(v=c.hasProvider(h)&&!this._fileService.hasCapability(h,1024),w.set(h.scheme,v)),v};this._dispooables.add(S.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(h=>{w.delete(h.scheme)})),this.extUri=new D.ExtUri(u),this._canonicalUris=new T.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,D.normalizePath)(c));let w=this._canonicalUris.get(c);return w?w.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new d(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,h)=>u[1].touch<h[1].touch?1:u[1].touch>h[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const w=this._limit*.5;for(let u=0;u<w;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};p=he([oe(0,b.IFileService)],p),t.UriIdentityService=p,(0,I.registerSingleton)(L.IUriIdentityService,p,!0)}),define(J[45],Y([0,1,48,3,6,11,13,72,138,139]),function(x,t,L,I,b,D,T,S,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=p;function C(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function c(s){if(s instanceof p)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new p(e,s)}function w(s,e,i,n,r,a){const m=b.dirname(e),y=b.join(n,m);if(!y.startsWith(n))return Promise.reject(new Error(S.localize(0,null,e)));const R=b.join(n,e);let P;return a.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(T.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((O,U)=>{if(!a.isCancellationRequested)try{P=(0,L.createWriteStream)(R,{mode:i}),P.once("close",()=>O()),P.once("error",U),s.once("error",U),s.pipe(P)}catch(q){U(q)}}))}function u(s,e,i,n){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,y)=>{const R=new I.Sequencer,P=O=>{O.isCancellationRequested||(a++,s.readEntry())};s.once("error",y),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?m():y(new p("Incomplete",new Error(S.localize(1,null,a,s.entryCount))))},y)),s.readEntry(),s.on("entry",O=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){P(n);return}const U=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ce=b.join(e,U);r=(0,I.createCancelablePromise)(le=>T.Promises.mkdir(ce,{recursive:!0}).then(()=>P(le)).then(void 0,y));return}const q=v(s,O),te=C(O);r=(0,I.createCancelablePromise)(ce=>R.queue(()=>q.then(le=>w(le,U,te,e,i,ce).then(()=>P(ce)))).then(null,y))})})}function h(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(c(r)):i((0,D.assertIsDefined)(a))})})}function v(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(c(r)):i((0,D.assertIsDefined)(a))})})}function g(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const a=(0,L.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=g;function E(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=h(s,!0);return i.overwrite&&(a=a.then(m=>T.Promises.rm(e).then(()=>m))),a.then(m=>u(m,e,{sourcePathRegex:r},n))}t.extract=E;function f(s,e){return h(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&v(i,a).then(m=>n(m),m=>r(m))}),i.once("close",()=>r(new Error(S.localize(2,null,e))))}))}function o(s,e){return f(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",m=>a.push(m)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(J[127],Y([0,1,45,79]),function(x,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(D){return(0,L.buffer)(D,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(S){throw new Error((0,I.localize)(0,null))}})}t.getManifest=b}),define(J[128],Y([0,1,20,3,7,2,9,6,12,19,43,8,31,13,45,80,21,22,23,90,16,15,32]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g,E,f,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let i=class extends D.Disposable{constructor(r,a,m,y,R){super();this.beforeRemovingExtension=r,this.fileService=a,this.logService=m,this.environmentService=y,this.productService=R,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=S.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const a=[];(r===null||r===0)&&a.push(this.scanSystemExtensions().then(null,m=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(m).message,g.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&a.push(this.scanUserExtensions(!0).then(null,m=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(m).message,g.ExtensionManagementErrorCode.Internal))));try{const m=await Promise.all(a);return(0,L.flatten)(m)}catch(m){throw this.joinErrors(m)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[a,m]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return m=m.filter(y=>!a[new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),r&&(m=(0,E.groupByExtension)(m,R=>R.identifier).map(R=>R.sort((P,O)=>p.rcompare(P.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",m.length),m}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,a,m,y){const R=r.key(),P=S.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=S.join(this.extensionsPath,R);try{await w.Promises.rm(O)}catch(q){try{await w.Promises.rm(O)}catch(te){}throw new g.ExtensionManagementError((0,h.localize)(0,null,O,r.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,a,P,y);let U=await this.scanExtension(C.URI.file(P),1);if(!U)throw new Error((0,h.localize)(1,null,P));await this.storeMetadata(U,{...m,installedTimestamp:Date.now()});try{await this.rename(r,P,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(q){try{await w.Promises.rm(P)}catch(te){}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(q)}. Deleted from extracted location`,P),q}try{U=await this.scanExtension(C.URI.file(O),1)}catch(q){}if(U)return U;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,a){return this.setMetadata(r,a),await this.storeMetadata(r,{...a,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const m=S.join(r.location.fsPath,"package.json"),y=await w.Promises.readFile(m,"utf8"),{manifest:R}=await this.parseManifest(y);return R.__metadata=a,await w.Promises.writeFile(m,JSON.stringify(R,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const a=r.map(m=>new E.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version));await this.withUninstalledExtensions(m=>{a.forEach(y=>m[y.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(y=>delete y[r.key()]);const m=(await this.scanExtensions(1)).find(y=>new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(r))||null;return m?(await this.storeMetadata(m,{installedTimestamp:Date.now()}),this.scanExtension(m.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let m={};if(a)try{m=JSON.parse(a)}catch(y){}return r&&(r(m),Object.keys(m).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(m)):await w.Promises.rm(this.uninstalledPath)),m})}async removeExtension(r,a){this.logService.trace(`Deleting ${a} extension from disk`,r.identifier.id,r.location.fsPath),await w.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new E.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,a,m,y){this.logService.trace(`Started extracting the extension from ${a} to ${m}`);try{await w.Promises.rm(m)}catch(R){throw new g.ExtensionManagementError(this.joinErrors(R).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(a,m,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${m}:`,r.id)}catch(R){try{await w.Promises.rm(m)}catch(O){}let P=g.ExtensionManagementErrorCode.Extract;throw R instanceof u.ExtractError&&(R.type==="CorruptZip"?P=g.ExtensionManagementErrorCode.CorruptZip:R.type==="Incomplete"&&(P=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(R.message,P)}}async rename(r,a,m,y){try{await w.Promises.rename(a,m)}catch(R){if(l.isWindows&&R&&R.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${a} to ${m} with 'EPERM' error. Trying again...`,r.id),this.rename(r,a,m,y);throw new g.ExtensionManagementError(R.message||(0,h.localize)(3,null,a,m),R.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const a=this.scanDevSystemExtensions(),[m,y]=await Promise.all([r,a]);return[...m,...y]}async scanExtensionsInDir(r,a){const m=new I.Limiter(10),y=await this.fileService.resolve(C.URI.file(r));return y.children?(await Promise.all(y.children.filter(P=>P.isDirectory).map(P=>m.queue(async()=>a===1&&(0,d.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,a))))).filter(P=>P&&P.identifier):[]}async scanExtension(r,a){try{const m=await this.fileService.resolve(r);if(m.children){const{manifest:y,metadata:R}=await this.readManifest(r.fsPath),P=m.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,O=m.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource,U={id:(0,E.getGalleryExtensionId)(y.publisher,y.name)},q={type:a,identifier:U,manifest:y,location:r,readmeUrl:P,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return R&&(this.setMetadata(q,R),q.installedTimestamp=R.installedTimestamp),q}}catch(m){a!==0&&this.logService.trace(m)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(m=>r.some(y=>(0,E.areSameExtensions)(m.identifier,{id:y})))}else return[]}setMetadata(r,a){r.publisherDisplayName=a.publisherDisplayName||null,r.publisherId=a.publisherId||null,r.identifier.uuid=a.id,r.isMachineScoped=!!a.isMachineScoped,r.isBuiltin=r.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),m=new Set;for(const P of a)r[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||m.add(P.identifier.id.toLowerCase());const y=(0,E.groupByExtension)(a,P=>P.identifier);await I.Promises.settled(y.map(async P=>{const O=P.sort((U,q)=>p.rcompare(U.manifest.version,q.manifest.version))[0];m.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const R=a.filter(P=>r[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await I.Promises.settled(R.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),a=[],m=(0,E.groupByExtension)(r,y=>y.identifier);a.push(...(0,L.flatten)(m.map(y=>y.sort((R,P)=>p.rcompare(R.manifest.version,P.manifest.version)).slice(1)))),await I.Promises.settled(a.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((m,y)=>new Error(`${m.message}${m.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=S.normalize(S.join(T.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const a=[w.Promises.readFile(S.join(r,"package.json"),"utf8").then(P=>this.parseManifest(P)),w.Promises.readFile(S.join(r,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:m,metadata:y},R]=await Promise.all(a);return{manifest:(0,f.localizeManifest)(m,R),metadata:y}}parseManifest(r){return new Promise((a,m)=>{try{const y=JSON.parse(r),R=y.__metadata||null;a({manifest:y,metadata:R})}catch(y){m(new Error((0,h.localize)(4,null)))}})}};i=he([oe(1,o.IFileService),oe(2,s.ILogService),oe(3,v.INativeEnvironmentService),oe(4,e.IProductService)],i),t.ExtensionsScanner=i}),define(J[129],Y([0,1,28,7,9,6,12,29,19,43,8,31,13,45,78,52,21,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g,E,f,o,s,e,i,n,r,a,m,y,R,P,O,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let q=class extends g.AbstractExtensionManagementService{constructor(z,H,re,M,k,W,G,ee,X){super(z,H,re,ee);this.environmentService=M,this.downloadService=k,this.fileService=G;const Z=this._register(W.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(n.ExtensionsScanner,N=>Z.postUninstall(N))),this.manifestCache=this._register(new i.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(o.ExtensionsDownloader));const _=this._register(new r.ExtensionsWatcher(this,G,M,re,X));this._register(_.onDidChangeExtensionsByAnotherSource(({added:N,removed:A})=>{N.length&&this._onDidInstallExtensions.fire(N.map(B=>({identifier:B.identifier,operation:0,local:B}))),A.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const z=await this.isAlpineLinux(),H=(0,E.getTargetPlatform)(z?"alpine":T.platform,S.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",H),H})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let z;try{z=(await this.fileService.readFile(p.URI.file("/etc/os-release"))).value.toString()}catch(H){try{z=(await this.fileService.readFile(p.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(re))}}return!!z&&(z.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const H=await this.collectFiles(z),re=await(0,w.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,H);return p.URI.file(re)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const H=await this.downloadVsix(z),re=D.resolve(H.fsPath);return(0,e.getManifest)(re)}getInstalled(z=null){return this.extensionsScanner.scanExtensions(z)}async install(z,H={}){this.logService.trace("ExtensionManagementService#install",z.toString());const re=await this.downloadVsix(z),M=await(0,e.getManifest)(D.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,a.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,H)}async updateMetadata(z,H){return this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,{...z.manifest.__metadata||{},...H}),this.manifestCache.invalidate(),z}async updateExtensionScope(z,H){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,{...z.manifest.__metadata||{},isMachineScoped:H}),this.manifestCache.invalidate(),z}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(z){if(z.scheme===b.Schemas.file)return z;const H=(0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(z,H),H}createInstallExtensionTask(z,H,re){return p.URI.isUri(H)?new le(z,H,re,this.galleryService,this.extensionsScanner,this.logService):new ce(H,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(z,H){return new ne(z,H,this.extensionsScanner)}async collectFiles(z){const H=async M=>{let k=await c.Promises.readdir(M);k=k.map(ee=>D.join(M,ee));const W=await Promise.all(k.map(ee=>c.Promises.stat(ee)));let G=Promise.resolve([]);return W.forEach((ee,X)=>{const Z=k[X];ee.isFile()&&(G=G.then(_=>[..._,Z])),ee.isDirectory()&&(G=G.then(_=>H(Z).then(N=>[..._,...N])))}),G};return(await H(z.location.fsPath)).map(M=>({path:`extension/${D.relative(z.location.fsPath,M)}`,localPath:M}))}};q=he([oe(0,E.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,R.ILogService),oe(3,v.INativeEnvironmentService),oe(4,h.IDownloadService),oe(5,y.IInstantiationService),oe(6,m.IFileService),oe(7,P.IProductService),oe(8,U.IUriIdentityService)],q),t.ExtensionManagementService=q;class te extends g.AbstractExtensionTask{constructor(z,H,re,M){super();this.identifier=z,this.source=H,this.extensionsScanner=re,this.logService=M,this._operation=1}get operation(){return this._operation}async installExtension(z,H){try{const re=await this.unsetUninstalledAndGetLocal(z.identifierWithVersion);if(re)return z.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,z.metadata):re}catch(re){throw T.isMacintosh?new E.ExtensionManagementError(u.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(u.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(z,H)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const re=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),re}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.key()]}async extract({zipPath:z,identifierWithVersion:H,metadata:re},M){let k=await this.extensionsScanner.extractUserExtension(H,z,re,M);return this.logService.info("Extracting completed.",H.id),k}}class ce extends te{constructor(z,H,re,M,k){super(z.identifier,z,M,k);this.gallery=z,this.options=H,this.extensionsDownloader=re}async doRun(z){const re=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));re&&(this._operation=2);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin;try{const k=await this.installExtension(M,z);return re&&d.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(p.URI.file(z))}catch(H){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,I.getErrorMessage)(H))}}async downloadInstallableExtension(z,H){const re={id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",z.identifier.id),M=(await this.extensionsDownloader.downloadExtension(z,H)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,M)}catch(k){throw new E.ExtensionManagementError((0,g.joinErrors)(k).message,E.ExtensionManagementErrorCode.Download)}try{const k=await(0,e.getManifest)(M);return{zipPath:M,identifierWithVersion:new f.ExtensionIdentifierWithVersion(z.identifier,k.version),metadata:re}}catch(k){throw await this.deleteDownloadedVSIX(M),new E.ExtensionManagementError((0,g.joinErrors)(k).message,E.ExtensionManagementErrorCode.Invalid)}}}class le extends te{constructor(z,H,re,M,k,W){super({id:(0,f.getGalleryExtensionId)(z.publisher,z.name)},H,k,W);this.manifest=z,this.location=H,this.options=re,this.galleryService=M}async doRun(z){const H=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,f.areSameExtensions)(this.identifier,W.identifier)),k=await this.getMetadata(this.identifier.id,z);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=2,H.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(W){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(H);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch(G){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:H,metadata:k},z)}async getMetadata(z,H){try{const re=(await this.galleryService.query({names:[z],pageSize:1},H)).firstPage[0];if(re)return{id:re.identifier.uuid,publisherDisplayName:re.publisherDisplayName,publisherId:re.publisherId}}catch(re){}return{}}}class ne extends g.AbstractExtensionTask{constructor(z,H,re){super();this.extension=z,this.options=H,this.extensionsScanner=re}async doRun(z){const H=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);H.push(...re.filter(k=>M.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else H.push(...re.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!H.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...H),this.options.remove)for(const M of H)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,L.toErrorMessage)(k)))}}}}),define(J[130],Y([0,1,115,3,17,7,2,11,26,21,93,15,114,140]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let u=class extends T.Disposable{constructor(v,g,E){super();this.environmentService=g,this.logService=E,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,g){this.logService.trace("RequestService#request",v.url);const{proxyUrl:E,strictSSL:f}=this;let o;try{o=await(0,p.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(i){this.logService.error("RequestService#request resolving shell environment failed",i)}const s={...process.env,...o},e=v.agent?v.agent:await(0,c.getProxyAgent)(v.url||"",s,{proxyUrl:E,strictSSL:f});return v.agent=e,v.strictSSL=f,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,g)}async getNodeRequest(v){return((0,L.parse)(v.url).protocol==="https:"?await new Promise((f,o)=>{x(["https"],f,o)}):await new Promise((f,o)=>{x(["http"],f,o)})).request}_request(v,g){return I.Promises.withAsyncBody(async(E,f)=>{let o;const s=(0,L.parse)(v.url),e=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),i={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,S.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(i.auth=v.user+":"+v.password),o=e(i,n=>{const r=(0,S.isNumber)(v.followRedirects)?v.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...v,url:n.headers.location,followRedirects:r-1},g).then(E,f);else{let a=n;n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,w.createGunzip)())),E({res:n,stream:(0,b.streamToBufferReadableStream)(a)})}}),o.on("error",f),v.timeout&&o.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&o.write(v.data),o.end(),g.onCancellationRequested(()=>{o.abort(),f((0,D.canceled)())})})}async resolveProxy(v){}};u=he([oe(0,l.IConfigurationService),oe(1,d.INativeEnvironmentService),oe(2,C.ILogService)],u),t.RequestService=u}),define(J[141],Y([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,21,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(x,t,L,I,b,D,T,S,l,d,p,C,c,w,u,h,v,g,E,f,o,s,e,i,n,r,a,m,y,R,P,O,U,q,te,ce,le,ne,de,z,H,re,M,k,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends S.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async N=>{const A=N.get(O.ILogService),B=N.get(i.IFileService),V=N.get(g.INativeEnvironmentService),K=N.get(o.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(V,K,B),await Promise.all(_.map(Q=>{(0,I.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new y.ServiceCollection,_={_serviceBrand:void 0,...q.default};Z.set(te.IProductService,_);const N=new E.NativeEnvironmentService(this.argv,_);Z.set(g.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(me=>me?c.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(N),B=[];B.push(new U.SpdLogLogger("cli",(0,d.join)(N.logsPath,"cli.log"),!0,A)),A===O.LogLevel.Trace&&B.push(new O.ConsoleLogger(A));const V=this._register(new O.MultiplexLogService(B));Z.set(O.ILogService,V);const K=this._register(new n.FileService(V));Z.set(i.IFileService,K);const Q=this._register(new r.DiskFileSystemProvider(V));K.registerProvider(l.Schemas.file,Q);const se=this._register(new u.ConfigurationService(N.settingsResource,K));Z.set(w.IConfigurationService,se),await se.initialize(),Z.set(k.IUriIdentityService,new W.UriIdentityService(K)),Z.set(ce.IRequestService,new a.SyncDescriptor(le.RequestService)),Z.set(h.IDownloadService,new a.SyncDescriptor(v.DownloadService)),Z.set(o.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),Z.set(o.IExtensionGalleryService,new a.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(o.IExtensionManagementCLIService,new a.SyncDescriptor(s.ExtensionManagementCLIService)),Z.set(R.ILocalizationsService,new a.SyncDescriptor(P.LocalizationsService));const ie=[];if((0,H.supportsTelemetry)(_,N)){_.aiConfig&&_.aiConfig.asimovKey&&ie.push(new re.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:ue}=N,Ie={appenders:ie,sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const Ee=await c.Promises.readFile((0,d.join)(N.userDataPath,"storage.json"));ve=JSON.parse(Ee.toString())[de.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&V.error(Ee)}return(0,ne.resolveCommonProperties)(K,(0,L.release)(),(0,L.hostname)(),process.arch,_.commit,_.version,ve,_.msftInternalDomains,ue)})(),piiPaths:[me,ye]};Z.set(de.ITelemetryService,new a.SyncDescriptor(z.TelemetryService,[Ie]))}else Z.set(de.ITelemetryService,H.NullTelemetryService);return[new m.InstantiationService(Z),ie]}registerErrorHandler(Z){(0,T.setUnexpectedErrorHandler)(_=>{const N=(0,D.toErrorMessage)(_,!0);!N||Z.error(`[uncaught exception in CLI]: ${N}`)}),process.on("uncaughtException",_=>(0,T.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,T.onUnexpectedError)(_))}async doRun(Z,_,N){if(this.argv["install-source"])return this.setInstallSource(Z,N,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?C.URI.file((0,d.isAbsolute)(_)?_:(0,d.join)((0,p.cwd)(),_)):_)}async setInstallSource(Z,_,N){await _.writeFile(C.URI.file(Z.installSourcePath),b.VSBuffer.fromString(N.slice(0,30)))}}async function ee(X){const Z=new G(X);try{await Z.run()}finally{Z.dispose()}}t.main=ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/552af97a0170b43c9323bec62211feb184da9749/core/vs/code/node/cliProcessMain.js.map
