/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let a in i)g.call(i,a)&&I.push(i[a]);return I}e.values=L;function D(i,I){for(let a in i)if(g.call(i,a)&&I({key:a,value:i[a]},function(){delete i[a]})===!1)return}e.forEach=D;function S(i,I){const a=Object.create(null);for(const p of i){const h=I(p);let w=a[h];w||(w=a[h]=[]),w.push(p)}return a}e.groupBy=S;function A(i){const I=Object.create(null);return i&&i.forEach((a,p)=>{I[p]=a}),I}e.fromMap=A;function k(i,I){const a=[],p=[];for(let h of i)I.has(h)||a.push(h);for(let h of I)i.has(h)||p.push(h);return{removed:a,added:p}}e.diffSets=k;function _(i,I){const a=[],p=[];for(let[h,w]of i)I.has(h)||a.push(w);for(let[h,w]of I)i.has(h)||p.push(w);return{removed:a,added:p}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,a){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(a)}delete(I,a){const p=this.map.get(I);!p||(p.delete(a),p.size===0&&this.map.delete(I))}forEach(I,a){const p=this.map.get(I);!p||p.forEach(a)}}e.SetMap=C}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(A){return(k,_,C)=>{let i=null,I=null;if(typeof C.value=="function"?(i="value",I=C.value):typeof C.get=="function"&&(i="get",I=C.get),!I)throw new Error("not supported");C[i]=A(I,_)}}e.createDecorator=g;function L(A,k,_){let C=null,i=null;if(typeof _.value=="function"?(C="value",i=_.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",i=_.get),!i)throw new Error("not supported");const I=`$memoize$${k}`;_[C]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,a)}),this[I]}}e.memoize=L;function D(A,k,_){return g((C,i)=>{const I=`$debounce$${i}`,a=`$debounce$result$${i}`;return function(...p){this[a]||(this[a]=_?_():void 0),clearTimeout(this[I]),k&&(this[a]=k(this[a],...p),p=[this[a]]),this[I]=setTimeout(()=>{C.apply(this,p),this[a]=_?_():void 0},A)}})}e.debounce=D;function S(A,k,_){return g((C,i)=>{const I=`$throttle$timer$${i}`,a=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...w){if(this[a]||(this[a]=_?_():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...w)),this[h])return;const y=this[p]+A;y<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[a]]),this[a]=_?_():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),C.apply(this,[this[a]]),this[a]=_?_():void 0},y-Date.now()))}})}e.throttle=S}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(f=>{f(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function D(v){_(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=D;function S(v){_(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function A(v){if(v instanceof Error){let{name:n,message:f}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:n,message:f,stack:r}}return v}e.transformErrorForSerialization=A;const k="Canceled";function _(v){return v instanceof Error&&v.name===k&&v.message===k}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=C;function i(){const v=new Error(k);return v.name=v.message,v}e.canceled=i;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function a(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=a;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(v){const n=new Error(`${v} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class y extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=y;class P extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=P;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function s(v){const n=v;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=s;function o(v,n=Object.create(null)){const f=new Error(v);return n.actions&&(f.actions=n.actions),f}e.createErrorWithActions=o}),define(fe[15],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,X=0){return W[W.length-(1+X)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function S(W,X,K=(de,_e)=>de===_e){if(W===X)return!0;if(!W||!X||W.length!==X.length)return!1;for(let de=0,_e=W.length;de<_e;de++)if(!K(W[de],X[de]))return!1;return!0}e.equals=S;function A(W,X,K){let de=0,_e=W.length-1;for(;de<=_e;){const Ce=(de+_e)/2|0,Pe=K(W[Ce],X);if(Pe<0)de=Ce+1;else if(Pe>0)_e=Ce-1;else return Ce}return-(de+1)}e.binarySearch=A;function k(W,X){let K=0,de=W.length;if(de===0)return 0;for(;K<de;){const _e=Math.floor((K+de)/2);X(W[_e])?de=_e:K=_e+1}return K}e.findFirstInSorted=k;function _(W,X,K){if(W=W|0,W>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],Ce=[],Pe=[];for(let Be of X){const $e=K(Be,de);$e<0?_e.push(Be):$e>0?Ce.push(Be):Pe.push(Be)}return W<_e.length?_(W,_e,K):W<_e.length+Pe.length?Pe[0]:_(W-(_e.length+Pe.length),Ce,K)}e.quickSelect=_;function C(W,X){const K=[];let de;for(const _e of W.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],K.push(de)):de.push(_e);return K}e.groupBy=C;function i(W,X,K){const de=[];function _e(Be,$e,He){if($e===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=$e,G.toInsert.push(...He)):de.push({start:Be,deleteCount:$e,toInsert:He})}let Ce=0,Pe=0;for(;;){if(Ce===W.length){_e(Ce,0,X.slice(Pe));break}if(Pe===X.length){_e(Ce,W.length-Ce,[]);break}const Be=W[Ce],$e=X[Pe],He=K(Be,$e);He===0?(Ce+=1,Pe+=1):He<0?(_e(Ce,1,[]),Ce+=1):He>0&&(_e(Ce,0,[$e]),Pe+=1)}return de}e.sortedDiff=i;function I(W,X,K){const de=i(W,X,K),_e=[],Ce=[];for(const Pe of de)_e.push(...W.slice(Pe.start,Pe.start+Pe.deleteCount)),Ce.push(...Pe.toInsert);return{removed:_e,added:Ce}}e.delta=I;function a(W,X,K){if(K===0)return[];const de=W.slice(0,K).sort(X);return h(W,X,de,K,W.length),de}e.top=a;function p(W,X,K,de,_e){return K===0?Promise.resolve([]):new Promise((Ce,Pe)=>{(async()=>{const Be=W.length,$e=W.slice(0,K).sort(X);for(let He=K,G=Math.min(K+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>K&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();h(W,X,$e,He,G)}return $e})().then(Ce,Pe)})}e.topAsync=p;function h(W,X,K,de,_e){for(const Ce=K.length;de<_e;de++){const Pe=W[de];if(X(Pe,K[Ce-1])<0){K.pop();const Be=k(K,$e=>X(Pe,$e)<0);K.splice(Be,0,Pe)}}}function w(W){return W.filter(X=>!!X)}e.coalesce=w;function y(W){let X=0;for(let K=0;K<W.length;K++)W[K]&&(W[X]=W[K],X+=1);W.length=X}e.coalesceInPlace=y;function P(W,X,K){W.splice(K,0,W.splice(X,1)[0])}e.move=P;function b(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=b;function s(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=s;function o(W,X=K=>K){const K=new Set;return W.filter(de=>{const _e=X(de);return K.has(_e)?!1:(K.add(_e),!0)})}e.distinct=o;function v(W){const X=Object.create(null);return K=>{const de=W(K);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function n(W,X){const K=f(W,X);if(K!==-1)return W[K]}e.findLast=n;function f(W,X){for(let K=W.length-1;K>=0;K--){const de=W[K];if(X(de))return K}return-1}e.lastIndex=f;function r(W,X){return W.length>0?W[0]:X}e.firstOrDefault=r;function t(W,X,K=(de,_e)=>de===_e){let de=0;for(let _e=0,Ce=Math.min(W.length,X.length);_e<Ce&&K(W[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=t;function d(W){return[].concat(...W)}e.flatten=d;function l(W,X){let K=typeof X=="number"?W:0;typeof X=="number"?K=W:(K=0,X=W);const de=[];if(K<=X)for(let _e=K;_e<X;_e++)de.push(_e);else for(let _e=K;_e>X;_e--)de.push(_e);return de}e.range=l;function c(W,X,K){return W.reduce((de,_e)=>(de[X(_e)]=K?K(_e):_e,de),Object.create(null))}e.index=c;function m(W,X){return W.push(X),()=>u(W,X)}e.insert=m;function u(W,X){const K=W.indexOf(X);if(K>-1)return W.splice(K,1),X}e.remove=u;function E(W,X,K){const de=W.slice(0,X),_e=W.slice(X);return de.concat(K,_e)}e.arrayInsert=E;function T(W,X){let K;if(typeof X=="number"){let de=X;K=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else K=Math.random;for(let de=W.length-1;de>0;de-=1){const _e=Math.floor(K()*(de+1)),Ce=W[de];W[de]=W[_e],W[_e]=Ce}}e.shuffle=T;function R(W,X){const K=W.indexOf(X);K>-1&&(W.splice(K,1),W.unshift(X))}e.pushToStart=R;function B(W,X){const K=W.indexOf(X);K>-1&&(W.splice(K,1),W.push(X))}e.pushToEnd=B;function N(W,X){return Array.isArray(W)?W.map(X):X(W)}e.mapArrayOrNot=N;function F(W){return Array.isArray(W)?W:[W]}e.asArray=F;function $(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=$;function M(W,X){for(const K of W){const de=X(K);if(de!==void 0)return de}}e.mapFind=M;function z(W,X,K){const de=x(W,X),_e=W.length,Ce=K.length;W.length=_e+Ce;for(let Pe=_e-1;Pe>=de;Pe--)W[Pe+Ce]=W[Pe];for(let Pe=0;Pe<Ce;Pe++)W[Pe+de]=K[Pe]}e.insertInto=z;function U(W,X,K,de){const _e=x(W,X),Ce=W.splice(_e,K);return z(W,_e,de),Ce}e.splice=U;function x(W,X){return X<0?Math.max(X+W.length,0):Math.min(X,W.length)}function j(W,X){let K=Number.MAX_SAFE_INTEGER,de=0;return W.forEach((_e,Ce)=>{const Pe=X(_e);Pe<K&&(K=Pe,de=Ce)}),de}e.minIndex=j;function O(W,X){let K=Number.MIN_SAFE_INTEGER,de=0;return W.forEach((_e,Ce)=>{const Pe=X(_e);Pe>K&&(K=Pe,de=Ce)}),de}e.maxIndex=O;class H{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let K=this.firstIdx;for(;K<this.items.length&&X(this.items[K]);)K++;const de=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,de}takeFromEndWhile(X){let K=this.lastIdx;for(;K>=0&&X(this.items[K]);)K--;const de=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const K=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,K}}e.ArrayQueue=H}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const D=this;let S=!1,A;return function(){return S||(S=!0,A=L.apply(D,arguments)),A}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=D;const S=Object.freeze([]);function A(){return S}L.empty=A;function*k(v){yield v}L.single=k;function _(v){return v||S}L.from=_;function C(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=C;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function I(v,n){for(const f of v)if(n(f))return!0;return!1}L.some=I;function a(v,n){for(const f of v)if(n(f))return f}L.find=a;function*p(v,n){for(const f of v)n(f)&&(yield f)}L.filter=p;function*h(v,n){let f=0;for(const r of v)yield n(r,f++)}L.map=h;function*w(...v){for(const n of v)for(const f of n)yield f}L.concat=w;function*y(v){for(const n of v)for(const f of n)yield f}L.concatNested=y;function P(v,n,f){let r=f;for(const t of v)r=n(r,t);return r}L.reduce=P;function*b(v,n,f=v.length){for(n<0&&(n+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);n<f;n++)yield v[n]}L.slice=b;function s(v,n=Number.POSITIVE_INFINITY){const f=[];if(n===0)return[f,v];const r=v[Symbol.iterator]();for(let t=0;t<n;t++){const d=r.next();if(d.done)return[f,L.empty()];f.push(d.value)}return[f,{[Symbol.iterator](){return r}}]}L.consume=s;function o(v,n,f=(r,t)=>r===t){const r=v[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const d=r.next(),l=t.next();if(d.done!==l.done)return!1;if(d.done)return!0;if(!f(d.value,l.value))return!1}}L.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(n){n.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function A(n,f=!1){let r=0,t=n.length,d="",l=0,c=16,m=0;function u($){let M=0,z=0;for(;M<$;){const U=n.charCodeAt(r);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;r++,M++}return M<$&&(z=-1),z}function E($){r=$,d="",l=0,c=16,m=0}function T(){const $=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&C(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&C(n.charCodeAt(r)))for(r++;r<n.length&&C(n.charCodeAt(r));)r++;else return m=3,n.substring($,r);let M=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&C(n.charCodeAt(r))){for(r++;r<n.length&&C(n.charCodeAt(r));)r++;M=r}else m=3;return n.substring($,M)}function R(){let $="",M=r;for(;;){if(r>=t){$+=n.substring(M,r),m=2;break}const z=n.charCodeAt(r);if(z===34){$+=n.substring(M,r),r++;break}if(z===92){if($+=n.substring(M,r),r++,r>=t){m=2;break}switch(n.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const x=u(4);x>=0?$+=String.fromCharCode(x):m=4;break;default:m=5}M=r;continue}if(z>=0&&z<=31)if(_(z)){$+=n.substring(M,r),m=2;break}else m=6;r++}return $}function B(){if(d="",m=0,l=r,r>=t)return l=t,c=17;let $=n.charCodeAt(r);if(k($)){do r++,d+=String.fromCharCode($),$=n.charCodeAt(r);while(k($));return c=15}if(_($))return r++,d+=String.fromCharCode($),$===13&&n.charCodeAt(r)===10&&(r++,d+=`
`),c=14;switch($){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,d=R(),c=10;case 47:const M=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!_(n.charCodeAt(r));)r++;return d=n.substring(M,r),c=12}if(n.charCodeAt(r+1)===42){r+=2;const z=t-1;let U=!1;for(;r<z;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,m=1),d=n.substring(M,r),c=13}return d+=String.fromCharCode($),r++,c=16;case 45:if(d+=String.fromCharCode($),r++,r===t||!C(n.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=T(),c=11;default:for(;r<t&&N($);)r++,$=n.charCodeAt(r);if(l!==r){switch(d=n.substring(l,r),d){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return d+=String.fromCharCode($),r++,c=16}}function N($){if(k($)||_($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:E,getPosition:()=>r,scan:f?F:B,getToken:()=>c,getTokenValue:()=>d,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>m}}e.createScanner=A;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function _(n){return n===10||n===13||n===8232||n===8233}function C(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,f){const r=[],t=new Object;let d;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(u,E,T,R){l.value=u,l.offset=E,l.length=T,l.type=R,l.colonOffset=void 0,d=l}try{s(n,{onObjectBegin:(u,E)=>{if(f<=u)throw t;d=void 0,c=f>u,r.push("")},onObjectProperty:(u,E,T)=>{if(f<E||(m(u,E,T,"property"),r[r.length-1]=u,f<=E+T))throw t},onObjectEnd:(u,E)=>{if(f<=u)throw t;d=void 0,r.pop()},onArrayBegin:(u,E)=>{if(f<=u)throw t;d=void 0,r.push(0)},onArrayEnd:(u,E)=>{if(f<=u)throw t;d=void 0,r.pop()},onLiteralValue:(u,E,T)=>{if(f<E||(m(u,E,T,v(u)),f<=E+T))throw t},onSeparator:(u,E,T)=>{if(f<=E)throw t;if(u===":"&&d&&d.type==="property")d.colonOffset=E,c=!1,d=void 0;else if(u===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(c=!0,r[r.length-1]=""),d=void 0}}})}catch(u){if(u!==t)throw u}return{path:r,previousNode:d,isAtPropertyKey:c,matches:u=>{let E=0;for(let T=0;E<u.length&&T<r.length;T++)if(u[E]===r[T]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function a(n,f=[],r=S.DEFAULT){let t=null,d=[];const l=[];function c(u){Array.isArray(d)?d.push(u):t!==null&&(d[t]=u)}return s(n,{onObjectBegin:()=>{const u={};c(u),l.push(d),d=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{d=l.pop()},onArrayBegin:()=>{const u=[];c(u),l.push(d),d=u,t=null},onArrayEnd:()=>{d=l.pop()},onLiteralValue:c,onError:(u,E,T)=>{f.push({error:u,offset:E,length:T})}},r),d[0]}e.parse=a;function p(n,f=[],r=S.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function l(u){return t.children.push(u),u}s(n,{onObjectBegin:u=>{t=l({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,E,T)=>{t=l({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:E,length:T,parent:t})},onObjectEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,d(u+E)},onArrayBegin:(u,E)=>{t=l({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,d(u+E)},onLiteralValue:(u,E,T)=>{l({type:v(u),offset:E,length:T,parent:t,value:u}),d(E+T)},onSeparator:(u,E,T)=>{t.type==="property"&&(u===":"?t.colonOffset=E:u===","&&d(E))},onError:(u,E,T)=>{f.push({error:u,offset:E,length:T})}},r);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=p;function h(n,f){if(!n)return;let r=n;for(let t of f)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let d=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===t){r=l.children[1],d=!0;break}if(!d)return}else{const d=t;if(r.type!=="array"||d<0||!Array.isArray(r.children)||d>=r.children.length)return;r=r.children[d]}return r}e.findNodeAtLocation=h;function w(n){if(!n.parent||!n.parent.children)return[];const f=w(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;f.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&f.push(r)}return f}e.getNodePath=w;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":const f=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(f[r.children[0].value]=y(t))}return f;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function P(n,f,r=!1){return f>=n.offset&&f<n.offset+n.length||r&&f===n.offset+n.length}e.contains=P;function b(n,f,r=!1){if(P(n,f,r)){const t=n.children;if(Array.isArray(t))for(let d=0;d<t.length&&t[d].offset<=f;d++){const l=b(t[d],f,r);if(l)return l}return n}}e.findNodeAtOffset=b;function s(n,f,r=S.DEFAULT){const t=A(n,!1);function d(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(K){return K?de=>K(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=d(f.onObjectBegin),m=l(f.onObjectProperty),u=d(f.onObjectEnd),E=d(f.onArrayBegin),T=d(f.onArrayEnd),R=l(f.onLiteralValue),B=l(f.onSeparator),N=d(f.onComment),F=l(f.onError),$=r&&r.disallowComments,M=r&&r.allowTrailingComma;function z(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:$||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:$?U(10):N();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,de=[],_e=[]){if(F(K),de.length+_e.length>0){let Ce=t.getToken();for(;Ce!==17;){if(de.indexOf(Ce)!==-1){z();break}else if(_e.indexOf(Ce)!==-1)break;Ce=z()}}}function x(K){const de=t.getTokenValue();return K?R(de):m(de),z(),!0}function j(){switch(t.getToken()){case 11:let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(de){U(2)}R(K);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function O(){return t.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),t.getToken()===6?(B(":"),z(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function H(){c(),z();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),B(","),z(),t.getToken()===2&&M)break}else K&&U(6,[],[]);O()||U(4,[],[2,5]),K=!0}return u(),t.getToken()!==2?U(7,[2],[]):z(),!0}function W(){E(),z();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||U(4,[],[]),B(","),z(),t.getToken()===4&&M)break}else K&&U(6,[],[]);X()||U(4,[],[4,5]),K=!0}return T(),t.getToken()!==4?U(8,[4],[]):z(),!0}function X(){switch(t.getToken()){case 3:return W();case 1:return H();case 10:return x(!0);default:return j()}}return z(),t.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(t.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=s;function o(n,f){let r=A(n),t=[],d,l=0,c;do switch(c=r.getPosition(),d=r.scan(),d){case 12:case 13:case 17:l!==c&&t.push(n.substring(l,c)),f!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,f)),l=r.getPosition();break}while(d!==17);return t.join("")}e.stripComments=o;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(_,C,i){let I,a,p,h,w;if(C){for(h=C.offset,w=h+C.length,p=h;p>0&&!k(_,p-1);)p--;let l=w;for(;l<_.length&&!k(_,l);)l++;a=_.substring(p,l),I=S(a,i)}else a=_,I=0,p=0,h=0,w=_.length;const y=A(i,_);let P=!1,b=0,s;i.insertSpaces?s=D(" ",i.tabSize||4):s="	";const o=(0,g.createScanner)(a,!1);let v=!1;function n(){return y+D(s,I+b)}function f(){let l=o.scan();for(P=!1;l===15||l===14;)P=P||l===14,l=o.scan();return v=l===16||o.getTokenError()!==0,l}const r=[];function t(l,c,m){!v&&c<w&&m>h&&_.substring(c,m)!==l&&r.push({offset:c,length:m-c,content:l})}let d=f();if(d!==17){const l=o.getTokenOffset()+p,c=D(s,I);t(c,p,l)}for(;d!==17;){let l=o.getTokenOffset()+o.getTokenLength()+p,c=f(),m="";for(;!P&&(c===12||c===13);){const E=o.getTokenOffset()+p;t(" ",l,E),l=o.getTokenOffset()+o.getTokenLength()+p,m=c===12?n():"",c=f()}if(c===2)d!==1&&(b--,m=n());else if(c===4)d!==3&&(b--,m=n());else{switch(d){case 3:case 1:b++,m=n();break;case 5:case 12:m=n();break;case 13:P?m=n():m=" ";break;case 6:m=" ";break;case 10:if(c===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?m=" ":c!==5&&c!==17&&(v=!0);break;case 16:v=!0;break}P&&(c===12||c===13)&&(m=n())}const u=o.getTokenOffset()+p;t(m,l,u),d=c}return r}e.format=L;function D(_,C){let i="";for(let I=0;I<C;I++)i+=_;return i}function S(_,C){let i=0,I=0;const a=C.tabSize||4;for(;i<_.length;){const p=_.charAt(i);if(p===" ")I++;else if(p==="	")I+=a;else break;i++}return Math.floor(I/a)}function A(_,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=A;function k(_,C){return`\r
`.indexOf(_.charAt(C))!==-1}e.isEOL=k}),define(fe[140],me([0,1,61,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,i,I){return S(C,i,void 0,I)}e.removeProperty=D;function S(C,i,I,a,p){const h=i.slice(),w=[],y=(0,g.parseTree)(C,w);let P,b;for(;h.length>0&&(b=h.pop(),P=(0,g.findNodeAtLocation)(y,h),P===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(P)if(P.type==="object"&&typeof b=="string"&&Array.isArray(P.children)){const s=(0,g.findNodeAtLocation)(P,[b]);if(s!==void 0)if(I===void 0){if(!s.parent)throw new Error("Malformed AST");const o=P.children.indexOf(s.parent);let v,n=s.parent.offset+s.parent.length;if(o>0){const f=P.children[o-1];v=f.offset+f.length}else v=P.offset+1,P.children.length>1&&(n=P.children[1].offset);return A(C,{offset:v,length:n-v,content:""},a)}else return A(C,{offset:s.offset,length:s.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,v=p?p(P.children.map(f=>f.children[0].value)):P.children.length;let n;if(v>0){const f=P.children[v-1];n={offset:f.offset+f.length,length:0,content:","+o}}else P.children.length===0?n={offset:P.offset+1,length:0,content:o}:n={offset:P.offset+1,length:0,content:o+","};return A(C,n,a)}}else if(P.type==="array"&&typeof b=="number"&&Array.isArray(P.children))if(I!==void 0){const s=`${JSON.stringify(I)}`;let o;if(P.children.length===0||b===0)o={offset:P.offset+1,length:0,content:P.children.length===0?s:s+","};else{const v=b===-1||b>P.children.length?P.children.length:b,n=P.children[v-1];o={offset:n.offset+n.length,length:0,content:","+s}}return A(C,o,a)}else{const s=b,o=P.children[s];let v;if(P.children.length===1)v={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===s){const n=P.children[s-1],f=n.offset+n.length,r=P.offset+P.length;v={offset:f,length:r-2-f,content:""}}else v={offset:o.offset,length:P.children[s+1].offset-o.offset,content:""};return A(C,v,a)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(I)},a)}}e.setProperty=S;function A(C,i,I){let a=k(C,i),p=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(a,p-1);)p--;for(;h<a.length&&!(0,L.isEOL)(a,h);)h++}const w=(0,L.format)(a,{offset:p,length:h-p},I);for(let P=w.length-1;P>=0;P--){const b=w[P];a=k(a,b),p=Math.min(p,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const y=C.length-(a.length-h)-p;return[{offset:p,length:y,content:a.substring(p,h)}]}e.withFormatting=A;function k(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=k;function _(C,i){let I=i.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),a=C.length;for(let p=I.length-1;p>=0;p--){let h=I[p];if(h.offset+h.length<=a)C=k(C,h);else throw new Error("Overlapping edit");a=h.offset}return C}e.applyEdits=_}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,78]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function A(t){S=t}if(e.setDisposableTracker=A,D){const t="__is_disposable_tracked__";A(new class{trackDisposable(d){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[t]||console.log(l)},3e3)}setParent(d,l){if(d&&d!==b.None)try{d[t]=!0}catch{}}markAsDisposed(d){if(d&&d!==b.None)try{d[t]=!0}catch{}}markAsSingleton(d){}})}function k(t){return S?.trackDisposable(t),t}function _(t){S?.markAsDisposed(t)}function C(t,d){S?.setParent(t,d)}function i(t,d){if(!!S)for(const l of t)S.setParent(l,d)}function I(t){return S?.markAsSingleton(t),t}e.markAsSingleton=I;class a extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=a;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(L.Iterable.is(t)){let d=[];for(const l of t)if(l)try{l.dispose()}catch(c){d.push(c)}if(d.length===1)throw d[0];if(d.length>1)throw new a(d);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const d=y(()=>h(t));return i(t,d),d}e.combinedDisposable=w;function y(t){const d=k({dispose:(0,g.once)(()=>{_(d),t()})});return d}e.toDisposable=y;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return C(d,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new P,k(this),C(this._store,this)}dispose(){_(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&C(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&C(d,null),d}}e.MutableDisposable=s;class o{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class v{constructor(){this.references=new Map}acquire(d,...l){let c=this.references.get(d);c||(c={counter:0,object:this.createReferencedObject(d,...l)},this.references.set(d,c));const{object:m}=c,u=(0,g.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(d,c.object),this.references.delete(d))});return c.counter++,{object:m,dispose:u}}}e.ReferenceCollection=v;class n{constructor(d){this.referenceCollection=d}async acquire(d,...l){const c=this.referenceCollection.acquire(d,...l);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(m){throw c.dispose(),m}}}e.AsyncReferenceCollection=n;class f{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=f;function r(t){const d=new P;try{t(d)}finally{d.dispose()}}e.disposeOnReturn=r}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const A=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=A}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,A){const k=new g(S);if(this._first===g.Undefined)this._first=k,this._last=k;else if(A){const C=this._last;this._last=k,k.prev=C,C.next=k}else{const C=this._first;this._first=k,k.next=C,C.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const A=S.prev;A.next=S.next,S.next.prev=A}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,De){for(var Ae=0;Ae<De.length;Ae++){var oe=De[Ae];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Re,oe.key,oe)}}function e(Re,De,Ae){return De&&Y(Re.prototype,De),Ae&&Y(Re,Ae),Re}function g(Re,De){if(!!Re){if(typeof Re=="string")return L(Re,De);var Ae=Object.prototype.toString.call(Re).slice(8,-1);if(Ae==="Object"&&Re.constructor&&(Ae=Re.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(Re);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return L(Re,De)}}function L(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var Ae=0,oe=new Array(De);Ae<De;Ae++)oe[Ae]=Re[Ae];return oe}function D(Re,De){var Ae=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Ae)return(Ae=Ae.call(Re)).next.bind(Ae);if(Array.isArray(Re)||(Ae=g(Re))||De&&Re&&typeof Re.length=="number"){Ae&&(Re=Ae);var oe=0;return function(){return oe>=Re.length?{done:!0}:{done:!1,value:Re[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var S={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){S.exports.defaults=Re}S.exports={defaults:A(),getDefaults:A,changeDefaults:k};var _=/[&<>"']/,C=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return a[De]};function h(Re,De){if(De){if(_.test(Re))return Re.replace(C,p)}else if(i.test(Re))return Re.replace(I,p);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(Re){return Re.replace(w,function(De,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var P=/(^|[^\[])\^/g;function b(Re,De){Re=Re.source||Re,De=De||"";var Ae={replace:function(ue,we){return we=we.source||we,we=we.replace(P,"$1"),Re=Re.replace(ue,we),Ae},getRegex:function(){return new RegExp(Re,De)}};return Ae}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,De,Ae){if(Re){var oe;try{oe=decodeURIComponent(y(Ae)).replace(s,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!o.test(Ae)&&(Ae=d(De,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch(ue){return null}return Ae}var n={},f=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(Re,De){n[" "+Re]||(f.test(Re)?n[" "+Re]=Re+"/":n[" "+Re]=u(Re,"/",!0)),Re=n[" "+Re];var Ae=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?Ae?De:Re.replace(r,"$1")+De:De.charAt(0)==="/"?Ae?De:Re.replace(t,"$1")+De:Re+De}var l={exec:function(){}};function c(Re){for(var De=1,Ae,oe;De<arguments.length;De++){Ae=arguments[De];for(oe in Ae)Object.prototype.hasOwnProperty.call(Ae,oe)&&(Re[oe]=Ae[oe])}return Re}function m(Re,De){var Ae=Re.replace(/\|/g,function(we,ve,Fe){for(var Ge=!1,ze=ve;--ze>=0&&Fe[ze]==="\\";)Ge=!Ge;return Ge?"|":" |"}),oe=Ae.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function u(Re,De,Ae){var oe=Re.length;if(oe===0)return"";for(var ue=0;ue<oe;){var we=Re.charAt(oe-ue-1);if(we===De&&!Ae)ue++;else if(we!==De&&Ae)ue++;else break}return Re.substr(0,oe-ue)}function E(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var Ae=Re.length,oe=0,ue=0;ue<Ae;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===De[0])oe++;else if(Re[ue]===De[1]&&(oe--,oe<0))return ue;return-1}function T(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,De){if(De<1)return"";for(var Ae="";De>1;)De&1&&(Ae+=Re),De>>=1,Re+=Re;return Ae+Re}var B={escape:h,unescape:y,edit:b,cleanUrl:v,resolveUrl:d,noopTest:l,merge:c,splitCells:m,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:T,repeatString:R},N=S.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,z=B.findClosingBracket;function U(Re,De,Ae,oe){var ue=De.href,we=De.title?M(De.title):null,ve=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){oe.state.inLink=!0;var Fe={type:"link",raw:Ae,href:ue,title:we,text:ve,tokens:oe.inlineTokens(ve,[])};return oe.state.inLink=!1,Fe}else return{type:"image",raw:Ae,href:ue,title:we,text:M(ve)}}function x(Re,De){var Ae=Re.match(/^(\s+)(?:```)/);if(Ae===null)return De;var oe=Ae[1];return De.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var ve=we[0];return ve.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var j=function(){function Re(Ae){this.options=Ae||N}var De=Re.prototype;return De.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},De.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var we=ue[0],ve=x(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:ve}}},De.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var ve=F(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var we,ve,Fe,Ge,ze,Ye,lt,xe,ge,be,re=ue[1].trim(),Q=re.length>1,Se={type:"list",raw:"",ordered:Q,start:Q?+re.slice(0,-1):"",loose:!1,items:[]};re=Q?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Q?re:"[*+-]");for(var Le=new RegExp("^( {0,3}"+re+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(ue=Le.exec(oe)));){ge=ue[2].split(`
`),this.options.pedantic?(Ge=2,be=ge[0].trimLeft()):(Ge=ue[2].search(/[^ ]/),Ge=ue[1].length+(Ge>4?1:Ge),be=ge[0].slice(Ge-ue[1].length)),Ye=!1,we=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(we=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var nt=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(xe)){we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=Ge?be+=`
`+xe.slice(Ge):be+=`
`+xe;continue}if(xe.search(/[^ ]/)>=Ge||!xe.trim()){be+=`
`+xe.slice(Ge);continue}else{we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(lt?Se.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(be),ve&&(Fe=ve[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:we,task:!!ve,checked:Fe,loose:!1,text:be}),Se.raw+=we,oe=oe.slice(we.length)}Se.items[Se.items.length-1].raw=we.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var qe=Se.items.length;for(ze=0;ze<qe;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(gt){return gt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},De.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var we={type:"table",header:$(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var ve=we.align.length,Fe,Ge,ze,Ye;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(ve=we.rows.length,Fe=0;Fe<ve;Fe++)we.rows[Fe]=$(we.rows[Fe],we.header.length).map(function(lt){return{text:lt}});for(ve=we.header.length,Ge=0;Ge<ve;Ge++)we.header[Ge].tokens=[],this.lexer.inlineTokens(we.header[Ge].text,we.header[Ge].tokens);for(ve=we.rows.length,Ge=0;Ge<ve;Ge++)for(Ye=we.rows[Ge],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return we}}},De.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},De.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},De.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=F(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Fe=z(ue[2],"()");if(Fe>-1){var Ge=ue[0].indexOf("!")===0?5:4,ze=Ge+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(we)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),U(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(oe,ue){var we;if((we=this.rules.inline.reflink.exec(oe))||(we=this.rules.inline.nolink.exec(oe))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=ue[ve.toLowerCase()],!ve||!ve.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(we,ve,we[0],this.lexer)}},De.emStrong=function(oe,ue,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ge=ve[0].length-1,ze,Ye,lt=Ge,xe=0,ge=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*oe.length+Ge);(ve=ge.exec(ue))!=null;)if(ze=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ze){if(Ye=ze.length,ve[3]||ve[4]){lt+=Ye;continue}else if((ve[5]||ve[6])&&Ge%3&&!((Ge+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(Ge,Ye)%2){var be=oe.slice(1,Ge+ve.index+Ye);return{type:"em",raw:oe.slice(0,Ge+ve.index+Ye+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var re=oe.slice(2,Ge+ve.index+Ye-1);return{type:"strong",raw:oe.slice(0,Ge+ve.index+Ye+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}}}}},De.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var we=ue[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return ve&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},De.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},De.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(oe,ue){var we=this.rules.inline.autolink.exec(oe);if(we){var ve,Fe;return we[2]==="@"?(ve=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+ve):(ve=M(we[1]),Fe=ve),{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(oe,ue){var we;if(we=this.rules.inline.url.exec(oe)){var ve,Fe;if(we[2]==="@")ve=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+ve;else{var Ge;do Ge=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ge!==we[0]);ve=M(we[0]),we[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(oe,ue){var we=this.rules.inline.text.exec(oe);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:ve=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Re}(),O=B.noopTest,H=B.edit,W=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=H(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=H(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=H(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=H(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=H(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=H(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=W({},X),X.gfm=W({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=H(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=W({},X.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:H(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=H(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=H(X._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=H(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=H(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=H(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=H(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=H(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=H(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=H(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=H(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=W({},K),K.pedantic=W({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=W({},K.normal,{escape:H(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=H(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=W({},K.gfm,{br:H(K.br).replace("{2,}","*").getRegex(),text:H(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:K},_e=j,Ce=S.exports.defaults,Pe=de.block,Be=de.inline,$e=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var De="",Ae,oe,ue=Re.length;for(Ae=0;Ae<ue;Ae++)oe=Re.charCodeAt(Ae),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var ee=function(){function Re(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||Ce,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Pe.normal,inline:Be.normal};this.options.pedantic?(oe.block=Pe.pedantic,oe.inline=Be.pedantic):this.options.gfm&&(oe.block=Pe.gfm,this.options.breaks?oe.inline=Be.breaks:oe.inline=Be.gfm),this.tokenizer.rules=oe}Re.lex=function(oe,ue){var we=new Re(ue);return we.lex(oe)},Re.lexInline=function(oe,ue){var we=new Re(ue);return we.inlineTokens(oe)};var De=Re.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ve,Fe,Ge,ze;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ve=lt.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.space(oe)){oe=oe.substring(ve.raw.length),ve.type&&ue.push(ve);continue}if(ve=this.tokenizer.code(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(ve=this.tokenizer.fences(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.heading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.hr(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.blockquote(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.list(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.html(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.def(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.lheading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=oe.slice(1),ge=void 0;we.options.extensions.startBlock.forEach(function(be){ge=be.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(Ge=oe.substring(0,lt+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(Ge))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve),ze=Ge.length!==oe.length,oe=oe.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(oe){var Ye="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},De.inline=function(oe,ue){this.inlineQueue.push({src:oe,tokens:ue})},De.inlineTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]);var ve,Fe,Ge,ze=oe,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(re){return(ve=re.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.tag(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.link(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.emStrong(oe,ze,xe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.codespan(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.br(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.del(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.autolink(oe,G)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(oe,G))){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var re=Infinity,Q=oe.slice(1),Se=void 0;we.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},Q),typeof Se=="number"&&Se>=0&&(re=Math.min(re,Se))}),re<Infinity&&re>=0&&(Ge=oe.substring(0,re+1))}(),ve=this.tokenizer.inlineText(Ge,He)){oe=oe.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(xe=ve.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(oe){var be="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),te=S.exports.defaults,ce=B.cleanUrl,Z=B.escape,se=function(){function Re(Ae){this.options=Ae||te}var De=Re.prototype;return De.code=function(oe,ue,we){var ve=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(oe,ve);Fe!=null&&Fe!==oe&&(we=!0,oe=Fe)}return oe=oe.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Z(ve,!0)+'">'+(we?oe:Z(oe,!0))+`</code></pre>
`:"<pre><code>"+(we?oe:Z(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ue,we,ve){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ue,we){var ve=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+ve+Fe+`>
`+oe+"</"+ve+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ue){var we=ue.header?"th":"td",ve=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return ve+oe+"</"+we+`>
`},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<a href="'+Z(oe)+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=">"+we+"</a>",ve},De.image=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<img src="'+oe+'" alt="'+we+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(oe){return oe},Re}(),pe=function(){function Re(){}var De=Re.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ue,we){return""+we},De.image=function(oe,ue,we){return""+we},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ue){var we=oe,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[oe];do ve++,we=oe+"-"+ve;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[oe]=ve,this.seen[we]=0),we},De.slug=function(oe,ue){ue===void 0&&(ue={});var we=this.serialize(oe);return this.getNextSafeSlug(we,ue.dryrun)},Re}(),je=se,Ke=pe,Ze=Me,rt=S.exports.defaults,ct=B.unescape,ye=function(){function Re(Ae){this.options=Ae||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(oe,ue){var we=new Re(ue);return we.parse(oe)},Re.parseInline=function(oe,ue){var we=new Re(ue);return we.parseInline(oe)};var De=Re.prototype;return De.parse=function(oe,ue){ue===void 0&&(ue=!0);var we="",ve,Fe,Ge,ze,Ye,lt,xe,ge,be,re,Q,Se,Le,nt,qe,gt,Et,pt,vt,wt=oe.length;for(ve=0;ve<wt;ve++){if(re=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(vt=this.options.extensions.renderers[re.type].call({parser:this},re),vt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(re.type))){we+=vt||"";continue}switch(re.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(re.tokens),re.depth,ct(this.parseInline(re.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(re.text,re.lang,re.escaped);continue}case"table":{for(ge="",xe="",ze=re.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(re.header[Fe].tokens),{header:!0,align:re.align[Fe]});for(ge+=this.renderer.tablerow(xe),be="",ze=re.rows.length,Fe=0;Fe<ze;Fe++){for(lt=re.rows[Fe],xe="",Ye=lt.length,Ge=0;Ge<Ye;Ge++)xe+=this.renderer.tablecell(this.parseInline(lt[Ge].tokens),{header:!1,align:re.align[Ge]});be+=this.renderer.tablerow(xe)}we+=this.renderer.table(ge,be);continue}case"blockquote":{be=this.parse(re.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(Q=re.ordered,Se=re.start,Le=re.loose,ze=re.items.length,be="",Fe=0;Fe<ze;Fe++)qe=re.items[Fe],gt=qe.checked,Et=qe.task,nt="",qe.task&&(pt=this.renderer.checkbox(gt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=pt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=pt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:pt}):nt+=pt),nt+=this.parse(qe.tokens,Le),be+=this.renderer.listitem(nt,Et,gt);we+=this.renderer.list(be,Q,Se);continue}case"html":{we+=this.renderer.html(re.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(re.tokens));continue}case"text":{for(be=re.tokens?this.parseInline(re.tokens):re.text;ve+1<wt&&oe[ve+1].type==="text";)re=oe[++ve],be+=`
`+(re.tokens?this.parseInline(re.tokens):re.text);we+=ue?this.renderer.paragraph(be):be;continue}default:{var Dt='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Dt);return}else throw new Error(Dt)}}}return we},De.parseInline=function(oe,ue){ue=ue||this.renderer;var we="",ve,Fe,Ge,ze=oe.length;for(ve=0;ve<ze;ve++){if(Fe=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=Ge||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return we},Re}(),at=ee,J=ye,ie=j,Ee=se,Qe=pe,et=Me,le=B.merge,Ie=B.checkSanitizeDeprecation,Ue=B.escape,Xe=S.exports.getDefaults,it=S.exports.changeDefaults,ft=S.exports.defaults;function tt(Re,De,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(Ae=De,De=null),De=le({},tt.defaults,De||{}),Ie(De),Ae){var oe=De.highlight,ue;try{ue=at.lex(Re,De)}catch(Ge){return Ae(Ge)}var we=function(ze){var Ye;if(!ze)try{De.walkTokens&&tt.walkTokens(ue,De.walkTokens),Ye=J.parse(ue,De)}catch(lt){ze=lt}return De.highlight=oe,ze?Ae(ze):Ae(null,Ye)};if(!oe||oe.length<3||(delete De.highlight,!ue.length))return we();var ve=0;tt.walkTokens(ue,function(Ge){Ge.type==="code"&&(ve++,setTimeout(function(){oe(Ge.text,Ge.lang,function(ze,Ye){if(ze)return we(ze);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Fe=at.lex(Re,De);return De.walkTokens&&tt.walkTokens(Fe,De.walkTokens),J.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(Ge.message+"",!0)+"</pre>";throw Ge}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),it(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,De=arguments.length,Ae=new Array(De),oe=0;oe<De;oe++)Ae[oe]=arguments[oe];var ue=le.apply(void 0,[{}].concat(Ae)),we=tt.defaults.extensions||{renderers:{},childTokens:{}},ve;Ae.forEach(function(Fe){if(Fe.extensions&&(ve=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=we.renderers?we.renderers[ze.name]:null;Ye?we.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var be=ze.renderer.apply(this,xe);return be===!1&&(be=Ye.apply(this,xe)),be}:we.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[ze.level]?we[ze.level].unshift(ze.tokenizer):we[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?we.startBlock?we.startBlock.push(ze.start):we.startBlock=[ze.start]:ze.level==="inline"&&(we.startInline?we.startInline.push(ze.start):we.startInline=[ze.start]))}ze.childTokens&&(we.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new Ee,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var re=arguments.length,Q=new Array(re),Se=0;Se<re;Se++)Q[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ie,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var re=arguments.length,Q=new Array(re),Se=0;Se<re;Se++)Q[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var Ge=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),Ge&&Ge(ze)}}ve&&(ue.extensions=we),tt.setOptions(ue)})},tt.walkTokens=function(Re,De){for(var Ae=function(){var ve=ue.value;switch(De(ve),ve.type){case"table":{for(var Fe=D(ve.header),Ge;!(Ge=Fe()).done;){var ze=Ge.value;tt.walkTokens(ze.tokens,De)}for(var Ye=D(ve.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=D(xe),be;!(be=ge()).done;){var re=be.value;tt.walkTokens(re.tokens,De)}break}case"list":{tt.walkTokens(ve.items,De);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[ve.type]?tt.defaults.extensions.childTokens[ve.type].forEach(function(Q){tt.walkTokens(ve[Q],De)}):ve.tokens&&tt.walkTokens(ve.tokens,De)}},oe=D(Re),ue;!(ue=oe()).done;)Ae()},tt.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=le({},tt.defaults,De||{}),Ie(De);try{var Ae=at.lexInline(Re,De);return De.walkTokens&&tt.walkTokens(Ae,De.walkTokens),J.parseInline(Ae,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(oe.message+"",!0)+"</pre>";throw oe}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=Ee,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ie,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[79],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(A,k,_){return Math.min(Math.max(A,k),_)}e.clamp=g;function L(A,k){return(k+A%k)%k}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class S{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function Y(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function A(_){S.push(_,Date.now())}function k(){const _=[];for(let C=0;C<S.length;C+=2)_.push({name:S[C],startTime:S[C+1]});return _}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))S.push({name:A.name,startTime:Math.round(D+A.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,D=!1,S=!1,A=!1,k=!1,_=!1,C=!1,i,I=g,a,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,_=!0,i=navigator.language,I=i;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",S=h.platform==="linux",A=S&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=g,I=g;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),d=t.availableLanguages["*"];i=t.locale,I=d||g,a=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var y;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let b=0;D?b=1:L?b=3:S&&(b=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=A,e.isNative=k,e.isWeb=_,e.isIOS=C,e.platform=b,e.userAgent=p,e.language=I;var s;(function(r){function t(){return e.language}r.value=t;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function l(){return e.language==="en"}r.isDefault=l})(s=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=a,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let d=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeSetImmediateId)for(let m=0,u=d.length;m<u;m++){const E=d[m];if(E.id===c.data.vscodeSetImmediateId){d.splice(m,1),E.callback();return}}});let l=0;return c=>{const m=++l;d.push({id:m,callback:c}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return d=>t.then(d)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:L?1:3;let v=!0,n=!1;function f(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=f}),define(fe[38],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,g.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[8],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,S=90,A=122,k=46,_=47,C=92,i=58,I=63;class a extends Error{constructor(o,v,n){let f;typeof v=="string"&&v.indexOf("not ")===0?(f="must not be",v=v.replace(/^not /,"")):f="must be";const r=o.indexOf(".")!==-1?"property":"argument";let t=`The "${o}" ${r} ${f} of type ${v}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(s,o){if(typeof s!="string")throw new a(o,"string",s)}function h(s){return s===_||s===C}function w(s){return s===_}function y(s){return s>=L&&s<=S||s>=D&&s<=A}function P(s,o,v,n){let f="",r=0,t=-1,d=0,l=0;for(let c=0;c<=s.length;++c){if(c<s.length)l=s.charCodeAt(c);else{if(n(l))break;l=_}if(n(l)){if(!(t===c-1||d===1))if(d===2){if(f.length<2||r!==2||f.charCodeAt(f.length-1)!==k||f.charCodeAt(f.length-2)!==k){if(f.length>2){const m=f.lastIndexOf(v);m===-1?(f="",r=0):(f=f.slice(0,m),r=f.length-1-f.lastIndexOf(v)),t=c,d=0;continue}else if(f.length!==0){f="",r=0,t=c,d=0;continue}}o&&(f+=f.length>0?`${v}..`:"..",r=2)}else f.length>0?f+=`${v}${s.slice(t+1,c)}`:f=s.slice(t+1,c),r=c-t-1;t=c,d=0}else l===k&&d!==-1?++d:d=-1}return f}function b(s,o){if(o===null||typeof o!="object")throw new a("pathObject","Object",o);const v=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return v?v===o.root?`${v}${n}`:`${v}${s}${n}`:n}e.win32={resolve(...s){let o="",v="",n=!1;for(let f=s.length-1;f>=-1;f--){let r;if(f>=0){if(r=s[f],p(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${o}\\`));const t=r.length;let d=0,l="",c=!1;const m=r.charCodeAt(0);if(t===1)h(m)&&(d=1,c=!0);else if(h(m))if(c=!0,h(r.charCodeAt(1))){let u=2,E=u;for(;u<t&&!h(r.charCodeAt(u));)u++;if(u<t&&u!==E){const T=r.slice(E,u);for(E=u;u<t&&h(r.charCodeAt(u));)u++;if(u<t&&u!==E){for(E=u;u<t&&!h(r.charCodeAt(u));)u++;(u===t||u!==E)&&(l=`\\\\${T}\\${r.slice(E,u)}`,d=u)}}}else d=1;else y(m)&&r.charCodeAt(1)===i&&(l=r.slice(0,2),d=2,t>2&&h(r.charCodeAt(2))&&(c=!0,d=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(n){if(o.length>0)break}else if(v=`${r.slice(d)}\\${v}`,n=c,c&&o.length>0)break}return v=P(v,!n,"\\",h),n?`${o}\\${v}`:`${o}${v}`||"."},normalize(s){p(s,"path");const o=s.length;if(o===0)return".";let v=0,n,f=!1;const r=s.charCodeAt(0);if(o===1)return w(r)?"\\":s;if(h(r))if(f=!0,h(s.charCodeAt(1))){let d=2,l=d;for(;d<o&&!h(s.charCodeAt(d));)d++;if(d<o&&d!==l){const c=s.slice(l,d);for(l=d;d<o&&h(s.charCodeAt(d));)d++;if(d<o&&d!==l){for(l=d;d<o&&!h(s.charCodeAt(d));)d++;if(d===o)return`\\\\${c}\\${s.slice(l)}\\`;d!==l&&(n=`\\\\${c}\\${s.slice(l,d)}`,v=d)}}}else v=1;else y(r)&&s.charCodeAt(1)===i&&(n=s.slice(0,2),v=2,o>2&&h(s.charCodeAt(2))&&(f=!0,v=3));let t=v<o?P(s.slice(v),!f,"\\",h):"";return t.length===0&&!f&&(t="."),t.length>0&&h(s.charCodeAt(o-1))&&(t+="\\"),n===void 0?f?`\\${t}`:t:f?`${n}\\${t}`:`${n}${t}`},isAbsolute(s){p(s,"path");const o=s.length;if(o===0)return!1;const v=s.charCodeAt(0);return h(v)||o>2&&y(v)&&s.charCodeAt(1)===i&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,v;for(let r=0;r<s.length;++r){const t=s[r];p(t,"path"),t.length>0&&(o===void 0?o=v=t:o+=`\\${t}`)}if(o===void 0)return".";let n=!0,f=0;if(typeof v=="string"&&h(v.charCodeAt(0))){++f;const r=v.length;r>1&&h(v.charCodeAt(1))&&(++f,r>2&&(h(v.charCodeAt(2))?++f:n=!1))}if(n){for(;f<o.length&&h(o.charCodeAt(f));)f++;f>=2&&(o=`\\${o.slice(f)}`)}return e.win32.normalize(o)},relative(s,o){if(p(s,"from"),p(o,"to"),s===o)return"";const v=e.win32.resolve(s),n=e.win32.resolve(o);if(v===n||(s=v.toLowerCase(),o=n.toLowerCase(),s===o))return"";let f=0;for(;f<s.length&&s.charCodeAt(f)===C;)f++;let r=s.length;for(;r-1>f&&s.charCodeAt(r-1)===C;)r--;const t=r-f;let d=0;for(;d<o.length&&o.charCodeAt(d)===C;)d++;let l=o.length;for(;l-1>d&&o.charCodeAt(l-1)===C;)l--;const c=l-d,m=t<c?t:c;let u=-1,E=0;for(;E<m;E++){const R=s.charCodeAt(f+E);if(R!==o.charCodeAt(d+E))break;R===C&&(u=E)}if(E!==m){if(u===-1)return n}else{if(c>m){if(o.charCodeAt(d+E)===C)return n.slice(d+E+1);if(E===2)return n.slice(d+E)}t>m&&(s.charCodeAt(f+E)===C?u=E:E===2&&(u=3)),u===-1&&(u=0)}let T="";for(E=f+u+1;E<=r;++E)(E===r||s.charCodeAt(E)===C)&&(T+=T.length===0?"..":"\\..");return d+=u,T.length>0?`${T}${n.slice(d,l)}`:(n.charCodeAt(d)===C&&++d,n.slice(d,l))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===C){if(o.charCodeAt(1)===C){const v=o.charCodeAt(2);if(v!==I&&v!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(y(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===C)return`\\\\?\\${o}`;return s},dirname(s){p(s,"path");const o=s.length;if(o===0)return".";let v=-1,n=0;const f=s.charCodeAt(0);if(o===1)return h(f)?s:".";if(h(f)){if(v=n=1,h(s.charCodeAt(1))){let d=2,l=d;for(;d<o&&!h(s.charCodeAt(d));)d++;if(d<o&&d!==l){for(l=d;d<o&&h(s.charCodeAt(d));)d++;if(d<o&&d!==l){for(l=d;d<o&&!h(s.charCodeAt(d));)d++;if(d===o)return s;d!==l&&(v=n=d+1)}}}}else y(f)&&s.charCodeAt(1)===i&&(v=o>2&&h(s.charCodeAt(2))?3:2,n=v);let r=-1,t=!0;for(let d=o-1;d>=n;--d)if(h(s.charCodeAt(d))){if(!t){r=d;break}}else t=!1;if(r===-1){if(v===-1)return".";r=v}return s.slice(0,r)},basename(s,o){o!==void 0&&p(o,"ext"),p(s,"path");let v=0,n=-1,f=!0,r;if(s.length>=2&&y(s.charCodeAt(0))&&s.charCodeAt(1)===i&&(v=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,d=-1;for(r=s.length-1;r>=v;--r){const l=s.charCodeAt(r);if(h(l)){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),t>=0&&(l===o.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=d))}return v===n?n=d:n===-1&&(n=s.length),s.slice(v,n)}for(r=s.length-1;r>=v;--r)if(h(s.charCodeAt(r))){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":s.slice(v,n)},extname(s){p(s,"path");let o=0,v=-1,n=0,f=-1,r=!0,t=0;s.length>=2&&s.charCodeAt(1)===i&&y(s.charCodeAt(0))&&(o=n=2);for(let d=s.length-1;d>=o;--d){const l=s.charCodeAt(d);if(h(l)){if(!r){n=d+1;break}continue}f===-1&&(r=!1,f=d+1),l===k?v===-1?v=d:t!==1&&(t=1):v!==-1&&(t=-1)}return v===-1||f===-1||t===0||t===1&&v===f-1&&v===n+1?"":s.slice(v,f)},format:b.bind(null,"\\"),parse(s){p(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const v=s.length;let n=0,f=s.charCodeAt(0);if(v===1)return h(f)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(h(f)){if(n=1,h(s.charCodeAt(1))){let u=2,E=u;for(;u<v&&!h(s.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&h(s.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&!h(s.charCodeAt(u));)u++;u===v?n=u:u!==E&&(n=u+1)}}}}else if(y(f)&&s.charCodeAt(1)===i){if(v<=2)return o.root=o.dir=s,o;if(n=2,h(s.charCodeAt(2))){if(v===3)return o.root=o.dir=s,o;n=3}}n>0&&(o.root=s.slice(0,n));let r=-1,t=n,d=-1,l=!0,c=s.length-1,m=0;for(;c>=n;--c){if(f=s.charCodeAt(c),h(f)){if(!l){t=c+1;break}continue}d===-1&&(l=!1,d=c+1),f===k?r===-1?r=c:m!==1&&(m=1):r!==-1&&(m=-1)}return d!==-1&&(r===-1||m===0||m===1&&r===d-1&&r===t+1?o.base=o.name=s.slice(t,d):(o.name=s.slice(t,r),o.base=s.slice(t,d),o.ext=s.slice(r,d))),t>0&&t!==n?o.dir=s.slice(0,t-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",v=!1;for(let n=s.length-1;n>=-1&&!v;n--){const f=n>=0?s[n]:g.cwd();p(f,"path"),f.length!==0&&(o=`${f}/${o}`,v=f.charCodeAt(0)===_)}return o=P(o,!v,"/",w),v?`/${o}`:o.length>0?o:"."},normalize(s){if(p(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_,v=s.charCodeAt(s.length-1)===_;return s=P(s,!o,"/",w),s.length===0?o?"/":v?"./":".":(v&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return p(s,"path"),s.length>0&&s.charCodeAt(0)===_},join(...s){if(s.length===0)return".";let o;for(let v=0;v<s.length;++v){const n=s[v];p(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(p(s,"from"),p(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const v=1,n=s.length,f=n-v,r=1,t=o.length-r,d=f<t?f:t;let l=-1,c=0;for(;c<d;c++){const u=s.charCodeAt(v+c);if(u!==o.charCodeAt(r+c))break;u===_&&(l=c)}if(c===d)if(t>d){if(o.charCodeAt(r+c)===_)return o.slice(r+c+1);if(c===0)return o.slice(r+c)}else f>d&&(s.charCodeAt(v+c)===_?l=c:c===0&&(l=0));let m="";for(c=v+l+1;c<=n;++c)(c===n||s.charCodeAt(c)===_)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(r+l)}`},toNamespacedPath(s){return s},dirname(s){if(p(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===_;let v=-1,n=!0;for(let f=s.length-1;f>=1;--f)if(s.charCodeAt(f)===_){if(!n){v=f;break}}else n=!1;return v===-1?o?"/":".":o&&v===1?"//":s.slice(0,v)},basename(s,o){o!==void 0&&p(o,"ext"),p(s,"path");let v=0,n=-1,f=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let t=o.length-1,d=-1;for(r=s.length-1;r>=0;--r){const l=s.charCodeAt(r);if(l===_){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),t>=0&&(l===o.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=d))}return v===n?n=d:n===-1&&(n=s.length),s.slice(v,n)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===_){if(!f){v=r+1;break}}else n===-1&&(f=!1,n=r+1);return n===-1?"":s.slice(v,n)},extname(s){p(s,"path");let o=-1,v=0,n=-1,f=!0,r=0;for(let t=s.length-1;t>=0;--t){const d=s.charCodeAt(t);if(d===_){if(!f){v=t+1;break}continue}n===-1&&(f=!1,n=t+1),d===k?o===-1?o=t:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||n===-1||r===0||r===1&&o===n-1&&o===v+1?"":s.slice(o,n)},format:b.bind(null,"/"),parse(s){p(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const v=s.charCodeAt(0)===_;let n;v?(o.root="/",n=1):n=0;let f=-1,r=0,t=-1,d=!0,l=s.length-1,c=0;for(;l>=n;--l){const m=s.charCodeAt(l);if(m===_){if(!d){r=l+1;break}continue}t===-1&&(d=!1,t=l+1),m===k?f===-1?f=l:c!==1&&(c=1):f!==-1&&(c=-1)}if(t!==-1){const m=r===0&&v?1:r;f===-1||c===0||c===1&&f===t-1&&f===r+1?o.base=o.name=s.slice(m,t):(o.name=s.slice(m,f),o.base=s.slice(m,t),o.ext=s.slice(f,t))}return r>0?o.dir=s.slice(0,r-1):v&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...A){const k=A.reduce((i,I)=>(i[I]=!0,i),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!k[i]).forEach(i=>{for(let I=0;I<_.length;I++)if(i.search(_[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(fe[46],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(fe[3],me([0,1,18,76,6,95,46]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(o){o.None=()=>D.Disposable.None;function v(M){return(z,U=null,x)=>{let j=!1,O;return O=M(H=>{if(!j)return O?O.dispose():j=!0,z.call(U,H)},null,x),j&&O.dispose(),O}}o.once=v;function n(M,z){return c((U,x=null,j)=>M(O=>U.call(x,z(O)),null,j))}o.map=n;function f(M,z){return c((U,x=null,j)=>M(O=>{z(O),U.call(x,O)},null,j))}o.forEach=f;function r(M,z){return c((U,x=null,j)=>M(O=>z(O)&&U.call(x,O),null,j))}o.filter=r;function t(M){return M}o.signal=t;function d(...M){return(z,U=null,x)=>(0,D.combinedDisposable)(...M.map(j=>j(O=>z.call(U,O),null,x)))}o.any=d;function l(M,z,U){let x=U;return n(M,j=>(x=z(x,j),x))}o.reduce=l;function c(M){let z;const U=new a({onFirstListenerAdd(){z=M(U.fire,U)},onLastListenerRemove(){z.dispose()}});return U.event}function m(M,z,U=100,x=!1,j){let O,H,W,X=0;const K=new a({leakWarningThreshold:j,onFirstListenerAdd(){O=M(de=>{X++,H=z(H,de),x&&!W&&(K.fire(H),H=void 0),clearTimeout(W),W=setTimeout(()=>{const _e=H;H=void 0,W=void 0,(!x||X>1)&&K.fire(_e),X=0},U)})},onLastListenerRemove(){O.dispose()}});return K.event}o.debounce=m;function u(M,z=(U,x)=>U===x){let U=!0,x;return r(M,j=>{const O=U||!z(j,x);return U=!1,x=j,O})}o.latch=u;function E(M,z){return[o.filter(M,z),o.filter(M,U=>!z(U))]}o.split=E;function T(M,z=!1,U=[]){let x=U.slice(),j=M(W=>{x?x.push(W):H.fire(W)});const O=()=>{x&&x.forEach(W=>H.fire(W)),x=null},H=new a({onFirstListenerAdd(){j||(j=M(W=>H.fire(W)))},onFirstListenerDidAdd(){x&&(z?setTimeout(O):O())},onLastListenerRemove(){j&&j.dispose(),j=null}});return H.event}o.buffer=T;class R{constructor(z){this.event=z}map(z){return new R(n(this.event,z))}forEach(z){return new R(f(this.event,z))}filter(z){return new R(r(this.event,z))}reduce(z,U){return new R(l(this.event,z,U))}latch(){return new R(u(this.event))}debounce(z,U=100,x=!1,j){return new R(m(this.event,z,U,x,j))}on(z,U,x){return this.event(z,U,x)}once(z,U,x){return v(this.event)(z,U,x)}}function B(M){return new R(M)}o.chain=B;function N(M,z,U=x=>x){const x=(...W)=>H.fire(U(...W)),j=()=>M.on(z,x),O=()=>M.removeListener(z,x),H=new a({onFirstListenerAdd:j,onLastListenerRemove:O});return H.event}o.fromNodeEventEmitter=N;function F(M,z,U=x=>x){const x=(...W)=>H.fire(U(...W)),j=()=>M.addEventListener(z,x),O=()=>M.removeEventListener(z,x),H=new a({onFirstListenerAdd:j,onLastListenerRemove:O});return H.event}o.fromDOMEventEmitter=F;function $(M){return new Promise(z=>v(M)(z))}o.toPromise=$})(k=e.Event||(e.Event={}));class _{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${_._idPool++}`}start(v){this._stopWatch=new A.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function i(o){const v=C;return C=o,{dispose(){C=v}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(v,n=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let n=C;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||v<n)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(f)||0;if(this._stacks.set(f,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,d=0;for(const[l,c]of this._stacks)(!t||d<c)&&(t=l,d=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${d}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class a{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(v,n,f)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[v,n]:v);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,n);const d=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{d&&d(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof D.DisposableStore?f.add(l):Array.isArray(f)&&f.push(l),l}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,f]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,f):n[0].call(n[1],f)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class p extends a{async fireAsync(v,n,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,v]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),d=[],l={...t,waitUntil:c=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");f&&(c=f(c,typeof r=="function"?r:r[0])),d.push(c)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(c){(0,g.onUnexpectedError)(c);continue}Object.freeze(d),await Promise.allSettled(d).then(c=>{for(const m of c)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class h extends a{constructor(v){super(v);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=h;class w extends h{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class y extends a{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const n={event:v,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const f=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(n=>this.emitter.fire(n))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class b{constructor(){this.buffers=[]}wrapEvent(v){return(n,f,r)=>v(t=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>n.call(f,t)):n.call(f,t)},void 0,r)}bufferEvents(v){const n=[];this.buffers.push(n);const f=v();return this.buffers.pop(),n.forEach(r=>r()),f}}e.EventBufferer=b;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,_){const C=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(C)}}});var D;(function(k){function _(C){return C===k.None||C===k.Cancelled||C instanceof S?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const a=this._icons.get(I.id);a?I.description?a.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function S(i,I){return new k(i,I)}e.registerCodicon=S;function A(i){return i?i.replace(/\$\((.*?)\)/g,(I,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=A;class k{constructor(I,a,p){this.id=I,this.definition=a,this.description=p,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function _(i,I){const a=["codicon","codicon-"+i];return I&&a.push("codicon-modifier-"+I),a}e.getClassNamesArray=_;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function a(w){if(w instanceof k)return["codicon","codicon-"+w.id];const y=I.exec(w.id);if(!y)return a(k.error);let[,P,b]=y;const s=["codicon","codicon-"+P];return b&&s.push("codicon-modifier-"+b.substr(1)),s}i.asClassNameArray=a;function p(w){return a(w).join(" ")}i.asClassName=p;function h(w){return"."+a(w).join(".")}i.asCSSSelector=h})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(k=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,18,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=D;function S(s){const o=s;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(s,o){return new k(s,o)}e.newWriteableStream=A;class k{constructor(o,v){this.reducer=o,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(v=>v(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(v=>v(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,v){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(o,v){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const f=n.indexOf(v);f>=0&&n.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(s,o){const v=[];let n;for(;(n=s.read())!==null;)v.push(n);return o(v)}e.consumeReadable=_;function C(s,o,v){const n=[];let f;for(;(f=s.read())!==null&&n.length<v;)n.push(f);return f===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof f!="undefined"){const r=f;return f=void 0,r}return s.read()}}}e.peekReadable=C;function i(s,o){return new Promise((v,n)=>{const f=[];I(s,{onData:r=>{o&&f.push(r)},onError:r=>{o?n(r):v(void 0)},onEnd:()=>{v(o?o(f):void 0)}})})}e.consumeStream=i;function I(s,o){s.on("error",v=>o.onError(v)),s.on("end",()=>o.onEnd()),s.on("data",v=>o.onData(v))}e.listenStream=I;function a(s,o){return new Promise((v,n)=>{const f=new L.DisposableStore,r=[],t=c=>{if(r.push(c),r.length>o)return f.dispose(),s.pause(),v({stream:s,buffer:r,ended:!1})},d=c=>n(c),l=()=>v({stream:s,buffer:r,ended:!0});f.add((0,L.toDisposable)(()=>s.removeListener("error",d))),s.on("error",d),f.add((0,L.toDisposable)(()=>s.removeListener("end",l))),s.on("end",l),f.add((0,L.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=a;function p(s,o){const v=A(o);return v.end(s),v}e.toStream=p;function h(){const s=A(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=h;function w(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=w;function y(s,o,v){const n=A(v);return I(s,{onData:f=>n.write(o.data(f)),onError:f=>n.error(o.error?o.error(f):f),onEnd:()=>n.end()}),n}e.transform=y;function P(s,o,v){let n=!1;return{read:()=>{const f=o.read();return n?f:(n=!0,f!==null?v([s,f]):s)}}}e.prefixedReadable=P;function b(s,o,v){let n=!1;const f=A(v);return I(o,{onData:r=>n?f.write(r):(n=!0,f.write(v([s,r]))),onError:r=>f.error(r),onEnd:()=>{n||(n=!0,f.write(s)),f.end()}}),f}e.prefixedStream=b}),define(fe[22],me([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,S;class A{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new A(Buffer.allocUnsafe(t)):new A(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new A(t)}static fromString(t,d){return!(d?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(t)):(D||(D=new TextEncoder),new A(D.encode(t)))}static concat(t,d){if(typeof d=="undefined"){d=0;for(let m=0,u=t.length;m<u;m++)d+=t[m].byteLength}const l=A.alloc(d);let c=0;for(let m=0,u=t.length;m<u;m++){const E=t[m];l.set(E,c),c+=E.byteLength}return l}toString(){return L?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(t,d){return new A(this.buffer.subarray(t,d))}set(t,d){t instanceof A?this.buffer.set(t.buffer,d):this.buffer.set(t,d)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,d){i(this.buffer,t,d)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,d){a(this.buffer,t,d)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,d){h(this.buffer,t,d)}}e.VSBuffer=A;function k(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=k;function _(r,t,d){r[d+0]=t&255,t=t>>>8,r[d+1]=t&255}e.writeUInt16LE=_;function C(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=C;function i(r,t,d){r[d+3]=t,t=t>>>8,r[d+2]=t,t=t>>>8,r[d+1]=t,t=t>>>8,r[d]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function a(r,t,d){r[d+0]=t&255,t=t>>>8,r[d+1]=t&255,t=t>>>8,r[d+2]=t&255,t=t>>>8,r[d+3]=t&255}e.writeUInt32LE=a;function p(r,t){return r[t]}e.readUInt8=p;function h(r,t,d){r[d]=t}e.writeUInt8=h;function w(r){return g.consumeReadable(r,t=>A.concat(t))}e.readableToBuffer=w;function y(r){return g.toReadable(r)}e.bufferToReadable=y;function P(r){return g.consumeStream(r,t=>A.concat(t))}e.streamToBuffer=P;async function b(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await P(r.stream)])}e.bufferedStreamToBuffer=b;function s(r){return g.toStream(r,t=>A.concat(t))}e.bufferToStream=s;function o(r){return g.transform(r,{data:t=>typeof t=="string"?A.fromString(t):A.wrap(t)},t=>A.concat(t))}e.streamToBufferReadableStream=o;function v(r){return g.newWriteableStream(t=>A.concat(t),r)}e.newWriteableBufferStream=v;function n(r,t){return g.prefixedReadable(r,t,d=>A.concat(d))}e.prefixedBufferReadable=n;function f(r,t){return g.prefixedStream(r,t,d=>A.concat(d))}e.prefixedBufferStream=f}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function D(le,...Ie){return Ie.length===0?le:le.replace(L,function(Ue,Xe){const it=parseInt(Xe,10);return isNaN(it)||it<0||it>=Ie.length?Ue:Ie[it]})}e.format=D;const S=/{([^}]+)}/g;function A(le,Ie){return le.replace(S,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=A;function k(le){return le.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=k;function _(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function C(le,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let it=le.length-1;it>=0;it--)le.charCodeAt(it)===Xe&&Ue++;return Ue}e.count=C;function i(le,Ie,Ue="\u2026"){return le.length<=Ie?le:`${le.substr(0,Ie)}${Ue}`}e.truncate=i;function I(le,Ie=" "){const Ue=a(le,Ie);return p(Ue,Ie)}e.trim=I;function a(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length;if(Ue===0||le.length===0)return le;let Xe=0;for(;le.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return le.substring(Xe)}e.ltrim=a;function p(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length,Xe=le.length;if(Ue===0||Xe===0)return le;let it=Xe,ft=-1;for(;ft=le.lastIndexOf(Ie,it-1),!(ft===-1||ft+Ue!==it);){if(ft===0)return"";it=ft}return le.substring(0,it)}e.rtrim=p;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function y(le,Ie,Ue={}){if(!le)throw new Error("Cannot create regex from empty string");Ie||(le=_(le)),Ue.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=y;function P(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function b(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=s;function o(le){return le.split(/\r\n|\r|\n/)}e.splitLines=o;function v(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++){const Xe=le.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function n(le,Ie=0,Ue=le.length){for(let Xe=Ie;Xe<Ue;Xe++){const it=le.charCodeAt(Xe);if(it!==32&&it!==9)return le.substring(Ie,Xe)}return le.substring(Ie,Ue)}e.getLeadingWhitespace=n;function f(le,Ie=le.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=le.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=f;function r(le,Ie){return le<Ie?-1:le>Ie?1:0}e.compare=r;function t(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re<De)return-1;if(Re>De)return 1}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function d(le,Ie){return l(le,Ie,0,le.length,0,Ie.length)}e.compareIgnoreCase=d;function l(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re===De)continue;if(Re>=128||De>=128)return t(le.toLowerCase(),Ie.toLowerCase(),Ue,Xe,it,ft);c(Re)&&(Re-=32),c(De)&&(De-=32);const Ae=Re-De;if(Ae!==0)return Ae}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=l;function c(le){return le>=97&&le<=122}e.isLowerAsciiLetter=c;function m(le){return le>=65&&le<=90}e.isUpperAsciiLetter=m;function u(le,Ie){return le.length===Ie.length&&l(le,Ie)===0}e.equalsIgnoreCase=u;function E(le,Ie){const Ue=Ie.length;return Ie.length>le.length?!1:l(le,Ie,0,Ue)===0}e.startsWithIgnoreCase=E;function T(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=T;function R(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);const it=le.length-1,ft=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(it-Ue)!==Ie.charCodeAt(ft-Ue))return Ue;return Xe}e.commonSuffixLength=R;function B(le){return 55296<=le&&le<=56319}e.isHighSurrogate=B;function N(le){return 56320<=le&&le<=57343}e.isLowSurrogate=N;function F(le,Ie){return(le-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(le,Ie,Ue){const Xe=le.charCodeAt(Ue);if(B(Xe)&&Ue+1<Ie){const it=le.charCodeAt(Ue+1);if(N(it))return F(Xe,it)}return Xe}e.getNextCodePoint=$;function M(le,Ie){const Ue=le.charCodeAt(Ie-1);if(N(Ue)&&Ie>1){const Xe=le.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ue)}return Ue}function z(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=le.length,ft=$(le,it,Ie);Ie+=ft>=65536?2:1;let tt=Ue.getGraphemeBreakType(ft);for(;Ie<it;){const ut=$(le,it,Ie),Re=Ue.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=z;function U(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=M(le,Ie);Ie-=it>=65536?2:1;let ft=Ue.getGraphemeBreakType(it);for(;Ie>0;){const tt=M(le,Ie),ut=Ue.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=U;function x(le,Ie){const Ue=ye.getInstance(),Xe=le.length,it=Ie,ft=$(le,Xe,Ie),tt=Ue.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const De=$(le,Xe,Ie),Ae=Ue.getGraphemeBreakType(De);if(rt(ut,Ae))break;Ie+=De>=65536?2:1,ut=Ae}const Re=Ie;for(Ie=it,ut=tt;Ie>0;){const De=M(le,Ie),Ae=Ue.getGraphemeBreakType(De);if(rt(Ae,ut))break;Ie-=De>=65536?2:1,ut=Ae}return[Ie,Re]}function j(le,Ie){return Ie>0&&N(le.charCodeAt(Ie))?x(le,Ie-1):x(le,Ie)}e.getCharContainingOffset=j;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function H(le){return O.test(le)}e.containsRTL=H;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return W.test(le)}e.containsEmoji=X;const K=/^[\t\n\r\x20-\x7E]*$/;function de(le){return K.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=_e;function Ce(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++)if(Pe(le.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=Ce;function Pe(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function Be(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Be;function $e(le,Ie){if(le.length<Ie)return le;const Ue=/\b/g;let Xe=0;for(;Ue.test(le)&&!(le.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=$e;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function te(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function se(le,Ie){if(!le||!Ie||le.length<Ie.length)return!1;const Ue=Ie.length,Xe=le.toLowerCase();let it=0,ft=-1;for(;it<Ue;){const tt=Xe.indexOf(Ie[it],ft+1);if(tt<0)return!1;ft=tt,it++}return!0}e.fuzzyContains=se;function pe(le,Ie=!1){return le?(Ie&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=le.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?le:(le[Ue-1]==="\r"&&Ue--,le.substr(0,Ue))}e.getNLines=je;function Ke(le){const Ie=90-65+1;return le=le%(2*Ie),le<Ie?String.fromCharCode(97+le):String.fromCharCode(65+le-Ie)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,Ie){return le===0?Ie!==5&&Ie!==7:le===2&&Ie===3?!1:le===4||le===2||le===3||Ie===4||Ie===2||Ie===3?!0:!(le===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(le===11||le===9)&&(Ie===9||Ie===10)||(le===12||le===10)&&Ie===10||Ie===5||Ie===13||Ie===7||le===1||le===13&&Ie===14||le===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let it=1;for(;it<=Xe;)if(Ie<Ue[3*it])it=2*it;else if(Ie>Ue[3*it+1])it=2*it+1;else return Ue[3*it+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,Ie){if(le===0)return 0;const Ue=ie(le,Ie);if(Ue!==void 0)return Ue;const Xe=M(Ie,le);return le-=Ee(Xe),le}e.getLeftDeleteOffset=J;function ie(le,Ie){let Ue=M(Ie,le);for(le-=Ee(Ue);Qe(Ue)||Ue===65039||Ue===8419;){if(le===0)return;Ue=M(Ie,le),le-=Ee(Ue)}if(!!Be(Ue)){if(le>=0){const Xe=M(Ie,le);Xe===8205&&(le-=Ee(Xe))}return le}}function Ee(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(fe[48],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return D(P,0)}e.hash=L;function D(P,b){switch(typeof P){case"object":return P===null?S(349,b):Array.isArray(P)?_(P,b):C(P,b);case"string":return k(P,b);case"boolean":return A(P,b);case"number":return S(P,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=D;function S(P,b){return(b<<5)-b+P|0}e.numberHash=S;function A(P,b){return S(P?433:863,b)}function k(P,b){b=S(149417,b);for(let s=0,o=P.length;s<o;s++)b=S(P.charCodeAt(s),b);return b}e.stringHash=k;function _(P,b){return b=S(104579,b),P.reduce((s,o)=>D(o,s),b)}function C(P,b){return b=S(181387,b),Object.keys(P).sort().reduce((s,o)=>(s=k(o,s),D(P[o],s)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=i;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(P,b,s=32){const o=s-b,v=~((1<<o)-1);return(P<<b|(v&P)>>>o)>>>0}function p(P,b=0,s=P.byteLength,o=0){for(let v=0;v<s;v++)P[b+v]=o}function h(P,b,s="0"){for(;P.length<b;)P=s+P;return P}function w(P,b=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(s=>s.toString(16).padStart(2,"0")).join(""):h((P>>>0).toString(16),b/4)}e.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const s=b.length;if(s===0)return;const o=this._buff;let v=this._buffLen,n=this._leftoverHighSurrogate,f,r;for(n!==0?(f=n,r=-1,n=0):(f=b.charCodeAt(0),r=0);;){let t=f;if(g.isHighSurrogate(f))if(r+1<s){const d=b.charCodeAt(r+1);g.isLowSurrogate(d)?(r++,t=g.computeCodePoint(f,d)):t=65533}else{n=f;break}else g.isLowSurrogate(f)&&(t=65533);if(v=this._push(o,v,t),r++,r<s)f=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=n}_push(b,s,o){return o<128?b[s++]=o:o<2048?(b[s++]=192|(o&1984)>>>6,b[s++]=128|(o&63)>>>0):o<65536?(b[s++]=224|(o&61440)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0):(b[s++]=240|(o&1835008)>>>18,b[s++]=128|(o&258048)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=y._bigBlock32,s=this._buffDV;for(let c=0;c<64;c+=4)b.setUint32(c,s.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)b.setUint32(c,a(b.getUint32(c-12,!1)^b.getUint32(c-32,!1)^b.getUint32(c-56,!1)^b.getUint32(c-64,!1),1),!1);let o=this._h0,v=this._h1,n=this._h2,f=this._h3,r=this._h4,t,d,l;for(let c=0;c<80;c++)c<20?(t=v&n|~v&f,d=1518500249):c<40?(t=v^n^f,d=1859775393):c<60?(t=v&n|v&f|n&f,d=2400959708):(t=v^n^f,d=3395469782),l=a(o,5)+t+r+d+b.getUint32(c*4,!1)&4294967295,r=f,f=n,n=a(v,30),v=o,o=l;this._h0=this._h0+o&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,15,9]),function(Y,e,g,L){"use strict";var D,S,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(r,t,d){let l=r.get(t);return l===void 0&&(l=d,r.set(t,l)),l}e.getOrSet=k;function _(r){const t=[];return r.forEach((d,l)=>{t.push(`${l} => ${d}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=_;function C(r){const t=[];return r.forEach(d=>{t.push(d)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const d=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return d-l}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class a{constructor(t=!0,d=!0){this._splitOnBackslash=t,this._caseSensitive=d}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new h(t))}static forPaths(){return new P(new a)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,d){if(d){const l=d.slice(0);(0,g.shuffle)(l);for(let c of l)this.set(c,t)}else{const l=t.slice(0);(0,g.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(t,d){const l=this._iter.reset(t);let c;this._root||(this._root=new w,this._root.segment=l.value());const m=[];for(c=this._root;;){const E=l.cmp(c.segment);if(E>0)c.left||(c.left=new w,c.left.segment=l.value()),m.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new w,c.right.segment=l.value()),m.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new w,c.mid.segment=l.value()),m.push([0,c]),c=c.mid;else break}const u=c.value;c.value=d,c.key=t;for(let E=m.length-1;E>=0;E--){const T=m[E][1];T.updateHeight();const R=T.balanceFactor();if(R<-1||R>1){const B=m[E][0],N=m[E+1][0];if(B===1&&N===1)m[E][1]=T.rotateLeft();else if(B===-1&&N===-1)m[E][1]=T.rotateRight();else if(B===1&&N===-1)T.right=m[E+1][1]=m[E+1][1].rotateRight(),m[E][1]=T.rotateLeft();else if(B===-1&&N===1)T.left=m[E+1][1]=m[E+1][1].rotateLeft(),m[E][1]=T.rotateRight();else throw new Error;if(E>0)switch(m[E-1][0]){case-1:m[E-1][1].left=m[E][1];break;case 1:m[E-1][1].right=m[E][1];break;case 0:m[E-1][1].mid=m[E][1];break}else this._root=m[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const d=this._iter.reset(t);let l=this._root;for(;l;){const c=d.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(d.hasNext())d.next(),l=l.mid;else break}return l}has(t){const d=this._getNode(t);return!(d?.value===void 0&&d?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,d){const l=this._iter.reset(t),c=[];let m=this._root;for(;m;){const u=l.cmp(m.segment);if(u>0)c.push([-1,m]),m=m.left;else if(u<0)c.push([1,m]),m=m.right;else if(l.hasNext())l.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this._min(m.right),{key:E,value:T,segment:R}=u;this._delete(u.key,!1),m.key=E,m.value=T,m.segment=R}else{const u=m.left??m.right;if(c.length>0){const[E,T]=c[c.length-1];switch(E){case-1:T.left=u;break;case 0:T.mid=u;break;case 1:T.right=u;break}}else this._root=u}for(let u=c.length-1;u>=0;u--){const E=c[u][1];E.updateHeight();const T=E.balanceFactor();if(T>1?(E.right.balanceFactor()>=0||(E.right=c[u+1][1]=c[u+1][1].rotateRight()),c[u][1]=E.rotateLeft()):T<-1&&(E.left.balanceFactor()<=0||(E.left=c[u+1][1]=c[u+1][1].rotateLeft()),c[u][1]=E.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const d=this._iter.reset(t);let l=this._root,c;for(;l;){const m=d.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(d.hasNext())d.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(t){const d=this._iter.reset(t);let l=this._root;for(;l;){const c=d.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(d.hasNext())d.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[d,l]of this)t(l,d)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=d=>{if(!d)return!0;const l=d.balanceFactor();return l<-1||l>1?!1:t(d.left)&&t(d.right)};return t(this._root)}}e.TernarySearchTree=P;class b{constructor(t,d){this.uri=t,this.value=d}}class s{constructor(t,d){this[D]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=d??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,d){return this.map.set(this.toKey(t),new b(t,d)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,d){typeof d!="undefined"&&(t=t.bind(d));for(let[l,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=r=>r.toString();var o;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class v{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,d=0){const l=this._map.get(t);if(!!l)return d!==0&&this.touch(l,d),l.value}set(t,d,l=0){let c=this._map.get(t);if(c)c.value=d,l!==0&&this.touch(c,l);else{switch(c={key:t,value:d,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const d=this._map.get(t);if(!!d)return this._map.delete(t),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,d){const l=this._state;let c=this._head;for(;c;){if(d?t.bind(d)(c.value,c.key,this):t(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,d=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.key,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}values(){const t=this,d=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.value,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}entries(){const t=this,d=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:[l.key,l.value],done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return c}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let d=this._head,l=this.size;for(;d&&l>t;)this._map.delete(d.key),d=d.next,l--;this._head=d,this._size=l,d&&(d.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const d=t.next,l=t.previous;if(!d||!l)throw new Error("Invalid list");d.previous=l,l.next=d}t.next=void 0,t.previous=void 0,this._state++}touch(t,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(t===this._head)return;const l=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(d===2){if(t===this._tail)return;const l=t.next,c=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((d,l)=>{t.push([l,d])}),t}fromJSON(t){this.clear();for(const[d,l]of t)this.set(d,l)}}e.LinkedMap=v;class n extends v{constructor(t,d=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,d=2){return super.get(t,d)}peek(t){return super.get(t,0)}set(t,d){return super.set(t,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class f{constructor(t){A.set(this,void 0),st(this,A,t,"f")}get size(){return Ne(this,A,"f").size}forEach(t,d){Ne(this,A,"f").forEach(t,d)}get(t){return Ne(this,A,"f").get(t)}has(t){return Ne(this,A,"f").has(t)}entries(){return Ne(this,A,"f").entries()}keys(){return Ne(this,A,"f").keys()}values(){return Ne(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Ne(this,A,"f").entries()}}e.ReadonlyMapView=f}),define(fe[98],me([0,1,24,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(se,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](se,pe);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Z,se,pe){if(!pe||pe.length<se.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,se):Me=pe.indexOf(se)===0,Me?se.length>0?[{start:0,end:se.length}]:[]:null}function A(Z,se){const pe=se.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=A;function k(Z,se){return _(Z.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=k;function _(Z,se,pe,Me){if(pe===Z.length)return[];if(Me===se.length)return null;if(Z[pe]===se[Me]){let je=null;return(je=_(Z,se,pe+1,Me+1))?P({start:Me,end:Me+1},je):null}return _(Z,se,pe,Me+1)}function C(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function I(Z){return 48<=Z&&Z<=57}function a(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function h(Z){return a(Z)||p.has(Z)}function w(Z,se){return Z===se||h(Z)&&h(se)}function y(Z){return C(Z)||i(Z)||I(Z)}function P(Z,se){return se.length===0?se=[Z]:Z.end===se[0].start?se[0].start=Z.start:se.unshift(Z),se}function b(Z,se){for(let pe=se;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||I(Me)||pe>0&&!y(Z.charCodeAt(pe-1)))return pe}return Z.length}function s(Z,se,pe,Me){if(pe===Z.length)return[];if(Me===se.length)return null;if(Z[pe]!==se[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=s(Z,se,pe+1,Me+1);!je&&(Ke=b(se,Ke))<se.length;)je=s(Z,se,pe+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function o(Z){let se=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),i(Ke)&&se++,C(Ke)&&pe++,y(Ke)&&Me++,I(Ke)&&je++;const Ze=se/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function v(Z){const{upperPercent:se,lowerPercent:pe}=Z;return pe===0&&se>.6}function n(Z){const{upperPercent:se,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&se<.8&&Me>.6&&je<.2}function f(Z){let se=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&se++,C(Me)&&pe++,a(Me)&&je++;return(se===0||pe===0)&&je===0?Z.length<=30:se<=5}function r(Z,se){if(!se||(se=se.trim(),se.length===0)||!f(Z)||se.length>60)return null;const pe=o(se);if(!n(pe)){if(!v(pe))return null;se=se.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<se.length&&(Me=s(Z,se,0,je))===null;)je=b(se,je+1);return Me}e.matchesCamelCase=r;function t(Z,se,pe=!1){if(!se||se.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),se=se.toLowerCase();je<se.length&&(Me=d(Z,se,0,je,pe))===null;)je=l(se,je+1);return Me}e.matchesWords=t;function d(Z,se,pe,Me,je){if(pe===Z.length)return[];if(Me===se.length)return null;if(w(Z.charCodeAt(pe),se.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=d(Z,se,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=l(se,Ze))<se.length;)Ke=d(Z,se,pe+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function l(Z,se){for(let pe=se;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const c=D(e.matchesPrefix,r,A),m=D(e.matchesPrefix,r,k),u=new g.LRUCache(1e4);function E(Z,se,pe=!1){if(typeof Z!="string"||typeof se!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(se);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,se):c(Z,se)}e.matchesFuzzy=E;function T(Z,se){const pe=Be(Z,Z.toLowerCase(),0,se,se.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=T;function R(Z,se,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,se,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const se=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=se[se.length-1];Ke&&Ke.end===je?Ke.end=je+1:se.push({start:je,end:je+1})}return se}e.createMatches=B;const N=128;function F(){const Z=[],se=[];for(let pe=0;pe<=N;pe++)se[pe]=0;for(let pe=0;pe<=N;pe++)Z.push(se.slice(0));return Z}function $(Z){const se=[];for(let pe=0;pe<=Z;pe++)se[pe]=0;return se}const M=$(2*N),z=$(2*N),U=F(),x=F(),j=F(),O=!1;function H(Z,se,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${se[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function W(Z,se,pe,Me){Z=Z.substr(se),pe=pe.substr(Me),console.log(H(x,Z,Z.length,pe,pe.length)),console.log(H(j,Z,Z.length,pe,pe.length)),console.log(H(U,Z,Z.length,pe,pe.length))}function X(Z,se){if(se<0||se>=Z.length)return!1;const pe=Z.codePointAt(se);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function K(Z,se){if(se<0||se>=Z.length)return!1;switch(Z.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function de(Z,se,pe){return se[Z]!==pe[Z]}function _e(Z,se,pe,Me,je,Ke,Ze=!1){for(;se<pe&&je<Ke;)Z[se]===Me[je]&&(Ze&&(M[se]=je),se+=1),je+=1;return se===pe}e.isPatternInWord=_e;var Ce;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Pe;(function(Z){Z.Default=[-100,0];function se(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=se})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,se,pe,Me,je,Ke,Ze){const rt=Z.length>N?N:Z.length,ct=Me.length>N?N:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!_e(se,pe,rt,je,Ke,ct,!0))return;$e(rt,ct,pe,Ke,se,je);let ye=1,at=1,J=pe,ie=Ke;const Ee=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ue=M[J],Xe=z[J],it=J+1<rt?z[J+1]:ct;for(at=Ue-Ke+1,ie=Ue;ie<it;at++,ie++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ie<=Xe&&(ft=He(Z,se,J,pe,Me,je,ie,ct,Ke,U[ye-1][at-1]===0,Ee));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+x[ye-1][at-1]);const Re=ie>Ue,De=Re?x[ye][at-1]+(U[ye][at-1]>0?-5:0):0,Ae=ie>Ue+1&&U[ye][at-1]>0,oe=Ae?x[ye][at-2]+(U[ye][at-2]>0?-5:0):0;if(Ae&&(!Re||oe>=De)&&(!tt||oe>=ut))x[ye][at]=oe,j[ye][at]=3,U[ye][at]=0;else if(Re&&(!tt||De>=ut))x[ye][at]=De,j[ye][at]=2,U[ye][at]=0;else if(tt)x[ye][at]=ut,j[ye][at]=1,U[ye][at]=U[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&W(Z,pe,Me,Ke),!Ee[0]&&!Ze)return;ye--,at--;const Qe=[x[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ue=at;do{const Xe=j[ye][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&se[pe+ye-1]===je[Ke+at-1]&&!de(Ue+Ke-1,Me,je)&&et+1>U[ye][Ue]&&(Ue=at),Ue===at?et++:et=1,le||(le=Ue),ye--,at=Ue-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const Ie=le-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function $e(Z,se,pe,Me,je,Ke){let Ze=Z-1,rt=se-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(z[Ze]=rt,Ze--),rt--}function He(Z,se,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(se[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ie=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ie=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||K(Ke,Ze-1))&&(J=5,ie=!0),J>1&&pe===Me&&(at[0]=!0),ie||(ie=de(Ze,je,Ke)||X(Ke,Ze-1)||K(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=ie?3:5):ye?J+=ie?2:0:J+=ie?0:1,Ze+1===rt&&(J-=ie?3:5),J}function G(Z,se,pe,Me,je,Ke,Ze){return te(Z,se,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,se,pe,Me,je,Ke,Ze){return te(Z,se,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function te(Z,se,pe,Me,je,Ke,Ze,rt){let ct=Be(Z,se,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const ie=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ie&&(ie[0]-=3,(!ct||ie[0]>ct[0])&&(ct=ie))}}}return ct}function ce(Z,se){if(se+1>=Z.length)return;const pe=Z[se],Me=Z[se+1];if(pe!==Me)return Z.slice(0,se)+Me+pe+Z.slice(se+2)}}),define(fe[142],me([0,1,47,98,9]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function k(w){return w.replace(A,(y,P)=>P?y:`\\${y}`)}e.escapeIcons=k;const _=new RegExp(`\\\\${S.source}`,"g");function C(w){return w.replace(_,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function I(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(y,P,b,s)=>b?y:P||s||"")}e.stripIcons=I;function a(w){const y=w.indexOf(e.iconStartMarker);return y===-1?{text:w}:p(w,y)}e.parseLabelWithIcons=a;function p(w,y){const P=[];let b="";function s(l){if(l){b+=l;for(const c of l)P.push(n)}}let o=-1,v="",n=0,f,r,t=y;const d=w.length;for(s(w.substr(0,y));t<d;)f=w[t],r=w[t+1],f===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=t,s(v),v=e.iconStartMarker,t++):f===")"&&o!==-1?(n+=t-o+1,o=-1,v=""):o!==-1?/^[a-z0-9\-~]$/i.test(f)?v+=f:(s(v),o=-1,v=""):s(f),t++;return s(v),{text:b,iconOffsets:P}}function h(w,y,P=!1){const{text:b,iconOffsets:s}=y;if(!s||s.length===0)return(0,L.matchesFuzzy)(w,b,P);const o=(0,D.ltrim)(b," "),v=b.length-o.length,n=(0,L.matchesFuzzy)(w,o,P);if(n)for(const f of n){const r=s[f.start+v]+v;f.start+=r,f.end+=r}return n}e.matchesFuzzyIconAware=h}),define(fe[99],me([0,1,18,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",h=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(p,h=0){return this.value+=C(this.supportThemeIcons?(0,L.escapeIcons)(p):p).replace(/([ \t]+)/g,(w,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,h){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=S;function A(a){return k(a)?!a.value:Array.isArray(a)?a.every(A):!0}e.isEmptyMarkdownString=A;function k(a){return a instanceof S?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(a,p){return a===p?!0:!a||!p?!1:a.value===p.value&&a.isTrusted===p.isTrusted&&a.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=_;function C(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function i(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(a){const p=[],h=a.split("|").map(y=>y.trim());a=h[0];const w=h[1];if(w){const y=/height=(\d+)/.exec(w),P=/width=(\d+)/.exec(w),b=y?y[1]:"",s=P?P[1]:"",o=isFinite(parseInt(s)),v=isFinite(parseInt(b));o&&p.push(`width="${s}"`),v&&p.push(`height="${b}"`)}return{href:a,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[80],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function D(C){return _(C,"NFC",L)}e.normalizeNFC=D;const S=new g.LRUCache(1e4);function A(C){return _(C,"NFD",S)}e.normalizeNFD=A;const k=/[^\u0000-\u0080]/;function _(C,i,I){if(!C)return C;const a=I.get(C);if(a)return a;let p;return k.test(C)?p=C.normalize(i):p=C,I.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(i){return A(i).replace(C,"")}}()}),define(fe[49],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const S="error",A="warning",k="warn",_="info",C="ignore";function i(a){return a?g.equalsIgnoreCase(S,a)?D.Error:g.equalsIgnoreCase(A,a)||g.equalsIgnoreCase(k,a)?D.Warning:g.equalsIgnoreCase(_,a)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function I(a){switch(a){case D.Error:return S;case D.Warning:return A;case D.Info:return _;default:return C}}D.toString=I}(L||(L={})),e.default=L}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function L(m){return typeof m=="string"}e.isString=L;function D(m){return Array.isArray(m)&&m.every(u=>L(u))}e.isStringArray=D;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=k;function _(m){return m===!0||m===!1}e.isBoolean=_;function C(m){return typeof m=="undefined"}e.isUndefined=C;function i(m){return!I(m)}e.isDefined=i;function I(m){return C(m)||m===null}e.isUndefinedOrNull=I;function a(m,u){if(!m)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=a;function p(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function h(...m){const u=[];for(let E=0;E<m.length;E++){const T=m[E];if(I(T))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(T)}return u}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function y(m){if(!S(m))return!1;for(let u in m)if(w.call(m,u))return!1;return!0}e.isEmptyObject=y;function P(m){return typeof m=="function"}e.isFunction=P;function b(...m){return m.length>0&&m.every(P)}e.areFunctions=b;function s(m,u){const E=Math.min(m.length,u.length);for(let T=0;T<E;T++)o(m[T],u[T])}e.validateConstraints=s;function o(m,u){if(L(u)){if(typeof m!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(P(u)){try{if(m instanceof u)return}catch{}if(!I(m)&&m.constructor===u||u.length===1&&u.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function v(m){let u=[],E=Object.getPrototypeOf(m);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=v;function n(m){const u=[];for(const E of v(m))typeof m[E]=="function"&&u.push(E);return u}e.getAllMethodNames=n;function f(m,u){const E=R=>function(){const B=Array.prototype.slice.call(arguments,0);return u(R,B)};let T={};for(const R of m)T[R]=E(R);return T}e.createProxyObject=f;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function t(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=t;function d(m){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${m}->${String(E)}`)}})}}}e.NotImplementedProxy=d;function l(m,u="Unreachable"){throw new Error(u)}e.assertNever=l;function c(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=c}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function k(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=k;function _(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function C(r,t=g.posix.sep){if(!r)return"";const d=r.length,l=r.charCodeAt(0);if(A(l)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let m=3;const u=m;for(;m<d&&!A(r.charCodeAt(m));m++);if(u!==m&&!A(r.charCodeAt(m+1))){for(m+=1;m<d;m++)if(A(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,t)}}return t}else if(P(l)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<d;c++)if(A(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=C;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let d=2;const l=d;for(;d<r.length&&(t=r.charCodeAt(d),t!==92);d++);return!(l===d||(t=r.charCodeAt(d+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=L.isWindows){const d=t?I:a;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||t&&p.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,t,d){const l=r===t;return!d||l?l:!r||!t?!1:(0,D.equalsIgnoreCase)(r,t)}e.isEqual=w;function y(r,t,d,l=g.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(d){if(!(0,D.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let m=t.length;return t.charAt(t.length-1)===l&&m--,r.charAt(m)===l}return t.charAt(t.length-1)!==l&&(t+=l),r.indexOf(t)===0}e.isEqualOrParent=y;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function b(r,t){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(t,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,D.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,D.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function s(r){const t=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:o(t)&&(r.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=s;function o(r){return L.isWindows?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function v(r){return o(r)?r[0]:void 0}e.getDriveLetter=v;function n(r,t,d){return t.length>r.length?-1:r===t?0:(d&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function f(r){const t=r.split(":");let d,l,c;if(t.forEach(m=>{const u=Number(m);(0,S.isNumber)(u)?l===void 0?l=u:c===void 0&&(c=u):d=d?[d,m].join(":"):m}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=f}),define(fe[25],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const y=Array.isArray(w)?[]:{};return Object.keys(w).forEach(P=>{w[P]&&typeof w[P]=="object"?y[P]=L(w[P]):y[P]=w[P]}),y}e.deepClone=L;function D(w){if(!w||typeof w!="object")return w;const y=[w];for(;y.length>0;){const P=y.shift();Object.freeze(P);for(const b in P)if(S.call(P,b)){const s=P[b];typeof s=="object"&&!Object.isFrozen(s)&&y.push(s)}}return w}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function A(w,y){return k(w,y,new Set)}e.cloneAndChange=A;function k(w,y,P){if((0,g.isUndefinedOrNull)(w))return w;const b=y(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const s=[];for(const o of w)s.push(k(o,y,P));return s}if((0,g.isObject)(w)){if(P.has(w))throw new Error("Cannot clone recursive data-structure");P.add(w);const s={};for(let o in w)S.call(w,o)&&(s[o]=k(w[o],y,P));return P.delete(w),s}return w}function _(w,y,P=!0){return(0,g.isObject)(w)?((0,g.isObject)(y)&&Object.keys(y).forEach(b=>{b in w?P&&((0,g.isObject)(w[b])&&(0,g.isObject)(y[b])?_(w[b],y[b],P):w[b]=y[b]):w[b]=y[b]}),w):y}e.mixin=_;function C(w,y){if(w===y)return!0;if(w==null||y===null||y===void 0||typeof w!=typeof y||typeof w!="object"||Array.isArray(w)!==Array.isArray(y))return!1;let P,b;if(Array.isArray(w)){if(w.length!==y.length)return!1;for(P=0;P<w.length;P++)if(!C(w[P],y[P]))return!1}else{const s=[];for(b in w)s.push(b);s.sort();const o=[];for(b in y)o.push(b);if(o.sort(),!C(s,o))return!1;for(P=0;P<s.length;P++)if(!C(w[s[P]],y[s[P]]))return!1}return!0}e.equals=C;function i(w){const y=new Set;return JSON.stringify(w,(P,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(y.has(b))return"[Circular]";y.add(b)}return b})}e.safeStringify=i;function I(w,y,P){const b=y(w);return typeof b=="undefined"?P:b}e.getOrDefault=I;function a(w,y){const P=Object.create(null);return!w||!y||Object.keys(y).forEach(s=>{const o=w[s],v=y[s];C(o,v)||(P[s]=v)}),P}e.distinct=a;function p(w,y){const P=y.toLowerCase(),b=Object.keys(w).find(s=>s.toLowerCase()===P);return b?w[b]:w[y]}e.getCaseInsensitive=p;function h(w,y){const P=Object.create(null);for(const b of Object.keys(w))y(b,w[b])&&(P[b]=w[b]);return P}e.filter=h}),define(fe[100],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(S){return S<0?0:S>255?255:S|0}e.toUint8=L;function D(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=D}),define(fe[2],me([0,1,8,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,A=/^\/\//;function k(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(r,t){return!r&&!t?"file":r}function C(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,d,l,c,m,u=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=_(t,u),this.authority=d||i,this.path=C(this.scheme,l||i),this.query=c||i,this.fragment=m||i,k(this,u))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:d,authority:l,path:c,query:m,fragment:u}=t;return d===void 0?d=this.scheme:d===null&&(d=i),l===void 0?l=this.authority:l===null&&(l=i),c===void 0?c=this.path:c===null&&(c=i),m===void 0?m=this.query:m===null&&(m=i),u===void 0?u=this.fragment:u===null&&(u=i),d===this.scheme&&l===this.authority&&c===this.path&&m===this.query&&u===this.fragment?this:new w(d,l,c,m,u)}static parse(t,d=!1){const l=a.exec(t);return l?new w(l[2]||i,f(l[4]||i),f(l[5]||i),f(l[7]||i),f(l[9]||i),d):new w(i,i,i,i,i)}static file(t){let d=i;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const l=t.indexOf(I,2);l===-1?(d=t.substring(2),t=I):(d=t.substring(2,l),t=t.substring(l)||I)}return new w("file",d,t,i,i)}static from(t){const d=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(d,!0),d}static joinPath(t,...d){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&t.scheme==="file"?l=p.file(g.win32.join(s(t,!0),...d)).path:l=g.posix.join(t.path,...d),t.with({path:l})}toString(t=!1){return o(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const d=new w(t);return d._formatted=t.external,d._fsPath=t._sep===h?t.fsPath:null,d}}else return t}}e.URI=p;const h=L.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(r,t){let d,l=-1;for(let c=0;c<r.length;c++){const m=r.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)l!==-1&&(d+=encodeURIComponent(r.substring(l,c)),l=-1),d!==void 0&&(d+=r.charAt(c));else{d===void 0&&(d=r.substr(0,c));const u=y[m];u!==void 0?(l!==-1&&(d+=encodeURIComponent(r.substring(l,c)),l=-1),d+=u):l===-1&&(l=c)}}return l!==-1&&(d+=encodeURIComponent(r.substring(l))),d!==void 0?d:r}function b(r){let t;for(let d=0;d<r.length;d++){const l=r.charCodeAt(d);l===35||l===63?(t===void 0&&(t=r.substr(0,d)),t+=y[l]):t!==void 0&&(t+=r[d])}return t!==void 0?t:r}function s(r,t){let d;return r.authority&&r.path.length>1&&r.scheme==="file"?d=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?d=r.path.substr(1):d=r.path[1].toLowerCase()+r.path.substr(2):d=r.path,L.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=s;function o(r,t){const d=t?b:P;let l="",{scheme:c,authority:m,path:u,query:E,fragment:T}=r;if(c&&(l+=c,l+=":"),(m||c==="file")&&(l+=I,l+=I),m){let R=m.indexOf("@");if(R!==-1){const B=m.substr(0,R);m=m.substr(R+1),R=B.indexOf(":"),R===-1?l+=d(B,!1):(l+=d(B.substr(0,R),!1),l+=":",l+=d(B.substr(R+1),!1)),l+="@"}m=m.toLowerCase(),R=m.indexOf(":"),R===-1?l+=d(m,!1):(l+=d(m.substr(0,R),!1),l+=m.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}l+=d(u,!0)}return E&&(l+="?",l+=d(E,!1)),T&&(l+="#",l+=t?T:P(T,!1)),l}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(r){return r.match(n)?r.replace(n,t=>v(t)):r}}),define(fe[62],me([0,1,22,9,2]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,_)}e.stringify=S;function A(i){let I=JSON.parse(i);return I=C(I),I}e.parse=A;var k;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function _(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function C(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let a=0;a<i.length;++a)i[a]=C(i[a],I+1);else for(const a in i)Object.hasOwnProperty.call(i,a)&&(i[a]=C(i[a],I+1))}return i}e.revive=C}),define(fe[10],me([0,1,11,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,i){this._hosts[_]=C,this._ports[_]=i}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],a=this._connectionTokens[C];let p=`path=${encodeURIComponent(_.path)}`;return typeof a=="string"&&(p+=`&tkn=${encodeURIComponent(a)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class A{asBrowserUri(_,C){const i=this.toUri(_,C);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${D.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(_,C){const i=this.toUri(_,C);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(_,C){return L.URI.isUri(_)?_:L.URI.parse(C.toUrl(_))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(p){return(0,k.uriToFsPath)(p,!0)}e.originalFSPath=_;class C{constructor(h){this._ignorePathCasing=h}compare(h,w,y=!1){return h===w?0:(0,A.compare)(this.getComparisonKey(h,y),this.getComparisonKey(w,y))}isEqual(h,w,y=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,y)===this.getComparisonKey(w,y)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,y=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return g.isEqualOrParent(_(h),_(w),this._ignorePathCasing(h))&&h.query===w.query&&(y||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(y||h.fragment===w.fragment)}return!1}joinPath(h,...w){return k.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(D.dirname(_(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(D.normalize(_(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const b=D.relative(_(h),_(w));return S.isWindows?g.toSlashes(b):b}let y=h.path||"/",P=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const s=Math.min(y.length,P.length);b<s&&!(y.charCodeAt(b)!==P.charCodeAt(b)&&y.charAt(b).toLowerCase()!==P.charAt(b).toLowerCase());b++);y=P.substr(0,b)+y.substr(b)}return D.posix.relative(y,P)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const y=k.URI.file(D.resolve(_(h),w));return h.with({authority:y.authority,path:y.path})}return w=g.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,A.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===L.Schemas.file){const y=_(h);return y.length>g.getRoot(y).length&&y[y.length-1]===w}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let y=!1;if(h.scheme===L.Schemas.file){const P=_(h);y=P!==void 0&&P.length===g.getRoot(P).length&&P[P.length-1]===w}else{w="/";const P=h.path;y=P.length===1&&P.charCodeAt(P.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===L.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,h){const w=[];for(let y=0;y<p.length;y++){const P=h(p[y]);p.some((b,s)=>s===y?!1:(0,e.isEqualOrParent)(P,h(b)))||w.push(p[y])}return w}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,v]=s.split(":");o&&v&&y.set(o,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&y.set(p.META_DATA_MIME,b),y}p.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function a(p,h,w){if(h){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:w,authority:h,path:y})}return p.with({scheme:w})}e.toLocalResource=a}),define(fe[16],me([0,1,21,18,3,6,23]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(U){return!!U&&typeof U.then=="function"}e.isThenable=k;function _(U){const x=new g.CancellationTokenSource,j=U(x.token),O=new Promise((H,W)=>{const X=x.token.onCancellationRequested(()=>{X.dispose(),x.dispose(),W((0,L.canceled)())});Promise.resolve(j).then(K=>{X.dispose(),x.dispose(),H(K)},K=>{X.dispose(),x.dispose(),W(K)})});return new class{cancel(){x.cancel()}then(H,W){return O.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return O.finally(H)}}}e.createCancelablePromise=_;function C(U,x,j){return Promise.race([U,new Promise(O=>x.onCancellationRequested(()=>O(j)))])}e.raceCancellation=C;async function i(U){let x=-1;const j=U.map((H,W)=>H.then(X=>(x=W,X))),O=await Promise.race(j);return U.forEach((H,W)=>{W!==x&&H.cancel()}),O}e.raceCancellablePromises=i;function I(U,x,j){let O;const H=setTimeout(()=>{O?.(void 0),j?.()},x);return Promise.race([U.finally(()=>clearTimeout(H)),new Promise(W=>O=W)])}e.raceTimeout=I;function a(U){return new Promise((x,j)=>{const O=U();k(O)?O.then(x,j):x(O)})}e.asPromise=a;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(j,j).then(O)})}return new Promise((j,O)=>{this.queuedPromise.then(j,O)})}return this.activePromise=x(),new Promise((j,O)=>{this.activePromise.then(H=>{this.activePromise=null,j(H)},H=>{this.activePromise=null,O(H)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(x,j){const H=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(x)===H&&this.promiseMap.delete(x)});return this.promiseMap.set(x,H),H}}e.SequencerByKey=w;class y{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,j=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,H)=>{this.doResolve=O,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class P{constructor(x){this.delayer=new y(x),this.throttler=new p}trigger(x,j){return this.delayer.trigger(()=>this.throttler.queue(x),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,j)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class s extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function o(U,x){return x?new Promise((j,O)=>{const H=setTimeout(()=>{W.dispose(),j()},U),W=x.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),O((0,L.canceled)())})}):_(j=>o(U,j))}e.timeout=o;function v(U,x=0){const j=setTimeout(U,x);return(0,S.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=v;function n(U){const x=[];let j=0;const O=U.length;function H(){return j<O?U[j++]():null}function W(X){X!=null&&x.push(X);const K=H();return K?K.then(W):Promise.resolve(x)}return Promise.resolve(null).then(W)}e.sequence=n;function f(U,x=O=>!!O,j=null){let O=0;const H=U.length,W=()=>{if(O>=H)return Promise.resolve(j);const X=U[O++];return Promise.resolve(X()).then(de=>x(de)?Promise.resolve(de):W())};return W()}e.first=f;function r(U,x=O=>!!O,j=null){if(U.length===0)return Promise.resolve(j);let O=U.length;const H=()=>{O=-1;for(const W of U)W.cancel?.()};return new Promise((W,X)=>{for(const K of U)K.then(de=>{--O>=0&&x(de)?(H(),W(de)):O===0&&W(j)}).catch(de=>{--O>=0&&(H(),X(de))})})}e.firstParallel=r;class t{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((j,O)=>{this.outstandingPromises.push({factory:x,c:j,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const j=x.factory();j.then(x.c,x.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class d extends t{constructor(){super(1)}}e.Queue=d;class l{constructor(){this.queues=new Map}queueFor(x,j=A.extUri){const O=j.getComparisonKey(x);let H=this.queues.get(O);return H||(H=new d,D.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(O)}),this.queues.set(O,H)),H}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor(x,j){this._token=-1,typeof x=="function"&&typeof j=="number"&&this.setIfNotSet(x,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},j)}setIfNotSet(x,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},j))}}e.TimeoutTimer=c;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setInterval(()=>{x()},j)}}e.IntervalTimer=m;class u{constructor(x,j){this.timeoutToken=-1,this.runner=x,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(x,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class T extends u{constructor(x,j){super(x,j);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class R extends S.Disposable{constructor(x,j,O,H){super();this.maxWorkChunkSize=x,this.maxPendingWork=j,this.throttleDelay=O,this.handler=H,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const x=setTimeout(()=>{const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0,clearTimeout(x))}}}:e.runWhenIdle=(U,x)=>{const j=requestIdleCallback(U,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(j))}}}}();class B{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function N(U,x,j){let O;for(let H=0;H<j;H++)try{return await U()}catch(W){O=W,await o(x)}throw O}e.retry=N;class F{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,j,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:j},j.then(()=>this.donePending(x),()=>this.donePending(x)),j}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let j,O;const H=new Promise((W,X)=>{j=W,O=X});this._next={run:x,promise:H,promiseResolve:j,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,j)=>{this.completeCallback=x,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(j=>{this.completeCallback(x),this.resolved=!0,j()})}error(x){return new Promise(j=>{this.errorCallback(x),this.rejected=!0,j()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=M;var z;(function(U){async function x(O){let H;const W=await Promise.all(O.map(X=>X.then(K=>K,K=>{H||(H=K)})));if(typeof H!="undefined")throw H;return W}U.settled=x;function j(O){return new Promise(async(H,W)=>{try{await O(H,W)}catch(X){W(X)}})}U.withAsyncBody=j})(z=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,16,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new g.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),S=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,E,T=!1){const R=u||"",B=E||"",N=D.value.collator.compare(R,B);return D.value.collatorIsNumeric&&N===0&&R!==B?R<B?-1:1:N}e.compareFileNames=k;function _(u,E){const T=S.value.collator;return u=u||"",E=E||"",v(T,u,E)}e.compareFileNamesDefault=_;function C(u,E){const T=S.value.collator;return u=u||"",E=E||"",t(u,E)||v(T,u,E)}e.compareFileNamesUpper=C;function i(u,E){const T=S.value.collator;return u=u||"",E=E||"",r(u,E)||v(T,u,E)}e.compareFileNamesLower=i;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function a(u,E,T=!1){T||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[R,B]=s(u),[N,F]=s(E);return R!==N?R<N?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=a;function p(u,E){const[T,R]=s(u),[B,N]=s(E);let F=D.value.collator.compare(R,N);if(F===0){if(D.value.collatorIsNumeric&&R!==N)return R<N?-1:1;if(F=D.value.collator.compare(T,B),D.value.collatorIsNumeric&&F===0&&T!==B)return T<B?-1:1}return F}e.compareFileExtensions=p;function h(u,E){u=u||"",E=E||"";const T=o(u),R=o(E),B=S.value.collator,N=A.value.collator;return v(N,T,R)||v(B,u,E)}e.compareFileExtensionsDefault=h;function w(u,E){u=u||"",E=E||"";const T=o(u),R=o(E),B=S.value.collator,N=A.value.collator;return v(N,T,R)||t(u,E)||v(B,u,E)}e.compareFileExtensionsUpper=w;function y(u,E){u=u||"",E=E||"";const T=o(u),R=o(E),B=S.value.collator,N=A.value.collator;return v(N,T,R)||r(u,E)||v(B,u,E)}e.compareFileExtensionsLower=y;function P(u,E){u=u||"",E=E||"";const T=o(u).toLowerCase(),R=o(E).toLowerCase();return T!==R?T<R?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=P;const b=/^(.*?)(\.([^.]*))?$/;function s(u,E=!1){const T=u?b.exec(u):[];let R=[T&&T[1]||"",T&&T[3]||""];return E&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function o(u){const E=u?b.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function v(u,E,T){let R=u.compare(E,T);return R!==0?R:E.length!==T.length?E.length<T.length?-1:1:0}function n(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function f(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function r(u,E){return n(u)&&f(E)?-1:f(u)&&n(E)?1:0}function t(u,E){return f(u)&&n(E)?-1:n(u)&&f(E)?1:0}function d(u,E,T=!1){return T||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function l(u,E,T=!1){const R=u.split(L.sep),B=E.split(L.sep),N=R.length-1,F=B.length-1;let $,M;for(let z=0;;z++){if($=N===z,M=F===z,$&&M)return k(R[z],B[z],T);if($)return-1;if(M)return 1;const U=d(R[z],B[z],T);if(U!==0)return U}}e.comparePaths=l;function c(u,E,T){const R=u.toLowerCase(),B=E.toLowerCase(),N=m(u,E,T);if(N)return N;const F=R.endsWith(T),$=B.endsWith(T);if(F!==$)return F?-1:1;const M=k(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=c;function m(u,E,T){const R=u.toLowerCase(),B=E.toLowerCase(),N=R.startsWith(T),F=B.startsWith(T);if(N!==F)return N?-1:1;if(N&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=m}),define(fe[102],me([0,1,101,98,48,8,11,9]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,C=[_,[]];function i(U,x,j,O){if(!U||!x)return C;const H=U.length,W=x.length;if(H<W)return C;const X=U.toLowerCase();return I(x,j,W,U,X,H,O)}e.scoreFuzzy=i;function I(U,x,j,O,H,W,X){const K=[],de=[];for(let Be=0;Be<j;Be++){const $e=Be*W,He=$e-W,G=Be>0,ee=U[Be],te=x[Be];for(let ce=0;ce<W;ce++){const Z=ce>0,se=$e+ce,pe=se-1,Me=He+ce-1,je=Z?K[pe]:0,Ke=G&&Z?K[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=a(ee,te,O,H,ce,Ze),rt&&Ke+rt>=je&&(X||G||H.startsWith(x,ce))?(de[se]=Ze+1,K[se]=Ke+rt):(de[se]=_,K[se]=je)}}const _e=[];let Ce=j-1,Pe=W-1;for(;Ce>=0&&Pe>=0;){const Be=Ce*W+Pe;de[Be]===_||(_e.push(Pe),Ce--),Pe--}return[K[j*W-1],_e.reverse()]}function a(U,x,j,O,H,W){let X=0;if(!p(x,O[H]))return X;if(X+=1,W>0&&(X+=W*5),U===j[H]&&(X+=1),H===0)X+=8;else{const K=h(j.charCodeAt(H-1));K?X+=K:(0,L.isUpper)(j.charCodeAt(H))&&W===0&&(X+=2)}return X}function p(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function h(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function y(U,x,j=0,O=0){const H=x;return H.values&&H.values.length>1?P(U,H.values,j,O):b(U,x,j,O)}e.scoreFuzzy2=y;function P(U,x,j,O){let H=0;const W=[];for(const X of x){const[K,de]=b(U,X,j,O);if(typeof K!="number")return w;H+=K,W.push(...de)}return[H,m(W)]}function b(U,x,j,O){const H=(0,L.fuzzyScore)(x.original,x.originalLowercase,j,U,U.toLowerCase(),O,!0);return H?[H[0],(0,L.createMatches)(H)]:w}const s=Object.freeze({score:0}),o=1<<18,v=1<<17,n=1<<16;function f(U,x,j,O){const H=O.values?O.values:[O];return(0,D.hash)({[O.normalized]:{values:H.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:x,allowNonContiguousMatches:j}})}function r(U,x,j,O,H){if(!U||!x.normalized)return s;const W=O.getItemLabel(U);if(!W)return s;const X=O.getItemDescription(U),K=f(W,X,j,x),de=H[K];if(de)return de;const _e=t(W,X,O.getItemPath(U),x,j);return H[K]=_e,_e}e.scoreItemFuzzy=r;function t(U,x,j,O,H){const W=!j||!O.containsPathSeparator;return j&&(A.isLinux?O.pathNormalized===j:(0,k.equalsIgnoreCase)(O.pathNormalized,j))?{score:o,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?d(U,x,j,O.values,W,H):l(U,x,j,O,W,H)}function d(U,x,j,O,H,W){let X=0;const K=[],de=[];for(const _e of O){const{score:Ce,labelMatch:Pe,descriptionMatch:Be}=l(U,x,j,_e,H,W);if(Ce===_)return s;X+=Ce,Pe&&K.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:m(K),descriptionMatch:m(de)}}function l(U,x,j,O,H,W){if(H||!x){const[X,K]=i(U,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,U);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/U.length*100)):_e=n,{score:_e+X,labelMatch:de||c(K)}}}if(x){let X=x;j&&(X=`${x}${S.sep}`);const K=X.length,de=`${X}${U}`,[_e,Ce]=i(de,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(_e){const Pe=c(Ce),Be=[],$e=[];return Pe.forEach(He=>{He.start<K&&He.end>K?(Be.push({start:0,end:He.end-K}),$e.push({start:He.start,end:K})):He.start>=K?Be.push({start:He.start-K,end:He.end-K}):$e.push(He)}),{score:_e,labelMatch:Be,descriptionMatch:$e}}}return s}function c(U){const x=[];if(!U)return x;let j;for(const O of U)j&&j.end===O?j.end+=1:(j={start:O,end:O+1},x.push(j));return x}function m(U){const x=U.sort((H,W)=>H.start-W.start),j=[];let O;for(const H of x)!O||!u(O,H)?(O=H,j.push(H)):(O.start=Math.min(O.start,H.start),O.end=Math.max(O.end,H.end));return j}function u(U,x){return!(U.end<x.start||x.end<U.start)}function E(U,x,j,O,H,W){const X=r(U,j,O,H,W),K=r(x,j,O,H,W),de=X.score,_e=K.score;if((de===o||_e===o)&&de!==_e)return de===o?-1:1;if(de>n||_e>n){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=R(X.labelMatch,K.labelMatch);if(ee!==0)return ee}const He=H.getItemLabel(U)||"",G=H.getItemLabel(x)||"";if(He.length!==G.length)return He.length-G.length}if(de!==_e)return de>_e?-1:1;const Ce=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(Ce&&!Pe)return-1;if(Pe&&!Ce)return 1;const Be=T(U,X,H),$e=T(x,K,H);return Be&&$e&&Be!==$e?$e>Be?-1:1:B(U,x,j,H)}e.compareItemsByFuzzyScore=E;function T(U,x,j){let O=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const W=j.getItemDescription(U);W&&(H+=W.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-O}function R(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const j=U[0].start,H=U[U.length-1].end-j,W=x[0].start,K=x[x.length-1].end-W;return H===K?0:K<H?1:-1}function B(U,x,j,O){const H=O.getItemLabel(U)||"",W=O.getItemLabel(x)||"",X=O.getItemDescription(U),K=O.getItemDescription(x),de=H.length+(X?X.length:0),_e=W.length+(K?K.length:0);if(de!==_e)return de-_e;const Ce=O.getItemPath(U),Pe=O.getItemPath(x);return Ce&&Pe&&Ce.length!==Pe.length?Ce.length-Pe.length:H!==W?(0,g.compareAnything)(H,W,j.normalized):X&&K&&X!==K?(0,g.compareAnything)(X,K,j.normalized):Ce&&Pe&&Ce!==Pe?(0,g.compareAnything)(Ce,Pe,j.normalized):0}function N(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function $(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:j,normalized:O,normalizedLowercase:H}=M(U),W=j.indexOf(S.sep)>=0,X=N(U);let K;const de=U.split(F);if(de.length>1)for(const _e of de){const Ce=N(_e),{pathNormalized:Pe,normalized:Be,normalizedLowercase:$e}=M(_e);Be&&(K||(K=[]),K.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:$e,expectContiguousMatch:Ce}))}return{original:U,originalLowercase:x,pathNormalized:j,normalized:O,normalizedLowercase:H,values:K,containsPathSeparator:W,expectContiguousMatch:X}}e.prepareQuery=$;function M(U){let x;A.isWindows?x=U.replace(/\//g,S.sep):x=U.replace(/\\/g,S.sep);const j=(0,k.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:j,normalizedLowercase:j.toLowerCase()}}function z(U){return Array.isArray(U)?$(U.map(x=>x.original).join(F)):$(U.original)}e.pieceToQuery=z}),define(fe[30],me([0,1,16,29,24,8,9]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const _="**",C="/",i="[/\\\\]",I="[^/\\\\]",a=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(O,H){if(!O)return[];const W=[];let X=!1,K=!1,de="";for(const _e of O){switch(_e){case H:if(!X&&!K){W.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":K=!0;break;case"]":K=!1;break}de+=_e}return de&&W.push(de),W}e.splitGlobAware=h;function w(O){if(!O)return"";let H="";const W=h(O,C);if(W.every(X=>X===_))H=".*";else{let X=!1;W.forEach((K,de)=>{if(K===_){X||(H+=p(2),X=!0);return}let _e=!1,Ce="",Pe=!1,Be="";for(const $e of K){if($e!=="}"&&_e){Ce+=$e;continue}if(Pe&&($e!=="]"||!Be)){let He;$e==="-"?He=$e:($e==="^"||$e==="!")&&!Be?He="^":$e===C?He="":He=A.escapeRegExpCharacters($e),Be+=He;continue}switch($e){case"{":_e=!0;continue;case"[":Pe=!0;continue;case"}":H+=`(?:${h(Ce,",").map(ee=>w(ee)).join("|")})`,_e=!1,Ce="";break;case"]":H+="["+Be+"]",Pe=!1,Be="";break;case"?":H+=I;continue;case"*":H+=p(1);continue;default:H+=A.escapeRegExpCharacters($e)}}de<W.length-1&&(W[de+1]!==_||de+2<W.length)&&(H+=i),X=!1})}return H}const y=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.LRUCache(1e4),f=function(){return!1},r=function(){return null};function t(O,H){if(!O)return r;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const X=`${W}_${!!H.trimForExclusions}`;let K=n.get(X);if(K)return d(K,O);let de;if(y.test(W)){const _e=W.substr(4);K=function(Ce,Pe){return typeof Ce=="string"&&Ce.endsWith(_e)?W:null}}else(de=P.exec(l(W,H)))?K=c(de[1],W):(H.trimForExclusions?s:b).test(W)?K=m(W,H):(de=o.exec(l(W,H)))?K=u(de[1].substr(1),W,!0):(de=v.exec(l(W,H)))?K=u(de[1],W,!1):K=E(W);return n.set(X,K),d(K,O)}function d(O,H){return typeof H=="string"?O:function(W,X){return L.isEqualOrParent(W,H.base)?O(S.relative(H.base,W),X):null}}function l(O,H){return H.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,H){const W=`/${O}`,X=`\\${O}`,K=function(_e,Ce){return typeof _e!="string"?null:Ce?Ce===O?H:null:_e===O||_e.endsWith(W)||_e.endsWith(X)?H:null},de=[O];return K.basenames=de,K.patterns=[H],K.allBasenames=de,K}function m(O,H){const W=j(O.slice(1,-1).split(",").map(Ce=>t(Ce,H)).filter(Ce=>Ce!==r),O),X=W.length;if(!X)return r;if(X===1)return W[0];const K=function(Ce,Pe){for(let Be=0,$e=W.length;Be<$e;Be++)if(W[Be](Ce,Pe))return O;return null},de=W.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=W.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function u(O,H,W){const X=S.sep===S.posix.sep,K=X?O:O.replace(a,S.sep),de=S.sep+K,_e=S.posix.sep+O,Ce=W?function(Pe,Be){return typeof Pe=="string"&&(Pe===K||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(_e)))?H:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===K||!X&&Pe===O)?H:null};return Ce.allPaths=[(W?"*/":"./")+O],Ce}function E(O){try{const H=new RegExp(`^${w(O)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?O:null}}catch(H){return r}}function T(O,H,W){return!O||typeof H!="string"?!1:R(O)(H,void 0,W)}e.match=T;function R(O,H={}){if(!O)return f;if(typeof O=="string"||$(O)){const W=t(O,H);if(W===r)return f;const X=function(K,de){return!!W(K,de)};return W.allBasenames&&(X.allBasenames=W.allBasenames),W.allPaths&&(X.allPaths=W.allPaths),X}return U(O,H)}e.parse=R;function B(O){if(!O)return;let H;return W=>(H||(H=(O()||Promise.resolve([])).then(X=>X?F(X):{})),H.then(X=>!!X[W]))}e.hasSiblingPromiseFn=B;function N(O){if(!O)return;let H;return W=>{if(!H){const X=O();H=X?F(X):{}}return!!H[W]}}e.hasSiblingFn=N;function F(O){const H={};for(const W of O)H[W]=!0;return H}function $(O){const H=O;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function z(O){return O.allPaths||[]}e.getPathTerms=z;function U(O,H){const W=j(Object.getOwnPropertyNames(O).map(Ce=>x(Ce,O[Ce],H)).filter(Ce=>Ce!==r)),X=W.length;if(!X)return r;if(!W.some(Ce=>!!Ce.requiresSiblings)){if(X===1)return W[0];const Ce=function($e,He){for(let G=0,ee=W.length;G<ee;G++){const te=W[G]($e,He);if(te)return te}return null},Pe=W.find($e=>!!$e.allBasenames);Pe&&(Ce.allBasenames=Pe.allBasenames);const Be=W.reduce(($e,He)=>He.allPaths?$e.concat(He.allPaths):$e,[]);return Be.length&&(Ce.allPaths=Be),Ce}const K=function(Ce,Pe,Be){let $e;for(let He=0,G=W.length;He<G;He++){const ee=W[He];ee.requiresSiblings&&Be&&(Pe||(Pe=S.basename(Ce)),$e||($e=Pe.substr(0,Pe.length-S.extname(Ce).length)));const te=ee(Ce,Pe,$e,Be);if(te)return te}return null},de=W.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=W.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function x(O,H,W){if(H===!1)return r;const X=t(O,W);if(X===r)return r;if(typeof H=="boolean")return X;if(H){const K=H.when;if(typeof K=="string"){const de=(_e,Ce,Pe,Be)=>{if(!Be||!X(_e,Ce))return null;const $e=K.replace("$(basename)",Pe),He=Be($e);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function j(O,H){const W=O.filter(Ce=>!!Ce.basenames);if(W.length<2)return O;const X=W.reduce((Ce,Pe)=>{const Be=Pe.basenames;return Be?Ce.concat(Be):Ce},[]);let K;if(H){K=[];for(let Ce=0,Pe=X.length;Ce<Pe;Ce++)K.push(H)}else K=W.reduce((Ce,Pe)=>{const Be=Pe.patterns;return Be?Ce.concat(Be):Ce},[]);const de=function(Ce,Pe){if(typeof Ce!="string")return null;if(!Pe){let $e;for($e=Ce.length;$e>0;$e--){const He=Ce.charCodeAt($e-1);if(He===47||He===92)break}Pe=Ce.substr($e)}const Be=X.indexOf(Pe);return Be!==-1?K[Be]:null};de.basenames=X,de.patterns=K,de.allBasenames=X;const _e=O.filter(Ce=>!Ce.basenames);return _e.push(de),_e}}),define(fe[81],me([0,1,29,10,8,11,23,9,2]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(t,d,l){if(typeof t=="string"&&(t=_.URI.file(t)),l){const m=l.getWorkspaceFolder(t);if(m){const u=l.getWorkspace().folders.length>1;let E;if((0,A.isEqual)(m.uri,t)?E="":E=(0,A.relativePath)(m.uri,t),u){const T=m.name?m.name:(0,A.basename)(m.uri);E=E?T+" \u2022 "+E:T}return E}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,D.normalize)(I(t.fsPath));let c=(0,D.normalize)(t.fsPath);return!S.isWindows&&d?.userHome&&(c=p(c,d.userHome.fsPath)),c}e.getPathLabel=C;function i(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const d=(0,A.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return S.isWindows&&(0,g.isRootOrDriveLetter)(d)?I(d):d}e.getBaseLabel=i;function I(t){return(0,g.hasDriveLetter)(t)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let a=Object.create(null);function p(t,d){if(S.isWindows||!t||!d)return t;let l=a.original===d?a.normalized:void 0;return l||(l=`${(0,k.rtrim)(d,D.posix.sep)}${D.posix.sep}`,a={original:d,normalized:l}),(S.isLinux?t.startsWith(l):(0,k.startsWithIgnoreCase)(t,l))&&(t=`~/${t.substr(l.length)}`),t}e.tildify=p;function h(t,d){return t.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=h;const w="\u2026",y="\\\\",P="~";function b(t,d=D.sep){const l=new Array(t.length);let c=!1;for(let m=0;m<t.length;m++){let u=t[m];if(u===""){l[m]=`.${d}`;continue}if(!u){l[m]=u;continue}c=!0;let E="";u.indexOf(y)===0?(E=u.substr(0,u.indexOf(y)+y.length),u=u.substr(u.indexOf(y)+y.length)):u.indexOf(d)===0?(E=u.substr(0,u.indexOf(d)+d.length),u=u.substr(u.indexOf(d)+d.length)):u.indexOf(P)===0&&(E=u.substr(0,u.indexOf(P)+P.length),u=u.substr(u.indexOf(P)+P.length));const T=u.split(d);for(let R=1;c&&R<=T.length;R++)for(let B=T.length-R;c&&B>=0;B--){c=!1;let N=T.slice(B,B+R).join(d);for(let F=0;!c&&F<t.length;F++)if(F!==m&&t[F]&&t[F].indexOf(N)>-1){const $=B+R===T.length,M=B>0&&t[F].indexOf(d)>-1?d+N:N,z=t[F].endsWith(M);c=!$||z}if(!c){let F="";(T[0].endsWith(":")||E!=="")&&(B===1&&(B=0,R++,N=T[0]+d+N),B>0&&(F=T[0]+d),F=E+F),B>0&&(F=F+w+d),F=F+N,B+R<T.length&&(F=F+d+w),l[m]=F}}c&&(l[m]=u)}return l}e.shorten=b;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(t,d=Object.create(null)){const l=[];let c=!1,m="";for(const u of t)if(u==="$"||c&&u==="{")m&&l.push({value:m,type:s.TEXT}),m="",c=!0;else if(u==="}"&&c){const E=d[m];if(typeof E=="string")E.length&&l.push({value:E,type:s.VARIABLE});else if(E){const T=l[l.length-1];(!T||T.type!==s.SEPARATOR)&&l.push({value:E.label,type:s.SEPARATOR})}m="",c=!1}else m+=u;return m&&!c&&l.push({value:m,type:s.TEXT}),l.filter((u,E)=>{if(u.type===s.SEPARATOR){const T=l[E-1],R=l[E+1];return[T,R].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=o;function v(t,d){return S.isMacintosh||d?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function n(t,d){return S.isMacintosh||d?t.replace(/\(&&\w\)|&&/g,""):S.isWindows?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function f(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=f;function r(t){const d=t.indexOf("/")!==-1?D.posix:D.win32,l=d.basename(t),c=d.dirname(t);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let _=[],C=[],i=[];function I(t,d=!1){const l=a(t);_.push(l),l.userConfigured?i.push(l):C.push(l),d&&!l.userConfigured&&_.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function a(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(_=_.filter(d=>!d.userConfigured),i=[]):(_=[],C=[],i=[])}e.clearTextMimes=p;function h(t,d){let l;if(t)switch(t.scheme){case L.Schemas.file:l=t.fsPath;break;case L.Schemas.data:l=S.DataUri.parseMetaData(t).get(S.DataUri.META_DATA_LABEL);break;default:l=t.path}if(!l)return[k.unknown];l=l.toLowerCase();const c=(0,D.basename)(l),m=w(l,c,i);if(m)return[m,k.text];const u=w(l,c,C);if(u)return[u,k.text];if(d){const E=y(d);if(E)return[E,k.text]}return[k.unknown]}e.guessMimeTypes=h;function w(t,d,l){let c=null,m=null,u=null;for(let E=l.length-1;E>=0;E--){const T=l[E];if(d===T.filenameLowercase){c=T;break}if(T.filepattern&&(!m||T.filepattern.length>m.filepattern.length)){const R=T.filepatternOnPath?t:d;T.filepatternLowercase?.(R)&&(m=T)}T.extension&&(!u||T.extension.length>u.extension.length)&&d.endsWith(T.extensionLowercase)&&(u=T)}return c?c.mime:m?m.mime:u?u.mime:null}function y(t){if((0,A.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let d=_.length-1;d>=0;d--){const l=_[d];if(!l.firstline)continue;const c=t.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function P(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(t){const d=(0,D.extname)(t),l=b[d.toLowerCase()];return l!==void 0?l:v(t)}e.getMediaOrTextMime=o;function v(t){const d=(0,D.extname)(t);return s[d.toLowerCase()]}e.getMediaMime=v;function n(t){for(const d in s)if(s[d]===t)return d}e.getExtensionForMimeType=n;const f=/^(.+)\/(.+?)(;.+)?$/;function r(t,d){const l=f.exec(t);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:d?void 0:t}e.normalizeMimeType=r}),define(fe[104],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:L(g.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:L(g.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:g.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,a){if(!i||a>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const h=S(i[p],I,a+1);h!==null&&(i[p]=h)}}return null}function A(i,I){const a=S(i,I,0);return a===null?i:a}e.transformOutgoingURIs=A;function k(i,I,a,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return a?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const w=k(i[h],I,a,p+1);w!==null&&(i[h]=w)}}return null}function _(i,I){const a=k(i,I,!1,0);return a===null?i:a}e.transformIncomingURIs=_;function C(i,I){const a=k(i,I,!0,0);return a===null?i:a}e.transformAndReviveIncomingURIs=C}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(_){return g.test(_)}e.isUUID=L;const D=new Uint8Array(16),S=[];for(let _=0;_<256;_++)S.push(_.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function k(){A(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,C="";return C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C+="-",C+=S[D[_++]],C+=S[D[_++]],C+="-",C+=S[D[_++]],C+=S[D[_++]],C+="-",C+=S[D[_++]],C+=S[D[_++]],C+="-",C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C+=S[D[_++]],C}e.generateUuid=k}),define(fe[143],me([0,1,105]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const A=[],k=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(k.length<1)return A;let _=0,C,i=_;for(;i<k.length;)if(C=k.charCodeAt(i),C===13||C===10){if(A.push(k.substring(_,i)),i++,i<k.length){const I=C;C=k.charCodeAt(i),(I===13&&C===10||I===10&&C===13)&&i++}_=i}else i++;return this.remaining=_<k.length?k.substr(_):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(fe[26],me([0,1,50,82,291,16,29,80,8,11,23,2,32]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(M,z=p.UNLINK){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?y(M):w(M)}async function w(M){try{const z=(0,_.join)((0,L.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(M,z)}catch(U){return y(M)}y(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function y(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function b(M,z){return v(await(z?s(M):(0,D.promisify)(g.readdir)(M)))}async function s(M){try{return await(0,D.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],U=await b(M);for(const x of U){let j=!1,O=!1,H=!1;try{const W=await e.Promises.lstat((0,_.join)(M,x));j=W.isFile(),O=W.isDirectory(),H=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}z.push({name:x,isFile:()=>j,isDirectory:()=>O,isSymbolicLink:()=>H})}return z}function o(M){return v(g.readdirSync(M))}e.readdirSync=o;function v(M){return M.map(z=>typeof z=="string"?C.isMacintosh?(0,k.normalizeNFC)(z):z:(z.name=C.isMacintosh?(0,k.normalizeNFC)(z.name):z.name,z))}async function n(M){const z=await b(M),U=[];for(const x of z)await r.existsDirectory((0,_.join)(M,x))&&U.push(x);return U}function f(M,z=1e3){return new Promise(U=>{let x=!1;const j=setInterval(()=>{x||(x=!0,g.access(M,O=>{x=!1,O&&(clearInterval(j),U(void 0))}))},z)})}e.whenDeleted=f;var r;(function(M){async function z(j){let O;try{if(O=await e.Promises.lstat(j),!O.isSymbolicLink())return{stat:O}}catch(H){}try{return{stat:await e.Promises.stat(j),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw W}throw H}}M.stat=z;async function U(j){try{const{stat:O,symbolicLink:H}=await M.stat(j);return O.isFile()&&H?.dangling!==!0}catch(O){}return!1}M.existsFile=U;async function x(j){try{const{stat:O,symbolicLink:H}=await M.stat(j);return O.isDirectory()&&H?.dangling!==!0}catch(O){}return!1}M.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new S.ResourceQueue;function d(M,z,U){return t.queueFor(I.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const x=u(U);return new Promise((j,O)=>c(M,z,x,H=>H?O(H):j()))})}let l=!0;function c(M,z,U,x){if(!l)return g.writeFile(M,z,{mode:U.mode,flag:U.flag},x);g.open(M,U.flag,U.mode,(j,O)=>{if(j)return x(j);g.writeFile(O,z,H=>{if(H)return g.close(O,()=>x(H));g.fdatasync(O,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),l=!1),g.close(O,X=>x(X))))})})}function m(M,z,U){const x=u(U);if(!l)return g.writeFileSync(M,z,{mode:x.mode,flag:x.flag});const j=g.openSync(M,x.flag,x.mode);try{g.writeFileSync(j,z);try{g.fdatasyncSync(j)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{g.closeSync(j)}}e.writeFileSync=m;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function E(M,z){if(M===z)return;async function U(x){try{const j=await e.Promises.lstat(x);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(x,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(M,z),await U(z)}catch(x){if(M.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await T(M,z,{preserveSymlinks:!1}),await h(M,p.MOVE),await U(z);else throw x}}async function T(M,z,U){return B(M,z,{root:{source:M,target:z},options:U,handledSourcePaths:new Set})}const R=511;async function B(M,z,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:j}=await r.stat(M);if(j){if(U.options.preserveSymlinks)try{return await $(M,z,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(j.dangling)return}return x.isDirectory()?N(M,z,x.mode&R,U):F(M,z,x.mode&R)}async function N(M,z,U,x){await e.Promises.mkdir(z,{recursive:!0,mode:U});const j=await b(M);for(const O of j)await B((0,_.join)(M,O),(0,_.join)(z,O),x)}async function F(M,z,U){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,U)}async function $(M,z,U){let x=await e.Promises.readlink(M);(0,A.isEqualOrParent)(x,U.root.source,!C.isLinux)&&(x=(0,_.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,D.promisify)(g.access)}get stat(){return(0,D.promisify)(g.stat)}get lstat(){return(0,D.promisify)(g.lstat)}get utimes(){return(0,D.promisify)(g.utimes)}get read(){return(0,D.promisify)(g.read)}get readFile(){return(0,D.promisify)(g.readFile)}get write(){return(0,D.promisify)(g.write)}get appendFile(){return(0,D.promisify)(g.appendFile)}get fdatasync(){return(0,D.promisify)(g.fdatasync)}get truncate(){return(0,D.promisify)(g.truncate)}get rename(){return(0,D.promisify)(g.rename)}get copyFile(){return(0,D.promisify)(g.copyFile)}get open(){return(0,D.promisify)(g.open)}get close(){return(0,D.promisify)(g.close)}get symlink(){return(0,D.promisify)(g.symlink)}get readlink(){return(0,D.promisify)(g.readlink)}get chmod(){return(0,D.promisify)(g.chmod)}get mkdir(){return(0,D.promisify)(g.mkdir)}get unlink(){return(0,D.promisify)(g.unlink)}get rmdir(){return(0,D.promisify)(g.rmdir)}get realpath(){return(0,D.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return n}get writeFile(){return d}get rm(){return h}get move(){return E}get copy(){return T}}}),define(fe[106],me([0,1,50,8,9,26]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const I=(0,L.dirname)(i);if(i===I)return i;const a=((0,L.basename)(i)||i).toLowerCase();try{const h=(0,S.readdirSync)(I).filter(w=>w.toLowerCase()===a);if(h.length===1){const w=A(I);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(a);if(w>=0){const y=A(I);if(y)return(0,L.join)(y,h[w])}}}catch(p){}return null}e.realcaseSync=A;async function k(i){try{return await S.Promises.realpath(i)}catch(I){const a=C(i);return await S.Promises.access(a,g.constants.R_OK),a}}e.realpath=k;function _(i){try{return g.realpathSync(i)}catch(I){const a=C(i);return g.accessSync(a,g.constants.R_OK),a}}e.realpathSync=_;function C(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var D=arguments.length,S=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(Y,e,g,L);else for(var k=Y.length-1;k>=0;k--)(A=Y[k])&&(S=(D<3?A(S):D>3?A(e,g,S):A(e,g))||S);return D>3&&S&&Object.defineProperty(e,g,S),S};define(fe[107],me([0,1,15,16,22,21,60,18,3,6,62,9,12]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function y(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(P||(P={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const H=this.buffer.slice(this.pos,this.pos+O);return this.pos+=H.byteLength,H}}class s{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function v(j){const O=D.VSBuffer.alloc(4);return O.writeUInt32BE(j,0),O}function n(j){return j.read(4).readUInt32BE(0)}function f(j){const O=D.VSBuffer.alloc(1);return O.writeUInt8(j,0),O}const r={Undefined:f(o.Undefined),String:f(o.String),Buffer:f(o.Buffer),VSBuffer:f(o.VSBuffer),Array:f(o.Array),Object:f(o.Object)},t=typeof Buffer!="undefined";function d(j,O){if(typeof O=="undefined")j.write(r.Undefined);else if(typeof O=="string"){const H=D.VSBuffer.fromString(O);j.write(r.String),j.write(v(H.byteLength)),j.write(H)}else if(t&&Buffer.isBuffer(O)){const H=D.VSBuffer.wrap(O);j.write(r.Buffer),j.write(v(H.byteLength)),j.write(H)}else if(O instanceof D.VSBuffer)j.write(r.VSBuffer),j.write(v(O.byteLength)),j.write(O);else if(Array.isArray(O)){j.write(r.Array),j.write(v(O.length));for(const H of O)d(j,H)}else{const H=D.VSBuffer.fromString(JSON.stringify(O));j.write(r.Object),j.write(v(H.byteLength)),j.write(H)}}function l(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(n(j)).toString();case o.Buffer:return j.read(n(j)).buffer;case o.VSBuffer:return j.read(n(j));case o.Array:{const H=n(j),W=[];for(let X=0;X<H;X++)W.push(l(j));return W}case o.Object:return JSON.parse(j.read(n(j)).toString())}}class c{constructor(O,H,W=null,X=1e3){this.protocol=O,this.ctx=H,this.logger=W,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(O,H){this.channels.set(O,H),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const H=this.send([O.type]);this.logger&&this.logger.logOutgoing(H,0,1,y(O.type));return}case 201:case 202:case 204:case 203:{const H=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(H,O.id,1,y(O.type),O.data);return}}}send(O,H=void 0){const W=new s;return d(W,O),d(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onRawMessage(O){const H=new b(O),W=l(H),X=l(H),K=W[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(K)}: ${W[2]}.${W[3]}`,X),this.onPromise({type:K,id:W[1],channelName:W[2],name:W[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(K)}: ${W[2]}.${W[3]}`,X),this.onEventListen({type:K,id:W[1],channelName:W[2],name:W[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:W[1]})}}onPromise(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=new S.CancellationTokenSource;let X;try{X=H.call(this.ctx,O.name,O.arg,W.token)}catch(_e){X=Promise.reject(_e)}const K=O.id;X.then(_e=>{this.sendResponse({id:K,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:K,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:K,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,C.toDisposable)(()=>W.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=O.id,K=H.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:W,data:de,type:204}));this.activeRequests.set(O.id,K)}disposeActiveRequest(O){const H=this.activeRequests.get(O.id);H&&(H.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let H=this.pendingRequests.get(O.channelName);H||(H=[],this.pendingRequests.set(O.channelName,H));const W=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:O,timeoutTimer:W})}flushPendingRequests(O){const H=this.pendingRequests.get(O);if(H){for(const W of H)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,H=null){this.protocol=O,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=H}getChannel(O){const H=this;return{call(W,X,K){return H.isDisposed?Promise.reject(k.canceled()):H.requestPromise(O,W,X,K)},listen(W,X){return H.isDisposed?Promise.reject(k.canceled()):H.requestEvent(O,W,X)}}}requestPromise(O,H,W,X=S.CancellationToken.None){const K=this.lastRequestId++,_e={id:K,type:100,channelName:O,name:H,arg:W};if(X.isCancellationRequested)return Promise.reject(k.canceled());let Ce;return new Promise((Be,$e)=>{if(X.isCancellationRequested)return $e(k.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(K),Be(Z.data);break;case 202:this.handlers.delete(K);const se=new Error(Z.data.message);se.stack=Z.data.stack,se.name=Z.data.name,$e(se);break;case 203:this.handlers.delete(K),$e(Z.data);break}};this.handlers.set(K,ce),this.sendRequest(_e)};let G=null;this.state===P.Idle?He():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:K,type:101}),$e(k.canceled())},te=X.onCancellationRequested(ee);Ce=(0,C.combinedDisposable)((0,C.toDisposable)(ee),te),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(O,H,W){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:H,arg:W};let _e=null;const Ce=new _.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ce),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ce),this.sendRequest({id:X,type:103}))}}),Pe=Be=>Ce.fire(Be.data);return this.handlers.set(X,Pe),Ce.event}sendRequest(O){switch(O.type){case 100:case 102:{const H=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(H,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const H=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(H,O.id,0,h(O.type));return}}}send(O,H=void 0){const W=new s;return d(W,O),d(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onBuffer(O){const H=new b(O),W=l(H),X=l(H),K=W[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,y(K)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],0,y(K),X),this.onResponse({type:W[0],id:W[1],data:X})}}onResponse(O){if(O.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(O.id);H&&H(O)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([A.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:H,onDidClientDisconnect:W})=>{_.Event.once(H.onMessage)(K=>{const de=new b(K),_e=l(de),Ce=new c(H,_e),Pe=new u(H);this.channels.forEach(($e,He)=>Ce.registerChannel(He,$e));const Be={channelServer:Ce,channelClient:Pe,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),W(()=>{Ce.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(H=>O.push(H)),O}getChannel(O,H){const W=this;return{call(X,K,de){let _e;if((0,a.isFunction)(H)){let Pe=(0,g.getRandomElement)(W.connections.filter(H));_e=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(W.onDidAddConnection,H))}else _e=H.routeCall(W,X,K);const Ce=_e.then(Pe=>Pe.channelClient.getChannel(O));return R(Ce).call(X,K,de)},listen(X,K){if((0,a.isFunction)(H))return W.getMulticastEvent(O,H,X,K);const de=H.routeEvent(W,X,K).then(_e=>_e.channelClient.getChannel(O));return R(de).listen(X,K)}}}getMulticastEvent(O,H,W,X){const K=this;let de=new C.DisposableStore;const _e=new _.Emitter({onFirstListenerAdd:()=>{de=new C.DisposableStore;const Ce=new _.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(W,X),te=Ce.add(ee);Pe.set(He,te)},$e=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};K.connections.filter(H).forEach(Be),_.Event.filter(K.onDidAddConnection,H)(Be,void 0,de),K.onDidRemoveConnection($e,void 0,de),Ce.event(_e.fire,_e,de),de.add(Ce)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,H){this.channels.set(O,H),this._connections.forEach(W=>{W.channelServer.registerChannel(O,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class T{constructor(O,H,W=null){const X=new s;d(X,H),O.send(X.buffer),this.channelClient=new u(O,W),this.channelServer=new c(O,H,W)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,H){this.channelServer.registerChannel(O,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function R(j){return{call(O,H,W){return j.then(X=>X.call(O,H,W))},listen(O,H){const W=new _.Relay;return j.then(X=>W.input=X.listen(O,H)),W.event}}}e.getDelayedChannel=R;function B(j){let O=!1;return{call(H,W,X){return O?j.call(H,W,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>j.call(H,W,X))},listen(H,W){if(O)return j.listen(H,W);const X=new _.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=j.listen(H,W)),X.event}}}e.getNextTickChannel=B;class N{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const H of O.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=N;var F;(function(j){function O(K,de){const _e=K,Ce=de&&de.disableMarshalling,Pe=new Map;for(const Be in _e)W(Be)&&Pe.set(Be,_.Event.buffer(_e[Be],!0));return new class{listen(Be,$e,He){const G=Pe.get($e);if(G)return G;if(X($e)){const ee=_e[$e];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${$e}`)}call(Be,$e,He){const G=_e[$e];if(typeof G=="function"){if(!Ce&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return G.apply(_e,He)}throw new Error(`Method not found: ${$e}`)}}}j.fromService=O;function H(K,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ce,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return K.listen(Pe,Be)}:W(Pe)?K.listen(Pe):async function(...Be){let $e;de&&!(0,a.isUndefinedOrNull)(de.context)?$e=[de.context,...Be]:$e=Be;const He=await K.call(Pe,$e);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}j.toService=H;function W(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function X(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let O=j.toString();if(O!=="[object Object]")return O}return j}function z(j){return Array.isArray(j)?j.map(M):M(j)}function U(j,O,H,W,X,K,de){de=z(de);const _e=$[X],Ce=_e[W%_e.length];let Pe=[`%c[${j}]%c[${String(O).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(K)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=U;class x{constructor(O,H){this._outgoingPrefix=O,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,H,W,X,K){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,H,W,X,K)}logIncoming(O,H,W,X,K){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,H,W,X,K)}}e.IPCLogger=x}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function i(){return C||(C=g.VSBuffer.alloc(0)),C}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,d){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const u=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=t),u}if(this._chunks[0].byteLength>t){const u=this._chunks[0].slice(0,t);return d&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),u}let l=g.VSBuffer.alloc(t),c=0,m=0;for(;t>0;){const u=this._chunks[m];if(u.byteLength>t){const E=u.slice(0,t);l.set(E,c),c+=t,d&&(this._chunks[m]=u.slice(t),this._totalLength-=t),t-=t}else l.set(u,c),c+=u.byteLength,d?(this._chunks.shift(),this._totalLength-=u.byteLength):m++,t-=u.byteLength}return l}}e.ChunkStream=I;var a;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(a||(a={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,d,l,c){this.type=t,this.id=d,this.ack=l,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5);else{const l=this._state.messageType,c=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,c,m,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=g.VSBuffer.alloc(13);d.writeUInt8(t.type,0),d.writeUInt32BE(t.id,1),d.writeUInt32BE(t.ack,5),d.writeUInt32BE(t.data.byteLength,9),this._writeSoon(d,t.data)}_bufferAdd(t,d){const l=this._totalLength===0;return this._data.push(t,d),this._totalLength+=t.byteLength+d.byteLength,l}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,d){this._bufferAdd(t,d)&&S.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=P;class b extends k.IPCClient{constructor(t,d,l=null){super(t,d,l);this.protocol=t}static fromSocket(t,d){return new b(new P(t),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class o{constructor(t){this.data=t,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],d=0,l=this._first;for(;l;)t[d++]=l.data,l=l.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const d=new o(t);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let d=0;d<n._HISTORY_LENGTH;d++)this.lastRuns[d]=t-1e3*d;setInterval(()=>{for(let d=n._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),d=(1+n._HISTORY_LENGTH)*1e3;let l=0;for(let c=0;c<n._HISTORY_LENGTH;c++)t-this.lastRuns[c]<=d&&l++;return 1-l/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class f{constructor(t,d=null,l=n.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),d&&this._socketReader.acceptChunk(d),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const d=new h(4,0,0,i());this._socketWriter.write(d),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,d){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let d=0,l=t.length;d<l;d++)this._socketWriter.write(t[d]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const d=this._outgoingUnackMsg.toArray();for(let l=0,c=d.length;l<c;l++)this._socketWriter.write(d[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,d,this._incomingAckId,t);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(t){const d=new h(2,0,0,t);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),d=Date.now()-t.writtenTime;if(d>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-d,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=f}),define(fe[109],me([0,1,100]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let _=(0,g.toUint8)(k);this._defaultValue=_,this._asciiMap=L._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=k;return _}set(k,_){let C=(0,g.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=C:this._map.set(k,C)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(D||(D={}));class S{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=S}),define(fe[144],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(k){super(0);for(let _=0,C=k.length;_<C;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function S(A){let k={};return _=>(k.hasOwnProperty(_)||(k[_]=A(_)),k[_])}e.getMapForWordSeparators=S(A=>new D(A))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,S){this.lineNumber=D,this.column=S}with(D=this.lineNumber,S=this.column){return D===this.lineNumber&&S===this.column?this:new g(D,S)}delta(D=0,S=0){return this.with(this.lineNumber+D,this.column+S)}equals(D){return g.equals(this,D)}static equals(D,S){return!D&&!S?!0:!!D&&!!S&&D.lineNumber===S.lineNumber&&D.column===S.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<S.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<=S.column}static compare(D,S){let A=D.lineNumber|0,k=S.lineNumber|0;if(A===k){let _=D.column|0,C=S.column|0;return _-C}return A-k}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(fe[43],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(S,A,k,_){S>k||S===k&&A>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=S,this.endColumn=A):(this.startLineNumber=S,this.startColumn=A,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return L.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return L.containsPosition(this,S)}static containsPosition(S,A){return!(A.lineNumber<S.startLineNumber||A.lineNumber>S.endLineNumber||A.lineNumber===S.startLineNumber&&A.column<S.startColumn||A.lineNumber===S.endLineNumber&&A.column>S.endColumn)}containsRange(S){return L.containsRange(this,S)}static containsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>S.endColumn)}strictContainsRange(S){return L.strictContainsRange(this,S)}static strictContainsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<=S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>=S.endColumn)}plusRange(S){return L.plusRange(this,S)}static plusRange(S,A){let k,_,C,i;return A.startLineNumber<S.startLineNumber?(k=A.startLineNumber,_=A.startColumn):A.startLineNumber===S.startLineNumber?(k=A.startLineNumber,_=Math.min(A.startColumn,S.startColumn)):(k=S.startLineNumber,_=S.startColumn),A.endLineNumber>S.endLineNumber?(C=A.endLineNumber,i=A.endColumn):A.endLineNumber===S.endLineNumber?(C=A.endLineNumber,i=Math.max(A.endColumn,S.endColumn)):(C=S.endLineNumber,i=S.endColumn),new L(k,_,C,i)}intersectRanges(S){return L.intersectRanges(this,S)}static intersectRanges(S,A){let k=S.startLineNumber,_=S.startColumn,C=S.endLineNumber,i=S.endColumn,I=A.startLineNumber,a=A.startColumn,p=A.endLineNumber,h=A.endColumn;return k<I?(k=I,_=a):k===I&&(_=Math.max(_,a)),C>p?(C=p,i=h):C===p&&(i=Math.min(i,h)),k>C||k===C&&_>i?null:new L(k,_,C,i)}equalsRange(S){return L.equalsRange(this,S)}static equalsRange(S,A){return!!S&&!!A&&S.startLineNumber===A.startLineNumber&&S.startColumn===A.startColumn&&S.endLineNumber===A.endLineNumber&&S.endColumn===A.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(S){return new g.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(S){return new g.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,A){return new L(this.startLineNumber,this.startColumn,S,A)}setStartPosition(S,A){return new L(S,A,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(S){return new L(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,A=S){return new L(S.lineNumber,S.column,A.lineNumber,A.column)}static lift(S){return S?new L(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn)}static areIntersecting(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,A){if(S&&A){const C=S.startLineNumber|0,i=A.startLineNumber|0;if(C===i){const I=S.startColumn|0,a=A.startColumn|0;if(I===a){const p=S.endLineNumber|0,h=A.endLineNumber|0;if(p===h){const w=S.endColumn|0,y=A.endColumn|0;return w-y}return p-h}return I-a}return C-i}return(S?1:0)-(A?1:0)}static compareRangesUsingEnds(S,A){return S.endLineNumber===A.endLineNumber?S.endColumn===A.endColumn?S.startLineNumber===A.startLineNumber?S.startColumn-A.startColumn:S.startLineNumber-A.startLineNumber:S.endColumn-A.endColumn:S.endLineNumber-A.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,43]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class S extends L.Range{constructor(k,_,C,i){super(k,_,C,i);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return S.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,k,_):new S(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new S(k,_,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new S(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new S(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new S(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new S(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let C=0,i=k.length;C<i;C++)if(!this.selectionsEqual(k[C],_[C]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,C,i,I){return I===0?new S(k,_,C,i):new S(C,i,k,_)}}e.Selection=S}),define(fe[110],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class C{constructor(s,o){this._findMatchBrand=void 0,this.range=s,this.matches=o}}e.FindMatch=C;var i;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(s,o,v){this.visibleColumn=s,this.className=o,this.horizontalLine=v}}e.IndentGuide=a;class p{constructor(s,o){this.top=s,this.endColumn=o}}e.IndentGuideHorizontalLine=p;var h;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class y{constructor(s,o,v,n,f,r){this.identifier=s,this.range=o,this.text=v,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=f,this._isTracked=r}}e.ValidAnnotatedEditOperation=y;class P{constructor(s,o,v){this.reverseEdits=s,this.changes=o,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=P}),define(fe[146],me([0,1,9,144,51,43,110]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(s,o,v,n){this.searchString=s,this.isRegex=o,this.matchCase=v,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=C(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(n){return null}if(!o)return null;let v=!this.isRegex&&!s;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(o,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=_;function C(b){if(!b||b.length===0)return!1;for(let s=0,o=b.length;s<o;s++)if(b.charCodeAt(s)===92){if(s++,s>=o)break;const n=b.charCodeAt(s);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(s,o,v){this.regex=s,this.wordSeparators=o,this.simpleSearch=v}}e.SearchData=i;function I(b,s,o){if(!o)return new A.FindMatch(b,null);let v=[];for(let n=0,f=s.length;n<f;n++)v[n]=s[n];return new A.FindMatch(b,v)}e.createFindMatch=I;class a{constructor(s){let o=[],v=0;for(let n=0,f=s.length;n<f;n++)s.charCodeAt(n)===10&&(o[v++]=n);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let v=0,n=o.length-1;if(n===-1||s<=o[0])return 0;for(;v<n;){const f=v+((n-v)/2>>0);o[f]>=s?n=f-1:o[f+1]>=s?(v=f,n=f):v=f+1}return v+1}}class p{static findMatches(s,o,v,n,f){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,v,new P(r.wordSeparators,r.regex),n,f):this._doFindMatchesLineByLine(s,v,r,n,f):[]}static _getMultilineMatchRange(s,o,v,n,f,r){let t,d=0;n?(d=n.findLineFeedCountBeforeOffset(f),t=o+f+d):t=o+f;let l;if(n){let E=n.findLineFeedCountBeforeOffset(f+r.length)-d;l=t+r.length+E}else l=t+r.length;const c=s.getPositionAt(t),m=s.getPositionAt(l);return new S.Range(c.lineNumber,c.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(s,o,v,n,f){const r=s.getOffsetAt(o.getStartPosition()),t=s.getValueInRange(o,1),d=s.getEOL()===`\r
`?new a(t):null,l=[];let c=0,m;for(v.reset(0);m=v.next(t);)if(l[c++]=I(this._getMultilineMatchRange(s,r,t,d,m.index,m[0]),m,n),c>=f)return l;return l}static _doFindMatchesLineByLine(s,o,v,n,f){const r=[];let t=0;if(o.startLineNumber===o.endLineNumber){const l=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return t=this._findMatchesInLine(v,l,o.startLineNumber,o.startColumn-1,t,r,n,f),r}const d=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);t=this._findMatchesInLine(v,d,o.startLineNumber,o.startColumn-1,t,r,n,f);for(let l=o.startLineNumber+1;l<o.endLineNumber&&t<f;l++)t=this._findMatchesInLine(v,s.getLineContent(l),l,0,t,r,n,f);if(t<f){const l=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);t=this._findMatchesInLine(v,l,o.endLineNumber,0,t,r,n,f)}return r}static _findMatchesInLine(s,o,v,n,f,r,t,d){const l=s.wordSeparators;if(!t&&s.simpleSearch){const u=s.simpleSearch,E=u.length,T=o.length;let R=-E;for(;(R=o.indexOf(u,R+E))!==-1;)if((!l||y(l,o,T,R,E))&&(r[f++]=new A.FindMatch(new S.Range(v,R+1+n,v,R+1+E+n),null),f>=d))return f;return f}const c=new P(s.wordSeparators,s.regex);let m;c.reset(0);do if(m=c.next(o),m&&(r[f++]=I(new S.Range(v,m.index+1+n,v,m.index+1+m[0].length+n),m,t),f>=d))return f;while(m);return f}static findNextMatch(s,o,v,n){const f=o.parseSearchRequest();if(!f)return null;const r=new P(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindNextMatchMultiline(s,v,r,n):this._doFindNextMatchLineByLine(s,v,r,n)}static _doFindNextMatchMultiline(s,o,v,n){const f=new D.Position(o.lineNumber,1),r=s.getOffsetAt(f),t=s.getLineCount(),d=s.getValueInRange(new S.Range(f.lineNumber,f.column,t,s.getLineMaxColumn(t)),1),l=s.getEOL()===`\r
`?new a(d):null;v.reset(o.column-1);let c=v.next(d);return c?I(this._getMultilineMatchRange(s,r,d,l,c.index,c[0]),c,n):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new D.Position(1,1),v,n):null}static _doFindNextMatchLineByLine(s,o,v,n){const f=s.getLineCount(),r=o.lineNumber,t=s.getLineContent(r),d=this._findFirstMatchInLine(v,t,r,o.column,n);if(d)return d;for(let l=1;l<=f;l++){const c=(r+l-1)%f,m=s.getLineContent(c+1),u=this._findFirstMatchInLine(v,m,c+1,1,n);if(u)return u}return null}static _findFirstMatchInLine(s,o,v,n,f){s.reset(n-1);const r=s.next(o);return r?I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,f):null}static findPreviousMatch(s,o,v,n){const f=o.parseSearchRequest();if(!f)return null;const r=new P(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindPreviousMatchMultiline(s,v,r,n):this._doFindPreviousMatchLineByLine(s,v,r,n)}static _doFindPreviousMatchMultiline(s,o,v,n){const f=this._doFindMatchesMultiline(s,new S.Range(1,1,o.lineNumber,o.column),v,n,10*k);if(f.length>0)return f[f.length-1];const r=s.getLineCount();return o.lineNumber!==r||o.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new D.Position(r,s.getLineMaxColumn(r)),v,n):null}static _doFindPreviousMatchLineByLine(s,o,v,n){const f=s.getLineCount(),r=o.lineNumber,t=s.getLineContent(r).substring(0,o.column-1),d=this._findLastMatchInLine(v,t,r,n);if(d)return d;for(let l=1;l<=f;l++){const c=(f+r-l-1)%f,m=s.getLineContent(c+1),u=this._findLastMatchInLine(v,m,c+1,n);if(u)return u}return null}static _findLastMatchInLine(s,o,v,n){let f=null,r;for(s.reset(0);r=s.next(o);)f=I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,n);return f}}e.TextModelSearch=p;function h(b,s,o,v,n){if(v===0)return!0;const f=s.charCodeAt(v-1);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=s.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function w(b,s,o,v,n){if(v+n===o)return!0;const f=s.charCodeAt(v+n);if(b.get(f)!==0||f===13||f===10)return!0;if(n>0){const r=s.charCodeAt(v+n-1);if(b.get(r)!==0)return!0}return!1}function y(b,s,o,v,n){return h(b,s,o,v,n)&&w(b,s,o,v,n)}e.isValidMatch=y;class P{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(v=this._searchRegex.exec(s),!v))return null;const n=v.index,f=v[0].length;if(n===this._prevMatchStartIndex&&f===this._prevMatchLength){if(f===0){g.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=f,!this._wordSeparators||y(this._wordSeparators,s,o,n,f))return v}while(v);return null}}e.Searcher=P}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)k.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function L(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let C="g";k.ignoreCase&&(C+="i"),k.multiline&&(C+="m"),k.unicode&&(C+="u"),_=new RegExp(k.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function S(k,_,C,i,I=D){if(C.length>I.maxLen){let y=k-I.maxLen/2;return y<0?y=0:i+=y,C=C.substring(y,k+I.maxLen/2),S(k,_,C,i,I)}const a=Date.now(),p=k-1-i;let h=-1,w=null;for(let y=1;!(Date.now()-a>=I.timeBudget);y++){const P=p-I.windowSize*y;_.lastIndex=Math.max(0,P);const b=A(_,C,p,h);if(!b&&w||(w=b,P<=0))break;h=P}if(w){let y={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return _.lastIndex=0,y}return null}e.getWordAtText=S;function A(k,_,C,i){let I;for(;I=k.exec(_);){const a=I.index||0;if(a<=C&&k.lastIndex>=C)return I;if(i>0&&a>i)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let _=0,C=k.notIn.length;_<C;_++)switch(k.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)S(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),S(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),S(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),S(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&S(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function S(A,k,_){A.has(k)?A.get(k).push(_):A.set(k,[_])}}),define(fe[83],me([0,1,30,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(S,A,k,_){if(Array.isArray(S)){let C=0;for(const i of S){const I=D(i,A,k,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof S=="string")return _?S==="*"?5:S===k?10:0:0;if(S){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:a}=S;if(!_&&!a)return 0;let p=0;if(I)if(I===A.scheme)p=10;else if(I==="*")p=5;else return 0;if(C)if(C===k)p=10;else if(C==="*")p=Math.max(p,5);else return 0;if(i){let h;if(typeof i=="string"?h=i:h={...i,base:(0,L.normalize)(i.base)},h===A.fsPath||(0,g.match)(h,A.fsPath))p=10;else return 0}return p}else return 0}}e.score=D}),define(fe[148],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(h,w,y){const P=new Uint8Array(h*w);for(let b=0,s=h*w;b<s;b++)P[b]=y;this._data=P,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,y){this._data[h*this.cols+w]=y}}e.Uint8Matrix=D;class S{constructor(h){let w=0,y=0;for(let b=0,s=h.length;b<s;b++){let[o,v,n]=h[b];v>w&&(w=v),o>y&&(y=o),n>y&&(y=n)}w++,y++;let P=new D(y,w,0);for(let b=0,s=h.length;b<s;b++){let[o,v,n]=h[b];P.set(o,v,n)}this._states=P,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=S;let A=null;function k(){return A===null&&(A=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var _;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function i(){if(C===null){C=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)C.set(p.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)C.set(h.charCodeAt(w),2)}return C}class I{static _createLink(h,w,y,P,b){let s=b-1;do{const o=w.charCodeAt(s);if(h.get(o)!==2)break;s--}while(s>P);if(P>0){const o=w.charCodeAt(P-1),v=w.charCodeAt(s);(o===40&&v===41||o===91&&v===93||o===123&&v===125)&&s--}return{range:{startLineNumber:y,startColumn:P+1,endLineNumber:y,endColumn:s+2},url:w.substring(P,s+1)}}static computeLinks(h,w=k()){const y=i();let P=[];for(let b=1,s=h.getLineCount();b<=s;b++){const o=h.getLineContent(b),v=o.length;let n=0,f=0,r=0,t=1,d=!1,l=!1,c=!1,m=!1;for(;n<v;){let u=!1;const E=o.charCodeAt(n);if(t===13){let T;switch(E){case 40:d=!0,T=0;break;case 41:T=d?0:1;break;case 91:c=!0,l=!0,T=0;break;case 93:c=!1,T=l?0:1;break;case 123:m=!0,T=0;break;case 125:T=m?0:1;break;case 39:T=r===34||r===96?0:1;break;case 34:T=r===39||r===96?0:1;break;case 96:T=r===39||r===34?0:1;break;case 42:T=r===42?1:0;break;case 124:T=r===124?1:0;break;case 32:T=c?0:1;break;default:T=y.get(E)}T===1&&(P.push(I._createLink(y,o,b,f,n)),u=!0)}else if(t===12){let T;E===91?(l=!0,T=0):T=y.get(E),T===1?u=!0:t=13}else t=w.nextState(t,E),t===0&&(u=!0);u&&(t=1,d=!1,l=!1,m=!1,f=n+1,r=E),n++}t===13&&P.push(I._createLink(y,o,b,f,v))}return P}}e.LinkComputer=I;function a(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=a}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,k){return this._map.set(A,k),this.fire([A]),(0,L.toDisposable)(()=>{this._map.get(A)===k&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,k){let _=null,C=!1;return this._promises.set(A,k.then(i=>{this._promises.delete(A),!(C||!i)&&(_=this.register(A,i))})),(0,L.toDisposable)(()=>{C=!0,_&&_.dispose()})}getPromise(A){const k=this.get(A);if(k)return Promise.resolve(k);const _=this._promises.get(A);return _?_.then(C=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(fe[112],me([0,1,22,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function S(I){for(let a=0,p=I.length;a<p;a+=4){const h=I[a+0],w=I[a+1],y=I[a+2],P=I[a+3];I[a+0]=P,I[a+1]=y,I[a+2]=w,I[a+3]=h}}function A(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||S(a),g.VSBuffer.wrap(a)}function k(I){const a=I.buffer;if(L.isLittleEndian()||S(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function _(I){const a=new Uint32Array(C(I));let p=0;if(a[p++]=I.id,I.type==="full")a[p++]=1,a[p++]=I.data.length,a.set(I.data,p),p+=I.data.length;else{a[p++]=2,a[p++]=I.deltas.length;for(const h of I.deltas)a[p++]=h.start,a[p++]=h.deleteCount,h.data?(a[p++]=h.data.length,a.set(h.data,p),p+=h.data.length):a[p++]=0}return A(a)}e.encodeSemanticTokensDto=_;function C(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(a+=p.data.length)}return a}function i(I){const a=k(I);let p=0;const h=a[p++];if(a[p++]===1){const b=a[p++],s=a.subarray(p,p+b);return p+=b,{id:h,type:"full",data:s}}const y=a[p++];let P=[];for(let b=0;b<y;b++){const s=a[p++],o=a[p++],v=a[p++];let n;v>0&&(n=a.subarray(p,p+v),p+=v),P[b]={start:s,deleteCount:o,data:n}}return{id:h,type:"delta",deltas:P}}e.decodeSemanticTokensDto=i}),define(fe[113],me([0,1,15,100]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,C){_=(0,L.toUint32)(_);const i=this.values,I=this.prefixSum,a=C.length;return a===0?!1:(this.values=new Uint32Array(i.length+a),this.values.set(i.subarray(0,_),0),this.values.set(i.subarray(_),_+a),this.values.set(C,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,C){return _=(0,L.toUint32)(_),C=(0,L.toUint32)(C),this.values[_]===C?!1:(this.values[_]=C,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,C){_=(0,L.toUint32)(_),C=(0,L.toUint32)(C);const i=this.values,I=this.prefixSum;if(_>=i.length)return!1;let a=i.length-_;return C>=a&&(C=a),C===0?!1:(this.values=new Uint32Array(i.length-C),this.values.set(i.subarray(0,_),0),this.values.set(i.subarray(_+C),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,L.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),_>=this.values.length&&(_=this.values.length-1);for(let i=C;i<=_;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let C=0,i=this.values.length-1,I=0,a=0,p=0;for(;C<=i;)if(I=C+(i-C)/2|0,a=this.prefixSum[I],p=a-this.values[I],_<p)i=I-1;else if(_>=a)C=I+1;else break;return new A(I,_-p)}}e.PrefixSumComputer=D;class S{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const C=this._indexBySum[_],i=C>0?this._prefixSum[C-1]:0;return new A(C,_-i)}removeValues(_,C){this._values.splice(_,C),this._invalidate(_)}insertValues(_,C){this._values=(0,g.arrayInsert)(this._values,_,C),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,C=this._values.length;_<C;_++){const i=this._values[_],I=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=I+i;for(let a=0;a<i;a++)this._indexBySum[I+a]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,C){this._values[_]!==C&&(this._values[_]=C,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=S;class A{constructor(_,C){this.index=_,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=C}}e.PrefixSumIndexOfResult=A}),define(fe[150],me([0,1,9,51,113]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(k,_,C,i){this._uri=k,this._lines=_,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new L.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let i=0;i<_;i++)C[i]=this._lines[i].length+k;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;let C=(0,g.splitLines)(_);if(C.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}C[C.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(k.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,i)}}e.MirrorTextModel=S}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,S=D*24,A=S*7,k=S*30,_=S*365;function C(I,a){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let h;return p<L?(h=p,a?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):p<D?(h=Math.floor(p/L),a?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):p<S?(h=Math.floor(p/D),a?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):p<A?(h=Math.floor(p/S),a?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):p<k?(h=Math.floor(p/A),a?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):p<_?(h=Math.floor(p/k),a?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(p/_),a?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=C;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,15,12,153]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(C,i){return i&&(C.stack||C.stacktrace)?D.localize(0,null,k(C),A(C.stack)||A(C.stacktrace)):k(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function k(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function _(C=null,i=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const I=g.coalesce(C),a=_(I[0],i);return I.length>1?D.localize(4,null,a,I.length):a}if(L.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return C.stack?S(C,i):C.message?C.message:D.localize(5,null)}e.toErrorMessage=_}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,143,26,154]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(n,f){if(k.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};f&&(r.cwd=f);const t=g.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(d=>{t.once("error",l=>{d({success:!1,error:l})}),t.once("exit",(l,c)=>{d(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(k.isLinux||k.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(d,l,c)=>{t(d?{success:!1,error:d}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function y(n){!n||(delete n.DEBUG,k.isMacintosh&&delete n.DYLD_LIBRARY_PATH,k.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function P(n=_.env){return n.comspec||"cmd.exe"}e.getWindowsShell=P;class b{constructor(f,r,t,d){if(r!==void 0&&t!==void 0&&d!==void 0)this.cmd=f,this.args=r,this.shell=t,this.options=d;else{const l=f;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(_.env).forEach(c=>{l[c]=_.env[c]}),Object.keys(this.options.env).forEach(c=>{l[c]=this.options.env[c]}),this.options.env=l}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const r=f.lastIndexOf(A.sep);return r!==-1&&(f=f.substring(r+1)),b.WellKnowCommands[f]?f:"other"}start(f){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(_.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let t,d;const l=new Promise((c,m)=>{t=c,d=m});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(m,u,E)=>{this.childProcess=null;const T=m;T&&T.killed?d({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(t,f,m,u,E)})}else{let c=null;const m=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,f,d);const E={terminated:this.terminateRequested};i.isNumber(u)&&(E.cmdCode=u),t(E)};if(this.shell&&k.isWindows){const u=S.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,T=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),E=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),T=T&&B.quoted});const N=["/s","/c"];E?T?N.push('"'+R.join(" ")+'"'):R.length>1?N.push('"'+R[0]+'" '+R.slice(1).join(" ")):N.push('"'+R[0]+'"'):N.push(R.join(" ")),c=g.spawn(P(),N,u)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(i.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",u=>{this.childProcess=null,d({terminated:this.terminateRequested,error:u})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,t,f,d,!0)))}return l})}handleClose(f,r,t,d){}ensureQuotes(f){return b.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,w(f,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!k.isWindows)return f(!1);const r=g.spawn(P(),["/s","/c"]);r.on("error",t=>f(!0)),r.on("exit",t=>f(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class s extends b{constructor(f,r,t,d){super(f,r,t,d);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,r,t,d,l){[d,l].forEach((c,m)=>{const u=new I.LineDecoder;u.write(c).forEach(R=>{r({line:R,source:m===0?0:1})});const T=u.end();T&&r({line:T,source:m===0?0:1})}),f({terminated:this.terminateRequested,error:t})}handleSpawn(f,r,t,d,l){const c=new I.LineDecoder,m=new I.LineDecoder;f.stdout.on("data",u=>{c.write(u).forEach(T=>t({line:T,source:0}))}),f.stderr.on("data",u=>{m.write(u).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(f,r,t,d){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&t({line:l,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=s;function o(n){let f=[],r=!1;const t=function(d){if(r){f.push(d);return}(!n.send(d,c=>{if(c&&console.error(c),r=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(u=>t(u))}})||k.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=o;var v;(function(n){async function f(r,t,d){if(A.isAbsolute(r))return r;if(t===void 0&&(t=_.cwd()),A.dirname(r)!=="."||(d===void 0&&i.isString(_.env.PATH)&&(d=_.env.PATH.split(A.delimiter)),d===void 0||d.length===0))return A.join(t,r);async function c(m){if(await a.Promises.exists(m)){let u;try{u=await a.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(u=await a.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(let m of d){let u;if(A.isAbsolute(m)?u=A.join(m,r):u=A.join(t,m,r),await c(u))return u;let E=u+".com";if(await c(E)||(E=u+".exe",await c(E)))return E}return A.join(t,r)}n.findExecutable=f})(v=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,155,11,111]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=k;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ie,Ee,Qe,et){this.id=ie,this.name=Ee,this.defaultValue=Qe,this.schema=et}compute(ie,Ee,Qe){return Qe}}class i{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class I{constructor(ie,Ee,Qe,et){this.id=ie,this.name=Ee,this.defaultValue=Qe,this.schema=et}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Qe){return Qe}}function a(J,ie){return typeof J=="undefined"?ie:J==="false"?!1:Boolean(J)}e.boolean=a;class p extends I{constructor(ie,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ie,Ee,Qe,et)}validate(ie){return a(ie,this.defaultValue)}}function h(J,ie,Ee,Qe){if(typeof J=="undefined")return ie;let et=parseInt(J,10);return isNaN(et)?ie:(et=Math.max(Ee,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(ie,Ee,Qe,et,le,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=le),super(ie,Ee,Qe,Ie),this.minimum=et,this.maximum=le}static clampedInt(ie,Ee,Qe,et){return h(ie,Ee,Qe,et)}validate(ie){return w.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class y extends I{constructor(ie,Ee,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(ie,Ee,Qe,le),this.validationFn=et}static clamp(ie,Ee,Qe){return ie<Ee?Ee:ie>Qe?Qe:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Qe=parseFloat(ie);return isNaN(Qe)?Ee:Qe}validate(ie){return this.validationFn(y.float(ie,this.defaultValue))}}class P extends I{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ie,Ee,Qe,et)}validate(ie){return P.string(ie,this.defaultValue)}}function b(J,ie,Ee){return typeof J!="string"||Ee.indexOf(J)===-1?ie:J}e.stringSet=b;class s extends I{constructor(ie,Ee,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(ie,Ee,Qe,le),this._allowedValues=et}validate(ie){return b(ie,this.defaultValue,this._allowedValues)}}class o extends C{constructor(ie,Ee,Qe,et,le,Ie,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=le,Ue.default=et),super(ie,Ee,Qe,Ue),this._allowedValues=le,this._convert=Ie}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Qe){return Qe===0?ie.accessibilitySupport:Qe}}class f extends C{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:a(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(J){switch(J){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(J){switch(J){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(ie,Ee,Qe){const et=["monaco-editor"];return Ee.get(33)&&et.push(Ee.get(33)),ie.extraEditorClassName&&et.push(ie.extraEditorClassName),Ee.get(65)==="default"?et.push("mouse-default"):Ee.get(65)==="copy"&&et.push("mouse-copy"),Ee.get(99)&&et.push("showUnused"),Ee.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ie,Ee,Qe){return Qe&&ie.emptySelectionClipboard}}class E extends C{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:g.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:a(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":b(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Ee.loop,this.defaultValue.loop)}}}class T extends C{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?T.OFF:ie==="true"?T.ON:ie:Boolean(ie)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class R extends i{constructor(){super(43)}compute(ie,Ee,Qe){return ie.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ie){let Ee=y.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(Ee,6,100)}compute(ie,Ee,Qe){return ie.fontInfo.fontSize}}class N extends C{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(w.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class F extends C{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{multiple:b(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??b(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??b(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??b(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??b(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??b(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends C{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:g.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),delay:w.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:a(Ee.sticky,this.defaultValue.sticky),above:a(Ee.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class z extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ie,Ee,Qe){return z.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Qe=ie.scrollBeyondLastLine?Ee-1:0,et=(ie.viewLineCount+Qe)/(ie.pixelRatio*ie.height),le=Math.floor(ie.viewLineCount/et);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(ie,Ee){const Qe=ie.outerWidth,et=ie.outerHeight,le=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=Ee.stableMinimapLayoutInput,Ue=Ie&&ie.outerHeight===Ie.outerHeight&&ie.lineHeight===Ie.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ie.pixelRatio&&ie.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ie.minimap.enabled===Ie.minimap.enabled&&ie.minimap.side===Ie.minimap.side&&ie.minimap.size===Ie.minimap.size&&ie.minimap.showSlider===Ie.minimap.showSlider&&ie.minimap.renderCharacters===Ie.minimap.renderCharacters&&ie.minimap.maxColumn===Ie.minimap.maxColumn&&ie.minimap.scale===Ie.minimap.scale&&ie.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ie.isViewportWrapping===Ie.isViewportWrapping,Xe=ie.lineHeight,it=ie.typicalHalfwidthCharacterWidth,ft=ie.scrollBeyondLastLine,tt=ie.minimap.renderCharacters;let ut=le>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Re=ie.minimap.maxColumn,De=ie.minimap.size,Ae=ie.minimap.side,oe=ie.verticalScrollbarWidth,ue=ie.viewLineCount,we=ie.remainingWidth,ve=ie.isViewportWrapping,Fe=tt?2:3;let Ge=Math.floor(le*et);const ze=Ge/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,be=1;if(De==="fill"||De==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:Et,desiredRatio:pt,minimapLineCount:vt}=z.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/vt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let Dt=!1,Ct=ut+1;if(De==="fit"){const At=Math.ceil((ue+Et)*xe);ve&&Ue&&we<=Ee.stableFitRemainingWidth?(Dt=!0,Ct=Ee.stableFitMaxMinimapScale):Dt=At>Ge}if(De==="fill"||Dt){Ye=!0;const At=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/pt))),ve&&Ue&&we<=Ee.stableFitRemainingWidth&&(Ct=Ee.stableFitMaxMinimapScale),ut=Math.min(Ct,Math.max(1,Math.floor(xe/Fe))),ut>At&&(be=Math.min(2,ut/At)),ge=ut/le/be,Ge=Math.ceil(Math.max(gt,ue+Et)*xe),ve?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=we,Ee.stableFitMaxMinimapScale=ut):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const re=Math.floor(Re*ge),Q=Math.min(re,Math.max(0,Math.floor((we-oe-2)*ge/(it+ge)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(le*Q);const Le=Se/le;Se=Math.floor(Se*be);const nt=tt?1:2,qe=Ae==="left"?0:Qe-Q-oe;return{renderMinimap:nt,minimapLeft:qe,minimapWidth:Q,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ie,Ee){const Qe=Ee.outerWidth|0,et=Ee.outerHeight|0,le=Ee.lineHeight|0,Ie=Ee.lineNumbersDigitCount|0,Ue=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,it=Ee.pixelRatio,ft=Ee.viewLineCount,tt=ie.get(121),ut=tt==="inherit"?ie.get(120):tt,Re=ut==="inherit"?ie.get(116):ut,De=ie.get(119),Ae=ie.get(2),oe=Ee.isDominatedByLongLines,ue=ie.get(49),we=ie.get(59).renderType!==0,ve=ie.get(60),Fe=ie.get(93),Ge=ie.get(64),ze=ie.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,be=ie.get(57),re=ie.get(37);let Q;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Ut=parseFloat(be.substr(0,be.length-2));Q=w.clampedInt(Ut*Ue,0,0,1e3)}else Q=w.clampedInt(be,0,0,1e3);re&&(Q+=16);let Se=0;if(we){const Ut=Math.max(Ie,ve);Se=Math.round(Ut*Xe)}let Le=0;ue&&(Le=le);let nt=0,qe=nt+Le,gt=qe+Se,Et=gt+Q;const pt=Qe-Le-Se-Q;let vt=!1,wt=!1,Dt=-1;Ae!==2&&(ut==="inherit"&&oe?(vt=!0,wt=!0):Re==="on"||Re==="bounded"?wt=!0:Re==="wordWrapColumn"&&(Dt=De));const Ct=z._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ue,pixelRatio:it,scrollBeyondLastLine:Fe,minimap:Ge,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:pt,isViewportWrapping:wt},Ee.memory||new _);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(nt+=Ct.minimapWidth,qe+=Ct.minimapWidth,gt+=Ct.minimapWidth,Et+=Ct.minimapWidth);const At=pt-Ct.minimapWidth,Nt=Math.max(1,Math.floor((At-Ye-2)/Ue)),It=lt?xe:0;return wt&&(Dt=Math.max(1,Nt),Re==="bounded"&&(Dt=Math.min(Dt,De))),{width:Qe,height:et,glyphMarginLeft:nt,glyphMarginWidth:Le,lineNumbersLeft:qe,lineNumbersWidth:Se,decorationsLeft:gt,decorationsWidth:Q,contentLeft:Et,contentWidth:At,minimap:Ct,viewportColumn:Nt,isWordWrapMinified:vt,isViewportWrapping:wt,wrappingColumn:Dt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:It,width:Ye,height:et-2*It,right:0}}}}e.EditorLayoutInfoComputer=z;class U extends C{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:g.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:a(ie.enabled,this.defaultValue.enabled)}}}class x extends C{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class j extends y{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>y.clamp(ie,0,150),{markdownDescription:g.localize(47,null)})}compute(ie,Ee,Qe){return ie.fontInfo.lineHeight}}class O extends C{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ie.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:g.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),size:b(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ee.side,this.defaultValue.side,["right","left"]),showSlider:b(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Ee.scale,1,1,3),maxColumn:w.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends C{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:w.clampedInt(Ee.top,0,0,1e3),bottom:w.clampedInt(Ee.bottom,0,0,1e3)}}}class X extends C{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:g.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),cycle:a(Ee.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(127)}compute(ie,Ee,Qe){return ie.pixelRatio}}class de extends C{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:g.localize(63,null)},other:{type:"boolean",default:ie.other,description:g.localize(64,null)}}}],default:ie,description:g.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Qe={other:a(Ee.other,this.defaultValue.other),comments:a(Ee.comments,this.defaultValue.comments),strings:a(Ee.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends C{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ie){let Ee=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Qe=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Qe}}}function Pe(J){const ie=J.get(86);return ie==="editable"?J.get(80):ie!=="on"}e.filterValidationDecorations=Pe;class Be extends C{constructor(){const ie=[],Ee={type:"number",description:g.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ie,description:g.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Qe of ie)if(typeof Qe=="number")Ee.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Ee.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return Ee.sort((Qe,et)=>Qe.column-et.column),Ee}return this.defaultValue}}function $e(J,ie){if(typeof J!="string")return ie;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends C{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:g.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Qe=w.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$e(Ee.vertical,this.defaultValue.vertical),horizontal:$e(Ee.horizontal,this.defaultValue.horizontal),useShadows:a(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(Ee.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(Ee.verticalSliderSize,et,0,1e3),scrollByPage:a(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends C{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:g.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),mode:b(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends C{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:g.localize(86,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:a(ie.enabled,this.defaultValue.enabled)}}}class te extends C{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ie.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ie.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{bracketPairs:ce(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,ie,Ee){const Qe=Ee.indexOf(J);return Qe===-1?ie:Ee[Qe]}class Z extends C{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ie.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:b(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:a(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:a(Ee.preview,this.defaultValue.preview),previewMode:b(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Ee.showMethods,this.defaultValue.showMethods),showFunctions:a(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Ee.showFields,this.defaultValue.showFields),showVariables:a(Ee.showVariables,this.defaultValue.showVariables),showClasses:a(Ee.showClasses,this.defaultValue.showClasses),showStructs:a(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:a(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Ee.showModules,this.defaultValue.showModules),showProperties:a(Ee.showProperties,this.defaultValue.showProperties),showEvents:a(Ee.showEvents,this.defaultValue.showEvents),showOperators:a(Ee.showOperators,this.defaultValue.showOperators),showUnits:a(Ee.showUnits,this.defaultValue.showUnits),showValues:a(Ee.showValues,this.defaultValue.showValues),showConstants:a(Ee.showConstants,this.defaultValue.showConstants),showEnums:a(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Ee.showKeywords,this.defaultValue.showKeywords),showWords:a(Ee.showWords,this.defaultValue.showWords),showColors:a(Ee.showColors,this.defaultValue.showColors),showFiles:a(Ee.showFiles,this.defaultValue.showFiles),showReferences:a(Ee.showReferences,this.defaultValue.showReferences),showFolders:a(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:a(Ee.showUsers,this.defaultValue.showUsers),showIssues:a(Ee.showIssues,this.defaultValue.showIssues)}}}class se extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends i{constructor(){super(128,[80])}compute(ie,Ee,Qe){return Ee.get(80)?!0:ie.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends i{constructor(){super(130,[129])}compute(ie,Ee,Qe){const et=Ee.get(129);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?ct:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new n),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new P(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new te),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new P(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new f),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new o(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new P(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new y(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new s(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new T),fontSize:ye(new B),fontWeight:ye(new N),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new y(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>y.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new U),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new j),lineNumbers:ye(new Ce),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new p(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new s(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new y(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new W),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new s(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new s(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new x),snippetSuggestions:ye(new s(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new se),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new s(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new s(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new s(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new P(115,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new s(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new P(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new P(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new s(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new s(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new m),pixelRatio:ye(new K),tabFocusMode:ye(new pe),layoutInfo:ye(new z),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(a){return a=a.trim(),a==="*"||L.test(a)}e.isValidVersionStr=S;function A(a){if(!S(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=a.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function k(a){if(!a)return null;let p=a.majorBase,h=a.majorMustEqual,w=a.minorBase,y=a.minorMustEqual,P=a.patchBase,b=a.patchMustEqual;a.hasCaret&&(p===0||(y=!1),b=!1);let s=0;if(a.preRelease){const o=D.exec(a.preRelease);if(o){const[,v,n,f]=o;s=Date.UTC(Number(v),Number(n)-1,Number(f))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:y,patchBase:P,patchMustEqual:b,isMinimum:a.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function _(a,p,h){let w;typeof a=="string"?w=k(A(a)):w=a;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let P;if(typeof h=="string"?P=k(A(h)):P=h,!w||!P)return!1;let b=w.majorBase,s=w.minorBase,o=w.patchBase,v=P.majorBase,n=P.minorBase,f=P.patchBase,r=P.notBefore,t=P.majorMustEqual,d=P.minorMustEqual,l=P.patchMustEqual;return P.isMinimum?b>v?!0:b<v?!1:s>n?!0:s<n||y&&y<r?!1:o>=f:(b===1&&v===0&&(!t||!d||!l)&&(v=1,n=0,f=0,t=!0,d=!1,l=!1),b<v?!1:b>v?!t:s<n?!1:s>n?!d:o<f?!1:o>f?!l:!(y&&y<r))}e.isValidVersion=_;function C(a,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(a,p,h.engines.vscode,w)}e.isValidExtensionVersion=C;function i(a,p,h){return a==="*"||I(p,h,a)}e.isEngineValid=i;function I(a,p,h,w=[]){let y=k(A(h));if(!y)return w.push(g.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!y.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return _(a,p,y)?!0:(w.push(g.localize(3,null,a,h)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(D,S=[],A=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=g}),define(fe[84],me([0,1,116]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(A,k,_){k instanceof g.SyncDescriptor||(k=new g.SyncDescriptor(k,[],_)),L.push([A,k])}e.registerSingleton=D;function S(){return L}e.getSingletonServiceDescriptors=S}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let A of this._nodes.values())A.outgoing.size===0&&S.push(A);return S}insertEdge(S,A){const k=this.lookupOrInsertNode(S),_=this.lookupOrInsertNode(A);k.outgoing.set(this._hashFn(A),_),_.incoming.set(this._hashFn(S),k)}removeNode(S){const A=this._hashFn(S);this._nodes.delete(A);for(let k of this._nodes.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(S){const A=this._hashFn(S);let k=this._nodes.get(A);return k||(k=new g(S),this._nodes.set(A,k)),k}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[A,k]of this._nodes)S.push(`${A}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,A]of this._nodes){const k=new Set([S]),_=this._findCycle(A,k);if(_)return _}}_findCycle(S,A){for(let[k,_]of S.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const C=this._findCycle(_,A);if(C)return C;A.delete(k)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(A,k,_,C){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:A,index:_,optional:C}):(k[g.DI_DEPENDENCIES]=[{id:A,index:_,optional:C}],k[g.DI_TARGET]=k)}function D(A){if(g.serviceIds.has(A))return g.serviceIds.get(A);const k=function(_,C,i){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,_,i,!1)};return k.toString=()=>A,g.serviceIds.set(A,k),k}e.createDecorator=D;function S(A){return A}e.refineServiceDecorator=S}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,48,6,24,79,83,183]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(C):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(y,P){let b={selector:y,provider:P,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(b){let s=this._entries.indexOf(b);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(y){return this.all(y).length>0}all(y){if(!y)return[];this._updateScores(y);const P=[];for(let b of this._entries)b._score>0&&P.push(b.provider);return P}ordered(y){const P=[];return this._orderedForEach(y,b=>P.push(b.provider)),P}orderedGroups(y){const P=[];let b,s;return this._orderedForEach(y,o=>{b&&s===o._score?b.push(o.provider):(s=o._score,b=[o.provider],P.push(b))}),P}_orderedForEach(y,P){if(!!y){this._updateScores(y);for(const b of this._entries)b._score>0&&P(b)}}_updateScores(y){let P={uri:y.uri.toString(),language:y.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let b of this._entries)if(b._score=(0,k.score)(b.selector,y.uri,y.getLanguageId(),(0,_.shouldSynchronizeModel)(y)),C(b.selector)&&b._score>0){for(let s of this._entries)s._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(y,P){return y._score<P._score?1:y._score>P._score?-1:y._time<P._time?1:y._time>P._time?-1:0}}e.LanguageFeatureRegistry=i;const I=new WeakMap;let a=0;function p(w){let y=I.get(w);return y===void 0&&(y=++a,I.set(w,y)),y}class h{constructor(y,P,b=Number.MAX_SAFE_INTEGER){this._registry=y,this.min=P,this.max=b,this._cache=new S.LRUCache(50,.7)}_key(y){return y.id+this._registry.all(y).reduce((P,b)=>(0,L.doHash)(p(b),P),0)}_clamp(y){return y===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(y*1.3)))}get(y){const P=this._key(y),b=this._cache.get(P);return this._clamp(b?.value)}update(y,P){const b=this._key(y);let s=this._cache.get(b);return s||(s=new A.MovingAverage,this._cache.set(b,s)),s.update(P),this.get(y)}}e.LanguageFeatureRequestDelays=h}),define(fe[85],me([0,1,2,43,184,149,47]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var C;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var i;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(i=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class a{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let T=this.getForeground(E),R="mtk"+T,B=this.getFontStyle(E);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(E,T){const R=this.getForeground(E),B=this.getFontStyle(E);let N=`color: ${T[R]};`;return B&1&&(N+="font-style: italic;"),B&2&&(N+="font-weight: bold;"),B&4&&(N+="text-decoration: underline;"),N}}e.TokenMetadata=a;var p;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const T=u[E];let R=T&&A.iconRegistry.get(T);return R||(console.info("No codicon found for CompletionItemKind "+E),R=A.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,T){let R=u[E];return typeof R=="undefined"&&!T&&(R=9),R}}();var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var o;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(o=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&g.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var n;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var r;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function R(F){return E.get(F)}u.fromString=R;function B(F){return T.get(F)}u.toString=B;function N(F,$){const M=T.get(F);let z=M&&A.iconRegistry.get("symbol-"+M);return z||(console.info("No codicon found for SymbolKind "+F),z=A.Codicon.symbolProperty),`${$?"inline":"block"} ${z.classNames}`}u.toCssClassName=N})(r=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(E){this.value=E}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var m;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(m=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=g.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",g.isMacintosh),A.set("isLinux",g.isLinux),A.set("isWindows",g.isWindows),A.set("isWeb",g.isWeb),A.set("isMacNative",g.isMacintosh&&!g.isWeb),A.set("isEdge",S.indexOf("Edg/")>=0),A.set("isFirefox",S.indexOf("Firefox")>=0),A.set("isChrome",S.indexOf("Chrome")>=0),A.set("isSafari",S.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return a.INSTANCE}static true(){return p.INSTANCE}static has(F){return h.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return b.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return y.create(F,$)}static not(F){return s.create(F)}static and(...F){return c.create(F,null)}static or(...F){return m.create(F,null,!0)}static greater(F,$){return v.create(F,$)}static greaterEquals(F,$){return n.create(F,$)}static smaller(F,$){return f.create(F,$)}static smallerEquals(F,$){return r.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return m.create(M.map(z=>this._deserializeAndExpression(z,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return c.create(M.map(z=>this._deserializeOne(z,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return y.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return f.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),z=F.lastIndexOf("/");if(M===z||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,z),x=F[z+1]==="i"?"i":"";try{return new RegExp(U,x)}catch(j){if($)throw new Error(`bad regexp-value '${F}', parse error: ${j}`);return console.warn(`bad regexp-value '${F}', parse error: ${j}`),null}}}e.ContextKeyExpr=C;function i(N,F){const $=N?N.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=i;function I(N,F){return N.cmp(F)}class a{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class p{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=A.get(F);return typeof M=="boolean"?M?p.INSTANCE:a.INSTANCE:new h(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=A.get(this.key);return typeof F=="boolean"?F?p.INSTANCE:a.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?h.create(F,M):s.create(F,M);const z=A.get(F);return typeof z=="boolean"?$===(z?"true":"false")?p.INSTANCE:a.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=A.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?p.INSTANCE:a.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class y{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new y(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?k.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=y;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?s.create(F,M):h.create(F,M);const z=A.get(F);return typeof z=="boolean"?$===(z?"true":"false")?a.INSTANCE:p.INSTANCE:new b(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=A.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?a.INSTANCE:p.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class s{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=A.get(F);return typeof M=="boolean"?M?a.INSTANCE:p.INSTANCE:new s(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=A.get(this.key);return typeof F=="boolean"?F?a.INSTANCE:p.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function o(N,F){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?F(N):a.INSTANCE}class v{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return o($,z=>new v(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class n{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return o($,z=>new n(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=n;class f{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return o($,z=>new f(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=f;class r{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return o($,z=>new r(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class d{constructor(F){this._actual=F,this.type=8}static create(F){return new d(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new d(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;function l(N){let F=null;for(let $=0,M=N.length;$<M;$++){const z=N[$].substituteConstants();if(N[$]!==z&&F===null){F=[];for(let U=0;U<$;U++)F[U]=N[U]}F!==null&&(F[$]=z)}return F===null?N:F}class c{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return c._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let z=!1;for(const U of F)if(!!U){if(U.type===1){z=!0;continue}if(U.type===0)return a.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&z)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const x=M.pop(),j=M.length===0,O=m.create(U.expr.map(H=>c.create([H,x],null)),null,j);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new c(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new c(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=m.create(F,this,!0)}return this.negated}}class m{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return m._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:m.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let z=[],U=!1;if(F){for(let x=0,j=F.length;x<j;x++){const O=F[x];if(!!O){if(O.type===0){U=!0;continue}if(O.type===1)return p.INSTANCE;if(O.type===9){z=z.concat(O.expr);continue}z.push(O)}}if(z.length===0&&U)return a.INSTANCE;z.sort(I)}if(z.length!==0){if(z.length===1)return z[0];for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];if(M){for(let x=0;x<z.length;x++)for(let j=x+1;j<z.length;j++)R(z[x],z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0]}return new m(z,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new m(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),z=[];for(const x of B($))for(const j of B(M))z.push(c.create([x,j],null));const U=F.length===0;F.unshift(m.create(z,null,U))}this.negated=F[0]}return this.negated}}class u extends h{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(N,F){return N<F?-1:N>F?1:0}function T(N,F,$,M){return N<$?-1:N>$?1:F<M?-1:F>M?1:0}function R(N,F){if(F.type===6&&N.type!==9&&N.type!==6){for(const z of F.expr)if(N.equals(z))return!0}const $=N.negate(),M=B($).concat(B(F));M.sort(I);for(let z=0;z<M.length;z++){const x=M[z].negate();for(let j=z+1;j<M.length;j++){const O=M[j];if(x.equals(O))return!0}}return!1}e.implies=R;function B(N){return N.type===9?N.expr:[N]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var S;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));function A(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(s,o){switch(s){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function C(s,o){return o==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function i(s,o,v){return C(o,v)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===v?!0:I(v).includes(s)}e.isTargetPlatformCompatible=i;function I(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function a(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=a;var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(s){s.Install="install",s.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(s){s[s.None=0]="None",s[s.Install=1]="Install",s[s.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var P;(function(s){s.Unsupported="Unsupported",s.Malicious="Malicious",s.Incompatible="Incompatible",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(o,v){super(o);this.code=v,this.name=v}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,8,11,96,26,114,159,187]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=C.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends a{openTerminal(o,v){return this.spawnTerminal(g,o,_.getWindowsShell(),v)}spawnTerminal(o,v,n,f){const r=v.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const t=D.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return o.spawn(r,f?[f]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return r.indexOf(" ")>=0&&d.push('""'),d.push(r),(t==="wt"||t==="wt.exe")&&d.push("-d ."),new Promise((l,c)=>{const m=y(process),u=o.spawn(n,d,{cwd:f,env:m});u.on("error",c),u.on("exit",()=>l())})}runInTerminal(o,v,n,f,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((d,l)=>{const c=`"${v} - ${I}"`,m=`""${n.join('" "')}" & pause"`,u=["/c","start",c,"/wait",t,"/c",m],E=Object.assign({},y(process),f);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const T={cwd:v,env:E,windowsVerbatimArguments:!0};g.spawn(p.CMD,u,T).on("error",B=>{l(P(B))}),d(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class h extends a{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,n,f,r){const t=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((d,l)=>{if(t===i.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const c=t===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",o||I,"-w",v];for(let R of n)u.push("-a"),u.push(R);if(f){const R=Object.assign({},y(process),f);for(let B in R){const N=R[B];N===null?(u.push("-u"),u.push(B)):(u.push("-e"),u.push(`${B}=${N}`))}}let E="";const T=g.spawn(h.OSASCRIPT,u);T.on("error",R=>{l(P(R))}),T.stderr.on("data",R=>{E+=R.toString()}),T.on("exit",R=>{if(R===0)d(void 0);else if(E){const B=E.split(`
`,1);l(new Error(B[0]))}else l(new Error(C.localize(1,null,c,R)))})}else l(new Error(C.localize(2,null,t)))})}spawnTerminal(o,v,n){const f=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const d=["-a",f];n&&d.push(n);const l=y(process),c=o.spawn("/usr/bin/open",d,{cwd:n,env:l});c.on("error",t),c.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends a{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,n,f,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{let c=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const u=`${b(n)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;c.push(`''${u}''`);const E=Object.assign({},y(process),f);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const T={cwd:v,env:E};let R="";const B=g.spawn(m,c,T);B.on("error",N=>{l(P(N))}),B.stderr.on("data",N=>{R+=N.toString()}),B.on("exit",N=>{if(N===0)d(void 0);else if(R){const F=R.split(`
`,1);l(new Error(F[0]))}else l(new Error(C.localize(4,null,m,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!S.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{o?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,v,n){const f=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{f.then(d=>{const l=y(process),c=o.spawn(d,[],{cwd:n,env:l});c.on("error",t),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=C.localize(3,null);function y(s){const o={...s.env};return(0,A.sanitizeProcessEnvironment)(o),o}function P(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(C.localize(5,null,s.path)):s}function b(s){let o="";for(let v of s)v.indexOf(" ")>=0?o+='"'+v+'"':o+=v,o+=" ";return o}}),define(fe[40],me([0,1,24,8,9,12,2,160,4]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function y(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=y;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,U){super(z);this.code=U}}e.FileSystemProviderError=b;function s(M,z){const U=new b(M.toString(),z);return v(U,z),U}e.createFileSystemProviderError=s;function o(M){return M||s((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=o;function v(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=v;function n(M){if(!M)return P.Unknown;if(M instanceof b)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=n;function f(M){if(M instanceof m)return M.fileOperationResult;switch(n(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(z,U,x){this.resource=z,this.operation=U,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var d;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const j of z){const O=x.get(j.type);O?O.push([j.resource,j]):x.set(j.type,[[j.resource,j]])}for(const[j,O]of x)switch(j){case 1:this.added=g.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(z,...U){return this.doContains(z,{includeChildren:!1},...U)}affects(z,...U){return this.doContains(z,{includeChildren:!0},...U)}doContains(z,U,...x){if(!z)return!1;const j=x.length>0;return!!((!j||x.includes(1))&&(this.added?.get(z)||U.includeChildren&&this.added?.findSuperstr(z))||(!j||x.includes(0))&&(this.updated?.get(z)||U.includeChildren&&this.updated?.findSuperstr(z))||(!j||x.includes(2))&&(this.deleted?.findSubstr(z)||U.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(M,z,U){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),U?(0,D.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=c;class m extends Error{constructor(z,U,x){super(z);this.fileOperationResult=U,this.options=x}}e.FileOperationError=m;class u extends m{constructor(z,U,x){super(z,2,x);this.stat=U}}e.NotModifiedSinceFileOperationError=u;var E;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,z){if(!z.hasProvider(A.URI.from({scheme:M.scheme})))return new Promise(U=>{const x=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===M.scheme&&j.added&&(x.dispose(),U())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(z){return(0,S.isNumber)(z)||(z=0),z<N.KB?(0,k.localize)(1,null,z.toFixed(0)):z<N.MB?(0,k.localize)(2,null,(z/N.KB).toFixed(2)):z<N.GB?(0,k.localize)(3,null,(z/N.MB).toFixed(2)):z<N.TB?(0,k.localize)(4,null,(z/N.GB).toFixed(2)):(0,k.localize)(5,null,(z/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*N.MB:16*N.GB,maxHeapSize:M===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(fe[86],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[S,A]of D)this.set(S,A)}set(D,S){const A=this._entries.get(D);return this._entries.set(D,S),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(fe[189],me([0,1,16,18,116,182,4,86]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new k.ServiceCollection,w=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=y,this._services.set(A.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...w){let y=a.traceInvocation(h),P=!1;try{return h({get:s=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(s,y);if(!o)throw new Error(`[invokeFunction] unknown service '${s}'`);return o}},...w)}finally{P=!0,y.stop()}}createInstance(h,...w){let y,P;return h instanceof D.SyncDescriptor?(y=a.traceCreation(h.ctor),P=this._createInstance(h.ctor,h.staticArguments.concat(w),y)):(y=a.traceCreation(h),P=this._createInstance(h,w,y)),y.stop(),P}_createInstance(h,w=[],y){let P=A._util.getServiceDependencies(h).sort((o,v)=>o.index-v.index),b=[];for(const o of P){let v=this._getOrCreateServiceInstance(o.id,y);if(!v&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);b.push(v)}let s=P.length>0?P[0].index:w.length;if(w.length!==s){console.warn(`[createInstance] First service dependency of ${h.name} at position ${s+1} conflicts with ${w.length} static arguments`);let o=s-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,s)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,w.branch(h,!0)):(w.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,w,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,y){const P=new S.Graph(o=>o.id.toString());let b=0;const s=[{id:h,desc:w,_trace:y}];for(;s.length;){const o=s.pop();if(P.lookupOrInsertNode(o),b++>1e3)throw new C(P);for(let v of A._util.getServiceDependencies(o.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(v.id);if(!n&&!v.optional&&console.warn(`[createInstance] ${h} depends on ${v.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const f={id:v.id,desc:n,_trace:o._trace.branch(v.id,!0)};P.insertEdge(o,f),s.push(f)}}}for(;;){const o=P.roots();if(o.length===0){if(!P.isEmpty())throw new C(P);break}for(const{data:v}of o){if(this._getServiceInstanceOrDescriptor(v.id)instanceof D.SyncDescriptor){const f=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,f)}P.removeNode(v)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,y=[],P,b){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(w,y,P,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,y,P,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],y,P){if(y){const b=new g.IdleValue(()=>this._createInstance(h,w,P));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let v=b.value,n=v[o];return typeof n!="function"||(n=n.bind(v),s[o]=n),n},set(s,o,v){return b.value[o]=v,!0}})}else return this._createInstance(h,w,P)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class a{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new a(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(h){return _?new a(0,h.name):a._None}branch(h,w){let y=new a(2,h.toString());return this._dep.push([h,w,y]),y}stop(){let h=Date.now()-this._start;a._totals+=h;let w=!1;function y(b,s){let o=[],v=new Array(b+1).join("	");for(const[n,f,r]of s._dep)if(f&&r){w=!0,o.push(`${v}CREATES -> ${n}`);let t=y(b+1,r);t&&o.push(t)}else o.push(`${v}uses -> ${n}`);return o.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(P.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(fe[13],me([0,1,52,3,6,11,4]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...f){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([n,...f]))}debug(n,...f){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([n,...f]))}info(n,...f){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([n,...f]))}warn(n,...f){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([n,...f]))}error(n,...f){if(this.checkLogLevel(_.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([n,...f]))}critical(n,...f){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([n,...f]))}flush(){}format(n){let f="";for(let r=0;r<n.length;r++){let t=n[r];if(typeof t=="object")try{t=JSON.stringify(t)}catch(d){}f+=(r>0?" ":"")+t}return f}}e.AbstractMessageLogger=i;class I extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!S.isWindows}trace(n,...f){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}debug(n,...f){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}info(n,...f){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...f):console.log(`[main ${k()}]`,n,...f))}warn(n,...f){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...f):console.warn(`[main ${k()}]`,n,...f))}error(n,...f){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...f):console.error(`[main ${k()}]`,n,...f))}critical(n,...f){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...f):console.error(`[main ${k()}]`,n,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class a extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...f){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",n,...f)}debug(n,...f){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...f)}info(n,...f){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",n,...f)}warn(n,...f){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",n,...f)}error(n,...f){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",n,...f)}critical(n,...f){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...f)}dispose(){}flush(){}}e.ConsoleLogger=a;class p extends C{constructor(n,f=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(f)}trace(n,...f){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(n),...f])}debug(n,...f){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(n),...f])}info(n,...f){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(n),...f])}warn(n,...f){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(n),...f])}error(n,...f){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(n),...f])}critical(n,...f){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(n),...f])}extractMessage(n){return typeof n=="string"?n:(0,g.toErrorMessage)(n,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends C{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const f of this.logServices)f.setLevel(n);super.setLevel(n)}trace(n,...f){for(const r of this.logServices)r.trace(n,...f)}debug(n,...f){for(const r of this.logServices)r.debug(n,...f)}info(n,...f){for(const r of this.logServices)r.info(n,...f)}warn(n,...f){for(const r of this.logServices)r.warn(n,...f)}error(n,...f){for(const r of this.logServices)r.error(n,...f)}critical(n,...f){for(const r of this.logServices)r.critical(n,...f)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class w extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...f){this.logger.trace(n,...f)}debug(n,...f){this.logger.debug(n,...f)}info(n,...f){this.logger.info(n,...f)}warn(n,...f){this.logger.warn(n,...f)}error(n,...f){this.logger.error(n,...f)}critical(n,...f){this.logger.critical(n,...f)}flush(){this.logger.flush()}}e.LogService=w;class y extends D.Disposable{constructor(n,f){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(f(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,f){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,f?.always?_.Trace:this.logLevel,f),this.loggers.set(n.toString(),r),f?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class P{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return _.Info}trace(n,...f){}debug(n,...f){}info(n,...f){}warn(n,...f){}error(n,...f){}critical(n,...f){}dispose(){}flush(){}}e.NullLogService=P;function b(v){if(v.verbose)return _.Trace;if(typeof v.logLevel=="string"){const n=s(v.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function s(v){switch(v){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=s;function o(v){switch(v){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=o}),define(fe[117],me([0,1,40,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(_,C,i,I){try{const a=await new Promise((p,h)=>{Y(["spdlog"],p,h)});return a.setFlushOn(L.LogLevel.Trace),a.createAsyncRotatingLogger(_,C,i,I)}catch(a){console.error(a)}return null}function S(_,C,i,I){const a=Y.__$__nodeRequire("spdlog");return a.setFlushOn(L.LogLevel.Trace),a.createRotatingLogger(_,C,i,I)}e.createRotatingLogger=S;function A(_,C,i){switch(C){case L.LogLevel.Trace:_.trace(i);break;case L.LogLevel.Debug:_.debug(i);break;case L.LogLevel.Info:_.info(i);break;case L.LogLevel.Warning:_.warn(i);break;case L.LogLevel.Error:_.error(i);break;case L.LogLevel.Critical:_.critical(i);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(C,i,I,a){super();this.name=C,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const C=this.rotating?6:1,i=30/C*g.ByteSize.MB;return D(this.name,this.filepath,i,C).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:a,message:p}of this.buffer)A(this._logger,a,p);this.buffer=[]}})}log(C,i){this._logger?A(this._logger,C,i):this.getLevel()<=C&&this.buffer.push({level:C,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(fe[118],me([0,1,49,161,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var A;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(h,w){return w-h}_.compare=C;const i=Object.create(null);i[_.Error]=(0,L.localize)(0,null),i[_.Warning]=(0,L.localize)(1,null),i[_.Info]=(0,L.localize)(2,null);function I(h){return i[h]||""}_.toString=I;function a(h){switch(h){case g.default.Error:return _.Error;case g.default.Warning:return _.Warning;case g.default.Info:return _.Info;case g.default.Ignore:return _.Hint}}_.fromSeverity=a;function p(h){switch(h){case _.Error:return g.default.Error;case _.Warning:return g.default.Warning;case _.Info:return g.default.Info;case _.Hint:return g.default.Ignore}}_.toSeverity=p}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const C="";function i(a){return I(a,!0)}_.makeKey=i;function I(a,p){let h=[C];return a.source?h.push(a.source.replace("\xA6","\\\xA6")):h.push(C),a.code?typeof a.code=="string"?h.push(a.code.replace("\xA6","\\\xA6")):h.push(a.code.value.replace("\xA6","\\\xA6")):h.push(C),a.severity!==void 0&&a.severity!==null?h.push(A.toString(a.severity)):h.push(C),a.message&&p?h.push(a.message.replace("\xA6","\\\xA6")):h.push(C),a.startLineNumber!==void 0&&a.startLineNumber!==null?h.push(a.startLineNumber.toString()):h.push(C),a.startColumn!==void 0&&a.startColumn!==null?h.push(a.startColumn.toString()):h.push(C),a.endLineNumber!==void 0&&a.endLineNumber!==null?h.push(a.endLineNumber.toString()):h.push(C),a.endColumn!==void 0&&a.endColumn!==null?h.push(a.endColumn.toString()):h.push(C),h.push(C),h.join("\xA6")}_.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(fe[190],me([0,1,3,49,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var S;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=_}),define(fe[191],me([0,1,6,9,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(k){return{resolved:k,dispose(){}}}});function A(k,_){return D.URI.isUri(k)?(0,L.equalsIgnoreCase)(k.scheme,_):(0,L.startsWithIgnoreCase)(k,_+":")}e.matchesScheme=A}),define(fe[192],me([0,1,10,11,38,23]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)A=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,S.dirname)(g.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,S.joinPath)(k,"product.json").fsPath);const _=Y.__$__nodeRequire((0,S.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:_.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[119],me([0,1,16,21,6,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,S.createDecorator)("progressService");var A;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends D.Disposable{constructor(I,a){super();this.deferred=new g.DeferredPromise,a.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([We(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:p.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,S.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,k){g.ok(L.isString(A)),g.ok(L.isObject(k)),g.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,k)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(fe[120],me([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class S{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[D(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new S;L.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[87],me([0,1,15,3,12,156,120,34]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=k.Registry.as(A.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const v=this.doRegisterConfigurations(s,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(s){const o=this.doDeregisterConfigurations(s);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:s,remove:o}){const v=[];v.push(...this.doDeregisterConfigurations(o)),v.push(...this.doRegisterConfigurations(s,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(v))}registerDefaultConfigurations(s){const o=[],v=[];for(const n of s)for(const f in n)if(o.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]={...this.defaultValues[f]||{},...n[f]};const r={type:"object",default:this.defaultValues[f],description:S.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};v.push(p(f)),this.configurationProperties[f]=r,this.defaultLanguageConfigurationOverridesNode.properties[f]=r}else{this.defaultValues[f]=n[f];const r=this.configurationProperties[f];r&&(this.updatePropertyDefaultValue(f,r),this.updateSchema(f,r))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(s){const o=[];for(const v of s)for(const n in v)if(o.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const f=this.configurationProperties[n];f&&(this.updatePropertyDefaultValue(n,f),this.updateSchema(n,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const o of s)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,o){const v=[];return s.forEach(n=>{v.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),v}doDeregisterConfigurations(s){const o=[],v=n=>{if(n.properties)for(const f in n.properties)o.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,n.properties[f]);n.allOf&&n.allOf.forEach(f=>v(f))};for(const n of s){v(n);const f=this.configurationContributors.indexOf(n);f!==-1&&this.configurationContributors.splice(f,1)}return o}validateAndRegisterProperties(s,o=!0,v,n=3){n=D.isUndefinedOrNull(s.scope)?n:s.scope;let f=[],r=s.properties;if(r)for(let d in r){if(o&&y(d)){delete r[d];continue}const l=r[d];if(this.updatePropertyDefaultValue(d,l),e.OVERRIDE_PROPERTY_PATTERN.test(d)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?n:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!v?.restrictedConfigurations?.includes(d):l.restricted),r[d].hasOwnProperty("included")&&!r[d].included){this.excludedConfigurationProperties[d]=r[d],delete r[d];continue}else this.configurationProperties[d]=r[d];!r[d].deprecationMessage&&r[d].markdownDeprecationMessage&&(r[d].deprecationMessage=r[d].markdownDeprecationMessage),f.push(d)}let t=s.allOf;if(t)for(let d of t)f.push(...this.validateAndRegisterProperties(d,o,v,n));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(s){const o=v=>{let n=v.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let f=v.allOf;f&&f.forEach(o)};o(s)}updateSchema(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.resourceLanguageSettingsSchema.properties[s]=o;break}}removeFromSchema(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const o=`[${s}]`,v={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,v),e.allSettings.properties[o]=v,e.applicationSettings.properties[o]=v,e.machineSettings.properties[o]=v,e.machineOverridableSettings.properties[o]=v,e.windowSettings.properties[o]=v,e.resourceSettings.properties[o]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,o){let v=this.defaultValues[s];D.isUndefined(v)&&(v=o.default),D.isUndefined(v)&&(v=h(o.type)),o.default=v}}const a="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(a);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new I;k.Registry.add(e.Extensions.Configuration,w);function y(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=y;function P(){const b=[],s=w.getConfigurationProperties();for(const o of Object.keys(s))b.push([o,s[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=P}),define(fe[121],me([0,1,25,12,2,87,4,34]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function _(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof D.URI)}e.isConfigurationOverrides=_;var C;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(f,r){const t=r?f?r.keys.filter(T=>f.keys.indexOf(T)===-1):[...r.keys]:[],d=f?r?f.keys.filter(T=>r.keys.indexOf(T)===-1):[...f.keys]:[],l=[];if(r&&f){for(const T of f.keys)if(r.keys.indexOf(T)!==-1){const R=P(f.contents,T),B=P(r.contents,T);g.equals(R,B)||l.push(T)}}const c=[],m=T=>{const R={};for(const B of T)for(const N of B.identifiers)R[v(N)]=B;return R},u=r?m(r.overrides):{},E=f?m(f.overrides):{};if(Object.keys(u).length)for(const T of t){const R=u[T];R&&c.push([(0,S.overrideIdentifierFromKey)(T),R.keys])}if(Object.keys(E).length)for(const T of d){const R=E[T];R&&c.push([(0,S.overrideIdentifierFromKey)(T),R.keys])}if(Object.keys(u).length&&Object.keys(E).length)for(const T of l){const R=E[T],B=u[T];if(R&&B){const N=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});c.push([(0,S.overrideIdentifierFromKey)(T),[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:d,updated:l,overrides:c}}e.compare=I;function a(f,r){const t=[];for(const d of Object.keys(f))if(S.OVERRIDE_PROPERTY_PATTERN.test(d)){const l={};for(const c in f[d])l[c]=f[d][c];t.push({identifiers:[(0,S.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(l),contents:p(l,r)})}return t}e.toOverrides=a;function p(f,r){const t=Object.create(null);for(let d in f)h(t,d,f[d],r);return t}e.toValuesTree=p;function h(f,r,t,d){const l=r.split("."),c=l.pop();let m=f;for(let u=0;u<l.length;u++){let E=l[u],T=m[E];switch(typeof T){case"undefined":T=m[E]=Object.create(null);break;case"object":break;default:d(`Ignoring ${r} as ${l.slice(0,u+1).join(".")} is ${JSON.stringify(T)}`);return}m=T}if(typeof m=="object"&&m!==null)try{m[c]=t}catch(u){d(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}else d(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=h;function w(f,r){const t=r.split(".");y(f,t)}e.removeFromValueTree=w;function y(f,r){const t=r.shift();if(r.length===0){delete f[t];return}if(Object.keys(f).indexOf(t)!==-1){const d=f[t];typeof d=="object"&&!Array.isArray(d)&&(y(d,r),Object.keys(d).length===0&&delete f[t])}}function P(f,r,t){function d(m,u){let E=m;for(const T of u){if(typeof E!="object"||E===null)return;E=E[T]}return E}const l=r.split("."),c=d(f,l);return typeof c=="undefined"?t:c}e.getConfigurationValue=P;function b(f,r,t){Object.keys(r).forEach(d=>{d!=="__proto__"&&(d in f?L.isObject(f[d])&&L.isObject(r[d])?b(f[d],r[d],t):t&&(f[d]=r[d]):f[d]=r[d])})}e.merge=b;function s(){const f=k.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(f)}e.getConfigurationKeys=s;function o(){const f=Object.create(null),r=k.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let t in r){let d=r[t].default;h(f,t,d,l=>console.error(`Conflict in default settings: ${l}`))}return f}e.getDefaultValues=o;function v(f){return`[${f}]`}e.keyFromOverrideIdentifier=v;function n(f,r,t){const d=f.inspect(r),l=f.inspect(t);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:d.defaultValue}e.getMigratedSettingValue=n}),define(fe[193],me([0,1,15,3,61,6,24,25,12,2,121,87,34]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},f=[],r=[]){this._contents=n,this._keys=f,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,f){const r=this.getContentsForOverrideIdentifer(f);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.keys;return[]}override(n){let f=this.overrideConfigurations.get(n);return f||(f=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,f)),f}merge(...n){const f=k.deepClone(this.contents),r=k.deepClone(this.overrides),t=[...this.keys];for(const d of n){this.mergeContents(f,d.contents);for(const l of d.overrides){const[c]=r.filter(m=>g.equals(m.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):r.push(k.deepClone(l))}for(const l of d.keys)t.indexOf(l)===-1&&t.push(l)}return new p(f,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const f=this.getContentsForOverrideIdentifer(n);if(!f||typeof f!="object"||!Object.keys(f).length)return this;let r={};for(const t of g.distinct([...Object.keys(this.contents),...Object.keys(f)])){let d=this.contents[t],l=f[t];l&&(typeof d=="object"&&typeof l=="object"?(d=k.deepClone(d),this.mergeContents(d,l)):d=l),r[t]=d}return new p(r,this.keys,this.overrides)}mergeContents(n,f){for(const r of Object.keys(f)){if(r in n&&_.isObject(n[r])&&_.isObject(f[r])){this.mergeContents(n[r],f[r]);continue}n[r]=k.deepClone(f[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const f of this.overrides)if(f.identifiers.indexOf(n)!==-1)return f.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,f){this.addKey(n),(0,i.addToValueTree)(this.contents,n,f,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let f=this.keys.length;for(let r=0;r<f;r++)n.indexOf(this.keys[r])===0&&(f=r);this.keys.splice(f,1,n)}removeKey(n){let f=this.keys.indexOf(n);return f!==-1?(this.keys.splice(f,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,i.getDefaultValues)(),f=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],d=>console.error(`Conflict in default settings file: ${d}`))});super(n,f,r)}}e.DefaultConfigurationModel=h;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,f){if(!_.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,f)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,f){this._raw=n;const{contents:r,keys:t,overrides:d,restricted:l}=this.doParseRaw(n,f);this._configurationModel=new p(r,t,d),this._restrictedConfigurations=l||[]}doParseContent(n){let f={},r=null,t=[],d=[],l=[];function c(u){Array.isArray(t)?t.push(u):r!==null&&(t[r]=u)}let m={onObjectBegin:()=>{let u={};c(u),d.push(t),t=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{t=d.pop()},onArrayBegin:()=>{let u=[];c(u),d.push(t),t=u,r=null},onArrayEnd:()=>{t=d.pop()},onLiteralValue:c,onError:(u,E,T)=>{l.push({error:u,offset:E,length:T})}};if(n)try{D.visit(n,m),f=t[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return f}doParseRaw(n,f){const r=a.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,f);n=t.raw;const d=(0,i.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),l=Object.keys(n),c=(0,i.toOverrides)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:d,keys:l,overrides:c,restricted:t.restricted}}filter(n,f,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const d={},l=[];for(let c in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(c)&&r){const m=this.filter(n[c],f,!1,t);d[c]=m.raw,l.push(...m.restricted)}else{const m=f[c],u=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&l.push(c),(u===void 0||t.scopes===void 0||t.scopes.includes(u))&&(t.skipRestricted&&m?.restricted||(d[c]=n[c]))}return{raw:d,restricted:l}}}e.ConfigurationModelParser=w;class y extends S.Disposable{constructor(n,f,r,t){super();this.userSettingsResource=n,this.scopes=f,this.fileService=t,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class P{constructor(n,f,r=new p,t=new p,d=new A.ResourceMap,l=new p,c=new A.ResourceMap,m=!0){this._defaultConfiguration=n,this._localUserConfiguration=f,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=d,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,f,r){return this.getConsolidateConfigurationModel(f,r).getValue(n)}updateValue(n,f,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new p,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,f===void 0?t.removeValue(n):t.setValue(n,f),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,f,r){const t=this.getConsolidateConfigurationModel(f,r),d=this.getFolderConfigurationModelForResource(f.resource,r),l=f.resource?this._memoryConfigurationByResource.get(f.resource)||this._memoryConfiguration:this._memoryConfiguration,c=f.overrideIdentifier?this._defaultConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),m=f.overrideIdentifier?this.userConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),u=f.overrideIdentifier?this.localUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),E=f.overrideIdentifier?this.remoteUserConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),T=r?f.overrideIdentifier?this._workspaceConfiguration.freeze().override(f.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,R=d?f.overrideIdentifier?d.freeze().override(f.overrideIdentifier).getValue(n):d.freeze().getValue(n):void 0,B=f.overrideIdentifier?l.override(f.overrideIdentifier).getValue(n):l.getValue(n),N=t.getValue(n),F=g.distinct(g.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(n,$)!==void 0);return{defaultValue:c,userValue:m,userLocalValue:u,userRemoteValue:E,workspaceValue:T,workspaceFolderValue:R,memoryValue:B,value:N,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:f.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:d?.freeze().getValue(n),override:f.overrideIdentifier?d?.freeze().getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:l.getValue(n),override:f.overrideIdentifier?l.getOverrideValue(n,f.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const f=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:f?f.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,f){this._folderConfigurations.set(n,f),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,f){const r=f.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const d=(0,I.overrideIdentifierFromKey)(t),l=this._defaultConfiguration.getKeysForOverrideIdentifier(d),c=n.getKeysForOverrideIdentifier(d),m=[...c.filter(u=>l.indexOf(u)===-1),...l.filter(u=>c.indexOf(u)===-1),...l.filter(u=>!k.equals(this._defaultConfiguration.override(d).getValue(u),n.override(d).getValue(u)))];return[d,m]});return this.updateDefaultConfiguration(n),{keys:f,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.localUserConfiguration,n),l=[...f,...r,...t];return l.length&&this.updateLocalUserConfiguration(n),{keys:l,overrides:d}}compareAndUpdateRemoteUserConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.remoteUserConfiguration,n);let l=[...f,...r,...t];return l.length&&this.updateRemoteUserConfiguration(n),{keys:l,overrides:d}}compareAndUpdateWorkspaceConfiguration(n){const{added:f,updated:r,removed:t,overrides:d}=(0,i.compare)(this.workspaceConfiguration,n);let l=[...f,...r,...t];return l.length&&this.updateWorkspaceConfiguration(n),{keys:l,overrides:d}}compareAndUpdateFolderConfiguration(n,f){const r=this.folderConfigurations.get(n),{added:t,updated:d,removed:l,overrides:c}=(0,i.compare)(r,f);let m=[...t,...d,...l];return(m.length||!r)&&this.updateFolderConfiguration(n,f),{keys:m,overrides:c}}compareAndDeleteFolderConfiguration(n){const f=this.folderConfigurations.get(n);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:d,overrides:l}=(0,i.compare)(f,void 0);return{keys:[...r,...t,...d],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,f){let r=this.getConsolidatedConfigurationModelForResource(n,f);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},f){let r=this.getWorkspaceConsolidatedConfiguration();if(f&&n){const t=f.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const d=this._memoryConfigurationByResource.get(n);d&&(r=r.merge(d))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let f=this._foldersConsolidatedConfigurations.get(n);if(!f){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(f=r.merge(t),this._freeze&&(f=f.freeze()),this._foldersConsolidatedConfigurations.set(n,f)):f=r}return f}getFolderConfigurationModelForResource(n,f){if(f&&n){const r=f.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,f)=>{const{contents:r,overrides:t,keys:d}=this._folderConfigurations.get(f);return n.push([f,{contents:r,overrides:t,keys:d}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(f=>n.add(f)),this.userConfiguration.freeze().keys.forEach(f=>n.add(f)),this._workspaceConfiguration.freeze().keys.forEach(f=>n.add(f)),this._folderConfigurations.forEach(f=>f.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const f=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>f.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>f.add(t))),[...f.values()]}static parse(n){const f=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((l,c)=>(l.set(C.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new A.ResourceMap);return new P(f,r,new p,t,d,new p,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=P;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const n=new Set,f=new Map;for(const t of v)t.keys.forEach(d=>n.add(d)),t.overrides.forEach(([d,l])=>{const c=(0,A.getOrSet)(f,d,new Set);l.forEach(m=>c.add(m))});const r=[];return f.forEach((t,d)=>r.push([d,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class s{constructor(n,f,r,t){this.change=n,this.previous=f,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const d=new Set;n.keys.forEach(c=>d.add(c)),n.overrides.forEach(([,c])=>c.forEach(m=>d.add(m))),this.affectedKeys=[...d.values()];const l=new p;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,f){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(f){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,f,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,f,this.currentWorkspace);return!k.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,f){let r=(0,i.toValuesTree)({[f]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(n,f,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,f);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=o}),define(fe[122],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(A,k=L.Unknown,_){super(A);this._message=A,this._code=k,this._detail=_,this.isHandled=k===L.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(A){return A instanceof D&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof D&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof D&&A.isHandled}}e.RemoteAuthorityResolverError=D}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function D(C){if(!C)return;const i=C.indexOf("+");return i<0?C:C.substr(0,i)}e.getRemoteName=D;function S(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function A(C){if(C.folders.length)return C.folders.every(i=>S(i.uri))?C.folders[0].uri:void 0;if(C.configuration&&S(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=A;function k(C){return A(C)?.scheme}e.getVirtualWorkspaceScheme=k;function _(C){return A(C)!==void 0}e.isVirtualWorkspace=_}),define(fe[27],me([0,1,9,4,64]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=S;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,y=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,y)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=_;function C(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function i(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(a,p){if(p&&a.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return a.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[194],me([0,1,9,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=D;class S{constructor(w,y){this.version=y,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof S?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=S;function A(h,w){return`${h}.${w}`}e.getExtensionId=A;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(h,w){return k(A(h,w))}e.getGalleryExtensionId=_;function C(h,w){const y=[],P=b=>{for(const s of y)if(s.some(o=>D(w(o),w(b))))return s;return null};for(const b of h){const s=P(b);s?s.push(b):y.push([b])}return y}e.groupByExtension=C;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function a(h){const w=new Set;for(const y of h)y.malicious&&w.add(y.id.id);return w}e.getMaliciousExtensionsSet=a;function p(h,w){const y=[],P=w.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const b=P.shift();if(b&&y.every(s=>!D(s.identifier,{id:b}))){const s=h.filter(o=>D(o.identifier,{id:b}));s.length===1&&(y.push(s[0]),P.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function a(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=a;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,y){return this._tunnelProvider=w,w?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],y=Array.from(this._tunnels.values());for(let P of y){const b=Array.from(P.values());for(let s of b){const o=await s.value;o&&w.push(o)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:y}of w.values())await y.then(P=>P?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,y,P,b,s=!1,o=k.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${P} on local port ${b}.`),!w)return;y||(y="localhost");const n=this.retainOrCreateTunnel(w,y,P,b,s,o,v);return n?n.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(f);return(f.tunnelRemoteHost!==y||f.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const y=this._tunnels.get(w.tunnelRemoteHost);if(y){const P=y.get(w.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,P))}}}}async tryDisposeTunnel(w,y,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${y}.`);const b=P.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(y),b}}async closeTunnel(w,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${y} `);const P=this._tunnels.get(w);if(P&&P.has(y)){const b=P.get(y);b.refcount=0,await this.tryDisposeTunnel(w,y,b)}}addTunnelToMap(w,y,P){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(y,{refcount:1,value:P})}async removeEmptyTunnelFromMap(w,y){const P=this._tunnels.get(w);P&&(await P.get(y)||P.delete(y),P.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,y){let P=[w];i(w)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const b=P.map(s=>this._tunnels.get(s));for(const s of b){const o=s?.get(y);if(o)return o}}canTunnel(w){return!!C(w)}createWithProvider(w,y,P,b,s,o,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${P} on local port ${b}.`);const f={elevationRequired:s?a(b===void 0?P:b):!1},r={remoteAddress:{host:y,port:P},localAddressPort:b,privacy:o,public:o!==k.Private,protocol:v},t=w.forwardPort(r,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(y,P,t),t}};p=Ve([We(0,S.ILogService)],p),e.AbstractTunnelService=p}),define(fe[195],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((D,S)=>Y(["vsda"],D,S))}async createNewMessage(D){try{const S=await this.vsda(),A=new S.validator;if(A){const k=String(g._nextId++);return this.validators.set(k,A),{id:k,data:A.createNewMessage(D)}}}catch(S){}return{id:"",data:D}}async validate(D,S){if(!D.id)return!0;const A=this.validators.get(D.id);if(!A)return!1;this.validators.delete(D.id);try{return A.validate(S)==="ok"}catch(k){return!1}}async sign(D){try{const S=await this.vsda(),A=new S.signer;if(A)return A.sign(D)}catch(S){}return D}}e.SignService=g,g._nextId=1}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,S,A=5){let k;return k=S(_=>{const C=typeof _=="string"?_:_.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(D),A);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,i)}),k}stopBuffering(D){const S=this._terminalBufferMap.get(D);S&&S.dispose()}flushBuffer(D){const S=this._terminalBufferMap.get(D);S&&(this._terminalBufferMap.delete(D),this._callback(D,S.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,47,3,6,4,34,197]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var _;(function(y){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}y.isThemeColor=P})(_=e.ThemeColor||(e.ThemeColor={}));function C(y){return{id:y}}e.themeColorFromId=C;var i;(function(y){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color=="undefined"||_.isThemeColor(f.color))}y.isThemeIcon=P;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function s(f){const r=b.exec(f);if(!r)return;let[,t]=r;return{id:t}}y.fromString=s;function o(f,r){let t=f.id;const d=t.lastIndexOf("~");return d!==-1&&(t=t.substring(0,d)),r&&(t=`${t}~${r}`),{id:t}}y.modify=o;function v(f,r){return f.id===r.id&&f.color?.id===r.color?.id}y.isEqual=v;function n(f,r){return{id:f.id,color:r?C(r):void 0}}y.asThemeIcon=n,y.asClassNameArray=g.CSSIcon.asClassNameArray,y.asClassName=g.CSSIcon.asClassName,y.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(y){switch(y){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(P);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new a;A.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,b){let s=this.theme.getColor(P);return s&&b&&(s=b(s,this.theme)),s?s.toString():null}}e.Themable=w}),define(fe[198],me([0,1,16,47,3,162,120,34,65]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,b,s,o){const v=this.iconsById[P];if(v){if(s&&!v.description){v.description=s,this.iconSchema.properties[P].markdownDescription=`${s} $(${P})`;const r=this.iconReferenceSchema.enum.indexOf(P);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return v}let n={id:P,description:s,defaults:b,deprecationMessage:o};this.iconsById[P]=n;let f={$ref:"#/definitions/icons"};return o&&(f.deprecationMessage=o),s&&(f.markdownDescription=`${s}: $(${P})`),this.iconSchema.properties[P]=f,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const b=this.iconReferenceSchema.enum.indexOf(P);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,b){const s=this.iconFontsById[P];if(s)return s;let o={id:P,definition:b};return this.iconFontsById[P]=o,this._onDidChange.fire(),o}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(v,n)=>v.id.localeCompare(n.id),b=v=>{for(;_.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of o.filter(n=>!!n.description).sort(P))s.push(`|<i class="${b(v)}"></i>|${v.id}|${_.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const v of o.filter(n=>!_.ThemeIcon.isThemeIcon(n.defaults)).sort(P))s.push(`|<i class="${b(v)}"></i>|${v.id}|`);return s.join(`
`)}}const i=new C;k.Registry.add(e.Extensions.IconContribution,i);function I(y,P,b,s){return i.registerIcon(y,P,b,s)}e.registerIcon=I;function a(){return i}e.getIconRegistry=a;function p(){for(const y of L.iconRegistry.all)i.registerIcon(y.id,y.definition,y.description);L.iconRegistry.onDidRegister(y=>i.registerIcon(y.id,y.definition,y.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let h=k.Registry.as(A.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=_.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var A;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function k(a){const p=a;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=k;function _(a){const p=a;return!!(p&&typeof p=="object"&&D.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(p,h,w,y,P){this._id=p,this._transient=w,this._configuration=y,this._ignorePathCasing=P,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class i{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(a){return new i({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(fe[199],me([0,1,29,61,140,81,10,8,11,23,2,163,4,64,44]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(M){return(typeof M=="string"?(0,k.extname)(M):(0,C.extname)(M))===w}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function v(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=v;function n(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=n;function f(M){const z=M;if(z?.uri)return{id:z.id,uri:i.URI.revive(z.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=f;function r(M,z){return C.extUriBiasedIgnorePathCase.isEqualOrParent(M,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function t(M){return d(M)||l(M)}e.isStoredWorkspaceFolder=t;function d(M){const z=M;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=d;function l(M){const z=M;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=l;function c(M,z,U,x,j=!_.isWindows,O){if(M.scheme!==x.scheme)return{name:U,uri:M.toString(!0)};let H=z?void 0:O.relativePath(x,M);if(H!==void 0)H.length===0?H=".":_.isWindows&&M.scheme===A.Schemas.file&&!j&&(H=H.replace(/\//g,"\\"));else if(M.scheme===A.Schemas.file)H=M.fsPath,_.isWindows&&(H=(0,S.normalizeDriveLetter)(H),j&&(H=(0,g.toSlashes)(H)));else{if(!O.isEqualAuthority(M.authority,x.authority))return{name:U,uri:M.toString(!0)};H=M.path}return{name:U,path:H}}e.getStoredWorkspaceFolder=c;function m(M,z,U){let x=[],j=new Set;const O=U.dirname(z);for(let H of M){let W;if(d(H))H.path&&(W=U.resolvePath(O,H.path));else if(l(H))try{W=i.URI.parse(H.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(X){console.warn(X)}if(W){let X=U.getComparisonKey(W);if(!j.has(X)){j.add(X);const K=H.name||U.basenameOrAuthority(W);x.push(new h.WorkspaceFolder({uri:W,name:K,index:x.length},H))}}}return x}e.toWorkspaceFolders=m;function u(M,z,U,x,j){let O=E(z,M);const H=j.dirname(z),W=j.dirname(x),X=[],K=T(O.folders);for(const Pe of O.folders){const Be=d(Pe)?j.resolvePath(H,Pe.path):i.URI.parse(Pe.uri);let $e;U?$e=!1:$e=!d(Pe)||(0,k.isAbsolute)(Pe.path),X.push(c(Be,$e,Pe.name,W,K,j))}const de={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},_e=D.setProperty(M,["folders"],X,de);let Ce=D.applyEdits(M,_e);return(0,C.isEqualAuthority)(O.remoteAuthority,(0,p.getRemoteAuthority)(x))&&(Ce=D.applyEdits(Ce,D.removeProperty(Ce,["remoteAuthority"],de))),Ce}e.rewriteWorkspaceFileForNewLocation=u;function E(M,z){let U=L.parse(z);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>t(x));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function T(M){return _.isWindows?M.some(z=>d(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function N(M){return typeof M.fileUri=="string"}function F(M,z){const U={workspaces:[],files:[]};if(M){const x=function(O,H){for(let W=0;W<O.length;W++)try{H(O[W],W)}catch(X){z.warn(`Error restoring recent entry ${JSON.stringify(O[W])}: ${X.toString()}. Skip entry.`)}},j=M;if(Array.isArray(j.entries))x(j.entries,O=>{const H=O.label,W=O.remoteAuthority;R(O)?U.workspaces.push({label:H,remoteAuthority:W,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):B(O)?U.workspaces.push({label:H,remoteAuthority:W,folderUri:i.URI.parse(O.folderUri)}):N(O)&&U.files.push({label:H,remoteAuthority:W,fileUri:i.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&x(O.workspaces3,(H,W)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[W]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:H.id,configPath:i.URI.parse(H.configURIPath)}}):typeof H=="string"&&U.workspaces.push({label:X,folderUri:i.URI.parse(H)})}),Array.isArray(O.files2)&&x(O.files2,(H,W)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[W]||void 0;typeof H=="string"&&U.files.push({label:X,fileUri:i.URI.parse(H)})})}}return U}e.restoreRecentlyOpened=F;function $(M){const z={entries:[]};for(const U of M.workspaces)b(U)?z.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):z.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)z.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return z}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const S=this._idPool++;return this._data.set(S,D),this.logDebugInfo(),S}get(D,S){return this._data.has(D)?this._data.get(D)[S]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[53],me([0,1,10,23,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k):this._providerInfo.set(k,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(fe[28],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[200],me([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,k,_){this._deferredPromises=new Map,this._id=A,this._shared=k,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,k){let _=this._value[A];return typeof _=="undefined"&&(_=k),_}update(A,k){this._value[A]=k;let _=this._deferredPromises.get(A);if(_!==void 0)return _.p;const C=new g.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(A,k){super(A.identifier.value,!0,k);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=D}),define(fe[201],me([0,1,3,2,13]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,C){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(_.value,C)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const C=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};S=Ve([We(0,D.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[202],me([0,1,27,3]),function(Y,e,g,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(k,_){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(k.identifier),st(this,D,_,"f"),Ne(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(k){return Ne(this,D,"f").get(this._id,k)}store(k,_){return Ne(this,D,"f").store(this._id,k,_)}delete(k){return Ne(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=S,D=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(b,s)=>{const o={controllerId:s};return L.set(b,o),o};e.createPrivateApiFor=D;const S=b=>L.get(b);e.getPrivateApiFor=S;const A=(b,s,o,v)=>{let n=o;return{enumerable:!0,configurable:!1,get(){return n},set(f){if(!v(n,f)){const r=n;n=f,b.listener?.({op:3,key:s,value:f,previous:r})}}}},k=(b,s)=>b===s,_={range:(b,s)=>b===s?!0:!b||!s?!1:b.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(b,s)=>!(b.length!==s.length||b.some(o=>!s.find(v=>o.id===v.id)))},C=Object.keys(_),i=(b,s)=>({range:A(b,"range",void 0,_.range),label:A(b,"label",s,_.label),description:A(b,"description",void 0,_.description),canResolveChildren:A(b,"canResolveChildren",!1,_.canResolveChildren),busy:A(b,"busy",!1,_.busy),error:A(b,"error",void 0,_.error),tags:A(b,"tags",[],_.tags)}),I=(b,s)=>{const o=new Map;for(const v of C)_[v](b[v],s[v])||o.set(v,s[v]);return o};e.diffTestItems=I;class a extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=a;class p extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class h extends Error{constructor(s,o,v){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=h;const w=b=>{const s=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(v,n){for(const f of o.values())v.call(n,f,this)},replace(v){const n=new Map,f=new Set(o.keys()),r={op:4,ops:[]};for(const t of v){if(!(t instanceof y))throw new p(t.id);const d=(0,e.getPrivateApiFor)(t).controllerId;if(d!==s.controllerId)throw new h(t.id,d,s.controllerId);if(n.has(t.id))throw new a(t.id);n.set(t.id,t),f.delete(t.id),r.ops.push({op:0,item:t})}for(const t of f.keys())r.ops.push({op:1,id:t});s.listener?.(r),o=n},add(v){if(!(v instanceof y))throw new p(v.id);o.set(v.id,v),s.listener?.({op:0,item:v})},delete(v){o.delete(v)&&s.listener?.({op:1,id:v})},get(v){return o.get(v)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class y{constructor(s,o,v,n){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const f=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof P?void 0:f.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(f,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=y;class P extends y{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=P}),define(fe[54],me([0,1,4,123,3,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(_){function C(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}_.fromApiTunnel=C;function i(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}_.fromServiceTunnel=i})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(C){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,i){return{dispose:()=>{}}}async $providePortAttributes(C,i,I,a,p){return[]}async $forwardPort(C,i){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([We(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,15,18,99,24,103,9,12,2,32,40,122]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";var p,h,w,y,P,b,s,o,v,n,f,r,t,d,l,c,m,u,E,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function V(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(V,q),Object.setPrototypeOf(V.prototype,q.prototype),V}let B=P=class{constructor(V){p.set(this,void 0),st(this,p,V,"f")}static from(...V){let ae=V;return new P(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}dispose(){typeof Ne(this,p,"f")=="function"&&(Ne(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,B=P=Ve([R],B),e.Disposable=B;let N=b=class{constructor(V,ae){if(V<0)throw(0,L.illegalArgument)("line must be non-negative");if(ae<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=V,this._character=ae}static Min(...V){if(V.length===0)throw new TypeError;let ae=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isBefore(ae)&&(ae=Je)}return ae}static Max(...V){if(V.length===0)throw new TypeError;let ae=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isAfter(ae)&&(ae=Je)}return ae}static isPosition(V){if(!V)return!1;if(V instanceof b)return!0;let{line:ae,character:ke}=V;return typeof ae=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,ae=0){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=0:typeof V=="number"?ke=V:(ke=typeof V.lineDelta=="number"?V.lineDelta:0,ae=typeof V.characterDelta=="number"?V.characterDelta:0),ke===0&&ae===0?this:new b(this.line+ke,this.character+ae)}with(V,ae=this.character){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=this.line:typeof V=="number"?ke=V:(ke=typeof V.line=="number"?V.line:this.line,ae=typeof V.character=="number"?V.character:this.character),ke===this.line&&ae===this.character?this:new b(ke,ae)}toJSON(){return{line:this.line,character:this.character}}};N=b=Ve([R],N),e.Position=N;let F=s=class{constructor(V,ae,ke,Je){let ot,dt;if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new N(V,ae),dt=new N(ke,Je)):V instanceof N&&ae instanceof N&&(ot=V,dt=ae),!ot||!dt)throw new Error("Invalid arguments");ot.isBefore(dt)?(this._start=ot,this._end=dt):(this._start=dt,this._end=ot)}static isRange(V){return V instanceof s?!0:V?N.isPosition(V.start)&&N.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof s?this.contains(V._start)&&this.contains(V._end):V instanceof N?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const ae=N.Max(V.start,this._start),ke=N.Min(V.end,this._end);if(!ae.isAfter(ke))return new s(ae,ke)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ae=N.Min(V.start,this._start),ke=N.Max(V.end,this.end);return new s(ae,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,ae=this.end){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return V?N.isPosition(V)?ke=V:(ke=V.start||this.start,ae=V.end||this.end):ke=this.start,ke.isEqual(this._start)&&ae.isEqual(this.end)?this:new s(ke,ae)}toJSON(){return[this.start,this.end]}};F=s=Ve([R],F),e.Range=F;let $=o=class extends F{constructor(V,ae,ke,Je){let ot,dt;if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new N(V,ae),dt=new N(ke,Je)):V instanceof N&&ae instanceof N&&(ot=V,dt=ae),!ot||!dt)throw new Error("Invalid arguments");super(ot,dt);this._anchor=ot,this._active=dt}static isSelection(V){return V instanceof o?!0:V?F.isRange(V)&&N.isPosition(V.anchor)&&N.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=o=Ve([R],$),e.Selection=$;class M{constructor(V,ae,ke){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(ae),this.connectionToken=ke}}e.ResolvedAuthority=M;class z extends Error{constructor(V,ae=a.RemoteAuthorityResolverErrorCode.Unknown,ke){super(V);this._message=V,this._code=ae,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(V,ae){return new z(V,a.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(V){return new z(V,a.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var U;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=v=class{constructor(V,ae){this._range=V,this._newText=ae}static isTextEdit(V){return V instanceof v?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ae){return new v(V,ae)}static insert(V,ae){return v.replace(new F(V,V),ae)}static delete(V){return v.replace(V,"")}static setEndOfLine(V){const ae=new v(new F(new N(0,0),new N(0,0)),"");return ae.newEol=V,ae}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,L.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,L.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,L.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=v=Ve([R],j),e.TextEdit=j;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let H=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,ae,ke,Je){this._edits.push({_type:1,from:V,to:ae,options:ke,metadata:Je})}createFile(V,ae,ke){this._edits.push({_type:1,from:void 0,to:V,options:ae,metadata:ke})}deleteFile(V,ae,ke){this._edits.push({_type:1,from:V,to:void 0,options:ae,metadata:ke})}replaceNotebookMetadata(V,ae,ke){this._edits.push({_type:3,metadata:ke,uri:V,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells(V,ae,ke,Je,ot){let dt,mt,kt=[],Rt;if(Ht.isNotebookRange(ae)&&Oe.isNotebookCellDataArray(ke)&&!Oe.isNotebookCellDataArray(Je)?(dt=ae.start,mt=ae.end,kt=ke,Rt=Je):typeof ae=="number"&&typeof ke=="number"&&Oe.isNotebookCellDataArray(Je)&&(dt=ae,mt=ke,kt=Je,Rt=ot),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||kt.length>0)&&this._edits.push({_type:5,uri:V,index:dt,count:mt-dt,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(V,ae,ke,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:8,index:ae,metadata:ke}})}replace(V,ae,ke,Je){this._edits.push({_type:2,uri:V,edit:new j(ae,ke),metadata:Je})}insert(V,ae,ke,Je){this.replace(V,new F(ae,ae),ke,Je)}delete(V,ae,ke){this.replace(V,ae,"",ke)}has(V){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===V.toString())}set(V,ae){if(ae)for(const ke of ae)ke&&this._edits.push({_type:2,uri:V,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===V.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(V){const ae=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===V.toString()&&ae.push(ke.edit);return ae}entries(){const V=new S.ResourceMap;for(let ae of this._edits)if(ae._type===2){let ke=V.get(ae.uri);ke||(ke=[ae.uri,[]],V.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};H=Ve([R],H),e.WorkspaceEdit=H;let W=n=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof n?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=n._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ae=this._tabstop++){if(typeof V=="function"){const ke=new n;ke._tabstop=this._tabstop,V(ke),this._tabstop=ke._tabstop,V=ke.value}else V=n._escape(V);return this.value+="${",this.value+=ae,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ae=this._tabstop++){const ke=V.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(V,ae){if(typeof ae=="function"){const ke=new n;ke._tabstop=this._tabstop,ae(ke),this._tabstop=ke._tabstop,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};W=n=Ve([R],W),e.SnippetString=W;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=f=class{constructor(V,ae){if(this.uri=V,ae)if(ae instanceof F)this.range=ae;else if(ae instanceof N)this.range=new F(ae,ae);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof f?!0:V?F.isRange(V.range)&&C.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=f=Ve([R],de),e.Location=de;let _e=class{constructor(V,ae){this.location=V,this.message=ae}static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&C.URI.isUri(V.location.uri):!1}static isEqual(V,ae){return V===ae?!0:!V||!ae?!1:V.message===ae.message&&V.location.range.isEqual(ae.location.range)&&V.location.uri.toString()===ae.location.uri.toString()}};_e=Ve([R],_e),e.DiagnosticRelatedInformation=_e;let Ce=class{constructor(V,ae,ke=K.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=V,this.message=ae,this.severity=ke}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ae){return V===ae?!0:!V||!ae?!1:V.message===ae.message&&V.severity===ae.severity&&V.code===ae.code&&V.severity===ae.severity&&V.source===ae.source&&V.range.isEqual(ae.range)&&(0,g.equals)(V.tags,ae.tags)&&(0,g.equals)(V.relatedInformation,ae.relatedInformation,_e.isEqual)}};Ce=Ve([R],Ce),e.Diagnostic=Ce;let Pe=class{constructor(V,ae){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ae}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(V,ae=Be.Text){this.range=V,this.kind=ae}toJSON(){return{range:this.range,kind:Be[this.kind]}}};$e=Ve([R],$e),e.DocumentHighlight=$e;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(V,ae,ke,Je,ot){this.name=V,this.kind=ae,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),r.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=r=Ve([R],ee),e.SymbolInformation=ee;let te=t=class{constructor(V,ae,ke,Je,ot){this.name=V,this.detail=ae,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(t.validate)}};te=t=Ve([R],te),e.DocumentSymbol=te;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(V,ae){this.title=V,this.kind=ae}};Z=Ve([R],Z),e.CodeAction=Z;let se=d=class{constructor(V){this.value=V}append(V){return new d(this.value?this.value+d.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+d.sep)}};se.sep=".",se=d=Ve([R],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let pe=class{constructor(V,ae){if(this.range=V,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(V,ae,ke,Je,ot,dt){this.kind=V,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(V,ae){this.fromRanges=ae,this.from=V}}e.CallHierarchyIncomingCall=je;class Ke{constructor(V,ae){this.fromRanges=ae,this.to=V}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(V,ae){this.range=V,this.command=ae}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ct=l=class{constructor(V,ae=!1){h.set(this,void 0),st(this,h,new D.MarkdownString(V,{supportThemeIcons:ae}),"f")}static isMarkdownString(V){return V instanceof l?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Ne(this,h,"f").value}set value(V){Ne(this,h,"f").value=V}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(V){Ne(this,h,"f").isTrusted=V}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(V){Ne(this,h,"f").supportThemeIcons=V}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(V){Ne(this,h,"f").supportHtml=V}appendText(V){return Ne(this,h,"f").appendText(V),this}appendMarkdown(V){return Ne(this,h,"f").appendMarkdown(V),this}appendCodeblock(V,ae){return Ne(this,h,"f").appendCodeblock(ae??"",V),this}};h=new WeakMap,ct=l=Ve([R],ct),e.MarkdownString=ct;let ye=class{constructor(V,ae){this.label=V,this.documentation=ae}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(V,ae){this.label=V,this.documentation=ae,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ie;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(V,ae,ke){this.text=V,this.position=ae,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ue=class{constructor(V,ae){this.label=V,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ue=Ve([R],Ue),e.CompletionItem=Ue;let Xe=class{constructor(V=[],ae=!1){this.items=V,this.isIncomplete=ae}};Xe=Ve([R],Xe),e.CompletionList=Xe;let it=class{constructor(V,ae,ke){this.text=V,this.range=ae,this.command=ke}};it=Ve([R],it),e.InlineSuggestion=it;let ft=class{constructor(V){this.items=V}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ae;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ae=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function V(ae){switch(ae){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(V,ae){if(ae&&!C.URI.isUri(ae))throw(0,L.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.target=ae}};ve=Ve([R],ve),e.DocumentLink=ve;let Fe=class{constructor(V,ae,ke,Je){this.red=V,this.green=ae,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let Ge=class{constructor(V,ae){if(ae&&!(ae instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.color=ae}};Ge=Ve([R],Ge),e.ColorInformation=Ge;let ze=class{constructor(V){if(!V||typeof V!="string")throw(0,L.illegalArgument)("label");this.label=V}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(V,ae,ke){if(this.startIndex=V,this.length=ae,this.tooltip=ke,typeof V!="number"||V<0)throw(0,L.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class be{constructor(V){this.options=V,typeof V!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=be;var re;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=c=class{constructor(V,ae){if(this.label=ae,typeof V!="string"||typeof ae!="string")throw(0,L.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Se.Clean=new c("clean","Clean"),Se.Build=new c("build","Build"),Se.Rebuild=new c("rebuild","Rebuild"),Se.Test=new c("test","Test"),Se=c=Ve([R],Se),e.TaskGroup=Se;function Le(q){let V="";for(let ae=0;ae<q.length;ae++)V+=q[ae].replace(/,/g,",,")+",";return V}let nt=class{constructor(V,ae,ke){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=V,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=ke):this._options=ae)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)V.push(ae);return Le(V)}};nt=Ve([R],nt),e.ProcessExecution=nt;let qe=class{constructor(V,ae,ke){if(this._args=[],Array.isArray(ae)){if(!V)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V,this._args=ae,this._options=ke}else{if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V,this._options=ae}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)V.push(typeof ae=="string"?ae:ae.value);return Le(V)}};qe=Ve([R],qe),e.ShellExecution=qe;var gt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,i.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=pt;let vt=m=class{constructor(V,ae,ke,Je,ot,dt){this.__deprecated=!1,this._definition=this.definition=V;let mt;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=ke,this.execution=Je,mt=ot,this.__deprecated=!0):ae===Et.Global||ae===Et.Workspace?(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt):(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof nt?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,i.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const ae=this._definition.type;(m.EmptyType===ae||m.ProcessType===ae||m.ShellType===ae||m.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=m=Ve([R],vt),e.Task=vt;var wt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let Dt=class{constructor(V,ae=Ct.None){this.collapsibleState=ae,C.URI.isUri(V)?this.resourceUri=V:this.label=V}};Dt=Ve([R],Dt),e.TreeItem=Dt;var Ct;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let At=class{constructor(V,ae){this.id=V,this.color=ae}};At=Ve([R],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let Nt=class{constructor(V){this.id=V}};Nt=Ve([R],Nt),e.ThemeColor=Nt;var It;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(It=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ut=class{constructor(V,ae){if(typeof V!="string"&&(!V||!C.URI.isUri(V)&&!C.URI.isUri(V.uri)))throw(0,L.illegalArgument)("base");if(typeof ae!="string")throw(0,L.illegalArgument)("pattern");typeof V=="string"?(this.baseFolder=C.URI.file(V),this.base=V):C.URI.isUri(V)?(this.baseFolder=V,this.base=V.fsPath):(this.baseFolder=V.uri,this.base=V.uri.fsPath),this.pattern=ae}};Ut=Ve([R],Ut),e.RelativePattern=Ut;let $t=class{constructor(V,ae,ke,Je){this.enabled=typeof V=="boolean"?V:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,i.generateUuid)()),this._id}};$t=Ve([R],$t),e.Breakpoint=$t;let St=class extends $t{constructor(V,ae,ke,Je,ot){super(ae,ke,Je,ot);if(V===null)throw(0,L.illegalArgument)("location");this.location=V}};St=Ve([R],St),e.SourceBreakpoint=St;let Qt=class extends $t{constructor(V,ae,ke,Je,ot){super(ae,ke,Je,ot);this.functionName=V}};Qt=Ve([R],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(V,ae,ke,Je,ot,dt,mt){super(Je,ot,dt,mt);if(!ae)throw(0,L.illegalArgument)("dataId");this.label=V,this.dataId=ae,this.canPersist=ke}};zt=Ve([R],zt),e.DataBreakpoint=zt;let nn=class{constructor(V,ae,ke){this.command=V,this.args=ae||[],this.options=ke}};nn=Ve([R],nn),e.DebugAdapterExecutable=nn;let rn=class{constructor(V,ae){this.port=V,this.host=ae}};rn=Ve([R],rn),e.DebugAdapterServer=rn;let Tt=class{constructor(V){this.path=V}};Tt=Ve([R],Tt),e.DebugAdapterNamedPipeServer=Tt;let Xt=class{constructor(V){this.implementation=V}};Xt=Ve([R],Xt),e.DebugAdapterInlineImplementation=Xt;let sn=class{constructor(V,ae){this.range=V,this.expression=ae}};sn=Ve([R],sn),e.EvaluatableExpression=sn;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(V,ae){this.range=V,this.text=ae}};Wt=Ve([R],Wt),e.InlineValueText=Wt;let bt=class{constructor(V,ae,ke=!0){this.range=V,this.variableName=ae,this.caseSensitiveLookup=ke}};bt=Ve([R],bt),e.InlineValueVariableLookup=bt;let on=class{constructor(V,ae){this.range=V,this.expression=ae}};on=Ve([R],on),e.InlineValueEvaluatableExpression=on;let Ft=class{constructor(V,ae){this.frameId=V,this.stoppedLocation=ae}};Ft=Ve([R],Ft),e.InlineValueContext=Ft;var Vt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Jt=u=class extends Error{constructor(V,ae=I.FileSystemProviderErrorCode.Unknown,ke){super(C.URI.isUri(V)?V.toString(!0):V);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(V){return new u(V,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(V){return new u(V,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(V){return new u(V,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(V){return new u(V,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Jt=u=Ve([R],Jt),e.FileSystemError=Jt;let an=class{constructor(V,ae,ke){this.start=V,this.end=ae,this.kind=ke}};an=Ve([R],an),e.FoldingRange=an;var hn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(hn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var fn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(fn=e.CommentMode||(e.CommentMode={}));class Zt{constructor(V,ae=[]){this.tokenTypes=V,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function En(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class jt{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let ae=0,ke=V.tokenTypes.length;ae<ke;ae++)this._tokenTypeStrToInt.set(V.tokenTypes[ae],ae);for(let ae=0,ke=V.tokenModifiers.length;ae<ke;ae++)this._tokenModifierStrToInt.set(V.tokenModifiers[ae],ae)}}push(V,ae,ke,Je,ot){if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(V,ae,ke,Je,ot);if(F.isRange(V)&&typeof ae=="string"&&En(ke))return this._push(V,ae,ke);throw(0,L.illegalArgument)()}_push(V,ae,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,ot=V.start.character,dt=V.end.character-V.start.character,mt=this._tokenTypeStrToInt.get(ae);let kt=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Mt>>>0}this._pushEncoded(Je,ot,dt,mt,kt)}_pushEncoded(V,ae,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<kt;Ot++){let xt=this._data[5*Ot],un=this._data[5*Ot+1];xt===0?(xt=Rt,un+=Mt):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=un,Rt=xt,Mt=un}}let dt=V,mt=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=V,this._prevChar=ae}static _sortAndDeltaEncode(V){let ae=[];const ke=V.length/5|0;for(let mt=0;mt<ke;mt++)ae[mt]=mt;ae.sort((mt,kt)=>{const Rt=V[5*mt],Mt=V[5*kt];if(Rt===Mt){const Ot=V[5*mt+1],xt=V[5*kt+1];return Ot-xt}return Rt-Mt});const Je=new Uint32Array(V.length);let ot=0,dt=0;for(let mt=0;mt<ke;mt++){const kt=5*ae[mt],Rt=V[kt+0],Mt=V[kt+1],Ot=V[kt+2],xt=V[kt+3],un=V[kt+4],Bn=Rt-ot,Kn=Bn===0?Mt-dt:Mt,dn=5*mt;Je[dn+0]=Bn,Je[dn+1]=Kn,Je[dn+2]=Ot,Je[dn+3]=xt,Je[dn+4]=un,ot=Rt,dt=Mt}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),V):new qt(jt._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=jt;class qt{constructor(V,ae){this.resultId=ae,this.data=V}}e.SemanticTokens=qt;class _n{constructor(V,ae,ke){this.start=V,this.deleteCount=ae,this.data=ke}}e.SemanticTokensEdit=_n;class Sn{constructor(V,ae){this.resultId=ae,this.edits=V}}e.SemanticTokensEdits=Sn;var Gt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let en=class{constructor(){}};en.Back={iconPath:new At("arrow-left")},en=Ve([R],en),e.QuickInputButtons=en;var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(V,ae,ke){this.badge=V,this.tooltip=ae,this.color=ke}static validate(V){if(V.badge){let ae=(0,k.nextCharLength)(V.badge,0);if(ae<V.badge.length&&(ae+=(0,k.nextCharLength)(V.badge,ae)),V.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Cn;let Kt=class{constructor(V){this.kind=V}};Kt=Ve([R],Kt),e.ColorTheme=Kt;var mn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(mn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(V,ae){if(V<0)throw(0,L.illegalArgument)("start must be positive");if(ae<0)throw(0,L.illegalArgument)("end must be positive");V<=ae?(this._start=V,this._end=ae):(this._start=ae,this._end=V)}static isNotebookRange(V){return V instanceof Ht?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let ae=this._start,ke=this._end;return V.start!==void 0&&(ae=V.start),V.end!==void 0&&(ke=V.end),ae===this._start&&ke===this._end?this:new Ht(ae,ke)}}e.NotebookRange=Ht;class Oe{constructor(V,ae,ke,Je,ot,dt,mt){this.kind=V,this.value=ae,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=dt,this.executionSummary=mt,Oe.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ae=>Oe.isNotebookCellData(ae))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Oe;class ln{constructor(V){this.cells=V}}e.NotebookData=ln;class Lt{constructor(V,ae){this.data=V,this.mime=ae;const ke=(0,A.normalizeMimeType)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(V){return V instanceof Lt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ae={name:V.name,message:V.message,stack:V.stack};return Lt.json(ae,"application/vnd.code.notebook.error")}static stdout(V){return Lt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Lt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ae="application/octet-stream"){return new Lt(V,ae)}static text(V,ae=A.Mimes.text){const ke=Ne(Lt,w,"f",y).encode(String(V));return new Lt(ke,ae)}static json(V,ae="application/json"){const ke=JSON.stringify(V,void 0,"	");return Lt.text(ke,ae)}}e.NotebookCellOutputItem=Lt,w=Lt,y={value:new TextEncoder};class _t{constructor(V,ae,ke){this.items=_t.ensureUniqueMimeTypes(V,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,i.generateUuid)(),this.metadata=ae??ke)}static isNotebookCellOutput(V){return V instanceof _t?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,_.isArray)(V.items)}static ensureUniqueMimeTypes(V,ae=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<V.length;ot++){const dt=V[ot],mt=(0,A.normalizeMimeType)(dt.mime);if(!ke.has(mt)){ke.add(mt);continue}Je.add(ot),ae&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?V:V.filter((ot,dt)=>!Je.has(dt))}}e.NotebookCellOutput=_t;var kn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(kn=e.NotebookCellKind||(e.NotebookCellKind={}));var In;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(In=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(V,ae){this.text=V,this.alignment=ae}}e.NotebookCellStatusBarItem=Pn;var An;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(An=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(V,ae=[]){this.uri=V,this.provides=(0,g.asArray)(ae)}}e.NotebookRendererScript=Tn;let cn=class{constructor(V,ae){this.label=V,this.timestamp=ae}};cn=Ve([R],cn),e.TimelineItem=cn;var vn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(V,ae){this.ranges=V,this.wordPattern=ae}}e.LinkedEditingRanges=Fn;class Mn{constructor(V,ae){this._port=V,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var ne;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ne=e.TestRunProfileKind||(e.TestRunProfileKind={}));let he=class{constructor(V=void 0,ae=void 0,ke=void 0){this.include=V,this.exclude=ae,this.profile=ke}};he=Ve([R],he),e.TestRunRequest=he;let Te=E=class{constructor(V){this.message=V}static diff(V,ae,ke){const Je=new E(V);return Je.expectedOutput=ae,Je.actualOutput=ke,Je}};Te=E=Ve([R],Te),e.TestMessage=Te;let ht=class{constructor(V){this.id=V}};ht=Ve([R],ht),e.TestTag=ht;let yt=class{constructor(V,ae){this.covered=V,this.total=ae}};yt=Ve([R],yt),e.CoveredCount=yt;let Pt=T=class{constructor(V,ae,ke,Je){this.uri=V,this.statementCoverage=ae,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(V,ae){const ke=new yt(0,0),Je=new yt(0,0),ot=new yt(0,0);for(const mt of ae)if("branches"in mt){ke.total+=1,ke.covered+=mt.executionCount>0?1:0;for(const kt of mt.branches)Je.total+=1,Je.covered+=kt.executionCount>0?1:0}else ot.total+=1,ot.covered+=mt.executionCount>0?1:0;const dt=new T(V,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return dt.detailedCoverage=ae,dt}};Pt=T=Ve([R],Pt),e.FileCoverage=Pt;let Nn=class{constructor(V,ae,ke=[]){this.executionCount=V,this.location=ae,this.branches=ke}};Nn=Ve([R],Nn),e.StatementCoverage=Nn;let Un=class{constructor(V,ae){this.executionCount=V,this.location=ae}};Un=Ve([R],Un),e.BranchCoverage=Un;let xn=class{constructor(V,ae){this.executionCount=V,this.location=ae}};xn=Ve([R],xn),e.FunctionCoverage=xn;var Vn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gn{constructor(V,ae,ke,Je,ot,dt){this.kind=V,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.TypeHierarchyItem=Gn}),define(fe[125],me([0,1,58,10,9,150,111,7,15]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(h,w){w?C.set(h,w):C.delete(h)}e.setWordDefinitionFor=i;function I(h){return C.get(h)}e.getWordDefinitionFor=I;class a extends S.MirrorTextModel{constructor(w,y,P,b,s,o,v,n){super(y,P,b,s);this._proxy=w,this._languageId=o,this._isDirty=v,this._notebook=n,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,_.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(y){return y?w._getTextInRange(y):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(y){return w._lineAt(y)},offsetAt(y){return w._offsetAt(y)},positionAt(y){return w._positionAt(y)},validateRange(y){return w._validateRange(y)},validatePosition(y){return w._validatePosition(y)},getWordRangeAtPosition(y,P){return w._getWordRangeAtPosition(y,P)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const y=this._validateRange(w);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const P=this._eol,b=y.start.line,s=y.end.line,o=[];o.push(this._lines[b].substring(y.start.character));for(let v=b+1;v<s;v++)o.push(this._lines[v]);return o.push(this._lines[s].substring(0,y.end.character)),o.join(P)}_lineAt(w){let y;if(w instanceof k.Position?y=w.line:typeof w=="number"&&(y=w),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new p(y,this._lines[y],y===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(w),P=this._lines[y.index].length;return new k.Position(y.index,Math.min(y.remainder,P))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const y=this._validatePosition(w.start),P=this._validatePosition(w.end);return y===w.start&&P===w.end?w:new k.Range(y.line,y.character,P.line,P.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:y,character:P}=w,b=!1;if(y<0)y=0,P=0,b=!0;else if(y>=this._lines.length)y=this._lines.length-1,P=this._lines[y].length,b=!0;else{const s=this._lines[y].length;P<0?(P=0,b=!0):P>s&&(P=s,b=!0)}return b?new k.Position(y,P):w}_getWordRangeAtPosition(w,y){const P=this._validatePosition(w);if(!y)y=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const b=(0,A.getWordAtText)(P.character+1,(0,A.ensureValidWordDefinition)(y),this._lines[P.line],0);if(b)return new k.Range(P.line,b.startColumn-1,P.line,b.endColumn-1)}}e.ExtHostDocumentData=a;class p{constructor(w,y,P){this._line=w,this._text=y,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[203],me([0,1,7,3,113,6,83,24,2,32]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(a,p,h,w){this._notebook=h,this._selector=w,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(P=>{const b=this._cellUris.get(P.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(P=>y(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const a=[],p=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),a.push(h.document.getText().length+1),p.push(h.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(a){if(!a){let b="";for(const s of this._cells)b+=s.document.getText()+`
`;return b=b.slice(0,-1),b}if(a.isEmpty)return"";const p=this.locationAt(a.start),h=this.locationAt(a.end),w=this._cellUris.get(p.uri),y=this._cellUris.get(h.uri);if(w===void 0||y===void 0)return"";if(w===y)return this._cells[w].document.getText(new g.Range(p.range.start,h.range.end));const P=[this._cells[w].document.getText(new g.Range(p.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<y;b++)P.push(this._cells[b].document.getText());return P.push(this._cells[y].document.getText(new g.Range(new g.Position(0,0),h.range.end))),P.join(`
`)}offsetAt(a){const p=this._cellLines.getIndexOf(a.line),h=this._cellLengths.getPrefixSum(p.index-1),w=this._cells[p.index].document.offsetAt(a.with(p.remainder));return h+w}positionAt(a){if(typeof a=="number"){const h=this._cellLengths.getIndexOf(a),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const p=this._cellUris.get(a.uri);if(p!==void 0){const h=this._cellLines.getPrefixSum(p-1);return new g.Position(h+a.range.start.line,a.range.start.character)}return new g.Position(0,0)}locationAt(a){g.Range.isRange(a)||(a=new g.Range(a,a));const p=this._cellLines.getIndexOf(a.start.line);let h=p;a.isEmpty||(h=this._cellLines.getIndexOf(a.end.line));const w=new g.Position(p.remainder,a.start.character),y=new g.Position(h.remainder,a.end.character),P=new g.Range(w,y),b=this._cells[p.index];return new g.Location(b.document.uri,b.document.validateRange(P))}contains(a){return this._cellUris.has(a)}validateRange(a){const p=this.validatePosition(a.start),h=this.validatePosition(a.end);return a.with(p,h)}validatePosition(a){const p=this._cellLines.getIndexOf(a.line),h=new g.Position(p.remainder,a.character),w=this._cells[p.index].document.validatePosition(h),y=this._cellLines.getPrefixSum(p.index-1);return new g.Position(y+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[204],me([0,1,7,14,3]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(k){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?g.ColorThemeKind.Light:k==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([We(0,L.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(fe[205],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function D(k,_){if(_.serializeBuffersForPostMessage){const C=new L,i=(p,h)=>{if(h instanceof ArrayBuffer){const w=C.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=S(h);if(w){const y=C.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:y,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(k,i),a=C.buffers.map(p=>{const h=new Uint8Array(p);return g.VSBuffer.wrap(h)});return{message:I,buffers:a}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function S(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(k,_){const C=_.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),i=_.length?(a,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const h=p,{index:w}=h,y=C[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(y,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(y,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(y,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(y,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(y,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(y,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(y,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(y,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(y,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(y,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(y,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return y}return p}:void 0;return{message:JSON.parse(k,i),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(fe[206],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function D(A){const k={items:new Map};return A.types.forEach((_,C)=>{k.items.set(_,{asString:async()=>A.items[C].asString})}),k}L.toITreeDataTransfer=D;async function S(A){const k={types:[],items:[]},_=Array.from(A.items.entries());for(const C of _)k.types.push(C[0]),k.items.push({asString:await C[1].asString()});return k}L.toTreeDataTransferDTO=S})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,_){return k.scheme===g.Schemas.http||k.scheme===g.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===g.Schemas.file&&(k=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:_.authority,path:k.path})),L.URI.from({scheme:g.Schemas.https,authority:`${k.scheme}+${S(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function S(k){return k.replace(/./g,_=>{const C=_.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?_:"-"+C.toString(16).padStart(4,"0")})}function A(k){return k.replace(/-([0-9a-f]{4})/g,(_,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=A}),define(fe[207],me([0,1,3,6,89]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(k,_,C){this._proxy=k,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const i=_.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,C,i,I){let a;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){a=s;break}if(!a)throw new Error("not a visible editor");const p=this,h=this._handlePool++,w=new g.Emitter,y=new g.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,D.asWebviewUri)(s,p._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(s){this._options=s,p._proxy.$setOptions(h,s)}get options(){return this._options}set html(s){this._html=s,p._proxy.$setHtml(h,s)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(s){return p._proxy.$postMessage(h,s)}},b=new class{constructor(){this.editor=k,this.line=_,this.height=C,this.webview=P,this.onDidDispose=y.event}dispose(){p._insets.has(h)&&(p._insets.delete(h),p._proxy.$disposeEditorInset(h),y.fire(),y.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,a.id,a.value.document.uri,_+1,C,i||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:k,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const C=this._insets.get(k);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=S}),define(fe[208],me([0,1,173,12,2,6,4,63,34,40,15,10]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function a(N,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&N.matches(M.input))return M.getViewState()}e.findViewStateForEditor=a;function p(N){if(v(N))return!1;const F=N;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=p;function h(N){if(v(N))return!1;const F=N;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function w(N){if(v(N)||h(N))return!1;const F=N;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function y(N){if(v(N))return!1;const F=N;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;var P;(function(N){N[N.SHORT=0]="SHORT",N[N.MEDIUM=1]="MEDIUM",N[N.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var b;(function(N){N[N.EXPLICIT=1]="EXPLICIT",N[N.AUTO=2]="AUTO",N[N.FOCUS_CHANGE=3]="FOCUS_CHANGE",N[N.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var s;(function(N){N[N.None=0]="None",N[N.Readonly=2]="Readonly",N[N.Untitled=4]="Untitled",N[N.Singleton=8]="Singleton",N[N.RequiresTrust=16]="RequiresTrust",N[N.CanSplitInGroup=32]="CanSplitInGroup",N[N.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends S.Disposable{}e.AbstractEditorInput=o;function v(N){return N instanceof o}e.isEditorInput=v;function n(N){const F=N;return D.URI.isUri(F?.preferredResource)}function f(N){const F=N;return v(F?.primary)&&v(F?.secondary)}e.isSideBySideEditorInput=f;function r(N){const F=N;return v(F?.modified)&&v(F?.original)}e.isDiffEditorInput=r;function t(N){return v(N?.editor)}e.isEditorInputWithOptions=t;function d(N){const F=N;return t(N)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=d;function l(N){const F=N;return typeof F?.groupId=="number"&&v(F.editor)}e.isEditorIdentifier=l;var c;(function(N){N[N.UNKNOWN=0]="UNKNOWN",N[N.REPLACE=1]="REPLACE",N[N.MOVE=2]="MOVE",N[N.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(N){N[N.PRIMARY=1]="PRIMARY",N[N.SECONDARY=2]="SECONDARY",N[N.BOTH=3]="BOTH",N[N.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:U}=this.getSideEditors(F);if(z&&U){if($?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getOriginalUri(z,{filterByScheme:$.filterByScheme})??this.getOriginalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:U}}if(h(F)||w(F))return;const M=n(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return f(F)||w(F)?{primary:F.primary,secondary:F.secondary}:r(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:U}=this.getSideEditors(F);if(z&&U){if($?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getCanonicalUri(z,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:U}}if(h(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new u;var E;(function(N){N[N.LEFT=0]="LEFT",N[N.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(A.IInstantiationService);for(const[M,z]of this.editorSerializerConstructors)this.createEditorSerializer(M,z,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const z=M.createInstance($);this.editorSerializerInstances.set(F,z)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new T);async function R(N,F){if(!N||!N.length)return[];const $=await Promise.all(N.map(async M=>{const z=D.URI.revive(M.fileUri);if(!z||!await F.canHandleResource(z))return;let x=M.exists,j=M.type;if(typeof x!="boolean"||typeof j!="number")try{j=(await F.resolve(z)).isFile?C.FileType.File:C.FileType.Unknown,x=!0}catch{x=!1}if(!x&&M.openOnlyIfExists||j!==C.FileType.File)return;const O={selection:x?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let H;return x?H={resource:z,options:O}:H={resource:z,options:O,forceUntitled:!0},H}));return(0,i.coalesce)($)}e.pathsToEditors=R;var B;(function(N){N[N.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",N[N.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[209],me([0,1,3,63,174,4,6,24,34,15,59,25,47,198]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",a.Codicon.window,(0,D.localize)(0,null));var h;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var w;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function y(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=y;function P(d){return`viewContainer.${d}.enabled`}e.getEnabledViewContainerContextKey=P;class b extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,m){const u=this.get(l.id);if(u)return u;const E=l;return E.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,k.getOrSet)(this.viewContainers,c,[]).push(E),m?.isDefault&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const m=this.viewContainers.get(c),u=m?.indexOf(l);if(u!==-1){m?.splice(u,1),m.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}_.Registry.add(h.ViewContainersRegistry,new b);var s;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function o(d,l){const c=d.group??s.More,m=l.group??s.More;return c!==m?c.localeCompare(m):(d.order??5)-(l.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:m})=>this.addViews(c,m)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const m=this.removeViews(l,c);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:c})}moveViews(l,c){for(const m of this._views.keys())if(m!==c){const u=this.removeViews(l,m);u.length&&(this.addViews(u,c),this._onDidChangeContainer.fire({views:u,from:m,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const m=(this._views.get(c)||[]).filter(u=>u.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(u=>u.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const m=new Map;for(const[u,E]of c)this._viewWelcomeContents.add(l,E),m.set(u,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(l,E),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),m}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,m=>c.push(m)),c.sort(o)}addViews(l,c){let m=this._views.get(c);m||(m=[],this._views.set(c,m),this._viewContainers.push(c));for(const u of l){if(this.getView(u.id)!==null)throw new Error((0,D.localize)(1,null,u.id));m.push(u)}}removeViews(l,c){const m=this._views.get(c);if(!m)return[];const u=[],E=[];for(const T of m)l.includes(T)?u.push(T):E.push(T);return u.length&&(E.length?this._views.set(c,E):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),u}}_.Registry.add(h.ViewsRegistry,new v),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,D.localize)(2,null));function n(d){return`view.${d}.visible`}e.getVisbileViewContextKey=n,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var f;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(f=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,l),this._hasResolve=!!c,this.resolve=async m=>{if(c&&!this.resolved){const u=await c(m);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,16,175]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,C,i){const I={command:k};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof i=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,D.localize)(0,null,i,k)};p(h)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const _=k,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,C)=>k.set(C,_)),await(0,L.timeout)(500),k.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(fe[210],me([0,1,9,2,8,25,10]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(r,t,d){return r.replace(k,function(l,c){return t&&c.length>0&&c[0]!=="_"?l:d&&d.hasOwnProperty(c)?d[c]:l})}e.formatPII=_;function C(r){const t={};for(const d of Object.keys(r))d.startsWith("!")||(t[d]=r[d]);return t}e.filterExceptionsFromTelemetry=C;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=a;function p(r,t,d){let l,c=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=m.exec(r);){let E=u.index+1,T=E+u[0].length;if(E<=t&&T>=d){l=u[0],c=E;break}}if(l){let E=/\w+/g,T=null;for(;(T=E.exec(l))&&!(T.index+1+c+T[0].length>=d););T&&(l=l.substring(0,E.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(h))}e.isUri=w;function y(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return L.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function P(r){if(typeof r.path=="object"){const t=L.URI.revive(r.path);if(t)return t.scheme===A.Schemas.file?t.fsPath:t.toString()}return r.path}function b(r,t){const d=t?y:P,l=(0,S.deepClone)(r);return o(l,(c,m)=>{c&&m&&(m.path=d(m))}),l}e.convertToDAPaths=b;function s(r,t){const d=t?y:P,l=(0,S.deepClone)(r);return o(l,(c,m)=>{!c&&m&&(m.path=d(m))}),l}e.convertToVSCPaths=s;function o(r,t){switch(r.type){case"event":const d=r;switch(d.event){case"output":t(!1,d.body.source);break;case"loadedSource":t(!1,d.body.source);break;case"breakpoint":t(!1,d.body.breakpoint.source);break;default:break}break;case"request":const l=r;switch(l.command){case"setBreakpoints":t(!0,l.arguments.source);break;case"breakpointLocations":t(!0,l.arguments.source);break;case"source":t(!0,l.arguments.source);break;case"gotoTargets":t(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(m=>t(!1,m));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(m=>t(!1,m.source));break;case"loadedSources":c.body.sources.forEach(m=>t(!1,m));break;case"scopes":c.body.scopes.forEach(m=>t(!1,m.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;case"setBreakpoints":c.body.breakpoints.forEach(m=>t(!1,m.source));break;default:break}break}}function v(r){return r.filter(t=>!t.presentation?.hidden).sort((t,d)=>t.presentation?d.presentation?t.presentation.group?d.presentation.group?t.presentation.group!==d.presentation.group?t.presentation.group.localeCompare(d.presentation.group):n(t.presentation.order,d.presentation.order):-1:d.presentation.group?1:n(t.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=v;function n(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function f(r,t){const d=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(d!=="none"&&(await t.saveAll(),d==="allEditorsInActiveGroup")){const l=t.activeEditorPane;l&&await t.save({editor:l.input,groupId:l.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(fe[211],me([0,1,26,39,176,127,8,9,25,11,186,126]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const s=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${a.TWO_CRLF}${s}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(a.TWO_CRLF);if(s!==-1){const v=this.rawData.toString("utf8",0,s).split(a.HEADER_LINESEPARATOR);for(const n of v){const f=n.split(a.HEADER_FIELDSEPARATOR);f[0]==="Content-Length"&&(this.contentLength=Number(f[1]))}this.rawData=this.rawData.slice(s+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class p extends a{startSession(){return new Promise((b,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",v=>{o?this._onError.fire(v):s(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class h extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class y extends a{constructor(b,s,o){super();this.adapterExecutable=b,this.debugType=s,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(D.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let v=process.env;if(o.env&&Object.keys(o.env).length>0&&(v=_.mixin(_.deepClone(process.env),o.env)),b==="node")if(Array.isArray(s)&&s.length>0){const f=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:f?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const t=L.fork(s[0],s.slice(1),r);if(!t.pid)throw new Error(D.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const f={env:v};o.cwd&&(f.cwd=o.cwd),this.serverProcess=L.spawn(b,s,f)}this.serverProcess.on("error",f=>{this._onError.fire(f)}),this.serverProcess.on("exit",(f,r)=>{this._onExit.fire(f)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",f=>{this._onError.fire(f)}),this.serverProcess.stdin.on("error",f=>{this._onError.fire(f)});const n=this.outputService;if(n){const f=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=n.getChannel(i.ExtensionsChannelId);t&&t.append(f(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((b,s)=>{const o=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,n,f){if(v)return s(v)});o.on("exit",b),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,s){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=A.join(s,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?o.program=b.program:o.program=A.join(s,b.program)),b.args&&(o.args=b.args);const v=b;return v.win&&(o.win=y.extract(v.win,s)),v.winx86&&(o.winx86=y.extract(v.winx86,s)),v.windows&&(o.windows=y.extract(v.windows,s)),v.osx&&(o.osx=y.extract(v.osx,s)),v.linux&&(o.linux=y.extract(v.linux,s)),o}static platformAdapterExecutable(b,s){let o=Object.create(null);s=s.toLowerCase();for(const d of b)if(d.contributes){const l=d.contributes.debuggers;l&&l.length>0&&l.filter(c=>typeof c.type=="string"&&k.equalsIgnoreCase(c.type,s)).forEach(c=>{const m=y.extract(c,d.extensionLocation.fsPath);o=_.mixin(o,m,d.isBuiltin)})}let v;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=o.winx86||o.win||o.windows:C.isWindows?v=o.win||o.windows:C.isMacintosh?v=o.osx:C.isLinux&&(v=o.linux),v=v||o;let n=v.program||o.program;const f=v.args||o.args;let r=v.runtime||o.runtime;const t=v.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof n=="string"?[n]:[]).concat(f||[])};if(n)return{type:"executable",command:n,args:f||[]}}}e.ExecutableDebugAdapter=y}),define(fe[212],me([0,1,39,11,29,188]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(a,p){return new Promise((h,w)=>{let y="";const P=g.spawn(a,p);P.pid&&P.stdout.on("data",b=>{y+=b.toString()}),P.on("error",b=>{w(b)}),P.on("close",b=>{h(y)})})}let k;function _(a,p){if(!k)if(L.isWindows)k=new S.WindowsExternalTerminalService;else if(L.isMacintosh)k=new S.MacExternalTerminalService;else if(L.isLinux)k=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=p.getConfiguration("terminal");return k.runInTerminal(a.title,a.cwd,a.args,a.env||{},h.external||{})}e.runInExternalTerminal=_;async function C(a){if(a)if(L.isWindows){const p=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{p.getProcessTree(a,w=>{h(w.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(a)]).then(p=>{const h=p.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var i;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(i||(i={}));function I(a,p,h,w){a=a.trim().toLowerCase();let y;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?y=1:a.indexOf("cmd.exe")>=0?y=0:a.indexOf("bash")>=0?y=2:L.isWindows?y=0:y=2;let P,b=" ";switch(y){case 1:if(P=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),h){const o=(0,D.getDriveLetter)(h);o&&(b+=`${o}:; `),b+=`cd ${P(h)}; `}if(w)for(let o in w){const v=w[o];v===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${v}'; `}if(p.length>0){const o=P(p.shift());b+=o[0]==="'"?`& ${o} `:`${o} `;for(let v of p)b+=`${P(v)} `}break;case 0:if(P=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),h){const o=(0,D.getDriveLetter)(h);o&&(b+=`${o}: && `),b+=`cd ${P(h)} && `}if(w){b+='cmd /C "';for(let o in w){let v=w[o];v===null?b+=`set "${o}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,n=>`^${n}`),b+=`set "${o}=${v}" && `)}}for(let o of p)b+=`${P(o)} `;w&&(b+='"');break;case 2:P=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(b+=`cd ${P(h)} ; `),w){b+="/usr/bin/env";for(let o in w){const v=w[o];v===null?b+=` -u ${s(o)}`:b+=` ${s(`${o}=${v}`)}`}b+=" "}for(let o of p)b+=`${P(o)} `;break}return b}e.prepareCommand=I}),define(fe[128],me([0,1,30,78,103,10,8,11,63]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var i;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(i=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var a;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(a=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var y;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(y=e.CellEditType||(e.CellEditType={}));var P;(function(E){E.scheme=S.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function R(M,z){return M.with({scheme:E.scheme,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}E.generate=R;function B(M){if(M.scheme!==E.scheme)return;const z=T.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}E.parse=B;function N(M){if(M.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const z=T.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=N;function F(M,z,U){return M.with({scheme:U,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}E.generateCellUri=F;function $(M,z){if(M.scheme!==z)return;const U=T.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||S.Schemas.file,fragment:null})}:void 0}E.parseCellUri=$})(P=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(E){return b.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function o(E){return b.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function v(E){return b.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=v;const n=E=>k.isWindows?E.replace(/\//g,"\\"):E;class f{constructor(T=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(T)].map(B=>({pattern:B,matches:g.parse(n(B))}))}sort(T){const R=new Map(L.Iterable.map(T,N=>[N,n(N)]));let B=[];for(const{matches:N}of this.order)for(const[F,$]of R)if(N($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((N,F)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(F)))),B}prioritize(T,R){const B=this.findIndex(T);if(B===-1){this.order.unshift({pattern:T,matches:g.parse(n(T))});return}const N=new Set(R.map($=>this.findIndex($,B)));N.delete(-1);const F=Array.from(N).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,R=this.order.length){const B=n(T);for(let N=0;N<R;N++)if(this.order[N].matches(B))return N;return-1}}e.MimeTypeDisplayOrder=f;function r(E,T,R,B=(N,F)=>N===F){const N=[];function F(z,U,x){if(U===0&&x.length===0)return;const j=N[N.length-1];j&&j.start+j.deleteCount===z?(j.deleteCount+=U,j.toInsert.push(...x)):N.push({start:z,deleteCount:U,toInsert:x})}let $=0,M=0;for(;;){if($===E.length){F($,0,T.slice(M));break}if(M===T.length){F($,E.length-$,[]);break}const z=E[$],U=T[M];if(B(z,U)){$+=1,M+=1;continue}R(U)?(F($,1,[]),$+=1):(F($,0,[U]),M+=1)}return N}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(E){const T=E;return!!((typeof T.include=="string"||g.isRelativePattern(T.include))&&(typeof T.exclude=="string"||g.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=d;function l(E,T,R){if(Array.isArray(E.viewType)&&E.viewType.indexOf(T)>=0||E.viewType===T)return!0;if(E.filenamePattern){let B=d(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=d(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(g.match(B,(0,A.basename)(R.fsPath).toLowerCase()))return!(N&&g.match(N,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)T[R]=this.textModel.cells[R].getHashValue();return T}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var m;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(T){return`${u._prefix}${T}`}static parse(T){if(T.startsWith(u._prefix))return T.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[213],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[214],me([0,1,178,4,63]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[215],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var S;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(I,a)=>{a.expand!==void 0&&(I.expand=a.expand),a.item!==void 0&&(I.item=I.item?Object.assign(I.item,a.item):a.item)};e.applyTestItemUpdate=A;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(a){}update(a){}remove(a,p){}complete(){}}e.IncrementalChangeCollector=C;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const p=this.createChangeCollector();for(const h of a)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const y=this.items.get(w.parent);y.children.add(w.item.extId);const P=this.createItem(w,y);this.items.set(w.item.extId,P),p.add(P)}}else{const y=this.createItem(w);this.roots.add(y),this.items.set(w.item.extId,y),p.add(y)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],y=this.items.get(w.extId);if(!y)break;w.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,w),p.update(y);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const y=[[h[1]]];for(;y.length;)for(const P of y.pop()){const b=this.items.get(P);b&&(y.push(b.children),this.items.delete(P),p.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}p.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=i}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(S){S.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(A,k=A.length){if(this.path=A,this.viewEnd=k,A.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,k,_=A.parent){if(A.id===k)return new D([k]);let C=[A.id];for(let i=_;i&&i.id!==k;i=i.parent)C.push(i.id);return C.push(k),new D(C.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new D(A.split("\0"))}static join(A,k){return new D([...A.path,k])}static joinToString(A,k){return A.toString()+"\0"+k}static compare(A,k){return A===k?0:k.startsWith(A+"\0")?2:A.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new D(this.path,A)}compare(A){if(typeof A=="string")return D.compare(this.toString(),A);for(let k=0;k<A.viewEnd&&k<this.viewEnd;k++)if(A.path[k]!==this.path[k])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=D}),define(fe[216],me([0,1,8,38,12,25,11,81,179]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,a,p){this._contributedVariables=new Map,this._context=I,this._labelService=a,p&&(this._envVariablesPromise=p.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(A.isWindows){const a=Object.create(null);return Object.keys(I).forEach(p=>{a[p.toLowerCase()]=I[p]}),a}return I}resolveWithEnvironment(I,a,p){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,p)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,p,h){const w=S.deepClone(a);return A.isWindows&&w.windows?Object.keys(w.windows).forEach(y=>w[y]=w.windows[y]):A.isMacintosh&&w.osx?Object.keys(w.osx).forEach(y=>w[y]=w.osx[y]):A.isLinux&&w.linux&&Object.keys(w.linux).forEach(y=>w[y]=w.linux[y]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,p,h)}async resolveAnyAsync(I,a,p){return this.resolveAnyBase(I,a,p)}async resolveAnyMap(I,a,p){const h=new Map;return{newConfig:await this.resolveAnyBase(I,a,p,h),resolvedVariables:h}}resolveWithInteractionReplace(I,a,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,p,h,w){if(D.isString(p))return this.resolveString(I,a,p,h,w);if(D.isArray(p))return p.map(y=>this.recursiveResolve(I,a,y,h,w));if(D.isObject(p)){let y=Object.create(null);return Object.keys(p).forEach(P=>{const b=this.resolveString(I,a,P,h,w);y[b]=this.recursiveResolve(I,a,p[P],h,w)}),y}return p}resolveString(I,a,p,h,w){return p.replace(C.VARIABLE_REGEXP,(P,b)=>{if(b.includes(C.VARIABLE_LHS))return P;let s=this.evaluateSingleVariable(I,P,b,a,h);return w&&w.set(b,s),s!==P&&D.isString(s)&&s.match(C.VARIABLE_REGEXP)&&(s=this.resolveString(I,a,s,h,w)),s})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,p,h,w){let y;const P=p.split(":");P.length>1&&(p=P[0],y=P[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,_.localize)(0,null,a))},s=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,_.localize)(1,null,a,g.basename(v)))},o=()=>{if(y){const v=this._context.getFolderUri(y);if(v)return v;throw new Error((0,_.localize)(2,null,a,y))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,a)):new Error((0,_.localize)(4,null,a))};switch(p){case"env":if(y){if(I){const v=I[A.isWindows?y.toLowerCase():y];if(D.isString(v))return v}return""}throw new Error((0,_.localize)(5,null,a));case"config":if(y){const v=this._context.getConfigurationValue(h,y);if(D.isUndefinedOrNull(v))throw new Error((0,_.localize)(6,null,a,y));if(D.isObject(v))throw new Error((0,_.localize)(7,null,a,y));return v}throw new Error((0,_.localize)(8,null,a));case"command":return this.resolveFromMap(a,y,w,"command");case"input":return this.resolveFromMap(a,y,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||y?(0,k.normalizeDriveLetter)(this.fsPath(o())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(o()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,_.localize)(9,null,a));case"selectedText":const n=this._context.getSelectedText();if(n)return n;throw new Error((0,_.localize)(10,null,a));case"file":return b();case"fileWorkspaceFolder":return s();case"relativeFile":return h||y?g.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":const f=g.dirname(b());if(h||y){const l=g.relative(this.fsPath(o()),f);return l.length===0?".":l}return f;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const r=g.basename(b());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||a;case"execInstallFolder":const d=this._context.getAppRoot();return d||a;case"pathSeparator":return g.sep;default:try{const l=y?`${p}:${y}`:p;return this.resolveFromMap(a,l,w,void 0)}catch(l){return a}}}}resolveFromMap(I,a,p,h){if(a&&p){const w=h===void 0?p[a]:p[h+":"+a];if(typeof w=="string")return w;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,208]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var S;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function C(w){const y=w;return(0,L.isEditorInput)(y?.editor)&&(0,L.isEditorInput)(y?.replacement)}e.isEditorReplacement=C;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function p(w){const y=w;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.isEditorGroup=p;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[217],me([0,1,4,130]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(S){const A=S;return typeof S=="number"||(0,L.isEditorGroup)(A)}e.isPreferredGroup=D}),define(fe[17],me([0,1,15,22,99,292,62,25,12,2,43,85,180,118,66,128,90,217,7]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ge){function be(Q){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:qe}=Q,gt=new b.Position(Se-1,Le-1),Et=new b.Position(nt-1,qe-1);return new b.Selection(gt,Et)}ge.to=be;function re(Q){const{anchor:Se,active:Le}=Q;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=re})(s=e.Selection||(e.Selection={}));var o;(function(ge){function be(Q){if(!Q)return;const{start:Se,end:Le}=Q;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=be;function re(Q){if(!Q)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:nt,endColumn:qe}=Q;return new b.Range(Se-1,Le-1,nt-1,qe-1)}ge.to=re})(o=e.Range||(e.Range={}));var v;(function(ge){function be(re){switch(re){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=be})(v=e.TokenType||(e.TokenType={}));var n;(function(ge){function be(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}ge.to=be;function re(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ge.from=re})(n=e.Position||(e.Position={}));var f;(function(ge){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(nt=>re(nt,Le)))}ge.from=be;function re(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:Q(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:le.from(Se.pattern),exclusive:Se.exclusive}}function Q(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(f=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function be(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=be;function re(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=re})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function be(Q){let Se;return Q.code&&((0,_.isString)(Q.code)||(0,_.isNumber)(Q.code)?Se=String(Q.code):Se={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:Se,severity:l.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(d.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(r.from)):void 0}}ge.from=be;function re(Q){const Se=new b.Diagnostic(o.to(Q),Q.message,l.to(Q.severity));return Se.source=Q.source,Se.code=(0,_.isString)(Q.code)?Q.code:Q.code?.value,Se.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(d.to),Se.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(r.to)),Se}ge.to=re})(t=e.Diagnostic||(e.Diagnostic={}));var d;(function(ge){function be(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ge.from=be;function re(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,o.to(Q)),Q.message)}ge.to=re})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ge){function be(Q){switch(Q){case b.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=be;function re(Q){switch(Q){case p.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=re})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ge){function be(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ge.from=be;function re(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=re})(c=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=u;var E;(function(ge){function be(qe){return qe.map(ge.from)}ge.fromMany=be;function re(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let gt;if(re(qe)){const{language:wt,value:Dt}=qe;gt={value:"```"+wt+`
`+Dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?gt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?gt={value:qe}:gt={value:""};const Et=Object.create(null);gt.uris=Et;const pt=wt=>{try{let Dt=C.URI.parse(wt,!0);Dt=Dt.with({query:Se(Dt.query,Et)}),Et[wt]=Dt}catch(Dt){}return""},vt=new S.Renderer;return vt.link=pt,vt.image=wt=>pt(D.parseHrefAndDimensions(wt).href),S(gt.value,{renderer:vt}),gt}ge.from=Q;function Se(qe,gt){if(!qe)return qe;let Et;try{Et=(0,A.parse)(qe)}catch(vt){}if(!Et)return qe;let pt=!1;return Et=(0,k.cloneAndChange)(Et,vt=>{if(C.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[wt]=vt,pt=!0,wt}else return}),pt?JSON.stringify(Et):qe}function Le(qe){const gt=new b.MarkdownString(qe.value,qe.supportThemeIcons);return gt.isTrusted=qe.isTrusted,gt.supportHtml=qe.supportHtml,gt}ge.to=Le;function nt(qe){if(!!qe)return typeof qe=="string"?qe:ge.from(qe)}ge.fromStrict=nt})(E=e.MarkdownString||(e.MarkdownString={}));function T(ge){return u(ge)?ge.map(be=>({range:o.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?E.fromMany(be.hoverMessage):be.hoverMessage?E.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):ge.map(be=>({range:o.from(be)}))}e.fromRangeOrRangeWithMessage=T;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?C.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function be(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?R(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ge.from=be})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(ge){function be(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?R(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?B.from(re.before):void 0,after:re.after?B.from(re.after):void 0}}ge.from=be})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function be(re){if(typeof re=="undefined")return re;switch(re){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=be})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function be(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?F.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?N.from(re.light):void 0,dark:re.dark?N.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?R(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?B.from(re.before):void 0,after:re.after?B.from(re.after):void 0}}ge.from=be})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function be(Q){return{text:Q.newText,eol:Q.newEol&&J.from(Q.newEol),range:o.from(Q.range)}}ge.from=be;function re(Q){const Se=new b.TextEdit(o.to(Q.range),Q.text);return Se.newEol=typeof Q.eol=="undefined"?void 0:J.to(Q.eol),Se}ge.to=re})(M=e.TextEdit||(e.TextEdit={}));var z;(function(ge){function be(Q,Se,Le){const nt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)nt.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const gt=Se?.getDocument(qe.uri);nt.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:gt?.version,metadata:qe.metadata})}else qe._type===3?nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(tt.from)}});return nt}ge.from=be;function re(Q){const Se=new b.WorkspaceEdit;for(const Le of Q.edits)Le.edit?Se.replace(C.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Se.renameFile(C.URI.revive(Le.oldUri),C.URI.revive(Le.newUri),Le.options);return Se}ge.to=re})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ge){const be=Object.create(null);be[b.SymbolKind.File]=0,be[b.SymbolKind.Module]=1,be[b.SymbolKind.Namespace]=2,be[b.SymbolKind.Package]=3,be[b.SymbolKind.Class]=4,be[b.SymbolKind.Method]=5,be[b.SymbolKind.Property]=6,be[b.SymbolKind.Field]=7,be[b.SymbolKind.Constructor]=8,be[b.SymbolKind.Enum]=9,be[b.SymbolKind.Interface]=10,be[b.SymbolKind.Function]=11,be[b.SymbolKind.Variable]=12,be[b.SymbolKind.Constant]=13,be[b.SymbolKind.String]=14,be[b.SymbolKind.Number]=15,be[b.SymbolKind.Boolean]=16,be[b.SymbolKind.Array]=17,be[b.SymbolKind.Object]=18,be[b.SymbolKind.Key]=19,be[b.SymbolKind.Null]=20,be[b.SymbolKind.EnumMember]=21,be[b.SymbolKind.Struct]=22,be[b.SymbolKind.Event]=23,be[b.SymbolKind.Operator]=24,be[b.SymbolKind.TypeParameter]=25;function re(Se){return typeof be[Se]=="number"?be[Se]:6}ge.from=re;function Q(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=Q})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(ge){function be(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}ge.from=be;function re(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}ge.to=re})(x=e.SymbolTag||(e.SymbolTag={}));var j;(function(ge){function be(Q){return{name:Q.name,kind:U.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}ge.from=be;function re(Q){const Se=new b.SymbolInformation(Q.name,U.to(Q.kind),Q.containerName,K.to(Q.location));return Se.tags=Q.tags&&Q.tags.map(x.to),Se}ge.to=re})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function be(Q){const Se={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:U.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Se.children=Q.children.map(be)),Se}ge.from=be;function re(Q){const Se=new b.DocumentSymbol(Q.name,Q.detail,U.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Se.tags=Q.tags.map(x.to)),Q.children&&(Se.children=Q.children.map(re)),Se}ge.to=re})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(ge){function be(Q){const Se=new b.CallHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",C.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function re(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:Q.name,detail:Q.detail,kind:U.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=re})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(ge){function be(re){return new b.CallHierarchyIncomingCall(H.to(re.from),re.fromRanges.map(Q=>o.to(Q)))}ge.to=be})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function be(re){return new b.CallHierarchyOutgoingCall(H.to(re.to),re.fromRanges.map(Q=>o.to(Q)))}ge.to=be})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(ge){function be(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}ge.from=be;function re(Q){return new b.Location(C.URI.revive(Q.uri),o.to(Q.range))}ge.to=re})(K=e.location||(e.location={}));var de;(function(ge){function be(Q){const Se=Q,Le=Q;return{originSelectionRange:Se.originSelectionRange?o.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:o.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?o.from(Se.targetSelectionRange):void 0}}ge.from=be;function re(Q){return{targetUri:C.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}ge.to=re})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function be(Q){return{range:o.from(Q.range),contents:E.fromMany(Q.contents)}}ge.from=be;function re(Q){return new b.Hover(Q.contents.map(E.to),o.to(Q.range))}ge.to=re})(_e=e.Hover||(e.Hover={}));var Ce;(function(ge){function be(Q){return{range:o.from(Q.range),expression:Q.expression}}ge.from=be;function re(Q){return new b.EvaluatableExpression(o.to(Q.range),Q.expression)}ge.to=re})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function be(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=be;function re(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}ge.to=re})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function be(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}ge.from=be;function re(Q){return new b.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}ge.to=re})(Be=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ge){function be(Q){return{range:o.from(Q.range),kind:Q.kind}}ge.from=be;function re(Q){return new b.DocumentHighlight(o.to(Q.range),Q.kind)}ge.to=re})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function be(re){switch(re){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function be(re){return{triggerKind:He.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ge.to=be})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function be(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}ge.from=be;function re(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}ge.to=re})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(ge){const be=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function re(Le){return be.get(Le)??9}ge.from=re;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return Q.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function be(re,Q){const Se=new b.CompletionItem(re.label);return Se.insertText=re.insertText,Se.kind=te.to(re.kind),Se.tags=re.tags?.map(ee.to),Se.detail=re.detail,Se.documentation=D.isMarkdownString(re.documentation)?E.to(re.documentation):re.documentation,Se.sortText=re.sortText,Se.filterText=re.filterText,Se.preselect=re.preselect,Se.commitCharacters=re.commitCharacters,i.Range.isIRange(re.range)?Se.range=o.to(re.range):typeof re.range=="object"&&(Se.range={inserting:o.to(re.range.insert),replacing:o.to(re.range.replace)}),Se.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Se.insertText=new b.SnippetString(re.insertText):(Se.insertText=re.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Se.additionalTextEdits=re.additionalTextEdits.map(Le=>M.to(Le))),Se.command=Q&&re.command?Q.fromInternal(re.command):void 0,Se}ge.to=be})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0}}ge.from=be;function re(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation}}ge.to=re})(Z=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.from):[],activeParameter:Q.activeParameter}}ge.from=be;function re(Q){return{label:Q.label,documentation:D.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.to):[],activeParameter:Q.activeParameter}}ge.to=re})(se=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function be(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(se.from):[]}}ge.from=be;function re(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(se.to):[]}}ge.to=re})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function be(Q){return{text:Q.text,position:n.from(Q.position),kind:je.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}ge.from=be;function re(Q){const Se=new b.InlayHint(Q.text,n.to(Q.position),je.to(Q.kind));return Se.whitespaceAfter=Q.whitespaceAfter,Se.whitespaceBefore=Q.whitespaceBefore,Se}ge.to=re})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function be(Q){return Q}ge.from=be;function re(Q){return Q}ge.to=re})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function be(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ge.from=be;function re(Q){let Se;if(Q.url)try{Se=typeof Q.url=="string"?C.URI.parse(Q.url,!0):C.URI.revive(Q.url)}catch(Le){}return new b.DocumentLink(o.to(Q.range),Se)}ge.to=re})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function be(Q){const Se=new b.ColorPresentation(Q.label);return Q.textEdit&&(Se.textEdit=M.to(Q.textEdit)),Q.additionalTextEdits&&(Se.additionalTextEdits=Q.additionalTextEdits.map(Le=>M.to(Le))),Se}ge.to=be;function re(Q){return{label:Q.label,textEdit:Q.textEdit?M.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Se=>M.from(Se)):void 0}}ge.from=re})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function be(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}ge.to=be;function re(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ge.from=re})(rt=e.Color||(e.Color={}));var ct;(function(ge){function be(Q){return{range:o.from(Q.range)}}ge.from=be;function re(Q){return new b.SelectionRange(o.to(Q.range))}ge.to=re})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function be(re){switch(re){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=be})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function be(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=be;function re(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=re})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function be(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}ge.from=be;function re(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}ge.to=re})(J=e.EndOfLine||(e.EndOfLine={}));var ie;(function(ge){function be(re){if(typeof re=="object")return re.viewId;switch(re){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=be})(ie=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(ge){function be(re){const Q={start:re.start+1,end:re.end+1};return re.kind&&(Q.kind=Qe.from(re.kind)),Q}ge.from=be})(Ee=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function be(re){if(re)switch(re){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=be})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function be(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?o.from(re.selection):void 0,override:typeof re.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ge.from=be})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function be(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:re(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}ge.from=be;function re(Q){const Se=Q;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function be(re){if(re){if(Array.isArray(re))return re.map(be);if(typeof re=="string")return re;{const Q=re;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:le.from(Q.pattern),exclusive:Q.exclusive}}}else return}ge.from=be})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function be(Q){return{start:Q.start,end:Q.end}}ge.from=be;function re(Q){return new b.NotebookRange(Q.start,Q.end)}ge.to=re})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function be(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ge.to=be;function re(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ge.from=re})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var it;(function(ge){function be(Q){switch(Q){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=be;function re(Q){switch(Q){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=re})(it=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function be(Q){const Se={metadata:Q.metadata??Object.create(null),cells:[]};for(let Le of Q.cells)b.NotebookCellData.validate(Le),Se.cells.push(tt.from(Le));return Se}ge.from=be;function re(Q){const Se=new b.NotebookData(Q.cells.map(tt.to));return(0,_.isEmptyObject)(Q.metadata)||(Se.metadata=Q.metadata),Se}ge.to=re})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function be(Q){return{cellKind:it.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Xe.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Re.from):[]}}ge.from=be;function re(Q){return new b.NotebookCellData(it.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Re.to):void 0,Q.metadata,Q.internalMetadata?Xe.to(Q.internalMetadata):void 0)}ge.to=re})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function be(Q){return{mime:Q.mime,valueBytes:L.VSBuffer.wrap(Q.data)}}ge.from=be;function re(Q){return new b.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ge.to=re})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function be(Q){return{outputId:Q.id,items:Q.items.map(ut.from),metadata:Q.metadata}}ge.from=be;function re(Q){const Se=Q.items.map(ut.to);return new b.NotebookCellOutput(Se,Q.outputId,Q.metadata)}ge.to=re})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function be(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(Q(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=be;function re(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=re;function Q(Le){const nt=Le,qe=le.from(nt.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const gt=le.from(nt.exclude);return!!(gt&&gt instanceof b.RelativePattern||typeof gt=="string")}function Se(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(ge){function be(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?B.from(re.top):void 0}}ge.from=be})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ge){function be(re,Q,Se){const Le=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,Se),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ge.from=be})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function be(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ge.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(ge){function be(Q){return{uri:Q.uri,provides:Q.provides}}ge.from=be;function re(Q){return new b.NotebookRendererScript(C.URI.revive(Q.uri),Q.provides)}ge.to=re})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(ge){function be(Q){return{message:E.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}ge.from=be;function re(Q){const Se=new b.TestMessage(typeof Q.message=="string"?Q.message:E.to(Q.message));return Se.actualOutput=Q.actual,Se.expectedOutput=Q.expected,Se.location=Q.location?K.to(Q.location):void 0,Se}ge.to=re})(ve=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let be;(function(re){re.Delimiter="\0"})(be||(be={})),ge.namespace=(re,Q)=>re+"\0"+Q,ge.denamespace=re=>{const Q=re.indexOf("\0");return{ctrlId:re.slice(0,Q),tagId:re.slice(Q+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ge;(function(ge){function be(Le){const nt=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:y.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(nt,qe.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}ge.from=be;function re(Le){return{parent:void 0,error:void 0,id:y.TestId.fromString(Le.extId).localId,label:Le.label,uri:C.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:qe}=Fe.denamespace(nt);return new b.TestTag(qe)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=re;function Q(Le){const nt=y.TestId.fromString(Le.extId),qe=new h.TestItemImpl(nt.controllerId,nt.localId,Le.label,C.URI.revive(Le.uri));return qe.range=o.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function Se(Le){let nt;for(const qe of Le.tests){const gt=Q(qe.item);(0,h.getPrivateApiFor)(gt).parent=nt,nt=gt}return nt}ge.toItemFromContext=Se})(Ge=e.TestItem||(e.TestItem={})),function(ge){function be(Q){return{id:Q.id}}ge.from=be;function re(Q){return new b.TestTag(Q.id)}ge.to=re}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const be=(Q,Se)=>{const Le={...Ge.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(qe=>qe.type===0).map(ve.to)})),children:Q.children.map(nt=>Se.get(nt)).filter(_.isDefined).map(nt=>be(nt,Se))};for(const nt of Le.children)nt.parent=Le;return Le};function re(Q){const Se=[],Le=new Map;for(const nt of Q.items)Le.set(nt.item.extId,nt),Q.request.targets.some(qe=>qe.controllerId===nt.controllerId&&qe.testIds.includes(nt.item.extId))&&Se.push(nt);return{completedAt:Q.completedAt,results:Se.map(nt=>be(nt,Le))}}ge.to=re})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function be(Le){return{covered:Le.covered,total:Le.covered}}function re(Le){return"line"in Le?n.from(Le):o.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:re(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&re(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:re(Le.location)}}ge.fromDetailed=Q;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}ge.fromFile=Se})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function be(re){switch(re){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=be})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function be(Q){const Se=new b.TypeHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",C.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function re(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:U.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=re})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[218],me([0,1,2,18,7,17,95]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(C,i,I,a={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,a)=>{const h={dispose:this._callbacks.push([i,I,C])};return Array.isArray(a)&&a.push(h),h}}async $participateInSave(C,i){const I=g.URI.revive(C);let a=!1;const p=setTimeout(()=>a=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(a)break;const y=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(w,{document:y,reason:S.TextDocumentSaveReason.to(i)});h.push(P)}}finally{clearTimeout(p)}return h}_deliverEventAsyncAndBlameBadListeners([C,i,I],a){const p=this._badListeners.get(C);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,a).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(C);this._badListeners.set(C,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,a){const p=[],h=Date.now(),{document:w,reason:y}=a,{version:P}=w,b=Object.freeze({document:w,reason:y,waitUntil(s){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{i.apply(I,[b])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,o)=>{const v=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(v),s(n)}).catch(n=>{clearTimeout(v),o(n)})}).then(s=>{const o={edits:[]};for(const v of s)if(Array.isArray(v)&&v.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:f,range:r}of v)o.edits.push({_type:2,resource:w.uri,edit:{range:r&&S.Range.from(r),text:n,eol:f&&S.EndOfLine.from(f)}});if(o.edits.length!==0)return P===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(fe[219],me([0,1,3,30,2,17,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(i,I,a,p,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,a&&(this._config+=1),p&&(this._config+=2),h&&(this._config+=4);const w=(0,L.parse)(I),y=i(P=>{if(!a)for(let b of P.created){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidCreate.fire(s)}if(!p)for(let b of P.changed){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidChange.fire(s)}if(!h)for(let b of P.deleted){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,y)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(i,I,a){this._logService=I,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,a,p){return new k(this._onFileSystemEvent.event,i,I,a,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(a=>D.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(a,p,h)=>{const w=function(P){a.call(p,P)};return w.extension=i,I.event(w,void 0,h)}}async $onWillRunFileOperation(i,I,a,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:D.URI.revive(h.source),newUri:D.URI.revive(h.target)}))},a,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>D.URI.revive(h.target))},a,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>D.URI.revive(h.target))},a,p)}}async _fireWillEvent(i,I,a,p){const h=new Set,w=[];if(await i.fireAsync(I,p,async(P,b)=>{const s=Date.now(),o=await Promise.resolve(P);o instanceof A.WorkspaceEdit&&(w.push(o),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-s>a&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||w.length===0)return;const y={edits:[]};for(let P of w){let{edits:b}=S.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);y.edits=y.edits.concat(b)}return{edit:y,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(fe[220],me([0,1,10,25,2,17,7,128]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(a,p,h,w){this.start=a,this.deletedCount=p,this.deletedItems=h,this.items=w}static asApiEvents(a){return a.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(h=>h.apiCell)}))}}class C{constructor(a,p,h){this.notebook=a,this._extHostDocument=p,this._cellData=h,this.handle=h.handle,this.uri=D.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(a,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return a._mime},set mime(h){a._mime=h},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(S.NotebookCellOutput.to)}setOutputItems(a,p,h){const w=h.map(S.NotebookCellOutputItem.to),y=this._outputs.find(P=>P.id===a);y&&(p||(y.items.length=0),y.items.push(...w))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=C;class i{constructor(a,p,h,w,y,P){this._proxy=a,this._textDocumentsAndEditors=p,this._textDocuments=h,this._emitter=w,this.uri=y,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===g.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(p){return p=a._validateIndex(p),a._cells[p].apiCell},getCells(p){return(p?a._getCells(p):a._cells).map(w=>w.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,p){this._versionId=a.versionId,this._isDirty=p;for(const h of a.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let p=a.start|0,h=a.end|0;return p<0&&(p=0),h>this._cells.length&&(h=this._cells.length),a.with({start:p,end:h})}_getCells(a){a=this._validateRange(a);const p=[];for(let h=a.start;h<a.end;h++)p.push(this._cells[h]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,p){if(this._disposed)return;const h=[],w=[],y=[];a.reverse().forEach(P=>{const s=P[2].map(n=>{const f=new C(this,this._textDocumentsAndEditors,n);return p||w.push(C.asModelAddData(this.apiNotebook,n)),f}),o=new _(P[0],P[1],[],s),v=this._cells.splice(P[0],P[1],...s);for(const n of v)y.push(n.uri),o.deletedItems.push(n.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:y}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(a,p){const h=this._cells.splice(a,1);this._cells.splice(p,0,...h);const w=[new _(a,1,h.map(y=>y.apiCell),[]),new _(p,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(w)}))}_setCellOutputs(a,p){const h=this._cells[a];h.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(a,p,h,w){const y=this._cells[a];y.setOutputItems(p,h,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[y.apiCell]}))}_changeCellLanguage(a,p){const h=this._cells[a];h.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(h.uri,p)}_changeCellMime(a,p){const h=this._cells[a];h.apiCell.mime=p}_changeCellMetadata(a,p){const h=this._cells[a],w=h.apiCell.metadata;h.setMetadata(p);const y=h.apiCell.metadata;(0,L.equals)(w,y)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(a,p){const h=this._cells[a],w=h.internalMetadata;if(h.setInternalMetadata(p),w.runState!==p.runState){const y=p.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:y}))}}getCellFromApiCell(a){return this._cells.find(p=>p.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(p=>p.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[131],me([0,1,7,17,18]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,i){this._throwIfFinalized(),!(_===C&&i.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:i.map(L.NotebookCellData.from)})}}class A{constructor(_,C,i,I,a,p){this.id=_,this._proxy=C,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,i){_._proxy.$tryRevealRange(_.id,L.NotebookRange.from(C),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const i=new S(this.document.version);return C(i),_._applyEdit(i.finalize())},setDecorations(C,i){return _.setDecorations(C,i)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(L.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let i=-1;for(let I=0;I<_.cellEdits.length;I++){if(i<0){C.push(_.cellEdits[I]),i++;continue}const p=C[i],h=_.cellEdits[I];if(p.editType===1&&h.editType===1&&p.index===h.index){p.cells.push(..._.cellEdits[I].cells),p.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[221],me([0,1,17,119,166,21,60,18]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,p,h){const w=this._handles++,{title:y,location:P,cancellable:b}=p,s={label:(0,D.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(P),title:y,source:s,cancellable:b},a).catch(k.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(a,p,h){let w;h&&(w=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,w));const y=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let P;try{P=p(new i(this._proxy,a),h&&w?w.token:S.CancellationToken.None)}catch(b){throw y(a),b}return P.then(b=>y(a),b=>y(a)),P}$acceptProgressCanceled(a){const p=this._mapHandleToCancellationSource.get(a);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=_;function C(I,a){return I.message=a.message,typeof a.increment=="number"&&(typeof I.increment=="number"?I.increment+=a.increment:I.increment=a.increment),I}class i extends L.Progress{constructor(a,p){super(h=>this.throttledReport(h));this._proxy=a,this._handle=p}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,A.throttle)(100,(I,a)=>C(I,a),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[132],me([0,1,58,18,77,17,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(a,p,h){const w=k._Keys.nextId();a.$registerTextEditorDecorationType(p.identifier,w,S.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){a.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class _{constructor(a,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,p){this._throwIfFinalized();let h=null;if(a instanceof A.Position)h=new A.Range(a,a);else if(a instanceof A.Range)h=a;else throw new Error("Unrecognized location");this._pushEdit(h,p,!1)}insert(a,p){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),p,!0)}delete(a){this._throwIfFinalized();let p=null;if(a instanceof A.Range)p=a;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(a,p,h){const w=this._document.validateRange(a);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:h})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=_;class C{constructor(a,p,h,w){this._proxy=a,this._id=p,this._accept(h),this._logService=w;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(P){y._setTabSize(P)},get insertSpaces(){return y._insertSpaces},set insertSpaces(P){y._setInsertSpaces(P)},get cursorStyle(){return y._cursorStyle},set cursorStyle(P){y._setCursorStyle(P)},get lineNumbers(){return y._lineNumbers},set lineNumbers(P){y._setLineNumbers(P)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(a){const p=this._validateTabSize(a);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const p=this._validateInsertSpaces(a);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let h=!1;if(typeof a.tabSize!="undefined"){const w=this._validateTabSize(a.tabSize);w==="auto"?(h=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,p.tabSize=w)}if(typeof a.insertSpaces!="undefined"){const w=this._validateInsertSpaces(a.insertSpaces);w==="auto"?(h=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,p.insertSpaces=w)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,h=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,h=!0,p.lineNumbers=S.TextEditorLineNumbersStyle.from(a.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(a){a.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=C;class i{constructor(a,p,h,w,y,P,b,s){this.id=a,this._proxy=p,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new C(this._proxy,this.id,P,h),this._visibleRanges=b,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,L.illegalArgument)("selection");o._selections=[v],o._trySetSelection()},get selections(){return o._selections},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof A.Selection)))throw(0,L.illegalArgument)("selections");o._selections=v,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return o._options.value},set options(v){o._disposed||o._options.assign(v)},get viewColumn(){return o._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new _(w.getValue(),n);return v(f),o._applyEdit(f)},insertSnippet(v,n,f={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=o._selections.map(t=>S.Range.from(t));else if(n instanceof A.Position){const{lineNumber:t,column:d}=S.Position.from(n);r=[{startLineNumber:t,startColumn:d,endLineNumber:t,endColumn:d}]}else if(n instanceof A.Range)r=[S.Range.from(n)];else{r=[];for(const t of n)if(t instanceof A.Range)r.push(S.Range.from(t));else{const{lineNumber:d,column:l}=S.Position.from(t);r.push({startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l})}}return p.$tryInsertSnippet(a,v.value,r,f)},setDecorations(v,n){const f=n.length===0;f&&!o._hasDecorationsForKey.has(v.key)||(f?o._hasDecorationsForKey.delete(v.key):o._hasDecorationsForKey.add(v.key),o._runOnProxy(()=>{if(S.isDecorationOptionsArr(n))return p.$trySetDecorations(a,v.key,S.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let t=0,d=n.length;t<d;t++){const l=n[t];r[4*t]=l.start.line+1,r[4*t+1]=l.start.character+1,r[4*t+2]=l.end.line+1,r[4*t+3]=l.end.character+1}return p.$trySetDecorationsFast(a,v.key,r)}}))},revealRange(v,n){o._runOnProxy(()=>p.$tryRevealRange(a,S.Range.from(v),n||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,S.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,g.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,g.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,g.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,g.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const h=p.edits.map(y=>y.range);h.sort((y,P)=>y.end.line===P.end.line?y.end.character===P.end.character?y.start.line===P.start.line?y.start.character-P.start.character:y.start.line-P.start.line:y.end.character-P.end.character:y.end.line-P.end.line);for(let y=0,P=h.length-1;y<P;y++){const b=h[y].end;if(h[y+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(y=>({range:S.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?S.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(fe[222],me([0,1,169,23,2,3,6,209,16,7,12,15,17,21,206]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,s){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class y{constructor(s,o,v){this._proxy=s,this.commands=o,this.logService=v,this.treeViews=new Map;function n(f){return f&&f.$treeViewId&&f.$treeItemHandle}o.registerArgumentProcessor({processArgument:f=>n(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(r=>n(r)?this.convertArgument(r):r):f})}registerTreeDataProvider(s,o,v){const n=this.createTreeView(s,{treeDataProvider:o},v);return{dispose:()=>n.dispose()}}createTreeView(s,o,v){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=o.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:n}),r=this.createExtHostTreeView(s,o,v);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(t){r.message=t},get title(){return r.title},set title(t){r.title=t},get description(){return r.description},set description(t){r.description=t},reveal:(t,d)=>r.reveal(t,d),dispose:async()=>{await f,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,o){const v=this.treeViews.get(s);return v?v.getChildren(o):Promise.reject(new Error((0,g.localize)(0,null,s)))}async $onDrop(s,o,v){const n=this.treeViews.get(s);if(!n)return Promise.reject(new Error((0,g.localize)(1,null,s)));const f=h.TreeDataTransferConverter.toITreeDataTransfer(o);if(f.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await f.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(d=>n.getExtensionElement(d)).filter(d=>!!d);t.length>0?f.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):f.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return n.onDrop(f,v)}async $hasResolve(s){const o=this.treeViews.get(s);if(!o)throw new Error((0,g.localize)(2,null,s));return o.hasResolve}$resolve(s,o,v){const n=this.treeViews.get(s);if(!n)throw new Error((0,g.localize)(3,null,s));return n.resolveTreeItem(o,v)}$setExpanded(s,o,v){const n=this.treeViews.get(s);if(!n)throw new Error((0,g.localize)(4,null,s));n.setExpanded(o,v)}$setSelection(s,o){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(5,null,s));v.setSelection(o)}$setVisible(s,o){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(6,null,s));v.setVisible(o)}createExtHostTreeView(s,o,v){const n=new P(s,o,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(s,n),n}convertArgument(s){const o=this.treeViews.get(s.$treeViewId);return o?o.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=y;class P extends A.Disposable{constructor(s,o,v,n,f,r){super();if(this.viewId=s,this.proxy=v,this.commands=n,this.logService=f,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const c of r.contributes.views[l])c.id===s&&(this._title=c.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let t,d;this._register(S.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(t||(t=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return t=null,this.refresh(c).then(()=>m())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,i.isUndefinedOrNull)(s))}async getChildren(s){const o=s?this.getExtensionElement(s):void 0;if(s&&!o)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(s);return v||(v=await this.fetchChildrenNodes(o)),v?v.map(n=>n.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,o){o=o||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(o.select)?!0:o.select,n=(0,i.isUndefinedOrNull)(o.focus)?!1:o.focus,f=(0,i.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:r.map(d=>d.item)},{select:v,focus:n,expand:f})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:n,expand:f})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,o){const v=this.getExtensionElement(s);v&&(o?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(s){(0,I.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,o){const v=this.getExtensionElement(o);if(!!v)return(0,_.asPromise)(()=>this.dndController?.onDrop(s,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,o){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(s);if(v){const n=this.nodes.get(v);if(n){const f=await this.dataProvider.resolveTreeItem(n.extensionItem,v,o)??n.extensionItem;return n.item.tooltip=this.getTooltip(f.tooltip),n.item.command=this.getCommand(n.disposableStore,f.command),n.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(o=>o?this.resolveUnknownParentChain(o).then(v=>this.resolveTreeNode(o,v[v.length-1]).then(n=>(v.push(n),v))):Promise.resolve([]))}resolveParent(s){const o=this.nodes.get(s);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,o){const v=this.nodes.get(s);return v?Promise.resolve(v):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(n=>this.createHandle(s,n,o,!0)).then(n=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(n);if(f){const r=this.nodes.get(f);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(s){if(s){let o;if(typeof s=="string"){const v=this.getExtensionElement(s);o=v?this.nodes.get(v):void 0}else o=s;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const o=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=s?this.nodes.get(s):void 0,n=await this.dataProvider.getChildren(s);if(o.token.isCancellationRequested)return;const f=await Promise.all((0,I.coalesce)(n||[]).map(async r=>{const t=await this.dataProvider.getTreeItem(r);return t&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,t,v):null}));return o.token.isCancellationRequested?void 0:(0,I.coalesce)(f)}finally{o.dispose()}}refresh(s){if(s.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(s);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const o=new Set,v=s.map(f=>this.nodes.get(f));for(const f of v)if(f&&!o.has(f.item.handle)){let r=f;for(;r&&r.parent&&v.findIndex(t=>r&&r.parent&&t&&t.item.handle===r.parent.item.handle)===-1;){const t=this.elements.get(r.parent.item.handle);r=t?this.nodes.get(t):void 0}r&&!r.parent&&o.add(f.item.handle)}const n=[];return o.forEach(f=>{const r=this.elements.get(f);if(r){const t=this.nodes.get(r);t&&(!t.parent||!o.has(t.parent.item.handle))&&n.push(f)}}),n}refreshHandles(s){const o={};return Promise.all(s.map(v=>this.refreshNode(v).then(n=>{n&&(o[v]=n.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(s){const o=this.getExtensionElement(s);if(o){const v=this.nodes.get(o);if(v)return this.clearChildren(o),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(n=>{if(n){const f=this.createTreeNode(o,n,v.parent);return this.updateNodeCache(o,f,v,v.parent),v.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,o,v){const n=this.createTreeNode(s,o,v);if(o.id&&this.elements.has(n.item.handle))throw new Error((0,g.localize)(7,null,o.id));return this.addNodeToCache(s,n),this.addNodeToParentCache(n,v),n}getTooltip(s){return C.MarkdownString.isMarkdownString(s)?a.MarkdownString.from(s):s}getCommand(s,o){return o?this.commands.toInternal(o,s):void 0}createTreeNode(s,o,v){const n=new A.DisposableStore,f=this.createHandle(s,o,v),r=this.getLightIconPath(o);return{item:{handle:f,parentHandle:v?v.item.handle:void 0,label:w(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(n,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,i.isUndefinedOrNull)(o.collapsibleState)?C.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:v,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(s){return s.iconPath instanceof C.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:o,label:v,resourceUri:n},f,r){if(o)return`${P.ID_HANDLE_PREFIX}/${o}`;const t=w(v,this.extension),d=f?f.item.handle:P.LABEL_HANDLE_PREFIX;let l=t?t.label:n?(0,L.basename)(n):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,m=this.getChildrenNodes(f)||[];let u,E=0;do{if(u=`${d}/${E}:${l}`,r||!this.elements.has(u)||c===u)break;E++}while(E<=m.length);return u}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof C.ThemeIcon))return typeof s.iconPath=="string"||D.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof C.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return D.URI.isUri(s)?s:D.URI.file(s)}addNodeToCache(s,o){this.elements.set(o.item.handle,s),this.nodes.set(s,o)}updateNodeCache(s,o,v,n){this.elements.delete(o.item.handle),this.nodes.delete(s),o.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(s,o);const f=this.getChildrenNodes(n)||[],r=f.filter(t=>t.item.handle===v.item.handle)[0];r&&f.splice(f.indexOf(r),1,o)}addNodeToParentCache(s,o){o?(o.children||(o.children=[]),o.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const o=this.nodes.get(s);if(o){if(o.children)for(const v of o.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}o.children=void 0}}else this.clearAll()}clear(s){const o=this.nodes.get(s);if(o){if(o.children)for(const v of o.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}this.nodes.delete(s),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(fe[223],me([0,1,16,3,6,12,66,17,129,90]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends D.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const p=this.diff[this.diff.length-1];if(p&&a[0]===1){if(p[0]===1&&p[1].extId===a[1].extId){(0,_.applyTestItemUpdate)(p[1],a[1]);return}if(p[0]===0&&p[1].item.extId===a[1].extId){(0,_.applyTestItemUpdate)(p[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,p){const h=this.tree.get(a);if(!!h){if((h.expandLevels===void 0||p>h.expandLevels)&&(h.expandLevels=p),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,p-1):w.wait().then(()=>this.expandChildren(h,p-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,p-1)):this.expandChildren(h,p-1)}}dispose(){for(const a of this.tree.values())(0,A.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,p){switch(p.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(a.fullId,p.id));break;case 0:this.upsertItem(p.item,a);break;case 4:for(const b of p.ops)this.onTestItemEvent(a,b);break;case 3:const{key:h,value:w,previous:y}=p,P=a.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(w,y,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[h]:w??null}}]);break}break;default:(0,S.assertNever)(p)}}upsertItem(a,p){if(!(a instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const h=C.TestId.fromExtHostTestItem(a,this.root.id,p?.actual),w=(0,A.getPrivateApiFor)(a);w.parent&&w.parent!==p?.actual&&w.parent.children.delete(a.id);let y=this.tree.get(h.toString());if(!y){y={fullId:h,actual:a,parent:p?h.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(y.fullId.toString(),y),this.setItemParent(a,p),this.pushDiff([0,{parent:y.parent&&y.parent.toString(),controllerId:this.controllerId,expand:y.expand,item:k.TestItem.from(a)}]),this.connectItemAndChildren(a,y,p);return}if(y.actual===a){this.connectItem(a,y,p);return}const P=y.actual.children,b=y.actual,s=(0,A.diffTestItems)(b,a);(0,A.getPrivateApiFor)(b).listener=void 0,y.actual=a,y.expand=0;for(const[o,v]of s)this.onTestItemEvent(y,{op:3,key:o,value:v,previous:b[o]});this.connectItemAndChildren(a,y,p);for(const o of P)a.children.get(o.id)||this.removeItem(C.TestId.joinToString(h,o.id))}diffTagRefs(a,p,h){const w=new Set(p.map(y=>y.id));for(const y of a)w.delete(y.id)||this.incrementTagRefs(y);this.pushDiff([1,{extId:h,item:{tags:a.map(y=>k.TestTag.namespace(this.controllerId,y.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const p=this.tags.get(a.id);p?p.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const p=this.tags.get(a);p&&!--p.refCount&&(this.tags.delete(a),this.pushDiff([6,k.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,p){(0,A.getPrivateApiFor)(a).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(a,p,h){this.setItemParent(a,h);const w=(0,A.getPrivateApiFor)(a);w.parent=h?.actual,w.listener=y=>this.onTestItemEvent(p,y),this.updateExpandability(p)}connectItemAndChildren(a,p,h){this.connectItem(a,p,h);for(const w of a.children)this.upsertItem(w,p)}updateExpandability(a){let p;this._resolveHandler?a.resolveBarrier?p=a.resolveBarrier.isOpen()?3:2:p=a.actual.canResolveChildren?1:0:p=0,p!==a.expand&&(a.expand=p,this.pushDiff([1,{extId:a.fullId.toString(),expand:p}]),p===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,p){if(p<0)return;const h=[];for(const w of a.actual.children){const y=this.expand(C.TestId.joinToString(a.fullId,w.id),p);(0,g.isThenable)(y)&&h.push(y)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const y=new g.Barrier;return y.open(),y}a.expand=2,this.pushExpandStateUpdate(a);const p=a.resolveBarrier=new g.Barrier,h=y=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=y.stack||y.message||String(y))};let w;try{w=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(y){h(y)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{p.open(),this.updateExpandability(a)}):(p.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const p=this.tree.get(a);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const h=[p];for(;h.length;){const w=h.pop();if(!!w){(0,A.getPrivateApiFor)(w.actual).listener=void 0;for(const y of w.actual.tags)this.decrementTagRefs(y.id);this.tree.delete(w.fullId.toString());for(const y of w.actual.children)h.push(this.tree.get(C.TestId.joinToString(w.fullId,y.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=i}),define(fe[224],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[225],me([0,1,27,3,8]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class A{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(a=>I.add(g.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(g.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const a=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(h=>p.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!p.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(a)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,P){this.addNode(y),this.addNode(P),this._arcs.has(y)?this._arcs.get(y).push(P):this._arcs.set(y,[P])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,P){const b=I.getArcs(y);for(let s=0;s<b.length;s++)if(!P.has(b[s]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let y of i){const P=g.ExtensionIdentifier.toKey(y.identifier);if(a.set(P,y),y.extensionDependencies)for(let b of y.extensionDependencies){const s=g.ExtensionIdentifier.toKey(b);I.addArc(P,s)}}let p=new Set;I.getNodes().filter(y=>I.getArcs(y).length===0).forEach(y=>p.add(y));let h=I.getNodes().filter(y=>!p.has(y)),w;do{w=!1;for(let y=0;y<h.length;y++){const P=h[y];I.hasOnlyGoodArcs(P,p)&&(h.splice(y,1),y--,p.add(P),w=!0)}}while(w);return h.map(y=>a.get(y))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=A;var k;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(k||(k={}));function _(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==a)return I-a;const p=D.posix.basename(C.extensionLocation.path),h=D.posix.basename(i.extensionLocation.path);return p<h?-1:p>h?1:0}}),define(fe[226],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function S(k){const _=g.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=S;function A(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=A}),define(fe[35],me([0,1,3,2,4,27,194]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class C{constructor(v){this.dependency=v}}e.MissingExtensionDependency=C;var i;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;class a{constructor(v,n,f,r){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=f,this.activationReason=r}}e.ActivationTimes=a;class p{constructor(v,n){this.description=v,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var h;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function w(o){o.enableProposedApi||y(o)}e.checkProposedApiEnabled=w;function y(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=y;function P(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=P;function b(o,v){return{identifier:new S.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!v,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class s{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,n){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,n,f,r,t){}_onDidActivateExtensionError(v,n){}_onExtensionRuntimeError(v,n){}_onExtensionHostExit(v){}}e.NullExtensionService=s}),define(fe[227],me([0,1,27,35,13]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class A{constructor(h,w,y,P){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=y,this.activateResolvedTime=P}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class k{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class _{constructor(h,w,y,P,b,s){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=y,this.module=P,this.exports=b,this.subscriptions=s}}e.ActivatedExtension=_;class C extends _{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends _{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends _{constructor(h){super(!0,h,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let a=class{constructor(h,w,y,P,b){this._logService=b,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(s=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,y.forEach(s=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(s),s)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=g.ExtensionIdentifier.toKey(h),y=this._activatedExtensions.get(w);if(!y)throw new Error("Extension `"+h.value+"` is not known or not activated");return y}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return S;const y=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(y.map(P=>({id:P.identifier,reason:{startup:w,extensionId:P.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const y=this._registry.getExtensionDescription(h);if(!y)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:y.identifier,reason:w}])}_handleActivateRequest(h,w,y){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){w[g.ExtensionIdentifier.toKey(h.id)]=h;return}const P=this._registry.getExtensionDescription(h.id);if(!P){const o=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,o,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(o));return}const b=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let s=!0;for(let o=0,v=b.length;o<v;o++){const n=b[o];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(n)))continue;const f=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(n));if(f&&!f.activationFailed)continue;if(f&&f.activationFailed){const l=P.displayName||P.identifier.value,c=this._registry.getExtensionDescription(n),m=c&&c.displayName||n,u=new Error(`Cannot activate the '${l}' extension because its dependency '${m}' failed to activate`);u.detail=f.activationFailedError,this._host.onExtensionActivationError(P.identifier,u,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(u));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(n))){s=!1,w[g.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(n)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){if(!r.main&&!r.browser)continue;s=!1,w[g.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:h.reason};continue}const t=P.displayName||P.identifier.value,d=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${n}'`);this._host.onExtensionActivationError(P.identifier,d,new L.MissingExtensionDependency(n)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(d));return}s?w[g.ExtensionIdentifier.toKey(P.identifier)]=h:y.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),y=[];for(let b=0,s=h.length;b<s;b++)this._handleActivateRequest(h[b],w,y);for(let b=0,s=y.length;b<s;b++){const o=g.ExtensionIdentifier.toKey(y[b].id);w[o]&&delete w[o]}const P=Object.keys(w).map(b=>w[b]);return y.length===0?Promise.all(P.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(P).then(b=>this._activateExtensions(y))}_activateExtension(h,w){const y=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const P=this._activatingExtensions.get(y);if(P)return P;const b=this._host.actualActivateExtension(h,w).then(void 0,s=>{const o=new Error;return s&&s.name&&(o.name=s.name),s&&s.message?o.message=`Activating extension '${h.value}' failed: ${s.message}.`:o.message=`Activating extension '${h.value}' failed: ${s}.`,s&&s.stack&&(o.stack=s.stack),this._host.onExtensionActivationError(h,o,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(s),new I(s)}).then(s=>{this._activatedExtensions.set(y,s),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,b),b}};a=Ve([We(4,D.ILogService)],a),e.ExtensionsActivator=a}),define(fe[228],me([0,1,13,35,28,10,117]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends g.LogService{constructor(C){if(C.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(L.ExtensionHostLogFileName,C.logFile.fsPath,!0,C.logLevel))}$setLevel(C){this.setLevel(C)}};k=Ve([We(0,D.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(fe[229],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,A)=>{this._actualOk=S,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,g.onUnexpectedError)(S))}then(S,A){return this._ensureActual().then(S,A)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(C,i){this._proxyIdentifierBrand=void 0,this.isMain=C,this.sid=i,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function D(_){const C=new g(!0,_);return L[C.nid]=C,C}e.createMainContextProxyIdentifier=D;function S(_){const C=new g(!1,_);return L[C.nid]=C,C}e.createExtHostContextProxyIdentifier=S;function A(_){return L[_].sid}e.getStringIdentifierForProxy=A;class k{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=k}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var A;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(s){s.name="$ident";function o(n,f){return Object.defineProperty(n,s.name,{value:f,enumerable:!0}),n}s.mixin=o;function v(n){return n[s.name]}s.of=v})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(o){return o._id=p._n++,o}}e.IdObject=p,p._n=0;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=L.URI.revive(o.resource):(o.newUri=L.URI.revive(o.newUri),o.oldUri=L.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,g.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=P;var b;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,C){return this._proxy.$setPassword(k,_,C)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,13,5,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,C,i){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};A=Ve([We(0,S.IExtHostRpcService),We(1,L.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,C){}})}),define(fe[230],me([0,1,3,5,7,27]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,C,i,I={}){const a=S.ExtensionIdentifier.toKey(_.identifier),p=this._inFlightRequests.get(a)||[],h=[...i].sort().join(" ");let w=p.find(y=>y.scopes===h);if(w)return w.result;{const y=this._getSession(_,a,C,i,I);w={scopes:h,result:y},p.push(w),this._inFlightRequests.set(a,p);try{await y}finally{const P=p.findIndex(b=>b.scopes===h);P>-1&&(p.splice(P),this._inFlightRequests.set(a,p))}return y}}async _getSession(_,C,i,I,a={}){await this._proxy.$ensureProvider(i);const p=_.displayName||_.name;return this._proxy.$getSession(i,I,C,p,a)}async removeSession(_,C){const i=this._authenticationProviders.get(_);return i?i.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,i,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===_)||this._providers.push({id:_,label:C});const a=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(_,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,C,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(_);const p=this._providers.findIndex(h=>h.id===_);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[231],me([0,1,5,14,17]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};S=Ve([We(0,L.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(fe[232],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(S){const A=S.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(k){return A.$writeText(k)}})}}e.ExtHostClipboard=L}),define(fe[41],me([0,1,12,7,17,25,5,15,13,62,43,51,2,6,4,14,66,22,55,52]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(d,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadCommands),this._logService=l,this.converter=new v(this,c=>{const m=this._apiCommands.get(c);return m?.result===f.Void?m:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,C.revive)(c)}},{processArgument(c){return(0,S.cloneAndChange)(c,function(m){if(i.Range.isIRange(m))return D.Range.to(m);if(I.Position.isIPosition(m))return D.Position.to(m);if(i.Range.isIRange(m.range)&&a.URI.isUri(m.uri))return D.location.to(m);if(m instanceof P.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(d){this._argumentProcessors.push(d)}registerApiCommand(d){const l=this.registerCommand(!1,d.id,async(...c)=>{const m=d.args.map((E,T)=>{if(!E.validate(c[T]))throw new Error(`Invalid argument '${E.name}' when running '${d.id}', received: ${c[T]}`);return E.convert(c[T])}),u=await this.executeCommand(d.internalId,...m);return d.result.convert(u,c,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this._apiCommands.set(d.id,d),new L.Disposable(()=>{l.dispose(),this._apiCommands.delete(d.id)})}registerCommand(d,l,c,m,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:m,description:u,extension:E}),d&&this._proxy.$registerCommand(l),new L.Disposable(()=>{this._commands.delete(l)&&d&&this._proxy.$unregisterCommand(l)})}executeCommand(d,...l){return this._logService.trace("ExtHostCommands#executeCommand",d),this._doExecuteCommand(d,l,!0)}async _doExecuteCommand(d,l,c){if(this._commands.has(d))return this._executeContributedCommand(d,l,!1);{let m=!1;const u=(0,S.cloneAndChange)(l,function(E){if(E instanceof L.Position)return D.Position.from(E);if(E instanceof L.Range)return D.Range.from(E);if(E instanceof L.Location)return D.location.from(E);if(L.NotebookRange.isNotebookRange(E))return D.NotebookRange.from(E);if(E instanceof ArrayBuffer)return m=!0,P.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return m=!0,P.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(d,m?new b.SerializableObjectWithBuffers(u):u,c);return(0,C.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(d,l,!1);throw E}}}async _executeContributedCommand(d,l,c){const m=this._commands.get(d);if(!m)throw new Error("Unknown command");let{callback:u,thisArg:E,description:T}=m;if(T)for(let R=0;R<T.args.length;R++)try{(0,g.validateConstraint)(l[R],T.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${T.args[R].name}' - ${T.args[R].description}`)}try{return await u.apply(E,l)}catch(R){if(d===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(d=B.command)}throw this._logService.error(R,d,m.extension?.identifier),c?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=d,this.source=m.extension?.displayName??m.extension?.name}}:R}}$executeContributedCommand(d,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",d),this._commands.has(d)?(l=l.map(c=>this._argumentProcessors.reduce((m,u)=>u.processArgument(m),c)),this._executeContributedCommand(d,l,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this._logService.trace("ExtHostCommands#getCommands",d),this._proxy.$getCommands().then(l=>(d&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(let[l,c]of this._commands){let{description:m}=c;m&&(d[l]=m)}return Promise.resolve(d)}};o=Ve([We(0,w.IExtHostRpcService),We(1,_.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class v{constructor(d,l,c){this._commands=d,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(d,l){if(!d)return;const c={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return c;const m=this._lookupApiCommand(d.command);if(m)c.id=m.internalId,c.arguments=m.args.map((u,E)=>u.convert(d.arguments&&d.arguments[E]));else if((0,k.isNonEmptyArray)(d.arguments)){const u=++this._cachIdPool;this._cache.set(u,d),l.add((0,p.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),c.$ident=u,c.id=this.delegatingCommandId,c.arguments=[u],this._logService.trace("CommandsConverter#CREATE",d.command,u)}return c}fromInternal(d){const l=A.ObjectIdentifier.of(d);return typeof l=="number"?this._cache.get(l):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this._cache.get(d[0])}_executeConvertedCommand(...d){const l=this.getActualCommand(...d);return this._logService.trace("CommandsConverter#EXECUTE",d[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class n{constructor(d,l,c,m){this.name=d,this.description=l,this.validate=c,this.convert=m}optional(){return new n(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,l){return new n(d??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>a.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),n.Range=new n("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),n.Selection=new n("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof y.TestItemImpl,D.TestItem.from);class f{constructor(d,l){this.description=d,this.convert=l}}e.ApiCommandResult=f,f.Void=new f("no result",t=>t);class r{constructor(d,l,c,m,u){this.id=d,this.internalId=l,this.description=c,this.args=m,this.result=u}}e.ApiCommand=r}),define(fe[233],me([0,1,17,7,85,41,15,112]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,p)=>{if((0,A.isFalsyOrEmpty)(a))return;class h extends L.SymbolInformation{static to(y){const P=new h(y.name,g.SymbolKind.to(y.kind),y.containerName||"",new L.Location(p[0],g.Range.to(y.range)));return P.detail=y.detail,P.range=P.location.range,P.selectionRange=g.Range.to(y.selectionRange),P.children=y.children?y.children.map(h.to):[],P}}return a.map(h.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(p=>L.Position.isPosition(p)),a=>a.map(g.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(p=>{let h;for(const w of p.reverse())h=new L.SelectionRange(g.Range.to(w),h);return h}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const p=[];if(Array.isArray(a))for(let h of a)p.push(...h[1].map(g.WorkspaceSymbol.to));return p})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(g.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:g.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return g.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(g.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,k.decodeSemanticTokensDto)(a);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new L.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const p=(0,k.decodeSemanticTokensDto)(a);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,p,h)=>{if(!a)return new L.CompletionList([]);const w=a.suggestions.map(y=>g.CompletionItem.to(y,h));return new L.CompletionList(w,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return g.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,p,h)=>i(w=>new L.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>L.Range.isRange(a),a=>L.Selection.isSelection(a)?g.Selection.from(a):g.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,p,h)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const y=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(y.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(y.command=h.fromInternal(w.command)),y.isPreferred=w.isPreferred,y}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(p=>new L.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof L.Color,g.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:g.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(g.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(g.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(g.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[g.ViewColumn.from(a.viewColumn),g.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class C{static register(p){_.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=C;function i(a){return p=>{if(Array.isArray(p))return p.map(a)}}function I(a){if(!Array.isArray(a))return;const p=[];for(const h of a)D.isLocationLink(h)?p.push(g.DefinitionLink.to(h)):p.push(g.location.to(h));return p}}),define(fe[234],me([0,1,16,60,3,6,2,85,27,17,7,5]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(p,h,w){const y=p.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const d=this._commentControllers.get(t.handle);return d||t}else if(t&&t.$mid===7){const d=this._commentControllers.get(t.commentControlHandle);if(!d)return t;const l=d.getCommentThread(t.commentThreadHandle);return l||t}else if(t&&t.$mid===8){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const l=d.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l,text:t.text}:t}else if(t&&t.$mid===9){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const l=d.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let c=t.commentUniqueId,m=l.getCommentByUniqueId(c);return m||t}else if(t&&t.$mid===10){const d=this._commentControllers.get(t.thread.commentControlHandle);if(!d)return t;const l=d.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;let c=t.text,m=t.commentUniqueId,u=l.getCommentByUniqueId(m);return u?(u.body=c,u):t}return t}})}createCommentController(t,d,l){const c=P.handlePool++,m=new s(t,c,d,l);this._commentControllers.set(m.handle,m);const u=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(m),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),u),m.value}$createCommentThreadTemplate(t,d,l){const c=this._commentControllers.get(t);!c||c.$createCommentThreadTemplate(d,l)}async $updateCommentThreadTemplate(t,d,l){const c=this._commentControllers.get(t);!c||c.$updateCommentThreadTemplate(d,l)}$deleteCommentThread(t,d){const l=this._commentControllers.get(t);l&&l.$deleteCommentThread(d)}$provideCommentingRanges(t,d,l){const c=this._commentControllers.get(t);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(A.URI.revive(d));return(0,g.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(m,l)).then(u=>u?u.map(E=>C.Range.from(E)):void 0)}$toggleReaction(t,d,l,c,m){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const E=u.getCommentThread(d);if(E){const T=E.getCommentByUniqueId(c.uniqueIdInThread);if(u!==void 0&&T&&u.reactionHandler)return u.reactionHandler(T,n(m))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class b{constructor(t,d,l,c,m,u,E){this._commentControllerHandle=d,this._id=l,this._uri=c,this._range=m,this._comments=u,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),y.$createCommentThread(d,this.handle,this._id,this._uri,C.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{y.$deleteCommentThread(d,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(R){T.range=R},get comments(){return T.comments},set comments(R){T.comments=R},get collapsibleState(){return T.collapsibleState},set collapsibleState(R){T.collapsibleState=R},get canReply(){return T.canReply},set canReply(R){T.canReply=R},get contextValue(){return T.contextValue},set contextValue(R){T.contextValue=R},get label(){return T.label},set label(R){T.label=R},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),d={};t("range")&&(d.range=C.Range.from(this._range)),t("label")&&(d.label=this.label),t("contextValue")&&(d.contextValue=this.contextValue??null),t("comments")&&(d.comments=this._comments.map(l=>o(this,l,this._commentsMap))),t("collapsibleState")&&(d.collapseState=f(this._collapseState)),t("canReply")&&(d.canReply=this.canReply),this.modifications={},y.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,d)}getCommentByUniqueId(t){for(let d of this._commentsMap){let l=d[0],c=d[1];if(t===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,d,l,c){this._extension=t,this._handle=d,this._id=l,this._label=c,this._threads=new Map,y.$registerCommentController(this.handle,l,c);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(u){m.options=u},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(u){m.commentingRangeProvider=u},get reactionHandler(){return m.reactionHandler},set reactionHandler(u){m.reactionHandler=u},createCommentThread(u,E,T){return m.createCommentThread(u,E,T).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{y.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,y.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,y.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,y.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,d,l,c){if(typeof t=="string"){const m=new b(this.id,this.handle,t,d,l,c,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,t,d,l,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,d){const l=new b(this.id,this.handle,void 0,A.URI.revive(t),C.Range.to(d),[],this._extension.identifier);return l.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,d){let l=this._threads.get(t);l&&(l.range=C.Range.to(d))}$deleteCommentThread(t){let d=this._threads.get(t);d&&d.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function o(r,t,d){let l=d.get(t);l||(l=++r.commentHandle,d.set(t,l));const c=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:C.MarkdownString.from(t.body),userName:t.author.name,userIconPath:c,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>v(m)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function n(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function f(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=a}),define(fe[133],me([0,1,2,5,7,4,14,13,15,9,8]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(p,h){this._logService=h,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,h){const w=wn._handlePool++;this._provider.set(w,{provider:p,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const y=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(w,null);return}let b=(0,_.asArray)(P);if(b.length<=wn._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const s=b.map(n=>({uri:n,rank:(0,C.count)(n.path,"/")})),o=(0,_.groupBy)(s,(n,f)=>n.rank-f.rank||(0,C.compare)(n.uri.path,f.uri.path));let v=[];e:for(let n of o){let f;for(let r of n){let t=(0,i.dirname)(r.uri.path);if(f!==t&&(f=t,v.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new D.Disposable(()=>{y?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,h,w){if(!this._provider.has(p))return Object.create(null);const y=Object.create(null),{provider:P,extensionId:b}=this._provider.get(p);return await Promise.all(h.map(async s=>{try{const{uri:o,id:v}=s,n=await Promise.resolve(P.provideFileDecoration(g.URI.revive(o),w));if(!n)return;try{D.FileDecoration.validate(n),y[v]=[n.propagate,n.tooltip,n.badge,n.color]}catch(f){this._logService.warn(`INVALID decoration from extension '${b.value}': ${f}`)}}catch(o){this._logService.error(o)}})),y}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,A.IExtHostRpcService),We(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[235],me([0,1,164,118,2,5,7,17,3,13,24,53]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";var a,p,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,s,o,v,n,f){this._name=b,this._owner=s,this._maxDiagnosticsPerFile=o,a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,st(this,h,new i.ResourceMap(r=>v.getComparisonKey(r)),"f"),st(this,a,n,"f"),st(this,p,f,"f")}dispose(){this._isDisposed||(Ne(this,p,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,a,"f")&&Ne(this,a,"f").$clear(this._owner),Ne(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,s){if(!b){this.clear();return}this._checkDisposed();let o=[];if(D.URI.isUri(b)){if(!s){this.delete(b);return}Ne(this,h,"f").set(b,s.slice()),o=[b]}else if(Array.isArray(b)){o=[];let n;b=[...b].sort(w._compareIndexedTuplesByUri);for(const f of b){const[r,t]=f;if((!n||r.toString()!==n.toString())&&(n&&Ne(this,h,"f").get(n).length===0&&Ne(this,h,"f").delete(n),n=r,o.push(r),Ne(this,h,"f").set(r,[])),t){const d=Ne(this,h,"f").get(r);d&&d.push(...t)}else{const d=Ne(this,h,"f").get(r);d&&(d.length=0)}}}if(Ne(this,p,"f").fire(o),!Ne(this,a,"f"))return;const v=[];for(let n of o){let f=[];const r=Ne(this,h,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){f=[];const t=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(let l of r)if(l.severity===t[d]&&f.push(k.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;f.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=r.map(t=>k.Diagnostic.from(t));v.push([n,f])}Ne(this,a,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Ne(this,p,"f").fire([b]),Ne(this,h,"f").delete(b),Ne(this,a,"f")&&Ne(this,a,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ne(this,p,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,h,"f").clear(),Ne(this,a,"f")&&Ne(this,a,"f").$clear(this._owner)}forEach(b,s){this._checkDisposed();for(let o of Ne(this,h,"f").keys())b.apply(s,[o,this.get(o),this])}get(b){this._checkDisposed();const s=Ne(this,h,"f").get(b);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ne(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,s){return b[0].toString()<s[0].toString()?-1:b[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w,a=new WeakMap,p=new WeakMap,h=new WeakMap;let y=class tn{constructor(b,s,o){this._logService=s,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,tn._mapper),this._proxy=b.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(b){const s=new i.ResourceMap;for(const o of b)s.set(o,o);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(b,s){const{_collections:o,_proxy:v,_onDidChangeDiagnostics:n,_logService:f,_fileSystemInfoService:r}=this,t=new class{$changeMany(c,m){v.$changeMany(c,m),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,c,m.length===0?"CLEARING":m)}$clear(c){v.$clear(c),f.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,c)}dispose(){v.dispose()}};let d;if(!s)s="_generated_diagnostic_collection_name_#"+tn._idPool++,d=s;else if(!o.has(s))d=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do d=s+tn._idPool++;while(o.has(d))}return new class extends w{constructor(){super(s,d,tn._maxDiagnosticsPerFile,r.extUri,t,n);o.set(d,this)}dispose(){super.dispose(),o.delete(d)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const s=new Map,o=[];for(const v of this._collections.values())v.forEach((n,f)=>{let r=s.get(n.toString());typeof r=="undefined"&&(r=o.length,s.set(n.toString(),r),o.push([n,[]])),o[r][1]=o[r][1].concat(...f)});return o}}_getDiagnostics(b){let s=[];for(let o of this._collections.values())o.has(b)&&(s=s.concat(o.get(b)));return s}$acceptMarkersChange(b){if(!this._mirrorCollection){const s="_generated_mirror",o=new w(s,s,tn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,o),this._mirrorCollection=o}for(const[s,o]of b)this._mirrorCollection.set(D.URI.revive(s),o.map(k.Diagnostic.to))}};y._idPool=0,y._maxDiagnosticsPerFile=1e3,y=Ve([We(1,C.ILogService),We(2,I.IExtHostFileSystemInfo)],y),e.ExtHostDiagnostics=y}),define(fe[236],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(A){this._proxy=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(k=>k?k.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(k=>k?g.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(fe[237],me([0,1,18,2,7,5,10,21,9]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,a,p){this._documentsAndEditors=a,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=C._handlePool++;this._documentContentProviders.set(p,a),this._proxy.$registerTextContentProvider(p,I);let h;return typeof a.onDidChange=="function"&&(h=a.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(y=>{if(!y&&typeof y!="string")return;const P=this._documentsAndEditors.getDocument(w);if(!P)return;const b=(0,_.splitLines)(y);if(!P.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,y)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,a){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(a),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(fe[238],me([0,1,3,6,2,5,125,17,12,25,7]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const y of w)this._onDidRemoveDocument.fire(y.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const y of w)this._onDidAddDocument.fire(y.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const h=this._documentsAndEditors.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this._documentsAndEditors.getDocument(p);if(h)return Promise.resolve(h);let w=this._documentLoader.get(p.toString());return w||(w=this._proxy.$tryOpenDocument(p).then(y=>{this._documentLoader.delete(p.toString());const P=D.URI.revive(y);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(P))},y=>(this._documentLoader.delete(p.toString()),Promise.reject(y))),this._documentLoader.set(p.toString(),w)),w}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(h=>D.URI.revive(h))}$acceptModelModeChanged(p,h){const w=D.URI.revive(p),y=this._documentsAndEditors.getDocument(w);if(!y)throw new Error("unknown document");this._onDidRemoveDocument.fire(y.document),y._acceptLanguageId(h),this._onDidAddDocument.fire(y.document)}$acceptModelSaved(p){const h=D.URI.revive(p),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(p,h){const w=D.URI.revive(p),y=this._documentsAndEditors.getDocument(w);if(!y)throw new Error("unknown document");y._acceptIsDirty(h),this._onDidChangeDocument.fire({document:y.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,w){const y=D.URI.revive(p),P=this._documentsAndEditors.getDocument(y);if(!P)throw new Error("unknown document");P._acceptIsDirty(w),P.onEvents(h);let b;h.isUndoing?b=i.TextDocumentChangeReason.Undo:h.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:P.document,contentChanges:h.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:b}))}setWordDefinitionFor(p,h){(0,A.setWordDefinitionFor)(p,h)}}e.ExtHostDocuments=I}),define(fe[45],me([0,1,58,3,6,2,4,5,125,14,132,17,13,24,10,78,141]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,v){this._extHostRpc=o,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const v=[],n=[],f=[];if(o.removedDocuments)for(const r of o.removedDocuments){const t=S.URI.revive(r),d=this._documents.get(t);d?.unref()&&(this._documents.delete(t),v.push(d.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const t=S.URI.revive(r.uri);let d=this._documents.get(t);if(d&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);d||(d=new P(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(t,d),n.push(d.value)),d.ref()}if(o.removedEditors)for(const r of o.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&f.push(t)}if(o.addedEditors)for(const r of o.addedEditors){const t=S.URI.revive(r.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const d=this._documents.get(t).value,l=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>d.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,l)}o.newActiveEditor!==void 0&&(g.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(f),o.removedDocuments&&this._onDidRemoveDocuments.fire(v),o.addedDocuments&&this._onDidAddDocuments.fire(n),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return o?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([We(0,C.IExtHostRpcService),We(1,a.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,17,5,2,3,4,14,16]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let C=class{constructor(I){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new S.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let a=-1;this._tabs=I.map((h,w)=>(h.isActive&&(a=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:D.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:y,viewId:P})=>({resource:D.URI.revive(y),viewId:P})),viewId:h.editorId,isActive:h.isActive,move:async(y,P)=>{this._proxy.$moveTab(h,y,g.ViewColumn.from(P)),await(0,_.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const p=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};C=Ve([We(0,k.IExtHostRpcService)],C),e.ExtHostEditorTabs=C}),define(fe[239],me([0,1,2,5,6,7,17,148,9,22]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const h=this._schemes.indexOf(p);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),h=[];let w,y,P=14,b=14;for(const s of p){let o=w?(0,_.commonPrefixLength)(w,s):0;for(o===0?y=1:y=b;o<s.length;o++)o+1===s.length?(P=b,b=9):b+=1,h.push([y,s.toUpperCase().charCodeAt(o),b]),h.push([y,s.toLowerCase().charCodeAt(o),b]),y=b;w=s,b=P}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new k.StateMachine(h)}}provideDocumentLinks(p){this._initStateMachine();const h=[],w=k.LinkComputer.computeLinks({getLineContent(y){return p.lineAt(y-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const y of w){const P=A.DocumentLink.to(y);P.target&&h.push(P)}return h}}class I{constructor(p,h){this._extHostLanguageFeatures=h,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,h,w,y={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(P,w);let b=2;y.isCaseSensitive&&(b+=1024),y.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(P,h,b).catch(o=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${h}`),console.error(o)});const s=w.onDidChangeFile(o=>{const v=[];for(const n of o){let{uri:f,type:r}=n;if(f.scheme!==h)continue;let t;switch(r){case S.FileChangeType.Changed:t=0;break;case S.FileChangeType.Created:t=1;break;case S.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:f,type:t})}this._proxy.$onFileSystemChange(P,v)});return(0,D.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(p){const{type:h,ctime:w,mtime:y,size:P,permissions:b}=p;return{type:h,ctime:w,mtime:y,size:P,permissions:b}}$stat(p,h){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(h))).then(w=>I._asIStat(w))}$readdir(p,h){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(h))).then(w=>C.VSBuffer.wrap(w))}$writeFile(p,h,w,y){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(h),w.buffer,y))}$delete(p,h,w){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(h),w))}$rename(p,h,w,y){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(h),g.URI.revive(w),y))}$copy(p,h,w,y){const P=this._getFsProvider(p);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(g.URI.revive(h),g.URI.revive(w),y))}$mkdir(p,h){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(h)))}$watch(p,h,w,y){const P=this._getFsProvider(p).watch(g.URI.revive(w),y);this._watches.set(h,P)}$unwatch(p,h){const w=this._watches.get(h);w&&(w.dispose(),this._watches.delete(h))}$open(p,h,w){const y=this._getFsProvider(p);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(g.URI.revive(h),w))}$close(p,h){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(h))}$read(p,h,w,y){const P=this._getFsProvider(p);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(y);return Promise.resolve(P.read(h,w,b.buffer,0,y)).then(s=>b.slice(0,s))}$write(p,h,w,y){const P=this._getFsProvider(p);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(h,w,y.buffer,0,y.byteLength))}_getFsProvider(p){const h=this._fsProvider.get(p);if(!h){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return h}}e.ExtHostFileSystem=I}),define(fe[92],me([0,1,5,40,7,22,4,14,53]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Bt{constructor(I,a){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return p.$stat(h).catch(Bt._handleError)},readDirectory(h){return p.$readdir(h).catch(Bt._handleError)},createDirectory(h){return p.$mkdir(h).catch(Bt._handleError)},async readFile(h){return p.$readFile(h).then(w=>w.buffer).catch(Bt._handleError)},writeFile(h,w){return p.$writeFile(h,S.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(h,w){return p.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(h,w,y){return p.$rename(h,w,{overwrite:!1,...y}).catch(Bt._handleError)},copy(h,w,y){return p.$copy(h,w,{overwrite:!1,...y}).catch(Bt._handleError)},isWritableFileSystem(h){const w=a.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};C=Ve([We(0,k.IExtHostRpcService),We(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[240],me([0,1,2,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(A,k,_,C){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=C;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(A,k,_,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=D}),define(fe[241],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,A),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(fe[242],me([0,1,2,25,17,7,5,9,43,15,12,145,6,112,77,88,46,18,3]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(te,ee);if(!(0,C.isFalsyOrEmpty)(ce))return ce[0]instanceof S.DocumentSymbol?ce.map(D.DocumentSymbol.from):s._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let se=ce.location.range.start.compareTo(Z.location.range.start);return se===0&&(se=Z.location.range.end.compareTo(ce.location.range.end)),se});const ee=[],te=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:ce.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(te.length===0){te.push(Z),ee.push(Z);break}const se=te[te.length-1];if(_.Range.containsRange(se.range,Z.range)&&!_.Range.equalsRange(se.range,Z.range)){se.children&&se.children.push(Z),te.push(Z);break}te.pop()}}return ee}}class o{constructor(G,ee,te){this._documents=G,this._commands=ee,this._provider=te,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(te,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),se=new a.DisposableStore;this._disposables.set(Z,se);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:D.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,se)});return pe}async resolveCodeLens(G,ee){const te=G.cacheId&&this._cache.get(...G.cacheId);if(!te)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ce=te:ce=await this._provider.resolveCodeLens(te,ee),ce||(ce=te),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??o._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(D.DefinitionLink.from):He?[D.DefinitionLink.from(He)]:[]}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideDefinition(ce,Z,te);return v(se)}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideDeclaration(ce,Z,te);return v(se)}}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideImplementation(ce,Z,te);return v(se)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideTypeDefinition(ce,Z,te);return v(se)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideHover(ce,Z,te);if(!(!se||(0,C.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ce.getWordRangeAtPosition(Z)),se.range||(se.range=new S.Range(Z,Z)),D.Hover.from(se)}}class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideEvaluatableExpression(ce,Z,te);if(se)return D.EvaluatableExpression.from(se)}}class c{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,te,ce){const Z=this._documents.getDocument(G),se=await this._provider.provideInlineValues(Z,D.Range.to(ee),D.InlineValueContext.to(te),ce);if(Array.isArray(se))return se.map(pe=>D.InlineValue.from(pe))}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideDocumentHighlights(ce,Z,te);if(Array.isArray(se))return se.map(D.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.provideLinkedEditingRanges(ce,Z,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,C.coalesce)(se.ranges.map(D.Range.from)),wordPattern:se.wordPattern}}}class E{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Position.to(ee),pe=await this._provider.provideReferences(Z,se,te,ce);if(Array.isArray(pe))return pe.map(D.location.from)}}class T{constructor(G,ee,te,ce,Z,se,pe){this._documents=G,this._commands=ee,this._diagnostics=te,this._provider=ce,this._logService=Z,this._extension=se,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,te,ce){const Z=this._documents.getDocument(G),se=I.Selection.isISelection(ee)?D.Selection.to(ee):D.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(se.intersection(ct.range)&&pe.push(ct)>T._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:te.only?new S.CodeActionKind(te.only):void 0,triggerKind:D.CodeActionTriggerKind.to(te.trigger)},je=await this._provider.provideCodeActions(Z,se,Me,ce);if(!(0,C.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new a.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(T._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(D.Diagnostic.from),edit:ye.edit&&D.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[te,ce]=G,Z=this._cache.get(te,ce);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(Z,ee)??Z;return se?.edit?D.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}T._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,te);if(Array.isArray(Z))return Z.map(D.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,se,te,ce);if(Array.isArray(pe))return pe.map(D.TextEdit.from)}}class N{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,te,ce,Z){const se=this._documents.getDocument(G),pe=D.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(se,pe,te,ce,Z);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const te=A.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,C.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const se=A.IdObject.mixin(D.WorkspaceSymbol.from(Z));this._symbolCache.set(se._id,Z),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const te=this._symbolCache.get(G._id);if(te){const ce=await this._provider.resolveWorkspaceSymbol(te,ee);return ce&&(0,L.mixin)(G,D.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[te,ce]=ee;te<=ce;te++)this._symbolCache.delete(te);this._resultCache.delete(G)}}}class ${constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,se,te,ce);return pe?D.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=D.Position.to(ee);try{const se=await this._provider.prepareRename(ce,Z,te);let pe,Me;if(S.Range.isRange(se)?(pe=se,Me=ce.getText(se)):(0,i.isObject)(se)&&(pe=se.range,Me=se.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(pe),text:Me}}catch(se){const pe=$._asMessage(se);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class z{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let se=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,te):await this._provider.provideDocumentSemanticTokens(ce,te);return Z&&this._previousResults.delete(ee),se?(se=z._fixProvidedSemanticTokens(se),this._send(z._convertToEdits(Z,se),se)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return z._isSemanticTokens(G)?z._isCorrectSemanticTokens(G)?G:new S.SemanticTokens(new Uint32Array(G.data),G.resultId):z._isSemanticTokensEdits(G)?z._isCorrectSemanticTokensEdits(G)?G:new S.SemanticTokensEdits(G.edits.map(ee=>new S.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!z._isSemanticTokens(ee)||!G||!G.tokens)return ee;const te=G.tokens,ce=te.length,Z=ee.data,se=Z.length;let pe=0;const Me=Math.min(ce,se);for(;pe<Me&&te[pe]===Z[pe];)pe++;if(pe===ce&&pe===se)return new S.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&te[ce-je-1]===Z[se-je-1];)je++;return new S.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,se-je)}],ee.resultId)}_send(G,ee){if(z._isSemanticTokens(G)){const te=this._nextResultId++;return this._previousResults.set(te,new M(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:te,type:"full",data:G.data})}if(z._isSemanticTokensEdits(G)){const te=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(te,new M(ee.resultId,ee.data)):this._previousResults.set(te,new M(G.resultId)),(0,p.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class U{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,D.Range.to(ee),te);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(G,ee,te,ce,Z){this._documents=G,this._commands=ee,this._provider=te,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Position.to(ee),pe=Z.getWordRangeAtPosition(se)||new S.Range(se,se),Me=pe.with({end:se}),je=new y.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,se,ce,D.CompletionContext.to(te));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new S.CompletionList(Ke):Ke,rt=x.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new a.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:D.Range.from(pe),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ie=Ze.items[J],Ee=this._convertCompletionItem(ie,[rt,J],Me,pe);ye.push(Ee)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveCompletionItem(te,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,te,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const se={x:ee,a:G.label,b:G.kind!==void 0?D.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(D.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=G.textEdit.newText):typeof G.insertText=="string"?se.h=G.insertText:G.insertText instanceof S.SnippetString&&(se.h=G.insertText.value,se.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),S.Range.isRange(pe)?se.j=D.Range.from(pe):pe&&(!te?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(se.j={insert:D.Range.from(pe.inserting),replace:D.Range.from(pe.replacing)}),se}}class j{constructor(G,ee,te){this._documents=G,this._provider=ee,this._commands=te,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,se,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:D.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const te=this._cache.get(G,ee);te&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class H{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,te,ce){const Z=this._documents.getDocument(G),se=D.Position.to(ee),pe=this.reviveContext(te),Me=await this._provider.provideSignatureHelp(Z,se,ce,pe);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const te=D.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=te.activeSignature,ee.activeParameter=te.activeParameter):ee=te}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class W{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,D.Range.to(ee),te);return Z?{hints:Z.map(D.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(te,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(D.DocumentLink.from)};{const Z=this._cache.add(ce),se={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=D.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],se.links.push(Me)}return se}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveDocumentLink(te,ee);if(!(!ce||!X._validateLink(ce)))return D.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class K{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(te,ee);return Array.isArray(ce)?ce.map(se=>({color:D.Color.from(se.color),range:D.Range.from(se.range)})):[]}async provideColorPresentations(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Range.to(ee.range),se=D.Color.to(ee.color),pe=await this._provider.provideColorPresentations(se,{document:ce,range:Z},te);if(!!Array.isArray(pe))return pe.map(D.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,te);if(!!Array.isArray(Z))return Z.map(D.FoldingRange.from)}}class _e{constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}async provideSelectionRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=ee.map(D.Position.to),se=await this._provider.provideSelectionRanges(ce,Z,te);if(!(0,C.isNonEmptyArray)(se))return[];if(se.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=se[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class Ce{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.prepareCallHierarchy(ce,Z,te);if(!se)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(se)?se.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,se)]}async provideCallsTo(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,te);if(!!Z)return Z.map(se=>({from:this._cacheAndConvertItem(G,se.from),fromRanges:se.fromRanges.map(pe=>D.Range.from(pe))}))}async provideCallsFrom(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,te);if(!!Z)return Z.map(se=>({to:this._cacheAndConvertItem(G,se.to),fromRanges:se.fromRanges.map(pe=>D.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=D.CallHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),se=await this._provider.prepareTypeHierarchy(ce,Z,te);if(!se)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(se)?se.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,se)]}async provideSupertypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,te);if(!!Z)return Z.map(se=>this._cacheAndConvertItem(G,se))}async provideSubtypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,te);if(!!Z)return Z.map(se=>this._cacheAndConvertItem(G,se))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=D.TypeHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class $e{constructor(G,ee,te,ce,Z,se,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ce,this._diagnostics=Z,this._logService=se,this._apiDeprecation=pe}_transformDocumentSelector(G){return D.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new S.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return $e._handlePool++}_withAdapter(G,ee,te,ce,Z=!1){const se=this._adapter.get(G);if(!se)return Promise.resolve(ce);if(se.adapter instanceof ee){let pe;se.extension&&(pe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=te(se.adapter,se.extension),je=se.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const te=this._nextHandle();return this._adapter.set(te,new Be(G,ee)),te}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,te,ce){const Z=this._addNewAdapter(new s(this._documents,te),G),se=ce&&ce.label||$e._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),se),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,te){return this._withAdapter(G,s,ce=>ce.provideDocumentSymbols(g.URI.revive(ee),te),void 0)}registerCodeLensProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new o(this._documents,this._commands.converter,te),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let se=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));se=S.Disposable.from(se,pe)}return se}$provideCodeLenses(G,ee,te){return this._withAdapter(G,o,ce=>ce.provideCodeLenses(g.URI.revive(ee),te),void 0)}$resolveCodeLens(G,ee,te){return this._withAdapter(G,o,ce=>ce.resolveCodeLens(ee,te),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,o,te=>Promise.resolve(te.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new n(this._documents,te),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,te,ce){return this._withAdapter(G,n,Z=>Z.provideDefinition(g.URI.revive(ee),te,ce),[])}registerDeclarationProvider(G,ee,te){const ce=this._addNewAdapter(new f(this._documents,te),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,te,ce){return this._withAdapter(G,f,Z=>Z.provideDeclaration(g.URI.revive(ee),te,ce),[])}registerImplementationProvider(G,ee,te){const ce=this._addNewAdapter(new r(this._documents,te),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,te,ce){return this._withAdapter(G,r,Z=>Z.provideImplementation(g.URI.revive(ee),te,ce),[])}registerTypeDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new t(this._documents,te),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,te,ce){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),te,ce),[])}registerHoverProvider(G,ee,te,ce){const Z=this._addNewAdapter(new d(this._documents,te),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,te,ce){return this._withAdapter(G,d,Z=>Z.provideHover(g.URI.revive(ee),te,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,te,ce){const Z=this._addNewAdapter(new l(this._documents,te),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,te,ce){return this._withAdapter(G,l,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),te,ce),void 0)}registerInlineValuesProvider(G,ee,te,ce){const Z=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new c(this._documents,te),G);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(se);if(Z!==void 0){const Me=te.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=S.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,te,ce,Z){return this._withAdapter(G,c,se=>se.provideInlineValues(g.URI.revive(ee),te,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,te){const ce=this._addNewAdapter(new m(this._documents,te),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,te,ce){return this._withAdapter(G,m,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),te,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,te){const ce=this._addNewAdapter(new u(this._documents,te),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,te,ce){return this._withAdapter(G,u,async Z=>{const se=await Z.provideLinkedEditingRanges(g.URI.revive(ee),te,ce);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?$e._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,te){const ce=this._addNewAdapter(new E(this._documents,te),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,te,ce,Z){return this._withAdapter(G,E,se=>se.provideReferences(g.URI.revive(ee),te,ce,Z),void 0)}registerCodeActionProvider(G,ee,te,ce){const Z=new a.DisposableStore,se=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,te,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},$e._extLabel(G),Boolean(te.resolveCodeAction)),Z.add(this._createDisposable(se)),Z}$provideCodeActions(G,ee,te,ce,Z){return this._withAdapter(G,T,se=>se.provideCodeActions(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCodeAction(G,ee,te){return this._withAdapter(G,T,ce=>ce.resolveCodeAction(ee,te),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,T,te=>Promise.resolve(te.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new R(this._documents,te),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,te,ce){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),te,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new B(this._documents,te),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,te,ce,Z){return this._withAdapter(G,B,se=>se.provideDocumentRangeFormattingEdits(g.URI.revive(ee),te,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,te,ce){const Z=this._addNewAdapter(new N(this._documents,te),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,te,ce,Z,se){return this._withAdapter(G,N,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),te,ce,Z,se),void 0)}registerWorkspaceSymbolProvider(G,ee){const te=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(G,ee,te){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(ee,te),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,te){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(ee,te),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,te=>te.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,te){const ce=this._addNewAdapter(new $(this._documents,te,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),$.supportsResolving(te)),this._createDisposable(ce)}$provideRenameEdits(G,ee,te,ce,Z){return this._withAdapter(G,$,se=>se.provideRenameEdits(g.URI.revive(ee),te,ce,Z),void 0)}$resolveRenameLocation(G,ee,te,ce){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(g.URI.revive(ee),te,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,te,ce){const Z=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new z(this._documents,te),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,se);let pe=this._createDisposable(Z);if(se){const Me=te.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(se));pe=S.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,te,ce){return this._withAdapter(G,z,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,z,te=>te.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,te,ce){const Z=this._addNewAdapter(new U(this._documents,te),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,te,ce){return this._withAdapter(G,U,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}registerCompletionItemProvider(G,ee,te,ce){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,te,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,x.supportsResolving(te),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,te,ce,Z){return this._withAdapter(G,x,se=>se.provideCompletionItems(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCompletionItem(G,ee,te){return this._withAdapter(G,x,ce=>ce.resolveCompletionItem(ee,te),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,x,te=>te.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,te){const ce=this._addNewAdapter(new j(this._documents,te,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,te,ce,Z){return this._withAdapter(G,j,se=>se.provideInlineCompletions(g.URI.revive(ee),te,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,te){this._withAdapter(G,j,async ce=>{ce.handleDidShowCompletionItem(ee,te)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,j,async te=>{te.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,te,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,se=this._addNewAdapter(new H(this._documents,te),G);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(ee),Z),this._createDisposable(se)}$provideSignatureHelp(G,ee,te,ce,Z){return this._withAdapter(G,H,se=>se.provideSignatureHelp(g.URI.revive(ee),te,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,H,te=>te.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,te){const ce=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new W(this._documents,te),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let se=this._createDisposable(Z);if(ce!==void 0){const pe=te.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));se=S.Disposable.from(se,pe)}return se}$provideInlayHints(G,ee,te,ce){return this._withAdapter(G,W,Z=>Z.provideInlayHints(g.URI.revive(ee),te,ce),void 0)}registerDocumentLinkProvider(G,ee,te){const ce=this._addNewAdapter(new X(this._documents,te),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof te.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,te){return this._withAdapter(G,X,ce=>ce.provideLinks(g.URI.revive(ee),te),void 0)}$resolveDocumentLink(G,ee,te){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,te),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,te=>te.releaseLinks(ee),void 0)}registerColorProvider(G,ee,te){const ce=this._addNewAdapter(new K(this._documents,te),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,te){return this._withAdapter(G,K,ce=>ce.provideColors(g.URI.revive(ee),te),[])}$provideColorPresentations(G,ee,te,ce){return this._withAdapter(G,K,Z=>Z.provideColorPresentations(g.URI.revive(ee),te,ce),void 0)}registerFoldingRangeProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new de(this._documents,te),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let se=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));se=S.Disposable.from(se,pe)}return se}$provideFoldingRanges(G,ee,te,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),te,ce),void 0)}registerSelectionRangeProvider(G,ee,te){const ce=this._addNewAdapter(new _e(this._documents,te,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,te,ce){return this._withAdapter(G,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),te,ce),[])}registerCallHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Ce(this._documents,te),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsTo(ee,te,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsFrom(ee,te,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,Ce,te=>Promise.resolve(te.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Pe(this._documents,te),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,te,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,te,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,te=>Promise.resolve(te.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:$e._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:$e._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?$e._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?$e._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:$e._serializeRegExp(G.beforeText),afterText:G.afterText?$e._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?$e._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map($e._serializeOnEnterRule)}setLanguageConfiguration(G,ee,te){let{wordPattern:ce}=te;if(ce&&(0,k.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?$e._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?$e._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?$e._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,se),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=$e,$e._handlePool=0}),define(fe[243],me([0,1,5,17,7,49,16,6]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(i,I,a,p){this._documents=I,this._commands=a,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,I){await this._proxy.$changeLanguage(i,I);const a=this._documents.getDocumentData(i);if(!a)throw new Error(`document '${i.toString}' NOT found`);return a.document}async tokenAtPosition(i,I){const a=i.version,p=L.Position.from(I),h=await this._proxy.$tokensAtPosition(i.uri,p),w={type:D.StandardTokenType.Other,range:i.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const y={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!y.range.contains(I)||a!==i.version?w:y}createLanguageStatusItem(i,I,a){const p=this._handlePool++,h=this._proxy,w=this._ids,y=`${i.identifier.value}/${I}`;if(w.has(y))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(y);const P={selector:a,id:I,name:i.displayName??i.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,s=new k.DisposableStore;const o=()=>{b?.dispose(),b=(0,A.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(p,{id:y,name:P.name??i.displayName??i.name,source:i.displayName??i.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===D.LanguageStatusSeverity.Error?S.default.Error:P.severity===D.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info,command:P.command&&this._commands.toInternal(P.command,s),accessibilityInfo:P.accessibilityInformation})},0)},v={dispose(){s.dispose(),b?.dispose(),h.$removeLanguageStatus(p),w.delete(y)},get id(){return P.id},get name(){return P.name},set name(n){P.name=n,o()},get selector(){return P.selector},set selector(n){P.selector=n,o()},get text(){return P.text},set text(n){P.text=n,o()},get detail(){return P.detail},set detail(n){P.detail=n,o()},get severity(){return P.severity},set severity(n){P.severity=n,o()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(n){P.accessibilityInformation=n,o()},get command(){return P.command},set command(n){P.command=n,o()}};return o(),v}}e.ExtHostLanguages=_}),define(fe[244],me([0,1,5,13,35]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(k){return k&&k.title}let A=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,C,i,I,a){const p={extension:_};let h;typeof I=="string"||S(I)?h=[I,...a]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,h=a),p.useCustom&&(0,D.checkProposedApiEnabled)(_);const w=[];for(let y=0;y<h.length;y++){const P=h[y];if(typeof P=="string")w.push({title:P,handle:y,isCloseAffordance:!1});else if(typeof P=="object"){let{title:b,isCloseAffordance:s}=P;w.push({title:b,isCloseAffordance:!!s,handle:y})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(C,i,p,w).then(y=>{if(typeof y=="number")return h[y]})}};A=Ve([We(1,L.ILogService)],A),e.ExtHostMessageService=A}),define(fe[245],me([0,1,22,3,48,6,24,9,12,2,88,5,17,7,55,220,131]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(s,o,v,n,f){this._textDocumentsAndEditors=v,this._textDocuments=n,this._extensionStoragePaths=f,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,d=r.cell.handle,c=this._documents.get(t)?.getCell(d);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,v]of this._editors)if(v.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const v=this._documents.get(s);if(!v&&!o)throw new Error(`NO notebook document for '${s}'`);return v}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,v,n,f){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:v});let r;return v.onDidChangeNotebookContentOptions&&(r=v.onDidChangeNotebookContentOptions(()=>{const t=a.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(o,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,a.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(s,f)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const v=o.filenamePattern.map(n=>a.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(o.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:v,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,v){const n=P._notebookStatusBarItemProviderHandlePool++,f=typeof v.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,f,o);let r;return f!==void 0&&(r=v.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(f))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,f),r&&r.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&a.NotebookData.from(s.content)});return C.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(s),n=this._documents.get(C.URI.revive(v));return(0,_.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(s,o){C.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let v;typeof o=="object"?v={position:a.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(a.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:v={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,v),f=n&&this._editors.get(n)?.apiEditor;if(f)return f;throw n?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,v,n){const f=this._notebookStatusBarItemProviders.get(s),r=C.URI.revive(o),t=this._documents.get(r);if(!t||!f)return;const d=t.getCellFromIndex(v);if(!d)return;const l=await f.provideCellStatusBarItems(d.apiCell,n);if(!l)return;const c=new S.DisposableStore,m=this._statusBarCache.add([c]),E=(Array.isArray(l)?l:[l]).map(T=>a.NotebookStatusBarItem.from(T,this._commandsConverter,c));return{cacheId:m,items:E}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,v,n,f){if((0,k.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},o,a.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(s,f)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,o,v){const n=this._notebookSerializer.get(s);if(!n)throw new Error("NO serializer found");const f=await n.deserializeNotebook(o.buffer,v);return new h.SerializableObjectWithBuffers(a.NotebookData.from(f))}async $notebookToData(s,o,v){const n=this._notebookSerializer.get(s);if(!n)throw new Error("NO serializer found");const f=await n.serializeNotebook(a.NotebookData.to(o.value),v);return g.VSBuffer.wrap(f)}async $openNotebook(s,o,v,n,f){const{provider:r}=this._getProviderData(s),t=await r.openNotebook(C.URI.revive(o),{backupId:v,untitledDocumentData:n?.buffer},f);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(a.NotebookCellData.from)})}async $saveNotebook(s,o,v){const n=this.getNotebookDocument(C.URI.revive(o)),{provider:f}=this._getProviderData(s);return await f.saveNotebook(n.apiNotebook,v),!0}async $saveNotebookAs(s,o,v,n){const f=this.getNotebookDocument(C.URI.revive(o)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(C.URI.revive(v),f.apiNotebook,n),!0}async $backupNotebook(s,o,v){const n=this.getNotebookDocument(C.URI.revive(o)),f=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension),t=String((0,D.hash)([n.uri.toString(),this._backupIdPool++])),d=C.URI.joinPath(r,t),l=await f.provider.backupNotebook(n.apiNotebook,{destination:d},v);return n.updateBackup(l),l.id}_createExtHostEditor(s,o,v){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const n=new y.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this._editors.set(o,n)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const v of s.value.removedDocuments){const n=C.URI.revive(v),f=this._documents.get(n);f&&(f.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const v=[];for(const n of s.value.addedDocuments){const f=C.URI.revive(n.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const r=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(d){r._onDidChangeNotebookCells.fire(d)},emitCellOutputsChange(d){r._onDidChangeCellOutputs.fire(d)},emitCellMetadataChange(d){r._onDidChangeCellMetadata.fire(d)},emitCellExecutionStateChange(d){r._onDidChangeCellExecutionState.fire(d)}},f,n);v.push(...n.cells.map(d=>w.ExtHostCell.asModelAddData(t.apiNotebook,d))),this._documents.get(f)?.dispose(),this._documents.set(f,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const v of s.value.addedEditors){if(this._editors.has(v.id))return;const n=C.URI.revive(v.documentUri),f=this._documents.get(n);f&&this._createExtHostEditor(f,v.id,v)}const o=[];if(s.value.removedEditors)for(const v of s.value.removedEditors){const n=this._editors.get(v);n&&(this._editors.delete(v),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),o.push(n))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const v=new Set;this._visibleNotebookEditors.forEach(n=>v.add(n.id));for(const n of this._editors.values()){const f=v.has(n.id);n._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(fe[246],me([0,1,3,77,13,5,14,17]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,a){const p=_._Keys.nextId();I.$registerNotebookEditorDecorationType(p,k.NotebookDecorationRenderOptions.from(a)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}_._Keys=new L.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,a,p){this._logService=I,this._extHostRpc=a,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,a);const p=this._notebooksAndEditors.getEditorById(I);a.visibleRanges&&p._acceptVisibleRanges(a.visibleRanges.ranges.map(k.NotebookRange.to)),a.selections&&p._acceptSelections(a.selections.selections.map(k.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const a in I)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(k.ViewColumn.to(I[a]))}};C=Ve([We(0,D.ILogService),We(1,A.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(fe[247],me([0,1,15,16,21,3,6,24,2,27,13,5,41,17,7,89,213,35,55]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(r,t,d,l,c){this._initData=t,this._extHostNotebook=d,this._commands=l,this._logService=c,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const m=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],a.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(r,t,d,l,c,m){for(let H of this._kernelData.values())if(H.controller.id===t&&C.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${r.identifier.value}, ${t}`);const T=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${r.identifier}'`);let R=!1;const B=new A.DisposableStore,N=new S.Emitter,F=new S.Emitter,$={id:`${r.identifier.value}/${t}`,notebookType:d,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let M=c??T,z;this._proxy.$addKernel(u,$).catch(H=>{console.log(H),R=!0});let U=0;const x=()=>{if(R)return;const H=++U;Promise.resolve().then(()=>{H===U&&this._proxy.$updateKernel(u,$)})},j=new k.ResourceMap,O={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return $.label},set label(H){$.label=H??r.displayName??r.name,x()},get detail(){return $.detail??""},set detail(H){$.detail=H,x()},get description(){return $.description??""},set description(H){$.description=H,x()},get kind(){return(0,P.checkProposedApiEnabled)(r),$.kind??""},set kind(H){(0,P.checkProposedApiEnabled)(r),$.kind=H,x()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(H){$.supportedLanguages=H,x()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(H){$.supportsExecutionOrder=H,x()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(H){M=H??T},get interruptHandler(){return z},set interruptHandler(H){z=H,$.supportsInterrupt=Boolean(H),x()},createNotebookCellExecution(H){if(R)throw new Error("notebook controller is DISPOSED");if(!j.has(H.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(W=>W.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return E._createNotebookCellExecution(H)},dispose:()=>{R||(this._logService.trace(`NotebookController[${u}], DISPOSED`),R=!0,this._kernelData.delete(u),B.dispose(),N.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(H,W){E._proxy.$updateNotebookPriority(u,H.uri,W)},onDidReceiveMessage:F.event,postMessage(H,W){return(0,P.checkProposedApiEnabled)(r),E._proxy.$postMessage(u,W&&E._extHostNotebook.getIdByEditor(W),H)},asWebviewUri(H){return(0,P.checkProposedApiEnabled)(r),(0,w.asWebviewUri)(H,E._initData.remote)}};return this._kernelData.set(u,{extensionId:r.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:j}),O}$acceptNotebookAssociation(r,t,d){const l=this._kernelData.get(r);if(l){const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));d?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),d),l.onDidChangeSelection.fire({selected:d,notebook:c.apiNotebook})}}async $executeCells(r,t,d){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),m=[];for(let u of d){const E=c.getCell(u);E&&m.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,c.apiNotebook,l.controller)}catch(u){this._logService.error(`NotebookController[${r}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(r,t,d){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let m of d){const u=c.getCell(m);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,t,d){const l=this._kernelData.get(r);if(!l)return;const c=this._extHostNotebook.getEditorById(t);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:d}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!d)throw new Error("invalid cell");if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const l=new v(d.notebook,d,this._proxy);this._activeExecutions.set(d.uri,l);const c=l.onDidChangeState(()=>{l.state===o.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(d.uri))});return l.asApiObject()}};s=Ve([We(4,i.ILogService)],s),e.ExtHostNotebookKernels=s;var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class v extends A.Disposable{constructor(r,t,d){super();this._document=r,this._cell=t,this._proxy=d,this._handle=v.HANDLE++,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new n(10,l=>this.update(l)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const t=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let t=this._cell;if(r&&(t=this._document.getCellFromApiCell(r)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(r){return r.map(t=>{const d=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return d===t.items?p.NotebookCellOutput.from(t):p.NotebookCellOutput.from({items:d,id:t.id,metadata:t.metadata})})}async updateOutputs(r,t,d){const l=this.cellIndexToHandle(t),c=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:y.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:d,outputs:c})}async updateOutputItems(r,t,d){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:y.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(p.NotebookCellOutputItem.from),outputId:t.id,append:d})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(d){r._executionOrder=d,r.update([{editType:y.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(d){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:y.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:d})},end(d,l){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:y.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:l,lastRunSuccess:d}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(d){return r.verifyStateForOutput(),r.updateOutputs([],d,!1)},appendOutput(d,l){return r.verifyStateForOutput(),r.updateOutputs(d,l,!0)},replaceOutput(d,l){return r.verifyStateForOutput(),r.updateOutputs(d,l,!1)},appendOutputItems(d,l){return r.verifyStateForOutput(),r.updateOutputItems(d,l,!0)},replaceOutputItems(d,l){return r.verifyStateForOutput(),r.updateOutputItems(d,l,!1)}})}}v.HANDLE=0;class n{constructor(r,t){this.delay=r,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>r.complete())}}}),define(fe[248],me([0,1,3,5,131]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(k,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=k.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,_,C){const i=this._extHostNotebook.getEditorById(k);this._rendererMessageEmitters.get(_)?.fire({editor:i.apiEditor,message:C})}createRendererMessaging(k,_){if(!k.contributes?.notebookRenderer?.some(a=>a.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const C=!!k.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(a,p,h)=>{const w=C?a:y=>{const P={};i.set(P,y.editor),a({editor:P,message:y.message})};return this.getOrCreateEmitterFor(_).event(w,p,h)},postMessage:(a,p)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(a)&&([a,p]=[p,a]);const h=C?p:i.get(p),w=h&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(w?.id,_,a)}}}getOrCreateEmitterFor(k){let _=this._rendererMessageEmitters.get(k);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(k)}}),this._rendererMessageEmitters.set(k,_),_)}}e.ExtHostNotebookRenderers=S}),define(fe[69],me([0,1,5,3,6,22,4,14]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends D.Disposable{constructor(h,w,y,P,b){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=h,this._proxy=b,this._id=b.$register(this.name,w,y,P),this._disposed=!1,this._offset=0}get name(){return this._name}append(h){this.validate(),this._offset+=h?S.VSBuffer.fromString(h).byteLength:0}update(){this._id.then(h=>this._proxy.$update(h))}appendLine(h){this.validate(),this.append(h+`
`)}clear(){this.validate();const h=this._offset;this._id.then(w=>this._proxy.$clear(w,h))}show(h,w){this.validate(),this._id.then(y=>this._proxy.$reveal(y,!!(typeof h=="boolean"?h:w)))}hide(){this.validate(),this._id.then(h=>this._proxy.$close(h))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(h=>this._proxy.$dispose(h)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(h,w,y){super(h,!1,void 0,w,y)}append(h){super.append(h),this._id.then(w=>this._proxy.$append(w,h)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends _{constructor(h,w,y){super(h,!0,w,void 0,y)}append(h){throw new Error("Not supported")}}class I{constructor(h,w){this.name=h,this._channel=w}append(h){this._channel.then(w=>w.append(h))}appendLine(h){this._channel.then(w=>w.appendLine(h))}clear(){this._channel.then(h=>h.clear())}show(h,w){this._channel.then(y=>y.show(h,w))}hide(){this._channel.then(h=>h.hide())}dispose(){this._channel.then(h=>h.dispose())}}e.LazyOutputChannel=I;let a=class{constructor(h){this._proxy=h.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(h){}createOutputChannel(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");return new C(h,w.identifier.value,this._proxy)}createOutputChannelFromLogFile(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(h,w,this._proxy)}};a=Ve([We(0,k.IExtHostRpcService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(fe[249],me([0,1,16,21,3,6,5,2,7,18,15,49,65]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(h,w,y){const P=h.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,m,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(l),T=++this._instances,R=P.$show(T,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},u),B={},N=R.then(()=>B);return Promise.race([N,E]).then(F=>{if(F!==B)return E.then($=>{const M=[];for(let z=0;z<$.length;z++){const U=$[z];let x,j,O,H,W;typeof U=="string"?x=U:(x=U.label,j=U.description,O=U.detail,H=U.picked,W=U.alwaysShow),M.push({label:x,description:j,handle:z,detail:O,picked:H,alwaysShow:W})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{m.onDidSelectItem($[z])}),P.$setItems(T,M),R.then(z=>{if(typeof z=="number")return $[z];if(Array.isArray(z))return z.map(U=>$[U])})})}).then(void 0,F=>{if(!(0,C.isPromiseCanceledError)(F))return P.$setError(T,F),Promise.reject(F)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=L.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,P.$input(l,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,C.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(l){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=L.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!m)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(l,c){const m=new r(l,c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(l){const c=new t(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const m=this._sessions.get(l);m&&m._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const m=this._sessions.get(l);m instanceof r&&m._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const m=this._sessions.get(l);m instanceof r&&m._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const m=this._sessions.get(l);m&&m._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,m){const u=this._sessions.get(l);u instanceof r&&u._fireDidTriggerItemButton(c,m)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class s{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,m)=>{const u=c===_.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(u,c)}),this.update({buttons:l.map((c,m)=>({...f(c),tooltip:c.tooltip,handle:c===_.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const m=l[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function o(d){if(d instanceof _.ThemeIcon)return{id:d.id};const l=n(d),c=v(d);return{dark:typeof l=="string"?k.URI.file(l):l,light:typeof c=="string"?k.URI.file(c):c}}function v(d){return typeof d=="object"&&"light"in d?d.light:d}function n(d){return typeof d=="object"&&"dark"in d?d.dark:d}function f(d){const l=o(d.iconPath);let c,m;return"id"in l?m=a.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:m}}class r extends s{constructor(l,c,m){super(l,m);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,m)=>{this._handlesToItems.set(m,c),this._itemsToHandles.set(c,m)}),this.update({items:l.map((c,m)=>({label:c.label,description:c.description,handle:m,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((u,E)=>({...f(u),tooltip:u.tooltip,handle:E})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,i.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,i.coalesce)(l.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const m=this._handlesToItems.get(l);if(!m||!m.buttons||!m.buttons.length)return;const u=m.buttons[c];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:m})}}class t extends s{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?I.default.Error:I.default.Ignore})}}return new b(w,y)}e.createExtHostQuickOpen=p}),define(fe[250],me([0,1,2,3,60,6,16,5,15,101,13,27,35,65,17]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(l){if(l)return typeof l.iconPath=="string"?g.URI.file(l.iconPath):g.URI.isUri(l.iconPath)||p.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function y(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const m=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,u=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,C.comparePaths)(m,u)}function P(l,c){let m=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(m=y(l,c),m!==0)return m;if(l.light&&c.light)m=y(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(m!==0)return m;if(l.dark&&c.dark)m=y(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return m}function b(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let m=0;m<l.arguments.length;m++){const u=l.arguments[m],E=c.arguments[m];if(u!==E)return u<E?-1:1}return 0}function s(l,c){let m=(0,C.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(m!==0)return m;if(l.command&&c.command)m=b(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(m!==0)return m;if(l.decorations&&c.decorations)m=P(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return m}function o(l,c){for(let m=0;m<l.length;m++)if(l[m]!==c[m])return!1;return!0}function v(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?o(l.arguments,c.arguments):l.arguments===c.arguments)}function n(l,c){return(0,_.equals)(l,c,v)}class f{constructor(c,m,u){this._extension=c,this._proxy=m,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,a.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,a.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,m){(0,a.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,m)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=f;class r{constructor(c,m,u,E,T){this._proxy=c,this._commands=m,this._sourceControlHandle=u,this._id=E,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,m){const u=this._resourceStatesCommandsMap.get(c);return u?(0,A.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(s),u=(0,_.sortedDiff)(this._resourceSnapshot,c,s).map(R=>{const B=R.toInsert.map(N=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,N);const $=N.resourceUri;let M;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const de=new S.DisposableStore;M=this._commands.converter.toInternal(N.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,N.command);const z=w(N.decorations),U=N.decorations&&w(N.decorations.light)||z,x=N.decorations&&w(N.decorations.dark)||z,j=[U,x],O=N.decorations&&N.decorations.tooltip||"",H=N.decorations&&!!N.decorations.strikeThrough,W=N.decorations&&!!N.decorations.faded,X=N.contextValue||"";return{rawResource:[F,$,j,O,H,W,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),E=u.map(({start:R,deleteCount:B,toInsert:N})=>[R,B,N.map(F=>F.rawResource)]),T=u.reverse();for(const{start:R,deleteCount:B,toInsert:N}of T){const F=N.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=c,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(c,m,u,E,T,R){this._extension=c,this._proxy=m,this._commands=u,this._id=E,this._label=T,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new S.MutableDisposable,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,T,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=c;const m=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,a.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new S.DisposableStore,this._actionButton=c;const m=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&n(this._statusBarCommands,c))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=c;const m=(c||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(c,m){const u=new r(this._proxy,this._commands,this.handle,c,m),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const c=[],m=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const T=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),T.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),c.push([u.handle,u.id,u.label,u.features]);const R=u._takeResourceStateSnapshot();R.length>0&&m.push([u.handle,R]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,c,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(m=>{const u=m._takeResourceStateSnapshot();u.length!==0&&c.push([m.handle,u])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,D.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let d=class $n{constructor(c,m,u){this._commands=m,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const T=this._sourceControls.get(E.sourceControlHandle);if(!T)return E;const R=T.getResourceGroup(E.groupHandle);return R?R.getResourceState(E.handle):E}else if(E&&E.$mid===4){const T=this._sourceControls.get(E.sourceControlHandle);return T?T.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const T=this._sourceControls.get(E.handle);return T||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,m,u,E){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,m,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const T=$n._handlePool++,R=new t(c,this._proxy,this._commands,m,u,E);this._sourceControls.set(T,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),B),R}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),u=m&&m[m.length-1];return u&&u.inputBox}$provideOriginalResource(c,m,u){const E=g.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,E.toString());const T=this._sourceControls.get(c);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(E,u)).then(R=>R||null)}$onInputBoxValueChange(c,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const u=this._sourceControls.get(c);return u&&u.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(c,m,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,m,u);const T=this._sourceControls.get(c);if(!T)return Promise.resolve(void 0);const R=T.getResourceGroup(m);return R?R.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(c,m,u){this.logService.trace("ExtHostSCM#$validateInput",c);const E=this._sourceControls.get(c);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>E.inputBox.validateInput(m,u)).then(T=>{if(!T)return Promise.resolve(void 0);const R=h.MarkdownString.fromStrict(T.message);return R?Promise.resolve([R,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};d._handlePool=0,d=Ve([We(2,i.ILogService)],d),e.ExtHostSCM=d});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[251],me([0,1,7,5,167,6,17,12]),function(Y,e,g,L,D,S,A,k){"use strict";var _,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(h,w,y,P,b=g.StatusBarAlignment.Left,s){_.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,st(this,_,h,"f"),st(this,C,w,"f"),this._entryId=i.ID_GEN++,this._extension=y,this._id=P,this._alignment=b,this._priority=this.validatePriority(s)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!i.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ne(this,C,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ne(this,C,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let y=this._color;this._backgroundColor&&(y=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,_,"f").$setEntry(this._entryId,h,w,this._text,P,this._command?.internal,y,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,_=new WeakMap,C=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const y=this._messages.indexOf(w);y>=0&&(this._messages.splice(y,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(h,w){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,y,P){return new i(this._proxy,this._commands,h,w,y,P)}setStatusBarMessage(h,w){const y=this._statusMessage.setMessage(h);let P;return typeof w=="number"?P=setTimeout(()=>y.dispose(),w):typeof w!="undefined"&&w.then(()=>y.dispose(),()=>y.dispose()),new g.Disposable(()=>{y.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=a}),define(fe[93],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}getValue(k,_,C){return this._proxy.$getValue(k,_).then(i=>i||C)}setValue(k,_,C){return this._proxy.$setValue(k,_,C)}$acceptValue(k,_,C){this._onDidChangeStorage.fire({shared:k,key:_,value:C})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,28,13,92,2]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let k=class{constructor(C,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(C){return A.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,i=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([We(0,L.IExtHostInitDataService),We(1,D.ILogService),We(2,S.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(fe[33],me([0,1,3,5,4,2,14,6,7,168,18,215,21,32,196,65,12,16]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(l,c,m,u){this._proxy=l,this._id=c,this._creationOptions=m,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(T,R=!0){E._checkDisposed(),E._proxy.$sendText(E._id,T,R)},show(T){E._checkDisposed(),E._proxy.$show(E._id,T)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,y.withNullAsUndefined)(l.shellPath),shellArgs:(0,y.withNullAsUndefined)(l.shellArgs),cwd:(0,y.withNullAsUndefined)(l.cwd),env:(0,y.withNullAsUndefined)(l.env),icon:(0,y.withNullAsUndefined)(r(l.iconPath)),color:w.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,y.withNullAsUndefined)(l.message),strictEnv:(0,y.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,y.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,y.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,y.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,m,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=b;class s{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let o=1,v=class extends k.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[m,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const m=new b(this._proxy,(0,p.generateUuid)(),l,l.name),u=new s(l.pty);return m.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,r(l.iconPath),t(l.color)).then(E=>{const T=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=T}),this._terminals.push(m),m.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const m=l.location.parentTerminal;if(m){const u=this._terminals.find(E=>E.value===m);u&&(c.resolvedExtHostIdentifier=u._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const u=new s(c),E=this._setupExtHostProcessListeners(l,u);this._terminalProcessDisposables[l]=E}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(l);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const m=this._getTerminalById(l);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(l,c,m){const u=this._getTerminalById(l);u&&u.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,m){this._terminalProcesses.get(l)?.resize(c,m)}async $acceptTerminalTitleChange(l,c){const m=this._getTerminalById(l);m&&(m.name=c)}async $acceptTerminalClosed(l,c){const m=this._getTerminalObjectIndexById(this._terminals,l);if(m!==null){const u=this._terminals.splice(m,1)[0];u.setExitCode(c),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(l,c,m,u){if(c){const R=this._getTerminalObjectIndexById(this._terminals,c);if(R!==null){this._terminals[R]._id=l,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:S.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},T=new b(this._proxy,l,E,m);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(l,c){const m=this._getTerminalById(l);m&&m._setProcessId(c)}async $startExtensionTerminal(l,c){const m=this._getTerminalById(l);if(!m)return{message:(0,C.localize)(0,null,l)};m.isOpen||await new Promise(E=>{const T=this.onDidOpenTerminal(async R=>{R===m.value&&(T.dispose(),E())})});const u=this._terminalProcesses.get(l);u?u.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const m=new k.DisposableStore;m.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(l,E.pid,E.cwd))),m.add(c.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(l,E))),this._bufferer.startBuffering(l,c.onProcessData),m.add(c.onProcessExit(E=>this._onProcessExit(l,E))),this._terminalProcesses.set(l,c);const u=this._extensionTerminalAwaitingStart[l];return u&&c instanceof s&&(c.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),m}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,m){try{this._terminalProcesses.get(l)?.resize(c,m)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:c}))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,l.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const m=new a.CancellationTokenSource().token;let u=await this._profileProviders.get(l)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,c);return}this.createTerminalFromOptions(u.options,c)}}async $provideLinks(l,c){const m=this._getTerminalById(l);if(!m)return[];this._terminalLinkCache.delete(l);const u=this._terminalLinkCancellationSource.get(l);u&&u.dispose(!0);const E=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,E);const T=[],R={terminal:m.value,line:c},B=[];for(const $ of this._linkProviders)B.push(P.Promises.withAsyncBody(async M=>{E.token.onCancellationRequested(()=>M({provider:$,links:[]}));const z=await $.provideTerminalLinks(R,E.token)||[];E.token.isCancellationRequested||M({provider:$,links:z})}));const N=await Promise.all(B);if(E.token.isCancellationRequested)return[];const F=new Map;for(const $ of N)$&&$.links.length>0&&T.push(...$.links.map(M=>{const z={id:o++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(z.id,{provider:$.provider,link:M}),z}));return this._terminalLinkCache.set(l,F),T}$activateLink(l,c){const m=this._terminalLinkCache.get(l)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const m=this._terminalProcessDisposables[l];m&&(m.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const m=this._getTerminalObjectIndexById(l,c);return m!==null?l[m]:null}_getTerminalObjectIndexById(l,c){let m=null;return l.some((u,E)=>u._id===c?(m=E,!0):!1),m}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new n,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const m=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const m=c[0],u=new n(c[1]);this._setEnvironmentVariableCollection(m,u)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};v=Ve([We(1,A.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class n{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:_.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:_.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const m=this.map.get(l);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((m,u)=>l.call(c,u,m,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let f=class extends v{constructor(l){super(!1,l)}createTerminal(l,c,m){throw new i.NotSupportedError}createTerminalFromOptions(l,c){throw new i.NotSupportedError}};f=Ve([We(0,A.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function r(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function t(d){return w.ThemeColor.isThemeColor(d)?d:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[252],me([0,1,15,22,21,3,76,48,6,25,12,32,5,14,66,17,7,223,129,90]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,B){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(a.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new f(this.proxy),B.registerArgumentProcessor({processArgument:N=>N?.$mid===13?w.TestItem.toItemFromContext(N):N})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const N=new _.DisposableStore,F=N.add(new P.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,z={items:F.root.children,get label(){return B},set label(x){B=x,F.root.label=x,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(x,j,O,H,W)=>{let X=(0,k.hash)(x);for(;$.has(X);)X++;const K=new u(this.proxy,R,X,x,j,O,H,W);return $.set(X,K),K},createTestItem(x,j,O){return new h.TestItemImpl(R,x,j,O)},createTestRun:(x,j,O=!0)=>this.runTracker.createTestRun(R,F,x,j,O),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{N.dispose()}};z.createRunConfiguration=z.createRunProfile,M.$registerTestController(R,B),N.add((0,_.toDisposable)(()=>M.$unregisterTestController(R)));const U={controller:z,collection:F,profiles:$};return this.controllers.set(R,U),N.add((0,_.toDisposable)(()=>this.controllers.delete(R))),N.add(F.onDidGenerateDiff(x=>M.$publishDiff(R,x))),z}createTestObserver(){return this.observer.checkout()}async runTests(R,B=D.CancellationToken.None){const N=r(R);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(N.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:E[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,N){return(0,g.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(R,B,N,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(N,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,C.deepFreeze)(w.TestResults.to(B))).concat(this.results).sort((B,N)=>N.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const N=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;N&&(await N.expand(R,B<0?Infinity:B),N.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const N=this.controllers.get(R.controllerId);if(!N)return;const{collection:F,profiles:$}=N,M=$.get(R.profileId);if(!M)return;const z=R.testIds.map(O=>F.tree.get(O)).filter(i.isDefined),U=R.excludeExtIds.map(O=>N.collection.tree.get(O)).filter(i.isDefined).filter(O=>z.some(H=>H.fullId.compare(O.fullId)===2));if(!z.length)return;const x=new y.TestRunRequest(z.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:z.map(O=>O.actual),U.map(O=>O.actual),M),j=this.runTracker.prepareForMainThreadTestRun(x,t.fromInternal(R,N.collection),B);try{await M.runHandler(x,B)}finally{j.isRunning&&!B.isCancellationRequested&&await S.Event.toPromise(j.onEnd),j.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=Ve([We(0,p.IExtHostRpcService)],v),e.ExtHostTesting=v;class n extends _.Disposable{constructor(R,B,N){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,N=this.dto.controllerId,F=(0,I.generateUuid)(),$=new d(this.proxy,B,F),M=j=>(O,...H)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),j(O,...H))},z=(j,O)=>{const H=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(j.uri&&j.range){const W={range:w.Range.from(j.range),uri:j.uri};for(const X of H)X.location=X.location||W}this.proxy.$appendTestMessagesInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),H)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(j){$.coverageProvider=j},enqueued:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),1)}),skipped:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),5)}),started:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),2)}),errored:M((j,O,H)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),6,H)}),failed:M((j,O,H)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),4,H)}),passed:M((j,O)=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,this.dto.controllerId).toString(),3,O)}),appendOutput:(j,O,H)=>{U||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(j),O&&w.location.from(O),H&&s.TestId.fromExtHostTestItem(H,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],N=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===N))break;R=R.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class f{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,N){return this.getTracker(R,B,N)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,N,F,$){const M=this.tracked.get(N);if(M)return M.createRun(F);const z=t.fromPublic(R,B,N,$),U=r(N);this.proxy.$startedExtensionTestRun({controllerId:R,profile:U&&{group:E[U.kind],id:U.profileId},exclude:N.exclude?.map(j=>j.id)??[],id:z.id,include:N.include?.map(j=>j.id)??[B.root.id],persist:$});const x=this.getTracker(N,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(F)}getTracker(R,B,N){const F=new n(B,this.proxy,N);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=f;const r=T=>{if(!!T.profile){if(!(T.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(R,B,N,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=N.map(z=>z+"\0"),this.excludePrefix=F.map(z=>z+"\0")}static fromPublic(R,B,N,F){return new t(R,(0,I.generateUuid)(),N.include?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[R],N.exclude?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(B===N||B.startsWith(N))return!1;for(const N of this.includePrefix)if(B===N||B.startsWith(N))return!0;return!1}}e.TestRunDto=t;class d{constructor(R,B,N){this.proxy=R,this.runId=B,this.taskId=N}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const N=await this.fileCoverage;let F=N?.[R];return!this._coverageProvider||!N||!F?[]:(F.detailedCoverage||(F=N[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class l extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:N}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...N].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,A.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,B,N,F,$,M,z=!1,U=void 0){this.controllerId=B,this.profileId=N,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=z,this._tag=U,o.set(this,void 0),st(this,o,R,"f");const x=E[$];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ne(this,o,"f").$publishTestRunProfile({profileId:N,controllerId:B,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:F,group:x,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ne(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,o=new WeakMap;const E={[y.TestRunProfileKind.Coverage]:8,[y.TestRunProfileKind.Debug]:4,[y.TestRunProfileKind.Run]:2}}),define(fe[253],me([0,1,3,15,5,132,17,7]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(a=>a.value)}async showTextDocument(i,I,a){let p;typeof I=="number"?p={position:A.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?p={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(i.uri,p),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new S.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const a=this._extHostDocumentsAndEditors.getEditor(i);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(A.Selection.to);a._acceptSelections(p)}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(A.Range.to));a._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:h,kind:p})}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const I in i){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const p=A.ViewColumn.to(i[I]);a.value.viewColumn!==p&&(a._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=_}),define(fe[254],me([0,1,2,4,5,6,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const p=a.uri===void 0?void 0:g.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(_(p))?.get(a.handle)}return a}})}async $getTimeline(i,I,a,p,h){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),a,p,h)}registerTimelineProvider(i,I,a,p){const h=new S.DisposableStore,w=this.convertTimelineItem(I.id,p,h).bind(this);let y;I.onDidChange&&(y=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(b,s,o,v){v?.resetCache&&(h.clear(),P.get(I.id)?.clear());const n=await I.provideTimeline(b,s,o);if(n==null)return;const f=w(b,v);return{...n,source:I.id,items:n.items.map(f)}},dispose(){for(const b of P.values())b.get(I.id)?.clear();y?.dispose(),h.dispose()}})}convertTimelineItem(i,I,a){return(p,h)=>{let w;if(h?.cacheResults){let y=this._itemsBySourceAndUriMap.get(i);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(i,y));const P=_(p);w=y.get(P),w===void 0&&(w=new Map,y.set(P,w))}return y=>{const{iconPath:P,...b}=y,s=`${i}|${y.id??y.timestamp}`;w?.set(s,y);let o,v,n;return y.iconPath&&(P instanceof A.ThemeIcon?n={id:P.id,color:P.color}:g.URI.isUri(P)?(o=P,v=P):{light:o,dark:v}=P),{...b,id:b.id??void 0,handle:s,source:i,command:y.command?I.toInternal(y.command,a):void 0,icon:o,iconDark:v,themeIcon:n,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=k;function _(C){return C?.toString()}}),define(fe[255],me([0,1,6,10,2,5]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(_){this._openers=new Map,this._proxy=_.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const a=I.schemes.find(p=>!A.supportedSchemes.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),(0,g.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,i){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const a=D.URI.revive(C);return I.canOpenExternalUri(a,i)}async $openUri(_,C,i){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[256],me([0,1,5,2,6,18,27]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(A.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=k.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,D.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(a){(0,S.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(C){return L.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=k,k.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,181,205,89,5]),function(Y,e,g,L,D,S,A,k,_){"use strict";var C,i,I,a,p,h,w,y,P,b,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(m,u,E,T,R,B,N){C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,""),y.set(this,void 0),P.set(this,!1),b.set(this,!1),s.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new g.Emitter),this._onDidDispose=Ne(this,o,"f").event,st(this,C,m,"f"),st(this,i,u,"f"),st(this,y,E,"f"),st(this,a,T,"f"),st(this,p,R,"f"),st(this,h,B,"f"),st(this,s,n(B),"f"),st(this,I,N,"f")}dispose(){st(this,P,!0,"f"),Ne(this,o,"f").fire(),Ne(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return st(this,b,!0,"f"),(0,k.asWebviewUri)(m,Ne(this,a,"f").remote)}get cspSource(){const m=Ne(this,h,"f").extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let u=m.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,w,"f")}set html(m){this.assertNotDisposed(),Ne(this,w,"f")!==m&&(st(this,w,m,"f"),!Ne(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(st(this,b,!0,"f"),Ne(this,I,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,i,"f").$setHtml(Ne(this,C,"f"),m))}get options(){return this.assertNotDisposed(),Ne(this,y,"f")}set options(m){this.assertNotDisposed(),Ne(this,i,"f").$setOptions(Ne(this,C,"f"),t(Ne(this,h,"f"),Ne(this,p,"f"),m)),st(this,y,m,"f")}async postMessage(m){if(Ne(this,P,"f"))return!1;const u=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ne(this,s,"f")});return Ne(this,i,"f").$postMessage(Ne(this,C,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ne(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,C=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,P=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap;function n(c){try{const m=(0,S.normalizeVersion)((0,S.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class f{constructor(m,u,E,T,R){this.initData=u,this.workspace=E,this._logService=T,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(m,u,...E){const T=this.getWebview(m);if(T){const{message:R}=(0,A.deserializeWebviewMessage)(u,E);T._onMessageEmitter.fire(R)}}$onMissingCsp(m,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,u,E){const T=new v(m,this._webviewProxy,d(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(m,T),T._onDidDispose(()=>{this._webviews.delete(m)}),T}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=f;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function t(c,m,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||l(c,m)}}e.serializeWebviewOptions=t;function d(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>D.URI.from(m))}}e.reviveOptions=d;function l(c,m){return[...(m?.getWorkspaceFolders()||[]).map(u=>u.uri),c.extensionLocation]}}),define(fe[257],me([0,1,21,48,6,10,23,2,17,71,88,5,7]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(n,f){this.document=n,this._storagePath=f,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,f){await this.getEdit(n).undo(),f||this.disposeBackup()}async redo(n,f){await this.getEdit(n).redo(),f||this.disposeBackup()}disposeEdits(n){for(const f of n)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=o(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const f=this._edits.get(n,0);if(!f)throw new Error("No edit found");return f}}class h{constructor(){this._documents=new Map}get(n,f){return this._documents.get(this.key(n,f))}add(n,f,r){const t=this.key(n,f.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${n} resource:${f.uri}`);const d=new p(f,r);return this._documents.set(t,d),d}delete(n,f){const r=this.key(n,f.uri);this._documents.delete(r)}key(n,f){return`${n}@@@${f}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class y{constructor(){this._providers=new Map}addTextProvider(n,f,r){return this.add(0,n,f,r)}addCustomProvider(n,f,r){return this.add(1,n,f,r)}get(n){return this._providers.get(n)}add(n,f,r,t){if(this._providers.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this._providers.set(f,{type:n,extension:r,provider:t}),new a.Disposable(()=>this._providers.delete(f))}}class P{constructor(n,f,r,t,d){this._extHostDocuments=f,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=d,this._editorProviders=new y,this._documents=new h,this._proxy=n.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,f,r,t){const d=new D.DisposableStore;return b(r)?(d.add(this._editorProviders.addTextProvider(f,n,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(n),f,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(n))):(d.add(this._editorProviders.addCustomProvider(f,n,r)),this.supportEditing(r)&&d.add(r.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(f,l.document.uri);if(s(l)){const m=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,f,m,l.label)}else this._proxy.$onContentChange(l.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(n),f,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(n))),a.Disposable.from(d,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(n,f,r,t,d){const l=this._editorProviders.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${f}'`);const c=k.URI.revive(n),m=await l.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:t?.buffer},d);let u;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(f,m,u),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(n,f){const r=this._editorProviders.get(f);if(!r)throw new Error(`No provider found for '${f}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${f}'`);const t=k.URI.revive(n),{document:d}=this.getCustomDocumentEntry(f,t);this._documents.delete(f,d),d.dispose()}async $resolveWebviewEditor(n,f,r,t,d,l){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const m=_.ViewColumn.to(d),u=this._extHostWebview.createNewWebview(f,t.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(f,r,t.title,m,t.panelOptions,u),T=k.URI.revive(n);switch(c.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,T);return c.provider.resolveCustomEditor(R,E,l)}case 0:{const R=this._extHostDocuments.getDocument(T);return c.provider.resolveCustomTextEditor(R,E,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,f,r){this.getCustomDocumentEntry(f,n).disposeEdits(r)}async $onMoveCustomEditor(n,f,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const d=this._extHostWebviewPanels.getWebviewPanel(n);if(!d)throw new Error("No webview found");const l=k.URI.revive(f),c=this._extHostDocuments.getDocument(l);await t.provider.moveCustomTextEditor(c,d,g.CancellationToken.None)}async $undo(n,f,r,t){return this.getCustomDocumentEntry(f,n).undo(r,t)}async $redo(n,f,r,t){return this.getCustomDocumentEntry(f,n).redo(r,t)}async $revert(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(n,f,r){const t=this.getCustomDocumentEntry(f,n);await this.getCustomEditorProvider(f).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(n,f,r,t){const d=this.getCustomDocumentEntry(f,n);return this.getCustomEditorProvider(f).saveCustomDocumentAs(d.document,k.URI.revive(r),t)}async $backup(n,f,r){const t=this.getCustomDocumentEntry(f,n),l=await this.getCustomEditorProvider(f).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(l),l.id}getCustomDocumentEntry(n,f){const r=this._documents.get(n,k.URI.revive(f));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const r=this._editorProviders.get(n)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function b(v){return typeof v.resolveCustomTextEditor=="function"}function s(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function o(v){const n=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(n)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[258],me([0,1,3,6,2,32,17,71,5,7]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";var i,I,a,p,h,w,y,P,b,s,o,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class f extends L.Disposable{constructor(l,c,m,u,E,T,R){super();i.set(this,void 0),I.set(this,void 0),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,void 0),y.set(this,void 0),P.set(this,void 0),b.set(this,!0),s.set(this,!0),o.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,v,"f").event,n.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ne(this,n,"f").event,st(this,i,l,"f"),st(this,I,c,"f"),st(this,a,m,"f"),st(this,h,T,"f"),st(this,P,E,"f"),st(this,w,u,"f"),st(this,p,R,"f")}dispose(){Ne(this,o,"f")||(st(this,o,!0,"f"),Ne(this,v,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,i,"f")),Ne(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,a,"f")}get title(){return this.assertNotDisposed(),Ne(this,w,"f")}set title(l){this.assertNotDisposed(),Ne(this,w,"f")!==l&&(st(this,w,l,"f"),Ne(this,I,"f").$setTitle(Ne(this,i,"f"),l))}get iconPath(){return this.assertNotDisposed(),Ne(this,y,"f")}set iconPath(l){this.assertNotDisposed(),Ne(this,y,"f")!==l&&(st(this,y,l,"f"),Ne(this,I,"f").$setIconPath(Ne(this,i,"f"),D.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ne(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,P,"f")=="number"&&Ne(this,P,"f")<0))return Ne(this,P,"f")}get active(){return this.assertNotDisposed(),Ne(this,s,"f")}get visible(){return this.assertNotDisposed(),Ne(this,b,"f")}_updateViewState(l){Ne(this,o,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(st(this,s,l.active,"f"),st(this,b,l.visible,"f"),st(this,P,l.viewColumn,"f"),Ne(this,n,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,i,"f"),{viewColumn:l?A.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ne(this,o,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap,P=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap,v=new WeakMap,n=new WeakMap;class r{constructor(l,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(l,c,m,u,E={}){const T=typeof u=="object"?u.viewColumn:u,R={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof u=="object"&&!!u.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(l),N=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(l),N,c,{title:m,panelOptions:t(E),webviewOptions:(0,k.serializeWebviewOptions)(l,this.workspace,E),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(N,E,l);return this.createNewWebviewPanel(N,c,m,T,E,F)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((m,u)=>{const E=l[m],T=l[u];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const m of c){const u=this.getWebviewPanel(m);if(!u)continue;const E=l[m];u._updateViewState({active:E.active,visible:E.visible,viewColumn:A.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(l)}),new C.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,m,u){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:T,extension:R}=E,B=this.webviews.createNewWebview(l,m.webviewOptions,R),N=this.createNewWebviewPanel(l,c,m.title,u,m.panelOptions,B);await T.deserializeWebviewPanel(N,m.state)}createNewWebviewPanel(l,c,m,u,E,T){const R=new f(l,this._proxy,c,m,u,E,T);return this._webviewPanels.set(l,R),R}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=r;function t(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[259],me([0,1,3,6,71,5,7]),function(Y,e,g,L,D,S,A){"use strict";var k,_,C,i,I,a,p,h,w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(o,v,n,f,r,t){super();k.set(this,void 0),_.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),a.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ne(this,w,"f").event,y.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,y,"f").event,st(this,C,n,"f"),st(this,p,f,"f"),st(this,k,o,"f"),st(this,_,v,"f"),st(this,i,r,"f"),st(this,a,t,"f")}dispose(){Ne(this,I,"f")||(st(this,I,!0,"f"),Ne(this,y,"f").fire(),Ne(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,p,"f")}set title(o){this.assertNotDisposed(),Ne(this,p,"f")!==o&&(st(this,p,o,"f"),Ne(this,_,"f").$setWebviewViewTitle(Ne(this,k,"f"),o))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(o){this.assertNotDisposed(),Ne(this,h,"f")!==o&&(st(this,h,o,"f"),Ne(this,_,"f").$setWebviewViewDescription(Ne(this,k,"f"),o))}get visible(){return Ne(this,a,"f")}get webview(){return Ne(this,i,"f")}get viewType(){return Ne(this,C,"f")}_setVisible(o){o===Ne(this,a,"f")||Ne(this,I,"f")||(st(this,a,o,"f"),Ne(this,w,"f").fire())}show(o){this.assertNotDisposed(),Ne(this,_,"f").$show(Ne(this,k,"f"),!!o)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,a=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,y=new WeakMap;class b{constructor(o,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,v,n,f){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:n,extension:o}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(o),v,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(o,v,n,f,r){const t=this._viewProviders.get(v);if(!t)throw new Error(`No view provider found for '${v}'`);const{provider:d,extension:l}=t,c=this._extHostWebview.createNewWebview(o,{},l),m=new P(o,this._proxy,v,n,c,!0);this._webviewViews.set(o,m),await d.resolveWebviewView(m,{state:f},r)}async $onDidChangeWebviewViewVisibility(o,v){this.getWebviewView(o)._setVisible(v)}async $disposeWebviewView(o){const v=this.getWebviewView(o);this._webviewViews.delete(o),v.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const v=this._webviewViews.get(o);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Wn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let p;if(typeof I=="string"){p=I;try{I=D.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,A.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,a)}async asExternalUri(I,a){if((0,A.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,a);return D.URI.from(p)}};C.InitialState={focused:!0},C=Ve([We(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(fe[260],me([0,1,8,82,32,41,6,5,2,14]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends A.Disposable{constructor(a,p){super();const h=a.getProxy(k.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const y=_.URI.file((0,g.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await h.$download(w,y),y})}};i=Ve([We(0,C.IExtHostRpcService),We(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[261],me([0,1,2,8,152,26,69,28,14,6,13,117,40]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(P,b,s){this.name=P,this.file=b,this.appender=s}static async create(P,b){const s=await(0,I.createRotatingLogger)(P,b,30*a.ByteSize.MB,1);return s.clearFormatters(),new p(P,b,s)}append(P){this.appender.critical(P)}flush(){this.appender.flush()}}class h extends A.AbstractExtHostOutputChannel{constructor(P,b,s,o){super(P,!1,g.URI.file(b.file),s,o);this._appender=b}append(P){super.append(P),this._appender.append(P),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(P,b){this._appender.flush(),super.show(P,b)}clear(){this._appender.flush(),super.clear()}}let w=class extends A.ExtHostOutputService{constructor(P,b,s){super(P);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=s.logsLocation}$setVisibleChannel(P){if(P){const b=this._channels.get(P);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(P,b){if(P=P.trim(),!P)throw new Error("illegal argument `name`. must not be falsy");const s=this._doCreateOutChannel(P,b);return s.then(o=>o._id.then(v=>this._channels.set(v,o))),new A.LazyOutputChannel(P,s)}async _doCreateOutChannel(P,b){try{const s=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(s)||await S.Promises.mkdir(s,{recursive:!0});const v=`${this._namePool++}-${P.replace(/[\\/:\*\?"<>\|]/g,"")}`,n=g.URI.file((0,L.join)(s,`${v}.log`)),f=await p.create(v,n.fsPath);return new h(P,f,b.identifier.value,this._proxy)}catch(s){return this.logService.error(s),new A.ExtHostPushOutputChannel(P,b.identifier.value,this._proxy)}}};w=Ve([We(0,_.IExtHostRpcService),We(1,i.ILogService),We(2,k.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(fe[262],me([0,1,50,8,2,70,6,10,16,26]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class i extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const f=await super._getWorkspaceStorageURI(n);if(f.scheme!==k.Schemas.file)return f;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const r=f.fsPath;let t=0;do{let d;t===0?d=r:d=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await I(d);const l=L.join(d,"vscode.lock"),c=await w(this._logService,l,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),D.URI.file(d);t++}while(t<10);return f}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=i;async function I(v){try{await C.Promises.stat(v);return}catch{}try{await C.Promises.mkdir(v,{recursive:!0})}catch{}}const a=1e3,p=10*60*1e3;class h extends A.Disposable{constructor(n,f){super();this.logService=n,this.filename=f,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await y(n,f);(!r||r.pid!==process.pid)&&(n.info(`Lock '${f}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(f,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${f}': Could not update mtime.`)}},a)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(n){}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+n};await C.Promises.writeFile(this.filename,JSON.stringify(f),{flag:"w"})}catch(f){this.logService.error(f)}}}async function w(v,n,f){try{const t={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){v.error(t)}const r=await y(v,n);return!r||r.pid!==process.pid?f?(v.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),s(v,n)):(v.info(`Lock '${n}': Lock acquired.`),new h(v,n))}async function y(v,n){let f;try{f=await C.Promises.readFile(n)}catch(r){return v.error(r),null}try{return JSON.parse(String(f))}catch(r){return v.error(r),null}}async function P(v,n){let f;try{f=await C.Promises.stat(n)}catch(r){return v.error(r),0}return f.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch(n){return!1}}async function s(v,n){const f=await y(v,n);if(!f)return v.info(`Lock '${n}': Could not read pid of lock holder.`),o(v,n);if(f.willReleaseAt){let c=f.willReleaseAt-Date.now();if(c<5e3){for(c>0?v.info(`Lock '${n}': The lockfile is scheduled to be released in ${c} ms.`):v.info(`Lock '${n}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,_.timeout)(Math.min(100,c)),await P(v,n)===0)return o(v,n);c=f.willReleaseAt-Date.now()}return o(v,n)}}if(!b(f.pid))return v.info(`Lock '${n}': The pid ${f.pid} appears to be gone.`),o(v,n);const r=await P(v,n),t=Date.now()-r;if(t<=p)return v.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;v.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const d=await P(v,n),l=Date.now()-d;return l<=p?(v.info(`Lock '${n}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(v.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),o(v,n))}async function o(v,n){v.info(`Lock '${n}': Deleting a stale lock.`);try{await C.Promises.unlink(n)}catch(f){}return w(v,n,!0)}}),define(fe[263],me([0,1,32,14,33]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,C){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:C})}createTerminalFromOptions(k,_){const C=new D.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),k,k.name);return this._terminals.push(C),C.create(k,this._serializeParentTerminal(k,_)),C.value}};S=Ve([We(0,L.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(fe[264],me([0,1,5,14,172,6,28,2,39,23,26,7,11,54,3,123,79,13]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,u,E){this.remoteAddress=m,this.localAddress=u,this._dispose=E,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(c){const m=c.trim().split(`
`),u=[];return m.forEach(T=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((T,R)=>(T[R.socket]=R,T),{})}e.getSockets=s;function o(...c){const m=[].concat(...c.map(n));return[...new Map(m.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:v(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=o;function v(c){let m="";if(c.length===8)for(let u=c.length-2;u>=0;u-=2)m+=parseInt(c.substr(u,2),16),u!==0&&(m+=".");else for(let u=c.length-4;u>=0;u-=4)m+=parseInt(c.substr(u,4),16).toString(16),u!==0&&(m+=":");return m}e.parseIpAddress=v;function n(c){const m=c.trim().split(`
`),u=m.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return m.map(T=>T.trim().split(/\s+/).reduce((R,B,N)=>(R[u[N]||N]=B,R),{}))}e.loadConnectionTable=n;function f(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const m=c.trim().split(`
`),u=[];return m.forEach(E=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);T&&T.length>=4&&u.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),u}e.getRootProcesses=r;async function t(c,m,u){const E=u.reduce((R,B)=>(R[B.pid]=B,R),{}),T=[];return c.forEach(({socket:R,ip:B,port:N})=>{const F=m[R]?m[R].pid:void 0,$=F?E[F]?.cmd:void 0;F&&$&&!f($)&&T.push({host:B,port:N,detail:$,pid:F})}),T}e.findPorts=t;function d(c,m,u){const E=new Map,T=r(m);for(const R of c){const B=u.get(R.port);if(B){E.set(R.port,B);continue}const N=T.find(F=>F.cmd.includes(`${R.port}`));if(N){let F=N,$;do $=T.find(M=>M.ppid===F.pid),$&&(F=$);while($);E.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=d;let l=class extends S.Disposable{constructor(m,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),a.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,m.displayName);if(E){const T=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:u}),this._proxy.$registerPortsAttributesProvider(m,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,u,E,T,R){const B=[];for(const F of m){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(u.map(async M=>$.provider.providePortAttributes(M,E,T,R))))}const N=B.filter(F=>!!F);return N.length>0?N.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let u=new y.MovingAverage,E;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),R=(await this.findCandidatePorts()).filter(N=>(0,w.isLocalhost)(N.host)||(0,w.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(N=>N.port).join(", ")}`);const B=new Date().getTime()-T;u.update(B),(!E||JSON.stringify(E)!==JSON.stringify(R))&&(E=R,await this._proxy.$onFoundNewCandidates(E)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let u=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,S.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,u){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(u&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const T=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:T,disposeListener:R}),p.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const u=await Promise.all(m.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),E=m.filter((T,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(T=>T.port).join(", ")} to ${E.map(T=>T.port).join(", ")}`),E}async findCandidatePorts(){let m="",u="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),u=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const E=o(m,u),T=await new Promise(U=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,j,O)=>{U(j)})}),R=s(T),B=await i.Promises.readdir("/proc"),N=[];for(let U of B)try{const x=Number(U),j=C.joinPath(k.URI.file("/proc"),U);if((await i.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(x)){const H=await i.Promises.readlink(C.joinPath(j,"cwd").fsPath),W=await i.Promises.readFile(C.joinPath(j,"cmdline").fsPath,"utf8");N.push({pid:x,cwd:H,cmd:W})}}catch(x){}const F=[],$=E.filter(U=>{const x=R[U.socket];return x||F.push(U),x}),M=t($,R,N);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(x=>{(0,_.exec)("ps -F -A -l | grep root",(j,O,H)=>{x(O)})});this._foundRootPorts=d(F,U,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return M.then(U=>z?U.concat(z):U)}};l=Ve([We(0,L.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,P.ILogService)],l),e.ExtHostTunnelService=l}),define(fe[265],me([0,1,16,22,21,18,3,6,104,229,55]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(E,T){try{return JSON.stringify(E,T)}catch(R){return"null"}}const p="$$ref$$",h={[p]:-1};class w{constructor(T,R){this.jsonString=T,this.referencedBuffers=R}}function y(E,T=null,R=!1){const B=[];return{jsonString:(R?a:JSON.stringify)(E,(F,$)=>{if(typeof $=="undefined")return h;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[p]:M}}if(T)return T(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=y;function P(E,T,R){return JSON.parse(E,(B,N)=>{if(N){const F=N[p];if(typeof F=="number")return T[F];if(R&&N.$mid===1)return R.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=P;function b(E,T){return JSON.stringify(E,T)}function s(E){return E?(T,R)=>R&&R.$mid===1?E.transformOutgoing(R):R:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},f=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=R,this._uriTransformer=B,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,F=i.ProxyIdentifier.count;N<F;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,_.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:R,sid:B}=T;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(T,R){let B={get:(N,F)=>(typeof F=="string"&&!N[F]&&F.charCodeAt(0)===36&&(N[F]=(...$)=>this._remoteCall(T,F,$)),F===r?R:N[F])};return new Proxy(Object.create(null),B)}set(T,R){return this._locals[T.nid]=R,R}assertRegistered(T){for(let R=0,B=T.length;R<B;R++){const N=T[R];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const R=T.byteLength,B=d.read(T,0),N=B.readUInt8(),F=B.readUInt32();switch(N){case 1:case 2:{let{rpcId:$,method:M,args:z}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,_.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,N===2);break}case 3:case 4:{let{rpcId:$,method:M,args:z}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,_.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,N===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=c.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=c.deserializeReplyErrError(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,R,B,N,F,$){this._logger&&this._logger.logIncoming(T,R,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(B)}.${N}(`,F);const M=String(R);let z,U;if($){const j=new D.CancellationTokenSource;F.push(j.token),z=this._invokeHandler(B,N,F),U=()=>j.cancel()}else z=this._invokeHandler(B,N,F),U=n;this._cancelInvokedHandlers[M]=U;const x=c.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(x.byteLength,R,1,"ack"),this._protocol.send(x),z.then(j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyOK(R,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",j),this._protocol.send(O)},j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyErr(R,j);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",j),this._protocol.send(O)})}_receiveCancel(T,R){this._logger&&this._logger.logIncoming(T,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(T,R,B){this._logger&&this._logger.logIncoming(T,R,0,"receiveReply:",B);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],F.resolveOk(B)}_receiveReplyErr(T,R,B){this._logger&&this._logger.logIncoming(T,R,0,"receiveReplyErr:",B);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(T,R,B){try{return Promise.resolve(this._doInvokeHandler(T,R,B))}catch(N){return Promise.reject(N)}}_doInvokeHandler(T,R,B){const N=this._locals[T];if(!N)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(T));let F=N[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,i.getStringIdentifierForProxy)(T));return F.apply(N,B)}_remoteCall(T,R,B){if(this._isDisposed)return Promise.reject(S.canceled());let N=null;if(B.length>0&&D.CancellationToken.isCancellationToken(B[B.length-1])&&(N=B.pop()),N&&N.isCancellationRequested)return Promise.reject(S.canceled());const F=c.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),z=new C.LazyPromise;N&&N.onCancellationRequested(()=>{const x=c.serializeCancel($);this._logger&&this._logger.logOutgoing(x.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[M]=z,this._onWillSendRequest($);const U=c.serializeRequest($,T,R,F,!!N);return this._logger&&this._logger.logOutgoing(U.byteLength,$,0,`request: ${(0,i.getStringIdentifierForProxy)(T)}.${R}(`,B),this._protocol.send(U),z}}e.RPCProtocol=t,I=f,t.UNRESPONSIVE_TIME=3*1e3;class d{constructor(T,R){this._buff=T,this._offset=R}static alloc(T,R,B){let N=new d(L.VSBuffer.alloc(B+1+4),0);return N.writeUInt8(T),N.writeUInt32(R),N}static read(T,R){return new d(T,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,R}static sizeMixedArray(T){let R=0;R+=1;for(let B=0,N=T.length;B<N;B++){const F=T[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let R=0,B=T.length;R<B;R++){const N=T[R];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let F=0;F<N.buffers.length;++F)this.writeBuffer(N.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(T);for(let B=0;B<T;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let z=0;z<F;++z)M.push(this.readVSBuffer());R[B]=new i.SerializableObjectWithBuffers(P($,M,null));break;case 4:R[B]=void 0;break}return R}}d.sizeUInt32=4;var l;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(T){for(let R=0,B=T.length;R<B;R++)if(T[R]instanceof L.VSBuffer||T[R]instanceof i.SerializableObjectWithBuffers||typeof T[R]=="undefined")return!0;return!1}static serializeRequestArguments(T,R){if(this._useMixedArgSerialization(T)){const B=[];for(let N=0,F=T.length;N<F;N++){const $=T[N];if($ instanceof L.VSBuffer)B[N]={type:2,value:$};else if(typeof $=="undefined")B[N]={type:4};else if($ instanceof i.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:z}=y($.value,R);B[N]={type:3,value:L.VSBuffer.fromString(M),buffers:z}}else B[N]={type:1,value:L.VSBuffer.fromString(b($,R))}}return{type:1,args:B}}return{type:0,args:b(T,R)}}static serializeRequest(T,R,B,N,F){switch(N.type){case 0:return this._requestJSONArgs(T,R,B,N.args,F);case 1:return this._requestMixedArgs(T,R,B,N.args,F)}}static _requestJSONArgs(T,R,B,N,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(N);let z=0;z+=d.sizeUInt8(),z+=d.sizeShortString($),z+=d.sizeLongString(M);let U=d.alloc(F?2:1,T,z);return U.writeUInt8(R),U.writeShortString($),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(T){const R=T.readUInt8(),B=T.readShortString(),N=T.readLongString();return{rpcId:R,method:B,args:JSON.parse(N)}}static _requestMixedArgs(T,R,B,N,F){const $=L.VSBuffer.fromString(B);let M=0;M+=d.sizeUInt8(),M+=d.sizeShortString($),M+=d.sizeMixedArray(N);let z=d.alloc(F?4:3,T,M);return z.writeUInt8(R),z.writeShortString($),z.writeMixedArray(N),z.buffer}static deserializeRequestMixedArgs(T){const R=T.readUInt8(),B=T.readShortString(),N=T.readMixedArray(),F=new Array(N.length);for(let $=0,M=N.length;$<M;$++){const z=N[$];typeof z=="string"?F[$]=JSON.parse(z):F[$]=z}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(T){return d.alloc(5,T,0).buffer}static serializeCancel(T){return d.alloc(6,T,0).buffer}static serializeReplyOK(T,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(T);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(T,R);if(R instanceof i.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:F}=y(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(T,N,F)}else return this._serializeReplyOKJSON(T,a(R,B))}static _serializeReplyOKEmpty(T){return d.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,R){let B=0;B+=d.sizeVSBuffer(R);let N=d.alloc(8,T,B);return N.writeVSBuffer(R),N.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,R){const B=L.VSBuffer.fromString(R);let N=0;N+=d.sizeLongString(B);let F=d.alloc(9,T,N);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(T,R,B){const N=L.VSBuffer.fromString(R);let F=0;F+=d.sizeUInt32,F+=d.sizeLongString(N);for(const M of B)F+=d.sizeVSBuffer(M);let $=d.alloc(10,T,F);$.writeUInt32(B.length),$.writeLongString(N);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(T){const R=T.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(T,R){const B=T.readUInt32(),N=T.readLongString(),F=[];for(let $=0;$<B;++$)F.push(T.readVSBuffer());return new i.SerializableObjectWithBuffers(P(N,F,R))}static serializeReplyErr(T,R){return R?this._serializeReplyErrEror(T,R):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,R){const B=L.VSBuffer.fromString(a(S.transformErrorForSerialization(R),null));let N=0;N+=d.sizeLongString(B);let F=d.alloc(11,T,N);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(T){const R=T.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(T){return d.alloc(12,T,0).buffer}}var m;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[266],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[267],me([0,1,10,8,11,2,4,64,44,224,266]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let I=class Hn{constructor(p,h,w,y){this.localUserHome=p,this.remoteAgentService=h,this.environmentService=w,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||p})()}get defaultUriScheme(){return Hn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,h){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const y=h.getWorkspace().folders[0];if(y)return y.uri.scheme;const P=h.getWorkspace().configuration;return P?P.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?L.win32:L.posix)}async fileURI(p){let h="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const y=p.indexOf("/",2);y===-1?(h=p.substring(2),p="/"):(h=p.substring(2,y),p=p.substring(y)||"/")}return S.URI.from({scheme:g.Schemas.file,authority:h,path:p,query:"",fragment:""})}};I=Ve([We(1,i.IRemoteAgentService),We(2,C.IWorkbenchEnvironmentService),We(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(A,k){this.line=A,this.character=k}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,k){return new g(0,0)}with(A){return new g(0,0)}}e.Position=g;class L{constructor(A,k,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(A,k),this.end=new g(_,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var D;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,15,30,25,29,9,4,8,18,72,12]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",h=(a.length+p.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var y;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(y=e.QueryType||(e.QueryType={}));function P(x){return!!x.preview}e.resultIsMatch=P;function b(x){return!!x.resource}e.isFileMatch=b;function s(x){return!!x.message}e.isProgressMessage=s;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=v;class n{constructor(j,O,H){this.ranges=O;const W=Array.isArray(O)?O:[O];if(H&&H.matchLines===1&&f(W)){j=(0,A.getNLines)(j,H.matchLines);let X="",K=0,de=0;const _e=Math.floor(H.charsPerLine/5),Ce=[];for(const Pe of W){const Be=Math.max(Pe.startColumn-_e,0),$e=Pe.startColumn+H.charsPerLine;if(Be>de+_e+h){const He=a+(Be-de)+p;X+=He+j.slice(Be,$e),K+=Be-(de+He.length)}else X+=j.slice(de,$e);Ce.push(new t(0,Pe.startColumn-K,Pe.endColumn-K)),de=$e}this.preview={text:X,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:j,matches:(0,g.mapArrayOrNot)(O,K=>new r(K.startLineNumber-X,K.startColumn,K.endLineNumber-X,K.endColumn))}}}}e.TextSearchMatch=n;function f(x){const j=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==j||O.endLineNumber!==j)return!1;return!0}class r{constructor(j,O,H,W){this.startLineNumber=j,this.startColumn=O,this.endLineNumber=H,this.endColumn=W}}e.SearchRange=r;class t extends r{constructor(j,O,H){super(j,O,j,H)}}e.OneLineRange=t;var d;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function l(x,j=!0){const O=x&&x.files&&x.files.exclude,H=j&&x&&x.search&&x.search.exclude;if(!O&&!H)return;if(!O||!H)return O||H;let W=Object.create(null);return W=D.mixin(W,D.deepClone(O)),W=D.mixin(W,D.deepClone(H),!0),W}e.getExcludes=l;function c(x,j){return x.excludePattern&&L.match(x.excludePattern,j)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,j)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const H=O.folder.fsPath;if(S.isEqualOrParent(j,H)){const W=_.relative(H,j);return!O.includePattern||!!L.match(O.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(j,O){super(j);this.code=O}}e.SearchError=u;function E(x){const j=x.message;if((0,C.isPromiseCanceledError)(x))return new u(j,m.canceled);try{const O=JSON.parse(j);return new u(O.message,O.code)}catch(O){return new u(j,m.other)}}e.deserializeSearchError=E;function T(x){const j={message:x.message,code:x.code};return new Error(JSON.stringify(j))}e.serializeSearchError=T;function R(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=R;function B(x){return x.type==="success"}e.isSerializedSearchSuccess=B;function N(x){return!!x.path}e.isSerializedFileMatch=N;function F(x,j){const O=x.searchPath?x.searchPath:x.relativePath;return(0,A.fuzzyContains)(O,j)}e.isFilePatternMatch=F;class ${constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(x,j){const O={...x||{},...j||{}};return Object.keys(O).filter(H=>{const W=O[H];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=M;class z{constructor(j,O){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=j.includePattern;O.includePattern&&(H?H={...H,...O.includePattern}:H=O.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}matchesExcludesSync(j,O,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,H))}includedInQuerySync(j,O,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,O,H))}includedInQuery(j,O,H){const W=this._parsedExcludeExpression(j,O,H),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,O,H):!0;return(0,I.isPromise)(W)?W.then(K=>K?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=z;function U(x){for(const j in x)if(typeof x[j]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,15,16,21,3,24,10,79,23,9,12,2,170,4,13,190,44,53,28,14,7,31,5]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o,v,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(T,R,B){return new C.ExtUri(N=>c(N,B)).isEqual(T,R)}function t(T,R,B){return r(T.uri,R.uri,B)?0:(0,i.compare)(T.uri.toString(),R.uri.toString())}function d(T,R,B){return T.index!==R.index?T.index<R.index?-1:1:r(T.uri,R.uri,B)?(0,i.compare)(T.name,R.name):(0,i.compare)(T.uri.toString(),R.uri.toString())}function l(T,R,B,N){const F=T.slice(0).sort((M,z)=>B(M,z,N)),$=R.slice(0).sort((M,z)=>B(M,z,N));return(0,g.delta)(F,$,(M,z)=>B(M,z,N))}function c(T,R){const B=R.getCapabilities(T.scheme);return!(B&&B&1024)}class m extends P.Workspace{constructor(R,B,N,F,$,M,z){super(R,N.map(U=>new P.WorkspaceFolder(U)),F,$,z);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(z),N.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(R,B,N,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:z,configuration:U,transient:x,isUntitled:j}=R,O=[],H=B;B?z.forEach((de,_e)=>{const Ce=a.URI.revive(de.uri),Pe=m._findFolder(N||B,Ce,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:Ce,name:de.name,index:_e})}):O.push(...z.map(({uri:de,name:_e,index:Ce})=>({uri:a.URI.revive(de),name:_e,index:Ce}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const W=new m($,M,O,!!x,U?a.URI.revive(U):null,!!j,de=>c(de,F)),{added:X,removed:K}=l(H?H.workspaceFolders:[],W.workspaceFolders,t,F);return{workspace:W,added:X,removed:K}}static _findFolder(R,B,N){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(r($.uri,B,N))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,C.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,B,N,F){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=N,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(f.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new m($.id,$.name,[],!!$.transient,$.configuration?a.URI.revive($.configuration):null,!!$.isUntitled,M=>c(M,N)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:k.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,N,...F){const $=[];if(Array.isArray(F)&&F.forEach(j=>{a.URI.isUri(j.uri)&&!$.some(O=>r(O.uri,j.uri,this._extHostFileSystemInfo))&&$.push({uri:j.uri,name:j.name||(0,C.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[B,N].some(j=>typeof j!="number"||j<0)||N===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+N>M.length)return!1;const z=M.slice(0);z.splice(B,N,...$.map(j=>({uri:j.uri,name:j.name||(0,C.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<z.length;j++){const O=z[j];if(z.some((H,W)=>W!==j&&r(O.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((j,O)=>j.index=O);const{added:U,removed:x}=l(M,z,d,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const j=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(j,B,N,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,(0,p.localize)(0,null,j,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let N,F="";if(typeof R=="string"?(N=a.URI.file(R),F=R):typeof R!="undefined"&&(N=R,F=R.fsPath),!N)return F;const $=this.getWorkspaceFolder(N,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,C.relativePath)($.uri,N);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:N,removed:F}=m.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:F}))}findFiles(R,B,N,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:U}=E(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(N),$).then(x=>Array.isArray(x)?x.map(j=>a.URI.revive(j)):[])}async findTextInFiles(R,B,N,F,$=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:U,folder:x}=E(B.include),j=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:U,excludePattern:j},H=!1;if(this._activeSearchCallbacks[M]=W=>{if(H)return;const X=a.URI.revive(W.resource);W.results.forEach(K=>{(0,n.resultIsMatch)(K)?N({uri:X,preview:{text:K.preview.text,matches:(0,g.mapArrayOrNot)(K.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(K.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):N({uri:X,text:K.text,lineNumber:K.lineNumber})})},$.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(x),O,M,$);return delete this._activeSearchCallbacks[M],W||{}}catch(W){throw delete this._activeSearchCallbacks[M],W}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([We(0,o.IExtHostRpcService),We(1,s.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,w.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function E(T){let R,B;return T&&(typeof T=="string"?R=T:(R=T.pattern,B=T.baseFolder||a.URI.file(T.base))),{includePattern:R,folder:B}}}),define(fe[37],me([0,1,25,3,36,5,7,193,87,12,16,4,14,13,2]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(f,r){if(r){const t=r.split(".");let d=f;for(let l=0;d&&l<t.length;l++)d=d[t[l]];return d}}function y(f){return f instanceof h.URI}function P(f){return f&&f.uri instanceof h.URI&&f.languageId&&typeof f.languageId=="string"}function b(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof h.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function o(f){if(y(f))return{resource:f};if(P(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(b(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let v=class{constructor(r,t,d){this._proxy=r.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=d,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(r,t))}};v=Ve([We(0,a.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,p.ILogService)],v),e.ExtHostConfiguration=v;class n{constructor(r,t,d,l){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=l,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const d={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,d))}getConfiguration(r,t,d){const l=o(t)||{},c=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,l,d?.identifier);function m(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof w(c,E)!="undefined"},get:(E,T)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,l,d?.identifier);let R=w(c,E);if(typeof R=="undefined")R=T;else{let B;const N=(F,$)=>{let M;const z=()=>{B=B||(0,g.deepClone)(c),M=M||w(B,$)};return(0,C.isObject)(F)?new Proxy(F,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>M;if(B)return M=M||w(B,$),M[x];const j=U[x];return typeof x=="string"?N(j,`${$}.${x}`):j},set:(U,x,j)=>(z(),M&&(M[x]=j),!0),deleteProperty:(U,x)=>(z(),M&&delete M[x],!0),defineProperty:(U,x,j)=>(z(),M&&Object.defineProperty(M,x,j),!0)}):F};R=N(R,E)}return R},update:(E,T,R,B)=>{E=r?`${r}.${E}`:E;const N=m(R);return T!==void 0?this._proxy.$updateConfigurationOption(N,E,T,l,B):this._proxy.$removeConfigurationOption(N,E,l,B)},inspect:E=>{E=r?`${r}.${E}`:E;const T=(0,g.deepClone)(this._configuration.inspect(E,l,this._extHostWorkspace.workspace));if(T)return{key:E,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof c=="object"&&(0,g.mixin)(u,c,!1),Object.freeze(u)}_toReadonlyValue(r){const t=d=>(0,C.isObject)(d)?new Proxy(d,{get:(l,c)=>t(l[c]),set:(l,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return t(r)}_validateConfigurationAccess(r,t,d){const l=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),c=d?`[${d.value}] `:"";if(l===4){typeof t?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){t?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const d=new k.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>d.affectsConfiguration(l,o(c))})}_toMap(r){return r.reduce((t,d)=>(t.set(d[0],d[1]),t),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[73],me([0,1,2,16,3,5,7,36,45,37,21,33,14,28,4,10,11,13,68,214,18]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var f;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(f=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(x){if(x){const j=x;return j&&!!j.process}else return!1}$.is=M;function z(x){if(x==null)return;const j={process:x.process,args:x.args};return x.options&&(j.options=r.from(x.options)),j}$.from=z;function U(x){if(x!=null)return new A.ProcessExecution(x.process,x.args,x.options)}$.to=U})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function($){function M(x){if(x){const j=x;return j&&(!!j.commandLine||!!j.command)}else return!1}$.is=M;function z(x){if(x==null)return;const j={};return x.commandLine!==void 0?j.commandLine=x.commandLine:(j.command=x.command,j.args=x.args),x.options&&(j.options=d.from(x.options)),j}$.from=z;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new A.ShellExecution(x.commandLine,x.options):new A.ShellExecution(x.command,x.args?x.args:[],x.options)}$.to=U})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function M(x){if(x){let j=x;return j&&j.customExecution==="customExecution"}else return!1}$.is=M;function z(x){return{customExecution:"customExecution"}}$.from=z;function U(x,j){return j.get(x)}$.to=U})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function($){function M(z,U){let x;return z.scope!==void 0&&typeof z.scope!="number"?x=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=s.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:x}}$.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function($){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}$.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function($){function M(x,j){if(x==null)return[];const O=[];for(let H of x){const W=z(H,j);W&&O.push(W)}return O}$.fromMany=M;function z(x,j){if(x==null)return;let O;x.execution instanceof A.ProcessExecution?O=t.from(x.execution):x.execution instanceof A.ShellExecution?O=l.from(x.execution):x.execution&&x.execution instanceof A.CustomExecution&&(O=c.from(x.execution));const H=n.from(x.definition);let W;return x.scope?typeof x.scope=="number"?W=x.scope:W=x.scope.uri:W=A.TaskScope.Workspace,!H||!W?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:j.identifier.value,label:x.source,scope:W},execution:O,isBackground:x.isBackground,group:u.from(x.group),presentationOptions:f.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}$.from=z;async function U(x,j,O){if(x==null)return;let H;t.is(x.execution)?H=t.to(x.execution):l.is(x.execution)?H=l.to(x.execution):c.is(x.execution)&&(H=c.to(x._id,O));const W=n.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await j.resolveWorkspaceFolder(g.URI.revive(x.source.scope)):X=A.TaskScope.Workspace),!W||!X)return;const K=new A.Task(W,X,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=A.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new A.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=f.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}$.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function($){function M(U){return U}$.from=M;function z(U){if(!!U)return Object.assign(Object.create(null),U)}$.to=z})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,z,U){this._id=z,this._task=U,v.set(this,void 0),st(this,v,M,"f")}get task(){return this._task}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}v=new WeakMap;var B;(function($){function M(z){return{id:z._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(M,z,U,x,j,O,H,W){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=j,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,U){if(!U)return new A.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:z,provider:U,extension:M}),this._proxy.$registerTaskProvider(x,z),new A.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(M,z){this._proxy.$registerTaskSystem(M,z)}fetchTasks(M){return this._proxy.$fetchTasks(T.from(M)).then(async z=>{const U=[];for(let x of z){const j=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);j&&U.push(j)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,z,U){const x=this._providedCustomExecutions2.get(M.id);x&&(this._activeCustomExecutions2.set(M.id,x),this._terminalService.attachPtyToTerminal(z,await x.callback(U))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const z=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const x=[],j=(0,L.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(z,x,U,O));return new Promise(O=>{j.then(H=>{Promise.all(x).then(()=>{O(H)})})})}async $resolveTask(M,z){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(z.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(x,i.CancellationToken.None);if(!j)return;this.checkDeprecation(j,U);const O=E.from(j,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(O.execution)&&await this.addCustomExecution(O,j,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,z,U){const x=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,z.execution)),this._providedCustomExecutions2.set(x,z.execution)}async getTaskExecution(M,z){if(typeof M=="string"){const j=this._taskExecutionPromises.get(M);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const x=new Promise((j,O)=>{function H(W,X,K){K?j(new R(W,X.id,K)):O("Unexpected: Task does not exist.")}z?H(this,M,z):E.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(W=>H(this,M,W))});return this._taskExecutionPromises.set(M.id,x),x.then(j=>(this._taskExecutions.set(M.id,j),j),j=>Promise.reject(j))}checkDeprecation(M,z){M._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};N=Ve([We(0,a.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,P.ILogService),We(7,b.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let F=class extends N{constructor(M,z,U,x,j,O,H,W){super(M,z,U,x,j,O,H,W);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(z,M);if(U===void 0)throw new Error("Task is not valid");if(c.is(U.execution))await this.addCustomExecution(U,z,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),z);return this._proxy.$executeTask(U).catch(j=>{throw new Error(j)}),x}provideTasksInternal(M,z,U,x){const j=[];if(x)for(let O of x){this.checkDeprecation(O,U),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const H=E.from(O,U.extension);H&&c.is(H.execution)?(j.push(H),z.push(this.addCustomExecution(H,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async resolveTaskInternal(M){if(c.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,U){}};F=Ve([We(0,a.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,P.ILogService),We(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[268],me([0,1,15,59,30,81,24,10,8,23,9,12,2,146,177,121,44,130,267,31]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(m,u,E,T){this.configurationService=m,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=T}text(m,u,E={}){m=this.getContentPattern(m,E);const T=this.configurationService.getValue(),R=u&&u.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(u?.map(y.toWorkspaceFolder),E),type:2,contentPattern:m,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:T.search.usePCRE2||R||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(m,u){const E=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const T={...m,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(m,u)&&(T.isCaseSensitive=!0),this.isMultiline(m)&&(T.isMultiline=!0),T}file(m,u={}){return{...this.commonQuery(m,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(m,u){return m?(m=Array.isArray(m)?m.map(t):t(m),u?this.parseSearchPaths(m):{pattern:n(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),T=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=m.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map($=>this.getFolderQueryForSearchPath($,u,T)):m.map($=>this.getFolderQueryForRoot($,u,T,R))).filter($=>!!$),N={_reason:u._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:T.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,s.pathIncludedInQuery)(N,U.fsPath)),z=this.commonQueryFromFileList(M);return{...N,...z}}const F=u.extraFileResources&&u.extraFileResources.filter($=>(0,s.pathIncludedInQuery)(N,$.fsPath));return N.extraFileResources=F&&F.length?F:void 0,N}commonQueryFromFileList(m){const u=[],E=new A.ResourceMap,T={};let R=!1;return m.forEach(B=>{if(B.scheme===k.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:_.dirname(B.fsPath)});let $=E.get(F);$||(R=!0,$={folder:F,includePattern:{}},u.push($),E.set(F,$));const M=_.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,T[B.fsPath]=!0)}),{folderQueries:u,includePattern:T,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(m,u){if(u.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const u=z=>_.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),T=(Array.isArray(m)?m:f(m)).map(z=>{const U=this.pathService.resolvedUserHome;return U?(0,S.untildify)(z,U.scheme===k.Schemas.file?U.fsPath:U.path):z}),R=L.groupBy(T,z=>u(z)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(z=>i.rtrim(z,"/")).map(z=>i.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),N={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(N.searchPaths=F);const $=g.flatten(B),M=n(...$);return M&&(N.pattern=M),N}getExcludesForFolder(m,u){return u.disregardExcludeSettings?void 0:(0,s.getExcludes)(m,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const u=g.flatten(m.map(T=>{let{pathPortion:R,globPortion:B}=v(T);B&&(B=d(B));const N=this.expandOneSearchPath(R);return g.flatten(N.map(F=>this.resolveOneSearchPathPattern(F,B)))})),E=new Map;return u.forEach(T=>{const R=T.searchPath.toString(),B=E.get(R);B?T.pattern&&(B.pattern=B.pattern||{},B.pattern[T.pattern]=!0):E.set(R,{searchPath:T.searchPath,pattern:T.pattern?n(T.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(m){if(_.isAbsolute(m)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:m})}]:[{searchPath:a.URI.file(_.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=t(m),m.startsWith("../")||m===".."){const T=_.posix.resolve(u.path,m);return[{searchPath:u.with({path:T})}]}const E=d(m);return[{searchPath:u,pattern:E}]}else{if(m==="./"||m===".\\")return[];{const u=m.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=u.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(T.length)return T.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&d(B)}});{const R=m.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:m,N=h.localize(0,null,B);throw new Error(N)}}}}resolveOneSearchPathPattern(m,u){const E=m.pattern&&u?`${m.pattern}/${u}`:m.pattern||u,T=[{searchPath:m.searchPath,pattern:E}];return E&&!E.endsWith("**")&&T.push({searchPath:m.searchPath,pattern:E+"/**"}),T}getFolderQueryForSearchPath(m,u,E){const T=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(m.searchPath),u,E,!1);return T?{...T,includePattern:m.pattern}:null}getFolderQueryForRoot(m,u,E,T){let R;const B=a.URI.isUri(m)?m:m.uri;if(E.searchPaths){const z=E.searchPaths.filter(U=>(0,C.isEqual)(U.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(R=z.pattern)}const N=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(N,u)||{},...R||{}},M=a.URI.isUri(m)?(0,C.basename)(m):m.name;return{folder:B,folderName:T?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!N.search.followSymlinks}}};o=Ve([We(0,w.IConfigurationService),We(1,y.IWorkspaceContextService),We(2,P.IEditorGroupsService),We(3,b.IPathService)],o),e.QueryBuilder=o;function v(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const u=m.index,E=c.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let T=c.substr(0,E.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:c.substr((E.index||0)+1)}}}return{pathPortion:c}}function n(...c){return c.length?c.reduce((m,u)=>(m[u]=!0,m),Object.create(null)):void 0}function f(c){return D.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(c){return c.replace(/\\/g,"/")}function d(c){return t(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,m){c=g.distinct(c,T=>T.toString());const u=[],E=m.getWorkspace();return c&&c.forEach(T=>{let R;if(m.getWorkbenchState()===2)R=(0,C.relativePath)(E.folders[0].uri,T),R&&R!=="."&&(R="./"+R);else{const B=m.getWorkspaceFolder(T);if(B){const N=B.name;if(E.folders.filter($=>$.name===N).length===1){const $=(0,C.relativePath)(B.uri,T);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=T.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=l}),define(fe[269],me([0,1,23,2,21,18,4,268,31,44]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(w,y){const P=y.activationEvents;if(!P)return Promise.resolve(void 0);const b=[],s=[];for(const t of P)if(/^workspaceContains:/.test(t)){const d=t.substr("workspaceContains:".length);d.indexOf("*")>=0||d.indexOf("?")>=0||w.forceUsingSearch?s.push(d):b.push(d)}if(b.length===0&&s.length===0)return Promise.resolve(void 0);let o;const v=new Promise((t,d)=>{o=t}),n=t=>o({activationEvent:t}),f=Promise.all(b.map(t=>a(w,t,n))).then(()=>{}),r=p(w,y.identifier,s,n);return Promise.all([f,r]).then(()=>{o(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function a(w,y,P){for(const b of w.folders)if(await w.exists(g.joinPath(L.URI.revive(b),y))){P(`workspaceContains:${y}`);return}}async function p(w,y,P,b){if(P.length===0)return Promise.resolve(void 0);const s=new D.CancellationTokenSource,o=w.checkExists(w.folders,P,s.token),v=setTimeout(async()=>{s.cancel(),b(`workspaceContainsTimeout:${P.join(",")}`)},i);let n=!1;try{n=await o}catch(f){S.isPromiseCanceledError(f)||S.onUnexpectedError(f)}s.dispose(),clearTimeout(v),n&&b(`workspaceContains:${P.join(",")}`)}function h(w,y,P,b){const s=w.get(A.IInstantiationService),o=w.get(_.ISearchService),n=s.createInstance(k.QueryBuilder).file(y.map(f=>(0,C.toWorkspaceFolder)(L.URI.revive(f))),{_reason:"checkExists",includePattern:P,exists:!0});return o.fileSearch(n,b).then(f=>!!f.limitHit,f=>S.isPromiseCanceledError(f)?!1:Promise.reject(f))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[42],me([0,1,165,8,74,23,16,6,24,2,13,5,37,227,93,36,35,225,18,27,22,200,7,122,4,28,70,14,86,54,33,3,269,91,202,10]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o,v,n,f,r,t,d,l,c,m,u,E,T,R,B,N){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class zn extends k.Disposable{constructor(O,H,W,X,K,de,_e,Ce,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=W,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=K,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=O.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(He=>$e.add(s.ExtensionIdentifier.toKey(He))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if($e.has(s.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new p.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(H){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,H){return this._activator.activateByEvent(O,H)}_activateById(O,H){return this._activator.activateById(O,H)}activateByIdWithErrors(O,H){return this._activateById(O,H).then(()=>{const W=this._activator.getActivatedExtension(O);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==N.Schemas.file)return O;const H=await this._hostUtils.realpath(O.fsPath);return C.URI.file(H)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=_.TernarySearchTree.forUris(H=>S.extUriBiasedIgnorePathCase.ignorePathCasing(H));for(const H of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(H)){const W=await this._realPathExtensionUri(H.extensionLocation);O.set(W,H)}return O})()),this._extensionPathIndex}_deactivate(O){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return H;const W=this._activator.getActivatedExtension(O);if(!W)return H;try{typeof W.module.deactivate=="function"&&(H=Promise.resolve(W.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,k.dispose)(W.subscriptions)}catch(X){this._logService.error(X)}return H}async _activateExtension(O,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,H).then(W=>{const X=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,H),this._logExtensionActivationTimes(O,H,"success",X),W},W=>{throw this._logExtensionActivationTimes(O,H,"failure"),W})}_logExtensionActivationTimes(O,H,W,X){const K=U(O,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...X||{},outcome:W})}_doActivateExtension(O,H){const W=U(O,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${H.startup}, activationEvent: '${H.activationEvent}'${O.identifier.value!==H.extensionId.value?`, root cause: ${H.extensionId.value}`:""}`),this._logService.flush();const K=new p.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,S.joinPath)(O.extensionLocation,X),K),this._loadExtensionContext(O)]).then(de=>(D.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zn._callActivate(this._logService,O.identifier,de[0],de[1],K))).then(de=>(D.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const H=new v.ExtensionGlobalMemento(O,this._storage),W=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),K=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,de=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([H.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Ce;return Object.freeze({globalState:H,workspaceState:W,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return L.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return C.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return K},get extension(){return Ce===void 0&&(Ce=new x(_e,O.identifier,O,de)),Ce},get extensionRuntime(){return(0,y.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,H,W,X,K){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,H,W,X,K).then(de=>new p.ActivatedExtension(!1,null,K.build(),W,de,X.subscriptions))}static _callActivateOptional(O,H,W,X,K){if(typeof W.activate=="function")try{K.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${H.value}`);const de=typeof global=="object"?global:self,_e=W.activate.apply(de,[X]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(_e).then(Ce=>(K.activateResolveStop(),Ce))}catch(de){return Promise.reject(de)}else return Promise.resolve(W)}_activateOneStartupFinished(O,H){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:H}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const H of O.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(O,H)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(H),X=Promise.all([O,W]).then(()=>{});return Promise.race([X,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(O,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,H){if(this.isActivated(H.identifier))return;const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:W,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,Ce)},K=await(0,T.checkActivateWorkspaceContainsExtension)(X,H);if(!!K)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:K.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:H}=this._initData.environment;if(!O||!H)throw new Error(g.localize(0,null));const W=await this._loadCommonJSModule(null,H,new p.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(g.localize(1,null,H.toString()));return new Promise((X,K)=>{const de=(Pe,Be)=>{Pe?K(Pe):X(typeof Be=="number"&&Be>0?1:0)},_e=(0,S.originalFSPath)(H),Ce=W.run(_e,de);Ce&&Ce.then&&Ce.then(()=>{X(0)}).catch(Pe=>{K(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,H){return this._resolvers[O]=H,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const H=O.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const W=O.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${W}`,!1),{authorityPrefix:W,resolver:this._resolvers[W]}}async $resolveAuthority(O,H){const{authorityPrefix:W,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:f.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${W}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),D.mark(`code/extHost/willResolveAuthority/${W}`);const K=await X.resolve(O,{resolveAttempt:H});D.mark(`code/extHost/didResolveAuthorityOK/${W}`);const de={authority:O,host:K.host,port:K.port,connectionToken:K.connectionToken},_e={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(D.mark(`code/extHost/didResolveAuthorityError/${W}`),K instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(O,H){const{authorityPrefix:W,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${W}`);const K=C.URI.revive(H);if(typeof X.getCanonicalURI=="undefined")return K;const de=await(0,A.asPromise)(()=>X.getCanonicalURI(K));return de||K}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,H){return H===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(O,!1))}async $activate(O,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,H),!0):!1}async $deltaExtensions(O,H){O.forEach(X=>X.extensionLocation=C.URI.revive(X.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(H.map(async X=>{const K=this._registry.getExtensionDescription(X);K&&W.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(O.map(async X=>{const K=await this._realPathExtensionUri(X.extensionLocation);W.set(K,X)})),this._registry.deltaExtensions(O,H),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let H=o.VSBuffer.alloc(O),W=Math.random()%256;for(let X=0;X<O;X++)H.writeUInt8(W,X);return H}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};z=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,l.IExtHostRpcService),We(3,w.IExtHostWorkspace),We(4,a.IExtHostConfiguration),We(5,i.ILogService),We(6,t.IExtHostInitDataService),We(7,d.IExtensionStoragePaths),We(8,m.IExtHostTunnelService),We(9,u.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function U(j,O){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(O,H,W,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,H,"f"),st(this,M,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=L.normalize((0,S.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=X}get isActive(){return Ne(this,F,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,F,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,F,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[57],me([0,1,8,2,3,16,5,7,126,36,42,45,216,37,210,14,4,12,38,56]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let o=class{constructor(c,m,u,E,T,R){this._workspaceService=m,this._extensionService=u,this._editorsService=E,this._configurationService=T,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=c.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(N=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const u=c;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,T="?";return m&&(E+=`${T}session=${encodeURIComponent(m.id)}`,T="&"),E+=`${T}ref=${u.sourceReference}`,L.URI.parse(E)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const u of c.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const T of E)(0,h.isDebuggerMainContribution)(T)&&m.push(T.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(T=>{const R=T.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,T),!0)});this.fireBreakpointChanges(m,[],[]);const u=[],E=new Map;for(const T of m)if(T instanceof k.SourceBreakpoint){let R=E.get(T.location.uri.toString());R||(R={type:"sourceMulti",uri:T.location.uri,lines:[]},E.set(T.location.uri.toString(),R),u.push(R)),R.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&u.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],m,[]);const u=m.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),E=m.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),T=m.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,T)}startDebugging(c,m,u){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,u){if(!m)return new k.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:E,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,u,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,E),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(c,m,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,E),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:u,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[T,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,R)}let u;const E=await this.getFolder(c);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new t(c.implementation)}createSignService(){}async $startDASession(c,m){const u=this,E=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const R=this.convertToDto(T),B=this.createDebugAdapter(R,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const N=B;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(E).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),N.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,z={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);z.body={signature:U},N.sendResponse(z)}else throw new Error("no signer")}catch(U){z.success=!1,z.message=U.message,N.sendResponse(z)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,h.convertToVSCPaths)($,!0),u._debugServiceProxy.$acceptDAMessage(c,$)}),N.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(c,$.name,$.message,$.stack)}),N.onExit($=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,P.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,m){m=(0,h.convertToDAPaths)(m,!1);const u=this._debugAdaptersTrackers.get(c);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(m);const E=this._debugAdapters.get(c);E&&E.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const u=this._debugAdapters.get(c);return this._debugAdapters.delete(c),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],u=[],E=[];if(c.added)for(const T of c.added){const R=T.id;if(R&&!this._breakpoints.has(R)){let B;if(T.type==="function")B=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")B=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const N=L.URI.revive(T.uri);B=new k.SourceBreakpoint(new k.Location(N,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}B._id=R,this._breakpoints.set(R,B),m.push(B)}}if(c.removed)for(const T of c.removed){const R=this._breakpoints.get(T);R&&(this._breakpoints.delete(T),u.push(R))}if(c.changed){for(const T of c.changed)if(T.id){const R=this._breakpoints.get(T.id);if(R){if(R instanceof k.FunctionBreakpoint&&T.type==="function"){const B=R;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.functionName=T.functionName}else if(R instanceof k.SourceBreakpoint&&T.type==="source"){const B=R;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.location=new k.Location(L.URI.revive(T.uri),new k.Position(T.line,T.character))}E.push(R)}}}this.fireBreakpointChanges(m,u,E)}$provideDebugConfigurations(c,m,u){return(0,S.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(m);return E.provideDebugConfigurations(T,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(c,m,u,E){return(0,S.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(m);return T.resolveDebugConfiguration(R,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,u,E){return(0,S.asPromise)(async()=>{const T=this.getConfigProviderByHandle(c);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(m);return T.resolveDebugConfigurationWithSubstitutedVariables(R,u,E)})}async $provideDebugAdapter(c,m){const u=this.getAdapterDescriptorFactoryByHandle(c);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(m);return this.getAdapterDescriptor(u,E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const u=await this.getSession(c);u&&u._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const E={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(u=>u.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(u=>u.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(u=>u.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const u=c.configuration.type,E=this._trackerFactories.filter(T=>T.type===u||T.type==="*").map(T=>(0,S.asPromise)(()=>T.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(E).then(T=>{const R=T.filter(B=>!!B);if(R.length>0)return new r(R)}),new Promise((T,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(c,m){const u=m.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(c){const T=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,T))).then(R=>{if(R)return R})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,E))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,u){(c.length>0||m.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:u}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const u=await this.getFolder(c.folderUri),E=c.parent?this._debugSessions.get(c.parent):void 0;m=new v(this._debugServiceProxy,c.id,c.type,c.name,u,c.configuration,E),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=L.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};o=Ve([We(0,w.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class v{constructor(c,m,u,E,T,R,B){this._debugServiceProxy=c,this._id=m,this._type=u,this._name=E,this._workspaceFolder=T,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=v;class n{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=n;class f extends a.AbstractVariableResolverService{constructor(c,m,u,E,T){function R(){if(m){const B=m.activeEditor();if(B)return B.document.uri;const N=E.tabs.filter(F=>F.isActive);if(N.length>0){const F=N[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:N[0].resource}}}super({getFolderUri:B=>{const N=c.filter(F=>F.name===B);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(B,N)=>u.getConfiguration(void 0,B).get(N),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const B=R();if(B){const N=T.getWorkspaceFolder(B);if(N)return g.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(m){const B=m.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(m){const B=m.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=f;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(u=>u.onExit?u.onExit(c,m):void 0)}}class t extends _.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends o{constructor(c,m,u,E,T,R){super(c,m,u,E,T,R)}createVariableResolver(c,m,u){return new f(c,m,u,this._editorTabs)}};d=Ve([We(0,w.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],d),e.WorkerExtHostDebugService=d}),define(fe[270],me([0,1,74,2,5,37,35,27,14,28,4,42,38,13]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(s,o,v,n,f,r,t){this._apiFactory=s,this._extensionRegistry=o,this._instaService=v,this._extHostConfiguration=n,this._extHostExtensionService=f,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(y,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};h=Ve([We(2,i.IInstantiationService),We(3,S.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,p.ILogService)],h),e.RequireInterceptor=h;class w{constructor(s,o,v,n,f){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=v,this._configProvider=n,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const v=this._extensionPaths.findSubstr(o);if(v){let n=this._extApiImpl.get(k.ExtensionIdentifier.toKey(v.identifier));return n||(n=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(v.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((f,r)=>n+=`	${r} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(s,o,v){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(D.MainContext.MainThreadTelemetry);const{environment:n}=v,f=o.getProxy(D.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;a.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>f.$getPassword(r,t),setPassword:(r,t,d)=>f.$setPassword(r,t,d),deletePassword:(r,t)=>f.$deletePassword(r,t),findPassword:r=>f.$findPassword(r),findCredentials(r){return f.$findCredentials(r)}}}load(s,o){const v=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:v?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const v=o-7;if((s.charAt(v)==="/"||s.charAt(v)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};y=Ve([We(1,_.IExtHostRpcService),We(2,C.IExtHostInitDataService)],y);let P=class{constructor(s,o,v){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(D.MainContext.MainThreadTelemetry);const n=v.getProxy(D.MainContext.MainThreadWindow);this._impl=(f,r)=>{const t=L.URI.parse(f);return r?this.callOriginal(f,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,f,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,f,{}):this.callOriginal(f,r)}}load(s,o,v){const n=this._extensionPaths.findSubstr(o);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=v(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([We(2,_.IExtHostRpcService)],P)}),define(fe[271],me([0,1,171,11,7,211,36,42,45,37,33,14,57,195,16,212,56]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends a.ExtHostDebugServiceBase{constructor(o,v,n,f,r,t,d){super(o,v,n,f,r,d);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(o,v){switch(o.type){case"server":return new S.SocketDebugAdapter(o);case"pipeServer":return new S.NamedPipeDebugAdapter(o);case"executable":return new S.ExecutableDebugAdapter(o,v.type)}return super.createDebugAdapter(o,v)}daExecutableFromPackage(o,v){const n=S.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),o.type);if(n)return new D.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new p.SignService}async $runInTerminal(o,v){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const n=await this._configurationService.getConfigProvider(),f=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=o.title||g.localize(0,null),d=JSON.stringify({shell:f,shellArgs:r});let l=await this._integratedTerminalInstances.checkout(d,t),c,m=!1;if(l)c=o.cwd;else{const R={shellPath:f,shellArgs:r,cwd:o.cwd,name:t,iconPath:new D.ThemeIcon("debug")};m=!0,l=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(l,d)}l.show(!0);const u=await l.processId;m?await new Promise(R=>setTimeout(R,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?l.sendText("cls"):f.indexOf("bash")>=0?l.sendText("clear"):L.isWindows?l.sendText("cls"):l.sendText("clear"));const E=(0,w.prepareCommand)(f,o.args,c,o.env);l.sendText(E);const T=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(l),T.dispose())});return u}else if(o.kind==="external")return(0,w.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,v)}createVariableResolver(o,v,n){return new a.ExtHostVariableResolverService(o,v,n,this._editorTabs,this._workspaceService)}};P=Ve([We(0,I.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,y.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class b{constructor(){this._terminalInstances=new Map}async checkout(o,v){const f=[...this._terminalInstances.entries()].map(([r,t])=>(0,h.createCancelablePromise)(async d=>{if(r.name!==v||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await r.processId))return null;const l=Date.now();return t.lastUsedAt+b.minUseDelay>l||d.isCancellationRequested||t.config!==o?null:(t.lastUsedAt=l,r)}));return await(0,h.firstParallel)(f,r=>!!r)}insert(o,v){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:v})}free(o){const v=this._terminalInstances.get(o);v&&(v.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(fe[272],me([0,1,8,2,114,36,57,45,37,44,33,14,28,73,10,13,68,56,23,82]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends p.ExtHostTaskBase{constructor(n,f,r,t,d,l,c,m,u){super(n,f,r,t,d,l,c,m);this.workspaceService=r,this.editorTabs=u,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,f){const r=f;if(!f.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=p.TaskHandleDTO.from(r,this.workspaceService),d=await this._proxy.$getTaskExecution(t);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.getTaskExecution(d,f);return this._proxy.$executeTask(t).catch(()=>{}),l}else{const t=p.TaskDTO.from(f,n);if(t===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,f,!1);const d=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),f);return this._proxy.$executeTask(t).catch(()=>{}),d}}provideTasksInternal(n,f,r,t){const d=[];if(t)for(let l of t){this.checkDeprecation(l,r),(!l.definition||!n[l.definition.type])&&this._logService.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const c=p.TaskDTO.from(l,r.extension);c&&(d.push(c),p.CustomExecutionDTO.is(c.execution)&&f.push(this.addCustomExecution(c,l,!0)))}return{tasks:d,extension:r.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(n,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let f=n&&n.length>0?n[0]:void 0;if(!f){const r=L.URI.file((0,s.homedir)());f=new C.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,f){const r=L.URI.revive(n),t={process:void 0,variables:Object.create(null)},d=await this._workspaceProvider.resolveWorkspaceFolder(r),l=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(l),m=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(l);for(let u of f.variables)t.variables[u]=await c.resolveAsync(m,u);if(f.process!==void 0){let u;if(f.process.path!==void 0){u=f.process.path.split(g.delimiter);for(let E=0;E<u.length;E++)u[E]=await c.resolveAsync(m,u[E])}t.process=await D.win32.findExecutable(await c.resolveAsync(m,f.process.name),f.process.cwd!==void 0?await c.resolveAsync(m,f.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(n,f,r){return D.win32.findExecutable(n,f,r)}};o=Ve([We(0,I.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,S.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,_.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,w.ILogService),We(7,y.IExtHostApiDeprecationService),We(8,P.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[273],me([0,1,16,18,74,6,2,5,265,13,84,86,28,189,14,67,42,33]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,v,n,f){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new _.RPCProtocol(o,null,f),v=b._transform(v,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(w.IURITransformerService,new w.URITransformerService(f)),r.set(y.IHostUtils,n);const t=new p.InstantiationService(r,!0),d=t.invokeFunction(u=>u.get(P.IExtHostTerminalService));this._disposables.add(d),this._logService=t.invokeFunction(u=>u.get(C.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=t.invokeFunction(u=>u.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,T)=>{let R="",B,N;for(const F of T)R+=`
	at ${F.toString()}`,N=F.getFileName(),!B&&N&&(B=u.findSubstr(A.URI.file(N)));return l.set(E,B),`${E.name||"Error"}: ${E.message||""}${R}`}});const c=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(u=>{const E=L.transformErrorForSerialization(u),T=l.get(u);T?c.$onExtensionRuntimeError(T.identifier,E):m.$onUnexpectedError(E)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,v){o.extensions.forEach(f=>f.extensionLocation=A.URI.revive(v.transformIncomingURIs(f.extensionLocation))),o.environment.appRoot=A.URI.revive(v.transformIncomingURIs(o.environment.appRoot));const n=o.environment.extensionDevelopmentLocationURI;return n&&(o.environment.extensionDevelopmentLocationURI=n.map(f=>A.URI.revive(v.transformIncomingURIs(f)))),o.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=A.URI.revive(v.transformIncomingURIs(o.logsLocation)),o.logFile=A.URI.revive(v.transformIncomingURIs(o.logFile)),o.workspace=v.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(fe[274],me([0,1,8,21,52,30,23,46,31]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(a,p,h){this.config=a,this.provider=p,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&S.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&S.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const p=this.config.folderQueries||[];return new Promise((h,w)=>{const y=P=>{this.resultCount++,a(P)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const b=P.toString(),s=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,s)||this.matchFile(y,{base:P,basename:s})}),Promise.all(p.map(P=>this.searchInFolder(P,y))).then(P=>{h({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{w(new Error((0,D.toErrorMessage)(P)))})})}async searchInFolder(a,p){const h=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(a),y=this.initDirectoryTree(),P=new _.QueryGlobTester(this.config,a),b=!P.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(h),s=k.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),v=s.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(f=>{const r=g.posix.relative(a.folder.path,f.path);if(b){const t=g.basename(f.path);this.matchFile(p,{base:a.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(y,a.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(y,P,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(a){const p=(0,_.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:h,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},p,h,w){if(h===this.filePattern){const P=g.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:P})}function y(P){const b=g.basename(P),s=g.dirname(P);let o=a[s];o||(o=a[s]=[],y(s)),o.push({base:p,relativePath:P,basename:b})}y(h)}matchDirectoryTree({rootEntries:a,pathToEntries:p},h,w){const y=this,P=this.filePattern;function b(s){const o=S.hasSiblingFn(()=>s.map(v=>v.basename));for(let v=0,n=s.length;v<n;v++){const f=s[v],{relativePath:r,basename:t}=f;if(h.matchesExcludesSync(r,t,P!==t?o:void 0))continue;const d=p[r];if(d)b(d);else{if(r===P)continue;y.matchFile(w,f)}if(y.isLimitHit)break}}b(a)}matchFile(a,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(p))}}class i{constructor(){this.sessions=new Map}fileSearch(a,p,h,w){const y=this.getSessionTokenSource(a.cacheKey),P=new C(a,p,y&&y.token);let b=0;const s=o=>{b+=o.length,h(o.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(P,i.BATCH_SIZE,s,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(a){const p=this.getSessionTokenSource(a);p&&p.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new L.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,p,h,w){w.onCancellationRequested(()=>{a.cancel()});const y=b=>{b&&(P.push(b),p>0&&P.length>=p&&(h(P),P=[]))};let P=[];return a.search(y).then(b=>(P.length&&h(P),b),b=>(P.length&&h(P),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,15,21,52,30,10,8,23,12,2,31]),function(Y,e,g,L,D,S,A,k,_,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(s,o,v,n){this.query=s,this.provider=o,this.fileUtils=v,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const v=this.query.folderQueries||[],n=new L.CancellationTokenSource;return o.onCancellationRequested(()=>n.cancel()),new Promise((f,r)=>{this.collector=new h(s);let t=!1;const d=(l,c)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(l);y(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,n.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const u=this.resultSize(l);this.resultCount+=u,(u>0||!y(l))&&this.collector.add(l,c)}};Promise.all(v.map((l,c)=>this.searchInFolder(l,m=>d(m,c),n.token))).then(l=>{n.dispose(),this.collector.flush();const c=l.some(m=>!!m&&!!m.limitHit);f({limitHit:this.isLimitHit||c,messages:(0,g.flatten)(l.map(m=>m?.message?(0,C.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{n.dispose();const c=(0,D.toErrorMessage)(l);r(new Error(c))})})}resultSize(s){return y(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const v=Array.isArray(s.ranges)?s.ranges:[s.ranges],n=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:v.slice(0,o),preview:{matches:n.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,v){const n=new I.QueryGlobTester(this.query,s),f=[],r={report:l=>{if(!this.validateProviderResult(l))return;const c=s.folder.scheme===A.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(l.uri))):void 0,m=_.relativePath(s.folder,l.uri);if(m){const u=n.includedInQuery(m,k.basename(m),c);(0,C.isPromise)(u)?f.push(u.then(E=>{E&&o(l)})):u&&o(l)}}},t=this.getSearchOptionsForFolder(s),d=await this.provider.provideTextSearchResults(p(this.query.contentPattern),t,r,v);return f.length&&await Promise.all(f),d}validateProviderResult(s){if(y(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,I.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),n={folder:i.URI.from(s.folder),excludes:v,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}}e.TextSearchManager=a;function p(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!_.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(w(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=h;function w(b){return y(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function y(b){return!!b.preview}e.extensionResultIsMatch=y;class P{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,274,14,67,13,2,135]),function(Y,e,g,L,D,S,A,k,_,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(w,y,P){this.extHostRpc=w,this._uriTransformer=y,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,y){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const P=this._handlePool++;return this._textSearchProvider.set(P,y),this._proxy.$registerTextSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(w,y){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const P=this._handlePool++;return this._fileSearchProvider.set(P,y),this._proxy.$registerFileSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(w,y,P,b){const s=a(P),o=this._fileSearchProvider.get(w);if(o)return this._fileSearchManager.fileSearch(s,o,v=>{this._proxy.$handleFileMatch(w,y,v.map(n=>n.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,y,P,b){const s=this._textSearchProvider.get(w);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=a(P);return this.createTextSearchManager(o,s).search(n=>this._proxy.$handleTextMatch(w,y,n),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,y){return new i.TextSearchManager(w,y,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([We(0,A.IExtHostRpcService),We(1,k.IURITransformerService),We(2,_.ILogService)],I),e.ExtHostSearch=I;function a(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>C.URI.revive(w))}}e.reviveQuery=a;function p(h){return{...h,folder:C.URI.revive(h.folder)}}}),define(fe[275],me([0,1,21,18,3,49,2,115,110,147,83,40,5,233,232,41,234,37,235,236,237,218,238,45,42,239,219,242,243,244,69,221,249,250,251,93,33,253,222,17,7,256,71,134,36,35,59,207,241,64,133,73,57,75,13,67,14,28,245,204,54,68,230,254,203,70,92,259,257,258,231,53,252,255,91,56,124,247,72,248,10,191,246,201,240]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o,v,n,f,r,t,d,l,c,m,u,E,T,R,B,N,F,$,M,z,U,x,j,O,H,W,X,K,de,_e,Ce,Pe,Be,$e,He,G,ee,te,ce,Z,se,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,ie,Ee,Qe,et,le,Ie,Ue,Xe,it,ft,tt,ut,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(oe){const ue=oe.get(te.IExtHostInitDataService),we=oe.get(ie.IExtHostFileSystemInfo),ve=oe.get(rt.IExtHostConsumerFileSystem),Fe=oe.get(r.IExtHostExtensionService),Ge=oe.get(H.IExtHostWorkspace),ze=oe.get(Ie.IExtHostTelemetry),Ye=oe.get(P.IExtHostConfiguration),lt=oe.get(G.IURITransformerService),xe=oe.get(ee.IExtHostRpcService),ge=oe.get(N.IExtHostStorage),be=oe.get(Ze.IExtensionStoragePaths),re=oe.get(He.ILogService),Q=oe.get(se.IExtHostTunnelService),Se=oe.get(pe.IExtHostApiDeprecationService),Le=oe.get(O.IExtHostWindow),nt=oe.get(et.IExtHostSecretState),qe=oe.get(le.IExtHostEditorTabs);xe.set(a.ExtHostContext.ExtHostFileSystemInfo,we),xe.set(a.ExtHostContext.ExtHostLogService,re),xe.set(a.ExtHostContext.ExtHostWorkspace,Ge),xe.set(a.ExtHostContext.ExtHostConfiguration,Ye),xe.set(a.ExtHostContext.ExtHostExtensionService,Fe),xe.set(a.ExtHostContext.ExtHostStorage,ge),xe.set(a.ExtHostContext.ExtHostTunnelService,Q),xe.set(a.ExtHostContext.ExtHostWindow,Le),xe.set(a.ExtHostContext.ExtHostSecretState,nt),xe.set(a.ExtHostContext.ExtHostTelemetry,ze),xe.set(a.ExtHostContext.ExtHostEditorTabs,qe);const gt=xe.set(a.ExtHostContext.ExtHostDecorations,oe.get(Ce.IExtHostDecorations)),Et=xe.set(a.ExtHostContext.ExtHostDocumentsAndEditors,oe.get(f.IExtHostDocumentsAndEditors)),pt=xe.set(a.ExtHostContext.ExtHostCommands,oe.get(w.IExtHostCommands)),vt=xe.set(a.ExtHostContext.ExtHostTerminalService,oe.get(F.IExtHostTerminalService)),wt=xe.set(a.ExtHostContext.ExtHostDebugService,oe.get(Be.IExtHostDebugService)),Dt=xe.set(a.ExtHostContext.ExtHostSearch,oe.get($e.IExtHostSearch)),Ct=xe.set(a.ExtHostContext.ExtHostTask,oe.get(Pe.IExtHostTask)),At=xe.set(a.ExtHostContext.ExtHostOutputService,oe.get(u.IExtHostOutputService)),Nt=xe.set(a.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),It=xe.set(a.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(xe,Et)),Ut=xe.set(a.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(xe,Et,re)),$t=xe.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(re,It,xe.getProxy(a.MainContext.MainThreadBulkEdits))),St=xe.set(a.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(xe,pt,Et,It,be)),Qt=xe.set(a.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(re,St)),zt=xe.set(a.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(re,xe,St)),nn=xe.set(a.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(xe,ue,St,pt,re)),rn=xe.set(a.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(xe,St)),Tt=xe.set(a.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,Et)),Xt=xe.set(a.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(a.MainContext.MainThreadTreeViews),pt,re)),sn=xe.set(a.ExtHostContext.ExtHostEditorInsets,new K.ExtHostEditorInsets(xe.getProxy(a.MainContext.MainThreadEditorInsets),Tt,ue)),Yt=xe.set(a.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,re,we)),Wt=xe.set(a.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(xe,It,pt.converter,lt)),bt=xe.set(a.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(xe,lt,It,pt,Yt,re,Se)),on=xe.set(a.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,bt)),Ft=xe.set(a.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(xe,re,Et)),Vt=xe.set(a.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(xe,Ge,pt)),Jt=xe.set(a.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,pt,re)),an=xe.set(a.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(xe,pt,It)),hn=xe.set(a.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(xe.getProxy(a.MainContext.MainThreadProgress))),bn=xe.set(a.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),fn=xe.set(a.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),Zt=xe.set(a.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),En=xe.set(a.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,pt)),jt=xe.set(a.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(xe,{remote:ue.remote},Ge,re,Se)),qt=xe.set(a.ExtHostContext.ExtHostWebviewPanels,new at.ExtHostWebviewPanels(xe,jt,Ge)),_n=xe.set(a.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,It,be,jt,qt)),Sn=xe.set(a.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(xe,jt)),Gt=xe.set(a.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(xe,pt)),yn=xe.set(a.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(xe));xe.set(a.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(xe,St,Et,pt));const en=(0,X.values)(a.ExtHostContext);xe.assertRegistered(en);const Dn=new J.ExtHostBulkEdits(xe,Et),Cn=new h.ExtHostClipboard(xe),Kt=new m.ExtHostMessageService(xe,re),mn=new s.ExtHostDialogs(xe),Ht=new B.ExtHostStatusBar(xe,pt.converter);return p.ExtHostApiCommands.register(pt),function(Oe,ln,Lt){const _t=function(){let ne=!Oe.isUnderDevelopment;function he(Te){ne||(re.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Te(ht){if(Array.isArray(ht))ht.forEach(Te);else if(typeof ht=="string")he(ht);else{const yt=ht;typeof yt.scheme=="undefined"&&he(ht),!Oe.enableProposedApi&&typeof yt.exclusive=="boolean"&&(0,W.throwProposedApiError)(Oe)}return ht}}(),kn={getSession(ne,he,Te){return(Te?.forceNewSession||Te?.silent)&&(0,W.checkProposedApiEnabled)(Oe),Zt.getSession(Oe,ne,he,Te)},async hasSession(ne,he){return(0,W.checkProposedApiEnabled)(Oe),!!await Zt.getSession(Oe,ne,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Te,ht){return Zt.registerAuthenticationProvider(ne,he,Te,ht)}},In={registerCommand(ne,he,Te){return pt.registerCommand(!0,ne,he,Te,void 0,Oe)},registerTextEditorCommand(ne,he,Te){return pt.registerCommand(!0,ne,(...ht)=>{const yt=Tt.getActiveTextEditor();if(!yt){re.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Te,[yt,Pt,...ht])}).then(Pt=>{Pt||re.warn("Edits from command "+ne+" were not applied.")},Pt=>{re.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ne,he,Te)=>((0,W.checkProposedApiEnabled)(Oe),pt.registerCommand(!0,ne,async(...ht)=>{const yt=Et.activeEditor(!0);if(!yt){re.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);he.apply(Te,[Pt,...ht])},void 0,void 0,Oe)),executeCommand(ne,...he){return pt.executeCommand(ne,...he)},getCommands(ne=!1){return pt.getCommands(ne)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,he){return Le.openUri(ne,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ue.environment.appUriScheme)return Nt.createAppUri(ne);try{return await Le.asExternalUri(ne,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,tt.matchesScheme)(ne,ft.Schemas.http)||(0,tt.matchesScheme)(ne,ft.Schemas.https))return ne;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,W.checkProposedApiEnabled)(Oe),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pn={createTestController(ne,he){return Gt.createTestController(ne,he)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Oe),Gt.createTestObserver()},runTests(ne){return(0,W.checkProposedApiEnabled)(Oe),Gt.runTests(ne)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Oe),Gt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Oe),Gt.results}},An={getExtension(ne){const he=ln.getExtensionDescription(ne);if(he)return new r.Extension(Fe,Oe.identifier,he,pn)},get all(){return ln.getAllExtensionDescriptions().map(ne=>new r.Extension(Fe,Oe.identifier,ne,pn))},get onDidChange(){return ln.onDidChange}},Tn={createDiagnosticCollection(ne){return Yt.createDiagnosticCollection(Oe.identifier,ne)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ne=>Yt.getDiagnostics(ne),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ne,he){return Wt.changeLanguage(ne.uri,he)},match(ne,he){return(0,i.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0)},registerCodeActionsProvider(ne,he,Te){return bt.registerCodeActionProvider(Oe,_t(ne),he,Te)},registerCodeLensProvider(ne,he){return bt.registerCodeLensProvider(Oe,_t(ne),he)},registerDefinitionProvider(ne,he){return bt.registerDefinitionProvider(Oe,_t(ne),he)},registerDeclarationProvider(ne,he){return bt.registerDeclarationProvider(Oe,_t(ne),he)},registerImplementationProvider(ne,he){return bt.registerImplementationProvider(Oe,_t(ne),he)},registerTypeDefinitionProvider(ne,he){return bt.registerTypeDefinitionProvider(Oe,_t(ne),he)},registerHoverProvider(ne,he){return bt.registerHoverProvider(Oe,_t(ne),he,Oe.identifier)},registerEvaluatableExpressionProvider(ne,he){return bt.registerEvaluatableExpressionProvider(Oe,_t(ne),he,Oe.identifier)},registerInlineValuesProvider(ne,he){return bt.registerInlineValuesProvider(Oe,_t(ne),he,Oe.identifier)},registerDocumentHighlightProvider(ne,he){return bt.registerDocumentHighlightProvider(Oe,_t(ne),he)},registerLinkedEditingRangeProvider(ne,he){return bt.registerLinkedEditingRangeProvider(Oe,_t(ne),he)},registerReferenceProvider(ne,he){return bt.registerReferenceProvider(Oe,_t(ne),he)},registerRenameProvider(ne,he){return bt.registerRenameProvider(Oe,_t(ne),he)},registerDocumentSymbolProvider(ne,he,Te){return bt.registerDocumentSymbolProvider(Oe,_t(ne),he,Te)},registerWorkspaceSymbolProvider(ne){return bt.registerWorkspaceSymbolProvider(Oe,ne)},registerDocumentFormattingEditProvider(ne,he){return bt.registerDocumentFormattingEditProvider(Oe,_t(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return bt.registerDocumentRangeFormattingEditProvider(Oe,_t(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Te,...ht){return bt.registerOnTypeFormattingEditProvider(Oe,_t(ne),he,[Te].concat(ht))},registerDocumentSemanticTokensProvider(ne,he,Te){return bt.registerDocumentSemanticTokensProvider(Oe,_t(ne),he,Te)},registerDocumentRangeSemanticTokensProvider(ne,he,Te){return bt.registerDocumentRangeSemanticTokensProvider(Oe,_t(ne),he,Te)},registerSignatureHelpProvider(ne,he,Te,...ht){return typeof Te=="object"?bt.registerSignatureHelpProvider(Oe,_t(ne),he,Te):bt.registerSignatureHelpProvider(Oe,_t(ne),he,typeof Te=="undefined"?[]:[Te,...ht])},registerCompletionItemProvider(ne,he,...Te){return bt.registerCompletionItemProvider(Oe,_t(ne),he,Te)},registerInlineCompletionItemProvider(ne,he){return(0,W.checkProposedApiEnabled)(Oe),bt.registerInlineCompletionsProvider(Oe,_t(ne),he)},registerDocumentLinkProvider(ne,he){return bt.registerDocumentLinkProvider(Oe,_t(ne),he)},registerColorProvider(ne,he){return bt.registerColorProvider(Oe,_t(ne),he)},registerFoldingRangeProvider(ne,he){return bt.registerFoldingRangeProvider(Oe,_t(ne),he)},registerSelectionRangeProvider(ne,he){return bt.registerSelectionRangeProvider(Oe,ne,he)},registerCallHierarchyProvider(ne,he){return bt.registerCallHierarchyProvider(Oe,ne,he)},registerTypeHierarchyProvider(ne,he){return bt.registerTypeHierarchyProvider(Oe,ne,he)},setLanguageConfiguration:(ne,he)=>bt.setLanguageConfiguration(Oe,ne,he),getTokenInformationAtPosition(ne,he){return(0,W.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return(0,W.checkProposedApiEnabled)(Oe),bt.registerInlayHintsProvider(Oe,ne,he)},createLanguageStatusItem(ne,he){return(0,W.checkProposedApiEnabled)(Oe),Wt.createLanguageStatusItem(Oe,ne,he)}},cn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ne,he,Te){const ht=await(A.URI.isUri(ne)?Promise.resolve(vn.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(ht,he,Te)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Oe,ne)},onDidChangeActiveTextEditor(ne,he,Te){return Tt.onDidChangeActiveTextEditor(ne,he,Te)},onDidChangeVisibleTextEditors(ne,he,Te){return Tt.onDidChangeVisibleTextEditors(ne,he,Te)},onDidChangeTextEditorSelection(ne,he,Te){return Tt.onDidChangeTextEditorSelection(ne,he,Te)},onDidChangeTextEditorOptions(ne,he,Te){return Tt.onDidChangeTextEditorOptions(ne,he,Te)},onDidChangeTextEditorVisibleRanges(ne,he,Te){return Tt.onDidChangeTextEditorVisibleRanges(ne,he,Te)},onDidChangeTextEditorViewColumn(ne,he,Te){return Tt.onDidChangeTextEditorViewColumn(ne,he,Te)},onDidCloseTerminal(ne,he,Te){return vt.onDidCloseTerminal(ne,he,Te)},onDidOpenTerminal(ne,he,Te){return vt.onDidOpenTerminal(ne,he,Te)},onDidChangeActiveTerminal(ne,he,Te){return vt.onDidChangeActiveTerminal(ne,he,Te)},onDidChangeTerminalDimensions(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),vt.onDidChangeTerminalDimensions(ne,he,Te)},onDidChangeTerminalState(ne,he,Te){return vt.onDidChangeTerminalState(ne,he,Te)},onDidWriteTerminalData(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),vt.onDidWriteTerminalData(ne,he,Te)},get state(){return Le.state},onDidChangeWindowState(ne,he,Te){return Le.onDidChangeWindowState(ne,he,Te)},showInformationMessage(ne,...he){return Kt.showMessage(Oe,S.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Kt.showMessage(Oe,S.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Kt.showMessage(Oe,S.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Te){return Vt.showQuickPick(ne,!!Oe.enableProposedApi,he,Te)},showWorkspaceFolderPick(ne){return Vt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Vt.showInput(ne,he)},showOpenDialog(ne){return mn.showOpenDialog(ne)},showSaveDialog(ne){return mn.showSaveDialog(ne)},createStatusBarItem(ne,he,Te){let ht,yt,Pt;return typeof ne=="string"?(ht=ne,yt=he,Pt=Te):(yt=ne,Pt=he),Ht.createStatusBarEntry(Oe,ht,yt,Pt)},setStatusBarMessage(ne,he){return Ht.setStatusBarMessage(ne,he)},withScmProgress(ne){return Se.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:U.ProgressLocation.SourceControl},(he,Te)=>ne({report(ht){}}))},withProgress(ne,he){return hn.withProgress(Oe,ne,he)},createOutputChannel(ne){return At.createOutputChannel(ne,Oe)},createWebviewPanel(ne,he,Te,ht){return qt.createWebviewPanel(Oe,ne,he,Te,ht)},createWebviewTextEditorInset(ne,he,Te,ht){return(0,W.checkProposedApiEnabled)(Oe),sn.createWebviewEditorInset(ne,he,Te,ht,Oe)},createTerminal(ne,he,Te){return typeof ne=="object"?("location"in ne&&(0,W.checkProposedApiEnabled)(Oe),"pty"in ne?vt.createExtensionTerminal(ne):vt.createTerminalFromOptions(ne)):vt.createTerminal(ne,he,Te)},registerTerminalLinkProvider(ne){return vt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return vt.registerProfileProvider(Oe,ne,he)},registerTreeDataProvider(ne,he){return Xt.registerTreeDataProvider(ne,he,Oe)},createTreeView(ne,he){return Xt.createTreeView(ne,he,Oe)},registerWebviewPanelSerializer:(ne,he)=>qt.registerWebviewPanelSerializer(Oe,ne,he),registerCustomEditorProvider:(ne,he,Te={})=>_n.registerCustomEditorProvider(Oe,ne,he,Te),registerFileDecorationProvider(ne){return gt.registerFileDecorationProvider(ne,Oe.identifier)},registerUriHandler(ne){return Nt.registerUriHandler(Oe.identifier,ne)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Te){return fn.onDidChangeActiveColorTheme(ne,he,Te)},registerWebviewViewProvider(ne,he,Te){return Sn.registerWebviewViewProvider(Oe,ne,he,Te?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Oe),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeActiveNotebookEditor(ne,he,Te)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ne,he,Te)},onDidChangeNotebookEditorVisibleRanges(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ne,he,Te)},showNotebookDocument(ne,he){return(0,W.checkProposedApiEnabled)(Oe),St.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ne,he,Te)},get tabs(){return(0,W.checkProposedApiEnabled)(Oe),qe.tabs},get activeTab(){return(0,W.checkProposedApiEnabled)(Oe),qe.activeTab},get onDidChangeTabs(){return(0,W.checkProposedApiEnabled)(Oe),qe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,W.checkProposedApiEnabled)(Oe),qe.onDidChangeActiveTab},getInlineCompletionItemController(ne){return(0,W.checkProposedApiEnabled)(Oe),l.InlineCompletionController.get(ne)}},vn={get rootPath(){return Se.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ne){throw L.readonly()},getWorkspaceFolder(ne){return Ge.getWorkspaceFolder(ne)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ne){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ne){throw L.readonly()},updateWorkspaceFolders:(ne,he,...Te)=>Ge.updateWorkspaceFolders(Oe,ne,he||0,...Te),onDidChangeWorkspaceFolders:function(ne,he,Te){return Ge.onDidChangeWorkspace(ne,he,Te)},asRelativePath:(ne,he)=>Ge.getRelativePath(ne,he),findFiles:(ne,he,Te,ht)=>Ge.findFiles(z.GlobPattern.from(ne),z.GlobPattern.from(he),Te,Oe.identifier,ht),findTextInFiles:(ne,he,Te,ht)=>{let yt,Pt;return typeof he=="object"?(yt=he,Pt=Te):(yt={},Pt=he,ht=Te),Ge.findTextInFiles(ne,yt||{},Pt,Oe.identifier,ht)},saveAll:ne=>Ge.saveAll(ne),applyEdit(ne){return Dn.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Te,ht)=>Ft.createFileSystemWatcher(z.GlobPattern.from(ne),he,Te,ht),get textDocuments(){return It.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw L.readonly()},openTextDocument(ne){let he;const Te=ne;if(typeof ne=="string")he=Promise.resolve(A.URI.file(ne));else if(A.URI.isUri(ne))he=Promise.resolve(ne);else if(!Te||typeof Te=="object")he=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ht=>It.ensureDocumentData(ht).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Te)=>It.onDidAddDocument(ne,he,Te),onDidCloseTextDocument:(ne,he,Te)=>It.onDidRemoveDocument(ne,he,Te),onDidChangeTextDocument:(ne,he,Te)=>It.onDidChangeDocument(ne,he,Te),onDidSaveTextDocument:(ne,he,Te)=>It.onDidSaveDocument(ne,he,Te),onWillSaveTextDocument:(ne,he,Te)=>$t.getOnWillSaveTextDocumentEvent(Oe)(ne,he,Te),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Te;if(A.URI.isUri(ne))Te=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Te=A.URI.revive(await St.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Te,ht){return St.registerNotebookSerializer(Oe,ne,he,Te,Oe.enableProposedApi?ht:void 0)},registerNotebookContentProvider:(ne,he,Te,ht)=>((0,W.checkProposedApiEnabled)(Oe),St.registerNotebookContentProvider(Oe,ne,he,Te,Oe.enableProposedApi?ht:void 0)),onDidChangeConfiguration:(ne,he,Te)=>Lt.onDidChangeConfiguration(ne,he,Te),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Lt.getConfiguration(ne,he,Oe)},registerTextDocumentContentProvider(ne,he){return Ut.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Se.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Oe,ne,he)),registerFileSystemProvider(ne,he,Te){return on.registerFileSystemProvider(Oe.identifier,ne,he,Te)},get fs(){return ve.value},registerFileSearchProvider:(ne,he)=>((0,W.checkProposedApiEnabled)(Oe),Dt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,W.checkProposedApiEnabled)(Oe),Dt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,W.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,W.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Te)=>Ft.onDidCreateFile(ne,he,Te),onDidDeleteFiles:(ne,he,Te)=>Ft.onDidDeleteFile(ne,he,Te),onDidRenameFiles:(ne,he,Te)=>Ft.onDidRenameFile(ne,he,Te),onWillCreateFiles:(ne,he,Te)=>Ft.getOnWillCreateFileEvent(Oe)(ne,he,Te),onWillDeleteFiles:(ne,he,Te)=>Ft.getOnWillDeleteFileEvent(Oe)(ne,he,Te),onWillRenameFiles:(ne,he,Te)=>Ft.getOnWillRenameFileEvent(Oe)(ne,he,Te),openTunnel:ne=>((0,W.checkProposedApiEnabled)(Oe),Q.openTunnel(Oe,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,W.checkProposedApiEnabled)(Oe),Q.getTunnels()},onDidChangeTunnels:(ne,he,Te)=>((0,W.checkProposedApiEnabled)(Oe),Q.onDidChangeTunnels(ne,he,Te)),registerPortAttributesProvider:(ne,he)=>((0,W.checkProposedApiEnabled)(Oe),Q.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,W.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ne,he,Oe.identifier,pt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ne=>((0,W.checkProposedApiEnabled)(Oe),Ge.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Te)=>Ge.onDidGrantWorkspaceTrust(ne,he,Te)},Rn={get inputBox(){return Se.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Oe)},createSourceControl(ne,he,Te){return Jt.createSourceControl(Oe,ne,he,Te)}},Ln={createCommentController(ne,he){return an.createCommentController(Oe,ne,he)}},Fn={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(ne,he,Te){return wt.onDidStartDebugSession(ne,he,Te)},onDidTerminateDebugSession(ne,he,Te){return wt.onDidTerminateDebugSession(ne,he,Te)},onDidChangeActiveDebugSession(ne,he,Te){return wt.onDidChangeActiveDebugSession(ne,he,Te)},onDidReceiveDebugSessionCustomEvent(ne,he,Te){return wt.onDidReceiveDebugSessionCustomEvent(ne,he,Te)},onDidChangeBreakpoints(ne,he,Te){return wt.onDidChangeBreakpoints(ne,he,Te)},registerDebugConfigurationProvider(ne,he,Te){return wt.registerDebugConfigurationProvider(ne,he,Te||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return wt.registerDebugAdapterDescriptorFactory(Oe,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return wt.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?wt.startDebugging(ne,he,{parentSession:Te}):wt.startDebugging(ne,he,Te||{})},stopDebugging(ne){return wt.stopDebugging(ne)},addBreakpoints(ne){return wt.addBreakpoints(ne)},removeBreakpoints(ne){return wt.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return wt.asDebugSourceUri(ne,he)}},Mn={registerTaskProvider:(ne,he)=>Ct.registerTaskProvider(Oe,ne,he),fetchTasks:ne=>Ct.fetchTasks(ne),executeTask:ne=>Ct.executeTask(Oe,ne),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ne,he,Te)=>Ct.onDidStartTask(ne,he,Te),onDidEndTask:(ne,he,Te)=>Ct.onDidEndTask(ne,he,Te),onDidStartTaskProcess:(ne,he,Te)=>Ct.onDidStartTaskProcess(ne,he,Te),onDidEndTaskProcess:(ne,he,Te)=>Ct.onDidEndTaskProcess(ne,he,Te)},On={createNotebookController(ne,he,Te,ht,yt){return nn.createNotebookController(Oe,ne,he,Te,ht,Oe.enableProposedApi?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>St.registerNotebookCellStatusBarItemProvider(Oe,ne,he),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,W.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return rn.createRendererMessaging(Oe,ne)},onDidChangeNotebookDocumentMetadata(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),Qt.onDidChangeNotebookDocumentMetadata(ne,he,Te)},onDidChangeNotebookCells(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCells(ne,he,Te)},onDidChangeNotebookCellExecutionState(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCellExecutionState(ne,he,Te)},onDidChangeCellOutputs(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeCellOutputs(ne,he,Te)},onDidChangeCellMetadata(ne,he,Te){return(0,W.checkProposedApiEnabled)(Oe),St.onDidChangeCellMetadata(ne,he,Te)},createConcatTextDocument(ne,he){return(0,W.checkProposedApiEnabled)(Oe),new Ke.ExtHostNotebookConcatDocument(St,It,ne,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:An,languages:Tn,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:cn,workspace:vn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:C.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:A.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ae}),define(fe[276],me([0,1,84,69,36,133,37,41,45,33,73,57,75,93,54,68,134,92,53,91,124,56]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,g.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,g.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(y.IExtHostWindow,y.ExtHostWindow),(0,g.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,g.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,g.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[94],me([0,1,15,13,31,72]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function k(I,a,p,h){const w=(0,g.mapArrayOrNot)(p,_),y=new D.TextSearchMatch(a,w,h),P=y.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,C),uri:I,preview:{text:y.preview.text,matches:(0,g.mapArrayOrNot)(P,C)}}}e.createTextSearchResult=k;function _(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function C(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(a,p){this.prefix=a,this.logService=p}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};i=Ve([We(1,L.ILogService)],i),e.OutputChannel=i}),define(fe[277],me([0,1,97,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(f=>f===n)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,A=512,k=512*8,_=512*128;class C{constructor(f){this.iconvLiteDecoder=f}static async create(f){let r;if(f!==e.UTF8)r=(await new Promise((d,l)=>{Y(["iconv-lite-umd"],d,l)})).getDecoder(p(f));else{const t=new TextDecoder;r={write(d){return t.decode(d,{stream:!0})},end(){return t.decode()}}}return new C(r)}write(f){return this.iconvLiteDecoder.write(f)}end(){return this.iconvLiteDecoder.end()}}function i(n,f){const r=f.minBytesRequiredForDetection??f.guessEncoding?k:A;return new Promise((t,d)=>{const l=(0,g.newWriteableStream)(T=>T.join("")),c=[];let m=0,u;const E=async()=>{try{const T=await v({buffer:L.VSBuffer.concat(c),bytesRead:m},f.guessEncoding);T.encoding=await f.overwriteEncoding(T.encoding),u=await C.create(T.encoding);const R=u.write(L.VSBuffer.concat(c).buffer);l.write(R),c.length=0,m=0,t({stream:l,detected:T})}catch(T){d(T)}};(0,g.listenStream)(n,{onData:async T=>{u?l.write(u.write(T.buffer)):(c.push(T),m+=T.byteLength,m>=r&&(n.pause(),await E(),setTimeout(()=>n.resume())))},onError:T=>l.error(T),onEnd:async()=>{u||await E(),l.end(u?.end())}})})}e.toDecodeStream=i;async function I(n,f,r){const d=(await new Promise((m,u)=>{Y(["iconv-lite-umd"],m,u)})).getEncoder(p(f),r);let l=!1,c=!1;return{read(){if(c)return null;const m=n.read();if(typeof m!="string"){if(c=!0,!l&&r?.addBOM)switch(f){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=d.end();return u&&u.length>0?(l=!0,L.VSBuffer.wrap(u)):null}return l=!0,L.VSBuffer.wrap(d.write(m))}}}e.toEncodeReadable=I;async function a(n){return(await new Promise((r,t)=>{Y(["iconv-lite-umd"],r,t)})).encodingExists(p(n))}e.encodingExists=a;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function h(n,f){if(!n||f<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),t=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(f<e.UTF8_BOM.length)return null;const d=n.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&d===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function y(n){const f=await new Promise((c,m)=>{Y(["jschardet"],c,m)}),r=n.slice(0,_),t=s(r.buffer),d=f.detect(t);if(!d||!d.encoding)return null;const l=d.encoding.toLowerCase();return 0<=w.indexOf(l)?null:b(d.encoding)}const P={ibm866:"cp866",big5:"cp950"};function b(n){const f=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[f]||f}function s(n){let f="";for(let r=0;r<n.length;r++)f+=String.fromCharCode(n[r]);return f}function o(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const f=n.match(/windows(\d+)/);return f?"windows-"+f[1]:n}}e.toCanonicalName=o;function v({buffer:n,bytesRead:f},r){let t=h(n,f),d=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&n){let l=!0,c=!0,m=!1;for(let u=0;u<f&&u<S;u++){const E=u%2==1,T=n.readUInt8(u)===0;if(T&&(m=!0),l&&(E&&!T||!E&&T)&&(l=!1),c&&(E&&T||!E&&!T)&&(c=!1),T&&!l&&!c)break}m&&(l?t=e.UTF16le:c?t=e.UTF16be:d=!0)}return r&&!d&&!t&&n?y(n.slice(0,f)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:d,encoding:t}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,277,26,135]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends D.TextSearchManager{constructor(k,_,C=L,i="searchProcess"){super(k,_,{readdir:I=>C.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},i)}}e.NativeTextSearchManager=S}),define(fe[278],me([0,1,279,293,294,2,295]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,a,p,h,w,y){const P=y.environment.useHostProxy,b=typeof P=="boolean"?P:!y.remote.isRemote,s=(0,A.createProxyResolver)({resolveProxy:v=>I.resolveProxy(v),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(v,n,...f)=>{switch(v){case A.LogLevel.Trace:h.trace(n,...f);break;case A.LogLevel.Debug:h.debug(n,...f);break;case A.LogLevel.Info:h.info(n,...f);break;case A.LogLevel.Warning:h.warn(n,...f);break;case A.LogLevel.Error:h.error(n,...f);break;case A.LogLevel.Critical:h.critical(n,...f);break;case A.LogLevel.Off:break;default:r(v,n,f);break}function r(t,d,...l){h.error("Unknown log level",t),h.error(d,...l)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),o=_(a,s);return i(p,o)}e.connectProxyResolver=k;function _(I,a){const p={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{p.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,A.createHttpPatch)(g,a,{config:"off"},h,!0)),on:Object.assign({},g,(0,A.createHttpPatch)(g,a,{config:"on"},h,!0)),override:Object.assign({},g,(0,A.createHttpPatch)(g,a,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,A.createHttpPatch)(g,a,p,h,!0)),default:Object.assign(g,(0,A.createHttpPatch)(g,a,p,h,!1))},https:{off:Object.assign({},L,(0,A.createHttpPatch)(L,a,{config:"off"},h,!0)),on:Object.assign({},L,(0,A.createHttpPatch)(L,a,{config:"on"},h,!0)),override:Object.assign({},L,(0,A.createHttpPatch)(L,a,{config:"override"},h,!0)),onRequest:Object.assign({},L,(0,A.createHttpPatch)(L,a,p,h,!0)),default:Object.assign(L,(0,A.createHttpPatch)(L,a,p,h,!1))},tls:Object.assign(D,(0,A.createTlsPatch)(D))}}const C=new Map;function i(I,a){return I.getExtensionPathIndex().then(p=>{const h=Y.__$__nodeRequire("module"),w=h._load;h._load=function(P,b,s){if(P==="tls")return a.tls;if(P!=="http"&&P!=="https")return w.apply(this,arguments);const o=a[P],v=p.findSubstr(S.URI.file(b.filename));let n=C.get(v);if(n||C.set(v,n={}),!n[P]){let f=o.default;v&&v.enableProposedApi&&(f=o[v.proxySupport]||o.onRequest),n[P]={...f}}return n[P]}})}}),define(fe[280],me([0,1,39,8,80,29,11,9,94,281]),function(Y,e,g,L,D,S,A,k,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(s,o,v,n){const f=a(s,o,v,n),r=o.folder.fsPath;return{cmd:g.spawn(i,f.args,{cwd:r}),rgDiskPath:i,siblingClauses:f.siblingClauses,rgArgs:f,cwd:r}}e.spawnRipgrepCmd=I;function a(s,o,v,n){const f=["--files","--hidden","--case-sensitive"];h([o],v,!1).forEach(t=>{const d=(0,_.anchorGlob)(t);if(f.push("-g",d),A.isMacintosh){const l=(0,D.normalizeNFD)(d);l!==d&&f.push("-g",l)}});const r=p([o],n,void 0,!1);return r.globArgs.forEach(t=>{const d=`!${(0,_.anchorGlob)(t)}`;if(f.push("-g",d),A.isMacintosh){const l=(0,D.normalizeNFD)(d);l!==d&&f.push("-g",l)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),s.exists&&f.push("--quiet"),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:r.siblingClauses}}function p(s,o,v,n=!0){const f=[];let r={};return s.forEach(t=>{const d=Object.assign({},t.excludePattern||{},o||{}),l=w(d,n?t.folder.fsPath:void 0,v);f.push(...l.globArgs),l.siblingClauses&&(r=Object.assign(r,l.siblingClauses))}),{globArgs:f,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function h(s,o,v=!0){const n=[];return s.forEach(f=>{const r=Object.assign({},o||{},f.includePattern||{}),t=w(r,v?f.folder.fsPath:void 0);n.push(...t.globArgs)}),n}e.foldersToIncludeGlobs=h;function w(s,o,v){const n=[],f={};return Object.keys(s).forEach(r=>{if(v&&v.has(r)||!r)return;const t=s[r];r=P(o?y(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),n.push(b(r))):t&&t.when&&(f[r]=t)}),{globArgs:n,siblingClauses:f}}function y(s,o){return L.isAbsolute(o)?o:L.join(s,o)}e.getAbsoluteGlob=y;function P(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function b(s){return S.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=b}),define(fe[282],me([0,1,39,50,8,105,15,52,30,80,29,11,46,9,12,26,31,280,102]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class o{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(d=>{const l=Object.assign({},d.excludePattern||{},this.config.excludePattern||{}),c=d.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==c).forEach(m=>{(0,i.isEqualOrParent)(m,c)&&(l[D.relative(c,m)]=!0)}),this.folderExcludePatterns.set(c,new n(l,c))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,d,l,c,m){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);d.forEach(u=>{const E=D.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(l,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(t,(u,E)=>{this.call(this.cmdTraversal,this,u,l,c,T=>{if(T){const R=(0,k.toErrorMessage)(T);console.error(R),this.errors.push(R),E(T,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const T=u?A.coalesce(u)[0]:null;m(T,this.isLimitHit)})}parallel(t,d,l){const c=new Array(t.length),m=new Array(t.length);let u=!1,E=0;if(t.length===0)return l(null,[]);t.forEach((T,R)=>{d(T,(B,N)=>{if(B?(u=!0,c[R]=null,m[R]=B):(c[R]=N,m[R]=null),++E===t.length)return l(u?m:null,c)})})}call(t,d,...l){try{t.apply(d,l)}catch(c){l[l.length-1](c)}}cmdTraversal(t,d,l,c){const m=t.folder.fsPath,u=I.isMacintosh;let E;const T=()=>E&&E.kill();s.add(T);let R=U=>{s.delete(T),R=()=>{},c(U)},B="";const N=this.initDirectoryTree();let F;const $=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);E=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),l({message:z}),this.cmdResultCount=0,this.collectStdout(E,"utf8",l,(U,x,j)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const H=(B+(u?C.normalizeNFC(x||""):x)).split(`
`);if(j){const W=H.length;H[W-1]=H[W-1].trim(),H[W-1]||H.pop()}else B=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,F){for(const W of H)if(this.matchFile(d,{base:m,relativePath:W,searchPath:this.getSearchPath(t,W)}),this.isLimitHit){T();break}(j||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,N,m,H,d),j&&(this.matchDirectoryTree(N,m,d),R())})}spawnFindCmd(t){const d=this.folderExcludePatterns.get(t.folder.fsPath),l=d.getBasenameTerms(),c=d.getPathTerms(),m=["-L","."];if(l.length||c.length){m.push("-not","(","(");for(const u of l)m.push("-name",u),m.push("-o");for(const u of c)m.push("-path",u),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,d,l){let c="";this.collectStdout(t,d,()=>{},(m,u,E)=>{if(m){l(m);return}c+=u,E&&l(null,c)})}collectStdout(t,d,l,c){let m=(T,R,B)=>{(T||B)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),c(T,R,B)},u=!1;t.stdout?(this.forwardData(t.stdout,d,m),t.stdout.once("data",()=>u=!0)):l({message:"stdout is null"});let E;t.stderr?E=this.collectData(t.stderr):l({message:"stderr is null"}),t.on("error",T=>{m(T)}),t.on("close",T=>{let R;!u&&(R=this.decodeData(E,d))&&f(R)?m(new Error(`command failed with error code ${T}: ${this.decodeData(E,d)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,d,l){const c=new S.StringDecoder(d);return t.on("data",m=>{l(null,c.write(m))}),c}collectData(t){const d=[];return t.on("data",l=>{d.push(l)}),d}decodeData(t,d){const l=new S.StringDecoder(d);return t.map(c=>l.write(c)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:d},l,c,m){c.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:l,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=E=>{const T=D.basename(E),R=D.dirname(E);let B=d[R];B||(B=d[R]=[],u(R)),B.push({base:l,relativePath:E,basename:T,searchPath:this.getSearchPath(t,E)})};c.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:d},l,c){const m=this,u=this.folderExcludePatterns.get(l),E=this.filePattern;function T(R){m.directoriesWalked++;const B=_.hasSiblingFn(()=>R.map(N=>N.basename));for(let N=0,F=R.length;N<F;N++){const $=R[N],{relativePath:M,basename:z}=$;if(u.test(M,z,E!==z?B:void 0))continue;const U=d[M];if(U)T(U);else{if(m.filesWalked++,M===E)continue;m.matchFile(c,$)}if(m.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,d,l,c,m){const u=t.folder,E=_.hasSiblingFn(()=>l);this.parallel(l,(T,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=d?[d,T].join(D.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test(B,T,this.config.filePattern!==T?E:void 0))return R(null);const N=[u.fsPath,B].join(D.sep);L.lstat(N,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(N,$,(M,z)=>M||this.isCanceled||this.isLimitHit?R(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,$,(U,x)=>U||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?R(null):(this.walkedPaths[x]=!0,w.Promises.readdir(N).then(j=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,B,j,c,O=>R(O||null))},j=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&h.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(c,{base:u.fsPath,relativePath:B,searchPath:this.getSearchPath(t,B)}),R(null,void 0)))})},T=>{const R=T&&A.coalesce(T);return m(R&&R.length>0?R[0]:void 0)})}matchFile(t,d){this.isFileMatch(d)&&(!this.includePattern||this.includePattern(d.relativePath,D.basename(d.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(d))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,y.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,d,l){return d.isSymbolicLink()?L.stat(t,l):l(null,d)}realPathIfNeeded(t,d,l){return d.isSymbolicLink()?L.realpath(t,(c,m)=>c?l(c):l(null,m)):l(null,t)}getSearchPath(t,d){return t.folderName?D.join(t.folderName,d):d}}e.FileWalker=o;class v{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new o(t)}search(t,d,l){this.walker.walk(this.folderQueries,this.extraFiles,t,d,(c,m)=>{l(c,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class n{constructor(t,d){this.expression=t,this.root=d,this.init(t)}init(t){let d,l;Object.keys(t).filter(c=>t[c]).forEach(c=>{D.isAbsolute(c)?(d=d||_.getEmptyExpression(),d[c]=t[c]):(l=l||_.getEmptyExpression(),l[c]=t[c])}),this.absoluteParsedExpr=d&&_.parse(d,{trimForExclusions:!0}),this.relativeParsedExpr=l&&_.parse(l,{trimForExclusions:!0})}test(t,d,l){return this.relativeParsedExpr&&this.relativeParsedExpr(t,d,l)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),d,l)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function f(r){const t=r.trim().split(`
`),d=t[0].trim();if(d.startsWith("Error parsing regex"))return d;if(d.startsWith("regex parse error"))return p.uppercaseFirstLetter(t[t.length-1].trim());if(d.startsWith("error parsing glob")||d.startsWith("unsupported encoding"))return d.charAt(0).toUpperCase()+d.substr(1);if(d==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(d.startsWith("Literal "))return d}e.rgErrorMsgForDisplay=f}),define(fe[137],me([0,1,39,296,105,15,59,30,8,9,2,31,72,297,281,94]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const y=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,T,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((B,N)=>{R.onCancellationRequested(()=>O());const F=f(u,E),$=E.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${y} ${M}
 - cwd: ${$}`);let z=g.spawn(y,F,{cwd:$});z.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),N((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const x=new o(E.maxResults,$,E.previewOptions);x.on("result",de=>{U=!0,W="",T.report(de)});let j=!1;const O=()=>{j=!0,z&&z.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,O()});let W="";z.stdout.on("data",de=>{x.handleData(de),U||(W+=de)});let X=!1;z.stdout.once("data",()=>X=!0);let K="";z.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),K+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),j)B({limitHit:H});else{x.flush(),z=null;let de;K&&!X&&(de=b(K))?N((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:H})}})})}}e.RipgrepTextSearchEngine=P;function b(m){const u=m.split(`
`),E=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(s(u),I.SearchErrorCode.regexParseError);const T=E.match(/grep config error: unknown encoding: (.*)/);if(T)return new I.SearchError(`Unknown encoding: ${T[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function s(m){const u=["Regex parse error"],E=m.filter(T=>T.startsWith("PCRE2:"));if(E.length>=1){const T=E[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const R=T.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=s;class o extends L.EventEmitter{constructor(u,E,T){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const T=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=T;return}let R=0;for(;E>=0;)this.handleLine(T.substring(R,E).trim()),R=E+1,E=T.indexOf(`
`,R);this.remainder=T.substring(R)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(T){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const T=v(E.data.path),R=i.URI.file(_.join(this.rootFolder,T)),B=this.createTextSearchMatch(E.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const T=v(E.data.path),R=i.URI.file(_.join(this.rootFolder,T));this.createTextSearchContext(E.data,R).forEach(N=>this.onResult(N))}}createTextSearchMatch(u,E){const T=u.line_number-1,R=v(u.lines),B=Buffer.from(R);let N=0,F=0,$=T;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,S.coalesce)(u.submatches.map((z,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=v(z.match),j=B.slice(N,z.start).toString().length,O=F+j,H=n(x),W=$,X=H.numLines+W,K=H.numLines>0?H.lastLineLength:H.lastLineLength+O;return N=z.end,F=K,$=X,new a.Range(W,O,X,K)}));return(0,w.createTextSearchResult)(E,R,M,this.previewOptions)}createTextSearchContext(u,E){const T=v(u.lines),R=u.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((B,N)=>({text:B,uri:E,lineNumber:R+N}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=o;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function n(m){const u=/\n/g;let E=0,T=-1,R;for(;R=u.exec(m);)E++,T=R.index;const B=T>=0?m.length-T-1:m.length;return{numLines:E,lastLineLength:B}}function f(m,u){const E=["--hidden"];E.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:R}=(0,A.groupBy)(u.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const N=new Set;R.forEach(F=>{N.add(F)}),E.push("-g","!*"),N.forEach(F=>{r(F).map(w.anchorGlob).forEach($=>{E.push("-g",$)})})}T&&T.length&&T.forEach(N=>{E.push("-g",N)}),u.excludes.map(w.anchorGlob).forEach(N=>E.push("-g",`!${N}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,C.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),E.push("--auto-hybrid-regex"));let B;if(m.isWordMatch){const F=(0,C.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(m.isRegExp){let N=l(m.pattern);N=c(N),E.push("--regexp",N)}else B=m.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),m.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),B&&E.push(B),E.push("."),E}function r(m){const u=(0,k.splitGlobAware)(m,"/");return u.map((E,T)=>u.slice(0,T+1).join("/"))}e.spreadGlobComponents=r;function t(m){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(u);)m=m.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const d=m=>m.type==="Assertion"&&m.kind==="lookbehind";function l(m){let u;try{u=new p.RegExpParser().parsePattern(m)}catch{return m}let E="",T=0;const R=(F,$,M)=>{E+=m.slice(T,F)+M,T=$},B=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(d))if($.type==="CharacterClass")if($.negate){const M=m.slice($.start+2,F.start)+m.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const z=$.parent;R(z.start,z.end,(M?`[^${M}]`:".")+(z.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=m.slice($.start+1,F.start)+m.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){d(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(u),E+=m.slice(T),E}e.fixRegexNewline=l;function c(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(fe[283],me([0,1,21,137,119,10]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,i,I,a){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const h={...i,folder:i.folder.with({scheme:S.Schemas.file})},w=new D.Progress(y=>I.report({...y,uri:y.uri.with({scheme:i.folder.scheme})}));return this.withToken(a,y=>p.provideTextSearchResults(C,h,w,y))}else return this.withToken(a,h=>p.provideTextSearchResults(C,i,I,h))}async withToken(C,i){const I=k(C);this.inProgress.add(I);const a=await i(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function k(_){const C=new g.CancellationTokenSource;return _.onCancellationRequested(()=>C.cancel()),C}}),define(fe[284],me([0,1,26,137,136]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(_){this.query=_}search(_,C,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){i({message:p})}},a=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((p,h)=>a.search(w=>{C(w.map(A))},_).then(w=>p({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=S;function A(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,C)=>{if(C.ranges){const i=C;return _+(Array.isArray(i.ranges)?i.ranges.length:1)}else return _+1},0)}}}),define(fe[285],me([0,1,50,298,15,16,18,3,102,8,46,2,40,31,282,284]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class y{constructor(n="searchProcess"){this.processType=n,this.caches=Object.create(null)}fileSearch(n){let f;const r=s(n),t=new k.Emitter({onFirstListenerDidAdd:()=>{f=(0,S.createCancelablePromise)(d=>this.doFileSearchWithEngine(h.Engine,r,l=>t.fire(l),d)),f.then(d=>t.fire(d),d=>t.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return t.event}textSearch(n){let f;const r=s(n),t=new k.Emitter({onFirstListenerDidAdd:()=>{f=(0,S.createCancelablePromise)(d=>this.ripgrepTextSearch(r,l=>t.fire(l),d)),f.then(d=>t.fire(d),d=>t.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return t.event}ripgrepTextSearch(n,f,r){return n.maxFileSize=(0,a.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(n).search(r,f,f)}doFileSearch(n,f,r){return this.doFileSearchWithEngine(h.Engine,n,f,r)}doFileSearchWithEngine(n,f,r,t,d=y.BATCH_SIZE){let l=0;const c=u=>{Array.isArray(u)?(l+=u.length,r(u.map(E=>this.rawMatchToSearchItem(E)))):u.relativePath?(l++,r(this.rawMatchToSearchItem(u))):r(u)};if(f.sortByScore){let u=this.trySortedSearchFromCache(f,c,t);if(!u){const E=f.maxResults?Object.assign({},f,{maxResults:null}):f,T=new n(E);u=this.doSortedSearch(T,f,r,c,t)}return new Promise((E,T)=>{u.then(([R,B])=>{const N=B.map(F=>this.rawMatchToSearchItem(F));this.sendProgress(N,r,d),E(R)},T)})}const m=new n(f);return this.doSearch(m,c,d,t).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(n){return{path:n.base?(0,C.join)(n.base,n.relativePath):n.relativePath}}doSortedSearch(n,f,r,t,d){const l=new k.Emitter;let c=(0,S.createCancelablePromise)(u=>{let E=[];const T=R=>{Array.isArray(R)?E=R:(t(R),l.fire(R))};return this.doSearch(n,T,-1,u).then(R=>[R,E])}),m;if(f.cacheKey){m=this.getOrCreateCache(f.cacheKey);const u={promise:c,event:l.event,resolved:!1};m.resultsToSearchCache[f.filePattern||""]=u,c.then(()=>{u.resolved=!0},E=>{delete m.resultsToSearchCache[f.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([u,E])=>{const T=m?m.scorerCache:Object.create(null),R=(typeof f.maxResults!="number"||f.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(f,E,T,d).then(B=>{const N=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:B.length},messages:u.messages,limitHit:u.limitHit||typeof f.maxResults=="number"&&E.length>f.maxResults},B]})})}getOrCreateCache(n){const f=this.caches[n];return f||(this.caches[n]=new P)}trySortedSearchFromCache(n,f,r){const t=n.cacheKey&&this.caches[n.cacheKey];if(!t)return;const d=this.getResultsFromCache(t,n.filePattern||"",f,r);if(d)return d.then(([l,c,m])=>{const u=i.StopWatch.create(!1);return this.sortResults(n,c,t.scorerCache,r).then(E=>{const T=u.elapsed(),R={fromCache:!0,detailStats:m,type:this.processType,resultCount:c.length,sortingTime:T};return[{type:"success",limitHit:l.limitHit||typeof n.maxResults=="number"&&c.length>n.maxResults,stats:R},E]})})}sortResults(n,f,r,t){const d=(0,_.prepareQuery)(n.filePattern||""),l=(m,u)=>(0,_.compareItemsByFuzzyScore)(m,u,d,!0,b,r),c=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.topAsync(f,l,c,1e4,t)}sendProgress(n,f,r){if(r&&r>0)for(let t=0;t<n.length;t+=r)f(n.slice(t,t+r));else f(n)}getResultsFromCache(n,f,r,t){const d=i.StopWatch.create(!1),l=f.indexOf(C.sep)>=0;let c;for(const T in n.resultsToSearchCache)if(f.startsWith(T)){if(l&&T.indexOf(C.sep)<0&&T!=="")continue;const R=n.resultsToSearchCache[T];c={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!c)return null;const m=d.elapsed(),u=i.StopWatch.create(!1),E=c.event(r);return t&&t.onCancellationRequested(()=>{E.dispose()}),c.promise.then(([T,R])=>{if(t&&t.isCancellationRequested)throw(0,A.canceled)();const B=[],N=(0,_.prepareQuery)(f).normalizedLowercase;for(const F of R)!(0,p.isFilePatternMatch)(F,N)||B.push(F);return[T,B,{cacheWasResolved:c.resolved,cacheLookupTime:m,cacheFilterTime:u.elapsed(),cacheEntryCount:R.length}]})}doSearch(n,f,r,t){return new Promise((d,l)=>{let c=[];t&&t.onCancellationRequested(()=>n.cancel()),n.search(m=>{m&&(r?(c.push(m),r>0&&c.length>=r&&(f(c),c=[])):f(m))},m=>{f(m)},(m,u)=>{c.length&&f(c),m?l(m):d(u)})})}clearCache(n){return delete this.caches[n],Promise.resolve(void 0)}preventCancellation(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,r){return n.then(f,r)}catch(f){return this.then(void 0,f)}finally(f){return n.finally(f)}}}}e.SearchService=y,y.BATCH_SIZE=512;class P{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,C.basename)(v.relativePath)}getItemDescription(v){return(0,C.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function s(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(o),extraFileResources:v.extraFileResources&&v.extraFileResources.map(n=>I.URI.revive(n))}}function o(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(fe[286],me([0,1,6,10,2,26,13,28,14,75,67,31,285,283,94,136]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let y=class extends C.ExtHostSearch{constructor(b,s,o,v){super(b,o,v);this._pfs=S,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new p.RipgrepSearchProvider(n)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new p.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(L.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,s,o,v){const n=(0,C.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,s,n,v):super.$provideFileSearchResults(b,s,o,v)}doInternalFileSearch(b,s,o,v){const n=f=>{if((0,I.isSerializedFileMatch)(f)&&(f=[f]),Array.isArray(f)){this._proxy.$handleFileMatch(b,s,f.map(r=>D.URI.file(r.path)));return}f.message&&this._logService.debug("ExtHostSearch",f.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,n,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,s){return new w.NativeTextSearchManager(b,s,void 0,"textSearchProvider")}};y=Ve([We(0,_.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,i.IURITransformerService),We(3,A.ILogService)],y),e.NativeExtHostSearch=y}),define(fe[138],me([0,1,299,127,82,22,18,3,6,8,11,32,107,108,300]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(c){this.socket=c,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const m=u=>c(S.VSBuffer.wrap(u));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(c){const m=u=>{c({type:0,hadError:u,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(c){return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(c){if(!this.socket.destroyed)try{this.socket.write(c.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((c,m)=>{if(this.socket.bufferSize===0){c();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),c()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=w;var y;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var P;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(P||(P={}));class b extends _.Disposable{constructor(c,m,u,E){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=E,m?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._totalOutgoingDataBytes+=c.byteLength,this._zlibDeflate?(this._zlibDeflate.write(c.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(S.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(c,!1)}_write(c,m){let u=2;c.byteLength<126?u+=0:c.byteLength<2**16?u+=2:u+=8;const E=S.VSBuffer.alloc(u);if(m?E.writeUInt8(194,0):E.writeUInt8(130,0),c.byteLength<126)E.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(c.byteLength>>>8&255,++T),E.writeUInt8(c.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(c.byteLength>>>24&255,++T),E.writeUInt8(c.byteLength>>>16&255,++T),E.writeUInt8(c.byteLength>>>8&255,++T),E.writeUInt8(c.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=E.byteLength+c.byteLength,this.socket.write(S.VSBuffer.concat([E,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._totalIncomingWireBytes+=c.byteLength,this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),u=m.readUInt8(0),E=(u&128)>>>7,T=(u&64)>>>6,R=m.readUInt8(1),B=(R&128)>>>7,N=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),u=m.readUInt8(1),E=(u&128)>>>7;let T=u&127,R=1;T===126?T=m.readUInt8(++R)*2**8+m.readUInt8(++R):T===127&&(T=m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R));let B=0;E&&(B=m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R)),this._state.state=3,this._state.readLen=T,this._state.mask=B}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);s(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(S.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function s(l,c){if(c===0)return;let m=l.byteLength>>>2;for(let N=0;N<m;N++){const F=l.readUInt32BE(N*4);l.writeUInt32BE(F^c,N*4)}let u=m*4,E=l.byteLength-u;const T=c>>>24&255,R=c>>>16&255,B=c>>>8&255;E>=1&&l.writeUInt8(l.readUInt8(u)^T,u),E>=2&&l.writeUInt8(l.readUInt8(u+1)^R,u+1),E>=3&&l.writeUInt8(l.readUInt8(u+2)^B,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function v(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):c=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),f(c),c}e.createRandomIPCHandle=v;function n(l,c,m){const u=(0,g.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${m}-${c}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${m}-${c}.sock`):E=(0,C.join)(l,`${m}-${c}.sock`),f(E),E}e.createStaticIPCHandle=n;function f(l){const c=o[i.platform];typeof c=="number"&&l.length>=c&&console.warn(`WARNING: IPC handle "${l}" is longer than ${c} chars, try a shorter --user-data-dir`)}class r extends a.IPCServer{constructor(c){super(r.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const m=k.Event.fromNodeEventEmitter(c,"connection");return k.Event.map(m,u=>({protocol:new p.Protocol(new w(u)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(l){return new Promise((c,m)=>{const u=(0,L.createServer)();u.on("error",m),u.listen(l,()=>{u.removeListener("error",m),c(new r(u))})})}e.serve=t;function d(l,c){return new Promise((m,u)=>{const E=(0,L.createConnection)(l,()=>{E.removeListener("error",u),m(p.Client.fromSocket(new w(E),c))});E.once("error",u)})}e.connect=d}),define(fe[287],me([0,1,138,279,50,41,2,199,13]),function(Y,e,g,L,D,S,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(a,p,h){this._commands=a,this.logService=p,this._ipcHandlePath=h,this._server=L.createServer((w,y)=>this.onRequest(w,y)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,p){const h=[];a.setEncoding("utf8"),a.on("data",w=>h.push(w)),a.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,y=>{y&&this.logService.error(y)}),p.end();break}})}open(a,p){let{fileURIs:h,folderURIs:w,forceNewWindow:y,diffMode:P,addMode:b,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:v}=a;const n=[];if(Array.isArray(w))for(const f of w)try{n.push({folderUri:A.URI.parse(f)})}catch(r){}if(Array.isArray(h))for(const f of h)try{(0,k.hasWorkspaceFileExtension)(f)?n.push({workspaceUri:A.URI.parse(f)}):n.push({fileUri:A.URI.parse(f)})}catch(r){}if(n.length){const f=v?A.URI.file(v):void 0,t={forceNewWindow:y,diffMode:P,addMode:b,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!f&&!b,waitMarkerFileURI:f};this._commands.executeCommand("_remoteCLI.windowOpen",n,t)}p.writeHead(200),p.end()}async openExternal(a,p){for(const h of a.uris){const w=A.URI.parse(h),y=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",y)}p.writeHead(200),p.end()}async manageExtensions(a,p){try{const h=P=>P?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),w={list:a.list,install:h(a.install),uninstall:h(a.uninstall),force:a.force},y=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(y)}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(a,p){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(h),p.end()}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let i=class extends C{constructor(a,p){super(a,p,(0,g.createRandomIPCHandle)())}};i=Ve([We(0,S.IExtHostCommands),We(1,_.ILogService)],i),e.CLIServer=i}),define(fe[288],me([0,1,74,275,270,5,278,42,260,2,10,7,287,106]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends D.RequireInterceptor{_installInterceptor(){const P=this,b=Y.__$__nodeRequire("module"),s=b._load;b._load=function(v,n,f){for(let r of P._alternatives){let t=r(v);if(t){v=t;break}}return P._factories.has(v)?P._factories.get(v).load(v,C.URI.file((0,p.realpathSync)(n.filename)),r=>s.apply(this,[r,n,f])):s.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(h,P,this._registry).install(),g.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const o=process.send,v=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?o.apply(process,n):(v.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,b,s){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{P&&g.mark(`code/extHost/willLoadExtensionCode/${P.value}`),o=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{P&&g.mark(`code/extHost/didLoadExtensionCode/${P.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const b in P){const s=P[b];s===null?delete process.env[b]:process.env[b]=s}}}e.ExtHostExtensionService=w}),define(fe[289],me([0,1,84,261,263,272,271,286,288,228,264,57,42,69,75,73,33,54,13,70,262]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y,P,b,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(a.IExtHostExtensionService,_.ExtHostExtensionService),(0,g.registerSingleton)(b.ILogService,C.ExtHostLogService),(0,g.registerSingleton)(s.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,A.ExtHostDebugService),(0,g.registerSingleton)(p.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(h.IExtHostSearch,k.NativeExtHostSearch),(0,g.registerSingleton)(w.IExtHostTask,S.ExtHostTask),(0,g.registerSingleton)(y.IExtHostTerminalService,D.ExtHostTerminalService),(0,g.registerSingleton)(P.IExtHostTunnelService,i.ExtHostTunnelService)}),define(fe[290],me([0,1,127,301,74,18,108,138,192,226,273,22,104,26,106,16,115,276,289]),function(Y,e,g,L,D,S,A,k,_,C,i,I,a,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),d=t._load;t._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return d.apply(this,arguments)}})();const b=process.exit.bind(process);function s(t){process.exit=function(d){if(t)b(d);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)}}let o=function(t){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,d)=>{let l=null,c=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,u=3e5,E=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),m),T=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),u);process.on("message",(B,N)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new k.NodeSocket(N);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new k.WebSocketNodeSocket(new k.NodeSocket(N),B.permessageDeflate,M,!1)}l?(E.cancel(),T.cancel(),l.beginAcceptReconnection($,F),l.endAcceptReconnection()):(clearTimeout(c),l=new A.PersistentProtocol($,F),l.onDidDispose(()=>o("renderer disconnected")),t(l),l.onSocketClose(()=>{E.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;E.isScheduled()&&T.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((d,l)=>{const c=g.createConnection(t,()=>{c.removeListener("error",l),d(new A.PersistentProtocol(new k.NodeSocket(c)))});c.once("error",l),c.on("close",()=>{o("renderer closed the socket")})})}}async function n(){const t=await v();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(d=>{(0,C.isMessageOfType)(d,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||t.send(d)}drain(){return t.drain()}}}function f(t){return new Promise(d=>{const l=t.onMessage(c=>{l.dispose();const m=JSON.parse(c.toString()),u=m.commit,E=_.default.commit;u&&E&&u!==E&&b(55);const T=[];process.on("unhandledRejection",(N,F)=>{T.push(F),setTimeout(()=>{const $=T.indexOf(F);$>=0&&F.catch(M=>{T.splice($,1),(0,S.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),(0,S.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const F=T.indexOf(N);F>=0&&T.splice(F,1)}),process.on("uncaughtException",function(N){(0,S.onUnexpectedError)(N)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch(N){N&&N.code==="EPERM"?(R++,R>=3&&o(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):o(`parent process ${m.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let B;try{B=Y.__$__nodeRequire("native-watchdog"),B.start(m.parentPid)}catch(N){(0,S.onUnexpectedError)(N)}t.send((0,C.createMessageOfType)(0)),d({protocol:t,initData:m})});t.send((0,C.createMessageOfType)(1))})}async function r(){D.mark("code/extHost/willConnectToRenderer");const t=await n();D.mark("code/extHost/didConnectToRenderer");const d=await f(t);D.mark("code/extHost/didWaitForInitData");const{initData:l}=d;s(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,y.boolean)(P.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(T){b(T)}exists(T){return p.Promises.exists(T)}realpath(T){return(0,h.realpath)(T)}};let m=null;if(l.remote.authority&&P.uriTransformerPath)try{const T=Y.__$__nodeRequire(P.uriTransformerPath)(l.remote.authority);m=new a.URITransformer(T)}catch(E){console.error(E)}const u=new i.ExtensionHostMain(d.protocol,l,c,m);o=E=>u.terminate(E)}e.startExtensionHostProcess=r}),define(fe[302],me([0,1,290]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/552af97a0170b43c9323bec62211feb184da9749/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
