/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/platform/log/common/log","vs/base/common/arrays","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(re){for(var e=[],d=0,M=re.length;d<M;d++)e[d]=we[re[d]];return e};define(we[42],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=d}),define(we[53],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let n in t)d.call(t,n)&&_.push(t[n]);return _}e.values=M;function E(t,_){for(let n in t)if(d.call(t,n)&&_({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,_){const n=Object.create(null);for(const m of t){const s=_(m);let u=n[s];u||(u=n[s]=[]),u.push(m)}return n}e.groupBy=A;function F(t){const _=Object.create(null);return t&&t.forEach((n,m)=>{_[m]=n}),_}e.fromMap=F;function P(t,_){const n=[],m=[];for(let s of t)_.has(s)||n.push(s);for(let s of _)t.has(s)||m.push(s);return{removed:n,added:m}}e.diffSets=P;function C(t,_){const n=[],m=[];for(let[s,u]of t)_.has(s)||n.push(u);for(let[s,u]of _)t.has(s)||m.push(u);return{removed:n,added:m}}e.diffMaps=C;class T{constructor(){this.map=new Map}add(_,n){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(n)}delete(_,n){const m=this.map.get(_);!m||(m.delete(n),m.size===0&&this.map.delete(_))}forEach(_,n){const m=this.map.get(_);!m||m.forEach(n)}}e.SetMap=T}),define(we[54],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(F){return(P,C,T)=>{let t=null,_=null;if(typeof T.value=="function"?(t="value",_=T.value):typeof T.get=="function"&&(t="get",_=T.get),!_)throw new Error("not supported");T[t]=F(_,C)}}e.createDecorator=d;function M(F,P,C){let T=null,t=null;if(typeof C.value=="function"?(T="value",t=C.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(T="get",t=C.get),!t)throw new Error("not supported");const _=`$memoize$${P}`;C[T]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[_]}}e.memoize=M;function E(F,P,C){return d((T,t)=>{const _=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...m){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),P&&(this[n]=P(this[n],...m),m=[this[n]]),this[_]=setTimeout(()=>{T.apply(this,m),this[n]=C?C():void 0},F)}})}e.debounce=E;function A(F,P,C){return d((T,t)=>{const _=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,m=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...u)),this[s])return;const p=this[m]+F;p<=Date.now()?(this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=C?C():void 0):(this[s]=!0,this[_]=setTimeout(()=>{this[s]=!1,this[m]=Date.now(),T.apply(this,[this[n]]),this[n]=C?C():void 0},p-Date.now()))}})}e.throttle=A}),define(we[55],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(we[102],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function F(i,g=!1){let a=0,r=i.length,v="",l=0,c=16,b=0;function h(x){let N=0,V=0;for(;N<x;){const W=i.charCodeAt(a);if(W>=48&&W<=57)V=V*16+W-48;else if(W>=65&&W<=70)V=V*16+W-65+10;else if(W>=97&&W<=102)V=V*16+W-97+10;else break;a++,N++}return N<x&&(V=-1),V}function y(x){a=x,v="",l=0,c=16,b=0}function R(){const x=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&T(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&T(i.charCodeAt(a)))for(a++;a<i.length&&T(i.charCodeAt(a));)a++;else return b=3,i.substring(x,a);let N=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&T(i.charCodeAt(a))){for(a++;a<i.length&&T(i.charCodeAt(a));)a++;N=a}else b=3;return i.substring(x,N)}function I(){let x="",N=a;for(;;){if(a>=r){x+=i.substring(N,a),b=2;break}const V=i.charCodeAt(a);if(V===34){x+=i.substring(N,a),a++;break}if(V===92){if(x+=i.substring(N,a),a++,a>=r){b=2;break}switch(i.charCodeAt(a++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const $=h(4);$>=0?x+=String.fromCharCode($):b=4;break;default:b=5}N=a;continue}if(V>=0&&V<=31)if(C(V)){x+=i.substring(N,a),b=2;break}else b=6;a++}return x}function U(){if(v="",b=0,l=a,a>=r)return l=r,c=17;let x=i.charCodeAt(a);if(P(x)){do a++,v+=String.fromCharCode(x),x=i.charCodeAt(a);while(P(x));return c=15}if(C(x))return a++,v+=String.fromCharCode(x),x===13&&i.charCodeAt(a)===10&&(a++,v+=`
`),c=14;switch(x){case 123:return a++,c=1;case 125:return a++,c=2;case 91:return a++,c=3;case 93:return a++,c=4;case 58:return a++,c=6;case 44:return a++,c=5;case 34:return a++,v=I(),c=10;case 47:const N=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<r&&!C(i.charCodeAt(a));)a++;return v=i.substring(N,a),c=12}if(i.charCodeAt(a+1)===42){a+=2;const V=r-1;let W=!1;for(;a<V;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,W=!0;break}a++}return W||(a++,b=1),v=i.substring(N,a),c=13}return v+=String.fromCharCode(x),a++,c=16;case 45:if(v+=String.fromCharCode(x),a++,a===r||!T(i.charCodeAt(a)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=R(),c=11;default:for(;a<r&&L(x);)a++,x=i.charCodeAt(a);if(l!==a){switch(v=i.substring(l,a),v){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return v+=String.fromCharCode(x),a++,c=16}}function L(x){if(P(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function D(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:y,getPosition:()=>a,scan:g?D:U,getToken:()=>c,getTokenValue:()=>v,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>b}}e.createScanner=F;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function T(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,g){const a=[],r=new Object;let v;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(h,y,R,I){l.value=h,l.offset=y,l.length=R,l.type=I,l.colonOffset=void 0,v=l}try{o(i,{onObjectBegin:(h,y)=>{if(g<=h)throw r;v=void 0,c=g>h,a.push("")},onObjectProperty:(h,y,R)=>{if(g<y||(b(h,y,R,"property"),a[a.length-1]=h,g<=y+R))throw r},onObjectEnd:(h,y)=>{if(g<=h)throw r;v=void 0,a.pop()},onArrayBegin:(h,y)=>{if(g<=h)throw r;v=void 0,a.push(0)},onArrayEnd:(h,y)=>{if(g<=h)throw r;v=void 0,a.pop()},onLiteralValue:(h,y,R)=>{if(g<y||(b(h,y,R,S(h)),g<=y+R))throw r},onSeparator:(h,y,R)=>{if(g<=y)throw r;if(h===":"&&v&&v.type==="property")v.colonOffset=y,c=!1,v=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(c=!0,a[a.length-1]=""),v=void 0}}})}catch(h){if(h!==r)throw h}return{path:a,previousNode:v,isAtPropertyKey:c,matches:h=>{let y=0;for(let R=0;y<h.length&&R<a.length;R++)if(h[y]===a[R]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=_;function n(i,g=[],a=A.DEFAULT){let r=null,v=[];const l=[];function c(h){Array.isArray(v)?v.push(h):r!==null&&(v[r]=h)}return o(i,{onObjectBegin:()=>{const h={};c(h),l.push(v),v=h,r=null},onObjectProperty:h=>{r=h},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const h=[];c(h),l.push(v),v=h,r=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:c,onError:(h,y,R)=>{g.push({error:h,offset:y,length:R})}},a),v[0]}e.parse=n;function m(i,g=[],a=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){r.type==="property"&&(r.length=h-r.offset,r=r.parent)}function l(h){return r.children.push(h),h}o(i,{onObjectBegin:h=>{r=l({type:"object",offset:h,length:-1,parent:r,children:[]})},onObjectProperty:(h,y,R)=>{r=l({type:"property",offset:y,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:h,offset:y,length:R,parent:r})},onObjectEnd:(h,y)=>{r.length=h+y-r.offset,r=r.parent,v(h+y)},onArrayBegin:(h,y)=>{r=l({type:"array",offset:h,length:-1,parent:r,children:[]})},onArrayEnd:(h,y)=>{r.length=h+y-r.offset,r=r.parent,v(h+y)},onLiteralValue:(h,y,R)=>{l({type:S(h),offset:y,length:R,parent:r,value:h}),v(y+R)},onSeparator:(h,y,R)=>{r.type==="property"&&(h===":"?r.colonOffset=y:h===","&&v(y))},onError:(h,y,R)=>{g.push({error:h,offset:y,length:R})}},a);const b=r.children[0];return b&&delete b.parent,b}e.parseTree=m;function s(i,g){if(!i)return;let a=i;for(let r of g)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===r){a=l.children[1],v=!0;break}if(!v)return}else{const v=r;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.findNodeAtLocation=s;function u(i){if(!i.parent||!i.parent.children)return[];const g=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;g.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&g.push(a)}return g}e.getNodePath=u;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const g=Object.create(null);for(let a of i.children){const r=a.children[1];r&&(g[a.children[0].value]=p(r))}return g;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function k(i,g,a=!1){return g>=i.offset&&g<i.offset+i.length||a&&g===i.offset+i.length}e.contains=k;function w(i,g,a=!1){if(k(i,g,a)){const r=i.children;if(Array.isArray(r))for(let v=0;v<r.length&&r[v].offset<=g;v++){const l=w(r[v],g,a);if(l)return l}return i}}e.findNodeAtOffset=w;function o(i,g,a=A.DEFAULT){const r=F(i,!1);function v(ce){return ce?()=>ce(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(ce){return ce?Fe=>ce(Fe,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=v(g.onObjectBegin),b=l(g.onObjectProperty),h=v(g.onObjectEnd),y=v(g.onArrayBegin),R=v(g.onArrayEnd),I=l(g.onLiteralValue),U=l(g.onSeparator),L=v(g.onComment),D=l(g.onError),x=a&&a.disallowComments,N=a&&a.allowTrailingComma;function V(){for(;;){const ce=r.scan();switch(r.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:x||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ce){case 12:case 13:x?W(10):L();break;case 16:W(1);break;case 15:case 14:break;default:return ce}}}function W(ce,Fe=[],Ge=[]){if(D(ce),Fe.length+Ge.length>0){let Ne=r.getToken();for(;Ne!==17;){if(Fe.indexOf(Ne)!==-1){V();break}else if(Ge.indexOf(Ne)!==-1)break;Ne=V()}}}function $(ce){const Fe=r.getTokenValue();return ce?I(Fe):b(Fe),V(),!0}function Z(){switch(r.getToken()){case 11:let ce=0;try{ce=JSON.parse(r.getTokenValue()),typeof ce!="number"&&(W(2),ce=0)}catch(Fe){W(2)}I(ce);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return V(),!0}function j(){return r.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),r.getToken()===6?(U(":"),V(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){c(),V();let ce=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ce||W(4,[],[]),U(","),V(),r.getToken()===2&&N)break}else ce&&W(6,[],[]);j()||W(4,[],[2,5]),ce=!0}return h(),r.getToken()!==2?W(7,[2],[]):V(),!0}function ae(){y(),V();let ce=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ce||W(4,[],[]),U(","),V(),r.getToken()===4&&N)break}else ce&&W(6,[],[]);pe()||W(4,[],[4,5]),ce=!0}return R(),r.getToken()!==4?W(8,[4],[]):V(),!0}function pe(){switch(r.getToken()){case 3:return ae();case 1:return Q();case 10:return $(!0);default:return Z()}}return V(),r.getToken()===17?a.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(r.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=o;function f(i,g){let a=F(i),r=[],v,l=0,c;do switch(c=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:l!==c&&r.push(i.substring(l,c)),g!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,g)),l=a.getPosition();break}while(v!==17);return r.join("")}e.stripComments=f;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(we[103],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new d(()=>E(this.getValue()))}}e.Lazy=d}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,ye){for(var De=0;De<ye.length;De++){var te=ye[De];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Ie,te.key,te)}}function e(Ie,ye,De){return ye&&re(Ie.prototype,ye),De&&re(Ie,De),Ie}function d(Ie,ye){if(!!Ie){if(typeof Ie=="string")return M(Ie,ye);var De=Object.prototype.toString.call(Ie).slice(8,-1);if(De==="Object"&&Ie.constructor&&(De=Ie.constructor.name),De==="Map"||De==="Set")return Array.from(Ie);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Ie,ye)}}function M(Ie,ye){(ye==null||ye>Ie.length)&&(ye=Ie.length);for(var De=0,te=new Array(ye);De<ye;De++)te[De]=Ie[De];return te}function E(Ie,ye){var De=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(De)return(De=De.call(Ie)).next.bind(De);if(Array.isArray(Ie)||(De=d(Ie))||ye&&Ie&&typeof Ie.length=="number"){De&&(Ie=De);var te=0;return function(){return te>=Ie.length?{done:!0}:{done:!1,value:Ie[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Ie){A.exports.defaults=Ie}A.exports={defaults:F(),getDefaults:F,changeDefaults:P};var C=/[&<>"']/,T=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ye){return n[ye]};function s(Ie,ye){if(ye){if(C.test(Ie))return Ie.replace(T,m)}else if(t.test(Ie))return Ie.replace(_,m);return Ie}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(u,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var k=/(^|[^\[])\^/g;function w(Ie,ye){Ie=Ie.source||Ie,ye=ye||"";var De={replace:function(oe,fe){return fe=fe.source||fe,fe=fe.replace(k,"$1"),Ie=Ie.replace(oe,fe),De},getRegex:function(){return new RegExp(Ie,ye)}};return De}var o=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Ie,ye,De){if(Ie){var te;try{te=decodeURIComponent(p(De)).replace(o,"").toLowerCase()}catch(oe){return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ye&&!f.test(De)&&(De=v(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(oe){return null}return De}var i={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ie,ye){i[" "+Ie]||(g.test(Ie)?i[" "+Ie]=Ie+"/":i[" "+Ie]=h(Ie,"/",!0)),Ie=i[" "+Ie];var De=Ie.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Ie.replace(a,"$1")+ye:ye.charAt(0)==="/"?De?ye:Ie.replace(r,"$1")+ye:Ie+ye}var l={exec:function(){}};function c(Ie){for(var ye=1,De,te;ye<arguments.length;ye++){De=arguments[ye];for(te in De)Object.prototype.hasOwnProperty.call(De,te)&&(Ie[te]=De[te])}return Ie}function b(Ie,ye){var De=Ie.replace(/\|/g,function(fe,he,ke){for(var Oe=!1,Me=he;--Me>=0&&ke[Me]==="\\";)Oe=!Oe;return Oe?"|":" |"}),te=De.split(/ \|/),oe=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>ye)te.splice(ye);else for(;te.length<ye;)te.push("");for(;oe<te.length;oe++)te[oe]=te[oe].trim().replace(/\\\|/g,"|");return te}function h(Ie,ye,De){var te=Ie.length;if(te===0)return"";for(var oe=0;oe<te;){var fe=Ie.charAt(te-oe-1);if(fe===ye&&!De)oe++;else if(fe!==ye&&De)oe++;else break}return Ie.substr(0,te-oe)}function y(Ie,ye){if(Ie.indexOf(ye[1])===-1)return-1;for(var De=Ie.length,te=0,oe=0;oe<De;oe++)if(Ie[oe]==="\\")oe++;else if(Ie[oe]===ye[0])te++;else if(Ie[oe]===ye[1]&&(te--,te<0))return oe;return-1}function R(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ie,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Ie),ye>>=1,Ie+=Ie;return De+Ie}var U={escape:s,unescape:p,edit:w,cleanUrl:S,resolveUrl:v,noopTest:l,merge:c,splitCells:b,rtrim:h,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:I},L=A.exports.defaults,D=U.rtrim,x=U.splitCells,N=U.escape,V=U.findClosingBracket;function W(Ie,ye,De,te){var oe=ye.href,fe=ye.title?N(ye.title):null,he=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){te.state.inLink=!0;var ke={type:"link",raw:De,href:oe,title:fe,text:he,tokens:te.inlineTokens(he,[])};return te.state.inLink=!1,ke}else return{type:"image",raw:De,href:oe,title:fe,text:N(he)}}function $(Ie,ye){var De=Ie.match(/^(\s+)(?:```)/);if(De===null)return ye;var te=De[1];return ye.split(`
`).map(function(oe){var fe=oe.match(/^\s+/);if(fe===null)return oe;var he=fe[0];return he.length>=te.length?oe.slice(te.length):oe}).join(`
`)}var Z=function(){function Ie(De){this.options=De||L}var ye=Ie.prototype;return ye.space=function(te){var oe=this.rules.block.newline.exec(te);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},ye.code=function(te){var oe=this.rules.block.code.exec(te);if(oe){var fe=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:D(fe,`
`)}}},ye.fences=function(te){var oe=this.rules.block.fences.exec(te);if(oe){var fe=oe[0],he=$(fe,oe[3]||"");return{type:"code",raw:fe,lang:oe[2]?oe[2].trim():oe[2],text:he}}},ye.heading=function(te){var oe=this.rules.block.heading.exec(te);if(oe){var fe=oe[2].trim();if(/#$/.test(fe)){var he=D(fe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(fe=he.trim())}var ke={type:"heading",raw:oe[0],depth:oe[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ye.hr=function(te){var oe=this.rules.block.hr.exec(te);if(oe)return{type:"hr",raw:oe[0]}},ye.blockquote=function(te){var oe=this.rules.block.blockquote.exec(te);if(oe){var fe=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ye.list=function(te){var oe=this.rules.block.list.exec(te);if(oe){var fe,he,ke,Oe,Me,He,it,Re,ue,me,J=oe[1].trim(),z=J.length>1,ve={type:"list",raw:"",ordered:z,start:z?+J.slice(0,-1):"",loose:!1,items:[]};J=z?"\\d{1,9}\\"+J.slice(-1):"\\"+J,this.options.pedantic&&(J=z?J:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+J+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(oe=Ce.exec(te)));){ue=oe[2].split(`
`),this.options.pedantic?(Oe=2,me=ue[0].trimLeft()):(Oe=oe[2].search(/[^ ]/),Oe=oe[1].length+(Oe>4?1:Oe),me=ue[0].slice(Oe-oe[1].length)),He=!1,fe=oe[0],!ue[0]&&/^ *$/.test(ue[1])&&(fe=oe[1]+ue.slice(0,2).join(`
`)+`
`,ve.loose=!0,ue=[]);var Ye=new RegExp("^ {0,"+Math.min(3,Oe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ue.length;Me++){if(Re=ue[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ye.test(Re)){fe=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}if(!He){Re.trim()||(He=!0),Re.search(/[^ ]/)>=Oe?me+=`
`+Re.slice(Oe):me+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Oe||!Re.trim()){me+=`
`+Re.slice(Oe);continue}else{fe=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}}ve.loose||(it?ve.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(me),he&&(ke=he[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:fe,task:!!he,checked:ke,loose:!1,text:me}),ve.raw+=fe,te=te.slice(fe.length)}ve.items[ve.items.length-1].raw=fe.trimRight(),ve.items[ve.items.length-1].text=me.trimRight(),ve.raw=ve.raw.trimRight();var Le=ve.items.length;for(Me=0;Me<Le;Me++)this.lexer.state.top=!1,ve.items[Me].tokens=this.lexer.blockTokens(ve.items[Me].text,[]),ve.items[Me].tokens.some(function(ct){return ct.type==="space"})&&(ve.loose=!0,ve.items[Me].loose=!0);return ve}},ye.html=function(te){var oe=this.rules.block.html.exec(te);if(oe){var fe={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},ye.def=function(te){var oe=this.rules.block.def.exec(te);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var fe=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:oe[0],href:oe[2],title:oe[3]}}},ye.table=function(te){var oe=this.rules.block.table.exec(te);if(oe){var fe={type:"table",header:x(oe[1]).map(function(it){return{text:it}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=oe[0];var he=fe.align.length,ke,Oe,Me,He;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(he=fe.rows.length,ke=0;ke<he;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(he=fe.header.length,Oe=0;Oe<he;Oe++)fe.header[Oe].tokens=[],this.lexer.inlineTokens(fe.header[Oe].text,fe.header[Oe].tokens);for(he=fe.rows.length,Oe=0;Oe<he;Oe++)for(He=fe.rows[Oe],Me=0;Me<He.length;Me++)He[Me].tokens=[],this.lexer.inlineTokens(He[Me].text,He[Me].tokens);return fe}}},ye.lheading=function(te){var oe=this.rules.block.lheading.exec(te);if(oe){var fe={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.paragraph=function(te){var oe=this.rules.block.paragraph.exec(te);if(oe){var fe={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.text=function(te){var oe=this.rules.block.text.exec(te);if(oe){var fe={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ye.escape=function(te){var oe=this.rules.inline.escape.exec(te);if(oe)return{type:"escape",raw:oe[0],text:N(oe[1])}},ye.tag=function(te){var oe=this.rules.inline.tag.exec(te);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]):oe[0]}},ye.link=function(te){var oe=this.rules.inline.link.exec(te);if(oe){var fe=oe[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var he=D(fe.slice(0,-1),"\\");if((fe.length-he.length)%2==0)return}else{var ke=V(oe[2],"()");if(ke>-1){var Oe=oe[0].indexOf("!")===0?5:4,Me=Oe+oe[1].length+ke;oe[2]=oe[2].substring(0,ke),oe[0]=oe[0].substring(0,Me).trim(),oe[3]=""}}var He=oe[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(He);Re&&(He=Re[1],it=Re[3])}else it=oe[3]?oe[3].slice(1,-1):"";return He=He.trim(),/^</.test(He)&&(this.options.pedantic&&!/>$/.test(fe)?He=He.slice(1):He=He.slice(1,-1)),W(oe,{href:He&&He.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ye.reflink=function(te,oe){var fe;if((fe=this.rules.inline.reflink.exec(te))||(fe=this.rules.inline.nolink.exec(te))){var he=(fe[2]||fe[1]).replace(/\s+/g," ");if(he=oe[he.toLowerCase()],!he||!he.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return W(fe,he,fe[0],this.lexer)}},ye.emStrong=function(te,oe,fe){fe===void 0&&(fe="");var he=this.rules.inline.emStrong.lDelim.exec(te);if(!!he&&!(he[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var Oe=he[0].length-1,Me,He,it=Oe,Re=0,ue=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,oe=oe.slice(-1*te.length+Oe);(he=ue.exec(oe))!=null;)if(Me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Me){if(He=Me.length,he[3]||he[4]){it+=He;continue}else if((he[5]||he[6])&&Oe%3&&!((Oe+He)%3)){Re+=He;continue}if(it-=He,!(it>0)){if(He=Math.min(He,He+it+Re),Math.min(Oe,He)%2){var me=te.slice(1,Oe+he.index+He);return{type:"em",raw:te.slice(0,Oe+he.index+He+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var J=te.slice(2,Oe+he.index+He-1);return{type:"strong",raw:te.slice(0,Oe+he.index+He+1),text:J,tokens:this.lexer.inlineTokens(J,[])}}}}}},ye.codespan=function(te){var oe=this.rules.inline.code.exec(te);if(oe){var fe=oe[2].replace(/\n/g," "),he=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return he&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:oe[0],text:fe}}},ye.br=function(te){var oe=this.rules.inline.br.exec(te);if(oe)return{type:"br",raw:oe[0]}},ye.del=function(te){var oe=this.rules.inline.del.exec(te);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},ye.autolink=function(te,oe){var fe=this.rules.inline.autolink.exec(te);if(fe){var he,ke;return fe[2]==="@"?(he=N(this.options.mangle?oe(fe[1]):fe[1]),ke="mailto:"+he):(he=N(fe[1]),ke=he),{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ye.url=function(te,oe){var fe;if(fe=this.rules.inline.url.exec(te)){var he,ke;if(fe[2]==="@")he=N(this.options.mangle?oe(fe[0]):fe[0]),ke="mailto:"+he;else{var Oe;do Oe=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(Oe!==fe[0]);he=N(fe[0]),fe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ye.inlineText=function(te,oe){var fe=this.rules.inline.text.exec(te);if(fe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:he=N(this.options.smartypants?oe(fe[0]):fe[0]),{type:"text",raw:fe[0],text:he}}},Ie}(),j=U.noopTest,Q=U.edit,ae=U.merge,pe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};pe._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,pe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,pe.def=Q(pe.def).replace("label",pe._label).replace("title",pe._title).getRegex(),pe.bullet=/(?:[*+-]|\d{1,9}[.)])/,pe.listItemStart=Q(/^( *)(bull) */).replace("bull",pe.bullet).getRegex(),pe.list=Q(pe.list).replace(/bull/g,pe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+pe.def.source+")").getRegex(),pe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",pe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,pe.html=Q(pe.html,"i").replace("comment",pe._comment).replace("tag",pe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),pe.paragraph=Q(pe._paragraph).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.blockquote=Q(pe.blockquote).replace("paragraph",pe.paragraph).getRegex(),pe.normal=ae({},pe),pe.gfm=ae({},pe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),pe.gfm.table=Q(pe.gfm.table).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.pedantic=ae({},pe.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",pe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(pe.normal._paragraph).replace("hr",pe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",pe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=Q(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=Q(pe._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=Q(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=Q(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=Q(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=Q(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=Q(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=Q(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=Q(ce.reflink).replace("label",ce._label).getRegex(),ce.reflinkSearch=Q(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=ae({},ce),ce.pedantic=ae({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=ae({},ce.normal,{escape:Q(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=Q(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=ae({},ce.gfm,{br:Q(ce.br).replace("{2,}","*").getRegex(),text:Q(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:pe,inline:ce},Ge=Z,Ne=A.exports.defaults,ze=Fe.block,Je=Fe.inline,Qe=U.repeatString;function Ke(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ie){var ye="",De,te,oe=Ie.length;for(De=0;De<oe;De++)te=Ie.charCodeAt(De),Math.random()>.5&&(te="x"+te.toString(16)),ye+="&#"+te+";";return ye}var K=function(){function Ie(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Ne,this.options.tokenizer=this.options.tokenizer||new Ge,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:ze.normal,inline:Je.normal};this.options.pedantic?(te.block=ze.pedantic,te.inline=Je.pedantic):this.options.gfm&&(te.block=ze.gfm,this.options.breaks?te.inline=Je.breaks:te.inline=Je.gfm),this.tokenizer.rules=te}Ie.lex=function(te,oe){var fe=new Ie(oe);return fe.lex(te)},Ie.lexInline=function(te,oe){var fe=new Ie(oe);return fe.inlineTokens(te)};var ye=Ie.prototype;return ye.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ye.blockTokens=function(te,oe){var fe=this;oe===void 0&&(oe=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var he,ke,Oe,Me;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(he=it.call({lexer:fe},te,oe))?(te=te.substring(he.raw.length),oe.push(he),!0):!1}))){if(he=this.tokenizer.space(te)){te=te.substring(he.raw.length),he.type&&oe.push(he);continue}if(he=this.tokenizer.code(te)){te=te.substring(he.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he);continue}if(he=this.tokenizer.fences(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.heading(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.hr(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.blockquote(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.list(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.html(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.def(te)){te=te.substring(he.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.lheading(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(Oe=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=te.slice(1),ue=void 0;fe.options.extensions.startBlock.forEach(function(me){ue=me.call({lexer:this},Re),typeof ue=="number"&&ue>=0&&(it=Math.min(it,ue))}),it<Infinity&&it>=0&&(Oe=te.substring(0,it+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Oe))){ke=oe[oe.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he),Me=Oe.length!==te.length,te=te.substring(he.raw.length);continue}if(he=this.tokenizer.text(te)){te=te.substring(he.raw.length),ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(he);continue}if(te){var He="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return this.state.top=!0,oe},ye.inline=function(te,oe){this.inlineQueue.push({src:te,tokens:oe})},ye.inlineTokens=function(te,oe){var fe=this;oe===void 0&&(oe=[]);var he,ke,Oe,Me=te,He,it,Re;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(He=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ue.includes(He[0].slice(He[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,He.index)+"["+Qe("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(He=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,He.index)+"["+Qe("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(He=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,He.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(he=J.call({lexer:fe},te,oe))?(te=te.substring(he.raw.length),oe.push(he),!0):!1}))){if(he=this.tokenizer.escape(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.tag(te)){te=te.substring(he.raw.length),ke=oe[oe.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(he=this.tokenizer.link(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(he.raw.length),ke=oe[oe.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(he=this.tokenizer.emStrong(te,Me,Re)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.codespan(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.br(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.del(te)){te=te.substring(he.raw.length),oe.push(he);continue}if(he=this.tokenizer.autolink(te,H)){te=te.substring(he.raw.length),oe.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(te,H))){te=te.substring(he.raw.length),oe.push(he);continue}if(Oe=te,this.options.extensions&&this.options.extensions.startInline&&function(){var J=Infinity,z=te.slice(1),ve=void 0;fe.options.extensions.startInline.forEach(function(Ce){ve=Ce.call({lexer:this},z),typeof ve=="number"&&ve>=0&&(J=Math.min(J,ve))}),J<Infinity&&J>=0&&(Oe=te.substring(0,J+1))}(),he=this.tokenizer.inlineText(Oe,Ke)){te=te.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Re=he.raw.slice(-1)),it=!0,ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):oe.push(he);continue}if(te){var me="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return oe},e(Ie,null,[{key:"rules",get:function(){return{block:ze,inline:Je}}}]),Ie}(),ee=A.exports.defaults,se=U.cleanUrl,G=U.escape,ne=function(){function Ie(De){this.options=De||ee}var ye=Ie.prototype;return ye.code=function(te,oe,fe){var he=(oe||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(te,he);ke!=null&&ke!==te&&(fe=!0,te=ke)}return te=te.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+G(he,!0)+'">'+(fe?te:G(te,!0))+`</code></pre>
`:"<pre><code>"+(fe?te:G(te,!0))+`</code></pre>
`},ye.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ye.html=function(te){return te},ye.heading=function(te,oe,fe,he){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+he.slug(fe)+'">'+te+"</h"+oe+`>
`:"<h"+oe+">"+te+"</h"+oe+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(te,oe,fe){var he=oe?"ol":"ul",ke=oe&&fe!==1?' start="'+fe+'"':"";return"<"+he+ke+`>
`+te+"</"+he+`>
`},ye.listitem=function(te){return"<li>"+te+`</li>
`},ye.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(te){return"<p>"+te+`</p>
`},ye.table=function(te,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+oe+`</table>
`},ye.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ye.tablecell=function(te,oe){var fe=oe.header?"th":"td",he=oe.align?"<"+fe+' align="'+oe.align+'">':"<"+fe+">";return he+te+"</"+fe+`>
`},ye.strong=function(te){return"<strong>"+te+"</strong>"},ye.em=function(te){return"<em>"+te+"</em>"},ye.codespan=function(te){return"<code>"+te+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(te){return"<del>"+te+"</del>"},ye.link=function(te,oe,fe){if(te=se(this.options.sanitize,this.options.baseUrl,te),te===null)return fe;var he='<a href="'+G(te)+'"';return oe&&(he+=' title="'+oe+'"'),he+=">"+fe+"</a>",he},ye.image=function(te,oe,fe){if(te=se(this.options.sanitize,this.options.baseUrl,te),te===null)return fe;var he='<img src="'+te+'" alt="'+fe+'"';return oe&&(he+=' title="'+oe+'"'),he+=this.options.xhtml?"/>":">",he},ye.text=function(te){return te},Ie}(),de=function(){function Ie(){}var ye=Ie.prototype;return ye.strong=function(te){return te},ye.em=function(te){return te},ye.codespan=function(te){return te},ye.del=function(te){return te},ye.html=function(te){return te},ye.text=function(te){return te},ye.link=function(te,oe,fe){return""+fe},ye.image=function(te,oe,fe){return""+fe},ye.br=function(){return""},Ie}(),Te=function(){function Ie(){this.seen={}}var ye=Ie.prototype;return ye.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(te,oe){var fe=te,he=0;if(this.seen.hasOwnProperty(fe)){he=this.seen[te];do he++,fe=te+"-"+he;while(this.seen.hasOwnProperty(fe))}return oe||(this.seen[te]=he,this.seen[fe]=0),fe},ye.slug=function(te,oe){oe===void 0&&(oe={});var fe=this.serialize(te);return this.getNextSafeSlug(fe,oe.dryrun)},Ie}(),xe=ne,$e=de,je=Te,et=A.exports.defaults,st=U.unescape,_e=function(){function Ie(De){this.options=De||et,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new je}Ie.parse=function(te,oe){var fe=new Ie(oe);return fe.parse(te)},Ie.parseInline=function(te,oe){var fe=new Ie(oe);return fe.parseInline(te)};var ye=Ie.prototype;return ye.parse=function(te,oe){oe===void 0&&(oe=!0);var fe="",he,ke,Oe,Me,He,it,Re,ue,me,J,z,ve,Ce,Ye,Le,ct,pt,dt,ht,ft=te.length;for(he=0;he<ft;he++){if(J=te[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(ht=this.options.extensions.renderers[J.type].call({parser:this},J),ht!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){fe+=ht||"";continue}switch(J.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(J.tokens),J.depth,st(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(ue="",Re="",Me=J.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(J.header[ke].tokens),{header:!0,align:J.align[ke]});for(ue+=this.renderer.tablerow(Re),me="",Me=J.rows.length,ke=0;ke<Me;ke++){for(it=J.rows[ke],Re="",He=it.length,Oe=0;Oe<He;Oe++)Re+=this.renderer.tablecell(this.parseInline(it[Oe].tokens),{header:!1,align:J.align[Oe]});me+=this.renderer.tablerow(Re)}fe+=this.renderer.table(ue,me);continue}case"blockquote":{me=this.parse(J.tokens),fe+=this.renderer.blockquote(me);continue}case"list":{for(z=J.ordered,ve=J.start,Ce=J.loose,Me=J.items.length,me="",ke=0;ke<Me;ke++)Le=J.items[ke],ct=Le.checked,pt=Le.task,Ye="",Le.task&&(dt=this.renderer.checkbox(ct),Ce?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=dt+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=dt+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:dt}):Ye+=dt),Ye+=this.parse(Le.tokens,Ce),me+=this.renderer.listitem(Ye,pt,ct);fe+=this.renderer.list(me,z,ve);continue}case"html":{fe+=this.renderer.html(J.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(me=J.tokens?this.parseInline(J.tokens):J.text;he+1<ft&&te[he+1].type==="text";)J=te[++he],me+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);fe+=oe?this.renderer.paragraph(me):me;continue}default:{var _t='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return fe},ye.parseInline=function(te,oe){oe=oe||this.renderer;var fe="",he,ke,Oe,Me=te.length;for(he=0;he<Me;he++){if(ke=te[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Oe=this.options.extensions.renderers[ke.type].call({parser:this},ke),Oe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=Oe||"";continue}switch(ke.type){case"escape":{fe+=oe.text(ke.text);break}case"html":{fe+=oe.html(ke.text);break}case"link":{fe+=oe.link(ke.href,ke.title,this.parseInline(ke.tokens,oe));break}case"image":{fe+=oe.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=oe.strong(this.parseInline(ke.tokens,oe));break}case"em":{fe+=oe.em(this.parseInline(ke.tokens,oe));break}case"codespan":{fe+=oe.codespan(ke.text);break}case"br":{fe+=oe.br();break}case"del":{fe+=oe.del(this.parseInline(ke.tokens,oe));break}case"text":{fe+=oe.text(ke.text);break}default:{var He='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return fe},Ie}(),nt=K,q=_e,X=Z,ge=ne,Ue=de,qe=Te,rt=U.merge,mt=U.checkSanitizeDeprecation,ut=U.escape,St=A.exports.getDefaults,Tt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Ie,ye,De){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=rt({},Xe.defaults,ye||{}),mt(ye),De){var te=ye.highlight,oe;try{oe=nt.lex(Ie,ye)}catch(Oe){return De(Oe)}var fe=function(Me){var He;if(!Me)try{ye.walkTokens&&Xe.walkTokens(oe,ye.walkTokens),He=q.parse(oe,ye)}catch(it){Me=it}return ye.highlight=te,Me?De(Me):De(null,He)};if(!te||te.length<3||(delete ye.highlight,!oe.length))return fe();var he=0;Xe.walkTokens(oe,function(Oe){Oe.type==="code"&&(he++,setTimeout(function(){te(Oe.text,Oe.lang,function(Me,He){if(Me)return fe(Me);He!=null&&He!==Oe.text&&(Oe.text=He,Oe.escaped=!0),he--,he===0&&fe()})},0))}),he===0&&fe();return}try{var ke=nt.lex(Ie,ye);return ye.walkTokens&&Xe.walkTokens(ke,ye.walkTokens),q.parse(ke,ye)}catch(Oe){if(Oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ut(Oe.message+"",!0)+"</pre>";throw Oe}}Xe.options=Xe.setOptions=function(Ie){return rt(Xe.defaults,Ie),Tt(Xe.defaults),Xe},Xe.getDefaults=St,Xe.defaults=It,Xe.use=function(){for(var Ie=this,ye=arguments.length,De=new Array(ye),te=0;te<ye;te++)De[te]=arguments[te];var oe=rt.apply(void 0,[{}].concat(De)),fe=Xe.defaults.extensions||{renderers:{},childTokens:{}},he;De.forEach(function(ke){if(ke.extensions&&(he=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var He=fe.renderers?fe.renderers[Me.name]:null;He?fe.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),ue=0;ue<it;ue++)Re[ue]=arguments[ue];var me=Me.renderer.apply(this,Re);return me===!1&&(me=He.apply(this,Re)),me}:fe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Me.level]?fe[Me.level].unshift(Me.tokenizer):fe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?fe.startBlock?fe.startBlock.push(Me.start):fe.startBlock=[Me.start]:Me.level==="inline"&&(fe.startInline?fe.startInline.push(Me.start):fe.startInline=[Me.start]))}Me.childTokens&&(fe.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Xe.defaults.renderer||new ge,He=function(ue){var me=Me[ue];Me[ue]=function(){for(var J=arguments.length,z=new Array(J),ve=0;ve<J;ve++)z[ve]=arguments[ve];var Ce=ke.renderer[ue].apply(Me,z);return Ce===!1&&(Ce=me.apply(Me,z)),Ce}};for(var it in ke.renderer)He(it);oe.renderer=Me}(),ke.tokenizer&&function(){var Me=Xe.defaults.tokenizer||new X,He=function(ue){var me=Me[ue];Me[ue]=function(){for(var J=arguments.length,z=new Array(J),ve=0;ve<J;ve++)z[ve]=arguments[ve];var Ce=ke.tokenizer[ue].apply(Me,z);return Ce===!1&&(Ce=me.apply(Me,z)),Ce}};for(var it in ke.tokenizer)He(it);oe.tokenizer=Me}(),ke.walkTokens){var Oe=Xe.defaults.walkTokens;oe.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Oe&&Oe(Me)}}he&&(oe.extensions=fe),Xe.setOptions(oe)})},Xe.walkTokens=function(Ie,ye){for(var De=function(){var he=oe.value;switch(ye(he),he.type){case"table":{for(var ke=E(he.header),Oe;!(Oe=ke()).done;){var Me=Oe.value;Xe.walkTokens(Me.tokens,ye)}for(var He=E(he.rows),it;!(it=He()).done;)for(var Re=it.value,ue=E(Re),me;!(me=ue()).done;){var J=me.value;Xe.walkTokens(J.tokens,ye)}break}case"list":{Xe.walkTokens(he.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[he.type]?Xe.defaults.extensions.childTokens[he.type].forEach(function(z){Xe.walkTokens(he[z],ye)}):he.tokens&&Xe.walkTokens(he.tokens,ye)}},te=E(Ie),oe;!(oe=te()).done;)De()},Xe.parseInline=function(Ie,ye){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ye=rt({},Xe.defaults,ye||{}),mt(ye);try{var De=nt.lexInline(Ie,ye);return ye.walkTokens&&Xe.walkTokens(De,ye.walkTokens),q.parseInline(De,ye)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ut(te.message+"",!0)+"</pre>";throw te}},Xe.Parser=q,Xe.parser=q.parse,Xe.Renderer=ge,Xe.TextRenderer=Ue,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=X,Xe.Slugger=qe,Xe.parse=Xe;var vt=Xe;return vt}),define(we[76],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(F,P,C){return Math.min(Math.max(F,P),C)}e.clamp=d;function M(F,P){return(P+F%P)%P}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function re(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function F(C){A.push(C,Date.now())}function P(){const C=[];for(let T=0;T<A.length;T+=2)C.push({name:A[T],startTime:A[T+1]});return C}return{mark:F,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(E+F.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function d(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=d(M))}(),define(we[34],be([0,1,3]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new d.Emitter}add(_){const n=this._icons.get(_.id);n?_.description?n.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,_){return new P(t,_)}e.registerCodicon=A;function F(t){return t?t.replace(/\$\((.*?)\)/g,(_,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class P{constructor(_,n,m){this.id=_,this.definition=n,this.description=m,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function C(t,_){const n=["codicon","codicon-"+t];return _&&n.push("codicon-modifier-"+_),n}e.getClassNamesArray=C;var T;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof P)return["codicon","codicon-"+u.id];const p=_.exec(u.id);if(!p)return n(P.error);let[,k,w]=p;const o=["codicon","codicon-"+k];return w&&o.push("codicon-modifier-"+w.substr(1)),o}t.asClassNameArray=n;function m(u){return n(u).join(" ")}t.asClassName=m;function s(u){return"."+n(u).join(".")}t.asCSSSelector=s})(T=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"})}(P=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,16,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const f=o;return f?[f.on,f.pause,f.resume,f.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=E;function A(o){const f=o;return f?E(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=A;function F(o,f){return new P(o,f)}e.newWriteableStream=F;class P{constructor(f,S){this.reducer=f,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(S=>S(f))}emitError(f){this.listeners.error.length===0?(0,d.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(S=>S(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,S){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(f,S){if(this.state.destroyed)return;let i;switch(f){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const g=i.indexOf(S);g>=0&&i.splice(g,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,f){const S=[];let i;for(;(i=o.read())!==null;)S.push(i);return f(S)}e.consumeReadable=C;function T(o,f,S){const i=[];let g;for(;(g=o.read())!==null&&i.length<S;)i.push(g);return g===null&&i.length>0?f(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g!="undefined"){const a=g;return g=void 0,a}return o.read()}}}e.peekReadable=T;function t(o,f){return new Promise((S,i)=>{const g=[];_(o,{onData:a=>{f&&g.push(a)},onError:a=>{f?i(a):S(void 0)},onEnd:()=>{S(f?f(g):void 0)}})})}e.consumeStream=t;function _(o,f){o.on("error",S=>f.onError(S)),o.on("end",()=>f.onEnd()),o.on("data",S=>f.onData(S))}e.listenStream=_;function n(o,f){return new Promise((S,i)=>{const g=new M.DisposableStore,a=[],r=c=>{if(a.push(c),a.length>f)return g.dispose(),o.pause(),S({stream:o,buffer:a,ended:!1})},v=c=>i(c),l=()=>S({stream:o,buffer:a,ended:!0});g.add((0,M.toDisposable)(()=>o.removeListener("error",v))),o.on("error",v),g.add((0,M.toDisposable)(()=>o.removeListener("end",l))),o.on("end",l),g.add((0,M.toDisposable)(()=>o.removeListener("data",r))),o.on("data",r)})}e.peekStream=n;function m(o,f){const S=F(f);return S.end(o),S}e.toStream=m;function s(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function u(o){let f=!1;return{read:()=>f?null:(f=!0,o)}}e.toReadable=u;function p(o,f,S){const i=F(S);return _(o,{onData:g=>i.write(f.data(g)),onError:g=>i.error(f.error?f.error(g):g),onEnd:()=>i.end()}),i}e.transform=p;function k(o,f,S){let i=!1;return{read:()=>{const g=f.read();return i?g:(i=!0,g!==null?S([o,g]):o)}}}e.prefixedReadable=k;function w(o,f,S){let i=!1;const g=F(S);return _(f,{onData:a=>i?g.write(a):(i=!0,g.write(S([o,a]))),onError:a=>g.error(a),onEnd:()=>{i||(i=!0,g.write(o)),g.end()}}),g}e.prefixedStream=w}),define(we[22],be([0,1,104]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return M?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return M&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,v){return!(v?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(r)):(E||(E=new TextEncoder),new F(E.encode(r)))}static concat(r,v){if(typeof v=="undefined"){v=0;for(let b=0,h=r.length;b<h;b++)v+=r[b].byteLength}const l=F.alloc(v);let c=0;for(let b=0,h=r.length;b<h;b++){const y=r[b];l.set(y,c),c+=y.byteLength}return l}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,v){return new F(this.buffer.subarray(r,v))}set(r,v){r instanceof F?this.buffer.set(r.buffer,v):this.buffer.set(r,v)}readUInt32BE(r){return T(this.buffer,r)}writeUInt32BE(r,v){t(this.buffer,r,v)}readUInt32LE(r){return _(this.buffer,r)}writeUInt32LE(r,v){n(this.buffer,r,v)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,v){s(this.buffer,r,v)}}e.VSBuffer=F;function P(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}e.readUInt16LE=P;function C(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255}e.writeUInt16LE=C;function T(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}e.readUInt32BE=T;function t(a,r,v){a[v+3]=r,r=r>>>8,a[v+2]=r,r=r>>>8,a[v+1]=r,r=r>>>8,a[v]=r}e.writeUInt32BE=t;function _(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}e.readUInt32LE=_;function n(a,r,v){a[v+0]=r&255,r=r>>>8,a[v+1]=r&255,r=r>>>8,a[v+2]=r&255,r=r>>>8,a[v+3]=r&255}e.writeUInt32LE=n;function m(a,r){return a[r]}e.readUInt8=m;function s(a,r,v){a[v]=r}e.writeUInt8=s;function u(a){return d.consumeReadable(a,r=>F.concat(r))}e.readableToBuffer=u;function p(a){return d.toReadable(a)}e.bufferToReadable=p;function k(a){return d.consumeStream(a,r=>F.concat(r))}e.streamToBuffer=k;async function w(a){return a.ended?F.concat(a.buffer):F.concat([...a.buffer,await k(a.stream)])}e.bufferedStreamToBuffer=w;function o(a){return d.toStream(a,r=>F.concat(r))}e.bufferToStream=o;function f(a){return d.transform(a,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}e.streamToBufferReadableStream=f;function S(a){return d.newWriteableStream(r=>F.concat(r),a)}e.newWriteableBufferStream=S;function i(a,r){return d.prefixedReadable(a,r,v=>F.concat(v))}e.prefixedBufferReadable=i;function g(a,r){return d.prefixedStream(a,r,v=>F.concat(v))}e.prefixedBufferStream=g});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[20],be([0,1,15,9]),function(re,e,d,M){"use strict";var E,A,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(a,r,v){let l=a.get(r);return l===void 0&&(l=v,a.set(r,l)),l}e.getOrSet=P;function C(a){const r=[];return a.forEach((v,l)=>{r.push(`${l} => ${v}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=C;function T(a){const r=[];return a.forEach(v=>{r.push(v)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=T;class t{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return v-l}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(m||(m={}));class s{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(p||(p={}));class k{constructor(r){this._iter=r}static forUris(r=()=>!1){return new k(new s(r))}static forPaths(){return new k(new n)}static forStrings(){return new k(new t)}static forConfigKeys(){return new k(new _)}clear(){this._root=void 0}fill(r,v){if(v){const l=v.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c,r)}else{const l=r.slice(0);(0,d.shuffle)(l);for(let c of l)this.set(c[0],c[1])}}set(r,v){const l=this._iter.reset(r);let c;this._root||(this._root=new u,this._root.segment=l.value());const b=[];for(c=this._root;;){const y=l.cmp(c.segment);if(y>0)c.left||(c.left=new u,c.left.segment=l.value()),b.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new u,c.right.segment=l.value()),b.push([1,c]),c=c.right;else if(l.hasNext())l.next(),c.mid||(c.mid=new u,c.mid.segment=l.value()),b.push([0,c]),c=c.mid;else break}const h=c.value;c.value=v,c.key=r;for(let y=b.length-1;y>=0;y--){const R=b[y][1];R.updateHeight();const I=R.balanceFactor();if(I<-1||I>1){const U=b[y][0],L=b[y+1][0];if(U===1&&L===1)b[y][1]=R.rotateLeft();else if(U===-1&&L===-1)b[y][1]=R.rotateRight();else if(U===1&&L===-1)R.right=b[y+1][1]=b[y+1][1].rotateRight(),b[y][1]=R.rotateLeft();else if(U===-1&&L===1)R.left=b[y+1][1]=b[y+1][1].rotateLeft(),b[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(b[y-1][0]){case-1:b[y-1][1].left=b[y][1];break;case 1:b[y-1][1].right=b[y][1];break;case 0:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}return h}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else break}return l}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const l=this._iter.reset(r),c=[];let b=this._root;for(;b;){const h=l.cmp(b.segment);if(h>0)c.push([-1,b]),b=b.left;else if(h<0)c.push([1,b]),b=b.right;else if(l.hasNext())l.next(),c.push([0,b]),b=b.mid;else break}if(!!b){if(v?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const h=this._min(b.right),{key:y,value:R,segment:I}=h;this._delete(h.key,!1),b.key=y,b.value=R,b.segment=I}else{const h=b.left??b.right;if(c.length>0){const[y,R]=c[c.length-1];switch(y){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const y=c[h][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=c[h+1][1]=c[h+1][1].rotateRight()),c[h][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=c[h+1][1]=c[h+1][1].rotateLeft()),c[h][1]=y.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let l=this._root,c;for(;l;){const b=v.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(v.hasNext())v.next(),c=l.value||c,l=l.mid;else break}return l&&l.value||c}findSuperstr(r){const v=this._iter.reset(r);let l=this._root;for(;l;){const c=v.cmp(l.segment);if(c>0)l=l.left;else if(c<0)l=l.right;else if(v.hasNext())v.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[v,l]of this)r(l,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=v=>{if(!v)return!0;const l=v.balanceFactor();return l<-1||l>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}e.TernarySearchTree=k;class w{constructor(r,v){this.uri=r,this.value=v}}class o{constructor(r,v){this[E]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=v??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),new w(r,v)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v!="undefined"&&(r=r.bind(v));for(let[l,c]of this.map)r(c.value,c.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=o,o.defaultToKey=a=>a.toString();var f;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class S{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const l=this._map.get(r);if(!!l)return v!==0&&this.touch(l,v),l.value}set(r,v,l=0){let c=this._map.get(r);if(c)c.value=v,l!==0&&this.touch(c,l);else{switch(c={key:r,value:v,next:void 0,previous:void 0},l){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const l=this._state;let c=this._head;for(;c;){if(v?r.bind(v)(c.value,c.key,this):r(c.value,c.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}values(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}entries(){const r=this,v=this._state;let l=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,l=this.size;for(;v&&l>r;)this._map.delete(v.key),v=v.next,l--;this._head=v,this._size=l,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,l=r.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const l=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(l.previous=c,c.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const l=r.next,c=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=c,c.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,l)=>{r.push([l,v])}),r}fromJSON(r){this.clear();for(const[v,l]of r)this.set(v,l)}}e.LinkedMap=S;class i extends S{constructor(r,v=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class g{constructor(r){F.set(this,void 0),Ze(this,F,r,"f")}get size(){return Ae(this,F,"f").size}forEach(r,v){Ae(this,F,"f").forEach(r,v)}get(r){return Ae(this,F,"f").get(r)}has(r){return Ae(this,F,"f").has(r)}entries(){return Ae(this,F,"f").entries()}keys(){return Ae(this,F,"f").keys()}values(){return Ae(this,F,"f").values()}[(F=new WeakMap,Symbol.iterator)](){return Ae(this,F,"f").entries()}}e.ReadonlyMapView=g}),define(we[105],be([0,1,20,9]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...G){return function(ne,de){for(let Te=0,xe=G.length;Te<xe;Te++){const $e=G[Te](ne,de);if($e)return $e}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,ne,de){if(!de||de.length<ne.length)return null;let Te;return G?Te=M.startsWithIgnoreCase(de,ne):Te=de.indexOf(ne)===0,Te?ne.length>0?[{start:0,end:ne.length}]:[]:null}function F(G,ne){const de=ne.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=F;function P(G,ne){return C(G.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=P;function C(G,ne,de,Te){if(de===G.length)return[];if(Te===ne.length)return null;if(G[de]===ne[Te]){let xe=null;return(xe=C(G,ne,de+1,Te+1))?k({start:Te,end:Te+1},xe):null}return C(G,ne,de,Te+1)}function T(G){return 97<=G&&G<=122}function t(G){return 65<=G&&G<=90}e.isUpper=t;function _(G){return 48<=G&&G<=57}function n(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function s(G){return n(G)||m.has(G)}function u(G,ne){return G===ne||s(G)&&s(ne)}function p(G){return T(G)||t(G)||_(G)}function k(G,ne){return ne.length===0?ne=[G]:G.end===ne[0].start?ne[0].start=G.start:ne.unshift(G),ne}function w(G,ne){for(let de=ne;de<G.length;de++){const Te=G.charCodeAt(de);if(t(Te)||_(Te)||de>0&&!p(G.charCodeAt(de-1)))return de}return G.length}function o(G,ne,de,Te){if(de===G.length)return[];if(Te===ne.length)return null;if(G[de]!==ne[Te].toLowerCase())return null;{let xe=null,$e=Te+1;for(xe=o(G,ne,de+1,Te+1);!xe&&($e=w(ne,$e))<ne.length;)xe=o(G,ne,de+1,$e),$e++;return xe===null?null:k({start:Te,end:Te+1},xe)}}function f(G){let ne=0,de=0,Te=0,xe=0,$e=0;for(let nt=0;nt<G.length;nt++)$e=G.charCodeAt(nt),t($e)&&ne++,T($e)&&de++,p($e)&&Te++,_($e)&&xe++;const je=ne/G.length,et=de/G.length,st=Te/G.length,_e=xe/G.length;return{upperPercent:je,lowerPercent:et,alphaPercent:st,numericPercent:_e}}function S(G){const{upperPercent:ne,lowerPercent:de}=G;return de===0&&ne>.6}function i(G){const{upperPercent:ne,lowerPercent:de,alphaPercent:Te,numericPercent:xe}=G;return de>.2&&ne<.8&&Te>.6&&xe<.2}function g(G){let ne=0,de=0,Te=0,xe=0;for(let $e=0;$e<G.length;$e++)Te=G.charCodeAt($e),t(Te)&&ne++,T(Te)&&de++,n(Te)&&xe++;return(ne===0||de===0)&&xe===0?G.length<=30:ne<=5}function a(G,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!g(G)||ne.length>60)return null;const de=f(ne);if(!i(de)){if(!S(de))return null;ne=ne.toLowerCase()}let Te=null,xe=0;for(G=G.toLowerCase();xe<ne.length&&(Te=o(G,ne,0,xe))===null;)xe=w(ne,xe+1);return Te}e.matchesCamelCase=a;function r(G,ne,de=!1){if(!ne||ne.length===0)return null;let Te=null,xe=0;for(G=G.toLowerCase(),ne=ne.toLowerCase();xe<ne.length&&(Te=v(G,ne,0,xe,de))===null;)xe=l(ne,xe+1);return Te}e.matchesWords=r;function v(G,ne,de,Te,xe){if(de===G.length)return[];if(Te===ne.length)return null;if(u(G.charCodeAt(de),ne.charCodeAt(Te))){let $e=null,je=Te+1;if($e=v(G,ne,de+1,Te+1,xe),!xe)for(;!$e&&(je=l(ne,je))<ne.length;)$e=v(G,ne,de+1,je,xe),je++;return $e===null?null:k({start:Te,end:Te+1},$e)}else return null}function l(G,ne){for(let de=ne;de<G.length;de++)if(s(G.charCodeAt(de))||de>0&&s(G.charCodeAt(de-1)))return de;return G.length}const c=E(e.matchesPrefix,a,F),b=E(e.matchesPrefix,a,P),h=new d.LRUCache(1e4);function y(G,ne,de=!1){if(typeof G!="string"||typeof ne!="string")return null;let Te=h.get(G);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(G),"i"),h.set(G,Te));const xe=Te.exec(ne);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:de?b(G,ne):c(G,ne)}e.matchesFuzzy=y;function R(G,ne){const de=Je(G,G.toLowerCase(),0,ne,ne.toLowerCase(),0,!0);return de?U(de):null}e.matchesFuzzy2=R;function I(G,ne,de,Te,xe,$e){const je=Math.min(13,G.length);for(;de<je;de++){const et=Je(G,ne,de,Te,xe,$e,!1);if(et)return et}return[0,$e]}e.anyScore=I;function U(G){if(typeof G=="undefined")return[];const ne=[],de=G[1];for(let Te=G.length-1;Te>1;Te--){const xe=G[Te]+de,$e=ne[ne.length-1];$e&&$e.end===xe?$e.end=xe+1:ne.push({start:xe,end:xe+1})}return ne}e.createMatches=U;const L=128;function D(){const G=[],ne=[];for(let de=0;de<=L;de++)ne[de]=0;for(let de=0;de<=L;de++)G.push(ne.slice(0));return G}function x(G){const ne=[];for(let de=0;de<=G;de++)ne[de]=0;return ne}const N=x(2*L),V=x(2*L),W=D(),$=D(),Z=D(),j=!1;function Q(G,ne,de,Te,xe){function $e(et,st,_e=" "){for(;et.length<st;)et=_e+et;return et}let je=` |   |${Te.split("").map(et=>$e(et,3)).join("|")}
`;for(let et=0;et<=de;et++)et===0?je+=" |":je+=`${ne[et-1]}|`,je+=G[et].slice(0,xe+1).map(st=>$e(st.toString(),3)).join("|")+`
`;return je}function ae(G,ne,de,Te){G=G.substr(ne),de=de.substr(Te),console.log(Q($,G,G.length,de,de.length)),console.log(Q(Z,G,G.length,de,de.length)),console.log(Q(W,G,G.length,de,de.length))}function pe(G,ne){if(ne<0||ne>=G.length)return!1;const de=G.codePointAt(ne);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(de)}}function ce(G,ne){if(ne<0||ne>=G.length)return!1;switch(G.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function Fe(G,ne,de){return ne[G]!==de[G]}function Ge(G,ne,de,Te,xe,$e,je=!1){for(;ne<de&&xe<$e;)G[ne]===Te[xe]&&(je&&(N[ne]=xe),ne+=1),xe+=1;return ne===de}e.isPatternInWord=Ge;var Ne;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Ne||(Ne={}));var ze;(function(G){G.Default=[-100,0];function ne(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=ne})(ze=e.FuzzyScore||(e.FuzzyScore={}));function Je(G,ne,de,Te,xe,$e,je){const et=G.length>L?L:G.length,st=Te.length>L?L:Te.length;if(de>=et||$e>=st||et-de>st-$e||!Ge(ne,de,et,xe,$e,st,!0))return;Qe(et,st,de,$e,ne,xe);let _e=1,nt=1,q=de,X=$e;const ge=[!1];for(_e=1,q=de;q<et;_e++,q++){const ut=N[q],St=V[q],Tt=q+1<et?V[q+1]:st;for(nt=ut-$e+1,X=ut;X<Tt;nt++,X++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;X<=St&&(It=Ke(G,ne,q,de,Te,xe,X,st,$e,W[_e-1][nt-1]===0,ge));let vt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,vt=It+$[_e-1][nt-1]);const Ie=X>ut,ye=Ie?$[_e][nt-1]+(W[_e][nt-1]>0?-5:0):0,De=X>ut+1&&W[_e][nt-1]>0,te=De?$[_e][nt-2]+(W[_e][nt-2]>0?-5:0):0;if(De&&(!Ie||te>=ye)&&(!Xe||te>=vt))$[_e][nt]=te,Z[_e][nt]=3,W[_e][nt]=0;else if(Ie&&(!Xe||ye>=vt))$[_e][nt]=ye,Z[_e][nt]=2,W[_e][nt]=0;else if(Xe)$[_e][nt]=vt,Z[_e][nt]=1,W[_e][nt]=W[_e-1][nt-1]+1;else throw new Error("not possible")}}if(j&&ae(G,de,Te,$e),!ge[0]&&!je)return;_e--,nt--;const Ue=[$[_e][nt],$e];let qe=0,rt=0;for(;_e>=1;){let ut=nt;do{const St=Z[_e][ut];if(St===3)ut=ut-2;else if(St===2)ut=ut-1;else break}while(ut>=1);qe>1&&ne[de+_e-1]===xe[$e+nt-1]&&!Fe(ut+$e-1,Te,xe)&&qe+1>W[_e][ut]&&(ut=nt),ut===nt?qe++:qe=1,rt||(rt=ut),_e--,nt=ut-1,Ue.push(nt)}st===et&&(Ue[0]+=2);const mt=rt-et;return Ue[0]-=mt,Ue}e.fuzzyScore=Je;function Qe(G,ne,de,Te,xe,$e){let je=G-1,et=ne-1;for(;je>=de&&et>=Te;)xe[je]===$e[et]&&(V[je]=et,je--),et--}function Ke(G,ne,de,Te,xe,$e,je,et,st,_e,nt){if(ne[de]!==$e[je])return Number.MIN_SAFE_INTEGER;let q=1,X=!1;return je===de-Te?q=G[de]===xe[je]?7:5:Fe(je,xe,$e)&&(je===0||!Fe(je-1,xe,$e))?(q=G[de]===xe[je]?7:5,X=!0):pe($e,je)&&(je===0||!pe($e,je-1))?q=5:(pe($e,je-1)||ce($e,je-1))&&(q=5,X=!0),q>1&&de===Te&&(nt[0]=!0),X||(X=Fe(je,xe,$e)||pe($e,je-1)||ce($e,je-1)),de===Te?je>st&&(q-=X?3:5):_e?q+=X?2:0:q+=X?0:1,je+1===et&&(q-=X?3:5),q}function H(G,ne,de,Te,xe,$e,je){return ee(G,ne,de,Te,xe,$e,!0,je)}e.fuzzyScoreGracefulAggressive=H;function K(G,ne,de,Te,xe,$e,je){return ee(G,ne,de,Te,xe,$e,!1,je)}e.fuzzyScoreGraceful=K;function ee(G,ne,de,Te,xe,$e,je,et){let st=Je(G,ne,de,Te,xe,$e,et);if(st&&!je)return st;if(G.length>=3){const _e=Math.min(7,G.length-1);for(let nt=de+1;nt<_e;nt++){const q=se(G,nt);if(q){const X=Je(q,q.toLowerCase(),de,Te,xe,$e,et);X&&(X[0]-=3,(!st||X[0]>st[0])&&(st=X))}}}return st}function se(G,ne){if(ne+1>=G.length)return;const de=G[ne],Te=G[ne+1];if(de!==Te)return G.slice(0,ne)+Te+de+G.slice(ne+2)}}),define(we[106],be([0,1,34,105,9]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${A.source}`,"g");function P(u){return u.replace(F,(p,k)=>k?p:`\\${p}`)}e.escapeIcons=P;const C=new RegExp(`\\\\${A.source}`,"g");function T(u){return u.replace(C,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=T;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(p,k,w,o)=>w?p:k||o||"")}e.stripIcons=_;function n(u){const p=u.indexOf(e.iconStartMarker);return p===-1?{text:u}:m(u,p)}e.parseLabelWithIcons=n;function m(u,p){const k=[];let w="";function o(l){if(l){w+=l;for(const c of l)k.push(i)}}let f=-1,S="",i=0,g,a,r=p;const v=u.length;for(o(u.substr(0,p));r<v;)g=u[r],a=u[r+1],g===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(f=r,o(S),S=e.iconStartMarker,r++):g===")"&&f!==-1?(i+=r-f+1,f=-1,S=""):f!==-1?/^[a-z0-9\-~]$/i.test(g)?S+=g:(o(S),f=-1,S=""):o(g),r++;return o(S),{text:w,iconOffsets:k}}function s(u,p,k=!1){const{text:w,iconOffsets:o}=p;if(!o||o.length===0)return(0,M.matchesFuzzy)(u,w,k);const f=(0,E.ltrim)(w," "),S=w.length-f.length,i=(0,M.matchesFuzzy)(u,f,k);if(i)for(const g of i){const a=o[g.start+S]+S;g.start+=a,g.end+=a}return i}e.matchesFuzzyIconAware=s}),define(we[77],be([0,1,16,106]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(m="",s=!1){if(this.value=m,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(m,s=0){return this.value+=T(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(u,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,s){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function F(n){return P(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function P(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function C(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function T(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(n){const m=[],s=n.split("|").map(p=>p.trim());n=s[0];const u=s[1];if(u){const p=/height=(\d+)/.exec(u),k=/width=(\d+)/.exec(u),w=p?p[1]:"",o=k?k[1]:"",f=isFinite(parseInt(o)),S=isFinite(parseInt(w));f&&m.push(`width="${o}"`),S&&m.push(`height="${w}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=_}),define(we[35],be([0,1,9]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",F="warning",P="warn",C="info",T="ignore";function t(n){return n?d.equalsIgnoreCase(A,n)?E.Error:d.equalsIgnoreCase(F,n)||d.equalsIgnoreCase(P,n)?E.Warning:d.equalsIgnoreCase(C,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(n){switch(n){case E.Error:return A;case E.Warning:return F;case E.Info:return C;default:return T}}E.toString=_}(M||(M={})),e.default=M}),define(we[43],be([0,1,17,25,9,10]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(a){return a===47||a===92}e.isPathSeparator=F;function P(a){return a.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=P;function C(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=C;function T(a,r=d.posix.sep){if(!a)return"";const v=a.length,l=a.charCodeAt(0);if(F(l)){if(F(a.charCodeAt(1))&&!F(a.charCodeAt(2))){let b=3;const h=b;for(;b<v&&!F(a.charCodeAt(b));b++);if(h!==b&&!F(a.charCodeAt(b+1))){for(b+=1;b<v;b++)if(F(a.charCodeAt(b)))return a.slice(0,b+1).replace(/[\\/]/g,r)}}return r}else if(k(l)&&a.charCodeAt(1)===58)return F(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let c=a.indexOf("://");if(c!==-1){for(c+=3;c<v;c++)if(F(a.charCodeAt(c)))return a.slice(0,c+1)}return""}e.getRoot=T;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let v=2;const l=v;for(;v<a.length&&(r=a.charCodeAt(v),r!==92);v++);return!(l===v||(r=a.charCodeAt(v+1),isNaN(r)||r===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(a,r=M.isWindows){const v=r?_:n;return!(!a||a.length===0||/^\s+$/.test(a)||(v.lastIndex=0,v.test(a))||r&&m.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=s;function u(a,r,v){const l=a===r;return!v||l?l:!a||!r?!1:(0,E.equalsIgnoreCase)(a,r)}e.isEqual=u;function p(a,r,v,l=d.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(v){if(!(0,E.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let b=r.length;return r.charAt(r.length-1)===l&&b--,a.charAt(b)===l}return r.charAt(r.length-1)!==l&&(r+=l),a.indexOf(r)===0}e.isEqualOrParent=p;function k(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=k;function w(a,r){return M.isWindows&&a.endsWith(":")&&(a+=d.sep),(0,d.isAbsolute)(a)||(a=(0,d.join)(r,a)),a=(0,d.normalize)(a),M.isWindows?(a=(0,E.rtrim)(a,d.sep),a.endsWith(":")&&(a+=d.sep)):(a=(0,E.rtrim)(a,d.sep),a||(a=d.sep)),a}e.sanitizeFilePath=w;function o(a){const r=(0,d.normalize)(a);return M.isWindows?a.length>3?!1:f(r)&&(a.length===2||r.charCodeAt(2)===92):r===d.posix.sep}e.isRootOrDriveLetter=o;function f(a){return M.isWindows?k(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function S(a){return f(a)?a[0]:void 0}e.getDriveLetter=S;function i(a,r,v){return r.length>a.length?-1:a===r?0:(v&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=i;function g(a){const r=a.split(":");let v,l,c;if(r.forEach(b=>{const h=Number(b);(0,A.isNumber)(h)?l===void 0?l=h:c===void 0&&(c=h):v=v?[v,b].join(":"):b}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:l!==void 0?l:void 0,column:c!==void 0?c:l!==void 0?1:void 0}}e.parseLineAndColumnAware=g}),define(we[23],be([0,1,10]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(k=>{u[k]&&typeof u[k]=="object"?p[k]=M(u[k]):p[k]=u[k]}),p}e.deepClone=M;function E(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const w in k)if(A.call(k,w)){const o=k[w];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return u}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function F(u,p){return P(u,p,new Set)}e.cloneAndChange=F;function P(u,p,k){if((0,d.isUndefinedOrNull)(u))return u;const w=p(u);if(typeof w!="undefined")return w;if((0,d.isArray)(u)){const o=[];for(const f of u)o.push(P(f,p,k));return o}if((0,d.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const o={};for(let f in u)A.call(u,f)&&(o[f]=P(u[f],p,k));return k.delete(u),o}return u}function C(u,p,k=!0){return(0,d.isObject)(u)?((0,d.isObject)(p)&&Object.keys(p).forEach(w=>{w in u?k&&((0,d.isObject)(u[w])&&(0,d.isObject)(p[w])?C(u[w],p[w],k):u[w]=p[w]):u[w]=p[w]}),u):p}e.mixin=C;function T(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let k,w;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(k=0;k<u.length;k++)if(!T(u[k],p[k]))return!1}else{const o=[];for(w in u)o.push(w);o.sort();const f=[];for(w in p)f.push(w);if(f.sort(),!T(o,f))return!1;for(k=0;k<o.length;k++)if(!T(u[o[k]],p[o[k]]))return!1}return!0}e.equals=T;function t(u){const p=new Set;return JSON.stringify(u,(k,w)=>{if((0,d.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=t;function _(u,p,k){const w=p(u);return typeof w=="undefined"?k:w}e.getOrDefault=_;function n(u,p){const k=Object.create(null);return!u||!p||Object.keys(p).forEach(o=>{const f=u[o],S=p[o];T(f,S)||(k[o]=S)}),k}e.distinct=n;function m(u,p){const k=p.toLowerCase(),w=Object.keys(u).find(o=>o.toLowerCase()===k);return w?u[w]:u[p]}e.getCaseInsensitive=m;function s(u,p){const k=Object.create(null);for(const w of Object.keys(u))p(w,u[w])&&(k[w]=u[w]);return k}e.filter=s}),define(we[56],be([0,1,22,9,2]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,C)}e.stringify=A;function F(t){let _=JSON.parse(t);return _=T(_),_}e.parse=F;var P;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function C(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function T(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof d.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=T(t[n],_+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=T(t[n],_+1))}return t}e.revive=T}),define(we[11],be([0,1,25,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,T,t){this._hosts[C]=T,this._ports[C]=t}setConnectionToken(C,T){this._connectionTokens[C]=T}rewrite(C){if(this._delegate)return this._delegate(C);const T=C.authority;let t=this._hosts[T];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[T],n=this._connectionTokens[T];let m=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:d.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class F{asBrowserUri(C,T){const t=this.toUri(C,T);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(C,T){const t=this.toUri(C,T);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(C,T){return M.URI.isUri(C)?C:M.URI.parse(T.toUrl(C))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[24],be([0,1,43,11,17,25,9,2]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=C;class T{constructor(s){this._ignorePathCasing=s}compare(s,u,p=!1){return s===u?0:(0,F.compare)(this.getComparisonKey(s,p),this.getComparisonKey(u,p))}isEqual(s,u,p=!1){return s===u?!0:!s||!u?!1:this.getComparisonKey(s,p)===this.getComparisonKey(u,p)}getComparisonKey(s,u=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,u,p=!1){if(s.scheme===u.scheme){if(s.scheme===M.Schemas.file)return d.isEqualOrParent(C(s),C(u),this._ignorePathCasing(s))&&s.query===u.query&&(p||s.fragment===u.fragment);if((0,e.isEqualAuthority)(s.authority,u.authority))return d.isEqualOrParent(s.path,u.path,this._ignorePathCasing(s),"/")&&s.query===u.query&&(p||s.fragment===u.fragment)}return!1}joinPath(s,...u){return P.URI.joinPath(s,...u)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return E.posix.basename(s.path)}extname(s){return E.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(E.dirname(C(s))).path:(u=E.posix.dirname(s.path),s.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),u="/")),s.with({path:u})}normalizePath(s){if(!s.path.length)return s;let u;return s.scheme===M.Schemas.file?u=P.URI.file(E.normalize(C(s))).path:u=E.posix.normalize(s.path),s.with({path:u})}relativePath(s,u){if(s.scheme!==u.scheme||!(0,e.isEqualAuthority)(s.authority,u.authority))return;if(s.scheme===M.Schemas.file){const w=E.relative(C(s),C(u));return A.isWindows?d.toSlashes(w):w}let p=s.path||"/",k=u.path||"/";if(this._ignorePathCasing(s)){let w=0;for(const o=Math.min(p.length,k.length);w<o&&!(p.charCodeAt(w)!==k.charCodeAt(w)&&p.charAt(w).toLowerCase()!==k.charAt(w).toLowerCase());w++);p=k.substr(0,w)+p.substr(w)}return E.posix.relative(p,k)}resolvePath(s,u){if(s.scheme===M.Schemas.file){const p=P.URI.file(E.resolve(C(s),u));return s.with({authority:p.authority,path:p.path})}return u=d.toPosixPath(u),s.with({path:E.posix.resolve(s.path,u)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,u){return s===u||s!==void 0&&u!==void 0&&(0,F.equalsIgnoreCase)(s,u)}hasTrailingPathSeparator(s,u=E.sep){if(s.scheme===M.Schemas.file){const p=C(s);return p.length>d.getRoot(p).length&&p[p.length-1]===u}else{const p=s.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,u=E.sep){return(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,u=E.sep){let p=!1;if(s.scheme===M.Schemas.file){const k=C(s);p=k!==void 0&&k.length===d.getRoot(k).length&&k[k.length-1]===u}else{u="/";const k=s.path;p=k.length===1&&k.charCodeAt(k.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(s,u)?s.with({path:s.path+"/"}):s}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(m=>m.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(m,s){const u=[];for(let p=0;p<m.length;p++){const k=s(m[p]);m.some((w,o)=>o===p?!1:(0,e.isEqualOrParent)(k,s(w)))||u.push(m[p])}return u}e.distinctParents=t;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(u){const p=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(o=>{const[f,S]=o.split(":");f&&S&&p.set(f,S)});const w=u.path.substring(0,u.path.indexOf(";"));return w&&p.set(m.META_DATA_MIME,w),p}m.parseMetaData=s})(_=e.DataUri||(e.DataUri={}));function n(m,s,u){if(s){let p=m.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),m.with({scheme:u,authority:s,path:p})}return m.with({scheme:u})}e.toLocalResource=n}),define(we[12],be([0,1,21,16,3,6,24]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(W){return!!W&&typeof W.then=="function"}e.isThenable=P;function C(W){const $=new d.CancellationTokenSource,Z=W($.token),j=new Promise((Q,ae)=>{const pe=$.token.onCancellationRequested(()=>{pe.dispose(),$.dispose(),ae((0,M.canceled)())});Promise.resolve(Z).then(ce=>{pe.dispose(),$.dispose(),Q(ce)},ce=>{pe.dispose(),$.dispose(),ae(ce)})});return new class{cancel(){$.cancel()}then(Q,ae){return j.then(Q,ae)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=C;function T(W,$,Z){return Promise.race([W,new Promise(j=>$.onCancellationRequested(()=>j(Z)))])}e.raceCancellation=T;async function t(W){let $=-1;const Z=W.map((Q,ae)=>Q.then(pe=>($=ae,pe))),j=await Promise.race(Z);return W.forEach((Q,ae)=>{ae!==$&&Q.cancel()}),j}e.raceCancellablePromises=t;function _(W,$,Z){let j;const Q=setTimeout(()=>{j?.(void 0),Z?.()},$);return Promise.race([W.finally(()=>clearTimeout(Q)),new Promise(ae=>j=ae)])}e.raceTimeout=_;function n(W){return new Promise(($,Z)=>{const j=W();P(j)?j.then($,Z):$(j)})}e.asPromise=n;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const Z=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(Z,Z).then(j)})}return new Promise((Z,j)=>{this.queuedPromise.then(Z,j)})}return this.activePromise=$(),new Promise((Z,j)=>{this.activePromise.then(Q=>{this.activePromise=null,Z(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=m;class s{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=s;class u{constructor(){this.promiseMap=new Map}queue($,Z){const Q=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.promiseMap.get($)===Q&&this.promiseMap.delete($)});return this.promiseMap.set($,Q),Q}}e.SequencerByKey=u;class p{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,Z=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class k{constructor($){this.delayer=new p($),this.throttler=new m}trigger($,Z){return this.delayer.trigger(()=>this.throttler.queue($),Z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class w{constructor(){this._isOpen=!1,this._promise=new Promise(($,Z)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class o extends w{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function f(W,$){return $?new Promise((Z,j)=>{const Q=setTimeout(()=>{ae.dispose(),Z()},W),ae=$.onCancellationRequested(()=>{clearTimeout(Q),ae.dispose(),j((0,M.canceled)())})}):C(Z=>f(W,Z))}e.timeout=f;function S(W,$=0){const Z=setTimeout(W,$);return(0,A.toDisposable)(()=>clearTimeout(Z))}e.disposableTimeout=S;function i(W){const $=[];let Z=0;const j=W.length;function Q(){return Z<j?W[Z++]():null}function ae(pe){pe!=null&&$.push(pe);const ce=Q();return ce?ce.then(ae):Promise.resolve($)}return Promise.resolve(null).then(ae)}e.sequence=i;function g(W,$=j=>!!j,Z=null){let j=0;const Q=W.length,ae=()=>{if(j>=Q)return Promise.resolve(Z);const pe=W[j++];return Promise.resolve(pe()).then(Fe=>$(Fe)?Promise.resolve(Fe):ae())};return ae()}e.first=g;function a(W,$=j=>!!j,Z=null){if(W.length===0)return Promise.resolve(Z);let j=W.length;const Q=()=>{j=-1;for(const ae of W)ae.cancel?.()};return new Promise((ae,pe)=>{for(const ce of W)ce.then(Fe=>{--j>=0&&$(Fe)?(Q(),ae(Fe)):j===0&&ae(Z)}).catch(Fe=>{--j>=0&&(Q(),pe(Fe))})})}e.firstParallel=a;class r{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((Z,j)=>{this.outstandingPromises.push({factory:$,c:Z,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const Z=$.factory();Z.then($.c,$.e),Z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class v extends r{constructor(){super(1)}}e.Queue=v;class l{constructor(){this.queues=new Map}queueFor($,Z=F.extUri){const j=Z.getComparisonKey($);let Q=this.queues.get(j);return Q||(Q=new v,E.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=l;class c{constructor($,Z){this._token=-1,typeof $=="function"&&typeof Z=="number"&&this.setIfNotSet($,Z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,Z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},Z)}setIfNotSet($,Z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},Z))}}e.TimeoutTimer=c;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,Z){this.cancel(),this._token=setInterval(()=>{$()},Z)}}e.IntervalTimer=b;class h{constructor($,Z){this.timeoutToken=-1,this.runner=$,this.timeout=Z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=h;class y{constructor($,Z){Z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=Z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends h{constructor($,Z){super($,Z);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class I extends A.Disposable{constructor($,Z,j,Q){super();this.maxWorkChunkSize=$,this.maxPendingWork=Z,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new h(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const $=setTimeout(()=>{const j=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout($))}}}:e.runWhenIdle=(W,$)=>{const Z=requestIdleCallback(W,typeof $=="number"?{timeout:$}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(Z))}}}}();class U{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(Z){this._error=Z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function L(W,$,Z){let j;for(let Q=0;Q<Z;Q++)try{return await W()}catch(ae){j=ae,await f($)}throw j}e.retry=L;class D{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,Z,j){return this._pending={taskId:$,cancel:()=>j?.(),promise:Z},Z.then(()=>this.donePending($),()=>this.donePending($)),Z}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let Z,j;const Q=new Promise((ae,pe)=>{Z=ae,j=pe});this._next={run:$,promise:Q,promiseResolve:Z,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=D;class x{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,Z)=>{this.completeCallback=$,this.errorCallback=Z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(Z=>{this.completeCallback($),this.resolved=!0,Z()})}error($){return new Promise(Z=>{this.errorCallback($),this.rejected=!0,Z()})}cancel(){new Promise($=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=N;var V;(function(W){async function $(j){let Q;const ae=await Promise.all(j.map(pe=>pe.then(ce=>ce,ce=>{Q||(Q=ce)})));if(typeof Q!="undefined")throw Q;return ae}W.settled=$;function Z(j){return new Promise(async(Q,ae)=>{try{await j(Q,ae)}catch(pe){ae(pe)}})}W.withAsyncBody=Z})(V=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,12,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new d.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(h,y,R=!1){const I=h||"",U=y||"",L=E.value.collator.compare(I,U);return E.value.collatorIsNumeric&&L===0&&I!==U?I<U?-1:1:L}e.compareFileNames=P;function C(h,y){const R=A.value.collator;return h=h||"",y=y||"",S(R,h,y)}e.compareFileNamesDefault=C;function T(h,y){const R=A.value.collator;return h=h||"",y=y||"",r(h,y)||S(R,h,y)}e.compareFileNamesUpper=T;function t(h,y){const R=A.value.collator;return h=h||"",y=y||"",a(h,y)||S(R,h,y)}e.compareFileNamesLower=t;function _(h,y){return h=h||"",y=y||"",h===y?0:h<y?-1:1}e.compareFileNamesUnicode=_;function n(h,y,R=!1){R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase());const[I,U]=o(h),[L,D]=o(y);return I!==L?I<L?-1:1:U===D?0:U<D?-1:1}e.noIntlCompareFileNames=n;function m(h,y){const[R,I]=o(h),[U,L]=o(y);let D=E.value.collator.compare(I,L);if(D===0){if(E.value.collatorIsNumeric&&I!==L)return I<L?-1:1;if(D=E.value.collator.compare(R,U),E.value.collatorIsNumeric&&D===0&&R!==U)return R<U?-1:1}return D}e.compareFileExtensions=m;function s(h,y){h=h||"",y=y||"";const R=f(h),I=f(y),U=A.value.collator,L=F.value.collator;return S(L,R,I)||S(U,h,y)}e.compareFileExtensionsDefault=s;function u(h,y){h=h||"",y=y||"";const R=f(h),I=f(y),U=A.value.collator,L=F.value.collator;return S(L,R,I)||r(h,y)||S(U,h,y)}e.compareFileExtensionsUpper=u;function p(h,y){h=h||"",y=y||"";const R=f(h),I=f(y),U=A.value.collator,L=F.value.collator;return S(L,R,I)||a(h,y)||S(U,h,y)}e.compareFileExtensionsLower=p;function k(h,y){h=h||"",y=y||"";const R=f(h).toLowerCase(),I=f(y).toLowerCase();return R!==I?R<I?-1:1:h!==y?h<y?-1:1:0}e.compareFileExtensionsUnicode=k;const w=/^(.*?)(\.([^.]*))?$/;function o(h,y=!1){const R=h?w.exec(h):[];let I=[R&&R[1]||"",R&&R[3]||""];return y&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function f(h){const y=h?w.exec(h):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function S(h,y,R){let I=h.compare(y,R);return I!==0?I:y.length!==R.length?y.length<R.length?-1:1:0}function i(h){const y=h.charAt(0);return y.toLocaleUpperCase()!==y}function g(h){const y=h.charAt(0);return y.toLocaleLowerCase()!==y}function a(h,y){return i(h)&&g(y)?-1:g(h)&&i(y)?1:0}function r(h,y){return g(h)&&i(y)?-1:i(h)&&g(y)?1:0}function v(h,y,R=!1){return R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase()),h===y?0:h<y?-1:1}function l(h,y,R=!1){const I=h.split(M.sep),U=y.split(M.sep),L=I.length-1,D=U.length-1;let x,N;for(let V=0;;V++){if(x=L===V,N=D===V,x&&N)return P(I[V],U[V],R);if(x)return-1;if(N)return 1;const W=v(I[V],U[V],R);if(W!==0)return W}}e.comparePaths=l;function c(h,y,R){const I=h.toLowerCase(),U=y.toLowerCase(),L=b(h,y,R);if(L)return L;const D=I.endsWith(R),x=U.endsWith(R);if(D!==x)return D?-1:1;const N=P(I,U);return N!==0?N:I.localeCompare(U)}e.compareAnything=c;function b(h,y,R){const I=h.toLowerCase(),U=y.toLowerCase(),L=I.startsWith(R),D=U.startsWith(R);if(L!==D)return L?-1:1;if(L&&D){if(I.length<U.length)return-1;if(I.length>U.length)return 1}return 0}e.compareByPrefix=b}),define(we[27],be([0,1,12,43,20,17,9]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const C="**",T="/",t="[/\\\\]",_="[^/\\\\]",n=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function s(j,Q){if(!j)return[];const ae=[];let pe=!1,ce=!1,Fe="";for(const Ge of j){switch(Ge){case Q:if(!pe&&!ce){ae.push(Fe),Fe="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}Fe+=Ge}return Fe&&ae.push(Fe),ae}e.splitGlobAware=s;function u(j){if(!j)return"";let Q="";const ae=s(j,T);if(ae.every(pe=>pe===C))Q=".*";else{let pe=!1;ae.forEach((ce,Fe)=>{if(ce===C){pe||(Q+=m(2),pe=!0);return}let Ge=!1,Ne="",ze=!1,Je="";for(const Qe of ce){if(Qe!=="}"&&Ge){Ne+=Qe;continue}if(ze&&(Qe!=="]"||!Je)){let Ke;Qe==="-"?Ke=Qe:(Qe==="^"||Qe==="!")&&!Je?Ke="^":Qe===T?Ke="":Ke=F.escapeRegExpCharacters(Qe),Je+=Ke;continue}switch(Qe){case"{":Ge=!0;continue;case"[":ze=!0;continue;case"}":Q+=`(?:${s(Ne,",").map(K=>u(K)).join("|")})`,Ge=!1,Ne="";break;case"]":Q+="["+Je+"]",ze=!1,Je="";break;case"?":Q+=_;continue;case"*":Q+=m(1);continue;default:Q+=F.escapeRegExpCharacters(Qe)}}Fe<ae.length-1&&(ae[Fe+1]!==C||Fe+2<ae.length)&&(Q+=t),pe=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),g=function(){return!1},a=function(){return null};function r(j,Q){if(!j)return a;let ae;typeof j!="string"?ae=j.pattern:ae=j,ae=ae.trim();const pe=`${ae}_${!!Q.trimForExclusions}`;let ce=i.get(pe);if(ce)return v(ce,j);let Fe;if(p.test(ae)){const Ge=ae.substr(4);ce=function(Ne,ze){return typeof Ne=="string"&&Ne.endsWith(Ge)?ae:null}}else(Fe=k.exec(l(ae,Q)))?ce=c(Fe[1],ae):(Q.trimForExclusions?o:w).test(ae)?ce=b(ae,Q):(Fe=f.exec(l(ae,Q)))?ce=h(Fe[1].substr(1),ae,!0):(Fe=S.exec(l(ae,Q)))?ce=h(Fe[1],ae,!1):ce=y(ae);return i.set(pe,ce),v(ce,j)}function v(j,Q){return typeof Q=="string"?j:function(ae,pe){return M.isEqualOrParent(ae,Q.base)?j(A.relative(Q.base,ae),pe):null}}function l(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function c(j,Q){const ae=`/${j}`,pe=`\\${j}`,ce=function(Ge,Ne){return typeof Ge!="string"?null:Ne?Ne===j?Q:null:Ge===j||Ge.endsWith(ae)||Ge.endsWith(pe)?Q:null},Fe=[j];return ce.basenames=Fe,ce.patterns=[Q],ce.allBasenames=Fe,ce}function b(j,Q){const ae=Z(j.slice(1,-1).split(",").map(Ne=>r(Ne,Q)).filter(Ne=>Ne!==a),j),pe=ae.length;if(!pe)return a;if(pe===1)return ae[0];const ce=function(Ne,ze){for(let Je=0,Qe=ae.length;Je<Qe;Je++)if(ae[Je](Ne,ze))return j;return null},Fe=ae.find(Ne=>!!Ne.allBasenames);Fe&&(ce.allBasenames=Fe.allBasenames);const Ge=ae.reduce((Ne,ze)=>ze.allPaths?Ne.concat(ze.allPaths):Ne,[]);return Ge.length&&(ce.allPaths=Ge),ce}function h(j,Q,ae){const pe=A.sep===A.posix.sep,ce=pe?j:j.replace(n,A.sep),Fe=A.sep+ce,Ge=A.posix.sep+j,Ne=ae?function(ze,Je){return typeof ze=="string"&&(ze===ce||ze.endsWith(Fe)||!pe&&(ze===j||ze.endsWith(Ge)))?Q:null}:function(ze,Je){return typeof ze=="string"&&(ze===ce||!pe&&ze===j)?Q:null};return Ne.allPaths=[(ae?"*/":"./")+j],Ne}function y(j){try{const Q=new RegExp(`^${u(j)}$`);return function(ae){return Q.lastIndex=0,typeof ae=="string"&&Q.test(ae)?j:null}}catch(Q){return a}}function R(j,Q,ae){return!j||typeof Q!="string"?!1:I(j)(Q,void 0,ae)}e.match=R;function I(j,Q={}){if(!j)return g;if(typeof j=="string"||x(j)){const ae=r(j,Q);if(ae===a)return g;const pe=function(ce,Fe){return!!ae(ce,Fe)};return ae.allBasenames&&(pe.allBasenames=ae.allBasenames),ae.allPaths&&(pe.allPaths=ae.allPaths),pe}return W(j,Q)}e.parse=I;function U(j){if(!j)return;let Q;return ae=>(Q||(Q=(j()||Promise.resolve([])).then(pe=>pe?D(pe):{})),Q.then(pe=>!!pe[ae]))}e.hasSiblingPromiseFn=U;function L(j){if(!j)return;let Q;return ae=>{if(!Q){const pe=j();Q=pe?D(pe):{}}return!!Q[ae]}}e.hasSiblingFn=L;function D(j){const Q={};for(const ae of j)Q[ae]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function W(j,Q){const ae=Z(Object.getOwnPropertyNames(j).map(Ne=>$(Ne,j[Ne],Q)).filter(Ne=>Ne!==a)),pe=ae.length;if(!pe)return a;if(!ae.some(Ne=>!!Ne.requiresSiblings)){if(pe===1)return ae[0];const Ne=function(Qe,Ke){for(let H=0,K=ae.length;H<K;H++){const ee=ae[H](Qe,Ke);if(ee)return ee}return null},ze=ae.find(Qe=>!!Qe.allBasenames);ze&&(Ne.allBasenames=ze.allBasenames);const Je=ae.reduce((Qe,Ke)=>Ke.allPaths?Qe.concat(Ke.allPaths):Qe,[]);return Je.length&&(Ne.allPaths=Je),Ne}const ce=function(Ne,ze,Je){let Qe;for(let Ke=0,H=ae.length;Ke<H;Ke++){const K=ae[Ke];K.requiresSiblings&&Je&&(ze||(ze=A.basename(Ne)),Qe||(Qe=ze.substr(0,ze.length-A.extname(Ne).length)));const ee=K(Ne,ze,Qe,Je);if(ee)return ee}return null},Fe=ae.find(Ne=>!!Ne.allBasenames);Fe&&(ce.allBasenames=Fe.allBasenames);const Ge=ae.reduce((Ne,ze)=>ze.allPaths?Ne.concat(ze.allPaths):Ne,[]);return Ge.length&&(ce.allPaths=Ge),ce}function $(j,Q,ae){if(Q===!1)return a;const pe=r(j,ae);if(pe===a)return a;if(typeof Q=="boolean")return pe;if(Q){const ce=Q.when;if(typeof ce=="string"){const Fe=(Ge,Ne,ze,Je)=>{if(!Je||!pe(Ge,Ne))return null;const Qe=ce.replace("$(basename)",ze),Ke=Je(Qe);return(0,d.isThenable)(Ke)?Ke.then(H=>H?j:null):Ke?j:null};return Fe.requiresSiblings=!0,Fe}}return pe}function Z(j,Q){const ae=j.filter(Ne=>!!Ne.basenames);if(ae.length<2)return j;const pe=ae.reduce((Ne,ze)=>{const Je=ze.basenames;return Je?Ne.concat(Je):Ne},[]);let ce;if(Q){ce=[];for(let Ne=0,ze=pe.length;Ne<ze;Ne++)ce.push(Q)}else ce=ae.reduce((Ne,ze)=>{const Je=ze.patterns;return Je?Ne.concat(Je):Ne},[]);const Fe=function(Ne,ze){if(typeof Ne!="string")return null;if(!ze){let Qe;for(Qe=Ne.length;Qe>0;Qe--){const Ke=Ne.charCodeAt(Qe-1);if(Ke===47||Ke===92)break}ze=Ne.substr(Qe)}const Je=pe.indexOf(ze);return Je!==-1?ce[Je]:null};Fe.basenames=pe,Fe.patterns=ce,Fe.allBasenames=pe;const Ge=j.filter(Ne=>!Ne.basenames);return Ge.push(Fe),Ge}}),define(we[78],be([0,1,43,11,17,25,24,9,2]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(r,v,l){if(typeof r=="string"&&(r=C.URI.file(r)),l){const b=l.getWorkspaceFolder(r);if(b){const h=l.getWorkspace().folders.length>1;let y;if((0,F.isEqual)(b.uri,r)?y="":y=(0,F.relativePath)(b.uri,r),h){const R=b.name?b.name:(0,F.basename)(b.uri);y=y?R+" \u2022 "+y:R}return y}}if(r.scheme!==M.Schemas.file&&r.scheme!==M.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(r.fsPath))return(0,E.normalize)(_(r.fsPath));let c=(0,E.normalize)(r.fsPath);return!A.isWindows&&v?.userHome&&(c=m(c,v.userHome.fsPath)),c}e.getPathLabel=T;function t(r){if(!r)return;typeof r=="string"&&(r=C.URI.file(r));const v=(0,F.basename)(r)||(r.scheme===M.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,d.isRootOrDriveLetter)(v)?_(v):v}e.getBaseLabel=t;function _(r){return(0,d.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=_;let n=Object.create(null);function m(r,v){if(A.isWindows||!r||!v)return r;let l=n.original===v?n.normalized:void 0;return l||(l=`${(0,P.rtrim)(v,E.posix.sep)}${E.posix.sep}`,n={original:v,normalized:l}),(A.isLinux?r.startsWith(l):(0,P.startsWithIgnoreCase)(r,l))&&(r=`~/${r.substr(l.length)}`),r}e.tildify=m;function s(r,v){return r.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=s;const u="\u2026",p="\\\\",k="~";function w(r,v=E.sep){const l=new Array(r.length);let c=!1;for(let b=0;b<r.length;b++){let h=r[b];if(h===""){l[b]=`.${v}`;continue}if(!h){l[b]=h;continue}c=!0;let y="";h.indexOf(p)===0?(y=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(v)===0?(y=h.substr(0,h.indexOf(v)+v.length),h=h.substr(h.indexOf(v)+v.length)):h.indexOf(k)===0&&(y=h.substr(0,h.indexOf(k)+k.length),h=h.substr(h.indexOf(k)+k.length));const R=h.split(v);for(let I=1;c&&I<=R.length;I++)for(let U=R.length-I;c&&U>=0;U--){c=!1;let L=R.slice(U,U+I).join(v);for(let D=0;!c&&D<r.length;D++)if(D!==b&&r[D]&&r[D].indexOf(L)>-1){const x=U+I===R.length,N=U>0&&r[D].indexOf(v)>-1?v+L:L,V=r[D].endsWith(N);c=!x||V}if(!c){let D="";(R[0].endsWith(":")||y!=="")&&(U===1&&(U=0,I++,L=R[0]+v+L),U>0&&(D=R[0]+v),D=y+D),U>0&&(D=D+u+v),D=D+L,U+I<R.length&&(D=D+v+u),l[b]=D}}c&&(l[b]=h)}return l}e.shorten=w;var o;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function f(r,v=Object.create(null)){const l=[];let c=!1,b="";for(const h of r)if(h==="$"||c&&h==="{")b&&l.push({value:b,type:o.TEXT}),b="",c=!0;else if(h==="}"&&c){const y=v[b];if(typeof y=="string")y.length&&l.push({value:y,type:o.VARIABLE});else if(y){const R=l[l.length-1];(!R||R.type!==o.SEPARATOR)&&l.push({value:y.label,type:o.SEPARATOR})}b="",c=!1}else b+=h;return b&&!c&&l.push({value:b,type:o.TEXT}),l.filter((h,y)=>{if(h.type===o.SEPARATOR){const R=l[y-1],I=l[y+1];return[R,I].every(U=>U&&(U.type===o.VARIABLE||U.type===o.TEXT)&&U.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=f;function S(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(r,v){return A.isMacintosh||v?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function g(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=g;function a(r){const v=r.indexOf("/")!==-1?E.posix:E.win32,l=v.basename(r),c=v.dirname(r);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=a}),define(we[79],be([0,1,27,11,17,24,9]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let C=[],T=[],t=[];function _(r,v=!1){const l=n(r);C.push(l),l.userConfigured?t.push(l):T.push(l),v&&!l.userConfigured&&C.forEach(c=>{c.mime===l.mime||c.userConfigured||(l.extension&&c.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&c.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&c.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&c.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=_;function n(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,d.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(r){r?(C=C.filter(v=>!v.userConfigured),t=[]):(C=[],T=[],t=[])}e.clearTextMimes=m;function s(r,v){let l;if(r)switch(r.scheme){case M.Schemas.file:l=r.fsPath;break;case M.Schemas.data:l=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[P.unknown];l=l.toLowerCase();const c=(0,E.basename)(l),b=u(l,c,t);if(b)return[b,P.text];const h=u(l,c,T);if(h)return[h,P.text];if(v){const y=p(v);if(y)return[y,P.text]}return[P.unknown]}e.guessMimeTypes=s;function u(r,v,l){let c=null,b=null,h=null;for(let y=l.length-1;y>=0;y--){const R=l[y];if(v===R.filenameLowercase){c=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const I=R.filepatternOnPath?r:v;R.filepatternLowercase?.(I)&&(b=R)}R.extension&&(!h||R.extension.length>h.extension.length)&&v.endsWith(R.extensionLowercase)&&(h=R)}return c?c.mime:b?b.mime:h?h.mime:null}function p(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let v=C.length-1;v>=0;v--){const l=C[v];if(!l.firstline)continue;const c=r.match(l.firstline);if(c&&c.length>0)return l.mime}return null}function k(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&k(r[0]):!0}e.isUnspecific=k;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const v=(0,E.extname)(r),l=w[v.toLowerCase()];return l!==void 0?l:S(r)}e.getMediaOrTextMime=f;function S(r){const v=(0,E.extname)(r);return o[v.toLowerCase()]}e.getMediaMime=S;function i(r){for(const v in o)if(o[v]===r)return v}e.getExtensionForMimeType=i;const g=/^(.+)\/(.+?)(;.+)?$/;function a(r,v){const l=g.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:v?void 0:r}e.normalizeMimeType=a}),define(we[108],be([0,1,2]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(d.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(d.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:d.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof d.URI)return _.transformOutgoing(t);for(let m in t)if(Object.hasOwnProperty.call(t,m)){const s=A(t[m],_,n+1);s!==null&&(t[m]=s)}}return null}function F(t,_){const n=A(t,_,0);return n===null?t:n}e.transformOutgoingURIs=F;function P(t,_,n,m){if(!t||m>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?d.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const u=P(t[s],_,n,m+1);u!==null&&(t[s]=u)}}return null}function C(t,_){const n=P(t,_,!1,0);return n===null?t:n}e.transformIncomingURIs=C;function T(t,_){const n=P(t,_,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=T}),define(we[36],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return d.test(C)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(C){for(let T=0;T<C.length;T++)C[T]=Math.floor(Math.random()*256);return C};function P(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let C=0,T="";return T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T+="-",T+=A[E[C++]],T+=A[E[C++]],T+="-",T+=A[E[C++]],T+=A[E[C++]],T+="-",T+=A[E[C++]],T+=A[E[C++]],T+="-",T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T+=A[E[C++]],T}e.generateUuid=P}),define(we[109],be([0,1,227]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends d.CharacterClassifier{constructor(P){super(0);for(let C=0,T=P.length;C<T;C++)this.set(P.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(F){let P={};return C=>(P.hasOwnProperty(C)||(P[C]=F(C)),P[C])}e.getMapForWordSeparators=A(F=>new E(F))}),define(we[80],be([0,1,23]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class T{constructor(o,f){this._findMatchBrand=void 0,this.range=o,this.matches=f}}e.FindMatch=T;var t;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(o,f,S){this.visibleColumn=o,this.className=f,this.horizontalLine=S}}e.IndentGuide=n;class m{constructor(o,f){this.top=o,this.endColumn=f}}e.IndentGuideHorizontalLine=m;var s;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(s=e.PositionAffinity||(e.PositionAffinity={}));var u;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,f,S,i,g,a){this.identifier=o,this.range=f,this.text=S,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=g,this._isTracked=a}}e.ValidAnnotatedEditOperation=p;class k{constructor(o,f,S){this.reverseEdits=o,this.changes=f,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=k}),define(we[110],be([0,1,9,109,111,44,80]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class C{constructor(o,f,S,i){this.searchString=o,this.isRegex=f,this.matchCase=S,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=T(this.searchString):o=this.searchString.indexOf(`
`)>=0;let f=null;try{f=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!f)return null;let S=!this.isRegex&&!o;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new t(f,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=C;function T(w){if(!w||w.length===0)return!1;for(let o=0,f=w.length;o<f;o++)if(w.charCodeAt(o)===92){if(o++,o>=f)break;const i=w.charCodeAt(o);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=T;class t{constructor(o,f,S){this.regex=o,this.wordSeparators=f,this.simpleSearch=S}}e.SearchData=t;function _(w,o,f){if(!f)return new F.FindMatch(w,null);let S=[];for(let i=0,g=o.length;i<g;i++)S[i]=o[i];return new F.FindMatch(w,S)}e.createFindMatch=_;class n{constructor(o){let f=[],S=0;for(let i=0,g=o.length;i<g;i++)o.charCodeAt(i)===10&&(f[S++]=i);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(o){const f=this._lineFeedsOffsets;let S=0,i=f.length-1;if(i===-1||o<=f[0])return 0;for(;S<i;){const g=S+((i-S)/2>>0);f[g]>=o?i=g-1:f[g+1]>=o?(S=g,i=g):S=g+1}return S+1}}class m{static findMatches(o,f,S,i,g){const a=f.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(o,S,new k(a.wordSeparators,a.regex),i,g):this._doFindMatchesLineByLine(o,S,a,i,g):[]}static _getMultilineMatchRange(o,f,S,i,g,a){let r,v=0;i?(v=i.findLineFeedCountBeforeOffset(g),r=f+g+v):r=f+g;let l;if(i){let y=i.findLineFeedCountBeforeOffset(g+a.length)-v;l=r+a.length+y}else l=r+a.length;const c=o.getPositionAt(r),b=o.getPositionAt(l);return new A.Range(c.lineNumber,c.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,f,S,i,g){const a=o.getOffsetAt(f.getStartPosition()),r=o.getValueInRange(f,1),v=o.getEOL()===`\r
`?new n(r):null,l=[];let c=0,b;for(S.reset(0);b=S.next(r);)if(l[c++]=_(this._getMultilineMatchRange(o,a,r,v,b.index,b[0]),b,i),c>=g)return l;return l}static _doFindMatchesLineByLine(o,f,S,i,g){const a=[];let r=0;if(f.startLineNumber===f.endLineNumber){const l=o.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(S,l,f.startLineNumber,f.startColumn-1,r,a,i,g),a}const v=o.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(S,v,f.startLineNumber,f.startColumn-1,r,a,i,g);for(let l=f.startLineNumber+1;l<f.endLineNumber&&r<g;l++)r=this._findMatchesInLine(S,o.getLineContent(l),l,0,r,a,i,g);if(r<g){const l=o.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(S,l,f.endLineNumber,0,r,a,i,g)}return a}static _findMatchesInLine(o,f,S,i,g,a,r,v){const l=o.wordSeparators;if(!r&&o.simpleSearch){const h=o.simpleSearch,y=h.length,R=f.length;let I=-y;for(;(I=f.indexOf(h,I+y))!==-1;)if((!l||p(l,f,R,I,y))&&(a[g++]=new F.FindMatch(new A.Range(S,I+1+i,S,I+1+y+i),null),g>=v))return g;return g}const c=new k(o.wordSeparators,o.regex);let b;c.reset(0);do if(b=c.next(f),b&&(a[g++]=_(new A.Range(S,b.index+1+i,S,b.index+1+b[0].length+i),b,r),g>=v))return g;while(b);return g}static findNextMatch(o,f,S,i){const g=f.parseSearchRequest();if(!g)return null;const a=new k(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(o,S,a,i):this._doFindNextMatchLineByLine(o,S,a,i)}static _doFindNextMatchMultiline(o,f,S,i){const g=new E.Position(f.lineNumber,1),a=o.getOffsetAt(g),r=o.getLineCount(),v=o.getValueInRange(new A.Range(g.lineNumber,g.column,r,o.getLineMaxColumn(r)),1),l=o.getEOL()===`\r
`?new n(v):null;S.reset(f.column-1);let c=S.next(v);return c?_(this._getMultilineMatchRange(o,a,v,l,c.index,c[0]),c,i):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),S,i):null}static _doFindNextMatchLineByLine(o,f,S,i){const g=o.getLineCount(),a=f.lineNumber,r=o.getLineContent(a),v=this._findFirstMatchInLine(S,r,a,f.column,i);if(v)return v;for(let l=1;l<=g;l++){const c=(a+l-1)%g,b=o.getLineContent(c+1),h=this._findFirstMatchInLine(S,b,c+1,1,i);if(h)return h}return null}static _findFirstMatchInLine(o,f,S,i,g){o.reset(i-1);const a=o.next(f);return a?_(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,g):null}static findPreviousMatch(o,f,S,i){const g=f.parseSearchRequest();if(!g)return null;const a=new k(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(o,S,a,i):this._doFindPreviousMatchLineByLine(o,S,a,i)}static _doFindPreviousMatchMultiline(o,f,S,i){const g=this._doFindMatchesMultiline(o,new A.Range(1,1,f.lineNumber,f.column),S,i,10*P);if(g.length>0)return g[g.length-1];const a=o.getLineCount();return f.lineNumber!==a||f.column!==o.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(o,new E.Position(a,o.getLineMaxColumn(a)),S,i):null}static _doFindPreviousMatchLineByLine(o,f,S,i){const g=o.getLineCount(),a=f.lineNumber,r=o.getLineContent(a).substring(0,f.column-1),v=this._findLastMatchInLine(S,r,a,i);if(v)return v;for(let l=1;l<=g;l++){const c=(g+a-l-1)%g,b=o.getLineContent(c+1),h=this._findLastMatchInLine(S,b,c+1,i);if(h)return h}return null}static _findLastMatchInLine(o,f,S,i){let g=null,a;for(o.reset(0);a=o.next(f);)g=_(new A.Range(S,a.index+1,S,a.index+1+a[0].length),a,i);return g}}e.TextModelSearch=m;function s(w,o,f,S,i){if(S===0)return!0;const g=o.charCodeAt(S-1);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(S);if(w.get(a)!==0)return!0}return!1}function u(w,o,f,S,i){if(S+i===f)return!0;const g=o.charCodeAt(S+i);if(w.get(g)!==0||g===13||g===10)return!0;if(i>0){const a=o.charCodeAt(S+i-1);if(w.get(a)!==0)return!0}return!1}function p(w,o,f,S,i){return s(w,o,f,S,i)&&u(w,o,f,S,i)}e.isValidMatch=p;class k{constructor(o,f){this._wordSeparators=o,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const f=o.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(S=this._searchRegex.exec(o),!S))return null;const i=S.index,g=S[0].length;if(i===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){d.getNextCodePoint(o,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=g,!this._wordSeparators||p(this._wordSeparators,o,f,i,g))return S}while(S);return null}}e.Searcher=k}),define(we[112],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class M{constructor(P){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let C=0,T=P.notIn.length;C<T;C++)switch(P.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of P)A(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),A(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),A(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),A(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&A(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=E;function A(F,P,C){F.has(P)?F.get(P).push(C):F.set(P,[C])}}),define(we[57],be([0,1,27,17]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,F,P,C){if(Array.isArray(A)){let T=0;for(const t of A){const _=E(t,F,P,C);if(_===10)return _;_>T&&(T=_)}return T}else{if(typeof A=="string")return C?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:t,scheme:_,hasAccessToAllModels:n}=A;if(!C&&!n)return 0;let m=0;if(_)if(_===F.scheme)m=10;else if(_==="*")m=5;else return 0;if(T)if(T===P)m=10;else if(T==="*")m=Math.max(m,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===F.fsPath||(0,d.match)(s,F.fsPath))m=10;else return 0}return m}else return 0}}e.score=E}),define(we[113],be([0,1,3,6]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,P){return this._map.set(F,P),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===P&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,P){let C=null,T=!1;return this._promises.set(F,P.then(t=>{this._promises.delete(F),!(T||!t)&&(C=this.register(F,t))})),(0,M.toDisposable)(()=>{T=!0,C&&C.dispose()})}getPromise(F){const P=this.get(F);if(P)return Promise.resolve(P);const C=this._promises.get(F);return C?C.then(T=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(we[81],be([0,1,22,25]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let n=0,m=_.length;n<m;n+=4){const s=_[n+0],u=_[n+1],p=_[n+2],k=_[n+3];_[n+0]=k,_[n+1]=p,_[n+2]=u,_[n+3]=s}}function F(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||A(n),d.VSBuffer.wrap(n)}function P(_){const n=_.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(_){const n=new Uint32Array(T(_));let m=0;if(n[m++]=_.id,_.type==="full")n[m++]=1,n[m++]=_.data.length,n.set(_.data,m),m+=_.data.length;else{n[m++]=2,n[m++]=_.deltas.length;for(const s of _.deltas)n[m++]=s.start,n[m++]=s.deleteCount,s.data?(n[m++]=s.data.length,n.set(s.data,m),m+=s.data.length):n[m++]=0}return F(n)}e.encodeSemanticTokensDto=C;function T(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(n+=m.data.length)}return n}function t(_){const n=P(_);let m=0;const s=n[m++];if(n[m++]===1){const w=n[m++],o=n.subarray(m,m+w);return m+=w,{id:s,type:"full",data:o}}const p=n[m++];let k=[];for(let w=0;w<p;w++){const o=n[m++],f=n[m++],S=n[m++];let i;S>0&&(i=n.subarray(m,m+S),m+=S),k[w]={start:o,deleteCount:f,data:i}}return{id:s,type:"delta",deltas:k}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[45],be([0,1,15,10,114]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,t){return t&&(T.stack||T.stacktrace)?E.localize(0,null,P(T),F(T.stack)||F(T.stacktrace)):P(T)}function F(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?E.localize(1,null,T.message):T.message||E.localize(2,null)}function C(T=null,t=!1){if(!T)return E.localize(3,null);if(Array.isArray(T)){const _=d.coalesce(T),n=C(_[0],t);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(T))return T;if(T.detail){const _=T.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return T.stack?A(T,t):T.message?T.message:E.localize(5,null)}e.toErrorMessage=C}),define(we[115],be([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[116],be([0,1,115,25,117]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=F;class P{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,ge){this._values[X]=ge}}e.ValidatedEditorOptions=P;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class T{constructor(X,ge,Ue,qe){this.id=X,this.name=ge,this.defaultValue=Ue,this.schema=qe}compute(X,ge,Ue){return Ue}}class t{constructor(X,ge=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(X){return this.defaultValue}}class _{constructor(X,ge,Ue,qe){this.id=X,this.name=ge,this.defaultValue=Ue,this.schema=qe}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,ge,Ue){return Ue}}function n(q,X){return typeof q=="undefined"?X:q==="false"?!1:Boolean(q)}e.boolean=n;class m extends _{constructor(X,ge,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ue),super(X,ge,Ue,qe)}validate(X){return n(X,this.defaultValue)}}function s(q,X,ge,Ue){if(typeof q=="undefined")return X;let qe=parseInt(q,10);return isNaN(qe)?X:(qe=Math.max(ge,qe),qe=Math.min(Ue,qe),qe|0)}e.clampedInt=s;class u extends _{constructor(X,ge,Ue,qe,rt,mt=void 0){typeof mt!="undefined"&&(mt.type="integer",mt.default=Ue,mt.minimum=qe,mt.maximum=rt),super(X,ge,Ue,mt),this.minimum=qe,this.maximum=rt}static clampedInt(X,ge,Ue,qe){return s(X,ge,Ue,qe)}validate(X){return u.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(X,ge,Ue,qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=Ue),super(X,ge,Ue,rt),this.validationFn=qe}static clamp(X,ge,Ue){return X<ge?ge:X>Ue?Ue:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X=="undefined")return ge;const Ue=parseFloat(X);return isNaN(Ue)?ge:Ue}validate(X){return this.validationFn(p.float(X,this.defaultValue))}}class k extends _{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ue),super(X,ge,Ue,qe)}validate(X){return k.string(X,this.defaultValue)}}function w(q,X,ge){return typeof q!="string"||ge.indexOf(q)===-1?X:q}e.stringSet=w;class o extends _{constructor(X,ge,Ue,qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=qe,rt.default=Ue),super(X,ge,Ue,rt),this._allowedValues=qe}validate(X){return w(X,this.defaultValue,this._allowedValues)}}class f extends T{constructor(X,ge,Ue,qe,rt,mt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=rt,ut.default=qe),super(X,ge,Ue,ut),this._allowedValues=rt,this._convert=mt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function S(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Ue){return Ue===0?X.accessibilitySupport:Ue}}class g extends T{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:d.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:n(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function c(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(X,ge,Ue){const qe=["monaco-editor"];return ge.get(33)&&qe.push(ge.get(33)),X.extraEditorClassName&&qe.push(X.extraEditorClassName),ge.get(65)==="default"?qe.push("mouse-default"):ge.get(65)==="copy"&&qe.push("mouse-copy"),ge.get(99)&&qe.push("showUnused"),ge.get(124)&&qe.push("showDeprecated"),qe.join(" ")}}class h extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(X,ge,Ue){return Ue&&X.emptySelectionClipboard}}class y extends T{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:d.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:d.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:n(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":w(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":w(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(ge.loop,this.defaultValue.loop)}}}class R extends T{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.ON:X:Boolean(X)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class I extends t{constructor(){super(43)}compute(X,ge,Ue){return X.fontInfo}}class U extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(X){let ge=p.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ge,6,100)}compute(X,ge,Ue){return X.fontInfo.fontSize}}class L extends T{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(u.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class D extends T{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:d.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:w(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??w(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??w(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??w(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??w(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??w(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:k.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:k.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:k.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:k.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:k.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends T{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:d.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),delay:u.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:n(ge.sticky,this.defaultValue.sticky),above:n(ge.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(X,ge,Ue){return V.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?ge-1:0,qe=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),rt=Math.floor(X.viewLineCount/qe);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ue,desiredRatio:qe,minimapLineCount:rt}}static _computeMinimapLayout(X,ge){const Ue=X.outerWidth,qe=X.outerHeight,rt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const mt=ge.stableMinimapLayoutInput,ut=mt&&X.outerHeight===mt.outerHeight&&X.lineHeight===mt.lineHeight&&X.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&X.pixelRatio===mt.pixelRatio&&X.scrollBeyondLastLine===mt.scrollBeyondLastLine&&X.minimap.enabled===mt.minimap.enabled&&X.minimap.side===mt.minimap.side&&X.minimap.size===mt.minimap.size&&X.minimap.showSlider===mt.minimap.showSlider&&X.minimap.renderCharacters===mt.minimap.renderCharacters&&X.minimap.maxColumn===mt.minimap.maxColumn&&X.minimap.scale===mt.minimap.scale&&X.verticalScrollbarWidth===mt.verticalScrollbarWidth&&X.isViewportWrapping===mt.isViewportWrapping,St=X.lineHeight,Tt=X.typicalHalfwidthCharacterWidth,It=X.scrollBeyondLastLine,Xe=X.minimap.renderCharacters;let vt=rt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ie=X.minimap.maxColumn,ye=X.minimap.size,De=X.minimap.side,te=X.verticalScrollbarWidth,oe=X.viewLineCount,fe=X.remainingWidth,he=X.isViewportWrapping,ke=Xe?2:3;let Oe=Math.floor(rt*qe);const Me=Oe/rt;let He=!1,it=!1,Re=ke*vt,ue=vt/rt,me=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:pt,desiredRatio:dt,minimapLineCount:ht}=V.computeContainedMinimapLineCount({viewLineCount:oe,scrollBeyondLastLine:It,height:qe,lineHeight:St,pixelRatio:rt});if(oe/ht>1)He=!0,it=!0,vt=1,Re=1,ue=vt/rt;else{let _t=!1,yt=vt+1;if(ye==="fit"){const Pt=Math.ceil((oe+pt)*Re);he&&ut&&fe<=ge.stableFitRemainingWidth?(_t=!0,yt=ge.stableFitMaxMinimapScale):_t=Pt>Oe}if(ye==="fill"||_t){He=!0;const Pt=vt;Re=Math.min(St*rt,Math.max(1,Math.floor(1/dt))),he&&ut&&fe<=ge.stableFitRemainingWidth&&(yt=ge.stableFitMaxMinimapScale),vt=Math.min(yt,Math.max(1,Math.floor(Re/ke))),vt>Pt&&(me=Math.min(2,vt/Pt)),ue=vt/rt/me,Oe=Math.ceil(Math.max(ct,oe+pt)*Re),he?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=fe,ge.stableFitMaxMinimapScale=vt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const J=Math.floor(Ie*ue),z=Math.min(J,Math.max(0,Math.floor((fe-te-2)*ue/(Tt+ue)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(rt*z);const Ce=ve/rt;ve=Math.floor(ve*me);const Ye=Xe?1:2,Le=De==="left"?0:Ue-z-te;return{renderMinimap:Ye,minimapLeft:Le,minimapWidth:z,minimapHeightIsEditorHeight:He,minimapIsSampling:it,minimapScale:vt,minimapLineHeight:Re,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:Oe,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:Me}}static computeLayout(X,ge){const Ue=ge.outerWidth|0,qe=ge.outerHeight|0,rt=ge.lineHeight|0,mt=ge.lineNumbersDigitCount|0,ut=ge.typicalHalfwidthCharacterWidth,St=ge.maxDigitWidth,Tt=ge.pixelRatio,It=ge.viewLineCount,Xe=X.get(121),vt=Xe==="inherit"?X.get(120):Xe,Ie=vt==="inherit"?X.get(116):vt,ye=X.get(119),De=X.get(2),te=ge.isDominatedByLongLines,oe=X.get(49),fe=X.get(59).renderType!==0,he=X.get(60),ke=X.get(93),Oe=X.get(64),Me=X.get(91),He=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,ue=Me.horizontalScrollbarSize,me=X.get(57),J=X.get(37);let z;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const xt=parseFloat(me.substr(0,me.length-2));z=u.clampedInt(xt*ut,0,0,1e3)}else z=u.clampedInt(me,0,0,1e3);J&&(z+=16);let ve=0;if(fe){const xt=Math.max(mt,he);ve=Math.round(xt*St)}let Ce=0;oe&&(Ce=rt);let Ye=0,Le=Ye+Ce,ct=Le+ve,pt=ct+z;const dt=Ue-Ce-ve-z;let ht=!1,ft=!1,_t=-1;De!==2&&(vt==="inherit"&&te?(ht=!0,ft=!0):Ie==="on"||Ie==="bounded"?ft=!0:Ie==="wordWrapColumn"&&(_t=ye));const yt=V._computeMinimapLayout({outerWidth:Ue,outerHeight:qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ut,pixelRatio:Tt,scrollBeyondLastLine:ke,minimap:Oe,verticalScrollbarWidth:He,viewLineCount:It,remainingWidth:dt,isViewportWrapping:ft},ge.memory||new C);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Ye+=yt.minimapWidth,Le+=yt.minimapWidth,ct+=yt.minimapWidth,pt+=yt.minimapWidth);const Pt=dt-yt.minimapWidth,Nt=Math.max(1,Math.floor((Pt-He-2)/ut)),Ct=it?Re:0;return ft&&(_t=Math.max(1,Nt),Ie==="bounded"&&(_t=Math.min(_t,ye))),{width:Ue,height:qe,glyphMarginLeft:Ye,glyphMarginWidth:Ce,lineNumbersLeft:Le,lineNumbersWidth:ve,decorationsLeft:ct,decorationsWidth:z,contentLeft:pt,contentWidth:Pt,minimap:yt,viewportColumn:Nt,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:_t,verticalScrollbarWidth:He,horizontalScrollbarHeight:ue,overviewRuler:{top:Ct,width:He,height:qe-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends T{constructor(){const X={enabled:!0};super(56,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:d.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class $ extends T{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:d.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:d.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:k.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class Z extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>p.clamp(X,0,150),{markdownDescription:d.localize(47,null)})}compute(X,ge,Ue){return X.fontInfo.lineHeight}}class j extends T{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:d.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(49,null),d.localize(50,null),d.localize(51,null)],default:X.size,description:d.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:d.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:d.localize(54,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:d.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:d.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),size:w(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ge.side,this.defaultValue.side,["right","left"]),showSlider:w(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(ge.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ge.scale,1,1,3),maxColumn:u.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends T{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:u.clampedInt(ge.top,0,0,1e3),bottom:u.clampedInt(ge.bottom,0,0,1e3)}}}class pe extends T{constructor(){const X={enabled:!0,cycle:!1};super(75,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:d.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),cycle:n(ge.cycle,this.defaultValue.cycle)}}}class ce extends t{constructor(){super(127)}compute(X,ge,Ue){return X.pixelRatio}}class Fe extends T{constructor(){const X={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:d.localize(62,null)},comments:{type:"boolean",default:X.comments,description:d.localize(63,null)},other:{type:"boolean",default:X.other,description:d.localize(64,null)}}}],default:X,description:d.localize(65,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const ge=X,Ue={other:n(ge.other,this.defaultValue.other),comments:n(ge.comments,this.defaultValue.comments),strings:n(ge.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Ge;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Ge=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends T{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null),d.localize(69,null)],default:"on",description:d.localize(70,null)})}validate(X){let ge=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(ge=4,Ue=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ue}}}function ze(q){const X=q.get(86);return X==="editable"?q.get(80):X!=="on"}e.filterValidationDecorations=ze;class Je extends T{constructor(){const X=[],ge={type:"number",description:d.localize(71,null)};super(90,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:d.localize(72,null),format:"color-hex"}}}]},default:X,description:d.localize(73,null)})}validate(X){if(Array.isArray(X)){let ge=[];for(let Ue of X)if(typeof Ue=="number")ge.push({column:u.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const qe=Ue;ge.push({column:u.clampedInt(qe.column,0,0,1e4),color:qe.color})}return ge.sort((Ue,qe)=>Ue.column-qe.column),ge}return this.defaultValue}}function Qe(q,X){if(typeof q!="string")return X;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends T{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"auto",description:d.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)],default:"auto",description:d.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:d.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:d.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Ue=u.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=u.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(ge.vertical,this.defaultValue.vertical),horizontal:Qe(ge.horizontal,this.defaultValue.horizontal),useShadows:n(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:u.clampedInt(ge.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:u.clampedInt(ge.verticalSliderSize,qe,0,1e3),scrollByPage:n(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class H extends T{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:d.localize(85,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),mode:w(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends T{constructor(){const X={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,description:d.localize(86,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class ee extends T{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(87,null),d.localize(88,null),d.localize(89,null)],default:X.bracketPairs,description:d.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(91,null),d.localize(92,null),d.localize(93,null)],default:X.bracketPairsHorizontal,description:d.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:d.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:d.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:X.highlightActiveIndentation,description:d.localize(97,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:se(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(q,X,ge){const Ue=ge.indexOf(q);return Ue===-1?X:ge[Ue]}class G extends T{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(98,null),d.localize(99,null)],default:X.insertMode,description:d.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:d.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:d.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:d.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:d.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:d.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:d.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:d.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:d.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:w(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(ge.showIcons,this.defaultValue.showIcons),showStatusBar:n(ge.showStatusBar,this.defaultValue.showStatusBar),preview:n(ge.preview,this.defaultValue.preview),previewMode:w(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(ge.showMethods,this.defaultValue.showMethods),showFunctions:n(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:n(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:n(ge.showFields,this.defaultValue.showFields),showVariables:n(ge.showVariables,this.defaultValue.showVariables),showClasses:n(ge.showClasses,this.defaultValue.showClasses),showStructs:n(ge.showStructs,this.defaultValue.showStructs),showInterfaces:n(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:n(ge.showModules,this.defaultValue.showModules),showProperties:n(ge.showProperties,this.defaultValue.showProperties),showEvents:n(ge.showEvents,this.defaultValue.showEvents),showOperators:n(ge.showOperators,this.defaultValue.showOperators),showUnits:n(ge.showUnits,this.defaultValue.showUnits),showValues:n(ge.showValues,this.defaultValue.showValues),showConstants:n(ge.showConstants,this.defaultValue.showConstants),showEnums:n(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:n(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(ge.showKeywords,this.defaultValue.showKeywords),showWords:n(ge.showWords,this.defaultValue.showWords),showColors:n(ge.showColors,this.defaultValue.showColors),showFiles:n(ge.showFiles,this.defaultValue.showFiles),showReferences:n(ge.showReferences,this.defaultValue.showReferences),showFolders:n(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:n(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(ge.showSnippets,this.defaultValue.showSnippets),showUsers:n(ge.showUsers,this.defaultValue.showUsers),showIssues:n(ge.showIssues,this.defaultValue.showIssues)}}}class ne extends T{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(140,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends t{constructor(){super(128,[80])}compute(X,ge,Ue){return ge.get(80)?!0:X.tabFocusMode}}var Te;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Te=e.WrappingIndent||(e.WrappingIndent={}));function xe(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class $e extends t{constructor(){super(130,[129])}compute(X,ge,Ue){const qe=ge.get(129);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?st:je,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function _e(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(141,null)})),acceptSuggestionOnEnter:_e(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(142,null),""],markdownDescription:d.localize(143,null)})),accessibilitySupport:_e(new i),accessibilityPageSize:_e(new u(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(144,null)})),ariaLabel:_e(new k(4,"ariaLabel",d.localize(145,null))),autoClosingBrackets:_e(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(146,null),d.localize(147,null),""],description:d.localize(148,null)})),autoClosingDelete:_e(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(149,null),""],description:d.localize(150,null)})),autoClosingOvertype:_e(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(151,null),""],description:d.localize(152,null)})),autoClosingQuotes:_e(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(153,null),d.localize(154,null),""],description:d.localize(155,null)})),autoIndent:_e(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[d.localize(156,null),d.localize(157,null),d.localize(158,null),d.localize(159,null),d.localize(160,null)],description:d.localize(161,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(162,null),d.localize(163,null),d.localize(164,null),""],description:d.localize(165,null)})),bracketPairColorization:_e(new K),bracketPairGuides:_e(new ee),stickyTabStops:_e(new m(103,"stickyTabStops",!1,{description:d.localize(166,null)})),codeLens:_e(new m(14,"codeLens",!0,{description:d.localize(167,null)})),codeLensFontFamily:_e(new k(15,"codeLensFontFamily","",{description:d.localize(168,null)})),codeLensFontSize:_e(new u(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(169,null)})),colorDecorators:_e(new m(17,"colorDecorators",!0,{description:d.localize(170,null)})),columnSelection:_e(new m(18,"columnSelection",!1,{description:d.localize(171,null)})),comments:_e(new g),contextmenu:_e(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(172,null)})),cursorBlinking:_e(new f(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:d.localize(173,null)})),cursorSmoothCaretAnimation:_e(new m(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(174,null)})),cursorStyle:_e(new f(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:d.localize(175,null)})),cursorSurroundingLines:_e(new u(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(176,null)})),cursorSurroundingLinesStyle:_e(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(177,null),d.localize(178,null)],description:d.localize(179,null)})),cursorWidth:_e(new u(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(180,null)})),disableLayerHinting:_e(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(30,"domReadOnly",!1)),dragAndDrop:_e(new m(31,"dragAndDrop",!0,{description:d.localize(181,null)})),emptySelectionClipboard:_e(new h),extraEditorClassName:_e(new k(33,"extraEditorClassName","")),fastScrollSensitivity:_e(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:d.localize(182,null)})),find:_e(new y),fixedOverflowWidgets:_e(new m(36,"fixedOverflowWidgets",!1)),folding:_e(new m(37,"folding",!0,{description:d.localize(183,null)})),foldingStrategy:_e(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(184,null),d.localize(185,null)],description:d.localize(186,null)})),foldingHighlight:_e(new m(39,"foldingHighlight",!0,{description:d.localize(187,null)})),foldingImportsByDefault:_e(new m(40,"foldingImportsByDefault",!1,{description:d.localize(188,null)})),unfoldOnClickAfterEndOfLine:_e(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(189,null)})),fontFamily:_e(new k(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(190,null)})),fontInfo:_e(new I),fontLigatures2:_e(new R),fontSize:_e(new U),fontWeight:_e(new L),formatOnPaste:_e(new m(47,"formatOnPaste",!1,{description:d.localize(191,null)})),formatOnType:_e(new m(48,"formatOnType",!1,{description:d.localize(192,null)})),glyphMargin:_e(new m(49,"glyphMargin",!0,{description:d.localize(193,null)})),gotoLocation:_e(new D),hideCursorInOverviewRuler:_e(new m(51,"hideCursorInOverviewRuler",!1,{description:d.localize(194,null)})),hover:_e(new x),inDiffEditor:_e(new m(53,"inDiffEditor",!1)),letterSpacing:_e(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:d.localize(195,null)})),lightbulb:_e(new W),lineDecorationsWidth:_e(new _(57,"lineDecorationsWidth",10)),lineHeight:_e(new Z),lineNumbers:_e(new Ne),lineNumbersMinChars:_e(new u(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(61,"linkedEditing",!1,{description:d.localize(196,null)})),links:_e(new m(62,"links",!0,{description:d.localize(197,null)})),matchBrackets:_e(new o(63,"matchBrackets","always",["always","near","never"],{description:d.localize(198,null)})),minimap:_e(new j),mouseStyle:_e(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:d.localize(199,null)})),mouseWheelZoom:_e(new m(67,"mouseWheelZoom",!1,{markdownDescription:d.localize(200,null)})),multiCursorMergeOverlapping:_e(new m(68,"multiCursorMergeOverlapping",!0,{description:d.localize(201,null)})),multiCursorModifier:_e(new f(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[d.localize(202,null),d.localize(203,null)],markdownDescription:d.localize(204,null)})),multiCursorPaste:_e(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(205,null),d.localize(206,null)],markdownDescription:d.localize(207,null)})),occurrencesHighlight:_e(new m(71,"occurrencesHighlight",!0,{description:d.localize(208,null)})),overviewRulerBorder:_e(new m(72,"overviewRulerBorder",!0,{description:d.localize(209,null)})),overviewRulerLanes:_e(new u(73,"overviewRulerLanes",3,0,3)),padding:_e(new ae),parameterHints:_e(new pe),peekWidgetDefaultFocus:_e(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(210,null),d.localize(211,null)],description:d.localize(212,null)})),definitionLinkOpensInPeek:_e(new m(77,"definitionLinkOpensInPeek",!1,{description:d.localize(213,null)})),quickSuggestions:_e(new Fe),quickSuggestionsDelay:_e(new u(79,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(214,null)})),readOnly:_e(new m(80,"readOnly",!1)),renameOnType:_e(new m(81,"renameOnType",!1,{description:d.localize(215,null),markdownDeprecationMessage:d.localize(216,null)})),renderControlCharacters:_e(new m(82,"renderControlCharacters",!0,{description:d.localize(217,null),restricted:!0})),renderFinalNewline:_e(new m(83,"renderFinalNewline",!0,{description:d.localize(218,null)})),renderLineHighlight:_e(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(219,null)],description:d.localize(220,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(221,null)})),renderValidationDecorations:_e(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(222,null),d.localize(223,null),d.localize(224,null),""],description:d.localize(225,null)})),revealHorizontalRightPadding:_e(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(89,"roundedSelection",!0,{description:d.localize(226,null)})),rulers:_e(new Je),scrollbar:_e(new Ke),scrollBeyondLastColumn:_e(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(227,null)})),scrollBeyondLastLine:_e(new m(93,"scrollBeyondLastLine",!0,{description:d.localize(228,null)})),scrollPredominantAxis:_e(new m(94,"scrollPredominantAxis",!0,{description:d.localize(229,null)})),selectionClipboard:_e(new m(95,"selectionClipboard",!0,{description:d.localize(230,null),included:M.isLinux})),selectionHighlight:_e(new m(96,"selectionHighlight",!0,{description:d.localize(231,null)})),selectOnLineNumbers:_e(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:_e(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(232,null),d.localize(233,null)],description:d.localize(234,null)})),showUnused:_e(new m(99,"showUnused",!0,{description:d.localize(235,null)})),showDeprecated:_e(new m(124,"showDeprecated",!0,{description:d.localize(236,null)})),inlayHints:_e(new $),snippetSuggestions:_e(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(237,null),d.localize(238,null),d.localize(239,null),d.localize(240,null)],description:d.localize(241,null)})),smartSelect:_e(new ne),smoothScrolling:_e(new m(102,"smoothScrolling",!1,{description:d.localize(242,null)})),stopRenderingLineAfter:_e(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new G),inlineSuggest:_e(new H),suggestFontSize:_e(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(243,null)})),suggestLineHeight:_e(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(244,null)})),suggestOnTriggerCharacters:_e(new m(108,"suggestOnTriggerCharacters",!0,{description:d.localize(245,null)})),suggestSelection:_e(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(246,null),d.localize(247,null),d.localize(248,null)],description:d.localize(249,null)})),tabCompletion:_e(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(250,null),d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),tabIndex:_e(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),useShadowDOM:_e(new m(113,"useShadowDOM",!0)),useTabStops:_e(new m(114,"useTabStops",!0,{description:d.localize(258,null)})),wordSeparators:_e(new k(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:d.localize(259,null)})),wordWrap:_e(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(260,null),d.localize(261,null),d.localize(262,null),d.localize(263,null)],description:d.localize(264,null)})),wordWrapBreakAfterCharacters:_e(new k(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new k(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(265,null)})),wordWrapOverride1:_e(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new f(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],xe,{enumDescriptions:[d.localize(266,null),d.localize(267,null),d.localize(268,null),d.localize(269,null)],description:d.localize(270,null)})),wrappingStrategy:_e(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(271,null),d.localize(272,null)],description:d.localize(273,null)})),editorClassName:_e(new b),pixelRatio:_e(new ce),tabFocusMode:_e(new de),layoutInfo:_e(new V),wrappingInfo:_e(new $e)}}),define(we[118],be([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[119],be([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[120],be([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[121],be([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[122],be([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(we[123],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[124],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[125],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[126],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[127],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[128],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[129],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[130],be([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[131],be([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(we[132],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[133],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[134],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[135],be([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[136],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[137],be([0,1,119]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function F(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=F;function P(n){if(!n)return null;let m=n.majorBase,s=n.majorMustEqual,u=n.minorBase,p=n.minorMustEqual,k=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(m===0||(p=!1),w=!1);let o=0;if(n.preRelease){const f=E.exec(n.preRelease);if(f){const[,S,i,g]=f;o=Date.UTC(Number(S),Number(i)-1,Number(g))}}return{majorBase:m,majorMustEqual:s,minorBase:u,minorMustEqual:p,patchBase:k,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=P;function C(n,m,s){let u;typeof n=="string"?u=P(F(n)):u=n;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let k;if(typeof s=="string"?k=P(F(s)):k=s,!u||!k)return!1;let w=u.majorBase,o=u.minorBase,f=u.patchBase,S=k.majorBase,i=k.minorBase,g=k.patchBase,a=k.notBefore,r=k.majorMustEqual,v=k.minorMustEqual,l=k.patchMustEqual;return k.isMinimum?w>S?!0:w<S?!1:o>i?!0:o<i||p&&p<a?!1:f>=g:(w===1&&S===0&&(!r||!v||!l)&&(S=1,i=0,g=0,r=!0,v=!1,l=!1),w<S?!1:w>S?!r:o<i?!1:o>i?!v:f<g?!1:f>g?!l:!(p&&p<a))}e.isValidVersion=C;function T(n,m,s,u){return s.isBuiltin||typeof s.main=="undefined"?!0:_(n,m,s.engines.vscode,u)}e.isValidExtensionVersion=T;function t(n,m,s){return n==="*"||_(m,s,n)}e.isEngineValid=t;function _(n,m,s,u=[]){let p=P(F(s));if(!p)return u.push(d.localize(0,null,s)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(d.localize(1,null,s)),!1}else if(!p.majorMustEqual)return u.push(d.localize(2,null,s)),!1;return C(n,m,p)?!0:(u.push(d.localize(3,null,n,s)),!1)}}),define(we[82],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(E,A=[],F=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=d}),define(we[58],be([0,1,82]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,P,C){P instanceof d.SyncDescriptor||(P=new d.SyncDescriptor(P,[],C)),M.push([F,P])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(we[138],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=d;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const P=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(F);P.outgoing.set(this._hashFn(F),C),C.incoming.set(this._hashFn(A),P)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let P of this._nodes.values())P.outgoing.delete(F),P.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let P=this._nodes.get(F);return P||(P=new d(A),this._nodes.set(F,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,P]of this._nodes)A.push(`${F}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const P=new Set([A]),C=this._findCycle(F,P);if(C)return C}}_findCycle(A,F){for(let[P,C]of A.outgoing){if(F.has(P))return[...F,P].join(" -> ");F.add(P);const T=this._findCycle(C,F);if(T)return T;F.delete(P)}}}e.Graph=M}),define(we[4],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=P})(d=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(F,P,C,T){P[d.DI_TARGET]===P?P[d.DI_DEPENDENCIES].push({id:F,index:C,optional:T}):(P[d.DI_DEPENDENCIES]=[{id:F,index:C,optional:T}],P[d.DI_TARGET]=P)}function E(F){if(d.serviceIds.has(F))return d.serviceIds.get(F);const P=function(C,T,t){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(P,C,t,!1)};return P.toString=()=>F,d.serviceIds.set(F,P),P}e.createDecorator=E;function A(F){return F}e.refineServiceDecorator=A}),define(we[139],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,d.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[140],be([0,1,3,59,6,20,76,57,139]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function T(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(T):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(p,k){let w={selector:p,provider:k,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(w){let o=this._entries.indexOf(w);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const k=[];for(let w of this._entries)w._score>0&&k.push(w.provider);return k}ordered(p){const k=[];return this._orderedForEach(p,w=>k.push(w.provider)),k}orderedGroups(p){const k=[];let w,o;return this._orderedForEach(p,f=>{w&&o===f._score?w.push(f.provider):(o=f._score,w=[f.provider],k.push(w))}),k}_orderedForEach(p,k){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&k(w)}}_updateScores(p){let k={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let w of this._entries)if(w._score=(0,P.score)(w.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),T(w.selector)&&w._score>0){for(let o of this._entries)o._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,k){return p._score<k._score?1:p._score>k._score?-1:p._time<k._time?1:p._time>k._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let n=0;function m(u){let p=_.get(u);return p===void 0&&(p=++n,_.set(u,p)),p}class s{constructor(p,k,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=k,this.max=w,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((k,w)=>(0,M.doHash)(m(w),k),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const k=this._key(p),w=this._cache.get(k);return this._clamp(w?.value)}update(p,k){const w=this._key(p);let o=this._cache.get(w);return o||(o=new F.MovingAverage,this._cache.set(w,o)),o.update(k),this.get(p)}}e.LanguageFeatureRequestDelays=s}),define(we[60],be([0,1,2,44,140,113,34]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var C;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var T;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var t;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),I="mtk"+R,U=this.getFontStyle(y);return U&1&&(I+=" mtki"),U&2&&(I+=" mtkb"),U&4&&(I+=" mtku"),I}static getInlineStyleFromMetadata(y,R){const I=this.getForeground(y),U=this.getFontStyle(y);let L=`color: ${R[I]};`;return U&1&&(L+="font-style: italic;"),U&2&&(L+="font-weight: bold;"),U&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var m;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(y){const R=h[y];let I=R&&F.iconRegistry.get(R);return I||(console.info("No codicon found for CompletionItemKind "+y),I=F.Codicon.symbolProperty),I.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(y,R){let I=h[y];return typeof I=="undefined"&&!R&&(I=9),I}}();var s;(function(h){h[h.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var u;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(u=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var k;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(k=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function S(h){return h&&d.URI.isUri(h.uri)&&M.Range.isIRange(h.range)&&(M.Range.isIRange(h.originSelectionRange)||M.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=S;var i;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var g;(function(h){h[h.Deprecated=1]="Deprecated"})(g=e.SymbolTag||(e.SymbolTag={}));var a;(function(h){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function I(D){return y.get(D)}h.fromString=I;function U(D){return R.get(D)}h.toString=U;function L(D,x){const N=R.get(D);let V=N&&F.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+D),V=F.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}h.toCssClassName=L})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(y){this.value=y}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var v;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var b;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[46],be([0,1,25,9,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=d.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",d.isMacintosh),F.set("isLinux",d.isLinux),F.set("isWindows",d.isWindows),F.set("isWeb",d.isWeb),F.set("isMacNative",d.isMacintosh&&!d.isWeb),F.set("isEdge",A.indexOf("Edg/")>=0),F.set("isFirefox",A.indexOf("Firefox")>=0),F.set("isChrome",A.indexOf("Chrome")>=0),F.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var C;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(D){return s.create(D)}static equals(D,x){return u.create(D,x)}static notEquals(D,x){return w.create(D,x)}static regex(D,x){return r.create(D,x)}static in(D,x){return p.create(D,x)}static not(D){return o.create(D)}static and(...D){return c.create(D,null)}static or(...D){return b.create(D,null,!0)}static greater(D,x){return S.create(D,x)}static greaterEquals(D,x){return i.create(D,x)}static smaller(D,x){return g.create(D,x)}static smallerEquals(D,x){return a.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){let N=D.split("||");return b.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(D,x){let N=D.split("&&");return c.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){let N=D.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],x))}if(D.indexOf("==")>=0){let N=D.split("==");return u.create(N[0].trim(),this._deserializeValue(N[1],x))}if(D.indexOf("=~")>=0){let N=D.split("=~");return r.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(D.indexOf(" in ")>=0){let N=D.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const N=D.split(">=");return i.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const N=D.split(">");return S.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const N=D.split("<=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const N=D.split("<");return g.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(D)?o.create(D.substr(1).trim()):s.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let N=/^'([^']*)'$/.exec(D);return N?N[1].trim():D}static _deserializeRegexValue(D,x){if((0,M.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=D.indexOf("/"),V=D.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let W=D.slice(N+1,V),$=D[V+1]==="i"?"i":"";try{return new RegExp(W,$)}catch(Z){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${Z}`);return console.warn(`bad regexp-value '${D}', parse error: ${Z}`),null}}}e.ContextKeyExpr=T;function t(L,D){const x=L?L.substituteConstants():void 0,N=D?D.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=t;function _(L,D){return L.cmp(D)}class n{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class s{constructor(D,x){this.key=D,this.negated=x,this.type=2}static create(D,x=null){const N=F.get(D);return typeof N=="boolean"?N?m.INSTANCE:n.INSTANCE:new s(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:y(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=F.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:n.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class u{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=4}static create(D,x,N=null){if(typeof x=="boolean")return x?s.create(D,N):o.create(D,N);const V=F.get(D);return typeof V=="boolean"?x===(V?"true":"false")?m.INSTANCE:n.INSTANCE:new u(D,x,N)}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=F.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:n.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=u;class p{constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}static create(D,x){return new p(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),N=D.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?P.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this)),this.negated}}e.ContextKeyInExpr=p;class k{constructor(D){this._actual=D,this.type=11}static create(D){return new k(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new k(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=k;class w{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=5}static create(D,x,N=null){if(typeof x=="boolean")return x?o.create(D,N):s.create(D,N);const V=F.get(D);return typeof V=="boolean"?x===(V?"true":"false")?n.INSTANCE:m.INSTANCE:new w(D,x,N)}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=F.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?n.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class o{constructor(D,x){this.key=D,this.negated=x,this.type=3}static create(D,x=null){const N=F.get(D);return typeof N=="boolean"?N?n.INSTANCE:m.INSTANCE:new o(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:y(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=F.get(this.key);return typeof D=="boolean"?D?n.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function f(L,D){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?D(L):n.INSTANCE}class S{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=12}static create(D,x,N=null){return f(x,V=>new S(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class i{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=13}static create(D,x,N=null){return f(x,V=>new i(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=i;class g{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=14}static create(D,x,N=null){return f(x,V=>new g(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=g;class a{constructor(D,x,N){this.key=D,this.value=x,this.negated=N,this.type=15}static create(D,x,N=null){return f(x,V=>new a(D,V,N))}cmp(D){return D.type!==this.type?this.type-D.type:R(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class r{constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}static create(D,x){return new r(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return x<N?-1:x>N?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",N=D.regexp?D.regexp.source:"";return this.key===D.key&&x===N}return!1}substituteConstants(){return this}evaluate(D){let x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class v{constructor(D){this._actual=D,this.type=8}static create(D){return new v(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new v(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=v;function l(L){let D=null;for(let x=0,N=L.length;x<N;x++){const V=L[x].substituteConstants();if(L[x]!==V&&D===null){D=[];for(let W=0;W<x;W++)D[W]=L[W]}D!==null&&(D[x]=V)}return D===null?L:D}class c{constructor(D,x){this.expr=D,this.negated=x,this.type=6}static create(D,x){return c._normalizeArr(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],D.expr[x]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=l(this.expr);return D===this.expr?this:c.create(D,this.negated)}evaluate(D){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const N=[];let V=!1;for(const W of D)if(!!W){if(W.type===1){V=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&V)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const $=N.pop(),Z=N.length===0,j=b.create(W.expr.map(Q=>c.create([Q,$],null)),null,Z);j&&(N.push(j),N.sort(_))}return N.length===1?N[0]:new c(N,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let x of this.expr)D.push(...x.keys());return D}map(D){return new c(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(let x of this.expr)D.push(x.negate());this.negated=b.create(D,this,!0)}return this.negated}}class b{constructor(D,x){this.expr=D,this.negated=x,this.type=9}static create(D,x,N){return b._normalizeArr(D,x,N)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],D.expr[x]);if(V!==0)return V}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=l(this.expr);return D===this.expr?this:b.create(D,this.negated,!1)}evaluate(D){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,N){let V=[],W=!1;if(D){for(let $=0,Z=D.length;$<Z;$++){const j=D[$];if(!!j){if(j.type===0){W=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&W)return n.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(N){for(let $=0;$<V.length;$++)for(let Z=$+1;Z<V.length;Z++)I(V[$],V[Z])&&(V.splice(Z,1),Z--);if(V.length===1)return V[0]}return new b(V,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let x of this.expr)D.push(...x.keys());return D}map(D){return new b(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){let D=[];for(let x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),N=D.shift(),V=[];for(const $ of U(x))for(const Z of U(N))V.push(c.create([$,Z],null));const W=D.length===0;D.unshift(b.create(V,null,W))}this.negated=D[0]}return this.negated}}class h extends s{constructor(D,x,N){super(D,null);this._defaultValue=x,typeof N=="object"?h._info.push({...N,key:D}):N!==!0&&h._info.push({key:D,description:N,type:x!=null?typeof x:void 0})}static all(){return h._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return u.create(this.key,D)}notEqualsTo(D){return w.create(this.key,D)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(L,D){return L<D?-1:L>D?1:0}function R(L,D,x,N){return L<x?-1:L>x?1:D<N?-1:D>N?1:0}function I(L,D){if(D.type===6&&L.type!==9&&L.type!==6){for(const V of D.expr)if(L.equals(V))return!0}const x=L.negate(),N=U(x).concat(U(D));N.sort(_);for(let V=0;V<N.length;V++){const $=N[V].negate();for(let Z=V+1;Z<N.length;Z++){const j=N[Z];if($.equals(j))return!0}}return!1}e.implies=I;function U(L){return L.type===9?L.expr:[L]}}),define(we[141],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(we[47],be([0,1,20,17,9,10,2,120,4]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function T(N){return N.create===!0}e.isFileOpenForWriteOptions=T;var t;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function s(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=s;function u(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var k;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(V,W){super(V);this.code=W}}e.FileSystemProviderError=w;function o(N,V){const W=new w(N.toString(),V);return S(W,V),W}e.createFileSystemProviderError=o;function f(N){return N||o((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=f;function S(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=S;function i(N){if(!N)return k.Unknown;if(N instanceof w)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return k.Unknown;switch(V[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=i;function g(N){if(N instanceof b)return N.fileOperationResult;switch(i(N)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var a;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(V,W,$){this.resource=V,this.operation=W,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var v;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class l{constructor(V,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const Z of V){const j=$.get(Z.type);j?j.push([Z.resource,Z]):$.set(Z.type,[[Z.resource,Z]])}for(const[Z,j]of $)switch(Z){case 1:this.added=d.TernarySearchTree.forUris(()=>W),this.added.fill(j);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>W),this.updated.fill(j);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>W),this.deleted.fill(j);break}}contains(V,...W){return this.doContains(V,{includeChildren:!1},...W)}affects(V,...W){return this.doContains(V,{includeChildren:!0},...W)}doContains(V,W,...$){if(!V)return!1;const Z=$.length>0;return!!((!Z||$.includes(1))&&(this.added?.get(V)||W.includeChildren&&this.added?.findSuperstr(V))||(!Z||$.includes(0))&&(this.updated?.get(V)||W.includeChildren&&this.updated?.findSuperstr(V))||(!Z||$.includes(2))&&(this.deleted?.findSubstr(V)||W.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function c(N,V,W){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),W?(0,E.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=c;class b extends Error{constructor(V,W,$){super(V);this.fileOperationResult=W,this.options=$}}e.FileOperationError=b;class h extends b{constructor(V,W,$){super(V,2,$);this.stat=W}}e.NotModifiedSinceFileOperationError=h;var y;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=I;async function U(N,V){if(!V.hasProvider(F.URI.from({scheme:N.scheme})))return new Promise(W=>{const $=V.onDidChangeFileSystemProviderRegistrations(Z=>{Z.scheme===N.scheme&&Z.added&&($.dispose(),W())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<L.KB?(0,P.localize)(1,null,V.toFixed(0)):V<L.MB?(0,P.localize)(2,null,(V/L.KB).toFixed(2)):V<L.GB?(0,P.localize)(3,null,(V/L.MB).toFixed(2)):V<L.TB?(0,P.localize)(4,null,(V/L.GB).toFixed(2)):(0,P.localize)(5,null,(V/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var D;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(D=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(we[61],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...E){this._entries=new Map;for(let[A,F]of E)this.set(A,F)}set(E,A){const F=this._entries.get(E);return this._entries.set(E,A),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=d}),define(we[142],be([0,1,12,16,82,138,4,61]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class T extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new P.ServiceCollection,u=!1,p){this._activeInstantiations=new Set,this._services=s,this._strict=u,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...u){let p=n.traceInvocation(s),k=!1;try{return s({get:o=>{if(k)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(o,p);if(!f)throw new Error(`[invokeFunction] unknown service '${o}'`);return f}},...u)}finally{k=!0,p.stop()}}createInstance(s,...u){let p,k;return s instanceof E.SyncDescriptor?(p=n.traceCreation(s.ctor),k=this._createInstance(s.ctor,s.staticArguments.concat(u),p)):(p=n.traceCreation(s),k=this._createInstance(s,u,p)),p.stop(),k}_createInstance(s,u=[],p){let k=F._util.getServiceDependencies(s).sort((f,S)=>f.index-S.index),w=[];for(const f of k){let S=this._getOrCreateServiceInstance(f.id,p);if(!S&&this._strict&&!f.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${f.id}.`);w.push(S)}let o=k.length>0?k[0].index:u.length;if(u.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${u.length} static arguments`);let f=o-u.length;f>0?u=u.concat(new Array(f)):u=u.slice(0,o)}return new s(...[...u,...w])}_setServiceInstance(s,u){if(this._services.get(s)instanceof E.SyncDescriptor)this._services.set(s,u);else if(this._parent)this._parent._setServiceInstance(s,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let u=this._services.get(s);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):u}_getOrCreateServiceInstance(s,u){let p=this._getServiceInstanceOrDescriptor(s);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,u.branch(s,!0)):(u.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,u,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,u,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,u,p){const k=new A.Graph(f=>f.id.toString());let w=0;const o=[{id:s,desc:u,_trace:p}];for(;o.length;){const f=o.pop();if(k.lookupOrInsertNode(f),w++>1e3)throw new T(k);for(let S of F._util.getServiceDependencies(f.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${s} depends on ${S.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const g={id:S.id,desc:i,_trace:f._trace.branch(S.id,!0)};k.insertEdge(f,g),o.push(g)}}}for(;;){const f=k.roots();if(f.length===0){if(!k.isEmpty())throw new T(k);break}for(const{data:S}of f){if(this._getServiceInstanceOrDescriptor(S.id)instanceof E.SyncDescriptor){const g=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,g)}k.removeNode(S)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,u,p=[],k,w){if(this._services.get(s)instanceof E.SyncDescriptor)return this._createServiceInstance(u,p,k,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,u,p,k,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(s,u=[],p,k){if(p){const w=new d.IdleValue(()=>this._createInstance(s,u,k));return new Proxy(Object.create(null),{get(o,f){if(f in o)return o[f];let S=w.value,i=S[f];return typeof i!="function"||(i=i.bind(S),o[f]=i),i},set(o,f,S){return w.value[f]=S,!0}})}else return this._createInstance(s,u,k)}}e.InstantiationService=t;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class n{constructor(s,u){this.type=s,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return C?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return C?new n(0,s.name):n._None}branch(s,u){let p=new n(2,s.toString());return this._dep.push([s,u,p]),p}stop(){let s=Date.now()-this._start;n._totals+=s;let u=!1;function p(w,o){let f=[],S=new Array(w+1).join("	");for(const[i,g,a]of o._dep)if(g&&a){u=!0,f.push(`${S}CREATES -> ${i}`);let r=p(w+1,a);r&&f.push(r)}else f.push(`${S}uses -> ${i}`);return f.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||u)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[14],be([0,1,45,3,6,25,4]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function P(){return new Date().toISOString()}var C;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;class T extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=T;class t extends T{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...g){this.checkLogLevel(C.Trace)&&this.log(C.Trace,this.format([i,...g]))}debug(i,...g){this.checkLogLevel(C.Debug)&&this.log(C.Debug,this.format([i,...g]))}info(i,...g){this.checkLogLevel(C.Info)&&this.log(C.Info,this.format([i,...g]))}warn(i,...g){this.checkLogLevel(C.Warning)&&this.log(C.Warning,this.format([i,...g]))}error(i,...g){if(this.checkLogLevel(C.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(C.Error,this.format(a))}else this.log(C.Error,this.format([i,...g]))}critical(i,...g){this.checkLogLevel(C.Critical)&&this.log(C.Critical,this.format([i,...g]))}flush(){}format(i){let g="";for(let a=0;a<i.length;a++){let r=i[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(v){}g+=(a>0?" ":"")+r}return g}}e.AbstractMessageLogger=t;class _ extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...g){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}debug(i,...g){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}info(i,...g){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...g):console.log(`[main ${P()}]`,i,...g))}warn(i,...g){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...g):console.warn(`[main ${P()}]`,i,...g))}error(i,...g){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}critical(i,...g){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...g):console.error(`[main ${P()}]`,i,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class n extends T{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...g){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",i,...g)}debug(i,...g){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...g)}info(i,...g){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",i,...g)}warn(i,...g){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",i,...g)}error(i,...g){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",i,...g)}critical(i,...g){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...g)}dispose(){}flush(){}}e.ConsoleLogger=n;class m extends T{constructor(i,g=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(g)}trace(i,...g){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(i),...g])}debug(i,...g){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(i),...g])}info(i,...g){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(i),...g])}warn(i,...g){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(i),...g])}error(i,...g){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(i),...g])}critical(i,...g){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(i),...g])}extractMessage(i){return typeof i=="string"?i:(0,d.toErrorMessage)(i,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends T{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const g of this.logServices)g.setLevel(i);super.setLevel(i)}trace(i,...g){for(const a of this.logServices)a.trace(i,...g)}debug(i,...g){for(const a of this.logServices)a.debug(i,...g)}info(i,...g){for(const a of this.logServices)a.info(i,...g)}warn(i,...g){for(const a of this.logServices)a.warn(i,...g)}error(i,...g){for(const a of this.logServices)a.error(i,...g)}critical(i,...g){for(const a of this.logServices)a.critical(i,...g)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class u extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...g){this.logger.trace(i,...g)}debug(i,...g){this.logger.debug(i,...g)}info(i,...g){this.logger.info(i,...g)}warn(i,...g){this.logger.warn(i,...g)}error(i,...g){this.logger.error(i,...g)}critical(i,...g){this.logger.critical(i,...g)}flush(){this.logger.flush()}}e.LogService=u;class p extends E.Disposable{constructor(i,g){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(g(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,g){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,g?.always?C.Trace:this.logLevel,g),this.loggers.set(i.toString(),a),g?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class k{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return C.Info}trace(i,...g){}debug(i,...g){}info(i,...g){}warn(i,...g){}error(i,...g){}critical(i,...g){}dispose(){}flush(){}}e.NullLogService=k;function w(S){if(S.verbose)return C.Trace;if(typeof S.logLevel=="string"){const i=o(S.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function o(S){switch(S){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=o;function f(S){switch(S){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=f}),define(we[83],be([0,1,35,121,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var F;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function T(s,u){return u-s}C.compare=T;const t=Object.create(null);t[C.Error]=(0,M.localize)(0,null),t[C.Warning]=(0,M.localize)(1,null),t[C.Info]=(0,M.localize)(2,null);function _(s){return t[s]||""}C.toString=_;function n(s){switch(s){case d.default.Error:return C.Error;case d.default.Warning:return C.Warning;case d.default.Info:return C.Info;case d.default.Ignore:return C.Hint}}C.fromSeverity=n;function m(s){switch(s){case C.Error:return d.default.Error;case C.Warning:return d.default.Warning;case C.Info:return d.default.Info;case C.Hint:return d.default.Ignore}}C.toSeverity=m}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(C){const T="";function t(n){return _(n,!0)}C.makeKey=t;function _(n,m){let s=[T];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(T),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(T),n.severity!==void 0&&n.severity!==null?s.push(F.toString(n.severity)):s.push(T),n.message&&m?s.push(n.message.replace("\xA6","\\\xA6")):s.push(T),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(T),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(T),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(T),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(T),s.push(T),s.join("\xA6")}C.makeKeyOptionalMessage=_})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(we[143],be([0,1,3,35,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new C,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=P;class C{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=C}),define(we[144],be([0,1,6,9,2,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function F(P,C){return E.URI.isUri(P)?(0,M.equalsIgnoreCase)(P.scheme,C):(0,M.startsWithIgnoreCase)(P,C+":")}e.matchesScheme=F});var Be=this&&this.__decorate||function(re,e,d,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,d):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,d,M);else for(var P=re.length-1;P>=0;P--)(F=re[P])&&(A=(E<3?F(A):E>3?F(e,d,A):F(e,d))||A);return E>3&&A&&Object.defineProperty(e,d,A),A},We=this&&this.__param||function(re,e){return function(d,M){e(d,M,re)}};define(we[145],be([0,1,12,21,6,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let C=class extends E.Disposable{constructor(_,n){super();this.deferred=new d.DeferredPromise,n.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Be([We(1,e.IProgressService)],C),e.UnmanagedProgress=C;class T extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[28],be([0,1,42,10]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,P){d.ok(M.isString(F)),d.ok(M.isObject(P)),d.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,P)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(we[84],be([0,1,3,28]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,T){this.schemasById[E(C)]=T,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[62],be([0,1,15,3,10,118,84,28]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=P.Registry.as(F.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,f=!0){this.registerConfigurations([o],f)}registerConfigurations(o,f=!0){const S=this.doRegisterConfigurations(o,f);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterConfigurations(o){const f=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}updateConfigurations({add:o,remove:f}){const S=[];S.push(...this.doDeregisterConfigurations(f)),S.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,d.distinct)(S))}registerDefaultConfigurations(o){const f=[],S=[];for(const i of o)for(const g in i)if(f.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]={...this.defaultValues[g]||{},...i[g]};const a={type:"object",default:this.defaultValues[g],description:A.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};S.push(m(g)),this.configurationProperties[g]=a,this.defaultLanguageConfigurationOverridesNode.properties[g]=a}else{this.defaultValues[g]=i[g];const a=this.configurationProperties[g];a&&(this.updatePropertyDefaultValue(g,a),this.updateSchema(g,a))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(o){const f=[];for(const S of o)for(const i in S)if(f.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const g=this.configurationProperties[i];g&&(this.updatePropertyDefaultValue(i,g),this.updateSchema(i,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const f of o)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,f){const S=[];return o.forEach(i=>{S.push(...this.validateAndRegisterProperties(i,f,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),S}doDeregisterConfigurations(o){const f=[],S=i=>{if(i.properties)for(const g in i.properties)f.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,i.properties[g]);i.allOf&&i.allOf.forEach(g=>S(g))};for(const i of o){S(i);const g=this.configurationContributors.indexOf(i);g!==-1&&this.configurationContributors.splice(g,1)}return f}validateAndRegisterProperties(o,f=!0,S,i=3){i=E.isUndefinedOrNull(o.scope)?i:o.scope;let g=[],a=o.properties;if(a)for(let v in a){if(f&&p(v)){delete a[v];continue}const l=a[v];if(this.updatePropertyDefaultValue(v,l),e.OVERRIDE_PROPERTY_PATTERN.test(v)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?i:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!S?.restrictedConfigurations?.includes(v):l.restricted),a[v].hasOwnProperty("included")&&!a[v].included){this.excludedConfigurationProperties[v]=a[v],delete a[v];continue}else this.configurationProperties[v]=a[v];!a[v].deprecationMessage&&a[v].markdownDeprecationMessage&&(a[v].deprecationMessage=a[v].markdownDeprecationMessage),g.push(v)}let r=o.allOf;if(r)for(let v of r)g.push(...this.validateAndRegisterProperties(v,f,S,i));return g}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const f=S=>{let i=S.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);let g=S.allOf;g&&g.forEach(f)};f(o)}updateSchema(o,f){switch(e.allSettings.properties[o]=f,f.scope){case 1:e.applicationSettings.properties[o]=f;break;case 2:e.machineSettings.properties[o]=f;break;case 6:e.machineOverridableSettings.properties[o]=f;break;case 3:e.windowSettings.properties[o]=f;break;case 4:e.resourceSettings.properties[o]=f;break;case 5:e.resourceSettings.properties[o]=f,this.resourceLanguageSettingsSchema.properties[o]=f;break}}removeFromSchema(o,f){switch(delete e.allSettings.properties[o],f.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const f=`[${o}]`,S={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,S),e.allSettings.properties[f]=S,e.applicationSettings.properties[f]=S,e.machineSettings.properties[f]=S,e.machineOverridableSettings.properties[f]=S,e.windowSettings.properties[f]=S,e.resourceSettings.properties[f]=S}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,f){let S=this.defaultValues[o];E.isUndefined(S)&&(S=f.default),E.isUndefined(S)&&(S=s(f.type)),f.default=S}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=m;function s(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=s;const u=new _;P.Registry.add(e.Extensions.Configuration,u);function p(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?A.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?A.localize(6,null,w):null:A.localize(4,null)}e.validateProperty=p;function k(){const w=[],o=u.getConfigurationProperties();for(const f of Object.keys(o))w.push([f,o[f].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=k}),define(we[85],be([0,1,23,10,2,62,4,28]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof E.URI)}e.isConfigurationOverrides=C;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(g,a){const r=a?g?a.keys.filter(R=>g.keys.indexOf(R)===-1):[...a.keys]:[],v=g?a?g.keys.filter(R=>a.keys.indexOf(R)===-1):[...g.keys]:[],l=[];if(a&&g){for(const R of g.keys)if(a.keys.indexOf(R)!==-1){const I=k(g.contents,R),U=k(a.contents,R);d.equals(I,U)||l.push(R)}}const c=[],b=R=>{const I={};for(const U of R)for(const L of U.identifiers)I[S(L)]=U;return I},h=a?b(a.overrides):{},y=g?b(g.overrides):{};if(Object.keys(h).length)for(const R of r){const I=h[R];I&&c.push([(0,A.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(y).length)for(const R of v){const I=y[R];I&&c.push([(0,A.overrideIdentifierFromKey)(R),I.keys])}if(Object.keys(h).length&&Object.keys(y).length)for(const R of l){const I=y[R],U=h[R];if(I&&U){const L=_({contents:I.contents,keys:I.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});c.push([(0,A.overrideIdentifierFromKey)(R),[...L.added,...L.removed,...L.updated]])}}return{added:r,removed:v,updated:l,overrides:c}}e.compare=_;function n(g,a){const r=[];for(const v of Object.keys(g))if(A.OVERRIDE_PROPERTY_PATTERN.test(v)){const l={};for(const c in g[v])l[c]=g[v][c];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(v).trim()],keys:Object.keys(l),contents:m(l,a)})}return r}e.toOverrides=n;function m(g,a){const r=Object.create(null);for(let v in g)s(r,v,g[v],a);return r}e.toValuesTree=m;function s(g,a,r,v){const l=a.split("."),c=l.pop();let b=g;for(let h=0;h<l.length;h++){let y=l[h],R=b[y];switch(typeof R){case"undefined":R=b[y]=Object.create(null);break;case"object":break;default:v(`Ignoring ${a} as ${l.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}b=R}if(typeof b=="object"&&b!==null)try{b[c]=r}catch(h){v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}else v(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=s;function u(g,a){const r=a.split(".");p(g,r)}e.removeFromValueTree=u;function p(g,a){const r=a.shift();if(a.length===0){delete g[r];return}if(Object.keys(g).indexOf(r)!==-1){const v=g[r];typeof v=="object"&&!Array.isArray(v)&&(p(v,a),Object.keys(v).length===0&&delete g[r])}}function k(g,a,r){function v(b,h){let y=b;for(const R of h){if(typeof y!="object"||y===null)return;y=y[R]}return y}const l=a.split("."),c=v(g,l);return typeof c=="undefined"?r:c}e.getConfigurationValue=k;function w(g,a,r){Object.keys(a).forEach(v=>{v!=="__proto__"&&(v in g?M.isObject(g[v])&&M.isObject(a[v])?w(g[v],a[v],r):r&&(g[v]=a[v]):g[v]=a[v])})}e.merge=w;function o(){const g=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(g)}e.getConfigurationKeys=o;function f(){const g=Object.create(null),a=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in a){let v=a[r].default;s(g,r,v,l=>console.error(`Conflict in default settings: ${l}`))}return g}e.getDefaultValues=f;function S(g){return`[${g}]`}e.keyFromOverrideIdentifier=S;function i(g,a,r){const v=g.inspect(a),l=g.inspect(r);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:v.defaultValue}e.getMigratedSettingValue=i}),define(we[146],be([0,1,15,3,102,6,20,23,10,2,85,62,28]),function(re,e,d,M,E,A,F,P,C,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(i={},g=[],a=[]){this._contents=i,this._keys=g,this._overrides=a,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,g){const a=this.getContentsForOverrideIdentifer(g);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.keys;return[]}override(i){let g=this.overrideConfigurations.get(i);return g||(g=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,g)),g}merge(...i){const g=P.deepClone(this.contents),a=P.deepClone(this.overrides),r=[...this.keys];for(const v of i){this.mergeContents(g,v.contents);for(const l of v.overrides){const[c]=a.filter(b=>d.equals(b.identifiers,l.identifiers));c?this.mergeContents(c.contents,l.contents):a.push(P.deepClone(l))}for(const l of v.keys)r.indexOf(l)===-1&&r.push(l)}return new m(g,r,a)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const g=this.getContentsForOverrideIdentifer(i);if(!g||typeof g!="object"||!Object.keys(g).length)return this;let a={};for(const r of d.distinct([...Object.keys(this.contents),...Object.keys(g)])){let v=this.contents[r],l=g[r];l&&(typeof v=="object"&&typeof l=="object"?(v=P.deepClone(v),this.mergeContents(v,l)):v=l),a[r]=v}return new m(a,this.keys,this.overrides)}mergeContents(i,g){for(const a of Object.keys(g)){if(a in i&&C.isObject(i[a])&&C.isObject(g[a])){this.mergeContents(i[a],g[a]);continue}i[a]=P.deepClone(g[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const g of this.overrides)if(g.identifiers.indexOf(i)!==-1)return g.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,g){this.addKey(i),(0,t.addToValueTree)(this.contents,i,g,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let g=this.keys.length;for(let a=0;a<g;a++)i.indexOf(this.keys[a])===0&&(g=a);this.keys.splice(g,1,i)}removeKey(i){let g=this.keys.indexOf(i);return g!==-1?(this.keys.splice(g,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const i=(0,t.getDefaultValues)(),g=(0,t.getConfigurationKeys)(),a=[];for(const r of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,_.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(i[r]),contents:(0,t.toValuesTree)(i[r],v=>console.error(`Conflict in default settings file: ${v}`))});super(i,g,a)}}e.DefaultConfigurationModel=s;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,g){if(!C.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,g)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,g){this._raw=i;const{contents:a,keys:r,overrides:v,restricted:l}=this.doParseRaw(i,g);this._configurationModel=new m(a,r,v),this._restrictedConfigurations=l||[]}doParseContent(i){let g={},a=null,r=[],v=[],l=[];function c(h){Array.isArray(r)?r.push(h):a!==null&&(r[a]=h)}let b={onObjectBegin:()=>{let h={};c(h),v.push(r),r=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{r=v.pop()},onArrayBegin:()=>{let h=[];c(h),v.push(r),r=h,a=null},onArrayEnd:()=>{r=v.pop()},onLiteralValue:c,onError:(h,y,R)=>{l.push({error:h,offset:y,length:R})}};if(i)try{E.visit(i,b),g=r[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return g}doParseRaw(i,g){const a=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,a,!0,g);i=r.raw;const v=(0,t.toValuesTree)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),l=Object.keys(i),c=(0,t.toOverrides)(i,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:v,keys:l,overrides:c,restricted:r.restricted}}filter(i,g,a,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const v={},l=[];for(let c in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(c)&&a){const b=this.filter(i[c],g,!1,r);v[c]=b.raw,l.push(...b.restricted)}else{const b=g[c],h=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&l.push(c),(h===void 0||r.scopes===void 0||r.scopes.includes(h))&&(r.skipRestricted&&b?.restricted||(v[c]=i[c]))}return{raw:v,restricted:l}}}e.ConfigurationModelParser=u;class p extends A.Disposable{constructor(i,g,a,r){super();this.userSettingsResource=i,this.scopes=g,this.fileService=r,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class k{constructor(i,g,a=new m,r=new m,v=new F.ResourceMap,l=new m,c=new F.ResourceMap,b=!0){this._defaultConfiguration=i,this._localUserConfiguration=g,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=v,this._memoryConfiguration=l,this._memoryConfigurationByResource=c,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,g,a){return this.getConsolidateConfigurationModel(g,a).getValue(i)}updateValue(i,g,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new m,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,g===void 0?r.removeValue(i):r.setValue(i,g),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,g,a){const r=this.getConsolidateConfigurationModel(g,a),v=this.getFolderConfigurationModelForResource(g.resource,a),l=g.resource?this._memoryConfigurationByResource.get(g.resource)||this._memoryConfiguration:this._memoryConfiguration,c=g.overrideIdentifier?this._defaultConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),b=g.overrideIdentifier?this.userConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),h=g.overrideIdentifier?this.localUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),y=g.overrideIdentifier?this.remoteUserConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),R=a?g.overrideIdentifier?this._workspaceConfiguration.freeze().override(g.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,I=v?g.overrideIdentifier?v.freeze().override(g.overrideIdentifier).getValue(i):v.freeze().getValue(i):void 0,U=g.overrideIdentifier?l.override(g.overrideIdentifier).getValue(i):l.getValue(i),L=r.getValue(i),D=d.distinct(d.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(i,x)!==void 0);return{defaultValue:c,userValue:b,userLocalValue:h,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:I,memoryValue:U,value:L,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:g.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,workspaceFolder:I!==void 0?{value:v?.freeze().getValue(i),override:g.overrideIdentifier?v?.freeze().getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:l.getValue(i),override:g.overrideIdentifier?l.getOverrideValue(i,g.overrideIdentifier):void 0}:void 0,overrideIdentifiers:D.length?D:void 0}}keys(i){const g=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:g?g.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,g){this._folderConfigurations.set(i,g),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,g){const a=g.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const v=(0,_.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(v),c=i.getKeysForOverrideIdentifier(v),b=[...c.filter(h=>l.indexOf(h)===-1),...l.filter(h=>c.indexOf(h)===-1),...l.filter(h=>!P.equals(this._defaultConfiguration.override(v).getValue(h),i.override(v).getValue(h)))];return[v,b]});return this.updateDefaultConfiguration(i),{keys:g,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.localUserConfiguration,i),l=[...g,...a,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateRemoteUserConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.remoteUserConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:v}}compareAndUpdateWorkspaceConfiguration(i){const{added:g,updated:a,removed:r,overrides:v}=(0,t.compare)(this.workspaceConfiguration,i);let l=[...g,...a,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:v}}compareAndUpdateFolderConfiguration(i,g){const a=this.folderConfigurations.get(i),{added:r,updated:v,removed:l,overrides:c}=(0,t.compare)(a,g);let b=[...r,...v,...l];return(b.length||!a)&&this.updateFolderConfiguration(i,g),{keys:b,overrides:c}}compareAndDeleteFolderConfiguration(i){const g=this.folderConfigurations.get(i);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:r,removed:v,overrides:l}=(0,t.compare)(g,void 0);return{keys:[...a,...r,...v],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,g){let a=this.getConsolidatedConfigurationModelForResource(i,g);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},g){let a=this.getWorkspaceConsolidatedConfiguration();if(g&&i){const r=g.getFolder(i);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const v=this._memoryConfigurationByResource.get(i);v&&(a=a.merge(v))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let g=this._foldersConsolidatedConfigurations.get(i);if(!g){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(g=a.merge(r),this._freeze&&(g=g.freeze()),this._foldersConsolidatedConfigurations.set(i,g)):g=a}return g}getFolderConfigurationModelForResource(i,g){if(g&&i){const a=g.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,g)=>{const{contents:a,overrides:r,keys:v}=this._folderConfigurations.get(g);return i.push([g,{contents:a,overrides:r,keys:v}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(g=>i.add(g)),this.userConfiguration.freeze().keys.forEach(g=>i.add(g)),this._workspaceConfiguration.freeze().keys.forEach(g=>i.add(g)),this._folderConfigurations.forEach(g=>g.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const g=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>g.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(r=>g.add(r))),[...g.values()]}static parse(i){const g=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),r=this.parseConfigurationModel(i.workspace),v=i.folders.reduce((l,c)=>(l.set(T.URI.revive(c[0]),this.parseConfigurationModel(c[1])),l),new F.ResourceMap);return new k(g,a,new m,r,v,new m,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new m(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=k;function w(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const i=new Set,g=new Map;for(const r of S)r.keys.forEach(v=>i.add(v)),r.overrides.forEach(([v,l])=>{const c=(0,F.getOrSet)(g,v,new Set);l.forEach(b=>c.add(b))});const a=[];return g.forEach((r,v)=>a.push([v,[...r.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=w;class o{constructor(i,g,a,r){this.change=i,this.previous=g,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const v=new Set;i.keys.forEach(c=>v.add(c)),i.overrides.forEach(([,c])=>c.forEach(b=>v.add(b))),this.affectedKeys=[...v.values()];const l=new m;this.affectedKeys.forEach(c=>l.setValue(c,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,g){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(g){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,g,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,g,this.currentWorkspace);return!P.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(i,g){let a=(0,t.toValuesTree)({[g]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(i=i[r],!i)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=o;class f extends o{constructor(i,g,a,r){super({keys:i.allKeys(),overrides:[]},void 0,i,g);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=f}),define(we[86],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,P=M.Unknown,C){super(F);this._message=F,this._code=P,this._detail=C,this.isHandled=P===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(we[63],be([0,1,11]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(T){return T.scheme===d.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=M;function E(T){if(!T)return;const t=T.indexOf("+");return t<0?T:T.substr(0,t)}e.getRemoteName=E;function A(T){return T.scheme!==d.Schemas.file&&T.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=A;function F(T){if(T.folders.length)return T.folders.every(t=>A(t.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=F;function P(T){return F(T)?.scheme}e.getVirtualWorkspaceScheme=P;function C(T){return F(T)!==void 0}e.isVirtualWorkspace=C}),define(we[26],be([0,1,9,4,63]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,s){if(typeof m=="undefined"||m===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof m=="string"||typeof s=="string"){let u=typeof m=="string"?m:m.value,p=typeof s=="string"?s:s.value;return d.equalsIgnoreCase(u,p)}return m._lower===s._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function T(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function t(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=t;function _(n,m){if(m&&n.enableProposedApi){const s=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[147],be([0,1,9,26]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(s,u){return s.uuid&&u.uuid?s.uuid===u.uuid:s.id===u.id?!0:(0,d.compareIgnoreCase)(s.id,u.id)===0}e.areSameExtensions=E;class A{constructor(u,p){this.version=p,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof A?E(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=A;function F(s,u){return`${s}.${u}`}e.getExtensionId=F;function P(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function C(s,u){return P(F(s,u))}e.getGalleryExtensionId=C;function T(s,u){const p=[],k=w=>{for(const o of p)if(o.some(f=>E(u(f),u(w))))return o;return null};for(const w of s){const o=k(w);o?o.push(w):p.push([w])}return p}e.groupByExtension=T;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const u=new Set;for(const p of s)p.malicious&&u.add(p.id.id);return u}e.getMaliciousExtensionsSet=n;function m(s,u){const p=[],k=u.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const w=k.shift();if(w&&p.every(o=>!E(o.identifier,{id:w}))){const o=s.filter(f=>E(f.identifier,{id:w}));o.length===1&&(p.push(o[0]),k.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(we[148],be([0,1,3,25,4,14]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var F;(function(s){s.Http="http",s.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=_;function n(s,u){return u?u!==1&&s<1024:!M.isWindows&&s<1024}e.isPortPrivileged=n;let m=class{constructor(u){this.logService=u,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u,p){return this._tunnelProvider=u,u?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],p=Array.from(this._tunnels.values());for(let k of p){const w=Array.from(k.values());for(let o of w){const f=await o.value;f&&u.push(f)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:p}of u.values())await p.then(k=>k?.dispose());u.clear()}this._tunnels.clear()}openTunnel(u,p,k,w,o=!1,f=P.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${k} on local port ${w}.`),!u)return;p||(p="localhost");const i=this.retainOrCreateTunnel(u,p,k,w,o,f,S);return i?i.then(g=>{if(!g){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,k);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(g);return(g.tunnelRemoteHost!==p||g.tunnelRemotePort!==k)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const p=this._tunnels.get(u.tunnelRemoteHost);if(p){const k=p.get(u.tunnelRemotePort);k&&(k.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,k))}}}}async tryDisposeTunnel(u,p,k){if(k.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${p}.`);const w=k.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(p),w}}async closeTunnel(u,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${p} `);const k=this._tunnels.get(u);if(k&&k.has(p)){const w=k.get(p);w.refcount=0,await this.tryDisposeTunnel(u,p,w)}}addTunnelToMap(u,p,k){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(p,{refcount:1,value:k})}async removeEmptyTunnelFromMap(u,p){const k=this._tunnels.get(u);k&&(await k.get(p)||k.delete(p),k.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,p){let k=[u];t(u)?(k.push(...e.LOCALHOST_ADDRESSES),k.push(...e.ALL_INTERFACES_ADDRESSES)):_(u)&&k.push(...e.ALL_INTERFACES_ADDRESSES);const w=k.map(o=>this._tunnels.get(o));for(const o of w){const f=o?.get(p);if(f)return f}}canTunnel(u){return!!T(u)}createWithProvider(u,p,k,w,o,f,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${k} on local port ${w}.`);const g={elevationRequired:o?n(w===void 0?k:w):!1},a={remoteAddress:{host:p,port:k},localAddressPort:w,privacy:f,public:f!==P.Private,protocol:S},r=u.forwardPort(a,g);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(p,k,r),r}};m=Be([We(0,A.ILogService)],m),e.AbstractTunnelService=m}),define(we[149],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,F=5){let P;return P=A(C=>{const T=typeof C=="string"?C:C.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(T);return}const _=setTimeout(()=>this.flushBuffer(E),F);t={data:[T],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),P.dispose()}},this._terminalBufferMap.set(E,t)}),P}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=d}),define(we[150],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(we[48],be([0,1,34,3,6,4,28,150]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var C;(function(p){function k(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=k})(C=e.ThemeColor||(e.ThemeColor={}));function T(p){return{id:p}}e.themeColorFromId=T;var t;(function(p){function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color=="undefined"||C.isThemeColor(g.color))}p.isThemeIcon=k;const w=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function o(g){const a=w.exec(g);if(!a)return;let[,r]=a;return{id:r}}p.fromString=o;function f(g,a){let r=g.id;const v=r.lastIndexOf("~");return v!==-1&&(r=r.substring(0,v)),a&&(r=`${r}~${a}`),{id:r}}p.modify=f;function S(g,a){return g.id===a.id&&g.color?.id===a.color?.id}p.isEqual=S;function i(g,a){return{id:g.id,color:a?T(a):void 0}}p.asThemeIcon=i,p.asClassNameArray=d.CSSIcon.asClassNameArray,p.asClassName=d.CSSIcon.asClassName,p.asCSSSelector=d.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function _(p){switch(p){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,E.toDisposable)(()=>{const w=this.themingParticipants.indexOf(k);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;F.Registry.add(e.Extensions.ThemingContribution,m);function s(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=s;class u extends E.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,w){let o=this.theme.getColor(k);return o&&w&&(o=w(o,this.theme)),o?o.toString():null}}e.Themable=u}),define(we[151],be([0,1,12,34,3,122,84,28,48]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class T{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,w,o,f){const S=this.iconsById[k];if(S){if(o&&!S.description){S.description=o,this.iconSchema.properties[k].markdownDescription=`${o} $(${k})`;const a=this.iconReferenceSchema.enum.indexOf(k);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=o),this._onDidChange.fire()}return S}let i={id:k,description:o,defaults:w,deprecationMessage:f};this.iconsById[k]=i;let g={$ref:"#/definitions/icons"};return f&&(g.deprecationMessage=f),o&&(g.markdownDescription=`${o}: $(${k})`),this.iconSchema.properties[k]=g,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const w=this.iconReferenceSchema.enum.indexOf(k);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,w){const o=this.iconFontsById[k];if(o)return o;let f={id:k,definition:w};return this.iconFontsById[k]=f,this._onDidChange.fire(),f}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(S,i)=>S.id.localeCompare(i.id),w=S=>{for(;C.ThemeIcon.isThemeIcon(S.defaults);)S=this.iconsById[S.defaults.id];return`codicon codicon-${S?S.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(S=>this.iconsById[S]);for(const S of f.filter(i=>!!i.description).sort(k))o.push(`|<i class="${w(S)}"></i>|${S.id}|${C.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const S of f.filter(i=>!C.ThemeIcon.isThemeIcon(i.defaults)).sort(k))o.push(`|<i class="${w(S)}"></i>|${S.id}|`);return o.join(`
`)}}const t=new T;P.Registry.add(e.Extensions.IconContribution,t);function _(p,k,w,o){return t.registerIcon(p,k,w,o)}e.registerIcon=_;function n(){return t}e.getIconRegistry=n;function m(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=P.Registry.as(F.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new d.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=C.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[49],be([0,1,20,24,2,4]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function C(n){const m=n;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class T{constructor(m,s,u,p,k){this._id=m,this._transient=u,this._configuration=p,this._ignorePathCasing=k,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class t{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(we[64],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(we[37],be([0,1,11,24,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(P=>{const C=this._providerInfo.get(P.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(P,C){C===null?this._providerInfo.delete(P):this._providerInfo.set(P,C)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,12]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,P,C){this._deferredPromises=new Map,this._id=F,this._shared=P,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of T.values())t.complete()}catch(t){for(const _ of T.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,P){let C=this._value[F];return typeof C=="undefined"&&(C=P),C}update(F,P){this._value[F]=P;let C=this._deferredPromises.get(F);if(C!==void 0)return C.p;const T=new d.DeferredPromise;return this._deferredPromises.set(F,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,P){super(F.identifier.value,!0,P);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(we[153],be([0,1,3,2,14]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,C){this._logService=P,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,C,T){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(C.value,T)}$acceptDirtyStateChanged(P,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptDirty(C)}$acceptModelSaved(P){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(P,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,C);const T=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));T.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=Be([We(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[13],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[154],be([0,1,26,3]),function(re,e,d,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,C){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(P.identifier),Ze(this,E,C,"f"),Ae(this,E,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Ae(this,E,"f").get(this._id,P)}store(P,C){return Ae(this,E,"f").store(this._id,P,C)}delete(P){return Ae(this,E,"f").delete(this._id,P)}}e.ExtensionSecrets=A,E=new WeakMap}),define(we[87],be([0,1,4,3]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(we[50],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(w,o)=>{const f={controllerId:o};return M.set(w,f),f};e.createPrivateApiFor=E;const A=w=>M.get(w);e.getPrivateApiFor=A;const F=(w,o,f,S)=>{let i=f;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!S(i,g)){const a=i;i=g,w.listener?.({op:3,key:o,value:g,previous:a})}}}},P=(w,o)=>w===o,C={range:(w,o)=>w===o?!0:!w||!o?!1:w.isEqual(o),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(w,o)=>!(w.length!==o.length||w.some(f=>!o.find(S=>f.id===S.id)))},T=Object.keys(C),t=(w,o)=>({range:F(w,"range",void 0,C.range),label:F(w,"label",o,C.label),description:F(w,"description",void 0,C.description),canResolveChildren:F(w,"canResolveChildren",!1,C.canResolveChildren),busy:F(w,"busy",!1,C.busy),error:F(w,"error",void 0,C.error),tags:F(w,"tags",[],C.tags)}),_=(w,o)=>{const f=new Map;for(const S of T)C[S](w[S],o[S])||f.set(S,o[S]);return f};e.diffTestItems=_;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class s extends Error{constructor(o,f,S){super(`TestItem with ID "${o}" is from controller "${f}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=s;const u=w=>{const o=(0,e.getPrivateApiFor)(w);let f=new Map;return{get size(){return f.size},forEach(S,i){for(const g of f.values())S.call(i,g,this)},replace(S){const i=new Map,g=new Set(f.keys()),a={op:4,ops:[]};for(const r of S){if(!(r instanceof p))throw new m(r.id);const v=(0,e.getPrivateApiFor)(r).controllerId;if(v!==o.controllerId)throw new s(r.id,v,o.controllerId);if(i.has(r.id))throw new n(r.id);i.set(r.id,r),g.delete(r.id),a.ops.push({op:0,item:r})}for(const r of g.keys())a.ops.push({op:1,id:r});o.listener?.(a),f=i},add(S){if(!(S instanceof p))throw new m(S.id);f.set(S.id,S),o.listener?.({op:0,item:S})},delete(S){f.delete(S)&&o.listener?.({op:1,id:S})},get(S){return f.get(S)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class p{constructor(o,f,S,i){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const g=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof k?void 0:g.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(g,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class k extends p{constructor(o,f){super(o,o,f,void 0)}}e.TestItemRootImpl=k}),define(we[65],be([0,1,4,148,3,13]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(C){function T(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=T;function t(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,t){return{dispose:()=>{}}}async $providePortAttributes(T,t,_,n,m){return[]}async $forwardPort(T,t){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([We(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[7],be([0,1,15,16,77,20,79,9,10,2,36,47,86]),function(re,e,d,M,E,A,F,P,C,T,t,_,n){"use strict";var m,s,u,p,k,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(B){function O(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(O,B),Object.setPrototypeOf(O.prototype,B.prototype),O}let U=k=class{constructor(O){m.set(this,void 0),Ze(this,m,O,"f")}static from(...O){let ie=O;return new k(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}dispose(){typeof Ae(this,m,"f")=="function"&&(Ae(this,m,"f").call(this),Ze(this,m,void 0,"f"))}};m=new WeakMap,U=k=Be([I],U),e.Disposable=U;let L=w=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ve=O[Ee];Ve.isBefore(ie)&&(ie=Ve)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ve=O[Ee];Ve.isAfter(ie)&&(ie=Ve)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof w)return!0;let{line:ie,character:Ee}=O;return typeof ie=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=0:typeof O=="number"?Ee=O:(Ee=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),Ee===0&&ie===0?this:new w(this.line+Ee,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=this.line:typeof O=="number"?Ee=O:(Ee=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),Ee===this.line&&ie===this.character?this:new w(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};L=w=Be([I],L),e.Position=L;let D=o=class{constructor(O,ie,Ee,Ve){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(tt=new L(O,ie),ot=new L(Ee,Ve)):O instanceof L&&ie instanceof L&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange(O){return O instanceof o?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof o?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=L.Max(O.start,this._start),Ee=L.Min(O.end,this._end);if(!ie.isAfter(Ee))return new o(ie,Ee)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=L.Min(O.start,this._start),Ee=L.Max(O.end,this.end);return new o(ie,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let Ee;return O?L.isPosition(O)?Ee=O:(Ee=O.start||this.start,ie=O.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ie.isEqual(this.end)?this:new o(Ee,ie)}toJSON(){return[this.start,this.end]}};D=o=Be([I],D),e.Range=D;let x=f=class extends D{constructor(O,ie,Ee,Ve){let tt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(tt=new L(O,ie),ot=new L(Ee,Ve)):O instanceof L&&ie instanceof L&&(tt=O,ot=ie),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection(O){return O instanceof f?!0:O?D.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=f=Be([I],x),e.Selection=x;class N{constructor(O,ie,Ee){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=N;class V extends Error{constructor(O,ie=n.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(O);this._message=O,this._code=ie,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(O,ie){return new V(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new V(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var $;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=S=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof S?!0:O?D.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new S(O,ie)}static insert(O,ie){return S.replace(new D(O,O),ie)}static delete(O){return S.replace(O,"")}static setEndOfLine(O){const ie=new S(new D(new L(0,0),new L(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!D.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Z=S=Be([I],Z),e.TextEdit=Z;var j;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,Ee,Ve){this._edits.push({_type:1,from:O,to:ie,options:Ee,metadata:Ve})}createFile(O,ie,Ee){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:Ee})}deleteFile(O,ie,Ee){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:Ee})}replaceNotebookMetadata(O,ie,Ee){this._edits.push({_type:3,metadata:Ee,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,Ee,Ve,tt){let ot,lt,Dt=[],Rt;if(Ht.isNotebookRange(ie)&&Pe.isNotebookCellDataArray(Ee)&&!Pe.isNotebookCellDataArray(Ve)?(ot=ie.start,lt=ie.end,Dt=Ee,Rt=Ve):typeof ie=="number"&&typeof Ee=="number"&&Pe.isNotebookCellDataArray(Ve)&&(ot=ie,lt=Ee,Dt=Ve,Rt=tt),ot===void 0||lt===void 0)throw new Error("Invalid arguments");(ot!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:lt-ot,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(O,ie,Ee,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:ie,metadata:Ee}})}replace(O,ie,Ee,Ve){this._edits.push({_type:2,uri:O,edit:new Z(ie,Ee),metadata:Ve})}insert(O,ie,Ee,Ve){this.replace(O,new D(ie,ie),Ee,Ve)}delete(O,ie,Ee){this.replace(O,ie,"",Ee)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const Ee of ie)Ee&&this._edits.push({_type:2,uri:O,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ve=this._edits[Ee];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[Ee]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===O.toString()&&ie.push(Ee.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Ee=O.get(ie.uri);Ee||(Ee=[ie.uri,[]],O.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Be([I],Q),e.WorkspaceEdit=Q;let ae=i=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof i?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=i._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const Ee=new i;Ee._tabstop=this._tabstop,O(Ee),this._tabstop=Ee._tabstop,O=Ee.value}else O=i._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const Ee=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const Ee=new i;Ee._tabstop=this._tabstop,ie(Ee),this._tabstop=Ee._tabstop,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ae=i=Be([I],ae),e.SnippetString=ae;var pe;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(pe=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=g=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof D)this.range=ie;else if(ie instanceof L)this.range=new D(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof g?!0:O?D.isRange(O.range)&&T.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=g=Be([I],Fe),e.Location=Fe;let Ge=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&D.isRange(O.location.range)&&T.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};Ge=Be([I],Ge),e.DiagnosticRelatedInformation=Ge;let Ne=class{constructor(O,ie,Ee=ce.Error){if(!D.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=Ee}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,d.equals)(O.tags,ie.tags)&&(0,d.equals)(O.relatedInformation,ie.relatedInformation,Ge.isEqual)}};Ne=Be([I],Ne),e.Diagnostic=Ne;let ze=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};ze=Be([I],ze),e.Hover=ze;var Je;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Je=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(O,ie=Je.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Je[this.kind]}}};Qe=Be([I],Qe),e.DocumentHighlight=Qe;var Ke;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Ke=e.SymbolKind||(e.SymbolKind={}));var H;(function(B){B[B.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let K=a=class{constructor(O,ie,Ee,Ve,tt){this.name=O,this.kind=ie,this.containerName=tt,typeof Ee=="string"&&(this.containerName=Ee),Ve instanceof Fe?this.location=Ve:Ee instanceof D&&(this.location=new Fe(Ve,Ee)),a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ke[this.kind],location:this.location,containerName:this.containerName}}};K=a=Be([I],K),e.SymbolInformation=K;let ee=r=class{constructor(O,ie,Ee,Ve,tt){this.name=O,this.detail=ie,this.kind=Ee,this.range=Ve,this.selectionRange=tt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};ee=r=Be([I],ee),e.DocumentSymbol=ee;var se;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(O,ie){this.title=O,this.kind=ie}};G=Be([I],G),e.CodeAction=G;let ne=v=class{constructor(O){this.value=O}append(O){return new v(this.value?this.value+v.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+v.sep)}};ne.sep=".",ne=v=Be([I],ne),e.CodeActionKind=ne,ne.Empty=new ne(""),ne.QuickFix=ne.Empty.append("quickfix"),ne.Refactor=ne.Empty.append("refactor"),ne.RefactorExtract=ne.Refactor.append("extract"),ne.RefactorInline=ne.Refactor.append("inline"),ne.RefactorRewrite=ne.Refactor.append("rewrite"),ne.Source=ne.Empty.append("source"),ne.SourceOrganizeImports=ne.Source.append("organizeImports"),ne.SourceFixAll=ne.Source.append("fixAll");let de=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=Be([I],de),e.SelectionRange=de;class Te{constructor(O,ie,Ee,Ve,tt,ot){this.kind=O,this.name=ie,this.detail=Ee,this.uri=Ve,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=Te;class xe{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=xe;class $e{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=$e;var je;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};et=Be([I],et),e.CodeLens=et;let st=l=class{constructor(O,ie=!1){s.set(this,void 0),Ze(this,s,new E.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof l?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,s,"f").value}set value(O){Ae(this,s,"f").value=O}get isTrusted(){return Ae(this,s,"f").isTrusted}set isTrusted(O){Ae(this,s,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,s,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,s,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,s,"f").supportHtml}set supportHtml(O){Ae(this,s,"f").supportHtml=O}appendText(O){return Ae(this,s,"f").appendText(O),this}appendMarkdown(O){return Ae(this,s,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Ae(this,s,"f").appendCodeblock(ie??"",O),this}};s=new WeakMap,st=l=Be([I],st),e.MarkdownString=st;let _e=class{constructor(O,ie){this.label=O,this.documentation=ie}};_e=Be([I],_e),e.ParameterInformation=_e;let nt=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};nt=Be([I],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Be([I],q),e.SignatureHelp=q;var X;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(O,ie,Ee){this.text=O,this.position=ie,this.kind=Ee}};Ue=Be([I],Ue),e.InlayHint=Ue;var qe;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var mt;(function(B){B[B.Deprecated=1]="Deprecated"})(mt=e.CompletionItemTag||(e.CompletionItemTag={}));let ut=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ut=Be([I],ut),e.CompletionItem=ut;let St=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};St=Be([I],St),e.CompletionList=St;let Tt=class{constructor(O,ie,Ee){this.text=O,this.range=ie,this.command=Ee}};Tt=Be([I],Tt),e.InlineSuggestion=Tt;let It=class{constructor(O){this.items=O}};It=Be([I],It),e.InlineSuggestions=It;var Xe;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var vt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ye;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var te;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var oe;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(oe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(te=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let he=class{constructor(O,ie){if(ie&&!T.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!D.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};he=Be([I],he),e.DocumentLink=he;let ke=class{constructor(O,ie,Ee,Ve){this.red=O,this.green=ie,this.blue=Ee,this.alpha=Ve}};ke=Be([I],ke),e.Color=ke;let Oe=class{constructor(O,ie){if(ie&&!(ie instanceof ke))throw(0,M.illegalArgument)("color");if(!D.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Oe=Be([I],Oe),e.ColorInformation=Oe;let Me=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Me=Be([I],Me),e.ColorPresentation=Me;var He;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var it;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(O,ie,Ee){if(this.startIndex=O,this.length=ie,this.tooltip=Ee,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ue;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ue=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var J;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(J=e.TaskRevealKind||(e.TaskRevealKind={}));var z;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(z=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=c=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ve.Clean=new c("clean","Clean"),ve.Build=new c("build","Build"),ve.Rebuild=new c("rebuild","Rebuild"),ve.Test=new c("test","Test"),ve=c=Be([I],ve),e.TaskGroup=ve;function Ce(B){let O="";for(let ie=0;ie<B.length;ie++)O+=B[ie].replace(/,/g,",,")+",";return O}let Ye=class{constructor(O,ie,Ee){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Ee):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return Ce(O)}};Ye=Be([I],Ye),e.ProcessExecution=Ye;let Le=class{constructor(O,ie,Ee){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=Ee}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return Ce(O)}};Le=Be([I],Le),e.ShellExecution=Le;var ct;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class dt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=dt;let ht=b=class{constructor(O,ie,Ee,Ve,tt,ot){this.__deprecated=!1,this._definition=this.definition=O;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Ee,this.execution=Ve,lt=tt,this.__deprecated=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=tt,lt=ot):(this.target=ie,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=tt,lt=ot),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ye?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof dt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(b.EmptyType===ie||b.ProcessType===ie||b.ShellType===ie||b.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=b=Be([I],ht),e.Task=ht;var ft;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(O,ie=yt.None){this.collapsibleState=ie,T.URI.isUri(O)?this.resourceUri=O:this.label=O}};_t=Be([I],_t),e.TreeItem=_t;var yt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(O,ie){this.id=O,this.color=ie}};Pt=Be([I],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Nt=class{constructor(O){this.id=O}};Nt=Be([I],Nt),e.ThemeColor=Nt;var Ct;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ct=e.ConfigurationTarget||(e.ConfigurationTarget={}));let xt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!T.URI.isUri(O)&&!T.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=T.URI.file(O),this.base=O):T.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};xt=Be([I],xt),e.RelativePattern=xt;let $t=class{constructor(O,ie,Ee,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};$t=Be([I],$t),e.Breakpoint=$t;let bt=class extends $t{constructor(O,ie,Ee,Ve,tt){super(ie,Ee,Ve,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};bt=Be([I],bt),e.SourceBreakpoint=bt;let Qt=class extends $t{constructor(O,ie,Ee,Ve,tt){super(ie,Ee,Ve,tt);this.functionName=O}};Qt=Be([I],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(O,ie,Ee,Ve,tt,ot,lt){super(Ve,tt,ot,lt);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=Ee}};zt=Be([I],zt),e.DataBreakpoint=zt;let ii=class{constructor(O,ie,Ee){this.command=O,this.args=ie||[],this.options=Ee}};ii=Be([I],ii),e.DebugAdapterExecutable=ii;let ni=class{constructor(O,ie){this.port=O,this.host=ie}};ni=Be([I],ni),e.DebugAdapterServer=ni;let At=class{constructor(O){this.path=O}};At=Be([I],At),e.DebugAdapterNamedPipeServer=At;let Yt=class{constructor(O){this.implementation=O}};Yt=Be([I],Yt),e.DebugAdapterInlineImplementation=Yt;let ri=class{constructor(O,ie){this.range=O,this.expression=ie}};ri=Be([I],ri),e.EvaluatableExpression=ri;var Jt;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(Jt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=Be([I],Wt),e.InlineValueText=Wt;let gt=class{constructor(O,ie,Ee=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=Ee}};gt=Be([I],gt),e.InlineValueVariableLookup=gt;let si=class{constructor(O,ie){this.range=O,this.expression=ie}};si=Be([I],si),e.InlineValueEvaluatableExpression=si;let Mt=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};Mt=Be([I],Mt),e.InlineValueContext=Mt;var Vt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=h=class extends Error{constructor(O,ie=_.FileSystemProviderErrorCode.Unknown,Ee){super(T.URI.isUri(O)?O.toString(!0):O);this.code=Ee?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(O){return new h(O,_.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(O){return new h(O,_.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(O){return new h(O,_.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(O){return new h(O,_.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(O){return new h(O,_.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(O){return new h(O,_.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};Xt=h=Be([I],Xt),e.FileSystemError=Xt;let oi=class{constructor(O,ie,Ee){this.start=O,this.end=ie,this.kind=Ee}};oi=Be([I],oi),e.FoldingRange=oi;var di;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(di=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(hi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=Zt;function bi(B){return typeof B=="undefined"||(0,C.isStringArray)(B)}class jt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,Ee=O.tokenTypes.length;ie<Ee;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,Ee=O.tokenModifiers.length;ie<Ee;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,Ee,Ve,tt){if(typeof O=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,ie,Ee,Ve,tt);if(D.isRange(O)&&typeof ie=="string"&&bi(Ee))return this._push(O,ie,Ee);throw(0,M.illegalArgument)()}_push(O,ie,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,tt=O.start.character,ot=O.end.character-O.start.character,lt=this._tokenTypeStrToInt.get(ie);let Dt=0;if(Ee)for(const Rt of Ee){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Lt>>>0}this._pushEncoded(Ve,tt,ot,lt,Dt)}_pushEncoded(O,ie,Ee,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Lt=0;for(let Ot=0;Ot<Dt;Ot++){let Bt=this._data[5*Ot],ui=this._data[5*Ot+1];Bt===0?(Bt=Rt,ui+=Lt):Bt+=Rt,this._data[5*Ot]=Bt,this._data[5*Ot+1]=ui,Rt=Bt,Lt=ui}}let ot=O,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const Ee=O.length/5|0;for(let lt=0;lt<Ee;lt++)ie[lt]=lt;ie.sort((lt,Dt)=>{const Rt=O[5*lt],Lt=O[5*Dt];if(Rt===Lt){const Ot=O[5*lt+1],Bt=O[5*Dt+1];return Ot-Bt}return Rt-Lt});const Ve=new Uint32Array(O.length);let tt=0,ot=0;for(let lt=0;lt<Ee;lt++){const Dt=5*ie[lt],Rt=O[Dt+0],Lt=O[Dt+1],Ot=O[Dt+2],Bt=O[Dt+3],ui=O[Dt+4],Bi=Rt-tt,Gi=Bi===0?Lt-ot:Lt,ci=5*lt;Ve[ci+0]=Bi,Ve[ci+1]=Gi,Ve[ci+2]=Ot,Ve[ci+3]=Bt,Ve[ci+4]=ui,tt=Rt,ot=Lt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(jt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=jt;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class Ei{constructor(O,ie,Ee){this.start=O,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Ei;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var Gt;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Be([I],ei),e.QuickInputButtons=ei;var Si;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,Ee){this.badge=O,this.tooltip=ie,this.color=Ee}static validate(O){if(O.badge){let ie=(0,P.nextCharLength)(O.badge,0);if(ie<O.badge.length&&(ie+=(0,P.nextCharLength)(O.badge,ie)),O.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(O){this.kind=O}};Kt=Be([I],Kt),e.ColorTheme=Kt;var fi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof Ht?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,Ee=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(Ee=O.end),ie===this._start&&Ee===this._end?this:new Ht(ie,Ee)}}e.NotebookRange=Ht;class Pe{constructor(O,ie,Ee,Ve,tt,ot,lt){this.kind=O,this.value=ie,this.languageId=Ee,this.mime=Ve,this.outputs=tt??[],this.metadata=ot,this.executionSummary=lt,Pe.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Pe.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Pe;class ai{constructor(O){this.cells=O}}e.NotebookData=ai;class Ft{constructor(O,ie){this.data=O,this.mime=ie;const Ee=(0,F.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(O){return O instanceof Ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Ft.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Ft(O,ie)}static text(O,ie=F.Mimes.text){const Ee=Ae(Ft,u,"f",p).encode(String(O));return new Ft(Ee,ie)}static json(O,ie="application/json"){const Ee=JSON.stringify(O,void 0,"	");return Ft.text(Ee,ie)}}e.NotebookCellOutputItem=Ft,u=Ft,p={value:new TextEncoder};class wt{constructor(O,ie,Ee){this.items=wt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,t.generateUuid)(),this.metadata=ie??Ee)}static isNotebookCellOutput(O){return O instanceof wt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const Ee=new Set,Ve=new Set;for(let tt=0;tt<O.length;tt++){const ot=O[tt],lt=(0,F.normalizeMimeType)(ot.mime);if(!Ee.has(lt)){Ee.add(lt);continue}Ve.add(tt),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ve.size===0?O:O.filter((tt,ot)=>!Ve.has(ot))}}e.NotebookCellOutput=wt;var Ci;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ci=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ii{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=Ii;var Pi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(O,ie=[]){this.uri=O,this.provides=(0,d.asArray)(ie)}}e.NotebookRendererScript=Ti;let li=class{constructor(O,ie){this.label=O,this.timestamp=ie}};li=Be([I],li),e.TimelineItem=li;var pi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Fi;class Mi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var Y;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(Y=e.TestRunProfileKind||(e.TestRunProfileKind={}));let le=class{constructor(O=void 0,ie=void 0,Ee=void 0){this.include=O,this.exclude=ie,this.profile=Ee}};le=Be([I],le),e.TestRunRequest=le;let Se=y=class{constructor(O){this.message=O}static diff(O,ie,Ee){const Ve=new y(O);return Ve.expectedOutput=ie,Ve.actualOutput=Ee,Ve}};Se=y=Be([I],Se),e.TestMessage=Se;let at=class{constructor(O){this.id=O}};at=Be([I],at),e.TestTag=at;let Et=class{constructor(O,ie){this.covered=O,this.total=ie}};Et=Be([I],Et),e.CoveredCount=Et;let kt=R=class{constructor(O,ie,Ee,Ve){this.uri=O,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=Ve}static fromDetails(O,ie){const Ee=new Et(0,0),Ve=new Et(0,0),tt=new Et(0,0);for(const lt of ie)if("branches"in lt){Ee.total+=1,Ee.covered+=lt.executionCount>0?1:0;for(const Dt of lt.branches)Ve.total+=1,Ve.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const ot=new R(O,Ee,Ve.total>0?Ve:void 0,tt.total>0?tt:void 0);return ot.detailedCoverage=ie,ot}};kt=R=Be([I],kt),e.FileCoverage=kt;let Oi=class{constructor(O,ie,Ee=[]){this.executionCount=O,this.location=ie,this.branches=Ee}};Oi=Be([I],Oi),e.StatementCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=Be([I],Ni),e.BranchCoverage=Ni;let xi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};xi=Be([I],xi),e.FunctionCoverage=xi;var zi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(O,ie,Ee,Ve,tt,ot){this.kind=O,this.name=ie,this.detail=Ee,this.uri=Ve,this.range=tt,this.selectionRange=ot}}e.TypeHierarchyItem=qi}),define(we[88],be([0,1,42,11,9,228,117,7,15]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function t(s,u){u?T.set(s,u):T.delete(s)}e.setWordDefinitionFor=t;function _(s){return T.get(s)}e.getWordDefinitionFor=_;class n extends A.MirrorTextModel{constructor(u,p,k,w,o,f,S,i){super(p,k,w,o);this._proxy=u,this._languageId=f,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,C.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(p){return p?u._getTextInRange(p):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(p){return u._lineAt(p)},offsetAt(p){return u._offsetAt(p)},positionAt(p){return u._positionAt(p)},validateRange(p){return u._validateRange(p)},validatePosition(p){return u._validatePosition(p)},getWordRangeAtPosition(p,k){return u._getWordRangeAtPosition(p,k)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,d.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,d.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const p=this._validateRange(u);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const k=this._eol,w=p.start.line,o=p.end.line,f=[];f.push(this._lines[w].substring(p.start.character));for(let S=w+1;S<o;S++)f.push(this._lines[S]);return f.push(this._lines[o].substring(0,p.end.character)),f.join(k)}_lineAt(u){let p;if(u instanceof P.Position?p=u.line:typeof u=="number"&&(p=u),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(u),k=this._lines[p.index].length;return new P.Position(p.index,Math.min(p.remainder,k))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const p=this._validatePosition(u.start),k=this._validatePosition(u.end);return p===u.start&&k===u.end?u:new P.Range(p.line,p.character,k.line,k.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:p,character:k}=u,w=!1;if(p<0)p=0,k=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,k=this._lines[p].length,w=!0;else{const o=this._lines[p].length;k<0?(k=0,w=!0):k>o&&(k=o,w=!0)}return w?new P.Position(p,k):u}_getWordRangeAtPosition(u,p){const k=this._validatePosition(u);if(!p)p=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,F.getWordAtText)(k.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[k.line],0);if(w)return new P.Range(k.line,w.startColumn-1,k.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(u,p,k){this._line=u,this._text=p,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(we[155],be([0,1,7,3,229,6,57,20,2,36]),function(re,e,d,M,E,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,m,s,u){this._notebook=s,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(k=>{const w=this._cellUris.get(k.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>p(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],m=[];for(const s of this._notebook.getCells())s.kind===d.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const o of this._cells)w+=o.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const m=this.locationAt(n.start),s=this.locationAt(n.end),u=this._cellUris.get(m.uri),p=this._cellUris.get(s.uri);if(u===void 0||p===void 0)return"";if(u===p)return this._cells[u].document.getText(new d.Range(m.range.start,s.range.end));const k=[this._cells[u].document.getText(new d.Range(m.range.start,new d.Position(this._cells[u].document.lineCount,0)))];for(let w=u+1;w<p;w++)k.push(this._cells[w].document.getText());return k.push(this._cells[p].document.getText(new d.Range(new d.Position(0,0),s.range.end))),k.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(m.index-1),u=this._cells[m.index].document.offsetAt(n.with(m.remainder));return s+u}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(u)}const m=this._cellUris.get(n.uri);if(m!==void 0){const s=this._cellLines.getPrefixSum(m-1);return new d.Position(s+n.range.start.line,n.range.start.character)}return new d.Position(0,0)}locationAt(n){d.Range.isRange(n)||(n=new d.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let s=m;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const u=new d.Position(m.remainder,n.start.character),p=new d.Position(s.remainder,n.end.character),k=new d.Range(u,p),w=this._cells[m.index];return new d.Location(w.document.uri,w.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(m,s)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),s=new d.Position(m.remainder,n.character),u=this._cells[m.index].document.validatePosition(s),p=this._cellLines.getPrefixSum(m.index-1);return new d.Position(p+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,7,13,3]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let C=P==="light"?d.ColorThemeKind.Light:P==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([We(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[66],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[157],be([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let T=this.buffers.indexOf(C);return T<0&&(T=this.buffers.length,this.buffers.push(C)),T}}function E(P,C){if(C.serializeBuffersForPostMessage){const T=new M,t=(m,s)=>{if(s instanceof ArrayBuffer){const u=T.add(s);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(s)){const u=A(s);if(u){const p=T.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:u,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},_=JSON.stringify(P,t),n=T.buffers.map(m=>{const s=new Uint8Array(m);return d.VSBuffer.wrap(s)});return{message:_,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=E;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(P,C){const T=C.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),t=C.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:u}=s,p=T[u];if(s.view)switch(s.view.type){case 1:return new Int8Array(p,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(P,t),arrayBuffers:T}}e.deserializeWebviewMessage=F}),define(we[158],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(M){function E(F){const P={items:new Map};return F.types.forEach((C,T)=>{P.items.set(C,{asString:async()=>F.items[T].asString})}),P}M.toITreeDataTransfer=E;async function A(F){const P={types:[],items:[]},C=Array.from(F.items.entries());for(const T of C)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}M.toTreeDataTransferDTO=A})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[67],be([0,1,11,2]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(P,C){return P.scheme===d.Schemas.http||P.scheme===d.Schemas.https?P:(C&&C.authority&&C.isRemote&&P.scheme===d.Schemas.file&&(P=M.URI.from({scheme:d.Schemas.vscodeRemote,authority:C.authority,path:P.path})),M.URI.from({scheme:d.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=E;function A(P){return P.replace(/./g,C=>{const T=C.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?C:"-"+T.toString(16).padStart(4,"0")})}function F(P){return P.replace(/-([0-9a-f]{4})/g,(C,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=F}),define(we[159],be([0,1,3,6,67]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,C,T){this._proxy=P,this._editors=C,this._initData=T,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const t=C.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,C,T,t,_){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===P){n=o;break}if(!n)throw new Error("not a visible editor");const m=this,s=this._handlePool++,u=new d.Emitter,p=new d.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,m._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,m._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,m._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(o){return m._proxy.$postMessage(s,o)}},w=new class{constructor(){this.editor=P,this.line=C,this.height=T,this.webview=k,this.onDidDispose=p.event}dispose(){m._insets.has(s)&&(m._insets.delete(s),m._proxy.$disposeEditorInset(s),p.fire(),p.dispose(),u.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,C+1,T,t||{},_.identifier,_.extensionLocation),this._insets.set(s,{editor:P,inset:w,onDidReceiveMessage:u}),w}$onDidDispose(P){const C=this._insets.get(P);C&&C.inset.dispose()}$onDidReceiveMessage(P,C){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=A}),define(we[160],be([0,1,130,10,2,6,4,46,28,47,15,11]),function(re,e,d,M,E,A,F,P,C,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,d.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,d.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,d.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,d.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,d.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,d.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,d.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,d.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,d.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,d.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,d.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,d.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,d.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,d.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,d.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,d.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,d.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,d.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,d.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,d.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,d.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,D,x){for(const N of x.visibleEditorPanes)if(N.group.id===D&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function m(L){if(S(L))return!1;const D=L;return E.URI.isUri(D?.resource)}e.isResourceEditorInput=m;function s(L){if(S(L))return!1;const D=L;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=s;function u(L){if(S(L)||s(L))return!1;const D=L;return D?.primary!==void 0&&D.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function p(L){if(S(L))return!1;const D=L;return D?D.resource===void 0||D.resource.scheme===_.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var k;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(k=e.Verbosity||(e.Verbosity={}));var w;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var o;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class f extends A.Disposable{}e.AbstractEditorInput=f;function S(L){return L instanceof f}e.isEditorInput=S;function i(L){const D=L;return E.URI.isUri(D?.preferredResource)}function g(L){const D=L;return S(D?.primary)&&S(D?.secondary)}e.isSideBySideEditorInput=g;function a(L){const D=L;return S(D?.modified)&&S(D?.original)}e.isDiffEditorInput=a;function r(L){return S(L?.editor)}e.isEditorInputWithOptions=r;function v(L){const D=L;return r(L)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=v;function l(L){const D=L;return typeof D?.groupId=="number"&&S(D.editor)}e.isEditorIdentifier=l;var c;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class h{getOriginalUri(D,x){if(!D)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(D);if(V&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri(W,{filterByScheme:x.filterByScheme});D=x.supportSideBySide===b.PRIMARY?V:W}}if(s(D)||u(D))return;const N=i(D)?D.preferredResource:D.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(D){return g(D)||u(D)?{primary:D.primary,secondary:D.secondary}:a(D)||s(D)?{primary:D.modified,secondary:D.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(D,x){if(!D)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(D);if(V&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:x.filterByScheme});D=x.supportSideBySide===b.PRIMARY?V:W}}if(s(D)||u(D))return;const N=D.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(D,x){if(Array.isArray(x)){if(x.some(N=>D.scheme===N))return D}else if(x===D.scheme)return D}}e.EditorResourceAccessor=new h;var y;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const x=this.instantiationService=D.get(F.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(D,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(D,V)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,x){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,x,this.instantiationService):this.editorSerializerConstructors.set(D,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new R);async function I(L,D){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const V=E.URI.revive(N.fileUri);if(!V||!await D.canHandleResource(V))return;let $=N.exists,Z=N.type;if(typeof $!="boolean"||typeof Z!="number")try{Z=(await D.resolve(V)).isFile?T.FileType.File:T.FileType.Unknown,$=!0}catch{$=!1}if(!$&&N.openOnlyIfExists||Z!==T.FileType.File)return;const j={selection:$?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return $?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,t.coalesce)(x)}e.pathsToEditors=I;var U;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,46,131,4,6,20,28,15,53,23,34,151]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var s;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var u;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function k(v){return`viewContainer.${v}.enabled`}e.getEnabledViewContainerContextKey=k;class w extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new d.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new d.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,T.flatten)([...this.viewContainers.values()])}registerViewContainer(l,c,b){const h=this.get(l.id);if(h)return h;const y=l;return y.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,P.getOrSet)(this.viewContainers,c,[]).push(y),b?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:c}),y}deregisterViewContainer(l){for(const c of this.viewContainers.keys()){const b=this.viewContainers.get(c),h=b?.indexOf(l);if(h!==-1){b?.splice(h,1),b.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===l)}}C.Registry.add(s.ViewContainersRegistry,new w);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function f(v,l){const c=v.group??o.More,b=l.group??o.More;return c!==b?c.localeCompare(b):(v.order??5)-(l.order??5)}class S extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new d.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new d.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new d.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new d.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:b})=>this.addViews(c,b)),this._onViewsRegistered.fire(l)}deregisterViews(l,c){const b=this.removeViews(l,c);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:c})}moveViews(l,c){for(const b of this._views.keys())if(b!==c){const h=this.removeViews(l,b);h.length&&(this.addViews(h,c),this._onDidChangeContainer.fire({views:h,from:b,to:c}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const c of this._viewContainers){const b=(this._views.get(c)||[]).filter(h=>h.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(h=>h.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this._viewWelcomeContents.add(l,c),this._onDidChangeViewWelcomeContent.fire(l),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,c),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,c){const b=new Map;for(const[h,y]of c)this._viewWelcomeContents.add(l,y),b.set(h,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(l,y),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),b}getViewWelcomeContent(l){const c=[];return this._viewWelcomeContents.forEach(l,b=>c.push(b)),c.sort(f)}addViews(l,c){let b=this._views.get(c);b||(b=[],this._views.set(c,b),this._viewContainers.push(c));for(const h of l){if(this.getView(h.id)!==null)throw new Error((0,E.localize)(1,null,h.id));b.push(h)}}removeViews(l,c){const b=this._views.get(c);if(!b)return[];const h=[],y=[];for(const R of b)l.includes(R)?h.push(R):y.push(R);return h.length&&(y.length?this._views.set(c,y):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),h}}C.Registry.add(s.ViewsRegistry,new S),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(v){return`view.${v}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var g;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(g=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(l,c){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,l),this._hasResolve=!!c,this.resolve=async b=>{if(c&&!this.resolved){const h=await c(b);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,12,132]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,C,T,t){const _={command:P};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const s={type:"response",seq:0,request_seq:_.seq,success:!1,command:P,message:(0,E.localize)(0,null,t,P)};m(s)}},t)}return T&&this.pendingRequests.set(_.seq,T),_.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,C){return P.type!=="event"||C.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,M.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const C=P,T=this.pendingRequests.get(C.request_seq);T&&(this.pendingRequests.delete(C.request_seq),T(C));break}}}internalSend(P,C){C.type=P,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((C,T)=>P.set(T,C)),await(0,M.timeout)(500),P.forEach((C,T)=>{C({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[163],be([0,1,9,2,17,23,11]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function C(a,r,v){return a.replace(P,function(l,c){return r&&c.length>0&&c[0]!=="_"?l:v&&v.hasOwnProperty(c)?v[c]:l})}e.formatPII=C;function T(a){const r={};for(const v of Object.keys(a))v.startsWith("!")||(r[v]=a[v]);return r}e.filterExceptionsFromTelemetry=T;function t(a){return a.configuration.request==="attach"&&!_(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function _(a){let r=a.configuration.type;if(!!r)return r==="vslsShare"&&(r=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(r,"extensionhost")||(0,d.equalsIgnoreCase)(r,"pwa-extensionhost")?a:a.parentSession?_(a.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function m(a,r,v){let l,c=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,h=null;for(;h=b.exec(a);){let y=h.index+1,R=y+h[0].length;if(y<=r&&R>=v){l=h[0],c=y;break}}if(l){let y=/\w+/g,R=null;for(;(R=y.exec(l))&&!(R.index+1+c+R[0].length>=v););R&&(l=l.substring(0,y.lastIndex))}return l?{start:c,end:c+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(s))}e.isUri=u;function p(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,E.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function k(a){if(typeof a.path=="object"){const r=M.URI.revive(a.path);if(r)return r.scheme===F.Schemas.file?r.fsPath:r.toString()}return a.path}function w(a,r){const v=r?p:k,l=(0,A.deepClone)(a);return f(l,(c,b)=>{c&&b&&(b.path=v(b))}),l}e.convertToDAPaths=w;function o(a,r){const v=r?p:k,l=(0,A.deepClone)(a);return f(l,(c,b)=>{!c&&b&&(b.path=v(b))}),l}e.convertToVSCPaths=o;function f(a,r){switch(a.type){case"event":const v=a;switch(v.event){case"output":r(!1,v.body.source);break;case"loadedSource":r(!1,v.body.source);break;case"breakpoint":r(!1,v.body.breakpoint.source);break;default:break}break;case"request":const l=a;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":c.body.sources.forEach(b=>r(!1,b));break;case"scopes":c.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":c.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function S(a){return a.filter(r=>!r.presentation?.hidden).sort((r,v)=>r.presentation?v.presentation?r.presentation.group?v.presentation.group?r.presentation.group!==v.presentation.group?r.presentation.group.localeCompare(v.presentation.group):i(r.presentation.order,v.presentation.order):-1:v.presentation.group?1:i(r.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=S;function i(a,r){return typeof a!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:a-r}async function g(a,r){const v=a.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorMode});if(v!=="none"&&(await r.saveAll(),v==="allEditorsInActiveGroup")){const l=r.activeEditorPane;l&&await r.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(we[89],be([0,1,27,164,79,11,17,25,46]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var t;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(t=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var k;(function(y){y.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function I(N,V){return N.with({scheme:y.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==A.Schemas.file?N.scheme:""}`})}y.generate=I;function U(N){if(N.scheme!==y.scheme)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parse=U;function L(N){if(N.scheme!==A.Schemas.vscodeNotebookCellMetadata)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=L;function D(N,V,W){return N.with({scheme:W,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==A.Schemas.file?N.scheme:""}`})}y.generateCellUri=D;function x(N,V){if(N.scheme!==V)return;const W=R.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||A.Schemas.file,fragment:null})}:void 0}y.parseCellUri=x})(k=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(y){return w.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function f(y){return w.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function S(y){return w.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=S;const i=y=>P.isWindows?y.replace(/\//g,"\\"):y;class g{constructor(R=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(R)].map(U=>({pattern:U,matches:d.parse(i(U))}))}sort(R){const I=new Map(M.Iterable.map(R,L=>[L,i(L)]));let U=[];for(const{matches:L}of this.order)for(const[D,x]of I)if(L(x)){U.push(D),I.delete(D);break}return I.size&&(U=U.concat([...I.keys()].sort((L,D)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(D)))),U}prioritize(R,I){const U=this.findIndex(R);if(U===-1){this.order.unshift({pattern:R,matches:d.parse(i(R))});return}const L=new Set(I.map(x=>this.findIndex(x,U)));L.delete(-1);const D=Array.from(L).sort();this.order.splice(U+1,0,...D.map(x=>this.order[x]));for(let x=D.length-1;x>=0;x--)this.order.splice(D[x],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,I=this.order.length){const U=i(R);for(let L=0;L<I;L++)if(this.order[L].matches(U))return L;return-1}}e.MimeTypeDisplayOrder=g;function a(y,R,I,U=(L,D)=>L===D){const L=[];function D(V,W,$){if(W===0&&$.length===0)return;const Z=L[L.length-1];Z&&Z.start+Z.deleteCount===V?(Z.deleteCount+=W,Z.toInsert.push(...$)):L.push({start:V,deleteCount:W,toInsert:$})}let x=0,N=0;for(;;){if(x===y.length){D(x,0,R.slice(N));break}if(N===R.length){D(x,y.length-x,[]);break}const V=y[x],W=R[N];if(U(V,W)){x+=1,N+=1;continue}I(W)?(D(x,1,[]),x+=1):(D(x,0,[W]),N+=1)}return L}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(y){y.default="default",y.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(y){const R=y;return!!((typeof R.include=="string"||d.isRelativePattern(R.include))&&(typeof R.exclude=="string"||d.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=v;function l(y,R,I){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let U=v(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,L=v(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(d.match(U,(0,F.basename)(I.fsPath).toLowerCase()))return!(L&&d.match(L,(0,F.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class c{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)R[I]=this.textModel.cells[I].getHashValue();return R}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(R){return`${h._prefix}${R}`}static parse(R){if(R.startsWith(h._prefix))return R.substr(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(we[165],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(we[166],be([0,1,134,4,46]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[167],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=d;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=F;var P;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=T;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const u=s[1];if(u.parent){if(this.items.has(u.parent)){const p=this.items.get(u.parent);p.children.add(u.item.extId);const k=this.createItem(u,p);this.items.set(u.item.extId,k),m.add(k)}}else{const p=this.createItem(u);this.roots.add(p),this.items.set(u.item.extId,p),m.add(p)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=s[1],p=this.items.get(u.extId);if(!p)break;u.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,u),m.update(p);break}case 2:{const u=this.items.get(s[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const p=[[s[1]]];for(;p.length;)for(const k of p.pop()){const w=this.items.get(k);w&&(p.push(w.children),this.items.delete(k),m.remove(w,w!==u),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=t}),define(we[68],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(A){A.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,P=F.length){if(this.path=F,this.viewEnd=P,F.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,P,C=F.parent){if(F.id===P)return new E([P]);let T=[F.id];for(let t=C;t&&t.id!==P;t=t.parent)T.push(t.id);return T.push(P),new E(T.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,P){return new E([...F.path,P])}static joinToString(F,P){return F.toString()+"\0"+P}static compare(F,P){return F===P?0:P.startsWith(F+"\0")?2:F.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let P=0;P<F.viewEnd&&P<this.viewEnd;P++)if(F.path[P]!==this.path[P])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(we[168],be([0,1,17,91,10,23,25,78,135]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(_,n,m){this._contributedVariables=new Map,this._context=_,this._labelService=n,m&&(this._envVariablesPromise=m.then(s=>this.prepareEnv(s)))}prepareEnv(_){if(F.isWindows){const n=Object.create(null);return Object.keys(_).forEach(m=>{n[m.toLowerCase()]=_[m]}),n}return _}resolveWithEnvironment(_,n,m){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,m)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,m,s){const u=A.deepClone(n);return F.isWindows&&u.windows?Object.keys(u.windows).forEach(p=>u[p]=u.windows[p]):F.isMacintosh&&u.osx?Object.keys(u.osx).forEach(p=>u[p]=u.osx[p]):F.isLinux&&u.linux&&Object.keys(u.linux).forEach(p=>u[p]=u.linux[p]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,u,m,s)}async resolveAnyAsync(_,n,m){return this.resolveAnyBase(_,n,m)}async resolveAnyMap(_,n,m){const s=new Map;return{newConfig:await this.resolveAnyBase(_,n,m,s),resolvedVariables:s}}resolveWithInteractionReplace(_,n,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,m,s,u){if(E.isString(m))return this.resolveString(_,n,m,s,u);if(E.isArray(m))return m.map(p=>this.recursiveResolve(_,n,p,s,u));if(E.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(k=>{const w=this.resolveString(_,n,k,s,u);p[w]=this.recursiveResolve(_,n,m[k],s,u)}),p}return m}resolveString(_,n,m,s,u){return m.replace(T.VARIABLE_REGEXP,(k,w)=>{if(w.includes(T.VARIABLE_LHS))return k;let o=this.evaluateSingleVariable(_,k,w,n,s);return u&&u.set(w,o),o!==k&&E.isString(o)&&o.match(T.VARIABLE_REGEXP)&&(o=this.resolveString(_,n,o,s,u)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,m,s,u){let p;const k=m.split(":");k.length>1&&(m=k[0],p=k[1]);const w=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,C.localize)(0,null,n))},o=()=>{const S=w();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,C.localize)(1,null,n,d.basename(S)))},f=()=>{if(p){const S=this._context.getFolderUri(p);if(S)return S;throw new Error((0,C.localize)(2,null,n,p))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(m){case"env":if(p){if(_){const S=_[F.isWindows?p.toLowerCase():p];if(E.isString(S))return S}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(p){const S=this._context.getConfigurationValue(s,p);if(E.isUndefinedOrNull(S))throw new Error((0,C.localize)(6,null,n,p));if(E.isObject(S))throw new Error((0,C.localize)(7,null,n,p));return S}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,u,"command");case"input":return this.resolveFromMap(n,p,u,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return s||p?(0,P.normalizeDriveLetter)(this.fsPath(f())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(f()));case"lineNumber":const S=this._context.getLineNumber();if(S)return S;throw new Error((0,C.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,C.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return o();case"relativeFile":return s||p?d.relative(this.fsPath(f()),w()):w();case"relativeFileDirname":const g=d.dirname(w());if(s||p){const l=d.relative(this.fsPath(f()),g);return l.length===0?".":l}return g;case"fileDirname":return d.dirname(w());case"fileExtname":return d.extname(w());case"fileBasename":return d.basename(w());case"fileBasenameNoExtension":const a=d.basename(w());return a.slice(0,a.length-d.extname(a).length);case"fileDirnameBasename":return d.basename(d.dirname(w()));case"execPath":const r=this._context.getExecPath();return r||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return d.sep;default:try{const l=p?`${m}:${p}`:m;return this.resolveFromMap(n,l,u,void 0)}catch(l){return n}}}}resolveFromMap(_,n,m,s){if(n&&m){const u=s===void 0?m[n]:m[s+":"+n];if(typeof u=="string")return u;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var E;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var P;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function T(u){const p=u;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=T;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(u){const p=u;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function s(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(we[169],be([0,1,4,92]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const F=A;return typeof A=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(we[8],be([0,1,15,22,77,230,56,23,10,2,44,60,136,83,50,89,68,169,7]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ue){function me(z){const{selectionStartLineNumber:ve,selectionStartColumn:Ce,positionLineNumber:Ye,positionColumn:Le}=z,ct=new w.Position(ve-1,Ce-1),pt=new w.Position(Ye-1,Le-1);return new w.Selection(ct,pt)}ue.to=me;function J(z){const{anchor:ve,active:Ce}=z;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}ue.from=J})(o=e.Selection||(e.Selection={}));var f;(function(ue){function me(z){if(!z)return;const{start:ve,end:Ce}=z;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}ue.from=me;function J(z){if(!z)return;const{startLineNumber:ve,startColumn:Ce,endLineNumber:Ye,endColumn:Le}=z;return new w.Range(ve-1,Ce-1,Ye-1,Le-1)}ue.to=J})(f=e.Range||(e.Range={}));var S;(function(ue){function me(J){switch(J){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ue.to=me})(S=e.TokenType||(e.TokenType={}));var i;(function(ue){function me(z){return new w.Position(z.lineNumber-1,z.column-1)}ue.to=me;function J(z){return{lineNumber:z.line+1,column:z.character+1}}ue.from=J})(i=e.Position||(e.Position={}));var g;(function(ue){function me(ve,Ce){return(0,d.coalesce)((0,d.asArray)(ve).map(Ye=>J(Ye,Ce)))}ue.from=me;function J(ve,Ce){if(typeof ve=="string")return{$serialized:!0,language:ve};if(ve)return{$serialized:!0,language:ve.language,scheme:z(ve.scheme,Ce),pattern:typeof ve.pattern=="undefined"?void 0:rt.from(ve.pattern),exclusive:ve.exclusive}}function z(ve,Ce){return Ce&&typeof ve=="string"?Ce.transformOutgoingScheme(ve):ve}})(g=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(ue){function me(z){switch(z){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ue.from=me;function J(z){switch(z){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ue.to=J})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ue){function me(z){let ve;return z.code&&((0,C.isString)(z.code)||(0,C.isNumber)(z.code)?ve=String(z.code):ve={value:String(z.code.value),target:z.code.target}),{...f.from(z.range),message:z.message,source:z.source,code:ve,severity:l.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(v.from),tags:Array.isArray(z.tags)?(0,d.coalesce)(z.tags.map(a.from)):void 0}}ue.from=me;function J(z){const ve=new w.Diagnostic(f.to(z),z.message,l.to(z.severity));return ve.source=z.source,ve.code=(0,C.isString)(z.code)?z.code:z.code?.value,ve.relatedInformation=z.relatedInformation&&z.relatedInformation.map(v.to),ve.tags=z.tags&&(0,d.coalesce)(z.tags.map(a.to)),ve}ue.to=J})(r=e.Diagnostic||(e.Diagnostic={}));var v;(function(ue){function me(z){return{...f.from(z.location.range),message:z.message,resource:z.location.uri}}ue.from=me;function J(z){return new w.DiagnosticRelatedInformation(new w.Location(z.resource,f.to(z)),z.message)}ue.to=J})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ue){function me(z){switch(z){case w.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ue.from=me;function J(z){switch(z){case m.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ue.to=J})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ue){function me(z){return typeof z=="number"&&z>=w.ViewColumn.One?z-1:z===w.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ue.from=me;function J(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=J})(c=e.ViewColumn||(e.ViewColumn={}));function b(ue){return typeof ue.range!="undefined"}function h(ue){return ue.length===0?!0:!!b(ue[0])}e.isDecorationOptionsArr=h;var y;(function(ue){function me(Le){return Le.map(ue.from)}ue.fromMany=me;function J(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function z(Le){let ct;if(J(Le)){const{language:ft,value:_t}=Le;ct={value:"```"+ft+`
`+_t+"\n```\n"}}else w.MarkdownString.isMarkdownString(Le)?ct={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons,supportHtml:Le.supportHtml}:typeof Le=="string"?ct={value:Le}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const dt=ft=>{try{let _t=T.URI.parse(ft,!0);_t=_t.with({query:ve(_t.query,pt)}),pt[ft]=_t}catch(_t){}return""},ht=new A.Renderer;return ht.link=dt,ht.image=ft=>dt(E.parseHrefAndDimensions(ft).href),A(ct.value,{renderer:ht}),ct}ue.from=z;function ve(Le,ct){if(!Le)return Le;let pt;try{pt=(0,F.parse)(Le)}catch(ht){}if(!pt)return Le;let dt=!1;return pt=(0,P.cloneAndChange)(pt,ht=>{if(T.URI.isUri(ht)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ht,dt=!0,ft}else return}),dt?JSON.stringify(pt):Le}function Ce(Le){const ct=new w.MarkdownString(Le.value,Le.supportThemeIcons);return ct.isTrusted=Le.isTrusted,ct.supportHtml=Le.supportHtml,ct}ue.to=Ce;function Ye(Le){if(!!Le)return typeof Le=="string"?Le:ue.from(Le)}ue.fromStrict=Ye})(y=e.MarkdownString||(e.MarkdownString={}));function R(ue){return h(ue)?ue.map(me=>({range:f.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?y.fromMany(me.hoverMessage):me.hoverMessage?y.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):ue.map(me=>({range:f.from(me)}))}e.fromRangeOrRangeWithMessage=R;function I(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?T.URI.file(ue):ue}e.pathOrURIToURI=I;var U;(function(ue){function me(J){return typeof J=="undefined"?J:{contentText:J.contentText,contentIconPath:J.contentIconPath?I(J.contentIconPath):void 0,border:J.border,borderColor:J.borderColor,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,color:J.color,backgroundColor:J.backgroundColor,margin:J.margin,width:J.width,height:J.height}}ue.from=me})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ue){function me(J){return typeof J=="undefined"?J:{backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?I(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?U.from(J.before):void 0,after:J.after?U.from(J.after):void 0}}ue.from=me})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var D;(function(ue){function me(J){if(typeof J=="undefined")return J;switch(J){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=me})(D=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ue){function me(J){return{isWholeLine:J.isWholeLine,rangeBehavior:J.rangeBehavior?D.from(J.rangeBehavior):void 0,overviewRulerLane:J.overviewRulerLane,light:J.light?L.from(J.light):void 0,dark:J.dark?L.from(J.dark):void 0,backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?I(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?U.from(J.before):void 0,after:J.after?U.from(J.after):void 0}}ue.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ue){function me(z){return{text:z.newText,eol:z.newEol&&q.from(z.newEol),range:f.from(z.range)}}ue.from=me;function J(z){const ve=new w.TextEdit(f.to(z.range),z.text);return ve.newEol=typeof z.eol=="undefined"?void 0:q.to(z.eol),ve}ue.to=J})(N=e.TextEdit||(e.TextEdit={}));var V;(function(ue){function me(z,ve,Ce){const Ye={edits:[]};if(z instanceof w.WorkspaceEdit)for(let Le of z._allEntries())if(Le._type===1)Ye.edits.push({_type:1,oldUri:Le.from,newUri:Le.to,options:Le.options,metadata:Le.metadata});else if(Le._type===2){const ct=ve?.getDocument(Le.uri);Ye.edits.push({_type:2,resource:Le.uri,edit:N.from(Le.edit),modelVersionId:ct?.version,metadata:Le.metadata})}else Le._type===3?Ye.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,edit:Le.edit,notebookMetadata:Le.notebookMetadata,notebookVersionId:Ce?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version}):Le._type===5&&Ye.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,notebookVersionId:Ce?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Le.index,count:Le.count,cells:Le.cells.map(Xe.from)}});return Ye}ue.from=me;function J(z){const ve=new w.WorkspaceEdit;for(const Ce of z.edits)Ce.edit?ve.replace(T.URI.revive(Ce.resource),f.to(Ce.edit.range),Ce.edit.text):ve.renameFile(T.URI.revive(Ce.oldUri),T.URI.revive(Ce.newUri),Ce.options);return ve}ue.to=J})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ue){const me=Object.create(null);me[w.SymbolKind.File]=0,me[w.SymbolKind.Module]=1,me[w.SymbolKind.Namespace]=2,me[w.SymbolKind.Package]=3,me[w.SymbolKind.Class]=4,me[w.SymbolKind.Method]=5,me[w.SymbolKind.Property]=6,me[w.SymbolKind.Field]=7,me[w.SymbolKind.Constructor]=8,me[w.SymbolKind.Enum]=9,me[w.SymbolKind.Interface]=10,me[w.SymbolKind.Function]=11,me[w.SymbolKind.Variable]=12,me[w.SymbolKind.Constant]=13,me[w.SymbolKind.String]=14,me[w.SymbolKind.Number]=15,me[w.SymbolKind.Boolean]=16,me[w.SymbolKind.Array]=17,me[w.SymbolKind.Object]=18,me[w.SymbolKind.Key]=19,me[w.SymbolKind.Null]=20,me[w.SymbolKind.EnumMember]=21,me[w.SymbolKind.Struct]=22,me[w.SymbolKind.Event]=23,me[w.SymbolKind.Operator]=24,me[w.SymbolKind.TypeParameter]=25;function J(ve){return typeof me[ve]=="number"?me[ve]:6}ue.from=J;function z(ve){for(const Ce in me)if(me[Ce]===ve)return Number(Ce);return w.SymbolKind.Property}ue.to=z})(W=e.SymbolKind||(e.SymbolKind={}));var $;(function(ue){function me(z){switch(z){case w.SymbolTag.Deprecated:return 1}}ue.from=me;function J(z){switch(z){case 1:return w.SymbolTag.Deprecated}}ue.to=J})($=e.SymbolTag||(e.SymbolTag={}));var Z;(function(ue){function me(z){return{name:z.name,kind:W.from(z.kind),tags:z.tags&&z.tags.map($.from),containerName:z.containerName,location:ce.from(z.location)}}ue.from=me;function J(z){const ve=new w.SymbolInformation(z.name,W.to(z.kind),z.containerName,ce.to(z.location));return ve.tags=z.tags&&z.tags.map($.to),ve}ue.to=J})(Z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ue){function me(z){const ve={name:z.name||"!!MISSING: name!!",detail:z.detail,range:f.from(z.range),selectionRange:f.from(z.selectionRange),kind:W.from(z.kind),tags:z.tags?.map($.from)??[]};return z.children&&(ve.children=z.children.map(me)),ve}ue.from=me;function J(z){const ve=new w.DocumentSymbol(z.name,z.detail,W.to(z.kind),f.to(z.range),f.to(z.selectionRange));return(0,d.isNonEmptyArray)(z.tags)&&(ve.tags=z.tags.map($.to)),z.children&&(ve.children=z.children.map(J)),ve}ue.to=J})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ue){function me(z){const ve=new w.CallHierarchyItem(W.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),f.to(z.range),f.to(z.selectionRange));return ve._sessionId=z._sessionId,ve._itemId=z._itemId,ve}ue.to=me;function J(z,ve,Ce){if(ve=ve??z._sessionId,Ce=Ce??z._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,name:z.name,detail:z.detail,kind:W.from(z.kind),uri:z.uri,range:f.from(z.range),selectionRange:f.from(z.selectionRange),tags:z.tags?.map($.from)}}ue.from=J})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ae;(function(ue){function me(J){return new w.CallHierarchyIncomingCall(Q.to(J.from),J.fromRanges.map(z=>f.to(z)))}ue.to=me})(ae=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(ue){function me(J){return new w.CallHierarchyOutgoingCall(Q.to(J.to),J.fromRanges.map(z=>f.to(z)))}ue.to=me})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ce;(function(ue){function me(z){return{range:z.range&&f.from(z.range),uri:z.uri}}ue.from=me;function J(z){return new w.Location(T.URI.revive(z.uri),f.to(z.range))}ue.to=J})(ce=e.location||(e.location={}));var Fe;(function(ue){function me(z){const ve=z,Ce=z;return{originSelectionRange:ve.originSelectionRange?f.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:Ce.uri,range:f.from(ve.targetRange?ve.targetRange:Ce.range),targetSelectionRange:ve.targetSelectionRange?f.from(ve.targetSelectionRange):void 0}}ue.from=me;function J(z){return{targetUri:T.URI.revive(z.uri),targetRange:f.to(z.range),targetSelectionRange:z.targetSelectionRange?f.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?f.to(z.originSelectionRange):void 0}}ue.to=J})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ge;(function(ue){function me(z){return{range:f.from(z.range),contents:y.fromMany(z.contents)}}ue.from=me;function J(z){return new w.Hover(z.contents.map(y.to),f.to(z.range))}ue.to=J})(Ge=e.Hover||(e.Hover={}));var Ne;(function(ue){function me(z){return{range:f.from(z.range),expression:z.expression}}ue.from=me;function J(z){return new w.EvaluatableExpression(f.to(z.range),z.expression)}ue.to=J})(Ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(ue){function me(z){if(z instanceof w.InlineValueText)return{type:"text",range:f.from(z.range),text:z.text};if(z instanceof w.InlineValueVariableLookup)return{type:"variable",range:f.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=me;function J(z){switch(z.type){case"text":return{range:f.to(z.range),text:z.text};case"variable":return{range:f.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:f.to(z.range),expression:z.expression}}}ue.to=J})(ze=e.InlineValue||(e.InlineValue={}));var Je;(function(ue){function me(z){return{frameId:z.frameId,stoppedLocation:f.from(z.stoppedLocation)}}ue.from=me;function J(z){return new w.InlineValueContext(z.frameId,f.to(z.stoppedLocation))}ue.to=J})(Je=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ue){function me(z){return{range:f.from(z.range),kind:z.kind}}ue.from=me;function J(z){return new w.DocumentHighlight(f.to(z.range),z.kind)}ue.to=J})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ke;(function(ue){function me(J){switch(J){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ue.to=me})(Ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(ue){function me(J){return{triggerKind:Ke.to(J.triggerKind),triggerCharacter:J.triggerCharacter}}ue.to=me})(H=e.CompletionContext||(e.CompletionContext={}));var K;(function(ue){function me(z){switch(z){case w.CompletionItemTag.Deprecated:return 1}}ue.from=me;function J(z){switch(z){case 1:return w.CompletionItemTag.Deprecated}}ue.to=J})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(ue){const me=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function J(Ce){return me.get(Ce)??9}ue.from=J;const z=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function ve(Ce){return z.get(Ce)??w.CompletionItemKind.Property}ue.to=ve})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ue){function me(J,z){const ve=new w.CompletionItem(J.label);return ve.insertText=J.insertText,ve.kind=ee.to(J.kind),ve.tags=J.tags?.map(K.to),ve.detail=J.detail,ve.documentation=E.isMarkdownString(J.documentation)?y.to(J.documentation):J.documentation,ve.sortText=J.sortText,ve.filterText=J.filterText,ve.preselect=J.preselect,ve.commitCharacters=J.commitCharacters,t.Range.isIRange(J.range)?ve.range=f.to(J.range):typeof J.range=="object"&&(ve.range={inserting:f.to(J.range.insert),replacing:f.to(J.range.replace)}),ve.keepWhitespace=typeof J.insertTextRules=="undefined"?!1:Boolean(J.insertTextRules&1),typeof J.insertTextRules!="undefined"&&J.insertTextRules&4?ve.insertText=new w.SnippetString(J.insertText):(ve.insertText=J.insertText,ve.textEdit=ve.range instanceof w.Range?new w.TextEdit(ve.range,ve.insertText):void 0),J.additionalTextEdits&&J.additionalTextEdits.length>0&&(ve.additionalTextEdits=J.additionalTextEdits.map(Ce=>N.to(Ce))),ve.command=z&&J.command?z.fromInternal(J.command):void 0,ve}ue.to=me})(se=e.CompletionItem||(e.CompletionItem={}));var G;(function(ue){function me(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0}}ue.from=me;function J(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation}}ue.to=J})(G=e.ParameterInformation||(e.ParameterInformation={}));var ne;(function(ue){function me(z){return{label:z.label,documentation:z.documentation?y.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(G.from):[],activeParameter:z.activeParameter}}ue.from=me;function J(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?y.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(G.to):[],activeParameter:z.activeParameter}}ue.to=J})(ne=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ue){function me(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(ne.from):[]}}ue.from=me;function J(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(ne.to):[]}}ue.to=J})(de=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(ue){function me(z){return{text:z.text,position:i.from(z.position),kind:xe.from(z.kind??w.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}ue.from=me;function J(z){const ve=new w.InlayHint(z.text,i.to(z.position),xe.to(z.kind));return ve.whitespaceAfter=z.whitespaceAfter,ve.whitespaceBefore=z.whitespaceBefore,ve}ue.to=J})(Te=e.InlayHint||(e.InlayHint={}));var xe;(function(ue){function me(z){return z}ue.from=me;function J(z){return z}ue.to=J})(xe=e.InlayHintKind||(e.InlayHintKind={}));var $e;(function(ue){function me(z){return{range:f.from(z.range),url:z.target,tooltip:z.tooltip}}ue.from=me;function J(z){let ve;if(z.url)try{ve=typeof z.url=="string"?T.URI.parse(z.url,!0):T.URI.revive(z.url)}catch(Ce){}return new w.DocumentLink(f.to(z.range),ve)}ue.to=J})($e=e.DocumentLink||(e.DocumentLink={}));var je;(function(ue){function me(z){const ve=new w.ColorPresentation(z.label);return z.textEdit&&(ve.textEdit=N.to(z.textEdit)),z.additionalTextEdits&&(ve.additionalTextEdits=z.additionalTextEdits.map(Ce=>N.to(Ce))),ve}ue.to=me;function J(z){return{label:z.label,textEdit:z.textEdit?N.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(ve=>N.from(ve)):void 0}}ue.from=J})(je=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ue){function me(z){return new w.Color(z[0],z[1],z[2],z[3])}ue.to=me;function J(z){return[z.red,z.green,z.blue,z.alpha]}ue.from=J})(et=e.Color||(e.Color={}));var st;(function(ue){function me(z){return{range:f.from(z.range)}}ue.from=me;function J(z){return new w.SelectionRange(f.to(z.range))}ue.to=J})(st=e.SelectionRange||(e.SelectionRange={}));var _e;(function(ue){function me(J){switch(J){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ue.to=me})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ue){function me(z){switch(z){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=me;function J(z){switch(z){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ue.to=J})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(ue){function me(z){if(z===w.EndOfLine.CRLF)return 1;if(z===w.EndOfLine.LF)return 0}ue.from=me;function J(z){if(z===1)return w.EndOfLine.CRLF;if(z===0)return w.EndOfLine.LF}ue.to=J})(q=e.EndOfLine||(e.EndOfLine={}));var X;(function(ue){function me(J){if(typeof J=="object")return J.viewId;switch(J){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=me})(X=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ue){function me(J){const z={start:J.start+1,end:J.end+1};return J.kind&&(z.kind=Ue.from(J.kind)),z}ue.from=me})(ge=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(ue){function me(J){if(J)switch(J){case w.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ue.from=me})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(ue){function me(J){if(J)return{pinned:typeof J.preview=="boolean"?!J.preview:void 0,inactive:J.background,preserveFocus:J.preserveFocus,selection:typeof J.selection=="object"?f.from(J.selection):void 0,override:typeof J.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ue.from=me})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(ue){function me(z){return z instanceof w.RelativePattern||typeof z=="string"?z:J(z)?new w.RelativePattern(z.base,z.pattern):z}ue.from=me;function J(z){const ve=z;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var mt;(function(ue){function me(J){if(J){if(Array.isArray(J))return J.map(me);if(typeof J=="string")return J;{const z=J;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:rt.from(z.pattern),exclusive:z.exclusive}}}else return}ue.from=me})(mt=e.LanguageSelector||(e.LanguageSelector={}));var ut;(function(ue){function me(z){return{start:z.start,end:z.end}}ue.from=me;function J(z){return new w.NotebookRange(z.start,z.end)}ue.to=J})(ut=e.NotebookRange||(e.NotebookRange={}));var St;(function(ue){function me(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}ue.to=me;function J(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}ue.from=J})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(ue){function me(z){switch(z){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}ue.from=me;function J(z){switch(z){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}ue.to=J})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ue){function me(z){const ve={metadata:z.metadata??Object.create(null),cells:[]};for(let Ce of z.cells)w.NotebookCellData.validate(Ce),ve.cells.push(Xe.from(Ce));return ve}ue.from=me;function J(z){const ve=new w.NotebookData(z.cells.map(Xe.to));return(0,C.isEmptyObject)(z.metadata)||(ve.metadata=z.metadata),ve}ue.to=J})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(ue){function me(z){return{cellKind:Tt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:St.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Ie.from):[]}}ue.from=me;function J(z){return new w.NotebookCellData(Tt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Ie.to):void 0,z.metadata,z.internalMetadata?St.to(z.internalMetadata):void 0)}ue.to=J})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(ue){function me(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}ue.from=me;function J(z){return new w.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}ue.to=J})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ue){function me(z){return{outputId:z.id,items:z.items.map(vt.from),metadata:z.metadata}}ue.from=me;function J(z){const ve=z.items.map(vt.to);return new w.NotebookCellOutput(ve,z.outputId,z.metadata)}ue.to=J})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(ue){function me(Ce){if(Ce!=null){if(Ce instanceof w.RelativePattern||typeof Ce=="string")return Ce;if(ve(Ce))return new w.RelativePattern(Ce.base,Ce.pattern);if(z(Ce))return{include:rt.from(Ce.include)||void 0,exclude:rt.from(Ce.exclude)||void 0}}}ue.from=me;function J(Ce){return typeof Ce=="string"?Ce:ve(Ce)?{base:Ce.base,pattern:Ce.pattern}:{include:Ce.include,exclude:Ce.exclude}}ue.to=J;function z(Ce){const Ye=Ce,Le=rt.from(Ye.include);if(!(Le&&Le instanceof w.RelativePattern||typeof Le=="string"))return!1;const ct=rt.from(Ye.exclude);return!!(ct&&ct instanceof w.RelativePattern||typeof ct=="string")}function ve(Ce){const Ye=Ce;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(ue){function me(J){return{backgroundColor:J.backgroundColor,borderColor:J.borderColor,top:J.top?U.from(J.top):void 0}}ue.from=me})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(ue){function me(J,z,ve){const Ce=typeof J.command=="string"?{title:"",command:J.command}:J.command;return{alignment:J.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Ce,ve),text:J.text,tooltip:J.tooltip,accessibilityInformation:J.accessibilityInformation,priority:J.priority}}ue.from=me})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var oe;(function(ue){function me(J){return{transientOutputs:J?.transientOutputs??!1,transientCellMetadata:J?.transientCellMetadata??{},transientDocumentMetadata:J?.transientDocumentMetadata??{}}}ue.from=me})(oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ue){function me(z){return{uri:z.uri,provides:z.provides}}ue.from=me;function J(z){return new w.NotebookRendererScript(T.URI.revive(z.uri),z.provides)}ue.to=J})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var he;(function(ue){function me(z){return{message:y.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?ce.from(z.location):void 0}}ue.from=me;function J(z){const ve=new w.TestMessage(typeof z.message=="string"?z.message:y.to(z.message));return ve.actualOutput=z.actual,ve.expectedOutput=z.expected,ve.location=z.location?ce.to(z.location):void 0,ve}ue.to=J})(he=e.TestMessage||(e.TestMessage={}));var ke;(function(ue){let me;(function(J){J.Delimiter="\0"})(me||(me={})),ue.namespace=(J,z)=>J+"\0"+z,ue.denamespace=J=>{const z=J.indexOf("\0");return{ctrlId:J.slice(0,z),tagId:J.slice(z+1)}}})(ke=e.TestTag||(e.TestTag={}));var Oe;(function(ue){function me(Ce){const Ye=(0,s.getPrivateApiFor)(Ce).controllerId;return{extId:p.TestId.fromExtHostTestItem(Ce,Ye).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(Le=>ke.namespace(Ye,Le.id)),range:f.from(Ce.range)||null,description:Ce.description||null,error:Ce.error&&y.fromStrict(Ce.error)||null}}ue.from=me;function J(Ce){return{parent:void 0,error:void 0,id:p.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:T.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(Ye=>{const{tagId:Le}=ke.denamespace(Ye);return new w.TestTag(Le)}),range:f.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0}}ue.toPlain=J;function z(Ce){const Ye=p.TestId.fromString(Ce.extId),Le=new s.TestItemImpl(Ye.controllerId,Ye.localId,Ce.label,T.URI.revive(Ce.uri));return Le.range=f.to(Ce.range||void 0),Le.description=Ce.description||void 0,Le}function ve(Ce){let Ye;for(const Le of Ce.tests){const ct=z(Le.item);(0,s.getPrivateApiFor)(ct).parent=Ye,Ye=ct}return Ye}ue.toItemFromContext=ve})(Oe=e.TestItem||(e.TestItem={})),function(ue){function me(z){return{id:z.id}}ue.from=me;function J(z){return new w.TestTag(z.id)}ue.to=J}(ke=e.TestTag||(e.TestTag={}));var Me;(function(ue){const me=(z,ve)=>{const Ce={...Oe.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(Le=>Le.type===0).map(he.to)})),children:z.children.map(Ye=>ve.get(Ye)).filter(C.isDefined).map(Ye=>me(Ye,ve))};for(const Ye of Ce.children)Ye.parent=Ce;return Ce};function J(z){const ve=[],Ce=new Map;for(const Ye of z.items)Ce.set(Ye.item.extId,Ye),z.request.targets.some(Le=>Le.controllerId===Ye.controllerId&&Le.testIds.includes(Ye.item.extId))&&ve.push(Ye);return{completedAt:z.completedAt,results:ve.map(Ye=>me(Ye,Ce))}}ue.to=J})(Me=e.TestResults||(e.TestResults={}));var He;(function(ue){function me(Ce){return{covered:Ce.covered,total:Ce.covered}}function J(Ce){return"line"in Ce?i.from(Ce):f.from(Ce)}function z(Ce){return"branches"in Ce?{count:Ce.executionCount,location:J(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&J(Ye.location)})):void 0}:{type:0,count:Ce.executionCount,location:J(Ce.location)}}ue.fromDetailed=z;function ve(Ce){return{uri:Ce.uri,statement:me(Ce.statementCoverage),branch:Ce.branchCoverage&&me(Ce.branchCoverage),function:Ce.functionCoverage&&me(Ce.functionCoverage),details:Ce.detailedCoverage?.map(z)}}ue.fromFile=ve})(He=e.TestCoverage||(e.TestCoverage={}));var it;(function(ue){function me(J){switch(J){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ue.to=me})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ue){function me(z){const ve=new w.TypeHierarchyItem(W.to(z.kind),z.name,z.detail||"",T.URI.revive(z.uri),f.to(z.range),f.to(z.selectionRange));return ve._sessionId=z._sessionId,ve._itemId=z._itemId,ve}ue.to=me;function J(z,ve,Ce){if(ve=ve??z._sessionId,Ce=Ce??z._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,kind:W.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:f.from(z.range),selectionRange:f.from(z.selectionRange),tags:z.tags?.map($.from)}}ue.from=J})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[170],be([0,1,2,16,7,8,231]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,t,_,n={timeout:1500,errors:3}){this._logService=T,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(t,_,n)=>{const s={dispose:this._callbacks.push([t,_,T])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(T,t){const _=d.URI.revive(T);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let u of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(_),k=await this._deliverEventAsyncAndBlameBadListeners(u,{document:p,reason:A.TextDocumentSaveReason.to(t)});s.push(k)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([T,t,_],n){const m=this._badListeners.get(T);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,T,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const u=this._badListeners.get(T);this._badListeners.set(T,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,t,_,n){const m=[],s=Date.now(),{document:u,reason:p}=n,{version:k}=u,w=Object.freeze({document:u,reason:p,waitUntil(o){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(o))}});try{t.apply(_,[w])}catch(o){return Promise.reject(o)}return Object.freeze(m),new Promise((o,f)=>{const S=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(S),o(i)}).catch(i=>{clearTimeout(S),f(i)})}).then(o=>{const f={edits:[]};for(const S of o)if(Array.isArray(S)&&S.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:g,range:a}of S)f.edits.push({_type:2,resource:u.uri,edit:{range:a&&A.Range.from(a),text:i,eol:g&&A.EndOfLine.from(g)}});if(f.edits.length!==0)return k===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(we[171],be([0,1,3,27,2,8,7]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(t,_,n,m,s){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),s&&(this._config+=4);const u=(0,M.parse)(_),p=t(k=>{if(!n)for(let w of k.created){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidCreate.fire(o)}if(!m)for(let w of k.changed){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let w of k.deleted){const o=E.URI.revive(w);u(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(t,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,n,m){return new P(this._onFileSystemEvent.event,t,_,n,m)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(n,m,s)=>{const u=function(k){n.call(m,k)};return u.extension=t,_.event(u,void 0,s)}}async $onWillRunFileOperation(t,_,n,m){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(s=>({oldUri:E.URI.revive(s.source),newUri:E.URI.revive(s.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(s=>E.URI.revive(s.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(s=>E.URI.revive(s.target))},n,m)}}async _fireWillEvent(t,_,n,m){const s=new Set,u=[];if(await t.fireAsync(_,m,async(k,w)=>{const o=Date.now(),f=await Promise.resolve(k);f instanceof F.WorkspaceEdit&&(u.push(f),s.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),m.isCancellationRequested||u.length===0)return;const p={edits:[]};for(let k of u){let{edits:w}=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=C}),define(we[172],be([0,1,11,23,2,8,7,89]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,m,s,u){this.start=n,this.deletedCount=m,this.deletedItems=s,this.items=u}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(s=>s.apiCell)}))}}class T{constructor(n,m,s){this.notebook=n,this._extHostDocument=m,this._cellData=s,this.handle=s.handle,this.uri=E.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,m,s){const u=s.map(A.NotebookCellOutputItem.to),p=this._outputs.find(k=>k.id===n);p&&(m||(p.items.length=0),p.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=T;class t{constructor(n,m,s,u,p,k){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=s,this._emitter=u,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===d.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const s of n.rawEvents)s.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===P.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,s=n.end|0;return m<0&&(m=0),s>this._cells.length&&(s=this._cells.length),n.with({start:m,end:s})}_getCells(n){n=this._validateRange(n);const m=[];for(let s=n.start;s<n.end;s++)m.push(this._cells[s]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const s=[],u=[],p=[];n.reverse().forEach(k=>{const o=k[2].map(i=>{const g=new T(this,this._textDocumentsAndEditors,i);return m||u.push(T.asModelAddData(this.apiNotebook,i)),g}),f=new C(k[0],k[1],[],o),S=this._cells.splice(k[0],k[1],...o);for(const i of S)p.push(i.uri),f.deletedItems.push(i.apiCell);s.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(s)}))}_moveCell(n,m){const s=this._cells.splice(n,1);this._cells.splice(m,0,...s);const u=[new C(n,1,s.map(p=>p.apiCell),[]),new C(m,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(u)}))}_setCellOutputs(n,m){const s=this._cells[n];s.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,m,s,u){const p=this._cells[n];p.setOutputItems(m,s,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,m){const s=this._cells[n];s.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(s.uri,m)}_changeCellMime(n,m){const s=this._cells[n];s.apiCell.mime=m}_changeCellMetadata(n,m){const s=this._cells[n],u=s.apiCell.metadata;s.setMetadata(m);const p=s.apiCell.metadata;(0,M.equals)(u,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,m){const s=this._cells[n],u=s.internalMetadata;if(s.setInternalMetadata(m),u.runState!==m.runState){const p=m.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,7,8,16]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:T})}replaceCells(C,T,t){this._throwIfFinalized(),!(C===T&&t.length===0)&&this._collectedEdits.push({editType:1,index:C,count:T-C,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(C,T,t,_,n,m){this.id=C,this._proxy=T,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(T){if(!Array.isArray(T)||!T.every(d.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");C._selections=T,C._trySetSelections(T)},get visibleRanges(){return C._visibleRanges},revealRange(T,t){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(T),t??d.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(T){const t=new A(this.document.version);return T(t),C._applyEdit(t.finalize())},setDecorations(T,t){return C.setDecorations(T,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const T=[];let t=-1;for(let _=0;_<C.cellEdits.length;_++){if(t<0){T.push(C.cellEdits[_]),t++;continue}const m=T[t],s=C.cellEdits[_];if(m.editType===1&&s.editType===1&&m.index===s.index){m.cells.push(...C.cellEdits[_].cells),m.count+=C.cellEdits[_].count;continue}T.push(C.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,T)}setDecorations(C,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return T.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(T),C.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[173],be([0,1,8,145,125,21,54,16]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,s){const u=this._handles++,{title:p,location:k,cancellable:w}=m,o={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(u,{location:d.ProgressLocation.from(k),title:p,source:o,cancellable:w},n).catch(P.onUnexpectedExternalError),this._withProgress(u,s,!!w)}_withProgress(n,m,s){let u;s&&(u=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,u));const p=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let k;try{k=m(new t(this._proxy,n),s&&u?u.token:A.CancellationToken.None)}catch(w){throw p(n),w}return k.then(w=>p(n),w=>p(n)),k}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function T(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class t extends M.Progress{constructor(n,m){super(s=>this.throttledReport(s));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Be([(0,F.throttle)(100,(_,n)=>T(_,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(we[94],be([0,1,42,16,55,8,7]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,m,s){const u=P._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,u,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new E.IdGenerator("TextEditorDecorationType");class C{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let s=null;if(n instanceof F.Position)s=new F.Range(n,n);else if(n instanceof F.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof F.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,s){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:m,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class T{constructor(n,m,s,u){this._proxy=n,this._id=m,this._accept(s),this._logService=u;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(k){p._setTabSize(k)},get insertSpaces(){return p._insertSpaces},set insertSpaces(k){p._setInsertSpaces(k)},get cursorStyle(){return p._cursorStyle},set cursorStyle(k){p._setCursorStyle(k)},get lineNumbers(){return p._lineNumbers},set lineNumbers(k){p._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let s=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(s=!0,m.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,s=!0,m.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(s=!0,m.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,s=!0,m.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(n){n.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=T;class t{constructor(n,m,s,u,p,k,w,o){this.id=n,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new T(this._proxy,this.id,k,s),this._visibleRanges=w,this._viewColumn=o;const f=this;this.value=Object.freeze({get document(){return u.getValue()},set document(S){throw(0,M.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(S){if(!(S instanceof F.Selection))throw(0,M.illegalArgument)("selection");f._selections=[S],f._trySetSelection()},get selections(){return f._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");f._selections=S,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(S){throw(0,M.readonly)("visibleRanges")},get options(){return f._options.value},set options(S){f._disposed||f._options.assign(S)},get viewColumn(){return f._viewColumn},set viewColumn(S){throw(0,M.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new C(u.getValue(),i);return S(g),f._applyEdit(g)},insertSnippet(S,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=f._selections.map(r=>A.Range.from(r));else if(i instanceof F.Position){const{lineNumber:r,column:v}=A.Position.from(i);a=[{startLineNumber:r,startColumn:v,endLineNumber:r,endColumn:v}]}else if(i instanceof F.Range)a=[A.Range.from(i)];else{a=[];for(const r of i)if(r instanceof F.Range)a.push(A.Range.from(r));else{const{lineNumber:v,column:l}=A.Position.from(r);a.push({startLineNumber:v,startColumn:l,endLineNumber:v,endColumn:l})}}return m.$tryInsertSnippet(n,S.value,a,g)},setDecorations(S,i){const g=i.length===0;g&&!f._hasDecorationsForKey.has(S.key)||(g?f._hasDecorationsForKey.delete(S.key):f._hasDecorationsForKey.add(S.key),f._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return m.$trySetDecorations(n,S.key,A.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let r=0,v=i.length;r<v;r++){const l=i[r];a[4*r]=l.start.line+1,a[4*r+1]=l.start.character+1,a[4*r+2]=l.end.line+1,a[4*r+3]=l.end.character+1}return m.$trySetDecorationsFast(n,S.key,a)}}))},revealRange(S,i){f._runOnProxy(()=>m.$tryRevealRange(n,A.Range.from(S),i||F.TextEditorRevealType.Default))},show(S){m.$tryShowEditor(n,A.ViewColumn.from(S))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,d.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,d.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,d.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,d.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(p=>p.range);s.sort((p,k)=>p.end.line===k.end.line?p.end.character===k.end.character?p.start.line===k.start.line?p.start.character-k.start.character:p.start.line-k.start.line:p.end.character-k.end.character:p.end.line-k.end.line);for(let p=0,k=s.length-1;p<k;p++){const w=s[p].end;if(s[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=m.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,u,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=t}),define(we[174],be([0,1,128,24,2,3,6,161,12,7,10,15,8,21,158]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,o){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let f;return Array.isArray(w.highlights)&&(f=w.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),f=f.length?f:void 0),{label:w.label,highlights:f}}}class p{constructor(o,f,S){this._proxy=o,this.commands=f,this.logService=S,this.treeViews=new Map;function i(g){return g&&g.$treeViewId&&g.$treeItemHandle}f.registerArgumentProcessor({processArgument:g=>i(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(a=>i(a)?this.convertArgument(a):a):g})}registerTreeDataProvider(o,f,S){const i=this.createTreeView(o,{treeDataProvider:f},S);return{dispose:()=>i.dispose()}}createTreeView(o,f,S){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=f.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(o,f,S);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(r){a.message=r},get title(){return a.title},set title(r){a.title=r},get description(){return a.description},set description(r){a.description=r},reveal:(r,v)=>a.reveal(r,v),dispose:async()=>{await g,this.treeViews.delete(o),a.dispose()}}}$getChildren(o,f){const S=this.treeViews.get(o);return S?S.getChildren(f):Promise.reject(new Error((0,d.localize)(0,null,o)))}async $onDrop(o,f,S){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,o)));const g=s.TreeDataTransferConverter.toITreeDataTransfer(f);if(g.items.has(P.TREE_ITEM_DATA_TRANSFER_TYPE)){const r=JSON.parse(await g.items.get(P.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(v=>i.getExtensionElement(v)).filter(v=>!!v);r.length>0?g.items.set(P.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(r)}):g.items.delete(P.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(g,S)}async $hasResolve(o){const f=this.treeViews.get(o);if(!f)throw new Error((0,d.localize)(2,null,o));return f.hasResolve}$resolve(o,f,S){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(3,null,o));return i.resolveTreeItem(f,S)}$setExpanded(o,f,S){const i=this.treeViews.get(o);if(!i)throw new Error((0,d.localize)(4,null,o));i.setExpanded(f,S)}$setSelection(o,f){const S=this.treeViews.get(o);if(!S)throw new Error((0,d.localize)(5,null,o));S.setSelection(f)}$setVisible(o,f){const S=this.treeViews.get(o);if(!S)throw new Error((0,d.localize)(6,null,o));S.setVisible(f)}createExtHostTreeView(o,f,S){const i=new k(o,f,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(o,i),i}convertArgument(o){const f=this.treeViews.get(o.$treeViewId);return f?f.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class k extends F.Disposable{constructor(o,f,S,i,g,a){super();if(this.viewId=o,this.proxy=S,this.commands=i,this.logService=g,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,a.contributes&&a.contributes.views)for(const l in a.contributes.views)for(const c of a.contributes.views[l])c.id===o&&(this._title=c.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(l=>this._onDidChangeData.fire({message:!1,element:l}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let r,v;this._register(A.Event.debounce(this._onDidChangeData.event,(l,c)=>(l||(l={message:!1,elements:[]}),c.element!==!1&&(r||(r=new Promise(b=>v=b),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(c.element)?l.elements.push(...c.element):l.elements.push(c.element)),c.message&&(l.message=!0),l),200,!0)(({message:l,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=v;return r=null,this.refresh(c).then(()=>b())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const f=o?this.getExtensionElement(o):void 0;if(o&&!f)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(o);return S||(S=await this.fetchChildrenNodes(f)),S?S.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,f){f=f||{select:!0,focus:!1};const S=(0,t.isUndefinedOrNull)(f.select)?!0:f.select,i=(0,t.isUndefinedOrNull)(f.focus)?!1:f.focus,g=(0,t.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(a=>this.resolveTreeNode(o,a[a.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:a.map(v=>v.item)},{select:S,focus:i,expand:g})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:g})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,f){const S=this.getExtensionElement(o);S&&(f?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,f){const S=this.getExtensionElement(f);if(!!S)return(0,C.asPromise)(()=>this.dndController?.onDrop(o,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,f){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(o);if(S){const i=this.nodes.get(S);if(i){const g=await this.dataProvider.resolveTreeItem(i.extensionItem,S,f)??i.extensionItem;return i.item.tooltip=this.getTooltip(g.tooltip),i.item.command=this.getCommand(i.disposableStore,g.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(f=>f?this.resolveUnknownParentChain(f).then(S=>this.resolveTreeNode(f,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(o){const f=this.nodes.get(o);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,f){const S=this.nodes.get(o);return S?Promise.resolve(S):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,f,!0)).then(i=>this.getChildren(f?f.item.handle:void 0).then(()=>{const g=this.getExtensionElement(i);if(g){const a=this.nodes.get(g);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let f;if(typeof o=="string"){const S=this.getExtensionElement(o);f=S?this.nodes.get(S):void 0}else f=o;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const f=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(f.token.isCancellationRequested)return;const g=await Promise.all((0,_.coalesce)(i||[]).map(async a=>{const r=await this.dataProvider.getTreeItem(a);return r&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(a,r,S):null}));return f.token.isCancellationRequested?void 0:(0,_.coalesce)(g)}finally{f.dispose()}}refresh(o){if(o.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(o);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const f=new Set,S=o.map(g=>this.nodes.get(g));for(const g of S)if(g&&!f.has(g.item.handle)){let a=g;for(;a&&a.parent&&S.findIndex(r=>a&&a.parent&&r&&r.item.handle===a.parent.item.handle)===-1;){const r=this.elements.get(a.parent.item.handle);a=r?this.nodes.get(r):void 0}a&&!a.parent&&f.add(g.item.handle)}const i=[];return f.forEach(g=>{const a=this.elements.get(g);if(a){const r=this.nodes.get(a);r&&(!r.parent||!f.has(r.parent.item.handle))&&i.push(g)}}),i}refreshHandles(o){const f={};return Promise.all(o.map(S=>this.refreshNode(S).then(i=>{i&&(f[S]=i.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(o){const f=this.getExtensionElement(o);if(f){const S=this.nodes.get(f);if(S)return this.clearChildren(f),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(i=>{if(i){const g=this.createTreeNode(f,i,S.parent);return this.updateNodeCache(f,g,S,S.parent),S.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,f,S){const i=this.createTreeNode(o,f,S);if(f.id&&this.elements.has(i.item.handle))throw new Error((0,d.localize)(7,null,f.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,S),i}getTooltip(o){return T.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,f){return f?this.commands.toInternal(f,o):void 0}createTreeNode(o,f,S){const i=new F.DisposableStore,g=this.createHandle(o,f,S),a=this.getLightIconPath(f);return{item:{handle:g,parentHandle:S?S.item.handle:void 0,label:u(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(i,f.command),contextValue:f.contextValue,icon:a,iconDark:this.getDarkIconPath(f)||a,themeIcon:this.getThemeIcon(f),collapsibleState:(0,t.isUndefinedOrNull)(f.collapsibleState)?T.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof T.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:f,label:S,resourceUri:i},g,a){if(f)return`${k.ID_HANDLE_PREFIX}/${f}`;const r=u(S,this.extension),v=g?g.item.handle:k.LABEL_HANDLE_PREFIX;let l=r?r.label:i?(0,M.basename)(i):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const c=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(g)||[];let h,y=0;do{if(h=`${v}/${y}:${l}`,a||!this.elements.has(h)||c===h)break;y++}while(y<=b.length);return h}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof T.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,f){this.elements.set(f.item.handle,o),this.nodes.set(o,f)}updateNodeCache(o,f,S,i){this.elements.delete(f.item.handle),this.nodes.delete(o),f.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(o,f);const g=this.getChildrenNodes(i)||[],a=g.filter(r=>r.item.handle===S.item.handle)[0];a&&g.splice(g.indexOf(a),1,f)}addNodeToParentCache(o,f){f?(f.children||(f.children=[]),f.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const f=this.nodes.get(o);if(f){if(f.children)for(const S of f.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}f.children=void 0}}else this.clearAll()}clear(o){const f=this.nodes.get(o);if(f){if(f.children)for(const S of f.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(we[175],be([0,1,12,3,6,10,50,8,90,68]),function(re,e,d,M,E,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||m>s.expandLevels)&&(s.expandLevels=m),s.expand===1){const u=this.resolveChildren(s);return u.isOpen()?this.expandChildren(s,m-1):u.wait().then(()=>this.expandChildren(s,m-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,m-1)):this.expandChildren(s,m-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const w of m.ops)this.onTestItemEvent(n,w);break;case 3:const{key:s,value:u,previous:p}=m,k=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,p,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[s]:u??null}}]);break}break;default:(0,A.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=T.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),u=(0,F.getPrivateApiFor)(n);u.parent&&u.parent!==m?.actual&&u.parent.children.delete(n.id);let p=this.tree.get(s.toString());if(!p){p={fullId:s,actual:n,parent:m?s.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,p,m);return}if(p.actual===n){this.connectItem(n,p,m);return}const k=p.actual.children,w=p.actual,o=(0,F.diffTestItems)(w,n);(0,F.getPrivateApiFor)(w).listener=void 0,p.actual=n,p.expand=0;for(const[f,S]of o)this.onTestItemEvent(p,{op:3,key:f,value:S,previous:w[f]});this.connectItemAndChildren(n,p,m);for(const f of k)n.children.get(f.id)||this.removeItem(T.TestId.joinToString(s,f.id))}diffTagRefs(n,m,s){const u=new Set(m.map(p=>p.id));for(const p of n)u.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:s,item:{tags:n.map(p=>P.TestTag.namespace(this.controllerId,p.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,F.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,s){this.setItemParent(n,s);const u=(0,F.getPrivateApiFor)(n);u.parent=s?.actual,u.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(n,m,s){this.connectItem(n,m,s);for(const u of n.children)this.upsertItem(u,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const s=[];for(const u of n.actual.children){const p=this.expand(T.TestId.joinToString(n.fullId,u.id),m);(0,d.isThenable)(p)&&s.push(p)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new d.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new d.Barrier,s=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){s(p)}return(0,d.isThenable)(u)?u.catch(s).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[m];for(;s.length;){const u=s.pop();if(!!u){(0,F.getPrivateApiFor)(u.actual).listener=void 0;for(const p of u.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(u.fullId.toString());for(const p of u.actual.children)s.push(this.tree.get(T.TestId.joinToString(u.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[176],be([0,1,4,141]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(M.IEnvironmentService)}),define(we[177],be([0,1,26,3,17]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${d.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(n=>_.add(d.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(d.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(s=>m.add(d.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(d.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,k){this.addNode(p),this.addNode(k),this._arcs.has(p)?this._arcs.get(p).push(k):this._arcs.set(p,[k])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,k){const w=_.getArcs(p);for(let o=0;o<w.length;o++)if(!k.has(w[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const k=d.ExtensionIdentifier.toKey(p.identifier);if(n.set(k,p),p.extensionDependencies)for(let w of p.extensionDependencies){const o=d.ExtensionIdentifier.toKey(w);_.addArc(k,o)}}let m=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>m.add(p));let s=_.getNodes().filter(p=>!m.has(p)),u;do{u=!1;for(let p=0;p<s.length;p++){const k=s[p];_.hasOnlyGoodArcs(k,m)&&(s.splice(p,1),p--,m.add(k),u=!0)}}while(u);return s.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(d.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=F;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function C(T,t){const _=T.isBuiltin?0:T.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==n)return _-n;const m=E.posix.basename(T.extensionLocation.path),s=E.posix.basename(t.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(we[178],be([0,1,22]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(P){const C=d.VSBuffer.alloc(1);switch(P){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=A;function F(P,C){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=F}),define(we[30],be([0,1,3,2,4,26,147]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var P;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class T{constructor(S){this.dependency=S}}e.MissingExtensionDependency=T;var t;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;class n{constructor(S,i,g,a){this.codeLoadingTime=S,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=a}}e.ActivationTimes=n;class m{constructor(S,i){this.description=S,this.value=i}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var s;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(f){f.enableProposedApi||p(f)}e.checkProposedApiEnabled=u;function p(f){throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.throwProposedApiError=p;function k(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=k;function w(f,S){return{identifier:new A.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!S,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=w;class o{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,i){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,i,g,a,r){}_onDidActivateExtensionError(S,i){}_onExtensionRuntimeError(S,i){}_onExtensionHostExit(S){}}e.NullExtensionService=o}),define(we[179],be([0,1,26,30,14]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class F{constructor(s,u,p,k){this.startup=s,this.codeLoadingTime=u,this.activateCallTime=p,this.activateResolvedTime=k}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class P{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,u){return s===-1||u===-1?-1:u-s}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class C{constructor(s,u,p,k,w,o){this.activationFailed=s,this.activationFailedError=u,this.activationTimes=p,this.module=k,this.exports=w,this.subscriptions=o}}e.ActivatedExtension=C;class T extends C{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class t extends C{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends C{constructor(s){super(!0,s,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(s,u,p,k,w){this._logService=w,this._registry=s,this._resolvedExtensionsSet=new Set,u.forEach(o=>this._resolvedExtensionsSet.add(d.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(d.ExtensionIdentifier.toKey(o),o)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const u=d.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(u)}getActivatedExtension(s){const u=d.ExtensionIdentifier.toKey(s),p=this._activatedExtensions.get(u);if(!p)throw new Error("Extension `"+s.value+"` is not known or not activated");return p}activateByEvent(s,u){if(this._alreadyActivatedEvents[s])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(p.map(k=>({id:k.identifier,reason:{startup:u,extensionId:k.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,u){const p=this._registry.getExtensionDescription(s);if(!p)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:p.identifier,reason:u}])}_handleActivateRequest(s,u,p){if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(s.id))){u[d.ExtensionIdentifier.toKey(s.id)]=s;return}const k=this._registry.getExtensionDescription(s.id);if(!k){const f=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,f,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(s.id),new _(f));return}const w=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let o=!0;for(let f=0,S=w.length;f<S;f++){const i=w[f];if(this._resolvedExtensionsSet.has(d.ExtensionIdentifier.toKey(i)))continue;const g=this._activatedExtensions.get(d.ExtensionIdentifier.toKey(i));if(g&&!g.activationFailed)continue;if(g&&g.activationFailed){const l=k.displayName||k.identifier.value,c=this._registry.getExtensionDescription(i),b=c&&c.displayName||i,h=new Error(`Cannot activate the '${l}' extension because its dependency '${b}' failed to activate`);h.detail=g.activationFailedError,this._host.onExtensionActivationError(k.identifier,h,null),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(k.identifier),new _(h));return}if(this._hostExtensionsMap.has(d.ExtensionIdentifier.toKey(i))){o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(d.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){if(!a.main&&!a.browser)continue;o=!1,u[d.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}const r=k.displayName||k.identifier.value,v=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(k.identifier,v,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(d.ExtensionIdentifier.toKey(k.identifier),new _(v));return}o?u[d.ExtensionIdentifier.toKey(k.identifier)]=s:p.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(w=>!this._activatedExtensions.has(d.ExtensionIdentifier.toKey(w.id))),s.length===0))return Promise.resolve(void 0);const u=Object.create(null),p=[];for(let w=0,o=s.length;w<o;w++)this._handleActivateRequest(s[w],u,p);for(let w=0,o=p.length;w<o;w++){const f=d.ExtensionIdentifier.toKey(p[w].id);u[f]&&delete u[f]}const k=Object.keys(u).map(w=>u[w]);return p.length===0?Promise.all(k.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(k).then(w=>this._activateExtensions(p))}_activateExtension(s,u){const p=d.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const k=this._activatingExtensions.get(p);if(k)return k;const w=this._host.actualActivateExtension(s,u).then(void 0,o=>{const f=new Error;return o&&o.name&&(f.name=o.name),o&&o.message?f.message=`Activating extension '${s.value}' failed: ${o.message}.`:f.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(f.stack=o.stack),this._host.onExtensionActivationError(s,f,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};n=Be([We(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(we[180],be([0,1,16]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,F)=>{this._actualOk=A,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,d.onUnexpectedError)(A))}then(A,F){return this._ensureActual().then(A,F)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(we[38],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(T,t){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=t,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const M=[];function E(C){const T=new d(!0,C);return M[T.nid]=T,T}e.createMainContextProxyIdentifier=E;function A(C){const T=new d(!1,C);return M[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function F(C){return M[C].sid}e.getStringIdentifierForProxy=F;class P{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=P}),define(we[5],be([0,1,56,2,38]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function f(i,g){return Object.defineProperty(i,o.name,{value:g,enumerable:!0}),i}o.mixin=f;function S(i){return i[o.name]}o.of=S})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(f){return f._id=m._n++,f}}e.IdObject=m,m._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(o){if(o&&o.edits)for(const f of o.edits)typeof f.resource=="object"?f.resource=M.URI.revive(f.resource):(f.newUri=M.URI.revive(f.newUri),f.oldUri=M.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,d.revive)(f.metadata));return o}e.reviveWorkspaceEditDto=k;var w;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,C){return this._proxy.$getPassword(P,C)}store(P,C,T){return this._proxy.$setPassword(P,C,T)}delete(P,C){return this._proxy.$deletePassword(P,C)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,14,5,13]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(C,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(E.MainContext.MainThreadTelemetry)}report(C,T,t){const _=this.getUsageKey(C,T);this._reportedUsages.has(_)||(this._reportedUsages.add(_),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:C}))}getUsageKey(C,T){return`${C}-${T.identifier.value}`}};F=Be([We(0,A.IExtHostRpcService),We(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(P,C,T){}})}),define(we[181],be([0,1,3,5,7,26]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,T,t,_={}){const n=A.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let u=m.find(p=>p.scopes===s);if(u)return u.result;{const p=this._getSession(C,n,T,t,_);u={scopes:s,result:p},m.push(u),this._inFlightRequests.set(n,m);try{await p}finally{const k=m.findIndex(w=>w.scopes===s);k>-1&&(m.splice(k),this._inFlightRequests.set(n,m))}return p}}async _getSession(C,T,t,_,n={}){await this._proxy.$ensureProvider(t);const m=C.displayName||C.name;return this._proxy.$getSession(t,_,T,m,n)}async removeSession(C,T){const t=this._authenticationProviders.get(C);return t?t.provider.removeSession(T):this._proxy.$removeSession(C,T)}registerAuthenticationProvider(C,T,t,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:T,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:T});const n=t.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,T,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(s=>s.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,T){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,T){return this._onDidChangeSessions.fire({provider:{id:C,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[182],be([0,1,5,13,8]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,C){this._extHostDocumentsAndEditors=C,this._proxy=P.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const C=E.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};A=Be([We(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[183],be([0,1,5]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const F=A.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(P){return F.$writeText(P)}})}}e.ExtHostClipboard=M}),define(we[39],be([0,1,10,7,8,23,5,15,14,56,44,111,2,6,4,13,50,22,38,45]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(v,l){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(F.MainContext.MainThreadCommands),this._logService=l,this.converter=new S(this,c=>{const b=this._apiCommands.get(c);return b?.result===g.Void?b:void 0},l),this._argumentProcessors=[{processArgument(c){return(0,T.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(b){if(t.Range.isIRange(b))return E.Range.to(b);if(_.Position.isIPosition(b))return E.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return E.location.to(b);if(b instanceof k.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const l=this.registerCommand(!1,v.id,async(...c)=>{const b=v.args.map((y,R)=>{if(!y.validate(c[R]))throw new Error(`Invalid argument '${y.name}' when running '${v.id}', received: ${c[R]}`);return y.convert(c[R])}),h=await this.executeCommand(v.internalId,...b);return v.result.convert(h,c,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{l.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,l,c,b,h,y){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:c,thisArg:b,description:h,extension:y}),v&&this._proxy.$registerCommand(l),new M.Disposable(()=>{this._commands.delete(l)&&v&&this._proxy.$unregisterCommand(l)})}executeCommand(v,...l){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,l,!0)}async _doExecuteCommand(v,l,c){if(this._commands.has(v))return this._executeContributedCommand(v,l,!1);{let b=!1;const h=(0,A.cloneAndChange)(l,function(y){if(y instanceof M.Position)return E.Position.from(y);if(y instanceof M.Range)return E.Range.from(y);if(y instanceof M.Location)return E.location.from(y);if(M.NotebookRange.isNotebookRange(y))return E.NotebookRange.from(y);if(y instanceof ArrayBuffer)return b=!0,k.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return b=!0,k.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(v,b?new w.SerializableObjectWithBuffers(h):h,c);return(0,T.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(v,l,!1);throw y}}}async _executeContributedCommand(v,l,c){const b=this._commands.get(v);if(!b)throw new Error("Unknown command");let{callback:h,thisArg:y,description:R}=b;if(R)for(let I=0;I<R.args.length;I++)try{(0,d.validateConstraint)(l[I],R.args[I].constraint)}catch(U){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${R.args[I].name}' - ${R.args[I].description}`)}try{return await h.apply(y,l)}catch(I){if(v===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...l);U&&(v=U.command)}throw this._logService.error(I,v,b.extension?.identifier),c?new class extends Error{constructor(){super((0,o.toErrorMessage)(I));this.id=v,this.source=b.extension?.displayName??b.extension?.name}}:I}}$executeContributedCommand(v,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(l=l.map(c=>this._argumentProcessors.reduce((b,h)=>h.processArgument(b),c)),this._executeContributedCommand(v,l,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(l=>(v&&(l=l.filter(c=>c[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[l,c]of this._commands){let{description:b}=c;b&&(v[l]=b)}return Promise.resolve(v)}};f=Be([We(0,u.IExtHostRpcService),We(1,C.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class S{constructor(v,l,c){this._commands=v,this._lookupApiCommand=l,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,l){if(!v)return;const c={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return c;const b=this._lookupApiCommand(v.command);if(b)c.id=b.internalId,c.arguments=b.args.map((h,y)=>h.convert(v.arguments&&v.arguments[y]));else if((0,P.isNonEmptyArray)(v.arguments)){const h=++this._cachIdPool;this._cache.set(h,v),l.add((0,m.toDisposable)(()=>{this._cache.delete(h),this._logService.trace("CommandsConverter#DISPOSE",h)})),c.$ident=h,c.id=this.delegatingCommandId,c.arguments=[h],this._logService.trace("CommandsConverter#CREATE",v.command,h)}return c}fromInternal(v){const l=F.ObjectIdentifier.of(v);return typeof l=="number"?this._cache.get(l):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const l=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=S;class i{constructor(v,l,c,b){this.name=v,this.description=l,this.validate=c,this.convert=b}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,l){return new i(v??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),i.Position=new i("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),i.Range=new i("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),i.Selection=new i("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),i.Number=new i("number","",r=>typeof r=="number",r=>r),i.String=new i("string","",r=>typeof r=="string",r=>r),i.CallHierarchyItem=new i("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",r=>r instanceof p.TestItemImpl,E.TestItem.from);class g{constructor(v,l){this.description=v,this.convert=l}}e.ApiCommandResult=g,g.Void=new g("no result",r=>r);class a{constructor(v,l,c,b,h){this.id=v,this.internalId=l,this.description=c,this.args=b,this.result=h}}e.ApiCommand=a}),define(we[184],be([0,1,8,7,60,39,15,81]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(d.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,F.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(p){const k=new s(p.name,d.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],d.Range.to(p.range)));return k.detail=p.detail,k.range=k.location.range,k.selectionRange=d.Range.to(p.selectionRange),k.children=p.children?p.children.map(s.to):[],k}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(d.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(d.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(d.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>M.Position.isPosition(m)),n=>n.map(d.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let s;for(const u of m.reverse())s=new M.SelectionRange(d.Range.to(u),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const m=[];if(Array.isArray(n))for(let s of n)m.push(...s[1].map(d.WorkspaceSymbol.to));return m})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(d.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:d.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return d.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(d.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,P.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,s)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(p=>d.CompletionItem.to(p,s));return new M.CompletionList(u,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return d.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,s)=>t(u=>new M.CodeLens(d.Range.to(u.range),u.command&&s.fromInternal(u.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?d.Selection.from(n):d.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,s)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(u.command)}else{const p=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(p.edit=d.WorkspaceEdit.to(u.edit)),u.command&&(p.command=s.fromInternal(u.command)),p.isPreferred=u.isPreferred,p}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new M.ColorInformation(d.Range.to(m.range),d.Color.to(m.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,d.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:d.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(d.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(d.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>d.NotebookExclusiveDocumentPattern.to(m))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(d.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[d.ViewColumn.from(n.viewColumn),d.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(d.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=T;function t(n){return m=>{if(Array.isArray(m))return m.map(n)}}function _(n){if(!Array.isArray(n))return;const m=[];for(const s of n)E.isLocationLink(s)?m.push(d.DefinitionLink.to(s)):m.push(d.location.to(s));return m}}),define(we[185],be([0,1,12,54,3,6,2,60,26,8,7,5]),function(re,e,d,M,E,A,F,P,C,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,s,u){const p=m.getProxy(_.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const v=this._commentControllers.get(r.handle);return v||r}else if(r&&r.$mid===7){const v=this._commentControllers.get(r.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.commentThreadHandle);return l||r}else if(r&&r.$mid===8){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);return l?{thread:l,text:r.text}:r}else if(r&&r.$mid===9){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.commentUniqueId,b=l.getCommentByUniqueId(c);return b||r}else if(r&&r.$mid===10){const v=this._commentControllers.get(r.thread.commentControlHandle);if(!v)return r;const l=v.getCommentThread(r.thread.commentThreadHandle);if(!l)return r;let c=r.text,b=r.commentUniqueId,h=l.getCommentByUniqueId(b);return h?(h.body=c,h):r}return r}})}createCommentController(r,v,l){const c=k.handlePool++,b=new o(r,c,v,l);this._commentControllers.set(b.handle,b);const h=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(r.identifier))||[];return h.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(r.identifier),h),b.value}$createCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$createCommentThreadTemplate(v,l)}async $updateCommentThreadTemplate(r,v,l){const c=this._commentControllers.get(r);!c||c.$updateCommentThreadTemplate(v,l)}$deleteCommentThread(r,v){const l=this._commentControllers.get(r);l&&l.$deleteCommentThread(v)}$provideCommentingRanges(r,v,l){const c=this._commentControllers.get(r);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const b=u.getDocument(F.URI.revive(v));return(0,d.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(b,l)).then(h=>h?h.map(y=>T.Range.from(y)):void 0)}$toggleReaction(r,v,l,c,b){const h=this._commentControllers.get(r);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const y=h.getCommentThread(v);if(y){const R=y.getCommentByUniqueId(c.uniqueIdInThread);if(h!==void 0&&R&&h.reactionHandler)return h.reactionHandler(R,i(b))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class w{constructor(r,v,l,c,b,h,y){this._commentControllerHandle=v,this._id=l,this._uri=c,this._range=b,this._comments=h,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,T.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(I){R.range=I},get comments(){return R.comments},set comments(I){R.comments=I},get collapsibleState(){return R.collapsibleState},set collapsibleState(I){R.collapsibleState=I},get canReply(){return R.canReply},set canReply(I){R.canReply=I},get contextValue(){return R.contextValue},set contextValue(I){R.contextValue=I},get label(){return R.label},set label(I){R.label=I},dispose:()=>{R.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const r=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),v={};r("range")&&(v.range=T.Range.from(this._range)),r("label")&&(v.label=this.label),r("contextValue")&&(v.contextValue=this.contextValue??null),r("comments")&&(v.comments=this._comments.map(l=>f(this,l,this._commentsMap))),r("collapsibleState")&&(v.collapseState=g(this._collapseState)),r("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(r){for(let v of this._commentsMap){let l=v[0],c=v[1];if(r===c)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}w._handlePool=0,Be([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(r,v,l,c){this._extension=r,this._handle=v,this._id=l,this._label=c,this._threads=new Map,p.$registerCommentController(this.handle,l,c);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(h){b.options=h},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(h){b.commentingRangeProvider=h},get reactionHandler(){return b.reactionHandler},set reactionHandler(h){b.reactionHandler=h},createCommentThread(h,y,R){return b.createCommentThread(h,y,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(r){this._commentingRangeProvider=r,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,v,l,c){if(typeof r=="string"){const b=new w(this.id,this.handle,r,v,l,c,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new w(this.id,this.handle,void 0,r,v,l,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(r,v){const l=new w(this.id,this.handle,void 0,F.URI.revive(r),T.Range.to(v),[],this._extension.identifier);return l.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(r,v){let l=this._threads.get(r);l&&(l.range=T.Range.to(v))}$deleteCommentThread(r){let v=this._threads.get(r);v&&v.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function f(a,r,v){let l=v.get(r);l||(l=++a.commentHandle,v.set(r,l));const c=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:l,body:T.MarkdownString.from(r.body),userName:r.author.name,userIconPath:c,label:r.label,commentReactions:r.reactions?r.reactions.map(b=>S(b)):void 0}}function S(a){return{label:a.label,iconPath:a.iconPath?T.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?F.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function g(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,7,4,13,14,15,9,17]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class vi{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const u=vi._handlePool++;this._provider.set(u,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(u,s.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(u,null);return}let w=(0,C.asArray)(k);if(w.length<=vi._maxEventSize){this._proxy.$onDidChange(u,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,w.length);const o=w.map(i=>({uri:i,rank:(0,T.count)(i.path,"/")})),f=(0,C.groupBy)(o,(i,g)=>i.rank-g.rank||(0,T.compare)(i.uri.path,g.uri.path));let S=[];e:for(let i of f){let g;for(let a of i){let r=(0,t.dirname)(a.uri.path);if(g!==r&&(g=r,S.push(a.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(u,S)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(m,s,u){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:k,extensionId:w}=this._provider.get(m);return await Promise.all(s.map(async o=>{try{const{uri:f,id:S}=o,i=await Promise.resolve(k.provideFileDecoration(d.URI.revive(f),u));if(!i)return;try{E.FileDecoration.validate(i),p[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(g){this._logService.warn(`INVALID decoration from extension '${w.value}': ${g}`)}}catch(f){this._logService.error(f)}})),p}};_._handlePool=0,_._maxEventSize=250,_=Be([We(0,F.IExtHostRpcService),We(1,P.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[186],be([0,1,123,83,2,5,7,8,3,14,20,37]),function(re,e,d,M,E,A,F,P,C,T,t,_){"use strict";var n,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(w,o,f,S,i,g){this._name=w,this._owner=o,this._maxDiagnosticsPerFile=f,n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ze(this,s,new t.ResourceMap(a=>S.getComparisonKey(a)),"f"),Ze(this,n,i,"f"),Ze(this,m,g,"f")}dispose(){this._isDisposed||(Ae(this,m,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner),Ae(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,o){if(!w){this.clear();return}this._checkDisposed();let f=[];if(E.URI.isUri(w)){if(!o){this.delete(w);return}Ae(this,s,"f").set(w,o.slice()),f=[w]}else if(Array.isArray(w)){f=[];let i;w=[...w].sort(u._compareIndexedTuplesByUri);for(const g of w){const[a,r]=g;if((!i||a.toString()!==i.toString())&&(i&&Ae(this,s,"f").get(i).length===0&&Ae(this,s,"f").delete(i),i=a,f.push(a),Ae(this,s,"f").set(a,[])),r){const v=Ae(this,s,"f").get(a);v&&v.push(...r)}else{const v=Ae(this,s,"f").get(a);v&&(v.length=0)}}}if(Ae(this,m,"f").fire(f),!Ae(this,n,"f"))return;const S=[];for(let i of f){let g=[];const a=Ae(this,s,"f").get(i);if(a)if(a.length>this._maxDiagnosticsPerFile){g=[];const r=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(let l of a)if(l.severity===r[v]&&g.push(P.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;g.push({severity:M.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=a.map(r=>P.Diagnostic.from(r));S.push([i,g])}Ae(this,n,"f").$changeMany(this._owner,S)}delete(w){this._checkDisposed(),Ae(this,m,"f").fire([w]),Ae(this,s,"f").delete(w),Ae(this,n,"f")&&Ae(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Ae(this,m,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,s,"f").clear(),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner)}forEach(w,o){this._checkDisposed();for(let f of Ae(this,s,"f").keys())w.apply(o,[f,this.get(f),this])}get(w){this._checkDisposed();const o=Ae(this,s,"f").get(w);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Ae(this,s,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,o){return w[0].toString()<o[0].toString()?-1:w[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=u,n=new WeakMap,m=new WeakMap,s=new WeakMap;let p=class ti{constructor(w,o,f){this._logService=o,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=w.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(w){const o=new t.ResourceMap;for(const f of w)o.set(f,f);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(w,o){const{_collections:f,_proxy:S,_onDidChangeDiagnostics:i,_logService:g,_fileSystemInfoService:a}=this,r=new class{$changeMany(c,b){S.$changeMany(c,b),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,c,b.length===0?"CLEARING":b)}$clear(c){S.$clear(c),g.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,c)}dispose(){S.dispose()}};let v;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,v=o;else if(!f.has(o))v=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do v=o+ti._idPool++;while(f.has(v))}return new class extends u{constructor(){super(o,v,ti._maxDiagnosticsPerFile,a.extUri,r,i);f.set(v,this)}dispose(){super.dispose(),f.delete(v)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const o=new Map,f=[];for(const S of this._collections.values())S.forEach((i,g)=>{let a=o.get(i.toString());typeof a=="undefined"&&(a=f.length,o.set(i.toString(),a),f.push([i,[]])),f[a][1]=f[a][1].concat(...g)});return f}}_getDiagnostics(w){let o=[];for(let f of this._collections.values())f.has(w)&&(o=o.concat(f.get(w)));return o}$acceptMarkersChange(w){if(!this._mirrorCollection){const o="_generated_mirror",f=new u(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,f),this._mirrorCollection=f}for(const[o,f]of w)this._mirrorCollection.set(E.URI.revive(o),f.map(P.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Be([We(1,T.ILogService),We(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(we[187],be([0,1,2,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(P=>P?P.map(C=>d.URI.revive(C)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(P=>P?d.URI.revive(P):void 0)}}e.ExtHostDialogs=E}),define(we[188],be([0,1,16,2,7,5,11,21,9]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(_,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(F.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=T._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,_);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(u=>{if(u.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(m,u).then(p=>{if(!p&&typeof p!="string")return;const k=this._documentsAndEditors.getDocument(u);if(!k)return;const w=(0,C.splitLines)(p);if(!k.equalLines(w))return this._proxy.$onVirtualDocumentChange(u,p)},d.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(_,n){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(we[189],be([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,s){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const p of u)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const p of u)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const s=this._documentsAndEditors.getDocument(m);if(s)return s}getDocument(m){const s=this.getDocumentData(m);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return s.document}ensureDocumentData(m){const s=this._documentsAndEditors.getDocument(m);if(s)return Promise.resolve(s);let u=this._documentLoader.get(m.toString());return u||(u=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const k=E.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(k))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),u)),u}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(s=>E.URI.revive(s))}$acceptModelModeChanged(m,s){const u=E.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(s),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const s=E.URI.revive(m),u=this._documentsAndEditors.getDocument(s);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(m,s){const u=E.URI.revive(m),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");p._acceptIsDirty(s),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,s,u){const p=E.URI.revive(m),k=this._documentsAndEditors.getDocument(p);if(!k)throw new Error("unknown document");k._acceptIsDirty(u),k.onEvents(s);let w;s.isUndoing?w=t.TextDocumentChangeReason.Undo:s.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:k.document,contentChanges:s.changes.map(o=>({range:P.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:w}))}setWordDefinitionFor(m,s){(0,F.setWordDefinitionFor)(m,s)}}e.ExtHostDocuments=_}),define(we[51],be([0,1,42,3,6,2,4,5,88,13,94,8,14,20,11,164,103]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(f,S){this._extHostRpc=f,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const S=[],i=[],g=[];if(f.removedDocuments)for(const a of f.removedDocuments){const r=A.URI.revive(a),v=this._documents.get(r);v?.unref()&&(this._documents.delete(r),S.push(v.value))}if(f.addedDocuments)for(const a of f.addedDocuments){const r=A.URI.revive(a.uri);let v=this._documents.get(r);if(v&&r.scheme!==s.Schemas.vscodeNotebookCell&&r.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);v||(v=new k(new C.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(r,v),i.push(v.value)),v.ref()}if(f.removedEditors)for(const a of f.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&g.push(r)}if(f.addedEditors)for(const a of f.addedEditors){const r=A.URI.revive(a.documentUri);d.ok(this._documents.has(r),`document '${r}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const v=this._documents.get(r).value,l=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),a.selections.map(_.Selection.to),a.options,a.visibleRanges.map(c=>_.Range.to(c)),typeof a.editorPosition=="number"?_.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}f.newActiveEditor!==void 0&&(d.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,E.dispose)(S),(0,E.dispose)(g),f.removedDocuments&&this._onDidRemoveDocuments.fire(S),f.addedDocuments&&this._onDidAddDocuments.fire(i),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return f?S:S?.value}allEditors(){return[...this._editors.values()]}};w=Be([We(0,T.IExtHostRpcService),We(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[71],be([0,1,8,5,2,3,4,13,12]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let T=class{constructor(_){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((s,u)=>(s.isActive&&(n=u),Object.freeze({label:s.label,viewColumn:d.ViewColumn.to(s.viewColumn),index:u,resource:E.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:p,viewId:k})=>({resource:E.URI.revive(p),viewId:k})),viewId:s.editorId,isActive:s.isActive,move:async(p,k)=>{this._proxy.$moveTab(s,p,d.ViewColumn.from(k)),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,u)=>s.viewColumn===u.viewColumn?s.index-u.index:s.viewColumn-u.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=Be([We(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(we[190],be([0,1,2,5,6,7,8,232,9,22]),function(re,e,d,M,E,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let u,p,k=14,w=14;for(const o of m){let f=u?(0,C.commonPrefixLength)(u,o):0;for(f===0?p=1:p=w;f<o.length;f++)f+1===o.length?(k=w,w=9):w+=1,s.push([p,o.toUpperCase().charCodeAt(f),w]),s.push([p,o.toLowerCase().charCodeAt(f),w]),p=w;u=o,w=k}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new P.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],u=P.LinkComputer.computeLinks({getLineContent(p){return m.lineAt(p-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const p of u){const k=F.DocumentLink.to(p);k.target&&s.push(k)}return s}}class _{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,u,p={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const k=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(k,u);let w=2;p.isCaseSensitive&&(w+=1024),p.isReadonly&&(w+=2048),typeof u.copy=="function"&&(w+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(k,s,w).catch(f=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(f)});const o=u.onDidChangeFile(f=>{const S=[];for(const i of f){let{uri:g,type:a}=i;if(g.scheme!==s)continue;let r;switch(a){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}S.push({resource:g,type:r})}this._proxy.$onFileSystemChange(k,S)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(m){const{type:s,ctime:u,mtime:p,size:k,permissions:w}=m;return{type:s,ctime:u,mtime:p,size:k,permissions:w}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(d.URI.revive(s))).then(u=>_._asIStat(u))}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(d.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(d.URI.revive(s))).then(u=>T.VSBuffer.wrap(u))}$writeFile(m,s,u,p){return Promise.resolve(this._getFsProvider(m).writeFile(d.URI.revive(s),u.buffer,p))}$delete(m,s,u){return Promise.resolve(this._getFsProvider(m).delete(d.URI.revive(s),u))}$rename(m,s,u,p){return Promise.resolve(this._getFsProvider(m).rename(d.URI.revive(s),d.URI.revive(u),p))}$copy(m,s,u,p){const k=this._getFsProvider(m);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(d.URI.revive(s),d.URI.revive(u),p))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(d.URI.revive(s)))}$watch(m,s,u,p){const k=this._getFsProvider(m).watch(d.URI.revive(u),p);this._watches.set(s,k)}$unwatch(m,s){const u=this._watches.get(s);u&&(u.dispose(),this._watches.delete(s))}$open(m,s,u){const p=this._getFsProvider(m);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(d.URI.revive(s),u))}$close(m,s){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(s))}$read(m,s,u,p){const k=this._getFsProvider(m);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const w=T.VSBuffer.alloc(p);return Promise.resolve(k.read(s,u,w.buffer,0,p)).then(o=>w.slice(0,o))}$write(m,s,u,p){const k=this._getFsProvider(m);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(s,u,p.buffer,0,p.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return s}}e.ExtHostFileSystem=_}),define(we[72],be([0,1,5,47,7,22,4,13,37]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=class Ut{constructor(_,n){const m=_.getProxy(d.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Ut._handleError)},readDirectory(s){return m.$readdir(s).catch(Ut._handleError)},createDirectory(s){return m.$mkdir(s).catch(Ut._handleError)},async readFile(s){return m.$readFile(s).then(u=>u.buffer).catch(Ut._handleError)},writeFile(s,u){return m.$writeFile(s,A.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(s,u){return m.$delete(s,{recursive:!1,useTrash:!1,...u}).catch(Ut._handleError)},rename(s,u,p){return m.$rename(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},copy(s,u,p){return m.$copy(s,u,{overwrite:!1,...p}).catch(Ut._handleError)},isWritableFileSystem(s){const u=n.getCapabilities(s);if(typeof u=="number")return!(u&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};T=Be([We(0,P.IExtHostRpcService),We(1,C.IExtHostFileSystemInfo)],T),e.ExtHostConsumerFileSystem=T,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[191],be([0,1,2,39]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,P,C,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=C,this._commands=T;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:d.URI.revive(_.notebookUri),inputUri:d.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,P,C,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:C,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(we[192],be([0,1,6,5]),function(re,e,d,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,F),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=E}),define(we[193],be([0,1,2,23,8,7,5,9,44,15,10,233,6,81,55,64,194,16,3]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentSymbols(H,K){const ee=this._documents.getDocument(H),se=await this._provider.provideDocumentSymbols(ee,K);if(!(0,T.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((se,G)=>{let ne=se.location.range.start.compareTo(G.location.range.start);return ne===0&&(ne=G.location.range.end.compareTo(se.location.range.end)),ne});const K=[],ee=[];for(const se of H){const G={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(ee.length===0){ee.push(G),K.push(G);break}const ne=ee[ee.length-1];if(C.Range.containsRange(ne.range,G.range)&&!C.Range.equalsRange(ne.range,G.range)){ne.children&&ne.children.push(G),ee.push(G);break}ee.pop()}}return K}}class f{constructor(H,K,ee){this._documents=H,this._commands=K,this._provider=ee,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,K){const ee=this._documents.getDocument(H),se=await this._provider.provideCodeLenses(ee,K);if(!se||K.isCancellationRequested)return;const G=this._cache.add(se),ne=new n.DisposableStore;this._disposables.set(G,ne);const de={cacheId:G,lenses:[]};for(let Te=0;Te<se.length;Te++)de.lenses.push({cacheId:[G,Te],range:E.Range.from(se[Te].range),command:this._commands.toInternal(se[Te].command,ne)});return de}async resolveCodeLens(H,K){const ee=H.cacheId&&this._cache.get(...H.cacheId);if(!ee)return;let se;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?se=ee:se=await this._provider.resolveCodeLens(ee,K),se||(se=ee),K.isCancellationRequested)return;const G=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!G)return H.command=this._commands.toInternal(se.command??f._badCmd,G),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Ke){return Array.isArray(Ke)?Ke.map(E.DefinitionLink.from):Ke?[E.DefinitionLink.from(Ke)]:[]}class i{constructor(H,K){this._documents=H,this._provider=K}async provideDefinition(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideDefinition(se,G,ee);return S(ne)}}class g{constructor(H,K){this._documents=H,this._provider=K}async provideDeclaration(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideDeclaration(se,G,ee);return S(ne)}}class a{constructor(H,K){this._documents=H,this._provider=K}async provideImplementation(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideImplementation(se,G,ee);return S(ne)}}class r{constructor(H,K){this._documents=H,this._provider=K}async provideTypeDefinition(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideTypeDefinition(se,G,ee);return S(ne)}}class v{constructor(H,K){this._documents=H,this._provider=K}async provideHover(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideHover(se,G,ee);if(!(!ne||(0,T.isFalsyOrEmpty)(ne.contents)))return ne.range||(ne.range=se.getWordRangeAtPosition(G)),ne.range||(ne.range=new A.Range(G,G)),E.Hover.from(ne)}}class l{constructor(H,K){this._documents=H,this._provider=K}async provideEvaluatableExpression(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideEvaluatableExpression(se,G,ee);if(ne)return E.EvaluatableExpression.from(ne)}}class c{constructor(H,K){this._documents=H,this._provider=K}async provideInlineValues(H,K,ee,se){const G=this._documents.getDocument(H),ne=await this._provider.provideInlineValues(G,E.Range.to(K),E.InlineValueContext.to(ee),se);if(Array.isArray(ne))return ne.map(de=>E.InlineValue.from(de))}}class b{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentHighlights(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideDocumentHighlights(se,G,ee);if(Array.isArray(ne))return ne.map(E.DocumentHighlight.from)}}class h{constructor(H,K){this._documents=H,this._provider=K}async provideLinkedEditingRanges(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.provideLinkedEditingRanges(se,G,ee);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,T.coalesce)(ne.ranges.map(E.Range.from)),wordPattern:ne.wordPattern}}}class y{constructor(H,K){this._documents=H,this._provider=K}async provideReferences(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Position.to(K),de=await this._provider.provideReferences(G,ne,ee,se);if(Array.isArray(de))return de.map(E.location.from)}}class R{constructor(H,K,ee,se,G,ne,de){this._documents=H,this._commands=K,this._diagnostics=ee,this._provider=se,this._logService=G,this._extension=ne,this._apiDeprecation=de,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,K,ee,se){const G=this._documents.getDocument(H),ne=_.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),de=[];for(const st of this._diagnostics.getDiagnostics(H))if(ne.intersection(st.range)&&de.push(st)>R._maxCodeActionsPerFile)break;const Te={diagnostics:de,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(G,ne,Te,se);if(!(0,T.isNonEmptyArray)(xe)||se.isCancellationRequested)return;const $e=this._cache.add(xe),je=new n.DisposableStore;this._disposables.set($e,je);const et=[];for(let st=0;st<xe.length;st++){const _e=xe[st];!_e||(R._isCommand(_e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this._commands.toInternal(_e,je)})):(Te.only&&(_e.kind?Te.only.contains(_e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[$e,st],title:_e.title,command:_e.command&&this._commands.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(E.Diagnostic.from),edit:_e.edit&&E.WorkspaceEdit.from(_e.edit),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:$e,actions:et}}async resolveCodeAction(H,K){const[ee,se]=H,G=this._cache.get(ee,se);if(!G||R._isCommand(G)||!this._provider.resolveCodeAction)return;const ne=await this._provider.resolveCodeAction(G,K)??G;return ne?.edit?E.WorkspaceEdit.from(ne.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}R._maxCodeActionsPerFile=1e3;class I{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentFormattingEdits(H,K,ee){const se=this._documents.getDocument(H),G=await this._provider.provideDocumentFormattingEdits(se,K,ee);if(Array.isArray(G))return G.map(E.TextEdit.from)}}class U{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeFormattingEdits(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Range.to(K),de=await this._provider.provideDocumentRangeFormattingEdits(G,ne,ee,se);if(Array.isArray(de))return de.map(E.TextEdit.from)}}class L{constructor(H,K){this._documents=H,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,K,ee,se,G){const ne=this._documents.getDocument(H),de=E.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(ne,de,ee,se,G);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class D{constructor(H,K){this._provider=H,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,K){const ee=F.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(H,K);if((0,T.isNonEmptyArray)(se))for(const G of se){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const ne=F.IdObject.mixin(E.WorkspaceSymbol.from(G));this._symbolCache.set(ne._id,G),ee.symbols.push(ne)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(H,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const ee=this._symbolCache.get(H._id);if(ee){const se=await this._provider.resolveWorkspaceSymbol(ee,K);return se&&(0,M.mixin)(H,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(H){const K=this._resultCache.get(H);if(K){for(let[ee,se]=K;ee<=se;ee++)this._symbolCache.delete(ee);this._resultCache.delete(H)}}}class x{constructor(H,K,ee){this._documents=H,this._provider=K,this._logService=ee}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Position.to(K);try{const de=await this._provider.provideRenameEdits(G,ne,ee,se);return de?E.WorkspaceEdit.from(de):void 0}catch(de){const Te=x._asMessage(de);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(H,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(H),G=E.Position.to(K);try{const ne=await this._provider.prepareRename(se,G,ee);let de,Te;if(A.Range.isRange(ne)?(de=ne,Te=se.getText(ne)):(0,t.isObject)(ne)&&(de=ne.range,Te=ne.placeholder),!de||!Te)return;if(de.start.line>G.line||de.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(de),text:Te}}catch(ne){const de=x._asMessage(ne);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ne)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class N{constructor(H,K){this.resultId=H,this.tokens=K}}class V{constructor(H,K){this._documents=H,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,K,ee){const se=this._documents.getDocument(H),G=K!==0?this._previousResults.get(K):null;let ne=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,G.resultId,ee):await this._provider.provideDocumentSemanticTokens(se,ee);return G&&this._previousResults.delete(K),ne?(ne=V._fixProvidedSemanticTokens(ne),this._send(V._convertToEdits(G,ne),ne)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return V._isSemanticTokens(H)?V._isCorrectSemanticTokens(H)?H:new A.SemanticTokens(new Uint32Array(H.data),H.resultId):V._isSemanticTokensEdits(H)?V._isCorrectSemanticTokensEdits(H)?H:new A.SemanticTokensEdits(H.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const K of H.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,K){if(!V._isSemanticTokens(K)||!H||!H.tokens)return K;const ee=H.tokens,se=ee.length,G=K.data,ne=G.length;let de=0;const Te=Math.min(se,ne);for(;de<Te&&ee[de]===G[de];)de++;if(de===se&&de===ne)return new A.SemanticTokensEdits([],K.resultId);let xe=0;const $e=Te-de;for(;xe<$e&&ee[se-xe-1]===G[ne-xe-1];)xe++;return new A.SemanticTokensEdits([{start:de,deleteCount:se-de-xe,data:G.subarray(de,ne-xe)}],K.resultId)}_send(H,K){if(V._isSemanticTokens(H)){const ee=this._nextResultId++;return this._previousResults.set(ee,new N(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:ee,type:"full",data:H.data})}if(V._isSemanticTokensEdits(H)){const ee=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(ee,new N(K.resultId,K.data)):this._previousResults.set(ee,new N(H.resultId)),(0,m.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(H.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class W{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeSemanticTokens(H,K,ee){const se=this._documents.getDocument(H),G=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(K),ee);return G?this._send(G):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=W;class ${constructor(H,K,ee,se,G){this._documents=H,this._commands=K,this._provider=ee,this._apiDeprecation=se,this._extension=G,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Position.to(K),de=G.getWordRangeAtPosition(ne)||new A.Range(ne,ne),Te=de.with({end:ne}),xe=new p.StopWatch(!0),$e=await this._provider.provideCompletionItems(G,ne,se,E.CompletionContext.to(ee));if(!$e||se.isCancellationRequested)return;const je=Array.isArray($e)?new A.CompletionList($e):$e,et=$.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const _e=[],nt={x:et,b:_e,a:{replace:E.Range.from(de),insert:E.Range.from(Te)},c:je.isIncomplete||void 0,d:xe.elapsed()};for(let q=0;q<je.items.length;q++){const X=je.items[q],ge=this._convertCompletionItem(X,[et,q],Te,de);_e.push(ge)}return nt}async resolveCompletionItem(H,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...H);if(!ee)return;const se=await this._provider.resolveCompletionItem(ee,K);if(!!se)return this._convertCompletionItem(se,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,K,ee,se){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const ne={x:K,a:H.label,b:H.kind!==void 0?E.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(E.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(H.command,G)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ne.h=H.textEdit.newText):typeof H.insertText=="string"?ne.h=H.insertText:H.insertText instanceof A.SnippetString&&(ne.h=H.insertText.value,ne.i|=4);let de;return H.textEdit?de=H.textEdit.range:H.range&&(de=H.range),A.Range.isRange(de)?ne.j=E.Range.from(de):de&&(!ee?.isEqual(de.inserting)||!se?.isEqual(de.replacing))&&(ne.j={insert:E.Range.from(de.inserting),replace:E.Range.from(de.replacing)}),ne}}class Z{constructor(H,K,ee){this._documents=H,this._provider=K,this._commands=ee,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Position.to(K),de=await this._provider.provideInlineCompletionItems(G,ne,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:E.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},se);if(!de||se.isCancellationRequested)return;const Te=(0,t.isArray)(de)?{items:de}:de,xe=this._cache.add(Te.items);let $e;return{pid:xe,items:Te.items.map((je,et)=>{let st;return je.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),st=this._commands.toInternal(je.command,$e)),{text:je.text,range:je.range?E.Range.from(je.range):void 0,command:st,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const K=this._disposables.get(H);K&&K.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,K){const ee=this._cache.get(H,K);ee&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let K=j.map.get(H);return K||(K=new j,j.map.set(H,K)),K}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(H,K){this._documents=H,this._provider=K,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(H,K,ee,se){const G=this._documents.getDocument(H),ne=E.Position.to(K),de=this.reviveContext(ee),Te=await this._provider.provideSignatureHelp(G,ne,se,de);if(Te){const xe=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:xe}}}reviveContext(H){let K;if(H.activeSignatureHelp){const ee=E.SignatureHelp.to(H.activeSignatureHelp),se=this._cache.get(H.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...H,activeSignatureHelp:K}}releaseSignatureHelp(H){this._cache.delete(H)}}class ae{constructor(H,K){this._documents=H,this._provider=K}async provideInlayHints(H,K,ee){const se=this._documents.getDocument(H),G=await this._provider.provideInlayHints(se,E.Range.to(K),ee);return G?{hints:G.map(E.InlayHint.from)}:void 0}}class pe{constructor(H,K){this._documents=H,this._provider=K,this._cache=new u.Cache("DocumentLink")}async provideLinks(H,K){const ee=this._documents.getDocument(H),se=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(pe._validateLink).map(E.DocumentLink.from)};{const G=this._cache.add(se),ne={links:[],id:G};for(let de=0;de<se.length;de++){if(!pe._validateLink(se[de]))continue;const Te=E.DocumentLink.from(se[de]);Te.cacheId=[G,de],ne.links.push(Te)}return ne}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...H);if(!ee)return;const se=await this._provider.resolveDocumentLink(ee,K);if(!(!se||!pe._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(H){this._cache.delete(H)}}class ce{constructor(H,K){this._documents=H,this._provider=K}async provideColors(H,K){const ee=this._documents.getDocument(H),se=await this._provider.provideDocumentColors(ee,K);return Array.isArray(se)?se.map(ne=>({color:E.Color.from(ne.color),range:E.Range.from(ne.range)})):[]}async provideColorPresentations(H,K,ee){const se=this._documents.getDocument(H),G=E.Range.to(K.range),ne=E.Color.to(K.color),de=await this._provider.provideColorPresentations(ne,{document:se,range:G},ee);if(!!Array.isArray(de))return de.map(E.ColorPresentation.from)}}class Fe{constructor(H,K){this._documents=H,this._provider=K}async provideFoldingRanges(H,K,ee){const se=this._documents.getDocument(H),G=await this._provider.provideFoldingRanges(se,K,ee);if(!!Array.isArray(G))return G.map(E.FoldingRange.from)}}class Ge{constructor(H,K,ee){this._documents=H,this._provider=K,this._logService=ee}async provideSelectionRanges(H,K,ee){const se=this._documents.getDocument(H),G=K.map(E.Position.to),ne=await this._provider.provideSelectionRanges(se,G,ee);if(!(0,T.isNonEmptyArray)(ne))return[];if(ne.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Te=0;Te<G.length;Te++){const xe=[];de.push(xe);let $e=G[Te],je=ne[Te];for(;;){if(!je.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(E.SelectionRange.from(je)),!je.parent)break;$e=je.range,je=je.parent}}return de}}class Ne{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.prepareCallHierarchy(se,G,ee);if(!ne)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ne)?ne.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ne)]}async provideCallsTo(H,K,ee){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(se,ee);if(!!G)return G.map(ne=>({from:this._cacheAndConvertItem(H,ne.from),fromRanges:ne.fromRanges.map(de=>E.Range.from(de))}))}async provideCallsFrom(H,K,ee){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(se,ee);if(!!G)return G.map(ne=>({to:this._cacheAndConvertItem(H,ne.to),fromRanges:ne.fromRanges.map(de=>E.Range.from(de))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const ee=this._cache.get(H),se=E.CallHierarchyItem.from(K,H,ee.size.toString(36));return ee.set(se._itemId,K),se}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class ze{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,ee){const se=this._documents.getDocument(H),G=E.Position.to(K),ne=await this._provider.prepareTypeHierarchy(se,G,ee);if(!ne)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ne)?ne.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ne)]}async provideSupertypes(H,K,ee){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(se,ee);if(!!G)return G.map(ne=>this._cacheAndConvertItem(H,ne))}async provideSubtypes(H,K,ee){const se=this._itemFromCache(H,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(se,ee);if(!!G)return G.map(ne=>this._cacheAndConvertItem(H,ne))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const ee=this._cache.get(H),se=E.TypeHierarchyItem.from(K,H,ee.size.toString(36));return ee.set(se._itemId,K),se}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class Je{constructor(H,K){this.adapter=H,this.extension=K}}class Qe{constructor(H,K,ee,se,G,ne,de){this._adapter=new Map,this._uriTransformer=K,this._proxy=H.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=se,this._diagnostics=G,this._logService=ne,this._apiDeprecation=de}_transformDocumentSelector(H){return E.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new A.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Qe._handlePool++}_withAdapter(H,K,ee,se,G=!1){const ne=this._adapter.get(H);if(!ne)return Promise.resolve(se);if(ne.adapter instanceof K){let de;ne.extension&&(de=Date.now(),this._logService.trace(`[${ne.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=ee(ne.adapter,ne.extension),xe=ne.extension;return xe&&Promise.resolve(Te).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-de}ms`),$e=>{G&&$e instanceof k.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,K){const ee=this._nextHandle();return this._adapter.set(ee,new Je(H,K)),ee}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,K,ee,se){const G=this._addNewAdapter(new o(this._documents,ee),H),ne=se&&se.label||Qe._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),ne),this._createDisposable(G)}$provideDocumentSymbols(H,K,ee){return this._withAdapter(H,o,se=>se.provideDocumentSymbols(d.URI.revive(K),ee),void 0)}registerCodeLensProvider(H,K,ee){const se=this._nextHandle(),G=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new f(this._documents,this._commands.converter,ee),H)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),G);let ne=this._createDisposable(se);if(G!==void 0){const de=ee.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(G));ne=A.Disposable.from(ne,de)}return ne}$provideCodeLenses(H,K,ee){return this._withAdapter(H,f,se=>se.provideCodeLenses(d.URI.revive(K),ee),void 0)}$resolveCodeLens(H,K,ee){return this._withAdapter(H,f,se=>se.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses(H,K){this._withAdapter(H,f,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(H,K,ee){const se=this._addNewAdapter(new i(this._documents,ee),H);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(H,K,ee,se){return this._withAdapter(H,i,G=>G.provideDefinition(d.URI.revive(K),ee,se),[])}registerDeclarationProvider(H,K,ee){const se=this._addNewAdapter(new g(this._documents,ee),H);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(H,K,ee,se){return this._withAdapter(H,g,G=>G.provideDeclaration(d.URI.revive(K),ee,se),[])}registerImplementationProvider(H,K,ee){const se=this._addNewAdapter(new a(this._documents,ee),H);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(H,K,ee,se){return this._withAdapter(H,a,G=>G.provideImplementation(d.URI.revive(K),ee,se),[])}registerTypeDefinitionProvider(H,K,ee){const se=this._addNewAdapter(new r(this._documents,ee),H);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(H,K,ee,se){return this._withAdapter(H,r,G=>G.provideTypeDefinition(d.URI.revive(K),ee,se),[])}registerHoverProvider(H,K,ee,se){const G=this._addNewAdapter(new v(this._documents,ee),H);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(H,K,ee,se){return this._withAdapter(H,v,G=>G.provideHover(d.URI.revive(K),ee,se),void 0)}registerEvaluatableExpressionProvider(H,K,ee,se){const G=this._addNewAdapter(new l(this._documents,ee),H);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(H,K,ee,se){return this._withAdapter(H,l,G=>G.provideEvaluatableExpression(d.URI.revive(K),ee,se),void 0)}registerInlineValuesProvider(H,K,ee,se){const G=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new c(this._documents,ee),H);this._proxy.$registerInlineValuesProvider(ne,this._transformDocumentSelector(K),G);let de=this._createDisposable(ne);if(G!==void 0){const Te=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(G));de=A.Disposable.from(de,Te)}return de}$provideInlineValues(H,K,ee,se,G){return this._withAdapter(H,c,ne=>ne.provideInlineValues(d.URI.revive(K),ee,se,G),void 0)}registerDocumentHighlightProvider(H,K,ee){const se=this._addNewAdapter(new b(this._documents,ee),H);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(H,K,ee,se){return this._withAdapter(H,b,G=>G.provideDocumentHighlights(d.URI.revive(K),ee,se),void 0)}registerLinkedEditingRangeProvider(H,K,ee){const se=this._addNewAdapter(new h(this._documents,ee),H);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(H,K,ee,se){return this._withAdapter(H,h,async G=>{const ne=await G.provideLinkedEditingRanges(d.URI.revive(K),ee,se);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Qe._serializeRegExp(ne.wordPattern):void 0}},void 0)}registerReferenceProvider(H,K,ee){const se=this._addNewAdapter(new y(this._documents,ee),H);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(H,K,ee,se,G){return this._withAdapter(H,y,ne=>ne.provideReferences(d.URI.revive(K),ee,se,G),void 0)}registerCodeActionProvider(H,K,ee,se){const G=new n.DisposableStore,ne=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ne,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(de=>de.value),documentation:se?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,G)}))},Qe._extLabel(H),Boolean(ee.resolveCodeAction)),G.add(this._createDisposable(ne)),G}$provideCodeActions(H,K,ee,se,G){return this._withAdapter(H,R,ne=>ne.provideCodeActions(d.URI.revive(K),ee,se,G),void 0)}$resolveCodeAction(H,K,ee){return this._withAdapter(H,R,se=>se.resolveCodeAction(K,ee),void 0)}$releaseCodeActions(H,K){this._withAdapter(H,R,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(H,K,ee){const se=this._addNewAdapter(new I(this._documents,ee),H);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentFormattingEdits(H,K,ee,se){return this._withAdapter(H,I,G=>G.provideDocumentFormattingEdits(d.URI.revive(K),ee,se),void 0)}registerDocumentRangeFormattingEditProvider(H,K,ee){const se=this._addNewAdapter(new U(this._documents,ee),H);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(H,K,ee,se,G){return this._withAdapter(H,U,ne=>ne.provideDocumentRangeFormattingEdits(d.URI.revive(K),ee,se,G),void 0)}registerOnTypeFormattingEditProvider(H,K,ee,se){const G=this._addNewAdapter(new L(this._documents,ee),H);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),se,H.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(H,K,ee,se,G,ne){return this._withAdapter(H,L,de=>de.provideOnTypeFormattingEdits(d.URI.revive(K),ee,se,G,ne),void 0)}registerWorkspaceSymbolProvider(H,K){const ee=this._addNewAdapter(new D(K,this._logService),H);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(H,K,ee){return this._withAdapter(H,D,se=>se.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol(H,K,ee){return this._withAdapter(H,D,se=>se.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols(H,K){this._withAdapter(H,D,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(H,K,ee){const se=this._addNewAdapter(new x(this._documents,ee,this._logService),H);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),x.supportsResolving(ee)),this._createDisposable(se)}$provideRenameEdits(H,K,ee,se,G){return this._withAdapter(H,x,ne=>ne.provideRenameEdits(d.URI.revive(K),ee,se,G),void 0)}$resolveRenameLocation(H,K,ee,se){return this._withAdapter(H,x,G=>G.resolveRenameLocation(d.URI.revive(K),ee,se),void 0)}registerDocumentSemanticTokensProvider(H,K,ee,se){const G=this._nextHandle(),ne=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Je(new V(this._documents,ee),H)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),se,ne);let de=this._createDisposable(G);if(ne){const Te=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(ne));de=A.Disposable.from(de,Te)}return de}$provideDocumentSemanticTokens(H,K,ee,se){return this._withAdapter(H,V,G=>G.provideDocumentSemanticTokens(d.URI.revive(K),ee,se),null,!0)}$releaseDocumentSemanticTokens(H,K){this._withAdapter(H,V,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(H,K,ee,se){const G=this._addNewAdapter(new W(this._documents,ee),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),se),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(H,K,ee,se){return this._withAdapter(H,W,G=>G.provideDocumentRangeSemanticTokens(d.URI.revive(K),ee,se),null,!0)}registerCompletionItemProvider(H,K,ee,se){const G=this._addNewAdapter(new $(this._documents,this._commands.converter,ee,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),se,$.supportsResolving(ee),`${H.identifier.value}(${se.join("")})`),this._createDisposable(G)}$provideCompletionItems(H,K,ee,se,G){return this._withAdapter(H,$,ne=>ne.provideCompletionItems(d.URI.revive(K),ee,se,G),void 0)}$resolveCompletionItem(H,K,ee){return this._withAdapter(H,$,se=>se.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems(H,K){this._withAdapter(H,$,ee=>ee.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(H,K,ee){const se=this._addNewAdapter(new Z(this._documents,ee,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(H,K,ee,se,G){return this._withAdapter(H,Z,ne=>ne.provideInlineCompletions(d.URI.revive(K),ee,se,G),void 0)}$handleInlineCompletionDidShow(H,K,ee){this._withAdapter(H,Z,async se=>{se.handleDidShowCompletionItem(K,ee)},void 0)}$freeInlineCompletionsList(H,K){this._withAdapter(H,Z,async ee=>{ee.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(H,K,ee,se){const G=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ne=this._addNewAdapter(new Q(this._documents,ee),H);return this._proxy.$registerSignatureHelpProvider(ne,this._transformDocumentSelector(K),G),this._createDisposable(ne)}$provideSignatureHelp(H,K,ee,se,G){return this._withAdapter(H,Q,ne=>ne.provideSignatureHelp(d.URI.revive(K),ee,se,G),void 0)}$releaseSignatureHelp(H,K){this._withAdapter(H,Q,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(H,K,ee){const se=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new ae(this._documents,ee),H);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),se);let ne=this._createDisposable(G);if(se!==void 0){const de=ee.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(se));ne=A.Disposable.from(ne,de)}return ne}$provideInlayHints(H,K,ee,se){return this._withAdapter(H,ae,G=>G.provideInlayHints(d.URI.revive(K),ee,se),void 0)}registerDocumentLinkProvider(H,K,ee){const se=this._addNewAdapter(new pe(this._documents,ee),H);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(H,K,ee){return this._withAdapter(H,pe,se=>se.provideLinks(d.URI.revive(K),ee),void 0)}$resolveDocumentLink(H,K,ee){return this._withAdapter(H,pe,se=>se.resolveLink(K,ee),void 0)}$releaseDocumentLinks(H,K){this._withAdapter(H,pe,ee=>ee.releaseLinks(K),void 0)}registerColorProvider(H,K,ee){const se=this._addNewAdapter(new ce(this._documents,ee),H);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(H,K,ee){return this._withAdapter(H,ce,se=>se.provideColors(d.URI.revive(K),ee),[])}$provideColorPresentations(H,K,ee,se){return this._withAdapter(H,ce,G=>G.provideColorPresentations(d.URI.revive(K),ee,se),void 0)}registerFoldingRangeProvider(H,K,ee){const se=this._nextHandle(),G=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new Fe(this._documents,ee),H)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),G);let ne=this._createDisposable(se);if(G!==void 0){const de=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));ne=A.Disposable.from(ne,de)}return ne}$provideFoldingRanges(H,K,ee,se){return this._withAdapter(H,Fe,G=>G.provideFoldingRanges(d.URI.revive(K),ee,se),void 0)}registerSelectionRangeProvider(H,K,ee){const se=this._addNewAdapter(new Ge(this._documents,ee,this._logService),H);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(H,K,ee,se){return this._withAdapter(H,Ge,G=>G.provideSelectionRanges(d.URI.revive(K),ee,se),[])}registerCallHierarchyProvider(H,K,ee){const se=this._addNewAdapter(new Ne(this._documents,ee),H);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(H,K,ee,se){return this._withAdapter(H,Ne,G=>Promise.resolve(G.prepareSession(d.URI.revive(K),ee,se)),void 0)}$provideCallHierarchyIncomingCalls(H,K,ee,se){return this._withAdapter(H,Ne,G=>G.provideCallsTo(K,ee,se),void 0)}$provideCallHierarchyOutgoingCalls(H,K,ee,se){return this._withAdapter(H,Ne,G=>G.provideCallsFrom(K,ee,se),void 0)}$releaseCallHierarchy(H,K){this._withAdapter(H,Ne,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}registerTypeHierarchyProvider(H,K,ee){const se=this._addNewAdapter(new ze(this._documents,ee),H);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(H,K,ee,se){return this._withAdapter(H,ze,G=>Promise.resolve(G.prepareSession(d.URI.revive(K),ee,se)),void 0)}$provideTypeHierarchySupertypes(H,K,ee,se){return this._withAdapter(H,ze,G=>G.provideSupertypes(K,ee,se),void 0)}$provideTypeHierarchySubtypes(H,K,ee,se){return this._withAdapter(H,ze,G=>G.provideSubtypes(K,ee,se),void 0)}$releaseTypeHierarchy(H,K){this._withAdapter(H,ze,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,P.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Qe._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Qe._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Qe._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Qe._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Qe._serializeRegExp(H.beforeText),afterText:H.afterText?Qe._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Qe._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Qe._serializeOnEnterRule)}setLanguageConfiguration(H,K,ee){let{wordPattern:se}=ee;if(se&&(0,P.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const G=this._nextHandle(),ne={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Qe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Qe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Qe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,ne),this._createDisposable(G)}$setWordDefinitions(H){for(const K of H)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Qe,Qe._handlePool=0}),define(we[195],be([0,1,5,8,7,35,12,6]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(t,_,n,m){this._documents=_,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,_){const n=t.version,m=M.Position.from(_),s=await this._proxy.$tokensAtPosition(t.uri,m),u={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!s)return u;const p={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!p.range.contains(_)||n!==t.version?u:p}createLanguageStatusItem(t,_,n){const m=this._handlePool++,s=this._proxy,u=this._ids,p=`${t.identifier.value}/${_}`;if(u.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);u.add(p);const k={selector:n,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,o=new P.DisposableStore;const f=()=>{w?.dispose(),w=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:k.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(k.selector,this._uriTransformer),label:k.text,detail:k.detail??"",severity:k.severity===E.LanguageStatusSeverity.Error?A.default.Error:k.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:k.command&&this._commands.toInternal(k.command,o),accessibilityInfo:k.accessibilityInformation})},0)},S={dispose(){o.dispose(),w?.dispose(),s.$removeLanguageStatus(m),u.delete(p)},get id(){return k.id},get name(){return k.name},set name(i){k.name=i,f()},get selector(){return k.selector},set selector(i){k.selector=i,f()},get text(){return k.text},set text(i){k.text=i,f()},get detail(){return k.detail},set detail(i){k.detail=i,f()},get severity(){return k.severity},set severity(i){k.severity=i,f()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(i){k.accessibilityInformation=i,f()},get command(){return k.command},set command(i){k.command=i,f()}};return f(),S}}e.ExtHostLanguages=C}),define(we[196],be([0,1,5,14,30]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let F=class{constructor(C,T){this._logService=T,this._proxy=C.getProxy(d.MainContext.MainThreadMessageService)}showMessage(C,T,t,_,n){const m={extension:C};let s;typeof _=="string"||A(_)?s=[_,...n]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,s=n),m.useCustom&&(0,E.checkProposedApiEnabled)(C);const u=[];for(let p=0;p<s.length;p++){const k=s[p];if(typeof k=="string")u.push({title:k,handle:p,isCloseAffordance:!1});else if(typeof k=="object"){let{title:w,isCloseAffordance:o}=k;u.push({title:w,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(T,t,m,u).then(p=>{if(typeof p=="number")return s[p]})}};F=Be([We(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(we[197],be([0,1,22,3,59,6,20,9,10,2,64,5,8,7,38,172,93]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(o,f,S,i,g){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=g,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const r=a.notebookEditor?.notebookUri,v=a.cell.handle,c=this._documents.get(r)?.getCell(v);if(c)return c.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const f=this._editors.get(o);if(!f)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(o){for(const[f,S]of this._editors)if(S.apiEditor===o)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,f){const S=this._documents.get(o);if(!S&&!f)throw new Error(`NO notebook document for '${o}'`);return S}_getProviderData(o){const f=this._notebookContentProviders.get(o);if(!f)throw new Error(`NO provider for '${o}'`);return f}registerNotebookContentProvider(o,f,S,i,g){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:o,provider:S});let a;return S.onDidChangeNotebookContentOptions&&(a=S.onDidChangeNotebookContentOptions(()=>{const r=n.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(f,r)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,g)),new m.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(o,f){if(!f)return;const S=f.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(f.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:f.displayName,filenamePattern:S,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,f,S){const i=k._notebookStatusBarItemProviderHandlePool++,g=typeof S.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,g,f);let a;return g!==void 0&&(a=S.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(g))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,g),a&&a.dispose()})}async createNotebookDocument(o){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return T.URI.revive(f)}async openNotebookDocument(o){const f=this._documents.get(o);if(f)return f.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(T.URI.revive(S));return(0,C.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,f){T.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let S;typeof f=="object"?S={position:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(n.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,S),g=i&&this._editors.get(i)?.apiEditor;if(g)return g;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,f,S,i){const g=this._notebookStatusBarItemProviders.get(o),a=T.URI.revive(f),r=this._documents.get(a);if(!r||!g)return;const v=r.getCellFromIndex(S);if(!v)return;const l=await g.provideCellStatusBarItems(v.apiCell,i);if(!l)return;const c=new A.DisposableStore,b=this._statusBarCache.add([c]),y=(Array.isArray(l)?l:[l]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,c));return{cacheId:b,items:y}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,f,S,i,g){if((0,P.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,S),this._notebookProxy.$registerNotebookSerializer(a,{id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,g)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(o,f,S){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.deserializeNotebook(f.buffer,S);return new s.SerializableObjectWithBuffers(n.NotebookData.from(g))}async $notebookToData(o,f,S){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const g=await i.serializeNotebook(n.NotebookData.to(f.value),S);return d.VSBuffer.wrap(g)}async $openNotebook(o,f,S,i,g){const{provider:a}=this._getProviderData(o),r=await a.openNotebook(T.URI.revive(f),{backupId:S,untitledDocumentData:i?.buffer},g);return new s.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,f,S){const i=this.getNotebookDocument(T.URI.revive(f)),{provider:g}=this._getProviderData(o);return await g.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(o,f,S,i){const g=this.getNotebookDocument(T.URI.revive(f)),{provider:a}=this._getProviderData(o);return await a.saveNotebookAs(T.URI.revive(S),g.apiNotebook,i),!0}async $backupNotebook(o,f,S){const i=this.getNotebookDocument(T.URI.revive(f)),g=this._getProviderData(o),a=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension),r=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),v=T.URI.joinPath(a,r),l=await g.provider.backupNotebook(i.apiNotebook,{destination:v},S);return i.updateBackup(l),l.id}_createExtHostEditor(o,f,S){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const i=new p.ExtHostNotebookEditor(f,this._notebookEditorsProxy,o,S.visibleRanges.map(n.NotebookRange.to),S.selections.map(n.NotebookRange.to),typeof S.viewColumn=="number"?n.ViewColumn.to(S.viewColumn):void 0);this._editors.set(f,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const S of o.value.removedDocuments){const i=T.URI.revive(S),g=this._documents.get(i);g&&(g.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(o.value.addedDocuments){const S=[];for(const i of o.value.addedDocuments){const g=T.URI.revive(i.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const a=this,r=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){a._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){a._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){a._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){a._onDidChangeCellExecutionState.fire(v)}},g,i);S.push(...i.cells.map(v=>u.ExtHostCell.asModelAddData(r.apiNotebook,v))),this._documents.get(g)?.dispose(),this._documents.set(g,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(o.value.addedEditors)for(const S of o.value.addedEditors){if(this._editors.has(S.id))return;const i=T.URI.revive(S.documentUri),g=this._documents.get(i);g&&this._createExtHostEditor(g,S.id,S)}const f=[];if(o.value.removedEditors)for(const S of o.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),f.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const g=S.has(i.id);i._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(we[198],be([0,1,3,55,14,5,13,8]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const m=C._Keys.nextId();_.$registerNotebookEditorDecorationType(m,P.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(_,n,m){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const m=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(_[n]))}};T=Be([We(0,E.ILogService),We(1,F.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(we[199],be([0,1,15,12,21,3,6,20,2,26,14,5,39,8,7,67,165,30,38]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(a,r,v,l,c){this._initData=r,this._extHostNotebook=v,this._commands=l,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:y}}else if(h&&"notebookEditor"in h){const y=this._extHostNotebook.getIdByEditor(h.notebookEditor);if(y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.document.uri.toString()}`);return{notebookEditorId:y}}return h})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(a,r,v,l,c,b){for(let Q of this._kernelData.values())if(Q.controller.id===r&&T.ExtensionIdentifier.equals(a.identifier,Q.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const h=this._handlePool++,y=this;this._logService.trace(`NotebookController[${h}], CREATED by ${a.identifier.value}, ${r}`);const R=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${a.identifier}'`);let I=!1;const U=new F.DisposableStore,L=new A.Emitter,D=new A.Emitter,x={id:`${a.identifier.value}/${r}`,notebookType:v,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let N=c??R,V;this._proxy.$addKernel(h,x).catch(Q=>{console.log(Q),I=!0});let W=0;const $=()=>{if(I)return;const Q=++W;Promise.resolve().then(()=>{Q===W&&this._proxy.$updateKernel(h,x)})},Z=new P.ResourceMap,j={get id(){return r},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(Q){x.label=Q??a.displayName??a.name,$()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,$()},get description(){return x.description??""},set description(Q){x.description=Q,$()},get kind(){return(0,k.checkProposedApiEnabled)(a),x.kind??""},set kind(Q){(0,k.checkProposedApiEnabled)(a),x.kind=Q,$()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,$()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,$()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??R},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),$()},createNotebookCellExecution(Q){if(I)throw new Error("notebook controller is DISPOSED");if(!Z.has(Q.notebook.uri))throw y._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return y._createNotebookCellExecution(Q)},dispose:()=>{I||(this._logService.trace(`NotebookController[${h}], DISPOSED`),I=!0,this._kernelData.delete(h),U.dispose(),L.dispose(),D.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(Q,ae){y._proxy.$updateNotebookPriority(h,Q.uri,ae)},onDidReceiveMessage:D.event,postMessage(Q,ae){return(0,k.checkProposedApiEnabled)(a),y._proxy.$postMessage(h,ae&&y._extHostNotebook.getIdByEditor(ae),Q)},asWebviewUri(Q){return(0,k.checkProposedApiEnabled)(a),(0,u.asWebviewUri)(Q,y._initData.remote)}};return this._kernelData.set(h,{extensionId:a.identifier,controller:j,onDidReceiveMessage:D,onDidChangeSelection:L,associatedNotebooks:Z}),j}$acceptNotebookAssociation(a,r,v){const l=this._kernelData.get(a);if(l){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));v?l.associatedNotebooks.set(c.uri,!0):l.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,c.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:c.apiNotebook})}}async $executeCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)),b=[];for(let h of v){const y=c.getCell(h);y&&b.push(y.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,c.uri.toString(),b.length),await l.controller.executeHandler.call(l.controller,b,c.apiNotebook,l.controller)}catch(h){this._logService.error(`NotebookController[${a}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,c.apiNotebook);else for(let b of v){const h=c.getCell(b);h&&this._activeExecutions.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,v){const l=this._kernelData.get(a);if(!l)return;const c=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:v}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const l=new S(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,l);const c=l.onDidChangeState(()=>{l.state===f.Resolved&&(l.dispose(),c.dispose(),this._activeExecutions.delete(v.uri))});return l.asApiObject()}};o=Be([We(4,t.ILogService)],o),e.ExtHostNotebookKernels=o;var f;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(f||(f={}));class S extends F.Disposable{constructor(a,r,v){super();this._document=a,this._cell=r,this._proxy=v,this._handle=S.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new w.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const v=s.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return v===r.items?m.NotebookCellOutput.from(r):m.NotebookCellOutput.from({items:v,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,v){const l=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(a));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:v,outputs:c})}async updateOutputItems(a,r,v){return a=s.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(a),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(m.NotebookCellOutputItem.from),outputId:r.id,append:v})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(v){a._executionOrder=v,a.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(v){if(a._state===f.Resolved||a._state===f.Started)throw new Error("Cannot call start again");a._state=f.Started,a._onDidChangeState.fire(),a.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:v})},end(v,l){if(a._state===f.Resolved)throw new Error("Cannot call resolve twice");a._state=f.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:v}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(v){return a.verifyStateForOutput(),a.updateOutputs([],v,!1)},appendOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!0)},replaceOutput(v,l){return a.verifyStateForOutput(),a.updateOutputs(v,l,!1)},appendOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!0)},replaceOutputItems(v,l){return a.verifyStateForOutput(),a.updateOutputItems(v,l,!1)}})}}S.HANDLE=0;class i{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(we[200],be([0,1,3,5,93]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(P,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,C,T){const t=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(C)?.fire({editor:t.apiEditor,message:T})}createRendererMessaging(P,C){if(!P.contributes?.notebookRenderer?.some(n=>n.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const T=!!P.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,m,s)=>{const u=T?n:p=>{const k={};t.set(k,p.editor),n({editor:k,message:p.message})};return this.getOrCreateEmitterFor(C).event(u,m,s)},postMessage:(n,m)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,m]=[m,n]);const s=T?m:t.get(m),u=s&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(u?.id,C,n)}}}getOrCreateEmitterFor(P){let C=this._rendererMessageEmitters.get(P);return C||(C=new d.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,C),C)}}e.ExtHostNotebookRenderers=A}),define(we[96],be([0,1,5,3,6,22,4,13]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class C extends E.Disposable{constructor(s,u,p,k,w){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=w,this._id=w.$register(this.name,u,p,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(u=>this._proxy.$clear(u,s))}show(s,u){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof s=="boolean"?s:u)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=C;class T extends C{constructor(s,u,p){super(s,!1,void 0,u,p)}append(s){super.append(s),this._id.then(u=>this._proxy.$append(u,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=T;class t extends C{constructor(s,u,p){super(s,!0,u,void 0,p)}append(s){throw new Error("Not supported")}}class _{constructor(s,u){this.name=s,this._channel=u}append(s){this._channel.then(u=>u.append(s))}appendLine(s){this._channel.then(u=>u.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,u){this._channel.then(p=>p.show(s,u))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=_;let n=class{constructor(s){this._proxy=s.getProxy(d.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new T(s,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,u){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(s,u,this._proxy)}};n=Be([We(0,P.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(we[201],be([0,1,12,21,3,6,5,2,7,16,15,35,48]),function(re,e,d,M,E,A,F,P,C,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(s,u,p){const k=s.getProxy(F.MainContext.MainThreadQuickOpen);class w{constructor(l,c){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=c}showQuickPick(l,c,b,h=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(l),R=++this._instances,I=k.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},h),U={},L=I.then(()=>U);return Promise.race([L,y]).then(D=>{if(D!==U)return y.then(x=>{const N=[];for(let V=0;V<x.length;V++){const W=x[V];let $,Z,j,Q,ae;typeof W=="string"?$=W:($=W.label,Z=W.description,j=W.detail,Q=W.picked,ae=W.alwaysShow),N.push({label:$,description:Z,handle:V,detail:j,picked:Q,alwaysShow:ae})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{b.onDidSelectItem(x[V])}),k.$setItems(R,N),I.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(W=>x[W])})})}).then(void 0,D=>{if(!(0,T.isPromiseCanceledError)(D))return k.$setError(R,D),Promise.reject(D)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,c=M.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,k.$input(l,typeof this._validateInput=="function",c).then(void 0,b=>{if(!(0,T.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(l){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,c=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!b)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(l,c){const b=new a(l,c,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(l){const c=new r(l,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(l,c){const b=this._sessions.get(l);b&&b._fireDidChangeValue(c)}$onDidAccept(l){const c=this._sessions.get(l);c&&c._fireDidAccept()}$onDidChangeActive(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const b=this._sessions.get(l);b instanceof a&&b._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){const b=this._sessions.get(l);b&&b._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,b){const h=this._sessions.get(l);h instanceof a&&h._fireDidTriggerItemButton(c,b)}$onDidHide(l){const c=this._sessions.get(l);c&&c._fireDidHide()}}class o{constructor(l,c){this._extensionId=l,this._onDidDispose=c,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((c,b)=>{const h=c===C.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(h,c)}),this.update({buttons:l.map((c,b)=>({...g(c),tooltip:c.tooltip,handle:c===C.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const c=this._handlesToButtons.get(l);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(l){if(!this._disposed){for(const c of Object.keys(l)){const b=l[c];this._pendingUpdate[c]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function f(v){if(v instanceof C.ThemeIcon)return{id:v.id};const l=i(v),c=S(v);return{dark:typeof l=="string"?P.URI.file(l):l,light:typeof c=="string"?P.URI.file(c):c}}function S(v){return typeof v=="object"&&"light"in v?v.light:v}function i(v){return typeof v=="object"&&"dark"in v?v.dark:v}function g(v){const l=f(v.iconPath);let c,b;return"id"in l?b=n.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:b}}class a extends o{constructor(l,c,b){super(l,b);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((c,b)=>{this._handlesToItems.set(b,c),this._itemsToHandles.set(c,b)}),this.update({items:l.map((c,b)=>({label:c.label,description:c.description,handle:b,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((h,y)=>({...g(h),tooltip:h.tooltip,handle:y})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(l){const c=(0,t.coalesce)(l.map(b=>this._handlesToItems.get(b)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(l,c){const b=this._handlesToItems.get(l);if(!b||!b.buttons||!b.buttons.length)return;const h=b.buttons[c];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:b})}}class r extends o{constructor(l,c){super(l,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?_.default.Error:_.default.Ignore})}}return new w(u,p)}e.createExtHostQuickOpen=m}),define(we[202],be([0,1,2,3,54,6,12,5,15,107,14,26,30,48,8]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(l){if(l)return typeof l.iconPath=="string"?d.URI.file(l.iconPath):d.URI.isUri(l.iconPath)||m.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function p(l,c){if(!l.iconPath&&!c.iconPath)return 0;if(l.iconPath){if(!c.iconPath)return 1}else return-1;const b=typeof l.iconPath=="string"?l.iconPath:d.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,h=typeof c.iconPath=="string"?c.iconPath:d.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,T.comparePaths)(b,h)}function k(l,c){let b=0;if(l.strikeThrough!==c.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==c.faded)return l.faded?1:-1;if(l.tooltip!==c.tooltip)return(l.tooltip||"").localeCompare(c.tooltip||"");if(b=p(l,c),b!==0)return b;if(l.light&&c.light)b=p(l.light,c.light);else{if(l.light)return 1;if(c.light)return-1}if(b!==0)return b;if(l.dark&&c.dark)b=p(l.dark,c.dark);else{if(l.dark)return 1;if(c.dark)return-1}return b}function w(l,c){if(l.command!==c.command)return l.command<c.command?-1:1;if(l.title!==c.title)return l.title<c.title?-1:1;if(l.tooltip!==c.tooltip){if(l.tooltip!==void 0&&c.tooltip!==void 0)return l.tooltip<c.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(l.arguments===c.arguments)return 0;if(l.arguments)if(c.arguments){if(l.arguments.length!==c.arguments.length)return l.arguments.length-c.arguments.length}else return 1;else return-1;for(let b=0;b<l.arguments.length;b++){const h=l.arguments[b],y=c.arguments[b];if(h!==y)return h<y?-1:1}return 0}function o(l,c){let b=(0,T.comparePaths)(l.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(b!==0)return b;if(l.command&&c.command)b=w(l.command,c.command);else{if(l.command)return 1;if(c.command)return-1}if(b!==0)return b;if(l.decorations&&c.decorations)b=k(l.decorations,c.decorations);else{if(l.decorations)return 1;if(c.decorations)return-1}return b}function f(l,c){for(let b=0;b<l.length;b++)if(l[b]!==c[b])return!1;return!0}function S(l,c){return l.command===c.command&&l.title===c.title&&l.tooltip===c.tooltip&&(l.arguments&&c.arguments?f(l.arguments,c.arguments):l.arguments===c.arguments)}function i(l,c){return(0,C.equals)(l,c,S)}class g{constructor(c,b,h){this._extension=c,this._proxy=b,this._sourceControlHandle=h,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,n.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,b){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,b)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=g;class a{constructor(c,b,h,y,R){this._proxy=c,this._commands=b,this._sourceControlHandle=h,this._id=y,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,b){const h=this._resourceStatesCommandsMap.get(c);return h?(0,F.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(o),h=(0,C.sortedDiff)(this._resourceSnapshot,c,o).map(I=>{const U=I.toInsert.map(L=>{const D=this._resourceHandlePool++;this._resourceStatesMap.set(D,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Fe=new A.DisposableStore;N=this._commands.converter.toInternal(L.command,Fe),this._resourceStatesDisposablesMap.set(D,Fe)}else this._resourceStatesCommandsMap.set(D,L.command);const V=u(L.decorations),W=L.decorations&&u(L.decorations.light)||V,$=L.decorations&&u(L.decorations.dark)||V,Z=[W,$],j=L.decorations&&L.decorations.tooltip||"",Q=L.decorations&&!!L.decorations.strikeThrough,ae=L.decorations&&!!L.decorations.faded,pe=L.contextValue||"";return{rawResource:[D,x,Z,j,Q,ae,pe,N],handle:D}});return{start:I.start,deleteCount:I.deleteCount,toInsert:U}}),y=h.map(({start:I,deleteCount:U,toInsert:L})=>[I,U,L.map(D=>D.rawResource)]),R=h.reverse();for(const{start:I,deleteCount:U,toInsert:L}of R){const D=L.map(N=>N.handle),x=this._handlesSnapshot.splice(I,U,...D);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=c,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class r{constructor(c,b,h,y,R,I){this._extension=c,this._proxy=b,this._commands=h,this._id=y,this._label=R,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,R,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=c;const b=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=c;const b=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&i(this._statusBarCommands,c))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=c;const b=(c||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(c,b){const h=new a(this._proxy,this._commands,this.handle,c,b),y=M.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,y),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const c=[],b=[];for(const[h,y]of this.createdResourceGroups){y.dispose();const R=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});M.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),R.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),c.push([h.handle,h.id,h.label,h.features]);const I=h._takeResourceStateSnapshot();I.length>0&&b.push([h.handle,I]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,c,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(b=>{const h=b._takeResourceStateSnapshot();h.length!==0&&c.push([b.handle,h])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Be([(0,E.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let v=class Ui{constructor(c,b,h){this._commands=b,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=c.getProxy(P.MainContext.MainThreadSCM),this._telemetry=c.getProxy(P.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const R=this._sourceControls.get(y.sourceControlHandle);if(!R)return y;const I=R.getResourceGroup(y.groupHandle);return I?I.getResourceState(y.handle):y}else if(y&&y.$mid===4){const R=this._sourceControls.get(y.sourceControlHandle);return R?R.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const R=this._sourceControls.get(y.handle);return R||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,b,h,y){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,b,h,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const R=Ui._handlePool++,I=new r(c,this._proxy,this._commands,b,h,y);this._sourceControls.set(R,I);const U=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier))||[];return U.push(I),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(c.identifier),U),I}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(c.identifier)),h=b&&b[b.length-1];return h&&h.inputBox}$provideOriginalResource(c,b,h){const y=d.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,y.toString());const R=this._sourceControls.get(c);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(y,h)).then(I=>I||null)}$onInputBoxValueChange(c,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const h=this._sourceControls.get(c);return h&&h.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(c,b,h,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,b,h);const R=this._sourceControls.get(c);if(!R)return Promise.resolve(void 0);const I=R.getResourceGroup(b);return I?I.$executeResourceCommand(h,y):Promise.resolve(void 0)}$validateInput(c,b,h){this.logService.trace("ExtHostSCM#$validateInput",c);const y=this._sourceControls.get(c);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>y.inputBox.validateInput(b,h)).then(R=>{if(!R)return Promise.resolve(void 0);const I=s.MarkdownString.fromStrict(R.message);return I?Promise.resolve([I,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};v._handlePool=0,v=Be([We(2,t.ILogService)],v),e.ExtHostSCM=v});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[203],be([0,1,7,5,126,6,8,10]),function(re,e,d,M,E,A,F,P){"use strict";var C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(s,u,p,k,w=d.StatusBarAlignment.Left,o){C.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Ze(this,C,s,"f"),Ze(this,T,u,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=k,this._alignment=w,this._priority=this.validatePriority(o)}validatePriority(s){if(!!(0,P.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!t.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Ae(this,T,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let u;this._name?u=this._name:u=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const k=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,C,"f").$setEntry(this._entryId,s,u,this._text,k,this._command?.internal,p,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,C=new WeakMap,T=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const u={message:s};return this._messages.unshift(u),this._update(),new d.Disposable(()=>{const p=this._messages.indexOf(u);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,u){this._proxy=s.getProxy(M.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new _(this)}createStatusBarEntry(s,u,p,k){return new t(this._proxy,this._commands,s,u,p,k)}setStatusBarMessage(s,u){const p=this._statusMessage.setMessage(s);let k;return typeof u=="number"?k=setTimeout(()=>p.dispose(),u):typeof u!="undefined"&&u.then(()=>p.dispose(),()=>p.dispose()),new d.Disposable(()=>{p.dispose(),clearTimeout(k)})}}e.ExtHostStatusBar=n}),define(we[73],be([0,1,5,3,4]),function(re,e,d,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,C){this._proxy.$registerExtensionStorageKeysToSync(P,C)}getValue(P,C,T){return this._proxy.$getValue(P,C).then(t=>t||T)}setValue(P,C,T){return this._proxy.$setValue(P,C,T)}$acceptValue(P,C,T){this._onDidChangeStorage.fire({shared:P,key:C,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(we[74],be([0,1,4,29,14,72,2]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(T){return F.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,t=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(T){if(this._value)return F.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return F.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([We(0,M.IExtHostInitDataService),We(1,E.ILogService),We(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(we[40],be([0,1,3,5,4,2,13,6,7,127,16,167,21,36,149,48,10,12]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class w{constructor(l,c,b,h){this._proxy=l,this._id=c,this._creationOptions=b,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,I=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,I)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(l,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,p.withNullAsUndefined)(l.shellPath),shellArgs:(0,p.withNullAsUndefined)(l.shellArgs),cwd:(0,p.withNullAsUndefined)(l.cwd),env:(0,p.withNullAsUndefined)(l.env),icon:(0,p.withNullAsUndefined)(a(l.iconPath)),color:u.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,p.withNullAsUndefined)(l.message),strictEnv:(0,p.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(l.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,c,b,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:u.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(l,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,c){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,c){return l===this._cols&&c===this._rows||l===0||c===0?!1:(this._cols=l,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=w;class o{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,c){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:c})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let f=1,S=class extends P.Disposable{constructor(l,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[b,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,c){const b=new w(this._proxy,(0,m.generateUuid)(),l,l.name),h=new o(l.pty);return b.createExtensionTerminal(l.location,this._serializeParentTerminal(l,c).resolvedExtHostIdentifier,a(l.iconPath),r(l.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,h);this._terminalProcessDisposables[y]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(l,c){if(c=c||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const b=l.location.parentTerminal;if(b){const h=this._terminals.find(y=>y.value===b);h&&(c.resolvedExtHostIdentifier=h._id)}}else l.location&&typeof l.location!="object"?c.location=l.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(l,c){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const h=new o(c),y=this._setupExtHostProcessListeners(l,h);this._terminalProcessDisposables[l]=y}async $acceptActiveTerminalChanged(l){const c=this._activeTerminal;if(l===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(l);b&&(this._activeTerminal=b,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,c){const b=this._getTerminalById(l);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:c})}async $acceptTerminalDimensions(l,c,b){const h=this._getTerminalById(l);h&&h.setDimensions(c,b)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(l,c,b){this._terminalProcesses.get(l)?.resize(c,b)}async $acceptTerminalTitleChange(l,c){const b=this._getTerminalById(l);b&&(b.name=c)}async $acceptTerminalClosed(l,c){const b=this._getTerminalObjectIndexById(this._terminals,l);if(b!==null){const h=this._terminals.splice(b,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(l,c,b,h){if(c){const I=this._getTerminalObjectIndexById(this._terminals,c);if(I!==null){this._terminals[I]._id=l,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const y={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:A.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new w(this._proxy,l,y,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(l,c){const b=this._getTerminalById(l);b&&b._setProcessId(c)}async $startExtensionTerminal(l,c){const b=this._getTerminalById(l);if(!b)return{message:(0,T.localize)(0,null,l)};b.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async I=>{I===b.value&&(R.dispose(),y())})});const h=this._terminalProcesses.get(l);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[l]={initialDimensions:c}}_setupExtHostProcessListeners(l,c){const b=new P.DisposableStore;b.add(c.onProcessReady(y=>this._proxy.$sendProcessReady(l,y.pid,y.cwd))),b.add(c.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(l,y))),this._bufferer.startBuffering(l,c.onProcessData),b.add(c.onProcessExit(y=>this._onProcessExit(l,y))),this._terminalProcesses.set(l,c);const h=this._extensionTerminalAwaitingStart[l];return h&&c instanceof o&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),b}$acceptProcessAckDataEvent(l,c){this._terminalProcesses.get(l)?.acknowledgeDataEvent(c)}$acceptProcessInput(l,c){this._terminalProcesses.get(l)?.input(c)}$acceptTerminalInteraction(l){const c=this._getTerminalById(l);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(l,c,b){try{this._terminalProcesses.get(l)?.resize(c,b)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(l,c){this._terminalProcesses.get(l)?.shutdown(c)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(c=>this._proxy.$sendProcessProperty(l,{type:"cwd",value:c}))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,c,b){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,b),this._proxy.$registerProfileProvider(c,l.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(l,c){const b=new n.CancellationTokenSource().token;let h=await this._profileProviders.get(l)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(l,c){const b=this._getTerminalById(l);if(!b)return[];this._terminalLinkCache.delete(l);const h=this._terminalLinkCancellationSource.get(l);h&&h.dispose(!0);const y=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,y);const R=[],I={terminal:b.value,line:c},U=[];for(const x of this._linkProviders)U.push(k.Promises.withAsyncBody(async N=>{y.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(I,y.token)||[];y.token.isCancellationRequested||N({provider:x,links:V})}));const L=await Promise.all(U);if(y.token.isCancellationRequested)return[];const D=new Map;for(const x of L)x&&x.links.length>0&&R.push(...x.links.map(N=>{const V={id:f++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return D.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(l,D),R}$activateLink(l,c){const b=this._terminalLinkCache.get(l)?.get(c);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(l,c){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const b=this._terminalProcessDisposables[l];b&&(b.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,c)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,c){const b=this._getTerminalObjectIndexById(l,c);return b!==null?l[b]:null}_getTerminalObjectIndexById(l,c){let b=null;return l.some((h,y)=>h._id===c?(b=y,!0):!1),b}getEnvironmentVariableCollection(l){let c=this._environmentVariableCollections.get(l.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(l.identifier.value,c)),c}_syncEnvironmentVariableCollection(l,c){const b=(0,_.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(l,c.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(l){l.forEach(c=>{const b=c[0],h=new i(c[1]);this._setEnvironmentVariableCollection(b,h)})}$acceptDefaultProfile(l,c){this._defaultProfile=l,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(l,c){this._environmentVariableCollections.set(l,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,c)})}};S=Be([We(1,F.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class i{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(l,c){this._setIfDiffers(l,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,c){const b=this.map.get(l);(!b||b.value!==c.value||b.type!==c.type)&&(this.map.set(l,c),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,c){this.map.forEach((b,h)=>l.call(c,h,b,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let g=class extends S{constructor(l){super(!1,l)}createTerminal(l,c,b){throw new t.NotSupportedError}createTerminalFromOptions(l,c){throw new t.NotSupportedError}};g=Be([We(0,F.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function a(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function r(v){return u.ThemeColor.isThemeColor(v)?v:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[204],be([0,1,15,22,21,3,234,59,6,23,10,36,5,13,50,8,7,175,90,68]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(I,U){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new g(this.proxy),U.registerArgumentProcessor({processArgument:L=>L?.$mid===13?u.TestItem.toItemFromContext(L):L})}createTestController(I,U){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const L=new C.DisposableStore,D=L.add(new k.SingleUseTestCollection(I));D.root.label=U;const x=new Map,N=this.proxy,V={items:D.root.children,get label(){return U},set label($){U=$,D.root.label=$,N.$updateControllerLabel(I,U)},get id(){return I},createRunProfile:($,Z,j,Q,ae)=>{let pe=(0,P.hash)($);for(;x.has(pe);)pe++;const ce=new h(this.proxy,I,pe,$,Z,j,Q,ae);return x.set(pe,ce),ce},createTestItem($,Z,j){return new s.TestItemImpl(I,$,Z,j)},createTestRun:($,Z,j=!0)=>this.runTracker.createTestRun(I,D,$,Z,j),set resolveHandler($){D.resolveHandler=$},get resolveHandler(){return D.resolveHandler},dispose:()=>{L.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(I,U),L.add((0,C.toDisposable)(()=>N.$unregisterTestController(I)));const W={controller:V,collection:D,profiles:x};return this.controllers.set(I,W),L.add((0,C.toDisposable)(()=>this.controllers.delete(I))),L.add(D.onDidGenerateDiff($=>N.$publishDiff(I,$))),V}createTestObserver(){return this.observer.checkout()}async runTests(I,U=E.CancellationToken.None){const L=a(I);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const D=this.controllers.get(L.controllerId);if(!D)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(x=>x.id)??[D.collection.root.id],profileGroup:y[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:I.exclude?.map(x=>x.id)},U)}$provideFileCoverage(I,U,L){return(0,d.mapFind)(this.runTracker.trackers,x=>x.id===I?x.getCoverage(U):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(I,U,L,D){return(0,d.mapFind)(this.runTracker.trackers,N=>N.id===I?N.getCoverage(U):void 0)?.resolveFileCoverage(L,D)??Promise.resolve([])}$configureRunProfile(I,U){this.controllers.get(I)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(U=>(0,T.deepFreeze)(u.TestResults.to(U))).concat(this.results).sort((U,L)=>L.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,U){const L=this.controllers.get(o.TestId.fromString(I).controllerId)?.collection;L&&(await L.expand(I,U<0?Infinity:U),L.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,U){const L=this.controllers.get(I.controllerId);if(!L)return;const{collection:D,profiles:x}=L,N=x.get(I.profileId);if(!N)return;const V=I.testIds.map(j=>D.tree.get(j)).filter(t.isDefined),W=I.excludeExtIds.map(j=>L.collection.tree.get(j)).filter(t.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const $=new p.TestRunRequest(V.some(j=>j.actual instanceof s.TestItemRootImpl)?void 0:V.map(j=>j.actual),W.map(j=>j.actual),N),Z=this.runTracker.prepareForMainThreadTestRun($,r.fromInternal(I,L.collection),U);try{await N.runHandler($,U)}finally{Z.isRunning&&!U.isCancellationRequested&&await A.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};S=Be([We(0,m.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends C.Disposable{constructor(I,U,L){super();this.dto=I,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:D}of this.tasks.values())D.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const U=this.dto.id,L=this.dto.controllerId,D=(0,_.generateUuid)(),x=new v(this.proxy,U,D),N=Z=>(j,...Q)=>{if(W){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),Z(j,...Q))},V=(Z,j)=>{const Q=j instanceof Array?j.map(u.TestMessage.from):[u.TestMessage.from(j)];if(Z.uri&&Z.range){const ae={range:u.Range.from(Z.range),uri:Z.uri};for(const pe of Q)pe.location=pe.location||ae}this.proxy.$appendTestMessagesInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),Q)};let W=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return x.coverageProvider},set coverageProvider(Z){x.coverageProvider=Z},enqueued:N(Z=>{this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),1)}),skipped:N(Z=>{this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),5)}),started:N(Z=>{this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),2)}),errored:N((Z,j,Q)=>{V(Z,j),this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),6,Q)}),failed:N((Z,j,Q)=>{V(Z,j),this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,L).toString(),4,Q)}),passed:N((Z,j)=>{this.proxy.$updateTestStateInRun(U,D,o.TestId.fromExtHostTestItem(Z,this.dto.controllerId).toString(),3,j)}),appendOutput:(Z,j,Q)=>{W||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(U,D,M.VSBuffer.fromString(Z),j&&u.location.from(j),Q&&o.TestId.fromExtHostTestItem(Q,L).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(U,D),this.tasks.delete(D),this.isRunning||this.dispose())}};return this.tasks.set(D,{run:$,coverage:x}),this.proxy.$startedTestRunTask(U,{id:D,name:I,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof s.TestItemImpl))throw new s.InvalidTestItemError(I.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const U=[],L=this.dto.colllection.root;for(;;){const D=u.TestItem.from(I);if(U.unshift(D),this.sharedTestIds.has(D.extId)||(this.sharedTestIds.add(D.extId),I===L))break;I=I.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class g{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,U,L){return this.getTracker(I,U,L)}cancelRunById(I){for(const U of this.tracked.values())if(U.id===I){U.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,U,L,D,x){const N=this.tracked.get(L);if(N)return N.createRun(D);const V=r.fromPublic(I,U,L,x),W=a(L);this.proxy.$startedExtensionTestRun({controllerId:I,profile:W&&{group:y[W.kind],id:W.profileId},exclude:L.exclude?.map(Z=>Z.id)??[],id:V.id,include:L.include?.map(Z=>Z.id)??[U.root.id],persist:x});const $=this.getTracker(L,V);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),$.createRun(D)}getTracker(I,U,L){const D=new i(U,this.proxy,L);return this.tracked.set(I,D),D.onEnd(()=>this.tracked.delete(I)),D}}e.TestRunCoordinator=g;const a=R=>{if(!!R.profile){if(!(R.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class r{constructor(I,U,L,D,x,N){this.controllerId=I,this.id=U,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(V=>V+"\0"),this.excludePrefix=D.map(V=>V+"\0")}static fromPublic(I,U,L,D){return new r(I,(0,_.generateUuid)(),L.include?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[I],L.exclude?.map(x=>o.TestId.fromExtHostTestItem(x,I).toString())??[],D,U)}static fromInternal(I,U){return new r(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,U)}isIncluded(I){const U=o.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(U===L||U.startsWith(L))return!1;for(const L of this.includePrefix)if(U===L||U.startsWith(L))return!0;return!1}}e.TestRunDto=r;class v{constructor(I,U,L){this.proxy=I,this.runId=U,this.taskId=L}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(I,U){const L=await this.fileCoverage;let D=L?.[I];return!this._coverageProvider||!L||!D?[]:(D.detailedCoverage||(D=L[I]=await this._coverageProvider.resolveFileCoverage?.(D,U)??D),D.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class l extends w.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,u.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:U,removed:L}=this;return{get added(){return[...I].map(D=>D.revived)},get updated(){return[...U].map(D=>D.revived)},get removed(){return[...L].map(D=>D.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,U){return{...I,revived:u.TestItem.toPlain(I.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=c;class b{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(U=>U.revived)},dispose:(0,F.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class h{constructor(I,U,L,D,x,N,V=!1,W=void 0){this.controllerId=U,this.profileId=L,this._label=D,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=W,f.set(this,void 0),Ze(this,f,I,"f");const $=y[x];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,f,"f").$publishTestRunProfile({profileId:L,controllerId:U,tag:W?u.TestTag.namespace(this.controllerId,W.id):null,label:D,group:$,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?u.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Ae(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Ae(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,f=new WeakMap;const y={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[205],be([0,1,3,15,5,94,8,7]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(n=>n.value)}async showTextDocument(t,_,n){let m;typeof _=="number"?m={position:F.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?m={position:F.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?F.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,m),u=s&&this._extHostDocumentsAndEditors.getEditor(s);if(u)return u.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(F.Selection.to);n._acceptSelections(m)}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:F.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=P.TextEditorSelectionChangeKind.fromValue(_.selections.source),s=_.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:m})}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(t){for(const _ in t){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const m=F.ViewColumn.to(t[_]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=C}),define(we[206],be([0,1,2,4,5,6,7]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class P{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:d.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(m))?.get(n.handle)}return n}})}async $getTimeline(t,_,n,m,s){return this._providers.get(t)?.provideTimeline(d.URI.revive(_),n,m,s)}registerTimelineProvider(t,_,n,m){const s=new A.DisposableStore,u=this.convertTimelineItem(_.id,m,s).bind(this);let p;_.onDidChange&&(p=_.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:_.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(w,o,f,S){S?.resetCache&&(s.clear(),k.get(_.id)?.clear());const i=await _.provideTimeline(w,o,f);if(i==null)return;const g=u(w,S);return{...i,source:_.id,items:i.items.map(g)}},dispose(){for(const w of k.values())w.get(_.id)?.clear();p?.dispose(),s.dispose()}})}convertTimelineItem(t,_,n){return(m,s)=>{let u;if(s?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const k=C(m);u=p.get(k),u===void 0&&(u=new Map,p.set(k,u))}return p=>{const{iconPath:k,...w}=p,o=`${t}|${p.id??p.timestamp}`;u?.set(o,p);let f,S,i;return p.iconPath&&(k instanceof F.ThemeIcon?i={id:k.id,color:k.color}:d.URI.isUri(k)?(f=k,S=k):{light:f,dark:S}=k),{...w,id:w.id??void 0,handle:o,source:t,command:p.command?_.toInternal(p.command,n):void 0,icon:f,iconDark:S,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=P;function C(T){return T?.toString()}}),define(we[207],be([0,1,6,11,2,5]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(C){this._openers=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,T,t,_){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const n=_.schemes.find(m=>!F.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,t),this._proxy.$registerUriOpener(T,_.schemes,C,_.label),(0,d.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(C,T,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=E.URI.revive(T);return _.canOpenExternalUri(n,t)}async $openUri(C,T,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(E.URI.revive(T.resolvedUri),{sourceUri:E.URI.revive(T.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[208],be([0,1,5,2,6,16,26]),function(re,e,d,M,E,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(T,t){if(this.handles.has(F.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const _=P.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(T)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,T),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(T)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(T,t){const _=this.handlers.get(T);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(T){return M.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[52],be([0,1,3,11,2,137,157,67,5]),function(re,e,d,M,E,A,F,P,C){"use strict";var T,t,_,n,m,s,u,p,k,w,o,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(b,h,y,R,I,U,L){T.set(this,void 0),t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,""),p.set(this,void 0),k.set(this,!1),w.set(this,!1),o.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new d.Emitter),this._onDidDispose=Ae(this,f,"f").event,Ze(this,T,b,"f"),Ze(this,t,h,"f"),Ze(this,p,y,"f"),Ze(this,n,R,"f"),Ze(this,m,I,"f"),Ze(this,s,U,"f"),Ze(this,o,i(U),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,k,!0,"f"),Ae(this,f,"f").fire(),Ae(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,w,!0,"f"),(0,P.asWebviewUri)(b,Ae(this,n,"f").remote)}get cspSource(){const b=Ae(this,s,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let h=b.toString();return h.endsWith("/")||(h+="/"),h+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,u,"f")}set html(b){this.assertNotDisposed(),Ae(this,u,"f")!==b&&(Ze(this,u,b,"f"),!Ae(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,w,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,t,"f").$setHtml(Ae(this,T,"f"),b))}get options(){return this.assertNotDisposed(),Ae(this,p,"f")}set options(b){this.assertNotDisposed(),Ae(this,t,"f").$setOptions(Ae(this,T,"f"),r(Ae(this,s,"f"),Ae(this,m,"f"),b)),Ze(this,p,b,"f")}async postMessage(b){if(Ae(this,k,"f"))return!1;const h=(0,F.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ae(this,o,"f")});return Ae(this,t,"f").$postMessage(Ae(this,T,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Ae(this,k,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap;function i(c){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class g{constructor(b,h,y,R,I){this.initData=h,this.workspace=y,this._logService=R,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,h,...y){const R=this.getWebview(b);if(R){const{message:I}=(0,F.deserializeWebviewMessage)(h,y);R._onMessageEmitter.fire(I)}}$onMissingCsp(b,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,h,y){const R=new S(b,this._webviewProxy,v(h),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=g;function a(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=a;function r(c,b,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||l(c,b)}}e.serializeWebviewOptions=r;function v(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(b=>E.URI.from(b))}}e.reviveOptions=v;function l(c,b){return[...(b?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(we[209],be([0,1,21,59,6,11,24,2,8,52,64,5,7]),function(re,e,d,M,E,A,F,P,C,T,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(i,g){this.document=i,this._storagePath=g,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,g){await this.getEdit(i).undo(),g||this.disposeBackup()}async redo(i,g){await this.getEdit(i).redo(),g||this.disposeBackup()}disposeEdits(i){for(const g of i)this._edits.delete(g)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=f(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const g=this._edits.get(i,0);if(!g)throw new Error("No edit found");return g}}class s{constructor(){this._documents=new Map}get(i,g){return this._documents.get(this.key(i,g))}add(i,g,a){const r=this.key(i,g.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${g.uri}`);const v=new m(g,a);return this._documents.set(r,v),v}delete(i,g){const a=this.key(i,g.uri);this._documents.delete(a)}key(i,g){return`${i}@@@${g}`}}var u;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(u||(u={}));class p{constructor(){this._providers=new Map}addTextProvider(i,g,a){return this.add(0,i,g,a)}addCustomProvider(i,g,a){return this.add(1,i,g,a)}get(i){return this._providers.get(i)}add(i,g,a,r){if(this._providers.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this._providers.set(g,{type:i,extension:a,provider:r}),new n.Disposable(()=>this._providers.delete(g))}}class k{constructor(i,g,a,r,v){this._extHostDocuments=g,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new s,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,g,a,r){const v=new E.DisposableStore;return w(a)?(v.add(this._editorProviders.addTextProvider(g,i,a)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(i))):(v.add(this._editorProviders.addCustomProvider(g,i,a)),this.supportEditing(a)&&v.add(a.onDidChangeCustomDocument(l=>{const c=this.getCustomDocumentEntry(g,l.document.uri);if(o(l)){const b=c.addEdit(l);this._proxy.$onDidEdit(l.document.uri,g,b,l.label)}else this._proxy.$onContentChange(l.document.uri,g)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(i),g,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(g)}))}async $createCustomDocument(i,g,a,r,v){const l=this._editorProviders.get(g);if(!l)throw new Error(`No provider found for '${g}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${g}'`);const c=P.URI.revive(i),b=await l.provider.openCustomDocument(c,{backupId:a,untitledDocumentData:r?.buffer},v);let h;return this.supportEditing(l.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension)),this._documents.add(g,b,h),{editable:this.supportEditing(l.provider)}}async $disposeCustomDocument(i,g){const a=this._editorProviders.get(g);if(!a)throw new Error(`No provider found for '${g}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${g}'`);const r=P.URI.revive(i),{document:v}=this.getCustomDocumentEntry(g,r);this._documents.delete(g,v),v.dispose()}async $resolveWebviewEditor(i,g,a,r,v,l){const c=this._editorProviders.get(a);if(!c)throw new Error(`No provider found for '${a}'`);const b=C.ViewColumn.to(v),h=this._extHostWebview.createNewWebview(g,r.webviewOptions,c.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(g,a,r.title,b,r.panelOptions,h),R=P.URI.revive(i);switch(c.type){case 1:{const{document:I}=this.getCustomDocumentEntry(a,R);return c.provider.resolveCustomEditor(I,y,l)}case 0:{const I=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(I,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,g,a){this.getCustomDocumentEntry(g,i).disposeEdits(a)}async $onMoveCustomEditor(i,g,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const v=this._extHostWebviewPanels.getWebviewPanel(i);if(!v)throw new Error("No webview found");const l=P.URI.revive(g),c=this._extHostDocuments.getDocument(l);await r.provider.moveCustomTextEditor(c,v,d.CancellationToken.None)}async $undo(i,g,a,r){return this.getCustomDocumentEntry(g,i).undo(a,r)}async $redo(i,g,a,r){return this.getCustomDocumentEntry(g,i).redo(a,r)}async $revert(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(i,g,a){const r=this.getCustomDocumentEntry(g,i);await this.getCustomEditorProvider(g).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(i,g,a,r){const v=this.getCustomDocumentEntry(g,i);return this.getCustomEditorProvider(g).saveCustomDocumentAs(v.document,P.URI.revive(a),r)}async $backup(i,g,a){const r=this.getCustomDocumentEntry(g,i),l=await this.getCustomEditorProvider(g).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(l),l.id}getCustomDocumentEntry(i,g){const a=this._documents.get(i,P.URI.revive(g));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function w(S){return typeof S.resolveCustomTextEditor=="function"}function o(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function f(S){const i=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,M.hash)(i)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[210],be([0,1,3,6,2,36,8,52,5,7]),function(re,e,d,M,E,A,F,P,C,T){"use strict";var t,_,n,m,s,u,p,k,w,o,f,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class g extends M.Disposable{constructor(l,c,b,h,y,R,I){super();t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,void 0),p.set(this,void 0),k.set(this,void 0),w.set(this,!0),o.set(this,!0),f.set(this,!1),S.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,S,"f").event,i.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Ze(this,t,l,"f"),Ze(this,_,c,"f"),Ze(this,n,b,"f"),Ze(this,s,R,"f"),Ze(this,k,y,"f"),Ze(this,u,h,"f"),Ze(this,m,I,"f")}dispose(){Ae(this,f,"f")||(Ze(this,f,!0,"f"),Ae(this,S,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,u,"f")}set title(l){this.assertNotDisposed(),Ae(this,u,"f")!==l&&(Ze(this,u,l,"f"),Ae(this,_,"f").$setTitle(Ae(this,t,"f"),l))}get iconPath(){return this.assertNotDisposed(),Ae(this,p,"f")}set iconPath(l){this.assertNotDisposed(),Ae(this,p,"f")!==l&&(Ze(this,p,l,"f"),Ae(this,_,"f").$setIconPath(Ae(this,t,"f"),E.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ae(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,k,"f")=="number"&&Ae(this,k,"f")<0))return Ae(this,k,"f")}get active(){return this.assertNotDisposed(),Ae(this,o,"f")}get visible(){return this.assertNotDisposed(),Ae(this,w,"f")}_updateViewState(l){Ae(this,f,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ze(this,o,l.active,"f"),Ze(this,w,l.visible,"f"),Ze(this,k,l.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(l,c){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,t,"f"),{viewColumn:l?F.ViewColumn.from(l):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ae(this,f,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap,S=new WeakMap,i=new WeakMap;class a{constructor(l,c,b){this.webviews=c,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(l,c,b,h,y={}){const R=typeof h=="object"?h.viewColumn:h,I={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},U=(0,P.shouldSerializeBuffersForPostMessage)(l),L=a.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(l),L,c,{title:b,panelOptions:r(y),webviewOptions:(0,P.serializeWebviewOptions)(l,this.workspace,y),serializeBuffersForPostMessage:U},I);const D=this.webviews.createNewWebview(L,y,l);return this.createNewWebviewPanel(L,c,b,R,y,D)}$onDidChangeWebviewPanelViewStates(l){const c=Object.keys(l);c.sort((b,h)=>{const y=l[b],R=l[h];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const b of c){const h=this.getWebviewPanel(b);if(!h)continue;const y=l[b];h._updateViewState({active:y.active,visible:y.visible,viewColumn:F.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,c,b){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:b,extension:l}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(l)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(l,c,b,h){const y=this._serializers.get(c);if(!y)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:I}=y,U=this.webviews.createNewWebview(l,b.webviewOptions,I),L=this.createNewWebviewPanel(l,c,b.title,h,b.panelOptions,U);await R.deserializeWebviewPanel(L,b.state)}createNewWebviewPanel(l,c,b,h,y,R){const I=new g(l,this._proxy,c,b,h,y,R);return this._webviewPanels.set(l,I),I}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function r(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[211],be([0,1,3,6,52,5,7]),function(re,e,d,M,E,A,F){"use strict";var P,C,T,t,_,n,m,s,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends M.Disposable{constructor(f,S,i,g,a,r){super();P.set(this,void 0),C.set(this,void 0),T.set(this,void 0),t.set(this,void 0),_.set(this,!1),n.set(this,void 0),m.set(this,void 0),s.set(this,void 0),u.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Ae(this,u,"f").event,p.set(this,this._register(new d.Emitter)),this.onDidDispose=Ae(this,p,"f").event,Ze(this,T,i,"f"),Ze(this,m,g,"f"),Ze(this,P,f,"f"),Ze(this,C,S,"f"),Ze(this,t,a,"f"),Ze(this,n,r,"f")}dispose(){Ae(this,_,"f")||(Ze(this,_,!0,"f"),Ae(this,p,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,m,"f")}set title(f){this.assertNotDisposed(),Ae(this,m,"f")!==f&&(Ze(this,m,f,"f"),Ae(this,C,"f").$setWebviewViewTitle(Ae(this,P,"f"),f))}get description(){return this.assertNotDisposed(),Ae(this,s,"f")}set description(f){this.assertNotDisposed(),Ae(this,s,"f")!==f&&(Ze(this,s,f,"f"),Ae(this,C,"f").$setWebviewViewDescription(Ae(this,P,"f"),f))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,T,"f")}_setVisible(f){f===Ae(this,n,"f")||Ae(this,_,"f")||(Ze(this,n,f,"f"),Ae(this,u,"f").fire())}show(f){this.assertNotDisposed(),Ae(this,C,"f").$show(Ae(this,P,"f"),!!f)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,C=new WeakMap,T=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,s=new WeakMap,u=new WeakMap,p=new WeakMap;class w{constructor(f,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,S,i,g){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:f}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(f),S,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(f,S,i,g,a){const r=this._viewProviders.get(S);if(!r)throw new Error(`No view provider found for '${S}'`);const{provider:v,extension:l}=r,c=this._extHostWebview.createNewWebview(f,{},l),b=new k(f,this._proxy,S,i,c,!0);this._webviewViews.set(f,b),await v.resolveWebviewView(b,{state:g},a)}async $onDidChangeWebviewViewVisibility(f,S){this.getWebviewView(f)._setVisible(S)}async $disposeWebviewView(f){const S=this.getWebviewView(f);this._webviewViews.delete(f),S.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const S=this._webviewViews.get(f);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=w}),define(we[97],be([0,1,3,5,2,11,9,4,13]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class $i{constructor(_){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let m;if(typeof _=="string"){m=_;try{_=E.URI.parse(_)}catch(s){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,F.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,n)}async asExternalUri(_,n){if((0,F.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,n);return E.URI.from(m)}};T.InitialState={focused:!0},T=Be([We(0,C.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(we[212],be([0,1,14,5,29,13]),function(re,e,d,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends d.AbstractLogger{constructor(C,T){super();this._proxy=C.getProxy(M.MainContext.MainThreadLog),this._logFile=T.logFile.toJSON(),this.setLevel(T.logLevel)}$setLevel(C){this.setLevel(C)}trace(C,...T){this.getLevel()<=d.LogLevel.Trace&&this._proxy.$log(this._logFile,d.LogLevel.Trace,Array.from(arguments))}debug(C,...T){this.getLevel()<=d.LogLevel.Debug&&this._proxy.$log(this._logFile,d.LogLevel.Debug,Array.from(arguments))}info(C,...T){this.getLevel()<=d.LogLevel.Info&&this._proxy.$log(this._logFile,d.LogLevel.Info,Array.from(arguments))}warn(C,...T){this.getLevel()<=d.LogLevel.Warning&&this._proxy.$log(this._logFile,d.LogLevel.Warning,Array.from(arguments))}error(C,...T){this.getLevel()<=d.LogLevel.Error&&this._proxy.$log(this._logFile,d.LogLevel.Error,Array.from(arguments))}critical(C,...T){this.getLevel()<=d.LogLevel.Critical&&this._proxy.$log(this._logFile,d.LogLevel.Critical,Array.from(arguments))}flush(){}};F=Be([We(0,A.IExtHostRpcService),We(1,E.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(we[213],be([0,1,12,22,21,16,3,6,108,180,38]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(y,R){try{return JSON.stringify(y,R)}catch(I){return"null"}}const m="$$ref$$",s={[m]:-1};class u{constructor(R,I){this.jsonString=R,this.referencedBuffers=I}}function p(y,R=null,I=!1){const U=[];return{jsonString:(I?n:JSON.stringify)(y,(D,x)=>{if(typeof x=="undefined")return s;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=U.push(x)-1;return{[m]:N}}if(R)return R(D,x)}return x}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=p;function k(y,R,I){return JSON.parse(y,(U,L)=>{if(L){const D=L[m];if(typeof D=="number")return R[D];if(I&&L.$mid===1)return I.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=k;function w(y,R){return JSON.stringify(y,R)}function o(y){return y?(R,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var f;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class r extends P.Disposable{constructor(R,I=null,U=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=I,this._uriTransformer=U,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,D=t.ProxyIdentifier.count;L<D;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:I,sid:U}=R;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,U)),this._proxies[I]}_createProxy(R,I){let U={get:(L,D)=>(typeof D=="string"&&!L[D]&&D.charCodeAt(0)===36&&(L[D]=(...x)=>this._remoteCall(R,D,x)),D===a?I:L[D])};return new Proxy(Object.create(null),U)}set(R,I){return this._locals[R.nid]=I,I}assertRegistered(R){for(let I=0,U=R.length;I<U;I++){const L=R[I];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const I=R.byteLength,U=v.read(R,0),L=U.readUInt8(),D=U.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:V}=c.deserializeRequestJSONArgs(U);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,D,x,N,V,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=c.deserializeRequestMixedArgs(U);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,D,x,N,V,L===4);break}case 5:{this._logger&&this._logger.logIncoming(I,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(I,D);break}case 7:{this._receiveReply(I,D,void 0);break}case 9:{let x=c.deserializeReplyOKJSON(U);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(I,D,x);break}case 10:{const x=c.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(I,D,x);break}case 8:{let x=c.deserializeReplyOKVSBuffer(U);this._receiveReply(I,D,x);break}case 11:{let x=c.deserializeReplyErrError(U);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(I,D,x);break}case 12:{this._receiveReplyErr(I,D,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,I,U,L,D,x){this._logger&&this._logger.logIncoming(R,I,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(U)}.${L}(`,D);const N=String(I);let V,W;if(x){const Z=new E.CancellationTokenSource;D.push(Z.token),V=this._invokeHandler(U,L,D),W=()=>Z.cancel()}else V=this._invokeHandler(U,L,D),W=i;this._cancelInvokedHandlers[N]=W;const $=c.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing($.byteLength,I,1,"ack"),this._protocol.send($),V.then(Z=>{delete this._cancelInvokedHandlers[N];const j=c.serializeReplyOK(I,Z,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"reply:",Z),this._protocol.send(j)},Z=>{delete this._cancelInvokedHandlers[N];const j=c.serializeReplyErr(I,Z);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"replyErr:",Z),this._protocol.send(j)})}_receiveCancel(R,I){this._logger&&this._logger.logIncoming(R,I,1,"receiveCancel");const U=String(I);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(R,I,U){this._logger&&this._logger.logIncoming(R,I,0,"receiveReply:",U);const L=String(I);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const D=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],D.resolveOk(U)}_receiveReplyErr(R,I,U){this._logger&&this._logger.logIncoming(R,I,0,"receiveReplyErr:",U);const L=String(I);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const D=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;U&&(U.$isError?(x=new Error,x.name=U.name,x.message=U.message,x.stack=U.stack):x=U),D.resolveErr(x)}_invokeHandler(R,I,U){try{return Promise.resolve(this._doInvokeHandler(R,I,U))}catch(L){return Promise.reject(L)}}_doInvokeHandler(R,I,U){const L=this._locals[R];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let D=L[I];if(typeof D!="function")throw new Error("Unknown method "+I+" on actor "+(0,t.getStringIdentifierForProxy)(R));return D.apply(L,U)}_remoteCall(R,I,U){if(this._isDisposed)return Promise.reject(A.canceled());let L=null;if(U.length>0&&E.CancellationToken.isCancellationToken(U[U.length-1])&&(L=U.pop()),L&&L.isCancellationRequested)return Promise.reject(A.canceled());const D=c.serializeRequestArguments(U,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new T.LazyPromise;L&&L.onCancellationRequested(()=>{const $=c.serializeCancel(x);this._logger&&this._logger.logOutgoing($.byteLength,x,0,"cancel"),this._protocol.send(c.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const W=c.serializeRequest(x,R,I,D,!!L);return this._logger&&this._logger.logOutgoing(W.byteLength,x,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${I}(`,U),this._protocol.send(W),V}}e.RPCProtocol=r,_=g,r.UNRESPONSIVE_TIME=3*1e3;class v{constructor(R,I){this._buff=R,this._offset=I}static alloc(R,I,U){let L=new v(M.VSBuffer.alloc(U+1+4),0);return L.writeUInt8(R),L.writeUInt32(I),L}static read(R,I){return new v(R,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,U}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,I}static sizeMixedArray(R){let I=0;I+=1;for(let U=0,L=R.length;U<L;U++){const D=R[U];switch(I+=1,D.type){case 1:I+=this.sizeLongString(D.value);break;case 2:I+=this.sizeVSBuffer(D.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(D.value);for(let x=0;x<D.buffers.length;++x)I+=this.sizeVSBuffer(D.buffers[x]);break;case 4:break}}return I}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let I=0,U=R.length;I<U;I++){const L=R[I];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let D=0;D<L.buffers.length;++D)this.writeBuffer(L.buffers[D]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(R);for(let U=0;U<R;U++)switch(this.readUInt8()){case 1:I[U]=this.readLongString();break;case 2:I[U]=this.readVSBuffer();break;case 3:const D=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<D;++V)N.push(this.readVSBuffer());I[U]=new t.SerializableObjectWithBuffers(k(x,N,null));break;case 4:I[U]=void 0;break}return I}}v.sizeUInt32=4;var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class c{static _useMixedArgSerialization(R){for(let I=0,U=R.length;I<U;I++)if(R[I]instanceof M.VSBuffer||R[I]instanceof t.SerializableObjectWithBuffers||typeof R[I]=="undefined")return!0;return!1}static serializeRequestArguments(R,I){if(this._useMixedArgSerialization(R)){const U=[];for(let L=0,D=R.length;L<D;L++){const x=R[L];if(x instanceof M.VSBuffer)U[L]={type:2,value:x};else if(typeof x=="undefined")U[L]={type:4};else if(x instanceof t.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(x.value,I);U[L]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else U[L]={type:1,value:M.VSBuffer.fromString(w(x,I))}}return{type:1,args:U}}return{type:0,args:w(R,I)}}static serializeRequest(R,I,U,L,D){switch(L.type){case 0:return this._requestJSONArgs(R,I,U,L.args,D);case 1:return this._requestMixedArgs(R,I,U,L.args,D)}}static _requestJSONArgs(R,I,U,L,D){const x=M.VSBuffer.fromString(U),N=M.VSBuffer.fromString(L);let V=0;V+=v.sizeUInt8(),V+=v.sizeShortString(x),V+=v.sizeLongString(N);let W=v.alloc(D?2:1,R,V);return W.writeUInt8(I),W.writeShortString(x),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(R){const I=R.readUInt8(),U=R.readShortString(),L=R.readLongString();return{rpcId:I,method:U,args:JSON.parse(L)}}static _requestMixedArgs(R,I,U,L,D){const x=M.VSBuffer.fromString(U);let N=0;N+=v.sizeUInt8(),N+=v.sizeShortString(x),N+=v.sizeMixedArray(L);let V=v.alloc(D?4:3,R,N);return V.writeUInt8(I),V.writeShortString(x),V.writeMixedArray(L),V.buffer}static deserializeRequestMixedArgs(R){const I=R.readUInt8(),U=R.readShortString(),L=R.readMixedArray(),D=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const V=L[x];typeof V=="string"?D[x]=JSON.parse(V):D[x]=V}return{rpcId:I,method:U,args:D}}static serializeAcknowledged(R){return v.alloc(5,R,0).buffer}static serializeCancel(R){return v.alloc(6,R,0).buffer}static serializeReplyOK(R,I,U){if(typeof I=="undefined")return this._serializeReplyOKEmpty(R);if(I instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,I);if(I instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:D}=p(I.value,U,!0);return this._serializeReplyOKJSONWithBuffers(R,L,D)}else return this._serializeReplyOKJSON(R,n(I,U))}static _serializeReplyOKEmpty(R){return v.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,I){let U=0;U+=v.sizeVSBuffer(I);let L=v.alloc(8,R,U);return L.writeVSBuffer(I),L.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,I){const U=M.VSBuffer.fromString(I);let L=0;L+=v.sizeLongString(U);let D=v.alloc(9,R,L);return D.writeLongString(U),D.buffer}static _serializeReplyOKJSONWithBuffers(R,I,U){const L=M.VSBuffer.fromString(I);let D=0;D+=v.sizeUInt32,D+=v.sizeLongString(L);for(const N of U)D+=v.sizeVSBuffer(N);let x=v.alloc(10,R,D);x.writeUInt32(U.length),x.writeLongString(L);for(const N of U)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(R){const I=R.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(R,I){const U=R.readUInt32(),L=R.readLongString(),D=[];for(let x=0;x<U;++x)D.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(k(L,D,I))}static serializeReplyErr(R,I){return I?this._serializeReplyErrEror(R,I):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,I){const U=M.VSBuffer.fromString(n(A.transformErrorForSerialization(I),null));let L=0;L+=v.sizeLongString(U);let D=v.alloc(11,R,L);return D.writeLongString(U),D.buffer}static deserializeReplyErrError(R){const I=R.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(R){return v.alloc(12,R,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(we[214],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const d=function(A){const F=P=>{self.removeEventListener("message",F);const C=P.data;Object.defineProperties(self,{postMessage:{value(T,t){C.postMessage(T,t)}},onmessage:{get(){return C.onmessage},set(T){C.onmessage=T}}}),C.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(A,F,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${d})('${F}'))`,T=new Blob([C],{type:"application/javascript"}),t=URL.createObjectURL(T),_=new MessageChannel,n=t,m={type:"_newWorker",id:n,port:_.port2,url:t,options:P};A(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};_.port1.postMessage(s),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(s){_.port1.onmessage=s}},onmessageerror:{get(){return _.port1.onmessageerror},set(s){_.port1.onmessageerror=s}}}),_.port1.addEventListener("messageerror",s=>{const u=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(u)}),_.port1.addEventListener("message",s=>{const u=new MessageEvent("message",{data:s.data});this.dispatchEvent(u)}),_.port1.start()}}e.NestedWorker=M}),define(we[215],be([0,1,4]),function(re,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(we[216],be([0,1,11,17,25,2,4,63,49,176,215]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let _=class Wi{constructor(m,s,u,p){this.localUserHome=m,this.remoteAgentService=s,this.environmentService=u,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,s){if(m.remoteAuthority)return d.Schemas.vscodeRemote;const u=(0,P.getVirtualWorkspaceScheme)(s.getWorkspace());if(u)return u;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const k=s.getWorkspace().configuration;return k?k.scheme:d.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let s="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(s=m.substring(2),m="/"):(s=m.substring(2,p),m=m.substring(p)||"/")}return A.URI.from({scheme:d.Schemas.file,authority:s,path:m,query:"",fragment:""})}};_=Be([We(1,t.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[98],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(F,P){this.line=F,this.character=P}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,P){return new d(0,0)}with(F){return new d(0,0)}}e.Position=d;class M{constructor(F,P,C,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(F,P),this.end=new d(C,T)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],be([0,1,15,27,23,43,9,4,17,16,98,10]),function(re,e,d,M,E,A,F,P,C,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",s=(n.length+m.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function($){$[$.file=0]="file",$[$.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var p;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function k($){return!!$.preview}e.resultIsMatch=k;function w($){return!!$.resource}e.isFileMatch=w;function o($){return!!$.message}e.isProgressMessage=o;var f;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=S;class i{constructor(Z,j,Q){this.ranges=j;const ae=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&g(ae)){Z=(0,F.getNLines)(Z,Q.matchLines);let pe="",ce=0,Fe=0;const Ge=Math.floor(Q.charsPerLine/5),Ne=[];for(const ze of ae){const Je=Math.max(ze.startColumn-Ge,0),Qe=ze.startColumn+Q.charsPerLine;if(Je>Fe+Ge+s){const Ke=n+(Je-Fe)+m;pe+=Ke+Z.slice(Je,Qe),ce+=Je-(Fe+Ke.length)}else pe+=Z.slice(Fe,Qe);Ne.push(new r(0,ze.startColumn-ce,ze.endColumn-ce)),Fe=Qe}this.preview={text:pe,matches:Array.isArray(this.ranges)?Ne:Ne[0]}}else{const pe=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:Z,matches:(0,d.mapArrayOrNot)(j,ce=>new a(ce.startLineNumber-pe,ce.startColumn,ce.endLineNumber-pe,ce.endColumn))}}}}e.TextSearchMatch=i;function g($){const Z=$[0].startLineNumber;for(const j of $)if(j.startLineNumber!==Z||j.endLineNumber!==Z)return!1;return!0}class a{constructor(Z,j,Q,ae){this.startLineNumber=Z,this.startColumn=j,this.endLineNumber=Q,this.endColumn=ae}}e.SearchRange=a;class r extends a{constructor(Z,j,Q){super(Z,j,Z,Q)}}e.OneLineRange=r;var v;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function l($,Z=!0){const j=$&&$.files&&$.files.exclude,Q=Z&&$&&$.search&&$.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let ae=Object.create(null);return ae=E.mixin(ae,E.deepClone(j)),ae=E.mixin(ae,E.deepClone(Q),!0),ae}e.getExcludes=l;function c($,Z){return $.excludePattern&&M.match($.excludePattern,Z)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&M.match($.includePattern,Z)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(j=>{const Q=j.folder.fsPath;if(A.isEqualOrParent(Z,Q)){const ae=C.relative(Q,Z);return!j.includePattern||!!M.match(j.includePattern,ae)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var b;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(Z,j){super(Z);this.code=j}}e.SearchError=h;function y($){const Z=$.message;if((0,T.isPromiseCanceledError)($))return new h(Z,b.canceled);try{const j=JSON.parse(Z);return new h(j.message,j.code)}catch(j){return new h(Z,b.other)}}e.deserializeSearchError=y;function R($){const Z={message:$.message,code:$.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=R;function I($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=I;function U($){return $.type==="success"}e.isSerializedSearchSuccess=U;function L($){return!!$.path}e.isSerializedFileMatch=L;function D($,Z){const j=$.searchPath?$.searchPath:$.relativePath;return(0,F.fuzzyContains)(j,Z)}e.isFilePatternMatch=D;class x{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N($,Z){const j={...$||{},...Z||{}};return Object.keys(j).filter(Q=>{const ae=j[Q];return typeof ae=="boolean"&&ae})}e.resolvePatternsForProvider=N;class V{constructor(Z,j){this._parsedIncludeExpression=null,this._excludeExpression={...Z.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=Z.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(Z,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,j,Q))}includedInQuerySync(Z,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Z,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Z,j,Q))}includedInQuery(Z,j,Q){const ae=this._parsedExcludeExpression(Z,j,Q),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Z,j,Q):!0;return(0,_.isPromise)(ae)?ae.then(ce=>ce?!1:pe()):pe()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W($){for(const Z in $)if(typeof $[Z]!="boolean")return!0;return!1}}),define(we[31],be([0,1,15,12,21,3,20,11,76,24,9,10,2,129,4,14,143,49,37,29,13,7,41,5]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o,f,S,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,I,U){return new T.ExtUri(L=>c(L,U)).isEqual(R,I)}function r(R,I,U){return a(R.uri,I.uri,U)?0:(0,t.compare)(R.uri.toString(),I.uri.toString())}function v(R,I,U){return R.index!==I.index?R.index<I.index?-1:1:a(R.uri,I.uri,U)?(0,t.compare)(R.name,I.name):(0,t.compare)(R.uri.toString(),I.uri.toString())}function l(R,I,U,L){const D=R.slice(0).sort((N,V)=>U(N,V,L)),x=I.slice(0).sort((N,V)=>U(N,V,L));return(0,d.delta)(D,x,(N,V)=>U(N,V,L))}function c(R,I){const U=I.getCapabilities(R.scheme);return!(U&&U&1024)}class b extends k.Workspace{constructor(I,U,L,D,x,N,V){super(I,L.map(W=>new k.WorkspaceFolder(W)),D,x,V);this._name=U,this._isUntitled=N,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(V),L.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(I,U,L,D){if(!I)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:W,transient:$,isUntitled:Z}=I,j=[],Q=U;U?V.forEach((Fe,Ge)=>{const Ne=n.URI.revive(Fe.uri),ze=b._findFolder(L||U,Ne,D);ze?(ze.name=Fe.name,ze.index=Fe.index,j.push(ze)):j.push({uri:Ne,name:Fe.name,index:Ge})}):j.push(...V.map(({uri:Fe,name:Ge,index:Ne})=>({uri:n.URI.revive(Fe),name:Ge,index:Ne}))),j.sort((Fe,Ge)=>Fe.index<Ge.index?-1:1);const ae=new b(x,N,j,!!$,W?n.URI.revive(W):null,!!Z,Fe=>c(Fe,D)),{added:pe,removed:ce}=l(Q?Q.workspaceFolders:[],ae.workspaceFolders,r,D);return{workspace:ae,added:pe,removed:ce}}static _findFolder(I,U,L){for(let D=0;D<I.folders.length;D++){const x=I.workspaceFolders[D];if(a(x.uri,U,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,U){return U&&this._structure.get(I)&&(I=(0,T.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let h=class{constructor(I,U,L,D){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=D,this._extHostFileSystemInfo=L,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=I.getProxy(g.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(g.MainContext.MainThreadMessageService);const x=U.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>c(N,L)):void 0}$initializeWorkspace(I,U){this._trusted=U,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,U,L,...D){const x=[];if(Array.isArray(D)&&D.forEach(Z=>{n.URI.isUri(Z.uri)&&!x.some(j=>a(j.uri,Z.uri,this._extHostFileSystemInfo))&&x.push({uri:Z.uri,name:Z.name||(0,T.basenameOrAuthority)(Z.uri)})}),this._unconfirmedWorkspace||[U,L].some(Z=>typeof Z!="number"||Z<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+L>N.length)return!1;const V=N.slice(0);V.splice(U,L,...x.map(Z=>({uri:Z.uri,name:Z.name||(0,T.basenameOrAuthority)(Z.uri),index:void 0})));for(let Z=0;Z<V.length;Z++){const j=V[Z];if(V.some((Q,ae)=>ae!==Z&&a(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((Z,j)=>Z.index=j);const{added:W,removed:$}=l(N,V,v,this._extHostFileSystemInfo);if(W.length===0&&$.length===0)return!1;if(this._proxy){const Z=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(Z,U,L,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,Z,j.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(I,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,U)}async getWorkspaceFolder2(I,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,U)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,U){let L,D="";if(typeof I=="string"?(L=n.URI.file(I),D=I):typeof I!="undefined"&&(L=I,D=I.fsPath),!L)return D;const x=this.getWorkspaceFolder(L,!0);if(!x)return D;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let N=(0,T.relativePath)(x.uri,L);return U&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:U,added:L,removed:D}=b.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:D}))}findFiles(I,U,L,D,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${D.value}, entryPoint: findFiles`);let N;if(U===null?N=!1:U&&(typeof U=="string"?N=U:N=U.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:W}=y(I);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then($=>Array.isArray($)?$.map(Z=>n.URI.revive(Z)):[])}async findTextInFiles(I,U,L,D,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${D.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:W,folder:$}=y(U.include),Z=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,j={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:V,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:W,excludePattern:Z},Q=!1;if(this._activeSearchCallbacks[N]=ae=>{if(Q)return;const pe=n.URI.revive(ae.resource);ae.results.forEach(ce=>{(0,i.resultIsMatch)(ce)?L({uri:pe,preview:{text:ce.preview.text,matches:(0,d.mapArrayOrNot)(ce.preview.matches,Fe=>new S.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,d.mapArrayOrNot)(ce.ranges,Fe=>new S.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):L({uri:pe,text:ce.text,lineNumber:ce.lineNumber})})},x.isCancellationRequested)return{};try{const ae=await this._proxy.$startTextSearch(I,(0,_.withUndefinedAsNull)($),j,N,x);return delete this._activeSearchCallbacks[N],ae||{}}catch(ae){throw delete this._activeSearchCallbacks[N],ae}}$handleTextSearchResult(I,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=Be([We(0,f.IExtHostRpcService),We(1,o.IExtHostInitDataService),We(2,w.IExtHostFileSystemInfo),We(3,u.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function y(R){let I,U;return R&&(typeof R=="string"?I=R:(I=R.pattern,U=R.baseFolder||n.URI.file(R.base))),{includePattern:I,folder:U}}}),define(we[32],be([0,1,23,3,31,5,7,146,62,10,12,4,13,14,2]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(g,a){if(a){const r=a.split(".");let v=g;for(let l=0;v&&l<r.length;l++)v=v[r[l]];return v}}function p(g){return g instanceof s.URI}function k(g){return g&&g.uri instanceof s.URI&&g.languageId&&typeof g.languageId=="string"}function w(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function o(g){return g&&g.uri instanceof s.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function f(g){if(p(g))return{resource:g};if(k(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(w(g))return{overrideIdentifier:g.languageId};if(o(g))return{resource:g.uri};if(g===null)return{resource:null}}let S=class{constructor(a,r,v){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=v,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,r))}};S=Be([We(0,n.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,m.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(a,r,v,l){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,v))}getConfiguration(a,r,v){const l=f(r)||{},c=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,v?.identifier);function b(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(y){return typeof u(c,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(a?`${a}.${y}`:y,l,v?.identifier);let I=u(c,y);if(typeof I=="undefined")I=R;else{let U;const L=(D,x)=>{let N;const V=()=>{U=U||(0,d.deepClone)(c),N=N||u(U,x)};return(0,T.isObject)(D)?new Proxy(D,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return V(),()=>N;if(U)return N=N||u(U,x),N[$];const Z=W[$];return typeof $=="string"?L(Z,`${x}.${$}`):Z},set:(W,$,Z)=>(V(),N&&(N[$]=Z),!0),deleteProperty:(W,$)=>(V(),N&&delete N[$],!0),defineProperty:(W,$,Z)=>(V(),N&&Object.defineProperty(N,$,Z),!0)}):D};I=L(I,y)}return I},update:(y,R,I,U)=>{y=a?`${a}.${y}`:y;const L=b(I);return R!==void 0?this._proxy.$updateConfigurationOption(L,y,R,l,U):this._proxy.$removeConfigurationOption(L,y,l,U)},inspect:y=>{y=a?`${a}.${y}`:y;const R=(0,d.deepClone)(this._configuration.inspect(y,l,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,d.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(a){const r=v=>(0,T.isObject)(v)?new Proxy(v,{get:(l,c)=>r(l[c]),set:(l,c,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(l,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(l,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return r(a)}_validateConfigurationAccess(a,r,v){const l=C.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),c=v?`[${v.value}] `:"";if(l===4){typeof r?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const v=new P.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,c)=>v.affectsConfiguration(l,f(c))})}_toMap(a){return a.reduce((r,v)=>(r.set(v[0],v[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[99],be([0,1,2,12,3,5,7,31,51,32,21,40,13,29,4,11,25,14,70,166,16]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o,f){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var g;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(g=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(x){function N($){if($){const Z=$;return Z&&!!Z.process}else return!1}x.is=N;function V($){if($==null)return;const Z={process:$.process,args:$.args};return $.options&&(Z.options=a.from($.options)),Z}x.from=V;function W($){if($!=null)return new F.ProcessExecution($.process,$.args,$.options)}x.to=W})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(x){function N($){if($){const Z=$;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}x.is=N;function V($){if($==null)return;const Z={};return $.commandLine!==void 0?Z.commandLine=$.commandLine:(Z.command=$.command,Z.args=$.args),$.options&&(Z.options=v.from($.options)),Z}x.from=V;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new F.ShellExecution($.commandLine,$.options):new F.ShellExecution($.command,$.args?$.args:[],$.options)}x.to=W})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(x){function N($){if($){let Z=$;return Z&&Z.customExecution==="customExecution"}else return!1}x.is=N;function V($){return{customExecution:"customExecution"}}x.from=V;function W($,Z){return Z.get($)}x.to=W})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(V,W){let $;return V.scope!==void 0&&typeof V.scope!="number"?$=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===F.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=o.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:$}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(x){function N($,Z){if($==null)return[];const j=[];for(let Q of $){const ae=V(Q,Z);ae&&j.push(ae)}return j}x.fromMany=N;function V($,Z){if($==null)return;let j;$.execution instanceof F.ProcessExecution?j=r.from($.execution):$.execution instanceof F.ShellExecution?j=l.from($.execution):$.execution&&$.execution instanceof F.CustomExecution&&(j=c.from($.execution));const Q=i.from($.definition);let ae;return $.scope?typeof $.scope=="number"?ae=$.scope:ae=$.scope.uri:ae=F.TaskScope.Workspace,!Q||!ae?void 0:{_id:$._id,definition:Q,name:$.name,source:{extensionId:Z.identifier.value,label:$.source,scope:ae},execution:j,isBackground:$.isBackground,group:h.from($.group),presentationOptions:g.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}x.from=V;async function W($,Z,j){if($==null)return;let Q;r.is($.execution)?Q=r.to($.execution):l.is($.execution)?Q=l.to($.execution):c.is($.execution)&&(Q=c.to($._id,j));const ae=i.to($.definition);let pe;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?pe=$.source.scope:pe=await Z.resolveWorkspaceFolder(d.URI.revive($.source.scope)):pe=F.TaskScope.Workspace),!ae||!pe)return;const ce=new F.Task(ae,pe,$.name,$.source.label,Q,$.problemMatchers);return $.isBackground!==void 0&&(ce.isBackground=$.isBackground),$.group!==void 0&&(ce.group=F.TaskGroup.from($.group._id),ce.group&&$.group.isDefault&&(ce.group=new F.TaskGroup(ce.group.id,ce.group.label),$.group.isDefault&&(ce.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ce.presentationOptions=g.to($.presentationOptions)),$._id&&(ce._id=$._id),$.detail&&(ce.detail=$.detail),ce}x.to=W})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(x){function N(W){return W}x.from=N;function V(W){if(!!W)return Object.assign(Object.create(null),W)}x.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(N,V,W){this._id=V,this._task=W,S.set(this,void 0),Ze(this,S,N,"f")}get task(){return this._task}terminate(){Ae(this,S,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}S=new WeakMap;var U;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,V,W,$,Z,j,Q,ae){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=N.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=Z,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=ae,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,W){if(!W)return new F.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:V,provider:W,extension:N}),this._proxy.$registerTaskProvider($,V),new F.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async V=>{const W=[];for(let $ of V){const Z=await y.to($,this._workspaceProvider,this._providedCustomExecutions2);Z&&W.push(Z)}return W})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,W){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(V,await $.callback(W))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));const $=[],Z=(0,M.asPromise)(()=>W.provider.provideTasks(t.CancellationToken.None)).then(j=>this.provideTasksInternal(V,$,W,j));return new Promise(j=>{Z.then(Q=>{Promise.all($).then(()=>{j(Q)})})})}async $resolveTask(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await y.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const Z=await W.provider.resolveTask($,t.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,W);const j=y.from(Z,W.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(j.execution)&&await this.addCustomExecution(j,Z,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,W){const $=await this._proxy.$createTaskId(N);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,V.execution)),this._providedCustomExecutions2.set($,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const Z=this._taskExecutionPromises.get(N);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}let W=this._taskExecutionPromises.get(N.id);if(W)return W;const $=new Promise((Z,j)=>{function Q(ae,pe,ce){ce?Z(new I(ae,pe.id,ce)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(ae=>Q(this,N,ae))});return this._taskExecutionPromises.set(N.id,$),$.then(Z=>(this._taskExecutions.set(N.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let W=this._notProvidedCustomExecutions.values(),$=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};L=Be([We(0,n.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,_.IExtHostTerminalService),We(6,k.ILogService),We(7,w.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let D=class extends L{constructor(N,V,W,$,Z,j,Q,ae){super(N,V,W,$,Z,j,Q,ae);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=y.from(V,N);if(W===void 0)throw new Error("Task is not valid");if(c.is(W.execution))await this.addCustomExecution(W,V,!1);else throw new f.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),V);return this._proxy.$executeTask(W).catch(Z=>{throw new Error(Z)}),$}provideTasksInternal(N,V,W,$){const Z=[];if($)for(let j of $){this.checkDeprecation(j,W),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=y.from(j,W.extension);Q&&c.is(Q.execution)?(Z.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:W.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,W){}};D=Be([We(0,n.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,_.IExtHostTerminalService),We(6,k.ILogService),We(7,w.IExtHostApiDeprecationService)],D),e.WorkerExtHostTask=D,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(we[217],be([0,1,15,53,27,78,20,11,17,24,9,10,2,110,133,85,49,92,216,41]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(b,h,y,R){this.configurationService=b,this.workspaceContextService=h,this.editorGroupsService=y,this.pathService=R}text(b,h,y={}){b=this.getContentPattern(b,y);const R=this.configurationService.getValue(),I=h&&h.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(h?.map(p.toWorkspaceFolder),y),type:2,contentPattern:b,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||I||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(b,h){const y=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(b,h)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,h={}){return{...this.commonQuery(b,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(b,h){return b?(b=Array.isArray(b)?b.map(r):r(b),h?this.parseSearchPaths(b):{pattern:i(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],h={}){const y=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),I=b.length>1,U=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,h,R)):b.map(x=>this.getFolderQueryForRoot(x,h,R,I))).filter(x=>!!x),L={_reason:h._reason,folderQueries:U,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=d.coalesce(d.flatten(this.editorGroupsService.groups.map(W=>W.editors.map($=>$.resource)))).filter(W=>(0,o.pathIncludedInQuery)(L,W.fsPath)),V=this.commonQueryFromFileList(N);return{...L,...V}}const D=h.extraFileResources&&h.extraFileResources.filter(x=>(0,o.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=D&&D.length?D:void 0,L}commonQueryFromFileList(b){const h=[],y=new F.ResourceMap,R={};let I=!1;return b.forEach(U=>{if(U.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(U)){const D=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:C.dirname(U.fsPath)});let x=y.get(D);x||(I=!0,x={folder:D,includePattern:{}},h.push(x),y.set(D,x));const N=C.relative(D.fsPath,U.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else U.fsPath&&(I=!0,R[U.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(b,h){if(h.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const h=V=>C.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),R=(Array.isArray(b)?b:g(b)).map(V=>{const W=this.pathService.resolvedUserHome;return W?(0,A.untildify)(V,W.scheme===P.Schemas.file?W.fsPath:W.path):V}),I=M.groupBy(R,V=>h(V)?"searchPaths":"exprSegments"),U=(I.exprSegments||[]).map(V=>t.rtrim(V,"/")).map(V=>t.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),a(V))),L={},D=this.expandSearchPathPatterns(I.searchPaths||[]);D&&D.length&&(L.searchPaths=D);const x=d.flatten(U),N=i(...x);return N&&(L.pattern=N),L}getExcludesForFolder(b,h){return h.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const h=d.flatten(b.map(R=>{let{pathPortion:I,globPortion:U}=S(R);U&&(U=v(U));const L=this.expandOneSearchPath(I);return d.flatten(L.map(D=>this.resolveOneSearchPathPattern(D,U)))})),y=new Map;return h.forEach(R=>{const I=R.searchPath.toString(),U=y.get(I);U?R.pattern&&(U.pattern=U.pattern||{},U.pattern[R.pattern]=!0):y.set(I,{searchPath:R.searchPath,pattern:R.pattern?i(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==P.Schemas.file?[{searchPath:h[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=r(b),b.startsWith("../")||b===".."){const R=C.posix.resolve(h.path,b);return[{searchPath:h.with({path:R})}]}const y=v(b);return[{searchPath:h,pattern:y}]}else{if(b==="./"||b===".\\")return[];{const h=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(I=>{const U=h.match(new RegExp(`^${t.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return U?{match:U,folder:I}:null}).filter(_.isDefined);if(R.length)return R.map(I=>{const U=I.match[1];return{searchPath:I.folder.uri,pattern:U&&v(U)}});{const I=b.match(/\.[\/\\](.+)[\/\\]?/),U=I?I[1]:b,L=s.localize(0,null,U);throw new Error(L)}}}}resolveOneSearchPathPattern(b,h){const y=b.pattern&&h?`${b.pattern}/${h}`:b.pattern||h,R=[{searchPath:b.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(b,h,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),h,y,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,h,y,R){let I;const U=n.URI.isUri(b)?b:b.uri;if(y.searchPaths){const V=y.searchPaths.filter(W=>(0,T.isEqual)(W.searchPath,U))[0];if(V&&!V.pattern)return null;V&&(I=V.pattern)}const L=this.configurationService.getValue({resource:U}),x={...this.getExcludesForFolder(L,h)||{},...I||{}},N=n.URI.isUri(b)?(0,T.basename)(b):b.name;return{folder:U,folderName:R?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!L.search.followSymlinks}}};f=Be([We(0,u.IConfigurationService),We(1,p.IWorkspaceContextService),We(2,k.IEditorGroupsService),We(3,w.IPathService)],f),e.QueryBuilder=f;function S(c){const b=c.match(/[\*\{\}\(\)\[\]\?]/);if(b){const h=b.index,y=c.substr(0,h).match(/[/|\\][^/\\]*$/);if(y){let R=c.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:c.substr((y.index||0)+1)}}}return{pathPortion:c}}function i(...c){return c.length?c.reduce((b,h)=>(b[h]=!0,b),Object.create(null)):void 0}function g(c){return E.splitGlobAware(c,",").map(b=>b.trim()).filter(b=>!!b.length)}function a(c){return[`**/${c}/**`,`**/${c}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function r(c){return c.replace(/\\/g,"/")}function v(c){return r(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(c,b){c=d.distinct(c,R=>R.toString());const h=[],y=b.getWorkspace();return c&&c.forEach(R=>{let I;if(b.getWorkbenchState()===2)I=(0,T.relativePath)(y.folders[0].uri,R),I&&I!=="."&&(I="./"+I);else{const U=b.getWorkspaceFolder(R);if(U){const L=U.name;if(y.folders.filter(x=>x.name===L).length===1){const x=(0,T.relativePath)(U.uri,R);x===""?I=`./${U.name}`:I=`./${U.name}/${x}`}else I=R.fsPath}}I&&h.push(I)}),h}e.resolveResourcesForSearchIncludes=l}),define(we[218],be([0,1,24,2,21,16,4,217,41,49]),function(re,e,d,M,E,A,F,P,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(u,p){const k=p.activationEvents;if(!k)return Promise.resolve(void 0);const w=[],o=[];for(const r of k)if(/^workspaceContains:/.test(r)){const v=r.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||u.forceUsingSearch?o.push(v):w.push(v)}if(w.length===0&&o.length===0)return Promise.resolve(void 0);let f;const S=new Promise((r,v)=>{f=r}),i=r=>f({activationEvent:r}),g=Promise.all(w.map(r=>n(u,r,i))).then(()=>{}),a=m(u,p.identifier,o,i);return Promise.all([g,a]).then(()=>{f(void 0)}),S}e.checkActivateWorkspaceContainsExtension=_;async function n(u,p,k){for(const w of u.folders)if(await u.exists(d.joinPath(M.URI.revive(w),p))){k(`workspaceContains:${p}`);return}}async function m(u,p,k,w){if(k.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,f=u.checkExists(u.folders,k,o.token),S=setTimeout(async()=>{o.cancel(),w(`workspaceContainsTimeout:${k.join(",")}`)},t);let i=!1;try{i=await f}catch(g){A.isPromiseCanceledError(g)||A.onUnexpectedError(g)}o.dispose(),clearTimeout(S),i&&w(`workspaceContains:${k.join(",")}`)}function s(u,p,k,w){const o=u.get(F.IInstantiationService),f=u.get(C.ISearchService),i=o.createInstance(P.QueryBuilder).file(p.map(g=>(0,T.toWorkspaceFolder)(M.URI.revive(g))),{_reason:"checkExists",includePattern:k,exists:!0});return f.fileSearch(i,w).then(g=>!!g.limitHit,g=>A.isPromiseCanceledError(g)?!1:Promise.reject(g))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(re,e,d,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,d):E?E.value=d:e.set(re,d),d},Ae=this&&this.__classPrivateFieldGet||function(re,e,d,M){if(d==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?M:d==="a"?M.call(re):M?M.value:e.get(re)};define(we[33],be([0,1,124,17,75,24,12,6,20,2,14,5,32,179,73,31,30,177,16,26,22,152,7,86,4,29,74,13,61,65,40,3,218,69,154,11]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R,I,U,L){"use strict";var D,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let V=class Hi extends P.Disposable{constructor(j,Q,ae,pe,ce,Fe,Ge,Ne,ze,Je){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=ae,this._initData=Ge,this._extHostWorkspace=pe,this._extHostConfiguration=ce,this._logService=Fe,this._extHostTunnelService=ze,this._extHostTerminalService=Je,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Ne,this._instaService=j.createChild(new c.ServiceCollection([s.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(Ke=>Qe.add(o.ExtensionIdentifier.toKey(Ke))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ke,H,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ke,w.transformErrorForSerialization(H),K)},actualActivateExtension:async(Ke,H)=>{if(Qe.has(o.ExtensionIdentifier.toKey(Ke)))return await this._mainThreadExtensionsProxy.$activateExtension(Ke,H),new m.HostExtension;const K=this._registry.getExtensionDescription(Ke);return this._activateExtension(K,H)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){w.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this._deactivate(ce))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const ae=this._activator.getActivatedExtension(j);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==L.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return T.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=C.TernarySearchTree.forUris(Q=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const ae=await this._realPathExtensionUri(Q.extensionLocation);j.set(ae,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const ae=this._activator.getActivatedExtension(j);if(!ae)return Q;try{typeof ae.module.deactivate=="function"&&(Q=Promise.resolve(ae.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(pe)}try{(0,P.dispose)(ae.subscriptions)}catch(pe){this._logService.error(pe)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(ae=>{const pe=ae.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",pe),ae},ae=>{throw this._logExtensionActivationTimes(j,Q,"failure"),ae})}_logExtensionActivationTimes(j,Q,ae,pe){const ce=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ce,...pe||{},outcome:ae})}_doActivateExtension(j,Q){const ae=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ae);const pe=this._getEntryPoint(j);if(!pe)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const ce=new m.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,A.joinPath)(j.extensionLocation,pe),ce),this._loadExtensionContext(j)]).then(Fe=>(E.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),Hi._callActivate(this._logService,j.identifier,Fe[0],Fe[1],ce))).then(Fe=>(E.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new S.ExtensionGlobalMemento(j,this._storage),ae=new S.ExtensionMemento(j.identifier.value,!1,this._storage),pe=new U.ExtensionSecrets(j,this._secretState),ce=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Fe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,ae.whenReady,this._storagePath.whenReady]).then(()=>{const Ge=this;let Ne;return Object.freeze({globalState:Q,workspaceState:ae,secrets:pe,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(ze){return M.join(j.extensionLocation.fsPath,ze)},get storagePath(){return Ge._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ge._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ge._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return T.URI.joinPath(Ge._initData.logsLocation,j.identifier.value)},get storageUri(){return Ge._storagePath.workspaceValue(j)},get globalStorageUri(){return Ge._storagePath.globalValue(j)},get extensionMode(){return ce},get extension(){return Ne===void 0&&(Ne=new $(Ge,j.identifier,j,Fe)),Ne},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j),Ge.extensionRuntime},get environmentVariableCollection(){return Ge._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,ae,pe,ce){return ae=ae||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,ae,pe,ce).then(Fe=>new m.ActivatedExtension(!1,null,ce.build(),ae,Fe,pe.subscriptions))}static _callActivateOptional(j,Q,ae,pe,ce){if(typeof ae.activate=="function")try{ce.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Ge=ae.activate.apply(Fe,[pe]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(Ge).then(Ne=>(ce.activateResolveStop(),Ne))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ae)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,ae=>{this._logService.error(ae)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ae=this._handleWorkspaceContainsEagerExtensions(Q),pe=Promise.all([j,ae]).then(()=>{});return Promise.race([pe,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const ae=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={folders:j.map(Fe=>Fe.uri),forceUsingSearch:ae,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ge,Ne)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ge,Ne)},ce=await(0,R.checkActivateWorkspaceContainsExtension)(pe,Q);if(!!ce)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ce.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(d.localize(0,null));const ae=await this._loadCommonJSModule(null,Q,new m.ExtensionActivationTimesBuilder(!1));if(!ae||typeof ae.run!="function")throw new Error(d.localize(1,null,Q.toString()));return new Promise((pe,ce)=>{const Fe=(ze,Je)=>{ze?ce(ze):pe(typeof Je=="number"&&Je>0?1:0)},Ge=(0,A.originalFSPath)(Q),Ne=ae.run(Ge,Fe);Ne&&Ne.then&&Ne.then(()=>{pe(0)}).catch(ze=>{ce(ze.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,P.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const ae=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this._resolvers[ae]}}async $resolveAuthority(j,Q){const{authorityPrefix:ae,resolver:pe}=await this._activateAndGetResolver(j);if(!pe)return{type:"error",error:{code:g.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ae}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe)),E.mark(`code/extHost/willResolveAuthority/${ae}`);const ce=await pe.resolve(j,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${ae}`);const Fe={authority:j,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},Ge={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted};return{type:"ok",value:{authority:Fe,options:Ge,tunnelInformation:{environmentTunnels:ce.environmentTunnels}}}}catch(ce){if(E.mark(`code/extHost/didResolveAuthorityError/${ae}`),ce instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(j,Q){const{authorityPrefix:ae,resolver:pe}=await this._activateAndGetResolver(j);if(!pe)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ae}`);const ce=T.URI.revive(Q);if(typeof pe.getCanonicalURI=="undefined")return ce;const Fe=await(0,F.asPromise)(()=>pe.getCanonicalURI(ce));return Fe||ce}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(ae=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(pe=>pe.extensionLocation=T.URI.revive(pe.extensionLocation));const ae=await this.getExtensionPathIndex();return await Promise.all(Q.map(async pe=>{const ce=this._registry.getExtensionDescription(pe);ce&&ae.delete(await this._realPathExtensionUri(ce.extensionLocation))})),await Promise.all(j.map(async pe=>{const ce=await this._realPathExtensionUri(pe.extensionLocation);ae.set(ce,pe)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=f.VSBuffer.alloc(j),ae=Math.random()%256;for(let pe=0;pe<j;pe++)Q.writeUInt8(ae,pe);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Be([We(0,a.IInstantiationService),We(1,e.IHostUtils),We(2,l.IExtHostRpcService),We(3,u.IExtHostWorkspace),We(4,n.IExtHostConfiguration),We(5,t.ILogService),We(6,r.IExtHostInitDataService),We(7,v.IExtensionStoragePaths),We(8,b.IExtHostTunnelService),We(9,h.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(Z,j){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class ${constructor(j,Q,ae,pe){D.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,D,j,"f"),Ze(this,x,Q,"f"),Ze(this,N,ae.identifier,"f"),this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=pe}get isActive(){return Ae(this,D,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,D,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,D,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,D=new WeakMap,x=new WeakMap,N=new WeakMap}),define(we[100],be([0,1,17,2,3,12,5,7,162,31,33,51,168,32,163,13,4,10,91,71]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let f=class{constructor(c,b,h,y,R,I){this._workspaceService=b,this._extensionService=h,this._editorsService=y,this._configurationService=R,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=c.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(L=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,b){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,R="?";return b&&(y+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),y+=`${R}ref=${h.sourceReference}`,M.URI.parse(y)}else{if(h.path)return M.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const b=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,s.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(b=>c.push(b)),c}addBreakpoints(c){this.startBreakpoints();const b=c.filter(R=>{const I=R.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,R),!0)});this.fireBreakpointChanges(b,[],[]);const h=[],y=new Map;for(const R of b)if(R instanceof P.SourceBreakpoint){let I=y.get(R.location.uri.toString());I||(I={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),I),h.push(I)),I.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&h.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const b=c.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],b,[]);const h=b.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),y=b.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),R=b.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(h,y,R)}startDebugging(c,b,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,b,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,b,h){if(!b)return new P.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:y,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,y),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(c,b,h){if(!h)return new P.Disposable(()=>{});if(!this.definesDebugType(c,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:y,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,y),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(c,b){if(!b)return new P.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:b}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==b)})}async $runInTerminal(c,b){return Promise.resolve(void 0)}async $substituteVariables(c,b){if(!this._variableResolver){const[R,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,I)}let h;const y=await this.getFolder(c);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,b)}createDebugAdapter(c,b){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,b){const h=this,y=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.convertToDto(R),U=this.createDebugAdapter(I,y);if(!U)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const L=U;return this._debugAdapters.set(c,L),this.getDebugAdapterTrackers(y).then(D=>(D&&this._debugAdaptersTrackers.set(c,D),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(N.arguments.value);V.body={signature:W},L.sendResponse(V)}else throw new Error("no signer")}catch(W){V.success=!1,V.message=W.message,L.sendResponse(V)}}else D&&D.onDidSendMessage&&D.onDidSendMessage(x),x=(0,s.convertToVSCPaths)(x,!0),h._debugServiceProxy.$acceptDAMessage(c,x)}),L.onError(x=>{D&&D.onError&&D.onError(x),this._debugServiceProxy.$acceptDAError(c,x.name,x.message,x.stack)}),L.onExit(x=>{D&&D.onExit&&D.onExit((0,k.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,k.withNullAsUndefined)(x),void 0)}),D&&D.onWillStartSession&&D.onWillStartSession(),L.startSession()))})}$sendDAMessage(c,b){b=(0,s.convertToDAPaths)(b,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(b);const y=this._debugAdapters.get(c);y&&y.sendMessage(b)}$stopDASession(c){const b=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),b&&b.onWillStopSession&&b.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const b=[],h=[],y=[];if(c.added)for(const R of c.added){const I=R.id;if(I&&!this._breakpoints.has(I)){let U;if(R.type==="function")U=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")U=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const L=M.URI.revive(R.uri);U=new P.SourceBreakpoint(new P.Location(L,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}U._id=I,this._breakpoints.set(I,U),b.push(U)}}if(c.removed)for(const R of c.removed){const I=this._breakpoints.get(R);I&&(this._breakpoints.delete(R),h.push(I))}if(c.changed){for(const R of c.changed)if(R.id){const I=this._breakpoints.get(R.id);if(I){if(I instanceof P.FunctionBreakpoint&&R.type==="function"){const U=I;U.enabled=R.enabled,U.condition=R.condition,U.hitCondition=R.hitCondition,U.logMessage=R.logMessage,U.functionName=R.functionName}else if(I instanceof P.SourceBreakpoint&&R.type==="source"){const U=I;U.enabled=R.enabled,U.condition=R.condition,U.hitCondition=R.hitCondition,U.logMessage=R.logMessage,U.location=new P.Location(M.URI.revive(R.uri),new P.Position(R.line,R.character))}y.push(I)}}}this.fireBreakpointChanges(b,h,y)}$provideDebugConfigurations(c,b,h){return(0,A.asPromise)(async()=>{const y=this.getConfigProviderByHandle(c);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return y.provideDebugConfigurations(R,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(c,b,h,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(b);return R.resolveDebugConfiguration(I,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables(c,b,h,y){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(c);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(I,h,y)})}async $provideDebugAdapter(c,b){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(b);return this.getAdapterDescriptor(h,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(c){const b=await this.getSession(c);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(c){const b=await this.getSession(c);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,b){const h=await this.getSession(c);h&&h._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(c,b){const y={session:await this.getSession(c),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const b=this._adapterFactories.filter(h=>h.type===c);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(c){const b=this._adapterFactories.filter(h=>h.handle===c);if(b.length>0)return b[0].factory}getConfigProviderByHandle(c){const b=this._configProviders.filter(h=>h.handle===c);if(b.length>0)return b[0].provider}definesDebugType(c,b){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===b)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,y=this._trackerFactories.filter(R=>R.type===h||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(c)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(R=>{const I=R.filter(U=>!!U);if(I.length>0)return new a(I)}),new Promise((R,I)=>{const U=setTimeout(()=>{clearTimeout(U),I(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(c,b){const h=b.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new P.DebugAdapterServer(h));if(c){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(I=>{if(I)return I})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,y))}daExecutableFromPackage(c,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,b,h){(c.length>0||b.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:b,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const b=this._debugSessions.get(c);if(b)return b}else{let b=this._debugSessions.get(c.id);if(!b){const h=await this.getFolder(c.folderUri),y=c.parent?this._debugSessions.get(c.parent):void 0;b=new S(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,y),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(c){if(c){const b=M.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};f=Be([We(0,u.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,t.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,o.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class S{constructor(c,b,h,y,R,I,U){this._debugServiceProxy=c,this._id=b,this._type=h,this._name=y,this._workspaceFolder=R,this._configuration=I,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,b)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=S;class i{constructor(c){this.value=Object.freeze({append(b){c.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=i;class g extends n.AbstractVariableResolverService{constructor(c,b,h,y,R){function I(){if(b){const U=b.activeEditor();if(U)return U.document.uri;const L=y.tabs.filter(D=>D.isActive);if(L.length>0){const D=L[0].resource;return D&&(D.primary||D.secondary)?D.primary??D.secondary:L[0].resource}}}super({getFolderUri:U=>{const L=c.filter(D=>D.name===U);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(U,L)=>h.getConfiguration(void 0,U).get(L),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=I();if(U)return d.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const U=I();if(U){const L=R.getWorkspaceFolder(U);if(L)return d.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(b){const U=b.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(b){const U=b.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=g;class a{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(b=>b.onError?b.onError(c):void 0)}onExit(c,b){this.trackers.forEach(h=>h.onExit?h.onExit(c,b):void 0)}}class r extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends f{constructor(c,b,h,y,R,I){super(c,b,h,y,R,I)}createVariableResolver(c,b,h){return new g(c,b,h,this._editorTabs)}};v=Be([We(0,u.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,t.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,m.IExtHostConfiguration),We(5,o.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(we[219],be([0,1,75,2,5,32,30,26,13,29,4,33,91,14]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,f,S,i,g,a,r){this._apiFactory=o,this._extensionRegistry=f,this._instaService=S,this._extHostConfiguration=i,this._extHostExtensionService=g,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,f,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,f,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let f of o.nodeModuleName)this._factories.set(f,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(f=>o.alternativeModuleName(f))}};s=Be([We(2,t.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,_.IExtHostExtensionService),We(5,T.IExtHostInitDataService),We(6,m.ILogService)],s),e.RequireInterceptor=s;class u{constructor(o,f,S,i,g){this._apiFactory=o,this._extensionPaths=f,this._extensionRegistry=S,this._configProvider=i,this._logService=g,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,f){const S=this._extensionPaths.findSubstr(f);if(S){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(S.identifier));return i||(i=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(S.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((g,a)=>i+=`	${a} -> ${g.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,f,S){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=f.getProxy(E.MainContext.MainThreadTelemetry);const{environment:i}=S,g=f.getProxy(E.MainContext.MainThreadKeytar);if(i.appRoot){let a=i.appRoot.fsPath;n.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>g.$getPassword(a,r),setPassword:(a,r,v)=>g.$setPassword(a,r,v),deletePassword:(a,r)=>g.$deletePassword(a,r),findPassword:a=>g.$findPassword(a),findCredentials(a){return g.$findCredentials(a)}}}load(o,f){const S=this._extensionPaths.findSubstr(f);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const f=o.length;if(f<=7||!this.alternativeNames)return;const S=f-7;if((o.charAt(S)==="/"||o.charAt(S)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=Be([We(1,C.IExtHostRpcService),We(2,T.IExtHostInitDataService)],p);let k=class{constructor(o,f,S){this._extensionPaths=o,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(E.MainContext.MainThreadTelemetry);const i=S.getProxy(E.MainContext.MainThreadWindow);this._impl=(g,a)=>{const r=M.URI.parse(g);return a?this.callOriginal(g,a):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,g,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?i.$openUri(r,g,{}):this.callOriginal(g,a)}}load(o,f,S){const i=this._extensionPaths.findSubstr(f);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=S(o),this._impl}callOriginal(o,f){return this.sendNoForwardTelemetry(),this._original(o,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=Be([We(2,C.IExtHostRpcService)],k)}),define(we[220],be([0,1,12,16,75,6,2,5,213,14,58,61,29,142,13,66,33,40]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(f,S,i,g){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new C.RPCProtocol(f,null,g),S=w._transform(S,this._rpcProtocol);const a=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...S}),a.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(g)),a.set(p.IHostUtils,i);const r=new m.InstantiationService(a,!0),v=r.invokeFunction(h=>h.get(k.IExtHostTerminalService));this._disposables.add(v),this._logService=r.invokeFunction(h=>h.get(T.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=r.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const l=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(y,R)=>{let I="",U,L;for(const D of R)I+=`
	at ${D.toString()}`,L=D.getFileName(),!U&&L&&(U=h.findSubstr(F.URI.file(L)));return l.set(y,U),`${y.name||"Error"}: ${y.message||""}${I}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(h=>{const y=M.transformErrorForSerialization(h),R=l.get(h);R?c.$onExtensionRuntimeError(R.identifier,y):b.$onUnexpectedError(y)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,d.timeout)(4e3),S]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,S){f.extensions.forEach(g=>g.extensionLocation=F.URI.revive(S.transformIncomingURIs(g.extensionLocation))),f.environment.appRoot=F.URI.revive(S.transformIncomingURIs(f.environment.appRoot));const i=f.environment.extensionDevelopmentLocationURI;return i&&(f.environment.extensionDevelopmentLocationURI=i.map(g=>F.URI.revive(S.transformIncomingURIs(g)))),f.environment.extensionTestsLocationURI=F.URI.revive(S.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=F.URI.revive(S.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=F.URI.revive(S.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=F.URI.revive(S.transformIncomingURIs(f.logsLocation)),f.logFile=F.URI.revive(S.transformIncomingURIs(f.logFile)),f.workspace=S.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=w}),define(we[221],be([0,1,17,21,45,27,24,194,41]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(n,m,s){this.config=n,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((s,u)=>{const p=k=>{this.resultCount++,n(k)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const w=k.toString(),o=d.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,o)||this.matchFile(p,{base:k,basename:o})}),Promise.all(m.map(k=>this.searchInFolder(k,p))).then(k=>{s({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{u(new Error((0,E.toErrorMessage)(k)))})})}async searchInFolder(n,m){const s=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),k=new C.QueryGlobTester(this.config,n),w=!k.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=P.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,s.token),S=o.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(g=>{const a=d.posix.relative(n.folder.path,g.path);if(w){const r=d.basename(g.path);this.matchFile(m,{base:n.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(p,n.folder,a,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,k,m),{providerTime:S,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,s,u){if(s===this.filePattern){const k=d.basename(this.filePattern);this.matchFile(u,{base:m,relativePath:this.filePattern,basename:k})}function p(k){const w=d.basename(k),o=d.dirname(k);let f=n[o];f||(f=n[o]=[],p(o)),f.push({base:m,relativePath:k,basename:w})}p(s)}matchDirectoryTree({rootEntries:n,pathToEntries:m},s,u){const p=this,k=this.filePattern;function w(o){const f=A.hasSiblingFn(()=>o.map(S=>S.basename));for(let S=0,i=o.length;S<i;S++){const g=o[S],{relativePath:a,basename:r}=g;if(s.matchesExcludesSync(a,r,k!==r?f:void 0))continue;const v=m[a];if(v)w(v);else{if(a===k)continue;p.matchFile(u,g)}if(p.isLimitHit)break}}w(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class t{constructor(){this.sessions=new Map}fileSearch(n,m,s,u){const p=this.getSessionTokenSource(n.cacheKey),k=new T(n,m,p&&p.token);let w=0;const o=f=>{w+=f.length,s(f.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(k,t.BATCH_SIZE,o,u).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:f.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,s,u){u.onCancellationRequested(()=>{n.cancel()});const p=w=>{w&&(k.push(w),m>0&&k.length>=m&&(s(k),k=[]))};let k=[];return n.search(p).then(w=>(k.length&&s(k),w),w=>(k.length&&s(k),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[222],be([0,1,15,21,45,27,11,17,24,10,2,41]),function(re,e,d,M,E,A,F,P,C,T,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,f,S,i){this.query=o,this.provider=f,this.fileUtils=S,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,f){const S=this.query.folderQueries||[],i=new M.CancellationTokenSource;return f.onCancellationRequested(()=>i.cancel()),new Promise((g,a)=>{this.collector=new s(o);let r=!1;const v=(l,c)=>{if(!r&&!this.isLimitHit){const b=this.resultSize(l);p(l)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,r=!0,i.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!p(l))&&this.collector.add(l,c)}};Promise.all(S.map((l,c)=>this.searchInFolder(l,b=>v(b,c),i.token))).then(l=>{i.dispose(),this.collector.flush();const c=l.some(b=>!!b&&!!b.limitHit);g({limitHit:this.isLimitHit||c,messages:(0,d.flatten)(l.map(b=>b?.message?(0,T.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},l=>{i.dispose();const c=(0,E.toErrorMessage)(l);a(new Error(c))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,f){const S=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:S.slice(0,f),preview:{matches:i.slice(0,f),text:o.preview.text},uri:o.uri}}async searchInFolder(o,f,S){const i=new _.QueryGlobTester(this.query,o),g=[],a={report:l=>{if(!this.validateProviderResult(l))return;const c=o.folder.scheme===F.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(l.uri))):void 0,b=C.relativePath(o.folder,l.uri);if(b){const h=i.includedInQuery(b,P.basename(b),c);(0,T.isPromise)(h)?g.push(h.then(y=>{y&&f(l)})):h&&f(l)}}},r=this.getSearchOptionsForFolder(o),v=await this.provider.provideTextSearchResults(m(this.query.contentPattern),r,a,S);return g.length&&await Promise.all(g),v}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const f=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),S=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:S,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,f=>this.sendItems(f))}add(o,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(u(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function u(w){return p(w)?{preview:{matches:(0,d.mapArrayOrNot)(w.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:w.preview.text},ranges:(0,d.mapArrayOrNot)(w.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class k{constructor(o,f){this.maxBatchSize=o,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,f){!o||this.addItemToBatch(o,f)}addItems(o,f){!o||this.addItemsToBatch(o,f)}addItemToBatch(o,f){this.batch.push(o),this.batchSize+=f,this.onUpdate()}addItemsToBatch(o,f){this.batch=this.batch.concat(o),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,221,13,66,14,2,222]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(u,p,k){this.extHostRpc=u,this._uriTransformer=p,this._logService=k,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,p){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const k=this._handlePool++;return this._textSearchProvider.set(k,p),this._proxy.$registerTextSearchProvider(k,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(u,p){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const k=this._handlePool++;return this._fileSearchProvider.set(k,p),this._proxy.$registerFileSearchProvider(k,this._transformScheme(u)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(u,p,k,w){const o=n(k),f=this._fileSearchProvider.get(u);if(f)return this._fileSearchManager.fileSearch(o,f,S=>{this._proxy.$handleFileMatch(u,p,S.map(i=>i.resource))},w);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,p,k,w){const o=this._textSearchProvider.get(u);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const f=n(k);return this.createTextSearchManager(f,o).search(i=>this._proxy.$handleTextMatch(u,p,i),w)}$enableExtensionHostSearch(){}createTextSearchManager(u,p){return new t.TextSearchManager(u,p,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};_=Be([We(0,F.IExtHostRpcService),We(1,P.IURITransformerService),We(2,C.ILogService)],_),e.ExtHostSearch=_;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(u=>T.URI.revive(u))}}e.reviveQuery=n;function m(s){return{...s,folder:T.URI.revive(s.folder)}}}),define(we[223],be([0,1,21,16,3,35,2,116,80,112,57,47,5,184,183,39,185,32,186,187,188,170,189,51,33,190,171,193,195,196,96,173,201,202,203,73,40,205,174,8,7,208,52,97,31,30,53,159,192,63,95,99,100,101,14,66,13,29,197,156,65,70,181,206,155,74,72,211,209,210,182,37,204,207,69,71,87,199,98,200,11,144,198,153,191]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o,f,S,i,g,a,r,v,l,c,b,h,y,R,I,U,L,D,x,N,V,W,$,Z,j,Q,ae,pe,ce,Fe,Ge,Ne,ze,Je,Qe,Ke,H,K,ee,se,G,ne,de,Te,xe,$e,je,et,st,_e,nt,q,X,ge,Ue,qe,rt,mt,ut,St,Tt,It,Xe,vt,Ie,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(te){const oe=te.get(ee.IExtHostInitDataService),fe=te.get(X.IExtHostFileSystemInfo),he=te.get(et.IExtHostConsumerFileSystem),ke=te.get(a.IExtHostExtensionService),Oe=te.get(Q.IExtHostWorkspace),Me=te.get(mt.IExtHostTelemetry),He=te.get(k.IExtHostConfiguration),it=te.get(H.IURITransformerService),Re=te.get(K.IExtHostRpcService),ue=te.get(L.IExtHostStorage),me=te.get(je.IExtensionStoragePaths),J=te.get(Ke.ILogService),z=te.get(ne.IExtHostTunnelService),ve=te.get(de.IExtHostApiDeprecationService),Ce=te.get(j.IExtHostWindow),Ye=te.get(qe.IExtHostSecretState),Le=te.get(rt.IExtHostEditorTabs);Re.set(n.ExtHostContext.ExtHostFileSystemInfo,fe),Re.set(n.ExtHostContext.ExtHostLogService,J),Re.set(n.ExtHostContext.ExtHostWorkspace,Oe),Re.set(n.ExtHostContext.ExtHostConfiguration,He),Re.set(n.ExtHostContext.ExtHostExtensionService,ke),Re.set(n.ExtHostContext.ExtHostStorage,ue),Re.set(n.ExtHostContext.ExtHostTunnelService,z),Re.set(n.ExtHostContext.ExtHostWindow,Ce),Re.set(n.ExtHostContext.ExtHostSecretState,Ye),Re.set(n.ExtHostContext.ExtHostTelemetry,Me),Re.set(n.ExtHostContext.ExtHostEditorTabs,Le);const ct=Re.set(n.ExtHostContext.ExtHostDecorations,te.get(Ne.IExtHostDecorations)),pt=Re.set(n.ExtHostContext.ExtHostDocumentsAndEditors,te.get(g.IExtHostDocumentsAndEditors)),dt=Re.set(n.ExtHostContext.ExtHostCommands,te.get(u.IExtHostCommands)),ht=Re.set(n.ExtHostContext.ExtHostTerminalService,te.get(D.IExtHostTerminalService)),ft=Re.set(n.ExtHostContext.ExtHostDebugService,te.get(Je.IExtHostDebugService)),_t=Re.set(n.ExtHostContext.ExtHostSearch,te.get(Qe.IExtHostSearch)),yt=Re.set(n.ExtHostContext.ExtHostTask,te.get(ze.IExtHostTask)),Pt=Re.set(n.ExtHostContext.ExtHostOutputService,te.get(h.IExtHostOutputService)),Nt=Re.set(n.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(Re)),Ct=Re.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Re,pt)),xt=Re.set(n.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Re,pt,J)),$t=Re.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(J,Ct,Re.getProxy(n.MainContext.MainThreadBulkEdits))),bt=Re.set(n.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Re,dt,pt,Ct,me)),Qt=Re.set(n.ExtHostContext.ExtHostNotebookDocuments,new Ie.ExtHostNotebookDocuments(J,bt)),zt=Re.set(n.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(J,Re,bt)),ii=Re.set(n.ExtHostContext.ExtHostNotebookKernels,new ut.ExtHostNotebookKernels(Re,oe,bt,dt,J)),ni=Re.set(n.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Re,bt)),At=Re.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,pt)),Yt=Re.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(n.MainContext.MainThreadTreeViews),dt,J)),ri=Re.set(n.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Re.getProxy(n.MainContext.MainThreadEditorInsets),At,oe)),Jt=Re.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Re,J,fe)),Wt=Re.set(n.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Re,Ct,dt.converter,it)),gt=Re.set(n.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Re,it,Ct,dt,Jt,J,ve)),si=Re.set(n.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Re,gt)),Mt=Re.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Re,J,pt)),Vt=Re.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Re,Oe,dt)),Xt=Re.set(n.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Re,dt,J)),oi=Re.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Re,dt,Ct)),di=Re.set(n.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Re.getProxy(n.MainContext.MainThreadProgress))),wi=Re.set(n.ExtHostContext.ExtHosLabelService,new Fe.ExtHostLabelService(Re)),hi=Re.set(n.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(Re)),Zt=Re.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(Re)),bi=Re.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(Re,dt)),jt=Re.set(n.ExtHostContext.ExtHostWebviews,new Z.ExtHostWebviews(Re,{remote:oe.remote},Oe,J,ve)),qt=Re.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Re,jt,Oe)),Ei=Re.set(n.ExtHostContext.ExtHostCustomEditors,new _e.ExtHostCustomEditors(Re,Ct,me,jt,qt)),_i=Re.set(n.ExtHostContext.ExtHostWebviewViews,new st.ExtHostWebviewViews(Re,jt)),Gt=Re.set(n.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Re,dt)),yi=Re.set(n.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(Re));Re.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Re,bt,pt,dt));const ei=(0,pe.values)(n.ExtHostContext);Re.assertRegistered(ei);const Si=new q.ExtHostBulkEdits(Re,pt),Di=new s.ExtHostClipboard(Re),Kt=new b.ExtHostMessageService(Re,J),fi=new o.ExtHostDialogs(Re),Ht=new U.ExtHostStatusBar(Re,dt.converter);return m.ExtHostApiCommands.register(dt),function(Pe,ai,Ft){const wt=function(){let Y=!Pe.isUnderDevelopment;function le(Se){Y||(J.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(at){if(Array.isArray(at))at.forEach(Se);else if(typeof at=="string")le(at);else{const Et=at;typeof Et.scheme=="undefined"&&le(at),!Pe.enableProposedApi&&typeof Et.exclusive=="boolean"&&(0,ae.throwProposedApiError)(Pe)}return at}}(),Ci={getSession(Y,le,Se){return(Se?.forceNewSession||Se?.silent)&&(0,ae.checkProposedApiEnabled)(Pe),Zt.getSession(Pe,Y,le,Se)},async hasSession(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),!!await Zt.getSession(Pe,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Se,at){return Zt.registerAuthenticationProvider(Y,le,Se,at)}},ki={registerCommand(Y,le,Se){return dt.registerCommand(!0,Y,le,Se,void 0,Pe)},registerTextEditorCommand(Y,le,Se){return dt.registerCommand(!0,Y,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){J.warn("Cannot execute "+Y+" because there is no active text editor.");return}return Et.edit(kt=>{le.apply(Se,[Et,kt,...at])}).then(kt=>{kt||J.warn("Edits from command "+Y+" were not applied.")},kt=>{J.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Pe),dt.registerCommand(!0,Y,async(...at)=>{const Et=pt.activeEditor(!0);if(!Et){J.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);le.apply(Se,[kt,...at])},void 0,void 0,Pe)),executeCommand(Y,...le){return dt.executeCommand(Y,...le)},getCommands(Y=!1){return dt.getCommands(Y)}},mi={get machineId(){return oe.telemetryInfo.machineId},get sessionId(){return oe.telemetryInfo.sessionId},get language(){return oe.environment.appLanguage},get appName(){return oe.environment.appName},get appRoot(){return oe.environment.appRoot?.fsPath??""},get appHost(){return oe.environment.appHost},get uriScheme(){return oe.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(oe.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Ce.openUri(Y,{allowTunneling:!!oe.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===oe.environment.appUriScheme)return Nt.createAppUri(Y);try{return await Ce.asExternalUri(Y,{allowTunneling:!!oe.remote.authority})}catch(le){if((0,Xe.matchesScheme)(Y,It.Schemas.http)||(0,Xe.matchesScheme)(Y,It.Schemas.https))return Y;throw le}},get remoteName(){return(0,Ge.getRemoteName)(oe.remote.authority)},get remoteAuthority(){return(0,ae.checkProposedApiEnabled)(Pe),oe.remote.authority},get uiKind(){return oe.uiKind}};oe.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=oe.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Ii={createTestController(Y,le){return Gt.createTestController(Y,le)},createTestObserver(){return(0,ae.checkProposedApiEnabled)(Pe),Gt.createTestObserver()},runTests(Y){return(0,ae.checkProposedApiEnabled)(Pe),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ae.checkProposedApiEnabled)(Pe),Gt.onResultsChanged},get testResults(){return(0,ae.checkProposedApiEnabled)(Pe),Gt.results}},Pi={getExtension(Y){const le=ai.getExtensionDescription(Y);if(le)return new a.Extension(ke,Pe.identifier,le,gi)},get all(){return ai.getAllExtensionDescriptions().map(Y=>new a.Extension(ke,Pe.identifier,Y,gi))},get onDidChange(){return ai.onDidChange}},Ti={createDiagnosticCollection(Y){return Jt.createDiagnosticCollection(Pe.identifier,Y)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:Y=>Jt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,le){return Wt.changeLanguage(Y.uri,le)},match(Y,le){return(0,t.score)(V.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Se){return gt.registerCodeActionProvider(Pe,wt(Y),le,Se)},registerCodeLensProvider(Y,le){return gt.registerCodeLensProvider(Pe,wt(Y),le)},registerDefinitionProvider(Y,le){return gt.registerDefinitionProvider(Pe,wt(Y),le)},registerDeclarationProvider(Y,le){return gt.registerDeclarationProvider(Pe,wt(Y),le)},registerImplementationProvider(Y,le){return gt.registerImplementationProvider(Pe,wt(Y),le)},registerTypeDefinitionProvider(Y,le){return gt.registerTypeDefinitionProvider(Pe,wt(Y),le)},registerHoverProvider(Y,le){return gt.registerHoverProvider(Pe,wt(Y),le,Pe.identifier)},registerEvaluatableExpressionProvider(Y,le){return gt.registerEvaluatableExpressionProvider(Pe,wt(Y),le,Pe.identifier)},registerInlineValuesProvider(Y,le){return gt.registerInlineValuesProvider(Pe,wt(Y),le,Pe.identifier)},registerDocumentHighlightProvider(Y,le){return gt.registerDocumentHighlightProvider(Pe,wt(Y),le)},registerLinkedEditingRangeProvider(Y,le){return gt.registerLinkedEditingRangeProvider(Pe,wt(Y),le)},registerReferenceProvider(Y,le){return gt.registerReferenceProvider(Pe,wt(Y),le)},registerRenameProvider(Y,le){return gt.registerRenameProvider(Pe,wt(Y),le)},registerDocumentSymbolProvider(Y,le,Se){return gt.registerDocumentSymbolProvider(Pe,wt(Y),le,Se)},registerWorkspaceSymbolProvider(Y){return gt.registerWorkspaceSymbolProvider(Pe,Y)},registerDocumentFormattingEditProvider(Y,le){return gt.registerDocumentFormattingEditProvider(Pe,wt(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return gt.registerDocumentRangeFormattingEditProvider(Pe,wt(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Se,...at){return gt.registerOnTypeFormattingEditProvider(Pe,wt(Y),le,[Se].concat(at))},registerDocumentSemanticTokensProvider(Y,le,Se){return gt.registerDocumentSemanticTokensProvider(Pe,wt(Y),le,Se)},registerDocumentRangeSemanticTokensProvider(Y,le,Se){return gt.registerDocumentRangeSemanticTokensProvider(Pe,wt(Y),le,Se)},registerSignatureHelpProvider(Y,le,Se,...at){return typeof Se=="object"?gt.registerSignatureHelpProvider(Pe,wt(Y),le,Se):gt.registerSignatureHelpProvider(Pe,wt(Y),le,typeof Se=="undefined"?[]:[Se,...at])},registerCompletionItemProvider(Y,le,...Se){return gt.registerCompletionItemProvider(Pe,wt(Y),le,Se)},registerInlineCompletionItemProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),gt.registerInlineCompletionsProvider(Pe,wt(Y),le)},registerDocumentLinkProvider(Y,le){return gt.registerDocumentLinkProvider(Pe,wt(Y),le)},registerColorProvider(Y,le){return gt.registerColorProvider(Pe,wt(Y),le)},registerFoldingRangeProvider(Y,le){return gt.registerFoldingRangeProvider(Pe,wt(Y),le)},registerSelectionRangeProvider(Y,le){return gt.registerSelectionRangeProvider(Pe,Y,le)},registerCallHierarchyProvider(Y,le){return gt.registerCallHierarchyProvider(Pe,Y,le)},registerTypeHierarchyProvider(Y,le){return gt.registerTypeHierarchyProvider(Pe,Y,le)},setLanguageConfiguration:(Y,le)=>gt.setLanguageConfiguration(Pe,Y,le),getTokenInformationAtPosition(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),Wt.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),gt.registerInlayHintsProvider(Pe,Y,le)},createLanguageStatusItem(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),Wt.createLanguageStatusItem(Pe,Y,le)}},li={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(Y,le,Se){const at=await(F.URI.isUri(Y)?Promise.resolve(pi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(at,le,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Pe,Y)},onDidChangeActiveTextEditor(Y,le,Se){return At.onDidChangeActiveTextEditor(Y,le,Se)},onDidChangeVisibleTextEditors(Y,le,Se){return At.onDidChangeVisibleTextEditors(Y,le,Se)},onDidChangeTextEditorSelection(Y,le,Se){return At.onDidChangeTextEditorSelection(Y,le,Se)},onDidChangeTextEditorOptions(Y,le,Se){return At.onDidChangeTextEditorOptions(Y,le,Se)},onDidChangeTextEditorVisibleRanges(Y,le,Se){return At.onDidChangeTextEditorVisibleRanges(Y,le,Se)},onDidChangeTextEditorViewColumn(Y,le,Se){return At.onDidChangeTextEditorViewColumn(Y,le,Se)},onDidCloseTerminal(Y,le,Se){return ht.onDidCloseTerminal(Y,le,Se)},onDidOpenTerminal(Y,le,Se){return ht.onDidOpenTerminal(Y,le,Se)},onDidChangeActiveTerminal(Y,le,Se){return ht.onDidChangeActiveTerminal(Y,le,Se)},onDidChangeTerminalDimensions(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),ht.onDidChangeTerminalDimensions(Y,le,Se)},onDidChangeTerminalState(Y,le,Se){return ht.onDidChangeTerminalState(Y,le,Se)},onDidWriteTerminalData(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),ht.onDidWriteTerminalData(Y,le,Se)},get state(){return Ce.state},onDidChangeWindowState(Y,le,Se){return Ce.onDidChangeWindowState(Y,le,Se)},showInformationMessage(Y,...le){return Kt.showMessage(Pe,A.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return Kt.showMessage(Pe,A.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return Kt.showMessage(Pe,A.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Se){return Vt.showQuickPick(Y,!!Pe.enableProposedApi,le,Se)},showWorkspaceFolderPick(Y){return Vt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return Vt.showInput(Y,le)},showOpenDialog(Y){return fi.showOpenDialog(Y)},showSaveDialog(Y){return fi.showSaveDialog(Y)},createStatusBarItem(Y,le,Se){let at,Et,kt;return typeof Y=="string"?(at=Y,Et=le,kt=Se):(Et=Y,kt=le),Ht.createStatusBarEntry(Pe,at,Et,kt)},setStatusBarMessage(Y,le){return Ht.setStatusBarMessage(Y,le)},withScmProgress(Y){return ve.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),di.withProgress(Pe,{location:W.ProgressLocation.SourceControl},(le,Se)=>Y({report(at){}}))},withProgress(Y,le){return di.withProgress(Pe,Y,le)},createOutputChannel(Y){return Pt.createOutputChannel(Y,Pe)},createWebviewPanel(Y,le,Se,at){return qt.createWebviewPanel(Pe,Y,le,Se,at)},createWebviewTextEditorInset(Y,le,Se,at){return(0,ae.checkProposedApiEnabled)(Pe),ri.createWebviewEditorInset(Y,le,Se,at,Pe)},createTerminal(Y,le,Se){return typeof Y=="object"?("location"in Y&&(0,ae.checkProposedApiEnabled)(Pe),"pty"in Y?ht.createExtensionTerminal(Y):ht.createTerminalFromOptions(Y)):ht.createTerminal(Y,le,Se)},registerTerminalLinkProvider(Y){return ht.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return ht.registerProfileProvider(Pe,Y,le)},registerTreeDataProvider(Y,le){return Yt.registerTreeDataProvider(Y,le,Pe)},createTreeView(Y,le){return Yt.createTreeView(Y,le,Pe)},registerWebviewPanelSerializer:(Y,le)=>qt.registerWebviewPanelSerializer(Pe,Y,le),registerCustomEditorProvider:(Y,le,Se={})=>Ei.registerCustomEditorProvider(Pe,Y,le,Se),registerFileDecorationProvider(Y){return ct.registerFileDecorationProvider(Y,Pe.identifier)},registerUriHandler(Y){return Nt.registerUriHandler(Pe.identifier,Y)},createQuickPick(){return Vt.createQuickPick(Pe.identifier,!!Pe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Pe.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Se){return hi.onDidChangeActiveColorTheme(Y,le,Se)},registerWebviewViewProvider(Y,le,Se){return _i.registerWebviewViewProvider(Pe,Y,le,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ae.checkProposedApiEnabled)(Pe),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeActiveNotebookEditor(Y,le,Se)},get visibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Pe),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),zt.onDidChangeNotebookEditorSelection(Y,le,Se)},onDidChangeNotebookEditorVisibleRanges(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),zt.onDidChangeNotebookEditorVisibleRanges(Y,le,Se)},showNotebookDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),bt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),yi.registerExternalUriOpener(Pe.identifier,Y,le,Se)},get tabs(){return(0,ae.checkProposedApiEnabled)(Pe),Le.tabs},get activeTab(){return(0,ae.checkProposedApiEnabled)(Pe),Le.activeTab},get onDidChangeTabs(){return(0,ae.checkProposedApiEnabled)(Pe),Le.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ae.checkProposedApiEnabled)(Pe),Le.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ae.checkProposedApiEnabled)(Pe),l.InlineCompletionController.get(Y)}},pi={get rootPath(){return ve.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Oe.getWorkspaceFolder(Y)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(Y){throw M.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,le,...Se)=>Oe.updateWorkspaceFolders(Pe,Y,le||0,...Se),onDidChangeWorkspaceFolders:function(Y,le,Se){return Oe.onDidChangeWorkspace(Y,le,Se)},asRelativePath:(Y,le)=>Oe.getRelativePath(Y,le),findFiles:(Y,le,Se,at)=>Oe.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(le),Se,Pe.identifier,at),findTextInFiles:(Y,le,Se,at)=>{let Et,kt;return typeof le=="object"?(Et=le,kt=Se):(Et={},kt=le,at=Se),Oe.findTextInFiles(Y,Et||{},kt,Pe.identifier,at)},saveAll:Y=>Oe.saveAll(Y),applyEdit(Y){return Si.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Se,at)=>Mt.createFileSystemWatcher(V.GlobPattern.from(Y),le,Se,at),get textDocuments(){return Ct.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let le;const Se=Y;if(typeof Y=="string")le=Promise.resolve(F.URI.file(Y));else if(F.URI.isUri(Y))le=Promise.resolve(Y);else if(!Se||typeof Se=="object")le=Ct.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(at=>Ct.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(Y,le,Se)=>Ct.onDidAddDocument(Y,le,Se),onDidCloseTextDocument:(Y,le,Se)=>Ct.onDidRemoveDocument(Y,le,Se),onDidChangeTextDocument:(Y,le,Se)=>Ct.onDidChangeDocument(Y,le,Se),onDidSaveTextDocument:(Y,le,Se)=>Ct.onDidSaveDocument(Y,le,Se),onWillSaveTextDocument:(Y,le,Se)=>$t.getOnWillSaveTextDocumentEvent(Pe)(Y,le,Se),get notebookDocuments(){return bt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Se;if(F.URI.isUri(Y))Se=Y,await bt.openNotebookDocument(Y);else if(typeof Y=="string")Se=F.URI.revive(await bt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Se,at){return bt.registerNotebookSerializer(Pe,Y,le,Se,Pe.enableProposedApi?at:void 0)},registerNotebookContentProvider:(Y,le,Se,at)=>((0,ae.checkProposedApiEnabled)(Pe),bt.registerNotebookContentProvider(Pe,Y,le,Se,Pe.enableProposedApi?at:void 0)),onDidChangeConfiguration:(Y,le,Se)=>Ft.onDidChangeConfiguration(Y,le,Se),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,Ft.getConfiguration(Y,le,Pe)},registerTextDocumentContentProvider(Y,le){return xt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(ve.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Pe,Y,le)),registerFileSystemProvider(Y,le,Se){return si.registerFileSystemProvider(Pe.identifier,Y,le,Se)},get fs(){return he.value},registerFileSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Pe),_t.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Pe),_t.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ae.checkProposedApiEnabled)(Pe),ke.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ae.checkProposedApiEnabled)(Pe),wi.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Se)=>Mt.onDidCreateFile(Y,le,Se),onDidDeleteFiles:(Y,le,Se)=>Mt.onDidDeleteFile(Y,le,Se),onDidRenameFiles:(Y,le,Se)=>Mt.onDidRenameFile(Y,le,Se),onWillCreateFiles:(Y,le,Se)=>Mt.getOnWillCreateFileEvent(Pe)(Y,le,Se),onWillDeleteFiles:(Y,le,Se)=>Mt.getOnWillDeleteFileEvent(Pe)(Y,le,Se),onWillRenameFiles:(Y,le,Se)=>Mt.getOnWillRenameFileEvent(Pe)(Y,le,Se),openTunnel:Y=>((0,ae.checkProposedApiEnabled)(Pe),z.openTunnel(Pe,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ae.checkProposedApiEnabled)(Pe),z.getTunnels()},onDidChangeTunnels:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Pe),z.onDidChangeTunnels(Y,le,Se)),registerPortAttributesProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Pe),z.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Pe),bi.registerTimelineProvider(Y,le,Pe.identifier,dt.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:Y=>((0,ae.checkProposedApiEnabled)(Pe),Oe.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Se)=>Oe.onDidGrantWorkspaceTrust(Y,le,Se)},Ai={get inputBox(){return ve.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Pe)},createSourceControl(Y,le,Se){return Xt.createSourceControl(Pe,Y,le,Se)}},Ri={createCommentController(Y,le){return oi.createCommentController(Pe,Y,le)}},Fi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(Y,le,Se){return ft.onDidStartDebugSession(Y,le,Se)},onDidTerminateDebugSession(Y,le,Se){return ft.onDidTerminateDebugSession(Y,le,Se)},onDidChangeActiveDebugSession(Y,le,Se){return ft.onDidChangeActiveDebugSession(Y,le,Se)},onDidReceiveDebugSessionCustomEvent(Y,le,Se){return ft.onDidReceiveDebugSessionCustomEvent(Y,le,Se)},onDidChangeBreakpoints(Y,le,Se){return ft.onDidChangeBreakpoints(Y,le,Se)},registerDebugConfigurationProvider(Y,le,Se){return ft.registerDebugConfigurationProvider(Y,le,Se||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return ft.registerDebugAdapterDescriptorFactory(Pe,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return ft.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Se){return!Se||typeof Se=="object"&&"configuration"in Se?ft.startDebugging(Y,le,{parentSession:Se}):ft.startDebugging(Y,le,Se||{})},stopDebugging(Y){return ft.stopDebugging(Y)},addBreakpoints(Y){return ft.addBreakpoints(Y)},removeBreakpoints(Y){return ft.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return ft.asDebugSourceUri(Y,le)}},Mi={registerTaskProvider:(Y,le)=>yt.registerTaskProvider(Pe,Y,le),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Pe,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,le,Se)=>yt.onDidStartTask(Y,le,Se),onDidEndTask:(Y,le,Se)=>yt.onDidEndTask(Y,le,Se),onDidStartTaskProcess:(Y,le,Se)=>yt.onDidStartTaskProcess(Y,le,Se),onDidEndTaskProcess:(Y,le,Se)=>yt.onDidEndTaskProcess(Y,le,Se)},Li={createNotebookController(Y,le,Se,at,Et){return ii.createNotebookController(Pe,Y,le,Se,at,Pe.enableProposedApi?Et:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>bt.registerNotebookCellStatusBarItemProvider(Pe,Y,le),get onDidSaveNotebookDocument(){return(0,ae.checkProposedApiEnabled)(Pe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ae.checkProposedApiEnabled)(Pe),zt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ni.createRendererMessaging(Pe,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),Qt.onDidChangeNotebookDocumentMetadata(Y,le,Se)},onDidChangeNotebookCells(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeNotebookCells(Y,le,Se)},onDidChangeNotebookCellExecutionState(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeNotebookCellExecutionState(Y,le,Se)},onDidChangeCellOutputs(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeCellOutputs(Y,le,Se)},onDidChangeCellMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Pe),bt.onDidChangeCellMetadata(Y,le,Se)},createConcatTextDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Pe),new $e.ExtHostNotebookConcatDocument(bt,Ct,Y,le)}};return{version:oe.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:Ti,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:li,workspace:pi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:T.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:St.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[224],be([0,1,58,96,31,95,32,39,51,40,99,100,101,73,65,70,97,72,37,69,87,71]),function(re,e,d,M,E,A,F,P,C,T,t,_,n,m,s,u,p,k,w,o,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,d.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,d.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,d.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,d.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,d.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,d.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,d.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,d.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,d.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,d.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,d.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,d.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,d.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,d.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,d.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,d.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,d.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(we[225],be([0,1,223,33,219,7,12,5,11]),function(re,e,d,M,E,A,F,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var T;(function(s){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...w)=>{w.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=w.slice(0,-1).join(","),f=w.pop().toString();return`(function anonymous(${o}) {${f}
})`}});function p(...k){return u?self.eval(u.createScript("",...k)):new Function(...k)}s.create=p})(T||(T={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(u,p){for(let k of this._alternatives){let w=k(u);if(w){u=w;break}}if(this._factories.has(u))return this._factories.get(u).load(u,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);m(u,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(d.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,p,k){p=p.with({path:n(p.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const w=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),w.status!==200)throw new Error(w.statusText);const o=await w.text(),f=`${p.toString(!0)}#vscode-extension`,S=`${o}
//# sourceURL=${f}`;let i;try{i=T.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(S)??S)}catch(v){throw console.error(u?`Loading code for extension ${u.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const g={},a={exports:g},r=v=>{const l=this._fakeModules.getModule(v,p);if(l===void 0)throw new Error(`Cannot load module '${v}'`);return l};try{return k.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,g,r),a.exports!==g?a.exports:g}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+u;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,u){return s.endsWith(u)?s:s+u}function m(s,u){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,f){const S=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:f,arguments:w(arguments)}),u&&S.apply(console,arguments)}}const k=1e5;function w(o){const f=[],S=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const g=o[i];g.stack?o[i]=g.stack:o[i]=g.toString()}S.push(o[i])}try{const i=JSON.stringify(S,function(g,a){if(a&&typeof a=="object"){if(f.indexOf(a)!==-1)return"[Circular]";f.push(a)}return a});return i.length>k?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[226],be([0,1,58,14,33,74,225,212]),function(re,e,d,M,E,A,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(E.IExtHostExtensionService,F.ExtHostExtensionService),(0,d.registerSingleton)(M.ILogService,P.ExtHostLogService),(0,d.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(we[235],be([0,1,22,3,178,220,214,17,75,11,2,224,226]),function(re,e,d,M,E,A,F,P,C,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(o,f){return o instanceof Request||/^file:/i.test(String(o))&&(o=T.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),m(o,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,f,S,i,g){return/^file:/i.test(f.toString())&&(f=T.FileAccess.asBrowserUri(t.URI.parse(f.toString())).toString(!0)),super.open(o,f,S??!0,i,g)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),f=self.Worker;Worker=function(S,i){/^file:/i.test(S.toString())&&(S=T.FileAccess.asBrowserUri(t.URI.parse(S.toString())).toString(!0));const a=`(${function(c){function b(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const h=fetch.bind(self);self.fetch=function(I,U){return I instanceof Request?h(I,U):h(b(I),U)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,U,L,D,x){return super.open(I,b(U),L??!0,D,x)}};const y=importScripts.bind(self);self.importScripts=(...I)=>{y(...I.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:I=>I}):void 0;y(R?R.createScriptURL(c):c)}.toString()}('${S}'))`;i=i||{},i.name=i.name||P.basename(S.toString());const r=new Blob([a],{type:"application/javascript"}),v=URL.createObjectURL(r);return new f(o?o.createScriptURL(v):v,i)}}else self.Worker=class extends F.NestedWorker{constructor(o,f){super(n,o,{name:P.basename(o.toString()),...f})}};const s=new class{constructor(){this.pid=void 0}exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class u{constructor(){const f=new MessageChannel,S=new M.Emitter;let i=!1;n(f.port2,[f.port2]),f.port1.onmessage=g=>{const{data:a}=g;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const r=d.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,E.isMessageOfType)(r,2)){i=!0,k("received terminate message from renderer");return}S.fire(r)},this.protocol={onMessage:S.event,send:g=>{if(!i){const a=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);f.port1.postMessage(a,[a])}}}}}function p(o){return new Promise(f=>{const S=o.onMessage(i=>{S.dispose();const g=JSON.parse(i.toString());o.send((0,E.createMessageOfType)(0)),f({protocol:o,initData:g})});o.send((0,E.createMessageOfType)(1))})}let k=o=>_();function w(){const o=new u;C.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(f=>{C.mark("code/extHost/didWaitForInitData");const S=new A.ExtensionHostMain(f.protocol,f.initData,s,null);k=i=>S.terminate(i)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/552af97a0170b43c9323bec62211feb184da9749/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
